#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1e6315be77eff662cf99876c2ac8964a81f2abc7";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "collectionsPrelude";
Object module_standardGrace_init();
extern Object module_standardGrace;
Object module_collectionsPrelude = NULL;
static char *originalSourceLines[] = {
  "dialect \"none\"",
  "",
  "def BoundsError is public = ProgrammingError.refine \"BoundsError\"",
  "def IteratorExhausted is public = ProgrammingError.refine \"IteratorExhausted\"",
  "def SubobjectResponsibility is public = ProgrammingError.refine \"SubobjectResponsibility\"",
  "def NoSuchObject is public = ProgrammingError.refine \"NoSuchObject\"",
  "def RequestError is public = ProgrammingError.refine \"RequestError\"",
  "def ConcurrentModification is public = ProgrammingError.refine \"ConcurrentModification\"",
  "def SizeUnknown is public = Exception.refine \"SizeUnknown\"",
  "",
  "method required is confidential {",
  "    SubobjectResponsibility.raise \"required method not overriden by subobject\"",
  "}",
  "",
  "",
  "type Function0⟦ResultT⟧  = type {",
  "    apply -> ResultT     // Function with no arguments and a result of type ResultT",
  "    //  matches -> Boolean   // answers true",
  "}",
  "type Function1⟦ArgT1, ResultT⟧ = type {",
  "    apply(a1:ArgT1) -> ResultT    // Function with argument a1 of type ArgT1, and a result of type ResultT",
  "    //  matches(a1:Object) -> Boolean   // answers true if a1 <: ArgT1",
  "}",
  "type Function2⟦ArgT1, ArgT2, ResultT⟧ = type {",
  "    apply(a1:ArgT1, a2:ArgT2) -> ResultT",
  "    // Function with arguments of types ArgT1 and ArgT2, and a result of type ResultT",
  "    //  matches(a1:Object, a2:Object) -> Boolean",
  "        // answers true if a1 <: ArgT1 and a2 <: ArgT2",
  "}",
  "type Procedure0 = Function0⟦Done⟧",
  "    // Function with no arguments and no result",
  "type Procedure1⟦ArgT1⟧ = Function1⟦ArgT1, Done⟧",
  "    // Function with 1 argument of type ArgT1, and no result",
  "type Procedure2⟦ArgT1, ArgT2⟧ = Function1⟦ArgT1, ArgT2, Done⟧",
  "    // Function with 2 argument of types ArgT1, and ArgT2, and no result",
  "type Predicate1⟦ArgT1⟧ = Function1⟦ArgT1, Boolean⟧",
  "    // Function with 1 argument of type ArgT1, returning Boolean",
  "",
  "",
  "type SelfType = Unknown     // becuase it's not yet in the language",
  "",
  "type Collection⟦T⟧ = Object & type {",
  "    iterator -> Iterator⟦T⟧",
  "        // the iterator on which I am based",
  "    isEmpty -> Boolean",
  "        // true if I have no elements",
  "    size -> Number",
  "        // my size (the number of elements that I contain);",
  "        // may raise SizeUnknown.",
  "    sizeIfUnknown(action: Function0⟦Number⟧)",
  "        // my size; if not known, then the result of applying action",
  "    == (other) -> Boolean",
  "        // other and self have the same size, and contain the same elements.",
  "    first -> T",
  "        // my first element; raises BoundsError if I have none.",
  "    do(body: Procedure1⟦T⟧) -> Done",
  "        // an internal iterator; applies body to each of my elements",
  "    do(body:Procedure1⟦T⟧) separatedBy(separator:Procedure0) -> Done",
  "        // an internal iterator; applies body to each of my elements, and applies separator in between",
  "    ++(other: Collection⟦T⟧) -> Collection⟦T⟧",
  "        // returns a new Collection over the concatenation of self and other",
  "    fold(binaryFunction:Function2⟦T, T, T⟧) startingWith(initial:T) -> T",
  "        // the left-associative fold of binaryFunction over self, starting with initial",
  "    map⟦U⟧(function:Function1⟦T, U⟧) -> Collection⟦U⟧",
  "        // returns a new iterator that yields my elements mapped by function",
  "    filter(condition:Predicate1⟦T⟧) -> Collection⟦T⟧",
  "        // returns a new iterator that yields those of my elements for which condition holds",
  "}",
  "",
  "type Expandable⟦T⟧ = Collection⟦T⟧ & type {",
  "    add(x: T) -> SelfType",
  "    addAll(xs: Collection⟦T⟧) -> SelfType",
  "}",
  "",
  "type Iterable⟦T⟧ = Collection⟦T⟧    // for backward compatibility",
  "",
  "type Enumerable⟦T⟧ = Collection⟦T⟧ & type {",
  "    values -> Collection⟦T⟧",
  "    asDictionary -> Dictionary⟦Number,T⟧",
  "    keysAndValuesDo(action:Function2⟦Number,T,Object⟧) -> Done",
  "    into(existing: Expandable⟦Unknown⟧) -> Collection⟦Unknown⟧",
  "    sortedBy(comparison:Function2⟦T,T,Number⟧) -> SelfType",
  "    sorted -> SelfType",
  "}",
  "",
  "type Sequence⟦T⟧ = Enumerable⟦T⟧ & type {",
  "    size -> Number",
  "    at(n:Number) -> T",
  "    indices -> Sequence⟦Number⟧",
  "    keys -> Sequence⟦Number⟧",
  "    second -> T",
  "    third -> T",
  "    fourth -> T",
  "    fifth -> T",
  "    last -> T",
  "    indexOf⟦W⟧(elem:T)ifAbsent(action:Function0⟦W⟧) -> Number | W",
  "    indexOf(elem:T) -> Number",
  "    contains(elem:T) -> Boolean",
  "    reversed -> Sequence⟦T⟧",
  "}",
  "",
  "type List⟦T⟧ = Sequence⟦T⟧ & type {",
  "    add(x: T) -> List⟦T⟧",
  "    addAll(xs: Collection⟦T⟧) -> List⟦T⟧",
  "    addFirst(x: T) -> List⟦T⟧",
  "    addAllFirst(xs: Collection⟦T⟧) -> List⟦T⟧",
  "    addLast(x: T) -> List⟦T⟧    // same as add",
  "    at(ix:Number) put(v:T) -> List⟦T⟧",
  "    clear -> List⟦T⟧",
  "    removeFirst -> T",
  "    removeAt(n: Number) -> T",
  "    removeLast -> T",
  "    remove(v:T)",
  "    remove(v:T) ifAbsent(action:Procedure0)",
  "    removeAll(vs: Collection⟦T⟧)",
  "    removeAll(vs: Collection⟦T⟧) ifAbsent(action:Function0⟦Unknown⟧)",
  "    pop -> T",
  "    ++(o: List⟦T⟧) -> List⟦T⟧",
  "    addAll(l: Collection⟦T⟧) -> List⟦T⟧",
  "    copy -> List⟦T⟧",
  "    sort -> List⟦T⟧",
  "    sortBy(sortBlock:Function2⟦T,T,Number⟧) -> List⟦T⟧",
  "    reverse -> List⟦T⟧",
  "    reversed -> List⟦T⟧",
  "}",
  "",
  "type Set⟦T⟧ = Collection⟦T⟧ & type {",
  "    size -> Number",
  "    add(x:T) -> SelfType",
  "    addAll(elements: Collection⟦T⟧) -> SelfType",
  "    remove(x: T) -> Set⟦T⟧",
  "    remove(x: T) ifAbsent(block: Procedure0) -> Set⟦T⟧",
  "    clear -> Set⟦T⟧",
  "    includes(booleanBlock: Predicate1⟦T⟧) -> Boolean",
  "    find(booleanBlock: Predicate1⟦T⟧) ifNone(notFoundBlock: Function0⟦T⟧) -> T",
  "    copy -> Set⟦T⟧",
  "    contains(elem:T) -> Boolean",
  "    ** (other:Set⟦T⟧) -> Set⟦T⟧",
  "    -- (other:Set⟦T⟧) -> Set⟦T⟧",
  "    ++ (other:Set⟦T⟧) -> Set⟦T⟧",
  "    isSubset(s2: Set⟦T⟧) -> Boolean",
  "    isSuperset(s2: Collection⟦T⟧) -> Boolean",
  "    removeAll(elems: Collection⟦T⟧)",
  "    removeAll(elems: Collection⟦T⟧)ifAbsent(action:Procedure0) -> Set⟦T⟧",
  "    into(existing: Expandable⟦Unknown⟧) -> Collection⟦Unknown⟧",
  "}",
  "",
  "type Dictionary⟦K,T⟧ = Collection⟦T⟧ & type {",
  "    size -> Number",
  "    containsKey(k:K) -> Boolean",
  "    containsValue(v:T) -> Boolean",
  "    contains(elem:T) -> Boolean",
  "    at(key:K)ifAbsent(action:Function0⟦Unknown⟧) -> Unknown",
  "    at(key:K)put(value:T) -> Dictionary⟦K,T⟧",
  "    at(k:K) -> T",
  "    removeAllKeys(keys: Collection⟦K⟧) -> Dictionary⟦K,T⟧",
  "    removeKey(key:K) -> Dictionary⟦K,T⟧",
  "    removeAllValues(removals: Collection⟦T⟧) -> Dictionary⟦K,T⟧",
  "    removeValue(v:T) -> Dictionary⟦K,T⟧",
  "    clear -> Dictionary⟦K,T⟧",
  "    keys -> Enumerable⟦K⟧",
  "    values -> Enumerable⟦T⟧",
  "    bindings -> Enumerable⟦Binding⟦K,T⟧⟧",
  "    keysAndValuesDo(action:Procedure2⟦K,T⟧) -> Done",
  "    keysDo(action:Procedure1⟦K⟧) -> Done",
  "    valuesDo(action:Procedure1⟦T⟧) -> Done",
  "    == (other:Object) -> Boolean",
  "    copy -> Dictionary⟦K,T⟧",
  "    ++ (other:Dictionary⟦K, T⟧) -> Dictionary⟦K, T⟧",
  "    -- (other:Dictionary⟦K, T⟧) -> Dictionary⟦K, T⟧",
  "    asDictionary -> Dictionary⟦K, T⟧",
  "}",
  "",
  "type Iterator⟦T⟧ = type {",
  "    hasNext -> Boolean",
  "    next -> T",
  "}",
  "",
  "class lazySequenceOver⟦T,R⟧ (source: Collection⟦T⟧)",
  "        mappedBy (function:Function1⟦T, R⟧) -> Enumerable⟦R⟧ is confidential {",
  "    use enumerable⟦T⟧",
  "    class iterator {",
  "        def sourceIterator = source.iterator",
  "        method asString { \"an iterator over a lazy map sequence\" }",
  "        method hasNext { sourceIterator.hasNext }",
  "        method next { function.apply(sourceIterator.next) }",
  "    }",
  "    method size { source.size }",
  "    method isEmpty { source.isEmpty }",
  "    method asDebugString { \"a lazy sequence mapping over {source}\" }",
  "}",
  "",
  "class lazySequenceOver⟦T⟧ (source: Collection⟦T⟧)",
  "        filteredBy(predicate:Predicate1⟦T⟧) -> Enumerable⟦T⟧ is confidential {",
  "    use enumerable⟦T⟧",
  "    class iterator {",
  "        var cache",
  "        var cacheLoaded := false",
  "        def sourceIterator = source.iterator",
  "        method asString { \"an iterator over filtered {source}\" }",
  "        method hasNext {",
  "        // To determine if this iterator has a next element, we have to find",
  "        // an acceptable element; this is then cached, for the use of next",
  "            if (cacheLoaded) then { true } else { hasNextAcceptableElement }",
  "        }",
  "        method next {",
  "            if (cacheLoaded.not) then { cache := nextAcceptableElement }",
  "            cacheLoaded := false",
  "            return cache",
  "        }",
  "        method nextAcceptableElement is confidential {",
  "        // return the next element of the underlying iterator satisfying",
  "        // predicate; if there is none, raises IteratorExhausted.",
  "            while { true } do {",
  "                def outerNext = sourceIterator.next",
  "                def isAcceptable = predicate.apply(outerNext)",
  "                if (isAcceptable) then { return outerNext }",
  "            }",
  "        }",
  "        method hasNextAcceptableElement is confidential {",
  "        // returns true is there is another element in the underlying iterator",
  "        // satisfying predicate, otherwise false",
  "            while { true } do {",
  "                if (sourceIterator.hasNext.not) then { return false }",
  "                def outerNext = sourceIterator.next",
  "                def isAcceptable = predicate.apply(outerNext)",
  "                if (isAcceptable) then {",
  "                    cacheLoaded := true",
  "                    cache := outerNext",
  "                    return true",
  "                }",
  "            }",
  "        }",
  "    }",
  "    method asDebugString { \"a lazy sequence filtering {source}\" }",
  "}",
  "",
  "class iteratorConcat⟦T⟧(left:Iterator⟦T⟧, right:Iterator⟦T⟧) {",
  "    method next {",
  "        if (left.hasNext) then {",
  "            left.next",
  "        } else {",
  "            right.next",
  "        }",
  "    }",
  "    method hasNext {",
  "        if (left.hasNext) then { return true }",
  "        return right.hasNext",
  "    }",
  "    method asDebugString { \"iteratorConcat of {left} and {right}\" }",
  "    method asString { \"an iterator over a concatenation\" }",
  "}",
  "class lazyConcatenation⟦T⟧(left, right) -> Enumerable⟦T⟧{",
  "    use enumerable⟦T⟧",
  "    method iterator {",
  "        iteratorConcat(left.iterator, right.iterator)",
  "    }",
  "    method asDebugString { \"lazy concatenation of {left} and {right}\" }",
  "    method size { left.size + right.size }  // may raise SizeUnknown",
  "}",
  "",
  "trait collection⟦T⟧ {",
  "    ",
  "    method asString { \"a collection trait\" }",
  "    method sizeIfUnknown(action) {",
  "        action.apply",
  "    }",
  "    method size {",
  "        SizeUnknown.raise \"this collection does not know its size\"",
  "    }",
  "    method do { required }",
  "    method iterator { required }",
  "    method isEmpty {",
  "        // override if size is known",
  "        iterator.hasNext.not",
  "    }",
  "    method first {",
  "        def it = self.iterator",
  "        if (it.hasNext) then { ",
  "            it.next",
  "        } else {",
  "            BoundsError.raise \"no first element in {self}\"",
  "        }",
  "    }",
  "    method do(block1) separatedBy(block0) {",
  "        var firstTime := true",
  "        var i := 0",
  "        self.do { each ->",
  "            if (firstTime) then {",
  "                firstTime := false",
  "            } else {",
  "                block0.apply",
  "            }",
  "            block1.apply(each)",
  "        }",
  "        return self",
  "    }",
  "    method reduce(initial, blk) {",
  "    // deprecated; for compatibility with builtInList",
  "        fold(blk)startingWith(initial)",
  "    }",
  "    method fold(blk)startingWith(initial) {",
  "        var result := initial",
  "        self.do {it ->",
  "            result := blk.apply(result, it)",
  "        }",
  "        return result",
  "    }",
  "    method map⟦R⟧(block1:Function1⟦T, R⟧) -> Enumerable⟦R⟧ {",
  "        lazySequenceOver(self) mappedBy(block1)",
  "    }",
  "    method filter(selectionCondition:Predicate1⟦T⟧) -> Enumerable⟦T⟧ {",
  "        lazySequenceOver(self) filteredBy(selectionCondition)",
  "    }",
  "    method iter { self.iterator }",
  "",
  "}",
  "",
  "trait enumerable⟦T⟧ {",
  "    use collection⟦T⟧",
  "    method iterator { required }",
  "    method size {",
  "        // override if size is known",
  "        SizeUnknown.raise \"size requested on {asDebugString}\"",
  "    }",
  "    method asDictionary {",
  "        def result = dictionary.empty",
  "        keysAndValuesDo { k, v ->",
  "            result.at(k) put(v)",
  "        }",
  "        return result",
  "    }",
  "    method into(existing: Expandable⟦T⟧) -> Collection⟦T⟧ {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            existing.add(selfIterator.next)",
  "        }",
  "        existing",
  "    }",
  "    method ==(other) {",
  "        isEqual (self) toCollection (other)",
  "    }",
  "    method do(block1:Procedure1⟦T⟧) -> Done {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            block1.apply(selfIterator.next)",
  "        }",
  "    }",
  "    method keysAndValuesDo(block2:Procedure2⟦Number,T⟧) -> Done {",
  "        var ix := 0",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            ix := ix + 1",
  "            block2.apply(ix, selfIterator.next)",
  "        }",
  "    }",
  "    method values -> Collection⟦T⟧ {",
  "        self",
  "    }",
  "    method fold⟦R⟧(block2)startingWith(initial) -> R {",
  "        var res := initial",
  "        def selfIterator = self.iterator",
  "        while { selfIterator.hasNext } do {",
  "            res := block2.apply(res, selfIterator.next)",
  "        }",
  "        return res",
  "    }",
  "    method ++ (other) -> Enumerable⟦T⟧ {",
  "        lazyConcatenation(self, other)",
  "    }",
  "    method sortedBy(sortBlock:Function2) -> List⟦T⟧ {",
  "        list.withAll(self).sortBy(sortBlock)",
  "    }",
  "    method sorted -> List⟦T⟧ {",
  "        list.withAll(self).sort",
  "    }",
  "    method asString {",
  "        var s := \"⟨\"",
  "        do { each -> s := s ++ each.asString } separatedBy { s := s ++ \", \" }",
  "        s ++ \"⟩\"",
  "    }",
  "}",
  "",
  "trait indexable⟦T⟧ {",
  "    use collection⟦T⟧",
  "    method at(index) { required }",
  "    method size { required }",
  "    method isEmpty { size == 0 }",
  "    method keysAndValuesDo(action:Procedure2⟦Number,T⟧) -> Done {",
  "        def curSize = size",
  "        var i := 1",
  "        while {i <= curSize} do {",
  "            action.apply(i, self.at(i))",
  "            i := i + 1",
  "        }",
  "    }",
  "    method first { at(1) }",
  "    method second { at(2) }",
  "    method third { at(3) }",
  "    method fourth { at(4) }",
  "    method fifth { at(5) }",
  "    method last { at(size) }",
  "    method indices { range.from 1 to(size) }",
  "    method indexOf(sought:T)  {",
  "        indexOf(sought) ifAbsent { NoSuchObject.raise \"collection does not contain {sought}\" }",
  "    }",
  "    method indexOf(sought:T) ifAbsent(action:Function0⟦Unknown⟧)  {",
  "        keysAndValuesDo { ix, v ->",
  "            if (v == sought) then { return ix }",
  "        }",
  "        action.apply",
  "    }",
  "    method asDictionary {",
  "        def result = dictionary.empty",
  "        keysAndValuesDo { k, v ->",
  "            result.at(k) put(v)",
  "        }",
  "        return result",
  "    }",
  "    method into(existing: Expandable⟦T⟧) -> Collection⟦T⟧ {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            existing.add(selfIterator.next)",
  "        }",
  "        existing",
  "    }",
  "}",
  "",
  "method max(a,b) is confidential {       // copied from standard prelude",
  "    if (a > b) then { a } else { b }",
  "}",
  "",
  "def emptySequence is confidential = object {",
  "    use indexable",
  "    method size { 0 }",
  "    method isEmpty { true }",
  "    method at(n) { BoundsError.raise \"index {n} of empty sequence\" }",
  "    method keys { self }",
  "    method values { self }",
  "    method keysAndValuesDo(block2) { done }",
  "    method reversed { self }",
  "    method ++(other: Collection) { sequence.withAll(other) }",
  "    method asString { \"⟨⟩\" }",
  "    method contains(element) { false }",
  "    method do(block1) { done }",
  "    method ==(other) {",
  "        match (other)",
  "            case {o: Collection ->",
  "                o.isEmpty",
  "            }",
  "            case {_ ->",
  "                false",
  "            }",
  "    }",
  "    class iterator {",
  "        method asString { \"emptySequenceIterator\" }",
  "        method hasNext { false }",
  "        method next { IteratorExhausted.raise \"on empty sequence\" }",
  "    }",
  "    method sorted { self }",
  "    method sortedBy(sortBlock:Function2){ self }",
  "}",
  "",
  "class sequence⟦T⟧ {",
  "",
  "    method asString { \"a sequence factory\" }",
  "",
  "    method empty {",
  "        // this is an optimization: there need be just one empty sequence",
  "        emptySequence",
  "    }",
  "",
  "    method withAll(arg: Collection⟦T⟧) {",
  "        var sizeCertain := true",
  "        // size might be uncertain if arg is a lazy collection.",
  "        def forecastSize = arg.sizeIfUnknown {",
  "            sizeCertain := false",
  "            8",
  "        }",
  "        var inner := prelude.primitiveArray.new(forecastSize)",
  "        var innerSize := inner.size",
  "        var ix := 0",
  "        if (sizeCertain) then {",
  "            // common, fast path",
  "            for (arg) do { elt ->",
  "                inner.at(ix)put(elt)",
  "                ix := ix + 1",
  "            }",
  "        } else {",
  "            // less-than-optimal path",
  "            for (arg) do { elt ->",
  "                if (innerSize <= ix) then {",
  "                    def newInner = prelude.primitiveArray.new(innerSize * 2)",
  "                    for (0..(innerSize-1)) do { i ->",
  "                        newInner.at(i)put(inner.at(i))",
  "                    }",
  "                    inner := newInner",
  "                    innerSize := inner.size",
  "                }",
  "                inner.at(ix)put(elt)",
  "                ix := ix + 1",
  "            }",
  "        }",
  "        if (ix == 0) then { return emptySequence }",
  "        self.fromprimitiveArray(inner, ix)",
  "    }",
  "    method fromprimitiveArray(pArray, sz) is confidential {",
  "        // constructs a sequence from the first sz elements of pArray",
  "",
  "        object {",
  "            use indexable",
  "            def size is public = sz",
  "            def inner = pArray",
  "",
  "            method boundsCheck(n) is confidential {",
  "                if (!(n >= 1) || !(n <= size)) then {",
  "                    // the condition is written this way because NaN always",
  "                    // compares false",
  "                    BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                }",
  "            }",
  "            method at(n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method keys {",
  "                range.from(1)to(size)",
  "            }",
  "            method values {",
  "                self",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block2.apply(i+1, inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method reversed {",
  "                def freshArray = prelude.primitiveArray.new(size)",
  "                var ix := size - 1",
  "                do { each ->",
  "                    freshArray.at (ix) put(each)",
  "                    ix := ix - 1",
  "                }",
  "                outer.fromprimitiveArray(freshArray, size)",
  "            }",
  "            method ++(other: Collection) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method asString {",
  "                var s := \"⟨\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"⟩\"",
  "            }",
  "            method contains(element) {",
  "                do { each -> if (each == element) then { return true } }",
  "                return false",
  "            }",
  "            method do(block1) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block1.apply(inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toCollection (other)",
  "            }",
  "            method iterator {",
  "                object {",
  "                    var idx := 1",
  "                    method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                    method asString { \"aSequenceIterator\" }",
  "                    method hasNext { idx <= sz }",
  "                    method next {",
  "                        if (idx > sz) then { IteratorExhausted.raise \"on sequence {outer}⟪{idx}⟫\" }",
  "                        def ret = at(idx)",
  "                        idx := idx + 1",
  "                        ret",
  "                    }",
  "                }",
  "            }",
  "            method sorted {",
  "                sequence.withAll(list.withAll(self).sortBy { l, r ->",
  "                    if (l == r) then {0}",
  "                        elseif {l < r} then {-1}",
  "                        else {1}",
  "                })",
  "            }",
  "            method sortedBy(sortBlock:Function2){",
  "                sequence.withAll(list.withAll(self).sortBy(sortBlock))",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "type MinimalyIterable = type {",
  "    iterator -> Iterator",
  "}",
  "",
  "method isEqual(left) toCollection(right) {",
  "    if (MinimalyIterable.match(right)) then {",
  "        def leftIter = left.iterator",
  "        def rightIter = right.iterator",
  "        while {leftIter.hasNext && rightIter.hasNext} do {",
  "            if (leftIter.next != rightIter.next) then {",
  "                return false",
  "            }",
  "        }",
  "        leftIter.hasNext == rightIter.hasNext",
  "    } else { ",
  "        false",
  "    }",
  "}",
  "",
  "class list⟦T⟧ {",
  "    ",
  "    method asString { \"the list class\" }",
  "    ",
  "    method empty -> List⟦T⟧ {",
  "        withAll(emptySequence)",
  "    }",
  "",
  "    method withAll(a: Collection⟦T⟧) -> List⟦T⟧ {",
  "        object {",
  "            use indexable⟦T⟧",
  "",
  "            var mods is readable := 0",
  "            var sizeCertain := true",
  "            // size might be uncertain if a is a lazy collection.",
  "            def initialSize = a.sizeIfUnknown{ sizeCertain := false ; 4 } * 2 + 1",
  "            var inner := prelude.primitiveArray.new(initialSize)",
  "            var size is readable := 0",
  "            if (sizeCertain) then {",
  "                // common, fast path",
  "                for (a) do { x ->",
  "                    inner.at(size)put(x)",
  "                    size := size + 1",
  "                }",
  "            } else {",
  "                // less-than-optimal path",
  "                var innerSize := initialSize",
  "                for (a) do { x ->",
  "                    if (innerSize <= size) then {",
  "                        def newInner = prelude.primitiveArray.new(innerSize * 2)",
  "                        for (0..(innerSize-1)) do { i ->",
  "                            newInner.at (i) put (inner.at(i) )",
  "                        }",
  "                        inner := newInner",
  "                        innerSize := inner.size",
  "                    }",
  "                    inner.at(size)put(x)",
  "                    size := size + 1",
  "                }",
  "            }",
  "            method boundsCheck(n) is confidential {",
  "                if ( !(n >= 1) || !(n <= size)) then {",
  "                    BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                }",
  "            }",
  "            method at(n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method at(n)put(x) {",
  "                mods := mods + 1",
  "                if (n == (size+1)) then {",
  "                    addLast(x)",
  "                } else {",
  "                    boundsCheck(n)",
  "                    inner.at(n-1)put(x)",
  "                }",
  "                self",
  "            }",
  "            method add(x) {",
  "                mods := mods + 1",
  "                if (size == inner.size) then { expandTo(inner.size * 2) }",
  "                inner.at(size)put(x)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method addAll(l) {",
  "                mods := mods + 1",
  "                if ((size + l.size) > inner.size) then {",
  "                    expandTo(max(size + l.size, size * 2))",
  "                }",
  "                for (l) do {each ->",
  "                    inner.at(size)put(each)",
  "                    size := size + 1",
  "                }",
  "                self",
  "            }",
  "            method push(x) {",
  "                mods := mods + 1",
  "                if (size == inner.size) then { expandTo(inner.size * 2) }",
  "                inner.at(size)put(x)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method addLast(x) { push(x) }    // compatibility",
  "            method removeLast {",
  "                mods := mods + 1",
  "                def result = inner.at(size - 1)",
  "                size := size - 1",
  "                result",
  "            }",
  "            method addAllFirst(l) {",
  "                mods := mods + 1",
  "                def increase = l.size",
  "                if ((size + increase) > inner.size) then {",
  "                    expandTo(max(size + increase, size * 2))",
  "                }",
  "                for (range.from(size-1)downTo(0)) do {i->",
  "                    inner.at(i+increase)put(inner.at(i))",
  "                }",
  "                var insertionIndex := 0",
  "                for (l) do {each ->",
  "                    inner.at(insertionIndex)put(each)",
  "                    insertionIndex := insertionIndex + 1",
  "                }",
  "                size := size + increase",
  "                self",
  "            }",
  "            method addFirst(elt:T) {",
  "                mods := mods + 1",
  "                if ((size + 1) > inner.size) then {",
  "                    expandTo(size * 2)",
  "                }",
  "                for (range.from (size-1) downTo 0) do {i->",
  "                    inner.at (i+1) put (inner.at(i) )",
  "                }",
  "                inner.at(0)put(elt)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method clear {",
  "                mods := mods + 1",
  "                inner := prelude.primitiveArray.new(initialSize)",
  "                size := 0",
  "                self",
  "            }",
  "            method removeFirst {",
  "                removeAt(1)",
  "            }",
  "            method removeAt(n) {",
  "                mods := mods + 1",
  "                boundsCheck(n)",
  "                def removed = inner.at(n-1)",
  "                for (n..(size-1)) do {i->",
  "                    inner.at(i-1)put(inner.at(i))",
  "                }",
  "                size := size - 1",
  "                return removed",
  "            }",
  "",
  "            method remove(elt:T) {",
  "                def ix = self.indexOf(elt) ifAbsent {",
  "                    NoSuchObject.raise \"list does not contain {elt}\"",
  "                }",
  "                removeAt(ix)",
  "                self",
  "            }",
  "",
  "            method remove(elt:T) ifAbsent(action:Procedure0) {",
  "                def ix = self.indexOf(elt) ifAbsent {",
  "                    action.apply",
  "                    return self",
  "                }",
  "                removeAt(ix)",
  "                self",
  "            }",
  "",
  "            method removeAll(vs: Collection⟦T⟧) {",
  "                removeAll(vs) ifAbsent { NoSuchObject.raise \"list does not contain object\" }",
  "                self",
  "            }",
  "            method removeAll(vs: Collection⟦T⟧) ifAbsent(action:Procedure0)  {",
  "                for (vs) do { each ->",
  "                    def ix = indexOf(each) ifAbsent { 0 }",
  "                    if (ix ≠ 0) then {",
  "                        removeAt(ix)",
  "                    } else {",
  "                        action.apply",
  "                    }",
  "                }",
  "                self",
  "            }",
  "            method pop { removeLast }",
  "            method reversed {",
  "                def result = list.empty",
  "                do { each -> result.addFirst(each) }",
  "                result",
  "            }",
  "            method reverse {",
  "                mods := mods + 1",
  "                var hiIx := size",
  "                var loIx := 1",
  "                while {loIx < hiIx} do {",
  "                    def hiVal = self.at(hiIx)",
  "                    self.at(hiIx) put (self.at(loIx))",
  "                    self.at(loIx) put (hiVal)",
  "                    hiIx := hiIx - 1",
  "                    loIx := loIx + 1",
  "                }",
  "                self",
  "            }",
  "            method ++(o) {",
  "                def l = list.withAll(self)",
  "                l.addAll(o)",
  "            }",
  "            method asString {",
  "                var s := \"[\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"]\"",
  "            }",
  "            method asDebugString {",
  "                var s := \"[\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asDebugString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"]\"",
  "            }",
  "            method contains(element) {",
  "                do { each -> if (each == element) then { return true } }",
  "                return false",
  "            }",
  "            method do(block1) {",
  "                def iMods = mods",
  "                var i := 0",
  "                while {i < size} do {",
  "                    if (iMods ≠ mods) then {",
  "                        ConcurrentModification.raise (asDebugString)",
  "                    }",
  "                    block1.apply(inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "",
  "            method ==(other) {",
  "                isEqual (self) toCollection (other)",
  "            }",
  "            method iterator {",
  "                object {",
  "                    def iMods = mods",
  "                    var idx := 1",
  "                    method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                    method asString { \"aListIterator\" }",
  "                    method hasNext { idx <= size }",
  "                    method next {",
  "                        if (iMods != mods) then {",
  "                            ConcurrentModification.raise (asDebugString)",
  "                        }",
  "                        if (idx > size) then { IteratorExhausted.raise \"on list\" }",
  "                        def ret = at(idx)",
  "                        idx := idx + 1",
  "                        ret",
  "                    }",
  "                }",
  "            }",
  "            method values {",
  "                self",
  "            }",
  "            method keys {",
  "                self.indices",
  "            }",
  "            method expandTo(newSize) is confidential {",
  "                def newInner = prelude.primitiveArray.new(newSize)",
  "                for (0..(size-1)) do {i->",
  "                    newInner.at(i)put(inner.at(i))",
  "                }",
  "                inner := newInner",
  "            }",
  "            method sortBy(sortBlock:Function2) {",
  "                mods := mods + 1",
  "                inner.sortInitial(size) by(sortBlock)",
  "                self",
  "            }",
  "            method sort {",
  "                sortBy { l, r ->",
  "                    if (l == r) then {0}",
  "                        elseif {l < r} then {-1}",
  "                        else {1}",
  "                }",
  "            }",
  "            method sortedBy(sortBlock:Function2) {",
  "                copy.sortBy(sortBlock)",
  "            }",
  "            method sorted {",
  "                copy.sort",
  "            }",
  "            method copy {",
  "                outer.withAll(self)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "",
  "def unused = object {",
  "    var unused := true",
  "    def key is public = self",
  "    def value is public = self",
  "    method asString { \"unused\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "def removed = object {",
  "    var removed := true",
  "    def key is public = self",
  "    def value is public = self",
  "    method asString { \"removed\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "class set⟦T⟧ {",
  "",
  "    method asString { \"a set class\" }",
  "",
  "    method withAll(a: Collection⟦T⟧) -> Set⟦T⟧ {",
  "        def cap = max (a.sizeIfUnknown{2} * 3 + 1, 8)",
  "        def result = ofCapacity (cap)",
  "        a.do { x -> result.add(x) }",
  "        result",
  "    }",
  "    ",
  "    method empty -> Set⟦T⟧ {",
  "        ofCapacity 8",
  "    }",
  "",
  "    class ofCapacity(cap) -> Set⟦T⟧ is confidential {",
  "        use collection⟦T⟧",
  "        var mods is readable := 0",
  "        var inner := prelude.primitiveArray.new(cap)",
  "        var size is readable := 0",
  "        (0..(cap - 1)).do { i ->",
  "            inner.at (i) put (unused)",
  "        }",
  "",
  "        method isEmpty { size == 0 }",
  "",
  "        method addAll(elements) {",
  "            mods := mods + 1",
  "            for (elements) do { x ->",
  "                if (! contains(x)) then {",
  "                    def t = findPositionForAdd(x)",
  "                    inner.at(t)put(x)",
  "                    size := size + 1",
  "                    if (size > (inner.size / 2)) then {",
  "                        expand",
  "                    }",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method add(x:T) {",
  "            if (! contains(x)) then {",
  "                mods := mods + 1",
  "                def t = findPositionForAdd(x)",
  "                inner.at(t)put(x)",
  "                size := size + 1",
  "                if (size > (inner.size / 2)) then {",
  "                    expand",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method removeAll(elements) {",
  "            for (elements) do { x ->",
  "                remove (x) ifAbsent {",
  "                    NoSuchObject.raise \"set does not contain {x}\"",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "        method removeAll(elements)ifAbsent(block:Procedure1⟦T⟧) {",
  "            mods := mods + 1",
  "            for (elements) do { x ->",
  "                var t := findPosition(x)",
  "                if (inner.at(t) == x) then {",
  "                    inner.at(t) put (removed)",
  "                    size := size - 1",
  "                } else {",
  "                    block.apply(x)",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "        method clear {",
  "            mods := mods + 1",
  "            inner := prelude.primitiveArray.new(cap)",
  "            size := 0",
  "            self",
  "        }",
  "",
  "        method remove (elt:T) ifAbsent (block) {",
  "            var t := findPosition(elt)",
  "            if (inner.at(t) == elt) then {",
  "                inner.at(t) put (removed)",
  "                mods := mods + 1",
  "                size := size - 1",
  "            } else {",
  "                block.apply",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method remove(elt:T) {",
  "            remove (elt) ifAbsent {",
  "                NoSuchObject.raise \"set does not contain {elt}\"",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method contains(x) {",
  "            var t := findPosition(x)",
  "            if (inner.at(t) == x) then {",
  "                return true",
  "            }",
  "            return false",
  "        }",
  "        method includes(booleanBlock) {",
  "            self.do { each ->",
  "                if (booleanBlock.apply(each)) then { return true }",
  "            }",
  "            return false",
  "        }",
  "        method find(booleanBlock)ifNone(notFoundBlock) {",
  "            self.do { each ->",
  "                if (booleanBlock.apply(each)) then { return each }",
  "            }",
  "            return notFoundBlock.apply",
  "        }",
  "        method findPosition(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            var candidate",
  "            while {",
  "                candidate := inner.at(t)",
  "                unused ≠ candidate",
  "            } do {",
  "                if (candidate == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method findPositionForAdd(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            var candidate",
  "            while {",
  "                candidate := inner.at(t)",
  "                (unused != candidate) && (removed != candidate)",
  "            } do {",
  "                if (candidate == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "",
  "        method asString {",
  "            var s := \"set\\{\"",
  "            do {each -> s := s ++ each.asString }",
  "                separatedBy { s := s ++ \", \" }",
  "            s ++ \"\\}\"",
  "        }",
  "        method asDebugString {",
  "            var s := \"set\\{\"",
  "            do {each -> s := s ++ each.asDebugString }",
  "                separatedBy { s := s ++ \", \" }",
  "            s ++ \"\\}\"",
  "        }",
  "        method extend(l) {",
  "            for (l) do {i->",
  "                add(i)",
  "            }",
  "        }",
  "        method do(block1) {",
  "            def iMods = mods",
  "            var i := 0",
  "            var found := 0",
  "            var candidate",
  "            while {found < size} do {",
  "                if (iMods != mods) then {",
  "                    ConcurrentModification.raise (outer.asDebugString)",
  "                }",
  "                candidate := inner.at(i)",
  "                if ((unused != candidate) && (removed != candidate)) then {",
  "                    found := found + 1",
  "                    block1.apply(candidate)",
  "                }",
  "                i := i + 1",
  "            }",
  "        }",
  "        method iterator {",
  "            object {",
  "                def iMods = mods",
  "                var count := 1",
  "                var idx := -1",
  "                method hasNext { size >= count }",
  "                method next {",
  "                    var candidate",
  "                    def innerSize = inner.size",
  "                    while {",
  "                        idx := idx + 1",
  "                        if (iMods != mods) then {",
  "                            ConcurrentModification.raise (outer.asDebugString)",
  "                        }",
  "                        if (idx >= innerSize) then {",
  "                            IteratorExhausted.raise \"iterator over {outer.asString}\"",
  "                        }",
  "                        candidate := inner.at(idx)",
  "                        (unused == candidate) || (removed == candidate)",
  "                    } do { }",
  "                    count := count + 1",
  "                    candidate",
  "                }",
  "            }",
  "        }",
  "",
  "        method expand is confidential {",
  "            def c = inner.size",
  "            def n = c * 2",
  "            def oldInner = inner",
  "            size := 0",
  "            inner := prelude.primitiveArray.new(n)",
  "            for (0..(inner.size-1)) do {i->",
  "                inner.at(i)put(unused)",
  "            }",
  "            for (0..(oldInner.size-1)) do {i->",
  "                if ((unused != oldInner.at(i)) && (removed != oldInner.at(i))) then {",
  "                    add(oldInner.at(i))",
  "                }",
  "            }",
  "        }",
  "        method ==(other) {",
  "            if (Collection.match(other)) then {",
  "                var otherSize := 0",
  "                other.do { each ->",
  "                    otherSize := otherSize + 1",
  "                    if (! self.contains(each)) then {",
  "                        return false",
  "                    }",
  "                }",
  "                otherSize == self.size",
  "            } else { ",
  "                false",
  "            }",
  "        }",
  "        method copy {",
  "            outer.withAll(self)",
  "        }",
  "        method ++ (other) {",
  "        // set union",
  "            copy.addAll(other)",
  "        }",
  "        method -- (other) {",
  "        // set difference",
  "            def result = set.empty",
  "            for (self) do {v->",
  "                if (!other.contains(v)) then {",
  "                    result.add(v)",
  "                }",
  "            }",
  "            result",
  "        }",
  "        method ** (other) {",
  "        // set intersection",
  "            set.withAll((filter {each -> other.contains(each)}))",
  "        }",
  "        method isSubset(s2: Set⟦T⟧) {",
  "            self.do{ each ->",
  "                if (s2.contains(each).not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "",
  "        method isSuperset(s2: Collection⟦T⟧) {",
  "            s2.do{ each ->",
  "                if (self.contains(each).not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "        method into(existing: Expandable⟦T⟧) -> Collection⟦T⟧ {",
  "            do { each -> existing.add(each) }",
  "            existing",
  "        }",
  "    }",
  "}",
  "",
  "type Binding⟦K,T⟧ = {",
  "    key -> K",
  "    value -> T",
  "    hash -> Number",
  "    ==(other) -> Boolean",
  "}",
  "",
  "def binding is public = object {",
  "    method asString { \"the binding class\" }",
  "",
  "    class key(k)value(v) {",
  "        method key {k}",
  "        method value {v}",
  "        method asString { \"{k}::{v}\" }",
  "        method hashcode { (k.hashcode * 1021) + v.hashcode }",
  "        method hash { (k.hash * 1021) + v.hash }",
  "        method == (other) {",
  "            match (other)",
  "                case {o:Binding -> (k == o.key) && (v == o.value) }",
  "                case {_ -> return false }",
  "        }",
  "    }",
  "}",
  "",
  "type ComparableToDictionary⟦K,T⟧ = type {",
  "    size -> Number",
  "    at(_:K)ifAbsent(_) -> T",
  "}",
  "",
  "class dictionary⟦K,T⟧ {",
  "",
  "    method asString { \"a dictionary class\" }",
  "",
  "    method withAll(initialBindings: Collection⟦Binding⟦K,T⟧⟧) -> Dictionary⟦K,T⟧ {",
  "        def result = empty",
  "        for (initialBindings) do { b -> result.add(b) }",
  "        result",
  "    }",
  "",
  "    class empty -> Dictionary⟦K,T⟧ {",
  "        use collection⟦T⟧",
  "        var mods is readable := 0",
  "        var numBindings := 0",
  "        var inner := prelude.primitiveArray.new(8)",
  "        for (0..(inner.size-1)) do { i ->",
  "            inner.at(i)put(unused)",
  "        }",
  "        method size { numBindings }",
  "        method at(key')put(value') {",
  "            mods := mods + 1",
  "            var t := findPositionForAdd(key')",
  "            if ((unused == inner.at(t)) || (removed == inner.at(t))) then {",
  "                numBindings := numBindings + 1",
  "            }",
  "            inner.at(t)put(binding.key(key')value(value'))",
  "            if ((size * 2) > inner.size) then { expand }",
  "            self    // for chaining",
  "        }",
  "        method add(aBinding) {",
  "            mods := mods + 1",
  "            var t := findPositionForAdd (aBinding.key)",
  "            if ((unused == inner.at(t)) || (removed == inner.at(t))) then {",
  "                numBindings := numBindings + 1",
  "            }",
  "            inner.at(t)put(aBinding)",
  "            if ((size * 2) > inner.size) then { expand }",
  "            self    // for chaining",
  "        }",
  "        method at(k) {",
  "            var b := inner.at(findPosition(k))",
  "            if (b.key == k) then {",
  "                return b.value",
  "            }",
  "            NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "        }",
  "        method at(k) ifAbsent(action) {",
  "            var b := inner.at(findPosition(k))",
  "            if (b.key == k) then {",
  "                return b.value",
  "            }",
  "            action.apply",
  "        }",
  "        method containsKey(k) {",
  "            var t := findPosition(k)",
  "            if (inner.at(t).key == k) then {",
  "                return true",
  "            }",
  "            false",
  "        }",
  "        method removeAllKeys(keys) {",
  "            mods := mods + 1",
  "            for (keys) do { k ->",
  "                var t := findPosition(k)",
  "                if (inner.at(t).key == k) then {",
  "                    inner.at(t)put(removed)",
  "                    numBindings := numBindings - 1",
  "                } else {",
  "                    NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "                }",
  "            }",
  "            self",
  "        }",
  "        method removeKey(k:K) {",
  "            mods := mods + 1",
  "            var t := findPosition(k)",
  "            if (inner.at(t).key == k) then {",
  "                inner.at(t)put(removed)",
  "                numBindings := numBindings - 1",
  "            } else {",
  "                NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "            }",
  "            self",
  "        }",
  "        method removeKey(k:K) ifAbsent (action:Function0⟦Unknown⟧) {",
  "            mods := mods + 1",
  "            var t := findPosition(k)",
  "            if (inner.at(t).key == k) then {",
  "                inner.at(t)put(removed)",
  "                numBindings := numBindings - 1",
  "            } else {",
  "                action.apply",
  "            }",
  "            self",
  "        }",
  "        method removeAllValues(removals) {",
  "            mods := mods + 1",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (removals.contains(a.value)) then {",
  "                    inner.at(i)put(removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            self",
  "        }",
  "        method removeValue(v) {",
  "            // remove all bindings with value v",
  "            mods := mods + 1",
  "            def initialNumBindings = numBindings",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (v == a.value) then {",
  "                    inner.at (i) put (removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            if (numBindings == initialNumBindings) then {",
  "                NoSuchObject.raise \"dictionary does not contain entry with value {v}\"",
  "            }",
  "            self",
  "        }",
  "        method removeValue(v) ifAbsent (action:Function0⟦Unknown⟧) {",
  "            // remove all bindings with value v",
  "            mods := mods + 1",
  "            def initialNumBindings = numBindings",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (v == a.value) then {",
  "                    inner.at (i) put (removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            if (numBindings == initialNumBindings) then {",
  "                action.apply",
  "            }",
  "            self",
  "        }",
  "        method clear {",
  "            inner := prelude.primitiveArray.new(8)",
  "            numBindings := 0",
  "            mods := mods + 1",
  "            for (0..(inner.size-1)) do { i ->",
  "                inner.at(i)put(unused)",
  "            }",
  "            self",
  "        }",
  "        method containsValue(v) {",
  "            self.valuesDo{ each ->",
  "                if (v == each) then { return true }",
  "            }",
  "            false",
  "        }",
  "        method contains(v) { containsValue(v) }",
  "",
  "        method findPosition(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            while { unused ≠ inner.at(t) } do {",
  "                if (inner.at(t).key == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method findPositionForAdd(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            while { (unused ≠ inner.at(t)) && (removed ≠ inner.at(t)) } do {",
  "                if (inner.at(t).key == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method asString {",
  "            // do()separatedBy won't work, because it iterates over values,",
  "            // and we need an iterator over bindings.",
  "            var s := \"dict⟬\"",
  "            var firstElement := true",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    if (! firstElement) then {",
  "                        s := s ++ \", \"",
  "                    } else {",
  "                        firstElement := false",
  "                    }",
  "                    s := s ++ \"{a.key}::{a.value}\"",
  "                }",
  "            }",
  "            s ++ \"⟭\"",
  "        }",
  "        method asDebugString {",
  "            var s := \"dict⟬\"",
  "            for (0..(inner.size-1)) do {i->",
  "                if (i > 0) then { s := s ++ \", \" }",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    s := s ++ \"{i}→{a.key}::{a.value}\"",
  "                } else {",
  "                    s := s ++ \"{i}→{a.asDebugString}\"",
  "                }",
  "            }",
  "            s ++ \"⟭\"",
  "        }",
  "        method keys -> Enumerable⟦K⟧ {",
  "            def sourceDictionary = self",
  "            object {",
  "                use enumerable⟦K⟧",
  "                class iterator {",
  "                    def sourceIterator = sourceDictionary.bindingsIterator",
  "                    method hasNext { sourceIterator.hasNext }",
  "                    method next { sourceIterator.next.key }",
  "                    method asString {",
  "                        \"an iterator over keys of {sourceDictionary}\"",
  "                    }",
  "                }",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over keys of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method values -> Enumerable⟦T⟧ {",
  "            def sourceDictionary = self",
  "            object {",
  "                use enumerable⟦T⟧",
  "                class iterator {",
  "                    def sourceIterator = sourceDictionary.bindingsIterator",
  "                    // should be request on outer",
  "                    method hasNext { sourceIterator.hasNext }",
  "                    method next { sourceIterator.next.value }",
  "                    method asString {",
  "                        \"an iterator over values of {sourceDictionary}\"",
  "                    }",
  "                }",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over values of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method bindings -> Enumerable⟦T⟧ {",
  "            def sourceDictionary = self",
  "            object {",
  "                use enumerable⟦T⟧",
  "                method iterator { sourceDictionary.bindingsIterator }",
  "                // should be request on outer",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over bindings of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method iterator -> Iterator⟦T⟧ { values.iterator }",
  "        class bindingsIterator -> Iterator⟦Binding⟦K, T⟧⟧ {",
  "            // this should be confidential, but can't be until `outer` is fixed.",
  "            def iMods = mods",
  "            var count := 1",
  "            var idx := 0",
  "            var elt",
  "            method hasNext { size >= count }",
  "            method next {",
  "                if (iMods != mods) then {",
  "                    ConcurrentModification.raise (outer.asString)",
  "                }",
  "                if (size < count) then { IteratorExhausted.raise \"over {outer.asString}\" }",
  "                while {",
  "                    elt := inner.at(idx)",
  "                    (unused == elt) || (removed == elt)",
  "                } do {",
  "                    idx := idx + 1",
  "                }",
  "                count := count + 1",
  "                idx := idx + 1",
  "                elt",
  "            }",
  "        }",
  "        method expand is confidential {",
  "            def c = inner.size",
  "            def n = c * 2",
  "            def oldInner = inner",
  "            inner := prelude.primitiveArray.new(n)",
  "            for (0..(n - 1)) do {i->",
  "                inner.at(i)put(unused)",
  "            }",
  "            numBindings := 0",
  "            for (0..(c - 1)) do {i->",
  "                def a = oldInner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    self.at(a.key)put(a.value)",
  "                }",
  "            }",
  "        }",
  "        method keysAndValuesDo(block2) {",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block2.apply(a.key, a.value)",
  "                }",
  "            }",
  "        }",
  "        method keysDo(block1) {",
  "            def iMods = mods",
  "            for (0..(inner.size-1)) do { i ->",
  "                if (iMods ≠ mods) then {",
  "                    ConcurrentModification.raise (asDebugString)",
  "                }",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block1.apply(a.key)",
  "                }",
  "            }",
  "        }",
  "        method valuesDo(block1) {",
  "            def iMods = mods",
  "            for (0..(inner.size-1)) do { i ->",
  "                if (iMods ≠ mods) then {",
  "                    ConcurrentModification.raise (asDebugString)",
  "                }",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block1.apply(a.value)",
  "                }",
  "            }",
  "        }",
  "        method do(block1) { valuesDo(block1) }",
  "",
  "        method ==(other) {",
  "            match (other)",
  "                case {o:ComparableToDictionary⟦K,V⟧ ->",
  "                    if (self.size != o.size) then {return false}",
  "                    self.keysAndValuesDo { k, v ->",
  "                        if (o.at(k)ifAbsent{return false} != v) then {",
  "                            return false",
  "                        }",
  "                    }",
  "                    return true",
  "                }",
  "                case {_ ->",
  "                    return false",
  "                }",
  "        }",
  "",
  "        method copy {",
  "            def newCopy = dictionary.empty",
  "            self.keysAndValuesDo{ k, v ->",
  "                newCopy.at(k)put(v)",
  "            }",
  "            newCopy",
  "        }",
  "",
  "        method asDictionary {",
  "            self",
  "        }",
  "",
  "        method ++(other) {",
  "            def newDict = self.copy",
  "            other.keysAndValuesDo {k, v ->",
  "                newDict.at(k) put(v)",
  "            }",
  "            return newDict",
  "        }",
  "",
  "        method --(other) {",
  "            def newDict = dictionary.empty",
  "            keysAndValuesDo { k, v ->",
  "                if (! other.containsKey(k)) then {",
  "                    newDict.at(k) put(v)",
  "                }",
  "            }",
  "            return newDict",
  "        }",
  "    }",
  "}",
  "",
  "class range {",
  "    method from(lower)to(upper) -> Sequence⟦Number⟧ {",
  "        match (lower)",
  "            case {_:Number -> }",
  "            case {_ -> RequestError.raise (\"lower bound {lower}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "        def start = lower.truncated",
  "        if (start != lower) then {",
  "            RequestError.raise (\"lower bound {lower}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "",
  "        match (upper)",
  "            case {_:Number -> }",
  "            case {_ -> RequestError.raise (\"upper bound {upper}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "        def stop = upper.truncated",
  "        if (stop != upper) then {",
  "            RequestError.raise (\"upper bound {upper}\" ++",
  "                \" in range.from()to() is not an integer\")",
  "        }",
  "",
  "        uncheckedFrom (lower) to (upper)",
  "    }",
  "",
  "    method uncheckedFrom (lower) to (upper) -> Sequence⟦Number⟧ {",
  "        object {",
  "            use indexable⟦Number⟧",
  "            def start = lower",
  "            def stop = upper",
  "            def size is public =",
  "                if ((upper-lower+1) < 0) then { 0 } else {upper-lower+1}",
  "",
  "            def hash is public = { ((start.hash * 1021) + stop.hash) * 3 }",
  "",
  "            method iterator -> Iterator {",
  "                object {",
  "                    var val := start",
  "                    method hasNext { val <= stop }",
  "                    method next {",
  "                        if (val > stop) then {",
  "                            IteratorExhausted.raise \"over {outer.asString}\"",
  "                        }",
  "                        val := val + 1",
  "                        return (val - 1)",
  "                    }",
  "                    method asString { \"iterator over {outer.asString} at {val}\" }",
  "                }",
  "            }",
  "            method at(ix:Number) {",
  "                if (!(ix <= self.size)) then {",
  "                    BoundsError.raise \"requested range.at({ix}), but upper bound is {size}\"",
  "                }",
  "                if (!(ix >= 1)) then {",
  "                    BoundsError.raise \"requested range.at({ix}), but lower bound is 1\"",
  "                }",
  "                return start + (ix - 1)",
  "            }",
  "            method contains(elem) -> Boolean {",
  "                try {",
  "                    def intElem = elem.truncated",
  "                    if (intElem != elem) then {return false}",
  "                    if (intElem < start) then {return false}",
  "                    if (intElem > stop) then {return false}",
  "                } catch { ex:prelude.Exception -> return false }",
  "                return true",
  "            }",
  "            method do(block1) {",
  "                var val := start",
  "                while {val <= stop} do {",
  "                    block1.apply(val)",
  "                    val := val + 1",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var key := 1",
  "                var val := start",
  "                while {val <= stop} do {",
  "                    block2.apply(key, val)",
  "                    key := key + 1",
  "                    val := val + 1",
  "                }",
  "            }",
  "            method reversed {",
  "                from(upper)downTo(lower)",
  "            }",
  "            method ++(other) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toCollection (other)",
  "            }",
  "            method sorted { self }",
  "",
  "            method sortedBy(c) { list.withAll(self).sortBy(c) }",
  "",
  "            method keys { 1..self.size }",
  "",
  "            method values { self }",
  "",
  "            method asString -> String{",
  "                \"range.from({lower})to({upper})\"",
  "            }",
  "        }",
  "    }",
  "    method from(upper)downTo(lower) -> Sequence⟦Number⟧ {",
  "        object {",
  "            use indexable⟦Number⟧",
  "            match (upper)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise (\"upper bound {upper}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\") }",
  "            def start = upper.truncated",
  "            if (start != upper) then {",
  "                RequestError.raise (\"upper bound {upper}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\")",
  "            }",
  "            match (lower)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise (\"lower bound {lower}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\") }",
  "            def stop = lower.truncated",
  "            if (stop != lower) then {",
  "                RequestError.raise (\"lower bound {lower}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\")",
  "            }",
  "            def size is public =",
  "                if ((upper-lower+1) < 0) then { 0 } else {upper-lower+1}",
  "            method iterator {",
  "                object {",
  "                    var val := start",
  "                    method hasNext { val >= stop }",
  "                    method next {",
  "                        if (val < stop) then { IteratorExhausted.raise \"over {outer.asString}\" }",
  "                        val := val - 1",
  "                        return (val + 1)",
  "                    }",
  "                    method asString { \"an iterator over {outer.asString} at {val}\" }",
  "                }",
  "            }",
  "            method at(ix:Number) {",
  "                if (!(ix <= self.size)) then {",
  "                    BoundsError.raise \"requested range.at({ix}) but upper bound is {size}\"",
  "                }",
  "                if (!(ix >= 1)) then {",
  "                    BoundsError.raise \"requested range.at({ix}) but lower bound is 1\"",
  "                }",
  "                return start - (ix - 1)",
  "            }",
  "            method contains(elem) -> Boolean {",
  "                try {",
  "                    def intElem = elem.truncated",
  "                    if (intElem != elem) then {return false}",
  "                    if (intElem > start) then {return false}",
  "                    if (intElem < stop) then {return false}",
  "                } catch { ex:prelude.Exception -> return false }",
  "                return true",
  "            }",
  "            method do(block1) {",
  "                var val := start",
  "                while {val >= stop} do {",
  "                    block1.apply(val)",
  "                    val := val - 1",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var key := 1",
  "                var val := start",
  "                while {val >= stop} do {",
  "                    block2.apply(key, val)",
  "                    key := key + 1",
  "                    val := val - 1",
  "                }",
  "            }",
  "            method reversed {",
  "                from(lower)to(upper)",
  "            }",
  "            method ++(other) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toCollection (other)",
  "            }",
  "            method sorted { self.reversed }",
  "",
  "            method sortedBy(c) { list.withAll(self).sortBy(c) }",
  "",
  "            method keys { 1..self.size }",
  "",
  "            method values { self }",
  "",
  "            method asString -> String {",
  "                \"range.from {upper} downTo {lower}\"",
  "            }",
  "        }",
  "    }",
  "}",
  NULL
};
Object reader_collectionsPrelude_outer_7(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_10(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_11(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_outer_49(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_52(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_cache_53(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_cache_53(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_cacheLoaded_54(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_cacheLoaded_54(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_sourceIterator_55(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_153(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_190(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_227(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_307(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_462(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_600(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_688(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_size_689(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_inner_690(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_905(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_idx_906(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_idx_906(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1063(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_1071(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_1072(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_1072(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_sizeCertain_1073(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_sizeCertain_1073(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_initialSize_1074(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_inner_1075(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_collectionsPrelude_inner_1075(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_collectionsPrelude_size_1076(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_collectionsPrelude_size_1076(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1837(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_iMods_1838(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_idx_1839(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_idx_1839(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2116(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_2152(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_2153(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_2153(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_2154(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_inner_2154(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_size_2155(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_size_2155(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2662(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_iMods_2663(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_count_2664(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_count_2664(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_2665(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_idx_2665(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2973(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_2988(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_2989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_2989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_numBindings_2990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_numBindings_2990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_2991(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_inner_2991(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_3835(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3838(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_3839(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_size_3864(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3881(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3884(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_3885(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_size_3910(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3927(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_size_3931(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3953(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_iMods_3954(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_count_3955(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_count_3955(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_3956(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_idx_3956(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_elt_3957(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_collectionsPrelude_elt_3957(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_4396(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_4544(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_start_4545(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_stop_4546(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_size_4547(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_hash_4548(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_collectionsPrelude_outer_4551(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_val_4552(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_val_4552(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_4871(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_start_4872(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_stop_4873(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_size_4874(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_4877(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_val_4878(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_val_4878(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_5445(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5497(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5516(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_unused_5517(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_unused_5517(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_key_5518(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_value_5519(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_5528(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_removed_5529(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_removed_5529(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_key_5530(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_value_5531(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_5543(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5548(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static Object strlit3;
static ClassData objclass6;
static ClassData objclass9;
static Object strlit13;
static Object strlit37;
static Object strlit41;
static ClassData objclass48;
static ClassData objclass51;
static Object strlit58;
static Object strlit62;
static Object strlit141;
static Object strlit145;
static ClassData objclass152;
static Object strlit171;
static Object strlit176;
static Object strlit180;
static Object strlit186;
static ClassData objclass189;
static Object strlit200;
static Object strlit205;
static Object strlit209;
static ClassData objclass226;
static Object strlit229;
static Object strlit235;
static Object strlit260;
static Object strlit264;
static ClassData objclass306;
static Object strlit314;
static Object strlit320;
static Object strlit433;
static Object strlit447;
static Object strlit454;
static ClassData objclass461;
static Object strlit539;
static Object strlit543;
static ClassData objclass599;
static Object strlit602;
static ClassData objclass687;
static Object strlit711;
static Object strlit718;
static Object strlit722;
static Object strlit817;
static Object strlit852;
static Object strlit859;
static ClassData objclass904;
static Object strlit909;
static Object strlit916;
static Object strlit922;
static Object strlit928;
static Object strlit944;
static Object strlit951;
static Object strlit957;
static ClassData objclass1062;
static Object strlit1065;
static ClassData objclass1070;
static Object strlit1097;
static Object strlit1104;
static Object strlit1108;
static Object strlit1575;
static Object strlit1579;
static Object strlit1602;
static Object strlit1691;
static Object strlit1726;
static Object strlit1733;
static Object strlit1737;
static Object strlit1772;
static Object strlit1779;
static ClassData objclass1836;
static Object strlit1842;
static Object strlit1849;
static Object strlit1855;
static Object strlit1861;
static Object strlit1898;
static ClassData objclass2115;
static Object strlit2118;
static ClassData objclass2151;
static Object strlit2265;
static Object strlit2269;
static Object strlit2372;
static Object strlit2376;
static Object strlit2546;
static Object strlit2560;
static Object strlit2567;
static Object strlit2571;
static Object strlit2585;
static Object strlit2592;
static ClassData objclass2661;
static Object strlit2718;
static Object strlit2726;
static ClassData objclass2972;
static Object strlit2975;
static ClassData objclass2987;
static Object strlit3130;
static Object strlit3134;
static Object strlit3208;
static Object strlit3212;
static Object strlit3253;
static Object strlit3257;
static Object strlit3401;
static Object strlit3405;
static Object strlit3665;
static Object strlit3700;
static Object strlit3708;
static Object strlit3715;
static Object strlit3721;
static Object strlit3732;
static Object strlit3736;
static Object strlit3758;
static Object strlit3778;
static Object strlit3785;
static Object strlit3792;
static Object strlit3796;
static Object strlit3808;
static Object strlit3815;
static Object strlit3819;
static Object strlit3830;
static ClassData objclass3834;
static ClassData objclass3837;
static Object strlit3854;
static Object strlit3858;
static Object strlit3867;
static Object strlit3871;
static ClassData objclass3880;
static ClassData objclass3883;
static Object strlit3900;
static Object strlit3904;
static Object strlit3913;
static Object strlit3917;
static ClassData objclass3926;
static Object strlit3934;
static Object strlit3938;
static ClassData objclass3952;
static Object strlit3997;
static Object strlit4005;
static Object strlit4311;
static ClassData objclass4395;
static Object strlit4404;
static Object strlit4416;
static Object strlit4421;
static Object strlit4425;
static Object strlit4432;
static Object strlit4436;
static Object strlit4451;
static Object strlit4456;
static Object strlit4460;
static Object strlit4467;
static Object strlit4471;
static Object strlit4482;
static Object strlit4494;
static Object strlit4499;
static Object strlit4503;
static Object strlit4510;
static Object strlit4514;
static Object strlit4528;
static Object strlit4531;
static Object strlit4535;
static ClassData objclass4543;
static ClassData objclass4550;
static Object strlit4576;
static Object strlit4584;
static Object strlit4604;
static Object strlit4611;
static Object strlit4619;
static Object strlit4640;
static Object strlit4647;
static Object strlit4651;
static Object strlit4666;
static Object strlit4670;
static Object strlit4715;
static Object strlit4810;
static Object strlit4815;
static Object strlit4819;
static ClassData objclass4870;
static ClassData objclass4876;
static Object strlit4902;
static Object strlit4910;
static Object strlit4930;
static Object strlit4937;
static Object strlit4945;
static Object strlit4966;
static Object strlit4973;
static Object strlit4977;
static Object strlit4992;
static Object strlit4996;
static Object strlit5041;
static Object strlit5138;
static Object strlit5143;
static Object strlit5147;
static Object strlit5160;
static Object strlit5172;
static Object strlit5177;
static Object strlit5181;
static Object strlit5188;
static Object strlit5192;
static Object strlit5209;
static Object strlit5214;
static Object strlit5218;
static Object strlit5225;
static Object strlit5229;
static Object strlit5240;
static Object strlit5252;
static Object strlit5257;
static Object strlit5261;
static Object strlit5268;
static Object strlit5272;
static Object strlit5289;
static Object strlit5294;
static Object strlit5298;
static Object strlit5305;
static Object strlit5309;
static Object strlit5337;
static Object strlit5343;
static Object strlit5349;
static Object strlit5355;
static Object strlit5361;
static Object strlit5367;
static Object strlit5373;
static ClassData objclass5444;
static Object strlit5453;
static Object strlit5457;
static Object strlit5471;
static Object strlit5484;
static ClassData objclass5496;
static Object strlit5499;
static Object strlit5504;
static ClassData objclass5515;
static Object strlit5521;
static ClassData objclass5527;
static Object strlit5533;
static ClassData objclass5542;
static Object strlit5545;
static ClassData objclass5547;
static Object strlit5553;
static Object strlit5558;
static Object strlit5562;
static Object strlit5611;
Object meth_collectionsPrelude_1_required(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "required");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SubobjectResponsibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit3 == NULL) {
    strlit3 = alloc_String("required method not overriden by subobject");
    gc_root(strlit3);
  }
// compiled string node returning strlit3 (depth = 3)
  gc_frame_newslot(strlit3);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SubobjectResponsibility (depth = 3)
  params[0] = strlit3;
  partcv[0] = 1;
  Object call4 = callmethodflags(*var_SubobjectResponsibility, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2);
// compiled call node returning call4 (depth = 2)
  gc_frame_end(frame);
  return call4;
}
Object meth_collectionsPrelude_12_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit13 == NULL) {
    strlit13 = alloc_String("an iterator over a lazy map sequence");
    gc_root(strlit13);
  }
// compiled string node returning strlit13 (depth = 2)
  gc_frame_end(frame);
  return strlit13;
}
Object meth_collectionsPrelude_14_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe15 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe16 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call17 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe16);
// compiled member node returning call17 (depth = 3)
  partcv[0] = 0;
  Object call18 = callmethodflags(call17, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe15);
// compiled member node returning call18 (depth = 2)
  gc_frame_end(frame);
  return call18;
}
Object meth_collectionsPrelude_19_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe20 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe21 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe22 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call23 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe22);
// compiled member node returning call23 (depth = 4)
  partcv[0] = 0;
  Object call24 = callmethodflags(call23, "next", 1, partcv, params, 0);
  gc_frame_end(callframe21);
// compiled member node returning call24 (depth = 3)
  gc_frame_newslot(call24);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_function (depth = 3)
  params[0] = call24;
  partcv[0] = 1;
  Object call25 = callmethodflags(*var_function, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe20);
// compiled call node returning call25 (depth = 2)
  gc_frame_end(frame);
  return call25;
}
Object meth_collectionsPrelude_8_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  Object *var_source = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9 = alloc_userobj2(4,5, objclass9);
  gc_frame_newslot(obj9);
  if (objclass9 == NULL) {
    glfree(obj9->class->name);
    obj9->class->name = "lazySequenceOver(_)mappedBy(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9, self, 0);
  addmethodreal(obj9,"outer", &reader_collectionsPrelude_outer_10);
  Object oldself9 = self;
  struct StackFrameObject *oldstackframe9 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9);
  gc_frame_newslot((Object)stackframe);
  self = obj9;
  Object *oldselfslot9 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9 = (*(struct UserObject *)self).data[0], lowerouter9 = thisouter9;
  if (inheritingObject9) {
    struct UserObject *inho9 = (struct UserObject *)inheritingObject9;
    while (inho9->super != GraceDefaultObject) inho9 = (struct UserObject *)inho9->super;
    inho9->super = obj9;
    self = inheritingObject9;
    *selfslot = self;
    lowerouter9 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9;
  }
  if (objclass9 == NULL) {
  Method *reader11 = addmethodrealflags(obj9, "sourceIterator",&reader_collectionsPrelude_sourceIterator_11, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader11->definitionModule = modulename;
  reader11->definitionLine = 183;
  }
  adddatum2(obj9, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo12 = (struct UserObject*)obj9;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_12_asString = addmethod2pos(obj9, "asString", &meth_collectionsPrelude_12_asString, 2);
  int argcv_meth_collectionsPrelude_12_asString[] = {0};
  meth_meth_collectionsPrelude_12_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_12_asString);
  meth_meth_collectionsPrelude_12_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_12_asString->definitionLine = 184;
// method "hasNext"
  struct UserObject *uo14 = (struct UserObject*)obj9;
  uo14->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_14_hasNext = addmethod2pos(obj9, "hasNext", &meth_collectionsPrelude_14_hasNext, 3);
  int argcv_meth_collectionsPrelude_14_hasNext[] = {0};
  meth_meth_collectionsPrelude_14_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_14_hasNext);
  meth_meth_collectionsPrelude_14_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_14_hasNext->definitionLine = 185;
// method "next"
  block_savedest(obj9);
  Object closure19 = createclosure(1, "next");
  setclosureframe(closure19, stackframe);
  addtoclosure(closure19, var_function);
  struct UserObject *uo19 = (struct UserObject*)obj9;
  uo19->data[4] = (Object)closure19;
  Method *meth_meth_collectionsPrelude_19_next = addmethod2pos(obj9, "next", &meth_collectionsPrelude_19_next, 4);
  int argcv_meth_collectionsPrelude_19_next[] = {0};
  meth_meth_collectionsPrelude_19_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_19_next);
  meth_meth_collectionsPrelude_19_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_19_next->definitionLine = 186;
  sourceObject = obj9;
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe26 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  partcv[0] = 0;
  Object call27 = callmethodflags(*var_source, "iterator", 1, partcv, params, 0);
  gc_frame_end(callframe26);
// compiled member node returning call27 (depth = 2)
  adddatum2(obj9, call27, 1);
  sourceObject = obj9;
  sourceObject = obj9;
  sourceObject = obj9;
  objclass9 = obj9->class;
  objclass9->definitionModule = modulename;
  objclass9->definitionLine = 182;
  (*(struct UserObject *)self).data[0] = lowerouter9;
  self = oldself9;
  selfslot = oldselfslot9;
  stackframe = oldstackframe9;
  gc_frame_end(frame);
  return obj9;
}
Object meth_collectionsPrelude_8_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  Object *var_source = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9 = alloc_userobj2(4,5, objclass9);
  gc_frame_newslot(obj9);
  if (objclass9 == NULL) {
    glfree(obj9->class->name);
    obj9->class->name = "lazySequenceOver(_)mappedBy(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj9, self, 0);
  addmethodreal(obj9,"outer", &reader_collectionsPrelude_outer_10);
  Object oldself9 = self;
  struct StackFrameObject *oldstackframe9 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9);
  gc_frame_newslot((Object)stackframe);
  self = obj9;
  Object *oldselfslot9 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9 = (*(struct UserObject *)self).data[0], lowerouter9 = thisouter9;
  if (inheritingObject9) {
    struct UserObject *inho9 = (struct UserObject *)inheritingObject9;
    while (inho9->super != GraceDefaultObject) inho9 = (struct UserObject *)inho9->super;
    inho9->super = obj9;
    self = inheritingObject9;
    *selfslot = self;
    lowerouter9 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9;
  }
  if (objclass9 == NULL) {
  Method *reader11 = addmethodrealflags(obj9, "sourceIterator",&reader_collectionsPrelude_sourceIterator_11, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader11->definitionModule = modulename;
  reader11->definitionLine = 183;
  }
  adddatum2(obj9, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo12 = (struct UserObject*)obj9;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_12_asString = addmethod2pos(obj9, "asString", &meth_collectionsPrelude_12_asString, 2);
  int argcv_meth_collectionsPrelude_12_asString[] = {0};
  meth_meth_collectionsPrelude_12_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_12_asString);
  meth_meth_collectionsPrelude_12_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_12_asString->definitionLine = 184;
// method "hasNext"
  struct UserObject *uo14 = (struct UserObject*)obj9;
  uo14->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_14_hasNext = addmethod2pos(obj9, "hasNext", &meth_collectionsPrelude_14_hasNext, 3);
  int argcv_meth_collectionsPrelude_14_hasNext[] = {0};
  meth_meth_collectionsPrelude_14_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_14_hasNext);
  meth_meth_collectionsPrelude_14_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_14_hasNext->definitionLine = 185;
// method "next"
  block_savedest(obj9);
  Object closure19 = createclosure(1, "next");
  setclosureframe(closure19, stackframe);
  addtoclosure(closure19, var_function);
  struct UserObject *uo19 = (struct UserObject*)obj9;
  uo19->data[4] = (Object)closure19;
  Method *meth_meth_collectionsPrelude_19_next = addmethod2pos(obj9, "next", &meth_collectionsPrelude_19_next, 4);
  int argcv_meth_collectionsPrelude_19_next[] = {0};
  meth_meth_collectionsPrelude_19_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_19_next);
  meth_meth_collectionsPrelude_19_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_19_next->definitionLine = 186;
  sourceObject = obj9;
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe26 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  partcv[0] = 0;
  Object call27 = callmethodflags(*var_source, "iterator", 1, partcv, params, 0);
  gc_frame_end(callframe26);
// compiled member node returning call27 (depth = 2)
  adddatum2(obj9, call27, 1);
  sourceObject = obj9;
  sourceObject = obj9;
  sourceObject = obj9;
  objclass9 = obj9->class;
  objclass9->definitionModule = modulename;
  objclass9->definitionLine = 182;
  (*(struct UserObject *)self).data[0] = lowerouter9;
  self = oldself9;
  selfslot = oldselfslot9;
  stackframe = oldstackframe9;
  gc_frame_end(frame);
  return obj9;
}
Object meth_collectionsPrelude_29_size(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe30 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  partcv[0] = 0;
  Object call31 = callmethodflags(*var_source, "size", 1, partcv, params, 0);
  gc_frame_end(callframe30);
// compiled member node returning call31 (depth = 2)
  gc_frame_end(frame);
  return call31;
}
Object meth_collectionsPrelude_32_isEmpty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe33 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  partcv[0] = 0;
  Object call34 = callmethodflags(*var_source, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe33);
// compiled member node returning call34 (depth = 2)
  gc_frame_end(frame);
  return call34;
}
Object meth_collectionsPrelude_35_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit37 == NULL) {
    strlit37 = alloc_String("");
    gc_root(strlit37);
  }
// compiled string node returning strlit37 (depth = 3)
  int op_slot_right_36 = gc_frame_newslot(strlit37);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_39 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit41 == NULL) {
    strlit41 = alloc_String("a lazy sequence mapping over ");
    gc_root(strlit41);
  }
// compiled string node returning strlit41 (depth = 4)
  int op_slot_left_39 = gc_frame_newslot(strlit41);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult42 = callmethod(strlit41, "++(1)", 1, partcv, params);
// compiled op node returning opresult42 (depth = 3)
  int op_slot_left_36 = gc_frame_newslot(opresult42);
  params[0] = strlit37;
  partcv[0] = 1;
  Object opresult43 = callmethod(opresult42, "++(1)", 1, partcv, params);
// compiled op node returning opresult43 (depth = 2)
  gc_frame_end(frame);
  return opresult43;
}
Object meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lazySequenceOver(1)mappedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)mappedBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)mappedBy(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)mappedBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_function = &(stackframe->slots[1]);
  *var_function = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part mappedBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  Object *var_R = &(stackframe->slots[4]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
    *var_R = args[curarg++];
  } else {
    *var_T = Unknown;
    *var_R = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6 = alloc_userobj2(5,6, objclass6);
  gc_frame_newslot(obj6);
  if (objclass6 == NULL) {
    glfree(obj6->class->name);
    obj6->class->name = "lazySequenceOver(_)mappedBy(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6, self, 0);
  addmethodreal(obj6,"outer", &reader_collectionsPrelude_outer_7);
  Object oldself6 = self;
  struct StackFrameObject *oldstackframe6 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6);
  gc_frame_newslot((Object)stackframe);
  self = obj6;
  Object *oldselfslot6 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6 = (*(struct UserObject *)self).data[0], lowerouter6 = thisouter6;
  if (inheritingObject6) {
    struct UserObject *inho6 = (struct UserObject *)inheritingObject6;
    while (inho6->super != GraceDefaultObject) inho6 = (struct UserObject *)inho6->super;
    inho6->super = obj6;
    self = inheritingObject6;
    *selfslot = self;
    lowerouter6 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6;
  }
// method "iterator"
  block_savedest(obj6);
  Object closure8 = createclosure(2, "iterator");
  setclosureframe(closure8, stackframe);
  addtoclosure(closure8, var_function);
  addtoclosure(closure8, var_source);
  struct UserObject *uo8 = (struct UserObject*)obj6;
  uo8->data[1] = (Object)closure8;
  Method *meth_meth_collectionsPrelude_8_iterator = addmethod2pos(obj6, "iterator", &meth_collectionsPrelude_8_iterator, 1);
  int argcv_meth_collectionsPrelude_8_iterator[] = {0};
  meth_meth_collectionsPrelude_8_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_8_iterator);
  meth_meth_collectionsPrelude_8_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_8_iterator->definitionLine = 182;
  block_savedest(obj6);
  Object closure28 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_function);
  addtoclosure(closure28, var_source);
  Method *meth_meth_collectionsPrelude_8_iterator_object = addmethod2pos(obj6, "iterator$object(1)", &meth_collectionsPrelude_8_iterator_object, 1);
  meth_meth_collectionsPrelude_8_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_8_iterator_object->definitionLine = 182;
// method "size"
  block_savedest(obj6);
  Object closure29 = createclosure(1, "size");
  setclosureframe(closure29, stackframe);
  addtoclosure(closure29, var_source);
  struct UserObject *uo29 = (struct UserObject*)obj6;
  uo29->data[2] = (Object)closure29;
  Method *meth_meth_collectionsPrelude_29_size = addmethod2pos(obj6, "size", &meth_collectionsPrelude_29_size, 2);
  int argcv_meth_collectionsPrelude_29_size[] = {0};
  meth_meth_collectionsPrelude_29_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_29_size);
  meth_meth_collectionsPrelude_29_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_29_size->definitionLine = 188;
// method "isEmpty"
  block_savedest(obj6);
  Object closure32 = createclosure(1, "isEmpty");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_source);
  struct UserObject *uo32 = (struct UserObject*)obj6;
  uo32->data[3] = (Object)closure32;
  Method *meth_meth_collectionsPrelude_32_isEmpty = addmethod2pos(obj6, "isEmpty", &meth_collectionsPrelude_32_isEmpty, 3);
  int argcv_meth_collectionsPrelude_32_isEmpty[] = {0};
  meth_meth_collectionsPrelude_32_isEmpty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_32_isEmpty);
  meth_meth_collectionsPrelude_32_isEmpty->definitionModule = modulename;
  meth_meth_collectionsPrelude_32_isEmpty->definitionLine = 189;
// method "asDebugString"
  block_savedest(obj6);
  Object closure35 = createclosure(1, "asDebugString");
  setclosureframe(closure35, stackframe);
  addtoclosure(closure35, var_source);
  struct UserObject *uo35 = (struct UserObject*)obj6;
  uo35->data[4] = (Object)closure35;
  Method *meth_meth_collectionsPrelude_35_asDebugString = addmethod2pos(obj6, "asDebugString", &meth_collectionsPrelude_35_asDebugString, 4);
  int argcv_meth_collectionsPrelude_35_asDebugString[] = {0};
  meth_meth_collectionsPrelude_35_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_35_asDebugString);
  meth_meth_collectionsPrelude_35_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_35_asDebugString->definitionLine = 190;
  sourceObject = obj6;
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe44 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call45 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe44);
// compiled call node returning call45 (depth = 2)
  struct UserObject *obj6_uo = (struct UserObject *)obj6;
  obj6_uo->super = call45;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  objclass6 = obj6->class;
  objclass6->definitionModule = modulename;
  objclass6->definitionLine = 179;
  (*(struct UserObject *)self).data[0] = lowerouter6;
  self = oldself6;
  selfslot = oldselfslot6;
  stackframe = oldstackframe6;
  gc_frame_end(frame);
  return obj6;
}
Object meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lazySequenceOver(1)mappedBy(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)mappedBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)mappedBy(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)mappedBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_function = &(stackframe->slots[1]);
  *var_function = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part mappedBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  Object *var_R = &(stackframe->slots[4]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
    *var_R = args[curarg++];
  } else {
    *var_T = Unknown;
    *var_R = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6 = alloc_userobj2(5,6, objclass6);
  gc_frame_newslot(obj6);
  if (objclass6 == NULL) {
    glfree(obj6->class->name);
    obj6->class->name = "lazySequenceOver(_)mappedBy(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj6, self, 0);
  addmethodreal(obj6,"outer", &reader_collectionsPrelude_outer_7);
  Object oldself6 = self;
  struct StackFrameObject *oldstackframe6 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6);
  gc_frame_newslot((Object)stackframe);
  self = obj6;
  Object *oldselfslot6 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6 = (*(struct UserObject *)self).data[0], lowerouter6 = thisouter6;
  if (inheritingObject6) {
    struct UserObject *inho6 = (struct UserObject *)inheritingObject6;
    while (inho6->super != GraceDefaultObject) inho6 = (struct UserObject *)inho6->super;
    inho6->super = obj6;
    self = inheritingObject6;
    *selfslot = self;
    lowerouter6 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6;
  }
// method "iterator"
  block_savedest(obj6);
  Object closure8 = createclosure(2, "iterator");
  setclosureframe(closure8, stackframe);
  addtoclosure(closure8, var_function);
  addtoclosure(closure8, var_source);
  struct UserObject *uo8 = (struct UserObject*)obj6;
  uo8->data[1] = (Object)closure8;
  Method *meth_meth_collectionsPrelude_8_iterator = addmethod2pos(obj6, "iterator", &meth_collectionsPrelude_8_iterator, 1);
  int argcv_meth_collectionsPrelude_8_iterator[] = {0};
  meth_meth_collectionsPrelude_8_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_8_iterator);
  meth_meth_collectionsPrelude_8_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_8_iterator->definitionLine = 182;
  block_savedest(obj6);
  Object closure28 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_function);
  addtoclosure(closure28, var_source);
  Method *meth_meth_collectionsPrelude_8_iterator_object = addmethod2pos(obj6, "iterator$object(1)", &meth_collectionsPrelude_8_iterator_object, 1);
  meth_meth_collectionsPrelude_8_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_8_iterator_object->definitionLine = 182;
// method "size"
  block_savedest(obj6);
  Object closure29 = createclosure(1, "size");
  setclosureframe(closure29, stackframe);
  addtoclosure(closure29, var_source);
  struct UserObject *uo29 = (struct UserObject*)obj6;
  uo29->data[2] = (Object)closure29;
  Method *meth_meth_collectionsPrelude_29_size = addmethod2pos(obj6, "size", &meth_collectionsPrelude_29_size, 2);
  int argcv_meth_collectionsPrelude_29_size[] = {0};
  meth_meth_collectionsPrelude_29_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_29_size);
  meth_meth_collectionsPrelude_29_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_29_size->definitionLine = 188;
// method "isEmpty"
  block_savedest(obj6);
  Object closure32 = createclosure(1, "isEmpty");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_source);
  struct UserObject *uo32 = (struct UserObject*)obj6;
  uo32->data[3] = (Object)closure32;
  Method *meth_meth_collectionsPrelude_32_isEmpty = addmethod2pos(obj6, "isEmpty", &meth_collectionsPrelude_32_isEmpty, 3);
  int argcv_meth_collectionsPrelude_32_isEmpty[] = {0};
  meth_meth_collectionsPrelude_32_isEmpty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_32_isEmpty);
  meth_meth_collectionsPrelude_32_isEmpty->definitionModule = modulename;
  meth_meth_collectionsPrelude_32_isEmpty->definitionLine = 189;
// method "asDebugString"
  block_savedest(obj6);
  Object closure35 = createclosure(1, "asDebugString");
  setclosureframe(closure35, stackframe);
  addtoclosure(closure35, var_source);
  struct UserObject *uo35 = (struct UserObject*)obj6;
  uo35->data[4] = (Object)closure35;
  Method *meth_meth_collectionsPrelude_35_asDebugString = addmethod2pos(obj6, "asDebugString", &meth_collectionsPrelude_35_asDebugString, 4);
  int argcv_meth_collectionsPrelude_35_asDebugString[] = {0};
  meth_meth_collectionsPrelude_35_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_35_asDebugString);
  meth_meth_collectionsPrelude_35_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_35_asDebugString->definitionLine = 190;
  sourceObject = obj6;
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe44 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call45 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe44);
// compiled call node returning call45 (depth = 2)
  struct UserObject *obj6_uo = (struct UserObject *)obj6;
  obj6_uo->super = call45;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  objclass6 = obj6->class;
  objclass6->definitionModule = modulename;
  objclass6->definitionLine = 179;
  (*(struct UserObject *)self).data[0] = lowerouter6;
  self = oldself6;
  selfslot = oldselfslot6;
  stackframe = oldstackframe6;
  gc_frame_end(frame);
  return obj6;
}
Object meth_collectionsPrelude_56_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit58 == NULL) {
    strlit58 = alloc_String("");
    gc_root(strlit58);
  }
// compiled string node returning strlit58 (depth = 3)
  int op_slot_right_57 = gc_frame_newslot(strlit58);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_60 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit62 == NULL) {
    strlit62 = alloc_String("an iterator over filtered ");
    gc_root(strlit62);
  }
// compiled string node returning strlit62 (depth = 4)
  int op_slot_left_60 = gc_frame_newslot(strlit62);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult63 = callmethod(strlit62, "++(1)", 1, partcv, params);
// compiled op node returning opresult63 (depth = 3)
  int op_slot_left_57 = gc_frame_newslot(opresult63);
  params[0] = strlit58;
  partcv[0] = 1;
  Object opresult64 = callmethod(opresult63, "++(1)", 1, partcv, params);
// compiled op node returning opresult64 (depth = 2)
  gc_frame_end(frame);
  return opresult64;
}
Object meth_collectionsPrelude_65_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe67 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call68 = callmethodflags(self, "cacheLoaded", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe67);
// compiled member node returning call68 (depth = 3)
  Object if66 = done;
  if (istrue(call68)) {
// starting to compile identifier node (depth = 3)
  Object bool69 = alloc_Boolean(1);
// compiled identifier node returning bool69 (depth = 3)
    gc_frame_newslot(bool69);
    if66 = bool69;
  } else {
// starting to compile member node (depth = 3)
  int callframe70 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call71 = callmethodflags(self, "hasNextAcceptableElement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe70);
// compiled member node returning call71 (depth = 3)
    gc_frame_newslot(call71);
    if66 = call71;
  }
// compiled if node returning if66 (depth = 2)
  gc_frame_end(frame);
  return if66;
}
Object meth_collectionsPrelude_72_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe74 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe75 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call76 = callmethodflags(self, "cacheLoaded", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe75);
// compiled member node returning call76 (depth = 4)
  partcv[0] = 0;
  Object call77 = callmethodflags(call76, "not", 1, partcv, params, 0);
  gc_frame_end(callframe74);
// compiled member node returning call77 (depth = 3)
  Object if73 = done;
  if (istrue(call77)) {
// starting to compile call node (depth = 3)
  int callframe78 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe79 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call80 = callmethodflags(self, "nextAcceptableElement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe79);
// compiled member node returning call80 (depth = 4)
  gc_frame_newslot(call80);
// call case 4: self request
  params[0] = call80;
  partcv[0] = 1;
  Object call81 = callmethodflags(self, "cache:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe78);
// compiled call node returning call81 (depth = 3)
    gc_frame_newslot(call81);
    if73 = call81;
  } else {
  }
// compiled if node returning if73 (depth = 2)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe82 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool83 = alloc_Boolean(0);
// compiled identifier node returning bool83 (depth = 3)
  gc_frame_newslot(bool83);
// call case 4: self request
  params[0] = bool83;
  partcv[0] = 1;
  Object call84 = callmethodflags(self, "cacheLoaded:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe82);
// compiled call node returning call84 (depth = 2)
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe85 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call86 = callmethodflags(self, "cache", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe85);
// compiled member node returning call86 (depth = 3)
  return call86;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_90__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile identifier node (depth = 4)
  Object bool91 = alloc_Boolean(1);
// compiled identifier node returning bool91 (depth = 4)
  gc_frame_end(frame);
  return bool91;
}
Object meth_collectionsPrelude_94__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_predicate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_outerNext = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "outerNext");
  Object *var_isAcceptable = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isAcceptable");
// definebindings:
// definebindings:
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe95 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe96 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call97 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe96);
// compiled member node returning call97 (depth = 6)
  partcv[0] = 0;
  Object call98 = callmethodflags(call97, "next", 1, partcv, params, 0);
  gc_frame_end(callframe95);
// compiled member node returning call98 (depth = 5)
  *var_outerNext = call98;
  if (call98 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe99 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_predicate (depth = 6)
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call100 = callmethodflags(*var_predicate, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe99);
// compiled call node returning call100 (depth = 5)
  *var_isAcceptable = call100;
  if (call100 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isAcceptable (depth = 5)
  Object if101 = done;
  if (istrue(*var_isAcceptable)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  block_return(realself, *var_outerNext);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if101 = undefined;
  } else {
  }
// compiled if node returning if101 (depth = 4)
  gc_frame_end(frame);
  return if101;
}
Object meth_collectionsPrelude_87_nextAcceptableElement(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nextAcceptableElement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_predicate = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe88 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block89 = alloc_Block(NULL, NULL, "collectionsPrelude", 214);
  gc_frame_newslot(block89);
// method "_apply"
  block_savedest(block89);
  Object closure90 = createclosure(1, "_apply");
  setclosureframe(closure90, stackframe);
  addtoclosure(closure90, selfslot);
  struct UserObject *uo90 = (struct UserObject*)block89;
  uo90->data[0] = (Object)closure90;
  Method *meth_meth_collectionsPrelude_90__apply = addmethod2pos(block89, "_apply", &meth_collectionsPrelude_90__apply, 0);
  int argcv_meth_collectionsPrelude_90__apply[] = {0};
  meth_meth_collectionsPrelude_90__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_90__apply);
  meth_meth_collectionsPrelude_90__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_90__apply->definitionLine = 1769;
// compiled block node returning block89 (depth = 3)
  gc_frame_newslot(block89);
// starting to compile block node (depth = 3)
  Object block93 = alloc_Block(NULL, NULL, "collectionsPrelude", 214);
  gc_frame_newslot(block93);
// method "_apply"
  block_savedest(block93);
  Object closure94 = createclosure(2, "_apply");
  setclosureframe(closure94, stackframe);
  addtoclosure(closure94, var_predicate);
  addtoclosure(closure94, selfslot);
  struct UserObject *uo94 = (struct UserObject*)block93;
  uo94->data[0] = (Object)closure94;
  Method *meth_meth_collectionsPrelude_94__apply = addmethod2pos(block93, "_apply", &meth_collectionsPrelude_94__apply, 0);
  int argcv_meth_collectionsPrelude_94__apply[] = {0};
  meth_meth_collectionsPrelude_94__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_94__apply);
  meth_meth_collectionsPrelude_94__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_94__apply->definitionLine = 1769;
// compiled block node returning block93 (depth = 3)
  gc_frame_newslot(block93);
// call case 5: prelude request
  params[0] = block89;
  params[1] = block93;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call103 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe88);
// compiled call node returning call103 (depth = 2)
  gc_frame_end(frame);
  return call103;
}
Object meth_collectionsPrelude_107__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile identifier node (depth = 4)
  Object bool108 = alloc_Boolean(1);
// compiled identifier node returning bool108 (depth = 4)
  gc_frame_end(frame);
  return bool108;
}
Object meth_collectionsPrelude_111__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_predicate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_outerNext = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "outerNext");
  Object *var_isAcceptable = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isAcceptable");
// definebindings:
// definebindings:
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe113 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe114 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe115 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call116 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe115);
// compiled member node returning call116 (depth = 7)
  partcv[0] = 0;
  Object call117 = callmethodflags(call116, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe114);
// compiled member node returning call117 (depth = 6)
  partcv[0] = 0;
  Object call118 = callmethodflags(call117, "not", 1, partcv, params, 0);
  gc_frame_end(callframe113);
// compiled member node returning call118 (depth = 5)
  Object if112 = done;
  if (istrue(call118)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool119 = alloc_Boolean(0);
// compiled identifier node returning bool119 (depth = 6)
  block_return(realself, bool119);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if112 = undefined;
  } else {
  }
// compiled if node returning if112 (depth = 4)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe120 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe121 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call122 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe121);
// compiled member node returning call122 (depth = 6)
  partcv[0] = 0;
  Object call123 = callmethodflags(call122, "next", 1, partcv, params, 0);
  gc_frame_end(callframe120);
// compiled member node returning call123 (depth = 5)
  *var_outerNext = call123;
  if (call123 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe124 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_predicate (depth = 6)
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call125 = callmethodflags(*var_predicate, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe124);
// compiled call node returning call125 (depth = 5)
  *var_isAcceptable = call125;
  if (call125 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isAcceptable (depth = 5)
  Object if126 = done;
  if (istrue(*var_isAcceptable)) {
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe127 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool128 = alloc_Boolean(1);
// compiled identifier node returning bool128 (depth = 6)
  gc_frame_newslot(bool128);
// call case 4: self request
  params[0] = bool128;
  partcv[0] = 1;
  Object call129 = callmethodflags(self, "cacheLoaded:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe127);
// compiled call node returning call129 (depth = 5)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe130 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 4: self request
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call131 = callmethodflags(self, "cache:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe130);
// compiled call node returning call131 (depth = 5)
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool132 = alloc_Boolean(1);
// compiled identifier node returning bool132 (depth = 6)
  block_return(realself, bool132);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if126 = undefined;
  } else {
  }
// compiled if node returning if126 (depth = 4)
  gc_frame_end(frame);
  return if126;
}
Object meth_collectionsPrelude_104_hasNextAcceptableElement(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNextAcceptableElement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_predicate = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe105 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block106 = alloc_Block(NULL, NULL, "collectionsPrelude", 223);
  gc_frame_newslot(block106);
// method "_apply"
  block_savedest(block106);
  Object closure107 = createclosure(1, "_apply");
  setclosureframe(closure107, stackframe);
  addtoclosure(closure107, selfslot);
  struct UserObject *uo107 = (struct UserObject*)block106;
  uo107->data[0] = (Object)closure107;
  Method *meth_meth_collectionsPrelude_107__apply = addmethod2pos(block106, "_apply", &meth_collectionsPrelude_107__apply, 0);
  int argcv_meth_collectionsPrelude_107__apply[] = {0};
  meth_meth_collectionsPrelude_107__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_107__apply);
  meth_meth_collectionsPrelude_107__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_107__apply->definitionLine = 1769;
// compiled block node returning block106 (depth = 3)
  gc_frame_newslot(block106);
// starting to compile block node (depth = 3)
  Object block110 = alloc_Block(NULL, NULL, "collectionsPrelude", 223);
  gc_frame_newslot(block110);
// method "_apply"
  block_savedest(block110);
  Object closure111 = createclosure(2, "_apply");
  setclosureframe(closure111, stackframe);
  addtoclosure(closure111, var_predicate);
  addtoclosure(closure111, selfslot);
  struct UserObject *uo111 = (struct UserObject*)block110;
  uo111->data[0] = (Object)closure111;
  Method *meth_meth_collectionsPrelude_111__apply = addmethod2pos(block110, "_apply", &meth_collectionsPrelude_111__apply, 0);
  int argcv_meth_collectionsPrelude_111__apply[] = {0};
  meth_meth_collectionsPrelude_111__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_111__apply);
  meth_meth_collectionsPrelude_111__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_111__apply->definitionLine = 1769;
// compiled block node returning block110 (depth = 3)
  gc_frame_newslot(block110);
// call case 5: prelude request
  params[0] = block106;
  params[1] = block110;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call134 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe105);
// compiled call node returning call134 (depth = 2)
  gc_frame_end(frame);
  return call134;
}
Object meth_collectionsPrelude_50_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  Object *var_predicate = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject51 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj51 = alloc_userobj2(10,9, objclass51);
  gc_frame_newslot(obj51);
  if (objclass51 == NULL) {
    glfree(obj51->class->name);
    obj51->class->name = "lazySequenceOver(_)filteredBy(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj51, self, 0);
  addmethodreal(obj51,"outer", &reader_collectionsPrelude_outer_52);
  Object oldself51 = self;
  struct StackFrameObject *oldstackframe51 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe51);
  gc_frame_newslot((Object)stackframe);
  self = obj51;
  Object *oldselfslot51 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter51 = (*(struct UserObject *)self).data[0], lowerouter51 = thisouter51;
  if (inheritingObject51) {
    struct UserObject *inho51 = (struct UserObject *)inheritingObject51;
    while (inho51->super != GraceDefaultObject) inho51 = (struct UserObject *)inho51->super;
    inho51->super = obj51;
    self = inheritingObject51;
    *selfslot = self;
    lowerouter51 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter51;
  }
  if (objclass51 == NULL) {
    Method *reader53 = addmethodrealflags(obj51, "cache", &reader_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
    Method *writer53 = addmethodrealflags(obj51, "cache:=(1)", &writer_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
    reader53->definitionModule = modulename;
    writer53->definitionModule = modulename;
    reader53->definitionLine = 197;
    writer53->definitionLine = 197;
  }
  obj51->flags |= OFLAG_MUTABLE;
  adddatum2(obj51, alloc_Undefined(), 1);
  if (objclass51 == NULL) {
    Method *reader54 = addmethodrealflags(obj51, "cacheLoaded", &reader_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
    Method *writer54 = addmethodrealflags(obj51, "cacheLoaded:=(1)", &writer_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
    reader54->definitionModule = modulename;
    writer54->definitionModule = modulename;
    reader54->definitionLine = 198;
    writer54->definitionLine = 198;
  }
  obj51->flags |= OFLAG_MUTABLE;
  adddatum2(obj51, alloc_Undefined(), 2);
  if (objclass51 == NULL) {
  Method *reader55 = addmethodrealflags(obj51, "sourceIterator",&reader_collectionsPrelude_sourceIterator_55, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader55->definitionModule = modulename;
  reader55->definitionLine = 199;
  }
  adddatum2(obj51, alloc_Undefined(), 3);
// method "asString"
  block_savedest(obj51);
  Object closure56 = createclosure(1, "asString");
  setclosureframe(closure56, stackframe);
  addtoclosure(closure56, var_source);
  struct UserObject *uo56 = (struct UserObject*)obj51;
  uo56->data[4] = (Object)closure56;
  Method *meth_meth_collectionsPrelude_56_asString = addmethod2pos(obj51, "asString", &meth_collectionsPrelude_56_asString, 4);
  int argcv_meth_collectionsPrelude_56_asString[] = {0};
  meth_meth_collectionsPrelude_56_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_56_asString);
  meth_meth_collectionsPrelude_56_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_56_asString->definitionLine = 200;
// method "hasNext"
  struct UserObject *uo65 = (struct UserObject*)obj51;
  uo65->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_65_hasNext = addmethod2pos(obj51, "hasNext", &meth_collectionsPrelude_65_hasNext, 5);
  int argcv_meth_collectionsPrelude_65_hasNext[] = {0};
  meth_meth_collectionsPrelude_65_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_65_hasNext);
  meth_meth_collectionsPrelude_65_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_65_hasNext->definitionLine = 201;
// method "next"
  struct UserObject *uo72 = (struct UserObject*)obj51;
  uo72->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_72_next = addmethod2pos(obj51, "next", &meth_collectionsPrelude_72_next, 6);
  int argcv_meth_collectionsPrelude_72_next[] = {0};
  meth_meth_collectionsPrelude_72_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_72_next);
  meth_meth_collectionsPrelude_72_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_72_next->definitionLine = 206;
// method "nextAcceptableElement"
  block_savedest(obj51);
  Object closure87 = createclosure(1, "nextAcceptableElement");
  setclosureframe(closure87, stackframe);
  addtoclosure(closure87, var_predicate);
  struct UserObject *uo87 = (struct UserObject*)obj51;
  uo87->data[7] = (Object)closure87;
  Method *meth_meth_collectionsPrelude_87_nextAcceptableElement = addmethod2pos(obj51, "nextAcceptableElement", &meth_collectionsPrelude_87_nextAcceptableElement, 7);
  int argcv_meth_collectionsPrelude_87_nextAcceptableElement[] = {0};
  meth_meth_collectionsPrelude_87_nextAcceptableElement->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_87_nextAcceptableElement);
  meth_meth_collectionsPrelude_87_nextAcceptableElement->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_87_nextAcceptableElement->definitionModule = modulename;
  meth_meth_collectionsPrelude_87_nextAcceptableElement->definitionLine = 211;
// method "hasNextAcceptableElement"
  block_savedest(obj51);
  Object closure104 = createclosure(1, "hasNextAcceptableElement");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_predicate);
  struct UserObject *uo104 = (struct UserObject*)obj51;
  uo104->data[8] = (Object)closure104;
  Method *meth_meth_collectionsPrelude_104_hasNextAcceptableElement = addmethod2pos(obj51, "hasNextAcceptableElement", &meth_collectionsPrelude_104_hasNextAcceptableElement, 8);
  int argcv_meth_collectionsPrelude_104_hasNextAcceptableElement[] = {0};
  meth_meth_collectionsPrelude_104_hasNextAcceptableElement->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_104_hasNextAcceptableElement);
  meth_meth_collectionsPrelude_104_hasNextAcceptableElement->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_104_hasNextAcceptableElement->definitionModule = modulename;
  meth_meth_collectionsPrelude_104_hasNextAcceptableElement->definitionLine = 220;
  sourceObject = obj51;
  adddatum2(obj51, undefined, 1);
  sourceObject = obj51;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool135 = alloc_Boolean(0);
// compiled identifier node returning bool135 (depth = 2)
  adddatum2(obj51, bool135, 2);
  sourceObject = obj51;
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe136 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  partcv[0] = 0;
  Object call137 = callmethodflags(*var_source, "iterator", 1, partcv, params, 0);
  gc_frame_end(callframe136);
// compiled member node returning call137 (depth = 2)
  adddatum2(obj51, call137, 3);
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  objclass51 = obj51->class;
  objclass51->definitionModule = modulename;
  objclass51->definitionLine = 196;
  (*(struct UserObject *)self).data[0] = lowerouter51;
  self = oldself51;
  selfslot = oldselfslot51;
  stackframe = oldstackframe51;
  gc_frame_end(frame);
  return obj51;
}
Object meth_collectionsPrelude_50_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  Object *var_predicate = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject51 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj51 = alloc_userobj2(10,9, objclass51);
  gc_frame_newslot(obj51);
  if (objclass51 == NULL) {
    glfree(obj51->class->name);
    obj51->class->name = "lazySequenceOver(_)filteredBy(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj51, self, 0);
  addmethodreal(obj51,"outer", &reader_collectionsPrelude_outer_52);
  Object oldself51 = self;
  struct StackFrameObject *oldstackframe51 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe51);
  gc_frame_newslot((Object)stackframe);
  self = obj51;
  Object *oldselfslot51 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter51 = (*(struct UserObject *)self).data[0], lowerouter51 = thisouter51;
  if (inheritingObject51) {
    struct UserObject *inho51 = (struct UserObject *)inheritingObject51;
    while (inho51->super != GraceDefaultObject) inho51 = (struct UserObject *)inho51->super;
    inho51->super = obj51;
    self = inheritingObject51;
    *selfslot = self;
    lowerouter51 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter51;
  }
  if (objclass51 == NULL) {
    Method *reader53 = addmethodrealflags(obj51, "cache", &reader_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
    Method *writer53 = addmethodrealflags(obj51, "cache:=(1)", &writer_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
    reader53->definitionModule = modulename;
    writer53->definitionModule = modulename;
    reader53->definitionLine = 197;
    writer53->definitionLine = 197;
  }
  obj51->flags |= OFLAG_MUTABLE;
  adddatum2(obj51, alloc_Undefined(), 1);
  if (objclass51 == NULL) {
    Method *reader54 = addmethodrealflags(obj51, "cacheLoaded", &reader_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
    Method *writer54 = addmethodrealflags(obj51, "cacheLoaded:=(1)", &writer_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
    reader54->definitionModule = modulename;
    writer54->definitionModule = modulename;
    reader54->definitionLine = 198;
    writer54->definitionLine = 198;
  }
  obj51->flags |= OFLAG_MUTABLE;
  adddatum2(obj51, alloc_Undefined(), 2);
  if (objclass51 == NULL) {
  Method *reader55 = addmethodrealflags(obj51, "sourceIterator",&reader_collectionsPrelude_sourceIterator_55, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader55->definitionModule = modulename;
  reader55->definitionLine = 199;
  }
  adddatum2(obj51, alloc_Undefined(), 3);
// method "asString"
  block_savedest(obj51);
  Object closure56 = createclosure(1, "asString");
  setclosureframe(closure56, stackframe);
  addtoclosure(closure56, var_source);
  struct UserObject *uo56 = (struct UserObject*)obj51;
  uo56->data[4] = (Object)closure56;
  Method *meth_meth_collectionsPrelude_56_asString = addmethod2pos(obj51, "asString", &meth_collectionsPrelude_56_asString, 4);
  int argcv_meth_collectionsPrelude_56_asString[] = {0};
  meth_meth_collectionsPrelude_56_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_56_asString);
  meth_meth_collectionsPrelude_56_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_56_asString->definitionLine = 200;
// method "hasNext"
  struct UserObject *uo65 = (struct UserObject*)obj51;
  uo65->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_65_hasNext = addmethod2pos(obj51, "hasNext", &meth_collectionsPrelude_65_hasNext, 5);
  int argcv_meth_collectionsPrelude_65_hasNext[] = {0};
  meth_meth_collectionsPrelude_65_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_65_hasNext);
  meth_meth_collectionsPrelude_65_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_65_hasNext->definitionLine = 201;
// method "next"
  struct UserObject *uo72 = (struct UserObject*)obj51;
  uo72->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_72_next = addmethod2pos(obj51, "next", &meth_collectionsPrelude_72_next, 6);
  int argcv_meth_collectionsPrelude_72_next[] = {0};
  meth_meth_collectionsPrelude_72_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_72_next);
  meth_meth_collectionsPrelude_72_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_72_next->definitionLine = 206;
// method "nextAcceptableElement"
  block_savedest(obj51);
  Object closure87 = createclosure(1, "nextAcceptableElement");
  setclosureframe(closure87, stackframe);
  addtoclosure(closure87, var_predicate);
  struct UserObject *uo87 = (struct UserObject*)obj51;
  uo87->data[7] = (Object)closure87;
  Method *meth_meth_collectionsPrelude_87_nextAcceptableElement = addmethod2pos(obj51, "nextAcceptableElement", &meth_collectionsPrelude_87_nextAcceptableElement, 7);
  int argcv_meth_collectionsPrelude_87_nextAcceptableElement[] = {0};
  meth_meth_collectionsPrelude_87_nextAcceptableElement->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_87_nextAcceptableElement);
  meth_meth_collectionsPrelude_87_nextAcceptableElement->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_87_nextAcceptableElement->definitionModule = modulename;
  meth_meth_collectionsPrelude_87_nextAcceptableElement->definitionLine = 211;
// method "hasNextAcceptableElement"
  block_savedest(obj51);
  Object closure104 = createclosure(1, "hasNextAcceptableElement");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_predicate);
  struct UserObject *uo104 = (struct UserObject*)obj51;
  uo104->data[8] = (Object)closure104;
  Method *meth_meth_collectionsPrelude_104_hasNextAcceptableElement = addmethod2pos(obj51, "hasNextAcceptableElement", &meth_collectionsPrelude_104_hasNextAcceptableElement, 8);
  int argcv_meth_collectionsPrelude_104_hasNextAcceptableElement[] = {0};
  meth_meth_collectionsPrelude_104_hasNextAcceptableElement->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_104_hasNextAcceptableElement);
  meth_meth_collectionsPrelude_104_hasNextAcceptableElement->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_104_hasNextAcceptableElement->definitionModule = modulename;
  meth_meth_collectionsPrelude_104_hasNextAcceptableElement->definitionLine = 220;
  sourceObject = obj51;
  adddatum2(obj51, undefined, 1);
  sourceObject = obj51;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool135 = alloc_Boolean(0);
// compiled identifier node returning bool135 (depth = 2)
  adddatum2(obj51, bool135, 2);
  sourceObject = obj51;
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe136 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  partcv[0] = 0;
  Object call137 = callmethodflags(*var_source, "iterator", 1, partcv, params, 0);
  gc_frame_end(callframe136);
// compiled member node returning call137 (depth = 2)
  adddatum2(obj51, call137, 3);
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  objclass51 = obj51->class;
  objclass51->definitionModule = modulename;
  objclass51->definitionLine = 196;
  (*(struct UserObject *)self).data[0] = lowerouter51;
  self = oldself51;
  selfslot = oldselfslot51;
  stackframe = oldstackframe51;
  gc_frame_end(frame);
  return obj51;
}
Object meth_collectionsPrelude_139_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit141 == NULL) {
    strlit141 = alloc_String("");
    gc_root(strlit141);
  }
// compiled string node returning strlit141 (depth = 3)
  int op_slot_right_140 = gc_frame_newslot(strlit141);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_143 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit145 == NULL) {
    strlit145 = alloc_String("a lazy sequence filtering ");
    gc_root(strlit145);
  }
// compiled string node returning strlit145 (depth = 4)
  int op_slot_left_143 = gc_frame_newslot(strlit145);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult146 = callmethod(strlit145, "++(1)", 1, partcv, params);
// compiled op node returning opresult146 (depth = 3)
  int op_slot_left_140 = gc_frame_newslot(opresult146);
  params[0] = strlit141;
  partcv[0] = 1;
  Object opresult147 = callmethod(opresult146, "++(1)", 1, partcv, params);
// compiled op node returning opresult147 (depth = 2)
  gc_frame_end(frame);
  return opresult147;
}
Object meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lazySequenceOver(1)filteredBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)filteredBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)filteredBy(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)filteredBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_predicate = &(stackframe->slots[1]);
  *var_predicate = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part filteredBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject48 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj48 = alloc_userobj2(3,4, objclass48);
  gc_frame_newslot(obj48);
  if (objclass48 == NULL) {
    glfree(obj48->class->name);
    obj48->class->name = "lazySequenceOver(_)filteredBy(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj48, self, 0);
  addmethodreal(obj48,"outer", &reader_collectionsPrelude_outer_49);
  Object oldself48 = self;
  struct StackFrameObject *oldstackframe48 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe48);
  gc_frame_newslot((Object)stackframe);
  self = obj48;
  Object *oldselfslot48 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter48 = (*(struct UserObject *)self).data[0], lowerouter48 = thisouter48;
  if (inheritingObject48) {
    struct UserObject *inho48 = (struct UserObject *)inheritingObject48;
    while (inho48->super != GraceDefaultObject) inho48 = (struct UserObject *)inho48->super;
    inho48->super = obj48;
    self = inheritingObject48;
    *selfslot = self;
    lowerouter48 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter48;
  }
// method "iterator"
  block_savedest(obj48);
  Object closure50 = createclosure(2, "iterator");
  setclosureframe(closure50, stackframe);
  addtoclosure(closure50, var_source);
  addtoclosure(closure50, var_predicate);
  struct UserObject *uo50 = (struct UserObject*)obj48;
  uo50->data[1] = (Object)closure50;
  Method *meth_meth_collectionsPrelude_50_iterator = addmethod2pos(obj48, "iterator", &meth_collectionsPrelude_50_iterator, 1);
  int argcv_meth_collectionsPrelude_50_iterator[] = {0};
  meth_meth_collectionsPrelude_50_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_50_iterator);
  meth_meth_collectionsPrelude_50_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_50_iterator->definitionLine = 196;
  block_savedest(obj48);
  Object closure138 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_source);
  addtoclosure(closure138, var_predicate);
  Method *meth_meth_collectionsPrelude_50_iterator_object = addmethod2pos(obj48, "iterator$object(1)", &meth_collectionsPrelude_50_iterator_object, 1);
  meth_meth_collectionsPrelude_50_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_50_iterator_object->definitionLine = 196;
// method "asDebugString"
  block_savedest(obj48);
  Object closure139 = createclosure(1, "asDebugString");
  setclosureframe(closure139, stackframe);
  addtoclosure(closure139, var_source);
  struct UserObject *uo139 = (struct UserObject*)obj48;
  uo139->data[2] = (Object)closure139;
  Method *meth_meth_collectionsPrelude_139_asDebugString = addmethod2pos(obj48, "asDebugString", &meth_collectionsPrelude_139_asDebugString, 2);
  int argcv_meth_collectionsPrelude_139_asDebugString[] = {0};
  meth_meth_collectionsPrelude_139_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_139_asDebugString);
  meth_meth_collectionsPrelude_139_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_139_asDebugString->definitionLine = 235;
  sourceObject = obj48;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe148 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call149 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe148);
// compiled call node returning call149 (depth = 2)
  struct UserObject *obj48_uo = (struct UserObject *)obj48;
  obj48_uo->super = call149;
  sourceObject = obj48;
  sourceObject = obj48;
  objclass48 = obj48->class;
  objclass48->definitionModule = modulename;
  objclass48->definitionLine = 193;
  (*(struct UserObject *)self).data[0] = lowerouter48;
  self = oldself48;
  selfslot = oldselfslot48;
  stackframe = oldstackframe48;
  gc_frame_end(frame);
  return obj48;
}
Object meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lazySequenceOver(1)filteredBy(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)filteredBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)filteredBy(_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)filteredBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_predicate = &(stackframe->slots[1]);
  *var_predicate = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part filteredBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject48 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj48 = alloc_userobj2(3,4, objclass48);
  gc_frame_newslot(obj48);
  if (objclass48 == NULL) {
    glfree(obj48->class->name);
    obj48->class->name = "lazySequenceOver(_)filteredBy(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj48, self, 0);
  addmethodreal(obj48,"outer", &reader_collectionsPrelude_outer_49);
  Object oldself48 = self;
  struct StackFrameObject *oldstackframe48 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe48);
  gc_frame_newslot((Object)stackframe);
  self = obj48;
  Object *oldselfslot48 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter48 = (*(struct UserObject *)self).data[0], lowerouter48 = thisouter48;
  if (inheritingObject48) {
    struct UserObject *inho48 = (struct UserObject *)inheritingObject48;
    while (inho48->super != GraceDefaultObject) inho48 = (struct UserObject *)inho48->super;
    inho48->super = obj48;
    self = inheritingObject48;
    *selfslot = self;
    lowerouter48 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter48;
  }
// method "iterator"
  block_savedest(obj48);
  Object closure50 = createclosure(2, "iterator");
  setclosureframe(closure50, stackframe);
  addtoclosure(closure50, var_source);
  addtoclosure(closure50, var_predicate);
  struct UserObject *uo50 = (struct UserObject*)obj48;
  uo50->data[1] = (Object)closure50;
  Method *meth_meth_collectionsPrelude_50_iterator = addmethod2pos(obj48, "iterator", &meth_collectionsPrelude_50_iterator, 1);
  int argcv_meth_collectionsPrelude_50_iterator[] = {0};
  meth_meth_collectionsPrelude_50_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_50_iterator);
  meth_meth_collectionsPrelude_50_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_50_iterator->definitionLine = 196;
  block_savedest(obj48);
  Object closure138 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_source);
  addtoclosure(closure138, var_predicate);
  Method *meth_meth_collectionsPrelude_50_iterator_object = addmethod2pos(obj48, "iterator$object(1)", &meth_collectionsPrelude_50_iterator_object, 1);
  meth_meth_collectionsPrelude_50_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_50_iterator_object->definitionLine = 196;
// method "asDebugString"
  block_savedest(obj48);
  Object closure139 = createclosure(1, "asDebugString");
  setclosureframe(closure139, stackframe);
  addtoclosure(closure139, var_source);
  struct UserObject *uo139 = (struct UserObject*)obj48;
  uo139->data[2] = (Object)closure139;
  Method *meth_meth_collectionsPrelude_139_asDebugString = addmethod2pos(obj48, "asDebugString", &meth_collectionsPrelude_139_asDebugString, 2);
  int argcv_meth_collectionsPrelude_139_asDebugString[] = {0};
  meth_meth_collectionsPrelude_139_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_139_asDebugString);
  meth_meth_collectionsPrelude_139_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_139_asDebugString->definitionLine = 235;
  sourceObject = obj48;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe148 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call149 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe148);
// compiled call node returning call149 (depth = 2)
  struct UserObject *obj48_uo = (struct UserObject *)obj48;
  obj48_uo->super = call149;
  sourceObject = obj48;
  sourceObject = obj48;
  objclass48 = obj48->class;
  objclass48->definitionModule = modulename;
  objclass48->definitionLine = 193;
  (*(struct UserObject *)self).data[0] = lowerouter48;
  self = oldself48;
  selfslot = oldselfslot48;
  stackframe = oldstackframe48;
  gc_frame_end(frame);
  return obj48;
}
Object meth_collectionsPrelude_154_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe156 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  partcv[0] = 0;
  Object call157 = callmethodflags(*var_left, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe156);
// compiled member node returning call157 (depth = 3)
  Object if155 = done;
  if (istrue(call157)) {
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe158 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  partcv[0] = 0;
  Object call159 = callmethodflags(*var_left, "next", 1, partcv, params, 0);
  gc_frame_end(callframe158);
// compiled member node returning call159 (depth = 3)
    gc_frame_newslot(call159);
    if155 = call159;
  } else {
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  partcv[0] = 0;
  Object call161 = callmethodflags(*var_right, "next", 1, partcv, params, 0);
  gc_frame_end(callframe160);
// compiled member node returning call161 (depth = 3)
    gc_frame_newslot(call161);
    if155 = call161;
  }
// compiled if node returning if155 (depth = 2)
  gc_frame_end(frame);
  return if155;
}
Object meth_collectionsPrelude_162_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe164 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  partcv[0] = 0;
  Object call165 = callmethodflags(*var_left, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe164);
// compiled member node returning call165 (depth = 3)
  Object if163 = done;
  if (istrue(call165)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool166 = alloc_Boolean(1);
// compiled identifier node returning bool166 (depth = 4)
  return bool166;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if163 = undefined;
  } else {
  }
// compiled if node returning if163 (depth = 2)
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe167 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  partcv[0] = 0;
  Object call168 = callmethodflags(*var_right, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe167);
// compiled member node returning call168 (depth = 3)
  return call168;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_169_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit171 == NULL) {
    strlit171 = alloc_String("");
    gc_root(strlit171);
  }
// compiled string node returning strlit171 (depth = 3)
  int op_slot_right_170 = gc_frame_newslot(strlit171);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  int op_slot_right_173 = gc_frame_newslot(*var_right);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit176 == NULL) {
    strlit176 = alloc_String(" and ");
    gc_root(strlit176);
  }
// compiled string node returning strlit176 (depth = 5)
  int op_slot_right_175 = gc_frame_newslot(strlit176);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  int op_slot_right_178 = gc_frame_newslot(*var_left);
// starting to compile string node (depth = 6)
  if (strlit180 == NULL) {
    strlit180 = alloc_String("iteratorConcat of ");
    gc_root(strlit180);
  }
// compiled string node returning strlit180 (depth = 6)
  int op_slot_left_178 = gc_frame_newslot(strlit180);
  params[0] = *var_left;
  partcv[0] = 1;
  Object opresult181 = callmethod(strlit180, "++(1)", 1, partcv, params);
// compiled op node returning opresult181 (depth = 5)
  int op_slot_left_175 = gc_frame_newslot(opresult181);
  params[0] = strlit176;
  partcv[0] = 1;
  Object opresult182 = callmethod(opresult181, "++(1)", 1, partcv, params);
// compiled op node returning opresult182 (depth = 4)
  int op_slot_left_173 = gc_frame_newslot(opresult182);
  params[0] = *var_right;
  partcv[0] = 1;
  Object opresult183 = callmethod(opresult182, "++(1)", 1, partcv, params);
// compiled op node returning opresult183 (depth = 3)
  int op_slot_left_170 = gc_frame_newslot(opresult183);
  params[0] = strlit171;
  partcv[0] = 1;
  Object opresult184 = callmethod(opresult183, "++(1)", 1, partcv, params);
// compiled op node returning opresult184 (depth = 2)
  gc_frame_end(frame);
  return opresult184;
}
Object meth_collectionsPrelude_185_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit186 == NULL) {
    strlit186 = alloc_String("an iterator over a concatenation");
    gc_root(strlit186);
  }
// compiled string node returning strlit186 (depth = 2)
  gc_frame_end(frame);
  return strlit186;
}
Object meth_collectionsPrelude_151_iteratorConcat_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iteratorConcat(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method iteratorConcat(_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iteratorConcat(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part iteratorConcat(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject152 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj152 = alloc_userobj2(4,5, objclass152);
  gc_frame_newslot(obj152);
  if (objclass152 == NULL) {
    glfree(obj152->class->name);
    obj152->class->name = "iteratorConcat(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj152, self, 0);
  addmethodreal(obj152,"outer", &reader_collectionsPrelude_outer_153);
  Object oldself152 = self;
  struct StackFrameObject *oldstackframe152 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe152);
  gc_frame_newslot((Object)stackframe);
  self = obj152;
  Object *oldselfslot152 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter152 = (*(struct UserObject *)self).data[0], lowerouter152 = thisouter152;
  if (inheritingObject152) {
    struct UserObject *inho152 = (struct UserObject *)inheritingObject152;
    while (inho152->super != GraceDefaultObject) inho152 = (struct UserObject *)inho152->super;
    inho152->super = obj152;
    self = inheritingObject152;
    *selfslot = self;
    lowerouter152 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter152;
  }
// method "next"
  block_savedest(obj152);
  Object closure154 = createclosure(2, "next");
  setclosureframe(closure154, stackframe);
  addtoclosure(closure154, var_left);
  addtoclosure(closure154, var_right);
  struct UserObject *uo154 = (struct UserObject*)obj152;
  uo154->data[1] = (Object)closure154;
  Method *meth_meth_collectionsPrelude_154_next = addmethod2pos(obj152, "next", &meth_collectionsPrelude_154_next, 1);
  int argcv_meth_collectionsPrelude_154_next[] = {0};
  meth_meth_collectionsPrelude_154_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_154_next);
  meth_meth_collectionsPrelude_154_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_154_next->definitionLine = 239;
// method "hasNext"
  block_savedest(obj152);
  Object closure162 = createclosure(2, "hasNext");
  setclosureframe(closure162, stackframe);
  addtoclosure(closure162, var_left);
  addtoclosure(closure162, var_right);
  struct UserObject *uo162 = (struct UserObject*)obj152;
  uo162->data[2] = (Object)closure162;
  Method *meth_meth_collectionsPrelude_162_hasNext = addmethod2pos(obj152, "hasNext", &meth_collectionsPrelude_162_hasNext, 2);
  int argcv_meth_collectionsPrelude_162_hasNext[] = {0};
  meth_meth_collectionsPrelude_162_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_162_hasNext);
  meth_meth_collectionsPrelude_162_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_162_hasNext->definitionLine = 246;
// method "asDebugString"
  block_savedest(obj152);
  Object closure169 = createclosure(2, "asDebugString");
  setclosureframe(closure169, stackframe);
  addtoclosure(closure169, var_right);
  addtoclosure(closure169, var_left);
  struct UserObject *uo169 = (struct UserObject*)obj152;
  uo169->data[3] = (Object)closure169;
  Method *meth_meth_collectionsPrelude_169_asDebugString = addmethod2pos(obj152, "asDebugString", &meth_collectionsPrelude_169_asDebugString, 3);
  int argcv_meth_collectionsPrelude_169_asDebugString[] = {0};
  meth_meth_collectionsPrelude_169_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_169_asDebugString);
  meth_meth_collectionsPrelude_169_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_169_asDebugString->definitionLine = 250;
// method "asString"
  struct UserObject *uo185 = (struct UserObject*)obj152;
  uo185->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_185_asString = addmethod2pos(obj152, "asString", &meth_collectionsPrelude_185_asString, 4);
  int argcv_meth_collectionsPrelude_185_asString[] = {0};
  meth_meth_collectionsPrelude_185_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_185_asString);
  meth_meth_collectionsPrelude_185_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_185_asString->definitionLine = 251;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  objclass152 = obj152->class;
  objclass152->definitionModule = modulename;
  objclass152->definitionLine = 238;
  (*(struct UserObject *)self).data[0] = lowerouter152;
  self = oldself152;
  selfslot = oldselfslot152;
  stackframe = oldstackframe152;
  gc_frame_end(frame);
  return obj152;
}
Object meth_collectionsPrelude_151_iteratorConcat_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iteratorConcat(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method iteratorConcat(_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iteratorConcat(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part iteratorConcat(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject152 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj152 = alloc_userobj2(4,5, objclass152);
  gc_frame_newslot(obj152);
  if (objclass152 == NULL) {
    glfree(obj152->class->name);
    obj152->class->name = "iteratorConcat(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj152, self, 0);
  addmethodreal(obj152,"outer", &reader_collectionsPrelude_outer_153);
  Object oldself152 = self;
  struct StackFrameObject *oldstackframe152 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe152);
  gc_frame_newslot((Object)stackframe);
  self = obj152;
  Object *oldselfslot152 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter152 = (*(struct UserObject *)self).data[0], lowerouter152 = thisouter152;
  if (inheritingObject152) {
    struct UserObject *inho152 = (struct UserObject *)inheritingObject152;
    while (inho152->super != GraceDefaultObject) inho152 = (struct UserObject *)inho152->super;
    inho152->super = obj152;
    self = inheritingObject152;
    *selfslot = self;
    lowerouter152 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter152;
  }
// method "next"
  block_savedest(obj152);
  Object closure154 = createclosure(2, "next");
  setclosureframe(closure154, stackframe);
  addtoclosure(closure154, var_left);
  addtoclosure(closure154, var_right);
  struct UserObject *uo154 = (struct UserObject*)obj152;
  uo154->data[1] = (Object)closure154;
  Method *meth_meth_collectionsPrelude_154_next = addmethod2pos(obj152, "next", &meth_collectionsPrelude_154_next, 1);
  int argcv_meth_collectionsPrelude_154_next[] = {0};
  meth_meth_collectionsPrelude_154_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_154_next);
  meth_meth_collectionsPrelude_154_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_154_next->definitionLine = 239;
// method "hasNext"
  block_savedest(obj152);
  Object closure162 = createclosure(2, "hasNext");
  setclosureframe(closure162, stackframe);
  addtoclosure(closure162, var_left);
  addtoclosure(closure162, var_right);
  struct UserObject *uo162 = (struct UserObject*)obj152;
  uo162->data[2] = (Object)closure162;
  Method *meth_meth_collectionsPrelude_162_hasNext = addmethod2pos(obj152, "hasNext", &meth_collectionsPrelude_162_hasNext, 2);
  int argcv_meth_collectionsPrelude_162_hasNext[] = {0};
  meth_meth_collectionsPrelude_162_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_162_hasNext);
  meth_meth_collectionsPrelude_162_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_162_hasNext->definitionLine = 246;
// method "asDebugString"
  block_savedest(obj152);
  Object closure169 = createclosure(2, "asDebugString");
  setclosureframe(closure169, stackframe);
  addtoclosure(closure169, var_right);
  addtoclosure(closure169, var_left);
  struct UserObject *uo169 = (struct UserObject*)obj152;
  uo169->data[3] = (Object)closure169;
  Method *meth_meth_collectionsPrelude_169_asDebugString = addmethod2pos(obj152, "asDebugString", &meth_collectionsPrelude_169_asDebugString, 3);
  int argcv_meth_collectionsPrelude_169_asDebugString[] = {0};
  meth_meth_collectionsPrelude_169_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_169_asDebugString);
  meth_meth_collectionsPrelude_169_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_169_asDebugString->definitionLine = 250;
// method "asString"
  struct UserObject *uo185 = (struct UserObject*)obj152;
  uo185->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_185_asString = addmethod2pos(obj152, "asString", &meth_collectionsPrelude_185_asString, 4);
  int argcv_meth_collectionsPrelude_185_asString[] = {0};
  meth_meth_collectionsPrelude_185_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_185_asString);
  meth_meth_collectionsPrelude_185_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_185_asString->definitionLine = 251;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  objclass152 = obj152->class;
  objclass152->definitionModule = modulename;
  objclass152->definitionLine = 238;
  (*(struct UserObject *)self).data[0] = lowerouter152;
  self = oldself152;
  selfslot = oldselfslot152;
  stackframe = oldstackframe152;
  gc_frame_end(frame);
  return obj152;
}
Object meth_collectionsPrelude_191_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe192 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe193 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  partcv[0] = 0;
  Object call194 = callmethodflags(*var_left, "iterator", 1, partcv, params, 0);
  gc_frame_end(callframe193);
// compiled member node returning call194 (depth = 3)
  gc_frame_newslot(call194);
// starting to compile member node (depth = 3)
  int callframe195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  partcv[0] = 0;
  Object call196 = callmethodflags(*var_right, "iterator", 1, partcv, params, 0);
  gc_frame_end(callframe195);
// compiled member node returning call196 (depth = 3)
  gc_frame_newslot(call196);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = call194;
  params[1] = call196;
  partcv[0] = 2;
  Object call197 = callmethodflags(module_collectionsPrelude, "iteratorConcat(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe192);
// compiled call node returning call197 (depth = 2)
  gc_frame_end(frame);
  return call197;
}
Object meth_collectionsPrelude_198_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit200 == NULL) {
    strlit200 = alloc_String("");
    gc_root(strlit200);
  }
// compiled string node returning strlit200 (depth = 3)
  int op_slot_right_199 = gc_frame_newslot(strlit200);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  int op_slot_right_202 = gc_frame_newslot(*var_right);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit205 == NULL) {
    strlit205 = alloc_String(" and ");
    gc_root(strlit205);
  }
// compiled string node returning strlit205 (depth = 5)
  int op_slot_right_204 = gc_frame_newslot(strlit205);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  int op_slot_right_207 = gc_frame_newslot(*var_left);
// starting to compile string node (depth = 6)
  if (strlit209 == NULL) {
    strlit209 = alloc_String("lazy concatenation of ");
    gc_root(strlit209);
  }
// compiled string node returning strlit209 (depth = 6)
  int op_slot_left_207 = gc_frame_newslot(strlit209);
  params[0] = *var_left;
  partcv[0] = 1;
  Object opresult210 = callmethod(strlit209, "++(1)", 1, partcv, params);
// compiled op node returning opresult210 (depth = 5)
  int op_slot_left_204 = gc_frame_newslot(opresult210);
  params[0] = strlit205;
  partcv[0] = 1;
  Object opresult211 = callmethod(opresult210, "++(1)", 1, partcv, params);
// compiled op node returning opresult211 (depth = 4)
  int op_slot_left_202 = gc_frame_newslot(opresult211);
  params[0] = *var_right;
  partcv[0] = 1;
  Object opresult212 = callmethod(opresult211, "++(1)", 1, partcv, params);
// compiled op node returning opresult212 (depth = 3)
  int op_slot_left_199 = gc_frame_newslot(opresult212);
  params[0] = strlit200;
  partcv[0] = 1;
  Object opresult213 = callmethod(opresult212, "++(1)", 1, partcv, params);
// compiled op node returning opresult213 (depth = 2)
  gc_frame_end(frame);
  return opresult213;
}
Object meth_collectionsPrelude_214_size(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe216 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  partcv[0] = 0;
  Object call217 = callmethodflags(*var_right, "size", 1, partcv, params, 0);
  gc_frame_end(callframe216);
// compiled member node returning call217 (depth = 3)
  int op_slot_right_215 = gc_frame_newslot(call217);
// starting to compile member node (depth = 3)
  int callframe219 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  partcv[0] = 0;
  Object call220 = callmethodflags(*var_left, "size", 1, partcv, params, 0);
  gc_frame_end(callframe219);
// compiled member node returning call220 (depth = 3)
  int op_slot_left_215 = gc_frame_newslot(call220);
  params[0] = call217;
  partcv[0] = 1;
  Object sum221 = callmethod(call220, "+(1)", 1, partcv, params);
// compiled op node returning sum221 (depth = 2)
  gc_frame_end(frame);
  return sum221;
}
Object meth_collectionsPrelude_188_lazyConcatenation_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lazyConcatenation(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method lazyConcatenation(_,_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lazyConcatenation(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part lazyConcatenation(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject189 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj189 = alloc_userobj2(3,4, objclass189);
  gc_frame_newslot(obj189);
  if (objclass189 == NULL) {
    glfree(obj189->class->name);
    obj189->class->name = "lazyConcatenation(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj189, self, 0);
  addmethodreal(obj189,"outer", &reader_collectionsPrelude_outer_190);
  Object oldself189 = self;
  struct StackFrameObject *oldstackframe189 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe189);
  gc_frame_newslot((Object)stackframe);
  self = obj189;
  Object *oldselfslot189 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter189 = (*(struct UserObject *)self).data[0], lowerouter189 = thisouter189;
  if (inheritingObject189) {
    struct UserObject *inho189 = (struct UserObject *)inheritingObject189;
    while (inho189->super != GraceDefaultObject) inho189 = (struct UserObject *)inho189->super;
    inho189->super = obj189;
    self = inheritingObject189;
    *selfslot = self;
    lowerouter189 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter189;
  }
// method "iterator"
  block_savedest(obj189);
  Object closure191 = createclosure(2, "iterator");
  setclosureframe(closure191, stackframe);
  addtoclosure(closure191, var_left);
  addtoclosure(closure191, var_right);
  struct UserObject *uo191 = (struct UserObject*)obj189;
  uo191->data[1] = (Object)closure191;
  Method *meth_meth_collectionsPrelude_191_iterator = addmethod2pos(obj189, "iterator", &meth_collectionsPrelude_191_iterator, 1);
  int argcv_meth_collectionsPrelude_191_iterator[] = {0};
  meth_meth_collectionsPrelude_191_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_191_iterator);
  meth_meth_collectionsPrelude_191_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_191_iterator->definitionLine = 255;
// method "asDebugString"
  block_savedest(obj189);
  Object closure198 = createclosure(2, "asDebugString");
  setclosureframe(closure198, stackframe);
  addtoclosure(closure198, var_right);
  addtoclosure(closure198, var_left);
  struct UserObject *uo198 = (struct UserObject*)obj189;
  uo198->data[2] = (Object)closure198;
  Method *meth_meth_collectionsPrelude_198_asDebugString = addmethod2pos(obj189, "asDebugString", &meth_collectionsPrelude_198_asDebugString, 2);
  int argcv_meth_collectionsPrelude_198_asDebugString[] = {0};
  meth_meth_collectionsPrelude_198_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_198_asDebugString);
  meth_meth_collectionsPrelude_198_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_198_asDebugString->definitionLine = 258;
// method "size"
  block_savedest(obj189);
  Object closure214 = createclosure(2, "size");
  setclosureframe(closure214, stackframe);
  addtoclosure(closure214, var_right);
  addtoclosure(closure214, var_left);
  struct UserObject *uo214 = (struct UserObject*)obj189;
  uo214->data[3] = (Object)closure214;
  Method *meth_meth_collectionsPrelude_214_size = addmethod2pos(obj189, "size", &meth_collectionsPrelude_214_size, 3);
  int argcv_meth_collectionsPrelude_214_size[] = {0};
  meth_meth_collectionsPrelude_214_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_214_size);
  meth_meth_collectionsPrelude_214_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_214_size->definitionLine = 259;
  sourceObject = obj189;
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe222 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call223 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe222);
// compiled call node returning call223 (depth = 2)
  struct UserObject *obj189_uo = (struct UserObject *)obj189;
  obj189_uo->super = call223;
  sourceObject = obj189;
  sourceObject = obj189;
  sourceObject = obj189;
  objclass189 = obj189->class;
  objclass189->definitionModule = modulename;
  objclass189->definitionLine = 253;
  (*(struct UserObject *)self).data[0] = lowerouter189;
  self = oldself189;
  selfslot = oldselfslot189;
  stackframe = oldstackframe189;
  gc_frame_end(frame);
  return obj189;
}
Object meth_collectionsPrelude_188_lazyConcatenation_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lazyConcatenation(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method lazyConcatenation(_,_)");
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lazyConcatenation(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part lazyConcatenation(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject189 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj189 = alloc_userobj2(3,4, objclass189);
  gc_frame_newslot(obj189);
  if (objclass189 == NULL) {
    glfree(obj189->class->name);
    obj189->class->name = "lazyConcatenation(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj189, self, 0);
  addmethodreal(obj189,"outer", &reader_collectionsPrelude_outer_190);
  Object oldself189 = self;
  struct StackFrameObject *oldstackframe189 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe189);
  gc_frame_newslot((Object)stackframe);
  self = obj189;
  Object *oldselfslot189 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter189 = (*(struct UserObject *)self).data[0], lowerouter189 = thisouter189;
  if (inheritingObject189) {
    struct UserObject *inho189 = (struct UserObject *)inheritingObject189;
    while (inho189->super != GraceDefaultObject) inho189 = (struct UserObject *)inho189->super;
    inho189->super = obj189;
    self = inheritingObject189;
    *selfslot = self;
    lowerouter189 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter189;
  }
// method "iterator"
  block_savedest(obj189);
  Object closure191 = createclosure(2, "iterator");
  setclosureframe(closure191, stackframe);
  addtoclosure(closure191, var_left);
  addtoclosure(closure191, var_right);
  struct UserObject *uo191 = (struct UserObject*)obj189;
  uo191->data[1] = (Object)closure191;
  Method *meth_meth_collectionsPrelude_191_iterator = addmethod2pos(obj189, "iterator", &meth_collectionsPrelude_191_iterator, 1);
  int argcv_meth_collectionsPrelude_191_iterator[] = {0};
  meth_meth_collectionsPrelude_191_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_191_iterator);
  meth_meth_collectionsPrelude_191_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_191_iterator->definitionLine = 255;
// method "asDebugString"
  block_savedest(obj189);
  Object closure198 = createclosure(2, "asDebugString");
  setclosureframe(closure198, stackframe);
  addtoclosure(closure198, var_right);
  addtoclosure(closure198, var_left);
  struct UserObject *uo198 = (struct UserObject*)obj189;
  uo198->data[2] = (Object)closure198;
  Method *meth_meth_collectionsPrelude_198_asDebugString = addmethod2pos(obj189, "asDebugString", &meth_collectionsPrelude_198_asDebugString, 2);
  int argcv_meth_collectionsPrelude_198_asDebugString[] = {0};
  meth_meth_collectionsPrelude_198_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_198_asDebugString);
  meth_meth_collectionsPrelude_198_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_198_asDebugString->definitionLine = 258;
// method "size"
  block_savedest(obj189);
  Object closure214 = createclosure(2, "size");
  setclosureframe(closure214, stackframe);
  addtoclosure(closure214, var_right);
  addtoclosure(closure214, var_left);
  struct UserObject *uo214 = (struct UserObject*)obj189;
  uo214->data[3] = (Object)closure214;
  Method *meth_meth_collectionsPrelude_214_size = addmethod2pos(obj189, "size", &meth_collectionsPrelude_214_size, 3);
  int argcv_meth_collectionsPrelude_214_size[] = {0};
  meth_meth_collectionsPrelude_214_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_214_size);
  meth_meth_collectionsPrelude_214_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_214_size->definitionLine = 259;
  sourceObject = obj189;
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe222 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call223 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe222);
// compiled call node returning call223 (depth = 2)
  struct UserObject *obj189_uo = (struct UserObject *)obj189;
  obj189_uo->super = call223;
  sourceObject = obj189;
  sourceObject = obj189;
  sourceObject = obj189;
  objclass189 = obj189->class;
  objclass189->definitionModule = modulename;
  objclass189->definitionLine = 253;
  (*(struct UserObject *)self).data[0] = lowerouter189;
  self = oldself189;
  selfslot = oldselfslot189;
  stackframe = oldstackframe189;
  gc_frame_end(frame);
  return obj189;
}
Object meth_collectionsPrelude_228_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit229 == NULL) {
    strlit229 = alloc_String("a collection trait");
    gc_root(strlit229);
  }
// compiled string node returning strlit229 (depth = 2)
  gc_frame_end(frame);
  return strlit229;
}
Object meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sizeIfUnknown(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sizeIfUnknown(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sizeIfUnknown(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sizeIfUnknown(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe231 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_action (depth = 3)
  partcv[0] = 0;
  Object call232 = callmethodflags(*var_action, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe231);
// compiled member node returning call232 (depth = 2)
  gc_frame_end(frame);
  return call232;
}
Object meth_collectionsPrelude_233_size(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe234 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit235 == NULL) {
    strlit235 = alloc_String("this collection does not know its size");
    gc_root(strlit235);
  }
// compiled string node returning strlit235 (depth = 3)
  gc_frame_newslot(strlit235);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SizeUnknown (depth = 3)
  params[0] = strlit235;
  partcv[0] = 1;
  Object call236 = callmethodflags(*var_SizeUnknown, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe234);
// compiled call node returning call236 (depth = 2)
  gc_frame_end(frame);
  return call236;
}
Object meth_collectionsPrelude_237_do(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe238 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  partcv[0] = 0;
  Object call239 = callmethodflags(module_collectionsPrelude, "required", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe238);
// compiled member node returning call239 (depth = 2)
  gc_frame_end(frame);
  return call239;
}
Object meth_collectionsPrelude_240_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe241 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  partcv[0] = 0;
  Object call242 = callmethodflags(module_collectionsPrelude, "required", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe241);
// compiled member node returning call242 (depth = 2)
  gc_frame_end(frame);
  return call242;
}
Object meth_collectionsPrelude_243_isEmpty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe244 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe245 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe246 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call247 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe246);
// compiled member node returning call247 (depth = 4)
  partcv[0] = 0;
  Object call248 = callmethodflags(call247, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe245);
// compiled member node returning call248 (depth = 3)
  partcv[0] = 0;
  Object call249 = callmethodflags(call248, "not", 1, partcv, params, 0);
  gc_frame_end(callframe244);
// compiled member node returning call249 (depth = 2)
  gc_frame_end(frame);
  return call249;
}
Object meth_collectionsPrelude_250_first(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "first");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_it = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "it");
// definebindings:
// definebindings:
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe251 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call252 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe251);
// compiled member node returning call252 (depth = 3)
  *var_it = call252;
  if (call252 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe254 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_it (depth = 4)
  partcv[0] = 0;
  Object call255 = callmethodflags(*var_it, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe254);
// compiled member node returning call255 (depth = 3)
  Object if253 = done;
  if (istrue(call255)) {
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe256 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_it (depth = 4)
  partcv[0] = 0;
  Object call257 = callmethodflags(*var_it, "next", 1, partcv, params, 0);
  gc_frame_end(callframe256);
// compiled member node returning call257 (depth = 3)
    gc_frame_newslot(call257);
    if253 = call257;
  } else {
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe258 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit260 == NULL) {
    strlit260 = alloc_String("");
    gc_root(strlit260);
  }
// compiled string node returning strlit260 (depth = 5)
  int op_slot_right_259 = gc_frame_newslot(strlit260);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  int op_slot_right_262 = gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit264 == NULL) {
    strlit264 = alloc_String("no first element in ");
    gc_root(strlit264);
  }
// compiled string node returning strlit264 (depth = 6)
  int op_slot_left_262 = gc_frame_newslot(strlit264);
  params[0] = self;
  partcv[0] = 1;
  Object opresult265 = callmethod(strlit264, "++(1)", 1, partcv, params);
// compiled op node returning opresult265 (depth = 5)
  int op_slot_left_259 = gc_frame_newslot(opresult265);
  params[0] = strlit260;
  partcv[0] = 1;
  Object opresult266 = callmethod(opresult265, "++(1)", 1, partcv, params);
// compiled op node returning opresult266 (depth = 4)
  gc_frame_newslot(opresult266);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult266;
  partcv[0] = 1;
  Object call267 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe258);
// compiled call node returning call267 (depth = 3)
    gc_frame_newslot(call267);
    if253 = call267;
  }
// compiled if node returning if253 (depth = 2)
  gc_frame_end(frame);
  return if253;
}
Object meth_collectionsPrelude_273__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_firstTime = getfromclosure(closure, 0);
  Object *var_block0 = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_firstTime (depth = 5)
  Object if274 = done;
  if (istrue(*var_firstTime)) {
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool275 = alloc_Boolean(0);
// compiled identifier node returning bool275 (depth = 6)
  *var_firstTime = bool275;
  if (bool275 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if274 = done;
  } else {
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe277 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block0 (depth = 6)
  partcv[0] = 0;
  Object call278 = callmethodflags(*var_block0, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe277);
// compiled member node returning call278 (depth = 5)
    gc_frame_newslot(call278);
    if274 = call278;
  }
// compiled if node returning if274 (depth = 4)
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe279 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call280 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe279);
// compiled call node returning call280 (depth = 4)
  gc_frame_end(frame);
  return call280;
}
Object meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)separatedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)separatedBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)separatedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for do(_)separatedBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *var_block0 = &(stackframe->slots[1]);
  *var_block0 = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part separatedBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_firstTime = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "firstTime");
  Object *var_i = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "i");
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool269 = alloc_Boolean(1);
// compiled identifier node returning bool269 (depth = 3)
  *var_firstTime = bool269;
  if (bool269 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num270 = alloc_Float64(0);
// compiled num node returning num270 (depth = 3)
  *var_i = num270;
  if (num270 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe271 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block272 = alloc_Block(NULL, NULL, "collectionsPrelude", 288);
  gc_frame_newslot(block272);
// method "_apply(_)"
  block_savedest(block272);
  Object closure273 = createclosure(4, "_apply(1)");
  setclosureframe(closure273, stackframe);
  addtoclosure(closure273, var_firstTime);
  addtoclosure(closure273, var_block0);
  addtoclosure(closure273, var_block1);
  addtoclosure(closure273, selfslot);
  struct UserObject *uo273 = (struct UserObject*)block272;
  uo273->data[0] = (Object)closure273;
  Method *meth_meth_collectionsPrelude_273__apply_40_1_41_ = addmethod2pos(block272, "_apply(1)", &meth_collectionsPrelude_273__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_273__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_273__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_273__apply_40_1_41_);
  meth_meth_collectionsPrelude_273__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_273__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block272 (depth = 3)
  gc_frame_newslot(block272);
// call case 4: self request
  params[0] = block272;
  partcv[0] = 1;
  Object call282 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe271);
// compiled call node returning call282 (depth = 2)
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  return self;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_283_reduce_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reduce(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method reduce(_,_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reduce(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initial = &(stackframe->slots[0]);
  *var_initial = args[curarg];
  curarg++;
  Object *var_blk = &(stackframe->slots[1]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part reduce(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe284 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blk (depth = 3)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_initial (depth = 3)
  gc_frame_newslot(*var_initial);
// call case 4: self request
  params[0] = *var_blk;
  params[1] = *var_initial;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call285 = callmethodflags(self, "fold(1)startingWith(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe284);
// compiled call node returning call285 (depth = 2)
  gc_frame_end(frame);
  return call285;
}
Object meth_collectionsPrelude_289__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object *var_blk = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe290 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  gc_frame_newslot(*var_result);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_it (depth = 6)
  gc_frame_newslot(*var_it);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_result;
  params[1] = *var_it;
  partcv[0] = 2;
  Object call291 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe290);
// compiled call node returning call291 (depth = 5)
  *var_result = call291;
  if (call291 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fold(1)startingWith(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for fold(_)startingWith(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part fold(_)");
  Object *var_initial = &(stackframe->slots[1]);
  *var_initial = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_initial (depth = 3)
  *var_result = *var_initial;
  if (*var_initial == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe287 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block288 = alloc_Block(NULL, NULL, "collectionsPrelude", 304);
  gc_frame_newslot(block288);
// method "_apply(_)"
  block_savedest(block288);
  Object closure289 = createclosure(3, "_apply(1)");
  setclosureframe(closure289, stackframe);
  addtoclosure(closure289, var_result);
  addtoclosure(closure289, var_blk);
  addtoclosure(closure289, selfslot);
  struct UserObject *uo289 = (struct UserObject*)block288;
  uo289->data[0] = (Object)closure289;
  Method *meth_meth_collectionsPrelude_289__apply_40_1_41_ = addmethod2pos(block288, "_apply(1)", &meth_collectionsPrelude_289__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_289__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_289__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_289__apply_40_1_41_);
  meth_meth_collectionsPrelude_289__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_289__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block288 (depth = 3)
  gc_frame_newslot(block288);
// call case 4: self request
  params[0] = block288;
  partcv[0] = 1;
  Object call294 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe287);
// compiled call node returning call294 (depth = 2)
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  return *var_result;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_295_map_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for map(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_R = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_R = args[curarg++];
  } else {
    *var_R = Unknown;
  }
// End typeParams
// definebindings:
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe296 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block1 (depth = 3)
  gc_frame_newslot(*var_block1);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  params[1] = *var_block1;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call297 = callmethodflags(module_collectionsPrelude, "lazySequenceOver(1)mappedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe296);
// compiled call node returning call297 (depth = 2)
  gc_frame_end(frame);
  return call297;
}
Object meth_collectionsPrelude_298_filter_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "filter(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method filter(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for filter(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_selectionCondition = &(stackframe->slots[0]);
  *var_selectionCondition = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part filter(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe299 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_selectionCondition (depth = 3)
  gc_frame_newslot(*var_selectionCondition);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  params[1] = *var_selectionCondition;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call300 = callmethodflags(module_collectionsPrelude, "lazySequenceOver(1)filteredBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe299);
// compiled call node returning call300 (depth = 2)
  gc_frame_end(frame);
  return call300;
}
Object meth_collectionsPrelude_301_iter(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe302 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call303 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe302);
// compiled member node returning call303 (depth = 2)
  gc_frame_end(frame);
  return call303;
}
Object meth_collectionsPrelude_225_collection(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "collection");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject226 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj226 = alloc_userobj2(13,14, objclass226);
  gc_frame_newslot(obj226);
  if (objclass226 == NULL) {
    glfree(obj226->class->name);
    obj226->class->name = "collection";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj226, self, 0);
  addmethodreal(obj226,"outer", &reader_collectionsPrelude_outer_227);
  Object oldself226 = self;
  struct StackFrameObject *oldstackframe226 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe226);
  gc_frame_newslot((Object)stackframe);
  self = obj226;
  Object *oldselfslot226 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter226 = (*(struct UserObject *)self).data[0], lowerouter226 = thisouter226;
  if (inheritingObject226) {
    struct UserObject *inho226 = (struct UserObject *)inheritingObject226;
    while (inho226->super != GraceDefaultObject) inho226 = (struct UserObject *)inho226->super;
    inho226->super = obj226;
    self = inheritingObject226;
    *selfslot = self;
    lowerouter226 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter226;
  }
// method "asString"
  struct UserObject *uo228 = (struct UserObject*)obj226;
  uo228->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_228_asString = addmethod2pos(obj226, "asString", &meth_collectionsPrelude_228_asString, 1);
  int argcv_meth_collectionsPrelude_228_asString[] = {0};
  meth_meth_collectionsPrelude_228_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_228_asString);
  meth_meth_collectionsPrelude_228_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_228_asString->definitionLine = 264;
// method "sizeIfUnknown(_)"
  struct UserObject *uo230 = (struct UserObject*)obj226;
  uo230->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_ = addmethod2pos(obj226, "sizeIfUnknown(1)", &meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_, 2);
  int argcv_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_);
  meth_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_->definitionLine = 265;
// method "size"
  block_savedest(obj226);
  Object closure233 = createclosure(1, "size");
  setclosureframe(closure233, stackframe);
  addtoclosure(closure233, var_SizeUnknown);
  struct UserObject *uo233 = (struct UserObject*)obj226;
  uo233->data[3] = (Object)closure233;
  Method *meth_meth_collectionsPrelude_233_size = addmethod2pos(obj226, "size", &meth_collectionsPrelude_233_size, 3);
  int argcv_meth_collectionsPrelude_233_size[] = {0};
  meth_meth_collectionsPrelude_233_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_233_size);
  meth_meth_collectionsPrelude_233_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_233_size->definitionLine = 268;
// method "do"
  struct UserObject *uo237 = (struct UserObject*)obj226;
  uo237->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_237_do = addmethod2pos(obj226, "do", &meth_collectionsPrelude_237_do, 4);
  int argcv_meth_collectionsPrelude_237_do[] = {0};
  meth_meth_collectionsPrelude_237_do->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_237_do);
  meth_meth_collectionsPrelude_237_do->definitionModule = modulename;
  meth_meth_collectionsPrelude_237_do->definitionLine = 271;
// method "iterator"
  struct UserObject *uo240 = (struct UserObject*)obj226;
  uo240->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_240_iterator = addmethod2pos(obj226, "iterator", &meth_collectionsPrelude_240_iterator, 5);
  int argcv_meth_collectionsPrelude_240_iterator[] = {0};
  meth_meth_collectionsPrelude_240_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_240_iterator);
  meth_meth_collectionsPrelude_240_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_240_iterator->definitionLine = 272;
// method "isEmpty"
  struct UserObject *uo243 = (struct UserObject*)obj226;
  uo243->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_243_isEmpty = addmethod2pos(obj226, "isEmpty", &meth_collectionsPrelude_243_isEmpty, 6);
  int argcv_meth_collectionsPrelude_243_isEmpty[] = {0};
  meth_meth_collectionsPrelude_243_isEmpty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_243_isEmpty);
  meth_meth_collectionsPrelude_243_isEmpty->definitionModule = modulename;
  meth_meth_collectionsPrelude_243_isEmpty->definitionLine = 273;
// method "first"
  block_savedest(obj226);
  Object closure250 = createclosure(1, "first");
  setclosureframe(closure250, stackframe);
  addtoclosure(closure250, var_BoundsError);
  struct UserObject *uo250 = (struct UserObject*)obj226;
  uo250->data[7] = (Object)closure250;
  Method *meth_meth_collectionsPrelude_250_first = addmethod2pos(obj226, "first", &meth_collectionsPrelude_250_first, 7);
  int argcv_meth_collectionsPrelude_250_first[] = {0};
  meth_meth_collectionsPrelude_250_first->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_250_first);
  meth_meth_collectionsPrelude_250_first->definitionModule = modulename;
  meth_meth_collectionsPrelude_250_first->definitionLine = 277;
// method "do(_)separatedBy(_)"
  struct UserObject *uo268 = (struct UserObject*)obj226;
  uo268->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_ = addmethod2pos(obj226, "do(1)separatedBy(1)", &meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_);
  meth_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_->definitionLine = 285;
// method "reduce(_,_)"
  struct UserObject *uo283 = (struct UserObject*)obj226;
  uo283->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_283_reduce_40_2_41_ = addmethod2pos(obj226, "reduce(2)", &meth_collectionsPrelude_283_reduce_40_2_41_, 9);
  int argcv_meth_collectionsPrelude_283_reduce_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_283_reduce_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_283_reduce_40_2_41_);
  meth_meth_collectionsPrelude_283_reduce_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_283_reduce_40_2_41_->definitionLine = 298;
// method "fold(_)startingWith(_)"
  struct UserObject *uo286 = (struct UserObject*)obj226;
  uo286->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_ = addmethod2pos(obj226, "fold(1)startingWith(1)", &meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_, 10);
  int argcv_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_);
  meth_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_->definitionLine = 302;
// method "map(_)"
  struct UserObject *uo295 = (struct UserObject*)obj226;
  uo295->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_295_map_40_1_41_ = addmethod2pos(obj226, "map(1)", &meth_collectionsPrelude_295_map_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_295_map_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_295_map_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_295_map_40_1_41_);
  meth_meth_collectionsPrelude_295_map_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_295_map_40_1_41_->definitionLine = 309;
// method "filter(_)"
  struct UserObject *uo298 = (struct UserObject*)obj226;
  uo298->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_298_filter_40_1_41_ = addmethod2pos(obj226, "filter(1)", &meth_collectionsPrelude_298_filter_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_298_filter_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_298_filter_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_298_filter_40_1_41_);
  meth_meth_collectionsPrelude_298_filter_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_298_filter_40_1_41_->definitionLine = 312;
// method "iter"
  struct UserObject *uo301 = (struct UserObject*)obj226;
  uo301->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_301_iter = addmethod2pos(obj226, "iter", &meth_collectionsPrelude_301_iter, 13);
  int argcv_meth_collectionsPrelude_301_iter[] = {0};
  meth_meth_collectionsPrelude_301_iter->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_301_iter);
  meth_meth_collectionsPrelude_301_iter->definitionModule = modulename;
  meth_meth_collectionsPrelude_301_iter->definitionLine = 315;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  objclass226 = obj226->class;
  objclass226->definitionModule = modulename;
  objclass226->definitionLine = 262;
  (*(struct UserObject *)self).data[0] = lowerouter226;
  self = oldself226;
  selfslot = oldselfslot226;
  stackframe = oldstackframe226;
  gc_frame_end(frame);
  return obj226;
}
Object meth_collectionsPrelude_225_collection_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "collection$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject226 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj226 = alloc_userobj2(13,14, objclass226);
  gc_frame_newslot(obj226);
  if (objclass226 == NULL) {
    glfree(obj226->class->name);
    obj226->class->name = "collection";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj226, self, 0);
  addmethodreal(obj226,"outer", &reader_collectionsPrelude_outer_227);
  Object oldself226 = self;
  struct StackFrameObject *oldstackframe226 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe226);
  gc_frame_newslot((Object)stackframe);
  self = obj226;
  Object *oldselfslot226 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter226 = (*(struct UserObject *)self).data[0], lowerouter226 = thisouter226;
  if (inheritingObject226) {
    struct UserObject *inho226 = (struct UserObject *)inheritingObject226;
    while (inho226->super != GraceDefaultObject) inho226 = (struct UserObject *)inho226->super;
    inho226->super = obj226;
    self = inheritingObject226;
    *selfslot = self;
    lowerouter226 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter226;
  }
// method "asString"
  struct UserObject *uo228 = (struct UserObject*)obj226;
  uo228->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_228_asString = addmethod2pos(obj226, "asString", &meth_collectionsPrelude_228_asString, 1);
  int argcv_meth_collectionsPrelude_228_asString[] = {0};
  meth_meth_collectionsPrelude_228_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_228_asString);
  meth_meth_collectionsPrelude_228_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_228_asString->definitionLine = 264;
// method "sizeIfUnknown(_)"
  struct UserObject *uo230 = (struct UserObject*)obj226;
  uo230->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_ = addmethod2pos(obj226, "sizeIfUnknown(1)", &meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_, 2);
  int argcv_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_);
  meth_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_230_sizeIfUnknown_40_1_41_->definitionLine = 265;
// method "size"
  block_savedest(obj226);
  Object closure233 = createclosure(1, "size");
  setclosureframe(closure233, stackframe);
  addtoclosure(closure233, var_SizeUnknown);
  struct UserObject *uo233 = (struct UserObject*)obj226;
  uo233->data[3] = (Object)closure233;
  Method *meth_meth_collectionsPrelude_233_size = addmethod2pos(obj226, "size", &meth_collectionsPrelude_233_size, 3);
  int argcv_meth_collectionsPrelude_233_size[] = {0};
  meth_meth_collectionsPrelude_233_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_233_size);
  meth_meth_collectionsPrelude_233_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_233_size->definitionLine = 268;
// method "do"
  struct UserObject *uo237 = (struct UserObject*)obj226;
  uo237->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_237_do = addmethod2pos(obj226, "do", &meth_collectionsPrelude_237_do, 4);
  int argcv_meth_collectionsPrelude_237_do[] = {0};
  meth_meth_collectionsPrelude_237_do->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_237_do);
  meth_meth_collectionsPrelude_237_do->definitionModule = modulename;
  meth_meth_collectionsPrelude_237_do->definitionLine = 271;
// method "iterator"
  struct UserObject *uo240 = (struct UserObject*)obj226;
  uo240->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_240_iterator = addmethod2pos(obj226, "iterator", &meth_collectionsPrelude_240_iterator, 5);
  int argcv_meth_collectionsPrelude_240_iterator[] = {0};
  meth_meth_collectionsPrelude_240_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_240_iterator);
  meth_meth_collectionsPrelude_240_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_240_iterator->definitionLine = 272;
// method "isEmpty"
  struct UserObject *uo243 = (struct UserObject*)obj226;
  uo243->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_243_isEmpty = addmethod2pos(obj226, "isEmpty", &meth_collectionsPrelude_243_isEmpty, 6);
  int argcv_meth_collectionsPrelude_243_isEmpty[] = {0};
  meth_meth_collectionsPrelude_243_isEmpty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_243_isEmpty);
  meth_meth_collectionsPrelude_243_isEmpty->definitionModule = modulename;
  meth_meth_collectionsPrelude_243_isEmpty->definitionLine = 273;
// method "first"
  block_savedest(obj226);
  Object closure250 = createclosure(1, "first");
  setclosureframe(closure250, stackframe);
  addtoclosure(closure250, var_BoundsError);
  struct UserObject *uo250 = (struct UserObject*)obj226;
  uo250->data[7] = (Object)closure250;
  Method *meth_meth_collectionsPrelude_250_first = addmethod2pos(obj226, "first", &meth_collectionsPrelude_250_first, 7);
  int argcv_meth_collectionsPrelude_250_first[] = {0};
  meth_meth_collectionsPrelude_250_first->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_250_first);
  meth_meth_collectionsPrelude_250_first->definitionModule = modulename;
  meth_meth_collectionsPrelude_250_first->definitionLine = 277;
// method "do(_)separatedBy(_)"
  struct UserObject *uo268 = (struct UserObject*)obj226;
  uo268->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_ = addmethod2pos(obj226, "do(1)separatedBy(1)", &meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_);
  meth_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_268_do_40_1_41_separatedBy_40_1_41_->definitionLine = 285;
// method "reduce(_,_)"
  struct UserObject *uo283 = (struct UserObject*)obj226;
  uo283->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_283_reduce_40_2_41_ = addmethod2pos(obj226, "reduce(2)", &meth_collectionsPrelude_283_reduce_40_2_41_, 9);
  int argcv_meth_collectionsPrelude_283_reduce_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_283_reduce_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_283_reduce_40_2_41_);
  meth_meth_collectionsPrelude_283_reduce_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_283_reduce_40_2_41_->definitionLine = 298;
// method "fold(_)startingWith(_)"
  struct UserObject *uo286 = (struct UserObject*)obj226;
  uo286->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_ = addmethod2pos(obj226, "fold(1)startingWith(1)", &meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_, 10);
  int argcv_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_);
  meth_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_286_fold_40_1_41_startingWith_40_1_41_->definitionLine = 302;
// method "map(_)"
  struct UserObject *uo295 = (struct UserObject*)obj226;
  uo295->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_295_map_40_1_41_ = addmethod2pos(obj226, "map(1)", &meth_collectionsPrelude_295_map_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_295_map_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_295_map_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_295_map_40_1_41_);
  meth_meth_collectionsPrelude_295_map_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_295_map_40_1_41_->definitionLine = 309;
// method "filter(_)"
  struct UserObject *uo298 = (struct UserObject*)obj226;
  uo298->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_298_filter_40_1_41_ = addmethod2pos(obj226, "filter(1)", &meth_collectionsPrelude_298_filter_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_298_filter_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_298_filter_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_298_filter_40_1_41_);
  meth_meth_collectionsPrelude_298_filter_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_298_filter_40_1_41_->definitionLine = 312;
// method "iter"
  struct UserObject *uo301 = (struct UserObject*)obj226;
  uo301->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_301_iter = addmethod2pos(obj226, "iter", &meth_collectionsPrelude_301_iter, 13);
  int argcv_meth_collectionsPrelude_301_iter[] = {0};
  meth_meth_collectionsPrelude_301_iter->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_301_iter);
  meth_meth_collectionsPrelude_301_iter->definitionModule = modulename;
  meth_meth_collectionsPrelude_301_iter->definitionLine = 315;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  sourceObject = obj226;
  objclass226 = obj226->class;
  objclass226->definitionModule = modulename;
  objclass226->definitionLine = 262;
  (*(struct UserObject *)self).data[0] = lowerouter226;
  self = oldself226;
  selfslot = oldselfslot226;
  stackframe = oldstackframe226;
  gc_frame_end(frame);
  return obj226;
}
Object meth_collectionsPrelude_308_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe309 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  partcv[0] = 0;
  Object call310 = callmethodflags(module_collectionsPrelude, "required", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe309);
// compiled member node returning call310 (depth = 2)
  gc_frame_end(frame);
  return call310;
}
Object meth_collectionsPrelude_311_size(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe312 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit314 == NULL) {
    strlit314 = alloc_String("");
    gc_root(strlit314);
  }
// compiled string node returning strlit314 (depth = 4)
  int op_slot_right_313 = gc_frame_newslot(strlit314);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe317 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call318 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe317);
// compiled member node returning call318 (depth = 5)
  int op_slot_right_316 = gc_frame_newslot(call318);
// starting to compile string node (depth = 5)
  if (strlit320 == NULL) {
    strlit320 = alloc_String("size requested on ");
    gc_root(strlit320);
  }
// compiled string node returning strlit320 (depth = 5)
  int op_slot_left_316 = gc_frame_newslot(strlit320);
  params[0] = call318;
  partcv[0] = 1;
  Object opresult321 = callmethod(strlit320, "++(1)", 1, partcv, params);
// compiled op node returning opresult321 (depth = 4)
  int op_slot_left_313 = gc_frame_newslot(opresult321);
  params[0] = strlit314;
  partcv[0] = 1;
  Object opresult322 = callmethod(opresult321, "++(1)", 1, partcv, params);
// compiled op node returning opresult322 (depth = 3)
  gc_frame_newslot(opresult322);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SizeUnknown (depth = 3)
  params[0] = opresult322;
  partcv[0] = 1;
  Object call323 = callmethodflags(*var_SizeUnknown, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe312);
// compiled call node returning call323 (depth = 2)
  gc_frame_end(frame);
  return call323;
}
Object meth_collectionsPrelude_331__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe332 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call333 = callmethodflags(*var_result, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe332);
// compiled call node returning call333 (depth = 4)
  gc_frame_end(frame);
  return call333;
}
Object meth_collectionsPrelude_324_asDictionary(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe325 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe326 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call327 = callmethodflags(module_collectionsPrelude, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe326);
// compiled member node returning call327 (depth = 4)
  partcv[0] = 0;
  Object call328 = callmethodflags(call327, "empty", 1, partcv, params, 0);
  gc_frame_end(callframe325);
// compiled member node returning call328 (depth = 3)
  *var_result = call328;
  if (call328 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe329 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block330 = alloc_Block(NULL, NULL, "collectionsPrelude", 328);
  gc_frame_newslot(block330);
// method "_apply(_,_)"
  block_savedest(block330);
  Object closure331 = createclosure(2, "_apply(2)");
  setclosureframe(closure331, stackframe);
  addtoclosure(closure331, var_result);
  addtoclosure(closure331, selfslot);
  struct UserObject *uo331 = (struct UserObject*)block330;
  uo331->data[0] = (Object)closure331;
  Method *meth_meth_collectionsPrelude_331__apply_40_2_41_ = addmethod2pos(block330, "_apply(2)", &meth_collectionsPrelude_331__apply_40_2_41_, 0);
  int argcv_meth_collectionsPrelude_331__apply_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_331__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_331__apply_40_2_41_);
  meth_meth_collectionsPrelude_331__apply_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_331__apply_40_2_41_->definitionLine = 1769;
// compiled block node returning block330 (depth = 3)
  gc_frame_newslot(block330);
// call case 4: self request
  params[0] = block330;
  partcv[0] = 1;
  Object call335 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe329);
// compiled call node returning call335 (depth = 2)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  return *var_result;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_341__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 4)
  int callframe342 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_selfIterator (depth = 5)
  partcv[0] = 0;
  Object call343 = callmethodflags(*var_selfIterator, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe342);
// compiled member node returning call343 (depth = 4)
  gc_frame_end(frame);
  return call343;
}
Object meth_collectionsPrelude_346__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_existing = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe347 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe348 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  partcv[0] = 0;
  Object call349 = callmethodflags(*var_selfIterator, "next", 1, partcv, params, 0);
  gc_frame_end(callframe348);
// compiled member node returning call349 (depth = 5)
  gc_frame_newslot(call349);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_existing (depth = 5)
  params[0] = call349;
  partcv[0] = 1;
  Object call350 = callmethodflags(*var_existing, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe347);
// compiled call node returning call350 (depth = 4)
  gc_frame_end(frame);
  return call350;
}
Object meth_collectionsPrelude_336_into_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe337 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call338 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe337);
// compiled member node returning call338 (depth = 3)
  *var_selfIterator = call338;
  if (call338 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe339 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block340 = alloc_Block(NULL, NULL, "collectionsPrelude", 335);
  gc_frame_newslot(block340);
// method "_apply"
  block_savedest(block340);
  Object closure341 = createclosure(2, "_apply");
  setclosureframe(closure341, stackframe);
  addtoclosure(closure341, var_selfIterator);
  addtoclosure(closure341, selfslot);
  struct UserObject *uo341 = (struct UserObject*)block340;
  uo341->data[0] = (Object)closure341;
  Method *meth_meth_collectionsPrelude_341__apply = addmethod2pos(block340, "_apply", &meth_collectionsPrelude_341__apply, 0);
  int argcv_meth_collectionsPrelude_341__apply[] = {0};
  meth_meth_collectionsPrelude_341__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_341__apply);
  meth_meth_collectionsPrelude_341__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_341__apply->definitionLine = 1769;
// compiled block node returning block340 (depth = 3)
  gc_frame_newslot(block340);
// starting to compile block node (depth = 3)
  Object block345 = alloc_Block(NULL, NULL, "collectionsPrelude", 335);
  gc_frame_newslot(block345);
// method "_apply"
  block_savedest(block345);
  Object closure346 = createclosure(3, "_apply");
  setclosureframe(closure346, stackframe);
  addtoclosure(closure346, var_selfIterator);
  addtoclosure(closure346, var_existing);
  addtoclosure(closure346, selfslot);
  struct UserObject *uo346 = (struct UserObject*)block345;
  uo346->data[0] = (Object)closure346;
  Method *meth_meth_collectionsPrelude_346__apply = addmethod2pos(block345, "_apply", &meth_collectionsPrelude_346__apply, 0);
  int argcv_meth_collectionsPrelude_346__apply[] = {0};
  meth_meth_collectionsPrelude_346__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_346__apply);
  meth_meth_collectionsPrelude_346__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_346__apply->definitionLine = 1769;
// compiled block node returning block345 (depth = 3)
  gc_frame_newslot(block345);
// call case 5: prelude request
  params[0] = block340;
  params[1] = block345;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call352 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe339);
// compiled call node returning call352 (depth = 2)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_existing (depth = 2)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude_353__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe354 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call355 = callmethodflags(module_collectionsPrelude, "isEqual(1)toCollection(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe354);
// compiled call node returning call355 (depth = 2)
  gc_frame_end(frame);
  return call355;
}
Object meth_collectionsPrelude_361__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 4)
  int callframe362 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_selfIterator (depth = 5)
  partcv[0] = 0;
  Object call363 = callmethodflags(*var_selfIterator, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe362);
// compiled member node returning call363 (depth = 4)
  gc_frame_end(frame);
  return call363;
}
Object meth_collectionsPrelude_366__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe367 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe368 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  partcv[0] = 0;
  Object call369 = callmethodflags(*var_selfIterator, "next", 1, partcv, params, 0);
  gc_frame_end(callframe368);
// compiled member node returning call369 (depth = 5)
  gc_frame_newslot(call369);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call369;
  partcv[0] = 1;
  Object call370 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe367);
// compiled call node returning call370 (depth = 4)
  gc_frame_end(frame);
  return call370;
}
Object meth_collectionsPrelude_356_do_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe357 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call358 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe357);
// compiled member node returning call358 (depth = 3)
  *var_selfIterator = call358;
  if (call358 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe359 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block360 = alloc_Block(NULL, NULL, "collectionsPrelude", 345);
  gc_frame_newslot(block360);
// method "_apply"
  block_savedest(block360);
  Object closure361 = createclosure(2, "_apply");
  setclosureframe(closure361, stackframe);
  addtoclosure(closure361, var_selfIterator);
  addtoclosure(closure361, selfslot);
  struct UserObject *uo361 = (struct UserObject*)block360;
  uo361->data[0] = (Object)closure361;
  Method *meth_meth_collectionsPrelude_361__apply = addmethod2pos(block360, "_apply", &meth_collectionsPrelude_361__apply, 0);
  int argcv_meth_collectionsPrelude_361__apply[] = {0};
  meth_meth_collectionsPrelude_361__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_361__apply);
  meth_meth_collectionsPrelude_361__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_361__apply->definitionLine = 1769;
// compiled block node returning block360 (depth = 3)
  gc_frame_newslot(block360);
// starting to compile block node (depth = 3)
  Object block365 = alloc_Block(NULL, NULL, "collectionsPrelude", 345);
  gc_frame_newslot(block365);
// method "_apply"
  block_savedest(block365);
  Object closure366 = createclosure(3, "_apply");
  setclosureframe(closure366, stackframe);
  addtoclosure(closure366, var_selfIterator);
  addtoclosure(closure366, var_block1);
  addtoclosure(closure366, selfslot);
  struct UserObject *uo366 = (struct UserObject*)block365;
  uo366->data[0] = (Object)closure366;
  Method *meth_meth_collectionsPrelude_366__apply = addmethod2pos(block365, "_apply", &meth_collectionsPrelude_366__apply, 0);
  int argcv_meth_collectionsPrelude_366__apply[] = {0};
  meth_meth_collectionsPrelude_366__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_366__apply);
  meth_meth_collectionsPrelude_366__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_366__apply->definitionLine = 1769;
// compiled block node returning block365 (depth = 3)
  gc_frame_newslot(block365);
// call case 5: prelude request
  params[0] = block360;
  params[1] = block365;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call372 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe359);
// compiled call node returning call372 (depth = 2)
  gc_frame_end(frame);
  return call372;
}
Object meth_collectionsPrelude_379__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 4)
  int callframe380 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_selfIterator (depth = 5)
  partcv[0] = 0;
  Object call381 = callmethodflags(*var_selfIterator, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe380);
// compiled member node returning call381 (depth = 4)
  gc_frame_end(frame);
  return call381;
}
Object meth_collectionsPrelude_384__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_selfIterator = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num386 = alloc_Float64(1);
// compiled num node returning num386 (depth = 6)
  int op_slot_right_385 = gc_frame_newslot(num386);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_385 = gc_frame_newslot(*var_ix);
  params[0] = num386;
  partcv[0] = 1;
  Object sum388 = callmethod(*var_ix, "+(1)", 1, partcv, params);
// compiled op node returning sum388 (depth = 5)
  *var_ix = sum388;
  if (sum388 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe390 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  gc_frame_newslot(*var_ix);
// starting to compile member node (depth = 5)
  int callframe391 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  partcv[0] = 0;
  Object call392 = callmethodflags(*var_selfIterator, "next", 1, partcv, params, 0);
  gc_frame_end(callframe391);
// compiled member node returning call392 (depth = 5)
  gc_frame_newslot(call392);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_ix;
  params[1] = call392;
  partcv[0] = 2;
  Object call393 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe390);
// compiled call node returning call393 (depth = 4)
  gc_frame_end(frame);
  return call393;
}
Object meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
  Object *var_selfIterator = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "selfIterator");
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num374 = alloc_Float64(0);
// compiled num node returning num374 (depth = 3)
  *var_ix = num374;
  if (num374 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe375 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call376 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe375);
// compiled member node returning call376 (depth = 3)
  *var_selfIterator = call376;
  if (call376 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe377 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block378 = alloc_Block(NULL, NULL, "collectionsPrelude", 352);
  gc_frame_newslot(block378);
// method "_apply"
  block_savedest(block378);
  Object closure379 = createclosure(2, "_apply");
  setclosureframe(closure379, stackframe);
  addtoclosure(closure379, var_selfIterator);
  addtoclosure(closure379, selfslot);
  struct UserObject *uo379 = (struct UserObject*)block378;
  uo379->data[0] = (Object)closure379;
  Method *meth_meth_collectionsPrelude_379__apply = addmethod2pos(block378, "_apply", &meth_collectionsPrelude_379__apply, 0);
  int argcv_meth_collectionsPrelude_379__apply[] = {0};
  meth_meth_collectionsPrelude_379__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_379__apply);
  meth_meth_collectionsPrelude_379__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_379__apply->definitionLine = 1769;
// compiled block node returning block378 (depth = 3)
  gc_frame_newslot(block378);
// starting to compile block node (depth = 3)
  Object block383 = alloc_Block(NULL, NULL, "collectionsPrelude", 352);
  gc_frame_newslot(block383);
// method "_apply"
  block_savedest(block383);
  Object closure384 = createclosure(4, "_apply");
  setclosureframe(closure384, stackframe);
  addtoclosure(closure384, var_ix);
  addtoclosure(closure384, var_selfIterator);
  addtoclosure(closure384, var_block2);
  addtoclosure(closure384, selfslot);
  struct UserObject *uo384 = (struct UserObject*)block383;
  uo384->data[0] = (Object)closure384;
  Method *meth_meth_collectionsPrelude_384__apply = addmethod2pos(block383, "_apply", &meth_collectionsPrelude_384__apply, 0);
  int argcv_meth_collectionsPrelude_384__apply[] = {0};
  meth_meth_collectionsPrelude_384__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_384__apply);
  meth_meth_collectionsPrelude_384__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_384__apply->definitionLine = 1769;
// compiled block node returning block383 (depth = 3)
  gc_frame_newslot(block383);
// call case 5: prelude request
  params[0] = block378;
  params[1] = block383;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call395 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe377);
// compiled call node returning call395 (depth = 2)
  gc_frame_end(frame);
  return call395;
}
Object meth_collectionsPrelude_396_values(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_402__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 4)
  int callframe403 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_selfIterator (depth = 5)
  partcv[0] = 0;
  Object call404 = callmethodflags(*var_selfIterator, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe403);
// compiled member node returning call404 (depth = 4)
  gc_frame_end(frame);
  return call404;
}
Object meth_collectionsPrelude_407__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_res = getfromclosure(closure, 0);
  Object *var_selfIterator = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe408 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_res (depth = 6)
  gc_frame_newslot(*var_res);
// starting to compile member node (depth = 6)
  int callframe409 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  partcv[0] = 0;
  Object call410 = callmethodflags(*var_selfIterator, "next", 1, partcv, params, 0);
  gc_frame_end(callframe409);
// compiled member node returning call410 (depth = 6)
  gc_frame_newslot(call410);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block2 (depth = 6)
  params[0] = *var_res;
  params[1] = call410;
  partcv[0] = 2;
  Object call411 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe408);
// compiled call node returning call411 (depth = 5)
  *var_res = call411;
  if (call411 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fold(1)startingWith(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for fold(_)startingWith(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part fold(_)");
  Object *var_initial = &(stackframe->slots[1]);
  *var_initial = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_R = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_R = args[curarg++];
  } else {
    *var_R = Unknown;
  }
// End typeParams
// definebindings:
  Object *var_res = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "res");
  Object *var_selfIterator = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "selfIterator");
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_initial (depth = 3)
  *var_res = *var_initial;
  if (*var_initial == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe398 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call399 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe398);
// compiled member node returning call399 (depth = 3)
  *var_selfIterator = call399;
  if (call399 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe400 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block401 = alloc_Block(NULL, NULL, "collectionsPrelude", 363);
  gc_frame_newslot(block401);
// method "_apply"
  block_savedest(block401);
  Object closure402 = createclosure(2, "_apply");
  setclosureframe(closure402, stackframe);
  addtoclosure(closure402, var_selfIterator);
  addtoclosure(closure402, selfslot);
  struct UserObject *uo402 = (struct UserObject*)block401;
  uo402->data[0] = (Object)closure402;
  Method *meth_meth_collectionsPrelude_402__apply = addmethod2pos(block401, "_apply", &meth_collectionsPrelude_402__apply, 0);
  int argcv_meth_collectionsPrelude_402__apply[] = {0};
  meth_meth_collectionsPrelude_402__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_402__apply);
  meth_meth_collectionsPrelude_402__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_402__apply->definitionLine = 1769;
// compiled block node returning block401 (depth = 3)
  gc_frame_newslot(block401);
// starting to compile block node (depth = 3)
  Object block406 = alloc_Block(NULL, NULL, "collectionsPrelude", 363);
  gc_frame_newslot(block406);
// method "_apply"
  block_savedest(block406);
  Object closure407 = createclosure(4, "_apply");
  setclosureframe(closure407, stackframe);
  addtoclosure(closure407, var_res);
  addtoclosure(closure407, var_selfIterator);
  addtoclosure(closure407, var_block2);
  addtoclosure(closure407, selfslot);
  struct UserObject *uo407 = (struct UserObject*)block406;
  uo407->data[0] = (Object)closure407;
  Method *meth_meth_collectionsPrelude_407__apply = addmethod2pos(block406, "_apply", &meth_collectionsPrelude_407__apply, 0);
  int argcv_meth_collectionsPrelude_407__apply[] = {0};
  meth_meth_collectionsPrelude_407__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_407__apply);
  meth_meth_collectionsPrelude_407__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_407__apply->definitionLine = 1769;
// compiled block node returning block406 (depth = 3)
  gc_frame_newslot(block406);
// call case 5: prelude request
  params[0] = block401;
  params[1] = block406;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call414 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe400);
// compiled call node returning call414 (depth = 2)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_res (depth = 3)
  return *var_res;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_415__43__43__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe416 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call417 = callmethodflags(module_collectionsPrelude, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe416);
// compiled call node returning call417 (depth = 2)
  gc_frame_end(frame);
  return call417;
}
Object meth_collectionsPrelude_418_sortedBy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe419 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile call node (depth = 3)
  int callframe420 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe421 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call422 = callmethodflags(module_collectionsPrelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe421);
// compiled member node returning call422 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call423 = callmethodflags(call422, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe420);
// compiled call node returning call423 (depth = 3)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call424 = callmethodflags(call423, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe419);
// compiled call node returning call424 (depth = 2)
  gc_frame_end(frame);
  return call424;
}
Object meth_collectionsPrelude_425_sorted(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe426 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 3)
  int callframe427 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe428 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call429 = callmethodflags(module_collectionsPrelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe428);
// compiled member node returning call429 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call430 = callmethodflags(call429, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe427);
// compiled call node returning call430 (depth = 3)
  partcv[0] = 0;
  Object call431 = callmethodflags(call430, "sort", 1, partcv, params, 0);
  gc_frame_end(callframe426);
// compiled member node returning call431 (depth = 2)
  gc_frame_end(frame);
  return call431;
}
Object meth_collectionsPrelude_436__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe438 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  partcv[0] = 0;
  Object call439 = callmethodflags(*var_each, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe438);
// compiled member node returning call439 (depth = 6)
  int op_slot_right_437 = gc_frame_newslot(call439);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_437 = gc_frame_newslot(*var_s);
  params[0] = call439;
  partcv[0] = 1;
  Object opresult441 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult441 (depth = 5)
  *var_s = opresult441;
  if (opresult441 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_445__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit447 == NULL) {
    strlit447 = alloc_String(", ");
    gc_root(strlit447);
  }
// compiled string node returning strlit447 (depth = 6)
  int op_slot_right_446 = gc_frame_newslot(strlit447);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_446 = gc_frame_newslot(*var_s);
  params[0] = strlit447;
  partcv[0] = 1;
  Object opresult449 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult449 (depth = 5)
  *var_s = opresult449;
  if (opresult449 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_432_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit433 == NULL) {
    strlit433 = alloc_String("""\xe2""""\x9f""""\xa8""");
    gc_root(strlit433);
  }
// compiled string node returning strlit433 (depth = 3)
  *var_s = strlit433;
  if (strlit433 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe434 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block435 = alloc_Block(NULL, NULL, "collectionsPrelude", 379);
  gc_frame_newslot(block435);
// method "_apply(_)"
  block_savedest(block435);
  Object closure436 = createclosure(2, "_apply(1)");
  setclosureframe(closure436, stackframe);
  addtoclosure(closure436, var_s);
  addtoclosure(closure436, selfslot);
  struct UserObject *uo436 = (struct UserObject*)block435;
  uo436->data[0] = (Object)closure436;
  Method *meth_meth_collectionsPrelude_436__apply_40_1_41_ = addmethod2pos(block435, "_apply(1)", &meth_collectionsPrelude_436__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_436__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_436__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_436__apply_40_1_41_);
  meth_meth_collectionsPrelude_436__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_436__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block435 (depth = 3)
  gc_frame_newslot(block435);
// starting to compile block node (depth = 3)
  Object block444 = alloc_Block(NULL, NULL, "collectionsPrelude", 379);
  gc_frame_newslot(block444);
// method "_apply"
  block_savedest(block444);
  Object closure445 = createclosure(2, "_apply");
  setclosureframe(closure445, stackframe);
  addtoclosure(closure445, var_s);
  addtoclosure(closure445, selfslot);
  struct UserObject *uo445 = (struct UserObject*)block444;
  uo445->data[0] = (Object)closure445;
  Method *meth_meth_collectionsPrelude_445__apply = addmethod2pos(block444, "_apply", &meth_collectionsPrelude_445__apply, 0);
  int argcv_meth_collectionsPrelude_445__apply[] = {0};
  meth_meth_collectionsPrelude_445__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_445__apply);
  meth_meth_collectionsPrelude_445__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_445__apply->definitionLine = 1769;
// compiled block node returning block444 (depth = 3)
  gc_frame_newslot(block444);
// call case 4: self request
  params[0] = block435;
  params[1] = block444;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call452 = callmethodflags(self, "do(1)separatedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe434);
// compiled call node returning call452 (depth = 2)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit454 == NULL) {
    strlit454 = alloc_String("""\xe2""""\x9f""""\xa9""");
    gc_root(strlit454);
  }
// compiled string node returning strlit454 (depth = 3)
  int op_slot_right_453 = gc_frame_newslot(strlit454);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_453 = gc_frame_newslot(*var_s);
  params[0] = strlit454;
  partcv[0] = 1;
  Object opresult456 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult456 (depth = 2)
  gc_frame_end(frame);
  return opresult456;
}
Object meth_collectionsPrelude_305_enumerable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "enumerable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject306 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj306 = alloc_userobj2(13,14, objclass306);
  gc_frame_newslot(obj306);
  if (objclass306 == NULL) {
    glfree(obj306->class->name);
    obj306->class->name = "enumerable";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj306, self, 0);
  addmethodreal(obj306,"outer", &reader_collectionsPrelude_outer_307);
  Object oldself306 = self;
  struct StackFrameObject *oldstackframe306 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe306);
  gc_frame_newslot((Object)stackframe);
  self = obj306;
  Object *oldselfslot306 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter306 = (*(struct UserObject *)self).data[0], lowerouter306 = thisouter306;
  if (inheritingObject306) {
    struct UserObject *inho306 = (struct UserObject *)inheritingObject306;
    while (inho306->super != GraceDefaultObject) inho306 = (struct UserObject *)inho306->super;
    inho306->super = obj306;
    self = inheritingObject306;
    *selfslot = self;
    lowerouter306 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter306;
  }
// method "iterator"
  struct UserObject *uo308 = (struct UserObject*)obj306;
  uo308->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_308_iterator = addmethod2pos(obj306, "iterator", &meth_collectionsPrelude_308_iterator, 1);
  int argcv_meth_collectionsPrelude_308_iterator[] = {0};
  meth_meth_collectionsPrelude_308_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_308_iterator);
  meth_meth_collectionsPrelude_308_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_308_iterator->definitionLine = 321;
// method "size"
  block_savedest(obj306);
  Object closure311 = createclosure(1, "size");
  setclosureframe(closure311, stackframe);
  addtoclosure(closure311, var_SizeUnknown);
  struct UserObject *uo311 = (struct UserObject*)obj306;
  uo311->data[2] = (Object)closure311;
  Method *meth_meth_collectionsPrelude_311_size = addmethod2pos(obj306, "size", &meth_collectionsPrelude_311_size, 2);
  int argcv_meth_collectionsPrelude_311_size[] = {0};
  meth_meth_collectionsPrelude_311_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_311_size);
  meth_meth_collectionsPrelude_311_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_311_size->definitionLine = 322;
// method "asDictionary"
  struct UserObject *uo324 = (struct UserObject*)obj306;
  uo324->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_324_asDictionary = addmethod2pos(obj306, "asDictionary", &meth_collectionsPrelude_324_asDictionary, 3);
  int argcv_meth_collectionsPrelude_324_asDictionary[] = {0};
  meth_meth_collectionsPrelude_324_asDictionary->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_324_asDictionary);
  meth_meth_collectionsPrelude_324_asDictionary->definitionModule = modulename;
  meth_meth_collectionsPrelude_324_asDictionary->definitionLine = 326;
// method "into(_)"
  struct UserObject *uo336 = (struct UserObject*)obj306;
  uo336->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_336_into_40_1_41_ = addmethod2pos(obj306, "into(1)", &meth_collectionsPrelude_336_into_40_1_41_, 4);
  int argcv_meth_collectionsPrelude_336_into_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_336_into_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_336_into_40_1_41_);
  meth_meth_collectionsPrelude_336_into_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_336_into_40_1_41_->definitionLine = 333;
// method "==(_)"
  struct UserObject *uo353 = (struct UserObject*)obj306;
  uo353->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_353__61__61__40_1_41_ = addmethod2pos(obj306, "==(1)", &meth_collectionsPrelude_353__61__61__40_1_41_, 5);
  int argcv_meth_collectionsPrelude_353__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_353__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_353__61__61__40_1_41_);
  meth_meth_collectionsPrelude_353__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_353__61__61__40_1_41_->definitionLine = 340;
// method "do(_)"
  struct UserObject *uo356 = (struct UserObject*)obj306;
  uo356->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_356_do_40_1_41_ = addmethod2pos(obj306, "do(1)", &meth_collectionsPrelude_356_do_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_356_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_356_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_356_do_40_1_41_);
  meth_meth_collectionsPrelude_356_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_356_do_40_1_41_->definitionLine = 343;
// method "keysAndValuesDo(_)"
  struct UserObject *uo373 = (struct UserObject*)obj306;
  uo373->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_ = addmethod2pos(obj306, "keysAndValuesDo(1)", &meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_->definitionLine = 349;
// method "values"
  struct UserObject *uo396 = (struct UserObject*)obj306;
  uo396->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_396_values = addmethod2pos(obj306, "values", &meth_collectionsPrelude_396_values, 8);
  int argcv_meth_collectionsPrelude_396_values[] = {0};
  meth_meth_collectionsPrelude_396_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_396_values);
  meth_meth_collectionsPrelude_396_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_396_values->definitionLine = 357;
// method "fold(_)startingWith(_)"
  struct UserObject *uo397 = (struct UserObject*)obj306;
  uo397->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_ = addmethod2pos(obj306, "fold(1)startingWith(1)", &meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_, 9);
  int argcv_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_);
  meth_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_->definitionLine = 360;
// method "++(_)"
  struct UserObject *uo415 = (struct UserObject*)obj306;
  uo415->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_415__43__43__40_1_41_ = addmethod2pos(obj306, "++(1)", &meth_collectionsPrelude_415__43__43__40_1_41_, 10);
  int argcv_meth_collectionsPrelude_415__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_415__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_415__43__43__40_1_41_);
  meth_meth_collectionsPrelude_415__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_415__43__43__40_1_41_->definitionLine = 368;
// method "sortedBy(_)"
  struct UserObject *uo418 = (struct UserObject*)obj306;
  uo418->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_418_sortedBy_40_1_41_ = addmethod2pos(obj306, "sortedBy(1)", &meth_collectionsPrelude_418_sortedBy_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_418_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_418_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_418_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_418_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_418_sortedBy_40_1_41_->definitionLine = 371;
// method "sorted"
  struct UserObject *uo425 = (struct UserObject*)obj306;
  uo425->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_425_sorted = addmethod2pos(obj306, "sorted", &meth_collectionsPrelude_425_sorted, 12);
  int argcv_meth_collectionsPrelude_425_sorted[] = {0};
  meth_meth_collectionsPrelude_425_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_425_sorted);
  meth_meth_collectionsPrelude_425_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_425_sorted->definitionLine = 374;
// method "asString"
  struct UserObject *uo432 = (struct UserObject*)obj306;
  uo432->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_432_asString = addmethod2pos(obj306, "asString", &meth_collectionsPrelude_432_asString, 13);
  int argcv_meth_collectionsPrelude_432_asString[] = {0};
  meth_meth_collectionsPrelude_432_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_432_asString);
  meth_meth_collectionsPrelude_432_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_432_asString->definitionLine = 377;
  sourceObject = obj306;
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe457 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call458 = callmethodflags(module_collectionsPrelude, "collection$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe457);
// compiled call node returning call458 (depth = 2)
  struct UserObject *obj306_uo = (struct UserObject *)obj306;
  obj306_uo->super = call458;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  objclass306 = obj306->class;
  objclass306->definitionModule = modulename;
  objclass306->definitionLine = 319;
  (*(struct UserObject *)self).data[0] = lowerouter306;
  self = oldself306;
  selfslot = oldselfslot306;
  stackframe = oldstackframe306;
  gc_frame_end(frame);
  return obj306;
}
Object meth_collectionsPrelude_305_enumerable_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "enumerable$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject306 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj306 = alloc_userobj2(13,14, objclass306);
  gc_frame_newslot(obj306);
  if (objclass306 == NULL) {
    glfree(obj306->class->name);
    obj306->class->name = "enumerable";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj306, self, 0);
  addmethodreal(obj306,"outer", &reader_collectionsPrelude_outer_307);
  Object oldself306 = self;
  struct StackFrameObject *oldstackframe306 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe306);
  gc_frame_newslot((Object)stackframe);
  self = obj306;
  Object *oldselfslot306 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter306 = (*(struct UserObject *)self).data[0], lowerouter306 = thisouter306;
  if (inheritingObject306) {
    struct UserObject *inho306 = (struct UserObject *)inheritingObject306;
    while (inho306->super != GraceDefaultObject) inho306 = (struct UserObject *)inho306->super;
    inho306->super = obj306;
    self = inheritingObject306;
    *selfslot = self;
    lowerouter306 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter306;
  }
// method "iterator"
  struct UserObject *uo308 = (struct UserObject*)obj306;
  uo308->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_308_iterator = addmethod2pos(obj306, "iterator", &meth_collectionsPrelude_308_iterator, 1);
  int argcv_meth_collectionsPrelude_308_iterator[] = {0};
  meth_meth_collectionsPrelude_308_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_308_iterator);
  meth_meth_collectionsPrelude_308_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_308_iterator->definitionLine = 321;
// method "size"
  block_savedest(obj306);
  Object closure311 = createclosure(1, "size");
  setclosureframe(closure311, stackframe);
  addtoclosure(closure311, var_SizeUnknown);
  struct UserObject *uo311 = (struct UserObject*)obj306;
  uo311->data[2] = (Object)closure311;
  Method *meth_meth_collectionsPrelude_311_size = addmethod2pos(obj306, "size", &meth_collectionsPrelude_311_size, 2);
  int argcv_meth_collectionsPrelude_311_size[] = {0};
  meth_meth_collectionsPrelude_311_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_311_size);
  meth_meth_collectionsPrelude_311_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_311_size->definitionLine = 322;
// method "asDictionary"
  struct UserObject *uo324 = (struct UserObject*)obj306;
  uo324->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_324_asDictionary = addmethod2pos(obj306, "asDictionary", &meth_collectionsPrelude_324_asDictionary, 3);
  int argcv_meth_collectionsPrelude_324_asDictionary[] = {0};
  meth_meth_collectionsPrelude_324_asDictionary->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_324_asDictionary);
  meth_meth_collectionsPrelude_324_asDictionary->definitionModule = modulename;
  meth_meth_collectionsPrelude_324_asDictionary->definitionLine = 326;
// method "into(_)"
  struct UserObject *uo336 = (struct UserObject*)obj306;
  uo336->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_336_into_40_1_41_ = addmethod2pos(obj306, "into(1)", &meth_collectionsPrelude_336_into_40_1_41_, 4);
  int argcv_meth_collectionsPrelude_336_into_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_336_into_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_336_into_40_1_41_);
  meth_meth_collectionsPrelude_336_into_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_336_into_40_1_41_->definitionLine = 333;
// method "==(_)"
  struct UserObject *uo353 = (struct UserObject*)obj306;
  uo353->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_353__61__61__40_1_41_ = addmethod2pos(obj306, "==(1)", &meth_collectionsPrelude_353__61__61__40_1_41_, 5);
  int argcv_meth_collectionsPrelude_353__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_353__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_353__61__61__40_1_41_);
  meth_meth_collectionsPrelude_353__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_353__61__61__40_1_41_->definitionLine = 340;
// method "do(_)"
  struct UserObject *uo356 = (struct UserObject*)obj306;
  uo356->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_356_do_40_1_41_ = addmethod2pos(obj306, "do(1)", &meth_collectionsPrelude_356_do_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_356_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_356_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_356_do_40_1_41_);
  meth_meth_collectionsPrelude_356_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_356_do_40_1_41_->definitionLine = 343;
// method "keysAndValuesDo(_)"
  struct UserObject *uo373 = (struct UserObject*)obj306;
  uo373->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_ = addmethod2pos(obj306, "keysAndValuesDo(1)", &meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_373_keysAndValuesDo_40_1_41_->definitionLine = 349;
// method "values"
  struct UserObject *uo396 = (struct UserObject*)obj306;
  uo396->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_396_values = addmethod2pos(obj306, "values", &meth_collectionsPrelude_396_values, 8);
  int argcv_meth_collectionsPrelude_396_values[] = {0};
  meth_meth_collectionsPrelude_396_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_396_values);
  meth_meth_collectionsPrelude_396_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_396_values->definitionLine = 357;
// method "fold(_)startingWith(_)"
  struct UserObject *uo397 = (struct UserObject*)obj306;
  uo397->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_ = addmethod2pos(obj306, "fold(1)startingWith(1)", &meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_, 9);
  int argcv_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_);
  meth_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_397_fold_40_1_41_startingWith_40_1_41_->definitionLine = 360;
// method "++(_)"
  struct UserObject *uo415 = (struct UserObject*)obj306;
  uo415->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_415__43__43__40_1_41_ = addmethod2pos(obj306, "++(1)", &meth_collectionsPrelude_415__43__43__40_1_41_, 10);
  int argcv_meth_collectionsPrelude_415__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_415__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_415__43__43__40_1_41_);
  meth_meth_collectionsPrelude_415__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_415__43__43__40_1_41_->definitionLine = 368;
// method "sortedBy(_)"
  struct UserObject *uo418 = (struct UserObject*)obj306;
  uo418->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_418_sortedBy_40_1_41_ = addmethod2pos(obj306, "sortedBy(1)", &meth_collectionsPrelude_418_sortedBy_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_418_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_418_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_418_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_418_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_418_sortedBy_40_1_41_->definitionLine = 371;
// method "sorted"
  struct UserObject *uo425 = (struct UserObject*)obj306;
  uo425->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_425_sorted = addmethod2pos(obj306, "sorted", &meth_collectionsPrelude_425_sorted, 12);
  int argcv_meth_collectionsPrelude_425_sorted[] = {0};
  meth_meth_collectionsPrelude_425_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_425_sorted);
  meth_meth_collectionsPrelude_425_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_425_sorted->definitionLine = 374;
// method "asString"
  struct UserObject *uo432 = (struct UserObject*)obj306;
  uo432->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_432_asString = addmethod2pos(obj306, "asString", &meth_collectionsPrelude_432_asString, 13);
  int argcv_meth_collectionsPrelude_432_asString[] = {0};
  meth_meth_collectionsPrelude_432_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_432_asString);
  meth_meth_collectionsPrelude_432_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_432_asString->definitionLine = 377;
  sourceObject = obj306;
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe457 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call458 = callmethodflags(module_collectionsPrelude, "collection$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe457);
// compiled call node returning call458 (depth = 2)
  struct UserObject *obj306_uo = (struct UserObject *)obj306;
  obj306_uo->super = call458;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  sourceObject = obj306;
  objclass306 = obj306->class;
  objclass306->definitionModule = modulename;
  objclass306->definitionLine = 319;
  (*(struct UserObject *)self).data[0] = lowerouter306;
  self = oldself306;
  selfslot = oldselfslot306;
  stackframe = oldstackframe306;
  gc_frame_end(frame);
  return obj306;
}
Object meth_collectionsPrelude_463_at_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_index = &(stackframe->slots[0]);
  *var_index = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe464 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  partcv[0] = 0;
  Object call465 = callmethodflags(module_collectionsPrelude, "required", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe464);
// compiled member node returning call465 (depth = 2)
  gc_frame_end(frame);
  return call465;
}
Object meth_collectionsPrelude_466_size(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe467 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  partcv[0] = 0;
  Object call468 = callmethodflags(module_collectionsPrelude, "required", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe467);
// compiled member node returning call468 (depth = 2)
  gc_frame_end(frame);
  return call468;
}
Object meth_collectionsPrelude_469_isEmpty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num471 = alloc_Float64(0);
// compiled num node returning num471 (depth = 3)
  int op_slot_right_470 = gc_frame_newslot(num471);
// starting to compile member node (depth = 3)
  int callframe473 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call474 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe473);
// compiled member node returning call474 (depth = 3)
  int op_slot_left_470 = gc_frame_newslot(call474);
  params[0] = num471;
  partcv[0] = 1;
  Object opresult475 = callmethod(call474, "==(1)", 1, partcv, params);
// compiled op node returning opresult475 (depth = 2)
  gc_frame_end(frame);
  return opresult475;
}
Object meth_collectionsPrelude_482__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_curSize = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_curSize (depth = 5)
  int op_slot_right_483 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_483 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult485 = callmethod(*var_i, "≤(1)", 1, partcv, params);
// compiled op node returning opresult485 (depth = 4)
  gc_frame_end(frame);
  return opresult485;
}
Object meth_collectionsPrelude_488__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_action = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe489 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 5)
  int callframe490 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call491 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe490);
// compiled call node returning call491 (depth = 5)
  gc_frame_newslot(call491);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  params[0] = *var_i;
  params[1] = call491;
  partcv[0] = 2;
  Object call492 = callmethodflags(*var_action, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe489);
// compiled call node returning call492 (depth = 4)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num494 = alloc_Float64(1);
// compiled num node returning num494 (depth = 6)
  int op_slot_right_493 = gc_frame_newslot(num494);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_493 = gc_frame_newslot(*var_i);
  params[0] = num494;
  partcv[0] = 1;
  Object sum496 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum496 (depth = 5)
  *var_i = sum496;
  if (sum496 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
  Object *var_i = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "i");
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe477 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call478 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe477);
// compiled member node returning call478 (depth = 3)
  *var_curSize = call478;
  if (call478 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num479 = alloc_Float64(1);
// compiled num node returning num479 (depth = 3)
  *var_i = num479;
  if (num479 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe480 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block481 = alloc_Block(NULL, NULL, "collectionsPrelude", 392);
  gc_frame_newslot(block481);
// method "_apply"
  block_savedest(block481);
  Object closure482 = createclosure(3, "_apply");
  setclosureframe(closure482, stackframe);
  addtoclosure(closure482, var_curSize);
  addtoclosure(closure482, var_i);
  addtoclosure(closure482, selfslot);
  struct UserObject *uo482 = (struct UserObject*)block481;
  uo482->data[0] = (Object)closure482;
  Method *meth_meth_collectionsPrelude_482__apply = addmethod2pos(block481, "_apply", &meth_collectionsPrelude_482__apply, 0);
  int argcv_meth_collectionsPrelude_482__apply[] = {0};
  meth_meth_collectionsPrelude_482__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_482__apply);
  meth_meth_collectionsPrelude_482__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_482__apply->definitionLine = 1769;
// compiled block node returning block481 (depth = 3)
  gc_frame_newslot(block481);
// starting to compile block node (depth = 3)
  Object block487 = alloc_Block(NULL, NULL, "collectionsPrelude", 392);
  gc_frame_newslot(block487);
// method "_apply"
  block_savedest(block487);
  Object closure488 = createclosure(3, "_apply");
  setclosureframe(closure488, stackframe);
  addtoclosure(closure488, var_i);
  addtoclosure(closure488, var_action);
  addtoclosure(closure488, selfslot);
  struct UserObject *uo488 = (struct UserObject*)block487;
  uo488->data[0] = (Object)closure488;
  Method *meth_meth_collectionsPrelude_488__apply = addmethod2pos(block487, "_apply", &meth_collectionsPrelude_488__apply, 0);
  int argcv_meth_collectionsPrelude_488__apply[] = {0};
  meth_meth_collectionsPrelude_488__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_488__apply);
  meth_meth_collectionsPrelude_488__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_488__apply->definitionLine = 1769;
// compiled block node returning block487 (depth = 3)
  gc_frame_newslot(block487);
// call case 5: prelude request
  params[0] = block481;
  params[1] = block487;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call499 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe480);
// compiled call node returning call499 (depth = 2)
  gc_frame_end(frame);
  return call499;
}
Object meth_collectionsPrelude_500_first(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "first");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe501 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num502 = alloc_Float64(1);
// compiled num node returning num502 (depth = 3)
  gc_frame_newslot(num502);
// call case 4: self request
  params[0] = num502;
  partcv[0] = 1;
  Object call503 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe501);
// compiled call node returning call503 (depth = 2)
  gc_frame_end(frame);
  return call503;
}
Object meth_collectionsPrelude_504_second(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "second");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe505 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num506 = alloc_Float64(2);
// compiled num node returning num506 (depth = 3)
  gc_frame_newslot(num506);
// call case 4: self request
  params[0] = num506;
  partcv[0] = 1;
  Object call507 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe505);
// compiled call node returning call507 (depth = 2)
  gc_frame_end(frame);
  return call507;
}
Object meth_collectionsPrelude_508_third(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "third");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe509 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num510 = alloc_Float64(3);
// compiled num node returning num510 (depth = 3)
  gc_frame_newslot(num510);
// call case 4: self request
  params[0] = num510;
  partcv[0] = 1;
  Object call511 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe509);
// compiled call node returning call511 (depth = 2)
  gc_frame_end(frame);
  return call511;
}
Object meth_collectionsPrelude_512_fourth(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fourth");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe513 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num514 = alloc_Float64(4);
// compiled num node returning num514 (depth = 3)
  gc_frame_newslot(num514);
// call case 4: self request
  params[0] = num514;
  partcv[0] = 1;
  Object call515 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe513);
// compiled call node returning call515 (depth = 2)
  gc_frame_end(frame);
  return call515;
}
Object meth_collectionsPrelude_516_fifth(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fifth");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe517 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num518 = alloc_Float64(5);
// compiled num node returning num518 (depth = 3)
  gc_frame_newslot(num518);
// call case 4: self request
  params[0] = num518;
  partcv[0] = 1;
  Object call519 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe517);
// compiled call node returning call519 (depth = 2)
  gc_frame_end(frame);
  return call519;
}
Object meth_collectionsPrelude_520_last(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "last");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe521 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe522 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call523 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe522);
// compiled member node returning call523 (depth = 3)
  gc_frame_newslot(call523);
// call case 4: self request
  params[0] = call523;
  partcv[0] = 1;
  Object call524 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe521);
// compiled call node returning call524 (depth = 2)
  gc_frame_end(frame);
  return call524;
}
Object meth_collectionsPrelude_525_indices(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "indices");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe526 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num527 = alloc_Float64(1);
// compiled num node returning num527 (depth = 3)
  gc_frame_newslot(num527);
// starting to compile member node (depth = 3)
  int callframe528 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call529 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe528);
// compiled member node returning call529 (depth = 3)
  gc_frame_newslot(call529);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe530 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  partcv[0] = 0;
  Object call531 = callmethodflags(module_collectionsPrelude, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe530);
// compiled member node returning call531 (depth = 3)
  params[0] = num527;
  params[1] = call529;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call532 = callmethodflags(call531, "from(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe526);
// compiled call node returning call532 (depth = 2)
  gc_frame_end(frame);
  return call532;
}
Object meth_collectionsPrelude_536__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sought = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe537 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit539 == NULL) {
    strlit539 = alloc_String("");
    gc_root(strlit539);
  }
// compiled string node returning strlit539 (depth = 6)
  int op_slot_right_538 = gc_frame_newslot(strlit539);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sought (depth = 7)
  int op_slot_right_541 = gc_frame_newslot(*var_sought);
// starting to compile string node (depth = 7)
  if (strlit543 == NULL) {
    strlit543 = alloc_String("collection does not contain ");
    gc_root(strlit543);
  }
// compiled string node returning strlit543 (depth = 7)
  int op_slot_left_541 = gc_frame_newslot(strlit543);
  params[0] = *var_sought;
  partcv[0] = 1;
  Object opresult544 = callmethod(strlit543, "++(1)", 1, partcv, params);
// compiled op node returning opresult544 (depth = 6)
  int op_slot_left_538 = gc_frame_newslot(opresult544);
  params[0] = strlit539;
  partcv[0] = 1;
  Object opresult545 = callmethod(opresult544, "++(1)", 1, partcv, params);
// compiled op node returning opresult545 (depth = 5)
  gc_frame_newslot(opresult545);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_NoSuchObject (depth = 5)
  params[0] = opresult545;
  partcv[0] = 1;
  Object call546 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe537);
// compiled call node returning call546 (depth = 4)
  gc_frame_end(frame);
  return call546;
}
Object meth_collectionsPrelude_533_indexOf_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indexOf(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sought = &(stackframe->slots[0]);
  *var_sought = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part indexOf(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe534 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sought (depth = 3)
  gc_frame_newslot(*var_sought);
// starting to compile block node (depth = 3)
  Object block535 = alloc_Block(NULL, NULL, "collectionsPrelude", 405);
  gc_frame_newslot(block535);
// method "_apply"
  block_savedest(block535);
  Object closure536 = createclosure(3, "_apply");
  setclosureframe(closure536, stackframe);
  addtoclosure(closure536, var_sought);
  addtoclosure(closure536, var_NoSuchObject);
  addtoclosure(closure536, selfslot);
  struct UserObject *uo536 = (struct UserObject*)block535;
  uo536->data[0] = (Object)closure536;
  Method *meth_meth_collectionsPrelude_536__apply = addmethod2pos(block535, "_apply", &meth_collectionsPrelude_536__apply, 0);
  int argcv_meth_collectionsPrelude_536__apply[] = {0};
  meth_meth_collectionsPrelude_536__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_536__apply);
  meth_meth_collectionsPrelude_536__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_536__apply->definitionLine = 1769;
// compiled block node returning block535 (depth = 3)
  gc_frame_newslot(block535);
// call case 4: self request
  params[0] = *var_sought;
  params[1] = block535;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call548 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe534);
// compiled call node returning call548 (depth = 2)
  gc_frame_end(frame);
  return call548;
}
Object meth_collectionsPrelude_552__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object *var_sought = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sought (depth = 6)
  int op_slot_right_554 = gc_frame_newslot(*var_sought);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_554 = gc_frame_newslot(*var_v);
  params[0] = *var_sought;
  partcv[0] = 1;
  Object opresult556 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult556 (depth = 5)
  Object if553 = done;
  if (istrue(opresult556)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  block_return(realself, *var_ix);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if553 = undefined;
  } else {
  }
// compiled if node returning if553 (depth = 4)
  gc_frame_end(frame);
  return if553;
}
Object meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "indexOf(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf(_)ifAbsent(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for indexOf(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_sought = &(stackframe->slots[0]);
  *var_sought = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part indexOf(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe550 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block551 = alloc_Block(NULL, NULL, "collectionsPrelude", 408);
  gc_frame_newslot(block551);
// method "_apply(_,_)"
  block_savedest(block551);
  Object closure552 = createclosure(2, "_apply(2)");
  setclosureframe(closure552, stackframe);
  addtoclosure(closure552, var_sought);
  addtoclosure(closure552, selfslot);
  struct UserObject *uo552 = (struct UserObject*)block551;
  uo552->data[0] = (Object)closure552;
  Method *meth_meth_collectionsPrelude_552__apply_40_2_41_ = addmethod2pos(block551, "_apply(2)", &meth_collectionsPrelude_552__apply_40_2_41_, 0);
  int argcv_meth_collectionsPrelude_552__apply_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_552__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_552__apply_40_2_41_);
  meth_meth_collectionsPrelude_552__apply_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_552__apply_40_2_41_->definitionLine = 1769;
// compiled block node returning block551 (depth = 3)
  gc_frame_newslot(block551);
// call case 4: self request
  params[0] = block551;
  partcv[0] = 1;
  Object call558 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe550);
// compiled call node returning call558 (depth = 2)
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe559 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_action (depth = 3)
  partcv[0] = 0;
  Object call560 = callmethodflags(*var_action, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe559);
// compiled member node returning call560 (depth = 2)
  gc_frame_end(frame);
  return call560;
}
Object meth_collectionsPrelude_568__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe569 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call570 = callmethodflags(*var_result, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe569);
// compiled call node returning call570 (depth = 4)
  gc_frame_end(frame);
  return call570;
}
Object meth_collectionsPrelude_561_asDictionary(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe562 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe563 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call564 = callmethodflags(module_collectionsPrelude, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe563);
// compiled member node returning call564 (depth = 4)
  partcv[0] = 0;
  Object call565 = callmethodflags(call564, "empty", 1, partcv, params, 0);
  gc_frame_end(callframe562);
// compiled member node returning call565 (depth = 3)
  *var_result = call565;
  if (call565 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe566 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block567 = alloc_Block(NULL, NULL, "collectionsPrelude", 415);
  gc_frame_newslot(block567);
// method "_apply(_,_)"
  block_savedest(block567);
  Object closure568 = createclosure(2, "_apply(2)");
  setclosureframe(closure568, stackframe);
  addtoclosure(closure568, var_result);
  addtoclosure(closure568, selfslot);
  struct UserObject *uo568 = (struct UserObject*)block567;
  uo568->data[0] = (Object)closure568;
  Method *meth_meth_collectionsPrelude_568__apply_40_2_41_ = addmethod2pos(block567, "_apply(2)", &meth_collectionsPrelude_568__apply_40_2_41_, 0);
  int argcv_meth_collectionsPrelude_568__apply_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_568__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_568__apply_40_2_41_);
  meth_meth_collectionsPrelude_568__apply_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_568__apply_40_2_41_->definitionLine = 1769;
// compiled block node returning block567 (depth = 3)
  gc_frame_newslot(block567);
// call case 4: self request
  params[0] = block567;
  partcv[0] = 1;
  Object call572 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe566);
// compiled call node returning call572 (depth = 2)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  return *var_result;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_578__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 4)
  int callframe579 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_selfIterator (depth = 5)
  partcv[0] = 0;
  Object call580 = callmethodflags(*var_selfIterator, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe579);
// compiled member node returning call580 (depth = 4)
  gc_frame_end(frame);
  return call580;
}
Object meth_collectionsPrelude_583__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_existing = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe584 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe585 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  partcv[0] = 0;
  Object call586 = callmethodflags(*var_selfIterator, "next", 1, partcv, params, 0);
  gc_frame_end(callframe585);
// compiled member node returning call586 (depth = 5)
  gc_frame_newslot(call586);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_existing (depth = 5)
  params[0] = call586;
  partcv[0] = 1;
  Object call587 = callmethodflags(*var_existing, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe584);
// compiled call node returning call587 (depth = 4)
  gc_frame_end(frame);
  return call587;
}
Object meth_collectionsPrelude_573_into_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe574 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call575 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe574);
// compiled member node returning call575 (depth = 3)
  *var_selfIterator = call575;
  if (call575 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe576 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block577 = alloc_Block(NULL, NULL, "collectionsPrelude", 422);
  gc_frame_newslot(block577);
// method "_apply"
  block_savedest(block577);
  Object closure578 = createclosure(2, "_apply");
  setclosureframe(closure578, stackframe);
  addtoclosure(closure578, var_selfIterator);
  addtoclosure(closure578, selfslot);
  struct UserObject *uo578 = (struct UserObject*)block577;
  uo578->data[0] = (Object)closure578;
  Method *meth_meth_collectionsPrelude_578__apply = addmethod2pos(block577, "_apply", &meth_collectionsPrelude_578__apply, 0);
  int argcv_meth_collectionsPrelude_578__apply[] = {0};
  meth_meth_collectionsPrelude_578__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_578__apply);
  meth_meth_collectionsPrelude_578__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_578__apply->definitionLine = 1769;
// compiled block node returning block577 (depth = 3)
  gc_frame_newslot(block577);
// starting to compile block node (depth = 3)
  Object block582 = alloc_Block(NULL, NULL, "collectionsPrelude", 422);
  gc_frame_newslot(block582);
// method "_apply"
  block_savedest(block582);
  Object closure583 = createclosure(3, "_apply");
  setclosureframe(closure583, stackframe);
  addtoclosure(closure583, var_selfIterator);
  addtoclosure(closure583, var_existing);
  addtoclosure(closure583, selfslot);
  struct UserObject *uo583 = (struct UserObject*)block582;
  uo583->data[0] = (Object)closure583;
  Method *meth_meth_collectionsPrelude_583__apply = addmethod2pos(block582, "_apply", &meth_collectionsPrelude_583__apply, 0);
  int argcv_meth_collectionsPrelude_583__apply[] = {0};
  meth_meth_collectionsPrelude_583__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_583__apply);
  meth_meth_collectionsPrelude_583__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_583__apply->definitionLine = 1769;
// compiled block node returning block582 (depth = 3)
  gc_frame_newslot(block582);
// call case 5: prelude request
  params[0] = block577;
  params[1] = block582;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call589 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe576);
// compiled call node returning call589 (depth = 2)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_existing (depth = 2)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude_460_indexable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject461 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj461 = alloc_userobj2(15,16, objclass461);
  gc_frame_newslot(obj461);
  if (objclass461 == NULL) {
    glfree(obj461->class->name);
    obj461->class->name = "indexable";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj461, self, 0);
  addmethodreal(obj461,"outer", &reader_collectionsPrelude_outer_462);
  Object oldself461 = self;
  struct StackFrameObject *oldstackframe461 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe461);
  gc_frame_newslot((Object)stackframe);
  self = obj461;
  Object *oldselfslot461 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter461 = (*(struct UserObject *)self).data[0], lowerouter461 = thisouter461;
  if (inheritingObject461) {
    struct UserObject *inho461 = (struct UserObject *)inheritingObject461;
    while (inho461->super != GraceDefaultObject) inho461 = (struct UserObject *)inho461->super;
    inho461->super = obj461;
    self = inheritingObject461;
    *selfslot = self;
    lowerouter461 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter461;
  }
// method "at(_)"
  struct UserObject *uo463 = (struct UserObject*)obj461;
  uo463->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_463_at_40_1_41_ = addmethod2pos(obj461, "at(1)", &meth_collectionsPrelude_463_at_40_1_41_, 1);
  int argcv_meth_collectionsPrelude_463_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_463_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_463_at_40_1_41_);
  meth_meth_collectionsPrelude_463_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_463_at_40_1_41_->definitionLine = 386;
// method "size"
  struct UserObject *uo466 = (struct UserObject*)obj461;
  uo466->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_466_size = addmethod2pos(obj461, "size", &meth_collectionsPrelude_466_size, 2);
  int argcv_meth_collectionsPrelude_466_size[] = {0};
  meth_meth_collectionsPrelude_466_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_466_size);
  meth_meth_collectionsPrelude_466_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_466_size->definitionLine = 387;
// method "isEmpty"
  struct UserObject *uo469 = (struct UserObject*)obj461;
  uo469->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_469_isEmpty = addmethod2pos(obj461, "isEmpty", &meth_collectionsPrelude_469_isEmpty, 3);
  int argcv_meth_collectionsPrelude_469_isEmpty[] = {0};
  meth_meth_collectionsPrelude_469_isEmpty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_469_isEmpty);
  meth_meth_collectionsPrelude_469_isEmpty->definitionModule = modulename;
  meth_meth_collectionsPrelude_469_isEmpty->definitionLine = 388;
// method "keysAndValuesDo(_)"
  struct UserObject *uo476 = (struct UserObject*)obj461;
  uo476->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_ = addmethod2pos(obj461, "keysAndValuesDo(1)", &meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_, 4);
  int argcv_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_->definitionLine = 389;
// method "first"
  struct UserObject *uo500 = (struct UserObject*)obj461;
  uo500->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_500_first = addmethod2pos(obj461, "first", &meth_collectionsPrelude_500_first, 5);
  int argcv_meth_collectionsPrelude_500_first[] = {0};
  meth_meth_collectionsPrelude_500_first->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_500_first);
  meth_meth_collectionsPrelude_500_first->definitionModule = modulename;
  meth_meth_collectionsPrelude_500_first->definitionLine = 397;
// method "second"
  struct UserObject *uo504 = (struct UserObject*)obj461;
  uo504->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_504_second = addmethod2pos(obj461, "second", &meth_collectionsPrelude_504_second, 6);
  int argcv_meth_collectionsPrelude_504_second[] = {0};
  meth_meth_collectionsPrelude_504_second->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_504_second);
  meth_meth_collectionsPrelude_504_second->definitionModule = modulename;
  meth_meth_collectionsPrelude_504_second->definitionLine = 398;
// method "third"
  struct UserObject *uo508 = (struct UserObject*)obj461;
  uo508->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_508_third = addmethod2pos(obj461, "third", &meth_collectionsPrelude_508_third, 7);
  int argcv_meth_collectionsPrelude_508_third[] = {0};
  meth_meth_collectionsPrelude_508_third->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_508_third);
  meth_meth_collectionsPrelude_508_third->definitionModule = modulename;
  meth_meth_collectionsPrelude_508_third->definitionLine = 399;
// method "fourth"
  struct UserObject *uo512 = (struct UserObject*)obj461;
  uo512->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_512_fourth = addmethod2pos(obj461, "fourth", &meth_collectionsPrelude_512_fourth, 8);
  int argcv_meth_collectionsPrelude_512_fourth[] = {0};
  meth_meth_collectionsPrelude_512_fourth->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_512_fourth);
  meth_meth_collectionsPrelude_512_fourth->definitionModule = modulename;
  meth_meth_collectionsPrelude_512_fourth->definitionLine = 400;
// method "fifth"
  struct UserObject *uo516 = (struct UserObject*)obj461;
  uo516->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_516_fifth = addmethod2pos(obj461, "fifth", &meth_collectionsPrelude_516_fifth, 9);
  int argcv_meth_collectionsPrelude_516_fifth[] = {0};
  meth_meth_collectionsPrelude_516_fifth->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_516_fifth);
  meth_meth_collectionsPrelude_516_fifth->definitionModule = modulename;
  meth_meth_collectionsPrelude_516_fifth->definitionLine = 401;
// method "last"
  struct UserObject *uo520 = (struct UserObject*)obj461;
  uo520->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_520_last = addmethod2pos(obj461, "last", &meth_collectionsPrelude_520_last, 10);
  int argcv_meth_collectionsPrelude_520_last[] = {0};
  meth_meth_collectionsPrelude_520_last->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_520_last);
  meth_meth_collectionsPrelude_520_last->definitionModule = modulename;
  meth_meth_collectionsPrelude_520_last->definitionLine = 402;
// method "indices"
  struct UserObject *uo525 = (struct UserObject*)obj461;
  uo525->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_525_indices = addmethod2pos(obj461, "indices", &meth_collectionsPrelude_525_indices, 11);
  int argcv_meth_collectionsPrelude_525_indices[] = {0};
  meth_meth_collectionsPrelude_525_indices->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_525_indices);
  meth_meth_collectionsPrelude_525_indices->definitionModule = modulename;
  meth_meth_collectionsPrelude_525_indices->definitionLine = 403;
// method "indexOf(_)"
  block_savedest(obj461);
  Object closure533 = createclosure(1, "indexOf(1)");
  setclosureframe(closure533, stackframe);
  addtoclosure(closure533, var_NoSuchObject);
  struct UserObject *uo533 = (struct UserObject*)obj461;
  uo533->data[12] = (Object)closure533;
  Method *meth_meth_collectionsPrelude_533_indexOf_40_1_41_ = addmethod2pos(obj461, "indexOf(1)", &meth_collectionsPrelude_533_indexOf_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_533_indexOf_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_533_indexOf_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_533_indexOf_40_1_41_);
  meth_meth_collectionsPrelude_533_indexOf_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_533_indexOf_40_1_41_->definitionLine = 404;
// method "indexOf(_)ifAbsent(_)"
  struct UserObject *uo549 = (struct UserObject*)obj461;
  uo549->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj461, "indexOf(1)ifAbsent(1)", &meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_, 13);
  int argcv_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_->definitionLine = 407;
// method "asDictionary"
  struct UserObject *uo561 = (struct UserObject*)obj461;
  uo561->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_561_asDictionary = addmethod2pos(obj461, "asDictionary", &meth_collectionsPrelude_561_asDictionary, 14);
  int argcv_meth_collectionsPrelude_561_asDictionary[] = {0};
  meth_meth_collectionsPrelude_561_asDictionary->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_561_asDictionary);
  meth_meth_collectionsPrelude_561_asDictionary->definitionModule = modulename;
  meth_meth_collectionsPrelude_561_asDictionary->definitionLine = 413;
// method "into(_)"
  struct UserObject *uo573 = (struct UserObject*)obj461;
  uo573->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_573_into_40_1_41_ = addmethod2pos(obj461, "into(1)", &meth_collectionsPrelude_573_into_40_1_41_, 15);
  int argcv_meth_collectionsPrelude_573_into_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_573_into_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_573_into_40_1_41_);
  meth_meth_collectionsPrelude_573_into_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_573_into_40_1_41_->definitionLine = 420;
  sourceObject = obj461;
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe590 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call591 = callmethodflags(module_collectionsPrelude, "collection$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe590);
// compiled call node returning call591 (depth = 2)
  struct UserObject *obj461_uo = (struct UserObject *)obj461;
  obj461_uo->super = call591;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  objclass461 = obj461->class;
  objclass461->definitionModule = modulename;
  objclass461->definitionLine = 384;
  (*(struct UserObject *)self).data[0] = lowerouter461;
  self = oldself461;
  selfslot = oldselfslot461;
  stackframe = oldstackframe461;
  gc_frame_end(frame);
  return obj461;
}
Object meth_collectionsPrelude_460_indexable_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexable$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject461 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj461 = alloc_userobj2(15,16, objclass461);
  gc_frame_newslot(obj461);
  if (objclass461 == NULL) {
    glfree(obj461->class->name);
    obj461->class->name = "indexable";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj461, self, 0);
  addmethodreal(obj461,"outer", &reader_collectionsPrelude_outer_462);
  Object oldself461 = self;
  struct StackFrameObject *oldstackframe461 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe461);
  gc_frame_newslot((Object)stackframe);
  self = obj461;
  Object *oldselfslot461 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter461 = (*(struct UserObject *)self).data[0], lowerouter461 = thisouter461;
  if (inheritingObject461) {
    struct UserObject *inho461 = (struct UserObject *)inheritingObject461;
    while (inho461->super != GraceDefaultObject) inho461 = (struct UserObject *)inho461->super;
    inho461->super = obj461;
    self = inheritingObject461;
    *selfslot = self;
    lowerouter461 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter461;
  }
// method "at(_)"
  struct UserObject *uo463 = (struct UserObject*)obj461;
  uo463->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_463_at_40_1_41_ = addmethod2pos(obj461, "at(1)", &meth_collectionsPrelude_463_at_40_1_41_, 1);
  int argcv_meth_collectionsPrelude_463_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_463_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_463_at_40_1_41_);
  meth_meth_collectionsPrelude_463_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_463_at_40_1_41_->definitionLine = 386;
// method "size"
  struct UserObject *uo466 = (struct UserObject*)obj461;
  uo466->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_466_size = addmethod2pos(obj461, "size", &meth_collectionsPrelude_466_size, 2);
  int argcv_meth_collectionsPrelude_466_size[] = {0};
  meth_meth_collectionsPrelude_466_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_466_size);
  meth_meth_collectionsPrelude_466_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_466_size->definitionLine = 387;
// method "isEmpty"
  struct UserObject *uo469 = (struct UserObject*)obj461;
  uo469->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_469_isEmpty = addmethod2pos(obj461, "isEmpty", &meth_collectionsPrelude_469_isEmpty, 3);
  int argcv_meth_collectionsPrelude_469_isEmpty[] = {0};
  meth_meth_collectionsPrelude_469_isEmpty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_469_isEmpty);
  meth_meth_collectionsPrelude_469_isEmpty->definitionModule = modulename;
  meth_meth_collectionsPrelude_469_isEmpty->definitionLine = 388;
// method "keysAndValuesDo(_)"
  struct UserObject *uo476 = (struct UserObject*)obj461;
  uo476->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_ = addmethod2pos(obj461, "keysAndValuesDo(1)", &meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_, 4);
  int argcv_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_476_keysAndValuesDo_40_1_41_->definitionLine = 389;
// method "first"
  struct UserObject *uo500 = (struct UserObject*)obj461;
  uo500->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_500_first = addmethod2pos(obj461, "first", &meth_collectionsPrelude_500_first, 5);
  int argcv_meth_collectionsPrelude_500_first[] = {0};
  meth_meth_collectionsPrelude_500_first->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_500_first);
  meth_meth_collectionsPrelude_500_first->definitionModule = modulename;
  meth_meth_collectionsPrelude_500_first->definitionLine = 397;
// method "second"
  struct UserObject *uo504 = (struct UserObject*)obj461;
  uo504->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_504_second = addmethod2pos(obj461, "second", &meth_collectionsPrelude_504_second, 6);
  int argcv_meth_collectionsPrelude_504_second[] = {0};
  meth_meth_collectionsPrelude_504_second->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_504_second);
  meth_meth_collectionsPrelude_504_second->definitionModule = modulename;
  meth_meth_collectionsPrelude_504_second->definitionLine = 398;
// method "third"
  struct UserObject *uo508 = (struct UserObject*)obj461;
  uo508->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_508_third = addmethod2pos(obj461, "third", &meth_collectionsPrelude_508_third, 7);
  int argcv_meth_collectionsPrelude_508_third[] = {0};
  meth_meth_collectionsPrelude_508_third->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_508_third);
  meth_meth_collectionsPrelude_508_third->definitionModule = modulename;
  meth_meth_collectionsPrelude_508_third->definitionLine = 399;
// method "fourth"
  struct UserObject *uo512 = (struct UserObject*)obj461;
  uo512->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_512_fourth = addmethod2pos(obj461, "fourth", &meth_collectionsPrelude_512_fourth, 8);
  int argcv_meth_collectionsPrelude_512_fourth[] = {0};
  meth_meth_collectionsPrelude_512_fourth->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_512_fourth);
  meth_meth_collectionsPrelude_512_fourth->definitionModule = modulename;
  meth_meth_collectionsPrelude_512_fourth->definitionLine = 400;
// method "fifth"
  struct UserObject *uo516 = (struct UserObject*)obj461;
  uo516->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_516_fifth = addmethod2pos(obj461, "fifth", &meth_collectionsPrelude_516_fifth, 9);
  int argcv_meth_collectionsPrelude_516_fifth[] = {0};
  meth_meth_collectionsPrelude_516_fifth->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_516_fifth);
  meth_meth_collectionsPrelude_516_fifth->definitionModule = modulename;
  meth_meth_collectionsPrelude_516_fifth->definitionLine = 401;
// method "last"
  struct UserObject *uo520 = (struct UserObject*)obj461;
  uo520->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_520_last = addmethod2pos(obj461, "last", &meth_collectionsPrelude_520_last, 10);
  int argcv_meth_collectionsPrelude_520_last[] = {0};
  meth_meth_collectionsPrelude_520_last->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_520_last);
  meth_meth_collectionsPrelude_520_last->definitionModule = modulename;
  meth_meth_collectionsPrelude_520_last->definitionLine = 402;
// method "indices"
  struct UserObject *uo525 = (struct UserObject*)obj461;
  uo525->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_525_indices = addmethod2pos(obj461, "indices", &meth_collectionsPrelude_525_indices, 11);
  int argcv_meth_collectionsPrelude_525_indices[] = {0};
  meth_meth_collectionsPrelude_525_indices->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_525_indices);
  meth_meth_collectionsPrelude_525_indices->definitionModule = modulename;
  meth_meth_collectionsPrelude_525_indices->definitionLine = 403;
// method "indexOf(_)"
  block_savedest(obj461);
  Object closure533 = createclosure(1, "indexOf(1)");
  setclosureframe(closure533, stackframe);
  addtoclosure(closure533, var_NoSuchObject);
  struct UserObject *uo533 = (struct UserObject*)obj461;
  uo533->data[12] = (Object)closure533;
  Method *meth_meth_collectionsPrelude_533_indexOf_40_1_41_ = addmethod2pos(obj461, "indexOf(1)", &meth_collectionsPrelude_533_indexOf_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_533_indexOf_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_533_indexOf_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_533_indexOf_40_1_41_);
  meth_meth_collectionsPrelude_533_indexOf_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_533_indexOf_40_1_41_->definitionLine = 404;
// method "indexOf(_)ifAbsent(_)"
  struct UserObject *uo549 = (struct UserObject*)obj461;
  uo549->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj461, "indexOf(1)ifAbsent(1)", &meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_, 13);
  int argcv_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_549_indexOf_40_1_41_ifAbsent_40_1_41_->definitionLine = 407;
// method "asDictionary"
  struct UserObject *uo561 = (struct UserObject*)obj461;
  uo561->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_561_asDictionary = addmethod2pos(obj461, "asDictionary", &meth_collectionsPrelude_561_asDictionary, 14);
  int argcv_meth_collectionsPrelude_561_asDictionary[] = {0};
  meth_meth_collectionsPrelude_561_asDictionary->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_561_asDictionary);
  meth_meth_collectionsPrelude_561_asDictionary->definitionModule = modulename;
  meth_meth_collectionsPrelude_561_asDictionary->definitionLine = 413;
// method "into(_)"
  struct UserObject *uo573 = (struct UserObject*)obj461;
  uo573->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_573_into_40_1_41_ = addmethod2pos(obj461, "into(1)", &meth_collectionsPrelude_573_into_40_1_41_, 15);
  int argcv_meth_collectionsPrelude_573_into_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_573_into_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_573_into_40_1_41_);
  meth_meth_collectionsPrelude_573_into_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_573_into_40_1_41_->definitionLine = 420;
  sourceObject = obj461;
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe590 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call591 = callmethodflags(module_collectionsPrelude, "collection$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe590);
// compiled call node returning call591 (depth = 2)
  struct UserObject *obj461_uo = (struct UserObject *)obj461;
  obj461_uo->super = call591;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  sourceObject = obj461;
  objclass461 = obj461->class;
  objclass461->definitionModule = modulename;
  objclass461->definitionLine = 384;
  (*(struct UserObject *)self).data[0] = lowerouter461;
  self = oldself461;
  selfslot = oldselfslot461;
  stackframe = oldstackframe461;
  gc_frame_end(frame);
  return obj461;
}
Object meth_collectionsPrelude_593_max_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "max(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method max(_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for max(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part max(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  int op_slot_right_595 = gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  int op_slot_left_595 = gc_frame_newslot(*var_a);
  params[0] = *var_b;
  partcv[0] = 1;
  Object opresult597 = callmethod(*var_a, ">(1)", 1, partcv, params);
// compiled op node returning opresult597 (depth = 3)
  Object if594 = done;
  if (istrue(opresult597)) {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
    gc_frame_newslot(*var_a);
    if594 = *var_a;
  } else {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
    gc_frame_newslot(*var_b);
    if594 = *var_b;
  }
// compiled if node returning if594 (depth = 2)
  gc_frame_end(frame);
  return if594;
}
Object meth_collectionsPrelude_601_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit602 == NULL) {
    strlit602 = alloc_String("a sequence factory");
    gc_root(strlit602);
  }
// compiled string node returning strlit602 (depth = 2)
  gc_frame_end(frame);
  return strlit602;
}
Object meth_collectionsPrelude_603_empty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_emptySequence (depth = 2)
  gc_frame_end(frame);
  return *var_emptySequence;
}
Object meth_collectionsPrelude_608__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sizeCertain = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool609 = alloc_Boolean(0);
// compiled identifier node returning bool609 (depth = 6)
  *var_sizeCertain = bool609;
  if (bool609 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num611 = alloc_Float64(8);
// compiled num node returning num611 (depth = 5)
  gc_frame_end(frame);
  return num611;
}
Object meth_collectionsPrelude_624__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_inner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe625 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elt (depth = 6)
  gc_frame_newslot(*var_elt);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inner (depth = 6)
  params[0] = *var_ix;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call626 = callmethodflags(*var_inner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe625);
// compiled call node returning call626 (depth = 5)
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num628 = alloc_Float64(1);
// compiled num node returning num628 (depth = 7)
  int op_slot_right_627 = gc_frame_newslot(num628);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_627 = gc_frame_newslot(*var_ix);
  params[0] = num628;
  partcv[0] = 1;
  Object sum630 = callmethod(*var_ix, "+(1)", 1, partcv, params);
// compiled op node returning sum630 (depth = 6)
  *var_ix = sum630;
  if (sum630 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_659__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_inner = getfromclosure(closure, 0);
  Object *var_newInner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe660 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 9)
  int callframe661 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_inner (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call662 = callmethodflags(*var_inner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe661);
// compiled call node returning call662 (depth = 9)
  gc_frame_newslot(call662);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newInner (depth = 9)
  params[0] = *var_i;
  params[1] = call662;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call663 = callmethodflags(*var_newInner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe660);
// compiled call node returning call663 (depth = 8)
  gc_frame_end(frame);
  return call663;
}
Object meth_collectionsPrelude_636__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var_inner = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// definebindings:
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_right_638 = gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_innerSize (depth = 7)
  int op_slot_left_638 = gc_frame_newslot(*var_innerSize);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult640 = callmethod(*var_innerSize, "≤(1)", 1, partcv, params);
// compiled op node returning opresult640 (depth = 6)
  Object if637 = done;
  if (istrue(opresult640)) {
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe641 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num643 = alloc_Float64(2);
// compiled num node returning num643 (depth = 9)
  int op_slot_right_642 = gc_frame_newslot(num643);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_642 = gc_frame_newslot(*var_innerSize);
  params[0] = num643;
  partcv[0] = 1;
  Object prod645 = callmethod(*var_innerSize, "*(1)", 1, partcv, params);
// compiled op node returning prod645 (depth = 8)
  gc_frame_newslot(prod645);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe646 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call647 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe646);
// compiled member node returning call647 (depth = 8)
  params[0] = prod645;
  partcv[0] = 1;
  Object call648 = callmethodflags(call647, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe641);
// compiled call node returning call648 (depth = 7)
  *var_newInner = call648;
  if (call648 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe649 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num652 = alloc_Float64(1);
// compiled num node returning num652 (depth = 9)
  int op_slot_right_651 = gc_frame_newslot(num652);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_651 = gc_frame_newslot(*var_innerSize);
  params[0] = num652;
  partcv[0] = 1;
  Object diff654 = callmethod(*var_innerSize, "-(1)", 1, partcv, params);
// compiled op node returning diff654 (depth = 8)
  int op_slot_right_650 = gc_frame_newslot(diff654);
// starting to compile num node (depth = 8)
  Object num656 = alloc_Float64(0);
// compiled num node returning num656 (depth = 8)
  int op_slot_left_650 = gc_frame_newslot(num656);
  params[0] = diff654;
  partcv[0] = 1;
  Object opresult657 = callmethod(num656, "..(1)", 1, partcv, params);
// compiled op node returning opresult657 (depth = 7)
  gc_frame_newslot(opresult657);
// starting to compile block node (depth = 7)
  Object block658 = alloc_Block(NULL, NULL, "collectionsPrelude", 494);
  gc_frame_newslot(block658);
// method "_apply(_)"
  block_savedest(block658);
  Object closure659 = createclosure(3, "_apply(1)");
  setclosureframe(closure659, stackframe);
  addtoclosure(closure659, var_inner);
  addtoclosure(closure659, var_newInner);
  addtoclosure(closure659, selfslot);
  struct UserObject *uo659 = (struct UserObject*)block658;
  uo659->data[0] = (Object)closure659;
  Method *meth_meth_collectionsPrelude_659__apply_40_1_41_ = addmethod2pos(block658, "_apply(1)", &meth_collectionsPrelude_659__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_659__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_659__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_659__apply_40_1_41_);
  meth_meth_collectionsPrelude_659__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_659__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block658 (depth = 7)
  gc_frame_newslot(block658);
// call case 5: prelude request
  params[0] = opresult657;
  params[1] = block658;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call665 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe649);
// compiled call node returning call665 (depth = 6)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newInner (depth = 7)
  *var_inner = *var_newInner;
  if (*var_newInner == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe667 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_inner (depth = 8)
  partcv[0] = 0;
  Object call668 = callmethodflags(*var_inner, "size", 1, partcv, params, 0);
  gc_frame_end(callframe667);
// compiled member node returning call668 (depth = 7)
  *var_innerSize = call668;
  if (call668 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if637 = done;
  } else {
  }
// compiled if node returning if637 (depth = 5)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe670 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elt (depth = 6)
  gc_frame_newslot(*var_elt);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inner (depth = 6)
  params[0] = *var_ix;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call671 = callmethodflags(*var_inner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe670);
// compiled call node returning call671 (depth = 5)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num673 = alloc_Float64(1);
// compiled num node returning num673 (depth = 7)
  int op_slot_right_672 = gc_frame_newslot(num673);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_672 = gc_frame_newslot(*var_ix);
  params[0] = num673;
  partcv[0] = 1;
  Object sum675 = callmethod(*var_ix, "+(1)", 1, partcv, params);
// compiled op node returning sum675 (depth = 6)
  *var_ix = sum675;
  if (sum675 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_604_withAll_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sizeCertain = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sizeCertain");
  Object *var_forecastSize = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "forecastSize");
  Object *var_inner = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "inner");
  Object *var_innerSize = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "innerSize");
  Object *var_ix = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ix");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool605 = alloc_Boolean(1);
// compiled identifier node returning bool605 (depth = 3)
  *var_sizeCertain = bool605;
  if (bool605 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe606 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block607 = alloc_Block(NULL, NULL, "collectionsPrelude", 476);
  gc_frame_newslot(block607);
// method "_apply"
  block_savedest(block607);
  Object closure608 = createclosure(2, "_apply");
  setclosureframe(closure608, stackframe);
  addtoclosure(closure608, var_sizeCertain);
  addtoclosure(closure608, selfslot);
  struct UserObject *uo608 = (struct UserObject*)block607;
  uo608->data[0] = (Object)closure608;
  Method *meth_meth_collectionsPrelude_608__apply = addmethod2pos(block607, "_apply", &meth_collectionsPrelude_608__apply, 0);
  int argcv_meth_collectionsPrelude_608__apply[] = {0};
  meth_meth_collectionsPrelude_608__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_608__apply);
  meth_meth_collectionsPrelude_608__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_608__apply->definitionLine = 1769;
// compiled block node returning block607 (depth = 4)
  gc_frame_newslot(block607);
// call case 6: other requests
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  params[0] = block607;
  partcv[0] = 1;
  Object call613 = callmethodflags(*var_arg, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe606);
// compiled call node returning call613 (depth = 3)
  *var_forecastSize = call613;
  if (call613 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe614 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_forecastSize (depth = 4)
  gc_frame_newslot(*var_forecastSize);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe615 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call616 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe615);
// compiled member node returning call616 (depth = 4)
  params[0] = *var_forecastSize;
  partcv[0] = 1;
  Object call617 = callmethodflags(call616, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe614);
// compiled call node returning call617 (depth = 3)
  *var_inner = call617;
  if (call617 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe618 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inner (depth = 4)
  partcv[0] = 0;
  Object call619 = callmethodflags(*var_inner, "size", 1, partcv, params, 0);
  gc_frame_end(callframe618);
// compiled member node returning call619 (depth = 3)
  *var_innerSize = call619;
  if (call619 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num620 = alloc_Float64(0);
// compiled num node returning num620 (depth = 3)
  *var_ix = num620;
  if (num620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sizeCertain (depth = 3)
  Object if621 = done;
  if (istrue(*var_sizeCertain)) {
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe622 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  gc_frame_newslot(*var_arg);
// starting to compile block node (depth = 4)
  Object block623 = alloc_Block(NULL, NULL, "collectionsPrelude", 485);
  gc_frame_newslot(block623);
// method "_apply(_)"
  block_savedest(block623);
  Object closure624 = createclosure(3, "_apply(1)");
  setclosureframe(closure624, stackframe);
  addtoclosure(closure624, var_ix);
  addtoclosure(closure624, var_inner);
  addtoclosure(closure624, selfslot);
  struct UserObject *uo624 = (struct UserObject*)block623;
  uo624->data[0] = (Object)closure624;
  Method *meth_meth_collectionsPrelude_624__apply_40_1_41_ = addmethod2pos(block623, "_apply(1)", &meth_collectionsPrelude_624__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_624__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_624__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_624__apply_40_1_41_);
  meth_meth_collectionsPrelude_624__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_624__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block623 (depth = 4)
  gc_frame_newslot(block623);
// call case 5: prelude request
  params[0] = *var_arg;
  params[1] = block623;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call633 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe622);
// compiled call node returning call633 (depth = 3)
    gc_frame_newslot(call633);
    if621 = call633;
  } else {
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe634 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  gc_frame_newslot(*var_arg);
// starting to compile block node (depth = 4)
  Object block635 = alloc_Block(NULL, NULL, "collectionsPrelude", 491);
  gc_frame_newslot(block635);
// method "_apply(_)"
  block_savedest(block635);
  Object closure636 = createclosure(4, "_apply(1)");
  setclosureframe(closure636, stackframe);
  addtoclosure(closure636, var_ix);
  addtoclosure(closure636, var_innerSize);
  addtoclosure(closure636, var_inner);
  addtoclosure(closure636, selfslot);
  struct UserObject *uo636 = (struct UserObject*)block635;
  uo636->data[0] = (Object)closure636;
  Method *meth_meth_collectionsPrelude_636__apply_40_1_41_ = addmethod2pos(block635, "_apply(1)", &meth_collectionsPrelude_636__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_636__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_636__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_636__apply_40_1_41_);
  meth_meth_collectionsPrelude_636__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_636__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block635 (depth = 4)
  gc_frame_newslot(block635);
// call case 5: prelude request
  params[0] = *var_arg;
  params[1] = block635;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call678 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe634);
// compiled call node returning call678 (depth = 3)
    gc_frame_newslot(call678);
    if621 = call678;
  }
// compiled if node returning if621 (depth = 2)
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num681 = alloc_Float64(0);
// compiled num node returning num681 (depth = 4)
  int op_slot_right_680 = gc_frame_newslot(num681);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ix (depth = 4)
  int op_slot_left_680 = gc_frame_newslot(*var_ix);
  params[0] = num681;
  partcv[0] = 1;
  Object opresult683 = callmethod(*var_ix, "==(1)", 1, partcv, params);
// compiled op node returning opresult683 (depth = 3)
  Object if679 = done;
  if (istrue(opresult683)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_emptySequence (depth = 4)
  return *var_emptySequence;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if679 = undefined;
  } else {
  }
// compiled if node returning if679 (depth = 2)
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe684 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inner (depth = 3)
  gc_frame_newslot(*var_inner);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_inner;
  params[1] = *var_ix;
  partcv[0] = 2;
  Object call685 = callmethodflags(self, "fromprimitiveArray(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe684);
// compiled call node returning call685 (depth = 2)
  gc_frame_end(frame);
  return call685;
}
Object meth_collectionsPrelude_691_boundsCheck_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method boundsCheck(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for boundsCheck(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part boundsCheck(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe694 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe696 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call697 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe696);
// compiled member node returning call697 (depth = 6)
  int op_slot_right_695 = gc_frame_newslot(call697);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_695 = gc_frame_newslot(*var_n);
  params[0] = call697;
  partcv[0] = 1;
  Object opresult699 = callmethod(*var_n, "≤(1)", 1, partcv, params);
// compiled op node returning opresult699 (depth = 5)
  partcv[0] = 0;
  Object call700 = callmethodflags(opresult699, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe694);
// compiled call node returning call700 (depth = 4)
  int op_slot_right_693 = gc_frame_newslot(call700);
// starting to compile call node (depth = 4)
  int callframe702 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num704 = alloc_Float64(1);
// compiled num node returning num704 (depth = 6)
  int op_slot_right_703 = gc_frame_newslot(num704);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_703 = gc_frame_newslot(*var_n);
  params[0] = num704;
  partcv[0] = 1;
  Object opresult706 = callmethod(*var_n, "≥(1)", 1, partcv, params);
// compiled op node returning opresult706 (depth = 5)
  partcv[0] = 0;
  Object call707 = callmethodflags(opresult706, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe702);
// compiled call node returning call707 (depth = 4)
  int op_slot_left_693 = gc_frame_newslot(call707);
  params[0] = call700;
  partcv[0] = 1;
  Object opresult708 = callmethod(call707, "||(1)", 1, partcv, params);
// compiled op node returning opresult708 (depth = 3)
  Object if692 = done;
  if (istrue(opresult708)) {
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe709 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit711 == NULL) {
    strlit711 = alloc_String("");
    gc_root(strlit711);
  }
// compiled string node returning strlit711 (depth = 5)
  int op_slot_right_710 = gc_frame_newslot(strlit711);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe714 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call715 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe714);
// compiled member node returning call715 (depth = 6)
  int op_slot_right_713 = gc_frame_newslot(call715);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit718 == NULL) {
    strlit718 = alloc_String(" out of bounds 1..");
    gc_root(strlit718);
  }
// compiled string node returning strlit718 (depth = 7)
  int op_slot_right_717 = gc_frame_newslot(strlit718);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_720 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 8)
  if (strlit722 == NULL) {
    strlit722 = alloc_String("index ");
    gc_root(strlit722);
  }
// compiled string node returning strlit722 (depth = 8)
  int op_slot_left_720 = gc_frame_newslot(strlit722);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult723 = callmethod(strlit722, "++(1)", 1, partcv, params);
// compiled op node returning opresult723 (depth = 7)
  int op_slot_left_717 = gc_frame_newslot(opresult723);
  params[0] = strlit718;
  partcv[0] = 1;
  Object opresult724 = callmethod(opresult723, "++(1)", 1, partcv, params);
// compiled op node returning opresult724 (depth = 6)
  int op_slot_left_713 = gc_frame_newslot(opresult724);
  params[0] = call715;
  partcv[0] = 1;
  Object opresult725 = callmethod(opresult724, "++(1)", 1, partcv, params);
// compiled op node returning opresult725 (depth = 5)
  int op_slot_left_710 = gc_frame_newslot(opresult725);
  params[0] = strlit711;
  partcv[0] = 1;
  Object opresult726 = callmethod(opresult725, "++(1)", 1, partcv, params);
// compiled op node returning opresult726 (depth = 4)
  gc_frame_newslot(opresult726);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult726;
  partcv[0] = 1;
  Object call727 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe709);
// compiled call node returning call727 (depth = 3)
    gc_frame_newslot(call727);
    if692 = call727;
  } else {
  }
// compiled if node returning if692 (depth = 2)
  gc_frame_end(frame);
  return if692;
}
Object meth_collectionsPrelude_728_at_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe729 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call730 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe729);
// compiled call node returning call730 (depth = 2)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe731 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num733 = alloc_Float64(1);
// compiled num node returning num733 (depth = 4)
  int op_slot_right_732 = gc_frame_newslot(num733);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_732 = gc_frame_newslot(*var_n);
  params[0] = num733;
  partcv[0] = 1;
  Object diff735 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff735 (depth = 3)
  gc_frame_newslot(diff735);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe736 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call737 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe736);
// compiled member node returning call737 (depth = 3)
  params[0] = diff735;
  partcv[0] = 1;
  Object call738 = callmethodflags(call737, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe731);
// compiled call node returning call738 (depth = 2)
  gc_frame_end(frame);
  return call738;
}
Object meth_collectionsPrelude_739_keys(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe740 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num741 = alloc_Float64(1);
// compiled num node returning num741 (depth = 3)
  gc_frame_newslot(num741);
// starting to compile member node (depth = 3)
  int callframe742 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call743 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe742);
// compiled member node returning call743 (depth = 3)
  gc_frame_newslot(call743);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe744 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  partcv[0] = 0;
  Object call745 = callmethodflags(module_collectionsPrelude, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe744);
// compiled member node returning call745 (depth = 3)
  params[0] = num741;
  params[1] = call743;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call746 = callmethodflags(call745, "from(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe740);
// compiled call node returning call746 (depth = 2)
  gc_frame_end(frame);
  return call746;
}
Object meth_collectionsPrelude_747_values(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_752__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe754 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call755 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe754);
// compiled member node returning call755 (depth = 5)
  int op_slot_right_753 = gc_frame_newslot(call755);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_753 = gc_frame_newslot(*var_i);
  params[0] = call755;
  partcv[0] = 1;
  Object opresult757 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult757 (depth = 4)
  gc_frame_end(frame);
  return opresult757;
}
Object meth_collectionsPrelude_760__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block2 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe761 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num763 = alloc_Float64(1);
// compiled num node returning num763 (depth = 6)
  int op_slot_right_762 = gc_frame_newslot(num763);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_762 = gc_frame_newslot(*var_i);
  params[0] = num763;
  partcv[0] = 1;
  Object sum765 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum765 (depth = 5)
  gc_frame_newslot(sum765);
// starting to compile call node (depth = 5)
  int callframe766 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe767 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call768 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe767);
// compiled member node returning call768 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call769 = callmethodflags(call768, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe766);
// compiled call node returning call769 (depth = 5)
  gc_frame_newslot(call769);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = sum765;
  params[1] = call769;
  partcv[0] = 2;
  Object call770 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe761);
// compiled call node returning call770 (depth = 4)
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num772 = alloc_Float64(1);
// compiled num node returning num772 (depth = 6)
  int op_slot_right_771 = gc_frame_newslot(num772);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_771 = gc_frame_newslot(*var_i);
  params[0] = num772;
  partcv[0] = 1;
  Object sum774 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum774 (depth = 5)
  *var_i = sum774;
  if (sum774 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num749 = alloc_Float64(0);
// compiled num node returning num749 (depth = 3)
  *var_i = num749;
  if (num749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe750 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block751 = alloc_Block(NULL, NULL, "collectionsPrelude", 534);
  gc_frame_newslot(block751);
// method "_apply"
  block_savedest(block751);
  Object closure752 = createclosure(2, "_apply");
  setclosureframe(closure752, stackframe);
  addtoclosure(closure752, var_i);
  addtoclosure(closure752, selfslot);
  struct UserObject *uo752 = (struct UserObject*)block751;
  uo752->data[0] = (Object)closure752;
  Method *meth_meth_collectionsPrelude_752__apply = addmethod2pos(block751, "_apply", &meth_collectionsPrelude_752__apply, 0);
  int argcv_meth_collectionsPrelude_752__apply[] = {0};
  meth_meth_collectionsPrelude_752__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_752__apply);
  meth_meth_collectionsPrelude_752__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_752__apply->definitionLine = 1769;
// compiled block node returning block751 (depth = 3)
  gc_frame_newslot(block751);
// starting to compile block node (depth = 3)
  Object block759 = alloc_Block(NULL, NULL, "collectionsPrelude", 534);
  gc_frame_newslot(block759);
// method "_apply"
  block_savedest(block759);
  Object closure760 = createclosure(3, "_apply");
  setclosureframe(closure760, stackframe);
  addtoclosure(closure760, var_i);
  addtoclosure(closure760, var_block2);
  addtoclosure(closure760, selfslot);
  struct UserObject *uo760 = (struct UserObject*)block759;
  uo760->data[0] = (Object)closure760;
  Method *meth_meth_collectionsPrelude_760__apply = addmethod2pos(block759, "_apply", &meth_collectionsPrelude_760__apply, 0);
  int argcv_meth_collectionsPrelude_760__apply[] = {0};
  meth_meth_collectionsPrelude_760__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_760__apply);
  meth_meth_collectionsPrelude_760__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_760__apply->definitionLine = 1769;
// compiled block node returning block759 (depth = 3)
  gc_frame_newslot(block759);
// call case 5: prelude request
  params[0] = block751;
  params[1] = block759;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call777 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe750);
// compiled call node returning call777 (depth = 2)
  gc_frame_end(frame);
  return call777;
}
Object meth_collectionsPrelude_793__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_freshArray = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe794 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_freshArray (depth = 5)
  params[0] = *var_ix;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call795 = callmethodflags(*var_freshArray, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe794);
// compiled call node returning call795 (depth = 4)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num797 = alloc_Float64(1);
// compiled num node returning num797 (depth = 6)
  int op_slot_right_796 = gc_frame_newslot(num797);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_796 = gc_frame_newslot(*var_ix);
  params[0] = num797;
  partcv[0] = 1;
  Object diff799 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff799 (depth = 5)
  *var_ix = diff799;
  if (diff799 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_778_reversed(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_freshArray = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "freshArray");
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe779 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe780 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call781 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe780);
// compiled member node returning call781 (depth = 4)
  gc_frame_newslot(call781);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe782 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call783 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe782);
// compiled member node returning call783 (depth = 4)
  params[0] = call781;
  partcv[0] = 1;
  Object call784 = callmethodflags(call783, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe779);
// compiled call node returning call784 (depth = 3)
  *var_freshArray = call784;
  if (call784 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num786 = alloc_Float64(1);
// compiled num node returning num786 (depth = 4)
  int op_slot_right_785 = gc_frame_newslot(num786);
// starting to compile member node (depth = 4)
  int callframe788 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call789 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe788);
// compiled member node returning call789 (depth = 4)
  int op_slot_left_785 = gc_frame_newslot(call789);
  params[0] = num786;
  partcv[0] = 1;
  Object diff790 = callmethod(call789, "-(1)", 1, partcv, params);
// compiled op node returning diff790 (depth = 3)
  *var_ix = diff790;
  if (diff790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe791 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block792 = alloc_Block(NULL, NULL, "collectionsPrelude", 542);
  gc_frame_newslot(block792);
// method "_apply(_)"
  block_savedest(block792);
  Object closure793 = createclosure(3, "_apply(1)");
  setclosureframe(closure793, stackframe);
  addtoclosure(closure793, var_ix);
  addtoclosure(closure793, var_freshArray);
  addtoclosure(closure793, selfslot);
  struct UserObject *uo793 = (struct UserObject*)block792;
  uo793->data[0] = (Object)closure793;
  Method *meth_meth_collectionsPrelude_793__apply_40_1_41_ = addmethod2pos(block792, "_apply(1)", &meth_collectionsPrelude_793__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_793__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_793__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_793__apply_40_1_41_);
  meth_meth_collectionsPrelude_793__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_793__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block792 (depth = 3)
  gc_frame_newslot(block792);
// call case 4: self request
  params[0] = block792;
  partcv[0] = 1;
  Object call802 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe791);
// compiled call node returning call802 (depth = 2)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe803 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_freshArray (depth = 3)
  gc_frame_newslot(*var_freshArray);
// starting to compile member node (depth = 3)
  int callframe804 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call805 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe804);
// compiled member node returning call805 (depth = 3)
  gc_frame_newslot(call805);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe806 = gc_frame_new();
// call case 3: self.outer request
  Object call807 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe806);
// compiled member node returning call807 (depth = 3)
  params[0] = *var_freshArray;
  params[1] = call805;
  partcv[0] = 2;
  Object call808 = callmethodflags(call807, "fromprimitiveArray(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe803);
// compiled call node returning call808 (depth = 2)
  gc_frame_end(frame);
  return call808;
}
Object meth_collectionsPrelude_809__43__43__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe810 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe811 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call812 = callmethodflags(module_collectionsPrelude, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe811);
// compiled call node returning call812 (depth = 3)
  gc_frame_newslot(call812);
// call case 6: other requests
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe813 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  partcv[0] = 0;
  Object call814 = callmethodflags(module_collectionsPrelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe813);
// compiled member node returning call814 (depth = 3)
  params[0] = call812;
  partcv[0] = 1;
  Object call815 = callmethodflags(call814, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe810);
// compiled call node returning call815 (depth = 2)
  gc_frame_end(frame);
  return call815;
}
Object meth_collectionsPrelude_830__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe832 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe833 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe834 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call835 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe834);
// compiled member node returning call835 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call836 = callmethodflags(call835, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe833);
// compiled call node returning call836 (depth = 7)
  partcv[0] = 0;
  Object call837 = callmethodflags(call836, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe832);
// compiled member node returning call837 (depth = 6)
  int op_slot_right_831 = gc_frame_newslot(call837);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_831 = gc_frame_newslot(*var_s);
  params[0] = call837;
  partcv[0] = 1;
  Object opresult839 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult839 (depth = 5)
  *var_s = opresult839;
  if (opresult839 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num844 = alloc_Float64(1);
// compiled num node returning num844 (depth = 7)
  int op_slot_right_843 = gc_frame_newslot(num844);
// starting to compile member node (depth = 7)
  int callframe846 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call847 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe846);
// compiled member node returning call847 (depth = 7)
  int op_slot_left_843 = gc_frame_newslot(call847);
  params[0] = num844;
  partcv[0] = 1;
  Object diff848 = callmethod(call847, "-(1)", 1, partcv, params);
// compiled op node returning diff848 (depth = 6)
  int op_slot_right_842 = gc_frame_newslot(diff848);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_842 = gc_frame_newslot(*var_i);
  params[0] = diff848;
  partcv[0] = 1;
  Object opresult850 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult850 (depth = 5)
  Object if841 = done;
  if (istrue(opresult850)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit852 == NULL) {
    strlit852 = alloc_String(", ");
    gc_root(strlit852);
  }
// compiled string node returning strlit852 (depth = 7)
  int op_slot_right_851 = gc_frame_newslot(strlit852);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_851 = gc_frame_newslot(*var_s);
  params[0] = strlit852;
  partcv[0] = 1;
  Object opresult854 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult854 (depth = 6)
  *var_s = opresult854;
  if (opresult854 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if841 = done;
  } else {
  }
// compiled if node returning if841 (depth = 4)
  gc_frame_end(frame);
  return if841;
}
Object meth_collectionsPrelude_816_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit817 == NULL) {
    strlit817 = alloc_String("""\xe2""""\x9f""""\xa8""");
    gc_root(strlit817);
  }
// compiled string node returning strlit817 (depth = 3)
  *var_s = strlit817;
  if (strlit817 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe818 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num821 = alloc_Float64(1);
// compiled num node returning num821 (depth = 5)
  int op_slot_right_820 = gc_frame_newslot(num821);
// starting to compile member node (depth = 5)
  int callframe823 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call824 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe823);
// compiled member node returning call824 (depth = 5)
  int op_slot_left_820 = gc_frame_newslot(call824);
  params[0] = num821;
  partcv[0] = 1;
  Object diff825 = callmethod(call824, "-(1)", 1, partcv, params);
// compiled op node returning diff825 (depth = 4)
  int op_slot_right_819 = gc_frame_newslot(diff825);
// starting to compile num node (depth = 4)
  Object num827 = alloc_Float64(0);
// compiled num node returning num827 (depth = 4)
  int op_slot_left_819 = gc_frame_newslot(num827);
  params[0] = diff825;
  partcv[0] = 1;
  Object opresult828 = callmethod(num827, "..(1)", 1, partcv, params);
// compiled op node returning opresult828 (depth = 3)
  gc_frame_newslot(opresult828);
// starting to compile block node (depth = 3)
  Object block829 = alloc_Block(NULL, NULL, "collectionsPrelude", 553);
  gc_frame_newslot(block829);
// method "_apply(_)"
  block_savedest(block829);
  Object closure830 = createclosure(2, "_apply(1)");
  setclosureframe(closure830, stackframe);
  addtoclosure(closure830, var_s);
  addtoclosure(closure830, selfslot);
  struct UserObject *uo830 = (struct UserObject*)block829;
  uo830->data[0] = (Object)closure830;
  Method *meth_meth_collectionsPrelude_830__apply_40_1_41_ = addmethod2pos(block829, "_apply(1)", &meth_collectionsPrelude_830__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_830__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_830__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_830__apply_40_1_41_);
  meth_meth_collectionsPrelude_830__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_830__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block829 (depth = 3)
  gc_frame_newslot(block829);
// call case 5: prelude request
  params[0] = opresult828;
  params[1] = block829;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call857 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe818);
// compiled call node returning call857 (depth = 2)
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit859 == NULL) {
    strlit859 = alloc_String("""\xe2""""\x9f""""\xa9""");
    gc_root(strlit859);
  }
// compiled string node returning strlit859 (depth = 3)
  int op_slot_right_858 = gc_frame_newslot(strlit859);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_858 = gc_frame_newslot(*var_s);
  params[0] = strlit859;
  partcv[0] = 1;
  Object opresult861 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult861 (depth = 2)
  gc_frame_end(frame);
  return opresult861;
}
Object meth_collectionsPrelude_865__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_element (depth = 6)
  int op_slot_right_867 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_867 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult869 = callmethod(*var_each, "==(1)", 1, partcv, params);
// compiled op node returning opresult869 (depth = 5)
  Object if866 = done;
  if (istrue(opresult869)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool870 = alloc_Boolean(1);
// compiled identifier node returning bool870 (depth = 6)
  block_return(realself, bool870);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if866 = undefined;
  } else {
  }
// compiled if node returning if866 (depth = 4)
  gc_frame_end(frame);
  return if866;
}
Object meth_collectionsPrelude_862_contains_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe863 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block864 = alloc_Block(NULL, NULL, "collectionsPrelude", 560);
  gc_frame_newslot(block864);
// method "_apply(_)"
  block_savedest(block864);
  Object closure865 = createclosure(2, "_apply(1)");
  setclosureframe(closure865, stackframe);
  addtoclosure(closure865, var_element);
  addtoclosure(closure865, selfslot);
  struct UserObject *uo865 = (struct UserObject*)block864;
  uo865->data[0] = (Object)closure865;
  Method *meth_meth_collectionsPrelude_865__apply_40_1_41_ = addmethod2pos(block864, "_apply(1)", &meth_collectionsPrelude_865__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_865__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_865__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_865__apply_40_1_41_);
  meth_meth_collectionsPrelude_865__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_865__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block864 (depth = 3)
  gc_frame_newslot(block864);
// call case 4: self request
  params[0] = block864;
  partcv[0] = 1;
  Object call872 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe863);
// compiled call node returning call872 (depth = 2)
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool873 = alloc_Boolean(0);
// compiled identifier node returning bool873 (depth = 3)
  return bool873;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_878__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe880 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call881 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe880);
// compiled member node returning call881 (depth = 5)
  int op_slot_right_879 = gc_frame_newslot(call881);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_879 = gc_frame_newslot(*var_i);
  params[0] = call881;
  partcv[0] = 1;
  Object opresult883 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult883 (depth = 4)
  gc_frame_end(frame);
  return opresult883;
}
Object meth_collectionsPrelude_886__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe887 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe888 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe889 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call890 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe889);
// compiled member node returning call890 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call891 = callmethodflags(call890, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe888);
// compiled call node returning call891 (depth = 5)
  gc_frame_newslot(call891);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call891;
  partcv[0] = 1;
  Object call892 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe887);
// compiled call node returning call892 (depth = 4)
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num894 = alloc_Float64(1);
// compiled num node returning num894 (depth = 6)
  int op_slot_right_893 = gc_frame_newslot(num894);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_893 = gc_frame_newslot(*var_i);
  params[0] = num894;
  partcv[0] = 1;
  Object sum896 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum896 (depth = 5)
  *var_i = sum896;
  if (sum896 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_874_do_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num875 = alloc_Float64(0);
// compiled num node returning num875 (depth = 3)
  *var_i = num875;
  if (num875 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe876 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block877 = alloc_Block(NULL, NULL, "collectionsPrelude", 565);
  gc_frame_newslot(block877);
// method "_apply"
  block_savedest(block877);
  Object closure878 = createclosure(2, "_apply");
  setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_i);
  addtoclosure(closure878, selfslot);
  struct UserObject *uo878 = (struct UserObject*)block877;
  uo878->data[0] = (Object)closure878;
  Method *meth_meth_collectionsPrelude_878__apply = addmethod2pos(block877, "_apply", &meth_collectionsPrelude_878__apply, 0);
  int argcv_meth_collectionsPrelude_878__apply[] = {0};
  meth_meth_collectionsPrelude_878__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_878__apply);
  meth_meth_collectionsPrelude_878__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_878__apply->definitionLine = 1769;
// compiled block node returning block877 (depth = 3)
  gc_frame_newslot(block877);
// starting to compile block node (depth = 3)
  Object block885 = alloc_Block(NULL, NULL, "collectionsPrelude", 565);
  gc_frame_newslot(block885);
// method "_apply"
  block_savedest(block885);
  Object closure886 = createclosure(3, "_apply");
  setclosureframe(closure886, stackframe);
  addtoclosure(closure886, var_i);
  addtoclosure(closure886, var_block1);
  addtoclosure(closure886, selfslot);
  struct UserObject *uo886 = (struct UserObject*)block885;
  uo886->data[0] = (Object)closure886;
  Method *meth_meth_collectionsPrelude_886__apply = addmethod2pos(block885, "_apply", &meth_collectionsPrelude_886__apply, 0);
  int argcv_meth_collectionsPrelude_886__apply[] = {0};
  meth_meth_collectionsPrelude_886__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_886__apply);
  meth_meth_collectionsPrelude_886__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_886__apply->definitionLine = 1769;
// compiled block node returning block885 (depth = 3)
  gc_frame_newslot(block885);
// call case 5: prelude request
  params[0] = block877;
  params[1] = block885;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call899 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe876);
// compiled call node returning call899 (depth = 2)
  gc_frame_end(frame);
  return call899;
}
Object meth_collectionsPrelude_900__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe901 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call902 = callmethodflags(module_collectionsPrelude, "isEqual(1)toCollection(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe901);
// compiled call node returning call902 (depth = 2)
  gc_frame_end(frame);
  return call902;
}
Object meth_collectionsPrelude_907_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit909 == NULL) {
    strlit909 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit909);
  }
// compiled string node returning strlit909 (depth = 3)
  int op_slot_right_908 = gc_frame_newslot(strlit909);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe912 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call913 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe912);
// compiled member node returning call913 (depth = 4)
  int op_slot_right_911 = gc_frame_newslot(call913);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit916 == NULL) {
    strlit916 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit916);
  }
// compiled string node returning strlit916 (depth = 5)
  int op_slot_right_915 = gc_frame_newslot(strlit916);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe919 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call920 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe919);
// compiled member node returning call920 (depth = 6)
  int op_slot_right_918 = gc_frame_newslot(call920);
// starting to compile string node (depth = 6)
  if (strlit922 == NULL) {
    strlit922 = alloc_String("");
    gc_root(strlit922);
  }
// compiled string node returning strlit922 (depth = 6)
  int op_slot_left_918 = gc_frame_newslot(strlit922);
  params[0] = call920;
  partcv[0] = 1;
  Object opresult923 = callmethod(strlit922, "++(1)", 1, partcv, params);
// compiled op node returning opresult923 (depth = 5)
  int op_slot_left_915 = gc_frame_newslot(opresult923);
  params[0] = strlit916;
  partcv[0] = 1;
  Object opresult924 = callmethod(opresult923, "++(1)", 1, partcv, params);
// compiled op node returning opresult924 (depth = 4)
  int op_slot_left_911 = gc_frame_newslot(opresult924);
  params[0] = call913;
  partcv[0] = 1;
  Object opresult925 = callmethod(opresult924, "++(1)", 1, partcv, params);
// compiled op node returning opresult925 (depth = 3)
  int op_slot_left_908 = gc_frame_newslot(opresult925);
  params[0] = strlit909;
  partcv[0] = 1;
  Object opresult926 = callmethod(opresult925, "++(1)", 1, partcv, params);
// compiled op node returning opresult926 (depth = 2)
  gc_frame_end(frame);
  return opresult926;
}
Object meth_collectionsPrelude_927_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit928 == NULL) {
    strlit928 = alloc_String("aSequenceIterator");
    gc_root(strlit928);
  }
// compiled string node returning strlit928 (depth = 2)
  gc_frame_end(frame);
  return strlit928;
}
Object meth_collectionsPrelude_929_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_930 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
  int callframe932 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call933 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe932);
// compiled member node returning call933 (depth = 3)
  int op_slot_left_930 = gc_frame_newslot(call933);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult934 = callmethod(call933, "≤(1)", 1, partcv, params);
// compiled op node returning opresult934 (depth = 2)
  gc_frame_end(frame);
  return opresult934;
}
Object meth_collectionsPrelude_935_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_937 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
  int callframe939 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call940 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe939);
// compiled member node returning call940 (depth = 4)
  int op_slot_left_937 = gc_frame_newslot(call940);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult941 = callmethod(call940, ">(1)", 1, partcv, params);
// compiled op node returning opresult941 (depth = 3)
  Object if936 = done;
  if (istrue(opresult941)) {
// starting to compile call node (depth = 3)
  int callframe942 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit944 == NULL) {
    strlit944 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit944);
  }
// compiled string node returning strlit944 (depth = 5)
  int op_slot_right_943 = gc_frame_newslot(strlit944);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe947 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call948 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe947);
// compiled member node returning call948 (depth = 6)
  int op_slot_right_946 = gc_frame_newslot(call948);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit951 == NULL) {
    strlit951 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit951);
  }
// compiled string node returning strlit951 (depth = 7)
  int op_slot_right_950 = gc_frame_newslot(strlit951);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe954 = gc_frame_new();
// call case 3: self.outer request
  Object call955 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe954);
// compiled member node returning call955 (depth = 8)
  int op_slot_right_953 = gc_frame_newslot(call955);
// starting to compile string node (depth = 8)
  if (strlit957 == NULL) {
    strlit957 = alloc_String("on sequence ");
    gc_root(strlit957);
  }
// compiled string node returning strlit957 (depth = 8)
  int op_slot_left_953 = gc_frame_newslot(strlit957);
  params[0] = call955;
  partcv[0] = 1;
  Object opresult958 = callmethod(strlit957, "++(1)", 1, partcv, params);
// compiled op node returning opresult958 (depth = 7)
  int op_slot_left_950 = gc_frame_newslot(opresult958);
  params[0] = strlit951;
  partcv[0] = 1;
  Object opresult959 = callmethod(opresult958, "++(1)", 1, partcv, params);
// compiled op node returning opresult959 (depth = 6)
  int op_slot_left_946 = gc_frame_newslot(opresult959);
  params[0] = call948;
  partcv[0] = 1;
  Object opresult960 = callmethod(opresult959, "++(1)", 1, partcv, params);
// compiled op node returning opresult960 (depth = 5)
  int op_slot_left_943 = gc_frame_newslot(opresult960);
  params[0] = strlit944;
  partcv[0] = 1;
  Object opresult961 = callmethod(opresult960, "++(1)", 1, partcv, params);
// compiled op node returning opresult961 (depth = 4)
  gc_frame_newslot(opresult961);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult961;
  partcv[0] = 1;
  Object call962 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe942);
// compiled call node returning call962 (depth = 3)
    gc_frame_newslot(call962);
    if936 = call962;
  } else {
  }
// compiled if node returning if936 (depth = 2)
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe963 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe964 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call965 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe964);
// compiled member node returning call965 (depth = 4)
  gc_frame_newslot(call965);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe966 = gc_frame_new();
// call case 3: self.outer request
  Object call967 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe966);
// compiled member node returning call967 (depth = 4)
  params[0] = call965;
  partcv[0] = 1;
  Object call968 = callmethodflags(call967, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe963);
// compiled call node returning call968 (depth = 3)
  *var_ret = call968;
  if (call968 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe969 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num971 = alloc_Float64(1);
// compiled num node returning num971 (depth = 4)
  int op_slot_right_970 = gc_frame_newslot(num971);
// starting to compile member node (depth = 4)
  int callframe973 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call974 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe973);
// compiled member node returning call974 (depth = 4)
  int op_slot_left_970 = gc_frame_newslot(call974);
  params[0] = num971;
  partcv[0] = 1;
  Object sum975 = callmethod(call974, "+(1)", 1, partcv, params);
// compiled op node returning sum975 (depth = 3)
  gc_frame_newslot(sum975);
// call case 4: self request
  params[0] = sum975;
  partcv[0] = 1;
  Object call976 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe969);
// compiled call node returning call976 (depth = 2)
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_903_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject904 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj904 = alloc_userobj2(6,6, objclass904);
  gc_frame_newslot(obj904);
  if (objclass904 == NULL) {
    glfree(obj904->class->name);
    obj904->class->name = "sequence.fromprimitiveArray(_,_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj904, self, 0);
  addmethodreal(obj904,"outer", &reader_collectionsPrelude_outer_905);
  Object oldself904 = self;
  struct StackFrameObject *oldstackframe904 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe904);
  gc_frame_newslot((Object)stackframe);
  self = obj904;
  Object *oldselfslot904 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter904 = (*(struct UserObject *)self).data[0], lowerouter904 = thisouter904;
  if (inheritingObject904) {
    struct UserObject *inho904 = (struct UserObject *)inheritingObject904;
    while (inho904->super != GraceDefaultObject) inho904 = (struct UserObject *)inho904->super;
    inho904->super = obj904;
    self = inheritingObject904;
    *selfslot = self;
    lowerouter904 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter904;
  }
  if (objclass904 == NULL) {
    Method *reader906 = addmethodrealflags(obj904, "idx", &reader_collectionsPrelude_idx_906, MFLAG_CONFIDENTIAL);
    Method *writer906 = addmethodrealflags(obj904, "idx:=(1)", &writer_collectionsPrelude_idx_906, MFLAG_CONFIDENTIAL);
    reader906->definitionModule = modulename;
    writer906->definitionModule = modulename;
    reader906->definitionLine = 575;
    writer906->definitionLine = 575;
  }
  obj904->flags |= OFLAG_MUTABLE;
  adddatum2(obj904, alloc_Undefined(), 1);
// method "asDebugString"
  struct UserObject *uo907 = (struct UserObject*)obj904;
  uo907->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_907_asDebugString = addmethod2pos(obj904, "asDebugString", &meth_collectionsPrelude_907_asDebugString, 2);
  int argcv_meth_collectionsPrelude_907_asDebugString[] = {0};
  meth_meth_collectionsPrelude_907_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_907_asDebugString);
  meth_meth_collectionsPrelude_907_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_907_asDebugString->definitionLine = 576;
// method "asString"
  struct UserObject *uo927 = (struct UserObject*)obj904;
  uo927->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_927_asString = addmethod2pos(obj904, "asString", &meth_collectionsPrelude_927_asString, 3);
  int argcv_meth_collectionsPrelude_927_asString[] = {0};
  meth_meth_collectionsPrelude_927_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_927_asString);
  meth_meth_collectionsPrelude_927_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_927_asString->definitionLine = 577;
// method "hasNext"
  block_savedest(obj904);
  Object closure929 = createclosure(1, "hasNext");
  setclosureframe(closure929, stackframe);
  addtoclosure(closure929, var_sz);
  struct UserObject *uo929 = (struct UserObject*)obj904;
  uo929->data[4] = (Object)closure929;
  Method *meth_meth_collectionsPrelude_929_hasNext = addmethod2pos(obj904, "hasNext", &meth_collectionsPrelude_929_hasNext, 4);
  int argcv_meth_collectionsPrelude_929_hasNext[] = {0};
  meth_meth_collectionsPrelude_929_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_929_hasNext);
  meth_meth_collectionsPrelude_929_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_929_hasNext->definitionLine = 578;
// method "next"
  block_savedest(obj904);
  Object closure935 = createclosure(2, "next");
  setclosureframe(closure935, stackframe);
  addtoclosure(closure935, var_sz);
  addtoclosure(closure935, var_IteratorExhausted);
  struct UserObject *uo935 = (struct UserObject*)obj904;
  uo935->data[5] = (Object)closure935;
  Method *meth_meth_collectionsPrelude_935_next = addmethod2pos(obj904, "next", &meth_collectionsPrelude_935_next, 5);
  int argcv_meth_collectionsPrelude_935_next[] = {0};
  meth_meth_collectionsPrelude_935_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_935_next);
  meth_meth_collectionsPrelude_935_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_935_next->definitionLine = 579;
  sourceObject = obj904;
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num977 = alloc_Float64(1);
// compiled num node returning num977 (depth = 2)
  adddatum2(obj904, num977, 1);
  sourceObject = obj904;
  sourceObject = obj904;
  sourceObject = obj904;
  sourceObject = obj904;
  objclass904 = obj904->class;
  objclass904->definitionModule = modulename;
  objclass904->definitionLine = 574;
  (*(struct UserObject *)self).data[0] = lowerouter904;
  self = oldself904;
  selfslot = oldselfslot904;
  stackframe = oldstackframe904;
  gc_frame_end(frame);
  return obj904;
}
Object meth_collectionsPrelude_903_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject904 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj904 = alloc_userobj2(6,6, objclass904);
  gc_frame_newslot(obj904);
  if (objclass904 == NULL) {
    glfree(obj904->class->name);
    obj904->class->name = "sequence.fromprimitiveArray(_,_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj904, self, 0);
  addmethodreal(obj904,"outer", &reader_collectionsPrelude_outer_905);
  Object oldself904 = self;
  struct StackFrameObject *oldstackframe904 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe904);
  gc_frame_newslot((Object)stackframe);
  self = obj904;
  Object *oldselfslot904 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter904 = (*(struct UserObject *)self).data[0], lowerouter904 = thisouter904;
  if (inheritingObject904) {
    struct UserObject *inho904 = (struct UserObject *)inheritingObject904;
    while (inho904->super != GraceDefaultObject) inho904 = (struct UserObject *)inho904->super;
    inho904->super = obj904;
    self = inheritingObject904;
    *selfslot = self;
    lowerouter904 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter904;
  }
  if (objclass904 == NULL) {
    Method *reader906 = addmethodrealflags(obj904, "idx", &reader_collectionsPrelude_idx_906, MFLAG_CONFIDENTIAL);
    Method *writer906 = addmethodrealflags(obj904, "idx:=(1)", &writer_collectionsPrelude_idx_906, MFLAG_CONFIDENTIAL);
    reader906->definitionModule = modulename;
    writer906->definitionModule = modulename;
    reader906->definitionLine = 575;
    writer906->definitionLine = 575;
  }
  obj904->flags |= OFLAG_MUTABLE;
  adddatum2(obj904, alloc_Undefined(), 1);
// method "asDebugString"
  struct UserObject *uo907 = (struct UserObject*)obj904;
  uo907->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_907_asDebugString = addmethod2pos(obj904, "asDebugString", &meth_collectionsPrelude_907_asDebugString, 2);
  int argcv_meth_collectionsPrelude_907_asDebugString[] = {0};
  meth_meth_collectionsPrelude_907_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_907_asDebugString);
  meth_meth_collectionsPrelude_907_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_907_asDebugString->definitionLine = 576;
// method "asString"
  struct UserObject *uo927 = (struct UserObject*)obj904;
  uo927->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_927_asString = addmethod2pos(obj904, "asString", &meth_collectionsPrelude_927_asString, 3);
  int argcv_meth_collectionsPrelude_927_asString[] = {0};
  meth_meth_collectionsPrelude_927_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_927_asString);
  meth_meth_collectionsPrelude_927_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_927_asString->definitionLine = 577;
// method "hasNext"
  block_savedest(obj904);
  Object closure929 = createclosure(1, "hasNext");
  setclosureframe(closure929, stackframe);
  addtoclosure(closure929, var_sz);
  struct UserObject *uo929 = (struct UserObject*)obj904;
  uo929->data[4] = (Object)closure929;
  Method *meth_meth_collectionsPrelude_929_hasNext = addmethod2pos(obj904, "hasNext", &meth_collectionsPrelude_929_hasNext, 4);
  int argcv_meth_collectionsPrelude_929_hasNext[] = {0};
  meth_meth_collectionsPrelude_929_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_929_hasNext);
  meth_meth_collectionsPrelude_929_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_929_hasNext->definitionLine = 578;
// method "next"
  block_savedest(obj904);
  Object closure935 = createclosure(2, "next");
  setclosureframe(closure935, stackframe);
  addtoclosure(closure935, var_sz);
  addtoclosure(closure935, var_IteratorExhausted);
  struct UserObject *uo935 = (struct UserObject*)obj904;
  uo935->data[5] = (Object)closure935;
  Method *meth_meth_collectionsPrelude_935_next = addmethod2pos(obj904, "next", &meth_collectionsPrelude_935_next, 5);
  int argcv_meth_collectionsPrelude_935_next[] = {0};
  meth_meth_collectionsPrelude_935_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_935_next);
  meth_meth_collectionsPrelude_935_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_935_next->definitionLine = 579;
  sourceObject = obj904;
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num977 = alloc_Float64(1);
// compiled num node returning num977 (depth = 2)
  adddatum2(obj904, num977, 1);
  sourceObject = obj904;
  sourceObject = obj904;
  sourceObject = obj904;
  sourceObject = obj904;
  objclass904 = obj904->class;
  objclass904->definitionModule = modulename;
  objclass904->definitionLine = 574;
  (*(struct UserObject *)self).data[0] = lowerouter904;
  self = oldself904;
  selfslot = oldselfslot904;
  stackframe = oldstackframe904;
  gc_frame_end(frame);
  return obj904;
}
Object meth_collectionsPrelude_983__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  int op_slot_right_985 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  int op_slot_left_985 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult987 = callmethod(*var_l, "==(1)", 1, partcv, params);
// compiled op node returning opresult987 (depth = 6)
  Object if984 = done;
  if (istrue(opresult987)) {
// starting to compile num node (depth = 6)
  Object num988 = alloc_Float64(0);
// compiled num node returning num988 (depth = 6)
    gc_frame_newslot(num988);
    if984 = num988;
  } else {
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_r (depth = 8)
  int op_slot_right_990 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_l (depth = 8)
  int op_slot_left_990 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult992 = callmethod(*var_l, "<(1)", 1, partcv, params);
// compiled op node returning opresult992 (depth = 7)
  Object if989 = done;
  if (istrue(opresult992)) {
// starting to compile call node (depth = 7)
  int callframe993 = gc_frame_new();
// call case 6: other requests
// starting to compile num node (depth = 8)
  Object num994 = alloc_Float64(1);
// compiled num node returning num994 (depth = 8)
  partcv[0] = 0;
  Object call995 = callmethodflags(num994, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe993);
// compiled call node returning call995 (depth = 7)
    gc_frame_newslot(call995);
    if989 = call995;
  } else {
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num996 = alloc_Float64(1);
// compiled num node returning num996 (depth = 7)
    gc_frame_newslot(num996);
    if989 = num996;
  }
// compiled if node returning if989 (depth = 6)
    gc_frame_newslot(if989);
    if984 = if989;
  }
// compiled if node returning if984 (depth = 5)
  gc_frame_end(frame);
  return if984;
}
Object meth_collectionsPrelude_979_sorted(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe980 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe981 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block982 = alloc_Block(NULL, NULL, "collectionsPrelude", 588);
  gc_frame_newslot(block982);
// method "_apply(_,_)"
  block_savedest(block982);
  Object closure983 = createclosure(1, "_apply(2)");
  setclosureframe(closure983, stackframe);
  addtoclosure(closure983, selfslot);
  struct UserObject *uo983 = (struct UserObject*)block982;
  uo983->data[0] = (Object)closure983;
  Method *meth_meth_collectionsPrelude_983__apply_40_2_41_ = addmethod2pos(block982, "_apply(2)", &meth_collectionsPrelude_983__apply_40_2_41_, 0);
  int argcv_meth_collectionsPrelude_983__apply_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_983__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_983__apply_40_2_41_);
  meth_meth_collectionsPrelude_983__apply_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_983__apply_40_2_41_->definitionLine = 1769;
// compiled block node returning block982 (depth = 4)
  gc_frame_newslot(block982);
// call case 6: other requests
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe998 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe999 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_collectionsPrelude (depth = 6)
  partcv[0] = 0;
  Object call1000 = callmethodflags(module_collectionsPrelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe999);
// compiled member node returning call1000 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call1001 = callmethodflags(call1000, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe998);
// compiled call node returning call1001 (depth = 4)
  params[0] = block982;
  partcv[0] = 1;
  Object call1002 = callmethodflags(call1001, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe981);
// compiled call node returning call1002 (depth = 3)
  gc_frame_newslot(call1002);
// call case 6: other requests
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1003 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  partcv[0] = 0;
  Object call1004 = callmethodflags(module_collectionsPrelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1003);
// compiled member node returning call1004 (depth = 3)
  params[0] = call1002;
  partcv[0] = 1;
  Object call1005 = callmethodflags(call1004, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe980);
// compiled call node returning call1005 (depth = 2)
  gc_frame_end(frame);
  return call1005;
}
Object meth_collectionsPrelude_1006_sortedBy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1007 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1008 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sortBlock (depth = 4)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe1009 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1010 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_collectionsPrelude (depth = 6)
  partcv[0] = 0;
  Object call1011 = callmethodflags(module_collectionsPrelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1010);
// compiled member node returning call1011 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call1012 = callmethodflags(call1011, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1009);
// compiled call node returning call1012 (depth = 4)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call1013 = callmethodflags(call1012, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1008);
// compiled call node returning call1013 (depth = 3)
  gc_frame_newslot(call1013);
// call case 6: other requests
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1014 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  partcv[0] = 0;
  Object call1015 = callmethodflags(module_collectionsPrelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1014);
// compiled member node returning call1015 (depth = 3)
  params[0] = call1013;
  partcv[0] = 1;
  Object call1016 = callmethodflags(call1015, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1007);
// compiled call node returning call1016 (depth = 2)
  gc_frame_end(frame);
  return call1016;
}
Object meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromprimitiveArray(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method fromprimitiveArray(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fromprimitiveArray(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pArray = &(stackframe->slots[0]);
  *var_pArray = args[curarg];
  curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  *var_sz = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part fromprimitiveArray(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject687 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj687 = alloc_userobj2(17,18, objclass687);
  gc_frame_newslot(obj687);
  if (objclass687 == NULL) {
    glfree(obj687->class->name);
    obj687->class->name = "sequence.fromprimitiveArray(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj687, self, 0);
  addmethodreal(obj687,"outer", &reader_collectionsPrelude_outer_688);
  Object oldself687 = self;
  struct StackFrameObject *oldstackframe687 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe687);
  gc_frame_newslot((Object)stackframe);
  self = obj687;
  Object *oldselfslot687 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter687 = (*(struct UserObject *)self).data[0], lowerouter687 = thisouter687;
  if (inheritingObject687) {
    struct UserObject *inho687 = (struct UserObject *)inheritingObject687;
    while (inho687->super != GraceDefaultObject) inho687 = (struct UserObject *)inho687->super;
    inho687->super = obj687;
    self = inheritingObject687;
    *selfslot = self;
    lowerouter687 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter687;
  }
  if (objclass687 == NULL) {
  Method *reader689 = addmethodrealflags(obj687, "size",&reader_collectionsPrelude_size_689, MFLAG_DEF);
  reader689->definitionModule = modulename;
  reader689->definitionLine = 512;
  }
  adddatum2(obj687, alloc_Undefined(), 1);
  if (objclass687 == NULL) {
  Method *reader690 = addmethodrealflags(obj687, "inner",&reader_collectionsPrelude_inner_690, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader690->definitionModule = modulename;
  reader690->definitionLine = 513;
  }
  adddatum2(obj687, alloc_Undefined(), 2);
// method "boundsCheck(_)"
  block_savedest(obj687);
  Object closure691 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure691, stackframe);
  addtoclosure(closure691, var_BoundsError);
  struct UserObject *uo691 = (struct UserObject*)obj687;
  uo691->data[3] = (Object)closure691;
  Method *meth_meth_collectionsPrelude_691_boundsCheck_40_1_41_ = addmethod2pos(obj687, "boundsCheck(1)", &meth_collectionsPrelude_691_boundsCheck_40_1_41_, 3);
  int argcv_meth_collectionsPrelude_691_boundsCheck_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_691_boundsCheck_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_691_boundsCheck_40_1_41_);
  meth_meth_collectionsPrelude_691_boundsCheck_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_691_boundsCheck_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_691_boundsCheck_40_1_41_->definitionLine = 515;
// method "at(_)"
  struct UserObject *uo728 = (struct UserObject*)obj687;
  uo728->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_728_at_40_1_41_ = addmethod2pos(obj687, "at(1)", &meth_collectionsPrelude_728_at_40_1_41_, 4);
  int argcv_meth_collectionsPrelude_728_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_728_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_728_at_40_1_41_);
  meth_meth_collectionsPrelude_728_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_728_at_40_1_41_->definitionLine = 522;
// method "keys"
  struct UserObject *uo739 = (struct UserObject*)obj687;
  uo739->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_739_keys = addmethod2pos(obj687, "keys", &meth_collectionsPrelude_739_keys, 5);
  int argcv_meth_collectionsPrelude_739_keys[] = {0};
  meth_meth_collectionsPrelude_739_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_739_keys);
  meth_meth_collectionsPrelude_739_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_739_keys->definitionLine = 526;
// method "values"
  struct UserObject *uo747 = (struct UserObject*)obj687;
  uo747->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_747_values = addmethod2pos(obj687, "values", &meth_collectionsPrelude_747_values, 6);
  int argcv_meth_collectionsPrelude_747_values[] = {0};
  meth_meth_collectionsPrelude_747_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_747_values);
  meth_meth_collectionsPrelude_747_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_747_values->definitionLine = 529;
// method "keysAndValuesDo(_)"
  struct UserObject *uo748 = (struct UserObject*)obj687;
  uo748->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_ = addmethod2pos(obj687, "keysAndValuesDo(1)", &meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_->definitionLine = 532;
// method "reversed"
  struct UserObject *uo778 = (struct UserObject*)obj687;
  uo778->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_778_reversed = addmethod2pos(obj687, "reversed", &meth_collectionsPrelude_778_reversed, 8);
  int argcv_meth_collectionsPrelude_778_reversed[] = {0};
  meth_meth_collectionsPrelude_778_reversed->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_778_reversed);
  meth_meth_collectionsPrelude_778_reversed->definitionModule = modulename;
  meth_meth_collectionsPrelude_778_reversed->definitionLine = 539;
// method "++(_)"
  struct UserObject *uo809 = (struct UserObject*)obj687;
  uo809->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_809__43__43__40_1_41_ = addmethod2pos(obj687, "++(1)", &meth_collectionsPrelude_809__43__43__40_1_41_, 9);
  int argcv_meth_collectionsPrelude_809__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_809__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_809__43__43__40_1_41_);
  meth_meth_collectionsPrelude_809__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_809__43__43__40_1_41_->definitionLine = 548;
// method "asString"
  struct UserObject *uo816 = (struct UserObject*)obj687;
  uo816->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_816_asString = addmethod2pos(obj687, "asString", &meth_collectionsPrelude_816_asString, 10);
  int argcv_meth_collectionsPrelude_816_asString[] = {0};
  meth_meth_collectionsPrelude_816_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_816_asString);
  meth_meth_collectionsPrelude_816_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_816_asString->definitionLine = 551;
// method "contains(_)"
  struct UserObject *uo862 = (struct UserObject*)obj687;
  uo862->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_862_contains_40_1_41_ = addmethod2pos(obj687, "contains(1)", &meth_collectionsPrelude_862_contains_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_862_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_862_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_862_contains_40_1_41_);
  meth_meth_collectionsPrelude_862_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_862_contains_40_1_41_->definitionLine = 559;
// method "do(_)"
  struct UserObject *uo874 = (struct UserObject*)obj687;
  uo874->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_874_do_40_1_41_ = addmethod2pos(obj687, "do(1)", &meth_collectionsPrelude_874_do_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_874_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_874_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_874_do_40_1_41_);
  meth_meth_collectionsPrelude_874_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_874_do_40_1_41_->definitionLine = 563;
// method "==(_)"
  struct UserObject *uo900 = (struct UserObject*)obj687;
  uo900->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_900__61__61__40_1_41_ = addmethod2pos(obj687, "==(1)", &meth_collectionsPrelude_900__61__61__40_1_41_, 13);
  int argcv_meth_collectionsPrelude_900__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_900__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_900__61__61__40_1_41_);
  meth_meth_collectionsPrelude_900__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_900__61__61__40_1_41_->definitionLine = 570;
// method "iterator"
  block_savedest(obj687);
  Object closure903 = createclosure(2, "iterator");
  setclosureframe(closure903, stackframe);
  addtoclosure(closure903, var_sz);
  addtoclosure(closure903, var_IteratorExhausted);
  struct UserObject *uo903 = (struct UserObject*)obj687;
  uo903->data[14] = (Object)closure903;
  Method *meth_meth_collectionsPrelude_903_iterator = addmethod2pos(obj687, "iterator", &meth_collectionsPrelude_903_iterator, 14);
  int argcv_meth_collectionsPrelude_903_iterator[] = {0};
  meth_meth_collectionsPrelude_903_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_903_iterator);
  meth_meth_collectionsPrelude_903_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_903_iterator->definitionLine = 573;
  block_savedest(obj687);
  Object closure978 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure978, stackframe);
  addtoclosure(closure978, var_sz);
  addtoclosure(closure978, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_903_iterator_object = addmethod2pos(obj687, "iterator$object(1)", &meth_collectionsPrelude_903_iterator_object, 14);
  meth_meth_collectionsPrelude_903_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_903_iterator_object->definitionLine = 573;
// method "sorted"
  struct UserObject *uo979 = (struct UserObject*)obj687;
  uo979->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_979_sorted = addmethod2pos(obj687, "sorted", &meth_collectionsPrelude_979_sorted, 15);
  int argcv_meth_collectionsPrelude_979_sorted[] = {0};
  meth_meth_collectionsPrelude_979_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_979_sorted);
  meth_meth_collectionsPrelude_979_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_979_sorted->definitionLine = 587;
// method "sortedBy(_)"
  struct UserObject *uo1006 = (struct UserObject*)obj687;
  uo1006->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1006_sortedBy_40_1_41_ = addmethod2pos(obj687, "sortedBy(1)", &meth_collectionsPrelude_1006_sortedBy_40_1_41_, 16);
  int argcv_meth_collectionsPrelude_1006_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1006_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1006_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_1006_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1006_sortedBy_40_1_41_->definitionLine = 594;
  sourceObject = obj687;
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1017 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1018 = callmethodflags(module_collectionsPrelude, "indexable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1017);
// compiled call node returning call1018 (depth = 2)
  struct UserObject *obj687_uo = (struct UserObject *)obj687;
  obj687_uo->super = call1018;
  sourceObject = obj687;
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sz (depth = 2)
  adddatum2(obj687, *var_sz, 1);
  sourceObject = obj687;
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_pArray (depth = 2)
  adddatum2(obj687, *var_pArray, 2);
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  objclass687 = obj687->class;
  objclass687->definitionModule = modulename;
  objclass687->definitionLine = 510;
  (*(struct UserObject *)self).data[0] = lowerouter687;
  self = oldself687;
  selfslot = oldselfslot687;
  stackframe = oldstackframe687;
  gc_frame_end(frame);
  return obj687;
}
Object meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromprimitiveArray(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method fromprimitiveArray(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fromprimitiveArray(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pArray = &(stackframe->slots[0]);
  *var_pArray = args[curarg];
  curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  *var_sz = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part fromprimitiveArray(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject687 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj687 = alloc_userobj2(17,18, objclass687);
  gc_frame_newslot(obj687);
  if (objclass687 == NULL) {
    glfree(obj687->class->name);
    obj687->class->name = "sequence.fromprimitiveArray(_,_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj687, self, 0);
  addmethodreal(obj687,"outer", &reader_collectionsPrelude_outer_688);
  Object oldself687 = self;
  struct StackFrameObject *oldstackframe687 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe687);
  gc_frame_newslot((Object)stackframe);
  self = obj687;
  Object *oldselfslot687 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter687 = (*(struct UserObject *)self).data[0], lowerouter687 = thisouter687;
  if (inheritingObject687) {
    struct UserObject *inho687 = (struct UserObject *)inheritingObject687;
    while (inho687->super != GraceDefaultObject) inho687 = (struct UserObject *)inho687->super;
    inho687->super = obj687;
    self = inheritingObject687;
    *selfslot = self;
    lowerouter687 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter687;
  }
  if (objclass687 == NULL) {
  Method *reader689 = addmethodrealflags(obj687, "size",&reader_collectionsPrelude_size_689, MFLAG_DEF);
  reader689->definitionModule = modulename;
  reader689->definitionLine = 512;
  }
  adddatum2(obj687, alloc_Undefined(), 1);
  if (objclass687 == NULL) {
  Method *reader690 = addmethodrealflags(obj687, "inner",&reader_collectionsPrelude_inner_690, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader690->definitionModule = modulename;
  reader690->definitionLine = 513;
  }
  adddatum2(obj687, alloc_Undefined(), 2);
// method "boundsCheck(_)"
  block_savedest(obj687);
  Object closure691 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure691, stackframe);
  addtoclosure(closure691, var_BoundsError);
  struct UserObject *uo691 = (struct UserObject*)obj687;
  uo691->data[3] = (Object)closure691;
  Method *meth_meth_collectionsPrelude_691_boundsCheck_40_1_41_ = addmethod2pos(obj687, "boundsCheck(1)", &meth_collectionsPrelude_691_boundsCheck_40_1_41_, 3);
  int argcv_meth_collectionsPrelude_691_boundsCheck_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_691_boundsCheck_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_691_boundsCheck_40_1_41_);
  meth_meth_collectionsPrelude_691_boundsCheck_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_691_boundsCheck_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_691_boundsCheck_40_1_41_->definitionLine = 515;
// method "at(_)"
  struct UserObject *uo728 = (struct UserObject*)obj687;
  uo728->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_728_at_40_1_41_ = addmethod2pos(obj687, "at(1)", &meth_collectionsPrelude_728_at_40_1_41_, 4);
  int argcv_meth_collectionsPrelude_728_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_728_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_728_at_40_1_41_);
  meth_meth_collectionsPrelude_728_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_728_at_40_1_41_->definitionLine = 522;
// method "keys"
  struct UserObject *uo739 = (struct UserObject*)obj687;
  uo739->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_739_keys = addmethod2pos(obj687, "keys", &meth_collectionsPrelude_739_keys, 5);
  int argcv_meth_collectionsPrelude_739_keys[] = {0};
  meth_meth_collectionsPrelude_739_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_739_keys);
  meth_meth_collectionsPrelude_739_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_739_keys->definitionLine = 526;
// method "values"
  struct UserObject *uo747 = (struct UserObject*)obj687;
  uo747->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_747_values = addmethod2pos(obj687, "values", &meth_collectionsPrelude_747_values, 6);
  int argcv_meth_collectionsPrelude_747_values[] = {0};
  meth_meth_collectionsPrelude_747_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_747_values);
  meth_meth_collectionsPrelude_747_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_747_values->definitionLine = 529;
// method "keysAndValuesDo(_)"
  struct UserObject *uo748 = (struct UserObject*)obj687;
  uo748->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_ = addmethod2pos(obj687, "keysAndValuesDo(1)", &meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_748_keysAndValuesDo_40_1_41_->definitionLine = 532;
// method "reversed"
  struct UserObject *uo778 = (struct UserObject*)obj687;
  uo778->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_778_reversed = addmethod2pos(obj687, "reversed", &meth_collectionsPrelude_778_reversed, 8);
  int argcv_meth_collectionsPrelude_778_reversed[] = {0};
  meth_meth_collectionsPrelude_778_reversed->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_778_reversed);
  meth_meth_collectionsPrelude_778_reversed->definitionModule = modulename;
  meth_meth_collectionsPrelude_778_reversed->definitionLine = 539;
// method "++(_)"
  struct UserObject *uo809 = (struct UserObject*)obj687;
  uo809->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_809__43__43__40_1_41_ = addmethod2pos(obj687, "++(1)", &meth_collectionsPrelude_809__43__43__40_1_41_, 9);
  int argcv_meth_collectionsPrelude_809__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_809__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_809__43__43__40_1_41_);
  meth_meth_collectionsPrelude_809__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_809__43__43__40_1_41_->definitionLine = 548;
// method "asString"
  struct UserObject *uo816 = (struct UserObject*)obj687;
  uo816->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_816_asString = addmethod2pos(obj687, "asString", &meth_collectionsPrelude_816_asString, 10);
  int argcv_meth_collectionsPrelude_816_asString[] = {0};
  meth_meth_collectionsPrelude_816_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_816_asString);
  meth_meth_collectionsPrelude_816_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_816_asString->definitionLine = 551;
// method "contains(_)"
  struct UserObject *uo862 = (struct UserObject*)obj687;
  uo862->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_862_contains_40_1_41_ = addmethod2pos(obj687, "contains(1)", &meth_collectionsPrelude_862_contains_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_862_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_862_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_862_contains_40_1_41_);
  meth_meth_collectionsPrelude_862_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_862_contains_40_1_41_->definitionLine = 559;
// method "do(_)"
  struct UserObject *uo874 = (struct UserObject*)obj687;
  uo874->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_874_do_40_1_41_ = addmethod2pos(obj687, "do(1)", &meth_collectionsPrelude_874_do_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_874_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_874_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_874_do_40_1_41_);
  meth_meth_collectionsPrelude_874_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_874_do_40_1_41_->definitionLine = 563;
// method "==(_)"
  struct UserObject *uo900 = (struct UserObject*)obj687;
  uo900->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_900__61__61__40_1_41_ = addmethod2pos(obj687, "==(1)", &meth_collectionsPrelude_900__61__61__40_1_41_, 13);
  int argcv_meth_collectionsPrelude_900__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_900__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_900__61__61__40_1_41_);
  meth_meth_collectionsPrelude_900__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_900__61__61__40_1_41_->definitionLine = 570;
// method "iterator"
  block_savedest(obj687);
  Object closure903 = createclosure(2, "iterator");
  setclosureframe(closure903, stackframe);
  addtoclosure(closure903, var_sz);
  addtoclosure(closure903, var_IteratorExhausted);
  struct UserObject *uo903 = (struct UserObject*)obj687;
  uo903->data[14] = (Object)closure903;
  Method *meth_meth_collectionsPrelude_903_iterator = addmethod2pos(obj687, "iterator", &meth_collectionsPrelude_903_iterator, 14);
  int argcv_meth_collectionsPrelude_903_iterator[] = {0};
  meth_meth_collectionsPrelude_903_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_903_iterator);
  meth_meth_collectionsPrelude_903_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_903_iterator->definitionLine = 573;
  block_savedest(obj687);
  Object closure978 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure978, stackframe);
  addtoclosure(closure978, var_sz);
  addtoclosure(closure978, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_903_iterator_object = addmethod2pos(obj687, "iterator$object(1)", &meth_collectionsPrelude_903_iterator_object, 14);
  meth_meth_collectionsPrelude_903_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_903_iterator_object->definitionLine = 573;
// method "sorted"
  struct UserObject *uo979 = (struct UserObject*)obj687;
  uo979->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_979_sorted = addmethod2pos(obj687, "sorted", &meth_collectionsPrelude_979_sorted, 15);
  int argcv_meth_collectionsPrelude_979_sorted[] = {0};
  meth_meth_collectionsPrelude_979_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_979_sorted);
  meth_meth_collectionsPrelude_979_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_979_sorted->definitionLine = 587;
// method "sortedBy(_)"
  struct UserObject *uo1006 = (struct UserObject*)obj687;
  uo1006->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1006_sortedBy_40_1_41_ = addmethod2pos(obj687, "sortedBy(1)", &meth_collectionsPrelude_1006_sortedBy_40_1_41_, 16);
  int argcv_meth_collectionsPrelude_1006_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1006_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1006_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_1006_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1006_sortedBy_40_1_41_->definitionLine = 594;
  sourceObject = obj687;
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1017 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1018 = callmethodflags(module_collectionsPrelude, "indexable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1017);
// compiled call node returning call1018 (depth = 2)
  struct UserObject *obj687_uo = (struct UserObject *)obj687;
  obj687_uo->super = call1018;
  sourceObject = obj687;
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sz (depth = 2)
  adddatum2(obj687, *var_sz, 1);
  sourceObject = obj687;
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_pArray (depth = 2)
  adddatum2(obj687, *var_pArray, 2);
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  sourceObject = obj687;
  objclass687 = obj687->class;
  objclass687->definitionModule = modulename;
  objclass687->definitionLine = 510;
  (*(struct UserObject *)self).data[0] = lowerouter687;
  self = oldself687;
  selfslot = oldselfslot687;
  stackframe = oldstackframe687;
  gc_frame_end(frame);
  return obj687;
}
Object meth_collectionsPrelude_598_sequence(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject599 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj599 = alloc_userobj2(5,6, objclass599);
  gc_frame_newslot(obj599);
  if (objclass599 == NULL) {
    glfree(obj599->class->name);
    obj599->class->name = "sequence";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj599, self, 0);
  addmethodreal(obj599,"outer", &reader_collectionsPrelude_outer_600);
  Object oldself599 = self;
  struct StackFrameObject *oldstackframe599 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe599);
  gc_frame_newslot((Object)stackframe);
  self = obj599;
  Object *oldselfslot599 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter599 = (*(struct UserObject *)self).data[0], lowerouter599 = thisouter599;
  if (inheritingObject599) {
    struct UserObject *inho599 = (struct UserObject *)inheritingObject599;
    while (inho599->super != GraceDefaultObject) inho599 = (struct UserObject *)inho599->super;
    inho599->super = obj599;
    self = inheritingObject599;
    *selfslot = self;
    lowerouter599 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter599;
  }
// method "asString"
  struct UserObject *uo601 = (struct UserObject*)obj599;
  uo601->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_601_asString = addmethod2pos(obj599, "asString", &meth_collectionsPrelude_601_asString, 1);
  int argcv_meth_collectionsPrelude_601_asString[] = {0};
  meth_meth_collectionsPrelude_601_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_601_asString);
  meth_meth_collectionsPrelude_601_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_601_asString->definitionLine = 466;
// method "empty"
  block_savedest(obj599);
  Object closure603 = createclosure(1, "empty");
  setclosureframe(closure603, stackframe);
  addtoclosure(closure603, var_emptySequence);
  struct UserObject *uo603 = (struct UserObject*)obj599;
  uo603->data[2] = (Object)closure603;
  Method *meth_meth_collectionsPrelude_603_empty = addmethod2pos(obj599, "empty", &meth_collectionsPrelude_603_empty, 2);
  int argcv_meth_collectionsPrelude_603_empty[] = {0};
  meth_meth_collectionsPrelude_603_empty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_603_empty);
  meth_meth_collectionsPrelude_603_empty->definitionModule = modulename;
  meth_meth_collectionsPrelude_603_empty->definitionLine = 468;
// method "withAll(_)"
  block_savedest(obj599);
  Object closure604 = createclosure(1, "withAll(1)");
  setclosureframe(closure604, stackframe);
  addtoclosure(closure604, var_emptySequence);
  struct UserObject *uo604 = (struct UserObject*)obj599;
  uo604->data[3] = (Object)closure604;
  Method *meth_meth_collectionsPrelude_604_withAll_40_1_41_ = addmethod2pos(obj599, "withAll(1)", &meth_collectionsPrelude_604_withAll_40_1_41_, 3);
  int argcv_meth_collectionsPrelude_604_withAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_604_withAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_604_withAll_40_1_41_);
  meth_meth_collectionsPrelude_604_withAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_604_withAll_40_1_41_->definitionLine = 473;
// method "fromprimitiveArray(_,_)"
  block_savedest(obj599);
  Object closure686 = createclosure(2, "fromprimitiveArray(2)");
  setclosureframe(closure686, stackframe);
  addtoclosure(closure686, var_BoundsError);
  addtoclosure(closure686, var_IteratorExhausted);
  struct UserObject *uo686 = (struct UserObject*)obj599;
  uo686->data[4] = (Object)closure686;
  Method *meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_ = addmethod2pos(obj599, "fromprimitiveArray(2)", &meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_, 4);
  int argcv_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_);
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_->definitionLine = 507;
  block_savedest(obj599);
  Object closure1019 = createclosure(2, "fromprimitiveArray(2)$object(1)");
  setclosureframe(closure1019, stackframe);
  addtoclosure(closure1019, var_BoundsError);
  addtoclosure(closure1019, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object = addmethod2pos(obj599, "fromprimitiveArray(2)$object(1)", &meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object, 4);
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object->definitionLine = 507;
  sourceObject = obj599;
  sourceObject = obj599;
  sourceObject = obj599;
  sourceObject = obj599;
  objclass599 = obj599->class;
  objclass599->definitionModule = modulename;
  objclass599->definitionLine = 464;
  (*(struct UserObject *)self).data[0] = lowerouter599;
  self = oldself599;
  selfslot = oldselfslot599;
  stackframe = oldstackframe599;
  gc_frame_end(frame);
  return obj599;
}
Object meth_collectionsPrelude_598_sequence_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sequence$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject599 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj599 = alloc_userobj2(5,6, objclass599);
  gc_frame_newslot(obj599);
  if (objclass599 == NULL) {
    glfree(obj599->class->name);
    obj599->class->name = "sequence";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj599, self, 0);
  addmethodreal(obj599,"outer", &reader_collectionsPrelude_outer_600);
  Object oldself599 = self;
  struct StackFrameObject *oldstackframe599 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe599);
  gc_frame_newslot((Object)stackframe);
  self = obj599;
  Object *oldselfslot599 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter599 = (*(struct UserObject *)self).data[0], lowerouter599 = thisouter599;
  if (inheritingObject599) {
    struct UserObject *inho599 = (struct UserObject *)inheritingObject599;
    while (inho599->super != GraceDefaultObject) inho599 = (struct UserObject *)inho599->super;
    inho599->super = obj599;
    self = inheritingObject599;
    *selfslot = self;
    lowerouter599 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter599;
  }
// method "asString"
  struct UserObject *uo601 = (struct UserObject*)obj599;
  uo601->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_601_asString = addmethod2pos(obj599, "asString", &meth_collectionsPrelude_601_asString, 1);
  int argcv_meth_collectionsPrelude_601_asString[] = {0};
  meth_meth_collectionsPrelude_601_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_601_asString);
  meth_meth_collectionsPrelude_601_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_601_asString->definitionLine = 466;
// method "empty"
  block_savedest(obj599);
  Object closure603 = createclosure(1, "empty");
  setclosureframe(closure603, stackframe);
  addtoclosure(closure603, var_emptySequence);
  struct UserObject *uo603 = (struct UserObject*)obj599;
  uo603->data[2] = (Object)closure603;
  Method *meth_meth_collectionsPrelude_603_empty = addmethod2pos(obj599, "empty", &meth_collectionsPrelude_603_empty, 2);
  int argcv_meth_collectionsPrelude_603_empty[] = {0};
  meth_meth_collectionsPrelude_603_empty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_603_empty);
  meth_meth_collectionsPrelude_603_empty->definitionModule = modulename;
  meth_meth_collectionsPrelude_603_empty->definitionLine = 468;
// method "withAll(_)"
  block_savedest(obj599);
  Object closure604 = createclosure(1, "withAll(1)");
  setclosureframe(closure604, stackframe);
  addtoclosure(closure604, var_emptySequence);
  struct UserObject *uo604 = (struct UserObject*)obj599;
  uo604->data[3] = (Object)closure604;
  Method *meth_meth_collectionsPrelude_604_withAll_40_1_41_ = addmethod2pos(obj599, "withAll(1)", &meth_collectionsPrelude_604_withAll_40_1_41_, 3);
  int argcv_meth_collectionsPrelude_604_withAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_604_withAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_604_withAll_40_1_41_);
  meth_meth_collectionsPrelude_604_withAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_604_withAll_40_1_41_->definitionLine = 473;
// method "fromprimitiveArray(_,_)"
  block_savedest(obj599);
  Object closure686 = createclosure(2, "fromprimitiveArray(2)");
  setclosureframe(closure686, stackframe);
  addtoclosure(closure686, var_BoundsError);
  addtoclosure(closure686, var_IteratorExhausted);
  struct UserObject *uo686 = (struct UserObject*)obj599;
  uo686->data[4] = (Object)closure686;
  Method *meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_ = addmethod2pos(obj599, "fromprimitiveArray(2)", &meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_, 4);
  int argcv_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_);
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41_->definitionLine = 507;
  block_savedest(obj599);
  Object closure1019 = createclosure(2, "fromprimitiveArray(2)$object(1)");
  setclosureframe(closure1019, stackframe);
  addtoclosure(closure1019, var_BoundsError);
  addtoclosure(closure1019, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object = addmethod2pos(obj599, "fromprimitiveArray(2)$object(1)", &meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object, 4);
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_686_fromprimitiveArray_40_2_41__object->definitionLine = 507;
  sourceObject = obj599;
  sourceObject = obj599;
  sourceObject = obj599;
  sourceObject = obj599;
  objclass599 = obj599->class;
  objclass599->definitionModule = modulename;
  objclass599->definitionLine = 464;
  (*(struct UserObject *)self).data[0] = lowerouter599;
  self = oldself599;
  selfslot = oldselfslot599;
  stackframe = oldstackframe599;
  gc_frame_end(frame);
  return obj599;
}
Object meth_collectionsPrelude_1031__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_rightIter = getfromclosure(closure, 0);
  Object *var_leftIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1033 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_rightIter (depth = 7)
  partcv[0] = 0;
  Object call1034 = callmethodflags(*var_rightIter, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe1033);
// compiled member node returning call1034 (depth = 6)
  int op_slot_right_1032 = gc_frame_newslot(call1034);
// starting to compile member node (depth = 6)
  int callframe1036 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_leftIter (depth = 7)
  partcv[0] = 0;
  Object call1037 = callmethodflags(*var_leftIter, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe1036);
// compiled member node returning call1037 (depth = 6)
  int op_slot_left_1032 = gc_frame_newslot(call1037);
  params[0] = call1034;
  partcv[0] = 1;
  Object opresult1038 = callmethod(call1037, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1038 (depth = 5)
  gc_frame_end(frame);
  return opresult1038;
}
Object meth_collectionsPrelude_1041__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_rightIter = getfromclosure(closure, 0);
  Object *var_leftIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1044 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_rightIter (depth = 8)
  partcv[0] = 0;
  Object call1045 = callmethodflags(*var_rightIter, "next", 1, partcv, params, 0);
  gc_frame_end(callframe1044);
// compiled member node returning call1045 (depth = 7)
  int op_slot_right_1043 = gc_frame_newslot(call1045);
// starting to compile member node (depth = 7)
  int callframe1047 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_leftIter (depth = 8)
  partcv[0] = 0;
  Object call1048 = callmethodflags(*var_leftIter, "next", 1, partcv, params, 0);
  gc_frame_end(callframe1047);
// compiled member node returning call1048 (depth = 7)
  int op_slot_left_1043 = gc_frame_newslot(call1048);
  params[0] = call1045;
  partcv[0] = 1;
  Object opresult1049 = callmethod(call1048, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1049 (depth = 6)
  Object if1042 = done;
  if (istrue(opresult1049)) {
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1050 = alloc_Boolean(0);
// compiled identifier node returning bool1050 (depth = 7)
  block_return(realself, bool1050);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if1042 = undefined;
  } else {
  }
// compiled if node returning if1042 (depth = 5)
  gc_frame_end(frame);
  return if1042;
}
Object meth_collectionsPrelude_1021_isEqual_40_1_41_toCollection_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isEqual(1)toCollection(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isEqual(_)toCollection(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isEqual(_)toCollection(_)");
  Object params[2];
  int partcv[2];
  Object *var_MinimalyIterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for isEqual(_)toCollection(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isEqual(_)");
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toCollection(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_leftIter = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "leftIter");
  Object *var_rightIter = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "rightIter");
// definebindings:
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1023 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  gc_frame_newslot(*var_right);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_MinimalyIterable (depth = 4)
  params[0] = *var_right;
  partcv[0] = 1;
  Object call1024 = callmethodflags(*var_MinimalyIterable, "match(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1023);
// compiled call node returning call1024 (depth = 3)
  Object if1022 = done;
  if (istrue(call1024)) {
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1025 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call1026 = callmethodflags(*var_left, "iterator", 1, partcv, params, 0);
  gc_frame_end(callframe1025);
// compiled member node returning call1026 (depth = 4)
  *var_leftIter = call1026;
  if (call1026 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1027 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  partcv[0] = 0;
  Object call1028 = callmethodflags(*var_right, "iterator", 1, partcv, params, 0);
  gc_frame_end(callframe1027);
// compiled member node returning call1028 (depth = 4)
  *var_rightIter = call1028;
  if (call1028 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1029 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1030 = alloc_Block(NULL, NULL, "collectionsPrelude", 609);
  gc_frame_newslot(block1030);
// method "_apply"
  block_savedest(block1030);
  Object closure1031 = createclosure(3, "_apply");
  setclosureframe(closure1031, stackframe);
  addtoclosure(closure1031, var_rightIter);
  addtoclosure(closure1031, var_leftIter);
  addtoclosure(closure1031, selfslot);
  struct UserObject *uo1031 = (struct UserObject*)block1030;
  uo1031->data[0] = (Object)closure1031;
  Method *meth_meth_collectionsPrelude_1031__apply = addmethod2pos(block1030, "_apply", &meth_collectionsPrelude_1031__apply, 0);
  int argcv_meth_collectionsPrelude_1031__apply[] = {0};
  meth_meth_collectionsPrelude_1031__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1031__apply);
  meth_meth_collectionsPrelude_1031__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_1031__apply->definitionLine = 1769;
// compiled block node returning block1030 (depth = 4)
  gc_frame_newslot(block1030);
// starting to compile block node (depth = 4)
  Object block1040 = alloc_Block(NULL, NULL, "collectionsPrelude", 609);
  gc_frame_newslot(block1040);
// method "_apply"
  block_savedest(block1040);
  Object closure1041 = createclosure(3, "_apply");
  setclosureframe(closure1041, stackframe);
  addtoclosure(closure1041, var_rightIter);
  addtoclosure(closure1041, var_leftIter);
  addtoclosure(closure1041, selfslot);
  struct UserObject *uo1041 = (struct UserObject*)block1040;
  uo1041->data[0] = (Object)closure1041;
  Method *meth_meth_collectionsPrelude_1041__apply = addmethod2pos(block1040, "_apply", &meth_collectionsPrelude_1041__apply, 0);
  int argcv_meth_collectionsPrelude_1041__apply[] = {0};
  meth_meth_collectionsPrelude_1041__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1041__apply);
  meth_meth_collectionsPrelude_1041__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_1041__apply->definitionLine = 1769;
// compiled block node returning block1040 (depth = 4)
  gc_frame_newslot(block1040);
// call case 5: prelude request
  params[0] = block1030;
  params[1] = block1040;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1052 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1029);
// compiled call node returning call1052 (depth = 3)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1054 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_rightIter (depth = 5)
  partcv[0] = 0;
  Object call1055 = callmethodflags(*var_rightIter, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe1054);
// compiled member node returning call1055 (depth = 4)
  int op_slot_right_1053 = gc_frame_newslot(call1055);
// starting to compile member node (depth = 4)
  int callframe1057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_leftIter (depth = 5)
  partcv[0] = 0;
  Object call1058 = callmethodflags(*var_leftIter, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe1057);
// compiled member node returning call1058 (depth = 4)
  int op_slot_left_1053 = gc_frame_newslot(call1058);
  params[0] = call1055;
  partcv[0] = 1;
  Object opresult1059 = callmethod(call1058, "==(1)", 1, partcv, params);
// compiled op node returning opresult1059 (depth = 3)
    gc_frame_newslot(opresult1059);
    if1022 = opresult1059;
  } else {
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1060 = alloc_Boolean(0);
// compiled identifier node returning bool1060 (depth = 3)
    gc_frame_newslot(bool1060);
    if1022 = bool1060;
  }
// compiled if node returning if1022 (depth = 2)
  gc_frame_end(frame);
  return if1022;
}
Object meth_collectionsPrelude_1064_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit1065 == NULL) {
    strlit1065 = alloc_String("the list class");
    gc_root(strlit1065);
  }
// compiled string node returning strlit1065 (depth = 2)
  gc_frame_end(frame);
  return strlit1065;
}
Object meth_collectionsPrelude_1066_empty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1067 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySequence (depth = 3)
  gc_frame_newslot(*var_emptySequence);
// call case 4: self request
  params[0] = *var_emptySequence;
  partcv[0] = 1;
  Object call1068 = callmethodflags(self, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1067);
// compiled call node returning call1068 (depth = 2)
  gc_frame_end(frame);
  return call1068;
}
Object meth_collectionsPrelude_1077_boundsCheck_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method boundsCheck(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for boundsCheck(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part boundsCheck(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1080 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1082 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1083 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1082);
// compiled member node returning call1083 (depth = 6)
  int op_slot_right_1081 = gc_frame_newslot(call1083);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_1081 = gc_frame_newslot(*var_n);
  params[0] = call1083;
  partcv[0] = 1;
  Object opresult1085 = callmethod(*var_n, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1085 (depth = 5)
  partcv[0] = 0;
  Object call1086 = callmethodflags(opresult1085, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe1080);
// compiled call node returning call1086 (depth = 4)
  int op_slot_right_1079 = gc_frame_newslot(call1086);
// starting to compile call node (depth = 4)
  int callframe1088 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1090 = alloc_Float64(1);
// compiled num node returning num1090 (depth = 6)
  int op_slot_right_1089 = gc_frame_newslot(num1090);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_1089 = gc_frame_newslot(*var_n);
  params[0] = num1090;
  partcv[0] = 1;
  Object opresult1092 = callmethod(*var_n, "≥(1)", 1, partcv, params);
// compiled op node returning opresult1092 (depth = 5)
  partcv[0] = 0;
  Object call1093 = callmethodflags(opresult1092, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe1088);
// compiled call node returning call1093 (depth = 4)
  int op_slot_left_1079 = gc_frame_newslot(call1093);
  params[0] = call1086;
  partcv[0] = 1;
  Object opresult1094 = callmethod(call1093, "||(1)", 1, partcv, params);
// compiled op node returning opresult1094 (depth = 3)
  Object if1078 = done;
  if (istrue(opresult1094)) {
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1095 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1097 == NULL) {
    strlit1097 = alloc_String("");
    gc_root(strlit1097);
  }
// compiled string node returning strlit1097 (depth = 5)
  int op_slot_right_1096 = gc_frame_newslot(strlit1097);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1101 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1100);
// compiled member node returning call1101 (depth = 6)
  int op_slot_right_1099 = gc_frame_newslot(call1101);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1104 == NULL) {
    strlit1104 = alloc_String(" out of bounds 1..");
    gc_root(strlit1104);
  }
// compiled string node returning strlit1104 (depth = 7)
  int op_slot_right_1103 = gc_frame_newslot(strlit1104);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_1106 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 8)
  if (strlit1108 == NULL) {
    strlit1108 = alloc_String("index ");
    gc_root(strlit1108);
  }
// compiled string node returning strlit1108 (depth = 8)
  int op_slot_left_1106 = gc_frame_newslot(strlit1108);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult1109 = callmethod(strlit1108, "++(1)", 1, partcv, params);
// compiled op node returning opresult1109 (depth = 7)
  int op_slot_left_1103 = gc_frame_newslot(opresult1109);
  params[0] = strlit1104;
  partcv[0] = 1;
  Object opresult1110 = callmethod(opresult1109, "++(1)", 1, partcv, params);
// compiled op node returning opresult1110 (depth = 6)
  int op_slot_left_1099 = gc_frame_newslot(opresult1110);
  params[0] = call1101;
  partcv[0] = 1;
  Object opresult1111 = callmethod(opresult1110, "++(1)", 1, partcv, params);
// compiled op node returning opresult1111 (depth = 5)
  int op_slot_left_1096 = gc_frame_newslot(opresult1111);
  params[0] = strlit1097;
  partcv[0] = 1;
  Object opresult1112 = callmethod(opresult1111, "++(1)", 1, partcv, params);
// compiled op node returning opresult1112 (depth = 4)
  gc_frame_newslot(opresult1112);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult1112;
  partcv[0] = 1;
  Object call1113 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1095);
// compiled call node returning call1113 (depth = 3)
    gc_frame_newslot(call1113);
    if1078 = call1113;
  } else {
  }
// compiled if node returning if1078 (depth = 2)
  gc_frame_end(frame);
  return if1078;
}
Object meth_collectionsPrelude_1114_at_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1115 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1116 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1115);
// compiled call node returning call1116 (depth = 2)
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1117 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1119 = alloc_Float64(1);
// compiled num node returning num1119 (depth = 4)
  int op_slot_right_1118 = gc_frame_newslot(num1119);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1118 = gc_frame_newslot(*var_n);
  params[0] = num1119;
  partcv[0] = 1;
  Object diff1121 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1121 (depth = 3)
  gc_frame_newslot(diff1121);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1122 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1123 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1122);
// compiled member node returning call1123 (depth = 3)
  params[0] = diff1121;
  partcv[0] = 1;
  Object call1124 = callmethodflags(call1123, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1117);
// compiled call node returning call1124 (depth = 2)
  gc_frame_end(frame);
  return call1124;
}
Object meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)put(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)put(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part put(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1126 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1128 = alloc_Float64(1);
// compiled num node returning num1128 (depth = 4)
  int op_slot_right_1127 = gc_frame_newslot(num1128);
// starting to compile member node (depth = 4)
  int callframe1130 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1131 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1130);
// compiled member node returning call1131 (depth = 4)
  int op_slot_left_1127 = gc_frame_newslot(call1131);
  params[0] = num1128;
  partcv[0] = 1;
  Object sum1132 = callmethod(call1131, "+(1)", 1, partcv, params);
// compiled op node returning sum1132 (depth = 3)
  gc_frame_newslot(sum1132);
// call case 4: self request
  params[0] = sum1132;
  partcv[0] = 1;
  Object call1133 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1126);
// compiled call node returning call1133 (depth = 2)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1137 = alloc_Float64(1);
// compiled num node returning num1137 (depth = 5)
  int op_slot_right_1136 = gc_frame_newslot(num1137);
// starting to compile member node (depth = 5)
  int callframe1139 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1140 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1139);
// compiled member node returning call1140 (depth = 5)
  int op_slot_left_1136 = gc_frame_newslot(call1140);
  params[0] = num1137;
  partcv[0] = 1;
  Object sum1141 = callmethod(call1140, "+(1)", 1, partcv, params);
// compiled op node returning sum1141 (depth = 4)
  int op_slot_right_1135 = gc_frame_newslot(sum1141);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1135 = gc_frame_newslot(*var_n);
  params[0] = sum1141;
  partcv[0] = 1;
  Object opresult1143 = callmethod(*var_n, "==(1)", 1, partcv, params);
// compiled op node returning opresult1143 (depth = 3)
  Object if1134 = done;
  if (istrue(opresult1143)) {
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1144 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1145 = callmethodflags(self, "addLast(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1144);
// compiled call node returning call1145 (depth = 3)
    gc_frame_newslot(call1145);
    if1134 = call1145;
  } else {
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1146 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1147 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1146);
// compiled call node returning call1147 (depth = 3)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1148 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1150 = alloc_Float64(1);
// compiled num node returning num1150 (depth = 5)
  int op_slot_right_1149 = gc_frame_newslot(num1150);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1149 = gc_frame_newslot(*var_n);
  params[0] = num1150;
  partcv[0] = 1;
  Object diff1152 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1152 (depth = 4)
  gc_frame_newslot(diff1152);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1153 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1154 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1153);
// compiled member node returning call1154 (depth = 4)
  params[0] = diff1152;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1155 = callmethodflags(call1154, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1148);
// compiled call node returning call1155 (depth = 3)
    gc_frame_newslot(call1155);
    if1134 = call1155;
  }
// compiled if node returning if1134 (depth = 2)
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1156_add_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1157 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1159 = alloc_Float64(1);
// compiled num node returning num1159 (depth = 4)
  int op_slot_right_1158 = gc_frame_newslot(num1159);
// starting to compile member node (depth = 4)
  int callframe1161 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1162 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1161);
// compiled member node returning call1162 (depth = 4)
  int op_slot_left_1158 = gc_frame_newslot(call1162);
  params[0] = num1159;
  partcv[0] = 1;
  Object sum1163 = callmethod(call1162, "+(1)", 1, partcv, params);
// compiled op node returning sum1163 (depth = 3)
  gc_frame_newslot(sum1163);
// call case 4: self request
  params[0] = sum1163;
  partcv[0] = 1;
  Object call1164 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1157);
// compiled call node returning call1164 (depth = 2)
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1167 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1168 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1169 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1168);
// compiled member node returning call1169 (depth = 5)
  partcv[0] = 0;
  Object call1170 = callmethodflags(call1169, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1167);
// compiled member node returning call1170 (depth = 4)
  int op_slot_right_1166 = gc_frame_newslot(call1170);
// starting to compile member node (depth = 4)
  int callframe1172 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1173 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1172);
// compiled member node returning call1173 (depth = 4)
  int op_slot_left_1166 = gc_frame_newslot(call1173);
  params[0] = call1170;
  partcv[0] = 1;
  Object opresult1174 = callmethod(call1173, "==(1)", 1, partcv, params);
// compiled op node returning opresult1174 (depth = 3)
  Object if1165 = done;
  if (istrue(opresult1174)) {
// starting to compile call node (depth = 3)
  int callframe1175 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1177 = alloc_Float64(2);
// compiled num node returning num1177 (depth = 5)
  int op_slot_right_1176 = gc_frame_newslot(num1177);
// starting to compile member node (depth = 5)
  int callframe1179 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1180 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1181 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1180);
// compiled member node returning call1181 (depth = 6)
  partcv[0] = 0;
  Object call1182 = callmethodflags(call1181, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1179);
// compiled member node returning call1182 (depth = 5)
  int op_slot_left_1176 = gc_frame_newslot(call1182);
  params[0] = num1177;
  partcv[0] = 1;
  Object prod1183 = callmethod(call1182, "*(1)", 1, partcv, params);
// compiled op node returning prod1183 (depth = 4)
  gc_frame_newslot(prod1183);
// call case 4: self request
  params[0] = prod1183;
  partcv[0] = 1;
  Object call1184 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1175);
// compiled call node returning call1184 (depth = 3)
    gc_frame_newslot(call1184);
    if1165 = call1184;
  } else {
  }
// compiled if node returning if1165 (depth = 2)
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1185 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe1186 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1187 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1186);
// compiled member node returning call1187 (depth = 3)
  gc_frame_newslot(call1187);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1188 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1189 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1188);
// compiled member node returning call1189 (depth = 3)
  params[0] = call1187;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1190 = callmethodflags(call1189, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1185);
// compiled call node returning call1190 (depth = 2)
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1191 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1193 = alloc_Float64(1);
// compiled num node returning num1193 (depth = 4)
  int op_slot_right_1192 = gc_frame_newslot(num1193);
// starting to compile member node (depth = 4)
  int callframe1195 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1196 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1195);
// compiled member node returning call1196 (depth = 4)
  int op_slot_left_1192 = gc_frame_newslot(call1196);
  params[0] = num1193;
  partcv[0] = 1;
  Object sum1197 = callmethod(call1196, "+(1)", 1, partcv, params);
// compiled op node returning sum1197 (depth = 3)
  gc_frame_newslot(sum1197);
// call case 4: self request
  params[0] = sum1197;
  partcv[0] = 1;
  Object call1198 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1191);
// compiled call node returning call1198 (depth = 2)
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1242__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1243 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1244 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1245 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1244);
// compiled member node returning call1245 (depth = 5)
  gc_frame_newslot(call1245);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1246 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1247 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1246);
// compiled member node returning call1247 (depth = 5)
  params[0] = call1245;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1248 = callmethodflags(call1247, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1243);
// compiled call node returning call1248 (depth = 4)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1249 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1251 = alloc_Float64(1);
// compiled num node returning num1251 (depth = 6)
  int op_slot_right_1250 = gc_frame_newslot(num1251);
// starting to compile member node (depth = 6)
  int callframe1253 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1254 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1253);
// compiled member node returning call1254 (depth = 6)
  int op_slot_left_1250 = gc_frame_newslot(call1254);
  params[0] = num1251;
  partcv[0] = 1;
  Object sum1255 = callmethod(call1254, "+(1)", 1, partcv, params);
// compiled op node returning sum1255 (depth = 5)
  gc_frame_newslot(sum1255);
// call case 4: self request
  params[0] = sum1255;
  partcv[0] = 1;
  Object call1256 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1249);
// compiled call node returning call1256 (depth = 4)
  gc_frame_end(frame);
  return call1256;
}
Object meth_collectionsPrelude_1199_addAll_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1200 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1202 = alloc_Float64(1);
// compiled num node returning num1202 (depth = 4)
  int op_slot_right_1201 = gc_frame_newslot(num1202);
// starting to compile member node (depth = 4)
  int callframe1204 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1205 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1204);
// compiled member node returning call1205 (depth = 4)
  int op_slot_left_1201 = gc_frame_newslot(call1205);
  params[0] = num1202;
  partcv[0] = 1;
  Object sum1206 = callmethod(call1205, "+(1)", 1, partcv, params);
// compiled op node returning sum1206 (depth = 3)
  gc_frame_newslot(sum1206);
// call case 4: self request
  params[0] = sum1206;
  partcv[0] = 1;
  Object call1207 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1200);
// compiled call node returning call1207 (depth = 2)
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1210 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1211 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1212 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1211);
// compiled member node returning call1212 (depth = 5)
  partcv[0] = 0;
  Object call1213 = callmethodflags(call1212, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1210);
// compiled member node returning call1213 (depth = 4)
  int op_slot_right_1209 = gc_frame_newslot(call1213);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1216 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  partcv[0] = 0;
  Object call1217 = callmethodflags(*var_l, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1216);
// compiled member node returning call1217 (depth = 5)
  int op_slot_right_1215 = gc_frame_newslot(call1217);
// starting to compile member node (depth = 5)
  int callframe1219 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1220 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1219);
// compiled member node returning call1220 (depth = 5)
  int op_slot_left_1215 = gc_frame_newslot(call1220);
  params[0] = call1217;
  partcv[0] = 1;
  Object sum1221 = callmethod(call1220, "+(1)", 1, partcv, params);
// compiled op node returning sum1221 (depth = 4)
  int op_slot_left_1209 = gc_frame_newslot(sum1221);
  params[0] = call1213;
  partcv[0] = 1;
  Object opresult1222 = callmethod(sum1221, ">(1)", 1, partcv, params);
// compiled op node returning opresult1222 (depth = 3)
  Object if1208 = done;
  if (istrue(opresult1222)) {
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1223 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1224 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1226 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  partcv[0] = 0;
  Object call1227 = callmethodflags(*var_l, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1226);
// compiled member node returning call1227 (depth = 6)
  int op_slot_right_1225 = gc_frame_newslot(call1227);
// starting to compile member node (depth = 6)
  int callframe1229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1230 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1229);
// compiled member node returning call1230 (depth = 6)
  int op_slot_left_1225 = gc_frame_newslot(call1230);
  params[0] = call1227;
  partcv[0] = 1;
  Object sum1231 = callmethod(call1230, "+(1)", 1, partcv, params);
// compiled op node returning sum1231 (depth = 5)
  gc_frame_newslot(sum1231);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1233 = alloc_Float64(2);
// compiled num node returning num1233 (depth = 6)
  int op_slot_right_1232 = gc_frame_newslot(num1233);
// starting to compile member node (depth = 6)
  int callframe1235 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1236 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1235);
// compiled member node returning call1236 (depth = 6)
  int op_slot_left_1232 = gc_frame_newslot(call1236);
  params[0] = num1233;
  partcv[0] = 1;
  Object prod1237 = callmethod(call1236, "*(1)", 1, partcv, params);
// compiled op node returning prod1237 (depth = 5)
  gc_frame_newslot(prod1237);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  params[0] = sum1231;
  params[1] = prod1237;
  partcv[0] = 2;
  Object call1238 = callmethodflags(module_collectionsPrelude, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1224);
// compiled call node returning call1238 (depth = 4)
  gc_frame_newslot(call1238);
// call case 4: self request
  params[0] = call1238;
  partcv[0] = 1;
  Object call1239 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1223);
// compiled call node returning call1239 (depth = 3)
    gc_frame_newslot(call1239);
    if1208 = call1239;
  } else {
  }
// compiled if node returning if1208 (depth = 2)
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1240 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block1241 = alloc_Block(NULL, NULL, "collectionsPrelude", 691);
  gc_frame_newslot(block1241);
// method "_apply(_)"
  block_savedest(block1241);
  Object closure1242 = createclosure(1, "_apply(1)");
  setclosureframe(closure1242, stackframe);
  addtoclosure(closure1242, selfslot);
  struct UserObject *uo1242 = (struct UserObject*)block1241;
  uo1242->data[0] = (Object)closure1242;
  Method *meth_meth_collectionsPrelude_1242__apply_40_1_41_ = addmethod2pos(block1241, "_apply(1)", &meth_collectionsPrelude_1242__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1242__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1242__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1242__apply_40_1_41_);
  meth_meth_collectionsPrelude_1242__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1242__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1241 (depth = 3)
  gc_frame_newslot(block1241);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block1241;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1258 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1240);
// compiled call node returning call1258 (depth = 2)
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1259_push_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method push(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for push(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part push(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1260 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1262 = alloc_Float64(1);
// compiled num node returning num1262 (depth = 4)
  int op_slot_right_1261 = gc_frame_newslot(num1262);
// starting to compile member node (depth = 4)
  int callframe1264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1265 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1264);
// compiled member node returning call1265 (depth = 4)
  int op_slot_left_1261 = gc_frame_newslot(call1265);
  params[0] = num1262;
  partcv[0] = 1;
  Object sum1266 = callmethod(call1265, "+(1)", 1, partcv, params);
// compiled op node returning sum1266 (depth = 3)
  gc_frame_newslot(sum1266);
// call case 4: self request
  params[0] = sum1266;
  partcv[0] = 1;
  Object call1267 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1260);
// compiled call node returning call1267 (depth = 2)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1270 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1271 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1272 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1271);
// compiled member node returning call1272 (depth = 5)
  partcv[0] = 0;
  Object call1273 = callmethodflags(call1272, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1270);
// compiled member node returning call1273 (depth = 4)
  int op_slot_right_1269 = gc_frame_newslot(call1273);
// starting to compile member node (depth = 4)
  int callframe1275 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1276 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1275);
// compiled member node returning call1276 (depth = 4)
  int op_slot_left_1269 = gc_frame_newslot(call1276);
  params[0] = call1273;
  partcv[0] = 1;
  Object opresult1277 = callmethod(call1276, "==(1)", 1, partcv, params);
// compiled op node returning opresult1277 (depth = 3)
  Object if1268 = done;
  if (istrue(opresult1277)) {
// starting to compile call node (depth = 3)
  int callframe1278 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1280 = alloc_Float64(2);
// compiled num node returning num1280 (depth = 5)
  int op_slot_right_1279 = gc_frame_newslot(num1280);
// starting to compile member node (depth = 5)
  int callframe1282 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1283 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1284 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1283);
// compiled member node returning call1284 (depth = 6)
  partcv[0] = 0;
  Object call1285 = callmethodflags(call1284, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1282);
// compiled member node returning call1285 (depth = 5)
  int op_slot_left_1279 = gc_frame_newslot(call1285);
  params[0] = num1280;
  partcv[0] = 1;
  Object prod1286 = callmethod(call1285, "*(1)", 1, partcv, params);
// compiled op node returning prod1286 (depth = 4)
  gc_frame_newslot(prod1286);
// call case 4: self request
  params[0] = prod1286;
  partcv[0] = 1;
  Object call1287 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1278);
// compiled call node returning call1287 (depth = 3)
    gc_frame_newslot(call1287);
    if1268 = call1287;
  } else {
  }
// compiled if node returning if1268 (depth = 2)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1288 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe1289 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1290 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1289);
// compiled member node returning call1290 (depth = 3)
  gc_frame_newslot(call1290);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1291 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1292 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1291);
// compiled member node returning call1292 (depth = 3)
  params[0] = call1290;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1293 = callmethodflags(call1292, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1288);
// compiled call node returning call1293 (depth = 2)
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1294 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1296 = alloc_Float64(1);
// compiled num node returning num1296 (depth = 4)
  int op_slot_right_1295 = gc_frame_newslot(num1296);
// starting to compile member node (depth = 4)
  int callframe1298 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1299 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1298);
// compiled member node returning call1299 (depth = 4)
  int op_slot_left_1295 = gc_frame_newslot(call1299);
  params[0] = num1296;
  partcv[0] = 1;
  Object sum1300 = callmethod(call1299, "+(1)", 1, partcv, params);
// compiled op node returning sum1300 (depth = 3)
  gc_frame_newslot(sum1300);
// call case 4: self request
  params[0] = sum1300;
  partcv[0] = 1;
  Object call1301 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1294);
// compiled call node returning call1301 (depth = 2)
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1302_addLast_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLast(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addLast(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addLast(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addLast(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1303 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1304 = callmethodflags(self, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1303);
// compiled call node returning call1304 (depth = 2)
  gc_frame_end(frame);
  return call1304;
}
Object meth_collectionsPrelude_1305_removeLast(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1306 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1308 = alloc_Float64(1);
// compiled num node returning num1308 (depth = 4)
  int op_slot_right_1307 = gc_frame_newslot(num1308);
// starting to compile member node (depth = 4)
  int callframe1310 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1311 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1310);
// compiled member node returning call1311 (depth = 4)
  int op_slot_left_1307 = gc_frame_newslot(call1311);
  params[0] = num1308;
  partcv[0] = 1;
  Object sum1312 = callmethod(call1311, "+(1)", 1, partcv, params);
// compiled op node returning sum1312 (depth = 3)
  gc_frame_newslot(sum1312);
// call case 4: self request
  params[0] = sum1312;
  partcv[0] = 1;
  Object call1313 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1306);
// compiled call node returning call1313 (depth = 2)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1314 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1316 = alloc_Float64(1);
// compiled num node returning num1316 (depth = 5)
  int op_slot_right_1315 = gc_frame_newslot(num1316);
// starting to compile member node (depth = 5)
  int callframe1318 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1319 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1318);
// compiled member node returning call1319 (depth = 5)
  int op_slot_left_1315 = gc_frame_newslot(call1319);
  params[0] = num1316;
  partcv[0] = 1;
  Object diff1320 = callmethod(call1319, "-(1)", 1, partcv, params);
// compiled op node returning diff1320 (depth = 4)
  gc_frame_newslot(diff1320);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1321 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1322 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1321);
// compiled member node returning call1322 (depth = 4)
  params[0] = diff1320;
  partcv[0] = 1;
  Object call1323 = callmethodflags(call1322, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1314);
// compiled call node returning call1323 (depth = 3)
  *var_result = call1323;
  if (call1323 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1324 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1326 = alloc_Float64(1);
// compiled num node returning num1326 (depth = 4)
  int op_slot_right_1325 = gc_frame_newslot(num1326);
// starting to compile member node (depth = 4)
  int callframe1328 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1329 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1328);
// compiled member node returning call1329 (depth = 4)
  int op_slot_left_1325 = gc_frame_newslot(call1329);
  params[0] = num1326;
  partcv[0] = 1;
  Object diff1330 = callmethod(call1329, "-(1)", 1, partcv, params);
// compiled op node returning diff1330 (depth = 3)
  gc_frame_newslot(diff1330);
// call case 4: self request
  params[0] = diff1330;
  partcv[0] = 1;
  Object call1331 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1324);
// compiled call node returning call1331 (depth = 2)
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_1384__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_increase = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1385 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_increase (depth = 6)
  int op_slot_right_1386 = gc_frame_newslot(*var_increase);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1386 = gc_frame_newslot(*var_i);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1388 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1388 (depth = 5)
  gc_frame_newslot(sum1388);
// starting to compile call node (depth = 5)
  int callframe1389 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1390 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1391 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1390);
// compiled member node returning call1391 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1392 = callmethodflags(call1391, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1389);
// compiled call node returning call1392 (depth = 5)
  gc_frame_newslot(call1392);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1393 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1394 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1393);
// compiled member node returning call1394 (depth = 5)
  params[0] = sum1388;
  params[1] = call1392;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1395 = callmethodflags(call1394, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1385);
// compiled call node returning call1395 (depth = 4)
  gc_frame_end(frame);
  return call1395;
}
Object meth_collectionsPrelude_1401__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_insertionIndex = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1402 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_insertionIndex (depth = 5)
  gc_frame_newslot(*var_insertionIndex);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1403 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1404 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1403);
// compiled member node returning call1404 (depth = 5)
  params[0] = *var_insertionIndex;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1405 = callmethodflags(call1404, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1402);
// compiled call node returning call1405 (depth = 4)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1407 = alloc_Float64(1);
// compiled num node returning num1407 (depth = 6)
  int op_slot_right_1406 = gc_frame_newslot(num1407);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertionIndex (depth = 6)
  int op_slot_left_1406 = gc_frame_newslot(*var_insertionIndex);
  params[0] = num1407;
  partcv[0] = 1;
  Object sum1409 = callmethod(*var_insertionIndex, "+(1)", 1, partcv, params);
// compiled op node returning sum1409 (depth = 5)
  *var_insertionIndex = sum1409;
  if (sum1409 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_1332_addAllFirst_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAllFirst(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAllFirst(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAllFirst(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAllFirst(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_increase = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "increase");
// definebindings:
// definebindings:
  Object *var_insertionIndex = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "insertionIndex");
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1333 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1335 = alloc_Float64(1);
// compiled num node returning num1335 (depth = 4)
  int op_slot_right_1334 = gc_frame_newslot(num1335);
// starting to compile member node (depth = 4)
  int callframe1337 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1338 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1337);
// compiled member node returning call1338 (depth = 4)
  int op_slot_left_1334 = gc_frame_newslot(call1338);
  params[0] = num1335;
  partcv[0] = 1;
  Object sum1339 = callmethod(call1338, "+(1)", 1, partcv, params);
// compiled op node returning sum1339 (depth = 3)
  gc_frame_newslot(sum1339);
// call case 4: self request
  params[0] = sum1339;
  partcv[0] = 1;
  Object call1340 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1333);
// compiled call node returning call1340 (depth = 2)
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1341 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  partcv[0] = 0;
  Object call1342 = callmethodflags(*var_l, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1341);
// compiled member node returning call1342 (depth = 3)
  *var_increase = call1342;
  if (call1342 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1345 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1346 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1347 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1346);
// compiled member node returning call1347 (depth = 5)
  partcv[0] = 0;
  Object call1348 = callmethodflags(call1347, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1345);
// compiled member node returning call1348 (depth = 4)
  int op_slot_right_1344 = gc_frame_newslot(call1348);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_increase (depth = 5)
  int op_slot_right_1350 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 5)
  int callframe1352 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1353 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1352);
// compiled member node returning call1353 (depth = 5)
  int op_slot_left_1350 = gc_frame_newslot(call1353);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1354 = callmethod(call1353, "+(1)", 1, partcv, params);
// compiled op node returning sum1354 (depth = 4)
  int op_slot_left_1344 = gc_frame_newslot(sum1354);
  params[0] = call1348;
  partcv[0] = 1;
  Object opresult1355 = callmethod(sum1354, ">(1)", 1, partcv, params);
// compiled op node returning opresult1355 (depth = 3)
  Object if1343 = done;
  if (istrue(opresult1355)) {
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1356 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1357 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_increase (depth = 6)
  int op_slot_right_1358 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 6)
  int callframe1360 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1361 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1360);
// compiled member node returning call1361 (depth = 6)
  int op_slot_left_1358 = gc_frame_newslot(call1361);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1362 = callmethod(call1361, "+(1)", 1, partcv, params);
// compiled op node returning sum1362 (depth = 5)
  gc_frame_newslot(sum1362);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1364 = alloc_Float64(2);
// compiled num node returning num1364 (depth = 6)
  int op_slot_right_1363 = gc_frame_newslot(num1364);
// starting to compile member node (depth = 6)
  int callframe1366 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1367 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1366);
// compiled member node returning call1367 (depth = 6)
  int op_slot_left_1363 = gc_frame_newslot(call1367);
  params[0] = num1364;
  partcv[0] = 1;
  Object prod1368 = callmethod(call1367, "*(1)", 1, partcv, params);
// compiled op node returning prod1368 (depth = 5)
  gc_frame_newslot(prod1368);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  params[0] = sum1362;
  params[1] = prod1368;
  partcv[0] = 2;
  Object call1369 = callmethodflags(module_collectionsPrelude, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1357);
// compiled call node returning call1369 (depth = 4)
  gc_frame_newslot(call1369);
// call case 4: self request
  params[0] = call1369;
  partcv[0] = 1;
  Object call1370 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1356);
// compiled call node returning call1370 (depth = 3)
    gc_frame_newslot(call1370);
    if1343 = call1370;
  } else {
  }
// compiled if node returning if1343 (depth = 2)
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1371 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1372 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1374 = alloc_Float64(1);
// compiled num node returning num1374 (depth = 5)
  int op_slot_right_1373 = gc_frame_newslot(num1374);
// starting to compile member node (depth = 5)
  int callframe1376 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1377 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1376);
// compiled member node returning call1377 (depth = 5)
  int op_slot_left_1373 = gc_frame_newslot(call1377);
  params[0] = num1374;
  partcv[0] = 1;
  Object diff1378 = callmethod(call1377, "-(1)", 1, partcv, params);
// compiled op node returning diff1378 (depth = 4)
  gc_frame_newslot(diff1378);
// starting to compile num node (depth = 4)
  Object num1379 = alloc_Float64(0);
// compiled num node returning num1379 (depth = 4)
  gc_frame_newslot(num1379);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1380 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call1381 = callmethodflags(module_collectionsPrelude, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1380);
// compiled member node returning call1381 (depth = 4)
  params[0] = diff1378;
  params[1] = num1379;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1382 = callmethodflags(call1381, "from(1)downTo(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1372);
// compiled call node returning call1382 (depth = 3)
  gc_frame_newslot(call1382);
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block1383 = alloc_Block(NULL, NULL, "collectionsPrelude", 717);
  gc_frame_newslot(block1383);
// method "_apply(_)"
  block_savedest(block1383);
  Object closure1384 = createclosure(2, "_apply(1)");
  setclosureframe(closure1384, stackframe);
  addtoclosure(closure1384, var_increase);
  addtoclosure(closure1384, selfslot);
  struct UserObject *uo1384 = (struct UserObject*)block1383;
  uo1384->data[0] = (Object)closure1384;
  Method *meth_meth_collectionsPrelude_1384__apply_40_1_41_ = addmethod2pos(block1383, "_apply(1)", &meth_collectionsPrelude_1384__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1384__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1384__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1384__apply_40_1_41_);
  meth_meth_collectionsPrelude_1384__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1384__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1383 (depth = 3)
  gc_frame_newslot(block1383);
// call case 5: prelude request
  params[0] = call1382;
  params[1] = block1383;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1397 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1371);
// compiled call node returning call1397 (depth = 2)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1398 = alloc_Float64(0);
// compiled num node returning num1398 (depth = 3)
  *var_insertionIndex = num1398;
  if (num1398 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1399 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block1400 = alloc_Block(NULL, NULL, "collectionsPrelude", 721);
  gc_frame_newslot(block1400);
// method "_apply(_)"
  block_savedest(block1400);
  Object closure1401 = createclosure(2, "_apply(1)");
  setclosureframe(closure1401, stackframe);
  addtoclosure(closure1401, var_insertionIndex);
  addtoclosure(closure1401, selfslot);
  struct UserObject *uo1401 = (struct UserObject*)block1400;
  uo1401->data[0] = (Object)closure1401;
  Method *meth_meth_collectionsPrelude_1401__apply_40_1_41_ = addmethod2pos(block1400, "_apply(1)", &meth_collectionsPrelude_1401__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1401__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1401__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1401__apply_40_1_41_);
  meth_meth_collectionsPrelude_1401__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1401__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1400 (depth = 3)
  gc_frame_newslot(block1400);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block1400;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1412 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1399);
// compiled call node returning call1412 (depth = 2)
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1413 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_increase (depth = 4)
  int op_slot_right_1414 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 4)
  int callframe1416 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1417 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1416);
// compiled member node returning call1417 (depth = 4)
  int op_slot_left_1414 = gc_frame_newslot(call1417);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1418 = callmethod(call1417, "+(1)", 1, partcv, params);
// compiled op node returning sum1418 (depth = 3)
  gc_frame_newslot(sum1418);
// call case 4: self request
  params[0] = sum1418;
  partcv[0] = 1;
  Object call1419 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1413);
// compiled call node returning call1419 (depth = 2)
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1464__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1465 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1467 = alloc_Float64(1);
// compiled num node returning num1467 (depth = 6)
  int op_slot_right_1466 = gc_frame_newslot(num1467);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1466 = gc_frame_newslot(*var_i);
  params[0] = num1467;
  partcv[0] = 1;
  Object sum1469 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1469 (depth = 5)
  gc_frame_newslot(sum1469);
// starting to compile call node (depth = 5)
  int callframe1470 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1471 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1472 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1471);
// compiled member node returning call1472 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1473 = callmethodflags(call1472, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1470);
// compiled call node returning call1473 (depth = 5)
  gc_frame_newslot(call1473);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1474 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1475 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1474);
// compiled member node returning call1475 (depth = 5)
  params[0] = sum1469;
  params[1] = call1473;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1476 = callmethodflags(call1475, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1465);
// compiled call node returning call1476 (depth = 4)
  gc_frame_end(frame);
  return call1476;
}
Object meth_collectionsPrelude_1420_addFirst_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addFirst(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addFirst(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addFirst(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addFirst(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1421 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1423 = alloc_Float64(1);
// compiled num node returning num1423 (depth = 4)
  int op_slot_right_1422 = gc_frame_newslot(num1423);
// starting to compile member node (depth = 4)
  int callframe1425 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1426 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1425);
// compiled member node returning call1426 (depth = 4)
  int op_slot_left_1422 = gc_frame_newslot(call1426);
  params[0] = num1423;
  partcv[0] = 1;
  Object sum1427 = callmethod(call1426, "+(1)", 1, partcv, params);
// compiled op node returning sum1427 (depth = 3)
  gc_frame_newslot(sum1427);
// call case 4: self request
  params[0] = sum1427;
  partcv[0] = 1;
  Object call1428 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1421);
// compiled call node returning call1428 (depth = 2)
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1431 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1432 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1433 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1432);
// compiled member node returning call1433 (depth = 5)
  partcv[0] = 0;
  Object call1434 = callmethodflags(call1433, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1431);
// compiled member node returning call1434 (depth = 4)
  int op_slot_right_1430 = gc_frame_newslot(call1434);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1437 = alloc_Float64(1);
// compiled num node returning num1437 (depth = 5)
  int op_slot_right_1436 = gc_frame_newslot(num1437);
// starting to compile member node (depth = 5)
  int callframe1439 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1440 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1439);
// compiled member node returning call1440 (depth = 5)
  int op_slot_left_1436 = gc_frame_newslot(call1440);
  params[0] = num1437;
  partcv[0] = 1;
  Object sum1441 = callmethod(call1440, "+(1)", 1, partcv, params);
// compiled op node returning sum1441 (depth = 4)
  int op_slot_left_1430 = gc_frame_newslot(sum1441);
  params[0] = call1434;
  partcv[0] = 1;
  Object opresult1442 = callmethod(sum1441, ">(1)", 1, partcv, params);
// compiled op node returning opresult1442 (depth = 3)
  Object if1429 = done;
  if (istrue(opresult1442)) {
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1443 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1445 = alloc_Float64(2);
// compiled num node returning num1445 (depth = 5)
  int op_slot_right_1444 = gc_frame_newslot(num1445);
// starting to compile member node (depth = 5)
  int callframe1447 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1448 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1447);
// compiled member node returning call1448 (depth = 5)
  int op_slot_left_1444 = gc_frame_newslot(call1448);
  params[0] = num1445;
  partcv[0] = 1;
  Object prod1449 = callmethod(call1448, "*(1)", 1, partcv, params);
// compiled op node returning prod1449 (depth = 4)
  gc_frame_newslot(prod1449);
// call case 4: self request
  params[0] = prod1449;
  partcv[0] = 1;
  Object call1450 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1443);
// compiled call node returning call1450 (depth = 3)
    gc_frame_newslot(call1450);
    if1429 = call1450;
  } else {
  }
// compiled if node returning if1429 (depth = 2)
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1451 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1452 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1454 = alloc_Float64(1);
// compiled num node returning num1454 (depth = 5)
  int op_slot_right_1453 = gc_frame_newslot(num1454);
// starting to compile member node (depth = 5)
  int callframe1456 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1457 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1456);
// compiled member node returning call1457 (depth = 5)
  int op_slot_left_1453 = gc_frame_newslot(call1457);
  params[0] = num1454;
  partcv[0] = 1;
  Object diff1458 = callmethod(call1457, "-(1)", 1, partcv, params);
// compiled op node returning diff1458 (depth = 4)
  gc_frame_newslot(diff1458);
// starting to compile num node (depth = 4)
  Object num1459 = alloc_Float64(0);
// compiled num node returning num1459 (depth = 4)
  gc_frame_newslot(num1459);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1460 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call1461 = callmethodflags(module_collectionsPrelude, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1460);
// compiled member node returning call1461 (depth = 4)
  params[0] = diff1458;
  params[1] = num1459;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1462 = callmethodflags(call1461, "from(1)downTo(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1452);
// compiled call node returning call1462 (depth = 3)
  gc_frame_newslot(call1462);
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block1463 = alloc_Block(NULL, NULL, "collectionsPrelude", 733);
  gc_frame_newslot(block1463);
// method "_apply(_)"
  block_savedest(block1463);
  Object closure1464 = createclosure(1, "_apply(1)");
  setclosureframe(closure1464, stackframe);
  addtoclosure(closure1464, selfslot);
  struct UserObject *uo1464 = (struct UserObject*)block1463;
  uo1464->data[0] = (Object)closure1464;
  Method *meth_meth_collectionsPrelude_1464__apply_40_1_41_ = addmethod2pos(block1463, "_apply(1)", &meth_collectionsPrelude_1464__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1464__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1464__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1464__apply_40_1_41_);
  meth_meth_collectionsPrelude_1464__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1464__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1463 (depth = 3)
  gc_frame_newslot(block1463);
// call case 5: prelude request
  params[0] = call1462;
  params[1] = block1463;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1478 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1451);
// compiled call node returning call1478 (depth = 2)
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1479 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1480 = alloc_Float64(0);
// compiled num node returning num1480 (depth = 3)
  gc_frame_newslot(num1480);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elt (depth = 3)
  gc_frame_newslot(*var_elt);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1481 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1482 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1481);
// compiled member node returning call1482 (depth = 3)
  params[0] = num1480;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1483 = callmethodflags(call1482, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1479);
// compiled call node returning call1483 (depth = 2)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1484 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1486 = alloc_Float64(1);
// compiled num node returning num1486 (depth = 4)
  int op_slot_right_1485 = gc_frame_newslot(num1486);
// starting to compile member node (depth = 4)
  int callframe1488 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1489 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1488);
// compiled member node returning call1489 (depth = 4)
  int op_slot_left_1485 = gc_frame_newslot(call1489);
  params[0] = num1486;
  partcv[0] = 1;
  Object sum1490 = callmethod(call1489, "+(1)", 1, partcv, params);
// compiled op node returning sum1490 (depth = 3)
  gc_frame_newslot(sum1490);
// call case 4: self request
  params[0] = sum1490;
  partcv[0] = 1;
  Object call1491 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1484);
// compiled call node returning call1491 (depth = 2)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1492_clear(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "clear");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1493 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1495 = alloc_Float64(1);
// compiled num node returning num1495 (depth = 4)
  int op_slot_right_1494 = gc_frame_newslot(num1495);
// starting to compile member node (depth = 4)
  int callframe1497 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1498 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1497);
// compiled member node returning call1498 (depth = 4)
  int op_slot_left_1494 = gc_frame_newslot(call1498);
  params[0] = num1495;
  partcv[0] = 1;
  Object sum1499 = callmethod(call1498, "+(1)", 1, partcv, params);
// compiled op node returning sum1499 (depth = 3)
  gc_frame_newslot(sum1499);
// call case 4: self request
  params[0] = sum1499;
  partcv[0] = 1;
  Object call1500 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1493);
// compiled call node returning call1500 (depth = 2)
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1501 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1502 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1503 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1504 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1503);
// compiled member node returning call1504 (depth = 4)
  gc_frame_newslot(call1504);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1505 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1506 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1505);
// compiled member node returning call1506 (depth = 4)
  params[0] = call1504;
  partcv[0] = 1;
  Object call1507 = callmethodflags(call1506, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1502);
// compiled call node returning call1507 (depth = 3)
  gc_frame_newslot(call1507);
// call case 4: self request
  params[0] = call1507;
  partcv[0] = 1;
  Object call1508 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1501);
// compiled call node returning call1508 (depth = 2)
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1509 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1510 = alloc_Float64(0);
// compiled num node returning num1510 (depth = 3)
  gc_frame_newslot(num1510);
// call case 4: self request
  params[0] = num1510;
  partcv[0] = 1;
  Object call1511 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1509);
// compiled call node returning call1511 (depth = 2)
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1512_removeFirst(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1513 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1514 = alloc_Float64(1);
// compiled num node returning num1514 (depth = 3)
  gc_frame_newslot(num1514);
// call case 4: self request
  params[0] = num1514;
  partcv[0] = 1;
  Object call1515 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1513);
// compiled call node returning call1515 (depth = 2)
  gc_frame_end(frame);
  return call1515;
}
Object meth_collectionsPrelude_1546__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1547 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1549 = alloc_Float64(1);
// compiled num node returning num1549 (depth = 6)
  int op_slot_right_1548 = gc_frame_newslot(num1549);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1548 = gc_frame_newslot(*var_i);
  params[0] = num1549;
  partcv[0] = 1;
  Object diff1551 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1551 (depth = 5)
  gc_frame_newslot(diff1551);
// starting to compile call node (depth = 5)
  int callframe1552 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1553 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1554 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1553);
// compiled member node returning call1554 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1555 = callmethodflags(call1554, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1552);
// compiled call node returning call1555 (depth = 5)
  gc_frame_newslot(call1555);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1556 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1557 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1556);
// compiled member node returning call1557 (depth = 5)
  params[0] = diff1551;
  params[1] = call1555;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1558 = callmethodflags(call1557, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1547);
// compiled call node returning call1558 (depth = 4)
  gc_frame_end(frame);
  return call1558;
}
Object meth_collectionsPrelude_1516_removeAt_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAt(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAt(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAt(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAt(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_removed = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "removed");
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1517 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1519 = alloc_Float64(1);
// compiled num node returning num1519 (depth = 4)
  int op_slot_right_1518 = gc_frame_newslot(num1519);
// starting to compile member node (depth = 4)
  int callframe1521 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1522 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1521);
// compiled member node returning call1522 (depth = 4)
  int op_slot_left_1518 = gc_frame_newslot(call1522);
  params[0] = num1519;
  partcv[0] = 1;
  Object sum1523 = callmethod(call1522, "+(1)", 1, partcv, params);
// compiled op node returning sum1523 (depth = 3)
  gc_frame_newslot(sum1523);
// call case 4: self request
  params[0] = sum1523;
  partcv[0] = 1;
  Object call1524 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1517);
// compiled call node returning call1524 (depth = 2)
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1525 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1526 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1525);
// compiled call node returning call1526 (depth = 2)
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1527 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1529 = alloc_Float64(1);
// compiled num node returning num1529 (depth = 5)
  int op_slot_right_1528 = gc_frame_newslot(num1529);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1528 = gc_frame_newslot(*var_n);
  params[0] = num1529;
  partcv[0] = 1;
  Object diff1531 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1531 (depth = 4)
  gc_frame_newslot(diff1531);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1532 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1533 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1532);
// compiled member node returning call1533 (depth = 4)
  params[0] = diff1531;
  partcv[0] = 1;
  Object call1534 = callmethodflags(call1533, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1527);
// compiled call node returning call1534 (depth = 3)
  *var_removed = call1534;
  if (call1534 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1535 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1538 = alloc_Float64(1);
// compiled num node returning num1538 (depth = 5)
  int op_slot_right_1537 = gc_frame_newslot(num1538);
// starting to compile member node (depth = 5)
  int callframe1540 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1541 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1540);
// compiled member node returning call1541 (depth = 5)
  int op_slot_left_1537 = gc_frame_newslot(call1541);
  params[0] = num1538;
  partcv[0] = 1;
  Object diff1542 = callmethod(call1541, "-(1)", 1, partcv, params);
// compiled op node returning diff1542 (depth = 4)
  int op_slot_right_1536 = gc_frame_newslot(diff1542);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1536 = gc_frame_newslot(*var_n);
  params[0] = diff1542;
  partcv[0] = 1;
  Object opresult1544 = callmethod(*var_n, "..(1)", 1, partcv, params);
// compiled op node returning opresult1544 (depth = 3)
  gc_frame_newslot(opresult1544);
// starting to compile block node (depth = 3)
  Object block1545 = alloc_Block(NULL, NULL, "collectionsPrelude", 753);
  gc_frame_newslot(block1545);
// method "_apply(_)"
  block_savedest(block1545);
  Object closure1546 = createclosure(1, "_apply(1)");
  setclosureframe(closure1546, stackframe);
  addtoclosure(closure1546, selfslot);
  struct UserObject *uo1546 = (struct UserObject*)block1545;
  uo1546->data[0] = (Object)closure1546;
  Method *meth_meth_collectionsPrelude_1546__apply_40_1_41_ = addmethod2pos(block1545, "_apply(1)", &meth_collectionsPrelude_1546__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1546__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1546__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1546__apply_40_1_41_);
  meth_meth_collectionsPrelude_1546__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1546__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1545 (depth = 3)
  gc_frame_newslot(block1545);
// call case 5: prelude request
  params[0] = opresult1544;
  params[1] = block1545;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1560 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1535);
// compiled call node returning call1560 (depth = 2)
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1561 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1563 = alloc_Float64(1);
// compiled num node returning num1563 (depth = 4)
  int op_slot_right_1562 = gc_frame_newslot(num1563);
// starting to compile member node (depth = 4)
  int callframe1565 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1566 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1565);
// compiled member node returning call1566 (depth = 4)
  int op_slot_left_1562 = gc_frame_newslot(call1566);
  params[0] = num1563;
  partcv[0] = 1;
  Object diff1567 = callmethod(call1566, "-(1)", 1, partcv, params);
// compiled op node returning diff1567 (depth = 3)
  gc_frame_newslot(diff1567);
// call case 4: self request
  params[0] = diff1567;
  partcv[0] = 1;
  Object call1568 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1561);
// compiled call node returning call1568 (depth = 2)
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_removed (depth = 3)
  return *var_removed;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_1572__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1573 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1575 == NULL) {
    strlit1575 = alloc_String("");
    gc_root(strlit1575);
  }
// compiled string node returning strlit1575 (depth = 7)
  int op_slot_right_1574 = gc_frame_newslot(strlit1575);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  int op_slot_right_1577 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 8)
  if (strlit1579 == NULL) {
    strlit1579 = alloc_String("list does not contain ");
    gc_root(strlit1579);
  }
// compiled string node returning strlit1579 (depth = 8)
  int op_slot_left_1577 = gc_frame_newslot(strlit1579);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult1580 = callmethod(strlit1579, "++(1)", 1, partcv, params);
// compiled op node returning opresult1580 (depth = 7)
  int op_slot_left_1574 = gc_frame_newslot(opresult1580);
  params[0] = strlit1575;
  partcv[0] = 1;
  Object opresult1581 = callmethod(opresult1580, "++(1)", 1, partcv, params);
// compiled op node returning opresult1581 (depth = 6)
  gc_frame_newslot(opresult1581);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult1581;
  partcv[0] = 1;
  Object call1582 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1573);
// compiled call node returning call1582 (depth = 5)
  gc_frame_end(frame);
  return call1582;
}
Object meth_collectionsPrelude_1569_remove_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1570 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 4)
  Object block1571 = alloc_Block(NULL, NULL, "collectionsPrelude", 761);
  gc_frame_newslot(block1571);
// method "_apply"
  block_savedest(block1571);
  Object closure1572 = createclosure(3, "_apply");
  setclosureframe(closure1572, stackframe);
  addtoclosure(closure1572, var_elt);
  addtoclosure(closure1572, var_NoSuchObject);
  addtoclosure(closure1572, selfslot);
  struct UserObject *uo1572 = (struct UserObject*)block1571;
  uo1572->data[0] = (Object)closure1572;
  Method *meth_meth_collectionsPrelude_1572__apply = addmethod2pos(block1571, "_apply", &meth_collectionsPrelude_1572__apply, 0);
  int argcv_meth_collectionsPrelude_1572__apply[] = {0};
  meth_meth_collectionsPrelude_1572__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1572__apply);
  meth_meth_collectionsPrelude_1572__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_1572__apply->definitionLine = 1769;
// compiled block node returning block1571 (depth = 4)
  gc_frame_newslot(block1571);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block1571;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1584 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1570);
// compiled call node returning call1584 (depth = 3)
  *var_ix = call1584;
  if (call1584 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1585 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1586 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1585);
// compiled call node returning call1586 (depth = 2)
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1590__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1591 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  partcv[0] = 0;
  Object call1592 = callmethodflags(*var_action, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe1591);
// compiled member node returning call1592 (depth = 5)
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  block_return(realself, self);
// compiled return node returning undefined (depth = 5)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_ix = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ix");
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1588 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 4)
  Object block1589 = alloc_Block(NULL, NULL, "collectionsPrelude", 769);
  gc_frame_newslot(block1589);
// method "_apply"
  block_savedest(block1589);
  Object closure1590 = createclosure(2, "_apply");
  setclosureframe(closure1590, stackframe);
  addtoclosure(closure1590, var_action);
  addtoclosure(closure1590, selfslot);
  struct UserObject *uo1590 = (struct UserObject*)block1589;
  uo1590->data[0] = (Object)closure1590;
  Method *meth_meth_collectionsPrelude_1590__apply = addmethod2pos(block1589, "_apply", &meth_collectionsPrelude_1590__apply, 0);
  int argcv_meth_collectionsPrelude_1590__apply[] = {0};
  meth_meth_collectionsPrelude_1590__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1590__apply);
  meth_meth_collectionsPrelude_1590__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_1590__apply->definitionLine = 1769;
// compiled block node returning block1589 (depth = 4)
  gc_frame_newslot(block1589);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block1589;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1594 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1588);
// compiled call node returning call1594 (depth = 3)
  *var_ix = call1594;
  if (call1594 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1595 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1596 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1595);
// compiled call node returning call1596 (depth = 2)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1600__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe1601 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1602 == NULL) {
    strlit1602 = alloc_String("list does not contain object");
    gc_root(strlit1602);
  }
// compiled string node returning strlit1602 (depth = 5)
  gc_frame_newslot(strlit1602);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_NoSuchObject (depth = 5)
  params[0] = strlit1602;
  partcv[0] = 1;
  Object call1603 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1601);
// compiled call node returning call1603 (depth = 4)
  gc_frame_end(frame);
  return call1603;
}
Object meth_collectionsPrelude_1597_removeAll_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1598 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vs (depth = 3)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 3)
  Object block1599 = alloc_Block(NULL, NULL, "collectionsPrelude", 778);
  gc_frame_newslot(block1599);
// method "_apply"
  block_savedest(block1599);
  Object closure1600 = createclosure(2, "_apply");
  setclosureframe(closure1600, stackframe);
  addtoclosure(closure1600, var_NoSuchObject);
  addtoclosure(closure1600, selfslot);
  struct UserObject *uo1600 = (struct UserObject*)block1599;
  uo1600->data[0] = (Object)closure1600;
  Method *meth_meth_collectionsPrelude_1600__apply = addmethod2pos(block1599, "_apply", &meth_collectionsPrelude_1600__apply, 0);
  int argcv_meth_collectionsPrelude_1600__apply[] = {0};
  meth_meth_collectionsPrelude_1600__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1600__apply);
  meth_meth_collectionsPrelude_1600__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_1600__apply->definitionLine = 1769;
// compiled block node returning block1599 (depth = 3)
  gc_frame_newslot(block1599);
// call case 4: self request
  params[0] = *var_vs;
  params[1] = block1599;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1605 = callmethodflags(self, "removeAll(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1598);
// compiled call node returning call1605 (depth = 2)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1612__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile num node (depth = 7)
  Object num1613 = alloc_Float64(0);
// compiled num node returning num1613 (depth = 7)
  gc_frame_end(frame);
  return num1613;
}
Object meth_collectionsPrelude_1609__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// definebindings:
// definebindings:
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1610 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// starting to compile block node (depth = 6)
  Object block1611 = alloc_Block(NULL, NULL, "collectionsPrelude", 783);
  gc_frame_newslot(block1611);
// method "_apply"
  block_savedest(block1611);
  Object closure1612 = createclosure(1, "_apply");
  setclosureframe(closure1612, stackframe);
  addtoclosure(closure1612, selfslot);
  struct UserObject *uo1612 = (struct UserObject*)block1611;
  uo1612->data[0] = (Object)closure1612;
  Method *meth_meth_collectionsPrelude_1612__apply = addmethod2pos(block1611, "_apply", &meth_collectionsPrelude_1612__apply, 0);
  int argcv_meth_collectionsPrelude_1612__apply[] = {0};
  meth_meth_collectionsPrelude_1612__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1612__apply);
  meth_meth_collectionsPrelude_1612__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_1612__apply->definitionLine = 1769;
// compiled block node returning block1611 (depth = 6)
  gc_frame_newslot(block1611);
// call case 4: self request
  params[0] = *var_each;
  params[1] = block1611;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1615 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1610);
// compiled call node returning call1615 (depth = 5)
  *var_ix = call1615;
  if (call1615 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1618 = alloc_Float64(0);
// compiled num node returning num1618 (depth = 6)
  int op_slot_right_1617 = gc_frame_newslot(num1618);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_1617 = gc_frame_newslot(*var_ix);
  params[0] = num1618;
  partcv[0] = 1;
  Object opresult1620 = callmethod(*var_ix, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1620 (depth = 5)
  Object if1616 = done;
  if (istrue(opresult1620)) {
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1621 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1622 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1621);
// compiled call node returning call1622 (depth = 5)
    gc_frame_newslot(call1622);
    if1616 = call1622;
  } else {
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1623 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  partcv[0] = 0;
  Object call1624 = callmethodflags(*var_action, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe1623);
// compiled member node returning call1624 (depth = 5)
    gc_frame_newslot(call1624);
    if1616 = call1624;
  }
// compiled if node returning if1616 (depth = 4)
  gc_frame_end(frame);
  return if1616;
}
Object meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAll(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1607 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vs (depth = 3)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 3)
  Object block1608 = alloc_Block(NULL, NULL, "collectionsPrelude", 782);
  gc_frame_newslot(block1608);
// method "_apply(_)"
  block_savedest(block1608);
  Object closure1609 = createclosure(2, "_apply(1)");
  setclosureframe(closure1609, stackframe);
  addtoclosure(closure1609, var_action);
  addtoclosure(closure1609, selfslot);
  struct UserObject *uo1609 = (struct UserObject*)block1608;
  uo1609->data[0] = (Object)closure1609;
  Method *meth_meth_collectionsPrelude_1609__apply_40_1_41_ = addmethod2pos(block1608, "_apply(1)", &meth_collectionsPrelude_1609__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1609__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1609__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1609__apply_40_1_41_);
  meth_meth_collectionsPrelude_1609__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1609__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1608 (depth = 3)
  gc_frame_newslot(block1608);
// call case 5: prelude request
  params[0] = *var_vs;
  params[1] = block1608;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1626 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1607);
// compiled call node returning call1626 (depth = 2)
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1627_pop(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe1628 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1629 = callmethodflags(self, "removeLast", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1628);
// compiled member node returning call1629 (depth = 2)
  gc_frame_end(frame);
  return call1629;
}
Object meth_collectionsPrelude_1637__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe1638 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call1639 = callmethodflags(*var_result, "addFirst(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1638);
// compiled call node returning call1639 (depth = 4)
  gc_frame_end(frame);
  return call1639;
}
Object meth_collectionsPrelude_1630_reversed(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1631 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1632 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call1633 = callmethodflags(module_collectionsPrelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1632);
// compiled member node returning call1633 (depth = 4)
  partcv[0] = 0;
  Object call1634 = callmethodflags(call1633, "empty", 1, partcv, params, 0);
  gc_frame_end(callframe1631);
// compiled member node returning call1634 (depth = 3)
  *var_result = call1634;
  if (call1634 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1635 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1636 = alloc_Block(NULL, NULL, "collectionsPrelude", 795);
  gc_frame_newslot(block1636);
// method "_apply(_)"
  block_savedest(block1636);
  Object closure1637 = createclosure(2, "_apply(1)");
  setclosureframe(closure1637, stackframe);
  addtoclosure(closure1637, var_result);
  addtoclosure(closure1637, selfslot);
  struct UserObject *uo1637 = (struct UserObject*)block1636;
  uo1637->data[0] = (Object)closure1637;
  Method *meth_meth_collectionsPrelude_1637__apply_40_1_41_ = addmethod2pos(block1636, "_apply(1)", &meth_collectionsPrelude_1637__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1637__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1637__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1637__apply_40_1_41_);
  meth_meth_collectionsPrelude_1637__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1637__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1636 (depth = 3)
  gc_frame_newslot(block1636);
// call case 4: self request
  params[0] = block1636;
  partcv[0] = 1;
  Object call1641 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1635);
// compiled call node returning call1641 (depth = 2)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_1656__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiIx (depth = 5)
  int op_slot_right_1657 = gc_frame_newslot(*var_hiIx);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loIx (depth = 5)
  int op_slot_left_1657 = gc_frame_newslot(*var_loIx);
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object opresult1659 = callmethod(*var_loIx, "<(1)", 1, partcv, params);
// compiled op node returning opresult1659 (depth = 4)
  gc_frame_end(frame);
  return opresult1659;
}
Object meth_collectionsPrelude_1662__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_hiVal = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiVal");
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1663 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_hiIx (depth = 6)
  gc_frame_newslot(*var_hiIx);
// call case 4: self request
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object call1664 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1663);
// compiled call node returning call1664 (depth = 5)
  *var_hiVal = call1664;
  if (call1664 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1665 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiIx (depth = 5)
  gc_frame_newslot(*var_hiIx);
// starting to compile call node (depth = 5)
  int callframe1666 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_loIx (depth = 6)
  gc_frame_newslot(*var_loIx);
// call case 4: self request
  params[0] = *var_loIx;
  partcv[0] = 1;
  Object call1667 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1666);
// compiled call node returning call1667 (depth = 5)
  gc_frame_newslot(call1667);
// call case 4: self request
  params[0] = *var_hiIx;
  params[1] = call1667;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1668 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1665);
// compiled call node returning call1668 (depth = 4)
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1669 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loIx (depth = 5)
  gc_frame_newslot(*var_loIx);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiVal (depth = 5)
  gc_frame_newslot(*var_hiVal);
// call case 4: self request
  params[0] = *var_loIx;
  params[1] = *var_hiVal;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1670 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1669);
// compiled call node returning call1670 (depth = 4)
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1672 = alloc_Float64(1);
// compiled num node returning num1672 (depth = 6)
  int op_slot_right_1671 = gc_frame_newslot(num1672);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_hiIx (depth = 6)
  int op_slot_left_1671 = gc_frame_newslot(*var_hiIx);
  params[0] = num1672;
  partcv[0] = 1;
  Object diff1674 = callmethod(*var_hiIx, "-(1)", 1, partcv, params);
// compiled op node returning diff1674 (depth = 5)
  *var_hiIx = diff1674;
  if (diff1674 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1677 = alloc_Float64(1);
// compiled num node returning num1677 (depth = 6)
  int op_slot_right_1676 = gc_frame_newslot(num1677);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_loIx (depth = 6)
  int op_slot_left_1676 = gc_frame_newslot(*var_loIx);
  params[0] = num1677;
  partcv[0] = 1;
  Object sum1679 = callmethod(*var_loIx, "+(1)", 1, partcv, params);
// compiled op node returning sum1679 (depth = 5)
  *var_loIx = sum1679;
  if (sum1679 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_1642_reverse(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reverse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_hiIx = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiIx");
  Object *var_loIx = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "loIx");
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1643 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1645 = alloc_Float64(1);
// compiled num node returning num1645 (depth = 4)
  int op_slot_right_1644 = gc_frame_newslot(num1645);
// starting to compile member node (depth = 4)
  int callframe1647 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1648 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1647);
// compiled member node returning call1648 (depth = 4)
  int op_slot_left_1644 = gc_frame_newslot(call1648);
  params[0] = num1645;
  partcv[0] = 1;
  Object sum1649 = callmethod(call1648, "+(1)", 1, partcv, params);
// compiled op node returning sum1649 (depth = 3)
  gc_frame_newslot(sum1649);
// call case 4: self request
  params[0] = sum1649;
  partcv[0] = 1;
  Object call1650 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1643);
// compiled call node returning call1650 (depth = 2)
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1651 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1652 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1651);
// compiled member node returning call1652 (depth = 3)
  *var_hiIx = call1652;
  if (call1652 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1653 = alloc_Float64(1);
// compiled num node returning num1653 (depth = 3)
  *var_loIx = num1653;
  if (num1653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1654 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1655 = alloc_Block(NULL, NULL, "collectionsPrelude", 802);
  gc_frame_newslot(block1655);
// method "_apply"
  block_savedest(block1655);
  Object closure1656 = createclosure(3, "_apply");
  setclosureframe(closure1656, stackframe);
  addtoclosure(closure1656, var_hiIx);
  addtoclosure(closure1656, var_loIx);
  addtoclosure(closure1656, selfslot);
  struct UserObject *uo1656 = (struct UserObject*)block1655;
  uo1656->data[0] = (Object)closure1656;
  Method *meth_meth_collectionsPrelude_1656__apply = addmethod2pos(block1655, "_apply", &meth_collectionsPrelude_1656__apply, 0);
  int argcv_meth_collectionsPrelude_1656__apply[] = {0};
  meth_meth_collectionsPrelude_1656__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1656__apply);
  meth_meth_collectionsPrelude_1656__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_1656__apply->definitionLine = 1769;
// compiled block node returning block1655 (depth = 3)
  gc_frame_newslot(block1655);
// starting to compile block node (depth = 3)
  Object block1661 = alloc_Block(NULL, NULL, "collectionsPrelude", 802);
  gc_frame_newslot(block1661);
// method "_apply"
  block_savedest(block1661);
  Object closure1662 = createclosure(3, "_apply");
  setclosureframe(closure1662, stackframe);
  addtoclosure(closure1662, var_hiIx);
  addtoclosure(closure1662, var_loIx);
  addtoclosure(closure1662, selfslot);
  struct UserObject *uo1662 = (struct UserObject*)block1661;
  uo1662->data[0] = (Object)closure1662;
  Method *meth_meth_collectionsPrelude_1662__apply = addmethod2pos(block1661, "_apply", &meth_collectionsPrelude_1662__apply, 0);
  int argcv_meth_collectionsPrelude_1662__apply[] = {0};
  meth_meth_collectionsPrelude_1662__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1662__apply);
  meth_meth_collectionsPrelude_1662__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_1662__apply->definitionLine = 1769;
// compiled block node returning block1661 (depth = 3)
  gc_frame_newslot(block1661);
// call case 5: prelude request
  params[0] = block1655;
  params[1] = block1661;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1682 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1654);
// compiled call node returning call1682 (depth = 2)
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1683__43__43__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_l = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "l");
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1684 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1685 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call1686 = callmethodflags(module_collectionsPrelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1685);
// compiled member node returning call1686 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1687 = callmethodflags(call1686, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1684);
// compiled call node returning call1687 (depth = 3)
  *var_l = call1687;
  if (call1687 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1688 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1689 = callmethodflags(*var_l, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1688);
// compiled call node returning call1689 (depth = 2)
  gc_frame_end(frame);
  return call1689;
}
Object meth_collectionsPrelude_1704__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1706 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1707 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1708 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1709 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1708);
// compiled member node returning call1709 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1710 = callmethodflags(call1709, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1707);
// compiled call node returning call1710 (depth = 7)
  partcv[0] = 0;
  Object call1711 = callmethodflags(call1710, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe1706);
// compiled member node returning call1711 (depth = 6)
  int op_slot_right_1705 = gc_frame_newslot(call1711);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1705 = gc_frame_newslot(*var_s);
  params[0] = call1711;
  partcv[0] = 1;
  Object opresult1713 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1713 (depth = 5)
  *var_s = opresult1713;
  if (opresult1713 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1718 = alloc_Float64(1);
// compiled num node returning num1718 (depth = 7)
  int op_slot_right_1717 = gc_frame_newslot(num1718);
// starting to compile member node (depth = 7)
  int callframe1720 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1721 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1720);
// compiled member node returning call1721 (depth = 7)
  int op_slot_left_1717 = gc_frame_newslot(call1721);
  params[0] = num1718;
  partcv[0] = 1;
  Object diff1722 = callmethod(call1721, "-(1)", 1, partcv, params);
// compiled op node returning diff1722 (depth = 6)
  int op_slot_right_1716 = gc_frame_newslot(diff1722);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1716 = gc_frame_newslot(*var_i);
  params[0] = diff1722;
  partcv[0] = 1;
  Object opresult1724 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1724 (depth = 5)
  Object if1715 = done;
  if (istrue(opresult1724)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1726 == NULL) {
    strlit1726 = alloc_String(", ");
    gc_root(strlit1726);
  }
// compiled string node returning strlit1726 (depth = 7)
  int op_slot_right_1725 = gc_frame_newslot(strlit1726);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1725 = gc_frame_newslot(*var_s);
  params[0] = strlit1726;
  partcv[0] = 1;
  Object opresult1728 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1728 (depth = 6)
  *var_s = opresult1728;
  if (opresult1728 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1715 = done;
  } else {
  }
// compiled if node returning if1715 (depth = 4)
  gc_frame_end(frame);
  return if1715;
}
Object meth_collectionsPrelude_1690_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1691 == NULL) {
    strlit1691 = alloc_String("[");
    gc_root(strlit1691);
  }
// compiled string node returning strlit1691 (depth = 3)
  *var_s = strlit1691;
  if (strlit1691 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1692 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1695 = alloc_Float64(1);
// compiled num node returning num1695 (depth = 5)
  int op_slot_right_1694 = gc_frame_newslot(num1695);
// starting to compile member node (depth = 5)
  int callframe1697 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1698 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1697);
// compiled member node returning call1698 (depth = 5)
  int op_slot_left_1694 = gc_frame_newslot(call1698);
  params[0] = num1695;
  partcv[0] = 1;
  Object diff1699 = callmethod(call1698, "-(1)", 1, partcv, params);
// compiled op node returning diff1699 (depth = 4)
  int op_slot_right_1693 = gc_frame_newslot(diff1699);
// starting to compile num node (depth = 4)
  Object num1701 = alloc_Float64(0);
// compiled num node returning num1701 (depth = 4)
  int op_slot_left_1693 = gc_frame_newslot(num1701);
  params[0] = diff1699;
  partcv[0] = 1;
  Object opresult1702 = callmethod(num1701, "..(1)", 1, partcv, params);
// compiled op node returning opresult1702 (depth = 3)
  gc_frame_newslot(opresult1702);
// starting to compile block node (depth = 3)
  Object block1703 = alloc_Block(NULL, NULL, "collectionsPrelude", 817);
  gc_frame_newslot(block1703);
// method "_apply(_)"
  block_savedest(block1703);
  Object closure1704 = createclosure(2, "_apply(1)");
  setclosureframe(closure1704, stackframe);
  addtoclosure(closure1704, var_s);
  addtoclosure(closure1704, selfslot);
  struct UserObject *uo1704 = (struct UserObject*)block1703;
  uo1704->data[0] = (Object)closure1704;
  Method *meth_meth_collectionsPrelude_1704__apply_40_1_41_ = addmethod2pos(block1703, "_apply(1)", &meth_collectionsPrelude_1704__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1704__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1704__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1704__apply_40_1_41_);
  meth_meth_collectionsPrelude_1704__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1704__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1703 (depth = 3)
  gc_frame_newslot(block1703);
// call case 5: prelude request
  params[0] = opresult1702;
  params[1] = block1703;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1731 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1692);
// compiled call node returning call1731 (depth = 2)
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1733 == NULL) {
    strlit1733 = alloc_String("]");
    gc_root(strlit1733);
  }
// compiled string node returning strlit1733 (depth = 3)
  int op_slot_right_1732 = gc_frame_newslot(strlit1733);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_1732 = gc_frame_newslot(*var_s);
  params[0] = strlit1733;
  partcv[0] = 1;
  Object opresult1735 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1735 (depth = 2)
  gc_frame_end(frame);
  return opresult1735;
}
Object meth_collectionsPrelude_1750__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1752 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1753 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1754 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1755 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1754);
// compiled member node returning call1755 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1756 = callmethodflags(call1755, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1753);
// compiled call node returning call1756 (depth = 7)
  partcv[0] = 0;
  Object call1757 = callmethodflags(call1756, "asDebugString", 1, partcv, params, 0);
  gc_frame_end(callframe1752);
// compiled member node returning call1757 (depth = 6)
  int op_slot_right_1751 = gc_frame_newslot(call1757);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1751 = gc_frame_newslot(*var_s);
  params[0] = call1757;
  partcv[0] = 1;
  Object opresult1759 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1759 (depth = 5)
  *var_s = opresult1759;
  if (opresult1759 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1764 = alloc_Float64(1);
// compiled num node returning num1764 (depth = 7)
  int op_slot_right_1763 = gc_frame_newslot(num1764);
// starting to compile member node (depth = 7)
  int callframe1766 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1767 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1766);
// compiled member node returning call1767 (depth = 7)
  int op_slot_left_1763 = gc_frame_newslot(call1767);
  params[0] = num1764;
  partcv[0] = 1;
  Object diff1768 = callmethod(call1767, "-(1)", 1, partcv, params);
// compiled op node returning diff1768 (depth = 6)
  int op_slot_right_1762 = gc_frame_newslot(diff1768);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1762 = gc_frame_newslot(*var_i);
  params[0] = diff1768;
  partcv[0] = 1;
  Object opresult1770 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1770 (depth = 5)
  Object if1761 = done;
  if (istrue(opresult1770)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1772 == NULL) {
    strlit1772 = alloc_String(", ");
    gc_root(strlit1772);
  }
// compiled string node returning strlit1772 (depth = 7)
  int op_slot_right_1771 = gc_frame_newslot(strlit1772);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1771 = gc_frame_newslot(*var_s);
  params[0] = strlit1772;
  partcv[0] = 1;
  Object opresult1774 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1774 (depth = 6)
  *var_s = opresult1774;
  if (opresult1774 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1761 = done;
  } else {
  }
// compiled if node returning if1761 (depth = 4)
  gc_frame_end(frame);
  return if1761;
}
Object meth_collectionsPrelude_1736_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1737 == NULL) {
    strlit1737 = alloc_String("[");
    gc_root(strlit1737);
  }
// compiled string node returning strlit1737 (depth = 3)
  *var_s = strlit1737;
  if (strlit1737 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1738 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1741 = alloc_Float64(1);
// compiled num node returning num1741 (depth = 5)
  int op_slot_right_1740 = gc_frame_newslot(num1741);
// starting to compile member node (depth = 5)
  int callframe1743 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1744 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1743);
// compiled member node returning call1744 (depth = 5)
  int op_slot_left_1740 = gc_frame_newslot(call1744);
  params[0] = num1741;
  partcv[0] = 1;
  Object diff1745 = callmethod(call1744, "-(1)", 1, partcv, params);
// compiled op node returning diff1745 (depth = 4)
  int op_slot_right_1739 = gc_frame_newslot(diff1745);
// starting to compile num node (depth = 4)
  Object num1747 = alloc_Float64(0);
// compiled num node returning num1747 (depth = 4)
  int op_slot_left_1739 = gc_frame_newslot(num1747);
  params[0] = diff1745;
  partcv[0] = 1;
  Object opresult1748 = callmethod(num1747, "..(1)", 1, partcv, params);
// compiled op node returning opresult1748 (depth = 3)
  gc_frame_newslot(opresult1748);
// starting to compile block node (depth = 3)
  Object block1749 = alloc_Block(NULL, NULL, "collectionsPrelude", 825);
  gc_frame_newslot(block1749);
// method "_apply(_)"
  block_savedest(block1749);
  Object closure1750 = createclosure(2, "_apply(1)");
  setclosureframe(closure1750, stackframe);
  addtoclosure(closure1750, var_s);
  addtoclosure(closure1750, selfslot);
  struct UserObject *uo1750 = (struct UserObject*)block1749;
  uo1750->data[0] = (Object)closure1750;
  Method *meth_meth_collectionsPrelude_1750__apply_40_1_41_ = addmethod2pos(block1749, "_apply(1)", &meth_collectionsPrelude_1750__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1750__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1750__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1750__apply_40_1_41_);
  meth_meth_collectionsPrelude_1750__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1750__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1749 (depth = 3)
  gc_frame_newslot(block1749);
// call case 5: prelude request
  params[0] = opresult1748;
  params[1] = block1749;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1777 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1738);
// compiled call node returning call1777 (depth = 2)
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1779 == NULL) {
    strlit1779 = alloc_String("]");
    gc_root(strlit1779);
  }
// compiled string node returning strlit1779 (depth = 3)
  int op_slot_right_1778 = gc_frame_newslot(strlit1779);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_1778 = gc_frame_newslot(*var_s);
  params[0] = strlit1779;
  partcv[0] = 1;
  Object opresult1781 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1781 (depth = 2)
  gc_frame_end(frame);
  return opresult1781;
}
Object meth_collectionsPrelude_1785__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_element (depth = 6)
  int op_slot_right_1787 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_1787 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult1789 = callmethod(*var_each, "==(1)", 1, partcv, params);
// compiled op node returning opresult1789 (depth = 5)
  Object if1786 = done;
  if (istrue(opresult1789)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1790 = alloc_Boolean(1);
// compiled identifier node returning bool1790 (depth = 6)
  block_return(realself, bool1790);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if1786 = undefined;
  } else {
  }
// compiled if node returning if1786 (depth = 4)
  gc_frame_end(frame);
  return if1786;
}
Object meth_collectionsPrelude_1782_contains_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1783 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1784 = alloc_Block(NULL, NULL, "collectionsPrelude", 832);
  gc_frame_newslot(block1784);
// method "_apply(_)"
  block_savedest(block1784);
  Object closure1785 = createclosure(2, "_apply(1)");
  setclosureframe(closure1785, stackframe);
  addtoclosure(closure1785, var_element);
  addtoclosure(closure1785, selfslot);
  struct UserObject *uo1785 = (struct UserObject*)block1784;
  uo1785->data[0] = (Object)closure1785;
  Method *meth_meth_collectionsPrelude_1785__apply_40_1_41_ = addmethod2pos(block1784, "_apply(1)", &meth_collectionsPrelude_1785__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1785__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1785__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1785__apply_40_1_41_);
  meth_meth_collectionsPrelude_1785__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1785__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1784 (depth = 3)
  gc_frame_newslot(block1784);
// call case 4: self request
  params[0] = block1784;
  partcv[0] = 1;
  Object call1792 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1783);
// compiled call node returning call1792 (depth = 2)
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool1793 = alloc_Boolean(0);
// compiled identifier node returning bool1793 (depth = 3)
  return bool1793;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_1800__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1802 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1803 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1802);
// compiled member node returning call1803 (depth = 5)
  int op_slot_right_1801 = gc_frame_newslot(call1803);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1801 = gc_frame_newslot(*var_i);
  params[0] = call1803;
  partcv[0] = 1;
  Object opresult1805 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1805 (depth = 4)
  gc_frame_end(frame);
  return opresult1805;
}
Object meth_collectionsPrelude_1808__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_iMods = getfromclosure(closure, 0);
  Object *var_ConcurrentModification = getfromclosure(closure, 1);
  Object *var_i = getfromclosure(closure, 2);
  Object *var_block1 = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1811 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1812 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1811);
// compiled member node returning call1812 (depth = 6)
  int op_slot_right_1810 = gc_frame_newslot(call1812);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_iMods (depth = 6)
  int op_slot_left_1810 = gc_frame_newslot(*var_iMods);
  params[0] = call1812;
  partcv[0] = 1;
  Object opresult1814 = callmethod(*var_iMods, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1814 (depth = 5)
  Object if1809 = done;
  if (istrue(opresult1814)) {
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1815 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe1816 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1817 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1816);
// compiled member node returning call1817 (depth = 6)
  gc_frame_newslot(call1817);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ConcurrentModification (depth = 6)
  params[0] = call1817;
  partcv[0] = 1;
  Object call1818 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1815);
// compiled call node returning call1818 (depth = 5)
    gc_frame_newslot(call1818);
    if1809 = call1818;
  } else {
  }
// compiled if node returning if1809 (depth = 4)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1819 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe1820 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1821 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1822 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1821);
// compiled member node returning call1822 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1823 = callmethodflags(call1822, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1820);
// compiled call node returning call1823 (depth = 5)
  gc_frame_newslot(call1823);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call1823;
  partcv[0] = 1;
  Object call1824 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1819);
// compiled call node returning call1824 (depth = 4)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1826 = alloc_Float64(1);
// compiled num node returning num1826 (depth = 6)
  int op_slot_right_1825 = gc_frame_newslot(num1826);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1825 = gc_frame_newslot(*var_i);
  params[0] = num1826;
  partcv[0] = 1;
  Object sum1828 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1828 (depth = 5)
  *var_i = sum1828;
  if (sum1828 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_1794_do_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_iMods = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "iMods");
  Object *var_i = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "i");
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1795 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1796 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1795);
// compiled member node returning call1796 (depth = 3)
  *var_iMods = call1796;
  if (call1796 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1797 = alloc_Float64(0);
// compiled num node returning num1797 (depth = 3)
  *var_i = num1797;
  if (num1797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1798 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1799 = alloc_Block(NULL, NULL, "collectionsPrelude", 838);
  gc_frame_newslot(block1799);
// method "_apply"
  block_savedest(block1799);
  Object closure1800 = createclosure(2, "_apply");
  setclosureframe(closure1800, stackframe);
  addtoclosure(closure1800, var_i);
  addtoclosure(closure1800, selfslot);
  struct UserObject *uo1800 = (struct UserObject*)block1799;
  uo1800->data[0] = (Object)closure1800;
  Method *meth_meth_collectionsPrelude_1800__apply = addmethod2pos(block1799, "_apply", &meth_collectionsPrelude_1800__apply, 0);
  int argcv_meth_collectionsPrelude_1800__apply[] = {0};
  meth_meth_collectionsPrelude_1800__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1800__apply);
  meth_meth_collectionsPrelude_1800__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_1800__apply->definitionLine = 1769;
// compiled block node returning block1799 (depth = 3)
  gc_frame_newslot(block1799);
// starting to compile block node (depth = 3)
  Object block1807 = alloc_Block(NULL, NULL, "collectionsPrelude", 838);
  gc_frame_newslot(block1807);
// method "_apply"
  block_savedest(block1807);
  Object closure1808 = createclosure(5, "_apply");
  setclosureframe(closure1808, stackframe);
  addtoclosure(closure1808, var_iMods);
  addtoclosure(closure1808, var_ConcurrentModification);
  addtoclosure(closure1808, var_i);
  addtoclosure(closure1808, var_block1);
  addtoclosure(closure1808, selfslot);
  struct UserObject *uo1808 = (struct UserObject*)block1807;
  uo1808->data[0] = (Object)closure1808;
  Method *meth_meth_collectionsPrelude_1808__apply = addmethod2pos(block1807, "_apply", &meth_collectionsPrelude_1808__apply, 0);
  int argcv_meth_collectionsPrelude_1808__apply[] = {0};
  meth_meth_collectionsPrelude_1808__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1808__apply);
  meth_meth_collectionsPrelude_1808__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_1808__apply->definitionLine = 1769;
// compiled block node returning block1807 (depth = 3)
  gc_frame_newslot(block1807);
// call case 5: prelude request
  params[0] = block1799;
  params[1] = block1807;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1831 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1798);
// compiled call node returning call1831 (depth = 2)
  gc_frame_end(frame);
  return call1831;
}
Object meth_collectionsPrelude_1832__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1833 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1834 = callmethodflags(module_collectionsPrelude, "isEqual(1)toCollection(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1833);
// compiled call node returning call1834 (depth = 2)
  gc_frame_end(frame);
  return call1834;
}
Object meth_collectionsPrelude_1840_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1842 == NULL) {
    strlit1842 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit1842);
  }
// compiled string node returning strlit1842 (depth = 3)
  int op_slot_right_1841 = gc_frame_newslot(strlit1842);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1845 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1846 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1845);
// compiled member node returning call1846 (depth = 4)
  int op_slot_right_1844 = gc_frame_newslot(call1846);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1849 == NULL) {
    strlit1849 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit1849);
  }
// compiled string node returning strlit1849 (depth = 5)
  int op_slot_right_1848 = gc_frame_newslot(strlit1849);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1852 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1853 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1852);
// compiled member node returning call1853 (depth = 6)
  int op_slot_right_1851 = gc_frame_newslot(call1853);
// starting to compile string node (depth = 6)
  if (strlit1855 == NULL) {
    strlit1855 = alloc_String("");
    gc_root(strlit1855);
  }
// compiled string node returning strlit1855 (depth = 6)
  int op_slot_left_1851 = gc_frame_newslot(strlit1855);
  params[0] = call1853;
  partcv[0] = 1;
  Object opresult1856 = callmethod(strlit1855, "++(1)", 1, partcv, params);
// compiled op node returning opresult1856 (depth = 5)
  int op_slot_left_1848 = gc_frame_newslot(opresult1856);
  params[0] = strlit1849;
  partcv[0] = 1;
  Object opresult1857 = callmethod(opresult1856, "++(1)", 1, partcv, params);
// compiled op node returning opresult1857 (depth = 4)
  int op_slot_left_1844 = gc_frame_newslot(opresult1857);
  params[0] = call1846;
  partcv[0] = 1;
  Object opresult1858 = callmethod(opresult1857, "++(1)", 1, partcv, params);
// compiled op node returning opresult1858 (depth = 3)
  int op_slot_left_1841 = gc_frame_newslot(opresult1858);
  params[0] = strlit1842;
  partcv[0] = 1;
  Object opresult1859 = callmethod(opresult1858, "++(1)", 1, partcv, params);
// compiled op node returning opresult1859 (depth = 2)
  gc_frame_end(frame);
  return opresult1859;
}
Object meth_collectionsPrelude_1860_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit1861 == NULL) {
    strlit1861 = alloc_String("aListIterator");
    gc_root(strlit1861);
  }
// compiled string node returning strlit1861 (depth = 2)
  gc_frame_end(frame);
  return strlit1861;
}
Object meth_collectionsPrelude_1862_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1864 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1865 = gc_frame_new();
// call case 3: self.outer request
  Object call1866 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1865);
// compiled member node returning call1866 (depth = 4)
  partcv[0] = 0;
  Object call1867 = callmethodflags(call1866, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1864);
// compiled member node returning call1867 (depth = 3)
  int op_slot_right_1863 = gc_frame_newslot(call1867);
// starting to compile member node (depth = 3)
  int callframe1869 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1870 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1869);
// compiled member node returning call1870 (depth = 3)
  int op_slot_left_1863 = gc_frame_newslot(call1870);
  params[0] = call1867;
  partcv[0] = 1;
  Object opresult1871 = callmethod(call1870, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1871 (depth = 2)
  gc_frame_end(frame);
  return opresult1871;
}
Object meth_collectionsPrelude_1872_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1875 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1876 = gc_frame_new();
// call case 3: self.outer request
  Object call1877 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1876);
// compiled member node returning call1877 (depth = 5)
  partcv[0] = 0;
  Object call1878 = callmethodflags(call1877, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1875);
// compiled member node returning call1878 (depth = 4)
  int op_slot_right_1874 = gc_frame_newslot(call1878);
// starting to compile member node (depth = 4)
  int callframe1880 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1881 = callmethodflags(self, "iMods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1880);
// compiled member node returning call1881 (depth = 4)
  int op_slot_left_1874 = gc_frame_newslot(call1881);
  params[0] = call1878;
  partcv[0] = 1;
  Object opresult1882 = callmethod(call1881, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1882 (depth = 3)
  Object if1873 = done;
  if (istrue(opresult1882)) {
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1883 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1884 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1885 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1884);
// compiled member node returning call1885 (depth = 4)
  gc_frame_newslot(call1885);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call1885;
  partcv[0] = 1;
  Object call1886 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1883);
// compiled call node returning call1886 (depth = 3)
    gc_frame_newslot(call1886);
    if1873 = call1886;
  } else {
  }
// compiled if node returning if1873 (depth = 2)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1889 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1890 = gc_frame_new();
// call case 3: self.outer request
  Object call1891 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1890);
// compiled member node returning call1891 (depth = 5)
  partcv[0] = 0;
  Object call1892 = callmethodflags(call1891, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1889);
// compiled member node returning call1892 (depth = 4)
  int op_slot_right_1888 = gc_frame_newslot(call1892);
// starting to compile member node (depth = 4)
  int callframe1894 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1895 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1894);
// compiled member node returning call1895 (depth = 4)
  int op_slot_left_1888 = gc_frame_newslot(call1895);
  params[0] = call1892;
  partcv[0] = 1;
  Object opresult1896 = callmethod(call1895, ">(1)", 1, partcv, params);
// compiled op node returning opresult1896 (depth = 3)
  Object if1887 = done;
  if (istrue(opresult1896)) {
// starting to compile call node (depth = 3)
  int callframe1897 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1898 == NULL) {
    strlit1898 = alloc_String("on list");
    gc_root(strlit1898);
  }
// compiled string node returning strlit1898 (depth = 4)
  gc_frame_newslot(strlit1898);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = strlit1898;
  partcv[0] = 1;
  Object call1899 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1897);
// compiled call node returning call1899 (depth = 3)
    gc_frame_newslot(call1899);
    if1887 = call1899;
  } else {
  }
// compiled if node returning if1887 (depth = 2)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1900 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1901 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1902 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1901);
// compiled member node returning call1902 (depth = 4)
  gc_frame_newslot(call1902);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1903 = gc_frame_new();
// call case 3: self.outer request
  Object call1904 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1903);
// compiled member node returning call1904 (depth = 4)
  params[0] = call1902;
  partcv[0] = 1;
  Object call1905 = callmethodflags(call1904, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1900);
// compiled call node returning call1905 (depth = 3)
  *var_ret = call1905;
  if (call1905 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1906 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1908 = alloc_Float64(1);
// compiled num node returning num1908 (depth = 4)
  int op_slot_right_1907 = gc_frame_newslot(num1908);
// starting to compile member node (depth = 4)
  int callframe1910 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1911 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1910);
// compiled member node returning call1911 (depth = 4)
  int op_slot_left_1907 = gc_frame_newslot(call1911);
  params[0] = num1908;
  partcv[0] = 1;
  Object sum1912 = callmethod(call1911, "+(1)", 1, partcv, params);
// compiled op node returning sum1912 (depth = 3)
  gc_frame_newslot(sum1912);
// call case 4: self request
  params[0] = sum1912;
  partcv[0] = 1;
  Object call1913 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1906);
// compiled call node returning call1913 (depth = 2)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_1835_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1836 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1836 = alloc_userobj2(7,7, objclass1836);
  gc_frame_newslot(obj1836);
  if (objclass1836 == NULL) {
    glfree(obj1836->class->name);
    obj1836->class->name = "list.withAll(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1836, self, 0);
  addmethodreal(obj1836,"outer", &reader_collectionsPrelude_outer_1837);
  Object oldself1836 = self;
  struct StackFrameObject *oldstackframe1836 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1836);
  gc_frame_newslot((Object)stackframe);
  self = obj1836;
  Object *oldselfslot1836 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1836 = (*(struct UserObject *)self).data[0], lowerouter1836 = thisouter1836;
  if (inheritingObject1836) {
    struct UserObject *inho1836 = (struct UserObject *)inheritingObject1836;
    while (inho1836->super != GraceDefaultObject) inho1836 = (struct UserObject *)inho1836->super;
    inho1836->super = obj1836;
    self = inheritingObject1836;
    *selfslot = self;
    lowerouter1836 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1836;
  }
  if (objclass1836 == NULL) {
  Method *reader1838 = addmethodrealflags(obj1836, "iMods",&reader_collectionsPrelude_iMods_1838, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader1838->definitionModule = modulename;
  reader1838->definitionLine = 852;
  }
  adddatum2(obj1836, alloc_Undefined(), 1);
  if (objclass1836 == NULL) {
    Method *reader1839 = addmethodrealflags(obj1836, "idx", &reader_collectionsPrelude_idx_1839, MFLAG_CONFIDENTIAL);
    Method *writer1839 = addmethodrealflags(obj1836, "idx:=(1)", &writer_collectionsPrelude_idx_1839, MFLAG_CONFIDENTIAL);
    reader1839->definitionModule = modulename;
    writer1839->definitionModule = modulename;
    reader1839->definitionLine = 853;
    writer1839->definitionLine = 853;
  }
  obj1836->flags |= OFLAG_MUTABLE;
  adddatum2(obj1836, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1840 = (struct UserObject*)obj1836;
  uo1840->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1840_asDebugString = addmethod2pos(obj1836, "asDebugString", &meth_collectionsPrelude_1840_asDebugString, 3);
  int argcv_meth_collectionsPrelude_1840_asDebugString[] = {0};
  meth_meth_collectionsPrelude_1840_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1840_asDebugString);
  meth_meth_collectionsPrelude_1840_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_1840_asDebugString->definitionLine = 854;
// method "asString"
  struct UserObject *uo1860 = (struct UserObject*)obj1836;
  uo1860->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1860_asString = addmethod2pos(obj1836, "asString", &meth_collectionsPrelude_1860_asString, 4);
  int argcv_meth_collectionsPrelude_1860_asString[] = {0};
  meth_meth_collectionsPrelude_1860_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1860_asString);
  meth_meth_collectionsPrelude_1860_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_1860_asString->definitionLine = 855;
// method "hasNext"
  struct UserObject *uo1862 = (struct UserObject*)obj1836;
  uo1862->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1862_hasNext = addmethod2pos(obj1836, "hasNext", &meth_collectionsPrelude_1862_hasNext, 5);
  int argcv_meth_collectionsPrelude_1862_hasNext[] = {0};
  meth_meth_collectionsPrelude_1862_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1862_hasNext);
  meth_meth_collectionsPrelude_1862_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_1862_hasNext->definitionLine = 856;
// method "next"
  block_savedest(obj1836);
  Object closure1872 = createclosure(2, "next");
  setclosureframe(closure1872, stackframe);
  addtoclosure(closure1872, var_ConcurrentModification);
  addtoclosure(closure1872, var_IteratorExhausted);
  struct UserObject *uo1872 = (struct UserObject*)obj1836;
  uo1872->data[6] = (Object)closure1872;
  Method *meth_meth_collectionsPrelude_1872_next = addmethod2pos(obj1836, "next", &meth_collectionsPrelude_1872_next, 6);
  int argcv_meth_collectionsPrelude_1872_next[] = {0};
  meth_meth_collectionsPrelude_1872_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1872_next);
  meth_meth_collectionsPrelude_1872_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_1872_next->definitionLine = 857;
  sourceObject = obj1836;
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe1914 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1915 = gc_frame_new();
// call case 3: self.outer request
  Object call1916 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1915);
// compiled member node returning call1916 (depth = 3)
  partcv[0] = 0;
  Object call1917 = callmethodflags(call1916, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1914);
// compiled member node returning call1917 (depth = 2)
  adddatum2(obj1836, call1917, 1);
  sourceObject = obj1836;
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num1918 = alloc_Float64(1);
// compiled num node returning num1918 (depth = 2)
  adddatum2(obj1836, num1918, 2);
  sourceObject = obj1836;
  sourceObject = obj1836;
  sourceObject = obj1836;
  sourceObject = obj1836;
  objclass1836 = obj1836->class;
  objclass1836->definitionModule = modulename;
  objclass1836->definitionLine = 851;
  (*(struct UserObject *)self).data[0] = lowerouter1836;
  self = oldself1836;
  selfslot = oldselfslot1836;
  stackframe = oldstackframe1836;
  gc_frame_end(frame);
  return obj1836;
}
Object meth_collectionsPrelude_1835_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1836 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1836 = alloc_userobj2(7,7, objclass1836);
  gc_frame_newslot(obj1836);
  if (objclass1836 == NULL) {
    glfree(obj1836->class->name);
    obj1836->class->name = "list.withAll(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1836, self, 0);
  addmethodreal(obj1836,"outer", &reader_collectionsPrelude_outer_1837);
  Object oldself1836 = self;
  struct StackFrameObject *oldstackframe1836 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1836);
  gc_frame_newslot((Object)stackframe);
  self = obj1836;
  Object *oldselfslot1836 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1836 = (*(struct UserObject *)self).data[0], lowerouter1836 = thisouter1836;
  if (inheritingObject1836) {
    struct UserObject *inho1836 = (struct UserObject *)inheritingObject1836;
    while (inho1836->super != GraceDefaultObject) inho1836 = (struct UserObject *)inho1836->super;
    inho1836->super = obj1836;
    self = inheritingObject1836;
    *selfslot = self;
    lowerouter1836 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1836;
  }
  if (objclass1836 == NULL) {
  Method *reader1838 = addmethodrealflags(obj1836, "iMods",&reader_collectionsPrelude_iMods_1838, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader1838->definitionModule = modulename;
  reader1838->definitionLine = 852;
  }
  adddatum2(obj1836, alloc_Undefined(), 1);
  if (objclass1836 == NULL) {
    Method *reader1839 = addmethodrealflags(obj1836, "idx", &reader_collectionsPrelude_idx_1839, MFLAG_CONFIDENTIAL);
    Method *writer1839 = addmethodrealflags(obj1836, "idx:=(1)", &writer_collectionsPrelude_idx_1839, MFLAG_CONFIDENTIAL);
    reader1839->definitionModule = modulename;
    writer1839->definitionModule = modulename;
    reader1839->definitionLine = 853;
    writer1839->definitionLine = 853;
  }
  obj1836->flags |= OFLAG_MUTABLE;
  adddatum2(obj1836, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1840 = (struct UserObject*)obj1836;
  uo1840->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1840_asDebugString = addmethod2pos(obj1836, "asDebugString", &meth_collectionsPrelude_1840_asDebugString, 3);
  int argcv_meth_collectionsPrelude_1840_asDebugString[] = {0};
  meth_meth_collectionsPrelude_1840_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1840_asDebugString);
  meth_meth_collectionsPrelude_1840_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_1840_asDebugString->definitionLine = 854;
// method "asString"
  struct UserObject *uo1860 = (struct UserObject*)obj1836;
  uo1860->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1860_asString = addmethod2pos(obj1836, "asString", &meth_collectionsPrelude_1860_asString, 4);
  int argcv_meth_collectionsPrelude_1860_asString[] = {0};
  meth_meth_collectionsPrelude_1860_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1860_asString);
  meth_meth_collectionsPrelude_1860_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_1860_asString->definitionLine = 855;
// method "hasNext"
  struct UserObject *uo1862 = (struct UserObject*)obj1836;
  uo1862->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1862_hasNext = addmethod2pos(obj1836, "hasNext", &meth_collectionsPrelude_1862_hasNext, 5);
  int argcv_meth_collectionsPrelude_1862_hasNext[] = {0};
  meth_meth_collectionsPrelude_1862_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1862_hasNext);
  meth_meth_collectionsPrelude_1862_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_1862_hasNext->definitionLine = 856;
// method "next"
  block_savedest(obj1836);
  Object closure1872 = createclosure(2, "next");
  setclosureframe(closure1872, stackframe);
  addtoclosure(closure1872, var_ConcurrentModification);
  addtoclosure(closure1872, var_IteratorExhausted);
  struct UserObject *uo1872 = (struct UserObject*)obj1836;
  uo1872->data[6] = (Object)closure1872;
  Method *meth_meth_collectionsPrelude_1872_next = addmethod2pos(obj1836, "next", &meth_collectionsPrelude_1872_next, 6);
  int argcv_meth_collectionsPrelude_1872_next[] = {0};
  meth_meth_collectionsPrelude_1872_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1872_next);
  meth_meth_collectionsPrelude_1872_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_1872_next->definitionLine = 857;
  sourceObject = obj1836;
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe1914 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1915 = gc_frame_new();
// call case 3: self.outer request
  Object call1916 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1915);
// compiled member node returning call1916 (depth = 3)
  partcv[0] = 0;
  Object call1917 = callmethodflags(call1916, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1914);
// compiled member node returning call1917 (depth = 2)
  adddatum2(obj1836, call1917, 1);
  sourceObject = obj1836;
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num1918 = alloc_Float64(1);
// compiled num node returning num1918 (depth = 2)
  adddatum2(obj1836, num1918, 2);
  sourceObject = obj1836;
  sourceObject = obj1836;
  sourceObject = obj1836;
  sourceObject = obj1836;
  objclass1836 = obj1836->class;
  objclass1836->definitionModule = modulename;
  objclass1836->definitionLine = 851;
  (*(struct UserObject *)self).data[0] = lowerouter1836;
  self = oldself1836;
  selfslot = oldselfslot1836;
  stackframe = oldstackframe1836;
  gc_frame_end(frame);
  return obj1836;
}
Object meth_collectionsPrelude_1920_values(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1921_keys(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe1922 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1923 = callmethodflags(self, "indices", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1922);
// compiled member node returning call1923 (depth = 2)
  gc_frame_end(frame);
  return call1923;
}
Object meth_collectionsPrelude_1941__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_newInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1942 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 5)
  int callframe1943 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1944 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1945 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1944);
// compiled member node returning call1945 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1946 = callmethodflags(call1945, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1943);
// compiled call node returning call1946 (depth = 5)
  gc_frame_newslot(call1946);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newInner (depth = 5)
  params[0] = *var_i;
  params[1] = call1946;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1947 = callmethodflags(*var_newInner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1942);
// compiled call node returning call1947 (depth = 4)
  gc_frame_end(frame);
  return call1947;
}
Object meth_collectionsPrelude_1924_expandTo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "expandTo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expandTo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expandTo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_newSize = &(stackframe->slots[0]);
  *var_newSize = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part expandTo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1925 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newSize (depth = 4)
  gc_frame_newslot(*var_newSize);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1926 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1927 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1926);
// compiled member node returning call1927 (depth = 4)
  params[0] = *var_newSize;
  partcv[0] = 1;
  Object call1928 = callmethodflags(call1927, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1925);
// compiled call node returning call1928 (depth = 3)
  *var_newInner = call1928;
  if (call1928 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1929 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1932 = alloc_Float64(1);
// compiled num node returning num1932 (depth = 5)
  int op_slot_right_1931 = gc_frame_newslot(num1932);
// starting to compile member node (depth = 5)
  int callframe1934 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1935 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1934);
// compiled member node returning call1935 (depth = 5)
  int op_slot_left_1931 = gc_frame_newslot(call1935);
  params[0] = num1932;
  partcv[0] = 1;
  Object diff1936 = callmethod(call1935, "-(1)", 1, partcv, params);
// compiled op node returning diff1936 (depth = 4)
  int op_slot_right_1930 = gc_frame_newslot(diff1936);
// starting to compile num node (depth = 4)
  Object num1938 = alloc_Float64(0);
// compiled num node returning num1938 (depth = 4)
  int op_slot_left_1930 = gc_frame_newslot(num1938);
  params[0] = diff1936;
  partcv[0] = 1;
  Object opresult1939 = callmethod(num1938, "..(1)", 1, partcv, params);
// compiled op node returning opresult1939 (depth = 3)
  gc_frame_newslot(opresult1939);
// starting to compile block node (depth = 3)
  Object block1940 = alloc_Block(NULL, NULL, "collectionsPrelude", 876);
  gc_frame_newslot(block1940);
// method "_apply(_)"
  block_savedest(block1940);
  Object closure1941 = createclosure(2, "_apply(1)");
  setclosureframe(closure1941, stackframe);
  addtoclosure(closure1941, var_newInner);
  addtoclosure(closure1941, selfslot);
  struct UserObject *uo1941 = (struct UserObject*)block1940;
  uo1941->data[0] = (Object)closure1941;
  Method *meth_meth_collectionsPrelude_1941__apply_40_1_41_ = addmethod2pos(block1940, "_apply(1)", &meth_collectionsPrelude_1941__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_1941__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1941__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1941__apply_40_1_41_);
  meth_meth_collectionsPrelude_1941__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1941__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block1940 (depth = 3)
  gc_frame_newslot(block1940);
// call case 5: prelude request
  params[0] = opresult1939;
  params[1] = block1940;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1949 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1929);
// compiled call node returning call1949 (depth = 2)
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1950 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newInner (depth = 3)
  gc_frame_newslot(*var_newInner);
// call case 4: self request
  params[0] = *var_newInner;
  partcv[0] = 1;
  Object call1951 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1950);
// compiled call node returning call1951 (depth = 2)
  gc_frame_end(frame);
  return call1951;
}
Object meth_collectionsPrelude_1952_sortBy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortBy(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1953 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1955 = alloc_Float64(1);
// compiled num node returning num1955 (depth = 4)
  int op_slot_right_1954 = gc_frame_newslot(num1955);
// starting to compile member node (depth = 4)
  int callframe1957 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1958 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1957);
// compiled member node returning call1958 (depth = 4)
  int op_slot_left_1954 = gc_frame_newslot(call1958);
  params[0] = num1955;
  partcv[0] = 1;
  Object sum1959 = callmethod(call1958, "+(1)", 1, partcv, params);
// compiled op node returning sum1959 (depth = 3)
  gc_frame_newslot(sum1959);
// call case 4: self request
  params[0] = sum1959;
  partcv[0] = 1;
  Object call1960 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1953);
// compiled call node returning call1960 (depth = 2)
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1961 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe1962 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1963 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1962);
// compiled member node returning call1963 (depth = 3)
  gc_frame_newslot(call1963);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1964 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1965 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1964);
// compiled member node returning call1965 (depth = 3)
  params[0] = call1963;
  params[1] = *var_sortBlock;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1966 = callmethodflags(call1965, "sortInitial(1)by(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1961);
// compiled call node returning call1966 (depth = 2)
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_1970__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_r (depth = 6)
  int op_slot_right_1972 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  int op_slot_left_1972 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult1974 = callmethod(*var_l, "==(1)", 1, partcv, params);
// compiled op node returning opresult1974 (depth = 5)
  Object if1971 = done;
  if (istrue(opresult1974)) {
// starting to compile num node (depth = 5)
  Object num1975 = alloc_Float64(0);
// compiled num node returning num1975 (depth = 5)
    gc_frame_newslot(num1975);
    if1971 = num1975;
  } else {
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  int op_slot_right_1977 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  int op_slot_left_1977 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult1979 = callmethod(*var_l, "<(1)", 1, partcv, params);
// compiled op node returning opresult1979 (depth = 6)
  Object if1976 = done;
  if (istrue(opresult1979)) {
// starting to compile call node (depth = 6)
  int callframe1980 = gc_frame_new();
// call case 6: other requests
// starting to compile num node (depth = 7)
  Object num1981 = alloc_Float64(1);
// compiled num node returning num1981 (depth = 7)
  partcv[0] = 0;
  Object call1982 = callmethodflags(num1981, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe1980);
// compiled call node returning call1982 (depth = 6)
    gc_frame_newslot(call1982);
    if1976 = call1982;
  } else {
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1983 = alloc_Float64(1);
// compiled num node returning num1983 (depth = 6)
    gc_frame_newslot(num1983);
    if1976 = num1983;
  }
// compiled if node returning if1976 (depth = 5)
    gc_frame_newslot(if1976);
    if1971 = if1976;
  }
// compiled if node returning if1971 (depth = 4)
  gc_frame_end(frame);
  return if1971;
}
Object meth_collectionsPrelude_1967_sort(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sort");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1968 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1969 = alloc_Block(NULL, NULL, "collectionsPrelude", 887);
  gc_frame_newslot(block1969);
// method "_apply(_,_)"
  block_savedest(block1969);
  Object closure1970 = createclosure(1, "_apply(2)");
  setclosureframe(closure1970, stackframe);
  addtoclosure(closure1970, selfslot);
  struct UserObject *uo1970 = (struct UserObject*)block1969;
  uo1970->data[0] = (Object)closure1970;
  Method *meth_meth_collectionsPrelude_1970__apply_40_2_41_ = addmethod2pos(block1969, "_apply(2)", &meth_collectionsPrelude_1970__apply_40_2_41_, 0);
  int argcv_meth_collectionsPrelude_1970__apply_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_1970__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1970__apply_40_2_41_);
  meth_meth_collectionsPrelude_1970__apply_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1970__apply_40_2_41_->definitionLine = 1769;
// compiled block node returning block1969 (depth = 3)
  gc_frame_newslot(block1969);
// call case 4: self request
  params[0] = block1969;
  partcv[0] = 1;
  Object call1985 = callmethodflags(self, "sortBy(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1968);
// compiled call node returning call1985 (depth = 2)
  gc_frame_end(frame);
  return call1985;
}
Object meth_collectionsPrelude_1986_sortedBy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1987 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1988 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1989 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1988);
// compiled member node returning call1989 (depth = 3)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call1990 = callmethodflags(call1989, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1987);
// compiled call node returning call1990 (depth = 2)
  gc_frame_end(frame);
  return call1990;
}
Object meth_collectionsPrelude_1991_sorted(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe1992 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1993 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1994 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1993);
// compiled member node returning call1994 (depth = 3)
  partcv[0] = 0;
  Object call1995 = callmethodflags(call1994, "sort", 1, partcv, params, 0);
  gc_frame_end(callframe1992);
// compiled member node returning call1995 (depth = 2)
  gc_frame_end(frame);
  return call1995;
}
Object meth_collectionsPrelude_1996_copy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1997 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1998 = gc_frame_new();
// call case 3: self.outer request
  Object call1999 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1998);
// compiled member node returning call1999 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call2000 = callmethodflags(call1999, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1997);
// compiled call node returning call2000 (depth = 2)
  gc_frame_end(frame);
  return call2000;
}
Object meth_collectionsPrelude_2013__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe2014 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool2015 = alloc_Boolean(0);
// compiled identifier node returning bool2015 (depth = 7)
  gc_frame_newslot(bool2015);
// call case 4: self request
  params[0] = bool2015;
  partcv[0] = 1;
  Object call2016 = callmethodflags(self, "sizeCertain:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2014);
// compiled call node returning call2016 (depth = 6)
// starting to compile num node (depth = 6)
  Object num2017 = alloc_Float64(4);
// compiled num node returning num2017 (depth = 6)
  gc_frame_end(frame);
  return num2017;
}
Object meth_collectionsPrelude_2034__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2035 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2037 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2036);
// compiled member node returning call2037 (depth = 6)
  gc_frame_newslot(call2037);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2038 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2039 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2038);
// compiled member node returning call2039 (depth = 6)
  params[0] = call2037;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2040 = callmethodflags(call2039, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2035);
// compiled call node returning call2040 (depth = 5)
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2041 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2043 = alloc_Float64(1);
// compiled num node returning num2043 (depth = 7)
  int op_slot_right_2042 = gc_frame_newslot(num2043);
// starting to compile member node (depth = 7)
  int callframe2045 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2046 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2045);
// compiled member node returning call2046 (depth = 7)
  int op_slot_left_2042 = gc_frame_newslot(call2046);
  params[0] = num2043;
  partcv[0] = 1;
  Object sum2047 = callmethod(call2046, "+(1)", 1, partcv, params);
// compiled op node returning sum2047 (depth = 6)
  gc_frame_newslot(sum2047);
// call case 4: self request
  params[0] = sum2047;
  partcv[0] = 1;
  Object call2048 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2041);
// compiled call node returning call2048 (depth = 5)
  gc_frame_end(frame);
  return call2048;
}
Object meth_collectionsPrelude_2080__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_newInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2081 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 9)
  int callframe2082 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2083 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2084 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2083);
// compiled member node returning call2084 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2085 = callmethodflags(call2084, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2082);
// compiled call node returning call2085 (depth = 9)
  gc_frame_newslot(call2085);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newInner (depth = 9)
  params[0] = *var_i;
  params[1] = call2085;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2086 = callmethodflags(*var_newInner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2081);
// compiled call node returning call2086 (depth = 8)
  gc_frame_end(frame);
  return call2086;
}
Object meth_collectionsPrelude_2055__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_innerSize = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// definebindings:
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2059 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2058);
// compiled member node returning call2059 (depth = 7)
  int op_slot_right_2057 = gc_frame_newslot(call2059);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_innerSize (depth = 7)
  int op_slot_left_2057 = gc_frame_newslot(*var_innerSize);
  params[0] = call2059;
  partcv[0] = 1;
  Object opresult2061 = callmethod(*var_innerSize, "≤(1)", 1, partcv, params);
// compiled op node returning opresult2061 (depth = 6)
  Object if2056 = done;
  if (istrue(opresult2061)) {
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2062 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2064 = alloc_Float64(2);
// compiled num node returning num2064 (depth = 9)
  int op_slot_right_2063 = gc_frame_newslot(num2064);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_2063 = gc_frame_newslot(*var_innerSize);
  params[0] = num2064;
  partcv[0] = 1;
  Object prod2066 = callmethod(*var_innerSize, "*(1)", 1, partcv, params);
// compiled op node returning prod2066 (depth = 8)
  gc_frame_newslot(prod2066);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2067 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2068 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2067);
// compiled member node returning call2068 (depth = 8)
  params[0] = prod2066;
  partcv[0] = 1;
  Object call2069 = callmethodflags(call2068, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2062);
// compiled call node returning call2069 (depth = 7)
  *var_newInner = call2069;
  if (call2069 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2070 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2073 = alloc_Float64(1);
// compiled num node returning num2073 (depth = 9)
  int op_slot_right_2072 = gc_frame_newslot(num2073);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_2072 = gc_frame_newslot(*var_innerSize);
  params[0] = num2073;
  partcv[0] = 1;
  Object diff2075 = callmethod(*var_innerSize, "-(1)", 1, partcv, params);
// compiled op node returning diff2075 (depth = 8)
  int op_slot_right_2071 = gc_frame_newslot(diff2075);
// starting to compile num node (depth = 8)
  Object num2077 = alloc_Float64(0);
// compiled num node returning num2077 (depth = 8)
  int op_slot_left_2071 = gc_frame_newslot(num2077);
  params[0] = diff2075;
  partcv[0] = 1;
  Object opresult2078 = callmethod(num2077, "..(1)", 1, partcv, params);
// compiled op node returning opresult2078 (depth = 7)
  gc_frame_newslot(opresult2078);
// starting to compile block node (depth = 7)
  Object block2079 = alloc_Block(NULL, NULL, "collectionsPrelude", 650);
  gc_frame_newslot(block2079);
// method "_apply(_)"
  block_savedest(block2079);
  Object closure2080 = createclosure(2, "_apply(1)");
  setclosureframe(closure2080, stackframe);
  addtoclosure(closure2080, var_newInner);
  addtoclosure(closure2080, selfslot);
  struct UserObject *uo2080 = (struct UserObject*)block2079;
  uo2080->data[0] = (Object)closure2080;
  Method *meth_meth_collectionsPrelude_2080__apply_40_1_41_ = addmethod2pos(block2079, "_apply(1)", &meth_collectionsPrelude_2080__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2080__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2080__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2080__apply_40_1_41_);
  meth_meth_collectionsPrelude_2080__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2080__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2079 (depth = 7)
  gc_frame_newslot(block2079);
// call case 5: prelude request
  params[0] = opresult2078;
  params[1] = block2079;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2088 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2070);
// compiled call node returning call2088 (depth = 6)
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2089 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newInner (depth = 7)
  gc_frame_newslot(*var_newInner);
// call case 4: self request
  params[0] = *var_newInner;
  partcv[0] = 1;
  Object call2090 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2089);
// compiled call node returning call2090 (depth = 6)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2091 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2092 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2093 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2092);
// compiled member node returning call2093 (depth = 8)
  partcv[0] = 0;
  Object call2094 = callmethodflags(call2093, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2091);
// compiled member node returning call2094 (depth = 7)
  *var_innerSize = call2094;
  if (call2094 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2056 = done;
  } else {
  }
// compiled if node returning if2056 (depth = 5)
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2096 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2097 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2098 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2097);
// compiled member node returning call2098 (depth = 6)
  gc_frame_newslot(call2098);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2099 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2100 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2099);
// compiled member node returning call2100 (depth = 6)
  params[0] = call2098;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2101 = callmethodflags(call2100, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2096);
// compiled call node returning call2101 (depth = 5)
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2102 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2104 = alloc_Float64(1);
// compiled num node returning num2104 (depth = 7)
  int op_slot_right_2103 = gc_frame_newslot(num2104);
// starting to compile member node (depth = 7)
  int callframe2106 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2107 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2106);
// compiled member node returning call2107 (depth = 7)
  int op_slot_left_2103 = gc_frame_newslot(call2107);
  params[0] = num2104;
  partcv[0] = 1;
  Object sum2108 = callmethod(call2107, "+(1)", 1, partcv, params);
// compiled op node returning sum2108 (depth = 6)
  gc_frame_newslot(sum2108);
// call case 4: self request
  params[0] = sum2108;
  partcv[0] = 1;
  Object call2109 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2102);
// compiled call node returning call2109 (depth = 5)
  gc_frame_end(frame);
  return call2109;
}
Object meth_collectionsPrelude_1069_withAll_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_ConcurrentModification = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1070 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1070 = alloc_userobj2(46,43, objclass1070);
  gc_frame_newslot(obj1070);
  if (objclass1070 == NULL) {
    glfree(obj1070->class->name);
    obj1070->class->name = "list.withAll(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1070, self, 0);
  addmethodreal(obj1070,"outer", &reader_collectionsPrelude_outer_1071);
  Object oldself1070 = self;
  struct StackFrameObject *oldstackframe1070 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1070);
  gc_frame_newslot((Object)stackframe);
  self = obj1070;
  Object *oldselfslot1070 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1070 = (*(struct UserObject *)self).data[0], lowerouter1070 = thisouter1070;
  if (inheritingObject1070) {
    struct UserObject *inho1070 = (struct UserObject *)inheritingObject1070;
    while (inho1070->super != GraceDefaultObject) inho1070 = (struct UserObject *)inho1070->super;
    inho1070->super = obj1070;
    self = inheritingObject1070;
    *selfslot = self;
    lowerouter1070 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1070;
  }
  if (objclass1070 == NULL) {
    Method *reader1072 = addmethodrealflags(obj1070, "mods", &reader_collectionsPrelude_mods_1072, 0);
    Method *writer1072 = addmethodrealflags(obj1070, "mods:=(1)", &writer_collectionsPrelude_mods_1072, MFLAG_CONFIDENTIAL);
    reader1072->definitionModule = modulename;
    writer1072->definitionModule = modulename;
    reader1072->definitionLine = 632;
    writer1072->definitionLine = 632;
  }
  obj1070->flags |= OFLAG_MUTABLE;
  adddatum2(obj1070, alloc_Undefined(), 1);
  if (objclass1070 == NULL) {
    Method *reader1073 = addmethodrealflags(obj1070, "sizeCertain", &reader_collectionsPrelude_sizeCertain_1073, MFLAG_CONFIDENTIAL);
    Method *writer1073 = addmethodrealflags(obj1070, "sizeCertain:=(1)", &writer_collectionsPrelude_sizeCertain_1073, MFLAG_CONFIDENTIAL);
    reader1073->definitionModule = modulename;
    writer1073->definitionModule = modulename;
    reader1073->definitionLine = 633;
    writer1073->definitionLine = 633;
  }
  obj1070->flags |= OFLAG_MUTABLE;
  adddatum2(obj1070, alloc_Undefined(), 2);
  if (objclass1070 == NULL) {
  Method *reader1074 = addmethodrealflags(obj1070, "initialSize",&reader_collectionsPrelude_initialSize_1074, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader1074->definitionModule = modulename;
  reader1074->definitionLine = 635;
  }
  adddatum2(obj1070, alloc_Undefined(), 3);
  if (objclass1070 == NULL) {
    Method *reader1075 = addmethodrealflags(obj1070, "inner", &reader_collectionsPrelude_inner_1075, MFLAG_CONFIDENTIAL);
    Method *writer1075 = addmethodrealflags(obj1070, "inner:=(1)", &writer_collectionsPrelude_inner_1075, MFLAG_CONFIDENTIAL);
    reader1075->definitionModule = modulename;
    writer1075->definitionModule = modulename;
    reader1075->definitionLine = 636;
    writer1075->definitionLine = 636;
  }
  obj1070->flags |= OFLAG_MUTABLE;
  adddatum2(obj1070, alloc_Undefined(), 4);
  if (objclass1070 == NULL) {
    Method *reader1076 = addmethodrealflags(obj1070, "size", &reader_collectionsPrelude_size_1076, 0);
    Method *writer1076 = addmethodrealflags(obj1070, "size:=(1)", &writer_collectionsPrelude_size_1076, MFLAG_CONFIDENTIAL);
    reader1076->definitionModule = modulename;
    writer1076->definitionModule = modulename;
    reader1076->definitionLine = 637;
    writer1076->definitionLine = 637;
  }
  obj1070->flags |= OFLAG_MUTABLE;
  adddatum2(obj1070, alloc_Undefined(), 5);
// method "boundsCheck(_)"
  block_savedest(obj1070);
  Object closure1077 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure1077, stackframe);
  addtoclosure(closure1077, var_BoundsError);
  struct UserObject *uo1077 = (struct UserObject*)obj1070;
  uo1077->data[6] = (Object)closure1077;
  Method *meth_meth_collectionsPrelude_1077_boundsCheck_40_1_41_ = addmethod2pos(obj1070, "boundsCheck(1)", &meth_collectionsPrelude_1077_boundsCheck_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_1077_boundsCheck_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1077_boundsCheck_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1077_boundsCheck_40_1_41_);
  meth_meth_collectionsPrelude_1077_boundsCheck_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_1077_boundsCheck_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1077_boundsCheck_40_1_41_->definitionLine = 660;
// method "at(_)"
  struct UserObject *uo1114 = (struct UserObject*)obj1070;
  uo1114->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1114_at_40_1_41_ = addmethod2pos(obj1070, "at(1)", &meth_collectionsPrelude_1114_at_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_1114_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1114_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1114_at_40_1_41_);
  meth_meth_collectionsPrelude_1114_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1114_at_40_1_41_->definitionLine = 665;
// method "at(_)put(_)"
  struct UserObject *uo1125 = (struct UserObject*)obj1070;
  uo1125->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_ = addmethod2pos(obj1070, "at(1)put(1)", &meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_);
  meth_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_->definitionLine = 669;
// method "add(_)"
  struct UserObject *uo1156 = (struct UserObject*)obj1070;
  uo1156->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1156_add_40_1_41_ = addmethod2pos(obj1070, "add(1)", &meth_collectionsPrelude_1156_add_40_1_41_, 9);
  int argcv_meth_collectionsPrelude_1156_add_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1156_add_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1156_add_40_1_41_);
  meth_meth_collectionsPrelude_1156_add_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1156_add_40_1_41_->definitionLine = 679;
// method "addAll(_)"
  struct UserObject *uo1199 = (struct UserObject*)obj1070;
  uo1199->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1199_addAll_40_1_41_ = addmethod2pos(obj1070, "addAll(1)", &meth_collectionsPrelude_1199_addAll_40_1_41_, 10);
  int argcv_meth_collectionsPrelude_1199_addAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1199_addAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1199_addAll_40_1_41_);
  meth_meth_collectionsPrelude_1199_addAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1199_addAll_40_1_41_->definitionLine = 686;
// method "push(_)"
  struct UserObject *uo1259 = (struct UserObject*)obj1070;
  uo1259->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1259_push_40_1_41_ = addmethod2pos(obj1070, "push(1)", &meth_collectionsPrelude_1259_push_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_1259_push_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1259_push_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1259_push_40_1_41_);
  meth_meth_collectionsPrelude_1259_push_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1259_push_40_1_41_->definitionLine = 697;
// method "addLast(_)"
  struct UserObject *uo1302 = (struct UserObject*)obj1070;
  uo1302->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1302_addLast_40_1_41_ = addmethod2pos(obj1070, "addLast(1)", &meth_collectionsPrelude_1302_addLast_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_1302_addLast_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1302_addLast_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1302_addLast_40_1_41_);
  meth_meth_collectionsPrelude_1302_addLast_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1302_addLast_40_1_41_->definitionLine = 704;
// method "removeLast"
  struct UserObject *uo1305 = (struct UserObject*)obj1070;
  uo1305->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1305_removeLast = addmethod2pos(obj1070, "removeLast", &meth_collectionsPrelude_1305_removeLast, 13);
  int argcv_meth_collectionsPrelude_1305_removeLast[] = {0};
  meth_meth_collectionsPrelude_1305_removeLast->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1305_removeLast);
  meth_meth_collectionsPrelude_1305_removeLast->definitionModule = modulename;
  meth_meth_collectionsPrelude_1305_removeLast->definitionLine = 705;
// method "addAllFirst(_)"
  struct UserObject *uo1332 = (struct UserObject*)obj1070;
  uo1332->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1332_addAllFirst_40_1_41_ = addmethod2pos(obj1070, "addAllFirst(1)", &meth_collectionsPrelude_1332_addAllFirst_40_1_41_, 14);
  int argcv_meth_collectionsPrelude_1332_addAllFirst_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1332_addAllFirst_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1332_addAllFirst_40_1_41_);
  meth_meth_collectionsPrelude_1332_addAllFirst_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1332_addAllFirst_40_1_41_->definitionLine = 711;
// method "addFirst(_)"
  struct UserObject *uo1420 = (struct UserObject*)obj1070;
  uo1420->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1420_addFirst_40_1_41_ = addmethod2pos(obj1070, "addFirst(1)", &meth_collectionsPrelude_1420_addFirst_40_1_41_, 15);
  int argcv_meth_collectionsPrelude_1420_addFirst_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1420_addFirst_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1420_addFirst_40_1_41_);
  meth_meth_collectionsPrelude_1420_addFirst_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1420_addFirst_40_1_41_->definitionLine = 728;
// method "clear"
  struct UserObject *uo1492 = (struct UserObject*)obj1070;
  uo1492->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1492_clear = addmethod2pos(obj1070, "clear", &meth_collectionsPrelude_1492_clear, 16);
  int argcv_meth_collectionsPrelude_1492_clear[] = {0};
  meth_meth_collectionsPrelude_1492_clear->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1492_clear);
  meth_meth_collectionsPrelude_1492_clear->definitionModule = modulename;
  meth_meth_collectionsPrelude_1492_clear->definitionLine = 740;
// method "removeFirst"
  struct UserObject *uo1512 = (struct UserObject*)obj1070;
  uo1512->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1512_removeFirst = addmethod2pos(obj1070, "removeFirst", &meth_collectionsPrelude_1512_removeFirst, 17);
  int argcv_meth_collectionsPrelude_1512_removeFirst[] = {0};
  meth_meth_collectionsPrelude_1512_removeFirst->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1512_removeFirst);
  meth_meth_collectionsPrelude_1512_removeFirst->definitionModule = modulename;
  meth_meth_collectionsPrelude_1512_removeFirst->definitionLine = 746;
// method "removeAt(_)"
  struct UserObject *uo1516 = (struct UserObject*)obj1070;
  uo1516->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1516_removeAt_40_1_41_ = addmethod2pos(obj1070, "removeAt(1)", &meth_collectionsPrelude_1516_removeAt_40_1_41_, 18);
  int argcv_meth_collectionsPrelude_1516_removeAt_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1516_removeAt_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1516_removeAt_40_1_41_);
  meth_meth_collectionsPrelude_1516_removeAt_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1516_removeAt_40_1_41_->definitionLine = 749;
// method "remove(_)"
  block_savedest(obj1070);
  Object closure1569 = createclosure(1, "remove(1)");
  setclosureframe(closure1569, stackframe);
  addtoclosure(closure1569, var_NoSuchObject);
  struct UserObject *uo1569 = (struct UserObject*)obj1070;
  uo1569->data[19] = (Object)closure1569;
  Method *meth_meth_collectionsPrelude_1569_remove_40_1_41_ = addmethod2pos(obj1070, "remove(1)", &meth_collectionsPrelude_1569_remove_40_1_41_, 19);
  int argcv_meth_collectionsPrelude_1569_remove_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1569_remove_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1569_remove_40_1_41_);
  meth_meth_collectionsPrelude_1569_remove_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1569_remove_40_1_41_->definitionLine = 760;
// method "remove(_)ifAbsent(_)"
  struct UserObject *uo1587 = (struct UserObject*)obj1070;
  uo1587->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj1070, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_, 20);
  int argcv_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_->definitionLine = 768;
// method "removeAll(_)"
  block_savedest(obj1070);
  Object closure1597 = createclosure(1, "removeAll(1)");
  setclosureframe(closure1597, stackframe);
  addtoclosure(closure1597, var_NoSuchObject);
  struct UserObject *uo1597 = (struct UserObject*)obj1070;
  uo1597->data[21] = (Object)closure1597;
  Method *meth_meth_collectionsPrelude_1597_removeAll_40_1_41_ = addmethod2pos(obj1070, "removeAll(1)", &meth_collectionsPrelude_1597_removeAll_40_1_41_, 21);
  int argcv_meth_collectionsPrelude_1597_removeAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1597_removeAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1597_removeAll_40_1_41_);
  meth_meth_collectionsPrelude_1597_removeAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1597_removeAll_40_1_41_->definitionLine = 777;
// method "removeAll(_)ifAbsent(_)"
  struct UserObject *uo1606 = (struct UserObject*)obj1070;
  uo1606->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj1070, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_, 22);
  int argcv_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_->definitionLine = 781;
// method "pop"
  struct UserObject *uo1627 = (struct UserObject*)obj1070;
  uo1627->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1627_pop = addmethod2pos(obj1070, "pop", &meth_collectionsPrelude_1627_pop, 23);
  int argcv_meth_collectionsPrelude_1627_pop[] = {0};
  meth_meth_collectionsPrelude_1627_pop->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1627_pop);
  meth_meth_collectionsPrelude_1627_pop->definitionModule = modulename;
  meth_meth_collectionsPrelude_1627_pop->definitionLine = 792;
// method "reversed"
  struct UserObject *uo1630 = (struct UserObject*)obj1070;
  uo1630->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1630_reversed = addmethod2pos(obj1070, "reversed", &meth_collectionsPrelude_1630_reversed, 24);
  int argcv_meth_collectionsPrelude_1630_reversed[] = {0};
  meth_meth_collectionsPrelude_1630_reversed->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1630_reversed);
  meth_meth_collectionsPrelude_1630_reversed->definitionModule = modulename;
  meth_meth_collectionsPrelude_1630_reversed->definitionLine = 793;
// method "reverse"
  struct UserObject *uo1642 = (struct UserObject*)obj1070;
  uo1642->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1642_reverse = addmethod2pos(obj1070, "reverse", &meth_collectionsPrelude_1642_reverse, 25);
  int argcv_meth_collectionsPrelude_1642_reverse[] = {0};
  meth_meth_collectionsPrelude_1642_reverse->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1642_reverse);
  meth_meth_collectionsPrelude_1642_reverse->definitionModule = modulename;
  meth_meth_collectionsPrelude_1642_reverse->definitionLine = 798;
// method "++(_)"
  struct UserObject *uo1683 = (struct UserObject*)obj1070;
  uo1683->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1683__43__43__40_1_41_ = addmethod2pos(obj1070, "++(1)", &meth_collectionsPrelude_1683__43__43__40_1_41_, 26);
  int argcv_meth_collectionsPrelude_1683__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1683__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1683__43__43__40_1_41_);
  meth_meth_collectionsPrelude_1683__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1683__43__43__40_1_41_->definitionLine = 811;
// method "asString"
  struct UserObject *uo1690 = (struct UserObject*)obj1070;
  uo1690->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1690_asString = addmethod2pos(obj1070, "asString", &meth_collectionsPrelude_1690_asString, 27);
  int argcv_meth_collectionsPrelude_1690_asString[] = {0};
  meth_meth_collectionsPrelude_1690_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1690_asString);
  meth_meth_collectionsPrelude_1690_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_1690_asString->definitionLine = 815;
// method "asDebugString"
  struct UserObject *uo1736 = (struct UserObject*)obj1070;
  uo1736->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1736_asDebugString = addmethod2pos(obj1070, "asDebugString", &meth_collectionsPrelude_1736_asDebugString, 28);
  int argcv_meth_collectionsPrelude_1736_asDebugString[] = {0};
  meth_meth_collectionsPrelude_1736_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1736_asDebugString);
  meth_meth_collectionsPrelude_1736_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_1736_asDebugString->definitionLine = 823;
// method "contains(_)"
  struct UserObject *uo1782 = (struct UserObject*)obj1070;
  uo1782->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1782_contains_40_1_41_ = addmethod2pos(obj1070, "contains(1)", &meth_collectionsPrelude_1782_contains_40_1_41_, 29);
  int argcv_meth_collectionsPrelude_1782_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1782_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1782_contains_40_1_41_);
  meth_meth_collectionsPrelude_1782_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1782_contains_40_1_41_->definitionLine = 831;
// method "do(_)"
  block_savedest(obj1070);
  Object closure1794 = createclosure(1, "do(1)");
  setclosureframe(closure1794, stackframe);
  addtoclosure(closure1794, var_ConcurrentModification);
  struct UserObject *uo1794 = (struct UserObject*)obj1070;
  uo1794->data[30] = (Object)closure1794;
  Method *meth_meth_collectionsPrelude_1794_do_40_1_41_ = addmethod2pos(obj1070, "do(1)", &meth_collectionsPrelude_1794_do_40_1_41_, 30);
  int argcv_meth_collectionsPrelude_1794_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1794_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1794_do_40_1_41_);
  meth_meth_collectionsPrelude_1794_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1794_do_40_1_41_->definitionLine = 835;
// method "==(_)"
  struct UserObject *uo1832 = (struct UserObject*)obj1070;
  uo1832->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1832__61__61__40_1_41_ = addmethod2pos(obj1070, "==(1)", &meth_collectionsPrelude_1832__61__61__40_1_41_, 31);
  int argcv_meth_collectionsPrelude_1832__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1832__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1832__61__61__40_1_41_);
  meth_meth_collectionsPrelude_1832__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1832__61__61__40_1_41_->definitionLine = 847;
// method "iterator"
  block_savedest(obj1070);
  Object closure1835 = createclosure(2, "iterator");
  setclosureframe(closure1835, stackframe);
  addtoclosure(closure1835, var_ConcurrentModification);
  addtoclosure(closure1835, var_IteratorExhausted);
  struct UserObject *uo1835 = (struct UserObject*)obj1070;
  uo1835->data[32] = (Object)closure1835;
  Method *meth_meth_collectionsPrelude_1835_iterator = addmethod2pos(obj1070, "iterator", &meth_collectionsPrelude_1835_iterator, 32);
  int argcv_meth_collectionsPrelude_1835_iterator[] = {0};
  meth_meth_collectionsPrelude_1835_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1835_iterator);
  meth_meth_collectionsPrelude_1835_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_1835_iterator->definitionLine = 850;
  block_savedest(obj1070);
  Object closure1919 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure1919, stackframe);
  addtoclosure(closure1919, var_ConcurrentModification);
  addtoclosure(closure1919, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_1835_iterator_object = addmethod2pos(obj1070, "iterator$object(1)", &meth_collectionsPrelude_1835_iterator_object, 32);
  meth_meth_collectionsPrelude_1835_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_1835_iterator_object->definitionLine = 850;
// method "values"
  struct UserObject *uo1920 = (struct UserObject*)obj1070;
  uo1920->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1920_values = addmethod2pos(obj1070, "values", &meth_collectionsPrelude_1920_values, 33);
  int argcv_meth_collectionsPrelude_1920_values[] = {0};
  meth_meth_collectionsPrelude_1920_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1920_values);
  meth_meth_collectionsPrelude_1920_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_1920_values->definitionLine = 868;
// method "keys"
  struct UserObject *uo1921 = (struct UserObject*)obj1070;
  uo1921->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1921_keys = addmethod2pos(obj1070, "keys", &meth_collectionsPrelude_1921_keys, 34);
  int argcv_meth_collectionsPrelude_1921_keys[] = {0};
  meth_meth_collectionsPrelude_1921_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1921_keys);
  meth_meth_collectionsPrelude_1921_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_1921_keys->definitionLine = 871;
// method "expandTo(_)"
  struct UserObject *uo1924 = (struct UserObject*)obj1070;
  uo1924->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1924_expandTo_40_1_41_ = addmethod2pos(obj1070, "expandTo(1)", &meth_collectionsPrelude_1924_expandTo_40_1_41_, 35);
  int argcv_meth_collectionsPrelude_1924_expandTo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1924_expandTo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1924_expandTo_40_1_41_);
  meth_meth_collectionsPrelude_1924_expandTo_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_1924_expandTo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1924_expandTo_40_1_41_->definitionLine = 874;
// method "sortBy(_)"
  struct UserObject *uo1952 = (struct UserObject*)obj1070;
  uo1952->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1952_sortBy_40_1_41_ = addmethod2pos(obj1070, "sortBy(1)", &meth_collectionsPrelude_1952_sortBy_40_1_41_, 36);
  int argcv_meth_collectionsPrelude_1952_sortBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1952_sortBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1952_sortBy_40_1_41_);
  meth_meth_collectionsPrelude_1952_sortBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1952_sortBy_40_1_41_->definitionLine = 881;
// method "sort"
  struct UserObject *uo1967 = (struct UserObject*)obj1070;
  uo1967->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1967_sort = addmethod2pos(obj1070, "sort", &meth_collectionsPrelude_1967_sort, 37);
  int argcv_meth_collectionsPrelude_1967_sort[] = {0};
  meth_meth_collectionsPrelude_1967_sort->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1967_sort);
  meth_meth_collectionsPrelude_1967_sort->definitionModule = modulename;
  meth_meth_collectionsPrelude_1967_sort->definitionLine = 886;
// method "sortedBy(_)"
  struct UserObject *uo1986 = (struct UserObject*)obj1070;
  uo1986->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1986_sortedBy_40_1_41_ = addmethod2pos(obj1070, "sortedBy(1)", &meth_collectionsPrelude_1986_sortedBy_40_1_41_, 38);
  int argcv_meth_collectionsPrelude_1986_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1986_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1986_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_1986_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1986_sortedBy_40_1_41_->definitionLine = 893;
// method "sorted"
  struct UserObject *uo1991 = (struct UserObject*)obj1070;
  uo1991->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1991_sorted = addmethod2pos(obj1070, "sorted", &meth_collectionsPrelude_1991_sorted, 39);
  int argcv_meth_collectionsPrelude_1991_sorted[] = {0};
  meth_meth_collectionsPrelude_1991_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1991_sorted);
  meth_meth_collectionsPrelude_1991_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_1991_sorted->definitionLine = 896;
// method "copy"
  struct UserObject *uo1996 = (struct UserObject*)obj1070;
  uo1996->data[40] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1996_copy = addmethod2pos(obj1070, "copy", &meth_collectionsPrelude_1996_copy, 40);
  int argcv_meth_collectionsPrelude_1996_copy[] = {0};
  meth_meth_collectionsPrelude_1996_copy->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1996_copy);
  meth_meth_collectionsPrelude_1996_copy->definitionModule = modulename;
  meth_meth_collectionsPrelude_1996_copy->definitionLine = 899;
  sourceObject = obj1070;
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2001 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2002 = callmethodflags(module_collectionsPrelude, "indexable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2001);
// compiled call node returning call2002 (depth = 2)
  struct UserObject *obj1070_uo = (struct UserObject *)obj1070;
  obj1070_uo->super = call2002;
  sourceObject = obj1070;
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2003 = alloc_Float64(0);
// compiled num node returning num2003 (depth = 2)
  adddatum2(obj1070, num2003, 1);
  sourceObject = obj1070;
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2004 = alloc_Boolean(1);
// compiled identifier node returning bool2004 (depth = 2)
  adddatum2(obj1070, bool2004, 2);
  sourceObject = obj1070;
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2006 = alloc_Float64(1);
// compiled num node returning num2006 (depth = 3)
  int op_slot_right_2005 = gc_frame_newslot(num2006);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2009 = alloc_Float64(2);
// compiled num node returning num2009 (depth = 4)
  int op_slot_right_2008 = gc_frame_newslot(num2009);
// starting to compile call node (depth = 4)
  int callframe2011 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2012 = alloc_Block(NULL, NULL, "collectionsPrelude", 635);
  gc_frame_newslot(block2012);
// method "_apply"
  block_savedest(block2012);
  Object closure2013 = createclosure(1, "_apply");
  setclosureframe(closure2013, stackframe);
  addtoclosure(closure2013, selfslot);
  struct UserObject *uo2013 = (struct UserObject*)block2012;
  uo2013->data[0] = (Object)closure2013;
  Method *meth_meth_collectionsPrelude_2013__apply = addmethod2pos(block2012, "_apply", &meth_collectionsPrelude_2013__apply, 0);
  int argcv_meth_collectionsPrelude_2013__apply[] = {0};
  meth_meth_collectionsPrelude_2013__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2013__apply);
  meth_meth_collectionsPrelude_2013__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2013__apply->definitionLine = 1769;
// compiled block node returning block2012 (depth = 5)
  gc_frame_newslot(block2012);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  params[0] = block2012;
  partcv[0] = 1;
  Object call2019 = callmethodflags(*var_a, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2011);
// compiled call node returning call2019 (depth = 4)
  int op_slot_left_2008 = gc_frame_newslot(call2019);
  params[0] = num2009;
  partcv[0] = 1;
  Object prod2020 = callmethod(call2019, "*(1)", 1, partcv, params);
// compiled op node returning prod2020 (depth = 3)
  int op_slot_left_2005 = gc_frame_newslot(prod2020);
  params[0] = num2006;
  partcv[0] = 1;
  Object sum2021 = callmethod(prod2020, "+(1)", 1, partcv, params);
// compiled op node returning sum2021 (depth = 2)
  adddatum2(obj1070, sum2021, 3);
  sourceObject = obj1070;
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2022 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2023 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2024 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2023);
// compiled member node returning call2024 (depth = 3)
  gc_frame_newslot(call2024);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2025 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2026 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2025);
// compiled member node returning call2026 (depth = 3)
  params[0] = call2024;
  partcv[0] = 1;
  Object call2027 = callmethodflags(call2026, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2022);
// compiled call node returning call2027 (depth = 2)
  adddatum2(obj1070, call2027, 4);
  sourceObject = obj1070;
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2028 = alloc_Float64(0);
// compiled num node returning num2028 (depth = 2)
  adddatum2(obj1070, num2028, 5);
  sourceObject = obj1070;
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2030 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2031 = callmethodflags(self, "sizeCertain", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2030);
// compiled member node returning call2031 (depth = 3)
  Object if2029 = done;
struct StackFrameObject *iftmpstackframe2029 = stackframe;
  if (istrue(call2031)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2029);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2032 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2033 = alloc_Block(NULL, NULL, "collectionsPrelude", 640);
  gc_frame_newslot(block2033);
// method "_apply(_)"
  block_savedest(block2033);
  Object closure2034 = createclosure(1, "_apply(1)");
  setclosureframe(closure2034, stackframe);
  addtoclosure(closure2034, selfslot);
  struct UserObject *uo2034 = (struct UserObject*)block2033;
  uo2034->data[0] = (Object)closure2034;
  Method *meth_meth_collectionsPrelude_2034__apply_40_1_41_ = addmethod2pos(block2033, "_apply(1)", &meth_collectionsPrelude_2034__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2034__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2034__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2034__apply_40_1_41_);
  meth_meth_collectionsPrelude_2034__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2034__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2033 (depth = 4)
  gc_frame_newslot(block2033);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2033;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2050 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2032);
// compiled call node returning call2050 (depth = 3)
    gc_frame_newslot(call2050);
    if2029 = call2050;
  } else {
  stackframe = alloc_StackFrame(1, iftmpstackframe2029);
  gc_frame_newslot((Object)stackframe);
// definebindings:
  Object *var_innerSize = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "innerSize");
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2051 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2052 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2051);
// compiled member node returning call2052 (depth = 4)
  *var_innerSize = call2052;
  if (call2052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2053 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2054 = alloc_Block(NULL, NULL, "collectionsPrelude", 647);
  gc_frame_newslot(block2054);
// method "_apply(_)"
  block_savedest(block2054);
  Object closure2055 = createclosure(2, "_apply(1)");
  setclosureframe(closure2055, stackframe);
  addtoclosure(closure2055, var_innerSize);
  addtoclosure(closure2055, selfslot);
  struct UserObject *uo2055 = (struct UserObject*)block2054;
  uo2055->data[0] = (Object)closure2055;
  Method *meth_meth_collectionsPrelude_2055__apply_40_1_41_ = addmethod2pos(block2054, "_apply(1)", &meth_collectionsPrelude_2055__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2055__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2055__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2055__apply_40_1_41_);
  meth_meth_collectionsPrelude_2055__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2055__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2054 (depth = 4)
  gc_frame_newslot(block2054);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2054;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2111 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2053);
// compiled call node returning call2111 (depth = 3)
    gc_frame_newslot(call2111);
    if2029 = call2111;
  }
stackframe = iftmpstackframe2029;
// compiled if node returning if2029 (depth = 2)
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  objclass1070 = obj1070->class;
  objclass1070->definitionModule = modulename;
  objclass1070->definitionLine = 629;
  (*(struct UserObject *)self).data[0] = lowerouter1070;
  self = oldself1070;
  selfslot = oldselfslot1070;
  stackframe = oldstackframe1070;
  gc_frame_end(frame);
  return obj1070;
}
Object meth_collectionsPrelude_1069_withAll_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method withAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_ConcurrentModification = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1070 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1070 = alloc_userobj2(46,43, objclass1070);
  gc_frame_newslot(obj1070);
  if (objclass1070 == NULL) {
    glfree(obj1070->class->name);
    obj1070->class->name = "list.withAll(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1070, self, 0);
  addmethodreal(obj1070,"outer", &reader_collectionsPrelude_outer_1071);
  Object oldself1070 = self;
  struct StackFrameObject *oldstackframe1070 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1070);
  gc_frame_newslot((Object)stackframe);
  self = obj1070;
  Object *oldselfslot1070 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1070 = (*(struct UserObject *)self).data[0], lowerouter1070 = thisouter1070;
  if (inheritingObject1070) {
    struct UserObject *inho1070 = (struct UserObject *)inheritingObject1070;
    while (inho1070->super != GraceDefaultObject) inho1070 = (struct UserObject *)inho1070->super;
    inho1070->super = obj1070;
    self = inheritingObject1070;
    *selfslot = self;
    lowerouter1070 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1070;
  }
  if (objclass1070 == NULL) {
    Method *reader1072 = addmethodrealflags(obj1070, "mods", &reader_collectionsPrelude_mods_1072, 0);
    Method *writer1072 = addmethodrealflags(obj1070, "mods:=(1)", &writer_collectionsPrelude_mods_1072, MFLAG_CONFIDENTIAL);
    reader1072->definitionModule = modulename;
    writer1072->definitionModule = modulename;
    reader1072->definitionLine = 632;
    writer1072->definitionLine = 632;
  }
  obj1070->flags |= OFLAG_MUTABLE;
  adddatum2(obj1070, alloc_Undefined(), 1);
  if (objclass1070 == NULL) {
    Method *reader1073 = addmethodrealflags(obj1070, "sizeCertain", &reader_collectionsPrelude_sizeCertain_1073, MFLAG_CONFIDENTIAL);
    Method *writer1073 = addmethodrealflags(obj1070, "sizeCertain:=(1)", &writer_collectionsPrelude_sizeCertain_1073, MFLAG_CONFIDENTIAL);
    reader1073->definitionModule = modulename;
    writer1073->definitionModule = modulename;
    reader1073->definitionLine = 633;
    writer1073->definitionLine = 633;
  }
  obj1070->flags |= OFLAG_MUTABLE;
  adddatum2(obj1070, alloc_Undefined(), 2);
  if (objclass1070 == NULL) {
  Method *reader1074 = addmethodrealflags(obj1070, "initialSize",&reader_collectionsPrelude_initialSize_1074, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader1074->definitionModule = modulename;
  reader1074->definitionLine = 635;
  }
  adddatum2(obj1070, alloc_Undefined(), 3);
  if (objclass1070 == NULL) {
    Method *reader1075 = addmethodrealflags(obj1070, "inner", &reader_collectionsPrelude_inner_1075, MFLAG_CONFIDENTIAL);
    Method *writer1075 = addmethodrealflags(obj1070, "inner:=(1)", &writer_collectionsPrelude_inner_1075, MFLAG_CONFIDENTIAL);
    reader1075->definitionModule = modulename;
    writer1075->definitionModule = modulename;
    reader1075->definitionLine = 636;
    writer1075->definitionLine = 636;
  }
  obj1070->flags |= OFLAG_MUTABLE;
  adddatum2(obj1070, alloc_Undefined(), 4);
  if (objclass1070 == NULL) {
    Method *reader1076 = addmethodrealflags(obj1070, "size", &reader_collectionsPrelude_size_1076, 0);
    Method *writer1076 = addmethodrealflags(obj1070, "size:=(1)", &writer_collectionsPrelude_size_1076, MFLAG_CONFIDENTIAL);
    reader1076->definitionModule = modulename;
    writer1076->definitionModule = modulename;
    reader1076->definitionLine = 637;
    writer1076->definitionLine = 637;
  }
  obj1070->flags |= OFLAG_MUTABLE;
  adddatum2(obj1070, alloc_Undefined(), 5);
// method "boundsCheck(_)"
  block_savedest(obj1070);
  Object closure1077 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure1077, stackframe);
  addtoclosure(closure1077, var_BoundsError);
  struct UserObject *uo1077 = (struct UserObject*)obj1070;
  uo1077->data[6] = (Object)closure1077;
  Method *meth_meth_collectionsPrelude_1077_boundsCheck_40_1_41_ = addmethod2pos(obj1070, "boundsCheck(1)", &meth_collectionsPrelude_1077_boundsCheck_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_1077_boundsCheck_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1077_boundsCheck_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1077_boundsCheck_40_1_41_);
  meth_meth_collectionsPrelude_1077_boundsCheck_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_1077_boundsCheck_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1077_boundsCheck_40_1_41_->definitionLine = 660;
// method "at(_)"
  struct UserObject *uo1114 = (struct UserObject*)obj1070;
  uo1114->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1114_at_40_1_41_ = addmethod2pos(obj1070, "at(1)", &meth_collectionsPrelude_1114_at_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_1114_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1114_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1114_at_40_1_41_);
  meth_meth_collectionsPrelude_1114_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1114_at_40_1_41_->definitionLine = 665;
// method "at(_)put(_)"
  struct UserObject *uo1125 = (struct UserObject*)obj1070;
  uo1125->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_ = addmethod2pos(obj1070, "at(1)put(1)", &meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_);
  meth_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1125_at_40_1_41_put_40_1_41_->definitionLine = 669;
// method "add(_)"
  struct UserObject *uo1156 = (struct UserObject*)obj1070;
  uo1156->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1156_add_40_1_41_ = addmethod2pos(obj1070, "add(1)", &meth_collectionsPrelude_1156_add_40_1_41_, 9);
  int argcv_meth_collectionsPrelude_1156_add_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1156_add_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1156_add_40_1_41_);
  meth_meth_collectionsPrelude_1156_add_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1156_add_40_1_41_->definitionLine = 679;
// method "addAll(_)"
  struct UserObject *uo1199 = (struct UserObject*)obj1070;
  uo1199->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1199_addAll_40_1_41_ = addmethod2pos(obj1070, "addAll(1)", &meth_collectionsPrelude_1199_addAll_40_1_41_, 10);
  int argcv_meth_collectionsPrelude_1199_addAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1199_addAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1199_addAll_40_1_41_);
  meth_meth_collectionsPrelude_1199_addAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1199_addAll_40_1_41_->definitionLine = 686;
// method "push(_)"
  struct UserObject *uo1259 = (struct UserObject*)obj1070;
  uo1259->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1259_push_40_1_41_ = addmethod2pos(obj1070, "push(1)", &meth_collectionsPrelude_1259_push_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_1259_push_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1259_push_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1259_push_40_1_41_);
  meth_meth_collectionsPrelude_1259_push_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1259_push_40_1_41_->definitionLine = 697;
// method "addLast(_)"
  struct UserObject *uo1302 = (struct UserObject*)obj1070;
  uo1302->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1302_addLast_40_1_41_ = addmethod2pos(obj1070, "addLast(1)", &meth_collectionsPrelude_1302_addLast_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_1302_addLast_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1302_addLast_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1302_addLast_40_1_41_);
  meth_meth_collectionsPrelude_1302_addLast_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1302_addLast_40_1_41_->definitionLine = 704;
// method "removeLast"
  struct UserObject *uo1305 = (struct UserObject*)obj1070;
  uo1305->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1305_removeLast = addmethod2pos(obj1070, "removeLast", &meth_collectionsPrelude_1305_removeLast, 13);
  int argcv_meth_collectionsPrelude_1305_removeLast[] = {0};
  meth_meth_collectionsPrelude_1305_removeLast->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1305_removeLast);
  meth_meth_collectionsPrelude_1305_removeLast->definitionModule = modulename;
  meth_meth_collectionsPrelude_1305_removeLast->definitionLine = 705;
// method "addAllFirst(_)"
  struct UserObject *uo1332 = (struct UserObject*)obj1070;
  uo1332->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1332_addAllFirst_40_1_41_ = addmethod2pos(obj1070, "addAllFirst(1)", &meth_collectionsPrelude_1332_addAllFirst_40_1_41_, 14);
  int argcv_meth_collectionsPrelude_1332_addAllFirst_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1332_addAllFirst_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1332_addAllFirst_40_1_41_);
  meth_meth_collectionsPrelude_1332_addAllFirst_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1332_addAllFirst_40_1_41_->definitionLine = 711;
// method "addFirst(_)"
  struct UserObject *uo1420 = (struct UserObject*)obj1070;
  uo1420->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1420_addFirst_40_1_41_ = addmethod2pos(obj1070, "addFirst(1)", &meth_collectionsPrelude_1420_addFirst_40_1_41_, 15);
  int argcv_meth_collectionsPrelude_1420_addFirst_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1420_addFirst_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1420_addFirst_40_1_41_);
  meth_meth_collectionsPrelude_1420_addFirst_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1420_addFirst_40_1_41_->definitionLine = 728;
// method "clear"
  struct UserObject *uo1492 = (struct UserObject*)obj1070;
  uo1492->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1492_clear = addmethod2pos(obj1070, "clear", &meth_collectionsPrelude_1492_clear, 16);
  int argcv_meth_collectionsPrelude_1492_clear[] = {0};
  meth_meth_collectionsPrelude_1492_clear->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1492_clear);
  meth_meth_collectionsPrelude_1492_clear->definitionModule = modulename;
  meth_meth_collectionsPrelude_1492_clear->definitionLine = 740;
// method "removeFirst"
  struct UserObject *uo1512 = (struct UserObject*)obj1070;
  uo1512->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1512_removeFirst = addmethod2pos(obj1070, "removeFirst", &meth_collectionsPrelude_1512_removeFirst, 17);
  int argcv_meth_collectionsPrelude_1512_removeFirst[] = {0};
  meth_meth_collectionsPrelude_1512_removeFirst->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1512_removeFirst);
  meth_meth_collectionsPrelude_1512_removeFirst->definitionModule = modulename;
  meth_meth_collectionsPrelude_1512_removeFirst->definitionLine = 746;
// method "removeAt(_)"
  struct UserObject *uo1516 = (struct UserObject*)obj1070;
  uo1516->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1516_removeAt_40_1_41_ = addmethod2pos(obj1070, "removeAt(1)", &meth_collectionsPrelude_1516_removeAt_40_1_41_, 18);
  int argcv_meth_collectionsPrelude_1516_removeAt_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1516_removeAt_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1516_removeAt_40_1_41_);
  meth_meth_collectionsPrelude_1516_removeAt_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1516_removeAt_40_1_41_->definitionLine = 749;
// method "remove(_)"
  block_savedest(obj1070);
  Object closure1569 = createclosure(1, "remove(1)");
  setclosureframe(closure1569, stackframe);
  addtoclosure(closure1569, var_NoSuchObject);
  struct UserObject *uo1569 = (struct UserObject*)obj1070;
  uo1569->data[19] = (Object)closure1569;
  Method *meth_meth_collectionsPrelude_1569_remove_40_1_41_ = addmethod2pos(obj1070, "remove(1)", &meth_collectionsPrelude_1569_remove_40_1_41_, 19);
  int argcv_meth_collectionsPrelude_1569_remove_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1569_remove_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1569_remove_40_1_41_);
  meth_meth_collectionsPrelude_1569_remove_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1569_remove_40_1_41_->definitionLine = 760;
// method "remove(_)ifAbsent(_)"
  struct UserObject *uo1587 = (struct UserObject*)obj1070;
  uo1587->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj1070, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_, 20);
  int argcv_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1587_remove_40_1_41_ifAbsent_40_1_41_->definitionLine = 768;
// method "removeAll(_)"
  block_savedest(obj1070);
  Object closure1597 = createclosure(1, "removeAll(1)");
  setclosureframe(closure1597, stackframe);
  addtoclosure(closure1597, var_NoSuchObject);
  struct UserObject *uo1597 = (struct UserObject*)obj1070;
  uo1597->data[21] = (Object)closure1597;
  Method *meth_meth_collectionsPrelude_1597_removeAll_40_1_41_ = addmethod2pos(obj1070, "removeAll(1)", &meth_collectionsPrelude_1597_removeAll_40_1_41_, 21);
  int argcv_meth_collectionsPrelude_1597_removeAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1597_removeAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1597_removeAll_40_1_41_);
  meth_meth_collectionsPrelude_1597_removeAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1597_removeAll_40_1_41_->definitionLine = 777;
// method "removeAll(_)ifAbsent(_)"
  struct UserObject *uo1606 = (struct UserObject*)obj1070;
  uo1606->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj1070, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_, 22);
  int argcv_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1606_removeAll_40_1_41_ifAbsent_40_1_41_->definitionLine = 781;
// method "pop"
  struct UserObject *uo1627 = (struct UserObject*)obj1070;
  uo1627->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1627_pop = addmethod2pos(obj1070, "pop", &meth_collectionsPrelude_1627_pop, 23);
  int argcv_meth_collectionsPrelude_1627_pop[] = {0};
  meth_meth_collectionsPrelude_1627_pop->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1627_pop);
  meth_meth_collectionsPrelude_1627_pop->definitionModule = modulename;
  meth_meth_collectionsPrelude_1627_pop->definitionLine = 792;
// method "reversed"
  struct UserObject *uo1630 = (struct UserObject*)obj1070;
  uo1630->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1630_reversed = addmethod2pos(obj1070, "reversed", &meth_collectionsPrelude_1630_reversed, 24);
  int argcv_meth_collectionsPrelude_1630_reversed[] = {0};
  meth_meth_collectionsPrelude_1630_reversed->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1630_reversed);
  meth_meth_collectionsPrelude_1630_reversed->definitionModule = modulename;
  meth_meth_collectionsPrelude_1630_reversed->definitionLine = 793;
// method "reverse"
  struct UserObject *uo1642 = (struct UserObject*)obj1070;
  uo1642->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1642_reverse = addmethod2pos(obj1070, "reverse", &meth_collectionsPrelude_1642_reverse, 25);
  int argcv_meth_collectionsPrelude_1642_reverse[] = {0};
  meth_meth_collectionsPrelude_1642_reverse->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1642_reverse);
  meth_meth_collectionsPrelude_1642_reverse->definitionModule = modulename;
  meth_meth_collectionsPrelude_1642_reverse->definitionLine = 798;
// method "++(_)"
  struct UserObject *uo1683 = (struct UserObject*)obj1070;
  uo1683->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1683__43__43__40_1_41_ = addmethod2pos(obj1070, "++(1)", &meth_collectionsPrelude_1683__43__43__40_1_41_, 26);
  int argcv_meth_collectionsPrelude_1683__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1683__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1683__43__43__40_1_41_);
  meth_meth_collectionsPrelude_1683__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1683__43__43__40_1_41_->definitionLine = 811;
// method "asString"
  struct UserObject *uo1690 = (struct UserObject*)obj1070;
  uo1690->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1690_asString = addmethod2pos(obj1070, "asString", &meth_collectionsPrelude_1690_asString, 27);
  int argcv_meth_collectionsPrelude_1690_asString[] = {0};
  meth_meth_collectionsPrelude_1690_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1690_asString);
  meth_meth_collectionsPrelude_1690_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_1690_asString->definitionLine = 815;
// method "asDebugString"
  struct UserObject *uo1736 = (struct UserObject*)obj1070;
  uo1736->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1736_asDebugString = addmethod2pos(obj1070, "asDebugString", &meth_collectionsPrelude_1736_asDebugString, 28);
  int argcv_meth_collectionsPrelude_1736_asDebugString[] = {0};
  meth_meth_collectionsPrelude_1736_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1736_asDebugString);
  meth_meth_collectionsPrelude_1736_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_1736_asDebugString->definitionLine = 823;
// method "contains(_)"
  struct UserObject *uo1782 = (struct UserObject*)obj1070;
  uo1782->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1782_contains_40_1_41_ = addmethod2pos(obj1070, "contains(1)", &meth_collectionsPrelude_1782_contains_40_1_41_, 29);
  int argcv_meth_collectionsPrelude_1782_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1782_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1782_contains_40_1_41_);
  meth_meth_collectionsPrelude_1782_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1782_contains_40_1_41_->definitionLine = 831;
// method "do(_)"
  block_savedest(obj1070);
  Object closure1794 = createclosure(1, "do(1)");
  setclosureframe(closure1794, stackframe);
  addtoclosure(closure1794, var_ConcurrentModification);
  struct UserObject *uo1794 = (struct UserObject*)obj1070;
  uo1794->data[30] = (Object)closure1794;
  Method *meth_meth_collectionsPrelude_1794_do_40_1_41_ = addmethod2pos(obj1070, "do(1)", &meth_collectionsPrelude_1794_do_40_1_41_, 30);
  int argcv_meth_collectionsPrelude_1794_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1794_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1794_do_40_1_41_);
  meth_meth_collectionsPrelude_1794_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1794_do_40_1_41_->definitionLine = 835;
// method "==(_)"
  struct UserObject *uo1832 = (struct UserObject*)obj1070;
  uo1832->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1832__61__61__40_1_41_ = addmethod2pos(obj1070, "==(1)", &meth_collectionsPrelude_1832__61__61__40_1_41_, 31);
  int argcv_meth_collectionsPrelude_1832__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1832__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1832__61__61__40_1_41_);
  meth_meth_collectionsPrelude_1832__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1832__61__61__40_1_41_->definitionLine = 847;
// method "iterator"
  block_savedest(obj1070);
  Object closure1835 = createclosure(2, "iterator");
  setclosureframe(closure1835, stackframe);
  addtoclosure(closure1835, var_ConcurrentModification);
  addtoclosure(closure1835, var_IteratorExhausted);
  struct UserObject *uo1835 = (struct UserObject*)obj1070;
  uo1835->data[32] = (Object)closure1835;
  Method *meth_meth_collectionsPrelude_1835_iterator = addmethod2pos(obj1070, "iterator", &meth_collectionsPrelude_1835_iterator, 32);
  int argcv_meth_collectionsPrelude_1835_iterator[] = {0};
  meth_meth_collectionsPrelude_1835_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1835_iterator);
  meth_meth_collectionsPrelude_1835_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_1835_iterator->definitionLine = 850;
  block_savedest(obj1070);
  Object closure1919 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure1919, stackframe);
  addtoclosure(closure1919, var_ConcurrentModification);
  addtoclosure(closure1919, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_1835_iterator_object = addmethod2pos(obj1070, "iterator$object(1)", &meth_collectionsPrelude_1835_iterator_object, 32);
  meth_meth_collectionsPrelude_1835_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_1835_iterator_object->definitionLine = 850;
// method "values"
  struct UserObject *uo1920 = (struct UserObject*)obj1070;
  uo1920->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1920_values = addmethod2pos(obj1070, "values", &meth_collectionsPrelude_1920_values, 33);
  int argcv_meth_collectionsPrelude_1920_values[] = {0};
  meth_meth_collectionsPrelude_1920_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1920_values);
  meth_meth_collectionsPrelude_1920_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_1920_values->definitionLine = 868;
// method "keys"
  struct UserObject *uo1921 = (struct UserObject*)obj1070;
  uo1921->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1921_keys = addmethod2pos(obj1070, "keys", &meth_collectionsPrelude_1921_keys, 34);
  int argcv_meth_collectionsPrelude_1921_keys[] = {0};
  meth_meth_collectionsPrelude_1921_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1921_keys);
  meth_meth_collectionsPrelude_1921_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_1921_keys->definitionLine = 871;
// method "expandTo(_)"
  struct UserObject *uo1924 = (struct UserObject*)obj1070;
  uo1924->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1924_expandTo_40_1_41_ = addmethod2pos(obj1070, "expandTo(1)", &meth_collectionsPrelude_1924_expandTo_40_1_41_, 35);
  int argcv_meth_collectionsPrelude_1924_expandTo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1924_expandTo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1924_expandTo_40_1_41_);
  meth_meth_collectionsPrelude_1924_expandTo_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_1924_expandTo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1924_expandTo_40_1_41_->definitionLine = 874;
// method "sortBy(_)"
  struct UserObject *uo1952 = (struct UserObject*)obj1070;
  uo1952->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1952_sortBy_40_1_41_ = addmethod2pos(obj1070, "sortBy(1)", &meth_collectionsPrelude_1952_sortBy_40_1_41_, 36);
  int argcv_meth_collectionsPrelude_1952_sortBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1952_sortBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1952_sortBy_40_1_41_);
  meth_meth_collectionsPrelude_1952_sortBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1952_sortBy_40_1_41_->definitionLine = 881;
// method "sort"
  struct UserObject *uo1967 = (struct UserObject*)obj1070;
  uo1967->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1967_sort = addmethod2pos(obj1070, "sort", &meth_collectionsPrelude_1967_sort, 37);
  int argcv_meth_collectionsPrelude_1967_sort[] = {0};
  meth_meth_collectionsPrelude_1967_sort->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1967_sort);
  meth_meth_collectionsPrelude_1967_sort->definitionModule = modulename;
  meth_meth_collectionsPrelude_1967_sort->definitionLine = 886;
// method "sortedBy(_)"
  struct UserObject *uo1986 = (struct UserObject*)obj1070;
  uo1986->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1986_sortedBy_40_1_41_ = addmethod2pos(obj1070, "sortedBy(1)", &meth_collectionsPrelude_1986_sortedBy_40_1_41_, 38);
  int argcv_meth_collectionsPrelude_1986_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1986_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1986_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_1986_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1986_sortedBy_40_1_41_->definitionLine = 893;
// method "sorted"
  struct UserObject *uo1991 = (struct UserObject*)obj1070;
  uo1991->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1991_sorted = addmethod2pos(obj1070, "sorted", &meth_collectionsPrelude_1991_sorted, 39);
  int argcv_meth_collectionsPrelude_1991_sorted[] = {0};
  meth_meth_collectionsPrelude_1991_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1991_sorted);
  meth_meth_collectionsPrelude_1991_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_1991_sorted->definitionLine = 896;
// method "copy"
  struct UserObject *uo1996 = (struct UserObject*)obj1070;
  uo1996->data[40] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1996_copy = addmethod2pos(obj1070, "copy", &meth_collectionsPrelude_1996_copy, 40);
  int argcv_meth_collectionsPrelude_1996_copy[] = {0};
  meth_meth_collectionsPrelude_1996_copy->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1996_copy);
  meth_meth_collectionsPrelude_1996_copy->definitionModule = modulename;
  meth_meth_collectionsPrelude_1996_copy->definitionLine = 899;
  sourceObject = obj1070;
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2001 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2002 = callmethodflags(module_collectionsPrelude, "indexable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2001);
// compiled call node returning call2002 (depth = 2)
  struct UserObject *obj1070_uo = (struct UserObject *)obj1070;
  obj1070_uo->super = call2002;
  sourceObject = obj1070;
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2003 = alloc_Float64(0);
// compiled num node returning num2003 (depth = 2)
  adddatum2(obj1070, num2003, 1);
  sourceObject = obj1070;
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2004 = alloc_Boolean(1);
// compiled identifier node returning bool2004 (depth = 2)
  adddatum2(obj1070, bool2004, 2);
  sourceObject = obj1070;
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2006 = alloc_Float64(1);
// compiled num node returning num2006 (depth = 3)
  int op_slot_right_2005 = gc_frame_newslot(num2006);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2009 = alloc_Float64(2);
// compiled num node returning num2009 (depth = 4)
  int op_slot_right_2008 = gc_frame_newslot(num2009);
// starting to compile call node (depth = 4)
  int callframe2011 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2012 = alloc_Block(NULL, NULL, "collectionsPrelude", 635);
  gc_frame_newslot(block2012);
// method "_apply"
  block_savedest(block2012);
  Object closure2013 = createclosure(1, "_apply");
  setclosureframe(closure2013, stackframe);
  addtoclosure(closure2013, selfslot);
  struct UserObject *uo2013 = (struct UserObject*)block2012;
  uo2013->data[0] = (Object)closure2013;
  Method *meth_meth_collectionsPrelude_2013__apply = addmethod2pos(block2012, "_apply", &meth_collectionsPrelude_2013__apply, 0);
  int argcv_meth_collectionsPrelude_2013__apply[] = {0};
  meth_meth_collectionsPrelude_2013__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2013__apply);
  meth_meth_collectionsPrelude_2013__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2013__apply->definitionLine = 1769;
// compiled block node returning block2012 (depth = 5)
  gc_frame_newslot(block2012);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  params[0] = block2012;
  partcv[0] = 1;
  Object call2019 = callmethodflags(*var_a, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2011);
// compiled call node returning call2019 (depth = 4)
  int op_slot_left_2008 = gc_frame_newslot(call2019);
  params[0] = num2009;
  partcv[0] = 1;
  Object prod2020 = callmethod(call2019, "*(1)", 1, partcv, params);
// compiled op node returning prod2020 (depth = 3)
  int op_slot_left_2005 = gc_frame_newslot(prod2020);
  params[0] = num2006;
  partcv[0] = 1;
  Object sum2021 = callmethod(prod2020, "+(1)", 1, partcv, params);
// compiled op node returning sum2021 (depth = 2)
  adddatum2(obj1070, sum2021, 3);
  sourceObject = obj1070;
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2022 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2023 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2024 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2023);
// compiled member node returning call2024 (depth = 3)
  gc_frame_newslot(call2024);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2025 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2026 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2025);
// compiled member node returning call2026 (depth = 3)
  params[0] = call2024;
  partcv[0] = 1;
  Object call2027 = callmethodflags(call2026, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2022);
// compiled call node returning call2027 (depth = 2)
  adddatum2(obj1070, call2027, 4);
  sourceObject = obj1070;
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2028 = alloc_Float64(0);
// compiled num node returning num2028 (depth = 2)
  adddatum2(obj1070, num2028, 5);
  sourceObject = obj1070;
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2030 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2031 = callmethodflags(self, "sizeCertain", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2030);
// compiled member node returning call2031 (depth = 3)
  Object if2029 = done;
struct StackFrameObject *iftmpstackframe2029 = stackframe;
  if (istrue(call2031)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2029);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2032 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2033 = alloc_Block(NULL, NULL, "collectionsPrelude", 640);
  gc_frame_newslot(block2033);
// method "_apply(_)"
  block_savedest(block2033);
  Object closure2034 = createclosure(1, "_apply(1)");
  setclosureframe(closure2034, stackframe);
  addtoclosure(closure2034, selfslot);
  struct UserObject *uo2034 = (struct UserObject*)block2033;
  uo2034->data[0] = (Object)closure2034;
  Method *meth_meth_collectionsPrelude_2034__apply_40_1_41_ = addmethod2pos(block2033, "_apply(1)", &meth_collectionsPrelude_2034__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2034__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2034__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2034__apply_40_1_41_);
  meth_meth_collectionsPrelude_2034__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2034__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2033 (depth = 4)
  gc_frame_newslot(block2033);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2033;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2050 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2032);
// compiled call node returning call2050 (depth = 3)
    gc_frame_newslot(call2050);
    if2029 = call2050;
  } else {
  stackframe = alloc_StackFrame(1, iftmpstackframe2029);
  gc_frame_newslot((Object)stackframe);
// definebindings:
  Object *var_innerSize = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "innerSize");
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2051 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2052 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2051);
// compiled member node returning call2052 (depth = 4)
  *var_innerSize = call2052;
  if (call2052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2053 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2054 = alloc_Block(NULL, NULL, "collectionsPrelude", 647);
  gc_frame_newslot(block2054);
// method "_apply(_)"
  block_savedest(block2054);
  Object closure2055 = createclosure(2, "_apply(1)");
  setclosureframe(closure2055, stackframe);
  addtoclosure(closure2055, var_innerSize);
  addtoclosure(closure2055, selfslot);
  struct UserObject *uo2055 = (struct UserObject*)block2054;
  uo2055->data[0] = (Object)closure2055;
  Method *meth_meth_collectionsPrelude_2055__apply_40_1_41_ = addmethod2pos(block2054, "_apply(1)", &meth_collectionsPrelude_2055__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2055__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2055__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2055__apply_40_1_41_);
  meth_meth_collectionsPrelude_2055__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2055__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2054 (depth = 4)
  gc_frame_newslot(block2054);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2054;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2111 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2053);
// compiled call node returning call2111 (depth = 3)
    gc_frame_newslot(call2111);
    if2029 = call2111;
  }
stackframe = iftmpstackframe2029;
// compiled if node returning if2029 (depth = 2)
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  sourceObject = obj1070;
  objclass1070 = obj1070->class;
  objclass1070->definitionModule = modulename;
  objclass1070->definitionLine = 629;
  (*(struct UserObject *)self).data[0] = lowerouter1070;
  self = oldself1070;
  selfslot = oldselfslot1070;
  stackframe = oldstackframe1070;
  gc_frame_end(frame);
  return obj1070;
}
Object meth_collectionsPrelude_1061_list(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "list");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var_NoSuchObject = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1062 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1062 = alloc_userobj2(4,5, objclass1062);
  gc_frame_newslot(obj1062);
  if (objclass1062 == NULL) {
    glfree(obj1062->class->name);
    obj1062->class->name = "list";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1062, self, 0);
  addmethodreal(obj1062,"outer", &reader_collectionsPrelude_outer_1063);
  Object oldself1062 = self;
  struct StackFrameObject *oldstackframe1062 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1062);
  gc_frame_newslot((Object)stackframe);
  self = obj1062;
  Object *oldselfslot1062 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1062 = (*(struct UserObject *)self).data[0], lowerouter1062 = thisouter1062;
  if (inheritingObject1062) {
    struct UserObject *inho1062 = (struct UserObject *)inheritingObject1062;
    while (inho1062->super != GraceDefaultObject) inho1062 = (struct UserObject *)inho1062->super;
    inho1062->super = obj1062;
    self = inheritingObject1062;
    *selfslot = self;
    lowerouter1062 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1062;
  }
// method "asString"
  struct UserObject *uo1064 = (struct UserObject*)obj1062;
  uo1064->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1064_asString = addmethod2pos(obj1062, "asString", &meth_collectionsPrelude_1064_asString, 1);
  int argcv_meth_collectionsPrelude_1064_asString[] = {0};
  meth_meth_collectionsPrelude_1064_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1064_asString);
  meth_meth_collectionsPrelude_1064_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_1064_asString->definitionLine = 622;
// method "empty"
  block_savedest(obj1062);
  Object closure1066 = createclosure(1, "empty");
  setclosureframe(closure1066, stackframe);
  addtoclosure(closure1066, var_emptySequence);
  struct UserObject *uo1066 = (struct UserObject*)obj1062;
  uo1066->data[2] = (Object)closure1066;
  Method *meth_meth_collectionsPrelude_1066_empty = addmethod2pos(obj1062, "empty", &meth_collectionsPrelude_1066_empty, 2);
  int argcv_meth_collectionsPrelude_1066_empty[] = {0};
  meth_meth_collectionsPrelude_1066_empty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1066_empty);
  meth_meth_collectionsPrelude_1066_empty->definitionModule = modulename;
  meth_meth_collectionsPrelude_1066_empty->definitionLine = 624;
// method "withAll(_)"
  block_savedest(obj1062);
  Object closure1069 = createclosure(4, "withAll(1)");
  setclosureframe(closure1069, stackframe);
  addtoclosure(closure1069, var_BoundsError);
  addtoclosure(closure1069, var_NoSuchObject);
  addtoclosure(closure1069, var_ConcurrentModification);
  addtoclosure(closure1069, var_IteratorExhausted);
  struct UserObject *uo1069 = (struct UserObject*)obj1062;
  uo1069->data[3] = (Object)closure1069;
  Method *meth_meth_collectionsPrelude_1069_withAll_40_1_41_ = addmethod2pos(obj1062, "withAll(1)", &meth_collectionsPrelude_1069_withAll_40_1_41_, 3);
  int argcv_meth_collectionsPrelude_1069_withAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1069_withAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1069_withAll_40_1_41_);
  meth_meth_collectionsPrelude_1069_withAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1069_withAll_40_1_41_->definitionLine = 628;
  block_savedest(obj1062);
  Object closure2112 = createclosure(4, "withAll(1)$object(1)");
  setclosureframe(closure2112, stackframe);
  addtoclosure(closure2112, var_BoundsError);
  addtoclosure(closure2112, var_NoSuchObject);
  addtoclosure(closure2112, var_ConcurrentModification);
  addtoclosure(closure2112, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_1069_withAll_40_1_41__object = addmethod2pos(obj1062, "withAll(1)$object(1)", &meth_collectionsPrelude_1069_withAll_40_1_41__object, 3);
  meth_meth_collectionsPrelude_1069_withAll_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_1069_withAll_40_1_41__object->definitionLine = 628;
  sourceObject = obj1062;
  sourceObject = obj1062;
  sourceObject = obj1062;
  objclass1062 = obj1062->class;
  objclass1062->definitionModule = modulename;
  objclass1062->definitionLine = 620;
  (*(struct UserObject *)self).data[0] = lowerouter1062;
  self = oldself1062;
  selfslot = oldselfslot1062;
  stackframe = oldstackframe1062;
  gc_frame_end(frame);
  return obj1062;
}
Object meth_collectionsPrelude_1061_list_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "list$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var_NoSuchObject = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1062 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1062 = alloc_userobj2(4,5, objclass1062);
  gc_frame_newslot(obj1062);
  if (objclass1062 == NULL) {
    glfree(obj1062->class->name);
    obj1062->class->name = "list";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj1062, self, 0);
  addmethodreal(obj1062,"outer", &reader_collectionsPrelude_outer_1063);
  Object oldself1062 = self;
  struct StackFrameObject *oldstackframe1062 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1062);
  gc_frame_newslot((Object)stackframe);
  self = obj1062;
  Object *oldselfslot1062 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1062 = (*(struct UserObject *)self).data[0], lowerouter1062 = thisouter1062;
  if (inheritingObject1062) {
    struct UserObject *inho1062 = (struct UserObject *)inheritingObject1062;
    while (inho1062->super != GraceDefaultObject) inho1062 = (struct UserObject *)inho1062->super;
    inho1062->super = obj1062;
    self = inheritingObject1062;
    *selfslot = self;
    lowerouter1062 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1062;
  }
// method "asString"
  struct UserObject *uo1064 = (struct UserObject*)obj1062;
  uo1064->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_1064_asString = addmethod2pos(obj1062, "asString", &meth_collectionsPrelude_1064_asString, 1);
  int argcv_meth_collectionsPrelude_1064_asString[] = {0};
  meth_meth_collectionsPrelude_1064_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1064_asString);
  meth_meth_collectionsPrelude_1064_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_1064_asString->definitionLine = 622;
// method "empty"
  block_savedest(obj1062);
  Object closure1066 = createclosure(1, "empty");
  setclosureframe(closure1066, stackframe);
  addtoclosure(closure1066, var_emptySequence);
  struct UserObject *uo1066 = (struct UserObject*)obj1062;
  uo1066->data[2] = (Object)closure1066;
  Method *meth_meth_collectionsPrelude_1066_empty = addmethod2pos(obj1062, "empty", &meth_collectionsPrelude_1066_empty, 2);
  int argcv_meth_collectionsPrelude_1066_empty[] = {0};
  meth_meth_collectionsPrelude_1066_empty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1066_empty);
  meth_meth_collectionsPrelude_1066_empty->definitionModule = modulename;
  meth_meth_collectionsPrelude_1066_empty->definitionLine = 624;
// method "withAll(_)"
  block_savedest(obj1062);
  Object closure1069 = createclosure(4, "withAll(1)");
  setclosureframe(closure1069, stackframe);
  addtoclosure(closure1069, var_BoundsError);
  addtoclosure(closure1069, var_NoSuchObject);
  addtoclosure(closure1069, var_ConcurrentModification);
  addtoclosure(closure1069, var_IteratorExhausted);
  struct UserObject *uo1069 = (struct UserObject*)obj1062;
  uo1069->data[3] = (Object)closure1069;
  Method *meth_meth_collectionsPrelude_1069_withAll_40_1_41_ = addmethod2pos(obj1062, "withAll(1)", &meth_collectionsPrelude_1069_withAll_40_1_41_, 3);
  int argcv_meth_collectionsPrelude_1069_withAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_1069_withAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1069_withAll_40_1_41_);
  meth_meth_collectionsPrelude_1069_withAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1069_withAll_40_1_41_->definitionLine = 628;
  block_savedest(obj1062);
  Object closure2112 = createclosure(4, "withAll(1)$object(1)");
  setclosureframe(closure2112, stackframe);
  addtoclosure(closure2112, var_BoundsError);
  addtoclosure(closure2112, var_NoSuchObject);
  addtoclosure(closure2112, var_ConcurrentModification);
  addtoclosure(closure2112, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_1069_withAll_40_1_41__object = addmethod2pos(obj1062, "withAll(1)$object(1)", &meth_collectionsPrelude_1069_withAll_40_1_41__object, 3);
  meth_meth_collectionsPrelude_1069_withAll_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_1069_withAll_40_1_41__object->definitionLine = 628;
  sourceObject = obj1062;
  sourceObject = obj1062;
  sourceObject = obj1062;
  objclass1062 = obj1062->class;
  objclass1062->definitionModule = modulename;
  objclass1062->definitionLine = 620;
  (*(struct UserObject *)self).data[0] = lowerouter1062;
  self = oldself1062;
  selfslot = oldselfslot1062;
  stackframe = oldstackframe1062;
  gc_frame_end(frame);
  return obj1062;
}
Object meth_collectionsPrelude_2117_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2118 == NULL) {
    strlit2118 = alloc_String("a set class");
    gc_root(strlit2118);
  }
// compiled string node returning strlit2118 (depth = 2)
  gc_frame_end(frame);
  return strlit2118;
}
Object meth_collectionsPrelude_2129__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile num node (depth = 8)
  Object num2130 = alloc_Float64(2);
// compiled num node returning num2130 (depth = 8)
  gc_frame_end(frame);
  return num2130;
}
Object meth_collectionsPrelude_2141__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe2142 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2143 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2142);
// compiled call node returning call2143 (depth = 4)
  gc_frame_end(frame);
  return call2143;
}
Object meth_collectionsPrelude_2119_withAll_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_cap = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "cap");
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2120 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2122 = alloc_Float64(1);
// compiled num node returning num2122 (depth = 5)
  int op_slot_right_2121 = gc_frame_newslot(num2122);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2125 = alloc_Float64(3);
// compiled num node returning num2125 (depth = 6)
  int op_slot_right_2124 = gc_frame_newslot(num2125);
// starting to compile call node (depth = 6)
  int callframe2127 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2128 = alloc_Block(NULL, NULL, "collectionsPrelude", 928);
  gc_frame_newslot(block2128);
// method "_apply"
  block_savedest(block2128);
  Object closure2129 = createclosure(1, "_apply");
  setclosureframe(closure2129, stackframe);
  addtoclosure(closure2129, selfslot);
  struct UserObject *uo2129 = (struct UserObject*)block2128;
  uo2129->data[0] = (Object)closure2129;
  Method *meth_meth_collectionsPrelude_2129__apply = addmethod2pos(block2128, "_apply", &meth_collectionsPrelude_2129__apply, 0);
  int argcv_meth_collectionsPrelude_2129__apply[] = {0};
  meth_meth_collectionsPrelude_2129__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2129__apply);
  meth_meth_collectionsPrelude_2129__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2129__apply->definitionLine = 1769;
// compiled block node returning block2128 (depth = 7)
  gc_frame_newslot(block2128);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  params[0] = block2128;
  partcv[0] = 1;
  Object call2132 = callmethodflags(*var_a, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2127);
// compiled call node returning call2132 (depth = 6)
  int op_slot_left_2124 = gc_frame_newslot(call2132);
  params[0] = num2125;
  partcv[0] = 1;
  Object prod2133 = callmethod(call2132, "*(1)", 1, partcv, params);
// compiled op node returning prod2133 (depth = 5)
  int op_slot_left_2121 = gc_frame_newslot(prod2133);
  params[0] = num2122;
  partcv[0] = 1;
  Object sum2134 = callmethod(prod2133, "+(1)", 1, partcv, params);
// compiled op node returning sum2134 (depth = 4)
  gc_frame_newslot(sum2134);
// starting to compile num node (depth = 4)
  Object num2135 = alloc_Float64(8);
// compiled num node returning num2135 (depth = 4)
  gc_frame_newslot(num2135);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  params[0] = sum2134;
  params[1] = num2135;
  partcv[0] = 2;
  Object call2136 = callmethodflags(module_collectionsPrelude, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2120);
// compiled call node returning call2136 (depth = 3)
  *var_cap = call2136;
  if (call2136 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2137 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cap (depth = 4)
  gc_frame_newslot(*var_cap);
// call case 4: self request
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call2138 = callmethodflags(self, "ofCapacity(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2137);
// compiled call node returning call2138 (depth = 3)
  *var_result = call2138;
  if (call2138 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2139 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2140 = alloc_Block(NULL, NULL, "collectionsPrelude", 930);
  gc_frame_newslot(block2140);
// method "_apply(_)"
  block_savedest(block2140);
  Object closure2141 = createclosure(2, "_apply(1)");
  setclosureframe(closure2141, stackframe);
  addtoclosure(closure2141, var_result);
  addtoclosure(closure2141, selfslot);
  struct UserObject *uo2141 = (struct UserObject*)block2140;
  uo2141->data[0] = (Object)closure2141;
  Method *meth_meth_collectionsPrelude_2141__apply_40_1_41_ = addmethod2pos(block2140, "_apply(1)", &meth_collectionsPrelude_2141__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2141__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2141__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2141__apply_40_1_41_);
  meth_meth_collectionsPrelude_2141__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2141__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2140 (depth = 3)
  gc_frame_newslot(block2140);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
  params[0] = block2140;
  partcv[0] = 1;
  Object call2145 = callmethodflags(*var_a, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2139);
// compiled call node returning call2145 (depth = 2)
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_2146_empty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2147 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2148 = alloc_Float64(8);
// compiled num node returning num2148 (depth = 3)
  gc_frame_newslot(num2148);
// call case 4: self request
  params[0] = num2148;
  partcv[0] = 1;
  Object call2149 = callmethodflags(self, "ofCapacity(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2147);
// compiled call node returning call2149 (depth = 2)
  gc_frame_end(frame);
  return call2149;
}
Object meth_collectionsPrelude_2156_isEmpty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2158 = alloc_Float64(0);
// compiled num node returning num2158 (depth = 3)
  int op_slot_right_2157 = gc_frame_newslot(num2158);
// starting to compile member node (depth = 3)
  int callframe2160 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2161 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2160);
// compiled member node returning call2161 (depth = 3)
  int op_slot_left_2157 = gc_frame_newslot(call2161);
  params[0] = num2158;
  partcv[0] = 1;
  Object opresult2162 = callmethod(call2161, "==(1)", 1, partcv, params);
// compiled op node returning opresult2162 (depth = 2)
  gc_frame_end(frame);
  return opresult2162;
}
Object meth_collectionsPrelude_2174__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// definebindings:
// definebindings:
// definebindings:
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2176 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe2177 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2178 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2177);
// compiled call node returning call2178 (depth = 6)
  partcv[0] = 0;
  Object call2179 = callmethodflags(call2178, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe2176);
// compiled call node returning call2179 (depth = 5)
  Object if2175 = done;
  if (istrue(call2179)) {
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2180 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2181 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2180);
// compiled call node returning call2181 (depth = 6)
  *var_t = call2181;
  if (call2181 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2182 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2183 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2184 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2183);
// compiled member node returning call2184 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2185 = callmethodflags(call2184, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2182);
// compiled call node returning call2185 (depth = 5)
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2186 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2188 = alloc_Float64(1);
// compiled num node returning num2188 (depth = 7)
  int op_slot_right_2187 = gc_frame_newslot(num2188);
// starting to compile member node (depth = 7)
  int callframe2190 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2191 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2190);
// compiled member node returning call2191 (depth = 7)
  int op_slot_left_2187 = gc_frame_newslot(call2191);
  params[0] = num2188;
  partcv[0] = 1;
  Object sum2192 = callmethod(call2191, "+(1)", 1, partcv, params);
// compiled op node returning sum2192 (depth = 6)
  gc_frame_newslot(sum2192);
// call case 4: self request
  params[0] = sum2192;
  partcv[0] = 1;
  Object call2193 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2186);
// compiled call node returning call2193 (depth = 5)
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2197 = alloc_Float64(2);
// compiled num node returning num2197 (depth = 8)
  int op_slot_right_2196 = gc_frame_newslot(num2197);
// starting to compile member node (depth = 8)
  int callframe2199 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2200 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2201 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2200);
// compiled member node returning call2201 (depth = 9)
  partcv[0] = 0;
  Object call2202 = callmethodflags(call2201, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2199);
// compiled member node returning call2202 (depth = 8)
  int op_slot_left_2196 = gc_frame_newslot(call2202);
  params[0] = num2197;
  partcv[0] = 1;
  Object quotient2203 = callmethod(call2202, "/(1)", 1, partcv, params);
// compiled op node returning quotient2203 (depth = 7)
  int op_slot_right_2195 = gc_frame_newslot(quotient2203);
// starting to compile member node (depth = 7)
  int callframe2205 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2206 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2205);
// compiled member node returning call2206 (depth = 7)
  int op_slot_left_2195 = gc_frame_newslot(call2206);
  params[0] = quotient2203;
  partcv[0] = 1;
  Object opresult2207 = callmethod(call2206, ">(1)", 1, partcv, params);
// compiled op node returning opresult2207 (depth = 6)
  Object if2194 = done;
  if (istrue(opresult2207)) {
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2208 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2209 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2208);
// compiled member node returning call2209 (depth = 6)
    gc_frame_newslot(call2209);
    if2194 = call2209;
  } else {
  }
// compiled if node returning if2194 (depth = 5)
    gc_frame_newslot(if2194);
    if2175 = if2194;
  } else {
  }
// compiled if node returning if2175 (depth = 4)
  gc_frame_end(frame);
  return if2175;
}
Object meth_collectionsPrelude_2163_addAll_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2164 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2166 = alloc_Float64(1);
// compiled num node returning num2166 (depth = 4)
  int op_slot_right_2165 = gc_frame_newslot(num2166);
// starting to compile member node (depth = 4)
  int callframe2168 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2169 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2168);
// compiled member node returning call2169 (depth = 4)
  int op_slot_left_2165 = gc_frame_newslot(call2169);
  params[0] = num2166;
  partcv[0] = 1;
  Object sum2170 = callmethod(call2169, "+(1)", 1, partcv, params);
// compiled op node returning sum2170 (depth = 3)
  gc_frame_newslot(sum2170);
// call case 4: self request
  params[0] = sum2170;
  partcv[0] = 1;
  Object call2171 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2164);
// compiled call node returning call2171 (depth = 2)
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2172 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2173 = alloc_Block(NULL, NULL, "collectionsPrelude", 951);
  gc_frame_newslot(block2173);
// method "_apply(_)"
  block_savedest(block2173);
  Object closure2174 = createclosure(1, "_apply(1)");
  setclosureframe(closure2174, stackframe);
  addtoclosure(closure2174, selfslot);
  struct UserObject *uo2174 = (struct UserObject*)block2173;
  uo2174->data[0] = (Object)closure2174;
  Method *meth_meth_collectionsPrelude_2174__apply_40_1_41_ = addmethod2pos(block2173, "_apply(1)", &meth_collectionsPrelude_2174__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2174__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2174__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2174__apply_40_1_41_);
  meth_meth_collectionsPrelude_2174__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2174__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2173 (depth = 3)
  gc_frame_newslot(block2173);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2173;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2211 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2172);
// compiled call node returning call2211 (depth = 2)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_2212_add_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// definebindings:
// definebindings:
// definebindings:
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2214 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2215 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2216 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2215);
// compiled call node returning call2216 (depth = 4)
  partcv[0] = 0;
  Object call2217 = callmethodflags(call2216, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe2214);
// compiled call node returning call2217 (depth = 3)
  Object if2213 = done;
  if (istrue(call2217)) {
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2218 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2220 = alloc_Float64(1);
// compiled num node returning num2220 (depth = 5)
  int op_slot_right_2219 = gc_frame_newslot(num2220);
// starting to compile member node (depth = 5)
  int callframe2222 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2223 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2222);
// compiled member node returning call2223 (depth = 5)
  int op_slot_left_2219 = gc_frame_newslot(call2223);
  params[0] = num2220;
  partcv[0] = 1;
  Object sum2224 = callmethod(call2223, "+(1)", 1, partcv, params);
// compiled op node returning sum2224 (depth = 4)
  gc_frame_newslot(sum2224);
// call case 4: self request
  params[0] = sum2224;
  partcv[0] = 1;
  Object call2225 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2218);
// compiled call node returning call2225 (depth = 3)
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2226 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2227 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2226);
// compiled call node returning call2227 (depth = 4)
  *var_t = call2227;
  if (call2227 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2228 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2230 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2229);
// compiled member node returning call2230 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2231 = callmethodflags(call2230, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2228);
// compiled call node returning call2231 (depth = 3)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2232 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2234 = alloc_Float64(1);
// compiled num node returning num2234 (depth = 5)
  int op_slot_right_2233 = gc_frame_newslot(num2234);
// starting to compile member node (depth = 5)
  int callframe2236 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2237 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2236);
// compiled member node returning call2237 (depth = 5)
  int op_slot_left_2233 = gc_frame_newslot(call2237);
  params[0] = num2234;
  partcv[0] = 1;
  Object sum2238 = callmethod(call2237, "+(1)", 1, partcv, params);
// compiled op node returning sum2238 (depth = 4)
  gc_frame_newslot(sum2238);
// call case 4: self request
  params[0] = sum2238;
  partcv[0] = 1;
  Object call2239 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2232);
// compiled call node returning call2239 (depth = 3)
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2243 = alloc_Float64(2);
// compiled num node returning num2243 (depth = 6)
  int op_slot_right_2242 = gc_frame_newslot(num2243);
// starting to compile member node (depth = 6)
  int callframe2245 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2246 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2247 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2246);
// compiled member node returning call2247 (depth = 7)
  partcv[0] = 0;
  Object call2248 = callmethodflags(call2247, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2245);
// compiled member node returning call2248 (depth = 6)
  int op_slot_left_2242 = gc_frame_newslot(call2248);
  params[0] = num2243;
  partcv[0] = 1;
  Object quotient2249 = callmethod(call2248, "/(1)", 1, partcv, params);
// compiled op node returning quotient2249 (depth = 5)
  int op_slot_right_2241 = gc_frame_newslot(quotient2249);
// starting to compile member node (depth = 5)
  int callframe2251 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2252 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2251);
// compiled member node returning call2252 (depth = 5)
  int op_slot_left_2241 = gc_frame_newslot(call2252);
  params[0] = quotient2249;
  partcv[0] = 1;
  Object opresult2253 = callmethod(call2252, ">(1)", 1, partcv, params);
// compiled op node returning opresult2253 (depth = 4)
  Object if2240 = done;
  if (istrue(opresult2253)) {
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2254 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2255 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2254);
// compiled member node returning call2255 (depth = 4)
    gc_frame_newslot(call2255);
    if2240 = call2255;
  } else {
  }
// compiled if node returning if2240 (depth = 3)
    gc_frame_newslot(if2240);
    if2213 = if2240;
  } else {
  }
// compiled if node returning if2213 (depth = 2)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_2262__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2263 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2265 == NULL) {
    strlit2265 = alloc_String("");
    gc_root(strlit2265);
  }
// compiled string node returning strlit2265 (depth = 8)
  int op_slot_right_2264 = gc_frame_newslot(strlit2265);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_x (depth = 9)
  int op_slot_right_2267 = gc_frame_newslot(*var_x);
// starting to compile string node (depth = 9)
  if (strlit2269 == NULL) {
    strlit2269 = alloc_String("set does not contain ");
    gc_root(strlit2269);
  }
// compiled string node returning strlit2269 (depth = 9)
  int op_slot_left_2267 = gc_frame_newslot(strlit2269);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2270 = callmethod(strlit2269, "++(1)", 1, partcv, params);
// compiled op node returning opresult2270 (depth = 8)
  int op_slot_left_2264 = gc_frame_newslot(opresult2270);
  params[0] = strlit2265;
  partcv[0] = 1;
  Object opresult2271 = callmethod(opresult2270, "++(1)", 1, partcv, params);
// compiled op node returning opresult2271 (depth = 7)
  gc_frame_newslot(opresult2271);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_NoSuchObject (depth = 7)
  params[0] = opresult2271;
  partcv[0] = 1;
  Object call2272 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2263);
// compiled call node returning call2272 (depth = 6)
  gc_frame_end(frame);
  return call2272;
}
Object meth_collectionsPrelude_2259__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2260 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// starting to compile block node (depth = 5)
  Object block2261 = alloc_Block(NULL, NULL, "collectionsPrelude", 979);
  gc_frame_newslot(block2261);
// method "_apply"
  block_savedest(block2261);
  Object closure2262 = createclosure(3, "_apply");
  setclosureframe(closure2262, stackframe);
  addtoclosure(closure2262, var_x);
  addtoclosure(closure2262, var_NoSuchObject);
  addtoclosure(closure2262, selfslot);
  struct UserObject *uo2262 = (struct UserObject*)block2261;
  uo2262->data[0] = (Object)closure2262;
  Method *meth_meth_collectionsPrelude_2262__apply = addmethod2pos(block2261, "_apply", &meth_collectionsPrelude_2262__apply, 0);
  int argcv_meth_collectionsPrelude_2262__apply[] = {0};
  meth_meth_collectionsPrelude_2262__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2262__apply);
  meth_meth_collectionsPrelude_2262__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2262__apply->definitionLine = 1769;
// compiled block node returning block2261 (depth = 5)
  gc_frame_newslot(block2261);
// call case 4: self request
  params[0] = *var_x;
  params[1] = block2261;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2274 = callmethodflags(self, "remove(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2260);
// compiled call node returning call2274 (depth = 4)
  gc_frame_end(frame);
  return call2274;
}
Object meth_collectionsPrelude_2256_removeAll_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2257 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2258 = alloc_Block(NULL, NULL, "collectionsPrelude", 978);
  gc_frame_newslot(block2258);
// method "_apply(_)"
  block_savedest(block2258);
  Object closure2259 = createclosure(2, "_apply(1)");
  setclosureframe(closure2259, stackframe);
  addtoclosure(closure2259, var_NoSuchObject);
  addtoclosure(closure2259, selfslot);
  struct UserObject *uo2259 = (struct UserObject*)block2258;
  uo2259->data[0] = (Object)closure2259;
  Method *meth_meth_collectionsPrelude_2259__apply_40_1_41_ = addmethod2pos(block2258, "_apply(1)", &meth_collectionsPrelude_2259__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2259__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2259__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2259__apply_40_1_41_);
  meth_meth_collectionsPrelude_2259__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2259__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2258 (depth = 3)
  gc_frame_newslot(block2258);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2258;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2276 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2257);
// compiled call node returning call2276 (depth = 2)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_2288__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_block = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// definebindings:
// definebindings:
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2289 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2290 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2289);
// compiled call node returning call2290 (depth = 5)
  *var_t = call2290;
  if (call2290 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2292 = gc_frame_newslot(*var_x);
// starting to compile call node (depth = 6)
  int callframe2294 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2295 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2296 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2295);
// compiled member node returning call2296 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2297 = callmethodflags(call2296, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2294);
// compiled call node returning call2297 (depth = 6)
  int op_slot_left_2292 = gc_frame_newslot(call2297);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2298 = callmethod(call2297, "==(1)", 1, partcv, params);
// compiled op node returning opresult2298 (depth = 5)
  Object if2291 = done;
  if (istrue(opresult2298)) {
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2299 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2300 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2301 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2300);
// compiled member node returning call2301 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2302 = callmethodflags(call2301, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2299);
// compiled call node returning call2302 (depth = 5)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2303 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2305 = alloc_Float64(1);
// compiled num node returning num2305 (depth = 7)
  int op_slot_right_2304 = gc_frame_newslot(num2305);
// starting to compile member node (depth = 7)
  int callframe2307 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2308 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2307);
// compiled member node returning call2308 (depth = 7)
  int op_slot_left_2304 = gc_frame_newslot(call2308);
  params[0] = num2305;
  partcv[0] = 1;
  Object diff2309 = callmethod(call2308, "-(1)", 1, partcv, params);
// compiled op node returning diff2309 (depth = 6)
  gc_frame_newslot(diff2309);
// call case 4: self request
  params[0] = diff2309;
  partcv[0] = 1;
  Object call2310 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2303);
// compiled call node returning call2310 (depth = 5)
    gc_frame_newslot(call2310);
    if2291 = call2310;
  } else {
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2311 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block (depth = 6)
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2312 = callmethodflags(*var_block, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2311);
// compiled call node returning call2312 (depth = 5)
    gc_frame_newslot(call2312);
    if2291 = call2312;
  }
// compiled if node returning if2291 (depth = 4)
  gc_frame_end(frame);
  return if2291;
}
Object meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *var_block = &(stackframe->slots[1]);
  *var_block = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2278 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2280 = alloc_Float64(1);
// compiled num node returning num2280 (depth = 4)
  int op_slot_right_2279 = gc_frame_newslot(num2280);
// starting to compile member node (depth = 4)
  int callframe2282 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2283 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2282);
// compiled member node returning call2283 (depth = 4)
  int op_slot_left_2279 = gc_frame_newslot(call2283);
  params[0] = num2280;
  partcv[0] = 1;
  Object sum2284 = callmethod(call2283, "+(1)", 1, partcv, params);
// compiled op node returning sum2284 (depth = 3)
  gc_frame_newslot(sum2284);
// call case 4: self request
  params[0] = sum2284;
  partcv[0] = 1;
  Object call2285 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2278);
// compiled call node returning call2285 (depth = 2)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2286 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2287 = alloc_Block(NULL, NULL, "collectionsPrelude", 987);
  gc_frame_newslot(block2287);
// method "_apply(_)"
  block_savedest(block2287);
  Object closure2288 = createclosure(3, "_apply(1)");
  setclosureframe(closure2288, stackframe);
  addtoclosure(closure2288, var_removed);
  addtoclosure(closure2288, var_block);
  addtoclosure(closure2288, selfslot);
  struct UserObject *uo2288 = (struct UserObject*)block2287;
  uo2288->data[0] = (Object)closure2288;
  Method *meth_meth_collectionsPrelude_2288__apply_40_1_41_ = addmethod2pos(block2287, "_apply(1)", &meth_collectionsPrelude_2288__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2288__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2288__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2288__apply_40_1_41_);
  meth_meth_collectionsPrelude_2288__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2288__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2287 (depth = 3)
  gc_frame_newslot(block2287);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2287;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2314 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2286);
// compiled call node returning call2314 (depth = 2)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_2315_clear(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "clear");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_cap = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2316 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2318 = alloc_Float64(1);
// compiled num node returning num2318 (depth = 4)
  int op_slot_right_2317 = gc_frame_newslot(num2318);
// starting to compile member node (depth = 4)
  int callframe2320 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2321 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2320);
// compiled member node returning call2321 (depth = 4)
  int op_slot_left_2317 = gc_frame_newslot(call2321);
  params[0] = num2318;
  partcv[0] = 1;
  Object sum2322 = callmethod(call2321, "+(1)", 1, partcv, params);
// compiled op node returning sum2322 (depth = 3)
  gc_frame_newslot(sum2322);
// call case 4: self request
  params[0] = sum2322;
  partcv[0] = 1;
  Object call2323 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2316);
// compiled call node returning call2323 (depth = 2)
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2324 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe2325 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cap (depth = 4)
  gc_frame_newslot(*var_cap);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2326 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2327 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2326);
// compiled member node returning call2327 (depth = 4)
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call2328 = callmethodflags(call2327, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2325);
// compiled call node returning call2328 (depth = 3)
  gc_frame_newslot(call2328);
// call case 4: self request
  params[0] = call2328;
  partcv[0] = 1;
  Object call2329 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2324);
// compiled call node returning call2329 (depth = 2)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2330 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2331 = alloc_Float64(0);
// compiled num node returning num2331 (depth = 3)
  gc_frame_newslot(num2331);
// call case 4: self request
  params[0] = num2331;
  partcv[0] = 1;
  Object call2332 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2330);
// compiled call node returning call2332 (depth = 2)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *var_block = &(stackframe->slots[1]);
  *var_block = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// definebindings:
// definebindings:
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2334 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// call case 4: self request
  params[0] = *var_elt;
  partcv[0] = 1;
  Object call2335 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2334);
// compiled call node returning call2335 (depth = 3)
  *var_t = call2335;
  if (call2335 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  int op_slot_right_2337 = gc_frame_newslot(*var_elt);
// starting to compile call node (depth = 4)
  int callframe2339 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2340 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2341 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2340);
// compiled member node returning call2341 (depth = 5)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2342 = callmethodflags(call2341, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2339);
// compiled call node returning call2342 (depth = 4)
  int op_slot_left_2337 = gc_frame_newslot(call2342);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult2343 = callmethod(call2342, "==(1)", 1, partcv, params);
// compiled op node returning opresult2343 (depth = 3)
  Object if2336 = done;
  if (istrue(opresult2343)) {
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2344 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_removed (depth = 4)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2345 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2346 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2345);
// compiled member node returning call2346 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2347 = callmethodflags(call2346, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2344);
// compiled call node returning call2347 (depth = 3)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2348 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2350 = alloc_Float64(1);
// compiled num node returning num2350 (depth = 5)
  int op_slot_right_2349 = gc_frame_newslot(num2350);
// starting to compile member node (depth = 5)
  int callframe2352 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2353 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2352);
// compiled member node returning call2353 (depth = 5)
  int op_slot_left_2349 = gc_frame_newslot(call2353);
  params[0] = num2350;
  partcv[0] = 1;
  Object sum2354 = callmethod(call2353, "+(1)", 1, partcv, params);
// compiled op node returning sum2354 (depth = 4)
  gc_frame_newslot(sum2354);
// call case 4: self request
  params[0] = sum2354;
  partcv[0] = 1;
  Object call2355 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2348);
// compiled call node returning call2355 (depth = 3)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2356 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2358 = alloc_Float64(1);
// compiled num node returning num2358 (depth = 5)
  int op_slot_right_2357 = gc_frame_newslot(num2358);
// starting to compile member node (depth = 5)
  int callframe2360 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2361 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2360);
// compiled member node returning call2361 (depth = 5)
  int op_slot_left_2357 = gc_frame_newslot(call2361);
  params[0] = num2358;
  partcv[0] = 1;
  Object diff2362 = callmethod(call2361, "-(1)", 1, partcv, params);
// compiled op node returning diff2362 (depth = 4)
  gc_frame_newslot(diff2362);
// call case 4: self request
  params[0] = diff2362;
  partcv[0] = 1;
  Object call2363 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2356);
// compiled call node returning call2363 (depth = 3)
    gc_frame_newslot(call2363);
    if2336 = call2363;
  } else {
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2364 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_block (depth = 4)
  partcv[0] = 0;
  Object call2365 = callmethodflags(*var_block, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe2364);
// compiled member node returning call2365 (depth = 3)
    gc_frame_newslot(call2365);
    if2336 = call2365;
  }
// compiled if node returning if2336 (depth = 2)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_2369__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2370 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2372 == NULL) {
    strlit2372 = alloc_String("");
    gc_root(strlit2372);
  }
// compiled string node returning strlit2372 (depth = 6)
  int op_slot_right_2371 = gc_frame_newslot(strlit2372);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_elt (depth = 7)
  int op_slot_right_2374 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 7)
  if (strlit2376 == NULL) {
    strlit2376 = alloc_String("set does not contain ");
    gc_root(strlit2376);
  }
// compiled string node returning strlit2376 (depth = 7)
  int op_slot_left_2374 = gc_frame_newslot(strlit2376);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult2377 = callmethod(strlit2376, "++(1)", 1, partcv, params);
// compiled op node returning opresult2377 (depth = 6)
  int op_slot_left_2371 = gc_frame_newslot(opresult2377);
  params[0] = strlit2372;
  partcv[0] = 1;
  Object opresult2378 = callmethod(opresult2377, "++(1)", 1, partcv, params);
// compiled op node returning opresult2378 (depth = 5)
  gc_frame_newslot(opresult2378);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_NoSuchObject (depth = 5)
  params[0] = opresult2378;
  partcv[0] = 1;
  Object call2379 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2370);
// compiled call node returning call2379 (depth = 4)
  gc_frame_end(frame);
  return call2379;
}
Object meth_collectionsPrelude_2366_remove_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2367 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elt (depth = 3)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 3)
  Object block2368 = alloc_Block(NULL, NULL, "collectionsPrelude", 1018);
  gc_frame_newslot(block2368);
// method "_apply"
  block_savedest(block2368);
  Object closure2369 = createclosure(3, "_apply");
  setclosureframe(closure2369, stackframe);
  addtoclosure(closure2369, var_elt);
  addtoclosure(closure2369, var_NoSuchObject);
  addtoclosure(closure2369, selfslot);
  struct UserObject *uo2369 = (struct UserObject*)block2368;
  uo2369->data[0] = (Object)closure2369;
  Method *meth_meth_collectionsPrelude_2369__apply = addmethod2pos(block2368, "_apply", &meth_collectionsPrelude_2369__apply, 0);
  int argcv_meth_collectionsPrelude_2369__apply[] = {0};
  meth_meth_collectionsPrelude_2369__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2369__apply);
  meth_meth_collectionsPrelude_2369__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2369__apply->definitionLine = 1769;
// compiled block node returning block2368 (depth = 3)
  gc_frame_newslot(block2368);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block2368;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2381 = callmethodflags(self, "remove(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2367);
// compiled call node returning call2381 (depth = 2)
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_2382_contains_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// definebindings:
// definebindings:
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2383 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2384 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2383);
// compiled call node returning call2384 (depth = 3)
  *var_t = call2384;
  if (call2384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  int op_slot_right_2386 = gc_frame_newslot(*var_x);
// starting to compile call node (depth = 4)
  int callframe2388 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2389 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2390 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2389);
// compiled member node returning call2390 (depth = 5)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2391 = callmethodflags(call2390, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2388);
// compiled call node returning call2391 (depth = 4)
  int op_slot_left_2386 = gc_frame_newslot(call2391);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2392 = callmethod(call2391, "==(1)", 1, partcv, params);
// compiled op node returning opresult2392 (depth = 3)
  Object if2385 = done;
  if (istrue(opresult2392)) {
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool2393 = alloc_Boolean(1);
// compiled identifier node returning bool2393 (depth = 4)
  return bool2393;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if2385 = undefined;
  } else {
  }
// compiled if node returning if2385 (depth = 2)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2394 = alloc_Boolean(0);
// compiled identifier node returning bool2394 (depth = 3)
  return bool2394;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_2398__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_booleanBlock = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2400 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_booleanBlock (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2401 = callmethodflags(*var_booleanBlock, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2400);
// compiled call node returning call2401 (depth = 5)
  Object if2399 = done;
  if (istrue(call2401)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2402 = alloc_Boolean(1);
// compiled identifier node returning bool2402 (depth = 6)
  block_return(realself, bool2402);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2399 = undefined;
  } else {
  }
// compiled if node returning if2399 (depth = 4)
  gc_frame_end(frame);
  return if2399;
}
Object meth_collectionsPrelude_2395_includes_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "includes(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method includes(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for includes(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_booleanBlock = &(stackframe->slots[0]);
  *var_booleanBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part includes(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2396 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2397 = alloc_Block(NULL, NULL, "collectionsPrelude", 1032);
  gc_frame_newslot(block2397);
// method "_apply(_)"
  block_savedest(block2397);
  Object closure2398 = createclosure(2, "_apply(1)");
  setclosureframe(closure2398, stackframe);
  addtoclosure(closure2398, var_booleanBlock);
  addtoclosure(closure2398, selfslot);
  struct UserObject *uo2398 = (struct UserObject*)block2397;
  uo2398->data[0] = (Object)closure2398;
  Method *meth_meth_collectionsPrelude_2398__apply_40_1_41_ = addmethod2pos(block2397, "_apply(1)", &meth_collectionsPrelude_2398__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2398__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2398__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2398__apply_40_1_41_);
  meth_meth_collectionsPrelude_2398__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2398__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2397 (depth = 3)
  gc_frame_newslot(block2397);
// call case 4: self request
  params[0] = block2397;
  partcv[0] = 1;
  Object call2404 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2396);
// compiled call node returning call2404 (depth = 2)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2405 = alloc_Boolean(0);
// compiled identifier node returning bool2405 (depth = 3)
  return bool2405;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_2409__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_booleanBlock = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2411 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_booleanBlock (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2412 = callmethodflags(*var_booleanBlock, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2411);
// compiled call node returning call2412 (depth = 5)
  Object if2410 = done;
  if (istrue(call2412)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  block_return(realself, *var_each);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2410 = undefined;
  } else {
  }
// compiled if node returning if2410 (depth = 4)
  gc_frame_end(frame);
  return if2410;
}
Object meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "find(1)ifNone(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method find(_)ifNone(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method find(_)ifNone(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for find(_)ifNone(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_booleanBlock = &(stackframe->slots[0]);
  *var_booleanBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part find(_)");
  Object *var_notFoundBlock = &(stackframe->slots[1]);
  *var_notFoundBlock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifNone(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2407 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2408 = alloc_Block(NULL, NULL, "collectionsPrelude", 1038);
  gc_frame_newslot(block2408);
// method "_apply(_)"
  block_savedest(block2408);
  Object closure2409 = createclosure(2, "_apply(1)");
  setclosureframe(closure2409, stackframe);
  addtoclosure(closure2409, var_booleanBlock);
  addtoclosure(closure2409, selfslot);
  struct UserObject *uo2409 = (struct UserObject*)block2408;
  uo2409->data[0] = (Object)closure2409;
  Method *meth_meth_collectionsPrelude_2409__apply_40_1_41_ = addmethod2pos(block2408, "_apply(1)", &meth_collectionsPrelude_2409__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2409__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2409__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2409__apply_40_1_41_);
  meth_meth_collectionsPrelude_2409__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2409__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2408 (depth = 3)
  gc_frame_newslot(block2408);
// call case 4: self request
  params[0] = block2408;
  partcv[0] = 1;
  Object call2414 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2407);
// compiled call node returning call2414 (depth = 2)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2415 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_notFoundBlock (depth = 4)
  partcv[0] = 0;
  Object call2416 = callmethodflags(*var_notFoundBlock, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe2415);
// compiled member node returning call2416 (depth = 3)
  return call2416;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_2430__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2431 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2432 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2433 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2432);
// compiled member node returning call2433 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2434 = callmethodflags(call2433, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2431);
// compiled call node returning call2434 (depth = 5)
  *var_candidate = call2434;
  if (call2434 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_candidate (depth = 5)
  int op_slot_right_2436 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_2436 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2438 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2438 (depth = 4)
  gc_frame_end(frame);
  return opresult2438;
}
Object meth_collectionsPrelude_2441__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_jump = getfromclosure(closure, 3);
  Object *var_s = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2443 = gc_frame_newslot(*var_x);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2443 = gc_frame_newslot(*var_candidate);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2445 = callmethod(*var_candidate, "==(1)", 1, partcv, params);
// compiled op node returning opresult2445 (depth = 5)
  Object if2442 = done;
  if (istrue(opresult2445)) {
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2442 = undefined;
  } else {
  }
// compiled if node returning if2442 (depth = 4)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2448 = alloc_Float64(0);
// compiled num node returning num2448 (depth = 6)
  int op_slot_right_2447 = gc_frame_newslot(num2448);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_2447 = gc_frame_newslot(*var_jump);
  params[0] = num2448;
  partcv[0] = 1;
  Object opresult2450 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2450 (depth = 5)
  Object if2446 = done;
  if (istrue(opresult2450)) {
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2451 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2454 = alloc_Float64(1);
// compiled num node returning num2454 (depth = 8)
  int op_slot_right_2453 = gc_frame_newslot(num2454);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2457 = alloc_Float64(3);
// compiled num node returning num2457 (depth = 9)
  int op_slot_right_2456 = gc_frame_newslot(num2457);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_2456 = gc_frame_newslot(*var_t);
  params[0] = num2457;
  partcv[0] = 1;
  Object prod2459 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod2459 (depth = 8)
  int op_slot_left_2453 = gc_frame_newslot(prod2459);
  params[0] = num2454;
  partcv[0] = 1;
  Object sum2460 = callmethod(prod2459, "+(1)", 1, partcv, params);
// compiled op node returning sum2460 (depth = 7)
  int op_slot_left_2451 = gc_frame_newslot(sum2460);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2461 = callmethod(sum2460, "%(1)", 1, partcv, params);
// compiled op node returning modulus2461 (depth = 6)
  *var_t = modulus2461;
  if (modulus2461 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2464 = alloc_Float64(1);
// compiled num node returning num2464 (depth = 7)
  int op_slot_right_2463 = gc_frame_newslot(num2464);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_2463 = gc_frame_newslot(*var_jump);
  params[0] = num2464;
  partcv[0] = 1;
  Object diff2466 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff2466 (depth = 6)
  *var_jump = diff2466;
  if (diff2466 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2446 = done;
  } else {
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2468 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2471 = alloc_Float64(1);
// compiled num node returning num2471 (depth = 8)
  int op_slot_right_2470 = gc_frame_newslot(num2471);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_2470 = gc_frame_newslot(*var_t);
  params[0] = num2471;
  partcv[0] = 1;
  Object sum2473 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum2473 (depth = 7)
  int op_slot_left_2468 = gc_frame_newslot(sum2473);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2474 = callmethod(sum2473, "%(1)", 1, partcv, params);
// compiled op node returning modulus2474 (depth = 6)
  *var_t = modulus2474;
  if (modulus2474 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2446 = done;
  }
// compiled if node returning if2446 (depth = 4)
  gc_frame_end(frame);
  return if2446;
}
Object meth_collectionsPrelude_2417_findPosition_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPosition(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPosition(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPosition(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPosition(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
  Object *var_candidate = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "candidate");
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2418 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  partcv[0] = 0;
  Object call2419 = callmethodflags(*var_x, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe2418);
// compiled member node returning call2419 (depth = 3)
  *var_h = call2419;
  if (call2419 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2420 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2421 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2422 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2421);
// compiled member node returning call2422 (depth = 4)
  partcv[0] = 0;
  Object call2423 = callmethodflags(call2422, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2420);
// compiled member node returning call2423 (depth = 3)
  *var_s = call2423;
  if (call2423 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_2424 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_2424 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2426 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus2426 (depth = 3)
  *var_t = modulus2426;
  if (modulus2426 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2427 = alloc_Float64(5);
// compiled num node returning num2427 (depth = 3)
  *var_jump = num2427;
  if (num2427 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2428 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2429 = alloc_Block(NULL, NULL, "collectionsPrelude", 1049);
  gc_frame_newslot(block2429);
// method "_apply"
  block_savedest(block2429);
  Object closure2430 = createclosure(4, "_apply");
  setclosureframe(closure2430, stackframe);
  addtoclosure(closure2430, var_t);
  addtoclosure(closure2430, var_candidate);
  addtoclosure(closure2430, var_unused);
  addtoclosure(closure2430, selfslot);
  struct UserObject *uo2430 = (struct UserObject*)block2429;
  uo2430->data[0] = (Object)closure2430;
  Method *meth_meth_collectionsPrelude_2430__apply = addmethod2pos(block2429, "_apply", &meth_collectionsPrelude_2430__apply, 0);
  int argcv_meth_collectionsPrelude_2430__apply[] = {0};
  meth_meth_collectionsPrelude_2430__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2430__apply);
  meth_meth_collectionsPrelude_2430__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2430__apply->definitionLine = 1769;
// compiled block node returning block2429 (depth = 3)
  gc_frame_newslot(block2429);
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2440 = alloc_Block(NULL, NULL, "collectionsPrelude", 1052);
  gc_frame_newslot(block2440);
// method "_apply"
  block_savedest(block2440);
  Object closure2441 = createclosure(6, "_apply");
  setclosureframe(closure2441, stackframe);
  addtoclosure(closure2441, var_x);
  addtoclosure(closure2441, var_candidate);
  addtoclosure(closure2441, var_t);
  addtoclosure(closure2441, var_jump);
  addtoclosure(closure2441, var_s);
  addtoclosure(closure2441, selfslot);
  struct UserObject *uo2441 = (struct UserObject*)block2440;
  uo2441->data[0] = (Object)closure2441;
  Method *meth_meth_collectionsPrelude_2441__apply = addmethod2pos(block2440, "_apply", &meth_collectionsPrelude_2441__apply, 0);
  int argcv_meth_collectionsPrelude_2441__apply[] = {0};
  meth_meth_collectionsPrelude_2441__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2441__apply);
  meth_meth_collectionsPrelude_2441__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2441__apply->definitionLine = 1769;
// compiled block node returning block2440 (depth = 3)
  gc_frame_newslot(block2440);
// call case 5: prelude request
  params[0] = block2429;
  params[1] = block2440;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2477 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2428);
// compiled call node returning call2477 (depth = 2)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_2491__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2492 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2493 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2494 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2493);
// compiled member node returning call2494 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2495 = callmethodflags(call2494, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2492);
// compiled call node returning call2495 (depth = 5)
  *var_candidate = call2495;
  if (call2495 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2498 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_2498 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2500 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2500 (depth = 5)
  int op_slot_right_2497 = gc_frame_newslot(opresult2500);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2502 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_2502 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2504 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2504 (depth = 5)
  int op_slot_left_2497 = gc_frame_newslot(opresult2504);
  params[0] = opresult2500;
  partcv[0] = 1;
  Object opresult2505 = callmethod(opresult2504, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2505 (depth = 4)
  gc_frame_end(frame);
  return opresult2505;
}
Object meth_collectionsPrelude_2508__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_jump = getfromclosure(closure, 3);
  Object *var_s = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2510 = gc_frame_newslot(*var_x);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2510 = gc_frame_newslot(*var_candidate);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2512 = callmethod(*var_candidate, "==(1)", 1, partcv, params);
// compiled op node returning opresult2512 (depth = 5)
  Object if2509 = done;
  if (istrue(opresult2512)) {
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2509 = undefined;
  } else {
  }
// compiled if node returning if2509 (depth = 4)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2515 = alloc_Float64(0);
// compiled num node returning num2515 (depth = 6)
  int op_slot_right_2514 = gc_frame_newslot(num2515);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_2514 = gc_frame_newslot(*var_jump);
  params[0] = num2515;
  partcv[0] = 1;
  Object opresult2517 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2517 (depth = 5)
  Object if2513 = done;
  if (istrue(opresult2517)) {
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2518 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2521 = alloc_Float64(1);
// compiled num node returning num2521 (depth = 8)
  int op_slot_right_2520 = gc_frame_newslot(num2521);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2524 = alloc_Float64(3);
// compiled num node returning num2524 (depth = 9)
  int op_slot_right_2523 = gc_frame_newslot(num2524);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_2523 = gc_frame_newslot(*var_t);
  params[0] = num2524;
  partcv[0] = 1;
  Object prod2526 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod2526 (depth = 8)
  int op_slot_left_2520 = gc_frame_newslot(prod2526);
  params[0] = num2521;
  partcv[0] = 1;
  Object sum2527 = callmethod(prod2526, "+(1)", 1, partcv, params);
// compiled op node returning sum2527 (depth = 7)
  int op_slot_left_2518 = gc_frame_newslot(sum2527);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2528 = callmethod(sum2527, "%(1)", 1, partcv, params);
// compiled op node returning modulus2528 (depth = 6)
  *var_t = modulus2528;
  if (modulus2528 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2531 = alloc_Float64(1);
// compiled num node returning num2531 (depth = 7)
  int op_slot_right_2530 = gc_frame_newslot(num2531);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_2530 = gc_frame_newslot(*var_jump);
  params[0] = num2531;
  partcv[0] = 1;
  Object diff2533 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff2533 (depth = 6)
  *var_jump = diff2533;
  if (diff2533 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2513 = done;
  } else {
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2535 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2538 = alloc_Float64(1);
// compiled num node returning num2538 (depth = 8)
  int op_slot_right_2537 = gc_frame_newslot(num2538);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_2537 = gc_frame_newslot(*var_t);
  params[0] = num2538;
  partcv[0] = 1;
  Object sum2540 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum2540 (depth = 7)
  int op_slot_left_2535 = gc_frame_newslot(sum2540);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2541 = callmethod(sum2540, "%(1)", 1, partcv, params);
// compiled op node returning modulus2541 (depth = 6)
  *var_t = modulus2541;
  if (modulus2541 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2513 = done;
  }
// compiled if node returning if2513 (depth = 4)
  gc_frame_end(frame);
  return if2513;
}
Object meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPositionForAdd(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPositionForAdd(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPositionForAdd(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPositionForAdd(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
  Object *var_candidate = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "candidate");
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2479 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  partcv[0] = 0;
  Object call2480 = callmethodflags(*var_x, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe2479);
// compiled member node returning call2480 (depth = 3)
  *var_h = call2480;
  if (call2480 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2481 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2482 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2483 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2482);
// compiled member node returning call2483 (depth = 4)
  partcv[0] = 0;
  Object call2484 = callmethodflags(call2483, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2481);
// compiled member node returning call2484 (depth = 3)
  *var_s = call2484;
  if (call2484 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_2485 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_2485 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2487 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus2487 (depth = 3)
  *var_t = modulus2487;
  if (modulus2487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2488 = alloc_Float64(5);
// compiled num node returning num2488 (depth = 3)
  *var_jump = num2488;
  if (num2488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2489 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2490 = alloc_Block(NULL, NULL, "collectionsPrelude", 1071);
  gc_frame_newslot(block2490);
// method "_apply"
  block_savedest(block2490);
  Object closure2491 = createclosure(5, "_apply");
  setclosureframe(closure2491, stackframe);
  addtoclosure(closure2491, var_t);
  addtoclosure(closure2491, var_candidate);
  addtoclosure(closure2491, var_removed);
  addtoclosure(closure2491, var_unused);
  addtoclosure(closure2491, selfslot);
  struct UserObject *uo2491 = (struct UserObject*)block2490;
  uo2491->data[0] = (Object)closure2491;
  Method *meth_meth_collectionsPrelude_2491__apply = addmethod2pos(block2490, "_apply", &meth_collectionsPrelude_2491__apply, 0);
  int argcv_meth_collectionsPrelude_2491__apply[] = {0};
  meth_meth_collectionsPrelude_2491__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2491__apply);
  meth_meth_collectionsPrelude_2491__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2491__apply->definitionLine = 1769;
// compiled block node returning block2490 (depth = 3)
  gc_frame_newslot(block2490);
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2507 = alloc_Block(NULL, NULL, "collectionsPrelude", 1074);
  gc_frame_newslot(block2507);
// method "_apply"
  block_savedest(block2507);
  Object closure2508 = createclosure(6, "_apply");
  setclosureframe(closure2508, stackframe);
  addtoclosure(closure2508, var_x);
  addtoclosure(closure2508, var_candidate);
  addtoclosure(closure2508, var_t);
  addtoclosure(closure2508, var_jump);
  addtoclosure(closure2508, var_s);
  addtoclosure(closure2508, selfslot);
  struct UserObject *uo2508 = (struct UserObject*)block2507;
  uo2508->data[0] = (Object)closure2508;
  Method *meth_meth_collectionsPrelude_2508__apply = addmethod2pos(block2507, "_apply", &meth_collectionsPrelude_2508__apply, 0);
  int argcv_meth_collectionsPrelude_2508__apply[] = {0};
  meth_meth_collectionsPrelude_2508__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2508__apply);
  meth_meth_collectionsPrelude_2508__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2508__apply->definitionLine = 1769;
// compiled block node returning block2507 (depth = 3)
  gc_frame_newslot(block2507);
// call case 5: prelude request
  params[0] = block2490;
  params[1] = block2507;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2544 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2489);
// compiled call node returning call2544 (depth = 2)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_2549__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2551 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  partcv[0] = 0;
  Object call2552 = callmethodflags(*var_each, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe2551);
// compiled member node returning call2552 (depth = 6)
  int op_slot_right_2550 = gc_frame_newslot(call2552);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2550 = gc_frame_newslot(*var_s);
  params[0] = call2552;
  partcv[0] = 1;
  Object opresult2554 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2554 (depth = 5)
  *var_s = opresult2554;
  if (opresult2554 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_2558__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2560 == NULL) {
    strlit2560 = alloc_String(", ");
    gc_root(strlit2560);
  }
// compiled string node returning strlit2560 (depth = 6)
  int op_slot_right_2559 = gc_frame_newslot(strlit2560);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2559 = gc_frame_newslot(*var_s);
  params[0] = strlit2560;
  partcv[0] = 1;
  Object opresult2562 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2562 (depth = 5)
  *var_s = opresult2562;
  if (opresult2562 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_2545_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2546 == NULL) {
    strlit2546 = alloc_String("set{");
    gc_root(strlit2546);
  }
// compiled string node returning strlit2546 (depth = 3)
  *var_s = strlit2546;
  if (strlit2546 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2547 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2548 = alloc_Block(NULL, NULL, "collectionsPrelude", 1090);
  gc_frame_newslot(block2548);
// method "_apply(_)"
  block_savedest(block2548);
  Object closure2549 = createclosure(2, "_apply(1)");
  setclosureframe(closure2549, stackframe);
  addtoclosure(closure2549, var_s);
  addtoclosure(closure2549, selfslot);
  struct UserObject *uo2549 = (struct UserObject*)block2548;
  uo2549->data[0] = (Object)closure2549;
  Method *meth_meth_collectionsPrelude_2549__apply_40_1_41_ = addmethod2pos(block2548, "_apply(1)", &meth_collectionsPrelude_2549__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2549__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2549__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2549__apply_40_1_41_);
  meth_meth_collectionsPrelude_2549__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2549__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2548 (depth = 3)
  gc_frame_newslot(block2548);
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2557 = alloc_Block(NULL, NULL, "collectionsPrelude", 1091);
  gc_frame_newslot(block2557);
// method "_apply"
  block_savedest(block2557);
  Object closure2558 = createclosure(2, "_apply");
  setclosureframe(closure2558, stackframe);
  addtoclosure(closure2558, var_s);
  addtoclosure(closure2558, selfslot);
  struct UserObject *uo2558 = (struct UserObject*)block2557;
  uo2558->data[0] = (Object)closure2558;
  Method *meth_meth_collectionsPrelude_2558__apply = addmethod2pos(block2557, "_apply", &meth_collectionsPrelude_2558__apply, 0);
  int argcv_meth_collectionsPrelude_2558__apply[] = {0};
  meth_meth_collectionsPrelude_2558__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2558__apply);
  meth_meth_collectionsPrelude_2558__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2558__apply->definitionLine = 1769;
// compiled block node returning block2557 (depth = 3)
  gc_frame_newslot(block2557);
// call case 4: self request
  params[0] = block2548;
  params[1] = block2557;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2565 = callmethodflags(self, "do(1)separatedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2547);
// compiled call node returning call2565 (depth = 2)
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2567 == NULL) {
    strlit2567 = alloc_String("}");
    gc_root(strlit2567);
  }
// compiled string node returning strlit2567 (depth = 3)
  int op_slot_right_2566 = gc_frame_newslot(strlit2567);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_2566 = gc_frame_newslot(*var_s);
  params[0] = strlit2567;
  partcv[0] = 1;
  Object opresult2569 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2569 (depth = 2)
  gc_frame_end(frame);
  return opresult2569;
}
Object meth_collectionsPrelude_2574__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2576 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  partcv[0] = 0;
  Object call2577 = callmethodflags(*var_each, "asDebugString", 1, partcv, params, 0);
  gc_frame_end(callframe2576);
// compiled member node returning call2577 (depth = 6)
  int op_slot_right_2575 = gc_frame_newslot(call2577);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2575 = gc_frame_newslot(*var_s);
  params[0] = call2577;
  partcv[0] = 1;
  Object opresult2579 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2579 (depth = 5)
  *var_s = opresult2579;
  if (opresult2579 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_2583__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2585 == NULL) {
    strlit2585 = alloc_String(", ");
    gc_root(strlit2585);
  }
// compiled string node returning strlit2585 (depth = 6)
  int op_slot_right_2584 = gc_frame_newslot(strlit2585);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2584 = gc_frame_newslot(*var_s);
  params[0] = strlit2585;
  partcv[0] = 1;
  Object opresult2587 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2587 (depth = 5)
  *var_s = opresult2587;
  if (opresult2587 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_2570_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2571 == NULL) {
    strlit2571 = alloc_String("set{");
    gc_root(strlit2571);
  }
// compiled string node returning strlit2571 (depth = 3)
  *var_s = strlit2571;
  if (strlit2571 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2572 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2573 = alloc_Block(NULL, NULL, "collectionsPrelude", 1096);
  gc_frame_newslot(block2573);
// method "_apply(_)"
  block_savedest(block2573);
  Object closure2574 = createclosure(2, "_apply(1)");
  setclosureframe(closure2574, stackframe);
  addtoclosure(closure2574, var_s);
  addtoclosure(closure2574, selfslot);
  struct UserObject *uo2574 = (struct UserObject*)block2573;
  uo2574->data[0] = (Object)closure2574;
  Method *meth_meth_collectionsPrelude_2574__apply_40_1_41_ = addmethod2pos(block2573, "_apply(1)", &meth_collectionsPrelude_2574__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2574__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2574__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2574__apply_40_1_41_);
  meth_meth_collectionsPrelude_2574__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2574__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2573 (depth = 3)
  gc_frame_newslot(block2573);
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2582 = alloc_Block(NULL, NULL, "collectionsPrelude", 1097);
  gc_frame_newslot(block2582);
// method "_apply"
  block_savedest(block2582);
  Object closure2583 = createclosure(2, "_apply");
  setclosureframe(closure2583, stackframe);
  addtoclosure(closure2583, var_s);
  addtoclosure(closure2583, selfslot);
  struct UserObject *uo2583 = (struct UserObject*)block2582;
  uo2583->data[0] = (Object)closure2583;
  Method *meth_meth_collectionsPrelude_2583__apply = addmethod2pos(block2582, "_apply", &meth_collectionsPrelude_2583__apply, 0);
  int argcv_meth_collectionsPrelude_2583__apply[] = {0};
  meth_meth_collectionsPrelude_2583__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2583__apply);
  meth_meth_collectionsPrelude_2583__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2583__apply->definitionLine = 1769;
// compiled block node returning block2582 (depth = 3)
  gc_frame_newslot(block2582);
// call case 4: self request
  params[0] = block2573;
  params[1] = block2582;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2590 = callmethodflags(self, "do(1)separatedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2572);
// compiled call node returning call2590 (depth = 2)
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2592 == NULL) {
    strlit2592 = alloc_String("}");
    gc_root(strlit2592);
  }
// compiled string node returning strlit2592 (depth = 3)
  int op_slot_right_2591 = gc_frame_newslot(strlit2592);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_2591 = gc_frame_newslot(*var_s);
  params[0] = strlit2592;
  partcv[0] = 1;
  Object opresult2594 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2594 (depth = 2)
  gc_frame_end(frame);
  return opresult2594;
}
Object meth_collectionsPrelude_2598__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2599 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2600 = callmethodflags(self, "add(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2599);
// compiled call node returning call2600 (depth = 4)
  gc_frame_end(frame);
  return call2600;
}
Object meth_collectionsPrelude_2595_extend_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2596 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block2597 = alloc_Block(NULL, NULL, "collectionsPrelude", 1101);
  gc_frame_newslot(block2597);
// method "_apply(_)"
  block_savedest(block2597);
  Object closure2598 = createclosure(1, "_apply(1)");
  setclosureframe(closure2598, stackframe);
  addtoclosure(closure2598, selfslot);
  struct UserObject *uo2598 = (struct UserObject*)block2597;
  uo2598->data[0] = (Object)closure2598;
  Method *meth_meth_collectionsPrelude_2598__apply_40_1_41_ = addmethod2pos(block2597, "_apply(1)", &meth_collectionsPrelude_2598__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2598__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2598__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2598__apply_40_1_41_);
  meth_meth_collectionsPrelude_2598__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2598__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2597 (depth = 3)
  gc_frame_newslot(block2597);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block2597;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2602 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2596);
// compiled call node returning call2602 (depth = 2)
  gc_frame_end(frame);
  return call2602;
}
Object meth_collectionsPrelude_2610__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_found = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2612 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2613 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2612);
// compiled member node returning call2613 (depth = 5)
  int op_slot_right_2611 = gc_frame_newslot(call2613);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_found (depth = 5)
  int op_slot_left_2611 = gc_frame_newslot(*var_found);
  params[0] = call2613;
  partcv[0] = 1;
  Object opresult2615 = callmethod(*var_found, "<(1)", 1, partcv, params);
// compiled op node returning opresult2615 (depth = 4)
  gc_frame_end(frame);
  return opresult2615;
}
Object meth_collectionsPrelude_2618__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_iMods = getfromclosure(closure, 0);
  Object *var_ConcurrentModification = getfromclosure(closure, 1);
  Object *var_i = getfromclosure(closure, 2);
  Object *var_candidate = getfromclosure(closure, 3);
  Object *var_removed = getfromclosure(closure, 4);
  Object *var_unused = getfromclosure(closure, 5);
  Object *var_found = getfromclosure(closure, 6);
  Object *var_block1 = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2621 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2622 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2621);
// compiled member node returning call2622 (depth = 6)
  int op_slot_right_2620 = gc_frame_newslot(call2622);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_iMods (depth = 6)
  int op_slot_left_2620 = gc_frame_newslot(*var_iMods);
  params[0] = call2622;
  partcv[0] = 1;
  Object opresult2624 = callmethod(*var_iMods, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2624 (depth = 5)
  Object if2619 = done;
  if (istrue(opresult2624)) {
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2625 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2626 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2627 = gc_frame_new();
// call case 3: self.outer request
  Object call2628 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2627);
// compiled member node returning call2628 (depth = 7)
  partcv[0] = 0;
  Object call2629 = callmethodflags(call2628, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2626);
// compiled member node returning call2629 (depth = 6)
  gc_frame_newslot(call2629);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ConcurrentModification (depth = 6)
  params[0] = call2629;
  partcv[0] = 1;
  Object call2630 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2625);
// compiled call node returning call2630 (depth = 5)
    gc_frame_newslot(call2630);
    if2619 = call2630;
  } else {
  }
// compiled if node returning if2619 (depth = 4)
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2631 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2632 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2633 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2632);
// compiled member node returning call2633 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2634 = callmethodflags(call2633, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2631);
// compiled call node returning call2634 (depth = 5)
  *var_candidate = call2634;
  if (call2634 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_right_2638 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_2638 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2640 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2640 (depth = 6)
  int op_slot_right_2637 = gc_frame_newslot(opresult2640);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_right_2642 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_2642 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2644 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2644 (depth = 6)
  int op_slot_left_2637 = gc_frame_newslot(opresult2644);
  params[0] = opresult2640;
  partcv[0] = 1;
  Object opresult2645 = callmethod(opresult2644, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2645 (depth = 5)
  Object if2636 = done;
  if (istrue(opresult2645)) {
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2647 = alloc_Float64(1);
// compiled num node returning num2647 (depth = 7)
  int op_slot_right_2646 = gc_frame_newslot(num2647);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_found (depth = 7)
  int op_slot_left_2646 = gc_frame_newslot(*var_found);
  params[0] = num2647;
  partcv[0] = 1;
  Object sum2649 = callmethod(*var_found, "+(1)", 1, partcv, params);
// compiled op node returning sum2649 (depth = 6)
  *var_found = sum2649;
  if (sum2649 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2651 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  gc_frame_newslot(*var_candidate);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object call2652 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2651);
// compiled call node returning call2652 (depth = 5)
    gc_frame_newslot(call2652);
    if2636 = call2652;
  } else {
  }
// compiled if node returning if2636 (depth = 4)
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2654 = alloc_Float64(1);
// compiled num node returning num2654 (depth = 6)
  int op_slot_right_2653 = gc_frame_newslot(num2654);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_2653 = gc_frame_newslot(*var_i);
  params[0] = num2654;
  partcv[0] = 1;
  Object sum2656 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum2656 (depth = 5)
  *var_i = sum2656;
  if (sum2656 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_2603_do_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_iMods = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "iMods");
  Object *var_i = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "i");
  Object *var_found = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "found");
  Object *var_candidate = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "candidate");
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2604 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2605 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2604);
// compiled member node returning call2605 (depth = 3)
  *var_iMods = call2605;
  if (call2605 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2606 = alloc_Float64(0);
// compiled num node returning num2606 (depth = 3)
  *var_i = num2606;
  if (num2606 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2607 = alloc_Float64(0);
// compiled num node returning num2607 (depth = 3)
  *var_found = num2607;
  if (num2607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2608 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2609 = alloc_Block(NULL, NULL, "collectionsPrelude", 1110);
  gc_frame_newslot(block2609);
// method "_apply"
  block_savedest(block2609);
  Object closure2610 = createclosure(2, "_apply");
  setclosureframe(closure2610, stackframe);
  addtoclosure(closure2610, var_found);
  addtoclosure(closure2610, selfslot);
  struct UserObject *uo2610 = (struct UserObject*)block2609;
  uo2610->data[0] = (Object)closure2610;
  Method *meth_meth_collectionsPrelude_2610__apply = addmethod2pos(block2609, "_apply", &meth_collectionsPrelude_2610__apply, 0);
  int argcv_meth_collectionsPrelude_2610__apply[] = {0};
  meth_meth_collectionsPrelude_2610__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2610__apply);
  meth_meth_collectionsPrelude_2610__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2610__apply->definitionLine = 1769;
// compiled block node returning block2609 (depth = 3)
  gc_frame_newslot(block2609);
// starting to compile block node (depth = 3)
  Object block2617 = alloc_Block(NULL, NULL, "collectionsPrelude", 1110);
  gc_frame_newslot(block2617);
// method "_apply"
  block_savedest(block2617);
  Object closure2618 = createclosure(9, "_apply");
  setclosureframe(closure2618, stackframe);
  addtoclosure(closure2618, var_iMods);
  addtoclosure(closure2618, var_ConcurrentModification);
  addtoclosure(closure2618, var_i);
  addtoclosure(closure2618, var_candidate);
  addtoclosure(closure2618, var_removed);
  addtoclosure(closure2618, var_unused);
  addtoclosure(closure2618, var_found);
  addtoclosure(closure2618, var_block1);
  addtoclosure(closure2618, selfslot);
  struct UserObject *uo2618 = (struct UserObject*)block2617;
  uo2618->data[0] = (Object)closure2618;
  Method *meth_meth_collectionsPrelude_2618__apply = addmethod2pos(block2617, "_apply", &meth_collectionsPrelude_2618__apply, 0);
  int argcv_meth_collectionsPrelude_2618__apply[] = {0};
  meth_meth_collectionsPrelude_2618__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2618__apply);
  meth_meth_collectionsPrelude_2618__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2618__apply->definitionLine = 1769;
// compiled block node returning block2617 (depth = 3)
  gc_frame_newslot(block2617);
// call case 5: prelude request
  params[0] = block2609;
  params[1] = block2617;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2659 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2608);
// compiled call node returning call2659 (depth = 2)
  gc_frame_end(frame);
  return call2659;
}
Object meth_collectionsPrelude_2666_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2668 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2669 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2668);
// compiled member node returning call2669 (depth = 3)
  int op_slot_right_2667 = gc_frame_newslot(call2669);
// starting to compile member node (depth = 3)
  int callframe2671 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2672 = gc_frame_new();
// call case 3: self.outer request
  Object call2673 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2672);
// compiled member node returning call2673 (depth = 4)
  partcv[0] = 0;
  Object call2674 = callmethodflags(call2673, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2671);
// compiled member node returning call2674 (depth = 3)
  int op_slot_left_2667 = gc_frame_newslot(call2674);
  params[0] = call2669;
  partcv[0] = 1;
  Object opresult2675 = callmethod(call2674, "≥(1)", 1, partcv, params);
// compiled op node returning opresult2675 (depth = 2)
  gc_frame_end(frame);
  return opresult2675;
}
Object meth_collectionsPrelude_2685__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_candidate = getfromclosure(closure, 3);
  Object *var_removed = getfromclosure(closure, 4);
  Object *var_unused = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2686 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2688 = alloc_Float64(1);
// compiled num node returning num2688 (depth = 6)
  int op_slot_right_2687 = gc_frame_newslot(num2688);
// starting to compile member node (depth = 6)
  int callframe2690 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2691 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2690);
// compiled member node returning call2691 (depth = 6)
  int op_slot_left_2687 = gc_frame_newslot(call2691);
  params[0] = num2688;
  partcv[0] = 1;
  Object sum2692 = callmethod(call2691, "+(1)", 1, partcv, params);
// compiled op node returning sum2692 (depth = 5)
  gc_frame_newslot(sum2692);
// call case 4: self request
  params[0] = sum2692;
  partcv[0] = 1;
  Object call2693 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2686);
// compiled call node returning call2693 (depth = 4)
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2696 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2697 = gc_frame_new();
// call case 3: self.outer request
  Object call2698 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2697);
// compiled member node returning call2698 (depth = 7)
  partcv[0] = 0;
  Object call2699 = callmethodflags(call2698, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2696);
// compiled member node returning call2699 (depth = 6)
  int op_slot_right_2695 = gc_frame_newslot(call2699);
// starting to compile member node (depth = 6)
  int callframe2701 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2702 = callmethodflags(self, "iMods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2701);
// compiled member node returning call2702 (depth = 6)
  int op_slot_left_2695 = gc_frame_newslot(call2702);
  params[0] = call2699;
  partcv[0] = 1;
  Object opresult2703 = callmethod(call2702, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2703 (depth = 5)
  Object if2694 = done;
  if (istrue(opresult2703)) {
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2704 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2705 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2706 = gc_frame_new();
// call case 3: self.outer request
  Object call2707 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2706);
// compiled member node returning call2707 (depth = 7)
  partcv[0] = 0;
  Object call2708 = callmethodflags(call2707, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2705);
// compiled member node returning call2708 (depth = 6)
  gc_frame_newslot(call2708);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ConcurrentModification (depth = 6)
  params[0] = call2708;
  partcv[0] = 1;
  Object call2709 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2704);
// compiled call node returning call2709 (depth = 5)
    gc_frame_newslot(call2709);
    if2694 = call2709;
  } else {
  }
// compiled if node returning if2694 (depth = 4)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_innerSize (depth = 6)
  int op_slot_right_2711 = gc_frame_newslot(*var_innerSize);
// starting to compile member node (depth = 6)
  int callframe2713 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2714 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2713);
// compiled member node returning call2714 (depth = 6)
  int op_slot_left_2711 = gc_frame_newslot(call2714);
  params[0] = *var_innerSize;
  partcv[0] = 1;
  Object opresult2715 = callmethod(call2714, "≥(1)", 1, partcv, params);
// compiled op node returning opresult2715 (depth = 5)
  Object if2710 = done;
  if (istrue(opresult2715)) {
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2716 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2718 == NULL) {
    strlit2718 = alloc_String("");
    gc_root(strlit2718);
  }
// compiled string node returning strlit2718 (depth = 7)
  int op_slot_right_2717 = gc_frame_newslot(strlit2718);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2721 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2722 = gc_frame_new();
// call case 3: self.outer request
  Object call2723 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2722);
// compiled member node returning call2723 (depth = 9)
  partcv[0] = 0;
  Object call2724 = callmethodflags(call2723, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2721);
// compiled member node returning call2724 (depth = 8)
  int op_slot_right_2720 = gc_frame_newslot(call2724);
// starting to compile string node (depth = 8)
  if (strlit2726 == NULL) {
    strlit2726 = alloc_String("iterator over ");
    gc_root(strlit2726);
  }
// compiled string node returning strlit2726 (depth = 8)
  int op_slot_left_2720 = gc_frame_newslot(strlit2726);
  params[0] = call2724;
  partcv[0] = 1;
  Object opresult2727 = callmethod(strlit2726, "++(1)", 1, partcv, params);
// compiled op node returning opresult2727 (depth = 7)
  int op_slot_left_2717 = gc_frame_newslot(opresult2727);
  params[0] = strlit2718;
  partcv[0] = 1;
  Object opresult2728 = callmethod(opresult2727, "++(1)", 1, partcv, params);
// compiled op node returning opresult2728 (depth = 6)
  gc_frame_newslot(opresult2728);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_IteratorExhausted (depth = 6)
  params[0] = opresult2728;
  partcv[0] = 1;
  Object call2729 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2716);
// compiled call node returning call2729 (depth = 5)
    gc_frame_newslot(call2729);
    if2710 = call2729;
  } else {
  }
// compiled if node returning if2710 (depth = 4)
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2730 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2731 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2732 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2731);
// compiled member node returning call2732 (depth = 6)
  gc_frame_newslot(call2732);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2733 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2734 = gc_frame_new();
// call case 3: self.outer request
  Object call2735 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2734);
// compiled member node returning call2735 (depth = 7)
  partcv[0] = 0;
  Object call2736 = callmethodflags(call2735, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2733);
// compiled member node returning call2736 (depth = 6)
  params[0] = call2732;
  partcv[0] = 1;
  Object call2737 = callmethodflags(call2736, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2730);
// compiled call node returning call2737 (depth = 5)
  *var_candidate = call2737;
  if (call2737 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2740 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_2740 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2742 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult2742 (depth = 5)
  int op_slot_right_2739 = gc_frame_newslot(opresult2742);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2744 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_2744 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2746 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult2746 (depth = 5)
  int op_slot_left_2739 = gc_frame_newslot(opresult2746);
  params[0] = opresult2742;
  partcv[0] = 1;
  Object opresult2747 = callmethod(opresult2746, "||(1)", 1, partcv, params);
// compiled op node returning opresult2747 (depth = 4)
  gc_frame_end(frame);
  return opresult2747;
}
Object meth_collectionsPrelude_2750__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_2676_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_candidate = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "candidate");
  Object *var_innerSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "innerSize");
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2677 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2678 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2679 = gc_frame_new();
// call case 3: self.outer request
  Object call2680 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2679);
// compiled member node returning call2680 (depth = 5)
  partcv[0] = 0;
  Object call2681 = callmethodflags(call2680, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2678);
// compiled member node returning call2681 (depth = 4)
  partcv[0] = 0;
  Object call2682 = callmethodflags(call2681, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2677);
// compiled member node returning call2682 (depth = 3)
  *var_innerSize = call2682;
  if (call2682 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2683 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2684 = alloc_Block(NULL, NULL, "collectionsPrelude", 1131);
  gc_frame_newslot(block2684);
// method "_apply"
  block_savedest(block2684);
  Object closure2685 = createclosure(7, "_apply");
  setclosureframe(closure2685, stackframe);
  addtoclosure(closure2685, var_ConcurrentModification);
  addtoclosure(closure2685, var_innerSize);
  addtoclosure(closure2685, var_IteratorExhausted);
  addtoclosure(closure2685, var_candidate);
  addtoclosure(closure2685, var_removed);
  addtoclosure(closure2685, var_unused);
  addtoclosure(closure2685, selfslot);
  struct UserObject *uo2685 = (struct UserObject*)block2684;
  uo2685->data[0] = (Object)closure2685;
  Method *meth_meth_collectionsPrelude_2685__apply = addmethod2pos(block2684, "_apply", &meth_collectionsPrelude_2685__apply, 0);
  int argcv_meth_collectionsPrelude_2685__apply[] = {0};
  meth_meth_collectionsPrelude_2685__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2685__apply);
  meth_meth_collectionsPrelude_2685__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2685__apply->definitionLine = 1769;
// compiled block node returning block2684 (depth = 3)
  gc_frame_newslot(block2684);
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2749 = alloc_Block(NULL, NULL, "collectionsPrelude", 1141);
  gc_frame_newslot(block2749);
// method "_apply"
  block_savedest(block2749);
  Object closure2750 = createclosure(1, "_apply");
  setclosureframe(closure2750, stackframe);
  addtoclosure(closure2750, selfslot);
  struct UserObject *uo2750 = (struct UserObject*)block2749;
  uo2750->data[0] = (Object)closure2750;
  Method *meth_meth_collectionsPrelude_2750__apply = addmethod2pos(block2749, "_apply", &meth_collectionsPrelude_2750__apply, 0);
  int argcv_meth_collectionsPrelude_2750__apply[] = {0};
  meth_meth_collectionsPrelude_2750__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2750__apply);
  meth_meth_collectionsPrelude_2750__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_2750__apply->definitionLine = 1769;
// compiled block node returning block2749 (depth = 3)
  gc_frame_newslot(block2749);
// call case 5: prelude request
  params[0] = block2684;
  params[1] = block2749;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2752 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2683);
// compiled call node returning call2752 (depth = 2)
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2753 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2755 = alloc_Float64(1);
// compiled num node returning num2755 (depth = 4)
  int op_slot_right_2754 = gc_frame_newslot(num2755);
// starting to compile member node (depth = 4)
  int callframe2757 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2758 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2757);
// compiled member node returning call2758 (depth = 4)
  int op_slot_left_2754 = gc_frame_newslot(call2758);
  params[0] = num2755;
  partcv[0] = 1;
  Object sum2759 = callmethod(call2758, "+(1)", 1, partcv, params);
// compiled op node returning sum2759 (depth = 3)
  gc_frame_newslot(sum2759);
// call case 4: self request
  params[0] = sum2759;
  partcv[0] = 1;
  Object call2760 = callmethodflags(self, "count:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2753);
// compiled call node returning call2760 (depth = 2)
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_candidate (depth = 2)
  gc_frame_end(frame);
  return *var_candidate;
}
Object meth_collectionsPrelude_2660_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2661 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2661 = alloc_userobj2(7,6, objclass2661);
  gc_frame_newslot(obj2661);
  if (objclass2661 == NULL) {
    glfree(obj2661->class->name);
    obj2661->class->name = "set.ofCapacity(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2661, self, 0);
  addmethodreal(obj2661,"outer", &reader_collectionsPrelude_outer_2662);
  Object oldself2661 = self;
  struct StackFrameObject *oldstackframe2661 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2661);
  gc_frame_newslot((Object)stackframe);
  self = obj2661;
  Object *oldselfslot2661 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2661 = (*(struct UserObject *)self).data[0], lowerouter2661 = thisouter2661;
  if (inheritingObject2661) {
    struct UserObject *inho2661 = (struct UserObject *)inheritingObject2661;
    while (inho2661->super != GraceDefaultObject) inho2661 = (struct UserObject *)inho2661->super;
    inho2661->super = obj2661;
    self = inheritingObject2661;
    *selfslot = self;
    lowerouter2661 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2661;
  }
  if (objclass2661 == NULL) {
  Method *reader2663 = addmethodrealflags(obj2661, "iMods",&reader_collectionsPrelude_iMods_2663, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader2663->definitionModule = modulename;
  reader2663->definitionLine = 1124;
  }
  adddatum2(obj2661, alloc_Undefined(), 1);
  if (objclass2661 == NULL) {
    Method *reader2664 = addmethodrealflags(obj2661, "count", &reader_collectionsPrelude_count_2664, MFLAG_CONFIDENTIAL);
    Method *writer2664 = addmethodrealflags(obj2661, "count:=(1)", &writer_collectionsPrelude_count_2664, MFLAG_CONFIDENTIAL);
    reader2664->definitionModule = modulename;
    writer2664->definitionModule = modulename;
    reader2664->definitionLine = 1125;
    writer2664->definitionLine = 1125;
  }
  obj2661->flags |= OFLAG_MUTABLE;
  adddatum2(obj2661, alloc_Undefined(), 2);
  if (objclass2661 == NULL) {
    Method *reader2665 = addmethodrealflags(obj2661, "idx", &reader_collectionsPrelude_idx_2665, MFLAG_CONFIDENTIAL);
    Method *writer2665 = addmethodrealflags(obj2661, "idx:=(1)", &writer_collectionsPrelude_idx_2665, MFLAG_CONFIDENTIAL);
    reader2665->definitionModule = modulename;
    writer2665->definitionModule = modulename;
    reader2665->definitionLine = 1126;
    writer2665->definitionLine = 1126;
  }
  obj2661->flags |= OFLAG_MUTABLE;
  adddatum2(obj2661, alloc_Undefined(), 3);
// method "hasNext"
  struct UserObject *uo2666 = (struct UserObject*)obj2661;
  uo2666->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2666_hasNext = addmethod2pos(obj2661, "hasNext", &meth_collectionsPrelude_2666_hasNext, 4);
  int argcv_meth_collectionsPrelude_2666_hasNext[] = {0};
  meth_meth_collectionsPrelude_2666_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2666_hasNext);
  meth_meth_collectionsPrelude_2666_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_2666_hasNext->definitionLine = 1127;
// method "next"
  block_savedest(obj2661);
  Object closure2676 = createclosure(4, "next");
  setclosureframe(closure2676, stackframe);
  addtoclosure(closure2676, var_ConcurrentModification);
  addtoclosure(closure2676, var_IteratorExhausted);
  addtoclosure(closure2676, var_removed);
  addtoclosure(closure2676, var_unused);
  struct UserObject *uo2676 = (struct UserObject*)obj2661;
  uo2676->data[5] = (Object)closure2676;
  Method *meth_meth_collectionsPrelude_2676_next = addmethod2pos(obj2661, "next", &meth_collectionsPrelude_2676_next, 5);
  int argcv_meth_collectionsPrelude_2676_next[] = {0};
  meth_meth_collectionsPrelude_2676_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2676_next);
  meth_meth_collectionsPrelude_2676_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_2676_next->definitionLine = 1128;
  sourceObject = obj2661;
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2761 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2762 = gc_frame_new();
// call case 3: self.outer request
  Object call2763 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2762);
// compiled member node returning call2763 (depth = 3)
  partcv[0] = 0;
  Object call2764 = callmethodflags(call2763, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2761);
// compiled member node returning call2764 (depth = 2)
  adddatum2(obj2661, call2764, 1);
  sourceObject = obj2661;
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2765 = alloc_Float64(1);
// compiled num node returning num2765 (depth = 2)
  adddatum2(obj2661, num2765, 2);
  sourceObject = obj2661;
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2766 = gc_frame_new();
// call case 6: other requests
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num2767 = alloc_Float64(1);
// compiled num node returning num2767 (depth = 3)
  partcv[0] = 0;
  Object call2768 = callmethodflags(num2767, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe2766);
// compiled call node returning call2768 (depth = 2)
  adddatum2(obj2661, call2768, 3);
  sourceObject = obj2661;
  sourceObject = obj2661;
  objclass2661 = obj2661->class;
  objclass2661->definitionModule = modulename;
  objclass2661->definitionLine = 1123;
  (*(struct UserObject *)self).data[0] = lowerouter2661;
  self = oldself2661;
  selfslot = oldselfslot2661;
  stackframe = oldstackframe2661;
  gc_frame_end(frame);
  return obj2661;
}
Object meth_collectionsPrelude_2660_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2661 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2661 = alloc_userobj2(7,6, objclass2661);
  gc_frame_newslot(obj2661);
  if (objclass2661 == NULL) {
    glfree(obj2661->class->name);
    obj2661->class->name = "set.ofCapacity(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2661, self, 0);
  addmethodreal(obj2661,"outer", &reader_collectionsPrelude_outer_2662);
  Object oldself2661 = self;
  struct StackFrameObject *oldstackframe2661 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2661);
  gc_frame_newslot((Object)stackframe);
  self = obj2661;
  Object *oldselfslot2661 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2661 = (*(struct UserObject *)self).data[0], lowerouter2661 = thisouter2661;
  if (inheritingObject2661) {
    struct UserObject *inho2661 = (struct UserObject *)inheritingObject2661;
    while (inho2661->super != GraceDefaultObject) inho2661 = (struct UserObject *)inho2661->super;
    inho2661->super = obj2661;
    self = inheritingObject2661;
    *selfslot = self;
    lowerouter2661 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2661;
  }
  if (objclass2661 == NULL) {
  Method *reader2663 = addmethodrealflags(obj2661, "iMods",&reader_collectionsPrelude_iMods_2663, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader2663->definitionModule = modulename;
  reader2663->definitionLine = 1124;
  }
  adddatum2(obj2661, alloc_Undefined(), 1);
  if (objclass2661 == NULL) {
    Method *reader2664 = addmethodrealflags(obj2661, "count", &reader_collectionsPrelude_count_2664, MFLAG_CONFIDENTIAL);
    Method *writer2664 = addmethodrealflags(obj2661, "count:=(1)", &writer_collectionsPrelude_count_2664, MFLAG_CONFIDENTIAL);
    reader2664->definitionModule = modulename;
    writer2664->definitionModule = modulename;
    reader2664->definitionLine = 1125;
    writer2664->definitionLine = 1125;
  }
  obj2661->flags |= OFLAG_MUTABLE;
  adddatum2(obj2661, alloc_Undefined(), 2);
  if (objclass2661 == NULL) {
    Method *reader2665 = addmethodrealflags(obj2661, "idx", &reader_collectionsPrelude_idx_2665, MFLAG_CONFIDENTIAL);
    Method *writer2665 = addmethodrealflags(obj2661, "idx:=(1)", &writer_collectionsPrelude_idx_2665, MFLAG_CONFIDENTIAL);
    reader2665->definitionModule = modulename;
    writer2665->definitionModule = modulename;
    reader2665->definitionLine = 1126;
    writer2665->definitionLine = 1126;
  }
  obj2661->flags |= OFLAG_MUTABLE;
  adddatum2(obj2661, alloc_Undefined(), 3);
// method "hasNext"
  struct UserObject *uo2666 = (struct UserObject*)obj2661;
  uo2666->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2666_hasNext = addmethod2pos(obj2661, "hasNext", &meth_collectionsPrelude_2666_hasNext, 4);
  int argcv_meth_collectionsPrelude_2666_hasNext[] = {0};
  meth_meth_collectionsPrelude_2666_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2666_hasNext);
  meth_meth_collectionsPrelude_2666_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_2666_hasNext->definitionLine = 1127;
// method "next"
  block_savedest(obj2661);
  Object closure2676 = createclosure(4, "next");
  setclosureframe(closure2676, stackframe);
  addtoclosure(closure2676, var_ConcurrentModification);
  addtoclosure(closure2676, var_IteratorExhausted);
  addtoclosure(closure2676, var_removed);
  addtoclosure(closure2676, var_unused);
  struct UserObject *uo2676 = (struct UserObject*)obj2661;
  uo2676->data[5] = (Object)closure2676;
  Method *meth_meth_collectionsPrelude_2676_next = addmethod2pos(obj2661, "next", &meth_collectionsPrelude_2676_next, 5);
  int argcv_meth_collectionsPrelude_2676_next[] = {0};
  meth_meth_collectionsPrelude_2676_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2676_next);
  meth_meth_collectionsPrelude_2676_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_2676_next->definitionLine = 1128;
  sourceObject = obj2661;
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2761 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2762 = gc_frame_new();
// call case 3: self.outer request
  Object call2763 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2762);
// compiled member node returning call2763 (depth = 3)
  partcv[0] = 0;
  Object call2764 = callmethodflags(call2763, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2761);
// compiled member node returning call2764 (depth = 2)
  adddatum2(obj2661, call2764, 1);
  sourceObject = obj2661;
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2765 = alloc_Float64(1);
// compiled num node returning num2765 (depth = 2)
  adddatum2(obj2661, num2765, 2);
  sourceObject = obj2661;
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2766 = gc_frame_new();
// call case 6: other requests
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num2767 = alloc_Float64(1);
// compiled num node returning num2767 (depth = 3)
  partcv[0] = 0;
  Object call2768 = callmethodflags(num2767, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe2766);
// compiled call node returning call2768 (depth = 2)
  adddatum2(obj2661, call2768, 3);
  sourceObject = obj2661;
  sourceObject = obj2661;
  objclass2661 = obj2661->class;
  objclass2661->definitionModule = modulename;
  objclass2661->definitionLine = 1123;
  (*(struct UserObject *)self).data[0] = lowerouter2661;
  self = oldself2661;
  selfslot = oldselfslot2661;
  stackframe = oldstackframe2661;
  gc_frame_end(frame);
  return obj2661;
}
Object meth_collectionsPrelude_2804__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2805 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2806 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2807 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2806);
// compiled member node returning call2807 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2808 = callmethodflags(call2807, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2805);
// compiled call node returning call2808 (depth = 4)
  gc_frame_end(frame);
  return call2808;
}
Object meth_collectionsPrelude_2823__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2827 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oldInner (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2828 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2827);
// compiled call node returning call2828 (depth = 7)
  int op_slot_right_2826 = gc_frame_newslot(call2828);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_2826 = gc_frame_newslot(*var_removed);
  params[0] = call2828;
  partcv[0] = 1;
  Object opresult2830 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2830 (depth = 6)
  int op_slot_right_2825 = gc_frame_newslot(opresult2830);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2833 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oldInner (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2834 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2833);
// compiled call node returning call2834 (depth = 7)
  int op_slot_right_2832 = gc_frame_newslot(call2834);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_2832 = gc_frame_newslot(*var_unused);
  params[0] = call2834;
  partcv[0] = 1;
  Object opresult2836 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2836 (depth = 6)
  int op_slot_left_2825 = gc_frame_newslot(opresult2836);
  params[0] = opresult2830;
  partcv[0] = 1;
  Object opresult2837 = callmethod(opresult2836, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2837 (depth = 5)
  Object if2824 = done;
  if (istrue(opresult2837)) {
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2838 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe2839 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oldInner (depth = 7)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2840 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2839);
// compiled call node returning call2840 (depth = 6)
  gc_frame_newslot(call2840);
// call case 4: self request
  params[0] = call2840;
  partcv[0] = 1;
  Object call2841 = callmethodflags(self, "add(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2838);
// compiled call node returning call2841 (depth = 5)
    gc_frame_newslot(call2841);
    if2824 = call2841;
  } else {
  }
// compiled if node returning if2824 (depth = 4)
  gc_frame_end(frame);
  return if2824;
}
Object meth_collectionsPrelude_2770_expand(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2771 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2772 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2773 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2772);
// compiled member node returning call2773 (depth = 4)
  partcv[0] = 0;
  Object call2774 = callmethodflags(call2773, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2771);
// compiled member node returning call2774 (depth = 3)
  *var_c = call2774;
  if (call2774 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2776 = alloc_Float64(2);
// compiled num node returning num2776 (depth = 4)
  int op_slot_right_2775 = gc_frame_newslot(num2776);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_2775 = gc_frame_newslot(*var_c);
  params[0] = num2776;
  partcv[0] = 1;
  Object prod2778 = callmethod(*var_c, "*(1)", 1, partcv, params);
// compiled op node returning prod2778 (depth = 3)
  *var_n = prod2778;
  if (prod2778 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2779 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2780 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2779);
// compiled member node returning call2780 (depth = 3)
  *var_oldInner = call2780;
  if (call2780 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2781 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2782 = alloc_Float64(0);
// compiled num node returning num2782 (depth = 3)
  gc_frame_newslot(num2782);
// call case 4: self request
  params[0] = num2782;
  partcv[0] = 1;
  Object call2783 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2781);
// compiled call node returning call2783 (depth = 2)
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2784 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe2785 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2786 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2787 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2786);
// compiled member node returning call2787 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2788 = callmethodflags(call2787, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2785);
// compiled call node returning call2788 (depth = 3)
  gc_frame_newslot(call2788);
// call case 4: self request
  params[0] = call2788;
  partcv[0] = 1;
  Object call2789 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2784);
// compiled call node returning call2789 (depth = 2)
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2790 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2793 = alloc_Float64(1);
// compiled num node returning num2793 (depth = 5)
  int op_slot_right_2792 = gc_frame_newslot(num2793);
// starting to compile member node (depth = 5)
  int callframe2795 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2796 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2797 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2796);
// compiled member node returning call2797 (depth = 6)
  partcv[0] = 0;
  Object call2798 = callmethodflags(call2797, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2795);
// compiled member node returning call2798 (depth = 5)
  int op_slot_left_2792 = gc_frame_newslot(call2798);
  params[0] = num2793;
  partcv[0] = 1;
  Object diff2799 = callmethod(call2798, "-(1)", 1, partcv, params);
// compiled op node returning diff2799 (depth = 4)
  int op_slot_right_2791 = gc_frame_newslot(diff2799);
// starting to compile num node (depth = 4)
  Object num2801 = alloc_Float64(0);
// compiled num node returning num2801 (depth = 4)
  int op_slot_left_2791 = gc_frame_newslot(num2801);
  params[0] = diff2799;
  partcv[0] = 1;
  Object opresult2802 = callmethod(num2801, "..(1)", 1, partcv, params);
// compiled op node returning opresult2802 (depth = 3)
  gc_frame_newslot(opresult2802);
// starting to compile block node (depth = 3)
  Object block2803 = alloc_Block(NULL, NULL, "collectionsPrelude", 1154);
  gc_frame_newslot(block2803);
// method "_apply(_)"
  block_savedest(block2803);
  Object closure2804 = createclosure(2, "_apply(1)");
  setclosureframe(closure2804, stackframe);
  addtoclosure(closure2804, var_unused);
  addtoclosure(closure2804, selfslot);
  struct UserObject *uo2804 = (struct UserObject*)block2803;
  uo2804->data[0] = (Object)closure2804;
  Method *meth_meth_collectionsPrelude_2804__apply_40_1_41_ = addmethod2pos(block2803, "_apply(1)", &meth_collectionsPrelude_2804__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2804__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2804__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2804__apply_40_1_41_);
  meth_meth_collectionsPrelude_2804__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2804__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2803 (depth = 3)
  gc_frame_newslot(block2803);
// call case 5: prelude request
  params[0] = opresult2802;
  params[1] = block2803;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2810 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2790);
// compiled call node returning call2810 (depth = 2)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2811 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2814 = alloc_Float64(1);
// compiled num node returning num2814 (depth = 5)
  int op_slot_right_2813 = gc_frame_newslot(num2814);
// starting to compile member node (depth = 5)
  int callframe2816 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldInner (depth = 6)
  partcv[0] = 0;
  Object call2817 = callmethodflags(*var_oldInner, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2816);
// compiled member node returning call2817 (depth = 5)
  int op_slot_left_2813 = gc_frame_newslot(call2817);
  params[0] = num2814;
  partcv[0] = 1;
  Object diff2818 = callmethod(call2817, "-(1)", 1, partcv, params);
// compiled op node returning diff2818 (depth = 4)
  int op_slot_right_2812 = gc_frame_newslot(diff2818);
// starting to compile num node (depth = 4)
  Object num2820 = alloc_Float64(0);
// compiled num node returning num2820 (depth = 4)
  int op_slot_left_2812 = gc_frame_newslot(num2820);
  params[0] = diff2818;
  partcv[0] = 1;
  Object opresult2821 = callmethod(num2820, "..(1)", 1, partcv, params);
// compiled op node returning opresult2821 (depth = 3)
  gc_frame_newslot(opresult2821);
// starting to compile block node (depth = 3)
  Object block2822 = alloc_Block(NULL, NULL, "collectionsPrelude", 1157);
  gc_frame_newslot(block2822);
// method "_apply(_)"
  block_savedest(block2822);
  Object closure2823 = createclosure(4, "_apply(1)");
  setclosureframe(closure2823, stackframe);
  addtoclosure(closure2823, var_oldInner);
  addtoclosure(closure2823, var_removed);
  addtoclosure(closure2823, var_unused);
  addtoclosure(closure2823, selfslot);
  struct UserObject *uo2823 = (struct UserObject*)block2822;
  uo2823->data[0] = (Object)closure2823;
  Method *meth_meth_collectionsPrelude_2823__apply_40_1_41_ = addmethod2pos(block2822, "_apply(1)", &meth_collectionsPrelude_2823__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2823__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2823__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2823__apply_40_1_41_);
  meth_meth_collectionsPrelude_2823__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2823__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2822 (depth = 3)
  gc_frame_newslot(block2822);
// call case 5: prelude request
  params[0] = opresult2821;
  params[1] = block2822;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2843 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2811);
// compiled call node returning call2843 (depth = 2)
  gc_frame_end(frame);
  return call2843;
}
Object meth_collectionsPrelude_2851__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_otherSize = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2853 = alloc_Float64(1);
// compiled num node returning num2853 (depth = 7)
  int op_slot_right_2852 = gc_frame_newslot(num2853);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_otherSize (depth = 7)
  int op_slot_left_2852 = gc_frame_newslot(*var_otherSize);
  params[0] = num2853;
  partcv[0] = 1;
  Object sum2855 = callmethod(*var_otherSize, "+(1)", 1, partcv, params);
// compiled op node returning sum2855 (depth = 6)
  *var_otherSize = sum2855;
  if (sum2855 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2858 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe2859 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2860 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2859);
// compiled call node returning call2860 (depth = 7)
  partcv[0] = 0;
  Object call2861 = callmethodflags(call2860, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe2858);
// compiled call node returning call2861 (depth = 6)
  Object if2857 = done;
  if (istrue(call2861)) {
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2862 = alloc_Boolean(0);
// compiled identifier node returning bool2862 (depth = 7)
  block_return(realself, bool2862);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if2857 = undefined;
  } else {
  }
// compiled if node returning if2857 (depth = 5)
  gc_frame_end(frame);
  return if2857;
}
Object meth_collectionsPrelude_2844__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_otherSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "otherSize");
// definebindings:
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2846 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_Collection (depth = 4)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call2847 = callmethodflags(*var_Collection, "match(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2846);
// compiled call node returning call2847 (depth = 3)
  Object if2845 = done;
  if (istrue(call2847)) {
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2848 = alloc_Float64(0);
// compiled num node returning num2848 (depth = 4)
  *var_otherSize = num2848;
  if (num2848 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2849 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2850 = alloc_Block(NULL, NULL, "collectionsPrelude", 1166);
  gc_frame_newslot(block2850);
// method "_apply(_)"
  block_savedest(block2850);
  Object closure2851 = createclosure(2, "_apply(1)");
  setclosureframe(closure2851, stackframe);
  addtoclosure(closure2851, var_otherSize);
  addtoclosure(closure2851, selfslot);
  struct UserObject *uo2851 = (struct UserObject*)block2850;
  uo2851->data[0] = (Object)closure2851;
  Method *meth_meth_collectionsPrelude_2851__apply_40_1_41_ = addmethod2pos(block2850, "_apply(1)", &meth_collectionsPrelude_2851__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2851__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2851__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2851__apply_40_1_41_);
  meth_meth_collectionsPrelude_2851__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2851__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2850 (depth = 4)
  gc_frame_newslot(block2850);
// call case 6: other requests
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  params[0] = block2850;
  partcv[0] = 1;
  Object call2864 = callmethodflags(*var_other, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2849);
// compiled call node returning call2864 (depth = 3)
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2866 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2867 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2866);
// compiled member node returning call2867 (depth = 4)
  int op_slot_right_2865 = gc_frame_newslot(call2867);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_otherSize (depth = 4)
  int op_slot_left_2865 = gc_frame_newslot(*var_otherSize);
  params[0] = call2867;
  partcv[0] = 1;
  Object opresult2869 = callmethod(*var_otherSize, "==(1)", 1, partcv, params);
// compiled op node returning opresult2869 (depth = 3)
    gc_frame_newslot(opresult2869);
    if2845 = opresult2869;
  } else {
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2870 = alloc_Boolean(0);
// compiled identifier node returning bool2870 (depth = 3)
    gc_frame_newslot(bool2870);
    if2845 = bool2870;
  }
// compiled if node returning if2845 (depth = 2)
  gc_frame_end(frame);
  return if2845;
}
Object meth_collectionsPrelude_2871_copy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2872 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2873 = gc_frame_new();
// call case 3: self.outer request
  Object call2874 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2873);
// compiled member node returning call2874 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call2875 = callmethodflags(call2874, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2872);
// compiled call node returning call2875 (depth = 2)
  gc_frame_end(frame);
  return call2875;
}
Object meth_collectionsPrelude_2876__43__43__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2877 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2878 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2879 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2878);
// compiled member node returning call2879 (depth = 3)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call2880 = callmethodflags(call2879, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2877);
// compiled call node returning call2880 (depth = 2)
  gc_frame_end(frame);
  return call2880;
}
Object meth_collectionsPrelude_2888__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_other = getfromclosure(closure, 0);
  Object *var_result = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2890 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe2891 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2892 = callmethodflags(*var_other, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2891);
// compiled call node returning call2892 (depth = 6)
  partcv[0] = 0;
  Object call2893 = callmethodflags(call2892, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe2890);
// compiled call node returning call2893 (depth = 5)
  Object if2889 = done;
  if (istrue(call2893)) {
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2894 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2895 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2894);
// compiled call node returning call2895 (depth = 5)
    gc_frame_newslot(call2895);
    if2889 = call2895;
  } else {
  }
// compiled if node returning if2889 (depth = 4)
  gc_frame_end(frame);
  return if2889;
}
Object meth_collectionsPrelude_2881__45__45__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "--(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method --(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for --(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part --(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2882 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2883 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call2884 = callmethodflags(module_collectionsPrelude, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2883);
// compiled member node returning call2884 (depth = 4)
  partcv[0] = 0;
  Object call2885 = callmethodflags(call2884, "empty", 1, partcv, params, 0);
  gc_frame_end(callframe2882);
// compiled member node returning call2885 (depth = 3)
  *var_result = call2885;
  if (call2885 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2886 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile block node (depth = 3)
  Object block2887 = alloc_Block(NULL, NULL, "collectionsPrelude", 1187);
  gc_frame_newslot(block2887);
// method "_apply(_)"
  block_savedest(block2887);
  Object closure2888 = createclosure(3, "_apply(1)");
  setclosureframe(closure2888, stackframe);
  addtoclosure(closure2888, var_other);
  addtoclosure(closure2888, var_result);
  addtoclosure(closure2888, selfslot);
  struct UserObject *uo2888 = (struct UserObject*)block2887;
  uo2888->data[0] = (Object)closure2888;
  Method *meth_meth_collectionsPrelude_2888__apply_40_1_41_ = addmethod2pos(block2887, "_apply(1)", &meth_collectionsPrelude_2888__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2888__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2888__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2888__apply_40_1_41_);
  meth_meth_collectionsPrelude_2888__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2888__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2887 (depth = 3)
  gc_frame_newslot(block2887);
// call case 5: prelude request
  params[0] = self;
  params[1] = block2887;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2897 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2886);
// compiled call node returning call2897 (depth = 2)
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_2902__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe2903 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2904 = callmethodflags(*var_other, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2903);
// compiled call node returning call2904 (depth = 5)
  gc_frame_end(frame);
  return call2904;
}
Object meth_collectionsPrelude_2898__42__42__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "**(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method **(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for **(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part **(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2899 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe2900 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2901 = alloc_Block(NULL, NULL, "collectionsPrelude", 1196);
  gc_frame_newslot(block2901);
// method "_apply(_)"
  block_savedest(block2901);
  Object closure2902 = createclosure(2, "_apply(1)");
  setclosureframe(closure2902, stackframe);
  addtoclosure(closure2902, var_other);
  addtoclosure(closure2902, selfslot);
  struct UserObject *uo2902 = (struct UserObject*)block2901;
  uo2902->data[0] = (Object)closure2902;
  Method *meth_meth_collectionsPrelude_2902__apply_40_1_41_ = addmethod2pos(block2901, "_apply(1)", &meth_collectionsPrelude_2902__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2902__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2902__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2902__apply_40_1_41_);
  meth_meth_collectionsPrelude_2902__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2902__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2901 (depth = 4)
  gc_frame_newslot(block2901);
// call case 4: self request
  params[0] = block2901;
  partcv[0] = 1;
  Object call2906 = callmethodflags(self, "filter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2900);
// compiled call node returning call2906 (depth = 3)
  gc_frame_newslot(call2906);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2907 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  partcv[0] = 0;
  Object call2908 = callmethodflags(module_collectionsPrelude, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2907);
// compiled member node returning call2908 (depth = 3)
  params[0] = call2906;
  partcv[0] = 1;
  Object call2909 = callmethodflags(call2908, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2899);
// compiled call node returning call2909 (depth = 2)
  gc_frame_end(frame);
  return call2909;
}
Object meth_collectionsPrelude_2913__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s2 = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2915 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe2916 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s2 (depth = 7)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2917 = callmethodflags(*var_s2, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2916);
// compiled call node returning call2917 (depth = 6)
  partcv[0] = 0;
  Object call2918 = callmethodflags(call2917, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2915);
// compiled member node returning call2918 (depth = 5)
  Object if2914 = done;
  if (istrue(call2918)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2919 = alloc_Boolean(0);
// compiled identifier node returning bool2919 (depth = 6)
  block_return(realself, bool2919);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2914 = undefined;
  } else {
  }
// compiled if node returning if2914 (depth = 4)
  gc_frame_end(frame);
  return if2914;
}
Object meth_collectionsPrelude_2910_isSubset_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSubset(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isSubset(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSubset(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s2 = &(stackframe->slots[0]);
  *var_s2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isSubset(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2911 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2912 = alloc_Block(NULL, NULL, "collectionsPrelude", 1199);
  gc_frame_newslot(block2912);
// method "_apply(_)"
  block_savedest(block2912);
  Object closure2913 = createclosure(2, "_apply(1)");
  setclosureframe(closure2913, stackframe);
  addtoclosure(closure2913, var_s2);
  addtoclosure(closure2913, selfslot);
  struct UserObject *uo2913 = (struct UserObject*)block2912;
  uo2913->data[0] = (Object)closure2913;
  Method *meth_meth_collectionsPrelude_2913__apply_40_1_41_ = addmethod2pos(block2912, "_apply(1)", &meth_collectionsPrelude_2913__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2913__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2913__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2913__apply_40_1_41_);
  meth_meth_collectionsPrelude_2913__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2913__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2912 (depth = 3)
  gc_frame_newslot(block2912);
// call case 4: self request
  params[0] = block2912;
  partcv[0] = 1;
  Object call2921 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2911);
// compiled call node returning call2921 (depth = 2)
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2922 = alloc_Boolean(1);
// compiled identifier node returning bool2922 (depth = 3)
  return bool2922;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_2926__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2928 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe2929 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2930 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2929);
// compiled call node returning call2930 (depth = 6)
  partcv[0] = 0;
  Object call2931 = callmethodflags(call2930, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2928);
// compiled member node returning call2931 (depth = 5)
  Object if2927 = done;
  if (istrue(call2931)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2932 = alloc_Boolean(0);
// compiled identifier node returning bool2932 (depth = 6)
  block_return(realself, bool2932);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2927 = undefined;
  } else {
  }
// compiled if node returning if2927 (depth = 4)
  gc_frame_end(frame);
  return if2927;
}
Object meth_collectionsPrelude_2923_isSuperset_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSuperset(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isSuperset(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSuperset(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s2 = &(stackframe->slots[0]);
  *var_s2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isSuperset(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2924 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2925 = alloc_Block(NULL, NULL, "collectionsPrelude", 1206);
  gc_frame_newslot(block2925);
// method "_apply(_)"
  block_savedest(block2925);
  Object closure2926 = createclosure(1, "_apply(1)");
  setclosureframe(closure2926, stackframe);
  addtoclosure(closure2926, selfslot);
  struct UserObject *uo2926 = (struct UserObject*)block2925;
  uo2926->data[0] = (Object)closure2926;
  Method *meth_meth_collectionsPrelude_2926__apply_40_1_41_ = addmethod2pos(block2925, "_apply(1)", &meth_collectionsPrelude_2926__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2926__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2926__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2926__apply_40_1_41_);
  meth_meth_collectionsPrelude_2926__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2926__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2925 (depth = 3)
  gc_frame_newslot(block2925);
// call case 6: other requests
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s2 (depth = 3)
  params[0] = block2925;
  partcv[0] = 1;
  Object call2934 = callmethodflags(*var_s2, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2924);
// compiled call node returning call2934 (depth = 2)
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2935 = alloc_Boolean(1);
// compiled identifier node returning bool2935 (depth = 3)
  return bool2935;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_2939__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_existing = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe2940 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_existing (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2941 = callmethodflags(*var_existing, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2940);
// compiled call node returning call2941 (depth = 4)
  gc_frame_end(frame);
  return call2941;
}
Object meth_collectionsPrelude_2936_into_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2937 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2938 = alloc_Block(NULL, NULL, "collectionsPrelude", 1212);
  gc_frame_newslot(block2938);
// method "_apply(_)"
  block_savedest(block2938);
  Object closure2939 = createclosure(2, "_apply(1)");
  setclosureframe(closure2939, stackframe);
  addtoclosure(closure2939, var_existing);
  addtoclosure(closure2939, selfslot);
  struct UserObject *uo2939 = (struct UserObject*)block2938;
  uo2939->data[0] = (Object)closure2939;
  Method *meth_meth_collectionsPrelude_2939__apply_40_1_41_ = addmethod2pos(block2938, "_apply(1)", &meth_collectionsPrelude_2939__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2939__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2939__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2939__apply_40_1_41_);
  meth_meth_collectionsPrelude_2939__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2939__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2938 (depth = 3)
  gc_frame_newslot(block2938);
// call case 4: self request
  params[0] = block2938;
  partcv[0] = 1;
  Object call2943 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2937);
// compiled call node returning call2943 (depth = 2)
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_existing (depth = 2)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude_2954__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2955 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2956 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2957 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2956);
// compiled member node returning call2957 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2958 = callmethodflags(call2957, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2955);
// compiled call node returning call2958 (depth = 4)
  gc_frame_end(frame);
  return call2958;
}
Object meth_collectionsPrelude_2150_ofCapacity_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ofCapacity(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ofCapacity(_)");
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var_Collection = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ofCapacity(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cap = &(stackframe->slots[0]);
  *var_cap = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ofCapacity(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2151 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2151 = alloc_userobj2(35,33, objclass2151);
  gc_frame_newslot(obj2151);
  if (objclass2151 == NULL) {
    glfree(obj2151->class->name);
    obj2151->class->name = "set.ofCapacity(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2151, self, 0);
  addmethodreal(obj2151,"outer", &reader_collectionsPrelude_outer_2152);
  Object oldself2151 = self;
  struct StackFrameObject *oldstackframe2151 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2151);
  gc_frame_newslot((Object)stackframe);
  self = obj2151;
  Object *oldselfslot2151 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2151 = (*(struct UserObject *)self).data[0], lowerouter2151 = thisouter2151;
  if (inheritingObject2151) {
    struct UserObject *inho2151 = (struct UserObject *)inheritingObject2151;
    while (inho2151->super != GraceDefaultObject) inho2151 = (struct UserObject *)inho2151->super;
    inho2151->super = obj2151;
    self = inheritingObject2151;
    *selfslot = self;
    lowerouter2151 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2151;
  }
  if (objclass2151 == NULL) {
    Method *reader2153 = addmethodrealflags(obj2151, "mods", &reader_collectionsPrelude_mods_2153, 0);
    Method *writer2153 = addmethodrealflags(obj2151, "mods:=(1)", &writer_collectionsPrelude_mods_2153, MFLAG_CONFIDENTIAL);
    reader2153->definitionModule = modulename;
    writer2153->definitionModule = modulename;
    reader2153->definitionLine = 940;
    writer2153->definitionLine = 940;
  }
  obj2151->flags |= OFLAG_MUTABLE;
  adddatum2(obj2151, alloc_Undefined(), 1);
  if (objclass2151 == NULL) {
    Method *reader2154 = addmethodrealflags(obj2151, "inner", &reader_collectionsPrelude_inner_2154, MFLAG_CONFIDENTIAL);
    Method *writer2154 = addmethodrealflags(obj2151, "inner:=(1)", &writer_collectionsPrelude_inner_2154, MFLAG_CONFIDENTIAL);
    reader2154->definitionModule = modulename;
    writer2154->definitionModule = modulename;
    reader2154->definitionLine = 941;
    writer2154->definitionLine = 941;
  }
  obj2151->flags |= OFLAG_MUTABLE;
  adddatum2(obj2151, alloc_Undefined(), 2);
  if (objclass2151 == NULL) {
    Method *reader2155 = addmethodrealflags(obj2151, "size", &reader_collectionsPrelude_size_2155, 0);
    Method *writer2155 = addmethodrealflags(obj2151, "size:=(1)", &writer_collectionsPrelude_size_2155, MFLAG_CONFIDENTIAL);
    reader2155->definitionModule = modulename;
    writer2155->definitionModule = modulename;
    reader2155->definitionLine = 942;
    writer2155->definitionLine = 942;
  }
  obj2151->flags |= OFLAG_MUTABLE;
  adddatum2(obj2151, alloc_Undefined(), 3);
// method "isEmpty"
  struct UserObject *uo2156 = (struct UserObject*)obj2151;
  uo2156->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2156_isEmpty = addmethod2pos(obj2151, "isEmpty", &meth_collectionsPrelude_2156_isEmpty, 4);
  int argcv_meth_collectionsPrelude_2156_isEmpty[] = {0};
  meth_meth_collectionsPrelude_2156_isEmpty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2156_isEmpty);
  meth_meth_collectionsPrelude_2156_isEmpty->definitionModule = modulename;
  meth_meth_collectionsPrelude_2156_isEmpty->definitionLine = 947;
// method "addAll(_)"
  struct UserObject *uo2163 = (struct UserObject*)obj2151;
  uo2163->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2163_addAll_40_1_41_ = addmethod2pos(obj2151, "addAll(1)", &meth_collectionsPrelude_2163_addAll_40_1_41_, 5);
  int argcv_meth_collectionsPrelude_2163_addAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2163_addAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2163_addAll_40_1_41_);
  meth_meth_collectionsPrelude_2163_addAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2163_addAll_40_1_41_->definitionLine = 949;
// method "add(_)"
  struct UserObject *uo2212 = (struct UserObject*)obj2151;
  uo2212->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2212_add_40_1_41_ = addmethod2pos(obj2151, "add(1)", &meth_collectionsPrelude_2212_add_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_2212_add_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2212_add_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2212_add_40_1_41_);
  meth_meth_collectionsPrelude_2212_add_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2212_add_40_1_41_->definitionLine = 964;
// method "removeAll(_)"
  block_savedest(obj2151);
  Object closure2256 = createclosure(1, "removeAll(1)");
  setclosureframe(closure2256, stackframe);
  addtoclosure(closure2256, var_NoSuchObject);
  struct UserObject *uo2256 = (struct UserObject*)obj2151;
  uo2256->data[7] = (Object)closure2256;
  Method *meth_meth_collectionsPrelude_2256_removeAll_40_1_41_ = addmethod2pos(obj2151, "removeAll(1)", &meth_collectionsPrelude_2256_removeAll_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_2256_removeAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2256_removeAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2256_removeAll_40_1_41_);
  meth_meth_collectionsPrelude_2256_removeAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2256_removeAll_40_1_41_->definitionLine = 977;
// method "removeAll(_)ifAbsent(_)"
  block_savedest(obj2151);
  Object closure2277 = createclosure(1, "removeAll(1)ifAbsent(1)");
  setclosureframe(closure2277, stackframe);
  addtoclosure(closure2277, var_removed);
  struct UserObject *uo2277 = (struct UserObject*)obj2151;
  uo2277->data[8] = (Object)closure2277;
  Method *meth_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj2151, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_->definitionLine = 985;
// method "clear"
  block_savedest(obj2151);
  Object closure2315 = createclosure(1, "clear");
  setclosureframe(closure2315, stackframe);
  addtoclosure(closure2315, var_cap);
  struct UserObject *uo2315 = (struct UserObject*)obj2151;
  uo2315->data[9] = (Object)closure2315;
  Method *meth_meth_collectionsPrelude_2315_clear = addmethod2pos(obj2151, "clear", &meth_collectionsPrelude_2315_clear, 9);
  int argcv_meth_collectionsPrelude_2315_clear[] = {0};
  meth_meth_collectionsPrelude_2315_clear->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2315_clear);
  meth_meth_collectionsPrelude_2315_clear->definitionModule = modulename;
  meth_meth_collectionsPrelude_2315_clear->definitionLine = 998;
// method "remove(_)ifAbsent(_)"
  block_savedest(obj2151);
  Object closure2333 = createclosure(1, "remove(1)ifAbsent(1)");
  setclosureframe(closure2333, stackframe);
  addtoclosure(closure2333, var_removed);
  struct UserObject *uo2333 = (struct UserObject*)obj2151;
  uo2333->data[10] = (Object)closure2333;
  Method *meth_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj2151, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_, 10);
  int argcv_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_->definitionLine = 1005;
// method "remove(_)"
  block_savedest(obj2151);
  Object closure2366 = createclosure(1, "remove(1)");
  setclosureframe(closure2366, stackframe);
  addtoclosure(closure2366, var_NoSuchObject);
  struct UserObject *uo2366 = (struct UserObject*)obj2151;
  uo2366->data[11] = (Object)closure2366;
  Method *meth_meth_collectionsPrelude_2366_remove_40_1_41_ = addmethod2pos(obj2151, "remove(1)", &meth_collectionsPrelude_2366_remove_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_2366_remove_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2366_remove_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2366_remove_40_1_41_);
  meth_meth_collectionsPrelude_2366_remove_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2366_remove_40_1_41_->definitionLine = 1017;
// method "contains(_)"
  struct UserObject *uo2382 = (struct UserObject*)obj2151;
  uo2382->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2382_contains_40_1_41_ = addmethod2pos(obj2151, "contains(1)", &meth_collectionsPrelude_2382_contains_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_2382_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2382_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2382_contains_40_1_41_);
  meth_meth_collectionsPrelude_2382_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2382_contains_40_1_41_->definitionLine = 1024;
// method "includes(_)"
  struct UserObject *uo2395 = (struct UserObject*)obj2151;
  uo2395->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2395_includes_40_1_41_ = addmethod2pos(obj2151, "includes(1)", &meth_collectionsPrelude_2395_includes_40_1_41_, 13);
  int argcv_meth_collectionsPrelude_2395_includes_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2395_includes_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2395_includes_40_1_41_);
  meth_meth_collectionsPrelude_2395_includes_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2395_includes_40_1_41_->definitionLine = 1031;
// method "find(_)ifNone(_)"
  struct UserObject *uo2406 = (struct UserObject*)obj2151;
  uo2406->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_ = addmethod2pos(obj2151, "find(1)ifNone(1)", &meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_, 14);
  int argcv_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_);
  meth_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_->definitionLine = 1037;
// method "findPosition(_)"
  block_savedest(obj2151);
  Object closure2417 = createclosure(1, "findPosition(1)");
  setclosureframe(closure2417, stackframe);
  addtoclosure(closure2417, var_unused);
  struct UserObject *uo2417 = (struct UserObject*)obj2151;
  uo2417->data[15] = (Object)closure2417;
  Method *meth_meth_collectionsPrelude_2417_findPosition_40_1_41_ = addmethod2pos(obj2151, "findPosition(1)", &meth_collectionsPrelude_2417_findPosition_40_1_41_, 15);
  int argcv_meth_collectionsPrelude_2417_findPosition_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2417_findPosition_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2417_findPosition_40_1_41_);
  meth_meth_collectionsPrelude_2417_findPosition_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_2417_findPosition_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2417_findPosition_40_1_41_->definitionLine = 1043;
// method "findPositionForAdd(_)"
  block_savedest(obj2151);
  Object closure2478 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure2478, stackframe);
  addtoclosure(closure2478, var_removed);
  addtoclosure(closure2478, var_unused);
  struct UserObject *uo2478 = (struct UserObject*)obj2151;
  uo2478->data[16] = (Object)closure2478;
  Method *meth_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_ = addmethod2pos(obj2151, "findPositionForAdd(1)", &meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_, 16);
  int argcv_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_);
  meth_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_->definitionLine = 1065;
// method "asString"
  struct UserObject *uo2545 = (struct UserObject*)obj2151;
  uo2545->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2545_asString = addmethod2pos(obj2151, "asString", &meth_collectionsPrelude_2545_asString, 17);
  int argcv_meth_collectionsPrelude_2545_asString[] = {0};
  meth_meth_collectionsPrelude_2545_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2545_asString);
  meth_meth_collectionsPrelude_2545_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_2545_asString->definitionLine = 1088;
// method "asDebugString"
  struct UserObject *uo2570 = (struct UserObject*)obj2151;
  uo2570->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2570_asDebugString = addmethod2pos(obj2151, "asDebugString", &meth_collectionsPrelude_2570_asDebugString, 18);
  int argcv_meth_collectionsPrelude_2570_asDebugString[] = {0};
  meth_meth_collectionsPrelude_2570_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2570_asDebugString);
  meth_meth_collectionsPrelude_2570_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_2570_asDebugString->definitionLine = 1094;
// method "extend(_)"
  struct UserObject *uo2595 = (struct UserObject*)obj2151;
  uo2595->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2595_extend_40_1_41_ = addmethod2pos(obj2151, "extend(1)", &meth_collectionsPrelude_2595_extend_40_1_41_, 19);
  int argcv_meth_collectionsPrelude_2595_extend_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2595_extend_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2595_extend_40_1_41_);
  meth_meth_collectionsPrelude_2595_extend_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2595_extend_40_1_41_->definitionLine = 1100;
// method "do(_)"
  block_savedest(obj2151);
  Object closure2603 = createclosure(3, "do(1)");
  setclosureframe(closure2603, stackframe);
  addtoclosure(closure2603, var_ConcurrentModification);
  addtoclosure(closure2603, var_removed);
  addtoclosure(closure2603, var_unused);
  struct UserObject *uo2603 = (struct UserObject*)obj2151;
  uo2603->data[20] = (Object)closure2603;
  Method *meth_meth_collectionsPrelude_2603_do_40_1_41_ = addmethod2pos(obj2151, "do(1)", &meth_collectionsPrelude_2603_do_40_1_41_, 20);
  int argcv_meth_collectionsPrelude_2603_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2603_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2603_do_40_1_41_);
  meth_meth_collectionsPrelude_2603_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2603_do_40_1_41_->definitionLine = 1105;
// method "iterator"
  block_savedest(obj2151);
  Object closure2660 = createclosure(4, "iterator");
  setclosureframe(closure2660, stackframe);
  addtoclosure(closure2660, var_ConcurrentModification);
  addtoclosure(closure2660, var_IteratorExhausted);
  addtoclosure(closure2660, var_removed);
  addtoclosure(closure2660, var_unused);
  struct UserObject *uo2660 = (struct UserObject*)obj2151;
  uo2660->data[21] = (Object)closure2660;
  Method *meth_meth_collectionsPrelude_2660_iterator = addmethod2pos(obj2151, "iterator", &meth_collectionsPrelude_2660_iterator, 21);
  int argcv_meth_collectionsPrelude_2660_iterator[] = {0};
  meth_meth_collectionsPrelude_2660_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2660_iterator);
  meth_meth_collectionsPrelude_2660_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_2660_iterator->definitionLine = 1122;
  block_savedest(obj2151);
  Object closure2769 = createclosure(4, "iterator$object(1)");
  setclosureframe(closure2769, stackframe);
  addtoclosure(closure2769, var_ConcurrentModification);
  addtoclosure(closure2769, var_IteratorExhausted);
  addtoclosure(closure2769, var_removed);
  addtoclosure(closure2769, var_unused);
  Method *meth_meth_collectionsPrelude_2660_iterator_object = addmethod2pos(obj2151, "iterator$object(1)", &meth_collectionsPrelude_2660_iterator_object, 21);
  meth_meth_collectionsPrelude_2660_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_2660_iterator_object->definitionLine = 1122;
// method "expand"
  block_savedest(obj2151);
  Object closure2770 = createclosure(2, "expand");
  setclosureframe(closure2770, stackframe);
  addtoclosure(closure2770, var_unused);
  addtoclosure(closure2770, var_removed);
  struct UserObject *uo2770 = (struct UserObject*)obj2151;
  uo2770->data[22] = (Object)closure2770;
  Method *meth_meth_collectionsPrelude_2770_expand = addmethod2pos(obj2151, "expand", &meth_collectionsPrelude_2770_expand, 22);
  int argcv_meth_collectionsPrelude_2770_expand[] = {0};
  meth_meth_collectionsPrelude_2770_expand->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2770_expand);
  meth_meth_collectionsPrelude_2770_expand->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_2770_expand->definitionModule = modulename;
  meth_meth_collectionsPrelude_2770_expand->definitionLine = 1148;
// method "==(_)"
  block_savedest(obj2151);
  Object closure2844 = createclosure(1, "==(1)");
  setclosureframe(closure2844, stackframe);
  addtoclosure(closure2844, var_Collection);
  struct UserObject *uo2844 = (struct UserObject*)obj2151;
  uo2844->data[23] = (Object)closure2844;
  Method *meth_meth_collectionsPrelude_2844__61__61__40_1_41_ = addmethod2pos(obj2151, "==(1)", &meth_collectionsPrelude_2844__61__61__40_1_41_, 23);
  int argcv_meth_collectionsPrelude_2844__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2844__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2844__61__61__40_1_41_);
  meth_meth_collectionsPrelude_2844__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2844__61__61__40_1_41_->definitionLine = 1163;
// method "copy"
  struct UserObject *uo2871 = (struct UserObject*)obj2151;
  uo2871->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2871_copy = addmethod2pos(obj2151, "copy", &meth_collectionsPrelude_2871_copy, 24);
  int argcv_meth_collectionsPrelude_2871_copy[] = {0};
  meth_meth_collectionsPrelude_2871_copy->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2871_copy);
  meth_meth_collectionsPrelude_2871_copy->definitionModule = modulename;
  meth_meth_collectionsPrelude_2871_copy->definitionLine = 1177;
// method "++(_)"
  struct UserObject *uo2876 = (struct UserObject*)obj2151;
  uo2876->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2876__43__43__40_1_41_ = addmethod2pos(obj2151, "++(1)", &meth_collectionsPrelude_2876__43__43__40_1_41_, 25);
  int argcv_meth_collectionsPrelude_2876__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2876__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2876__43__43__40_1_41_);
  meth_meth_collectionsPrelude_2876__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2876__43__43__40_1_41_->definitionLine = 1180;
// method "--(_)"
  struct UserObject *uo2881 = (struct UserObject*)obj2151;
  uo2881->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2881__45__45__40_1_41_ = addmethod2pos(obj2151, "--(1)", &meth_collectionsPrelude_2881__45__45__40_1_41_, 26);
  int argcv_meth_collectionsPrelude_2881__45__45__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2881__45__45__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2881__45__45__40_1_41_);
  meth_meth_collectionsPrelude_2881__45__45__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2881__45__45__40_1_41_->definitionLine = 1184;
// method "**(_)"
  struct UserObject *uo2898 = (struct UserObject*)obj2151;
  uo2898->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2898__42__42__40_1_41_ = addmethod2pos(obj2151, "**(1)", &meth_collectionsPrelude_2898__42__42__40_1_41_, 27);
  int argcv_meth_collectionsPrelude_2898__42__42__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2898__42__42__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2898__42__42__40_1_41_);
  meth_meth_collectionsPrelude_2898__42__42__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2898__42__42__40_1_41_->definitionLine = 1194;
// method "isSubset(_)"
  struct UserObject *uo2910 = (struct UserObject*)obj2151;
  uo2910->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2910_isSubset_40_1_41_ = addmethod2pos(obj2151, "isSubset(1)", &meth_collectionsPrelude_2910_isSubset_40_1_41_, 28);
  int argcv_meth_collectionsPrelude_2910_isSubset_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2910_isSubset_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2910_isSubset_40_1_41_);
  meth_meth_collectionsPrelude_2910_isSubset_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2910_isSubset_40_1_41_->definitionLine = 1198;
// method "isSuperset(_)"
  struct UserObject *uo2923 = (struct UserObject*)obj2151;
  uo2923->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2923_isSuperset_40_1_41_ = addmethod2pos(obj2151, "isSuperset(1)", &meth_collectionsPrelude_2923_isSuperset_40_1_41_, 29);
  int argcv_meth_collectionsPrelude_2923_isSuperset_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2923_isSuperset_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2923_isSuperset_40_1_41_);
  meth_meth_collectionsPrelude_2923_isSuperset_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2923_isSuperset_40_1_41_->definitionLine = 1205;
// method "into(_)"
  struct UserObject *uo2936 = (struct UserObject*)obj2151;
  uo2936->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2936_into_40_1_41_ = addmethod2pos(obj2151, "into(1)", &meth_collectionsPrelude_2936_into_40_1_41_, 30);
  int argcv_meth_collectionsPrelude_2936_into_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2936_into_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2936_into_40_1_41_);
  meth_meth_collectionsPrelude_2936_into_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2936_into_40_1_41_->definitionLine = 1211;
  sourceObject = obj2151;
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2944 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2945 = callmethodflags(module_collectionsPrelude, "collection$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2944);
// compiled call node returning call2945 (depth = 2)
  struct UserObject *obj2151_uo = (struct UserObject *)obj2151;
  obj2151_uo->super = call2945;
  sourceObject = obj2151;
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2946 = alloc_Float64(0);
// compiled num node returning num2946 (depth = 2)
  adddatum2(obj2151, num2946, 1);
  sourceObject = obj2151;
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2947 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cap (depth = 3)
  gc_frame_newslot(*var_cap);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2948 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2949 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2948);
// compiled member node returning call2949 (depth = 3)
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call2950 = callmethodflags(call2949, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2947);
// compiled call node returning call2950 (depth = 2)
  adddatum2(obj2151, call2950, 2);
  sourceObject = obj2151;
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2951 = alloc_Float64(0);
// compiled num node returning num2951 (depth = 2)
  adddatum2(obj2151, num2951, 3);
  sourceObject = obj2151;
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2952 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2953 = alloc_Block(NULL, NULL, "collectionsPrelude", 943);
  gc_frame_newslot(block2953);
// method "_apply(_)"
  block_savedest(block2953);
  Object closure2954 = createclosure(2, "_apply(1)");
  setclosureframe(closure2954, stackframe);
  addtoclosure(closure2954, var_unused);
  addtoclosure(closure2954, selfslot);
  struct UserObject *uo2954 = (struct UserObject*)block2953;
  uo2954->data[0] = (Object)closure2954;
  Method *meth_meth_collectionsPrelude_2954__apply_40_1_41_ = addmethod2pos(block2953, "_apply(1)", &meth_collectionsPrelude_2954__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2954__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2954__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2954__apply_40_1_41_);
  meth_meth_collectionsPrelude_2954__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2954__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2953 (depth = 3)
  gc_frame_newslot(block2953);
// call case 6: other requests
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2962 = alloc_Float64(1);
// compiled num node returning num2962 (depth = 5)
  int op_slot_right_2961 = gc_frame_newslot(num2962);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cap (depth = 5)
  int op_slot_left_2961 = gc_frame_newslot(*var_cap);
  params[0] = num2962;
  partcv[0] = 1;
  Object diff2964 = callmethod(*var_cap, "-(1)", 1, partcv, params);
// compiled op node returning diff2964 (depth = 4)
  int op_slot_right_2960 = gc_frame_newslot(diff2964);
// starting to compile num node (depth = 4)
  Object num2966 = alloc_Float64(0);
// compiled num node returning num2966 (depth = 4)
  int op_slot_left_2960 = gc_frame_newslot(num2966);
  params[0] = diff2964;
  partcv[0] = 1;
  Object opresult2967 = callmethod(num2966, "..(1)", 1, partcv, params);
// compiled op node returning opresult2967 (depth = 3)
  params[0] = block2953;
  partcv[0] = 1;
  Object call2968 = callmethodflags(opresult2967, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2952);
// compiled call node returning call2968 (depth = 2)
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  objclass2151 = obj2151->class;
  objclass2151->definitionModule = modulename;
  objclass2151->definitionLine = 938;
  (*(struct UserObject *)self).data[0] = lowerouter2151;
  self = oldself2151;
  selfslot = oldselfslot2151;
  stackframe = oldstackframe2151;
  gc_frame_end(frame);
  return obj2151;
}
Object meth_collectionsPrelude_2150_ofCapacity_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ofCapacity(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method ofCapacity(_)");
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var_Collection = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ofCapacity(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cap = &(stackframe->slots[0]);
  *var_cap = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ofCapacity(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2151 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2151 = alloc_userobj2(35,33, objclass2151);
  gc_frame_newslot(obj2151);
  if (objclass2151 == NULL) {
    glfree(obj2151->class->name);
    obj2151->class->name = "set.ofCapacity(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2151, self, 0);
  addmethodreal(obj2151,"outer", &reader_collectionsPrelude_outer_2152);
  Object oldself2151 = self;
  struct StackFrameObject *oldstackframe2151 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2151);
  gc_frame_newslot((Object)stackframe);
  self = obj2151;
  Object *oldselfslot2151 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2151 = (*(struct UserObject *)self).data[0], lowerouter2151 = thisouter2151;
  if (inheritingObject2151) {
    struct UserObject *inho2151 = (struct UserObject *)inheritingObject2151;
    while (inho2151->super != GraceDefaultObject) inho2151 = (struct UserObject *)inho2151->super;
    inho2151->super = obj2151;
    self = inheritingObject2151;
    *selfslot = self;
    lowerouter2151 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2151;
  }
  if (objclass2151 == NULL) {
    Method *reader2153 = addmethodrealflags(obj2151, "mods", &reader_collectionsPrelude_mods_2153, 0);
    Method *writer2153 = addmethodrealflags(obj2151, "mods:=(1)", &writer_collectionsPrelude_mods_2153, MFLAG_CONFIDENTIAL);
    reader2153->definitionModule = modulename;
    writer2153->definitionModule = modulename;
    reader2153->definitionLine = 940;
    writer2153->definitionLine = 940;
  }
  obj2151->flags |= OFLAG_MUTABLE;
  adddatum2(obj2151, alloc_Undefined(), 1);
  if (objclass2151 == NULL) {
    Method *reader2154 = addmethodrealflags(obj2151, "inner", &reader_collectionsPrelude_inner_2154, MFLAG_CONFIDENTIAL);
    Method *writer2154 = addmethodrealflags(obj2151, "inner:=(1)", &writer_collectionsPrelude_inner_2154, MFLAG_CONFIDENTIAL);
    reader2154->definitionModule = modulename;
    writer2154->definitionModule = modulename;
    reader2154->definitionLine = 941;
    writer2154->definitionLine = 941;
  }
  obj2151->flags |= OFLAG_MUTABLE;
  adddatum2(obj2151, alloc_Undefined(), 2);
  if (objclass2151 == NULL) {
    Method *reader2155 = addmethodrealflags(obj2151, "size", &reader_collectionsPrelude_size_2155, 0);
    Method *writer2155 = addmethodrealflags(obj2151, "size:=(1)", &writer_collectionsPrelude_size_2155, MFLAG_CONFIDENTIAL);
    reader2155->definitionModule = modulename;
    writer2155->definitionModule = modulename;
    reader2155->definitionLine = 942;
    writer2155->definitionLine = 942;
  }
  obj2151->flags |= OFLAG_MUTABLE;
  adddatum2(obj2151, alloc_Undefined(), 3);
// method "isEmpty"
  struct UserObject *uo2156 = (struct UserObject*)obj2151;
  uo2156->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2156_isEmpty = addmethod2pos(obj2151, "isEmpty", &meth_collectionsPrelude_2156_isEmpty, 4);
  int argcv_meth_collectionsPrelude_2156_isEmpty[] = {0};
  meth_meth_collectionsPrelude_2156_isEmpty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2156_isEmpty);
  meth_meth_collectionsPrelude_2156_isEmpty->definitionModule = modulename;
  meth_meth_collectionsPrelude_2156_isEmpty->definitionLine = 947;
// method "addAll(_)"
  struct UserObject *uo2163 = (struct UserObject*)obj2151;
  uo2163->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2163_addAll_40_1_41_ = addmethod2pos(obj2151, "addAll(1)", &meth_collectionsPrelude_2163_addAll_40_1_41_, 5);
  int argcv_meth_collectionsPrelude_2163_addAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2163_addAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2163_addAll_40_1_41_);
  meth_meth_collectionsPrelude_2163_addAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2163_addAll_40_1_41_->definitionLine = 949;
// method "add(_)"
  struct UserObject *uo2212 = (struct UserObject*)obj2151;
  uo2212->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2212_add_40_1_41_ = addmethod2pos(obj2151, "add(1)", &meth_collectionsPrelude_2212_add_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_2212_add_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2212_add_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2212_add_40_1_41_);
  meth_meth_collectionsPrelude_2212_add_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2212_add_40_1_41_->definitionLine = 964;
// method "removeAll(_)"
  block_savedest(obj2151);
  Object closure2256 = createclosure(1, "removeAll(1)");
  setclosureframe(closure2256, stackframe);
  addtoclosure(closure2256, var_NoSuchObject);
  struct UserObject *uo2256 = (struct UserObject*)obj2151;
  uo2256->data[7] = (Object)closure2256;
  Method *meth_meth_collectionsPrelude_2256_removeAll_40_1_41_ = addmethod2pos(obj2151, "removeAll(1)", &meth_collectionsPrelude_2256_removeAll_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_2256_removeAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2256_removeAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2256_removeAll_40_1_41_);
  meth_meth_collectionsPrelude_2256_removeAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2256_removeAll_40_1_41_->definitionLine = 977;
// method "removeAll(_)ifAbsent(_)"
  block_savedest(obj2151);
  Object closure2277 = createclosure(1, "removeAll(1)ifAbsent(1)");
  setclosureframe(closure2277, stackframe);
  addtoclosure(closure2277, var_removed);
  struct UserObject *uo2277 = (struct UserObject*)obj2151;
  uo2277->data[8] = (Object)closure2277;
  Method *meth_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj2151, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2277_removeAll_40_1_41_ifAbsent_40_1_41_->definitionLine = 985;
// method "clear"
  block_savedest(obj2151);
  Object closure2315 = createclosure(1, "clear");
  setclosureframe(closure2315, stackframe);
  addtoclosure(closure2315, var_cap);
  struct UserObject *uo2315 = (struct UserObject*)obj2151;
  uo2315->data[9] = (Object)closure2315;
  Method *meth_meth_collectionsPrelude_2315_clear = addmethod2pos(obj2151, "clear", &meth_collectionsPrelude_2315_clear, 9);
  int argcv_meth_collectionsPrelude_2315_clear[] = {0};
  meth_meth_collectionsPrelude_2315_clear->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2315_clear);
  meth_meth_collectionsPrelude_2315_clear->definitionModule = modulename;
  meth_meth_collectionsPrelude_2315_clear->definitionLine = 998;
// method "remove(_)ifAbsent(_)"
  block_savedest(obj2151);
  Object closure2333 = createclosure(1, "remove(1)ifAbsent(1)");
  setclosureframe(closure2333, stackframe);
  addtoclosure(closure2333, var_removed);
  struct UserObject *uo2333 = (struct UserObject*)obj2151;
  uo2333->data[10] = (Object)closure2333;
  Method *meth_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj2151, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_, 10);
  int argcv_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2333_remove_40_1_41_ifAbsent_40_1_41_->definitionLine = 1005;
// method "remove(_)"
  block_savedest(obj2151);
  Object closure2366 = createclosure(1, "remove(1)");
  setclosureframe(closure2366, stackframe);
  addtoclosure(closure2366, var_NoSuchObject);
  struct UserObject *uo2366 = (struct UserObject*)obj2151;
  uo2366->data[11] = (Object)closure2366;
  Method *meth_meth_collectionsPrelude_2366_remove_40_1_41_ = addmethod2pos(obj2151, "remove(1)", &meth_collectionsPrelude_2366_remove_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_2366_remove_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2366_remove_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2366_remove_40_1_41_);
  meth_meth_collectionsPrelude_2366_remove_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2366_remove_40_1_41_->definitionLine = 1017;
// method "contains(_)"
  struct UserObject *uo2382 = (struct UserObject*)obj2151;
  uo2382->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2382_contains_40_1_41_ = addmethod2pos(obj2151, "contains(1)", &meth_collectionsPrelude_2382_contains_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_2382_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2382_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2382_contains_40_1_41_);
  meth_meth_collectionsPrelude_2382_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2382_contains_40_1_41_->definitionLine = 1024;
// method "includes(_)"
  struct UserObject *uo2395 = (struct UserObject*)obj2151;
  uo2395->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2395_includes_40_1_41_ = addmethod2pos(obj2151, "includes(1)", &meth_collectionsPrelude_2395_includes_40_1_41_, 13);
  int argcv_meth_collectionsPrelude_2395_includes_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2395_includes_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2395_includes_40_1_41_);
  meth_meth_collectionsPrelude_2395_includes_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2395_includes_40_1_41_->definitionLine = 1031;
// method "find(_)ifNone(_)"
  struct UserObject *uo2406 = (struct UserObject*)obj2151;
  uo2406->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_ = addmethod2pos(obj2151, "find(1)ifNone(1)", &meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_, 14);
  int argcv_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_);
  meth_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2406_find_40_1_41_ifNone_40_1_41_->definitionLine = 1037;
// method "findPosition(_)"
  block_savedest(obj2151);
  Object closure2417 = createclosure(1, "findPosition(1)");
  setclosureframe(closure2417, stackframe);
  addtoclosure(closure2417, var_unused);
  struct UserObject *uo2417 = (struct UserObject*)obj2151;
  uo2417->data[15] = (Object)closure2417;
  Method *meth_meth_collectionsPrelude_2417_findPosition_40_1_41_ = addmethod2pos(obj2151, "findPosition(1)", &meth_collectionsPrelude_2417_findPosition_40_1_41_, 15);
  int argcv_meth_collectionsPrelude_2417_findPosition_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2417_findPosition_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2417_findPosition_40_1_41_);
  meth_meth_collectionsPrelude_2417_findPosition_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_2417_findPosition_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2417_findPosition_40_1_41_->definitionLine = 1043;
// method "findPositionForAdd(_)"
  block_savedest(obj2151);
  Object closure2478 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure2478, stackframe);
  addtoclosure(closure2478, var_removed);
  addtoclosure(closure2478, var_unused);
  struct UserObject *uo2478 = (struct UserObject*)obj2151;
  uo2478->data[16] = (Object)closure2478;
  Method *meth_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_ = addmethod2pos(obj2151, "findPositionForAdd(1)", &meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_, 16);
  int argcv_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_);
  meth_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2478_findPositionForAdd_40_1_41_->definitionLine = 1065;
// method "asString"
  struct UserObject *uo2545 = (struct UserObject*)obj2151;
  uo2545->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2545_asString = addmethod2pos(obj2151, "asString", &meth_collectionsPrelude_2545_asString, 17);
  int argcv_meth_collectionsPrelude_2545_asString[] = {0};
  meth_meth_collectionsPrelude_2545_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2545_asString);
  meth_meth_collectionsPrelude_2545_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_2545_asString->definitionLine = 1088;
// method "asDebugString"
  struct UserObject *uo2570 = (struct UserObject*)obj2151;
  uo2570->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2570_asDebugString = addmethod2pos(obj2151, "asDebugString", &meth_collectionsPrelude_2570_asDebugString, 18);
  int argcv_meth_collectionsPrelude_2570_asDebugString[] = {0};
  meth_meth_collectionsPrelude_2570_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2570_asDebugString);
  meth_meth_collectionsPrelude_2570_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_2570_asDebugString->definitionLine = 1094;
// method "extend(_)"
  struct UserObject *uo2595 = (struct UserObject*)obj2151;
  uo2595->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2595_extend_40_1_41_ = addmethod2pos(obj2151, "extend(1)", &meth_collectionsPrelude_2595_extend_40_1_41_, 19);
  int argcv_meth_collectionsPrelude_2595_extend_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2595_extend_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2595_extend_40_1_41_);
  meth_meth_collectionsPrelude_2595_extend_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2595_extend_40_1_41_->definitionLine = 1100;
// method "do(_)"
  block_savedest(obj2151);
  Object closure2603 = createclosure(3, "do(1)");
  setclosureframe(closure2603, stackframe);
  addtoclosure(closure2603, var_ConcurrentModification);
  addtoclosure(closure2603, var_removed);
  addtoclosure(closure2603, var_unused);
  struct UserObject *uo2603 = (struct UserObject*)obj2151;
  uo2603->data[20] = (Object)closure2603;
  Method *meth_meth_collectionsPrelude_2603_do_40_1_41_ = addmethod2pos(obj2151, "do(1)", &meth_collectionsPrelude_2603_do_40_1_41_, 20);
  int argcv_meth_collectionsPrelude_2603_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2603_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2603_do_40_1_41_);
  meth_meth_collectionsPrelude_2603_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2603_do_40_1_41_->definitionLine = 1105;
// method "iterator"
  block_savedest(obj2151);
  Object closure2660 = createclosure(4, "iterator");
  setclosureframe(closure2660, stackframe);
  addtoclosure(closure2660, var_ConcurrentModification);
  addtoclosure(closure2660, var_IteratorExhausted);
  addtoclosure(closure2660, var_removed);
  addtoclosure(closure2660, var_unused);
  struct UserObject *uo2660 = (struct UserObject*)obj2151;
  uo2660->data[21] = (Object)closure2660;
  Method *meth_meth_collectionsPrelude_2660_iterator = addmethod2pos(obj2151, "iterator", &meth_collectionsPrelude_2660_iterator, 21);
  int argcv_meth_collectionsPrelude_2660_iterator[] = {0};
  meth_meth_collectionsPrelude_2660_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2660_iterator);
  meth_meth_collectionsPrelude_2660_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_2660_iterator->definitionLine = 1122;
  block_savedest(obj2151);
  Object closure2769 = createclosure(4, "iterator$object(1)");
  setclosureframe(closure2769, stackframe);
  addtoclosure(closure2769, var_ConcurrentModification);
  addtoclosure(closure2769, var_IteratorExhausted);
  addtoclosure(closure2769, var_removed);
  addtoclosure(closure2769, var_unused);
  Method *meth_meth_collectionsPrelude_2660_iterator_object = addmethod2pos(obj2151, "iterator$object(1)", &meth_collectionsPrelude_2660_iterator_object, 21);
  meth_meth_collectionsPrelude_2660_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_2660_iterator_object->definitionLine = 1122;
// method "expand"
  block_savedest(obj2151);
  Object closure2770 = createclosure(2, "expand");
  setclosureframe(closure2770, stackframe);
  addtoclosure(closure2770, var_unused);
  addtoclosure(closure2770, var_removed);
  struct UserObject *uo2770 = (struct UserObject*)obj2151;
  uo2770->data[22] = (Object)closure2770;
  Method *meth_meth_collectionsPrelude_2770_expand = addmethod2pos(obj2151, "expand", &meth_collectionsPrelude_2770_expand, 22);
  int argcv_meth_collectionsPrelude_2770_expand[] = {0};
  meth_meth_collectionsPrelude_2770_expand->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2770_expand);
  meth_meth_collectionsPrelude_2770_expand->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_2770_expand->definitionModule = modulename;
  meth_meth_collectionsPrelude_2770_expand->definitionLine = 1148;
// method "==(_)"
  block_savedest(obj2151);
  Object closure2844 = createclosure(1, "==(1)");
  setclosureframe(closure2844, stackframe);
  addtoclosure(closure2844, var_Collection);
  struct UserObject *uo2844 = (struct UserObject*)obj2151;
  uo2844->data[23] = (Object)closure2844;
  Method *meth_meth_collectionsPrelude_2844__61__61__40_1_41_ = addmethod2pos(obj2151, "==(1)", &meth_collectionsPrelude_2844__61__61__40_1_41_, 23);
  int argcv_meth_collectionsPrelude_2844__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2844__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2844__61__61__40_1_41_);
  meth_meth_collectionsPrelude_2844__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2844__61__61__40_1_41_->definitionLine = 1163;
// method "copy"
  struct UserObject *uo2871 = (struct UserObject*)obj2151;
  uo2871->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2871_copy = addmethod2pos(obj2151, "copy", &meth_collectionsPrelude_2871_copy, 24);
  int argcv_meth_collectionsPrelude_2871_copy[] = {0};
  meth_meth_collectionsPrelude_2871_copy->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2871_copy);
  meth_meth_collectionsPrelude_2871_copy->definitionModule = modulename;
  meth_meth_collectionsPrelude_2871_copy->definitionLine = 1177;
// method "++(_)"
  struct UserObject *uo2876 = (struct UserObject*)obj2151;
  uo2876->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2876__43__43__40_1_41_ = addmethod2pos(obj2151, "++(1)", &meth_collectionsPrelude_2876__43__43__40_1_41_, 25);
  int argcv_meth_collectionsPrelude_2876__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2876__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2876__43__43__40_1_41_);
  meth_meth_collectionsPrelude_2876__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2876__43__43__40_1_41_->definitionLine = 1180;
// method "--(_)"
  struct UserObject *uo2881 = (struct UserObject*)obj2151;
  uo2881->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2881__45__45__40_1_41_ = addmethod2pos(obj2151, "--(1)", &meth_collectionsPrelude_2881__45__45__40_1_41_, 26);
  int argcv_meth_collectionsPrelude_2881__45__45__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2881__45__45__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2881__45__45__40_1_41_);
  meth_meth_collectionsPrelude_2881__45__45__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2881__45__45__40_1_41_->definitionLine = 1184;
// method "**(_)"
  struct UserObject *uo2898 = (struct UserObject*)obj2151;
  uo2898->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2898__42__42__40_1_41_ = addmethod2pos(obj2151, "**(1)", &meth_collectionsPrelude_2898__42__42__40_1_41_, 27);
  int argcv_meth_collectionsPrelude_2898__42__42__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2898__42__42__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2898__42__42__40_1_41_);
  meth_meth_collectionsPrelude_2898__42__42__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2898__42__42__40_1_41_->definitionLine = 1194;
// method "isSubset(_)"
  struct UserObject *uo2910 = (struct UserObject*)obj2151;
  uo2910->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2910_isSubset_40_1_41_ = addmethod2pos(obj2151, "isSubset(1)", &meth_collectionsPrelude_2910_isSubset_40_1_41_, 28);
  int argcv_meth_collectionsPrelude_2910_isSubset_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2910_isSubset_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2910_isSubset_40_1_41_);
  meth_meth_collectionsPrelude_2910_isSubset_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2910_isSubset_40_1_41_->definitionLine = 1198;
// method "isSuperset(_)"
  struct UserObject *uo2923 = (struct UserObject*)obj2151;
  uo2923->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2923_isSuperset_40_1_41_ = addmethod2pos(obj2151, "isSuperset(1)", &meth_collectionsPrelude_2923_isSuperset_40_1_41_, 29);
  int argcv_meth_collectionsPrelude_2923_isSuperset_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2923_isSuperset_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2923_isSuperset_40_1_41_);
  meth_meth_collectionsPrelude_2923_isSuperset_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2923_isSuperset_40_1_41_->definitionLine = 1205;
// method "into(_)"
  struct UserObject *uo2936 = (struct UserObject*)obj2151;
  uo2936->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2936_into_40_1_41_ = addmethod2pos(obj2151, "into(1)", &meth_collectionsPrelude_2936_into_40_1_41_, 30);
  int argcv_meth_collectionsPrelude_2936_into_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2936_into_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2936_into_40_1_41_);
  meth_meth_collectionsPrelude_2936_into_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2936_into_40_1_41_->definitionLine = 1211;
  sourceObject = obj2151;
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2944 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2945 = callmethodflags(module_collectionsPrelude, "collection$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2944);
// compiled call node returning call2945 (depth = 2)
  struct UserObject *obj2151_uo = (struct UserObject *)obj2151;
  obj2151_uo->super = call2945;
  sourceObject = obj2151;
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2946 = alloc_Float64(0);
// compiled num node returning num2946 (depth = 2)
  adddatum2(obj2151, num2946, 1);
  sourceObject = obj2151;
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2947 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cap (depth = 3)
  gc_frame_newslot(*var_cap);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2948 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2949 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2948);
// compiled member node returning call2949 (depth = 3)
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call2950 = callmethodflags(call2949, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2947);
// compiled call node returning call2950 (depth = 2)
  adddatum2(obj2151, call2950, 2);
  sourceObject = obj2151;
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2951 = alloc_Float64(0);
// compiled num node returning num2951 (depth = 2)
  adddatum2(obj2151, num2951, 3);
  sourceObject = obj2151;
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2952 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2953 = alloc_Block(NULL, NULL, "collectionsPrelude", 943);
  gc_frame_newslot(block2953);
// method "_apply(_)"
  block_savedest(block2953);
  Object closure2954 = createclosure(2, "_apply(1)");
  setclosureframe(closure2954, stackframe);
  addtoclosure(closure2954, var_unused);
  addtoclosure(closure2954, selfslot);
  struct UserObject *uo2954 = (struct UserObject*)block2953;
  uo2954->data[0] = (Object)closure2954;
  Method *meth_meth_collectionsPrelude_2954__apply_40_1_41_ = addmethod2pos(block2953, "_apply(1)", &meth_collectionsPrelude_2954__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2954__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2954__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2954__apply_40_1_41_);
  meth_meth_collectionsPrelude_2954__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2954__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2953 (depth = 3)
  gc_frame_newslot(block2953);
// call case 6: other requests
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2962 = alloc_Float64(1);
// compiled num node returning num2962 (depth = 5)
  int op_slot_right_2961 = gc_frame_newslot(num2962);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cap (depth = 5)
  int op_slot_left_2961 = gc_frame_newslot(*var_cap);
  params[0] = num2962;
  partcv[0] = 1;
  Object diff2964 = callmethod(*var_cap, "-(1)", 1, partcv, params);
// compiled op node returning diff2964 (depth = 4)
  int op_slot_right_2960 = gc_frame_newslot(diff2964);
// starting to compile num node (depth = 4)
  Object num2966 = alloc_Float64(0);
// compiled num node returning num2966 (depth = 4)
  int op_slot_left_2960 = gc_frame_newslot(num2966);
  params[0] = diff2964;
  partcv[0] = 1;
  Object opresult2967 = callmethod(num2966, "..(1)", 1, partcv, params);
// compiled op node returning opresult2967 (depth = 3)
  params[0] = block2953;
  partcv[0] = 1;
  Object call2968 = callmethodflags(opresult2967, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2952);
// compiled call node returning call2968 (depth = 2)
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  sourceObject = obj2151;
  objclass2151 = obj2151->class;
  objclass2151->definitionModule = modulename;
  objclass2151->definitionLine = 938;
  (*(struct UserObject *)self).data[0] = lowerouter2151;
  self = oldself2151;
  selfslot = oldselfslot2151;
  stackframe = oldstackframe2151;
  gc_frame_end(frame);
  return obj2151;
}
Object meth_collectionsPrelude_2114_set(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "set");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var_Collection = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2115 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2115 = alloc_userobj2(5,6, objclass2115);
  gc_frame_newslot(obj2115);
  if (objclass2115 == NULL) {
    glfree(obj2115->class->name);
    obj2115->class->name = "set";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2115, self, 0);
  addmethodreal(obj2115,"outer", &reader_collectionsPrelude_outer_2116);
  Object oldself2115 = self;
  struct StackFrameObject *oldstackframe2115 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2115);
  gc_frame_newslot((Object)stackframe);
  self = obj2115;
  Object *oldselfslot2115 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2115 = (*(struct UserObject *)self).data[0], lowerouter2115 = thisouter2115;
  if (inheritingObject2115) {
    struct UserObject *inho2115 = (struct UserObject *)inheritingObject2115;
    while (inho2115->super != GraceDefaultObject) inho2115 = (struct UserObject *)inho2115->super;
    inho2115->super = obj2115;
    self = inheritingObject2115;
    *selfslot = self;
    lowerouter2115 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2115;
  }
// method "asString"
  struct UserObject *uo2117 = (struct UserObject*)obj2115;
  uo2117->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2117_asString = addmethod2pos(obj2115, "asString", &meth_collectionsPrelude_2117_asString, 1);
  int argcv_meth_collectionsPrelude_2117_asString[] = {0};
  meth_meth_collectionsPrelude_2117_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2117_asString);
  meth_meth_collectionsPrelude_2117_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_2117_asString->definitionLine = 925;
// method "withAll(_)"
  struct UserObject *uo2119 = (struct UserObject*)obj2115;
  uo2119->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2119_withAll_40_1_41_ = addmethod2pos(obj2115, "withAll(1)", &meth_collectionsPrelude_2119_withAll_40_1_41_, 2);
  int argcv_meth_collectionsPrelude_2119_withAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2119_withAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2119_withAll_40_1_41_);
  meth_meth_collectionsPrelude_2119_withAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2119_withAll_40_1_41_->definitionLine = 927;
// method "empty"
  struct UserObject *uo2146 = (struct UserObject*)obj2115;
  uo2146->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2146_empty = addmethod2pos(obj2115, "empty", &meth_collectionsPrelude_2146_empty, 3);
  int argcv_meth_collectionsPrelude_2146_empty[] = {0};
  meth_meth_collectionsPrelude_2146_empty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2146_empty);
  meth_meth_collectionsPrelude_2146_empty->definitionModule = modulename;
  meth_meth_collectionsPrelude_2146_empty->definitionLine = 934;
// method "ofCapacity(_)"
  block_savedest(obj2115);
  Object closure2150 = createclosure(6, "ofCapacity(1)");
  setclosureframe(closure2150, stackframe);
  addtoclosure(closure2150, var_NoSuchObject);
  addtoclosure(closure2150, var_removed);
  addtoclosure(closure2150, var_unused);
  addtoclosure(closure2150, var_ConcurrentModification);
  addtoclosure(closure2150, var_IteratorExhausted);
  addtoclosure(closure2150, var_Collection);
  struct UserObject *uo2150 = (struct UserObject*)obj2115;
  uo2150->data[4] = (Object)closure2150;
  Method *meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41_ = addmethod2pos(obj2115, "ofCapacity(1)", &meth_collectionsPrelude_2150_ofCapacity_40_1_41_, 4);
  int argcv_meth_collectionsPrelude_2150_ofCapacity_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2150_ofCapacity_40_1_41_);
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41_->definitionLine = 938;
  block_savedest(obj2115);
  Object closure2969 = createclosure(6, "ofCapacity(1)$object(1)");
  setclosureframe(closure2969, stackframe);
  addtoclosure(closure2969, var_NoSuchObject);
  addtoclosure(closure2969, var_removed);
  addtoclosure(closure2969, var_unused);
  addtoclosure(closure2969, var_ConcurrentModification);
  addtoclosure(closure2969, var_IteratorExhausted);
  addtoclosure(closure2969, var_Collection);
  Method *meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41__object = addmethod2pos(obj2115, "ofCapacity(1)$object(1)", &meth_collectionsPrelude_2150_ofCapacity_40_1_41__object, 4);
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41__object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41__object->definitionLine = 938;
  sourceObject = obj2115;
  sourceObject = obj2115;
  sourceObject = obj2115;
  sourceObject = obj2115;
  objclass2115 = obj2115->class;
  objclass2115->definitionModule = modulename;
  objclass2115->definitionLine = 923;
  (*(struct UserObject *)self).data[0] = lowerouter2115;
  self = oldself2115;
  selfslot = oldselfslot2115;
  stackframe = oldstackframe2115;
  gc_frame_end(frame);
  return obj2115;
}
Object meth_collectionsPrelude_2114_set_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "set$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var_Collection = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2115 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2115 = alloc_userobj2(5,6, objclass2115);
  gc_frame_newslot(obj2115);
  if (objclass2115 == NULL) {
    glfree(obj2115->class->name);
    obj2115->class->name = "set";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2115, self, 0);
  addmethodreal(obj2115,"outer", &reader_collectionsPrelude_outer_2116);
  Object oldself2115 = self;
  struct StackFrameObject *oldstackframe2115 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2115);
  gc_frame_newslot((Object)stackframe);
  self = obj2115;
  Object *oldselfslot2115 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2115 = (*(struct UserObject *)self).data[0], lowerouter2115 = thisouter2115;
  if (inheritingObject2115) {
    struct UserObject *inho2115 = (struct UserObject *)inheritingObject2115;
    while (inho2115->super != GraceDefaultObject) inho2115 = (struct UserObject *)inho2115->super;
    inho2115->super = obj2115;
    self = inheritingObject2115;
    *selfslot = self;
    lowerouter2115 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2115;
  }
// method "asString"
  struct UserObject *uo2117 = (struct UserObject*)obj2115;
  uo2117->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2117_asString = addmethod2pos(obj2115, "asString", &meth_collectionsPrelude_2117_asString, 1);
  int argcv_meth_collectionsPrelude_2117_asString[] = {0};
  meth_meth_collectionsPrelude_2117_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2117_asString);
  meth_meth_collectionsPrelude_2117_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_2117_asString->definitionLine = 925;
// method "withAll(_)"
  struct UserObject *uo2119 = (struct UserObject*)obj2115;
  uo2119->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2119_withAll_40_1_41_ = addmethod2pos(obj2115, "withAll(1)", &meth_collectionsPrelude_2119_withAll_40_1_41_, 2);
  int argcv_meth_collectionsPrelude_2119_withAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2119_withAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2119_withAll_40_1_41_);
  meth_meth_collectionsPrelude_2119_withAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2119_withAll_40_1_41_->definitionLine = 927;
// method "empty"
  struct UserObject *uo2146 = (struct UserObject*)obj2115;
  uo2146->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2146_empty = addmethod2pos(obj2115, "empty", &meth_collectionsPrelude_2146_empty, 3);
  int argcv_meth_collectionsPrelude_2146_empty[] = {0};
  meth_meth_collectionsPrelude_2146_empty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2146_empty);
  meth_meth_collectionsPrelude_2146_empty->definitionModule = modulename;
  meth_meth_collectionsPrelude_2146_empty->definitionLine = 934;
// method "ofCapacity(_)"
  block_savedest(obj2115);
  Object closure2150 = createclosure(6, "ofCapacity(1)");
  setclosureframe(closure2150, stackframe);
  addtoclosure(closure2150, var_NoSuchObject);
  addtoclosure(closure2150, var_removed);
  addtoclosure(closure2150, var_unused);
  addtoclosure(closure2150, var_ConcurrentModification);
  addtoclosure(closure2150, var_IteratorExhausted);
  addtoclosure(closure2150, var_Collection);
  struct UserObject *uo2150 = (struct UserObject*)obj2115;
  uo2150->data[4] = (Object)closure2150;
  Method *meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41_ = addmethod2pos(obj2115, "ofCapacity(1)", &meth_collectionsPrelude_2150_ofCapacity_40_1_41_, 4);
  int argcv_meth_collectionsPrelude_2150_ofCapacity_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2150_ofCapacity_40_1_41_);
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41_->definitionLine = 938;
  block_savedest(obj2115);
  Object closure2969 = createclosure(6, "ofCapacity(1)$object(1)");
  setclosureframe(closure2969, stackframe);
  addtoclosure(closure2969, var_NoSuchObject);
  addtoclosure(closure2969, var_removed);
  addtoclosure(closure2969, var_unused);
  addtoclosure(closure2969, var_ConcurrentModification);
  addtoclosure(closure2969, var_IteratorExhausted);
  addtoclosure(closure2969, var_Collection);
  Method *meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41__object = addmethod2pos(obj2115, "ofCapacity(1)$object(1)", &meth_collectionsPrelude_2150_ofCapacity_40_1_41__object, 4);
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41__object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_2150_ofCapacity_40_1_41__object->definitionLine = 938;
  sourceObject = obj2115;
  sourceObject = obj2115;
  sourceObject = obj2115;
  sourceObject = obj2115;
  objclass2115 = obj2115->class;
  objclass2115->definitionModule = modulename;
  objclass2115->definitionLine = 923;
  (*(struct UserObject *)self).data[0] = lowerouter2115;
  self = oldself2115;
  selfslot = oldselfslot2115;
  stackframe = oldstackframe2115;
  gc_frame_end(frame);
  return obj2115;
}
Object meth_collectionsPrelude_2974_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2975 == NULL) {
    strlit2975 = alloc_String("a dictionary class");
    gc_root(strlit2975);
  }
// compiled string node returning strlit2975 (depth = 2)
  gc_frame_end(frame);
  return strlit2975;
}
Object meth_collectionsPrelude_2981__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe2982 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call2983 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2982);
// compiled call node returning call2983 (depth = 4)
  gc_frame_end(frame);
  return call2983;
}
Object meth_collectionsPrelude_2976_withAll_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initialBindings = &(stackframe->slots[0]);
  *var_initialBindings = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2977 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2978 = callmethodflags(self, "empty", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2977);
// compiled member node returning call2978 (depth = 3)
  *var_result = call2978;
  if (call2978 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2979 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_initialBindings (depth = 3)
  gc_frame_newslot(*var_initialBindings);
// starting to compile block node (depth = 3)
  Object block2980 = alloc_Block(NULL, NULL, "collectionsPrelude", 1253);
  gc_frame_newslot(block2980);
// method "_apply(_)"
  block_savedest(block2980);
  Object closure2981 = createclosure(2, "_apply(1)");
  setclosureframe(closure2981, stackframe);
  addtoclosure(closure2981, var_result);
  addtoclosure(closure2981, selfslot);
  struct UserObject *uo2981 = (struct UserObject*)block2980;
  uo2981->data[0] = (Object)closure2981;
  Method *meth_meth_collectionsPrelude_2981__apply_40_1_41_ = addmethod2pos(block2980, "_apply(1)", &meth_collectionsPrelude_2981__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_2981__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2981__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2981__apply_40_1_41_);
  meth_meth_collectionsPrelude_2981__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2981__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block2980 (depth = 3)
  gc_frame_newslot(block2980);
// call case 5: prelude request
  params[0] = *var_initialBindings;
  params[1] = block2980;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2985 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2979);
// compiled call node returning call2985 (depth = 2)
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_2992_size(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2993 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2994 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2993);
// compiled member node returning call2994 (depth = 2)
  gc_frame_end(frame);
  return call2994;
}
Object meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)put(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)put(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_key_39_ = &(stackframe->slots[0]);
  *var_key_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_value_39_ = &(stackframe->slots[1]);
  *var_value_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part put(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2996 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2998 = alloc_Float64(1);
// compiled num node returning num2998 (depth = 4)
  int op_slot_right_2997 = gc_frame_newslot(num2998);
// starting to compile member node (depth = 4)
  int callframe3000 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3001 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3000);
// compiled member node returning call3001 (depth = 4)
  int op_slot_left_2997 = gc_frame_newslot(call3001);
  params[0] = num2998;
  partcv[0] = 1;
  Object sum3002 = callmethod(call3001, "+(1)", 1, partcv, params);
// compiled op node returning sum3002 (depth = 3)
  gc_frame_newslot(sum3002);
// call case 4: self request
  params[0] = sum3002;
  partcv[0] = 1;
  Object call3003 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2996);
// compiled call node returning call3003 (depth = 2)
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3004 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_key_39_ (depth = 4)
  gc_frame_newslot(*var_key_39_);
// call case 4: self request
  params[0] = *var_key_39_;
  partcv[0] = 1;
  Object call3005 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3004);
// compiled call node returning call3005 (depth = 3)
  *var_t = call3005;
  if (call3005 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3009 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3010 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3011 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3010);
// compiled member node returning call3011 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3012 = callmethodflags(call3011, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3009);
// compiled call node returning call3012 (depth = 5)
  int op_slot_right_3008 = gc_frame_newslot(call3012);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_removed (depth = 5)
  int op_slot_left_3008 = gc_frame_newslot(*var_removed);
  params[0] = call3012;
  partcv[0] = 1;
  Object opresult3014 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult3014 (depth = 4)
  int op_slot_right_3007 = gc_frame_newslot(opresult3014);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3017 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3018 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3019 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3018);
// compiled member node returning call3019 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3020 = callmethodflags(call3019, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3017);
// compiled call node returning call3020 (depth = 5)
  int op_slot_right_3016 = gc_frame_newslot(call3020);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3016 = gc_frame_newslot(*var_unused);
  params[0] = call3020;
  partcv[0] = 1;
  Object opresult3022 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult3022 (depth = 4)
  int op_slot_left_3007 = gc_frame_newslot(opresult3022);
  params[0] = opresult3014;
  partcv[0] = 1;
  Object opresult3023 = callmethod(opresult3022, "||(1)", 1, partcv, params);
// compiled op node returning opresult3023 (depth = 3)
  Object if3006 = done;
  if (istrue(opresult3023)) {
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3024 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3026 = alloc_Float64(1);
// compiled num node returning num3026 (depth = 5)
  int op_slot_right_3025 = gc_frame_newslot(num3026);
// starting to compile member node (depth = 5)
  int callframe3028 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3029 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3028);
// compiled member node returning call3029 (depth = 5)
  int op_slot_left_3025 = gc_frame_newslot(call3029);
  params[0] = num3026;
  partcv[0] = 1;
  Object sum3030 = callmethod(call3029, "+(1)", 1, partcv, params);
// compiled op node returning sum3030 (depth = 4)
  gc_frame_newslot(sum3030);
// call case 4: self request
  params[0] = sum3030;
  partcv[0] = 1;
  Object call3031 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3024);
// compiled call node returning call3031 (depth = 3)
    gc_frame_newslot(call3031);
    if3006 = call3031;
  } else {
  }
// compiled if node returning if3006 (depth = 2)
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3032 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// starting to compile call node (depth = 3)
  int callframe3033 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_key_39_ (depth = 4)
  gc_frame_newslot(*var_key_39_);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_value_39_ (depth = 4)
  gc_frame_newslot(*var_value_39_);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_binding (depth = 4)
  params[0] = *var_key_39_;
  params[1] = *var_value_39_;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3034 = callmethodflags(*var_binding, "key(1)value(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3033);
// compiled call node returning call3034 (depth = 3)
  gc_frame_newslot(call3034);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3035 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3036 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3035);
// compiled member node returning call3036 (depth = 3)
  params[0] = *var_t;
  params[1] = call3034;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3037 = callmethodflags(call3036, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3032);
// compiled call node returning call3037 (depth = 2)
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3040 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3041 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3042 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3041);
// compiled member node returning call3042 (depth = 5)
  partcv[0] = 0;
  Object call3043 = callmethodflags(call3042, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3040);
// compiled member node returning call3043 (depth = 4)
  int op_slot_right_3039 = gc_frame_newslot(call3043);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3046 = alloc_Float64(2);
// compiled num node returning num3046 (depth = 5)
  int op_slot_right_3045 = gc_frame_newslot(num3046);
// starting to compile member node (depth = 5)
  int callframe3048 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3049 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3048);
// compiled member node returning call3049 (depth = 5)
  int op_slot_left_3045 = gc_frame_newslot(call3049);
  params[0] = num3046;
  partcv[0] = 1;
  Object prod3050 = callmethod(call3049, "*(1)", 1, partcv, params);
// compiled op node returning prod3050 (depth = 4)
  int op_slot_left_3039 = gc_frame_newslot(prod3050);
  params[0] = call3043;
  partcv[0] = 1;
  Object opresult3051 = callmethod(prod3050, ">(1)", 1, partcv, params);
// compiled op node returning opresult3051 (depth = 3)
  Object if3038 = done;
  if (istrue(opresult3051)) {
// starting to compile member node (depth = 3)
  int callframe3052 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3053 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3052);
// compiled member node returning call3053 (depth = 3)
    gc_frame_newslot(call3053);
    if3038 = call3053;
  } else {
  }
// compiled if node returning if3038 (depth = 2)
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_3054_add_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aBinding = &(stackframe->slots[0]);
  *var_aBinding = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3055 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3057 = alloc_Float64(1);
// compiled num node returning num3057 (depth = 4)
  int op_slot_right_3056 = gc_frame_newslot(num3057);
// starting to compile member node (depth = 4)
  int callframe3059 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3060 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3059);
// compiled member node returning call3060 (depth = 4)
  int op_slot_left_3056 = gc_frame_newslot(call3060);
  params[0] = num3057;
  partcv[0] = 1;
  Object sum3061 = callmethod(call3060, "+(1)", 1, partcv, params);
// compiled op node returning sum3061 (depth = 3)
  gc_frame_newslot(sum3061);
// call case 4: self request
  params[0] = sum3061;
  partcv[0] = 1;
  Object call3062 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3055);
// compiled call node returning call3062 (depth = 2)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3063 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3064 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aBinding (depth = 5)
  partcv[0] = 0;
  Object call3065 = callmethodflags(*var_aBinding, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3064);
// compiled member node returning call3065 (depth = 4)
  gc_frame_newslot(call3065);
// call case 4: self request
  params[0] = call3065;
  partcv[0] = 1;
  Object call3066 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3063);
// compiled call node returning call3066 (depth = 3)
  *var_t = call3066;
  if (call3066 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3070 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3071 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3072 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3071);
// compiled member node returning call3072 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3073 = callmethodflags(call3072, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3070);
// compiled call node returning call3073 (depth = 5)
  int op_slot_right_3069 = gc_frame_newslot(call3073);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_removed (depth = 5)
  int op_slot_left_3069 = gc_frame_newslot(*var_removed);
  params[0] = call3073;
  partcv[0] = 1;
  Object opresult3075 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult3075 (depth = 4)
  int op_slot_right_3068 = gc_frame_newslot(opresult3075);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3078 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3079 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3080 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3079);
// compiled member node returning call3080 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3081 = callmethodflags(call3080, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3078);
// compiled call node returning call3081 (depth = 5)
  int op_slot_right_3077 = gc_frame_newslot(call3081);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3077 = gc_frame_newslot(*var_unused);
  params[0] = call3081;
  partcv[0] = 1;
  Object opresult3083 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult3083 (depth = 4)
  int op_slot_left_3068 = gc_frame_newslot(opresult3083);
  params[0] = opresult3075;
  partcv[0] = 1;
  Object opresult3084 = callmethod(opresult3083, "||(1)", 1, partcv, params);
// compiled op node returning opresult3084 (depth = 3)
  Object if3067 = done;
  if (istrue(opresult3084)) {
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3085 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3087 = alloc_Float64(1);
// compiled num node returning num3087 (depth = 5)
  int op_slot_right_3086 = gc_frame_newslot(num3087);
// starting to compile member node (depth = 5)
  int callframe3089 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3090 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3089);
// compiled member node returning call3090 (depth = 5)
  int op_slot_left_3086 = gc_frame_newslot(call3090);
  params[0] = num3087;
  partcv[0] = 1;
  Object sum3091 = callmethod(call3090, "+(1)", 1, partcv, params);
// compiled op node returning sum3091 (depth = 4)
  gc_frame_newslot(sum3091);
// call case 4: self request
  params[0] = sum3091;
  partcv[0] = 1;
  Object call3092 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3085);
// compiled call node returning call3092 (depth = 3)
    gc_frame_newslot(call3092);
    if3067 = call3092;
  } else {
  }
// compiled if node returning if3067 (depth = 2)
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3093 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_aBinding (depth = 3)
  gc_frame_newslot(*var_aBinding);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3094 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3095 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3094);
// compiled member node returning call3095 (depth = 3)
  params[0] = *var_t;
  params[1] = *var_aBinding;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3096 = callmethodflags(call3095, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3093);
// compiled call node returning call3096 (depth = 2)
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3099 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3101 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3100);
// compiled member node returning call3101 (depth = 5)
  partcv[0] = 0;
  Object call3102 = callmethodflags(call3101, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3099);
// compiled member node returning call3102 (depth = 4)
  int op_slot_right_3098 = gc_frame_newslot(call3102);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3105 = alloc_Float64(2);
// compiled num node returning num3105 (depth = 5)
  int op_slot_right_3104 = gc_frame_newslot(num3105);
// starting to compile member node (depth = 5)
  int callframe3107 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3108 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3107);
// compiled member node returning call3108 (depth = 5)
  int op_slot_left_3104 = gc_frame_newslot(call3108);
  params[0] = num3105;
  partcv[0] = 1;
  Object prod3109 = callmethod(call3108, "*(1)", 1, partcv, params);
// compiled op node returning prod3109 (depth = 4)
  int op_slot_left_3098 = gc_frame_newslot(prod3109);
  params[0] = call3102;
  partcv[0] = 1;
  Object opresult3110 = callmethod(prod3109, ">(1)", 1, partcv, params);
// compiled op node returning opresult3110 (depth = 3)
  Object if3097 = done;
  if (istrue(opresult3110)) {
// starting to compile member node (depth = 3)
  int callframe3111 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3112 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3111);
// compiled member node returning call3112 (depth = 3)
    gc_frame_newslot(call3112);
    if3097 = call3112;
  } else {
  }
// compiled if node returning if3097 (depth = 2)
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_3113_at_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_b = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "b");
// definebindings:
// definebindings:
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3114 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3115 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3116 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3115);
// compiled call node returning call3116 (depth = 4)
  gc_frame_newslot(call3116);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3117 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3118 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3117);
// compiled member node returning call3118 (depth = 4)
  params[0] = call3116;
  partcv[0] = 1;
  Object call3119 = callmethodflags(call3118, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3114);
// compiled call node returning call3119 (depth = 3)
  *var_b = call3119;
  if (call3119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3121 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3123 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  partcv[0] = 0;
  Object call3124 = callmethodflags(*var_b, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3123);
// compiled member node returning call3124 (depth = 4)
  int op_slot_left_3121 = gc_frame_newslot(call3124);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3125 = callmethod(call3124, "==(1)", 1, partcv, params);
// compiled op node returning opresult3125 (depth = 3)
  Object if3120 = done;
  if (istrue(opresult3125)) {
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3126 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  partcv[0] = 0;
  Object call3127 = callmethodflags(*var_b, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3126);
// compiled member node returning call3127 (depth = 4)
  return call3127;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3120 = undefined;
  } else {
  }
// compiled if node returning if3120 (depth = 2)
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3128 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3130 == NULL) {
    strlit3130 = alloc_String("");
    gc_root(strlit3130);
  }
// compiled string node returning strlit3130 (depth = 4)
  int op_slot_right_3129 = gc_frame_newslot(strlit3130);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  int op_slot_right_3132 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 5)
  if (strlit3134 == NULL) {
    strlit3134 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3134);
  }
// compiled string node returning strlit3134 (depth = 5)
  int op_slot_left_3132 = gc_frame_newslot(strlit3134);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3135 = callmethod(strlit3134, "++(1)", 1, partcv, params);
// compiled op node returning opresult3135 (depth = 4)
  int op_slot_left_3129 = gc_frame_newslot(opresult3135);
  params[0] = strlit3130;
  partcv[0] = 1;
  Object opresult3136 = callmethod(opresult3135, "++(1)", 1, partcv, params);
// compiled op node returning opresult3136 (depth = 3)
  gc_frame_newslot(opresult3136);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NoSuchObject (depth = 3)
  params[0] = opresult3136;
  partcv[0] = 1;
  Object call3137 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3128);
// compiled call node returning call3137 (depth = 2)
  gc_frame_end(frame);
  return call3137;
}
Object meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)ifAbsent(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_b = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "b");
// definebindings:
// definebindings:
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3139 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3140 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3141 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3140);
// compiled call node returning call3141 (depth = 4)
  gc_frame_newslot(call3141);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3142 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3143 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3142);
// compiled member node returning call3143 (depth = 4)
  params[0] = call3141;
  partcv[0] = 1;
  Object call3144 = callmethodflags(call3143, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3139);
// compiled call node returning call3144 (depth = 3)
  *var_b = call3144;
  if (call3144 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3146 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3148 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  partcv[0] = 0;
  Object call3149 = callmethodflags(*var_b, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3148);
// compiled member node returning call3149 (depth = 4)
  int op_slot_left_3146 = gc_frame_newslot(call3149);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3150 = callmethod(call3149, "==(1)", 1, partcv, params);
// compiled op node returning opresult3150 (depth = 3)
  Object if3145 = done;
  if (istrue(opresult3150)) {
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3151 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  partcv[0] = 0;
  Object call3152 = callmethodflags(*var_b, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3151);
// compiled member node returning call3152 (depth = 4)
  return call3152;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3145 = undefined;
  } else {
  }
// compiled if node returning if3145 (depth = 2)
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3153 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_action (depth = 3)
  partcv[0] = 0;
  Object call3154 = callmethodflags(*var_action, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe3153);
// compiled member node returning call3154 (depth = 2)
  gc_frame_end(frame);
  return call3154;
}
Object meth_collectionsPrelude_3155_containsKey_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "containsKey(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method containsKey(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for containsKey(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part containsKey(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// definebindings:
// definebindings:
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3156 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3157 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3156);
// compiled call node returning call3157 (depth = 3)
  *var_t = call3157;
  if (call3157 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3159 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3161 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe3162 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3163 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3164 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3163);
// compiled member node returning call3164 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3165 = callmethodflags(call3164, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3162);
// compiled call node returning call3165 (depth = 5)
  partcv[0] = 0;
  Object call3166 = callmethodflags(call3165, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3161);
// compiled member node returning call3166 (depth = 4)
  int op_slot_left_3159 = gc_frame_newslot(call3166);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3167 = callmethod(call3166, "==(1)", 1, partcv, params);
// compiled op node returning opresult3167 (depth = 3)
  Object if3158 = done;
  if (istrue(opresult3167)) {
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool3168 = alloc_Boolean(1);
// compiled identifier node returning bool3168 (depth = 4)
  return bool3168;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3158 = undefined;
  } else {
  }
// compiled if node returning if3158 (depth = 2)
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool3169 = alloc_Boolean(0);
// compiled identifier node returning bool3169 (depth = 2)
  gc_frame_end(frame);
  return bool3169;
}
Object meth_collectionsPrelude_3181__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// definebindings:
// definebindings:
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3182 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3183 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3182);
// compiled call node returning call3183 (depth = 5)
  *var_t = call3183;
  if (call3183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  int op_slot_right_3185 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 6)
  int callframe3187 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3188 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3189 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3190 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3189);
// compiled member node returning call3190 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3191 = callmethodflags(call3190, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3188);
// compiled call node returning call3191 (depth = 7)
  partcv[0] = 0;
  Object call3192 = callmethodflags(call3191, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3187);
// compiled member node returning call3192 (depth = 6)
  int op_slot_left_3185 = gc_frame_newslot(call3192);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3193 = callmethod(call3192, "==(1)", 1, partcv, params);
// compiled op node returning opresult3193 (depth = 5)
  Object if3184 = done;
  if (istrue(opresult3193)) {
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3194 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3195 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3196 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3195);
// compiled member node returning call3196 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3197 = callmethodflags(call3196, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3194);
// compiled call node returning call3197 (depth = 5)
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3198 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3200 = alloc_Float64(1);
// compiled num node returning num3200 (depth = 7)
  int op_slot_right_3199 = gc_frame_newslot(num3200);
// starting to compile member node (depth = 7)
  int callframe3202 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3203 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3202);
// compiled member node returning call3203 (depth = 7)
  int op_slot_left_3199 = gc_frame_newslot(call3203);
  params[0] = num3200;
  partcv[0] = 1;
  Object diff3204 = callmethod(call3203, "-(1)", 1, partcv, params);
// compiled op node returning diff3204 (depth = 6)
  gc_frame_newslot(diff3204);
// call case 4: self request
  params[0] = diff3204;
  partcv[0] = 1;
  Object call3205 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3198);
// compiled call node returning call3205 (depth = 5)
    gc_frame_newslot(call3205);
    if3184 = call3205;
  } else {
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3206 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3208 == NULL) {
    strlit3208 = alloc_String("");
    gc_root(strlit3208);
  }
// compiled string node returning strlit3208 (depth = 7)
  int op_slot_right_3207 = gc_frame_newslot(strlit3208);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_k (depth = 8)
  int op_slot_right_3210 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 8)
  if (strlit3212 == NULL) {
    strlit3212 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3212);
  }
// compiled string node returning strlit3212 (depth = 8)
  int op_slot_left_3210 = gc_frame_newslot(strlit3212);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3213 = callmethod(strlit3212, "++(1)", 1, partcv, params);
// compiled op node returning opresult3213 (depth = 7)
  int op_slot_left_3207 = gc_frame_newslot(opresult3213);
  params[0] = strlit3208;
  partcv[0] = 1;
  Object opresult3214 = callmethod(opresult3213, "++(1)", 1, partcv, params);
// compiled op node returning opresult3214 (depth = 6)
  gc_frame_newslot(opresult3214);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult3214;
  partcv[0] = 1;
  Object call3215 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3206);
// compiled call node returning call3215 (depth = 5)
    gc_frame_newslot(call3215);
    if3184 = call3215;
  }
// compiled if node returning if3184 (depth = 4)
  gc_frame_end(frame);
  return if3184;
}
Object meth_collectionsPrelude_3170_removeAllKeys_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAllKeys(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAllKeys(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAllKeys(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_keys = &(stackframe->slots[0]);
  *var_keys = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAllKeys(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3171 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3173 = alloc_Float64(1);
// compiled num node returning num3173 (depth = 4)
  int op_slot_right_3172 = gc_frame_newslot(num3173);
// starting to compile member node (depth = 4)
  int callframe3175 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3176 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3175);
// compiled member node returning call3176 (depth = 4)
  int op_slot_left_3172 = gc_frame_newslot(call3176);
  params[0] = num3173;
  partcv[0] = 1;
  Object sum3177 = callmethod(call3176, "+(1)", 1, partcv, params);
// compiled op node returning sum3177 (depth = 3)
  gc_frame_newslot(sum3177);
// call case 4: self request
  params[0] = sum3177;
  partcv[0] = 1;
  Object call3178 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3171);
// compiled call node returning call3178 (depth = 2)
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3179 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_keys (depth = 3)
  gc_frame_newslot(*var_keys);
// starting to compile block node (depth = 3)
  Object block3180 = alloc_Block(NULL, NULL, "collectionsPrelude", 1309);
  gc_frame_newslot(block3180);
// method "_apply(_)"
  block_savedest(block3180);
  Object closure3181 = createclosure(3, "_apply(1)");
  setclosureframe(closure3181, stackframe);
  addtoclosure(closure3181, var_removed);
  addtoclosure(closure3181, var_NoSuchObject);
  addtoclosure(closure3181, selfslot);
  struct UserObject *uo3181 = (struct UserObject*)block3180;
  uo3181->data[0] = (Object)closure3181;
  Method *meth_meth_collectionsPrelude_3181__apply_40_1_41_ = addmethod2pos(block3180, "_apply(1)", &meth_collectionsPrelude_3181__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_3181__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3181__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3181__apply_40_1_41_);
  meth_meth_collectionsPrelude_3181__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3181__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block3180 (depth = 3)
  gc_frame_newslot(block3180);
// call case 5: prelude request
  params[0] = *var_keys;
  params[1] = block3180;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3217 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3179);
// compiled call node returning call3217 (depth = 2)
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_3218_removeKey_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeKey(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeKey(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeKey(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeKey(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// definebindings:
// definebindings:
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3219 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3221 = alloc_Float64(1);
// compiled num node returning num3221 (depth = 4)
  int op_slot_right_3220 = gc_frame_newslot(num3221);
// starting to compile member node (depth = 4)
  int callframe3223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3224 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3223);
// compiled member node returning call3224 (depth = 4)
  int op_slot_left_3220 = gc_frame_newslot(call3224);
  params[0] = num3221;
  partcv[0] = 1;
  Object sum3225 = callmethod(call3224, "+(1)", 1, partcv, params);
// compiled op node returning sum3225 (depth = 3)
  gc_frame_newslot(sum3225);
// call case 4: self request
  params[0] = sum3225;
  partcv[0] = 1;
  Object call3226 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3219);
// compiled call node returning call3226 (depth = 2)
// Begin line 1322
  setline(1322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3227 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3228 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3227);
// compiled call node returning call3228 (depth = 3)
  *var_t = call3228;
  if (call3228 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3230 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3232 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe3233 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3234 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3235 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3234);
// compiled member node returning call3235 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3236 = callmethodflags(call3235, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3233);
// compiled call node returning call3236 (depth = 5)
  partcv[0] = 0;
  Object call3237 = callmethodflags(call3236, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3232);
// compiled member node returning call3237 (depth = 4)
  int op_slot_left_3230 = gc_frame_newslot(call3237);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3238 = callmethod(call3237, "==(1)", 1, partcv, params);
// compiled op node returning opresult3238 (depth = 3)
  Object if3229 = done;
  if (istrue(opresult3238)) {
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3239 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_removed (depth = 4)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3240 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3241 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3240);
// compiled member node returning call3241 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3242 = callmethodflags(call3241, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3239);
// compiled call node returning call3242 (depth = 3)
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3243 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3245 = alloc_Float64(1);
// compiled num node returning num3245 (depth = 5)
  int op_slot_right_3244 = gc_frame_newslot(num3245);
// starting to compile member node (depth = 5)
  int callframe3247 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3248 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3247);
// compiled member node returning call3248 (depth = 5)
  int op_slot_left_3244 = gc_frame_newslot(call3248);
  params[0] = num3245;
  partcv[0] = 1;
  Object diff3249 = callmethod(call3248, "-(1)", 1, partcv, params);
// compiled op node returning diff3249 (depth = 4)
  gc_frame_newslot(diff3249);
// call case 4: self request
  params[0] = diff3249;
  partcv[0] = 1;
  Object call3250 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3243);
// compiled call node returning call3250 (depth = 3)
    gc_frame_newslot(call3250);
    if3229 = call3250;
  } else {
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3251 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3253 == NULL) {
    strlit3253 = alloc_String("");
    gc_root(strlit3253);
  }
// compiled string node returning strlit3253 (depth = 5)
  int op_slot_right_3252 = gc_frame_newslot(strlit3253);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  int op_slot_right_3255 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 6)
  if (strlit3257 == NULL) {
    strlit3257 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3257);
  }
// compiled string node returning strlit3257 (depth = 6)
  int op_slot_left_3255 = gc_frame_newslot(strlit3257);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3258 = callmethod(strlit3257, "++(1)", 1, partcv, params);
// compiled op node returning opresult3258 (depth = 5)
  int op_slot_left_3252 = gc_frame_newslot(opresult3258);
  params[0] = strlit3253;
  partcv[0] = 1;
  Object opresult3259 = callmethod(opresult3258, "++(1)", 1, partcv, params);
// compiled op node returning opresult3259 (depth = 4)
  gc_frame_newslot(opresult3259);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_NoSuchObject (depth = 4)
  params[0] = opresult3259;
  partcv[0] = 1;
  Object call3260 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3251);
// compiled call node returning call3260 (depth = 3)
    gc_frame_newslot(call3260);
    if3229 = call3260;
  }
// compiled if node returning if3229 (depth = 2)
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeKey(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeKey(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeKey(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeKey(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeKey(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// definebindings:
// definebindings:
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3262 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3264 = alloc_Float64(1);
// compiled num node returning num3264 (depth = 4)
  int op_slot_right_3263 = gc_frame_newslot(num3264);
// starting to compile member node (depth = 4)
  int callframe3266 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3267 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3266);
// compiled member node returning call3267 (depth = 4)
  int op_slot_left_3263 = gc_frame_newslot(call3267);
  params[0] = num3264;
  partcv[0] = 1;
  Object sum3268 = callmethod(call3267, "+(1)", 1, partcv, params);
// compiled op node returning sum3268 (depth = 3)
  gc_frame_newslot(sum3268);
// call case 4: self request
  params[0] = sum3268;
  partcv[0] = 1;
  Object call3269 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3262);
// compiled call node returning call3269 (depth = 2)
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3270 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3271 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3270);
// compiled call node returning call3271 (depth = 3)
  *var_t = call3271;
  if (call3271 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3273 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3275 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe3276 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3278 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3277);
// compiled member node returning call3278 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3279 = callmethodflags(call3278, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3276);
// compiled call node returning call3279 (depth = 5)
  partcv[0] = 0;
  Object call3280 = callmethodflags(call3279, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3275);
// compiled member node returning call3280 (depth = 4)
  int op_slot_left_3273 = gc_frame_newslot(call3280);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3281 = callmethod(call3280, "==(1)", 1, partcv, params);
// compiled op node returning opresult3281 (depth = 3)
  Object if3272 = done;
  if (istrue(opresult3281)) {
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3282 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_removed (depth = 4)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3283 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3284 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3283);
// compiled member node returning call3284 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3285 = callmethodflags(call3284, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3282);
// compiled call node returning call3285 (depth = 3)
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3286 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3288 = alloc_Float64(1);
// compiled num node returning num3288 (depth = 5)
  int op_slot_right_3287 = gc_frame_newslot(num3288);
// starting to compile member node (depth = 5)
  int callframe3290 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3291 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3290);
// compiled member node returning call3291 (depth = 5)
  int op_slot_left_3287 = gc_frame_newslot(call3291);
  params[0] = num3288;
  partcv[0] = 1;
  Object diff3292 = callmethod(call3291, "-(1)", 1, partcv, params);
// compiled op node returning diff3292 (depth = 4)
  gc_frame_newslot(diff3292);
// call case 4: self request
  params[0] = diff3292;
  partcv[0] = 1;
  Object call3293 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3286);
// compiled call node returning call3293 (depth = 3)
    gc_frame_newslot(call3293);
    if3272 = call3293;
  } else {
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3294 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  partcv[0] = 0;
  Object call3295 = callmethodflags(*var_action, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe3294);
// compiled member node returning call3295 (depth = 3)
    gc_frame_newslot(call3295);
    if3272 = call3295;
  }
// compiled if node returning if3272 (depth = 2)
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_3319__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_removals = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// definebindings:
// definebindings:
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3320 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3321 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3322 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3321);
// compiled member node returning call3322 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3323 = callmethodflags(call3322, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3320);
// compiled call node returning call3323 (depth = 5)
  *var_a = call3323;
  if (call3323 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3325 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3326 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call3327 = callmethodflags(*var_a, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3326);
// compiled member node returning call3327 (depth = 6)
  gc_frame_newslot(call3327);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removals (depth = 6)
  params[0] = call3327;
  partcv[0] = 1;
  Object call3328 = callmethodflags(*var_removals, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3325);
// compiled call node returning call3328 (depth = 5)
  Object if3324 = done;
  if (istrue(call3328)) {
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3329 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3330 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3331 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3330);
// compiled member node returning call3331 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3332 = callmethodflags(call3331, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3329);
// compiled call node returning call3332 (depth = 5)
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3333 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3335 = alloc_Float64(1);
// compiled num node returning num3335 (depth = 7)
  int op_slot_right_3334 = gc_frame_newslot(num3335);
// starting to compile member node (depth = 7)
  int callframe3337 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3338 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3337);
// compiled member node returning call3338 (depth = 7)
  int op_slot_left_3334 = gc_frame_newslot(call3338);
  params[0] = num3335;
  partcv[0] = 1;
  Object diff3339 = callmethod(call3338, "-(1)", 1, partcv, params);
// compiled op node returning diff3339 (depth = 6)
  gc_frame_newslot(diff3339);
// call case 4: self request
  params[0] = diff3339;
  partcv[0] = 1;
  Object call3340 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3333);
// compiled call node returning call3340 (depth = 5)
    gc_frame_newslot(call3340);
    if3324 = call3340;
  } else {
  }
// compiled if node returning if3324 (depth = 4)
  gc_frame_end(frame);
  return if3324;
}
Object meth_collectionsPrelude_3296_removeAllValues_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAllValues(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAllValues(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAllValues(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_removals = &(stackframe->slots[0]);
  *var_removals = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAllValues(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3297 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3299 = alloc_Float64(1);
// compiled num node returning num3299 (depth = 4)
  int op_slot_right_3298 = gc_frame_newslot(num3299);
// starting to compile member node (depth = 4)
  int callframe3301 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3302 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3301);
// compiled member node returning call3302 (depth = 4)
  int op_slot_left_3298 = gc_frame_newslot(call3302);
  params[0] = num3299;
  partcv[0] = 1;
  Object sum3303 = callmethod(call3302, "+(1)", 1, partcv, params);
// compiled op node returning sum3303 (depth = 3)
  gc_frame_newslot(sum3303);
// call case 4: self request
  params[0] = sum3303;
  partcv[0] = 1;
  Object call3304 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3297);
// compiled call node returning call3304 (depth = 2)
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3305 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3308 = alloc_Float64(1);
// compiled num node returning num3308 (depth = 5)
  int op_slot_right_3307 = gc_frame_newslot(num3308);
// starting to compile member node (depth = 5)
  int callframe3310 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3311 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3312 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3311);
// compiled member node returning call3312 (depth = 6)
  partcv[0] = 0;
  Object call3313 = callmethodflags(call3312, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3310);
// compiled member node returning call3313 (depth = 5)
  int op_slot_left_3307 = gc_frame_newslot(call3313);
  params[0] = num3308;
  partcv[0] = 1;
  Object diff3314 = callmethod(call3313, "-(1)", 1, partcv, params);
// compiled op node returning diff3314 (depth = 4)
  int op_slot_right_3306 = gc_frame_newslot(diff3314);
// starting to compile num node (depth = 4)
  Object num3316 = alloc_Float64(0);
// compiled num node returning num3316 (depth = 4)
  int op_slot_left_3306 = gc_frame_newslot(num3316);
  params[0] = diff3314;
  partcv[0] = 1;
  Object opresult3317 = callmethod(num3316, "..(1)", 1, partcv, params);
// compiled op node returning opresult3317 (depth = 3)
  gc_frame_newslot(opresult3317);
// starting to compile block node (depth = 3)
  Object block3318 = alloc_Block(NULL, NULL, "collectionsPrelude", 1344);
  gc_frame_newslot(block3318);
// method "_apply(_)"
  block_savedest(block3318);
  Object closure3319 = createclosure(3, "_apply(1)");
  setclosureframe(closure3319, stackframe);
  addtoclosure(closure3319, var_removals);
  addtoclosure(closure3319, var_removed);
  addtoclosure(closure3319, selfslot);
  struct UserObject *uo3319 = (struct UserObject*)block3318;
  uo3319->data[0] = (Object)closure3319;
  Method *meth_meth_collectionsPrelude_3319__apply_40_1_41_ = addmethod2pos(block3318, "_apply(1)", &meth_collectionsPrelude_3319__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_3319__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3319__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3319__apply_40_1_41_);
  meth_meth_collectionsPrelude_3319__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3319__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block3318 (depth = 3)
  gc_frame_newslot(block3318);
// call case 5: prelude request
  params[0] = opresult3317;
  params[1] = block3318;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3342 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3305);
// compiled call node returning call3342 (depth = 2)
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_3368__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// definebindings:
// definebindings:
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3369 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3370 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3371 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3370);
// compiled member node returning call3371 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3372 = callmethodflags(call3371, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3369);
// compiled call node returning call3372 (depth = 5)
  *var_a = call3372;
  if (call3372 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3375 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call3376 = callmethodflags(*var_a, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3375);
// compiled member node returning call3376 (depth = 6)
  int op_slot_right_3374 = gc_frame_newslot(call3376);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3374 = gc_frame_newslot(*var_v);
  params[0] = call3376;
  partcv[0] = 1;
  Object opresult3378 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult3378 (depth = 5)
  Object if3373 = done;
  if (istrue(opresult3378)) {
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3379 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3381 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3380);
// compiled member node returning call3381 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3382 = callmethodflags(call3381, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3379);
// compiled call node returning call3382 (depth = 5)
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3383 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3385 = alloc_Float64(1);
// compiled num node returning num3385 (depth = 7)
  int op_slot_right_3384 = gc_frame_newslot(num3385);
// starting to compile member node (depth = 7)
  int callframe3387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3388 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3387);
// compiled member node returning call3388 (depth = 7)
  int op_slot_left_3384 = gc_frame_newslot(call3388);
  params[0] = num3385;
  partcv[0] = 1;
  Object diff3389 = callmethod(call3388, "-(1)", 1, partcv, params);
// compiled op node returning diff3389 (depth = 6)
  gc_frame_newslot(diff3389);
// call case 4: self request
  params[0] = diff3389;
  partcv[0] = 1;
  Object call3390 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3383);
// compiled call node returning call3390 (depth = 5)
    gc_frame_newslot(call3390);
    if3373 = call3390;
  } else {
  }
// compiled if node returning if3373 (depth = 4)
  gc_frame_end(frame);
  return if3373;
}
Object meth_collectionsPrelude_3343_removeValue_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeValue(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeValue(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeValue(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_initialNumBindings = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "initialNumBindings");
// definebindings:
// definebindings:
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3344 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3346 = alloc_Float64(1);
// compiled num node returning num3346 (depth = 4)
  int op_slot_right_3345 = gc_frame_newslot(num3346);
// starting to compile member node (depth = 4)
  int callframe3348 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3349 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3348);
// compiled member node returning call3349 (depth = 4)
  int op_slot_left_3345 = gc_frame_newslot(call3349);
  params[0] = num3346;
  partcv[0] = 1;
  Object sum3350 = callmethod(call3349, "+(1)", 1, partcv, params);
// compiled op node returning sum3350 (depth = 3)
  gc_frame_newslot(sum3350);
// call case 4: self request
  params[0] = sum3350;
  partcv[0] = 1;
  Object call3351 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3344);
// compiled call node returning call3351 (depth = 2)
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3352 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3353 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3352);
// compiled member node returning call3353 (depth = 3)
  *var_initialNumBindings = call3353;
  if (call3353 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3354 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3357 = alloc_Float64(1);
// compiled num node returning num3357 (depth = 5)
  int op_slot_right_3356 = gc_frame_newslot(num3357);
// starting to compile member node (depth = 5)
  int callframe3359 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3360 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3361 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3360);
// compiled member node returning call3361 (depth = 6)
  partcv[0] = 0;
  Object call3362 = callmethodflags(call3361, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3359);
// compiled member node returning call3362 (depth = 5)
  int op_slot_left_3356 = gc_frame_newslot(call3362);
  params[0] = num3357;
  partcv[0] = 1;
  Object diff3363 = callmethod(call3362, "-(1)", 1, partcv, params);
// compiled op node returning diff3363 (depth = 4)
  int op_slot_right_3355 = gc_frame_newslot(diff3363);
// starting to compile num node (depth = 4)
  Object num3365 = alloc_Float64(0);
// compiled num node returning num3365 (depth = 4)
  int op_slot_left_3355 = gc_frame_newslot(num3365);
  params[0] = diff3363;
  partcv[0] = 1;
  Object opresult3366 = callmethod(num3365, "..(1)", 1, partcv, params);
// compiled op node returning opresult3366 (depth = 3)
  gc_frame_newslot(opresult3366);
// starting to compile block node (depth = 3)
  Object block3367 = alloc_Block(NULL, NULL, "collectionsPrelude", 1357);
  gc_frame_newslot(block3367);
// method "_apply(_)"
  block_savedest(block3367);
  Object closure3368 = createclosure(3, "_apply(1)");
  setclosureframe(closure3368, stackframe);
  addtoclosure(closure3368, var_v);
  addtoclosure(closure3368, var_removed);
  addtoclosure(closure3368, selfslot);
  struct UserObject *uo3368 = (struct UserObject*)block3367;
  uo3368->data[0] = (Object)closure3368;
  Method *meth_meth_collectionsPrelude_3368__apply_40_1_41_ = addmethod2pos(block3367, "_apply(1)", &meth_collectionsPrelude_3368__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_3368__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3368__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3368__apply_40_1_41_);
  meth_meth_collectionsPrelude_3368__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3368__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block3367 (depth = 3)
  gc_frame_newslot(block3367);
// call case 5: prelude request
  params[0] = opresult3366;
  params[1] = block3367;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3392 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3354);
// compiled call node returning call3392 (depth = 2)
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initialNumBindings (depth = 4)
  int op_slot_right_3394 = gc_frame_newslot(*var_initialNumBindings);
// starting to compile member node (depth = 4)
  int callframe3396 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3397 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3396);
// compiled member node returning call3397 (depth = 4)
  int op_slot_left_3394 = gc_frame_newslot(call3397);
  params[0] = *var_initialNumBindings;
  partcv[0] = 1;
  Object opresult3398 = callmethod(call3397, "==(1)", 1, partcv, params);
// compiled op node returning opresult3398 (depth = 3)
  Object if3393 = done;
  if (istrue(opresult3398)) {
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3399 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3401 == NULL) {
    strlit3401 = alloc_String("");
    gc_root(strlit3401);
  }
// compiled string node returning strlit3401 (depth = 5)
  int op_slot_right_3400 = gc_frame_newslot(strlit3401);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_right_3403 = gc_frame_newslot(*var_v);
// starting to compile string node (depth = 6)
  if (strlit3405 == NULL) {
    strlit3405 = alloc_String("dictionary does not contain entry with value ");
    gc_root(strlit3405);
  }
// compiled string node returning strlit3405 (depth = 6)
  int op_slot_left_3403 = gc_frame_newslot(strlit3405);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult3406 = callmethod(strlit3405, "++(1)", 1, partcv, params);
// compiled op node returning opresult3406 (depth = 5)
  int op_slot_left_3400 = gc_frame_newslot(opresult3406);
  params[0] = strlit3401;
  partcv[0] = 1;
  Object opresult3407 = callmethod(opresult3406, "++(1)", 1, partcv, params);
// compiled op node returning opresult3407 (depth = 4)
  gc_frame_newslot(opresult3407);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_NoSuchObject (depth = 4)
  params[0] = opresult3407;
  partcv[0] = 1;
  Object call3408 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3399);
// compiled call node returning call3408 (depth = 3)
    gc_frame_newslot(call3408);
    if3393 = call3408;
  } else {
  }
// compiled if node returning if3393 (depth = 2)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_3434__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// definebindings:
// definebindings:
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3435 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3436 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3437 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3436);
// compiled member node returning call3437 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3438 = callmethodflags(call3437, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3435);
// compiled call node returning call3438 (depth = 5)
  *var_a = call3438;
  if (call3438 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3441 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call3442 = callmethodflags(*var_a, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3441);
// compiled member node returning call3442 (depth = 6)
  int op_slot_right_3440 = gc_frame_newslot(call3442);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3440 = gc_frame_newslot(*var_v);
  params[0] = call3442;
  partcv[0] = 1;
  Object opresult3444 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult3444 (depth = 5)
  Object if3439 = done;
  if (istrue(opresult3444)) {
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3445 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3446 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3447 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3446);
// compiled member node returning call3447 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3448 = callmethodflags(call3447, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3445);
// compiled call node returning call3448 (depth = 5)
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3449 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3451 = alloc_Float64(1);
// compiled num node returning num3451 (depth = 7)
  int op_slot_right_3450 = gc_frame_newslot(num3451);
// starting to compile member node (depth = 7)
  int callframe3453 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3454 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3453);
// compiled member node returning call3454 (depth = 7)
  int op_slot_left_3450 = gc_frame_newslot(call3454);
  params[0] = num3451;
  partcv[0] = 1;
  Object diff3455 = callmethod(call3454, "-(1)", 1, partcv, params);
// compiled op node returning diff3455 (depth = 6)
  gc_frame_newslot(diff3455);
// call case 4: self request
  params[0] = diff3455;
  partcv[0] = 1;
  Object call3456 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3449);
// compiled call node returning call3456 (depth = 5)
    gc_frame_newslot(call3456);
    if3439 = call3456;
  } else {
  }
// compiled if node returning if3439 (depth = 4)
  gc_frame_end(frame);
  return if3439;
}
Object meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeValue(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeValue(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeValue(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_initialNumBindings = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "initialNumBindings");
// definebindings:
// definebindings:
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3410 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3412 = alloc_Float64(1);
// compiled num node returning num3412 (depth = 4)
  int op_slot_right_3411 = gc_frame_newslot(num3412);
// starting to compile member node (depth = 4)
  int callframe3414 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3415 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3414);
// compiled member node returning call3415 (depth = 4)
  int op_slot_left_3411 = gc_frame_newslot(call3415);
  params[0] = num3412;
  partcv[0] = 1;
  Object sum3416 = callmethod(call3415, "+(1)", 1, partcv, params);
// compiled op node returning sum3416 (depth = 3)
  gc_frame_newslot(sum3416);
// call case 4: self request
  params[0] = sum3416;
  partcv[0] = 1;
  Object call3417 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3410);
// compiled call node returning call3417 (depth = 2)
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3418 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3419 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3418);
// compiled member node returning call3419 (depth = 3)
  *var_initialNumBindings = call3419;
  if (call3419 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3420 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3423 = alloc_Float64(1);
// compiled num node returning num3423 (depth = 5)
  int op_slot_right_3422 = gc_frame_newslot(num3423);
// starting to compile member node (depth = 5)
  int callframe3425 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3426 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3427 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3426);
// compiled member node returning call3427 (depth = 6)
  partcv[0] = 0;
  Object call3428 = callmethodflags(call3427, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3425);
// compiled member node returning call3428 (depth = 5)
  int op_slot_left_3422 = gc_frame_newslot(call3428);
  params[0] = num3423;
  partcv[0] = 1;
  Object diff3429 = callmethod(call3428, "-(1)", 1, partcv, params);
// compiled op node returning diff3429 (depth = 4)
  int op_slot_right_3421 = gc_frame_newslot(diff3429);
// starting to compile num node (depth = 4)
  Object num3431 = alloc_Float64(0);
// compiled num node returning num3431 (depth = 4)
  int op_slot_left_3421 = gc_frame_newslot(num3431);
  params[0] = diff3429;
  partcv[0] = 1;
  Object opresult3432 = callmethod(num3431, "..(1)", 1, partcv, params);
// compiled op node returning opresult3432 (depth = 3)
  gc_frame_newslot(opresult3432);
// starting to compile block node (depth = 3)
  Object block3433 = alloc_Block(NULL, NULL, "collectionsPrelude", 1373);
  gc_frame_newslot(block3433);
// method "_apply(_)"
  block_savedest(block3433);
  Object closure3434 = createclosure(3, "_apply(1)");
  setclosureframe(closure3434, stackframe);
  addtoclosure(closure3434, var_v);
  addtoclosure(closure3434, var_removed);
  addtoclosure(closure3434, selfslot);
  struct UserObject *uo3434 = (struct UserObject*)block3433;
  uo3434->data[0] = (Object)closure3434;
  Method *meth_meth_collectionsPrelude_3434__apply_40_1_41_ = addmethod2pos(block3433, "_apply(1)", &meth_collectionsPrelude_3434__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_3434__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3434__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3434__apply_40_1_41_);
  meth_meth_collectionsPrelude_3434__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3434__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block3433 (depth = 3)
  gc_frame_newslot(block3433);
// call case 5: prelude request
  params[0] = opresult3432;
  params[1] = block3433;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3458 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3420);
// compiled call node returning call3458 (depth = 2)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initialNumBindings (depth = 4)
  int op_slot_right_3460 = gc_frame_newslot(*var_initialNumBindings);
// starting to compile member node (depth = 4)
  int callframe3462 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3463 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3462);
// compiled member node returning call3463 (depth = 4)
  int op_slot_left_3460 = gc_frame_newslot(call3463);
  params[0] = *var_initialNumBindings;
  partcv[0] = 1;
  Object opresult3464 = callmethod(call3463, "==(1)", 1, partcv, params);
// compiled op node returning opresult3464 (depth = 3)
  Object if3459 = done;
  if (istrue(opresult3464)) {
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3465 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  partcv[0] = 0;
  Object call3466 = callmethodflags(*var_action, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe3465);
// compiled member node returning call3466 (depth = 3)
    gc_frame_newslot(call3466);
    if3459 = call3466;
  } else {
  }
// compiled if node returning if3459 (depth = 2)
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_3500__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3501 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3502 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3503 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3502);
// compiled member node returning call3503 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3504 = callmethodflags(call3503, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3501);
// compiled call node returning call3504 (depth = 4)
  gc_frame_end(frame);
  return call3504;
}
Object meth_collectionsPrelude_3467_clear(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "clear");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3468 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe3469 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num3470 = alloc_Float64(8);
// compiled num node returning num3470 (depth = 4)
  gc_frame_newslot(num3470);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3471 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3472 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3471);
// compiled member node returning call3472 (depth = 4)
  params[0] = num3470;
  partcv[0] = 1;
  Object call3473 = callmethodflags(call3472, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3469);
// compiled call node returning call3473 (depth = 3)
  gc_frame_newslot(call3473);
// call case 4: self request
  params[0] = call3473;
  partcv[0] = 1;
  Object call3474 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3468);
// compiled call node returning call3474 (depth = 2)
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3475 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num3476 = alloc_Float64(0);
// compiled num node returning num3476 (depth = 3)
  gc_frame_newslot(num3476);
// call case 4: self request
  params[0] = num3476;
  partcv[0] = 1;
  Object call3477 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3475);
// compiled call node returning call3477 (depth = 2)
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3478 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3480 = alloc_Float64(1);
// compiled num node returning num3480 (depth = 4)
  int op_slot_right_3479 = gc_frame_newslot(num3480);
// starting to compile member node (depth = 4)
  int callframe3482 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3483 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3482);
// compiled member node returning call3483 (depth = 4)
  int op_slot_left_3479 = gc_frame_newslot(call3483);
  params[0] = num3480;
  partcv[0] = 1;
  Object sum3484 = callmethod(call3483, "+(1)", 1, partcv, params);
// compiled op node returning sum3484 (depth = 3)
  gc_frame_newslot(sum3484);
// call case 4: self request
  params[0] = sum3484;
  partcv[0] = 1;
  Object call3485 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3478);
// compiled call node returning call3485 (depth = 2)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3486 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3489 = alloc_Float64(1);
// compiled num node returning num3489 (depth = 5)
  int op_slot_right_3488 = gc_frame_newslot(num3489);
// starting to compile member node (depth = 5)
  int callframe3491 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3492 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3493 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3492);
// compiled member node returning call3493 (depth = 6)
  partcv[0] = 0;
  Object call3494 = callmethodflags(call3493, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3491);
// compiled member node returning call3494 (depth = 5)
  int op_slot_left_3488 = gc_frame_newslot(call3494);
  params[0] = num3489;
  partcv[0] = 1;
  Object diff3495 = callmethod(call3494, "-(1)", 1, partcv, params);
// compiled op node returning diff3495 (depth = 4)
  int op_slot_right_3487 = gc_frame_newslot(diff3495);
// starting to compile num node (depth = 4)
  Object num3497 = alloc_Float64(0);
// compiled num node returning num3497 (depth = 4)
  int op_slot_left_3487 = gc_frame_newslot(num3497);
  params[0] = diff3495;
  partcv[0] = 1;
  Object opresult3498 = callmethod(num3497, "..(1)", 1, partcv, params);
// compiled op node returning opresult3498 (depth = 3)
  gc_frame_newslot(opresult3498);
// starting to compile block node (depth = 3)
  Object block3499 = alloc_Block(NULL, NULL, "collectionsPrelude", 1389);
  gc_frame_newslot(block3499);
// method "_apply(_)"
  block_savedest(block3499);
  Object closure3500 = createclosure(2, "_apply(1)");
  setclosureframe(closure3500, stackframe);
  addtoclosure(closure3500, var_unused);
  addtoclosure(closure3500, selfslot);
  struct UserObject *uo3500 = (struct UserObject*)block3499;
  uo3500->data[0] = (Object)closure3500;
  Method *meth_meth_collectionsPrelude_3500__apply_40_1_41_ = addmethod2pos(block3499, "_apply(1)", &meth_collectionsPrelude_3500__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_3500__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3500__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3500__apply_40_1_41_);
  meth_meth_collectionsPrelude_3500__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3500__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block3499 (depth = 3)
  gc_frame_newslot(block3499);
// call case 5: prelude request
  params[0] = opresult3498;
  params[1] = block3499;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3506 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3486);
// compiled call node returning call3506 (depth = 2)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_3510__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_right_3512 = gc_frame_newslot(*var_each);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3512 = gc_frame_newslot(*var_v);
  params[0] = *var_each;
  partcv[0] = 1;
  Object opresult3514 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult3514 (depth = 5)
  Object if3511 = done;
  if (istrue(opresult3514)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3515 = alloc_Boolean(1);
// compiled identifier node returning bool3515 (depth = 6)
  block_return(realself, bool3515);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3511 = undefined;
  } else {
  }
// compiled if node returning if3511 (depth = 4)
  gc_frame_end(frame);
  return if3511;
}
Object meth_collectionsPrelude_3507_containsValue_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "containsValue(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method containsValue(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for containsValue(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part containsValue(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3508 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3509 = alloc_Block(NULL, NULL, "collectionsPrelude", 1395);
  gc_frame_newslot(block3509);
// method "_apply(_)"
  block_savedest(block3509);
  Object closure3510 = createclosure(2, "_apply(1)");
  setclosureframe(closure3510, stackframe);
  addtoclosure(closure3510, var_v);
  addtoclosure(closure3510, selfslot);
  struct UserObject *uo3510 = (struct UserObject*)block3509;
  uo3510->data[0] = (Object)closure3510;
  Method *meth_meth_collectionsPrelude_3510__apply_40_1_41_ = addmethod2pos(block3509, "_apply(1)", &meth_collectionsPrelude_3510__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_3510__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3510__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3510__apply_40_1_41_);
  meth_meth_collectionsPrelude_3510__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3510__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block3509 (depth = 3)
  gc_frame_newslot(block3509);
// call case 4: self request
  params[0] = block3509;
  partcv[0] = 1;
  Object call3517 = callmethodflags(self, "valuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3508);
// compiled call node returning call3517 (depth = 2)
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool3518 = alloc_Boolean(0);
// compiled identifier node returning bool3518 (depth = 2)
  gc_frame_end(frame);
  return bool3518;
}
Object meth_collectionsPrelude_3519_contains_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3520 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3521 = callmethodflags(self, "containsValue(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3520);
// compiled call node returning call3521 (depth = 2)
  gc_frame_end(frame);
  return call3521;
}
Object meth_collectionsPrelude_3535__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3537 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3538 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3539 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3538);
// compiled member node returning call3539 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3540 = callmethodflags(call3539, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3537);
// compiled call node returning call3540 (depth = 5)
  int op_slot_right_3536 = gc_frame_newslot(call3540);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3536 = gc_frame_newslot(*var_unused);
  params[0] = call3540;
  partcv[0] = 1;
  Object opresult3542 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3542 (depth = 4)
  gc_frame_end(frame);
  return opresult3542;
}
Object meth_collectionsPrelude_3545__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_3547 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
  int callframe3549 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3550 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3552 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3551);
// compiled member node returning call3552 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3553 = callmethodflags(call3552, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3550);
// compiled call node returning call3553 (depth = 7)
  partcv[0] = 0;
  Object call3554 = callmethodflags(call3553, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3549);
// compiled member node returning call3554 (depth = 6)
  int op_slot_left_3547 = gc_frame_newslot(call3554);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult3555 = callmethod(call3554, "==(1)", 1, partcv, params);
// compiled op node returning opresult3555 (depth = 5)
  Object if3546 = done;
  if (istrue(opresult3555)) {
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3546 = undefined;
  } else {
  }
// compiled if node returning if3546 (depth = 4)
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3558 = alloc_Float64(0);
// compiled num node returning num3558 (depth = 6)
  int op_slot_right_3557 = gc_frame_newslot(num3558);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_3557 = gc_frame_newslot(*var_jump);
  params[0] = num3558;
  partcv[0] = 1;
  Object opresult3560 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3560 (depth = 5)
  Object if3556 = done;
  if (istrue(opresult3560)) {
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3561 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3564 = alloc_Float64(1);
// compiled num node returning num3564 (depth = 8)
  int op_slot_right_3563 = gc_frame_newslot(num3564);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3567 = alloc_Float64(3);
// compiled num node returning num3567 (depth = 9)
  int op_slot_right_3566 = gc_frame_newslot(num3567);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_3566 = gc_frame_newslot(*var_t);
  params[0] = num3567;
  partcv[0] = 1;
  Object prod3569 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod3569 (depth = 8)
  int op_slot_left_3563 = gc_frame_newslot(prod3569);
  params[0] = num3564;
  partcv[0] = 1;
  Object sum3570 = callmethod(prod3569, "+(1)", 1, partcv, params);
// compiled op node returning sum3570 (depth = 7)
  int op_slot_left_3561 = gc_frame_newslot(sum3570);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3571 = callmethod(sum3570, "%(1)", 1, partcv, params);
// compiled op node returning modulus3571 (depth = 6)
  *var_t = modulus3571;
  if (modulus3571 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3574 = alloc_Float64(1);
// compiled num node returning num3574 (depth = 7)
  int op_slot_right_3573 = gc_frame_newslot(num3574);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_3573 = gc_frame_newslot(*var_jump);
  params[0] = num3574;
  partcv[0] = 1;
  Object diff3576 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff3576 (depth = 6)
  *var_jump = diff3576;
  if (diff3576 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3556 = done;
  } else {
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3578 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3581 = alloc_Float64(1);
// compiled num node returning num3581 (depth = 8)
  int op_slot_right_3580 = gc_frame_newslot(num3581);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_3580 = gc_frame_newslot(*var_t);
  params[0] = num3581;
  partcv[0] = 1;
  Object sum3583 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum3583 (depth = 7)
  int op_slot_left_3578 = gc_frame_newslot(sum3583);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3584 = callmethod(sum3583, "%(1)", 1, partcv, params);
// compiled op node returning modulus3584 (depth = 6)
  *var_t = modulus3584;
  if (modulus3584 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3556 = done;
  }
// compiled if node returning if3556 (depth = 4)
  gc_frame_end(frame);
  return if3556;
}
Object meth_collectionsPrelude_3522_findPosition_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPosition(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPosition(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPosition(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPosition(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3523 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  partcv[0] = 0;
  Object call3524 = callmethodflags(*var_x, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe3523);
// compiled member node returning call3524 (depth = 3)
  *var_h = call3524;
  if (call3524 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3525 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3526 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3527 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3526);
// compiled member node returning call3527 (depth = 4)
  partcv[0] = 0;
  Object call3528 = callmethodflags(call3527, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3525);
// compiled member node returning call3528 (depth = 3)
  *var_s = call3528;
  if (call3528 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_3529 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_3529 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3531 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus3531 (depth = 3)
  *var_t = modulus3531;
  if (modulus3531 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num3532 = alloc_Float64(5);
// compiled num node returning num3532 (depth = 3)
  *var_jump = num3532;
  if (num3532 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3533 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3534 = alloc_Block(NULL, NULL, "collectionsPrelude", 1407);
  gc_frame_newslot(block3534);
// method "_apply"
  block_savedest(block3534);
  Object closure3535 = createclosure(3, "_apply");
  setclosureframe(closure3535, stackframe);
  addtoclosure(closure3535, var_t);
  addtoclosure(closure3535, var_unused);
  addtoclosure(closure3535, selfslot);
  struct UserObject *uo3535 = (struct UserObject*)block3534;
  uo3535->data[0] = (Object)closure3535;
  Method *meth_meth_collectionsPrelude_3535__apply = addmethod2pos(block3534, "_apply", &meth_collectionsPrelude_3535__apply, 0);
  int argcv_meth_collectionsPrelude_3535__apply[] = {0};
  meth_meth_collectionsPrelude_3535__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3535__apply);
  meth_meth_collectionsPrelude_3535__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_3535__apply->definitionLine = 1769;
// compiled block node returning block3534 (depth = 3)
  gc_frame_newslot(block3534);
// starting to compile block node (depth = 3)
  Object block3544 = alloc_Block(NULL, NULL, "collectionsPrelude", 1407);
  gc_frame_newslot(block3544);
// method "_apply"
  block_savedest(block3544);
  Object closure3545 = createclosure(5, "_apply");
  setclosureframe(closure3545, stackframe);
  addtoclosure(closure3545, var_x);
  addtoclosure(closure3545, var_t);
  addtoclosure(closure3545, var_jump);
  addtoclosure(closure3545, var_s);
  addtoclosure(closure3545, selfslot);
  struct UserObject *uo3545 = (struct UserObject*)block3544;
  uo3545->data[0] = (Object)closure3545;
  Method *meth_meth_collectionsPrelude_3545__apply = addmethod2pos(block3544, "_apply", &meth_collectionsPrelude_3545__apply, 0);
  int argcv_meth_collectionsPrelude_3545__apply[] = {0};
  meth_meth_collectionsPrelude_3545__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3545__apply);
  meth_meth_collectionsPrelude_3545__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_3545__apply->definitionLine = 1769;
// compiled block node returning block3544 (depth = 3)
  gc_frame_newslot(block3544);
// call case 5: prelude request
  params[0] = block3534;
  params[1] = block3544;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3587 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3533);
// compiled call node returning call3587 (depth = 2)
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_3601__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3604 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3605 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3606 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3605);
// compiled member node returning call3606 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3607 = callmethodflags(call3606, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3604);
// compiled call node returning call3607 (depth = 6)
  int op_slot_right_3603 = gc_frame_newslot(call3607);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_3603 = gc_frame_newslot(*var_removed);
  params[0] = call3607;
  partcv[0] = 1;
  Object opresult3609 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3609 (depth = 5)
  int op_slot_right_3602 = gc_frame_newslot(opresult3609);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3612 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3613 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3614 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3613);
// compiled member node returning call3614 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3615 = callmethodflags(call3614, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3612);
// compiled call node returning call3615 (depth = 6)
  int op_slot_right_3611 = gc_frame_newslot(call3615);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_3611 = gc_frame_newslot(*var_unused);
  params[0] = call3615;
  partcv[0] = 1;
  Object opresult3617 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3617 (depth = 5)
  int op_slot_left_3602 = gc_frame_newslot(opresult3617);
  params[0] = opresult3609;
  partcv[0] = 1;
  Object opresult3618 = callmethod(opresult3617, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3618 (depth = 4)
  gc_frame_end(frame);
  return opresult3618;
}
Object meth_collectionsPrelude_3621__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_3623 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
  int callframe3625 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3626 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3627 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3628 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3627);
// compiled member node returning call3628 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3629 = callmethodflags(call3628, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3626);
// compiled call node returning call3629 (depth = 7)
  partcv[0] = 0;
  Object call3630 = callmethodflags(call3629, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3625);
// compiled member node returning call3630 (depth = 6)
  int op_slot_left_3623 = gc_frame_newslot(call3630);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult3631 = callmethod(call3630, "==(1)", 1, partcv, params);
// compiled op node returning opresult3631 (depth = 5)
  Object if3622 = done;
  if (istrue(opresult3631)) {
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3622 = undefined;
  } else {
  }
// compiled if node returning if3622 (depth = 4)
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3634 = alloc_Float64(0);
// compiled num node returning num3634 (depth = 6)
  int op_slot_right_3633 = gc_frame_newslot(num3634);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_3633 = gc_frame_newslot(*var_jump);
  params[0] = num3634;
  partcv[0] = 1;
  Object opresult3636 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3636 (depth = 5)
  Object if3632 = done;
  if (istrue(opresult3636)) {
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3637 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3640 = alloc_Float64(1);
// compiled num node returning num3640 (depth = 8)
  int op_slot_right_3639 = gc_frame_newslot(num3640);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3643 = alloc_Float64(3);
// compiled num node returning num3643 (depth = 9)
  int op_slot_right_3642 = gc_frame_newslot(num3643);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_3642 = gc_frame_newslot(*var_t);
  params[0] = num3643;
  partcv[0] = 1;
  Object prod3645 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod3645 (depth = 8)
  int op_slot_left_3639 = gc_frame_newslot(prod3645);
  params[0] = num3640;
  partcv[0] = 1;
  Object sum3646 = callmethod(prod3645, "+(1)", 1, partcv, params);
// compiled op node returning sum3646 (depth = 7)
  int op_slot_left_3637 = gc_frame_newslot(sum3646);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3647 = callmethod(sum3646, "%(1)", 1, partcv, params);
// compiled op node returning modulus3647 (depth = 6)
  *var_t = modulus3647;
  if (modulus3647 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3650 = alloc_Float64(1);
// compiled num node returning num3650 (depth = 7)
  int op_slot_right_3649 = gc_frame_newslot(num3650);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_3649 = gc_frame_newslot(*var_jump);
  params[0] = num3650;
  partcv[0] = 1;
  Object diff3652 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff3652 (depth = 6)
  *var_jump = diff3652;
  if (diff3652 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3632 = done;
  } else {
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3654 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3657 = alloc_Float64(1);
// compiled num node returning num3657 (depth = 8)
  int op_slot_right_3656 = gc_frame_newslot(num3657);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_3656 = gc_frame_newslot(*var_t);
  params[0] = num3657;
  partcv[0] = 1;
  Object sum3659 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum3659 (depth = 7)
  int op_slot_left_3654 = gc_frame_newslot(sum3659);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3660 = callmethod(sum3659, "%(1)", 1, partcv, params);
// compiled op node returning modulus3660 (depth = 6)
  *var_t = modulus3660;
  if (modulus3660 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3632 = done;
  }
// compiled if node returning if3632 (depth = 4)
  gc_frame_end(frame);
  return if3632;
}
Object meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPositionForAdd(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPositionForAdd(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPositionForAdd(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPositionForAdd(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3589 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  partcv[0] = 0;
  Object call3590 = callmethodflags(*var_x, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe3589);
// compiled member node returning call3590 (depth = 3)
  *var_h = call3590;
  if (call3590 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3591 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3592 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3593 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3592);
// compiled member node returning call3593 (depth = 4)
  partcv[0] = 0;
  Object call3594 = callmethodflags(call3593, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3591);
// compiled member node returning call3594 (depth = 3)
  *var_s = call3594;
  if (call3594 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_3595 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_3595 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3597 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus3597 (depth = 3)
  *var_t = modulus3597;
  if (modulus3597 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num3598 = alloc_Float64(5);
// compiled num node returning num3598 (depth = 3)
  *var_jump = num3598;
  if (num3598 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3599 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3600 = alloc_Block(NULL, NULL, "collectionsPrelude", 1425);
  gc_frame_newslot(block3600);
// method "_apply"
  block_savedest(block3600);
  Object closure3601 = createclosure(4, "_apply");
  setclosureframe(closure3601, stackframe);
  addtoclosure(closure3601, var_t);
  addtoclosure(closure3601, var_removed);
  addtoclosure(closure3601, var_unused);
  addtoclosure(closure3601, selfslot);
  struct UserObject *uo3601 = (struct UserObject*)block3600;
  uo3601->data[0] = (Object)closure3601;
  Method *meth_meth_collectionsPrelude_3601__apply = addmethod2pos(block3600, "_apply", &meth_collectionsPrelude_3601__apply, 0);
  int argcv_meth_collectionsPrelude_3601__apply[] = {0};
  meth_meth_collectionsPrelude_3601__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3601__apply);
  meth_meth_collectionsPrelude_3601__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_3601__apply->definitionLine = 1769;
// compiled block node returning block3600 (depth = 3)
  gc_frame_newslot(block3600);
// starting to compile block node (depth = 3)
  Object block3620 = alloc_Block(NULL, NULL, "collectionsPrelude", 1425);
  gc_frame_newslot(block3620);
// method "_apply"
  block_savedest(block3620);
  Object closure3621 = createclosure(5, "_apply");
  setclosureframe(closure3621, stackframe);
  addtoclosure(closure3621, var_x);
  addtoclosure(closure3621, var_t);
  addtoclosure(closure3621, var_jump);
  addtoclosure(closure3621, var_s);
  addtoclosure(closure3621, selfslot);
  struct UserObject *uo3621 = (struct UserObject*)block3620;
  uo3621->data[0] = (Object)closure3621;
  Method *meth_meth_collectionsPrelude_3621__apply = addmethod2pos(block3620, "_apply", &meth_collectionsPrelude_3621__apply, 0);
  int argcv_meth_collectionsPrelude_3621__apply[] = {0};
  meth_meth_collectionsPrelude_3621__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3621__apply);
  meth_meth_collectionsPrelude_3621__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_3621__apply->definitionLine = 1769;
// compiled block node returning block3620 (depth = 3)
  gc_frame_newslot(block3620);
// call case 5: prelude request
  params[0] = block3600;
  params[1] = block3620;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3663 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3599);
// compiled call node returning call3663 (depth = 2)
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_3681__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_firstElement = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3682 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3683 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3684 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3683);
// compiled member node returning call3684 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3685 = callmethodflags(call3684, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3682);
// compiled call node returning call3685 (depth = 5)
  *var_a = call3685;
  if (call3685 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3688 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_3688 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3690 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3690 (depth = 6)
  int op_slot_right_3687 = gc_frame_newslot(opresult3690);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3692 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_3692 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3694 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3694 (depth = 6)
  int op_slot_left_3687 = gc_frame_newslot(opresult3694);
  params[0] = opresult3690;
  partcv[0] = 1;
  Object opresult3695 = callmethod(opresult3694, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3695 (depth = 5)
  Object if3686 = done;
  if (istrue(opresult3695)) {
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3697 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstElement (depth = 7)
  partcv[0] = 0;
  Object call3698 = callmethodflags(*var_firstElement, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3697);
// compiled call node returning call3698 (depth = 6)
  Object if3696 = done;
  if (istrue(call3698)) {
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3700 == NULL) {
    strlit3700 = alloc_String(", ");
    gc_root(strlit3700);
  }
// compiled string node returning strlit3700 (depth = 8)
  int op_slot_right_3699 = gc_frame_newslot(strlit3700);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3699 = gc_frame_newslot(*var_s);
  params[0] = strlit3700;
  partcv[0] = 1;
  Object opresult3702 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3702 (depth = 7)
  *var_s = opresult3702;
  if (opresult3702 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3696 = done;
  } else {
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3704 = alloc_Boolean(0);
// compiled identifier node returning bool3704 (depth = 7)
  *var_firstElement = bool3704;
  if (bool3704 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3696 = done;
  }
// compiled if node returning if3696 (depth = 5)
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3708 == NULL) {
    strlit3708 = alloc_String("");
    gc_root(strlit3708);
  }
// compiled string node returning strlit3708 (depth = 8)
  int op_slot_right_3707 = gc_frame_newslot(strlit3708);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3711 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  partcv[0] = 0;
  Object call3712 = callmethodflags(*var_a, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3711);
// compiled member node returning call3712 (depth = 9)
  int op_slot_right_3710 = gc_frame_newslot(call3712);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3715 == NULL) {
    strlit3715 = alloc_String("::");
    gc_root(strlit3715);
  }
// compiled string node returning strlit3715 (depth = 10)
  int op_slot_right_3714 = gc_frame_newslot(strlit3715);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe3718 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  partcv[0] = 0;
  Object call3719 = callmethodflags(*var_a, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3718);
// compiled member node returning call3719 (depth = 11)
  int op_slot_right_3717 = gc_frame_newslot(call3719);
// starting to compile string node (depth = 11)
  if (strlit3721 == NULL) {
    strlit3721 = alloc_String("");
    gc_root(strlit3721);
  }
// compiled string node returning strlit3721 (depth = 11)
  int op_slot_left_3717 = gc_frame_newslot(strlit3721);
  params[0] = call3719;
  partcv[0] = 1;
  Object opresult3722 = callmethod(strlit3721, "++(1)", 1, partcv, params);
// compiled op node returning opresult3722 (depth = 10)
  int op_slot_left_3714 = gc_frame_newslot(opresult3722);
  params[0] = strlit3715;
  partcv[0] = 1;
  Object opresult3723 = callmethod(opresult3722, "++(1)", 1, partcv, params);
// compiled op node returning opresult3723 (depth = 9)
  int op_slot_left_3710 = gc_frame_newslot(opresult3723);
  params[0] = call3712;
  partcv[0] = 1;
  Object opresult3724 = callmethod(opresult3723, "++(1)", 1, partcv, params);
// compiled op node returning opresult3724 (depth = 8)
  int op_slot_left_3707 = gc_frame_newslot(opresult3724);
  params[0] = strlit3708;
  partcv[0] = 1;
  Object opresult3725 = callmethod(opresult3724, "++(1)", 1, partcv, params);
// compiled op node returning opresult3725 (depth = 7)
  int op_slot_right_3706 = gc_frame_newslot(opresult3725);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3706 = gc_frame_newslot(*var_s);
  params[0] = opresult3725;
  partcv[0] = 1;
  Object opresult3727 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3727 (depth = 6)
  *var_s = opresult3727;
  if (opresult3727 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3686 = done;
  } else {
  }
// compiled if node returning if3686 (depth = 4)
  gc_frame_end(frame);
  return if3686;
}
Object meth_collectionsPrelude_3664_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_firstElement = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "firstElement");
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3665 == NULL) {
    strlit3665 = alloc_String("dict""\xe2""""\x9f""""\xac""");
    gc_root(strlit3665);
  }
// compiled string node returning strlit3665 (depth = 3)
  *var_s = strlit3665;
  if (strlit3665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3666 = alloc_Boolean(1);
// compiled identifier node returning bool3666 (depth = 3)
  *var_firstElement = bool3666;
  if (bool3666 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3667 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3670 = alloc_Float64(1);
// compiled num node returning num3670 (depth = 5)
  int op_slot_right_3669 = gc_frame_newslot(num3670);
// starting to compile member node (depth = 5)
  int callframe3672 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3673 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3674 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3673);
// compiled member node returning call3674 (depth = 6)
  partcv[0] = 0;
  Object call3675 = callmethodflags(call3674, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3672);
// compiled member node returning call3675 (depth = 5)
  int op_slot_left_3669 = gc_frame_newslot(call3675);
  params[0] = num3670;
  partcv[0] = 1;
  Object diff3676 = callmethod(call3675, "-(1)", 1, partcv, params);
// compiled op node returning diff3676 (depth = 4)
  int op_slot_right_3668 = gc_frame_newslot(diff3676);
// starting to compile num node (depth = 4)
  Object num3678 = alloc_Float64(0);
// compiled num node returning num3678 (depth = 4)
  int op_slot_left_3668 = gc_frame_newslot(num3678);
  params[0] = diff3676;
  partcv[0] = 1;
  Object opresult3679 = callmethod(num3678, "..(1)", 1, partcv, params);
// compiled op node returning opresult3679 (depth = 3)
  gc_frame_newslot(opresult3679);
// starting to compile block node (depth = 3)
  Object block3680 = alloc_Block(NULL, NULL, "collectionsPrelude", 1443);
  gc_frame_newslot(block3680);
// method "_apply(_)"
  block_savedest(block3680);
  Object closure3681 = createclosure(5, "_apply(1)");
  setclosureframe(closure3681, stackframe);
  addtoclosure(closure3681, var_removed);
  addtoclosure(closure3681, var_unused);
  addtoclosure(closure3681, var_firstElement);
  addtoclosure(closure3681, var_s);
  addtoclosure(closure3681, selfslot);
  struct UserObject *uo3681 = (struct UserObject*)block3680;
  uo3681->data[0] = (Object)closure3681;
  Method *meth_meth_collectionsPrelude_3681__apply_40_1_41_ = addmethod2pos(block3680, "_apply(1)", &meth_collectionsPrelude_3681__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_3681__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3681__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3681__apply_40_1_41_);
  meth_meth_collectionsPrelude_3681__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3681__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block3680 (depth = 3)
  gc_frame_newslot(block3680);
// call case 5: prelude request
  params[0] = opresult3679;
  params[1] = block3680;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3730 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3667);
// compiled call node returning call3730 (depth = 2)
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3732 == NULL) {
    strlit3732 = alloc_String("""\xe2""""\x9f""""\xad""");
    gc_root(strlit3732);
  }
// compiled string node returning strlit3732 (depth = 3)
  int op_slot_right_3731 = gc_frame_newslot(strlit3732);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_3731 = gc_frame_newslot(*var_s);
  params[0] = strlit3732;
  partcv[0] = 1;
  Object opresult3734 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3734 (depth = 2)
  gc_frame_end(frame);
  return opresult3734;
}
Object meth_collectionsPrelude_3751__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// definebindings:
// definebindings:
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3754 = alloc_Float64(0);
// compiled num node returning num3754 (depth = 6)
  int op_slot_right_3753 = gc_frame_newslot(num3754);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_3753 = gc_frame_newslot(*var_i);
  params[0] = num3754;
  partcv[0] = 1;
  Object opresult3756 = callmethod(*var_i, ">(1)", 1, partcv, params);
// compiled op node returning opresult3756 (depth = 5)
  Object if3752 = done;
  if (istrue(opresult3756)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3758 == NULL) {
    strlit3758 = alloc_String(", ");
    gc_root(strlit3758);
  }
// compiled string node returning strlit3758 (depth = 7)
  int op_slot_right_3757 = gc_frame_newslot(strlit3758);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3757 = gc_frame_newslot(*var_s);
  params[0] = strlit3758;
  partcv[0] = 1;
  Object opresult3760 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3760 (depth = 6)
  *var_s = opresult3760;
  if (opresult3760 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3752 = done;
  } else {
  }
// compiled if node returning if3752 (depth = 4)
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3762 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3763 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3764 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3763);
// compiled member node returning call3764 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3765 = callmethodflags(call3764, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3762);
// compiled call node returning call3765 (depth = 5)
  *var_a = call3765;
  if (call3765 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3768 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_3768 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3770 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3770 (depth = 6)
  int op_slot_right_3767 = gc_frame_newslot(opresult3770);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3772 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_3772 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3774 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3774 (depth = 6)
  int op_slot_left_3767 = gc_frame_newslot(opresult3774);
  params[0] = opresult3770;
  partcv[0] = 1;
  Object opresult3775 = callmethod(opresult3774, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3775 (depth = 5)
  Object if3766 = done;
  if (istrue(opresult3775)) {
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3778 == NULL) {
    strlit3778 = alloc_String("");
    gc_root(strlit3778);
  }
// compiled string node returning strlit3778 (depth = 8)
  int op_slot_right_3777 = gc_frame_newslot(strlit3778);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3781 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  partcv[0] = 0;
  Object call3782 = callmethodflags(*var_a, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3781);
// compiled member node returning call3782 (depth = 9)
  int op_slot_right_3780 = gc_frame_newslot(call3782);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3785 == NULL) {
    strlit3785 = alloc_String("::");
    gc_root(strlit3785);
  }
// compiled string node returning strlit3785 (depth = 10)
  int op_slot_right_3784 = gc_frame_newslot(strlit3785);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe3788 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  partcv[0] = 0;
  Object call3789 = callmethodflags(*var_a, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3788);
// compiled member node returning call3789 (depth = 11)
  int op_slot_right_3787 = gc_frame_newslot(call3789);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3792 == NULL) {
    strlit3792 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit3792);
  }
// compiled string node returning strlit3792 (depth = 12)
  int op_slot_right_3791 = gc_frame_newslot(strlit3792);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_right_3794 = gc_frame_newslot(*var_i);
// starting to compile string node (depth = 13)
  if (strlit3796 == NULL) {
    strlit3796 = alloc_String("");
    gc_root(strlit3796);
  }
// compiled string node returning strlit3796 (depth = 13)
  int op_slot_left_3794 = gc_frame_newslot(strlit3796);
  params[0] = *var_i;
  partcv[0] = 1;
  Object opresult3797 = callmethod(strlit3796, "++(1)", 1, partcv, params);
// compiled op node returning opresult3797 (depth = 12)
  int op_slot_left_3791 = gc_frame_newslot(opresult3797);
  params[0] = strlit3792;
  partcv[0] = 1;
  Object opresult3798 = callmethod(opresult3797, "++(1)", 1, partcv, params);
// compiled op node returning opresult3798 (depth = 11)
  int op_slot_left_3787 = gc_frame_newslot(opresult3798);
  params[0] = call3789;
  partcv[0] = 1;
  Object opresult3799 = callmethod(opresult3798, "++(1)", 1, partcv, params);
// compiled op node returning opresult3799 (depth = 10)
  int op_slot_left_3784 = gc_frame_newslot(opresult3799);
  params[0] = strlit3785;
  partcv[0] = 1;
  Object opresult3800 = callmethod(opresult3799, "++(1)", 1, partcv, params);
// compiled op node returning opresult3800 (depth = 9)
  int op_slot_left_3780 = gc_frame_newslot(opresult3800);
  params[0] = call3782;
  partcv[0] = 1;
  Object opresult3801 = callmethod(opresult3800, "++(1)", 1, partcv, params);
// compiled op node returning opresult3801 (depth = 8)
  int op_slot_left_3777 = gc_frame_newslot(opresult3801);
  params[0] = strlit3778;
  partcv[0] = 1;
  Object opresult3802 = callmethod(opresult3801, "++(1)", 1, partcv, params);
// compiled op node returning opresult3802 (depth = 7)
  int op_slot_right_3776 = gc_frame_newslot(opresult3802);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3776 = gc_frame_newslot(*var_s);
  params[0] = opresult3802;
  partcv[0] = 1;
  Object opresult3804 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3804 (depth = 6)
  *var_s = opresult3804;
  if (opresult3804 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3766 = done;
  } else {
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3808 == NULL) {
    strlit3808 = alloc_String("");
    gc_root(strlit3808);
  }
// compiled string node returning strlit3808 (depth = 8)
  int op_slot_right_3807 = gc_frame_newslot(strlit3808);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3811 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  partcv[0] = 0;
  Object call3812 = callmethodflags(*var_a, "asDebugString", 1, partcv, params, 0);
  gc_frame_end(callframe3811);
// compiled member node returning call3812 (depth = 9)
  int op_slot_right_3810 = gc_frame_newslot(call3812);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3815 == NULL) {
    strlit3815 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit3815);
  }
// compiled string node returning strlit3815 (depth = 10)
  int op_slot_right_3814 = gc_frame_newslot(strlit3815);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_right_3817 = gc_frame_newslot(*var_i);
// starting to compile string node (depth = 11)
  if (strlit3819 == NULL) {
    strlit3819 = alloc_String("");
    gc_root(strlit3819);
  }
// compiled string node returning strlit3819 (depth = 11)
  int op_slot_left_3817 = gc_frame_newslot(strlit3819);
  params[0] = *var_i;
  partcv[0] = 1;
  Object opresult3820 = callmethod(strlit3819, "++(1)", 1, partcv, params);
// compiled op node returning opresult3820 (depth = 10)
  int op_slot_left_3814 = gc_frame_newslot(opresult3820);
  params[0] = strlit3815;
  partcv[0] = 1;
  Object opresult3821 = callmethod(opresult3820, "++(1)", 1, partcv, params);
// compiled op node returning opresult3821 (depth = 9)
  int op_slot_left_3810 = gc_frame_newslot(opresult3821);
  params[0] = call3812;
  partcv[0] = 1;
  Object opresult3822 = callmethod(opresult3821, "++(1)", 1, partcv, params);
// compiled op node returning opresult3822 (depth = 8)
  int op_slot_left_3807 = gc_frame_newslot(opresult3822);
  params[0] = strlit3808;
  partcv[0] = 1;
  Object opresult3823 = callmethod(opresult3822, "++(1)", 1, partcv, params);
// compiled op node returning opresult3823 (depth = 7)
  int op_slot_right_3806 = gc_frame_newslot(opresult3823);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3806 = gc_frame_newslot(*var_s);
  params[0] = opresult3823;
  partcv[0] = 1;
  Object opresult3825 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3825 (depth = 6)
  *var_s = opresult3825;
  if (opresult3825 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3766 = done;
  }
// compiled if node returning if3766 (depth = 4)
  gc_frame_end(frame);
  return if3766;
}
Object meth_collectionsPrelude_3735_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3736 == NULL) {
    strlit3736 = alloc_String("dict""\xe2""""\x9f""""\xac""");
    gc_root(strlit3736);
  }
// compiled string node returning strlit3736 (depth = 3)
  *var_s = strlit3736;
  if (strlit3736 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3737 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3740 = alloc_Float64(1);
// compiled num node returning num3740 (depth = 5)
  int op_slot_right_3739 = gc_frame_newslot(num3740);
// starting to compile member node (depth = 5)
  int callframe3742 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3743 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3744 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3743);
// compiled member node returning call3744 (depth = 6)
  partcv[0] = 0;
  Object call3745 = callmethodflags(call3744, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3742);
// compiled member node returning call3745 (depth = 5)
  int op_slot_left_3739 = gc_frame_newslot(call3745);
  params[0] = num3740;
  partcv[0] = 1;
  Object diff3746 = callmethod(call3745, "-(1)", 1, partcv, params);
// compiled op node returning diff3746 (depth = 4)
  int op_slot_right_3738 = gc_frame_newslot(diff3746);
// starting to compile num node (depth = 4)
  Object num3748 = alloc_Float64(0);
// compiled num node returning num3748 (depth = 4)
  int op_slot_left_3738 = gc_frame_newslot(num3748);
  params[0] = diff3746;
  partcv[0] = 1;
  Object opresult3749 = callmethod(num3748, "..(1)", 1, partcv, params);
// compiled op node returning opresult3749 (depth = 3)
  gc_frame_newslot(opresult3749);
// starting to compile block node (depth = 3)
  Object block3750 = alloc_Block(NULL, NULL, "collectionsPrelude", 1458);
  gc_frame_newslot(block3750);
// method "_apply(_)"
  block_savedest(block3750);
  Object closure3751 = createclosure(4, "_apply(1)");
  setclosureframe(closure3751, stackframe);
  addtoclosure(closure3751, var_s);
  addtoclosure(closure3751, var_removed);
  addtoclosure(closure3751, var_unused);
  addtoclosure(closure3751, selfslot);
  struct UserObject *uo3751 = (struct UserObject*)block3750;
  uo3751->data[0] = (Object)closure3751;
  Method *meth_meth_collectionsPrelude_3751__apply_40_1_41_ = addmethod2pos(block3750, "_apply(1)", &meth_collectionsPrelude_3751__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_3751__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3751__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3751__apply_40_1_41_);
  meth_meth_collectionsPrelude_3751__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3751__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block3750 (depth = 3)
  gc_frame_newslot(block3750);
// call case 5: prelude request
  params[0] = opresult3749;
  params[1] = block3750;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3828 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3737);
// compiled call node returning call3828 (depth = 2)
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3830 == NULL) {
    strlit3830 = alloc_String("""\xe2""""\x9f""""\xad""");
    gc_root(strlit3830);
  }
// compiled string node returning strlit3830 (depth = 3)
  int op_slot_right_3829 = gc_frame_newslot(strlit3830);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_3829 = gc_frame_newslot(*var_s);
  params[0] = strlit3830;
  partcv[0] = 1;
  Object opresult3832 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3832 (depth = 2)
  gc_frame_end(frame);
  return opresult3832;
}
Object meth_collectionsPrelude_3840_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3841 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3842 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3843 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3842);
// compiled member node returning call3843 (depth = 3)
  partcv[0] = 0;
  Object call3844 = callmethodflags(call3843, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe3841);
// compiled member node returning call3844 (depth = 2)
  gc_frame_end(frame);
  return call3844;
}
Object meth_collectionsPrelude_3845_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3846 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3847 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3848 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3849 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3848);
// compiled member node returning call3849 (depth = 4)
  partcv[0] = 0;
  Object call3850 = callmethodflags(call3849, "next", 1, partcv, params, 0);
  gc_frame_end(callframe3847);
// compiled member node returning call3850 (depth = 3)
  partcv[0] = 0;
  Object call3851 = callmethodflags(call3850, "key", 1, partcv, params, 0);
  gc_frame_end(callframe3846);
// compiled member node returning call3851 (depth = 2)
  gc_frame_end(frame);
  return call3851;
}
Object meth_collectionsPrelude_3852_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3854 == NULL) {
    strlit3854 = alloc_String("");
    gc_root(strlit3854);
  }
// compiled string node returning strlit3854 (depth = 3)
  int op_slot_right_3853 = gc_frame_newslot(strlit3854);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3856 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3858 == NULL) {
    strlit3858 = alloc_String("an iterator over keys of ");
    gc_root(strlit3858);
  }
// compiled string node returning strlit3858 (depth = 4)
  int op_slot_left_3856 = gc_frame_newslot(strlit3858);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3859 = callmethod(strlit3858, "++(1)", 1, partcv, params);
// compiled op node returning opresult3859 (depth = 3)
  int op_slot_left_3853 = gc_frame_newslot(opresult3859);
  params[0] = strlit3854;
  partcv[0] = 1;
  Object opresult3860 = callmethod(opresult3859, "++(1)", 1, partcv, params);
// compiled op node returning opresult3860 (depth = 2)
  gc_frame_end(frame);
  return opresult3860;
}
Object meth_collectionsPrelude_3836_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3837 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3837 = alloc_userobj2(4,5, objclass3837);
  gc_frame_newslot(obj3837);
  if (objclass3837 == NULL) {
    glfree(obj3837->class->name);
    obj3837->class->name = "dictionary.empty.keys.iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3837, self, 0);
  addmethodreal(obj3837,"outer", &reader_collectionsPrelude_outer_3838);
  Object oldself3837 = self;
  struct StackFrameObject *oldstackframe3837 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3837);
  gc_frame_newslot((Object)stackframe);
  self = obj3837;
  Object *oldselfslot3837 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3837 = (*(struct UserObject *)self).data[0], lowerouter3837 = thisouter3837;
  if (inheritingObject3837) {
    struct UserObject *inho3837 = (struct UserObject *)inheritingObject3837;
    while (inho3837->super != GraceDefaultObject) inho3837 = (struct UserObject *)inho3837->super;
    inho3837->super = obj3837;
    self = inheritingObject3837;
    *selfslot = self;
    lowerouter3837 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3837;
  }
  if (objclass3837 == NULL) {
  Method *reader3839 = addmethodrealflags(obj3837, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3839, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3839->definitionModule = modulename;
  reader3839->definitionLine = 1474;
  }
  adddatum2(obj3837, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3840 = (struct UserObject*)obj3837;
  uo3840->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3840_hasNext = addmethod2pos(obj3837, "hasNext", &meth_collectionsPrelude_3840_hasNext, 2);
  int argcv_meth_collectionsPrelude_3840_hasNext[] = {0};
  meth_meth_collectionsPrelude_3840_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3840_hasNext);
  meth_meth_collectionsPrelude_3840_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_3840_hasNext->definitionLine = 1475;
// method "next"
  struct UserObject *uo3845 = (struct UserObject*)obj3837;
  uo3845->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3845_next = addmethod2pos(obj3837, "next", &meth_collectionsPrelude_3845_next, 3);
  int argcv_meth_collectionsPrelude_3845_next[] = {0};
  meth_meth_collectionsPrelude_3845_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3845_next);
  meth_meth_collectionsPrelude_3845_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_3845_next->definitionLine = 1476;
// method "asString"
  block_savedest(obj3837);
  Object closure3852 = createclosure(1, "asString");
  setclosureframe(closure3852, stackframe);
  addtoclosure(closure3852, var_sourceDictionary);
  struct UserObject *uo3852 = (struct UserObject*)obj3837;
  uo3852->data[4] = (Object)closure3852;
  Method *meth_meth_collectionsPrelude_3852_asString = addmethod2pos(obj3837, "asString", &meth_collectionsPrelude_3852_asString, 4);
  int argcv_meth_collectionsPrelude_3852_asString[] = {0};
  meth_meth_collectionsPrelude_3852_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3852_asString);
  meth_meth_collectionsPrelude_3852_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3852_asString->definitionLine = 1477;
  sourceObject = obj3837;
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3861 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3862 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 1, partcv, params, 0);
  gc_frame_end(callframe3861);
// compiled member node returning call3862 (depth = 2)
  adddatum2(obj3837, call3862, 1);
  sourceObject = obj3837;
  sourceObject = obj3837;
  sourceObject = obj3837;
  objclass3837 = obj3837->class;
  objclass3837->definitionModule = modulename;
  objclass3837->definitionLine = 1473;
  (*(struct UserObject *)self).data[0] = lowerouter3837;
  self = oldself3837;
  selfslot = oldselfslot3837;
  stackframe = oldstackframe3837;
  gc_frame_end(frame);
  return obj3837;
}
Object meth_collectionsPrelude_3836_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3837 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3837 = alloc_userobj2(4,5, objclass3837);
  gc_frame_newslot(obj3837);
  if (objclass3837 == NULL) {
    glfree(obj3837->class->name);
    obj3837->class->name = "dictionary.empty.keys.iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3837, self, 0);
  addmethodreal(obj3837,"outer", &reader_collectionsPrelude_outer_3838);
  Object oldself3837 = self;
  struct StackFrameObject *oldstackframe3837 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3837);
  gc_frame_newslot((Object)stackframe);
  self = obj3837;
  Object *oldselfslot3837 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3837 = (*(struct UserObject *)self).data[0], lowerouter3837 = thisouter3837;
  if (inheritingObject3837) {
    struct UserObject *inho3837 = (struct UserObject *)inheritingObject3837;
    while (inho3837->super != GraceDefaultObject) inho3837 = (struct UserObject *)inho3837->super;
    inho3837->super = obj3837;
    self = inheritingObject3837;
    *selfslot = self;
    lowerouter3837 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3837;
  }
  if (objclass3837 == NULL) {
  Method *reader3839 = addmethodrealflags(obj3837, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3839, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3839->definitionModule = modulename;
  reader3839->definitionLine = 1474;
  }
  adddatum2(obj3837, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3840 = (struct UserObject*)obj3837;
  uo3840->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3840_hasNext = addmethod2pos(obj3837, "hasNext", &meth_collectionsPrelude_3840_hasNext, 2);
  int argcv_meth_collectionsPrelude_3840_hasNext[] = {0};
  meth_meth_collectionsPrelude_3840_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3840_hasNext);
  meth_meth_collectionsPrelude_3840_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_3840_hasNext->definitionLine = 1475;
// method "next"
  struct UserObject *uo3845 = (struct UserObject*)obj3837;
  uo3845->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3845_next = addmethod2pos(obj3837, "next", &meth_collectionsPrelude_3845_next, 3);
  int argcv_meth_collectionsPrelude_3845_next[] = {0};
  meth_meth_collectionsPrelude_3845_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3845_next);
  meth_meth_collectionsPrelude_3845_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_3845_next->definitionLine = 1476;
// method "asString"
  block_savedest(obj3837);
  Object closure3852 = createclosure(1, "asString");
  setclosureframe(closure3852, stackframe);
  addtoclosure(closure3852, var_sourceDictionary);
  struct UserObject *uo3852 = (struct UserObject*)obj3837;
  uo3852->data[4] = (Object)closure3852;
  Method *meth_meth_collectionsPrelude_3852_asString = addmethod2pos(obj3837, "asString", &meth_collectionsPrelude_3852_asString, 4);
  int argcv_meth_collectionsPrelude_3852_asString[] = {0};
  meth_meth_collectionsPrelude_3852_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3852_asString);
  meth_meth_collectionsPrelude_3852_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3852_asString->definitionLine = 1477;
  sourceObject = obj3837;
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3861 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3862 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 1, partcv, params, 0);
  gc_frame_end(callframe3861);
// compiled member node returning call3862 (depth = 2)
  adddatum2(obj3837, call3862, 1);
  sourceObject = obj3837;
  sourceObject = obj3837;
  sourceObject = obj3837;
  objclass3837 = obj3837->class;
  objclass3837->definitionModule = modulename;
  objclass3837->definitionLine = 1473;
  (*(struct UserObject *)self).data[0] = lowerouter3837;
  self = oldself3837;
  selfslot = oldselfslot3837;
  stackframe = oldstackframe3837;
  gc_frame_end(frame);
  return obj3837;
}
Object meth_collectionsPrelude_3865_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3867 == NULL) {
    strlit3867 = alloc_String("");
    gc_root(strlit3867);
  }
// compiled string node returning strlit3867 (depth = 3)
  int op_slot_right_3866 = gc_frame_newslot(strlit3867);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3869 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3871 == NULL) {
    strlit3871 = alloc_String("a lazy sequence over keys of ");
    gc_root(strlit3871);
  }
// compiled string node returning strlit3871 (depth = 4)
  int op_slot_left_3869 = gc_frame_newslot(strlit3871);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3872 = callmethod(strlit3871, "++(1)", 1, partcv, params);
// compiled op node returning opresult3872 (depth = 3)
  int op_slot_left_3866 = gc_frame_newslot(opresult3872);
  params[0] = strlit3867;
  partcv[0] = 1;
  Object opresult3873 = callmethod(opresult3872, "++(1)", 1, partcv, params);
// compiled op node returning opresult3873 (depth = 2)
  gc_frame_end(frame);
  return opresult3873;
}
Object meth_collectionsPrelude_3833_keys(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3834 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3834 = alloc_userobj2(4,5, objclass3834);
  gc_frame_newslot(obj3834);
  if (objclass3834 == NULL) {
    glfree(obj3834->class->name);
    obj3834->class->name = "dictionary.empty.keys";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3834, self, 0);
  addmethodreal(obj3834,"outer", &reader_collectionsPrelude_outer_3835);
  Object oldself3834 = self;
  struct StackFrameObject *oldstackframe3834 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3834);
  gc_frame_newslot((Object)stackframe);
  self = obj3834;
  Object *oldselfslot3834 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3834 = (*(struct UserObject *)self).data[0], lowerouter3834 = thisouter3834;
  if (inheritingObject3834) {
    struct UserObject *inho3834 = (struct UserObject *)inheritingObject3834;
    while (inho3834->super != GraceDefaultObject) inho3834 = (struct UserObject *)inho3834->super;
    inho3834->super = obj3834;
    self = inheritingObject3834;
    *selfslot = self;
    lowerouter3834 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3834;
  }
// method "iterator"
  block_savedest(obj3834);
  Object closure3836 = createclosure(1, "iterator");
  setclosureframe(closure3836, stackframe);
  addtoclosure(closure3836, var_sourceDictionary);
  struct UserObject *uo3836 = (struct UserObject*)obj3834;
  uo3836->data[1] = (Object)closure3836;
  Method *meth_meth_collectionsPrelude_3836_iterator = addmethod2pos(obj3834, "iterator", &meth_collectionsPrelude_3836_iterator, 1);
  int argcv_meth_collectionsPrelude_3836_iterator[] = {0};
  meth_meth_collectionsPrelude_3836_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3836_iterator);
  meth_meth_collectionsPrelude_3836_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_3836_iterator->definitionLine = 1473;
  block_savedest(obj3834);
  Object closure3863 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure3863, stackframe);
  addtoclosure(closure3863, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_3836_iterator_object = addmethod2pos(obj3834, "iterator$object(1)", &meth_collectionsPrelude_3836_iterator_object, 1);
  meth_meth_collectionsPrelude_3836_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3836_iterator_object->definitionLine = 1473;
  if (objclass3834 == NULL) {
  Method *reader3864 = addmethodrealflags(obj3834, "size",&reader_collectionsPrelude_size_3864, MFLAG_DEF);
  reader3864->definitionModule = modulename;
  reader3864->definitionLine = 1481;
  }
  adddatum2(obj3834, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3834);
  Object closure3865 = createclosure(1, "asDebugString");
  setclosureframe(closure3865, stackframe);
  addtoclosure(closure3865, var_sourceDictionary);
  struct UserObject *uo3865 = (struct UserObject*)obj3834;
  uo3865->data[3] = (Object)closure3865;
  Method *meth_meth_collectionsPrelude_3865_asDebugString = addmethod2pos(obj3834, "asDebugString", &meth_collectionsPrelude_3865_asDebugString, 3);
  int argcv_meth_collectionsPrelude_3865_asDebugString[] = {0};
  meth_meth_collectionsPrelude_3865_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3865_asDebugString);
  meth_meth_collectionsPrelude_3865_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3865_asDebugString->definitionLine = 1482;
  sourceObject = obj3834;
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3874 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3875 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3874);
// compiled call node returning call3875 (depth = 2)
  struct UserObject *obj3834_uo = (struct UserObject *)obj3834;
  obj3834_uo->super = call3875;
  sourceObject = obj3834;
  sourceObject = obj3834;
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3876 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3877 = callmethodflags(*var_sourceDictionary, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3876);
// compiled member node returning call3877 (depth = 2)
  adddatum2(obj3834, call3877, 2);
  sourceObject = obj3834;
  objclass3834 = obj3834->class;
  objclass3834->definitionModule = modulename;
  objclass3834->definitionLine = 1471;
  (*(struct UserObject *)self).data[0] = lowerouter3834;
  self = oldself3834;
  selfslot = oldselfslot3834;
  stackframe = oldstackframe3834;
  gc_frame_end(frame);
  return obj3834;
}
Object meth_collectionsPrelude_3833_keys_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3834 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3834 = alloc_userobj2(4,5, objclass3834);
  gc_frame_newslot(obj3834);
  if (objclass3834 == NULL) {
    glfree(obj3834->class->name);
    obj3834->class->name = "dictionary.empty.keys";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3834, self, 0);
  addmethodreal(obj3834,"outer", &reader_collectionsPrelude_outer_3835);
  Object oldself3834 = self;
  struct StackFrameObject *oldstackframe3834 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3834);
  gc_frame_newslot((Object)stackframe);
  self = obj3834;
  Object *oldselfslot3834 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3834 = (*(struct UserObject *)self).data[0], lowerouter3834 = thisouter3834;
  if (inheritingObject3834) {
    struct UserObject *inho3834 = (struct UserObject *)inheritingObject3834;
    while (inho3834->super != GraceDefaultObject) inho3834 = (struct UserObject *)inho3834->super;
    inho3834->super = obj3834;
    self = inheritingObject3834;
    *selfslot = self;
    lowerouter3834 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3834;
  }
// method "iterator"
  block_savedest(obj3834);
  Object closure3836 = createclosure(1, "iterator");
  setclosureframe(closure3836, stackframe);
  addtoclosure(closure3836, var_sourceDictionary);
  struct UserObject *uo3836 = (struct UserObject*)obj3834;
  uo3836->data[1] = (Object)closure3836;
  Method *meth_meth_collectionsPrelude_3836_iterator = addmethod2pos(obj3834, "iterator", &meth_collectionsPrelude_3836_iterator, 1);
  int argcv_meth_collectionsPrelude_3836_iterator[] = {0};
  meth_meth_collectionsPrelude_3836_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3836_iterator);
  meth_meth_collectionsPrelude_3836_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_3836_iterator->definitionLine = 1473;
  block_savedest(obj3834);
  Object closure3863 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure3863, stackframe);
  addtoclosure(closure3863, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_3836_iterator_object = addmethod2pos(obj3834, "iterator$object(1)", &meth_collectionsPrelude_3836_iterator_object, 1);
  meth_meth_collectionsPrelude_3836_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3836_iterator_object->definitionLine = 1473;
  if (objclass3834 == NULL) {
  Method *reader3864 = addmethodrealflags(obj3834, "size",&reader_collectionsPrelude_size_3864, MFLAG_DEF);
  reader3864->definitionModule = modulename;
  reader3864->definitionLine = 1481;
  }
  adddatum2(obj3834, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3834);
  Object closure3865 = createclosure(1, "asDebugString");
  setclosureframe(closure3865, stackframe);
  addtoclosure(closure3865, var_sourceDictionary);
  struct UserObject *uo3865 = (struct UserObject*)obj3834;
  uo3865->data[3] = (Object)closure3865;
  Method *meth_meth_collectionsPrelude_3865_asDebugString = addmethod2pos(obj3834, "asDebugString", &meth_collectionsPrelude_3865_asDebugString, 3);
  int argcv_meth_collectionsPrelude_3865_asDebugString[] = {0};
  meth_meth_collectionsPrelude_3865_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3865_asDebugString);
  meth_meth_collectionsPrelude_3865_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3865_asDebugString->definitionLine = 1482;
  sourceObject = obj3834;
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3874 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3875 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3874);
// compiled call node returning call3875 (depth = 2)
  struct UserObject *obj3834_uo = (struct UserObject *)obj3834;
  obj3834_uo->super = call3875;
  sourceObject = obj3834;
  sourceObject = obj3834;
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3876 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3877 = callmethodflags(*var_sourceDictionary, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3876);
// compiled member node returning call3877 (depth = 2)
  adddatum2(obj3834, call3877, 2);
  sourceObject = obj3834;
  objclass3834 = obj3834->class;
  objclass3834->definitionModule = modulename;
  objclass3834->definitionLine = 1471;
  (*(struct UserObject *)self).data[0] = lowerouter3834;
  self = oldself3834;
  selfslot = oldselfslot3834;
  stackframe = oldstackframe3834;
  gc_frame_end(frame);
  return obj3834;
}
Object meth_collectionsPrelude_3886_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3887 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3888 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3889 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3888);
// compiled member node returning call3889 (depth = 3)
  partcv[0] = 0;
  Object call3890 = callmethodflags(call3889, "hasNext", 1, partcv, params, 0);
  gc_frame_end(callframe3887);
// compiled member node returning call3890 (depth = 2)
  gc_frame_end(frame);
  return call3890;
}
Object meth_collectionsPrelude_3891_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3892 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3893 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3894 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3895 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3894);
// compiled member node returning call3895 (depth = 4)
  partcv[0] = 0;
  Object call3896 = callmethodflags(call3895, "next", 1, partcv, params, 0);
  gc_frame_end(callframe3893);
// compiled member node returning call3896 (depth = 3)
  partcv[0] = 0;
  Object call3897 = callmethodflags(call3896, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3892);
// compiled member node returning call3897 (depth = 2)
  gc_frame_end(frame);
  return call3897;
}
Object meth_collectionsPrelude_3898_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3900 == NULL) {
    strlit3900 = alloc_String("");
    gc_root(strlit3900);
  }
// compiled string node returning strlit3900 (depth = 3)
  int op_slot_right_3899 = gc_frame_newslot(strlit3900);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3902 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3904 == NULL) {
    strlit3904 = alloc_String("an iterator over values of ");
    gc_root(strlit3904);
  }
// compiled string node returning strlit3904 (depth = 4)
  int op_slot_left_3902 = gc_frame_newslot(strlit3904);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3905 = callmethod(strlit3904, "++(1)", 1, partcv, params);
// compiled op node returning opresult3905 (depth = 3)
  int op_slot_left_3899 = gc_frame_newslot(opresult3905);
  params[0] = strlit3900;
  partcv[0] = 1;
  Object opresult3906 = callmethod(opresult3905, "++(1)", 1, partcv, params);
// compiled op node returning opresult3906 (depth = 2)
  gc_frame_end(frame);
  return opresult3906;
}
Object meth_collectionsPrelude_3882_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3883 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3883 = alloc_userobj2(4,5, objclass3883);
  gc_frame_newslot(obj3883);
  if (objclass3883 == NULL) {
    glfree(obj3883->class->name);
    obj3883->class->name = "dictionary.empty.values.iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3883, self, 0);
  addmethodreal(obj3883,"outer", &reader_collectionsPrelude_outer_3884);
  Object oldself3883 = self;
  struct StackFrameObject *oldstackframe3883 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3883);
  gc_frame_newslot((Object)stackframe);
  self = obj3883;
  Object *oldselfslot3883 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3883 = (*(struct UserObject *)self).data[0], lowerouter3883 = thisouter3883;
  if (inheritingObject3883) {
    struct UserObject *inho3883 = (struct UserObject *)inheritingObject3883;
    while (inho3883->super != GraceDefaultObject) inho3883 = (struct UserObject *)inho3883->super;
    inho3883->super = obj3883;
    self = inheritingObject3883;
    *selfslot = self;
    lowerouter3883 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3883;
  }
  if (objclass3883 == NULL) {
  Method *reader3885 = addmethodrealflags(obj3883, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3885, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3885->definitionModule = modulename;
  reader3885->definitionLine = 1492;
  }
  adddatum2(obj3883, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3886 = (struct UserObject*)obj3883;
  uo3886->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3886_hasNext = addmethod2pos(obj3883, "hasNext", &meth_collectionsPrelude_3886_hasNext, 2);
  int argcv_meth_collectionsPrelude_3886_hasNext[] = {0};
  meth_meth_collectionsPrelude_3886_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3886_hasNext);
  meth_meth_collectionsPrelude_3886_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_3886_hasNext->definitionLine = 1494;
// method "next"
  struct UserObject *uo3891 = (struct UserObject*)obj3883;
  uo3891->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3891_next = addmethod2pos(obj3883, "next", &meth_collectionsPrelude_3891_next, 3);
  int argcv_meth_collectionsPrelude_3891_next[] = {0};
  meth_meth_collectionsPrelude_3891_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3891_next);
  meth_meth_collectionsPrelude_3891_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_3891_next->definitionLine = 1495;
// method "asString"
  block_savedest(obj3883);
  Object closure3898 = createclosure(1, "asString");
  setclosureframe(closure3898, stackframe);
  addtoclosure(closure3898, var_sourceDictionary);
  struct UserObject *uo3898 = (struct UserObject*)obj3883;
  uo3898->data[4] = (Object)closure3898;
  Method *meth_meth_collectionsPrelude_3898_asString = addmethod2pos(obj3883, "asString", &meth_collectionsPrelude_3898_asString, 4);
  int argcv_meth_collectionsPrelude_3898_asString[] = {0};
  meth_meth_collectionsPrelude_3898_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3898_asString);
  meth_meth_collectionsPrelude_3898_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3898_asString->definitionLine = 1496;
  sourceObject = obj3883;
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3907 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3908 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 1, partcv, params, 0);
  gc_frame_end(callframe3907);
// compiled member node returning call3908 (depth = 2)
  adddatum2(obj3883, call3908, 1);
  sourceObject = obj3883;
  sourceObject = obj3883;
  sourceObject = obj3883;
  objclass3883 = obj3883->class;
  objclass3883->definitionModule = modulename;
  objclass3883->definitionLine = 1491;
  (*(struct UserObject *)self).data[0] = lowerouter3883;
  self = oldself3883;
  selfslot = oldselfslot3883;
  stackframe = oldstackframe3883;
  gc_frame_end(frame);
  return obj3883;
}
Object meth_collectionsPrelude_3882_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3883 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3883 = alloc_userobj2(4,5, objclass3883);
  gc_frame_newslot(obj3883);
  if (objclass3883 == NULL) {
    glfree(obj3883->class->name);
    obj3883->class->name = "dictionary.empty.values.iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3883, self, 0);
  addmethodreal(obj3883,"outer", &reader_collectionsPrelude_outer_3884);
  Object oldself3883 = self;
  struct StackFrameObject *oldstackframe3883 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3883);
  gc_frame_newslot((Object)stackframe);
  self = obj3883;
  Object *oldselfslot3883 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3883 = (*(struct UserObject *)self).data[0], lowerouter3883 = thisouter3883;
  if (inheritingObject3883) {
    struct UserObject *inho3883 = (struct UserObject *)inheritingObject3883;
    while (inho3883->super != GraceDefaultObject) inho3883 = (struct UserObject *)inho3883->super;
    inho3883->super = obj3883;
    self = inheritingObject3883;
    *selfslot = self;
    lowerouter3883 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3883;
  }
  if (objclass3883 == NULL) {
  Method *reader3885 = addmethodrealflags(obj3883, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3885, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3885->definitionModule = modulename;
  reader3885->definitionLine = 1492;
  }
  adddatum2(obj3883, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3886 = (struct UserObject*)obj3883;
  uo3886->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3886_hasNext = addmethod2pos(obj3883, "hasNext", &meth_collectionsPrelude_3886_hasNext, 2);
  int argcv_meth_collectionsPrelude_3886_hasNext[] = {0};
  meth_meth_collectionsPrelude_3886_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3886_hasNext);
  meth_meth_collectionsPrelude_3886_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_3886_hasNext->definitionLine = 1494;
// method "next"
  struct UserObject *uo3891 = (struct UserObject*)obj3883;
  uo3891->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3891_next = addmethod2pos(obj3883, "next", &meth_collectionsPrelude_3891_next, 3);
  int argcv_meth_collectionsPrelude_3891_next[] = {0};
  meth_meth_collectionsPrelude_3891_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3891_next);
  meth_meth_collectionsPrelude_3891_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_3891_next->definitionLine = 1495;
// method "asString"
  block_savedest(obj3883);
  Object closure3898 = createclosure(1, "asString");
  setclosureframe(closure3898, stackframe);
  addtoclosure(closure3898, var_sourceDictionary);
  struct UserObject *uo3898 = (struct UserObject*)obj3883;
  uo3898->data[4] = (Object)closure3898;
  Method *meth_meth_collectionsPrelude_3898_asString = addmethod2pos(obj3883, "asString", &meth_collectionsPrelude_3898_asString, 4);
  int argcv_meth_collectionsPrelude_3898_asString[] = {0};
  meth_meth_collectionsPrelude_3898_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3898_asString);
  meth_meth_collectionsPrelude_3898_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3898_asString->definitionLine = 1496;
  sourceObject = obj3883;
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3907 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3908 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 1, partcv, params, 0);
  gc_frame_end(callframe3907);
// compiled member node returning call3908 (depth = 2)
  adddatum2(obj3883, call3908, 1);
  sourceObject = obj3883;
  sourceObject = obj3883;
  sourceObject = obj3883;
  objclass3883 = obj3883->class;
  objclass3883->definitionModule = modulename;
  objclass3883->definitionLine = 1491;
  (*(struct UserObject *)self).data[0] = lowerouter3883;
  self = oldself3883;
  selfslot = oldselfslot3883;
  stackframe = oldstackframe3883;
  gc_frame_end(frame);
  return obj3883;
}
Object meth_collectionsPrelude_3911_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3913 == NULL) {
    strlit3913 = alloc_String("");
    gc_root(strlit3913);
  }
// compiled string node returning strlit3913 (depth = 3)
  int op_slot_right_3912 = gc_frame_newslot(strlit3913);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3915 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3917 == NULL) {
    strlit3917 = alloc_String("a lazy sequence over values of ");
    gc_root(strlit3917);
  }
// compiled string node returning strlit3917 (depth = 4)
  int op_slot_left_3915 = gc_frame_newslot(strlit3917);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3918 = callmethod(strlit3917, "++(1)", 1, partcv, params);
// compiled op node returning opresult3918 (depth = 3)
  int op_slot_left_3912 = gc_frame_newslot(opresult3918);
  params[0] = strlit3913;
  partcv[0] = 1;
  Object opresult3919 = callmethod(opresult3918, "++(1)", 1, partcv, params);
// compiled op node returning opresult3919 (depth = 2)
  gc_frame_end(frame);
  return opresult3919;
}
Object meth_collectionsPrelude_3879_values(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3880 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3880 = alloc_userobj2(4,5, objclass3880);
  gc_frame_newslot(obj3880);
  if (objclass3880 == NULL) {
    glfree(obj3880->class->name);
    obj3880->class->name = "dictionary.empty.values";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3880, self, 0);
  addmethodreal(obj3880,"outer", &reader_collectionsPrelude_outer_3881);
  Object oldself3880 = self;
  struct StackFrameObject *oldstackframe3880 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3880);
  gc_frame_newslot((Object)stackframe);
  self = obj3880;
  Object *oldselfslot3880 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3880 = (*(struct UserObject *)self).data[0], lowerouter3880 = thisouter3880;
  if (inheritingObject3880) {
    struct UserObject *inho3880 = (struct UserObject *)inheritingObject3880;
    while (inho3880->super != GraceDefaultObject) inho3880 = (struct UserObject *)inho3880->super;
    inho3880->super = obj3880;
    self = inheritingObject3880;
    *selfslot = self;
    lowerouter3880 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3880;
  }
// method "iterator"
  block_savedest(obj3880);
  Object closure3882 = createclosure(1, "iterator");
  setclosureframe(closure3882, stackframe);
  addtoclosure(closure3882, var_sourceDictionary);
  struct UserObject *uo3882 = (struct UserObject*)obj3880;
  uo3882->data[1] = (Object)closure3882;
  Method *meth_meth_collectionsPrelude_3882_iterator = addmethod2pos(obj3880, "iterator", &meth_collectionsPrelude_3882_iterator, 1);
  int argcv_meth_collectionsPrelude_3882_iterator[] = {0};
  meth_meth_collectionsPrelude_3882_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3882_iterator);
  meth_meth_collectionsPrelude_3882_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_3882_iterator->definitionLine = 1491;
  block_savedest(obj3880);
  Object closure3909 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure3909, stackframe);
  addtoclosure(closure3909, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_3882_iterator_object = addmethod2pos(obj3880, "iterator$object(1)", &meth_collectionsPrelude_3882_iterator_object, 1);
  meth_meth_collectionsPrelude_3882_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3882_iterator_object->definitionLine = 1491;
  if (objclass3880 == NULL) {
  Method *reader3910 = addmethodrealflags(obj3880, "size",&reader_collectionsPrelude_size_3910, MFLAG_DEF);
  reader3910->definitionModule = modulename;
  reader3910->definitionLine = 1500;
  }
  adddatum2(obj3880, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3880);
  Object closure3911 = createclosure(1, "asDebugString");
  setclosureframe(closure3911, stackframe);
  addtoclosure(closure3911, var_sourceDictionary);
  struct UserObject *uo3911 = (struct UserObject*)obj3880;
  uo3911->data[3] = (Object)closure3911;
  Method *meth_meth_collectionsPrelude_3911_asDebugString = addmethod2pos(obj3880, "asDebugString", &meth_collectionsPrelude_3911_asDebugString, 3);
  int argcv_meth_collectionsPrelude_3911_asDebugString[] = {0};
  meth_meth_collectionsPrelude_3911_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3911_asDebugString);
  meth_meth_collectionsPrelude_3911_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3911_asDebugString->definitionLine = 1501;
  sourceObject = obj3880;
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3920 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3921 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3920);
// compiled call node returning call3921 (depth = 2)
  struct UserObject *obj3880_uo = (struct UserObject *)obj3880;
  obj3880_uo->super = call3921;
  sourceObject = obj3880;
  sourceObject = obj3880;
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3922 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3923 = callmethodflags(*var_sourceDictionary, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3922);
// compiled member node returning call3923 (depth = 2)
  adddatum2(obj3880, call3923, 2);
  sourceObject = obj3880;
  objclass3880 = obj3880->class;
  objclass3880->definitionModule = modulename;
  objclass3880->definitionLine = 1489;
  (*(struct UserObject *)self).data[0] = lowerouter3880;
  self = oldself3880;
  selfslot = oldselfslot3880;
  stackframe = oldstackframe3880;
  gc_frame_end(frame);
  return obj3880;
}
Object meth_collectionsPrelude_3879_values_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3880 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3880 = alloc_userobj2(4,5, objclass3880);
  gc_frame_newslot(obj3880);
  if (objclass3880 == NULL) {
    glfree(obj3880->class->name);
    obj3880->class->name = "dictionary.empty.values";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3880, self, 0);
  addmethodreal(obj3880,"outer", &reader_collectionsPrelude_outer_3881);
  Object oldself3880 = self;
  struct StackFrameObject *oldstackframe3880 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3880);
  gc_frame_newslot((Object)stackframe);
  self = obj3880;
  Object *oldselfslot3880 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3880 = (*(struct UserObject *)self).data[0], lowerouter3880 = thisouter3880;
  if (inheritingObject3880) {
    struct UserObject *inho3880 = (struct UserObject *)inheritingObject3880;
    while (inho3880->super != GraceDefaultObject) inho3880 = (struct UserObject *)inho3880->super;
    inho3880->super = obj3880;
    self = inheritingObject3880;
    *selfslot = self;
    lowerouter3880 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3880;
  }
// method "iterator"
  block_savedest(obj3880);
  Object closure3882 = createclosure(1, "iterator");
  setclosureframe(closure3882, stackframe);
  addtoclosure(closure3882, var_sourceDictionary);
  struct UserObject *uo3882 = (struct UserObject*)obj3880;
  uo3882->data[1] = (Object)closure3882;
  Method *meth_meth_collectionsPrelude_3882_iterator = addmethod2pos(obj3880, "iterator", &meth_collectionsPrelude_3882_iterator, 1);
  int argcv_meth_collectionsPrelude_3882_iterator[] = {0};
  meth_meth_collectionsPrelude_3882_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3882_iterator);
  meth_meth_collectionsPrelude_3882_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_3882_iterator->definitionLine = 1491;
  block_savedest(obj3880);
  Object closure3909 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure3909, stackframe);
  addtoclosure(closure3909, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_3882_iterator_object = addmethod2pos(obj3880, "iterator$object(1)", &meth_collectionsPrelude_3882_iterator_object, 1);
  meth_meth_collectionsPrelude_3882_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3882_iterator_object->definitionLine = 1491;
  if (objclass3880 == NULL) {
  Method *reader3910 = addmethodrealflags(obj3880, "size",&reader_collectionsPrelude_size_3910, MFLAG_DEF);
  reader3910->definitionModule = modulename;
  reader3910->definitionLine = 1500;
  }
  adddatum2(obj3880, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3880);
  Object closure3911 = createclosure(1, "asDebugString");
  setclosureframe(closure3911, stackframe);
  addtoclosure(closure3911, var_sourceDictionary);
  struct UserObject *uo3911 = (struct UserObject*)obj3880;
  uo3911->data[3] = (Object)closure3911;
  Method *meth_meth_collectionsPrelude_3911_asDebugString = addmethod2pos(obj3880, "asDebugString", &meth_collectionsPrelude_3911_asDebugString, 3);
  int argcv_meth_collectionsPrelude_3911_asDebugString[] = {0};
  meth_meth_collectionsPrelude_3911_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3911_asDebugString);
  meth_meth_collectionsPrelude_3911_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3911_asDebugString->definitionLine = 1501;
  sourceObject = obj3880;
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3920 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3921 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3920);
// compiled call node returning call3921 (depth = 2)
  struct UserObject *obj3880_uo = (struct UserObject *)obj3880;
  obj3880_uo->super = call3921;
  sourceObject = obj3880;
  sourceObject = obj3880;
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3922 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3923 = callmethodflags(*var_sourceDictionary, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3922);
// compiled member node returning call3923 (depth = 2)
  adddatum2(obj3880, call3923, 2);
  sourceObject = obj3880;
  objclass3880 = obj3880->class;
  objclass3880->definitionModule = modulename;
  objclass3880->definitionLine = 1489;
  (*(struct UserObject *)self).data[0] = lowerouter3880;
  self = oldself3880;
  selfslot = oldselfslot3880;
  stackframe = oldstackframe3880;
  gc_frame_end(frame);
  return obj3880;
}
Object meth_collectionsPrelude_3928_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3929 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3930 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 1, partcv, params, 0);
  gc_frame_end(callframe3929);
// compiled member node returning call3930 (depth = 2)
  gc_frame_end(frame);
  return call3930;
}
Object meth_collectionsPrelude_3932_asDebugString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3934 == NULL) {
    strlit3934 = alloc_String("");
    gc_root(strlit3934);
  }
// compiled string node returning strlit3934 (depth = 3)
  int op_slot_right_3933 = gc_frame_newslot(strlit3934);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3936 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3938 == NULL) {
    strlit3938 = alloc_String("a lazy sequence over bindings of ");
    gc_root(strlit3938);
  }
// compiled string node returning strlit3938 (depth = 4)
  int op_slot_left_3936 = gc_frame_newslot(strlit3938);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3939 = callmethod(strlit3938, "++(1)", 1, partcv, params);
// compiled op node returning opresult3939 (depth = 3)
  int op_slot_left_3933 = gc_frame_newslot(opresult3939);
  params[0] = strlit3934;
  partcv[0] = 1;
  Object opresult3940 = callmethod(opresult3939, "++(1)", 1, partcv, params);
// compiled op node returning opresult3940 (depth = 2)
  gc_frame_end(frame);
  return opresult3940;
}
Object meth_collectionsPrelude_3925_bindings(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "bindings");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3926 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3926 = alloc_userobj2(3,4, objclass3926);
  gc_frame_newslot(obj3926);
  if (objclass3926 == NULL) {
    glfree(obj3926->class->name);
    obj3926->class->name = "dictionary.empty.bindings";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3926, self, 0);
  addmethodreal(obj3926,"outer", &reader_collectionsPrelude_outer_3927);
  Object oldself3926 = self;
  struct StackFrameObject *oldstackframe3926 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3926);
  gc_frame_newslot((Object)stackframe);
  self = obj3926;
  Object *oldselfslot3926 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3926 = (*(struct UserObject *)self).data[0], lowerouter3926 = thisouter3926;
  if (inheritingObject3926) {
    struct UserObject *inho3926 = (struct UserObject *)inheritingObject3926;
    while (inho3926->super != GraceDefaultObject) inho3926 = (struct UserObject *)inho3926->super;
    inho3926->super = obj3926;
    self = inheritingObject3926;
    *selfslot = self;
    lowerouter3926 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3926;
  }
// method "iterator"
  block_savedest(obj3926);
  Object closure3928 = createclosure(1, "iterator");
  setclosureframe(closure3928, stackframe);
  addtoclosure(closure3928, var_sourceDictionary);
  struct UserObject *uo3928 = (struct UserObject*)obj3926;
  uo3928->data[1] = (Object)closure3928;
  Method *meth_meth_collectionsPrelude_3928_iterator = addmethod2pos(obj3926, "iterator", &meth_collectionsPrelude_3928_iterator, 1);
  int argcv_meth_collectionsPrelude_3928_iterator[] = {0};
  meth_meth_collectionsPrelude_3928_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3928_iterator);
  meth_meth_collectionsPrelude_3928_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_3928_iterator->definitionLine = 1510;
  if (objclass3926 == NULL) {
  Method *reader3931 = addmethodrealflags(obj3926, "size",&reader_collectionsPrelude_size_3931, MFLAG_DEF);
  reader3931->definitionModule = modulename;
  reader3931->definitionLine = 1512;
  }
  adddatum2(obj3926, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3926);
  Object closure3932 = createclosure(1, "asDebugString");
  setclosureframe(closure3932, stackframe);
  addtoclosure(closure3932, var_sourceDictionary);
  struct UserObject *uo3932 = (struct UserObject*)obj3926;
  uo3932->data[3] = (Object)closure3932;
  Method *meth_meth_collectionsPrelude_3932_asDebugString = addmethod2pos(obj3926, "asDebugString", &meth_collectionsPrelude_3932_asDebugString, 3);
  int argcv_meth_collectionsPrelude_3932_asDebugString[] = {0};
  meth_meth_collectionsPrelude_3932_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3932_asDebugString);
  meth_meth_collectionsPrelude_3932_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3932_asDebugString->definitionLine = 1513;
  sourceObject = obj3926;
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3941 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3942 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3941);
// compiled call node returning call3942 (depth = 2)
  struct UserObject *obj3926_uo = (struct UserObject *)obj3926;
  obj3926_uo->super = call3942;
  sourceObject = obj3926;
  sourceObject = obj3926;
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3943 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3944 = callmethodflags(*var_sourceDictionary, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3943);
// compiled member node returning call3944 (depth = 2)
  adddatum2(obj3926, call3944, 2);
  sourceObject = obj3926;
  objclass3926 = obj3926->class;
  objclass3926->definitionModule = modulename;
  objclass3926->definitionLine = 1508;
  (*(struct UserObject *)self).data[0] = lowerouter3926;
  self = oldself3926;
  selfslot = oldselfslot3926;
  stackframe = oldstackframe3926;
  gc_frame_end(frame);
  return obj3926;
}
Object meth_collectionsPrelude_3925_bindings_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "bindings$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3926 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3926 = alloc_userobj2(3,4, objclass3926);
  gc_frame_newslot(obj3926);
  if (objclass3926 == NULL) {
    glfree(obj3926->class->name);
    obj3926->class->name = "dictionary.empty.bindings";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3926, self, 0);
  addmethodreal(obj3926,"outer", &reader_collectionsPrelude_outer_3927);
  Object oldself3926 = self;
  struct StackFrameObject *oldstackframe3926 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3926);
  gc_frame_newslot((Object)stackframe);
  self = obj3926;
  Object *oldselfslot3926 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3926 = (*(struct UserObject *)self).data[0], lowerouter3926 = thisouter3926;
  if (inheritingObject3926) {
    struct UserObject *inho3926 = (struct UserObject *)inheritingObject3926;
    while (inho3926->super != GraceDefaultObject) inho3926 = (struct UserObject *)inho3926->super;
    inho3926->super = obj3926;
    self = inheritingObject3926;
    *selfslot = self;
    lowerouter3926 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3926;
  }
// method "iterator"
  block_savedest(obj3926);
  Object closure3928 = createclosure(1, "iterator");
  setclosureframe(closure3928, stackframe);
  addtoclosure(closure3928, var_sourceDictionary);
  struct UserObject *uo3928 = (struct UserObject*)obj3926;
  uo3928->data[1] = (Object)closure3928;
  Method *meth_meth_collectionsPrelude_3928_iterator = addmethod2pos(obj3926, "iterator", &meth_collectionsPrelude_3928_iterator, 1);
  int argcv_meth_collectionsPrelude_3928_iterator[] = {0};
  meth_meth_collectionsPrelude_3928_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3928_iterator);
  meth_meth_collectionsPrelude_3928_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_3928_iterator->definitionLine = 1510;
  if (objclass3926 == NULL) {
  Method *reader3931 = addmethodrealflags(obj3926, "size",&reader_collectionsPrelude_size_3931, MFLAG_DEF);
  reader3931->definitionModule = modulename;
  reader3931->definitionLine = 1512;
  }
  adddatum2(obj3926, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3926);
  Object closure3932 = createclosure(1, "asDebugString");
  setclosureframe(closure3932, stackframe);
  addtoclosure(closure3932, var_sourceDictionary);
  struct UserObject *uo3932 = (struct UserObject*)obj3926;
  uo3932->data[3] = (Object)closure3932;
  Method *meth_meth_collectionsPrelude_3932_asDebugString = addmethod2pos(obj3926, "asDebugString", &meth_collectionsPrelude_3932_asDebugString, 3);
  int argcv_meth_collectionsPrelude_3932_asDebugString[] = {0};
  meth_meth_collectionsPrelude_3932_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3932_asDebugString);
  meth_meth_collectionsPrelude_3932_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3932_asDebugString->definitionLine = 1513;
  sourceObject = obj3926;
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3941 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3942 = callmethodflags(module_collectionsPrelude, "enumerable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3941);
// compiled call node returning call3942 (depth = 2)
  struct UserObject *obj3926_uo = (struct UserObject *)obj3926;
  obj3926_uo->super = call3942;
  sourceObject = obj3926;
  sourceObject = obj3926;
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3943 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  partcv[0] = 0;
  Object call3944 = callmethodflags(*var_sourceDictionary, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3943);
// compiled member node returning call3944 (depth = 2)
  adddatum2(obj3926, call3944, 2);
  sourceObject = obj3926;
  objclass3926 = obj3926->class;
  objclass3926->definitionModule = modulename;
  objclass3926->definitionLine = 1508;
  (*(struct UserObject *)self).data[0] = lowerouter3926;
  self = oldself3926;
  selfslot = oldselfslot3926;
  stackframe = oldstackframe3926;
  gc_frame_end(frame);
  return obj3926;
}
Object meth_collectionsPrelude_3946_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3947 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3948 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3949 = callmethodflags(self, "values", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3948);
// compiled member node returning call3949 (depth = 3)
  partcv[0] = 0;
  Object call3950 = callmethodflags(call3949, "iterator", 1, partcv, params, 0);
  gc_frame_end(callframe3947);
// compiled member node returning call3950 (depth = 2)
  gc_frame_end(frame);
  return call3950;
}
Object meth_collectionsPrelude_3958_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3960 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3961 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3960);
// compiled member node returning call3961 (depth = 3)
  int op_slot_right_3959 = gc_frame_newslot(call3961);
// starting to compile member node (depth = 3)
  int callframe3963 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3964 = gc_frame_new();
// call case 3: self.outer request
  Object call3965 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3964);
// compiled member node returning call3965 (depth = 4)
  partcv[0] = 0;
  Object call3966 = callmethodflags(call3965, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3963);
// compiled member node returning call3966 (depth = 3)
  int op_slot_left_3959 = gc_frame_newslot(call3966);
  params[0] = call3961;
  partcv[0] = 1;
  Object opresult3967 = callmethod(call3966, "≥(1)", 1, partcv, params);
// compiled op node returning opresult3967 (depth = 2)
  gc_frame_end(frame);
  return opresult3967;
}
Object meth_collectionsPrelude_4011__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4012 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4013 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4014 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4015 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4014);
// compiled member node returning call4015 (depth = 6)
  gc_frame_newslot(call4015);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4016 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4017 = gc_frame_new();
// call case 3: self.outer request
  Object call4018 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4017);
// compiled member node returning call4018 (depth = 7)
  partcv[0] = 0;
  Object call4019 = callmethodflags(call4018, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4016);
// compiled member node returning call4019 (depth = 6)
  params[0] = call4015;
  partcv[0] = 1;
  Object call4020 = callmethodflags(call4019, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4013);
// compiled call node returning call4020 (depth = 5)
  gc_frame_newslot(call4020);
// call case 4: self request
  params[0] = call4020;
  partcv[0] = 1;
  Object call4021 = callmethodflags(self, "elt:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4012);
// compiled call node returning call4021 (depth = 4)
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4024 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4025 = callmethodflags(self, "elt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4024);
// compiled member node returning call4025 (depth = 6)
  int op_slot_right_4023 = gc_frame_newslot(call4025);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_4023 = gc_frame_newslot(*var_removed);
  params[0] = call4025;
  partcv[0] = 1;
  Object opresult4027 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult4027 (depth = 5)
  int op_slot_right_4022 = gc_frame_newslot(opresult4027);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4030 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4031 = callmethodflags(self, "elt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4030);
// compiled member node returning call4031 (depth = 6)
  int op_slot_right_4029 = gc_frame_newslot(call4031);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_4029 = gc_frame_newslot(*var_unused);
  params[0] = call4031;
  partcv[0] = 1;
  Object opresult4033 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult4033 (depth = 5)
  int op_slot_left_4022 = gc_frame_newslot(opresult4033);
  params[0] = opresult4027;
  partcv[0] = 1;
  Object opresult4034 = callmethod(opresult4033, "||(1)", 1, partcv, params);
// compiled op node returning opresult4034 (depth = 4)
  gc_frame_end(frame);
  return opresult4034;
}
Object meth_collectionsPrelude_4037__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4038 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4040 = alloc_Float64(1);
// compiled num node returning num4040 (depth = 6)
  int op_slot_right_4039 = gc_frame_newslot(num4040);
// starting to compile member node (depth = 6)
  int callframe4042 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4043 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4042);
// compiled member node returning call4043 (depth = 6)
  int op_slot_left_4039 = gc_frame_newslot(call4043);
  params[0] = num4040;
  partcv[0] = 1;
  Object sum4044 = callmethod(call4043, "+(1)", 1, partcv, params);
// compiled op node returning sum4044 (depth = 5)
  gc_frame_newslot(sum4044);
// call case 4: self request
  params[0] = sum4044;
  partcv[0] = 1;
  Object call4045 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4038);
// compiled call node returning call4045 (depth = 4)
  gc_frame_end(frame);
  return call4045;
}
Object meth_collectionsPrelude_3968_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3971 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3972 = gc_frame_new();
// call case 3: self.outer request
  Object call3973 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3972);
// compiled member node returning call3973 (depth = 5)
  partcv[0] = 0;
  Object call3974 = callmethodflags(call3973, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3971);
// compiled member node returning call3974 (depth = 4)
  int op_slot_right_3970 = gc_frame_newslot(call3974);
// starting to compile member node (depth = 4)
  int callframe3976 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3977 = callmethodflags(self, "iMods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3976);
// compiled member node returning call3977 (depth = 4)
  int op_slot_left_3970 = gc_frame_newslot(call3977);
  params[0] = call3974;
  partcv[0] = 1;
  Object opresult3978 = callmethod(call3977, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3978 (depth = 3)
  Object if3969 = done;
  if (istrue(opresult3978)) {
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3979 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3980 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3981 = gc_frame_new();
// call case 3: self.outer request
  Object call3982 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3981);
// compiled member node returning call3982 (depth = 5)
  partcv[0] = 0;
  Object call3983 = callmethodflags(call3982, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3980);
// compiled member node returning call3983 (depth = 4)
  gc_frame_newslot(call3983);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call3983;
  partcv[0] = 1;
  Object call3984 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3979);
// compiled call node returning call3984 (depth = 3)
    gc_frame_newslot(call3984);
    if3969 = call3984;
  } else {
  }
// compiled if node returning if3969 (depth = 2)
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3987 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3988 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3987);
// compiled member node returning call3988 (depth = 4)
  int op_slot_right_3986 = gc_frame_newslot(call3988);
// starting to compile member node (depth = 4)
  int callframe3990 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3991 = gc_frame_new();
// call case 3: self.outer request
  Object call3992 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3991);
// compiled member node returning call3992 (depth = 5)
  partcv[0] = 0;
  Object call3993 = callmethodflags(call3992, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3990);
// compiled member node returning call3993 (depth = 4)
  int op_slot_left_3986 = gc_frame_newslot(call3993);
  params[0] = call3988;
  partcv[0] = 1;
  Object opresult3994 = callmethod(call3993, "<(1)", 1, partcv, params);
// compiled op node returning opresult3994 (depth = 3)
  Object if3985 = done;
  if (istrue(opresult3994)) {
// starting to compile call node (depth = 3)
  int callframe3995 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3997 == NULL) {
    strlit3997 = alloc_String("");
    gc_root(strlit3997);
  }
// compiled string node returning strlit3997 (depth = 5)
  int op_slot_right_3996 = gc_frame_newslot(strlit3997);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4000 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4001 = gc_frame_new();
// call case 3: self.outer request
  Object call4002 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4001);
// compiled member node returning call4002 (depth = 7)
  partcv[0] = 0;
  Object call4003 = callmethodflags(call4002, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4000);
// compiled member node returning call4003 (depth = 6)
  int op_slot_right_3999 = gc_frame_newslot(call4003);
// starting to compile string node (depth = 6)
  if (strlit4005 == NULL) {
    strlit4005 = alloc_String("over ");
    gc_root(strlit4005);
  }
// compiled string node returning strlit4005 (depth = 6)
  int op_slot_left_3999 = gc_frame_newslot(strlit4005);
  params[0] = call4003;
  partcv[0] = 1;
  Object opresult4006 = callmethod(strlit4005, "++(1)", 1, partcv, params);
// compiled op node returning opresult4006 (depth = 5)
  int op_slot_left_3996 = gc_frame_newslot(opresult4006);
  params[0] = strlit3997;
  partcv[0] = 1;
  Object opresult4007 = callmethod(opresult4006, "++(1)", 1, partcv, params);
// compiled op node returning opresult4007 (depth = 4)
  gc_frame_newslot(opresult4007);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4007;
  partcv[0] = 1;
  Object call4008 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3995);
// compiled call node returning call4008 (depth = 3)
    gc_frame_newslot(call4008);
    if3985 = call4008;
  } else {
  }
// compiled if node returning if3985 (depth = 2)
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4009 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4010 = alloc_Block(NULL, NULL, "collectionsPrelude", 1531);
  gc_frame_newslot(block4010);
// method "_apply"
  block_savedest(block4010);
  Object closure4011 = createclosure(3, "_apply");
  setclosureframe(closure4011, stackframe);
  addtoclosure(closure4011, var_removed);
  addtoclosure(closure4011, var_unused);
  addtoclosure(closure4011, selfslot);
  struct UserObject *uo4011 = (struct UserObject*)block4010;
  uo4011->data[0] = (Object)closure4011;
  Method *meth_meth_collectionsPrelude_4011__apply = addmethod2pos(block4010, "_apply", &meth_collectionsPrelude_4011__apply, 0);
  int argcv_meth_collectionsPrelude_4011__apply[] = {0};
  meth_meth_collectionsPrelude_4011__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4011__apply);
  meth_meth_collectionsPrelude_4011__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_4011__apply->definitionLine = 1769;
// compiled block node returning block4010 (depth = 3)
  gc_frame_newslot(block4010);
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4036 = alloc_Block(NULL, NULL, "collectionsPrelude", 1534);
  gc_frame_newslot(block4036);
// method "_apply"
  block_savedest(block4036);
  Object closure4037 = createclosure(1, "_apply");
  setclosureframe(closure4037, stackframe);
  addtoclosure(closure4037, selfslot);
  struct UserObject *uo4037 = (struct UserObject*)block4036;
  uo4037->data[0] = (Object)closure4037;
  Method *meth_meth_collectionsPrelude_4037__apply = addmethod2pos(block4036, "_apply", &meth_collectionsPrelude_4037__apply, 0);
  int argcv_meth_collectionsPrelude_4037__apply[] = {0};
  meth_meth_collectionsPrelude_4037__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4037__apply);
  meth_meth_collectionsPrelude_4037__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_4037__apply->definitionLine = 1769;
// compiled block node returning block4036 (depth = 3)
  gc_frame_newslot(block4036);
// call case 5: prelude request
  params[0] = block4010;
  params[1] = block4036;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4047 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4009);
// compiled call node returning call4047 (depth = 2)
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4048 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4050 = alloc_Float64(1);
// compiled num node returning num4050 (depth = 4)
  int op_slot_right_4049 = gc_frame_newslot(num4050);
// starting to compile member node (depth = 4)
  int callframe4052 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4053 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4052);
// compiled member node returning call4053 (depth = 4)
  int op_slot_left_4049 = gc_frame_newslot(call4053);
  params[0] = num4050;
  partcv[0] = 1;
  Object sum4054 = callmethod(call4053, "+(1)", 1, partcv, params);
// compiled op node returning sum4054 (depth = 3)
  gc_frame_newslot(sum4054);
// call case 4: self request
  params[0] = sum4054;
  partcv[0] = 1;
  Object call4055 = callmethodflags(self, "count:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4048);
// compiled call node returning call4055 (depth = 2)
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4056 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4058 = alloc_Float64(1);
// compiled num node returning num4058 (depth = 4)
  int op_slot_right_4057 = gc_frame_newslot(num4058);
// starting to compile member node (depth = 4)
  int callframe4060 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4061 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4060);
// compiled member node returning call4061 (depth = 4)
  int op_slot_left_4057 = gc_frame_newslot(call4061);
  params[0] = num4058;
  partcv[0] = 1;
  Object sum4062 = callmethod(call4061, "+(1)", 1, partcv, params);
// compiled op node returning sum4062 (depth = 3)
  gc_frame_newslot(sum4062);
// call case 4: self request
  params[0] = sum4062;
  partcv[0] = 1;
  Object call4063 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4056);
// compiled call node returning call4063 (depth = 2)
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4064 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4065 = callmethodflags(self, "elt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4064);
// compiled member node returning call4065 (depth = 2)
  gc_frame_end(frame);
  return call4065;
}
Object meth_collectionsPrelude_3951_bindingsIterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindingsIterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3952 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3952 = alloc_userobj2(9,7, objclass3952);
  gc_frame_newslot(obj3952);
  if (objclass3952 == NULL) {
    glfree(obj3952->class->name);
    obj3952->class->name = "dictionary.empty.bindingsIterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3952, self, 0);
  addmethodreal(obj3952,"outer", &reader_collectionsPrelude_outer_3953);
  Object oldself3952 = self;
  struct StackFrameObject *oldstackframe3952 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3952);
  gc_frame_newslot((Object)stackframe);
  self = obj3952;
  Object *oldselfslot3952 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3952 = (*(struct UserObject *)self).data[0], lowerouter3952 = thisouter3952;
  if (inheritingObject3952) {
    struct UserObject *inho3952 = (struct UserObject *)inheritingObject3952;
    while (inho3952->super != GraceDefaultObject) inho3952 = (struct UserObject *)inho3952->super;
    inho3952->super = obj3952;
    self = inheritingObject3952;
    *selfslot = self;
    lowerouter3952 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3952;
  }
  if (objclass3952 == NULL) {
  Method *reader3954 = addmethodrealflags(obj3952, "iMods",&reader_collectionsPrelude_iMods_3954, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3954->definitionModule = modulename;
  reader3954->definitionLine = 1521;
  }
  adddatum2(obj3952, alloc_Undefined(), 1);
  if (objclass3952 == NULL) {
    Method *reader3955 = addmethodrealflags(obj3952, "count", &reader_collectionsPrelude_count_3955, MFLAG_CONFIDENTIAL);
    Method *writer3955 = addmethodrealflags(obj3952, "count:=(1)", &writer_collectionsPrelude_count_3955, MFLAG_CONFIDENTIAL);
    reader3955->definitionModule = modulename;
    writer3955->definitionModule = modulename;
    reader3955->definitionLine = 1522;
    writer3955->definitionLine = 1522;
  }
  obj3952->flags |= OFLAG_MUTABLE;
  adddatum2(obj3952, alloc_Undefined(), 2);
  if (objclass3952 == NULL) {
    Method *reader3956 = addmethodrealflags(obj3952, "idx", &reader_collectionsPrelude_idx_3956, MFLAG_CONFIDENTIAL);
    Method *writer3956 = addmethodrealflags(obj3952, "idx:=(1)", &writer_collectionsPrelude_idx_3956, MFLAG_CONFIDENTIAL);
    reader3956->definitionModule = modulename;
    writer3956->definitionModule = modulename;
    reader3956->definitionLine = 1523;
    writer3956->definitionLine = 1523;
  }
  obj3952->flags |= OFLAG_MUTABLE;
  adddatum2(obj3952, alloc_Undefined(), 3);
  if (objclass3952 == NULL) {
    Method *reader3957 = addmethodrealflags(obj3952, "elt", &reader_collectionsPrelude_elt_3957, MFLAG_CONFIDENTIAL);
    Method *writer3957 = addmethodrealflags(obj3952, "elt:=(1)", &writer_collectionsPrelude_elt_3957, MFLAG_CONFIDENTIAL);
    reader3957->definitionModule = modulename;
    writer3957->definitionModule = modulename;
    reader3957->definitionLine = 1524;
    writer3957->definitionLine = 1524;
  }
  obj3952->flags |= OFLAG_MUTABLE;
  adddatum2(obj3952, alloc_Undefined(), 4);
// method "hasNext"
  struct UserObject *uo3958 = (struct UserObject*)obj3952;
  uo3958->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3958_hasNext = addmethod2pos(obj3952, "hasNext", &meth_collectionsPrelude_3958_hasNext, 5);
  int argcv_meth_collectionsPrelude_3958_hasNext[] = {0};
  meth_meth_collectionsPrelude_3958_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3958_hasNext);
  meth_meth_collectionsPrelude_3958_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_3958_hasNext->definitionLine = 1525;
// method "next"
  block_savedest(obj3952);
  Object closure3968 = createclosure(4, "next");
  setclosureframe(closure3968, stackframe);
  addtoclosure(closure3968, var_ConcurrentModification);
  addtoclosure(closure3968, var_IteratorExhausted);
  addtoclosure(closure3968, var_removed);
  addtoclosure(closure3968, var_unused);
  struct UserObject *uo3968 = (struct UserObject*)obj3952;
  uo3968->data[6] = (Object)closure3968;
  Method *meth_meth_collectionsPrelude_3968_next = addmethod2pos(obj3952, "next", &meth_collectionsPrelude_3968_next, 6);
  int argcv_meth_collectionsPrelude_3968_next[] = {0};
  meth_meth_collectionsPrelude_3968_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3968_next);
  meth_meth_collectionsPrelude_3968_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_3968_next->definitionLine = 1526;
  sourceObject = obj3952;
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4066 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4067 = gc_frame_new();
// call case 3: self.outer request
  Object call4068 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4067);
// compiled member node returning call4068 (depth = 3)
  partcv[0] = 0;
  Object call4069 = callmethodflags(call4068, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4066);
// compiled member node returning call4069 (depth = 2)
  adddatum2(obj3952, call4069, 1);
  sourceObject = obj3952;
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4070 = alloc_Float64(1);
// compiled num node returning num4070 (depth = 2)
  adddatum2(obj3952, num4070, 2);
  sourceObject = obj3952;
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4071 = alloc_Float64(0);
// compiled num node returning num4071 (depth = 2)
  adddatum2(obj3952, num4071, 3);
  sourceObject = obj3952;
  adddatum2(obj3952, undefined, 4);
  sourceObject = obj3952;
  sourceObject = obj3952;
  objclass3952 = obj3952->class;
  objclass3952->definitionModule = modulename;
  objclass3952->definitionLine = 1519;
  (*(struct UserObject *)self).data[0] = lowerouter3952;
  self = oldself3952;
  selfslot = oldselfslot3952;
  stackframe = oldstackframe3952;
  gc_frame_end(frame);
  return obj3952;
}
Object meth_collectionsPrelude_3951_bindingsIterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindingsIterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3952 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3952 = alloc_userobj2(9,7, objclass3952);
  gc_frame_newslot(obj3952);
  if (objclass3952 == NULL) {
    glfree(obj3952->class->name);
    obj3952->class->name = "dictionary.empty.bindingsIterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj3952, self, 0);
  addmethodreal(obj3952,"outer", &reader_collectionsPrelude_outer_3953);
  Object oldself3952 = self;
  struct StackFrameObject *oldstackframe3952 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3952);
  gc_frame_newslot((Object)stackframe);
  self = obj3952;
  Object *oldselfslot3952 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3952 = (*(struct UserObject *)self).data[0], lowerouter3952 = thisouter3952;
  if (inheritingObject3952) {
    struct UserObject *inho3952 = (struct UserObject *)inheritingObject3952;
    while (inho3952->super != GraceDefaultObject) inho3952 = (struct UserObject *)inho3952->super;
    inho3952->super = obj3952;
    self = inheritingObject3952;
    *selfslot = self;
    lowerouter3952 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3952;
  }
  if (objclass3952 == NULL) {
  Method *reader3954 = addmethodrealflags(obj3952, "iMods",&reader_collectionsPrelude_iMods_3954, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3954->definitionModule = modulename;
  reader3954->definitionLine = 1521;
  }
  adddatum2(obj3952, alloc_Undefined(), 1);
  if (objclass3952 == NULL) {
    Method *reader3955 = addmethodrealflags(obj3952, "count", &reader_collectionsPrelude_count_3955, MFLAG_CONFIDENTIAL);
    Method *writer3955 = addmethodrealflags(obj3952, "count:=(1)", &writer_collectionsPrelude_count_3955, MFLAG_CONFIDENTIAL);
    reader3955->definitionModule = modulename;
    writer3955->definitionModule = modulename;
    reader3955->definitionLine = 1522;
    writer3955->definitionLine = 1522;
  }
  obj3952->flags |= OFLAG_MUTABLE;
  adddatum2(obj3952, alloc_Undefined(), 2);
  if (objclass3952 == NULL) {
    Method *reader3956 = addmethodrealflags(obj3952, "idx", &reader_collectionsPrelude_idx_3956, MFLAG_CONFIDENTIAL);
    Method *writer3956 = addmethodrealflags(obj3952, "idx:=(1)", &writer_collectionsPrelude_idx_3956, MFLAG_CONFIDENTIAL);
    reader3956->definitionModule = modulename;
    writer3956->definitionModule = modulename;
    reader3956->definitionLine = 1523;
    writer3956->definitionLine = 1523;
  }
  obj3952->flags |= OFLAG_MUTABLE;
  adddatum2(obj3952, alloc_Undefined(), 3);
  if (objclass3952 == NULL) {
    Method *reader3957 = addmethodrealflags(obj3952, "elt", &reader_collectionsPrelude_elt_3957, MFLAG_CONFIDENTIAL);
    Method *writer3957 = addmethodrealflags(obj3952, "elt:=(1)", &writer_collectionsPrelude_elt_3957, MFLAG_CONFIDENTIAL);
    reader3957->definitionModule = modulename;
    writer3957->definitionModule = modulename;
    reader3957->definitionLine = 1524;
    writer3957->definitionLine = 1524;
  }
  obj3952->flags |= OFLAG_MUTABLE;
  adddatum2(obj3952, alloc_Undefined(), 4);
// method "hasNext"
  struct UserObject *uo3958 = (struct UserObject*)obj3952;
  uo3958->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3958_hasNext = addmethod2pos(obj3952, "hasNext", &meth_collectionsPrelude_3958_hasNext, 5);
  int argcv_meth_collectionsPrelude_3958_hasNext[] = {0};
  meth_meth_collectionsPrelude_3958_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3958_hasNext);
  meth_meth_collectionsPrelude_3958_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_3958_hasNext->definitionLine = 1525;
// method "next"
  block_savedest(obj3952);
  Object closure3968 = createclosure(4, "next");
  setclosureframe(closure3968, stackframe);
  addtoclosure(closure3968, var_ConcurrentModification);
  addtoclosure(closure3968, var_IteratorExhausted);
  addtoclosure(closure3968, var_removed);
  addtoclosure(closure3968, var_unused);
  struct UserObject *uo3968 = (struct UserObject*)obj3952;
  uo3968->data[6] = (Object)closure3968;
  Method *meth_meth_collectionsPrelude_3968_next = addmethod2pos(obj3952, "next", &meth_collectionsPrelude_3968_next, 6);
  int argcv_meth_collectionsPrelude_3968_next[] = {0};
  meth_meth_collectionsPrelude_3968_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3968_next);
  meth_meth_collectionsPrelude_3968_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_3968_next->definitionLine = 1526;
  sourceObject = obj3952;
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4066 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4067 = gc_frame_new();
// call case 3: self.outer request
  Object call4068 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4067);
// compiled member node returning call4068 (depth = 3)
  partcv[0] = 0;
  Object call4069 = callmethodflags(call4068, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4066);
// compiled member node returning call4069 (depth = 2)
  adddatum2(obj3952, call4069, 1);
  sourceObject = obj3952;
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4070 = alloc_Float64(1);
// compiled num node returning num4070 (depth = 2)
  adddatum2(obj3952, num4070, 2);
  sourceObject = obj3952;
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4071 = alloc_Float64(0);
// compiled num node returning num4071 (depth = 2)
  adddatum2(obj3952, num4071, 3);
  sourceObject = obj3952;
  adddatum2(obj3952, undefined, 4);
  sourceObject = obj3952;
  sourceObject = obj3952;
  objclass3952 = obj3952->class;
  objclass3952->definitionModule = modulename;
  objclass3952->definitionLine = 1519;
  (*(struct UserObject *)self).data[0] = lowerouter3952;
  self = oldself3952;
  selfslot = oldselfslot3952;
  stackframe = oldstackframe3952;
  gc_frame_end(frame);
  return obj3952;
}
Object meth_collectionsPrelude_4100__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4101 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4102 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4103 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4102);
// compiled member node returning call4103 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4104 = callmethodflags(call4103, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4101);
// compiled call node returning call4104 (depth = 4)
  gc_frame_end(frame);
  return call4104;
}
Object meth_collectionsPrelude_4120__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// definebindings:
// definebindings:
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4121 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldInner (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4122 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4121);
// compiled call node returning call4122 (depth = 5)
  *var_a = call4122;
  if (call4122 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4125 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4125 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4127 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4127 (depth = 6)
  int op_slot_right_4124 = gc_frame_newslot(opresult4127);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4129 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4129 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4131 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4131 (depth = 6)
  int op_slot_left_4124 = gc_frame_newslot(opresult4131);
  params[0] = opresult4127;
  partcv[0] = 1;
  Object opresult4132 = callmethod(opresult4131, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4132 (depth = 5)
  Object if4123 = done;
  if (istrue(opresult4132)) {
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4133 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4134 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call4135 = callmethodflags(*var_a, "key", 1, partcv, params, 0);
  gc_frame_end(callframe4134);
// compiled member node returning call4135 (depth = 6)
  gc_frame_newslot(call4135);
// starting to compile member node (depth = 6)
  int callframe4136 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call4137 = callmethodflags(*var_a, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4136);
// compiled member node returning call4137 (depth = 6)
  gc_frame_newslot(call4137);
// call case 4: self request
  params[0] = call4135;
  params[1] = call4137;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4138 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4133);
// compiled call node returning call4138 (depth = 5)
    gc_frame_newslot(call4138);
    if4123 = call4138;
  } else {
  }
// compiled if node returning if4123 (depth = 4)
  gc_frame_end(frame);
  return if4123;
}
Object meth_collectionsPrelude_4073_expand(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4074 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4075 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4076 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4075);
// compiled member node returning call4076 (depth = 4)
  partcv[0] = 0;
  Object call4077 = callmethodflags(call4076, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4074);
// compiled member node returning call4077 (depth = 3)
  *var_c = call4077;
  if (call4077 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4079 = alloc_Float64(2);
// compiled num node returning num4079 (depth = 4)
  int op_slot_right_4078 = gc_frame_newslot(num4079);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_4078 = gc_frame_newslot(*var_c);
  params[0] = num4079;
  partcv[0] = 1;
  Object prod4081 = callmethod(*var_c, "*(1)", 1, partcv, params);
// compiled op node returning prod4081 (depth = 3)
  *var_n = prod4081;
  if (prod4081 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4082 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4083 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4082);
// compiled member node returning call4083 (depth = 3)
  *var_oldInner = call4083;
  if (call4083 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4084 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4085 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4086 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4087 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4086);
// compiled member node returning call4087 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4088 = callmethodflags(call4087, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4085);
// compiled call node returning call4088 (depth = 3)
  gc_frame_newslot(call4088);
// call case 4: self request
  params[0] = call4088;
  partcv[0] = 1;
  Object call4089 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4084);
// compiled call node returning call4089 (depth = 2)
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4090 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4093 = alloc_Float64(1);
// compiled num node returning num4093 (depth = 5)
  int op_slot_right_4092 = gc_frame_newslot(num4093);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_4092 = gc_frame_newslot(*var_n);
  params[0] = num4093;
  partcv[0] = 1;
  Object diff4095 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff4095 (depth = 4)
  int op_slot_right_4091 = gc_frame_newslot(diff4095);
// starting to compile num node (depth = 4)
  Object num4097 = alloc_Float64(0);
// compiled num node returning num4097 (depth = 4)
  int op_slot_left_4091 = gc_frame_newslot(num4097);
  params[0] = diff4095;
  partcv[0] = 1;
  Object opresult4098 = callmethod(num4097, "..(1)", 1, partcv, params);
// compiled op node returning opresult4098 (depth = 3)
  gc_frame_newslot(opresult4098);
// starting to compile block node (depth = 3)
  Object block4099 = alloc_Block(NULL, NULL, "collectionsPrelude", 1547);
  gc_frame_newslot(block4099);
// method "_apply(_)"
  block_savedest(block4099);
  Object closure4100 = createclosure(2, "_apply(1)");
  setclosureframe(closure4100, stackframe);
  addtoclosure(closure4100, var_unused);
  addtoclosure(closure4100, selfslot);
  struct UserObject *uo4100 = (struct UserObject*)block4099;
  uo4100->data[0] = (Object)closure4100;
  Method *meth_meth_collectionsPrelude_4100__apply_40_1_41_ = addmethod2pos(block4099, "_apply(1)", &meth_collectionsPrelude_4100__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4100__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4100__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4100__apply_40_1_41_);
  meth_meth_collectionsPrelude_4100__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4100__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block4099 (depth = 3)
  gc_frame_newslot(block4099);
// call case 5: prelude request
  params[0] = opresult4098;
  params[1] = block4099;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4106 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4090);
// compiled call node returning call4106 (depth = 2)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4107 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4108 = alloc_Float64(0);
// compiled num node returning num4108 (depth = 3)
  gc_frame_newslot(num4108);
// call case 4: self request
  params[0] = num4108;
  partcv[0] = 1;
  Object call4109 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4107);
// compiled call node returning call4109 (depth = 2)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4110 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4113 = alloc_Float64(1);
// compiled num node returning num4113 (depth = 5)
  int op_slot_right_4112 = gc_frame_newslot(num4113);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_4112 = gc_frame_newslot(*var_c);
  params[0] = num4113;
  partcv[0] = 1;
  Object diff4115 = callmethod(*var_c, "-(1)", 1, partcv, params);
// compiled op node returning diff4115 (depth = 4)
  int op_slot_right_4111 = gc_frame_newslot(diff4115);
// starting to compile num node (depth = 4)
  Object num4117 = alloc_Float64(0);
// compiled num node returning num4117 (depth = 4)
  int op_slot_left_4111 = gc_frame_newslot(num4117);
  params[0] = diff4115;
  partcv[0] = 1;
  Object opresult4118 = callmethod(num4117, "..(1)", 1, partcv, params);
// compiled op node returning opresult4118 (depth = 3)
  gc_frame_newslot(opresult4118);
// starting to compile block node (depth = 3)
  Object block4119 = alloc_Block(NULL, NULL, "collectionsPrelude", 1551);
  gc_frame_newslot(block4119);
// method "_apply(_)"
  block_savedest(block4119);
  Object closure4120 = createclosure(4, "_apply(1)");
  setclosureframe(closure4120, stackframe);
  addtoclosure(closure4120, var_oldInner);
  addtoclosure(closure4120, var_removed);
  addtoclosure(closure4120, var_unused);
  addtoclosure(closure4120, selfslot);
  struct UserObject *uo4120 = (struct UserObject*)block4119;
  uo4120->data[0] = (Object)closure4120;
  Method *meth_meth_collectionsPrelude_4120__apply_40_1_41_ = addmethod2pos(block4119, "_apply(1)", &meth_collectionsPrelude_4120__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4120__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4120__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4120__apply_40_1_41_);
  meth_meth_collectionsPrelude_4120__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4120__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block4119 (depth = 3)
  gc_frame_newslot(block4119);
// call case 5: prelude request
  params[0] = opresult4118;
  params[1] = block4119;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4140 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4110);
// compiled call node returning call4140 (depth = 2)
  gc_frame_end(frame);
  return call4140;
}
Object meth_collectionsPrelude_4156__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// definebindings:
// definebindings:
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4157 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4158 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4159 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4158);
// compiled member node returning call4159 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4160 = callmethodflags(call4159, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4157);
// compiled call node returning call4160 (depth = 5)
  *var_a = call4160;
  if (call4160 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4163 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4163 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4165 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4165 (depth = 6)
  int op_slot_right_4162 = gc_frame_newslot(opresult4165);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4167 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4167 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4169 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4169 (depth = 6)
  int op_slot_left_4162 = gc_frame_newslot(opresult4169);
  params[0] = opresult4165;
  partcv[0] = 1;
  Object opresult4170 = callmethod(opresult4169, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4170 (depth = 5)
  Object if4161 = done;
  if (istrue(opresult4170)) {
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4171 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4172 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call4173 = callmethodflags(*var_a, "key", 1, partcv, params, 0);
  gc_frame_end(callframe4172);
// compiled member node returning call4173 (depth = 6)
  gc_frame_newslot(call4173);
// starting to compile member node (depth = 6)
  int callframe4174 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call4175 = callmethodflags(*var_a, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4174);
// compiled member node returning call4175 (depth = 6)
  gc_frame_newslot(call4175);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block2 (depth = 6)
  params[0] = call4173;
  params[1] = call4175;
  partcv[0] = 2;
  Object call4176 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4171);
// compiled call node returning call4176 (depth = 5)
    gc_frame_newslot(call4176);
    if4161 = call4176;
  } else {
  }
// compiled if node returning if4161 (depth = 4)
  gc_frame_end(frame);
  return if4161;
}
Object meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4142 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4145 = alloc_Float64(1);
// compiled num node returning num4145 (depth = 5)
  int op_slot_right_4144 = gc_frame_newslot(num4145);
// starting to compile member node (depth = 5)
  int callframe4147 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4148 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4149 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4148);
// compiled member node returning call4149 (depth = 6)
  partcv[0] = 0;
  Object call4150 = callmethodflags(call4149, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4147);
// compiled member node returning call4150 (depth = 5)
  int op_slot_left_4144 = gc_frame_newslot(call4150);
  params[0] = num4145;
  partcv[0] = 1;
  Object diff4151 = callmethod(call4150, "-(1)", 1, partcv, params);
// compiled op node returning diff4151 (depth = 4)
  int op_slot_right_4143 = gc_frame_newslot(diff4151);
// starting to compile num node (depth = 4)
  Object num4153 = alloc_Float64(0);
// compiled num node returning num4153 (depth = 4)
  int op_slot_left_4143 = gc_frame_newslot(num4153);
  params[0] = diff4151;
  partcv[0] = 1;
  Object opresult4154 = callmethod(num4153, "..(1)", 1, partcv, params);
// compiled op node returning opresult4154 (depth = 3)
  gc_frame_newslot(opresult4154);
// starting to compile block node (depth = 3)
  Object block4155 = alloc_Block(NULL, NULL, "collectionsPrelude", 1559);
  gc_frame_newslot(block4155);
// method "_apply(_)"
  block_savedest(block4155);
  Object closure4156 = createclosure(4, "_apply(1)");
  setclosureframe(closure4156, stackframe);
  addtoclosure(closure4156, var_removed);
  addtoclosure(closure4156, var_unused);
  addtoclosure(closure4156, var_block2);
  addtoclosure(closure4156, selfslot);
  struct UserObject *uo4156 = (struct UserObject*)block4155;
  uo4156->data[0] = (Object)closure4156;
  Method *meth_meth_collectionsPrelude_4156__apply_40_1_41_ = addmethod2pos(block4155, "_apply(1)", &meth_collectionsPrelude_4156__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4156__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4156__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4156__apply_40_1_41_);
  meth_meth_collectionsPrelude_4156__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4156__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block4155 (depth = 3)
  gc_frame_newslot(block4155);
// call case 5: prelude request
  params[0] = opresult4154;
  params[1] = block4155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4178 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4142);
// compiled call node returning call4178 (depth = 2)
  gc_frame_end(frame);
  return call4178;
}
Object meth_collectionsPrelude_4196__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_iMods = getfromclosure(closure, 0);
  Object *var_ConcurrentModification = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object *var_block1 = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// definebindings:
// definebindings:
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4199 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4200 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4199);
// compiled member node returning call4200 (depth = 6)
  int op_slot_right_4198 = gc_frame_newslot(call4200);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_iMods (depth = 6)
  int op_slot_left_4198 = gc_frame_newslot(*var_iMods);
  params[0] = call4200;
  partcv[0] = 1;
  Object opresult4202 = callmethod(*var_iMods, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4202 (depth = 5)
  Object if4197 = done;
  if (istrue(opresult4202)) {
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4203 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4204 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4205 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4204);
// compiled member node returning call4205 (depth = 6)
  gc_frame_newslot(call4205);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ConcurrentModification (depth = 6)
  params[0] = call4205;
  partcv[0] = 1;
  Object call4206 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4203);
// compiled call node returning call4206 (depth = 5)
    gc_frame_newslot(call4206);
    if4197 = call4206;
  } else {
  }
// compiled if node returning if4197 (depth = 4)
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4207 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4208 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4209 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4208);
// compiled member node returning call4209 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4210 = callmethodflags(call4209, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4207);
// compiled call node returning call4210 (depth = 5)
  *var_a = call4210;
  if (call4210 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4213 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4213 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4215 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4215 (depth = 6)
  int op_slot_right_4212 = gc_frame_newslot(opresult4215);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4217 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4217 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4219 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4219 (depth = 6)
  int op_slot_left_4212 = gc_frame_newslot(opresult4219);
  params[0] = opresult4215;
  partcv[0] = 1;
  Object opresult4220 = callmethod(opresult4219, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4220 (depth = 5)
  Object if4211 = done;
  if (istrue(opresult4220)) {
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4221 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4222 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call4223 = callmethodflags(*var_a, "key", 1, partcv, params, 0);
  gc_frame_end(callframe4222);
// compiled member node returning call4223 (depth = 6)
  gc_frame_newslot(call4223);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call4223;
  partcv[0] = 1;
  Object call4224 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4221);
// compiled call node returning call4224 (depth = 5)
    gc_frame_newslot(call4224);
    if4211 = call4224;
  } else {
  }
// compiled if node returning if4211 (depth = 4)
  gc_frame_end(frame);
  return if4211;
}
Object meth_collectionsPrelude_4179_keysDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysDo(_)");
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_iMods = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "iMods");
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4180 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4181 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4180);
// compiled member node returning call4181 (depth = 3)
  *var_iMods = call4181;
  if (call4181 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4182 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4185 = alloc_Float64(1);
// compiled num node returning num4185 (depth = 5)
  int op_slot_right_4184 = gc_frame_newslot(num4185);
// starting to compile member node (depth = 5)
  int callframe4187 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4188 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4189 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4188);
// compiled member node returning call4189 (depth = 6)
  partcv[0] = 0;
  Object call4190 = callmethodflags(call4189, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4187);
// compiled member node returning call4190 (depth = 5)
  int op_slot_left_4184 = gc_frame_newslot(call4190);
  params[0] = num4185;
  partcv[0] = 1;
  Object diff4191 = callmethod(call4190, "-(1)", 1, partcv, params);
// compiled op node returning diff4191 (depth = 4)
  int op_slot_right_4183 = gc_frame_newslot(diff4191);
// starting to compile num node (depth = 4)
  Object num4193 = alloc_Float64(0);
// compiled num node returning num4193 (depth = 4)
  int op_slot_left_4183 = gc_frame_newslot(num4193);
  params[0] = diff4191;
  partcv[0] = 1;
  Object opresult4194 = callmethod(num4193, "..(1)", 1, partcv, params);
// compiled op node returning opresult4194 (depth = 3)
  gc_frame_newslot(opresult4194);
// starting to compile block node (depth = 3)
  Object block4195 = alloc_Block(NULL, NULL, "collectionsPrelude", 1568);
  gc_frame_newslot(block4195);
// method "_apply(_)"
  block_savedest(block4195);
  Object closure4196 = createclosure(6, "_apply(1)");
  setclosureframe(closure4196, stackframe);
  addtoclosure(closure4196, var_iMods);
  addtoclosure(closure4196, var_ConcurrentModification);
  addtoclosure(closure4196, var_removed);
  addtoclosure(closure4196, var_unused);
  addtoclosure(closure4196, var_block1);
  addtoclosure(closure4196, selfslot);
  struct UserObject *uo4196 = (struct UserObject*)block4195;
  uo4196->data[0] = (Object)closure4196;
  Method *meth_meth_collectionsPrelude_4196__apply_40_1_41_ = addmethod2pos(block4195, "_apply(1)", &meth_collectionsPrelude_4196__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4196__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4196__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4196__apply_40_1_41_);
  meth_meth_collectionsPrelude_4196__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4196__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block4195 (depth = 3)
  gc_frame_newslot(block4195);
// call case 5: prelude request
  params[0] = opresult4194;
  params[1] = block4195;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4226 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4182);
// compiled call node returning call4226 (depth = 2)
  gc_frame_end(frame);
  return call4226;
}
Object meth_collectionsPrelude_4244__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_iMods = getfromclosure(closure, 0);
  Object *var_ConcurrentModification = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object *var_block1 = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// definebindings:
// definebindings:
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4247 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4248 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4247);
// compiled member node returning call4248 (depth = 6)
  int op_slot_right_4246 = gc_frame_newslot(call4248);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_iMods (depth = 6)
  int op_slot_left_4246 = gc_frame_newslot(*var_iMods);
  params[0] = call4248;
  partcv[0] = 1;
  Object opresult4250 = callmethod(*var_iMods, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4250 (depth = 5)
  Object if4245 = done;
  if (istrue(opresult4250)) {
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4251 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4252 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4253 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4252);
// compiled member node returning call4253 (depth = 6)
  gc_frame_newslot(call4253);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ConcurrentModification (depth = 6)
  params[0] = call4253;
  partcv[0] = 1;
  Object call4254 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4251);
// compiled call node returning call4254 (depth = 5)
    gc_frame_newslot(call4254);
    if4245 = call4254;
  } else {
  }
// compiled if node returning if4245 (depth = 4)
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4255 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4256 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4257 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4256);
// compiled member node returning call4257 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4258 = callmethodflags(call4257, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4255);
// compiled call node returning call4258 (depth = 5)
  *var_a = call4258;
  if (call4258 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4261 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4261 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4263 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4263 (depth = 6)
  int op_slot_right_4260 = gc_frame_newslot(opresult4263);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4265 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4265 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4267 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4267 (depth = 6)
  int op_slot_left_4260 = gc_frame_newslot(opresult4267);
  params[0] = opresult4263;
  partcv[0] = 1;
  Object opresult4268 = callmethod(opresult4267, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4268 (depth = 5)
  Object if4259 = done;
  if (istrue(opresult4268)) {
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4269 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4270 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call4271 = callmethodflags(*var_a, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4270);
// compiled member node returning call4271 (depth = 6)
  gc_frame_newslot(call4271);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call4271;
  partcv[0] = 1;
  Object call4272 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4269);
// compiled call node returning call4272 (depth = 5)
    gc_frame_newslot(call4272);
    if4259 = call4272;
  } else {
  }
// compiled if node returning if4259 (depth = 4)
  gc_frame_end(frame);
  return if4259;
}
Object meth_collectionsPrelude_4227_valuesDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method valuesDo(_)");
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for valuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part valuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_iMods = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "iMods");
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4228 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4229 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4228);
// compiled member node returning call4229 (depth = 3)
  *var_iMods = call4229;
  if (call4229 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4230 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4233 = alloc_Float64(1);
// compiled num node returning num4233 (depth = 5)
  int op_slot_right_4232 = gc_frame_newslot(num4233);
// starting to compile member node (depth = 5)
  int callframe4235 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4236 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4237 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4236);
// compiled member node returning call4237 (depth = 6)
  partcv[0] = 0;
  Object call4238 = callmethodflags(call4237, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4235);
// compiled member node returning call4238 (depth = 5)
  int op_slot_left_4232 = gc_frame_newslot(call4238);
  params[0] = num4233;
  partcv[0] = 1;
  Object diff4239 = callmethod(call4238, "-(1)", 1, partcv, params);
// compiled op node returning diff4239 (depth = 4)
  int op_slot_right_4231 = gc_frame_newslot(diff4239);
// starting to compile num node (depth = 4)
  Object num4241 = alloc_Float64(0);
// compiled num node returning num4241 (depth = 4)
  int op_slot_left_4231 = gc_frame_newslot(num4241);
  params[0] = diff4239;
  partcv[0] = 1;
  Object opresult4242 = callmethod(num4241, "..(1)", 1, partcv, params);
// compiled op node returning opresult4242 (depth = 3)
  gc_frame_newslot(opresult4242);
// starting to compile block node (depth = 3)
  Object block4243 = alloc_Block(NULL, NULL, "collectionsPrelude", 1580);
  gc_frame_newslot(block4243);
// method "_apply(_)"
  block_savedest(block4243);
  Object closure4244 = createclosure(6, "_apply(1)");
  setclosureframe(closure4244, stackframe);
  addtoclosure(closure4244, var_iMods);
  addtoclosure(closure4244, var_ConcurrentModification);
  addtoclosure(closure4244, var_removed);
  addtoclosure(closure4244, var_unused);
  addtoclosure(closure4244, var_block1);
  addtoclosure(closure4244, selfslot);
  struct UserObject *uo4244 = (struct UserObject*)block4243;
  uo4244->data[0] = (Object)closure4244;
  Method *meth_meth_collectionsPrelude_4244__apply_40_1_41_ = addmethod2pos(block4243, "_apply(1)", &meth_collectionsPrelude_4244__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4244__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4244__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4244__apply_40_1_41_);
  meth_meth_collectionsPrelude_4244__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4244__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block4243 (depth = 3)
  gc_frame_newslot(block4243);
// call case 5: prelude request
  params[0] = opresult4242;
  params[1] = block4243;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4274 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4230);
// compiled call node returning call4274 (depth = 2)
  gc_frame_end(frame);
  return call4274;
}
Object meth_collectionsPrelude_4275_do_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4276 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block1 (depth = 3)
  gc_frame_newslot(*var_block1);
// call case 4: self request
  params[0] = *var_block1;
  partcv[0] = 1;
  Object call4277 = callmethodflags(self, "valuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4276);
// compiled call node returning call4277 (depth = 2)
  gc_frame_end(frame);
  return call4277;
}
Object meth_collectionsPrelude_4299__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile return node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool4300 = alloc_Boolean(0);
// compiled identifier node returning bool4300 (depth = 11)
  block_return(realself, bool4300);
// compiled return node returning undefined (depth = 10)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_4293__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_o = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  int op_slot_right_4295 = gc_frame_newslot(*var_v);
// starting to compile call node (depth = 8)
  int callframe4297 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_k (depth = 9)
  gc_frame_newslot(*var_k);
// starting to compile block node (depth = 9)
  Object block4298 = alloc_Block(NULL, NULL, "collectionsPrelude", 1597);
  gc_frame_newslot(block4298);
// method "_apply"
  block_savedest(block4298);
  Object closure4299 = createclosure(1, "_apply");
  setclosureframe(closure4299, stackframe);
  addtoclosure(closure4299, selfslot);
  struct UserObject *uo4299 = (struct UserObject*)block4298;
  uo4299->data[0] = (Object)closure4299;
  Method *meth_meth_collectionsPrelude_4299__apply = addmethod2pos(block4298, "_apply", &meth_collectionsPrelude_4299__apply, 0);
  int argcv_meth_collectionsPrelude_4299__apply[] = {0};
  meth_meth_collectionsPrelude_4299__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4299__apply);
  meth_meth_collectionsPrelude_4299__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_4299__apply->definitionLine = 1769;
// compiled block node returning block4298 (depth = 9)
  gc_frame_newslot(block4298);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  params[0] = *var_k;
  params[1] = block4298;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4302 = callmethodflags(*var_o, "at(1)ifAbsent(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4297);
// compiled call node returning call4302 (depth = 8)
  int op_slot_left_4295 = gc_frame_newslot(call4302);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult4303 = callmethod(call4302, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4303 (depth = 7)
  Object if4294 = done;
  if (istrue(opresult4303)) {
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4304 = alloc_Boolean(0);
// compiled identifier node returning bool4304 (depth = 8)
  block_return(realself, bool4304);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if4294 = undefined;
  } else {
  }
// compiled if node returning if4294 (depth = 6)
  gc_frame_end(frame);
  return if4294;
}
Object meth_collectionsPrelude_4281__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4284 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call4285 = callmethodflags(*var_o, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4284);
// compiled member node returning call4285 (depth = 6)
  int op_slot_right_4283 = gc_frame_newslot(call4285);
// starting to compile member node (depth = 6)
  int callframe4287 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4288 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4287);
// compiled member node returning call4288 (depth = 6)
  int op_slot_left_4283 = gc_frame_newslot(call4288);
  params[0] = call4285;
  partcv[0] = 1;
  Object opresult4289 = callmethod(call4288, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4289 (depth = 5)
  Object if4282 = done;
  if (istrue(opresult4289)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4290 = alloc_Boolean(0);
// compiled identifier node returning bool4290 (depth = 6)
  block_return(realself, bool4290);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4282 = undefined;
  } else {
  }
// compiled if node returning if4282 (depth = 4)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4291 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4292 = alloc_Block(NULL, NULL, "collectionsPrelude", 1596);
  gc_frame_newslot(block4292);
// method "_apply(_,_)"
  block_savedest(block4292);
  Object closure4293 = createclosure(2, "_apply(2)");
  setclosureframe(closure4293, stackframe);
  addtoclosure(closure4293, var_o);
  addtoclosure(closure4293, selfslot);
  struct UserObject *uo4293 = (struct UserObject*)block4292;
  uo4293->data[0] = (Object)closure4293;
  Method *meth_meth_collectionsPrelude_4293__apply_40_2_41_ = addmethod2pos(block4292, "_apply(2)", &meth_collectionsPrelude_4293__apply_40_2_41_, 0);
  int argcv_meth_collectionsPrelude_4293__apply_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_4293__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4293__apply_40_2_41_);
  meth_meth_collectionsPrelude_4293__apply_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4293__apply_40_2_41_->definitionLine = 1769;
// compiled block node returning block4292 (depth = 5)
  gc_frame_newslot(block4292);
// call case 4: self request
  params[0] = block4292;
  partcv[0] = 1;
  Object call4306 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4291);
// compiled call node returning call4306 (depth = 4)
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4307 = alloc_Boolean(1);
// compiled identifier node returning bool4307 (depth = 5)
  block_return(realself, bool4307);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_4319__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___5 = &(stackframe->slots[0]);
  *var___5 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4320 = alloc_Boolean(0);
// compiled identifier node returning bool4320 (depth = 5)
  block_return(realself, bool4320);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_4278__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_ComparableToDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame4279 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4280 = alloc_Block(NULL, NULL, "collectionsPrelude", 1594);
  gc_frame_newslot(block4280);
// method "_apply(_)"
  block_savedest(block4280);
  Object closure4281 = createclosure(1, "_apply(1)");
  setclosureframe(closure4281, stackframe);
  addtoclosure(closure4281, selfslot);
  struct UserObject *uo4281 = (struct UserObject*)block4280;
  uo4281->data[0] = (Object)closure4281;
  Method *meth_meth_collectionsPrelude_4281__apply_40_1_41_ = addmethod2pos(block4280, "_apply(1)", &meth_collectionsPrelude_4281__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4281__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4281__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4281__apply_40_1_41_);
  meth_meth_collectionsPrelude_4281__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4281__apply_40_1_41_->definitionLine = 1769;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4309 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4310 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4311 == NULL) {
    strlit4311 = alloc_String("o");
    gc_root(strlit4311);
  }
// compiled string node returning strlit4311 (depth = 6)
  gc_frame_newslot(strlit4311);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4312 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4313 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4312);
// compiled member node returning call4313 (depth = 6)
  params[0] = strlit4311;
  partcv[0] = 1;
  Object call4314 = callmethodflags(call4313, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4310);
// compiled call node returning call4314 (depth = 5)
  gc_frame_newslot(call4314);
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ComparableToDictionary (depth = 5)
  gc_frame_newslot(*var_ComparableToDictionary);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4315 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4316 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4315);
// compiled member node returning call4316 (depth = 5)
  params[0] = call4314;
  params[1] = *var_ComparableToDictionary;
  partcv[0] = 2;
  Object call4317 = callmethodflags(call4316, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4309);
// compiled call node returning call4317 (depth = 4)
((struct UserObject *)block4280)->data[1] = call4317;
// compiled block node returning block4280 (depth = 3)
  gc_frame_newslot(block4280);
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4318 = alloc_Block(NULL, NULL, "collectionsPrelude", 1603);
  gc_frame_newslot(block4318);
// method "_apply(_)"
  block_savedest(block4318);
  Object closure4319 = createclosure(1, "_apply(1)");
  setclosureframe(closure4319, stackframe);
  addtoclosure(closure4319, selfslot);
  struct UserObject *uo4319 = (struct UserObject*)block4318;
  uo4319->data[0] = (Object)closure4319;
  Method *meth_meth_collectionsPrelude_4319__apply_40_1_41_ = addmethod2pos(block4318, "_apply(1)", &meth_collectionsPrelude_4319__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4319__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4319__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4319__apply_40_1_41_);
  meth_meth_collectionsPrelude_4319__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4319__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block4318 (depth = 3)
  gc_frame_newslot(block4318);
  params[0] = block4280;
  params[1] = block4318;
  Object matchres4279 = matchCase(*var_other, params, 2);
  gc_frame_end(frame4279);
// compiled matchcase node returning matchres4279 (depth = 2)
  gc_frame_end(frame);
  return matchres4279;
}
Object meth_collectionsPrelude_4329__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_newCopy = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4330 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newCopy (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4331 = callmethodflags(*var_newCopy, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4330);
// compiled call node returning call4331 (depth = 4)
  gc_frame_end(frame);
  return call4331;
}
Object meth_collectionsPrelude_4322_copy(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_newCopy = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "newCopy");
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4323 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4324 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call4325 = callmethodflags(module_collectionsPrelude, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4324);
// compiled member node returning call4325 (depth = 4)
  partcv[0] = 0;
  Object call4326 = callmethodflags(call4325, "empty", 1, partcv, params, 0);
  gc_frame_end(callframe4323);
// compiled member node returning call4326 (depth = 3)
  *var_newCopy = call4326;
  if (call4326 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4327 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4328 = alloc_Block(NULL, NULL, "collectionsPrelude", 1610);
  gc_frame_newslot(block4328);
// method "_apply(_,_)"
  block_savedest(block4328);
  Object closure4329 = createclosure(2, "_apply(2)");
  setclosureframe(closure4329, stackframe);
  addtoclosure(closure4329, var_newCopy);
  addtoclosure(closure4329, selfslot);
  struct UserObject *uo4329 = (struct UserObject*)block4328;
  uo4329->data[0] = (Object)closure4329;
  Method *meth_meth_collectionsPrelude_4329__apply_40_2_41_ = addmethod2pos(block4328, "_apply(2)", &meth_collectionsPrelude_4329__apply_40_2_41_, 0);
  int argcv_meth_collectionsPrelude_4329__apply_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_4329__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4329__apply_40_2_41_);
  meth_meth_collectionsPrelude_4329__apply_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4329__apply_40_2_41_->definitionLine = 1769;
// compiled block node returning block4328 (depth = 3)
  gc_frame_newslot(block4328);
// call case 4: self request
  params[0] = block4328;
  partcv[0] = 1;
  Object call4333 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4327);
// compiled call node returning call4333 (depth = 2)
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newCopy (depth = 2)
  gc_frame_end(frame);
  return *var_newCopy;
}
Object meth_collectionsPrelude_4334_asDictionary(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_4340__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_newDict = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4341 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newDict (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4342 = callmethodflags(*var_newDict, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4341);
// compiled call node returning call4342 (depth = 4)
  gc_frame_end(frame);
  return call4342;
}
Object meth_collectionsPrelude_4335__43__43__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_newDict = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDict");
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4336 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4337 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4336);
// compiled member node returning call4337 (depth = 3)
  *var_newDict = call4337;
  if (call4337 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4338 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4339 = alloc_Block(NULL, NULL, "collectionsPrelude", 1622);
  gc_frame_newslot(block4339);
// method "_apply(_,_)"
  block_savedest(block4339);
  Object closure4340 = createclosure(2, "_apply(2)");
  setclosureframe(closure4340, stackframe);
  addtoclosure(closure4340, var_newDict);
  addtoclosure(closure4340, selfslot);
  struct UserObject *uo4340 = (struct UserObject*)block4339;
  uo4340->data[0] = (Object)closure4340;
  Method *meth_meth_collectionsPrelude_4340__apply_40_2_41_ = addmethod2pos(block4339, "_apply(2)", &meth_collectionsPrelude_4340__apply_40_2_41_, 0);
  int argcv_meth_collectionsPrelude_4340__apply_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_4340__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4340__apply_40_2_41_);
  meth_meth_collectionsPrelude_4340__apply_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4340__apply_40_2_41_->definitionLine = 1769;
// compiled block node returning block4339 (depth = 3)
  gc_frame_newslot(block4339);
// call case 6: other requests
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  params[0] = block4339;
  partcv[0] = 1;
  Object call4344 = callmethodflags(*var_other, "keysAndValuesDo(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4338);
// compiled call node returning call4344 (depth = 2)
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newDict (depth = 3)
  return *var_newDict;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_4352__apply_40_2_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object *var_newDict = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4354 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe4355 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  gc_frame_newslot(*var_k);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_k;
  partcv[0] = 1;
  Object call4356 = callmethodflags(*var_other, "containsKey(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4355);
// compiled call node returning call4356 (depth = 6)
  partcv[0] = 0;
  Object call4357 = callmethodflags(call4356, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4354);
// compiled call node returning call4357 (depth = 5)
  Object if4353 = done;
  if (istrue(call4357)) {
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4358 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newDict (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4359 = callmethodflags(*var_newDict, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4358);
// compiled call node returning call4359 (depth = 5)
    gc_frame_newslot(call4359);
    if4353 = call4359;
  } else {
  }
// compiled if node returning if4353 (depth = 4)
  gc_frame_end(frame);
  return if4353;
}
Object meth_collectionsPrelude_4345__45__45__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "--(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method --(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for --(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part --(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_newDict = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDict");
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4346 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4347 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call4348 = callmethodflags(module_collectionsPrelude, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4347);
// compiled member node returning call4348 (depth = 4)
  partcv[0] = 0;
  Object call4349 = callmethodflags(call4348, "empty", 1, partcv, params, 0);
  gc_frame_end(callframe4346);
// compiled member node returning call4349 (depth = 3)
  *var_newDict = call4349;
  if (call4349 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4350 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4351 = alloc_Block(NULL, NULL, "collectionsPrelude", 1630);
  gc_frame_newslot(block4351);
// method "_apply(_,_)"
  block_savedest(block4351);
  Object closure4352 = createclosure(3, "_apply(2)");
  setclosureframe(closure4352, stackframe);
  addtoclosure(closure4352, var_other);
  addtoclosure(closure4352, var_newDict);
  addtoclosure(closure4352, selfslot);
  struct UserObject *uo4352 = (struct UserObject*)block4351;
  uo4352->data[0] = (Object)closure4352;
  Method *meth_meth_collectionsPrelude_4352__apply_40_2_41_ = addmethod2pos(block4351, "_apply(2)", &meth_collectionsPrelude_4352__apply_40_2_41_, 0);
  int argcv_meth_collectionsPrelude_4352__apply_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_4352__apply_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4352__apply_40_2_41_);
  meth_meth_collectionsPrelude_4352__apply_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4352__apply_40_2_41_->definitionLine = 1769;
// compiled block node returning block4351 (depth = 3)
  gc_frame_newslot(block4351);
// call case 4: self request
  params[0] = block4351;
  partcv[0] = 1;
  Object call4361 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4350);
// compiled call node returning call4361 (depth = 2)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newDict (depth = 3)
  return *var_newDict;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_4385__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4386 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4388 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4387);
// compiled member node returning call4388 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4389 = callmethodflags(call4388, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4386);
// compiled call node returning call4389 (depth = 4)
  gc_frame_end(frame);
  return call4389;
}
Object meth_collectionsPrelude_2986_empty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_IteratorExhausted = getfromclosure(closure, 5);
  Object *var_ComparableToDictionary = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2987 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2987 = alloc_userobj2(45,43, objclass2987);
  gc_frame_newslot(obj2987);
  if (objclass2987 == NULL) {
    glfree(obj2987->class->name);
    obj2987->class->name = "dictionary.empty";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2987, self, 0);
  addmethodreal(obj2987,"outer", &reader_collectionsPrelude_outer_2988);
  Object oldself2987 = self;
  struct StackFrameObject *oldstackframe2987 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2987);
  gc_frame_newslot((Object)stackframe);
  self = obj2987;
  Object *oldselfslot2987 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2987 = (*(struct UserObject *)self).data[0], lowerouter2987 = thisouter2987;
  if (inheritingObject2987) {
    struct UserObject *inho2987 = (struct UserObject *)inheritingObject2987;
    while (inho2987->super != GraceDefaultObject) inho2987 = (struct UserObject *)inho2987->super;
    inho2987->super = obj2987;
    self = inheritingObject2987;
    *selfslot = self;
    lowerouter2987 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2987;
  }
  if (objclass2987 == NULL) {
    Method *reader2989 = addmethodrealflags(obj2987, "mods", &reader_collectionsPrelude_mods_2989, 0);
    Method *writer2989 = addmethodrealflags(obj2987, "mods:=(1)", &writer_collectionsPrelude_mods_2989, MFLAG_CONFIDENTIAL);
    reader2989->definitionModule = modulename;
    writer2989->definitionModule = modulename;
    reader2989->definitionLine = 1259;
    writer2989->definitionLine = 1259;
  }
  obj2987->flags |= OFLAG_MUTABLE;
  adddatum2(obj2987, alloc_Undefined(), 1);
  if (objclass2987 == NULL) {
    Method *reader2990 = addmethodrealflags(obj2987, "numBindings", &reader_collectionsPrelude_numBindings_2990, MFLAG_CONFIDENTIAL);
    Method *writer2990 = addmethodrealflags(obj2987, "numBindings:=(1)", &writer_collectionsPrelude_numBindings_2990, MFLAG_CONFIDENTIAL);
    reader2990->definitionModule = modulename;
    writer2990->definitionModule = modulename;
    reader2990->definitionLine = 1260;
    writer2990->definitionLine = 1260;
  }
  obj2987->flags |= OFLAG_MUTABLE;
  adddatum2(obj2987, alloc_Undefined(), 2);
  if (objclass2987 == NULL) {
    Method *reader2991 = addmethodrealflags(obj2987, "inner", &reader_collectionsPrelude_inner_2991, MFLAG_CONFIDENTIAL);
    Method *writer2991 = addmethodrealflags(obj2987, "inner:=(1)", &writer_collectionsPrelude_inner_2991, MFLAG_CONFIDENTIAL);
    reader2991->definitionModule = modulename;
    writer2991->definitionModule = modulename;
    reader2991->definitionLine = 1261;
    writer2991->definitionLine = 1261;
  }
  obj2987->flags |= OFLAG_MUTABLE;
  adddatum2(obj2987, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo2992 = (struct UserObject*)obj2987;
  uo2992->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2992_size = addmethod2pos(obj2987, "size", &meth_collectionsPrelude_2992_size, 4);
  int argcv_meth_collectionsPrelude_2992_size[] = {0};
  meth_meth_collectionsPrelude_2992_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2992_size);
  meth_meth_collectionsPrelude_2992_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_2992_size->definitionLine = 1265;
// method "at(_)put(_)"
  block_savedest(obj2987);
  Object closure2995 = createclosure(3, "at(1)put(1)");
  setclosureframe(closure2995, stackframe);
  addtoclosure(closure2995, var_removed);
  addtoclosure(closure2995, var_unused);
  addtoclosure(closure2995, var_binding);
  struct UserObject *uo2995 = (struct UserObject*)obj2987;
  uo2995->data[5] = (Object)closure2995;
  Method *meth_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_ = addmethod2pos(obj2987, "at(1)put(1)", &meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_, 5);
  int argcv_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_);
  meth_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_->definitionLine = 1266;
// method "add(_)"
  block_savedest(obj2987);
  Object closure3054 = createclosure(2, "add(1)");
  setclosureframe(closure3054, stackframe);
  addtoclosure(closure3054, var_removed);
  addtoclosure(closure3054, var_unused);
  struct UserObject *uo3054 = (struct UserObject*)obj2987;
  uo3054->data[6] = (Object)closure3054;
  Method *meth_meth_collectionsPrelude_3054_add_40_1_41_ = addmethod2pos(obj2987, "add(1)", &meth_collectionsPrelude_3054_add_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_3054_add_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3054_add_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3054_add_40_1_41_);
  meth_meth_collectionsPrelude_3054_add_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3054_add_40_1_41_->definitionLine = 1276;
// method "at(_)"
  block_savedest(obj2987);
  Object closure3113 = createclosure(1, "at(1)");
  setclosureframe(closure3113, stackframe);
  addtoclosure(closure3113, var_NoSuchObject);
  struct UserObject *uo3113 = (struct UserObject*)obj2987;
  uo3113->data[7] = (Object)closure3113;
  Method *meth_meth_collectionsPrelude_3113_at_40_1_41_ = addmethod2pos(obj2987, "at(1)", &meth_collectionsPrelude_3113_at_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_3113_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3113_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3113_at_40_1_41_);
  meth_meth_collectionsPrelude_3113_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3113_at_40_1_41_->definitionLine = 1286;
// method "at(_)ifAbsent(_)"
  struct UserObject *uo3138 = (struct UserObject*)obj2987;
  uo3138->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj2987, "at(1)ifAbsent(1)", &meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_->definitionLine = 1293;
// method "containsKey(_)"
  struct UserObject *uo3155 = (struct UserObject*)obj2987;
  uo3155->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3155_containsKey_40_1_41_ = addmethod2pos(obj2987, "containsKey(1)", &meth_collectionsPrelude_3155_containsKey_40_1_41_, 9);
  int argcv_meth_collectionsPrelude_3155_containsKey_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3155_containsKey_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3155_containsKey_40_1_41_);
  meth_meth_collectionsPrelude_3155_containsKey_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3155_containsKey_40_1_41_->definitionLine = 1300;
// method "removeAllKeys(_)"
  block_savedest(obj2987);
  Object closure3170 = createclosure(2, "removeAllKeys(1)");
  setclosureframe(closure3170, stackframe);
  addtoclosure(closure3170, var_removed);
  addtoclosure(closure3170, var_NoSuchObject);
  struct UserObject *uo3170 = (struct UserObject*)obj2987;
  uo3170->data[10] = (Object)closure3170;
  Method *meth_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_ = addmethod2pos(obj2987, "removeAllKeys(1)", &meth_collectionsPrelude_3170_removeAllKeys_40_1_41_, 10);
  int argcv_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_);
  meth_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_->definitionLine = 1307;
// method "removeKey(_)"
  block_savedest(obj2987);
  Object closure3218 = createclosure(2, "removeKey(1)");
  setclosureframe(closure3218, stackframe);
  addtoclosure(closure3218, var_removed);
  addtoclosure(closure3218, var_NoSuchObject);
  struct UserObject *uo3218 = (struct UserObject*)obj2987;
  uo3218->data[11] = (Object)closure3218;
  Method *meth_meth_collectionsPrelude_3218_removeKey_40_1_41_ = addmethod2pos(obj2987, "removeKey(1)", &meth_collectionsPrelude_3218_removeKey_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_3218_removeKey_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3218_removeKey_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3218_removeKey_40_1_41_);
  meth_meth_collectionsPrelude_3218_removeKey_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3218_removeKey_40_1_41_->definitionLine = 1320;
// method "removeKey(_)ifAbsent(_)"
  block_savedest(obj2987);
  Object closure3261 = createclosure(1, "removeKey(1)ifAbsent(1)");
  setclosureframe(closure3261, stackframe);
  addtoclosure(closure3261, var_removed);
  struct UserObject *uo3261 = (struct UserObject*)obj2987;
  uo3261->data[12] = (Object)closure3261;
  Method *meth_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj2987, "removeKey(1)ifAbsent(1)", &meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_->definitionLine = 1331;
// method "removeAllValues(_)"
  block_savedest(obj2987);
  Object closure3296 = createclosure(1, "removeAllValues(1)");
  setclosureframe(closure3296, stackframe);
  addtoclosure(closure3296, var_removed);
  struct UserObject *uo3296 = (struct UserObject*)obj2987;
  uo3296->data[13] = (Object)closure3296;
  Method *meth_meth_collectionsPrelude_3296_removeAllValues_40_1_41_ = addmethod2pos(obj2987, "removeAllValues(1)", &meth_collectionsPrelude_3296_removeAllValues_40_1_41_, 13);
  int argcv_meth_collectionsPrelude_3296_removeAllValues_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3296_removeAllValues_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3296_removeAllValues_40_1_41_);
  meth_meth_collectionsPrelude_3296_removeAllValues_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3296_removeAllValues_40_1_41_->definitionLine = 1342;
// method "removeValue(_)"
  block_savedest(obj2987);
  Object closure3343 = createclosure(2, "removeValue(1)");
  setclosureframe(closure3343, stackframe);
  addtoclosure(closure3343, var_removed);
  addtoclosure(closure3343, var_NoSuchObject);
  struct UserObject *uo3343 = (struct UserObject*)obj2987;
  uo3343->data[14] = (Object)closure3343;
  Method *meth_meth_collectionsPrelude_3343_removeValue_40_1_41_ = addmethod2pos(obj2987, "removeValue(1)", &meth_collectionsPrelude_3343_removeValue_40_1_41_, 14);
  int argcv_meth_collectionsPrelude_3343_removeValue_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3343_removeValue_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3343_removeValue_40_1_41_);
  meth_meth_collectionsPrelude_3343_removeValue_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3343_removeValue_40_1_41_->definitionLine = 1353;
// method "removeValue(_)ifAbsent(_)"
  block_savedest(obj2987);
  Object closure3409 = createclosure(1, "removeValue(1)ifAbsent(1)");
  setclosureframe(closure3409, stackframe);
  addtoclosure(closure3409, var_removed);
  struct UserObject *uo3409 = (struct UserObject*)obj2987;
  uo3409->data[15] = (Object)closure3409;
  Method *meth_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj2987, "removeValue(1)ifAbsent(1)", &meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_, 15);
  int argcv_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_->definitionLine = 1369;
// method "clear"
  block_savedest(obj2987);
  Object closure3467 = createclosure(1, "clear");
  setclosureframe(closure3467, stackframe);
  addtoclosure(closure3467, var_unused);
  struct UserObject *uo3467 = (struct UserObject*)obj2987;
  uo3467->data[16] = (Object)closure3467;
  Method *meth_meth_collectionsPrelude_3467_clear = addmethod2pos(obj2987, "clear", &meth_collectionsPrelude_3467_clear, 16);
  int argcv_meth_collectionsPrelude_3467_clear[] = {0};
  meth_meth_collectionsPrelude_3467_clear->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3467_clear);
  meth_meth_collectionsPrelude_3467_clear->definitionModule = modulename;
  meth_meth_collectionsPrelude_3467_clear->definitionLine = 1385;
// method "containsValue(_)"
  struct UserObject *uo3507 = (struct UserObject*)obj2987;
  uo3507->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3507_containsValue_40_1_41_ = addmethod2pos(obj2987, "containsValue(1)", &meth_collectionsPrelude_3507_containsValue_40_1_41_, 17);
  int argcv_meth_collectionsPrelude_3507_containsValue_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3507_containsValue_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3507_containsValue_40_1_41_);
  meth_meth_collectionsPrelude_3507_containsValue_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3507_containsValue_40_1_41_->definitionLine = 1394;
// method "contains(_)"
  struct UserObject *uo3519 = (struct UserObject*)obj2987;
  uo3519->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3519_contains_40_1_41_ = addmethod2pos(obj2987, "contains(1)", &meth_collectionsPrelude_3519_contains_40_1_41_, 18);
  int argcv_meth_collectionsPrelude_3519_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3519_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3519_contains_40_1_41_);
  meth_meth_collectionsPrelude_3519_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3519_contains_40_1_41_->definitionLine = 1400;
// method "findPosition(_)"
  block_savedest(obj2987);
  Object closure3522 = createclosure(1, "findPosition(1)");
  setclosureframe(closure3522, stackframe);
  addtoclosure(closure3522, var_unused);
  struct UserObject *uo3522 = (struct UserObject*)obj2987;
  uo3522->data[19] = (Object)closure3522;
  Method *meth_meth_collectionsPrelude_3522_findPosition_40_1_41_ = addmethod2pos(obj2987, "findPosition(1)", &meth_collectionsPrelude_3522_findPosition_40_1_41_, 19);
  int argcv_meth_collectionsPrelude_3522_findPosition_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3522_findPosition_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3522_findPosition_40_1_41_);
  meth_meth_collectionsPrelude_3522_findPosition_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_3522_findPosition_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3522_findPosition_40_1_41_->definitionLine = 1402;
// method "findPositionForAdd(_)"
  block_savedest(obj2987);
  Object closure3588 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure3588, stackframe);
  addtoclosure(closure3588, var_removed);
  addtoclosure(closure3588, var_unused);
  struct UserObject *uo3588 = (struct UserObject*)obj2987;
  uo3588->data[20] = (Object)closure3588;
  Method *meth_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_ = addmethod2pos(obj2987, "findPositionForAdd(1)", &meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_, 20);
  int argcv_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_);
  meth_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_->definitionLine = 1420;
// method "asString"
  block_savedest(obj2987);
  Object closure3664 = createclosure(2, "asString");
  setclosureframe(closure3664, stackframe);
  addtoclosure(closure3664, var_removed);
  addtoclosure(closure3664, var_unused);
  struct UserObject *uo3664 = (struct UserObject*)obj2987;
  uo3664->data[21] = (Object)closure3664;
  Method *meth_meth_collectionsPrelude_3664_asString = addmethod2pos(obj2987, "asString", &meth_collectionsPrelude_3664_asString, 21);
  int argcv_meth_collectionsPrelude_3664_asString[] = {0};
  meth_meth_collectionsPrelude_3664_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3664_asString);
  meth_meth_collectionsPrelude_3664_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3664_asString->definitionLine = 1438;
// method "asDebugString"
  block_savedest(obj2987);
  Object closure3735 = createclosure(2, "asDebugString");
  setclosureframe(closure3735, stackframe);
  addtoclosure(closure3735, var_removed);
  addtoclosure(closure3735, var_unused);
  struct UserObject *uo3735 = (struct UserObject*)obj2987;
  uo3735->data[22] = (Object)closure3735;
  Method *meth_meth_collectionsPrelude_3735_asDebugString = addmethod2pos(obj2987, "asDebugString", &meth_collectionsPrelude_3735_asDebugString, 22);
  int argcv_meth_collectionsPrelude_3735_asDebugString[] = {0};
  meth_meth_collectionsPrelude_3735_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3735_asDebugString);
  meth_meth_collectionsPrelude_3735_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3735_asDebugString->definitionLine = 1456;
// method "keys"
  struct UserObject *uo3833 = (struct UserObject*)obj2987;
  uo3833->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3833_keys = addmethod2pos(obj2987, "keys", &meth_collectionsPrelude_3833_keys, 23);
  int argcv_meth_collectionsPrelude_3833_keys[] = {0};
  meth_meth_collectionsPrelude_3833_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3833_keys);
  meth_meth_collectionsPrelude_3833_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_3833_keys->definitionLine = 1469;
  Method *meth_meth_collectionsPrelude_3833_keys_object = addmethod2pos(obj2987, "keys$object(1)", &meth_collectionsPrelude_3833_keys_object, 23);
  int argcv_meth_collectionsPrelude_3833_keys_object[] = {0};
  meth_meth_collectionsPrelude_3833_keys_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3833_keys_object);
  meth_meth_collectionsPrelude_3833_keys_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3833_keys_object->definitionLine = 1469;
// method "values"
  struct UserObject *uo3879 = (struct UserObject*)obj2987;
  uo3879->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3879_values = addmethod2pos(obj2987, "values", &meth_collectionsPrelude_3879_values, 24);
  int argcv_meth_collectionsPrelude_3879_values[] = {0};
  meth_meth_collectionsPrelude_3879_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3879_values);
  meth_meth_collectionsPrelude_3879_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_3879_values->definitionLine = 1487;
  Method *meth_meth_collectionsPrelude_3879_values_object = addmethod2pos(obj2987, "values$object(1)", &meth_collectionsPrelude_3879_values_object, 24);
  int argcv_meth_collectionsPrelude_3879_values_object[] = {0};
  meth_meth_collectionsPrelude_3879_values_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3879_values_object);
  meth_meth_collectionsPrelude_3879_values_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3879_values_object->definitionLine = 1487;
// method "bindings"
  struct UserObject *uo3925 = (struct UserObject*)obj2987;
  uo3925->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3925_bindings = addmethod2pos(obj2987, "bindings", &meth_collectionsPrelude_3925_bindings, 25);
  int argcv_meth_collectionsPrelude_3925_bindings[] = {0};
  meth_meth_collectionsPrelude_3925_bindings->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3925_bindings);
  meth_meth_collectionsPrelude_3925_bindings->definitionModule = modulename;
  meth_meth_collectionsPrelude_3925_bindings->definitionLine = 1506;
  Method *meth_meth_collectionsPrelude_3925_bindings_object = addmethod2pos(obj2987, "bindings$object(1)", &meth_collectionsPrelude_3925_bindings_object, 25);
  int argcv_meth_collectionsPrelude_3925_bindings_object[] = {0};
  meth_meth_collectionsPrelude_3925_bindings_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3925_bindings_object);
  meth_meth_collectionsPrelude_3925_bindings_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3925_bindings_object->definitionLine = 1506;
// method "iterator"
  struct UserObject *uo3946 = (struct UserObject*)obj2987;
  uo3946->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3946_iterator = addmethod2pos(obj2987, "iterator", &meth_collectionsPrelude_3946_iterator, 26);
  int argcv_meth_collectionsPrelude_3946_iterator[] = {0};
  meth_meth_collectionsPrelude_3946_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3946_iterator);
  meth_meth_collectionsPrelude_3946_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_3946_iterator->definitionLine = 1518;
// method "bindingsIterator"
  block_savedest(obj2987);
  Object closure3951 = createclosure(4, "bindingsIterator");
  setclosureframe(closure3951, stackframe);
  addtoclosure(closure3951, var_ConcurrentModification);
  addtoclosure(closure3951, var_IteratorExhausted);
  addtoclosure(closure3951, var_removed);
  addtoclosure(closure3951, var_unused);
  struct UserObject *uo3951 = (struct UserObject*)obj2987;
  uo3951->data[27] = (Object)closure3951;
  Method *meth_meth_collectionsPrelude_3951_bindingsIterator = addmethod2pos(obj2987, "bindingsIterator", &meth_collectionsPrelude_3951_bindingsIterator, 27);
  int argcv_meth_collectionsPrelude_3951_bindingsIterator[] = {0};
  meth_meth_collectionsPrelude_3951_bindingsIterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3951_bindingsIterator);
  meth_meth_collectionsPrelude_3951_bindingsIterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_3951_bindingsIterator->definitionLine = 1519;
  block_savedest(obj2987);
  Object closure4072 = createclosure(4, "bindingsIterator$object(1)");
  setclosureframe(closure4072, stackframe);
  addtoclosure(closure4072, var_ConcurrentModification);
  addtoclosure(closure4072, var_IteratorExhausted);
  addtoclosure(closure4072, var_removed);
  addtoclosure(closure4072, var_unused);
  Method *meth_meth_collectionsPrelude_3951_bindingsIterator_object = addmethod2pos(obj2987, "bindingsIterator$object(1)", &meth_collectionsPrelude_3951_bindingsIterator_object, 27);
  meth_meth_collectionsPrelude_3951_bindingsIterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3951_bindingsIterator_object->definitionLine = 1519;
// method "expand"
  block_savedest(obj2987);
  Object closure4073 = createclosure(2, "expand");
  setclosureframe(closure4073, stackframe);
  addtoclosure(closure4073, var_unused);
  addtoclosure(closure4073, var_removed);
  struct UserObject *uo4073 = (struct UserObject*)obj2987;
  uo4073->data[28] = (Object)closure4073;
  Method *meth_meth_collectionsPrelude_4073_expand = addmethod2pos(obj2987, "expand", &meth_collectionsPrelude_4073_expand, 28);
  int argcv_meth_collectionsPrelude_4073_expand[] = {0};
  meth_meth_collectionsPrelude_4073_expand->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4073_expand);
  meth_meth_collectionsPrelude_4073_expand->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_4073_expand->definitionModule = modulename;
  meth_meth_collectionsPrelude_4073_expand->definitionLine = 1542;
// method "keysAndValuesDo(_)"
  block_savedest(obj2987);
  Object closure4141 = createclosure(2, "keysAndValuesDo(1)");
  setclosureframe(closure4141, stackframe);
  addtoclosure(closure4141, var_removed);
  addtoclosure(closure4141, var_unused);
  struct UserObject *uo4141 = (struct UserObject*)obj2987;
  uo4141->data[29] = (Object)closure4141;
  Method *meth_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_ = addmethod2pos(obj2987, "keysAndValuesDo(1)", &meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_, 29);
  int argcv_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_->definitionLine = 1558;
// method "keysDo(_)"
  block_savedest(obj2987);
  Object closure4179 = createclosure(3, "keysDo(1)");
  setclosureframe(closure4179, stackframe);
  addtoclosure(closure4179, var_ConcurrentModification);
  addtoclosure(closure4179, var_removed);
  addtoclosure(closure4179, var_unused);
  struct UserObject *uo4179 = (struct UserObject*)obj2987;
  uo4179->data[30] = (Object)closure4179;
  Method *meth_meth_collectionsPrelude_4179_keysDo_40_1_41_ = addmethod2pos(obj2987, "keysDo(1)", &meth_collectionsPrelude_4179_keysDo_40_1_41_, 30);
  int argcv_meth_collectionsPrelude_4179_keysDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4179_keysDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4179_keysDo_40_1_41_);
  meth_meth_collectionsPrelude_4179_keysDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4179_keysDo_40_1_41_->definitionLine = 1566;
// method "valuesDo(_)"
  block_savedest(obj2987);
  Object closure4227 = createclosure(3, "valuesDo(1)");
  setclosureframe(closure4227, stackframe);
  addtoclosure(closure4227, var_ConcurrentModification);
  addtoclosure(closure4227, var_removed);
  addtoclosure(closure4227, var_unused);
  struct UserObject *uo4227 = (struct UserObject*)obj2987;
  uo4227->data[31] = (Object)closure4227;
  Method *meth_meth_collectionsPrelude_4227_valuesDo_40_1_41_ = addmethod2pos(obj2987, "valuesDo(1)", &meth_collectionsPrelude_4227_valuesDo_40_1_41_, 31);
  int argcv_meth_collectionsPrelude_4227_valuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4227_valuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4227_valuesDo_40_1_41_);
  meth_meth_collectionsPrelude_4227_valuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4227_valuesDo_40_1_41_->definitionLine = 1578;
// method "do(_)"
  struct UserObject *uo4275 = (struct UserObject*)obj2987;
  uo4275->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4275_do_40_1_41_ = addmethod2pos(obj2987, "do(1)", &meth_collectionsPrelude_4275_do_40_1_41_, 32);
  int argcv_meth_collectionsPrelude_4275_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4275_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4275_do_40_1_41_);
  meth_meth_collectionsPrelude_4275_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4275_do_40_1_41_->definitionLine = 1590;
// method "==(_)"
  block_savedest(obj2987);
  Object closure4278 = createclosure(1, "==(1)");
  setclosureframe(closure4278, stackframe);
  addtoclosure(closure4278, var_ComparableToDictionary);
  struct UserObject *uo4278 = (struct UserObject*)obj2987;
  uo4278->data[33] = (Object)closure4278;
  Method *meth_meth_collectionsPrelude_4278__61__61__40_1_41_ = addmethod2pos(obj2987, "==(1)", &meth_collectionsPrelude_4278__61__61__40_1_41_, 33);
  int argcv_meth_collectionsPrelude_4278__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4278__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4278__61__61__40_1_41_);
  meth_meth_collectionsPrelude_4278__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4278__61__61__40_1_41_->definitionLine = 1592;
// method "copy"
  struct UserObject *uo4322 = (struct UserObject*)obj2987;
  uo4322->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4322_copy = addmethod2pos(obj2987, "copy", &meth_collectionsPrelude_4322_copy, 34);
  int argcv_meth_collectionsPrelude_4322_copy[] = {0};
  meth_meth_collectionsPrelude_4322_copy->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4322_copy);
  meth_meth_collectionsPrelude_4322_copy->definitionModule = modulename;
  meth_meth_collectionsPrelude_4322_copy->definitionLine = 1608;
// method "asDictionary"
  struct UserObject *uo4334 = (struct UserObject*)obj2987;
  uo4334->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4334_asDictionary = addmethod2pos(obj2987, "asDictionary", &meth_collectionsPrelude_4334_asDictionary, 35);
  int argcv_meth_collectionsPrelude_4334_asDictionary[] = {0};
  meth_meth_collectionsPrelude_4334_asDictionary->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4334_asDictionary);
  meth_meth_collectionsPrelude_4334_asDictionary->definitionModule = modulename;
  meth_meth_collectionsPrelude_4334_asDictionary->definitionLine = 1616;
// method "++(_)"
  struct UserObject *uo4335 = (struct UserObject*)obj2987;
  uo4335->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4335__43__43__40_1_41_ = addmethod2pos(obj2987, "++(1)", &meth_collectionsPrelude_4335__43__43__40_1_41_, 36);
  int argcv_meth_collectionsPrelude_4335__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4335__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4335__43__43__40_1_41_);
  meth_meth_collectionsPrelude_4335__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4335__43__43__40_1_41_->definitionLine = 1620;
// method "--(_)"
  struct UserObject *uo4345 = (struct UserObject*)obj2987;
  uo4345->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4345__45__45__40_1_41_ = addmethod2pos(obj2987, "--(1)", &meth_collectionsPrelude_4345__45__45__40_1_41_, 37);
  int argcv_meth_collectionsPrelude_4345__45__45__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4345__45__45__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4345__45__45__40_1_41_);
  meth_meth_collectionsPrelude_4345__45__45__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4345__45__45__40_1_41_->definitionLine = 1628;
  sourceObject = obj2987;
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4362 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4363 = callmethodflags(module_collectionsPrelude, "collection$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4362);
// compiled call node returning call4363 (depth = 2)
  struct UserObject *obj2987_uo = (struct UserObject *)obj2987;
  obj2987_uo->super = call4363;
  sourceObject = obj2987;
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4364 = alloc_Float64(0);
// compiled num node returning num4364 (depth = 2)
  adddatum2(obj2987, num4364, 1);
  sourceObject = obj2987;
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4365 = alloc_Float64(0);
// compiled num node returning num4365 (depth = 2)
  adddatum2(obj2987, num4365, 2);
  sourceObject = obj2987;
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4366 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4367 = alloc_Float64(8);
// compiled num node returning num4367 (depth = 3)
  gc_frame_newslot(num4367);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4368 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4369 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4368);
// compiled member node returning call4369 (depth = 3)
  params[0] = num4367;
  partcv[0] = 1;
  Object call4370 = callmethodflags(call4369, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4366);
// compiled call node returning call4370 (depth = 2)
  adddatum2(obj2987, call4370, 3);
  sourceObject = obj2987;
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4371 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4374 = alloc_Float64(1);
// compiled num node returning num4374 (depth = 5)
  int op_slot_right_4373 = gc_frame_newslot(num4374);
// starting to compile member node (depth = 5)
  int callframe4376 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4377 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4378 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4377);
// compiled member node returning call4378 (depth = 6)
  partcv[0] = 0;
  Object call4379 = callmethodflags(call4378, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4376);
// compiled member node returning call4379 (depth = 5)
  int op_slot_left_4373 = gc_frame_newslot(call4379);
  params[0] = num4374;
  partcv[0] = 1;
  Object diff4380 = callmethod(call4379, "-(1)", 1, partcv, params);
// compiled op node returning diff4380 (depth = 4)
  int op_slot_right_4372 = gc_frame_newslot(diff4380);
// starting to compile num node (depth = 4)
  Object num4382 = alloc_Float64(0);
// compiled num node returning num4382 (depth = 4)
  int op_slot_left_4372 = gc_frame_newslot(num4382);
  params[0] = diff4380;
  partcv[0] = 1;
  Object opresult4383 = callmethod(num4382, "..(1)", 1, partcv, params);
// compiled op node returning opresult4383 (depth = 3)
  gc_frame_newslot(opresult4383);
// starting to compile block node (depth = 3)
  Object block4384 = alloc_Block(NULL, NULL, "collectionsPrelude", 1262);
  gc_frame_newslot(block4384);
// method "_apply(_)"
  block_savedest(block4384);
  Object closure4385 = createclosure(2, "_apply(1)");
  setclosureframe(closure4385, stackframe);
  addtoclosure(closure4385, var_unused);
  addtoclosure(closure4385, selfslot);
  struct UserObject *uo4385 = (struct UserObject*)block4384;
  uo4385->data[0] = (Object)closure4385;
  Method *meth_meth_collectionsPrelude_4385__apply_40_1_41_ = addmethod2pos(block4384, "_apply(1)", &meth_collectionsPrelude_4385__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4385__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4385__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4385__apply_40_1_41_);
  meth_meth_collectionsPrelude_4385__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4385__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block4384 (depth = 3)
  gc_frame_newslot(block4384);
// call case 5: prelude request
  params[0] = opresult4383;
  params[1] = block4384;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4391 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4371);
// compiled call node returning call4391 (depth = 2)
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  objclass2987 = obj2987->class;
  objclass2987->definitionModule = modulename;
  objclass2987->definitionLine = 1257;
  (*(struct UserObject *)self).data[0] = lowerouter2987;
  self = oldself2987;
  selfslot = oldselfslot2987;
  stackframe = oldstackframe2987;
  gc_frame_end(frame);
  return obj2987;
}
Object meth_collectionsPrelude_2986_empty_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_IteratorExhausted = getfromclosure(closure, 5);
  Object *var_ComparableToDictionary = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2987 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2987 = alloc_userobj2(45,43, objclass2987);
  gc_frame_newslot(obj2987);
  if (objclass2987 == NULL) {
    glfree(obj2987->class->name);
    obj2987->class->name = "dictionary.empty";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2987, self, 0);
  addmethodreal(obj2987,"outer", &reader_collectionsPrelude_outer_2988);
  Object oldself2987 = self;
  struct StackFrameObject *oldstackframe2987 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2987);
  gc_frame_newslot((Object)stackframe);
  self = obj2987;
  Object *oldselfslot2987 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2987 = (*(struct UserObject *)self).data[0], lowerouter2987 = thisouter2987;
  if (inheritingObject2987) {
    struct UserObject *inho2987 = (struct UserObject *)inheritingObject2987;
    while (inho2987->super != GraceDefaultObject) inho2987 = (struct UserObject *)inho2987->super;
    inho2987->super = obj2987;
    self = inheritingObject2987;
    *selfslot = self;
    lowerouter2987 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2987;
  }
  if (objclass2987 == NULL) {
    Method *reader2989 = addmethodrealflags(obj2987, "mods", &reader_collectionsPrelude_mods_2989, 0);
    Method *writer2989 = addmethodrealflags(obj2987, "mods:=(1)", &writer_collectionsPrelude_mods_2989, MFLAG_CONFIDENTIAL);
    reader2989->definitionModule = modulename;
    writer2989->definitionModule = modulename;
    reader2989->definitionLine = 1259;
    writer2989->definitionLine = 1259;
  }
  obj2987->flags |= OFLAG_MUTABLE;
  adddatum2(obj2987, alloc_Undefined(), 1);
  if (objclass2987 == NULL) {
    Method *reader2990 = addmethodrealflags(obj2987, "numBindings", &reader_collectionsPrelude_numBindings_2990, MFLAG_CONFIDENTIAL);
    Method *writer2990 = addmethodrealflags(obj2987, "numBindings:=(1)", &writer_collectionsPrelude_numBindings_2990, MFLAG_CONFIDENTIAL);
    reader2990->definitionModule = modulename;
    writer2990->definitionModule = modulename;
    reader2990->definitionLine = 1260;
    writer2990->definitionLine = 1260;
  }
  obj2987->flags |= OFLAG_MUTABLE;
  adddatum2(obj2987, alloc_Undefined(), 2);
  if (objclass2987 == NULL) {
    Method *reader2991 = addmethodrealflags(obj2987, "inner", &reader_collectionsPrelude_inner_2991, MFLAG_CONFIDENTIAL);
    Method *writer2991 = addmethodrealflags(obj2987, "inner:=(1)", &writer_collectionsPrelude_inner_2991, MFLAG_CONFIDENTIAL);
    reader2991->definitionModule = modulename;
    writer2991->definitionModule = modulename;
    reader2991->definitionLine = 1261;
    writer2991->definitionLine = 1261;
  }
  obj2987->flags |= OFLAG_MUTABLE;
  adddatum2(obj2987, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo2992 = (struct UserObject*)obj2987;
  uo2992->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2992_size = addmethod2pos(obj2987, "size", &meth_collectionsPrelude_2992_size, 4);
  int argcv_meth_collectionsPrelude_2992_size[] = {0};
  meth_meth_collectionsPrelude_2992_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2992_size);
  meth_meth_collectionsPrelude_2992_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_2992_size->definitionLine = 1265;
// method "at(_)put(_)"
  block_savedest(obj2987);
  Object closure2995 = createclosure(3, "at(1)put(1)");
  setclosureframe(closure2995, stackframe);
  addtoclosure(closure2995, var_removed);
  addtoclosure(closure2995, var_unused);
  addtoclosure(closure2995, var_binding);
  struct UserObject *uo2995 = (struct UserObject*)obj2987;
  uo2995->data[5] = (Object)closure2995;
  Method *meth_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_ = addmethod2pos(obj2987, "at(1)put(1)", &meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_, 5);
  int argcv_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_);
  meth_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2995_at_40_1_41_put_40_1_41_->definitionLine = 1266;
// method "add(_)"
  block_savedest(obj2987);
  Object closure3054 = createclosure(2, "add(1)");
  setclosureframe(closure3054, stackframe);
  addtoclosure(closure3054, var_removed);
  addtoclosure(closure3054, var_unused);
  struct UserObject *uo3054 = (struct UserObject*)obj2987;
  uo3054->data[6] = (Object)closure3054;
  Method *meth_meth_collectionsPrelude_3054_add_40_1_41_ = addmethod2pos(obj2987, "add(1)", &meth_collectionsPrelude_3054_add_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_3054_add_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3054_add_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3054_add_40_1_41_);
  meth_meth_collectionsPrelude_3054_add_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3054_add_40_1_41_->definitionLine = 1276;
// method "at(_)"
  block_savedest(obj2987);
  Object closure3113 = createclosure(1, "at(1)");
  setclosureframe(closure3113, stackframe);
  addtoclosure(closure3113, var_NoSuchObject);
  struct UserObject *uo3113 = (struct UserObject*)obj2987;
  uo3113->data[7] = (Object)closure3113;
  Method *meth_meth_collectionsPrelude_3113_at_40_1_41_ = addmethod2pos(obj2987, "at(1)", &meth_collectionsPrelude_3113_at_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_3113_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3113_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3113_at_40_1_41_);
  meth_meth_collectionsPrelude_3113_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3113_at_40_1_41_->definitionLine = 1286;
// method "at(_)ifAbsent(_)"
  struct UserObject *uo3138 = (struct UserObject*)obj2987;
  uo3138->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj2987, "at(1)ifAbsent(1)", &meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3138_at_40_1_41_ifAbsent_40_1_41_->definitionLine = 1293;
// method "containsKey(_)"
  struct UserObject *uo3155 = (struct UserObject*)obj2987;
  uo3155->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3155_containsKey_40_1_41_ = addmethod2pos(obj2987, "containsKey(1)", &meth_collectionsPrelude_3155_containsKey_40_1_41_, 9);
  int argcv_meth_collectionsPrelude_3155_containsKey_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3155_containsKey_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3155_containsKey_40_1_41_);
  meth_meth_collectionsPrelude_3155_containsKey_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3155_containsKey_40_1_41_->definitionLine = 1300;
// method "removeAllKeys(_)"
  block_savedest(obj2987);
  Object closure3170 = createclosure(2, "removeAllKeys(1)");
  setclosureframe(closure3170, stackframe);
  addtoclosure(closure3170, var_removed);
  addtoclosure(closure3170, var_NoSuchObject);
  struct UserObject *uo3170 = (struct UserObject*)obj2987;
  uo3170->data[10] = (Object)closure3170;
  Method *meth_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_ = addmethod2pos(obj2987, "removeAllKeys(1)", &meth_collectionsPrelude_3170_removeAllKeys_40_1_41_, 10);
  int argcv_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_);
  meth_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3170_removeAllKeys_40_1_41_->definitionLine = 1307;
// method "removeKey(_)"
  block_savedest(obj2987);
  Object closure3218 = createclosure(2, "removeKey(1)");
  setclosureframe(closure3218, stackframe);
  addtoclosure(closure3218, var_removed);
  addtoclosure(closure3218, var_NoSuchObject);
  struct UserObject *uo3218 = (struct UserObject*)obj2987;
  uo3218->data[11] = (Object)closure3218;
  Method *meth_meth_collectionsPrelude_3218_removeKey_40_1_41_ = addmethod2pos(obj2987, "removeKey(1)", &meth_collectionsPrelude_3218_removeKey_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_3218_removeKey_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3218_removeKey_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3218_removeKey_40_1_41_);
  meth_meth_collectionsPrelude_3218_removeKey_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3218_removeKey_40_1_41_->definitionLine = 1320;
// method "removeKey(_)ifAbsent(_)"
  block_savedest(obj2987);
  Object closure3261 = createclosure(1, "removeKey(1)ifAbsent(1)");
  setclosureframe(closure3261, stackframe);
  addtoclosure(closure3261, var_removed);
  struct UserObject *uo3261 = (struct UserObject*)obj2987;
  uo3261->data[12] = (Object)closure3261;
  Method *meth_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj2987, "removeKey(1)ifAbsent(1)", &meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_, 12);
  int argcv_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3261_removeKey_40_1_41_ifAbsent_40_1_41_->definitionLine = 1331;
// method "removeAllValues(_)"
  block_savedest(obj2987);
  Object closure3296 = createclosure(1, "removeAllValues(1)");
  setclosureframe(closure3296, stackframe);
  addtoclosure(closure3296, var_removed);
  struct UserObject *uo3296 = (struct UserObject*)obj2987;
  uo3296->data[13] = (Object)closure3296;
  Method *meth_meth_collectionsPrelude_3296_removeAllValues_40_1_41_ = addmethod2pos(obj2987, "removeAllValues(1)", &meth_collectionsPrelude_3296_removeAllValues_40_1_41_, 13);
  int argcv_meth_collectionsPrelude_3296_removeAllValues_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3296_removeAllValues_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3296_removeAllValues_40_1_41_);
  meth_meth_collectionsPrelude_3296_removeAllValues_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3296_removeAllValues_40_1_41_->definitionLine = 1342;
// method "removeValue(_)"
  block_savedest(obj2987);
  Object closure3343 = createclosure(2, "removeValue(1)");
  setclosureframe(closure3343, stackframe);
  addtoclosure(closure3343, var_removed);
  addtoclosure(closure3343, var_NoSuchObject);
  struct UserObject *uo3343 = (struct UserObject*)obj2987;
  uo3343->data[14] = (Object)closure3343;
  Method *meth_meth_collectionsPrelude_3343_removeValue_40_1_41_ = addmethod2pos(obj2987, "removeValue(1)", &meth_collectionsPrelude_3343_removeValue_40_1_41_, 14);
  int argcv_meth_collectionsPrelude_3343_removeValue_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3343_removeValue_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3343_removeValue_40_1_41_);
  meth_meth_collectionsPrelude_3343_removeValue_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3343_removeValue_40_1_41_->definitionLine = 1353;
// method "removeValue(_)ifAbsent(_)"
  block_savedest(obj2987);
  Object closure3409 = createclosure(1, "removeValue(1)ifAbsent(1)");
  setclosureframe(closure3409, stackframe);
  addtoclosure(closure3409, var_removed);
  struct UserObject *uo3409 = (struct UserObject*)obj2987;
  uo3409->data[15] = (Object)closure3409;
  Method *meth_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_ = addmethod2pos(obj2987, "removeValue(1)ifAbsent(1)", &meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_, 15);
  int argcv_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_);
  meth_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3409_removeValue_40_1_41_ifAbsent_40_1_41_->definitionLine = 1369;
// method "clear"
  block_savedest(obj2987);
  Object closure3467 = createclosure(1, "clear");
  setclosureframe(closure3467, stackframe);
  addtoclosure(closure3467, var_unused);
  struct UserObject *uo3467 = (struct UserObject*)obj2987;
  uo3467->data[16] = (Object)closure3467;
  Method *meth_meth_collectionsPrelude_3467_clear = addmethod2pos(obj2987, "clear", &meth_collectionsPrelude_3467_clear, 16);
  int argcv_meth_collectionsPrelude_3467_clear[] = {0};
  meth_meth_collectionsPrelude_3467_clear->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3467_clear);
  meth_meth_collectionsPrelude_3467_clear->definitionModule = modulename;
  meth_meth_collectionsPrelude_3467_clear->definitionLine = 1385;
// method "containsValue(_)"
  struct UserObject *uo3507 = (struct UserObject*)obj2987;
  uo3507->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3507_containsValue_40_1_41_ = addmethod2pos(obj2987, "containsValue(1)", &meth_collectionsPrelude_3507_containsValue_40_1_41_, 17);
  int argcv_meth_collectionsPrelude_3507_containsValue_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3507_containsValue_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3507_containsValue_40_1_41_);
  meth_meth_collectionsPrelude_3507_containsValue_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3507_containsValue_40_1_41_->definitionLine = 1394;
// method "contains(_)"
  struct UserObject *uo3519 = (struct UserObject*)obj2987;
  uo3519->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3519_contains_40_1_41_ = addmethod2pos(obj2987, "contains(1)", &meth_collectionsPrelude_3519_contains_40_1_41_, 18);
  int argcv_meth_collectionsPrelude_3519_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3519_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3519_contains_40_1_41_);
  meth_meth_collectionsPrelude_3519_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3519_contains_40_1_41_->definitionLine = 1400;
// method "findPosition(_)"
  block_savedest(obj2987);
  Object closure3522 = createclosure(1, "findPosition(1)");
  setclosureframe(closure3522, stackframe);
  addtoclosure(closure3522, var_unused);
  struct UserObject *uo3522 = (struct UserObject*)obj2987;
  uo3522->data[19] = (Object)closure3522;
  Method *meth_meth_collectionsPrelude_3522_findPosition_40_1_41_ = addmethod2pos(obj2987, "findPosition(1)", &meth_collectionsPrelude_3522_findPosition_40_1_41_, 19);
  int argcv_meth_collectionsPrelude_3522_findPosition_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3522_findPosition_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3522_findPosition_40_1_41_);
  meth_meth_collectionsPrelude_3522_findPosition_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_3522_findPosition_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3522_findPosition_40_1_41_->definitionLine = 1402;
// method "findPositionForAdd(_)"
  block_savedest(obj2987);
  Object closure3588 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure3588, stackframe);
  addtoclosure(closure3588, var_removed);
  addtoclosure(closure3588, var_unused);
  struct UserObject *uo3588 = (struct UserObject*)obj2987;
  uo3588->data[20] = (Object)closure3588;
  Method *meth_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_ = addmethod2pos(obj2987, "findPositionForAdd(1)", &meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_, 20);
  int argcv_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_);
  meth_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_3588_findPositionForAdd_40_1_41_->definitionLine = 1420;
// method "asString"
  block_savedest(obj2987);
  Object closure3664 = createclosure(2, "asString");
  setclosureframe(closure3664, stackframe);
  addtoclosure(closure3664, var_removed);
  addtoclosure(closure3664, var_unused);
  struct UserObject *uo3664 = (struct UserObject*)obj2987;
  uo3664->data[21] = (Object)closure3664;
  Method *meth_meth_collectionsPrelude_3664_asString = addmethod2pos(obj2987, "asString", &meth_collectionsPrelude_3664_asString, 21);
  int argcv_meth_collectionsPrelude_3664_asString[] = {0};
  meth_meth_collectionsPrelude_3664_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3664_asString);
  meth_meth_collectionsPrelude_3664_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3664_asString->definitionLine = 1438;
// method "asDebugString"
  block_savedest(obj2987);
  Object closure3735 = createclosure(2, "asDebugString");
  setclosureframe(closure3735, stackframe);
  addtoclosure(closure3735, var_removed);
  addtoclosure(closure3735, var_unused);
  struct UserObject *uo3735 = (struct UserObject*)obj2987;
  uo3735->data[22] = (Object)closure3735;
  Method *meth_meth_collectionsPrelude_3735_asDebugString = addmethod2pos(obj2987, "asDebugString", &meth_collectionsPrelude_3735_asDebugString, 22);
  int argcv_meth_collectionsPrelude_3735_asDebugString[] = {0};
  meth_meth_collectionsPrelude_3735_asDebugString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3735_asDebugString);
  meth_meth_collectionsPrelude_3735_asDebugString->definitionModule = modulename;
  meth_meth_collectionsPrelude_3735_asDebugString->definitionLine = 1456;
// method "keys"
  struct UserObject *uo3833 = (struct UserObject*)obj2987;
  uo3833->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3833_keys = addmethod2pos(obj2987, "keys", &meth_collectionsPrelude_3833_keys, 23);
  int argcv_meth_collectionsPrelude_3833_keys[] = {0};
  meth_meth_collectionsPrelude_3833_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3833_keys);
  meth_meth_collectionsPrelude_3833_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_3833_keys->definitionLine = 1469;
  Method *meth_meth_collectionsPrelude_3833_keys_object = addmethod2pos(obj2987, "keys$object(1)", &meth_collectionsPrelude_3833_keys_object, 23);
  int argcv_meth_collectionsPrelude_3833_keys_object[] = {0};
  meth_meth_collectionsPrelude_3833_keys_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3833_keys_object);
  meth_meth_collectionsPrelude_3833_keys_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3833_keys_object->definitionLine = 1469;
// method "values"
  struct UserObject *uo3879 = (struct UserObject*)obj2987;
  uo3879->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3879_values = addmethod2pos(obj2987, "values", &meth_collectionsPrelude_3879_values, 24);
  int argcv_meth_collectionsPrelude_3879_values[] = {0};
  meth_meth_collectionsPrelude_3879_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3879_values);
  meth_meth_collectionsPrelude_3879_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_3879_values->definitionLine = 1487;
  Method *meth_meth_collectionsPrelude_3879_values_object = addmethod2pos(obj2987, "values$object(1)", &meth_collectionsPrelude_3879_values_object, 24);
  int argcv_meth_collectionsPrelude_3879_values_object[] = {0};
  meth_meth_collectionsPrelude_3879_values_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3879_values_object);
  meth_meth_collectionsPrelude_3879_values_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3879_values_object->definitionLine = 1487;
// method "bindings"
  struct UserObject *uo3925 = (struct UserObject*)obj2987;
  uo3925->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3925_bindings = addmethod2pos(obj2987, "bindings", &meth_collectionsPrelude_3925_bindings, 25);
  int argcv_meth_collectionsPrelude_3925_bindings[] = {0};
  meth_meth_collectionsPrelude_3925_bindings->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3925_bindings);
  meth_meth_collectionsPrelude_3925_bindings->definitionModule = modulename;
  meth_meth_collectionsPrelude_3925_bindings->definitionLine = 1506;
  Method *meth_meth_collectionsPrelude_3925_bindings_object = addmethod2pos(obj2987, "bindings$object(1)", &meth_collectionsPrelude_3925_bindings_object, 25);
  int argcv_meth_collectionsPrelude_3925_bindings_object[] = {0};
  meth_meth_collectionsPrelude_3925_bindings_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3925_bindings_object);
  meth_meth_collectionsPrelude_3925_bindings_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3925_bindings_object->definitionLine = 1506;
// method "iterator"
  struct UserObject *uo3946 = (struct UserObject*)obj2987;
  uo3946->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_3946_iterator = addmethod2pos(obj2987, "iterator", &meth_collectionsPrelude_3946_iterator, 26);
  int argcv_meth_collectionsPrelude_3946_iterator[] = {0};
  meth_meth_collectionsPrelude_3946_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3946_iterator);
  meth_meth_collectionsPrelude_3946_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_3946_iterator->definitionLine = 1518;
// method "bindingsIterator"
  block_savedest(obj2987);
  Object closure3951 = createclosure(4, "bindingsIterator");
  setclosureframe(closure3951, stackframe);
  addtoclosure(closure3951, var_ConcurrentModification);
  addtoclosure(closure3951, var_IteratorExhausted);
  addtoclosure(closure3951, var_removed);
  addtoclosure(closure3951, var_unused);
  struct UserObject *uo3951 = (struct UserObject*)obj2987;
  uo3951->data[27] = (Object)closure3951;
  Method *meth_meth_collectionsPrelude_3951_bindingsIterator = addmethod2pos(obj2987, "bindingsIterator", &meth_collectionsPrelude_3951_bindingsIterator, 27);
  int argcv_meth_collectionsPrelude_3951_bindingsIterator[] = {0};
  meth_meth_collectionsPrelude_3951_bindingsIterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_3951_bindingsIterator);
  meth_meth_collectionsPrelude_3951_bindingsIterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_3951_bindingsIterator->definitionLine = 1519;
  block_savedest(obj2987);
  Object closure4072 = createclosure(4, "bindingsIterator$object(1)");
  setclosureframe(closure4072, stackframe);
  addtoclosure(closure4072, var_ConcurrentModification);
  addtoclosure(closure4072, var_IteratorExhausted);
  addtoclosure(closure4072, var_removed);
  addtoclosure(closure4072, var_unused);
  Method *meth_meth_collectionsPrelude_3951_bindingsIterator_object = addmethod2pos(obj2987, "bindingsIterator$object(1)", &meth_collectionsPrelude_3951_bindingsIterator_object, 27);
  meth_meth_collectionsPrelude_3951_bindingsIterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_3951_bindingsIterator_object->definitionLine = 1519;
// method "expand"
  block_savedest(obj2987);
  Object closure4073 = createclosure(2, "expand");
  setclosureframe(closure4073, stackframe);
  addtoclosure(closure4073, var_unused);
  addtoclosure(closure4073, var_removed);
  struct UserObject *uo4073 = (struct UserObject*)obj2987;
  uo4073->data[28] = (Object)closure4073;
  Method *meth_meth_collectionsPrelude_4073_expand = addmethod2pos(obj2987, "expand", &meth_collectionsPrelude_4073_expand, 28);
  int argcv_meth_collectionsPrelude_4073_expand[] = {0};
  meth_meth_collectionsPrelude_4073_expand->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4073_expand);
  meth_meth_collectionsPrelude_4073_expand->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_4073_expand->definitionModule = modulename;
  meth_meth_collectionsPrelude_4073_expand->definitionLine = 1542;
// method "keysAndValuesDo(_)"
  block_savedest(obj2987);
  Object closure4141 = createclosure(2, "keysAndValuesDo(1)");
  setclosureframe(closure4141, stackframe);
  addtoclosure(closure4141, var_removed);
  addtoclosure(closure4141, var_unused);
  struct UserObject *uo4141 = (struct UserObject*)obj2987;
  uo4141->data[29] = (Object)closure4141;
  Method *meth_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_ = addmethod2pos(obj2987, "keysAndValuesDo(1)", &meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_, 29);
  int argcv_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4141_keysAndValuesDo_40_1_41_->definitionLine = 1558;
// method "keysDo(_)"
  block_savedest(obj2987);
  Object closure4179 = createclosure(3, "keysDo(1)");
  setclosureframe(closure4179, stackframe);
  addtoclosure(closure4179, var_ConcurrentModification);
  addtoclosure(closure4179, var_removed);
  addtoclosure(closure4179, var_unused);
  struct UserObject *uo4179 = (struct UserObject*)obj2987;
  uo4179->data[30] = (Object)closure4179;
  Method *meth_meth_collectionsPrelude_4179_keysDo_40_1_41_ = addmethod2pos(obj2987, "keysDo(1)", &meth_collectionsPrelude_4179_keysDo_40_1_41_, 30);
  int argcv_meth_collectionsPrelude_4179_keysDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4179_keysDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4179_keysDo_40_1_41_);
  meth_meth_collectionsPrelude_4179_keysDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4179_keysDo_40_1_41_->definitionLine = 1566;
// method "valuesDo(_)"
  block_savedest(obj2987);
  Object closure4227 = createclosure(3, "valuesDo(1)");
  setclosureframe(closure4227, stackframe);
  addtoclosure(closure4227, var_ConcurrentModification);
  addtoclosure(closure4227, var_removed);
  addtoclosure(closure4227, var_unused);
  struct UserObject *uo4227 = (struct UserObject*)obj2987;
  uo4227->data[31] = (Object)closure4227;
  Method *meth_meth_collectionsPrelude_4227_valuesDo_40_1_41_ = addmethod2pos(obj2987, "valuesDo(1)", &meth_collectionsPrelude_4227_valuesDo_40_1_41_, 31);
  int argcv_meth_collectionsPrelude_4227_valuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4227_valuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4227_valuesDo_40_1_41_);
  meth_meth_collectionsPrelude_4227_valuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4227_valuesDo_40_1_41_->definitionLine = 1578;
// method "do(_)"
  struct UserObject *uo4275 = (struct UserObject*)obj2987;
  uo4275->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4275_do_40_1_41_ = addmethod2pos(obj2987, "do(1)", &meth_collectionsPrelude_4275_do_40_1_41_, 32);
  int argcv_meth_collectionsPrelude_4275_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4275_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4275_do_40_1_41_);
  meth_meth_collectionsPrelude_4275_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4275_do_40_1_41_->definitionLine = 1590;
// method "==(_)"
  block_savedest(obj2987);
  Object closure4278 = createclosure(1, "==(1)");
  setclosureframe(closure4278, stackframe);
  addtoclosure(closure4278, var_ComparableToDictionary);
  struct UserObject *uo4278 = (struct UserObject*)obj2987;
  uo4278->data[33] = (Object)closure4278;
  Method *meth_meth_collectionsPrelude_4278__61__61__40_1_41_ = addmethod2pos(obj2987, "==(1)", &meth_collectionsPrelude_4278__61__61__40_1_41_, 33);
  int argcv_meth_collectionsPrelude_4278__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4278__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4278__61__61__40_1_41_);
  meth_meth_collectionsPrelude_4278__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4278__61__61__40_1_41_->definitionLine = 1592;
// method "copy"
  struct UserObject *uo4322 = (struct UserObject*)obj2987;
  uo4322->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4322_copy = addmethod2pos(obj2987, "copy", &meth_collectionsPrelude_4322_copy, 34);
  int argcv_meth_collectionsPrelude_4322_copy[] = {0};
  meth_meth_collectionsPrelude_4322_copy->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4322_copy);
  meth_meth_collectionsPrelude_4322_copy->definitionModule = modulename;
  meth_meth_collectionsPrelude_4322_copy->definitionLine = 1608;
// method "asDictionary"
  struct UserObject *uo4334 = (struct UserObject*)obj2987;
  uo4334->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4334_asDictionary = addmethod2pos(obj2987, "asDictionary", &meth_collectionsPrelude_4334_asDictionary, 35);
  int argcv_meth_collectionsPrelude_4334_asDictionary[] = {0};
  meth_meth_collectionsPrelude_4334_asDictionary->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4334_asDictionary);
  meth_meth_collectionsPrelude_4334_asDictionary->definitionModule = modulename;
  meth_meth_collectionsPrelude_4334_asDictionary->definitionLine = 1616;
// method "++(_)"
  struct UserObject *uo4335 = (struct UserObject*)obj2987;
  uo4335->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4335__43__43__40_1_41_ = addmethod2pos(obj2987, "++(1)", &meth_collectionsPrelude_4335__43__43__40_1_41_, 36);
  int argcv_meth_collectionsPrelude_4335__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4335__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4335__43__43__40_1_41_);
  meth_meth_collectionsPrelude_4335__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4335__43__43__40_1_41_->definitionLine = 1620;
// method "--(_)"
  struct UserObject *uo4345 = (struct UserObject*)obj2987;
  uo4345->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4345__45__45__40_1_41_ = addmethod2pos(obj2987, "--(1)", &meth_collectionsPrelude_4345__45__45__40_1_41_, 37);
  int argcv_meth_collectionsPrelude_4345__45__45__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4345__45__45__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4345__45__45__40_1_41_);
  meth_meth_collectionsPrelude_4345__45__45__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4345__45__45__40_1_41_->definitionLine = 1628;
  sourceObject = obj2987;
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4362 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4363 = callmethodflags(module_collectionsPrelude, "collection$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4362);
// compiled call node returning call4363 (depth = 2)
  struct UserObject *obj2987_uo = (struct UserObject *)obj2987;
  obj2987_uo->super = call4363;
  sourceObject = obj2987;
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4364 = alloc_Float64(0);
// compiled num node returning num4364 (depth = 2)
  adddatum2(obj2987, num4364, 1);
  sourceObject = obj2987;
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4365 = alloc_Float64(0);
// compiled num node returning num4365 (depth = 2)
  adddatum2(obj2987, num4365, 2);
  sourceObject = obj2987;
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4366 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4367 = alloc_Float64(8);
// compiled num node returning num4367 (depth = 3)
  gc_frame_newslot(num4367);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4368 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4369 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4368);
// compiled member node returning call4369 (depth = 3)
  params[0] = num4367;
  partcv[0] = 1;
  Object call4370 = callmethodflags(call4369, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4366);
// compiled call node returning call4370 (depth = 2)
  adddatum2(obj2987, call4370, 3);
  sourceObject = obj2987;
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4371 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4374 = alloc_Float64(1);
// compiled num node returning num4374 (depth = 5)
  int op_slot_right_4373 = gc_frame_newslot(num4374);
// starting to compile member node (depth = 5)
  int callframe4376 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4377 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4378 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4377);
// compiled member node returning call4378 (depth = 6)
  partcv[0] = 0;
  Object call4379 = callmethodflags(call4378, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4376);
// compiled member node returning call4379 (depth = 5)
  int op_slot_left_4373 = gc_frame_newslot(call4379);
  params[0] = num4374;
  partcv[0] = 1;
  Object diff4380 = callmethod(call4379, "-(1)", 1, partcv, params);
// compiled op node returning diff4380 (depth = 4)
  int op_slot_right_4372 = gc_frame_newslot(diff4380);
// starting to compile num node (depth = 4)
  Object num4382 = alloc_Float64(0);
// compiled num node returning num4382 (depth = 4)
  int op_slot_left_4372 = gc_frame_newslot(num4382);
  params[0] = diff4380;
  partcv[0] = 1;
  Object opresult4383 = callmethod(num4382, "..(1)", 1, partcv, params);
// compiled op node returning opresult4383 (depth = 3)
  gc_frame_newslot(opresult4383);
// starting to compile block node (depth = 3)
  Object block4384 = alloc_Block(NULL, NULL, "collectionsPrelude", 1262);
  gc_frame_newslot(block4384);
// method "_apply(_)"
  block_savedest(block4384);
  Object closure4385 = createclosure(2, "_apply(1)");
  setclosureframe(closure4385, stackframe);
  addtoclosure(closure4385, var_unused);
  addtoclosure(closure4385, selfslot);
  struct UserObject *uo4385 = (struct UserObject*)block4384;
  uo4385->data[0] = (Object)closure4385;
  Method *meth_meth_collectionsPrelude_4385__apply_40_1_41_ = addmethod2pos(block4384, "_apply(1)", &meth_collectionsPrelude_4385__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4385__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4385__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4385__apply_40_1_41_);
  meth_meth_collectionsPrelude_4385__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4385__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block4384 (depth = 3)
  gc_frame_newslot(block4384);
// call case 5: prelude request
  params[0] = opresult4383;
  params[1] = block4384;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4391 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4371);
// compiled call node returning call4391 (depth = 2)
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  sourceObject = obj2987;
  objclass2987 = obj2987->class;
  objclass2987->definitionModule = modulename;
  objclass2987->definitionLine = 1257;
  (*(struct UserObject *)self).data[0] = lowerouter2987;
  self = oldself2987;
  selfslot = oldselfslot2987;
  stackframe = oldstackframe2987;
  gc_frame_end(frame);
  return obj2987;
}
Object meth_collectionsPrelude_2971_dictionary(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_IteratorExhausted = getfromclosure(closure, 5);
  Object *var_ComparableToDictionary = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_K = &(stackframe->slots[1]);
  Object *var_T = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_K = args[curarg++];
    *var_T = args[curarg++];
  } else {
    *var_K = Unknown;
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2972 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2972 = alloc_userobj2(4,5, objclass2972);
  gc_frame_newslot(obj2972);
  if (objclass2972 == NULL) {
    glfree(obj2972->class->name);
    obj2972->class->name = "dictionary";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2972, self, 0);
  addmethodreal(obj2972,"outer", &reader_collectionsPrelude_outer_2973);
  Object oldself2972 = self;
  struct StackFrameObject *oldstackframe2972 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2972);
  gc_frame_newslot((Object)stackframe);
  self = obj2972;
  Object *oldselfslot2972 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2972 = (*(struct UserObject *)self).data[0], lowerouter2972 = thisouter2972;
  if (inheritingObject2972) {
    struct UserObject *inho2972 = (struct UserObject *)inheritingObject2972;
    while (inho2972->super != GraceDefaultObject) inho2972 = (struct UserObject *)inho2972->super;
    inho2972->super = obj2972;
    self = inheritingObject2972;
    *selfslot = self;
    lowerouter2972 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2972;
  }
// method "asString"
  struct UserObject *uo2974 = (struct UserObject*)obj2972;
  uo2974->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2974_asString = addmethod2pos(obj2972, "asString", &meth_collectionsPrelude_2974_asString, 1);
  int argcv_meth_collectionsPrelude_2974_asString[] = {0};
  meth_meth_collectionsPrelude_2974_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2974_asString);
  meth_meth_collectionsPrelude_2974_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_2974_asString->definitionLine = 1249;
// method "withAll(_)"
  struct UserObject *uo2976 = (struct UserObject*)obj2972;
  uo2976->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2976_withAll_40_1_41_ = addmethod2pos(obj2972, "withAll(1)", &meth_collectionsPrelude_2976_withAll_40_1_41_, 2);
  int argcv_meth_collectionsPrelude_2976_withAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2976_withAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2976_withAll_40_1_41_);
  meth_meth_collectionsPrelude_2976_withAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2976_withAll_40_1_41_->definitionLine = 1251;
// method "empty"
  block_savedest(obj2972);
  Object closure2986 = createclosure(7, "empty");
  setclosureframe(closure2986, stackframe);
  addtoclosure(closure2986, var_removed);
  addtoclosure(closure2986, var_unused);
  addtoclosure(closure2986, var_binding);
  addtoclosure(closure2986, var_NoSuchObject);
  addtoclosure(closure2986, var_ConcurrentModification);
  addtoclosure(closure2986, var_IteratorExhausted);
  addtoclosure(closure2986, var_ComparableToDictionary);
  struct UserObject *uo2986 = (struct UserObject*)obj2972;
  uo2986->data[3] = (Object)closure2986;
  Method *meth_meth_collectionsPrelude_2986_empty = addmethod2pos(obj2972, "empty", &meth_collectionsPrelude_2986_empty, 3);
  int argcv_meth_collectionsPrelude_2986_empty[] = {0};
  meth_meth_collectionsPrelude_2986_empty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2986_empty);
  meth_meth_collectionsPrelude_2986_empty->definitionModule = modulename;
  meth_meth_collectionsPrelude_2986_empty->definitionLine = 1257;
  block_savedest(obj2972);
  Object closure4392 = createclosure(7, "empty$object(1)");
  setclosureframe(closure4392, stackframe);
  addtoclosure(closure4392, var_removed);
  addtoclosure(closure4392, var_unused);
  addtoclosure(closure4392, var_binding);
  addtoclosure(closure4392, var_NoSuchObject);
  addtoclosure(closure4392, var_ConcurrentModification);
  addtoclosure(closure4392, var_IteratorExhausted);
  addtoclosure(closure4392, var_ComparableToDictionary);
  Method *meth_meth_collectionsPrelude_2986_empty_object = addmethod2pos(obj2972, "empty$object(1)", &meth_collectionsPrelude_2986_empty_object, 3);
  meth_meth_collectionsPrelude_2986_empty_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_2986_empty_object->definitionLine = 1257;
  sourceObject = obj2972;
  sourceObject = obj2972;
  sourceObject = obj2972;
  objclass2972 = obj2972->class;
  objclass2972->definitionModule = modulename;
  objclass2972->definitionLine = 1247;
  (*(struct UserObject *)self).data[0] = lowerouter2972;
  self = oldself2972;
  selfslot = oldselfslot2972;
  stackframe = oldstackframe2972;
  gc_frame_end(frame);
  return obj2972;
}
Object meth_collectionsPrelude_2971_dictionary_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dictionary$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_IteratorExhausted = getfromclosure(closure, 5);
  Object *var_ComparableToDictionary = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_K = &(stackframe->slots[1]);
  Object *var_T = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_K = args[curarg++];
    *var_T = args[curarg++];
  } else {
    *var_K = Unknown;
    *var_T = Unknown;
  }
// End typeParams
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2972 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2972 = alloc_userobj2(4,5, objclass2972);
  gc_frame_newslot(obj2972);
  if (objclass2972 == NULL) {
    glfree(obj2972->class->name);
    obj2972->class->name = "dictionary";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj2972, self, 0);
  addmethodreal(obj2972,"outer", &reader_collectionsPrelude_outer_2973);
  Object oldself2972 = self;
  struct StackFrameObject *oldstackframe2972 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2972);
  gc_frame_newslot((Object)stackframe);
  self = obj2972;
  Object *oldselfslot2972 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2972 = (*(struct UserObject *)self).data[0], lowerouter2972 = thisouter2972;
  if (inheritingObject2972) {
    struct UserObject *inho2972 = (struct UserObject *)inheritingObject2972;
    while (inho2972->super != GraceDefaultObject) inho2972 = (struct UserObject *)inho2972->super;
    inho2972->super = obj2972;
    self = inheritingObject2972;
    *selfslot = self;
    lowerouter2972 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2972;
  }
// method "asString"
  struct UserObject *uo2974 = (struct UserObject*)obj2972;
  uo2974->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2974_asString = addmethod2pos(obj2972, "asString", &meth_collectionsPrelude_2974_asString, 1);
  int argcv_meth_collectionsPrelude_2974_asString[] = {0};
  meth_meth_collectionsPrelude_2974_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2974_asString);
  meth_meth_collectionsPrelude_2974_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_2974_asString->definitionLine = 1249;
// method "withAll(_)"
  struct UserObject *uo2976 = (struct UserObject*)obj2972;
  uo2976->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_2976_withAll_40_1_41_ = addmethod2pos(obj2972, "withAll(1)", &meth_collectionsPrelude_2976_withAll_40_1_41_, 2);
  int argcv_meth_collectionsPrelude_2976_withAll_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_2976_withAll_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2976_withAll_40_1_41_);
  meth_meth_collectionsPrelude_2976_withAll_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_2976_withAll_40_1_41_->definitionLine = 1251;
// method "empty"
  block_savedest(obj2972);
  Object closure2986 = createclosure(7, "empty");
  setclosureframe(closure2986, stackframe);
  addtoclosure(closure2986, var_removed);
  addtoclosure(closure2986, var_unused);
  addtoclosure(closure2986, var_binding);
  addtoclosure(closure2986, var_NoSuchObject);
  addtoclosure(closure2986, var_ConcurrentModification);
  addtoclosure(closure2986, var_IteratorExhausted);
  addtoclosure(closure2986, var_ComparableToDictionary);
  struct UserObject *uo2986 = (struct UserObject*)obj2972;
  uo2986->data[3] = (Object)closure2986;
  Method *meth_meth_collectionsPrelude_2986_empty = addmethod2pos(obj2972, "empty", &meth_collectionsPrelude_2986_empty, 3);
  int argcv_meth_collectionsPrelude_2986_empty[] = {0};
  meth_meth_collectionsPrelude_2986_empty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2986_empty);
  meth_meth_collectionsPrelude_2986_empty->definitionModule = modulename;
  meth_meth_collectionsPrelude_2986_empty->definitionLine = 1257;
  block_savedest(obj2972);
  Object closure4392 = createclosure(7, "empty$object(1)");
  setclosureframe(closure4392, stackframe);
  addtoclosure(closure4392, var_removed);
  addtoclosure(closure4392, var_unused);
  addtoclosure(closure4392, var_binding);
  addtoclosure(closure4392, var_NoSuchObject);
  addtoclosure(closure4392, var_ConcurrentModification);
  addtoclosure(closure4392, var_IteratorExhausted);
  addtoclosure(closure4392, var_ComparableToDictionary);
  Method *meth_meth_collectionsPrelude_2986_empty_object = addmethod2pos(obj2972, "empty$object(1)", &meth_collectionsPrelude_2986_empty_object, 3);
  meth_meth_collectionsPrelude_2986_empty_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_2986_empty_object->definitionLine = 1257;
  sourceObject = obj2972;
  sourceObject = obj2972;
  sourceObject = obj2972;
  objclass2972 = obj2972->class;
  objclass2972->definitionModule = modulename;
  objclass2972->definitionLine = 1247;
  (*(struct UserObject *)self).data[0] = lowerouter2972;
  self = oldself2972;
  selfslot = oldselfslot2972;
  stackframe = oldstackframe2972;
  gc_frame_end(frame);
  return obj2972;
}
Object meth_collectionsPrelude_4400__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___6 = &(stackframe->slots[0]);
  *var___6 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_4412__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___7 = &(stackframe->slots[0]);
  *var___7 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe4413 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4416 == NULL) {
    strlit4416 = alloc_String(") is not an integer");
    gc_root(strlit4416);
  }
// compiled string node returning strlit4416 (depth = 7)
  int op_slot_right_4415 = gc_frame_newslot(strlit4416);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4418 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4421 == NULL) {
    strlit4421 = alloc_String(")to(");
    gc_root(strlit4421);
  }
// compiled string node returning strlit4421 (depth = 9)
  int op_slot_right_4420 = gc_frame_newslot(strlit4421);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lower (depth = 10)
  int op_slot_right_4423 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 10)
  if (strlit4425 == NULL) {
    strlit4425 = alloc_String(" in range.from(");
    gc_root(strlit4425);
  }
// compiled string node returning strlit4425 (depth = 10)
  int op_slot_left_4423 = gc_frame_newslot(strlit4425);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4426 = callmethod(strlit4425, "++(1)", 1, partcv, params);
// compiled op node returning opresult4426 (depth = 9)
  int op_slot_left_4420 = gc_frame_newslot(opresult4426);
  params[0] = strlit4421;
  partcv[0] = 1;
  Object opresult4427 = callmethod(opresult4426, "++(1)", 1, partcv, params);
// compiled op node returning opresult4427 (depth = 8)
  int op_slot_left_4418 = gc_frame_newslot(opresult4427);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4428 = callmethod(opresult4427, "++(1)", 1, partcv, params);
// compiled op node returning opresult4428 (depth = 7)
  int op_slot_left_4415 = gc_frame_newslot(opresult4428);
  params[0] = strlit4416;
  partcv[0] = 1;
  Object opresult4429 = callmethod(opresult4428, "++(1)", 1, partcv, params);
// compiled op node returning opresult4429 (depth = 6)
  int op_slot_right_4414 = gc_frame_newslot(opresult4429);
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4432 == NULL) {
    strlit4432 = alloc_String("");
    gc_root(strlit4432);
  }
// compiled string node returning strlit4432 (depth = 7)
  int op_slot_right_4431 = gc_frame_newslot(strlit4432);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_4434 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit4436 == NULL) {
    strlit4436 = alloc_String("lower bound ");
    gc_root(strlit4436);
  }
// compiled string node returning strlit4436 (depth = 8)
  int op_slot_left_4434 = gc_frame_newslot(strlit4436);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4437 = callmethod(strlit4436, "++(1)", 1, partcv, params);
// compiled op node returning opresult4437 (depth = 7)
  int op_slot_left_4431 = gc_frame_newslot(opresult4437);
  params[0] = strlit4432;
  partcv[0] = 1;
  Object opresult4438 = callmethod(opresult4437, "++(1)", 1, partcv, params);
// compiled op node returning opresult4438 (depth = 6)
  int op_slot_left_4414 = gc_frame_newslot(opresult4438);
  params[0] = opresult4429;
  partcv[0] = 1;
  Object opresult4439 = callmethod(opresult4438, "++(1)", 1, partcv, params);
// compiled op node returning opresult4439 (depth = 5)
  gc_frame_newslot(opresult4439);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4439;
  partcv[0] = 1;
  Object call4440 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4413);
// compiled call node returning call4440 (depth = 4)
  gc_frame_end(frame);
  return call4440;
}
Object meth_collectionsPrelude_4478__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___8 = &(stackframe->slots[0]);
  *var___8 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_4490__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___9 = &(stackframe->slots[0]);
  *var___9 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe4491 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4494 == NULL) {
    strlit4494 = alloc_String(") is not an integer");
    gc_root(strlit4494);
  }
// compiled string node returning strlit4494 (depth = 7)
  int op_slot_right_4493 = gc_frame_newslot(strlit4494);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4496 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4499 == NULL) {
    strlit4499 = alloc_String(")to(");
    gc_root(strlit4499);
  }
// compiled string node returning strlit4499 (depth = 9)
  int op_slot_right_4498 = gc_frame_newslot(strlit4499);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lower (depth = 10)
  int op_slot_right_4501 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 10)
  if (strlit4503 == NULL) {
    strlit4503 = alloc_String(" in range.from(");
    gc_root(strlit4503);
  }
// compiled string node returning strlit4503 (depth = 10)
  int op_slot_left_4501 = gc_frame_newslot(strlit4503);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4504 = callmethod(strlit4503, "++(1)", 1, partcv, params);
// compiled op node returning opresult4504 (depth = 9)
  int op_slot_left_4498 = gc_frame_newslot(opresult4504);
  params[0] = strlit4499;
  partcv[0] = 1;
  Object opresult4505 = callmethod(opresult4504, "++(1)", 1, partcv, params);
// compiled op node returning opresult4505 (depth = 8)
  int op_slot_left_4496 = gc_frame_newslot(opresult4505);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4506 = callmethod(opresult4505, "++(1)", 1, partcv, params);
// compiled op node returning opresult4506 (depth = 7)
  int op_slot_left_4493 = gc_frame_newslot(opresult4506);
  params[0] = strlit4494;
  partcv[0] = 1;
  Object opresult4507 = callmethod(opresult4506, "++(1)", 1, partcv, params);
// compiled op node returning opresult4507 (depth = 6)
  int op_slot_right_4492 = gc_frame_newslot(opresult4507);
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4510 == NULL) {
    strlit4510 = alloc_String("");
    gc_root(strlit4510);
  }
// compiled string node returning strlit4510 (depth = 7)
  int op_slot_right_4509 = gc_frame_newslot(strlit4510);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4512 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit4514 == NULL) {
    strlit4514 = alloc_String("upper bound ");
    gc_root(strlit4514);
  }
// compiled string node returning strlit4514 (depth = 8)
  int op_slot_left_4512 = gc_frame_newslot(strlit4514);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4515 = callmethod(strlit4514, "++(1)", 1, partcv, params);
// compiled op node returning opresult4515 (depth = 7)
  int op_slot_left_4509 = gc_frame_newslot(opresult4515);
  params[0] = strlit4510;
  partcv[0] = 1;
  Object opresult4516 = callmethod(opresult4515, "++(1)", 1, partcv, params);
// compiled op node returning opresult4516 (depth = 6)
  int op_slot_left_4492 = gc_frame_newslot(opresult4516);
  params[0] = opresult4507;
  partcv[0] = 1;
  Object opresult4517 = callmethod(opresult4516, "++(1)", 1, partcv, params);
// compiled op node returning opresult4517 (depth = 5)
  gc_frame_newslot(opresult4517);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4517;
  partcv[0] = 1;
  Object call4518 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4491);
// compiled call node returning call4518 (depth = 4)
  gc_frame_end(frame);
  return call4518;
}
Object meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from(1)to(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)to(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)to(_)");
  Object params[2];
  int partcv[2];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from(_)to(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
// definebindings:
// definebindings:
  Object *var_stop = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "stop");
// definebindings:
// definebindings:
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame4398 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4399 = alloc_Block(NULL, NULL, "collectionsPrelude", 1643);
  gc_frame_newslot(block4399);
// method "_apply(_)"
  block_savedest(block4399);
  Object closure4400 = createclosure(1, "_apply(1)");
  setclosureframe(closure4400, stackframe);
  addtoclosure(closure4400, selfslot);
  struct UserObject *uo4400 = (struct UserObject*)block4399;
  uo4400->data[0] = (Object)closure4400;
  Method *meth_meth_collectionsPrelude_4400__apply_40_1_41_ = addmethod2pos(block4399, "_apply(1)", &meth_collectionsPrelude_4400__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4400__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4400__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4400__apply_40_1_41_);
meth_meth_collectionsPrelude_4400__apply_40_1_41_->type->types[0] = type_Number;
meth_meth_collectionsPrelude_4400__apply_40_1_41_->type->names[0] = "__6";
  meth_meth_collectionsPrelude_4400__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4400__apply_40_1_41_->definitionLine = 1769;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4402 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4403 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4404 == NULL) {
    strlit4404 = alloc_String("__6");
    gc_root(strlit4404);
  }
// compiled string node returning strlit4404 (depth = 6)
  gc_frame_newslot(strlit4404);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4405 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4406 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4405);
// compiled member node returning call4406 (depth = 6)
  params[0] = strlit4404;
  partcv[0] = 1;
  Object call4407 = callmethodflags(call4406, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4403);
// compiled call node returning call4407 (depth = 5)
  gc_frame_newslot(call4407);
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4408 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4409 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4408);
// compiled member node returning call4409 (depth = 5)
  params[0] = call4407;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4410 = callmethodflags(call4409, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4402);
// compiled call node returning call4410 (depth = 4)
((struct UserObject *)block4399)->data[1] = call4410;
// compiled block node returning block4399 (depth = 3)
  gc_frame_newslot(block4399);
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4411 = alloc_Block(NULL, NULL, "collectionsPrelude", 1644);
  gc_frame_newslot(block4411);
// method "_apply(_)"
  block_savedest(block4411);
  Object closure4412 = createclosure(4, "_apply(1)");
  setclosureframe(closure4412, stackframe);
  addtoclosure(closure4412, var_upper);
  addtoclosure(closure4412, var_lower);
  addtoclosure(closure4412, var_RequestError);
  addtoclosure(closure4412, selfslot);
  struct UserObject *uo4412 = (struct UserObject*)block4411;
  uo4412->data[0] = (Object)closure4412;
  Method *meth_meth_collectionsPrelude_4412__apply_40_1_41_ = addmethod2pos(block4411, "_apply(1)", &meth_collectionsPrelude_4412__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4412__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4412__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4412__apply_40_1_41_);
  meth_meth_collectionsPrelude_4412__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4412__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block4411 (depth = 3)
  gc_frame_newslot(block4411);
  params[0] = block4399;
  params[1] = block4411;
  Object matchres4398 = matchCase(*var_lower, params, 2);
  gc_frame_end(frame4398);
// compiled matchcase node returning matchres4398 (depth = 2)
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4442 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  partcv[0] = 0;
  Object call4443 = callmethodflags(*var_lower, "truncated", 1, partcv, params, 0);
  gc_frame_end(callframe4442);
// compiled member node returning call4443 (depth = 3)
  *var_start = call4443;
  if (call4443 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_4445 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  int op_slot_left_4445 = gc_frame_newslot(*var_start);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4447 = callmethod(*var_start, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4447 (depth = 3)
  Object if4444 = done;
  if (istrue(opresult4447)) {
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4448 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4451 == NULL) {
    strlit4451 = alloc_String(") is not an integer");
    gc_root(strlit4451);
  }
// compiled string node returning strlit4451 (depth = 6)
  int op_slot_right_4450 = gc_frame_newslot(strlit4451);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4453 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4456 == NULL) {
    strlit4456 = alloc_String(")to(");
    gc_root(strlit4456);
  }
// compiled string node returning strlit4456 (depth = 8)
  int op_slot_right_4455 = gc_frame_newslot(strlit4456);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lower (depth = 9)
  int op_slot_right_4458 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 9)
  if (strlit4460 == NULL) {
    strlit4460 = alloc_String(" in range.from(");
    gc_root(strlit4460);
  }
// compiled string node returning strlit4460 (depth = 9)
  int op_slot_left_4458 = gc_frame_newslot(strlit4460);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4461 = callmethod(strlit4460, "++(1)", 1, partcv, params);
// compiled op node returning opresult4461 (depth = 8)
  int op_slot_left_4455 = gc_frame_newslot(opresult4461);
  params[0] = strlit4456;
  partcv[0] = 1;
  Object opresult4462 = callmethod(opresult4461, "++(1)", 1, partcv, params);
// compiled op node returning opresult4462 (depth = 7)
  int op_slot_left_4453 = gc_frame_newslot(opresult4462);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4463 = callmethod(opresult4462, "++(1)", 1, partcv, params);
// compiled op node returning opresult4463 (depth = 6)
  int op_slot_left_4450 = gc_frame_newslot(opresult4463);
  params[0] = strlit4451;
  partcv[0] = 1;
  Object opresult4464 = callmethod(opresult4463, "++(1)", 1, partcv, params);
// compiled op node returning opresult4464 (depth = 5)
  int op_slot_right_4449 = gc_frame_newslot(opresult4464);
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4467 == NULL) {
    strlit4467 = alloc_String("");
    gc_root(strlit4467);
  }
// compiled string node returning strlit4467 (depth = 6)
  int op_slot_right_4466 = gc_frame_newslot(strlit4467);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_4469 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit4471 == NULL) {
    strlit4471 = alloc_String("lower bound ");
    gc_root(strlit4471);
  }
// compiled string node returning strlit4471 (depth = 7)
  int op_slot_left_4469 = gc_frame_newslot(strlit4471);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4472 = callmethod(strlit4471, "++(1)", 1, partcv, params);
// compiled op node returning opresult4472 (depth = 6)
  int op_slot_left_4466 = gc_frame_newslot(opresult4472);
  params[0] = strlit4467;
  partcv[0] = 1;
  Object opresult4473 = callmethod(opresult4472, "++(1)", 1, partcv, params);
// compiled op node returning opresult4473 (depth = 5)
  int op_slot_left_4449 = gc_frame_newslot(opresult4473);
  params[0] = opresult4464;
  partcv[0] = 1;
  Object opresult4474 = callmethod(opresult4473, "++(1)", 1, partcv, params);
// compiled op node returning opresult4474 (depth = 4)
  gc_frame_newslot(opresult4474);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult4474;
  partcv[0] = 1;
  Object call4475 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4448);
// compiled call node returning call4475 (depth = 3)
    gc_frame_newslot(call4475);
    if4444 = call4475;
  } else {
  }
// compiled if node returning if4444 (depth = 2)
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame4476 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4477 = alloc_Block(NULL, NULL, "collectionsPrelude", 1652);
  gc_frame_newslot(block4477);
// method "_apply(_)"
  block_savedest(block4477);
  Object closure4478 = createclosure(1, "_apply(1)");
  setclosureframe(closure4478, stackframe);
  addtoclosure(closure4478, selfslot);
  struct UserObject *uo4478 = (struct UserObject*)block4477;
  uo4478->data[0] = (Object)closure4478;
  Method *meth_meth_collectionsPrelude_4478__apply_40_1_41_ = addmethod2pos(block4477, "_apply(1)", &meth_collectionsPrelude_4478__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4478__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4478__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4478__apply_40_1_41_);
meth_meth_collectionsPrelude_4478__apply_40_1_41_->type->types[0] = type_Number;
meth_meth_collectionsPrelude_4478__apply_40_1_41_->type->names[0] = "__8";
  meth_meth_collectionsPrelude_4478__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4478__apply_40_1_41_->definitionLine = 1769;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4480 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4481 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4482 == NULL) {
    strlit4482 = alloc_String("__8");
    gc_root(strlit4482);
  }
// compiled string node returning strlit4482 (depth = 6)
  gc_frame_newslot(strlit4482);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4483 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4484 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4483);
// compiled member node returning call4484 (depth = 6)
  params[0] = strlit4482;
  partcv[0] = 1;
  Object call4485 = callmethodflags(call4484, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4481);
// compiled call node returning call4485 (depth = 5)
  gc_frame_newslot(call4485);
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4486 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4487 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4486);
// compiled member node returning call4487 (depth = 5)
  params[0] = call4485;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4488 = callmethodflags(call4487, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4480);
// compiled call node returning call4488 (depth = 4)
((struct UserObject *)block4477)->data[1] = call4488;
// compiled block node returning block4477 (depth = 3)
  gc_frame_newslot(block4477);
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4489 = alloc_Block(NULL, NULL, "collectionsPrelude", 1653);
  gc_frame_newslot(block4489);
// method "_apply(_)"
  block_savedest(block4489);
  Object closure4490 = createclosure(4, "_apply(1)");
  setclosureframe(closure4490, stackframe);
  addtoclosure(closure4490, var_upper);
  addtoclosure(closure4490, var_lower);
  addtoclosure(closure4490, var_RequestError);
  addtoclosure(closure4490, selfslot);
  struct UserObject *uo4490 = (struct UserObject*)block4489;
  uo4490->data[0] = (Object)closure4490;
  Method *meth_meth_collectionsPrelude_4490__apply_40_1_41_ = addmethod2pos(block4489, "_apply(1)", &meth_collectionsPrelude_4490__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4490__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4490__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4490__apply_40_1_41_);
  meth_meth_collectionsPrelude_4490__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4490__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block4489 (depth = 3)
  gc_frame_newslot(block4489);
  params[0] = block4477;
  params[1] = block4489;
  Object matchres4476 = matchCase(*var_upper, params, 2);
  gc_frame_end(frame4476);
// compiled matchcase node returning matchres4476 (depth = 2)
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4520 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  partcv[0] = 0;
  Object call4521 = callmethodflags(*var_upper, "truncated", 1, partcv, params, 0);
  gc_frame_end(callframe4520);
// compiled member node returning call4521 (depth = 3)
  *var_stop = call4521;
  if (call4521 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4523 = gc_frame_newslot(*var_upper);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_stop (depth = 4)
  int op_slot_left_4523 = gc_frame_newslot(*var_stop);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4525 = callmethod(*var_stop, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4525 (depth = 3)
  Object if4522 = done;
  if (istrue(opresult4525)) {
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4526 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4528 == NULL) {
    strlit4528 = alloc_String(" in range.from()to() is not an integer");
    gc_root(strlit4528);
  }
// compiled string node returning strlit4528 (depth = 5)
  int op_slot_right_4527 = gc_frame_newslot(strlit4528);
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4531 == NULL) {
    strlit4531 = alloc_String("");
    gc_root(strlit4531);
  }
// compiled string node returning strlit4531 (depth = 6)
  int op_slot_right_4530 = gc_frame_newslot(strlit4531);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4533 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit4535 == NULL) {
    strlit4535 = alloc_String("upper bound ");
    gc_root(strlit4535);
  }
// compiled string node returning strlit4535 (depth = 7)
  int op_slot_left_4533 = gc_frame_newslot(strlit4535);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4536 = callmethod(strlit4535, "++(1)", 1, partcv, params);
// compiled op node returning opresult4536 (depth = 6)
  int op_slot_left_4530 = gc_frame_newslot(opresult4536);
  params[0] = strlit4531;
  partcv[0] = 1;
  Object opresult4537 = callmethod(opresult4536, "++(1)", 1, partcv, params);
// compiled op node returning opresult4537 (depth = 5)
  int op_slot_left_4527 = gc_frame_newslot(opresult4537);
  params[0] = strlit4528;
  partcv[0] = 1;
  Object opresult4538 = callmethod(opresult4537, "++(1)", 1, partcv, params);
// compiled op node returning opresult4538 (depth = 4)
  gc_frame_newslot(opresult4538);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult4538;
  partcv[0] = 1;
  Object call4539 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4526);
// compiled call node returning call4539 (depth = 3)
    gc_frame_newslot(call4539);
    if4522 = call4539;
  } else {
  }
// compiled if node returning if4522 (depth = 2)
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4540 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// call case 4: self request
  params[0] = *var_lower;
  params[1] = *var_upper;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4541 = callmethodflags(self, "uncheckedFrom(1)to(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4540);
// compiled call node returning call4541 (depth = 2)
  gc_frame_end(frame);
  return call4541;
}
Object meth_collectionsPrelude_4553_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4555 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4556 = gc_frame_new();
// call case 3: self.outer request
  Object call4557 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4556);
// compiled member node returning call4557 (depth = 4)
  partcv[0] = 0;
  Object call4558 = callmethodflags(call4557, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4555);
// compiled member node returning call4558 (depth = 3)
  int op_slot_right_4554 = gc_frame_newslot(call4558);
// starting to compile member node (depth = 3)
  int callframe4560 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4561 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4560);
// compiled member node returning call4561 (depth = 3)
  int op_slot_left_4554 = gc_frame_newslot(call4561);
  params[0] = call4558;
  partcv[0] = 1;
  Object opresult4562 = callmethod(call4561, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4562 (depth = 2)
  gc_frame_end(frame);
  return opresult4562;
}
Object meth_collectionsPrelude_4563_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4566 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4567 = gc_frame_new();
// call case 3: self.outer request
  Object call4568 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4567);
// compiled member node returning call4568 (depth = 5)
  partcv[0] = 0;
  Object call4569 = callmethodflags(call4568, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4566);
// compiled member node returning call4569 (depth = 4)
  int op_slot_right_4565 = gc_frame_newslot(call4569);
// starting to compile member node (depth = 4)
  int callframe4571 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4572 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4571);
// compiled member node returning call4572 (depth = 4)
  int op_slot_left_4565 = gc_frame_newslot(call4572);
  params[0] = call4569;
  partcv[0] = 1;
  Object opresult4573 = callmethod(call4572, ">(1)", 1, partcv, params);
// compiled op node returning opresult4573 (depth = 3)
  Object if4564 = done;
  if (istrue(opresult4573)) {
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4574 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4576 == NULL) {
    strlit4576 = alloc_String("");
    gc_root(strlit4576);
  }
// compiled string node returning strlit4576 (depth = 5)
  int op_slot_right_4575 = gc_frame_newslot(strlit4576);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4579 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4580 = gc_frame_new();
// call case 3: self.outer request
  Object call4581 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4580);
// compiled member node returning call4581 (depth = 7)
  partcv[0] = 0;
  Object call4582 = callmethodflags(call4581, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4579);
// compiled member node returning call4582 (depth = 6)
  int op_slot_right_4578 = gc_frame_newslot(call4582);
// starting to compile string node (depth = 6)
  if (strlit4584 == NULL) {
    strlit4584 = alloc_String("over ");
    gc_root(strlit4584);
  }
// compiled string node returning strlit4584 (depth = 6)
  int op_slot_left_4578 = gc_frame_newslot(strlit4584);
  params[0] = call4582;
  partcv[0] = 1;
  Object opresult4585 = callmethod(strlit4584, "++(1)", 1, partcv, params);
// compiled op node returning opresult4585 (depth = 5)
  int op_slot_left_4575 = gc_frame_newslot(opresult4585);
  params[0] = strlit4576;
  partcv[0] = 1;
  Object opresult4586 = callmethod(opresult4585, "++(1)", 1, partcv, params);
// compiled op node returning opresult4586 (depth = 4)
  gc_frame_newslot(opresult4586);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4586;
  partcv[0] = 1;
  Object call4587 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4574);
// compiled call node returning call4587 (depth = 3)
    gc_frame_newslot(call4587);
    if4564 = call4587;
  } else {
  }
// compiled if node returning if4564 (depth = 2)
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4588 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4590 = alloc_Float64(1);
// compiled num node returning num4590 (depth = 4)
  int op_slot_right_4589 = gc_frame_newslot(num4590);
// starting to compile member node (depth = 4)
  int callframe4592 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4593 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4592);
// compiled member node returning call4593 (depth = 4)
  int op_slot_left_4589 = gc_frame_newslot(call4593);
  params[0] = num4590;
  partcv[0] = 1;
  Object sum4594 = callmethod(call4593, "+(1)", 1, partcv, params);
// compiled op node returning sum4594 (depth = 3)
  gc_frame_newslot(sum4594);
// call case 4: self request
  params[0] = sum4594;
  partcv[0] = 1;
  Object call4595 = callmethodflags(self, "val:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4588);
// compiled call node returning call4595 (depth = 2)
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4597 = alloc_Float64(1);
// compiled num node returning num4597 (depth = 4)
  int op_slot_right_4596 = gc_frame_newslot(num4597);
// starting to compile member node (depth = 4)
  int callframe4599 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4600 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4599);
// compiled member node returning call4600 (depth = 4)
  int op_slot_left_4596 = gc_frame_newslot(call4600);
  params[0] = num4597;
  partcv[0] = 1;
  Object diff4601 = callmethod(call4600, "-(1)", 1, partcv, params);
// compiled op node returning diff4601 (depth = 3)
  return diff4601;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_4602_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4604 == NULL) {
    strlit4604 = alloc_String("");
    gc_root(strlit4604);
  }
// compiled string node returning strlit4604 (depth = 3)
  int op_slot_right_4603 = gc_frame_newslot(strlit4604);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4607 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4608 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4607);
// compiled member node returning call4608 (depth = 4)
  int op_slot_right_4606 = gc_frame_newslot(call4608);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4611 == NULL) {
    strlit4611 = alloc_String(" at ");
    gc_root(strlit4611);
  }
// compiled string node returning strlit4611 (depth = 5)
  int op_slot_right_4610 = gc_frame_newslot(strlit4611);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4614 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4615 = gc_frame_new();
// call case 3: self.outer request
  Object call4616 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4615);
// compiled member node returning call4616 (depth = 7)
  partcv[0] = 0;
  Object call4617 = callmethodflags(call4616, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4614);
// compiled member node returning call4617 (depth = 6)
  int op_slot_right_4613 = gc_frame_newslot(call4617);
// starting to compile string node (depth = 6)
  if (strlit4619 == NULL) {
    strlit4619 = alloc_String("iterator over ");
    gc_root(strlit4619);
  }
// compiled string node returning strlit4619 (depth = 6)
  int op_slot_left_4613 = gc_frame_newslot(strlit4619);
  params[0] = call4617;
  partcv[0] = 1;
  Object opresult4620 = callmethod(strlit4619, "++(1)", 1, partcv, params);
// compiled op node returning opresult4620 (depth = 5)
  int op_slot_left_4610 = gc_frame_newslot(opresult4620);
  params[0] = strlit4611;
  partcv[0] = 1;
  Object opresult4621 = callmethod(opresult4620, "++(1)", 1, partcv, params);
// compiled op node returning opresult4621 (depth = 4)
  int op_slot_left_4606 = gc_frame_newslot(opresult4621);
  params[0] = call4608;
  partcv[0] = 1;
  Object opresult4622 = callmethod(opresult4621, "++(1)", 1, partcv, params);
// compiled op node returning opresult4622 (depth = 3)
  int op_slot_left_4603 = gc_frame_newslot(opresult4622);
  params[0] = strlit4604;
  partcv[0] = 1;
  Object opresult4623 = callmethod(opresult4622, "++(1)", 1, partcv, params);
// compiled op node returning opresult4623 (depth = 2)
  gc_frame_end(frame);
  return opresult4623;
}
Object meth_collectionsPrelude_4549_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4550 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4550 = alloc_userobj2(5,5, objclass4550);
  gc_frame_newslot(obj4550);
  if (objclass4550 == NULL) {
    glfree(obj4550->class->name);
    obj4550->class->name = "range.uncheckedFrom(_)to(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4550, self, 0);
  addmethodreal(obj4550,"outer", &reader_collectionsPrelude_outer_4551);
  Object oldself4550 = self;
  struct StackFrameObject *oldstackframe4550 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4550);
  gc_frame_newslot((Object)stackframe);
  self = obj4550;
  Object *oldselfslot4550 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4550 = (*(struct UserObject *)self).data[0], lowerouter4550 = thisouter4550;
  if (inheritingObject4550) {
    struct UserObject *inho4550 = (struct UserObject *)inheritingObject4550;
    while (inho4550->super != GraceDefaultObject) inho4550 = (struct UserObject *)inho4550->super;
    inho4550->super = obj4550;
    self = inheritingObject4550;
    *selfslot = self;
    lowerouter4550 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4550;
  }
  if (objclass4550 == NULL) {
    Method *reader4552 = addmethodrealflags(obj4550, "val", &reader_collectionsPrelude_val_4552, MFLAG_CONFIDENTIAL);
    Method *writer4552 = addmethodrealflags(obj4550, "val:=(1)", &writer_collectionsPrelude_val_4552, MFLAG_CONFIDENTIAL);
    reader4552->definitionModule = modulename;
    writer4552->definitionModule = modulename;
    reader4552->definitionLine = 1676;
    writer4552->definitionLine = 1676;
  }
  obj4550->flags |= OFLAG_MUTABLE;
  adddatum2(obj4550, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4553 = (struct UserObject*)obj4550;
  uo4553->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4553_hasNext = addmethod2pos(obj4550, "hasNext", &meth_collectionsPrelude_4553_hasNext, 2);
  int argcv_meth_collectionsPrelude_4553_hasNext[] = {0};
  meth_meth_collectionsPrelude_4553_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4553_hasNext);
  meth_meth_collectionsPrelude_4553_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_4553_hasNext->definitionLine = 1677;
// method "next"
  block_savedest(obj4550);
  Object closure4563 = createclosure(1, "next");
  setclosureframe(closure4563, stackframe);
  addtoclosure(closure4563, var_IteratorExhausted);
  struct UserObject *uo4563 = (struct UserObject*)obj4550;
  uo4563->data[3] = (Object)closure4563;
  Method *meth_meth_collectionsPrelude_4563_next = addmethod2pos(obj4550, "next", &meth_collectionsPrelude_4563_next, 3);
  int argcv_meth_collectionsPrelude_4563_next[] = {0};
  meth_meth_collectionsPrelude_4563_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4563_next);
  meth_meth_collectionsPrelude_4563_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_4563_next->definitionLine = 1678;
// method "asString"
  struct UserObject *uo4602 = (struct UserObject*)obj4550;
  uo4602->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4602_asString = addmethod2pos(obj4550, "asString", &meth_collectionsPrelude_4602_asString, 4);
  int argcv_meth_collectionsPrelude_4602_asString[] = {0};
  meth_meth_collectionsPrelude_4602_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4602_asString);
  meth_meth_collectionsPrelude_4602_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_4602_asString->definitionLine = 1685;
  sourceObject = obj4550;
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4624 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4625 = gc_frame_new();
// call case 3: self.outer request
  Object call4626 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4625);
// compiled member node returning call4626 (depth = 3)
  partcv[0] = 0;
  Object call4627 = callmethodflags(call4626, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4624);
// compiled member node returning call4627 (depth = 2)
  adddatum2(obj4550, call4627, 1);
  sourceObject = obj4550;
  sourceObject = obj4550;
  sourceObject = obj4550;
  objclass4550 = obj4550->class;
  objclass4550->definitionModule = modulename;
  objclass4550->definitionLine = 1675;
  (*(struct UserObject *)self).data[0] = lowerouter4550;
  self = oldself4550;
  selfslot = oldselfslot4550;
  stackframe = oldstackframe4550;
  gc_frame_end(frame);
  return obj4550;
}
Object meth_collectionsPrelude_4549_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4550 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4550 = alloc_userobj2(5,5, objclass4550);
  gc_frame_newslot(obj4550);
  if (objclass4550 == NULL) {
    glfree(obj4550->class->name);
    obj4550->class->name = "range.uncheckedFrom(_)to(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4550, self, 0);
  addmethodreal(obj4550,"outer", &reader_collectionsPrelude_outer_4551);
  Object oldself4550 = self;
  struct StackFrameObject *oldstackframe4550 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4550);
  gc_frame_newslot((Object)stackframe);
  self = obj4550;
  Object *oldselfslot4550 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4550 = (*(struct UserObject *)self).data[0], lowerouter4550 = thisouter4550;
  if (inheritingObject4550) {
    struct UserObject *inho4550 = (struct UserObject *)inheritingObject4550;
    while (inho4550->super != GraceDefaultObject) inho4550 = (struct UserObject *)inho4550->super;
    inho4550->super = obj4550;
    self = inheritingObject4550;
    *selfslot = self;
    lowerouter4550 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4550;
  }
  if (objclass4550 == NULL) {
    Method *reader4552 = addmethodrealflags(obj4550, "val", &reader_collectionsPrelude_val_4552, MFLAG_CONFIDENTIAL);
    Method *writer4552 = addmethodrealflags(obj4550, "val:=(1)", &writer_collectionsPrelude_val_4552, MFLAG_CONFIDENTIAL);
    reader4552->definitionModule = modulename;
    writer4552->definitionModule = modulename;
    reader4552->definitionLine = 1676;
    writer4552->definitionLine = 1676;
  }
  obj4550->flags |= OFLAG_MUTABLE;
  adddatum2(obj4550, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4553 = (struct UserObject*)obj4550;
  uo4553->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4553_hasNext = addmethod2pos(obj4550, "hasNext", &meth_collectionsPrelude_4553_hasNext, 2);
  int argcv_meth_collectionsPrelude_4553_hasNext[] = {0};
  meth_meth_collectionsPrelude_4553_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4553_hasNext);
  meth_meth_collectionsPrelude_4553_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_4553_hasNext->definitionLine = 1677;
// method "next"
  block_savedest(obj4550);
  Object closure4563 = createclosure(1, "next");
  setclosureframe(closure4563, stackframe);
  addtoclosure(closure4563, var_IteratorExhausted);
  struct UserObject *uo4563 = (struct UserObject*)obj4550;
  uo4563->data[3] = (Object)closure4563;
  Method *meth_meth_collectionsPrelude_4563_next = addmethod2pos(obj4550, "next", &meth_collectionsPrelude_4563_next, 3);
  int argcv_meth_collectionsPrelude_4563_next[] = {0};
  meth_meth_collectionsPrelude_4563_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4563_next);
  meth_meth_collectionsPrelude_4563_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_4563_next->definitionLine = 1678;
// method "asString"
  struct UserObject *uo4602 = (struct UserObject*)obj4550;
  uo4602->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4602_asString = addmethod2pos(obj4550, "asString", &meth_collectionsPrelude_4602_asString, 4);
  int argcv_meth_collectionsPrelude_4602_asString[] = {0};
  meth_meth_collectionsPrelude_4602_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4602_asString);
  meth_meth_collectionsPrelude_4602_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_4602_asString->definitionLine = 1685;
  sourceObject = obj4550;
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4624 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4625 = gc_frame_new();
// call case 3: self.outer request
  Object call4626 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4625);
// compiled member node returning call4626 (depth = 3)
  partcv[0] = 0;
  Object call4627 = callmethodflags(call4626, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4624);
// compiled member node returning call4627 (depth = 2)
  adddatum2(obj4550, call4627, 1);
  sourceObject = obj4550;
  sourceObject = obj4550;
  sourceObject = obj4550;
  objclass4550 = obj4550->class;
  objclass4550->definitionModule = modulename;
  objclass4550->definitionLine = 1675;
  (*(struct UserObject *)self).data[0] = lowerouter4550;
  self = oldself4550;
  selfslot = oldselfslot4550;
  stackframe = oldstackframe4550;
  gc_frame_end(frame);
  return obj4550;
}
Object meth_collectionsPrelude_4629_at_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4631 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4633 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4634 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4633);
// compiled member node returning call4634 (depth = 5)
  int op_slot_right_4632 = gc_frame_newslot(call4634);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4632 = gc_frame_newslot(*var_ix);
  params[0] = call4634;
  partcv[0] = 1;
  Object opresult4636 = callmethod(*var_ix, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4636 (depth = 4)
  partcv[0] = 0;
  Object call4637 = callmethodflags(opresult4636, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4631);
// compiled call node returning call4637 (depth = 3)
  Object if4630 = done;
  if (istrue(call4637)) {
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4638 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4640 == NULL) {
    strlit4640 = alloc_String("");
    gc_root(strlit4640);
  }
// compiled string node returning strlit4640 (depth = 5)
  int op_slot_right_4639 = gc_frame_newslot(strlit4640);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4643 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4644 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4643);
// compiled member node returning call4644 (depth = 6)
  int op_slot_right_4642 = gc_frame_newslot(call4644);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4647 == NULL) {
    strlit4647 = alloc_String("), but upper bound is ");
    gc_root(strlit4647);
  }
// compiled string node returning strlit4647 (depth = 7)
  int op_slot_right_4646 = gc_frame_newslot(strlit4647);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_right_4649 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 8)
  if (strlit4651 == NULL) {
    strlit4651 = alloc_String("requested range.at(");
    gc_root(strlit4651);
  }
// compiled string node returning strlit4651 (depth = 8)
  int op_slot_left_4649 = gc_frame_newslot(strlit4651);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4652 = callmethod(strlit4651, "++(1)", 1, partcv, params);
// compiled op node returning opresult4652 (depth = 7)
  int op_slot_left_4646 = gc_frame_newslot(opresult4652);
  params[0] = strlit4647;
  partcv[0] = 1;
  Object opresult4653 = callmethod(opresult4652, "++(1)", 1, partcv, params);
// compiled op node returning opresult4653 (depth = 6)
  int op_slot_left_4642 = gc_frame_newslot(opresult4653);
  params[0] = call4644;
  partcv[0] = 1;
  Object opresult4654 = callmethod(opresult4653, "++(1)", 1, partcv, params);
// compiled op node returning opresult4654 (depth = 5)
  int op_slot_left_4639 = gc_frame_newslot(opresult4654);
  params[0] = strlit4640;
  partcv[0] = 1;
  Object opresult4655 = callmethod(opresult4654, "++(1)", 1, partcv, params);
// compiled op node returning opresult4655 (depth = 4)
  gc_frame_newslot(opresult4655);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4655;
  partcv[0] = 1;
  Object call4656 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4638);
// compiled call node returning call4656 (depth = 3)
    gc_frame_newslot(call4656);
    if4630 = call4656;
  } else {
  }
// compiled if node returning if4630 (depth = 2)
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4658 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4660 = alloc_Float64(1);
// compiled num node returning num4660 (depth = 5)
  int op_slot_right_4659 = gc_frame_newslot(num4660);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4659 = gc_frame_newslot(*var_ix);
  params[0] = num4660;
  partcv[0] = 1;
  Object opresult4662 = callmethod(*var_ix, "≥(1)", 1, partcv, params);
// compiled op node returning opresult4662 (depth = 4)
  partcv[0] = 0;
  Object call4663 = callmethodflags(opresult4662, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4658);
// compiled call node returning call4663 (depth = 3)
  Object if4657 = done;
  if (istrue(call4663)) {
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4664 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4666 == NULL) {
    strlit4666 = alloc_String("), but lower bound is 1");
    gc_root(strlit4666);
  }
// compiled string node returning strlit4666 (depth = 5)
  int op_slot_right_4665 = gc_frame_newslot(strlit4666);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_right_4668 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 6)
  if (strlit4670 == NULL) {
    strlit4670 = alloc_String("requested range.at(");
    gc_root(strlit4670);
  }
// compiled string node returning strlit4670 (depth = 6)
  int op_slot_left_4668 = gc_frame_newslot(strlit4670);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4671 = callmethod(strlit4670, "++(1)", 1, partcv, params);
// compiled op node returning opresult4671 (depth = 5)
  int op_slot_left_4665 = gc_frame_newslot(opresult4671);
  params[0] = strlit4666;
  partcv[0] = 1;
  Object opresult4672 = callmethod(opresult4671, "++(1)", 1, partcv, params);
// compiled op node returning opresult4672 (depth = 4)
  gc_frame_newslot(opresult4672);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4672;
  partcv[0] = 1;
  Object call4673 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4664);
// compiled call node returning call4673 (depth = 3)
    gc_frame_newslot(call4673);
    if4657 = call4673;
  } else {
  }
// compiled if node returning if4657 (depth = 2)
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4676 = alloc_Float64(1);
// compiled num node returning num4676 (depth = 5)
  int op_slot_right_4675 = gc_frame_newslot(num4676);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4675 = gc_frame_newslot(*var_ix);
  params[0] = num4676;
  partcv[0] = 1;
  Object diff4678 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff4678 (depth = 4)
  int op_slot_right_4674 = gc_frame_newslot(diff4678);
// starting to compile member node (depth = 4)
  int callframe4680 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4681 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4680);
// compiled member node returning call4681 (depth = 4)
  int op_slot_left_4674 = gc_frame_newslot(call4681);
  params[0] = diff4678;
  partcv[0] = 1;
  Object sum4682 = callmethod(call4681, "+(1)", 1, partcv, params);
// compiled op node returning sum4682 (depth = 3)
  return sum4682;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_4686__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elem = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_intElem = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "intElem");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4687 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  partcv[0] = 0;
  Object call4688 = callmethodflags(*var_elem, "truncated", 1, partcv, params, 0);
  gc_frame_end(callframe4687);
// compiled member node returning call4688 (depth = 5)
  *var_intElem = call4688;
  if (call4688 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  int op_slot_right_4690 = gc_frame_newslot(*var_elem);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4690 = gc_frame_newslot(*var_intElem);
  params[0] = *var_elem;
  partcv[0] = 1;
  Object opresult4692 = callmethod(*var_intElem, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4692 (depth = 5)
  Object if4689 = done;
  if (istrue(opresult4692)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4693 = alloc_Boolean(0);
// compiled identifier node returning bool4693 (depth = 6)
  block_return(realself, bool4693);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4689 = undefined;
  } else {
  }
// compiled if node returning if4689 (depth = 4)
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4696 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4697 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4696);
// compiled member node returning call4697 (depth = 6)
  int op_slot_right_4695 = gc_frame_newslot(call4697);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4695 = gc_frame_newslot(*var_intElem);
  params[0] = call4697;
  partcv[0] = 1;
  Object opresult4699 = callmethod(*var_intElem, "<(1)", 1, partcv, params);
// compiled op node returning opresult4699 (depth = 5)
  Object if4694 = done;
  if (istrue(opresult4699)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4700 = alloc_Boolean(0);
// compiled identifier node returning bool4700 (depth = 6)
  block_return(realself, bool4700);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4694 = undefined;
  } else {
  }
// compiled if node returning if4694 (depth = 4)
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4703 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4704 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4703);
// compiled member node returning call4704 (depth = 6)
  int op_slot_right_4702 = gc_frame_newslot(call4704);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4702 = gc_frame_newslot(*var_intElem);
  params[0] = call4704;
  partcv[0] = 1;
  Object opresult4706 = callmethod(*var_intElem, ">(1)", 1, partcv, params);
// compiled op node returning opresult4706 (depth = 5)
  Object if4701 = done;
  if (istrue(opresult4706)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4707 = alloc_Boolean(0);
// compiled identifier node returning bool4707 (depth = 6)
  block_return(realself, bool4707);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4701 = undefined;
  } else {
  }
// compiled if node returning if4701 (depth = 4)
  gc_frame_end(frame);
  return if4701;
}
Object meth_collectionsPrelude_4710__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4711 = alloc_Boolean(0);
// compiled identifier node returning bool4711 (depth = 5)
  block_return(realself, bool4711);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_4683_contains_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block4685 = alloc_Block(NULL, NULL, "collectionsPrelude", 1698);
  gc_frame_newslot(block4685);
// method "_apply"
  block_savedest(block4685);
  Object closure4686 = createclosure(2, "_apply");
  setclosureframe(closure4686, stackframe);
  addtoclosure(closure4686, var_elem);
  addtoclosure(closure4686, selfslot);
  struct UserObject *uo4686 = (struct UserObject*)block4685;
  uo4686->data[0] = (Object)closure4686;
  Method *meth_meth_collectionsPrelude_4686__apply = addmethod2pos(block4685, "_apply", &meth_collectionsPrelude_4686__apply, 0);
  int argcv_meth_collectionsPrelude_4686__apply[] = {0};
  meth_meth_collectionsPrelude_4686__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4686__apply);
  meth_meth_collectionsPrelude_4686__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_4686__apply->definitionLine = 1769;
// compiled block node returning block4685 (depth = 3)
  int frame4684 = gc_frame_new();
  gc_frame_newslot(block4685);
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4709 = alloc_Block(NULL, NULL, "collectionsPrelude", 1703);
  gc_frame_newslot(block4709);
// method "_apply(_)"
  block_savedest(block4709);
  Object closure4710 = createclosure(1, "_apply(1)");
  setclosureframe(closure4710, stackframe);
  addtoclosure(closure4710, selfslot);
  struct UserObject *uo4710 = (struct UserObject*)block4709;
  uo4710->data[0] = (Object)closure4710;
  Method *meth_meth_collectionsPrelude_4710__apply_40_1_41_ = addmethod2pos(block4709, "_apply(1)", &meth_collectionsPrelude_4710__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_4710__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4710__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4710__apply_40_1_41_);
  meth_meth_collectionsPrelude_4710__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4710__apply_40_1_41_->definitionLine = 1769;
// starting to compile call node (depth = 4)
  int callframe4713 = gc_frame_new();
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4714 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4715 == NULL) {
    strlit4715 = alloc_String("ex");
    gc_root(strlit4715);
  }
// compiled string node returning strlit4715 (depth = 6)
  gc_frame_newslot(strlit4715);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4716 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4717 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4716);
// compiled member node returning call4717 (depth = 6)
  params[0] = strlit4715;
  partcv[0] = 1;
  Object call4718 = callmethodflags(call4717, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4714);
// compiled call node returning call4718 (depth = 5)
  gc_frame_newslot(call4718);
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4719 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4720 = callmethodflags(prelude, "Exception", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4719);
// compiled member node returning call4720 (depth = 5)
  gc_frame_newslot(call4720);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4721 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4722 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4721);
// compiled member node returning call4722 (depth = 5)
  params[0] = call4718;
  params[1] = call4720;
  partcv[0] = 2;
  Object call4723 = callmethodflags(call4722, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4713);
// compiled call node returning call4723 (depth = 4)
((struct UserObject *)block4709)->data[1] = call4723;
// compiled block node returning block4709 (depth = 3)
  gc_frame_newslot(block4709);
  params[0] = block4709;
  setline(1698);
  Object catchres4684 = tryCatch(block4685, params, 1,NULL);
  gc_frame_end(frame4684);
// compiled trycatch node returning catchres4684 (depth = 2)
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4724 = alloc_Boolean(1);
// compiled identifier node returning bool4724 (depth = 3)
  return bool4724;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_4730__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4732 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4733 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4732);
// compiled member node returning call4733 (depth = 5)
  int op_slot_right_4731 = gc_frame_newslot(call4733);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4731 = gc_frame_newslot(*var_val);
  params[0] = call4733;
  partcv[0] = 1;
  Object opresult4735 = callmethod(*var_val, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4735 (depth = 4)
  gc_frame_end(frame);
  return opresult4735;
}
Object meth_collectionsPrelude_4738__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4739 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_val;
  partcv[0] = 1;
  Object call4740 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4739);
// compiled call node returning call4740 (depth = 4)
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4742 = alloc_Float64(1);
// compiled num node returning num4742 (depth = 6)
  int op_slot_right_4741 = gc_frame_newslot(num4742);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4741 = gc_frame_newslot(*var_val);
  params[0] = num4742;
  partcv[0] = 1;
  Object sum4744 = callmethod(*var_val, "+(1)", 1, partcv, params);
// compiled op node returning sum4744 (depth = 5)
  *var_val = sum4744;
  if (sum4744 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_4725_do_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4726 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4727 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4726);
// compiled member node returning call4727 (depth = 3)
  *var_val = call4727;
  if (call4727 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4728 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4729 = alloc_Block(NULL, NULL, "collectionsPrelude", 1708);
  gc_frame_newslot(block4729);
// method "_apply"
  block_savedest(block4729);
  Object closure4730 = createclosure(2, "_apply");
  setclosureframe(closure4730, stackframe);
  addtoclosure(closure4730, var_val);
  addtoclosure(closure4730, selfslot);
  struct UserObject *uo4730 = (struct UserObject*)block4729;
  uo4730->data[0] = (Object)closure4730;
  Method *meth_meth_collectionsPrelude_4730__apply = addmethod2pos(block4729, "_apply", &meth_collectionsPrelude_4730__apply, 0);
  int argcv_meth_collectionsPrelude_4730__apply[] = {0};
  meth_meth_collectionsPrelude_4730__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4730__apply);
  meth_meth_collectionsPrelude_4730__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_4730__apply->definitionLine = 1769;
// compiled block node returning block4729 (depth = 3)
  gc_frame_newslot(block4729);
// starting to compile block node (depth = 3)
  Object block4737 = alloc_Block(NULL, NULL, "collectionsPrelude", 1708);
  gc_frame_newslot(block4737);
// method "_apply"
  block_savedest(block4737);
  Object closure4738 = createclosure(3, "_apply");
  setclosureframe(closure4738, stackframe);
  addtoclosure(closure4738, var_val);
  addtoclosure(closure4738, var_block1);
  addtoclosure(closure4738, selfslot);
  struct UserObject *uo4738 = (struct UserObject*)block4737;
  uo4738->data[0] = (Object)closure4738;
  Method *meth_meth_collectionsPrelude_4738__apply = addmethod2pos(block4737, "_apply", &meth_collectionsPrelude_4738__apply, 0);
  int argcv_meth_collectionsPrelude_4738__apply[] = {0};
  meth_meth_collectionsPrelude_4738__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4738__apply);
  meth_meth_collectionsPrelude_4738__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_4738__apply->definitionLine = 1769;
// compiled block node returning block4737 (depth = 3)
  gc_frame_newslot(block4737);
// call case 5: prelude request
  params[0] = block4729;
  params[1] = block4737;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4747 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4728);
// compiled call node returning call4747 (depth = 2)
  gc_frame_end(frame);
  return call4747;
}
Object meth_collectionsPrelude_4754__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4756 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4757 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4756);
// compiled member node returning call4757 (depth = 5)
  int op_slot_right_4755 = gc_frame_newslot(call4757);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4755 = gc_frame_newslot(*var_val);
  params[0] = call4757;
  partcv[0] = 1;
  Object opresult4759 = callmethod(*var_val, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4759 (depth = 4)
  gc_frame_end(frame);
  return opresult4759;
}
Object meth_collectionsPrelude_4762__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_key = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4763 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_key (depth = 5)
  gc_frame_newslot(*var_key);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_key;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call4764 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4763);
// compiled call node returning call4764 (depth = 4)
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4766 = alloc_Float64(1);
// compiled num node returning num4766 (depth = 6)
  int op_slot_right_4765 = gc_frame_newslot(num4766);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_key (depth = 6)
  int op_slot_left_4765 = gc_frame_newslot(*var_key);
  params[0] = num4766;
  partcv[0] = 1;
  Object sum4768 = callmethod(*var_key, "+(1)", 1, partcv, params);
// compiled op node returning sum4768 (depth = 5)
  *var_key = sum4768;
  if (sum4768 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4771 = alloc_Float64(1);
// compiled num node returning num4771 (depth = 6)
  int op_slot_right_4770 = gc_frame_newslot(num4771);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4770 = gc_frame_newslot(*var_val);
  params[0] = num4771;
  partcv[0] = 1;
  Object sum4773 = callmethod(*var_val, "+(1)", 1, partcv, params);
// compiled op node returning sum4773 (depth = 5)
  *var_val = sum4773;
  if (sum4773 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_key = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "key");
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4749 = alloc_Float64(1);
// compiled num node returning num4749 (depth = 3)
  *var_key = num4749;
  if (num4749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4750 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4751 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4750);
// compiled member node returning call4751 (depth = 3)
  *var_val = call4751;
  if (call4751 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4752 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4753 = alloc_Block(NULL, NULL, "collectionsPrelude", 1716);
  gc_frame_newslot(block4753);
// method "_apply"
  block_savedest(block4753);
  Object closure4754 = createclosure(2, "_apply");
  setclosureframe(closure4754, stackframe);
  addtoclosure(closure4754, var_val);
  addtoclosure(closure4754, selfslot);
  struct UserObject *uo4754 = (struct UserObject*)block4753;
  uo4754->data[0] = (Object)closure4754;
  Method *meth_meth_collectionsPrelude_4754__apply = addmethod2pos(block4753, "_apply", &meth_collectionsPrelude_4754__apply, 0);
  int argcv_meth_collectionsPrelude_4754__apply[] = {0};
  meth_meth_collectionsPrelude_4754__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4754__apply);
  meth_meth_collectionsPrelude_4754__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_4754__apply->definitionLine = 1769;
// compiled block node returning block4753 (depth = 3)
  gc_frame_newslot(block4753);
// starting to compile block node (depth = 3)
  Object block4761 = alloc_Block(NULL, NULL, "collectionsPrelude", 1716);
  gc_frame_newslot(block4761);
// method "_apply"
  block_savedest(block4761);
  Object closure4762 = createclosure(4, "_apply");
  setclosureframe(closure4762, stackframe);
  addtoclosure(closure4762, var_key);
  addtoclosure(closure4762, var_val);
  addtoclosure(closure4762, var_block2);
  addtoclosure(closure4762, selfslot);
  struct UserObject *uo4762 = (struct UserObject*)block4761;
  uo4762->data[0] = (Object)closure4762;
  Method *meth_meth_collectionsPrelude_4762__apply = addmethod2pos(block4761, "_apply", &meth_collectionsPrelude_4762__apply, 0);
  int argcv_meth_collectionsPrelude_4762__apply[] = {0};
  meth_meth_collectionsPrelude_4762__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4762__apply);
  meth_meth_collectionsPrelude_4762__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_4762__apply->definitionLine = 1769;
// compiled block node returning block4761 (depth = 3)
  gc_frame_newslot(block4761);
// call case 5: prelude request
  params[0] = block4753;
  params[1] = block4761;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4776 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4752);
// compiled call node returning call4776 (depth = 2)
  gc_frame_end(frame);
  return call4776;
}
Object meth_collectionsPrelude_4777_reversed(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4778 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4779 = gc_frame_new();
// call case 3: self.outer request
  Object call4780 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4779);
// compiled member node returning call4780 (depth = 3)
  params[0] = *var_upper;
  params[1] = *var_lower;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4781 = callmethodflags(call4780, "from(1)downTo(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4778);
// compiled call node returning call4781 (depth = 2)
  gc_frame_end(frame);
  return call4781;
}
Object meth_collectionsPrelude_4782__43__43__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4783 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4784 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call4785 = callmethodflags(module_collectionsPrelude, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4784);
// compiled call node returning call4785 (depth = 3)
  gc_frame_newslot(call4785);
// call case 6: other requests
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4786 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  partcv[0] = 0;
  Object call4787 = callmethodflags(module_collectionsPrelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4786);
// compiled member node returning call4787 (depth = 3)
  params[0] = call4785;
  partcv[0] = 1;
  Object call4788 = callmethodflags(call4787, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4783);
// compiled call node returning call4788 (depth = 2)
  gc_frame_end(frame);
  return call4788;
}
Object meth_collectionsPrelude_4789__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4790 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4791 = callmethodflags(module_collectionsPrelude, "isEqual(1)toCollection(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4790);
// compiled call node returning call4791 (depth = 2)
  gc_frame_end(frame);
  return call4791;
}
Object meth_collectionsPrelude_4792_sorted(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_4793_sortedBy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4794 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile call node (depth = 3)
  int callframe4795 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4796 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call4797 = callmethodflags(module_collectionsPrelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4796);
// compiled member node returning call4797 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call4798 = callmethodflags(call4797, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4795);
// compiled call node returning call4798 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4799 = callmethodflags(call4798, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4794);
// compiled call node returning call4799 (depth = 2)
  gc_frame_end(frame);
  return call4799;
}
Object meth_collectionsPrelude_4800_keys(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4802 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4803 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4802);
// compiled member node returning call4803 (depth = 3)
  int op_slot_right_4801 = gc_frame_newslot(call4803);
// starting to compile num node (depth = 3)
  Object num4805 = alloc_Float64(1);
// compiled num node returning num4805 (depth = 3)
  int op_slot_left_4801 = gc_frame_newslot(num4805);
  params[0] = call4803;
  partcv[0] = 1;
  Object opresult4806 = callmethod(num4805, "..(1)", 1, partcv, params);
// compiled op node returning opresult4806 (depth = 2)
  gc_frame_end(frame);
  return opresult4806;
}
Object meth_collectionsPrelude_4807_values(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_4808_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4810 == NULL) {
    strlit4810 = alloc_String(")");
    gc_root(strlit4810);
  }
// compiled string node returning strlit4810 (depth = 3)
  int op_slot_right_4809 = gc_frame_newslot(strlit4810);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4812 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4815 == NULL) {
    strlit4815 = alloc_String(")to(");
    gc_root(strlit4815);
  }
// compiled string node returning strlit4815 (depth = 5)
  int op_slot_right_4814 = gc_frame_newslot(strlit4815);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4817 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 6)
  if (strlit4819 == NULL) {
    strlit4819 = alloc_String("range.from(");
    gc_root(strlit4819);
  }
// compiled string node returning strlit4819 (depth = 6)
  int op_slot_left_4817 = gc_frame_newslot(strlit4819);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4820 = callmethod(strlit4819, "++(1)", 1, partcv, params);
// compiled op node returning opresult4820 (depth = 5)
  int op_slot_left_4814 = gc_frame_newslot(opresult4820);
  params[0] = strlit4815;
  partcv[0] = 1;
  Object opresult4821 = callmethod(opresult4820, "++(1)", 1, partcv, params);
// compiled op node returning opresult4821 (depth = 4)
  int op_slot_left_4812 = gc_frame_newslot(opresult4821);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4822 = callmethod(opresult4821, "++(1)", 1, partcv, params);
// compiled op node returning opresult4822 (depth = 3)
  int op_slot_left_4809 = gc_frame_newslot(opresult4822);
  params[0] = strlit4810;
  partcv[0] = 1;
  Object opresult4823 = callmethod(opresult4822, "++(1)", 1, partcv, params);
// compiled op node returning opresult4823 (depth = 2)
  gc_frame_end(frame);
  return opresult4823;
}
Object meth_collectionsPrelude_4847__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4849 = alloc_Float64(3);
// compiled num node returning num4849 (depth = 4)
  int op_slot_right_4848 = gc_frame_newslot(num4849);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4852 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4853 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4854 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4853);
// compiled member node returning call4854 (depth = 6)
  partcv[0] = 0;
  Object call4855 = callmethodflags(call4854, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe4852);
// compiled member node returning call4855 (depth = 5)
  int op_slot_right_4851 = gc_frame_newslot(call4855);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4858 = alloc_Float64(1021);
// compiled num node returning num4858 (depth = 6)
  int op_slot_right_4857 = gc_frame_newslot(num4858);
// starting to compile member node (depth = 6)
  int callframe4860 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4861 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4862 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4861);
// compiled member node returning call4862 (depth = 7)
  partcv[0] = 0;
  Object call4863 = callmethodflags(call4862, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe4860);
// compiled member node returning call4863 (depth = 6)
  int op_slot_left_4857 = gc_frame_newslot(call4863);
  params[0] = num4858;
  partcv[0] = 1;
  Object prod4864 = callmethod(call4863, "*(1)", 1, partcv, params);
// compiled op node returning prod4864 (depth = 5)
  int op_slot_left_4851 = gc_frame_newslot(prod4864);
  params[0] = call4855;
  partcv[0] = 1;
  Object sum4865 = callmethod(prod4864, "+(1)", 1, partcv, params);
// compiled op node returning sum4865 (depth = 4)
  int op_slot_left_4848 = gc_frame_newslot(sum4865);
  params[0] = num4849;
  partcv[0] = 1;
  Object prod4866 = callmethod(sum4865, "*(1)", 1, partcv, params);
// compiled op node returning prod4866 (depth = 3)
  gc_frame_end(frame);
  return prod4866;
}
Object meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uncheckedFrom(1)to(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method uncheckedFrom(_)to(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method uncheckedFrom(_)to(_)");
  Object params[1];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for uncheckedFrom(_)to(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part uncheckedFrom(_)");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4543 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4543 = alloc_userobj2(18,19, objclass4543);
  gc_frame_newslot(obj4543);
  if (objclass4543 == NULL) {
    glfree(obj4543->class->name);
    obj4543->class->name = "range.uncheckedFrom(_)to(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4543, self, 0);
  addmethodreal(obj4543,"outer", &reader_collectionsPrelude_outer_4544);
  Object oldself4543 = self;
  struct StackFrameObject *oldstackframe4543 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4543);
  gc_frame_newslot((Object)stackframe);
  self = obj4543;
  Object *oldselfslot4543 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4543 = (*(struct UserObject *)self).data[0], lowerouter4543 = thisouter4543;
  if (inheritingObject4543) {
    struct UserObject *inho4543 = (struct UserObject *)inheritingObject4543;
    while (inho4543->super != GraceDefaultObject) inho4543 = (struct UserObject *)inho4543->super;
    inho4543->super = obj4543;
    self = inheritingObject4543;
    *selfslot = self;
    lowerouter4543 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4543;
  }
  if (objclass4543 == NULL) {
  Method *reader4545 = addmethodrealflags(obj4543, "start",&reader_collectionsPrelude_start_4545, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4545->definitionModule = modulename;
  reader4545->definitionLine = 1667;
  }
  adddatum2(obj4543, alloc_Undefined(), 1);
  if (objclass4543 == NULL) {
  Method *reader4546 = addmethodrealflags(obj4543, "stop",&reader_collectionsPrelude_stop_4546, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4546->definitionModule = modulename;
  reader4546->definitionLine = 1668;
  }
  adddatum2(obj4543, alloc_Undefined(), 2);
  if (objclass4543 == NULL) {
  Method *reader4547 = addmethodrealflags(obj4543, "size",&reader_collectionsPrelude_size_4547, MFLAG_DEF);
  reader4547->definitionModule = modulename;
  reader4547->definitionLine = 1669;
  }
  adddatum2(obj4543, alloc_Undefined(), 3);
  if (objclass4543 == NULL) {
  Method *reader4548 = addmethodrealflags(obj4543, "hash",&reader_collectionsPrelude_hash_4548, MFLAG_DEF);
  reader4548->definitionModule = modulename;
  reader4548->definitionLine = 1672;
  }
  adddatum2(obj4543, alloc_Undefined(), 4);
// method "iterator"
  block_savedest(obj4543);
  Object closure4549 = createclosure(1, "iterator");
  setclosureframe(closure4549, stackframe);
  addtoclosure(closure4549, var_IteratorExhausted);
  struct UserObject *uo4549 = (struct UserObject*)obj4543;
  uo4549->data[5] = (Object)closure4549;
  Method *meth_meth_collectionsPrelude_4549_iterator = addmethod2pos(obj4543, "iterator", &meth_collectionsPrelude_4549_iterator, 5);
  int argcv_meth_collectionsPrelude_4549_iterator[] = {0};
  meth_meth_collectionsPrelude_4549_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4549_iterator);
  meth_meth_collectionsPrelude_4549_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_4549_iterator->definitionLine = 1674;
  block_savedest(obj4543);
  Object closure4628 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure4628, stackframe);
  addtoclosure(closure4628, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_4549_iterator_object = addmethod2pos(obj4543, "iterator$object(1)", &meth_collectionsPrelude_4549_iterator_object, 5);
  meth_meth_collectionsPrelude_4549_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_4549_iterator_object->definitionLine = 1674;
// method "at(_)"
  block_savedest(obj4543);
  Object closure4629 = createclosure(1, "at(1)");
  setclosureframe(closure4629, stackframe);
  addtoclosure(closure4629, var_BoundsError);
  struct UserObject *uo4629 = (struct UserObject*)obj4543;
  uo4629->data[6] = (Object)closure4629;
  Method *meth_meth_collectionsPrelude_4629_at_40_1_41_ = addmethod2pos(obj4543, "at(1)", &meth_collectionsPrelude_4629_at_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_4629_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4629_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4629_at_40_1_41_);
meth_meth_collectionsPrelude_4629_at_40_1_41_->type->types[0] = type_Number;
meth_meth_collectionsPrelude_4629_at_40_1_41_->type->names[0] = "ix";
  meth_meth_collectionsPrelude_4629_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4629_at_40_1_41_->definitionLine = 1688;
// method "contains(_)"
  struct UserObject *uo4683 = (struct UserObject*)obj4543;
  uo4683->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4683_contains_40_1_41_ = addmethod2pos(obj4543, "contains(1)", &meth_collectionsPrelude_4683_contains_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_4683_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4683_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4683_contains_40_1_41_);
  meth_meth_collectionsPrelude_4683_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4683_contains_40_1_41_->definitionLine = 1697;
// method "do(_)"
  struct UserObject *uo4725 = (struct UserObject*)obj4543;
  uo4725->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4725_do_40_1_41_ = addmethod2pos(obj4543, "do(1)", &meth_collectionsPrelude_4725_do_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_4725_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4725_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4725_do_40_1_41_);
  meth_meth_collectionsPrelude_4725_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4725_do_40_1_41_->definitionLine = 1706;
// method "keysAndValuesDo(_)"
  struct UserObject *uo4748 = (struct UserObject*)obj4543;
  uo4748->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_ = addmethod2pos(obj4543, "keysAndValuesDo(1)", &meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_, 9);
  int argcv_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_->definitionLine = 1713;
// method "reversed"
  block_savedest(obj4543);
  Object closure4777 = createclosure(2, "reversed");
  setclosureframe(closure4777, stackframe);
  addtoclosure(closure4777, var_upper);
  addtoclosure(closure4777, var_lower);
  struct UserObject *uo4777 = (struct UserObject*)obj4543;
  uo4777->data[10] = (Object)closure4777;
  Method *meth_meth_collectionsPrelude_4777_reversed = addmethod2pos(obj4543, "reversed", &meth_collectionsPrelude_4777_reversed, 10);
  int argcv_meth_collectionsPrelude_4777_reversed[] = {0};
  meth_meth_collectionsPrelude_4777_reversed->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4777_reversed);
  meth_meth_collectionsPrelude_4777_reversed->definitionModule = modulename;
  meth_meth_collectionsPrelude_4777_reversed->definitionLine = 1722;
// method "++(_)"
  struct UserObject *uo4782 = (struct UserObject*)obj4543;
  uo4782->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4782__43__43__40_1_41_ = addmethod2pos(obj4543, "++(1)", &meth_collectionsPrelude_4782__43__43__40_1_41_, 11);
  int argcv_meth_collectionsPrelude_4782__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4782__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4782__43__43__40_1_41_);
  meth_meth_collectionsPrelude_4782__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4782__43__43__40_1_41_->definitionLine = 1725;
// method "==(_)"
  struct UserObject *uo4789 = (struct UserObject*)obj4543;
  uo4789->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4789__61__61__40_1_41_ = addmethod2pos(obj4543, "==(1)", &meth_collectionsPrelude_4789__61__61__40_1_41_, 12);
  int argcv_meth_collectionsPrelude_4789__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4789__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4789__61__61__40_1_41_);
  meth_meth_collectionsPrelude_4789__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4789__61__61__40_1_41_->definitionLine = 1728;
// method "sorted"
  struct UserObject *uo4792 = (struct UserObject*)obj4543;
  uo4792->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4792_sorted = addmethod2pos(obj4543, "sorted", &meth_collectionsPrelude_4792_sorted, 13);
  int argcv_meth_collectionsPrelude_4792_sorted[] = {0};
  meth_meth_collectionsPrelude_4792_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4792_sorted);
  meth_meth_collectionsPrelude_4792_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_4792_sorted->definitionLine = 1731;
// method "sortedBy(_)"
  struct UserObject *uo4793 = (struct UserObject*)obj4543;
  uo4793->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4793_sortedBy_40_1_41_ = addmethod2pos(obj4543, "sortedBy(1)", &meth_collectionsPrelude_4793_sortedBy_40_1_41_, 14);
  int argcv_meth_collectionsPrelude_4793_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4793_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4793_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_4793_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4793_sortedBy_40_1_41_->definitionLine = 1733;
// method "keys"
  struct UserObject *uo4800 = (struct UserObject*)obj4543;
  uo4800->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4800_keys = addmethod2pos(obj4543, "keys", &meth_collectionsPrelude_4800_keys, 15);
  int argcv_meth_collectionsPrelude_4800_keys[] = {0};
  meth_meth_collectionsPrelude_4800_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4800_keys);
  meth_meth_collectionsPrelude_4800_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_4800_keys->definitionLine = 1735;
// method "values"
  struct UserObject *uo4807 = (struct UserObject*)obj4543;
  uo4807->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4807_values = addmethod2pos(obj4543, "values", &meth_collectionsPrelude_4807_values, 16);
  int argcv_meth_collectionsPrelude_4807_values[] = {0};
  meth_meth_collectionsPrelude_4807_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4807_values);
  meth_meth_collectionsPrelude_4807_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_4807_values->definitionLine = 1737;
// method "asString"
  block_savedest(obj4543);
  Object closure4808 = createclosure(2, "asString");
  setclosureframe(closure4808, stackframe);
  addtoclosure(closure4808, var_upper);
  addtoclosure(closure4808, var_lower);
  struct UserObject *uo4808 = (struct UserObject*)obj4543;
  uo4808->data[17] = (Object)closure4808;
  Method *meth_meth_collectionsPrelude_4808_asString = addmethod2pos(obj4543, "asString", &meth_collectionsPrelude_4808_asString, 17);
  int argcv_meth_collectionsPrelude_4808_asString[] = {0};
  meth_meth_collectionsPrelude_4808_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4808_asString);
  meth_meth_collectionsPrelude_4808_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_4808_asString->definitionLine = 1739;
  sourceObject = obj4543;
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4824 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4825 = callmethodflags(module_collectionsPrelude, "indexable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4824);
// compiled call node returning call4825 (depth = 2)
  struct UserObject *obj4543_uo = (struct UserObject *)obj4543;
  obj4543_uo->super = call4825;
  sourceObject = obj4543;
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lower (depth = 2)
  adddatum2(obj4543, *var_lower, 1);
  sourceObject = obj4543;
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_upper (depth = 2)
  adddatum2(obj4543, *var_upper, 2);
  sourceObject = obj4543;
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4828 = alloc_Float64(0);
// compiled num node returning num4828 (depth = 4)
  int op_slot_right_4827 = gc_frame_newslot(num4828);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4831 = alloc_Float64(1);
// compiled num node returning num4831 (depth = 5)
  int op_slot_right_4830 = gc_frame_newslot(num4831);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4833 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_4833 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4835 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4835 (depth = 5)
  int op_slot_left_4830 = gc_frame_newslot(diff4835);
  params[0] = num4831;
  partcv[0] = 1;
  Object sum4836 = callmethod(diff4835, "+(1)", 1, partcv, params);
// compiled op node returning sum4836 (depth = 4)
  int op_slot_left_4827 = gc_frame_newslot(sum4836);
  params[0] = num4828;
  partcv[0] = 1;
  Object opresult4837 = callmethod(sum4836, "<(1)", 1, partcv, params);
// compiled op node returning opresult4837 (depth = 3)
  Object if4826 = done;
struct StackFrameObject *iftmpstackframe4826 = stackframe;
  if (istrue(opresult4837)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4826);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile num node (depth = 3)
  Object num4838 = alloc_Float64(0);
// compiled num node returning num4838 (depth = 3)
    gc_frame_newslot(num4838);
    if4826 = num4838;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4826);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4840 = alloc_Float64(1);
// compiled num node returning num4840 (depth = 4)
  int op_slot_right_4839 = gc_frame_newslot(num4840);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_4842 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_4842 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4844 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4844 (depth = 4)
  int op_slot_left_4839 = gc_frame_newslot(diff4844);
  params[0] = num4840;
  partcv[0] = 1;
  Object sum4845 = callmethod(diff4844, "+(1)", 1, partcv, params);
// compiled op node returning sum4845 (depth = 3)
    gc_frame_newslot(sum4845);
    if4826 = sum4845;
  }
stackframe = iftmpstackframe4826;
// compiled if node returning if4826 (depth = 2)
  adddatum2(obj4543, if4826, 3);
  sourceObject = obj4543;
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block4846 = alloc_Block(NULL, NULL, "collectionsPrelude", 1672);
  gc_frame_newslot(block4846);
// method "_apply"
  block_savedest(block4846);
  Object closure4847 = createclosure(1, "_apply");
  setclosureframe(closure4847, stackframe);
  addtoclosure(closure4847, selfslot);
  struct UserObject *uo4847 = (struct UserObject*)block4846;
  uo4847->data[0] = (Object)closure4847;
  Method *meth_meth_collectionsPrelude_4847__apply = addmethod2pos(block4846, "_apply", &meth_collectionsPrelude_4847__apply, 0);
  int argcv_meth_collectionsPrelude_4847__apply[] = {0};
  meth_meth_collectionsPrelude_4847__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4847__apply);
  meth_meth_collectionsPrelude_4847__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_4847__apply->definitionLine = 1769;
// compiled block node returning block4846 (depth = 2)
  adddatum2(obj4543, block4846, 4);
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  objclass4543 = obj4543->class;
  objclass4543->definitionModule = modulename;
  objclass4543->definitionLine = 1665;
  (*(struct UserObject *)self).data[0] = lowerouter4543;
  self = oldself4543;
  selfslot = oldselfslot4543;
  stackframe = oldstackframe4543;
  gc_frame_end(frame);
  return obj4543;
}
Object meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uncheckedFrom(1)to(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method uncheckedFrom(_)to(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method uncheckedFrom(_)to(_)");
  Object params[1];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for uncheckedFrom(_)to(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part uncheckedFrom(_)");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4543 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4543 = alloc_userobj2(18,19, objclass4543);
  gc_frame_newslot(obj4543);
  if (objclass4543 == NULL) {
    glfree(obj4543->class->name);
    obj4543->class->name = "range.uncheckedFrom(_)to(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4543, self, 0);
  addmethodreal(obj4543,"outer", &reader_collectionsPrelude_outer_4544);
  Object oldself4543 = self;
  struct StackFrameObject *oldstackframe4543 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4543);
  gc_frame_newslot((Object)stackframe);
  self = obj4543;
  Object *oldselfslot4543 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4543 = (*(struct UserObject *)self).data[0], lowerouter4543 = thisouter4543;
  if (inheritingObject4543) {
    struct UserObject *inho4543 = (struct UserObject *)inheritingObject4543;
    while (inho4543->super != GraceDefaultObject) inho4543 = (struct UserObject *)inho4543->super;
    inho4543->super = obj4543;
    self = inheritingObject4543;
    *selfslot = self;
    lowerouter4543 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4543;
  }
  if (objclass4543 == NULL) {
  Method *reader4545 = addmethodrealflags(obj4543, "start",&reader_collectionsPrelude_start_4545, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4545->definitionModule = modulename;
  reader4545->definitionLine = 1667;
  }
  adddatum2(obj4543, alloc_Undefined(), 1);
  if (objclass4543 == NULL) {
  Method *reader4546 = addmethodrealflags(obj4543, "stop",&reader_collectionsPrelude_stop_4546, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4546->definitionModule = modulename;
  reader4546->definitionLine = 1668;
  }
  adddatum2(obj4543, alloc_Undefined(), 2);
  if (objclass4543 == NULL) {
  Method *reader4547 = addmethodrealflags(obj4543, "size",&reader_collectionsPrelude_size_4547, MFLAG_DEF);
  reader4547->definitionModule = modulename;
  reader4547->definitionLine = 1669;
  }
  adddatum2(obj4543, alloc_Undefined(), 3);
  if (objclass4543 == NULL) {
  Method *reader4548 = addmethodrealflags(obj4543, "hash",&reader_collectionsPrelude_hash_4548, MFLAG_DEF);
  reader4548->definitionModule = modulename;
  reader4548->definitionLine = 1672;
  }
  adddatum2(obj4543, alloc_Undefined(), 4);
// method "iterator"
  block_savedest(obj4543);
  Object closure4549 = createclosure(1, "iterator");
  setclosureframe(closure4549, stackframe);
  addtoclosure(closure4549, var_IteratorExhausted);
  struct UserObject *uo4549 = (struct UserObject*)obj4543;
  uo4549->data[5] = (Object)closure4549;
  Method *meth_meth_collectionsPrelude_4549_iterator = addmethod2pos(obj4543, "iterator", &meth_collectionsPrelude_4549_iterator, 5);
  int argcv_meth_collectionsPrelude_4549_iterator[] = {0};
  meth_meth_collectionsPrelude_4549_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4549_iterator);
  meth_meth_collectionsPrelude_4549_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_4549_iterator->definitionLine = 1674;
  block_savedest(obj4543);
  Object closure4628 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure4628, stackframe);
  addtoclosure(closure4628, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_4549_iterator_object = addmethod2pos(obj4543, "iterator$object(1)", &meth_collectionsPrelude_4549_iterator_object, 5);
  meth_meth_collectionsPrelude_4549_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_4549_iterator_object->definitionLine = 1674;
// method "at(_)"
  block_savedest(obj4543);
  Object closure4629 = createclosure(1, "at(1)");
  setclosureframe(closure4629, stackframe);
  addtoclosure(closure4629, var_BoundsError);
  struct UserObject *uo4629 = (struct UserObject*)obj4543;
  uo4629->data[6] = (Object)closure4629;
  Method *meth_meth_collectionsPrelude_4629_at_40_1_41_ = addmethod2pos(obj4543, "at(1)", &meth_collectionsPrelude_4629_at_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_4629_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4629_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4629_at_40_1_41_);
meth_meth_collectionsPrelude_4629_at_40_1_41_->type->types[0] = type_Number;
meth_meth_collectionsPrelude_4629_at_40_1_41_->type->names[0] = "ix";
  meth_meth_collectionsPrelude_4629_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4629_at_40_1_41_->definitionLine = 1688;
// method "contains(_)"
  struct UserObject *uo4683 = (struct UserObject*)obj4543;
  uo4683->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4683_contains_40_1_41_ = addmethod2pos(obj4543, "contains(1)", &meth_collectionsPrelude_4683_contains_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_4683_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4683_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4683_contains_40_1_41_);
  meth_meth_collectionsPrelude_4683_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4683_contains_40_1_41_->definitionLine = 1697;
// method "do(_)"
  struct UserObject *uo4725 = (struct UserObject*)obj4543;
  uo4725->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4725_do_40_1_41_ = addmethod2pos(obj4543, "do(1)", &meth_collectionsPrelude_4725_do_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_4725_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4725_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4725_do_40_1_41_);
  meth_meth_collectionsPrelude_4725_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4725_do_40_1_41_->definitionLine = 1706;
// method "keysAndValuesDo(_)"
  struct UserObject *uo4748 = (struct UserObject*)obj4543;
  uo4748->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_ = addmethod2pos(obj4543, "keysAndValuesDo(1)", &meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_, 9);
  int argcv_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4748_keysAndValuesDo_40_1_41_->definitionLine = 1713;
// method "reversed"
  block_savedest(obj4543);
  Object closure4777 = createclosure(2, "reversed");
  setclosureframe(closure4777, stackframe);
  addtoclosure(closure4777, var_upper);
  addtoclosure(closure4777, var_lower);
  struct UserObject *uo4777 = (struct UserObject*)obj4543;
  uo4777->data[10] = (Object)closure4777;
  Method *meth_meth_collectionsPrelude_4777_reversed = addmethod2pos(obj4543, "reversed", &meth_collectionsPrelude_4777_reversed, 10);
  int argcv_meth_collectionsPrelude_4777_reversed[] = {0};
  meth_meth_collectionsPrelude_4777_reversed->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4777_reversed);
  meth_meth_collectionsPrelude_4777_reversed->definitionModule = modulename;
  meth_meth_collectionsPrelude_4777_reversed->definitionLine = 1722;
// method "++(_)"
  struct UserObject *uo4782 = (struct UserObject*)obj4543;
  uo4782->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4782__43__43__40_1_41_ = addmethod2pos(obj4543, "++(1)", &meth_collectionsPrelude_4782__43__43__40_1_41_, 11);
  int argcv_meth_collectionsPrelude_4782__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4782__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4782__43__43__40_1_41_);
  meth_meth_collectionsPrelude_4782__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4782__43__43__40_1_41_->definitionLine = 1725;
// method "==(_)"
  struct UserObject *uo4789 = (struct UserObject*)obj4543;
  uo4789->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4789__61__61__40_1_41_ = addmethod2pos(obj4543, "==(1)", &meth_collectionsPrelude_4789__61__61__40_1_41_, 12);
  int argcv_meth_collectionsPrelude_4789__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4789__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4789__61__61__40_1_41_);
  meth_meth_collectionsPrelude_4789__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4789__61__61__40_1_41_->definitionLine = 1728;
// method "sorted"
  struct UserObject *uo4792 = (struct UserObject*)obj4543;
  uo4792->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4792_sorted = addmethod2pos(obj4543, "sorted", &meth_collectionsPrelude_4792_sorted, 13);
  int argcv_meth_collectionsPrelude_4792_sorted[] = {0};
  meth_meth_collectionsPrelude_4792_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4792_sorted);
  meth_meth_collectionsPrelude_4792_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_4792_sorted->definitionLine = 1731;
// method "sortedBy(_)"
  struct UserObject *uo4793 = (struct UserObject*)obj4543;
  uo4793->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4793_sortedBy_40_1_41_ = addmethod2pos(obj4543, "sortedBy(1)", &meth_collectionsPrelude_4793_sortedBy_40_1_41_, 14);
  int argcv_meth_collectionsPrelude_4793_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4793_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4793_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_4793_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4793_sortedBy_40_1_41_->definitionLine = 1733;
// method "keys"
  struct UserObject *uo4800 = (struct UserObject*)obj4543;
  uo4800->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4800_keys = addmethod2pos(obj4543, "keys", &meth_collectionsPrelude_4800_keys, 15);
  int argcv_meth_collectionsPrelude_4800_keys[] = {0};
  meth_meth_collectionsPrelude_4800_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4800_keys);
  meth_meth_collectionsPrelude_4800_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_4800_keys->definitionLine = 1735;
// method "values"
  struct UserObject *uo4807 = (struct UserObject*)obj4543;
  uo4807->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4807_values = addmethod2pos(obj4543, "values", &meth_collectionsPrelude_4807_values, 16);
  int argcv_meth_collectionsPrelude_4807_values[] = {0};
  meth_meth_collectionsPrelude_4807_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4807_values);
  meth_meth_collectionsPrelude_4807_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_4807_values->definitionLine = 1737;
// method "asString"
  block_savedest(obj4543);
  Object closure4808 = createclosure(2, "asString");
  setclosureframe(closure4808, stackframe);
  addtoclosure(closure4808, var_upper);
  addtoclosure(closure4808, var_lower);
  struct UserObject *uo4808 = (struct UserObject*)obj4543;
  uo4808->data[17] = (Object)closure4808;
  Method *meth_meth_collectionsPrelude_4808_asString = addmethod2pos(obj4543, "asString", &meth_collectionsPrelude_4808_asString, 17);
  int argcv_meth_collectionsPrelude_4808_asString[] = {0};
  meth_meth_collectionsPrelude_4808_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4808_asString);
  meth_meth_collectionsPrelude_4808_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_4808_asString->definitionLine = 1739;
  sourceObject = obj4543;
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4824 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4825 = callmethodflags(module_collectionsPrelude, "indexable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4824);
// compiled call node returning call4825 (depth = 2)
  struct UserObject *obj4543_uo = (struct UserObject *)obj4543;
  obj4543_uo->super = call4825;
  sourceObject = obj4543;
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lower (depth = 2)
  adddatum2(obj4543, *var_lower, 1);
  sourceObject = obj4543;
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_upper (depth = 2)
  adddatum2(obj4543, *var_upper, 2);
  sourceObject = obj4543;
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4828 = alloc_Float64(0);
// compiled num node returning num4828 (depth = 4)
  int op_slot_right_4827 = gc_frame_newslot(num4828);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4831 = alloc_Float64(1);
// compiled num node returning num4831 (depth = 5)
  int op_slot_right_4830 = gc_frame_newslot(num4831);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4833 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_4833 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4835 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4835 (depth = 5)
  int op_slot_left_4830 = gc_frame_newslot(diff4835);
  params[0] = num4831;
  partcv[0] = 1;
  Object sum4836 = callmethod(diff4835, "+(1)", 1, partcv, params);
// compiled op node returning sum4836 (depth = 4)
  int op_slot_left_4827 = gc_frame_newslot(sum4836);
  params[0] = num4828;
  partcv[0] = 1;
  Object opresult4837 = callmethod(sum4836, "<(1)", 1, partcv, params);
// compiled op node returning opresult4837 (depth = 3)
  Object if4826 = done;
struct StackFrameObject *iftmpstackframe4826 = stackframe;
  if (istrue(opresult4837)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4826);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile num node (depth = 3)
  Object num4838 = alloc_Float64(0);
// compiled num node returning num4838 (depth = 3)
    gc_frame_newslot(num4838);
    if4826 = num4838;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4826);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4840 = alloc_Float64(1);
// compiled num node returning num4840 (depth = 4)
  int op_slot_right_4839 = gc_frame_newslot(num4840);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_4842 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_4842 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4844 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4844 (depth = 4)
  int op_slot_left_4839 = gc_frame_newslot(diff4844);
  params[0] = num4840;
  partcv[0] = 1;
  Object sum4845 = callmethod(diff4844, "+(1)", 1, partcv, params);
// compiled op node returning sum4845 (depth = 3)
    gc_frame_newslot(sum4845);
    if4826 = sum4845;
  }
stackframe = iftmpstackframe4826;
// compiled if node returning if4826 (depth = 2)
  adddatum2(obj4543, if4826, 3);
  sourceObject = obj4543;
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block4846 = alloc_Block(NULL, NULL, "collectionsPrelude", 1672);
  gc_frame_newslot(block4846);
// method "_apply"
  block_savedest(block4846);
  Object closure4847 = createclosure(1, "_apply");
  setclosureframe(closure4847, stackframe);
  addtoclosure(closure4847, selfslot);
  struct UserObject *uo4847 = (struct UserObject*)block4846;
  uo4847->data[0] = (Object)closure4847;
  Method *meth_meth_collectionsPrelude_4847__apply = addmethod2pos(block4846, "_apply", &meth_collectionsPrelude_4847__apply, 0);
  int argcv_meth_collectionsPrelude_4847__apply[] = {0};
  meth_meth_collectionsPrelude_4847__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4847__apply);
  meth_meth_collectionsPrelude_4847__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_4847__apply->definitionLine = 1769;
// compiled block node returning block4846 (depth = 2)
  adddatum2(obj4543, block4846, 4);
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  sourceObject = obj4543;
  objclass4543 = obj4543->class;
  objclass4543->definitionModule = modulename;
  objclass4543->definitionLine = 1665;
  (*(struct UserObject *)self).data[0] = lowerouter4543;
  self = oldself4543;
  selfslot = oldselfslot4543;
  stackframe = oldstackframe4543;
  gc_frame_end(frame);
  return obj4543;
}
Object meth_collectionsPrelude_4879_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4881 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4882 = gc_frame_new();
// call case 3: self.outer request
  Object call4883 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4882);
// compiled member node returning call4883 (depth = 4)
  partcv[0] = 0;
  Object call4884 = callmethodflags(call4883, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4881);
// compiled member node returning call4884 (depth = 3)
  int op_slot_right_4880 = gc_frame_newslot(call4884);
// starting to compile member node (depth = 3)
  int callframe4886 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4887 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4886);
// compiled member node returning call4887 (depth = 3)
  int op_slot_left_4880 = gc_frame_newslot(call4887);
  params[0] = call4884;
  partcv[0] = 1;
  Object opresult4888 = callmethod(call4887, "≥(1)", 1, partcv, params);
// compiled op node returning opresult4888 (depth = 2)
  gc_frame_end(frame);
  return opresult4888;
}
Object meth_collectionsPrelude_4889_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4892 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4893 = gc_frame_new();
// call case 3: self.outer request
  Object call4894 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4893);
// compiled member node returning call4894 (depth = 5)
  partcv[0] = 0;
  Object call4895 = callmethodflags(call4894, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4892);
// compiled member node returning call4895 (depth = 4)
  int op_slot_right_4891 = gc_frame_newslot(call4895);
// starting to compile member node (depth = 4)
  int callframe4897 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4898 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4897);
// compiled member node returning call4898 (depth = 4)
  int op_slot_left_4891 = gc_frame_newslot(call4898);
  params[0] = call4895;
  partcv[0] = 1;
  Object opresult4899 = callmethod(call4898, "<(1)", 1, partcv, params);
// compiled op node returning opresult4899 (depth = 3)
  Object if4890 = done;
  if (istrue(opresult4899)) {
// starting to compile call node (depth = 3)
  int callframe4900 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4902 == NULL) {
    strlit4902 = alloc_String("");
    gc_root(strlit4902);
  }
// compiled string node returning strlit4902 (depth = 5)
  int op_slot_right_4901 = gc_frame_newslot(strlit4902);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4905 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4906 = gc_frame_new();
// call case 3: self.outer request
  Object call4907 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4906);
// compiled member node returning call4907 (depth = 7)
  partcv[0] = 0;
  Object call4908 = callmethodflags(call4907, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4905);
// compiled member node returning call4908 (depth = 6)
  int op_slot_right_4904 = gc_frame_newslot(call4908);
// starting to compile string node (depth = 6)
  if (strlit4910 == NULL) {
    strlit4910 = alloc_String("over ");
    gc_root(strlit4910);
  }
// compiled string node returning strlit4910 (depth = 6)
  int op_slot_left_4904 = gc_frame_newslot(strlit4910);
  params[0] = call4908;
  partcv[0] = 1;
  Object opresult4911 = callmethod(strlit4910, "++(1)", 1, partcv, params);
// compiled op node returning opresult4911 (depth = 5)
  int op_slot_left_4901 = gc_frame_newslot(opresult4911);
  params[0] = strlit4902;
  partcv[0] = 1;
  Object opresult4912 = callmethod(opresult4911, "++(1)", 1, partcv, params);
// compiled op node returning opresult4912 (depth = 4)
  gc_frame_newslot(opresult4912);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4912;
  partcv[0] = 1;
  Object call4913 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4900);
// compiled call node returning call4913 (depth = 3)
    gc_frame_newslot(call4913);
    if4890 = call4913;
  } else {
  }
// compiled if node returning if4890 (depth = 2)
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4914 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4916 = alloc_Float64(1);
// compiled num node returning num4916 (depth = 4)
  int op_slot_right_4915 = gc_frame_newslot(num4916);
// starting to compile member node (depth = 4)
  int callframe4918 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4919 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4918);
// compiled member node returning call4919 (depth = 4)
  int op_slot_left_4915 = gc_frame_newslot(call4919);
  params[0] = num4916;
  partcv[0] = 1;
  Object diff4920 = callmethod(call4919, "-(1)", 1, partcv, params);
// compiled op node returning diff4920 (depth = 3)
  gc_frame_newslot(diff4920);
// call case 4: self request
  params[0] = diff4920;
  partcv[0] = 1;
  Object call4921 = callmethodflags(self, "val:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4914);
// compiled call node returning call4921 (depth = 2)
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4923 = alloc_Float64(1);
// compiled num node returning num4923 (depth = 4)
  int op_slot_right_4922 = gc_frame_newslot(num4923);
// starting to compile member node (depth = 4)
  int callframe4925 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4926 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4925);
// compiled member node returning call4926 (depth = 4)
  int op_slot_left_4922 = gc_frame_newslot(call4926);
  params[0] = num4923;
  partcv[0] = 1;
  Object sum4927 = callmethod(call4926, "+(1)", 1, partcv, params);
// compiled op node returning sum4927 (depth = 3)
  return sum4927;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_4928_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4930 == NULL) {
    strlit4930 = alloc_String("");
    gc_root(strlit4930);
  }
// compiled string node returning strlit4930 (depth = 3)
  int op_slot_right_4929 = gc_frame_newslot(strlit4930);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4933 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4934 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4933);
// compiled member node returning call4934 (depth = 4)
  int op_slot_right_4932 = gc_frame_newslot(call4934);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4937 == NULL) {
    strlit4937 = alloc_String(" at ");
    gc_root(strlit4937);
  }
// compiled string node returning strlit4937 (depth = 5)
  int op_slot_right_4936 = gc_frame_newslot(strlit4937);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4940 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4941 = gc_frame_new();
// call case 3: self.outer request
  Object call4942 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4941);
// compiled member node returning call4942 (depth = 7)
  partcv[0] = 0;
  Object call4943 = callmethodflags(call4942, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4940);
// compiled member node returning call4943 (depth = 6)
  int op_slot_right_4939 = gc_frame_newslot(call4943);
// starting to compile string node (depth = 6)
  if (strlit4945 == NULL) {
    strlit4945 = alloc_String("an iterator over ");
    gc_root(strlit4945);
  }
// compiled string node returning strlit4945 (depth = 6)
  int op_slot_left_4939 = gc_frame_newslot(strlit4945);
  params[0] = call4943;
  partcv[0] = 1;
  Object opresult4946 = callmethod(strlit4945, "++(1)", 1, partcv, params);
// compiled op node returning opresult4946 (depth = 5)
  int op_slot_left_4936 = gc_frame_newslot(opresult4946);
  params[0] = strlit4937;
  partcv[0] = 1;
  Object opresult4947 = callmethod(opresult4946, "++(1)", 1, partcv, params);
// compiled op node returning opresult4947 (depth = 4)
  int op_slot_left_4932 = gc_frame_newslot(opresult4947);
  params[0] = call4934;
  partcv[0] = 1;
  Object opresult4948 = callmethod(opresult4947, "++(1)", 1, partcv, params);
// compiled op node returning opresult4948 (depth = 3)
  int op_slot_left_4929 = gc_frame_newslot(opresult4948);
  params[0] = strlit4930;
  partcv[0] = 1;
  Object opresult4949 = callmethod(opresult4948, "++(1)", 1, partcv, params);
// compiled op node returning opresult4949 (depth = 2)
  gc_frame_end(frame);
  return opresult4949;
}
Object meth_collectionsPrelude_4875_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4876 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4876 = alloc_userobj2(5,5, objclass4876);
  gc_frame_newslot(obj4876);
  if (objclass4876 == NULL) {
    glfree(obj4876->class->name);
    obj4876->class->name = "range.from(_)downTo(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4876, self, 0);
  addmethodreal(obj4876,"outer", &reader_collectionsPrelude_outer_4877);
  Object oldself4876 = self;
  struct StackFrameObject *oldstackframe4876 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4876);
  gc_frame_newslot((Object)stackframe);
  self = obj4876;
  Object *oldselfslot4876 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4876 = (*(struct UserObject *)self).data[0], lowerouter4876 = thisouter4876;
  if (inheritingObject4876) {
    struct UserObject *inho4876 = (struct UserObject *)inheritingObject4876;
    while (inho4876->super != GraceDefaultObject) inho4876 = (struct UserObject *)inho4876->super;
    inho4876->super = obj4876;
    self = inheritingObject4876;
    *selfslot = self;
    lowerouter4876 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4876;
  }
  if (objclass4876 == NULL) {
    Method *reader4878 = addmethodrealflags(obj4876, "val", &reader_collectionsPrelude_val_4878, MFLAG_CONFIDENTIAL);
    Method *writer4878 = addmethodrealflags(obj4876, "val:=(1)", &writer_collectionsPrelude_val_4878, MFLAG_CONFIDENTIAL);
    reader4878->definitionModule = modulename;
    writer4878->definitionModule = modulename;
    reader4878->definitionLine = 1769;
    writer4878->definitionLine = 1769;
  }
  obj4876->flags |= OFLAG_MUTABLE;
  adddatum2(obj4876, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4879 = (struct UserObject*)obj4876;
  uo4879->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4879_hasNext = addmethod2pos(obj4876, "hasNext", &meth_collectionsPrelude_4879_hasNext, 2);
  int argcv_meth_collectionsPrelude_4879_hasNext[] = {0};
  meth_meth_collectionsPrelude_4879_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4879_hasNext);
  meth_meth_collectionsPrelude_4879_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_4879_hasNext->definitionLine = 1770;
// method "next"
  block_savedest(obj4876);
  Object closure4889 = createclosure(1, "next");
  setclosureframe(closure4889, stackframe);
  addtoclosure(closure4889, var_IteratorExhausted);
  struct UserObject *uo4889 = (struct UserObject*)obj4876;
  uo4889->data[3] = (Object)closure4889;
  Method *meth_meth_collectionsPrelude_4889_next = addmethod2pos(obj4876, "next", &meth_collectionsPrelude_4889_next, 3);
  int argcv_meth_collectionsPrelude_4889_next[] = {0};
  meth_meth_collectionsPrelude_4889_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4889_next);
  meth_meth_collectionsPrelude_4889_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_4889_next->definitionLine = 1771;
// method "asString"
  struct UserObject *uo4928 = (struct UserObject*)obj4876;
  uo4928->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4928_asString = addmethod2pos(obj4876, "asString", &meth_collectionsPrelude_4928_asString, 4);
  int argcv_meth_collectionsPrelude_4928_asString[] = {0};
  meth_meth_collectionsPrelude_4928_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4928_asString);
  meth_meth_collectionsPrelude_4928_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_4928_asString->definitionLine = 1776;
  sourceObject = obj4876;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4950 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4951 = gc_frame_new();
// call case 3: self.outer request
  Object call4952 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4951);
// compiled member node returning call4952 (depth = 3)
  partcv[0] = 0;
  Object call4953 = callmethodflags(call4952, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4950);
// compiled member node returning call4953 (depth = 2)
  adddatum2(obj4876, call4953, 1);
  sourceObject = obj4876;
  sourceObject = obj4876;
  sourceObject = obj4876;
  objclass4876 = obj4876->class;
  objclass4876->definitionModule = modulename;
  objclass4876->definitionLine = 1768;
  (*(struct UserObject *)self).data[0] = lowerouter4876;
  self = oldself4876;
  selfslot = oldselfslot4876;
  stackframe = oldstackframe4876;
  gc_frame_end(frame);
  return obj4876;
}
Object meth_collectionsPrelude_4875_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4876 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4876 = alloc_userobj2(5,5, objclass4876);
  gc_frame_newslot(obj4876);
  if (objclass4876 == NULL) {
    glfree(obj4876->class->name);
    obj4876->class->name = "range.from(_)downTo(_).iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4876, self, 0);
  addmethodreal(obj4876,"outer", &reader_collectionsPrelude_outer_4877);
  Object oldself4876 = self;
  struct StackFrameObject *oldstackframe4876 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4876);
  gc_frame_newslot((Object)stackframe);
  self = obj4876;
  Object *oldselfslot4876 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4876 = (*(struct UserObject *)self).data[0], lowerouter4876 = thisouter4876;
  if (inheritingObject4876) {
    struct UserObject *inho4876 = (struct UserObject *)inheritingObject4876;
    while (inho4876->super != GraceDefaultObject) inho4876 = (struct UserObject *)inho4876->super;
    inho4876->super = obj4876;
    self = inheritingObject4876;
    *selfslot = self;
    lowerouter4876 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4876;
  }
  if (objclass4876 == NULL) {
    Method *reader4878 = addmethodrealflags(obj4876, "val", &reader_collectionsPrelude_val_4878, MFLAG_CONFIDENTIAL);
    Method *writer4878 = addmethodrealflags(obj4876, "val:=(1)", &writer_collectionsPrelude_val_4878, MFLAG_CONFIDENTIAL);
    reader4878->definitionModule = modulename;
    writer4878->definitionModule = modulename;
    reader4878->definitionLine = 1769;
    writer4878->definitionLine = 1769;
  }
  obj4876->flags |= OFLAG_MUTABLE;
  adddatum2(obj4876, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4879 = (struct UserObject*)obj4876;
  uo4879->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4879_hasNext = addmethod2pos(obj4876, "hasNext", &meth_collectionsPrelude_4879_hasNext, 2);
  int argcv_meth_collectionsPrelude_4879_hasNext[] = {0};
  meth_meth_collectionsPrelude_4879_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4879_hasNext);
  meth_meth_collectionsPrelude_4879_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_4879_hasNext->definitionLine = 1770;
// method "next"
  block_savedest(obj4876);
  Object closure4889 = createclosure(1, "next");
  setclosureframe(closure4889, stackframe);
  addtoclosure(closure4889, var_IteratorExhausted);
  struct UserObject *uo4889 = (struct UserObject*)obj4876;
  uo4889->data[3] = (Object)closure4889;
  Method *meth_meth_collectionsPrelude_4889_next = addmethod2pos(obj4876, "next", &meth_collectionsPrelude_4889_next, 3);
  int argcv_meth_collectionsPrelude_4889_next[] = {0};
  meth_meth_collectionsPrelude_4889_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4889_next);
  meth_meth_collectionsPrelude_4889_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_4889_next->definitionLine = 1771;
// method "asString"
  struct UserObject *uo4928 = (struct UserObject*)obj4876;
  uo4928->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_4928_asString = addmethod2pos(obj4876, "asString", &meth_collectionsPrelude_4928_asString, 4);
  int argcv_meth_collectionsPrelude_4928_asString[] = {0};
  meth_meth_collectionsPrelude_4928_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4928_asString);
  meth_meth_collectionsPrelude_4928_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_4928_asString->definitionLine = 1776;
  sourceObject = obj4876;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4950 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4951 = gc_frame_new();
// call case 3: self.outer request
  Object call4952 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4951);
// compiled member node returning call4952 (depth = 3)
  partcv[0] = 0;
  Object call4953 = callmethodflags(call4952, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4950);
// compiled member node returning call4953 (depth = 2)
  adddatum2(obj4876, call4953, 1);
  sourceObject = obj4876;
  sourceObject = obj4876;
  sourceObject = obj4876;
  objclass4876 = obj4876->class;
  objclass4876->definitionModule = modulename;
  objclass4876->definitionLine = 1768;
  (*(struct UserObject *)self).data[0] = lowerouter4876;
  self = oldself4876;
  selfslot = oldselfslot4876;
  stackframe = oldstackframe4876;
  gc_frame_end(frame);
  return obj4876;
}
Object meth_collectionsPrelude_4955_at_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4957 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4959 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4960 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4959);
// compiled member node returning call4960 (depth = 5)
  int op_slot_right_4958 = gc_frame_newslot(call4960);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4958 = gc_frame_newslot(*var_ix);
  params[0] = call4960;
  partcv[0] = 1;
  Object opresult4962 = callmethod(*var_ix, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4962 (depth = 4)
  partcv[0] = 0;
  Object call4963 = callmethodflags(opresult4962, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4957);
// compiled call node returning call4963 (depth = 3)
  Object if4956 = done;
  if (istrue(call4963)) {
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4964 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4966 == NULL) {
    strlit4966 = alloc_String("");
    gc_root(strlit4966);
  }
// compiled string node returning strlit4966 (depth = 5)
  int op_slot_right_4965 = gc_frame_newslot(strlit4966);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4969 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4970 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4969);
// compiled member node returning call4970 (depth = 6)
  int op_slot_right_4968 = gc_frame_newslot(call4970);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4973 == NULL) {
    strlit4973 = alloc_String(") but upper bound is ");
    gc_root(strlit4973);
  }
// compiled string node returning strlit4973 (depth = 7)
  int op_slot_right_4972 = gc_frame_newslot(strlit4973);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_right_4975 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 8)
  if (strlit4977 == NULL) {
    strlit4977 = alloc_String("requested range.at(");
    gc_root(strlit4977);
  }
// compiled string node returning strlit4977 (depth = 8)
  int op_slot_left_4975 = gc_frame_newslot(strlit4977);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4978 = callmethod(strlit4977, "++(1)", 1, partcv, params);
// compiled op node returning opresult4978 (depth = 7)
  int op_slot_left_4972 = gc_frame_newslot(opresult4978);
  params[0] = strlit4973;
  partcv[0] = 1;
  Object opresult4979 = callmethod(opresult4978, "++(1)", 1, partcv, params);
// compiled op node returning opresult4979 (depth = 6)
  int op_slot_left_4968 = gc_frame_newslot(opresult4979);
  params[0] = call4970;
  partcv[0] = 1;
  Object opresult4980 = callmethod(opresult4979, "++(1)", 1, partcv, params);
// compiled op node returning opresult4980 (depth = 5)
  int op_slot_left_4965 = gc_frame_newslot(opresult4980);
  params[0] = strlit4966;
  partcv[0] = 1;
  Object opresult4981 = callmethod(opresult4980, "++(1)", 1, partcv, params);
// compiled op node returning opresult4981 (depth = 4)
  gc_frame_newslot(opresult4981);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4981;
  partcv[0] = 1;
  Object call4982 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4964);
// compiled call node returning call4982 (depth = 3)
    gc_frame_newslot(call4982);
    if4956 = call4982;
  } else {
  }
// compiled if node returning if4956 (depth = 2)
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4984 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4986 = alloc_Float64(1);
// compiled num node returning num4986 (depth = 5)
  int op_slot_right_4985 = gc_frame_newslot(num4986);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4985 = gc_frame_newslot(*var_ix);
  params[0] = num4986;
  partcv[0] = 1;
  Object opresult4988 = callmethod(*var_ix, "≥(1)", 1, partcv, params);
// compiled op node returning opresult4988 (depth = 4)
  partcv[0] = 0;
  Object call4989 = callmethodflags(opresult4988, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4984);
// compiled call node returning call4989 (depth = 3)
  Object if4983 = done;
  if (istrue(call4989)) {
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4990 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4992 == NULL) {
    strlit4992 = alloc_String(") but lower bound is 1");
    gc_root(strlit4992);
  }
// compiled string node returning strlit4992 (depth = 5)
  int op_slot_right_4991 = gc_frame_newslot(strlit4992);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_right_4994 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 6)
  if (strlit4996 == NULL) {
    strlit4996 = alloc_String("requested range.at(");
    gc_root(strlit4996);
  }
// compiled string node returning strlit4996 (depth = 6)
  int op_slot_left_4994 = gc_frame_newslot(strlit4996);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4997 = callmethod(strlit4996, "++(1)", 1, partcv, params);
// compiled op node returning opresult4997 (depth = 5)
  int op_slot_left_4991 = gc_frame_newslot(opresult4997);
  params[0] = strlit4992;
  partcv[0] = 1;
  Object opresult4998 = callmethod(opresult4997, "++(1)", 1, partcv, params);
// compiled op node returning opresult4998 (depth = 4)
  gc_frame_newslot(opresult4998);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4998;
  partcv[0] = 1;
  Object call4999 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4990);
// compiled call node returning call4999 (depth = 3)
    gc_frame_newslot(call4999);
    if4983 = call4999;
  } else {
  }
// compiled if node returning if4983 (depth = 2)
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5002 = alloc_Float64(1);
// compiled num node returning num5002 (depth = 5)
  int op_slot_right_5001 = gc_frame_newslot(num5002);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_5001 = gc_frame_newslot(*var_ix);
  params[0] = num5002;
  partcv[0] = 1;
  Object diff5004 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff5004 (depth = 4)
  int op_slot_right_5000 = gc_frame_newslot(diff5004);
// starting to compile member node (depth = 4)
  int callframe5006 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5007 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5006);
// compiled member node returning call5007 (depth = 4)
  int op_slot_left_5000 = gc_frame_newslot(call5007);
  params[0] = diff5004;
  partcv[0] = 1;
  Object diff5008 = callmethod(call5007, "-(1)", 1, partcv, params);
// compiled op node returning diff5008 (depth = 3)
  return diff5008;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_5012__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elem = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_intElem = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "intElem");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5013 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  partcv[0] = 0;
  Object call5014 = callmethodflags(*var_elem, "truncated", 1, partcv, params, 0);
  gc_frame_end(callframe5013);
// compiled member node returning call5014 (depth = 5)
  *var_intElem = call5014;
  if (call5014 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  int op_slot_right_5016 = gc_frame_newslot(*var_elem);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5016 = gc_frame_newslot(*var_intElem);
  params[0] = *var_elem;
  partcv[0] = 1;
  Object opresult5018 = callmethod(*var_intElem, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5018 (depth = 5)
  Object if5015 = done;
  if (istrue(opresult5018)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5019 = alloc_Boolean(0);
// compiled identifier node returning bool5019 (depth = 6)
  block_return(realself, bool5019);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5015 = undefined;
  } else {
  }
// compiled if node returning if5015 (depth = 4)
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5022 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5023 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5022);
// compiled member node returning call5023 (depth = 6)
  int op_slot_right_5021 = gc_frame_newslot(call5023);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5021 = gc_frame_newslot(*var_intElem);
  params[0] = call5023;
  partcv[0] = 1;
  Object opresult5025 = callmethod(*var_intElem, ">(1)", 1, partcv, params);
// compiled op node returning opresult5025 (depth = 5)
  Object if5020 = done;
  if (istrue(opresult5025)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5026 = alloc_Boolean(0);
// compiled identifier node returning bool5026 (depth = 6)
  block_return(realself, bool5026);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5020 = undefined;
  } else {
  }
// compiled if node returning if5020 (depth = 4)
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5029 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5030 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5029);
// compiled member node returning call5030 (depth = 6)
  int op_slot_right_5028 = gc_frame_newslot(call5030);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5028 = gc_frame_newslot(*var_intElem);
  params[0] = call5030;
  partcv[0] = 1;
  Object opresult5032 = callmethod(*var_intElem, "<(1)", 1, partcv, params);
// compiled op node returning opresult5032 (depth = 5)
  Object if5027 = done;
  if (istrue(opresult5032)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5033 = alloc_Boolean(0);
// compiled identifier node returning bool5033 (depth = 6)
  block_return(realself, bool5033);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5027 = undefined;
  } else {
  }
// compiled if node returning if5027 (depth = 4)
  gc_frame_end(frame);
  return if5027;
}
Object meth_collectionsPrelude_5036__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5037 = alloc_Boolean(0);
// compiled identifier node returning bool5037 (depth = 5)
  block_return(realself, bool5037);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_5009_contains_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block5011 = alloc_Block(NULL, NULL, "collectionsPrelude", 1789);
  gc_frame_newslot(block5011);
// method "_apply"
  block_savedest(block5011);
  Object closure5012 = createclosure(2, "_apply");
  setclosureframe(closure5012, stackframe);
  addtoclosure(closure5012, var_elem);
  addtoclosure(closure5012, selfslot);
  struct UserObject *uo5012 = (struct UserObject*)block5011;
  uo5012->data[0] = (Object)closure5012;
  Method *meth_meth_collectionsPrelude_5012__apply = addmethod2pos(block5011, "_apply", &meth_collectionsPrelude_5012__apply, 0);
  int argcv_meth_collectionsPrelude_5012__apply[] = {0};
  meth_meth_collectionsPrelude_5012__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5012__apply);
  meth_meth_collectionsPrelude_5012__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_5012__apply->definitionLine = 1769;
// compiled block node returning block5011 (depth = 3)
  int frame5010 = gc_frame_new();
  gc_frame_newslot(block5011);
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5035 = alloc_Block(NULL, NULL, "collectionsPrelude", 1794);
  gc_frame_newslot(block5035);
// method "_apply(_)"
  block_savedest(block5035);
  Object closure5036 = createclosure(1, "_apply(1)");
  setclosureframe(closure5036, stackframe);
  addtoclosure(closure5036, selfslot);
  struct UserObject *uo5036 = (struct UserObject*)block5035;
  uo5036->data[0] = (Object)closure5036;
  Method *meth_meth_collectionsPrelude_5036__apply_40_1_41_ = addmethod2pos(block5035, "_apply(1)", &meth_collectionsPrelude_5036__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5036__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5036__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5036__apply_40_1_41_);
  meth_meth_collectionsPrelude_5036__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5036__apply_40_1_41_->definitionLine = 1769;
// starting to compile call node (depth = 4)
  int callframe5039 = gc_frame_new();
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5040 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5041 == NULL) {
    strlit5041 = alloc_String("ex");
    gc_root(strlit5041);
  }
// compiled string node returning strlit5041 (depth = 6)
  gc_frame_newslot(strlit5041);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5042 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5043 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5042);
// compiled member node returning call5043 (depth = 6)
  params[0] = strlit5041;
  partcv[0] = 1;
  Object call5044 = callmethodflags(call5043, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5040);
// compiled call node returning call5044 (depth = 5)
  gc_frame_newslot(call5044);
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5045 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5046 = callmethodflags(prelude, "Exception", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5045);
// compiled member node returning call5046 (depth = 5)
  gc_frame_newslot(call5046);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5047 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5048 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5047);
// compiled member node returning call5048 (depth = 5)
  params[0] = call5044;
  params[1] = call5046;
  partcv[0] = 2;
  Object call5049 = callmethodflags(call5048, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5039);
// compiled call node returning call5049 (depth = 4)
((struct UserObject *)block5035)->data[1] = call5049;
// compiled block node returning block5035 (depth = 3)
  gc_frame_newslot(block5035);
  params[0] = block5035;
  setline(1789);
  Object catchres5010 = tryCatch(block5011, params, 1,NULL);
  gc_frame_end(frame5010);
// compiled trycatch node returning catchres5010 (depth = 2)
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5050 = alloc_Boolean(1);
// compiled identifier node returning bool5050 (depth = 3)
  return bool5050;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_5056__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5059 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5058);
// compiled member node returning call5059 (depth = 5)
  int op_slot_right_5057 = gc_frame_newslot(call5059);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_5057 = gc_frame_newslot(*var_val);
  params[0] = call5059;
  partcv[0] = 1;
  Object opresult5061 = callmethod(*var_val, "≥(1)", 1, partcv, params);
// compiled op node returning opresult5061 (depth = 4)
  gc_frame_end(frame);
  return opresult5061;
}
Object meth_collectionsPrelude_5064__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5065 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_val;
  partcv[0] = 1;
  Object call5066 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5065);
// compiled call node returning call5066 (depth = 4)
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5068 = alloc_Float64(1);
// compiled num node returning num5068 (depth = 6)
  int op_slot_right_5067 = gc_frame_newslot(num5068);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_5067 = gc_frame_newslot(*var_val);
  params[0] = num5068;
  partcv[0] = 1;
  Object diff5070 = callmethod(*var_val, "-(1)", 1, partcv, params);
// compiled op node returning diff5070 (depth = 5)
  *var_val = diff5070;
  if (diff5070 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_5051_do_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5052 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5053 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5052);
// compiled member node returning call5053 (depth = 3)
  *var_val = call5053;
  if (call5053 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5054 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5055 = alloc_Block(NULL, NULL, "collectionsPrelude", 1799);
  gc_frame_newslot(block5055);
// method "_apply"
  block_savedest(block5055);
  Object closure5056 = createclosure(2, "_apply");
  setclosureframe(closure5056, stackframe);
  addtoclosure(closure5056, var_val);
  addtoclosure(closure5056, selfslot);
  struct UserObject *uo5056 = (struct UserObject*)block5055;
  uo5056->data[0] = (Object)closure5056;
  Method *meth_meth_collectionsPrelude_5056__apply = addmethod2pos(block5055, "_apply", &meth_collectionsPrelude_5056__apply, 0);
  int argcv_meth_collectionsPrelude_5056__apply[] = {0};
  meth_meth_collectionsPrelude_5056__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5056__apply);
  meth_meth_collectionsPrelude_5056__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_5056__apply->definitionLine = 1769;
// compiled block node returning block5055 (depth = 3)
  gc_frame_newslot(block5055);
// starting to compile block node (depth = 3)
  Object block5063 = alloc_Block(NULL, NULL, "collectionsPrelude", 1799);
  gc_frame_newslot(block5063);
// method "_apply"
  block_savedest(block5063);
  Object closure5064 = createclosure(3, "_apply");
  setclosureframe(closure5064, stackframe);
  addtoclosure(closure5064, var_val);
  addtoclosure(closure5064, var_block1);
  addtoclosure(closure5064, selfslot);
  struct UserObject *uo5064 = (struct UserObject*)block5063;
  uo5064->data[0] = (Object)closure5064;
  Method *meth_meth_collectionsPrelude_5064__apply = addmethod2pos(block5063, "_apply", &meth_collectionsPrelude_5064__apply, 0);
  int argcv_meth_collectionsPrelude_5064__apply[] = {0};
  meth_meth_collectionsPrelude_5064__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5064__apply);
  meth_meth_collectionsPrelude_5064__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_5064__apply->definitionLine = 1769;
// compiled block node returning block5063 (depth = 3)
  gc_frame_newslot(block5063);
// call case 5: prelude request
  params[0] = block5055;
  params[1] = block5063;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5073 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5054);
// compiled call node returning call5073 (depth = 2)
  gc_frame_end(frame);
  return call5073;
}
Object meth_collectionsPrelude_5080__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5082 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5083 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5082);
// compiled member node returning call5083 (depth = 5)
  int op_slot_right_5081 = gc_frame_newslot(call5083);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_5081 = gc_frame_newslot(*var_val);
  params[0] = call5083;
  partcv[0] = 1;
  Object opresult5085 = callmethod(*var_val, "≥(1)", 1, partcv, params);
// compiled op node returning opresult5085 (depth = 4)
  gc_frame_end(frame);
  return opresult5085;
}
Object meth_collectionsPrelude_5088__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_key = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5089 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_key (depth = 5)
  gc_frame_newslot(*var_key);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_key;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call5090 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5089);
// compiled call node returning call5090 (depth = 4)
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5092 = alloc_Float64(1);
// compiled num node returning num5092 (depth = 6)
  int op_slot_right_5091 = gc_frame_newslot(num5092);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_key (depth = 6)
  int op_slot_left_5091 = gc_frame_newslot(*var_key);
  params[0] = num5092;
  partcv[0] = 1;
  Object sum5094 = callmethod(*var_key, "+(1)", 1, partcv, params);
// compiled op node returning sum5094 (depth = 5)
  *var_key = sum5094;
  if (sum5094 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5097 = alloc_Float64(1);
// compiled num node returning num5097 (depth = 6)
  int op_slot_right_5096 = gc_frame_newslot(num5097);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_5096 = gc_frame_newslot(*var_val);
  params[0] = num5097;
  partcv[0] = 1;
  Object diff5099 = callmethod(*var_val, "-(1)", 1, partcv, params);
// compiled op node returning diff5099 (depth = 5)
  *var_val = diff5099;
  if (diff5099 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_key = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "key");
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num5075 = alloc_Float64(1);
// compiled num node returning num5075 (depth = 3)
  *var_key = num5075;
  if (num5075 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5076 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5077 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5076);
// compiled member node returning call5077 (depth = 3)
  *var_val = call5077;
  if (call5077 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5078 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5079 = alloc_Block(NULL, NULL, "collectionsPrelude", 1807);
  gc_frame_newslot(block5079);
// method "_apply"
  block_savedest(block5079);
  Object closure5080 = createclosure(2, "_apply");
  setclosureframe(closure5080, stackframe);
  addtoclosure(closure5080, var_val);
  addtoclosure(closure5080, selfslot);
  struct UserObject *uo5080 = (struct UserObject*)block5079;
  uo5080->data[0] = (Object)closure5080;
  Method *meth_meth_collectionsPrelude_5080__apply = addmethod2pos(block5079, "_apply", &meth_collectionsPrelude_5080__apply, 0);
  int argcv_meth_collectionsPrelude_5080__apply[] = {0};
  meth_meth_collectionsPrelude_5080__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5080__apply);
  meth_meth_collectionsPrelude_5080__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_5080__apply->definitionLine = 1769;
// compiled block node returning block5079 (depth = 3)
  gc_frame_newslot(block5079);
// starting to compile block node (depth = 3)
  Object block5087 = alloc_Block(NULL, NULL, "collectionsPrelude", 1807);
  gc_frame_newslot(block5087);
// method "_apply"
  block_savedest(block5087);
  Object closure5088 = createclosure(4, "_apply");
  setclosureframe(closure5088, stackframe);
  addtoclosure(closure5088, var_key);
  addtoclosure(closure5088, var_val);
  addtoclosure(closure5088, var_block2);
  addtoclosure(closure5088, selfslot);
  struct UserObject *uo5088 = (struct UserObject*)block5087;
  uo5088->data[0] = (Object)closure5088;
  Method *meth_meth_collectionsPrelude_5088__apply = addmethod2pos(block5087, "_apply", &meth_collectionsPrelude_5088__apply, 0);
  int argcv_meth_collectionsPrelude_5088__apply[] = {0};
  meth_meth_collectionsPrelude_5088__apply->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5088__apply);
  meth_meth_collectionsPrelude_5088__apply->definitionModule = modulename;
  meth_meth_collectionsPrelude_5088__apply->definitionLine = 1769;
// compiled block node returning block5087 (depth = 3)
  gc_frame_newslot(block5087);
// call case 5: prelude request
  params[0] = block5079;
  params[1] = block5087;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5102 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5078);
// compiled call node returning call5102 (depth = 2)
  gc_frame_end(frame);
  return call5102;
}
Object meth_collectionsPrelude_5103_reversed(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5104 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5105 = gc_frame_new();
// call case 3: self.outer request
  Object call5106 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5105);
// compiled member node returning call5106 (depth = 3)
  params[0] = *var_lower;
  params[1] = *var_upper;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5107 = callmethodflags(call5106, "from(1)to(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5104);
// compiled call node returning call5107 (depth = 2)
  gc_frame_end(frame);
  return call5107;
}
Object meth_collectionsPrelude_5108__43__43__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5109 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe5110 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call5111 = callmethodflags(module_collectionsPrelude, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5110);
// compiled call node returning call5111 (depth = 3)
  gc_frame_newslot(call5111);
// call case 6: other requests
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5112 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  partcv[0] = 0;
  Object call5113 = callmethodflags(module_collectionsPrelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5112);
// compiled member node returning call5113 (depth = 3)
  params[0] = call5111;
  partcv[0] = 1;
  Object call5114 = callmethodflags(call5113, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5109);
// compiled call node returning call5114 (depth = 2)
  gc_frame_end(frame);
  return call5114;
}
Object meth_collectionsPrelude_5115__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5116 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5117 = callmethodflags(module_collectionsPrelude, "isEqual(1)toCollection(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5116);
// compiled call node returning call5117 (depth = 2)
  gc_frame_end(frame);
  return call5117;
}
Object meth_collectionsPrelude_5118_sorted(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5119 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5120 = callmethodflags(self, "reversed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5119);
// compiled member node returning call5120 (depth = 2)
  gc_frame_end(frame);
  return call5120;
}
Object meth_collectionsPrelude_5121_sortedBy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5122 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile call node (depth = 3)
  int callframe5123 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5124 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call5125 = callmethodflags(module_collectionsPrelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5124);
// compiled member node returning call5125 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5126 = callmethodflags(call5125, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5123);
// compiled call node returning call5126 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call5127 = callmethodflags(call5126, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5122);
// compiled call node returning call5127 (depth = 2)
  gc_frame_end(frame);
  return call5127;
}
Object meth_collectionsPrelude_5128_keys(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5130 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5131 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5130);
// compiled member node returning call5131 (depth = 3)
  int op_slot_right_5129 = gc_frame_newslot(call5131);
// starting to compile num node (depth = 3)
  Object num5133 = alloc_Float64(1);
// compiled num node returning num5133 (depth = 3)
  int op_slot_left_5129 = gc_frame_newslot(num5133);
  params[0] = call5131;
  partcv[0] = 1;
  Object opresult5134 = callmethod(num5133, "..(1)", 1, partcv, params);
// compiled op node returning opresult5134 (depth = 2)
  gc_frame_end(frame);
  return opresult5134;
}
Object meth_collectionsPrelude_5135_values(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_5136_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit5138 == NULL) {
    strlit5138 = alloc_String("");
    gc_root(strlit5138);
  }
// compiled string node returning strlit5138 (depth = 3)
  int op_slot_right_5137 = gc_frame_newslot(strlit5138);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5140 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5143 == NULL) {
    strlit5143 = alloc_String(" downTo ");
    gc_root(strlit5143);
  }
// compiled string node returning strlit5143 (depth = 5)
  int op_slot_right_5142 = gc_frame_newslot(strlit5143);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_5145 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 6)
  if (strlit5147 == NULL) {
    strlit5147 = alloc_String("range.from ");
    gc_root(strlit5147);
  }
// compiled string node returning strlit5147 (depth = 6)
  int op_slot_left_5145 = gc_frame_newslot(strlit5147);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5148 = callmethod(strlit5147, "++(1)", 1, partcv, params);
// compiled op node returning opresult5148 (depth = 5)
  int op_slot_left_5142 = gc_frame_newslot(opresult5148);
  params[0] = strlit5143;
  partcv[0] = 1;
  Object opresult5149 = callmethod(opresult5148, "++(1)", 1, partcv, params);
// compiled op node returning opresult5149 (depth = 4)
  int op_slot_left_5140 = gc_frame_newslot(opresult5149);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5150 = callmethod(opresult5149, "++(1)", 1, partcv, params);
// compiled op node returning opresult5150 (depth = 3)
  int op_slot_left_5137 = gc_frame_newslot(opresult5150);
  params[0] = strlit5138;
  partcv[0] = 1;
  Object opresult5151 = callmethod(opresult5150, "++(1)", 1, partcv, params);
// compiled op node returning opresult5151 (depth = 2)
  gc_frame_end(frame);
  return opresult5151;
}
Object meth_collectionsPrelude_5156__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___10 = &(stackframe->slots[0]);
  *var___10 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_5168__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___11 = &(stackframe->slots[0]);
  *var___11 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe5169 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5172 == NULL) {
    strlit5172 = alloc_String(") is not an integer");
    gc_root(strlit5172);
  }
// compiled string node returning strlit5172 (depth = 7)
  int op_slot_right_5171 = gc_frame_newslot(strlit5172);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5174 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5177 == NULL) {
    strlit5177 = alloc_String(")downTo(");
    gc_root(strlit5177);
  }
// compiled string node returning strlit5177 (depth = 9)
  int op_slot_right_5176 = gc_frame_newslot(strlit5177);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_upper (depth = 10)
  int op_slot_right_5179 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 10)
  if (strlit5181 == NULL) {
    strlit5181 = alloc_String(" in range.from(");
    gc_root(strlit5181);
  }
// compiled string node returning strlit5181 (depth = 10)
  int op_slot_left_5179 = gc_frame_newslot(strlit5181);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5182 = callmethod(strlit5181, "++(1)", 1, partcv, params);
// compiled op node returning opresult5182 (depth = 9)
  int op_slot_left_5176 = gc_frame_newslot(opresult5182);
  params[0] = strlit5177;
  partcv[0] = 1;
  Object opresult5183 = callmethod(opresult5182, "++(1)", 1, partcv, params);
// compiled op node returning opresult5183 (depth = 8)
  int op_slot_left_5174 = gc_frame_newslot(opresult5183);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5184 = callmethod(opresult5183, "++(1)", 1, partcv, params);
// compiled op node returning opresult5184 (depth = 7)
  int op_slot_left_5171 = gc_frame_newslot(opresult5184);
  params[0] = strlit5172;
  partcv[0] = 1;
  Object opresult5185 = callmethod(opresult5184, "++(1)", 1, partcv, params);
// compiled op node returning opresult5185 (depth = 6)
  int op_slot_right_5170 = gc_frame_newslot(opresult5185);
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5188 == NULL) {
    strlit5188 = alloc_String("");
    gc_root(strlit5188);
  }
// compiled string node returning strlit5188 (depth = 7)
  int op_slot_right_5187 = gc_frame_newslot(strlit5188);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_5190 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit5192 == NULL) {
    strlit5192 = alloc_String("upper bound ");
    gc_root(strlit5192);
  }
// compiled string node returning strlit5192 (depth = 8)
  int op_slot_left_5190 = gc_frame_newslot(strlit5192);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5193 = callmethod(strlit5192, "++(1)", 1, partcv, params);
// compiled op node returning opresult5193 (depth = 7)
  int op_slot_left_5187 = gc_frame_newslot(opresult5193);
  params[0] = strlit5188;
  partcv[0] = 1;
  Object opresult5194 = callmethod(opresult5193, "++(1)", 1, partcv, params);
// compiled op node returning opresult5194 (depth = 6)
  int op_slot_left_5170 = gc_frame_newslot(opresult5194);
  params[0] = opresult5185;
  partcv[0] = 1;
  Object opresult5195 = callmethod(opresult5194, "++(1)", 1, partcv, params);
// compiled op node returning opresult5195 (depth = 5)
  gc_frame_newslot(opresult5195);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5195;
  partcv[0] = 1;
  Object call5196 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5169);
// compiled call node returning call5196 (depth = 4)
  gc_frame_end(frame);
  return call5196;
}
Object meth_collectionsPrelude_5236__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___12 = &(stackframe->slots[0]);
  *var___12 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_5248__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___13 = &(stackframe->slots[0]);
  *var___13 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe5249 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5252 == NULL) {
    strlit5252 = alloc_String(") is not an integer");
    gc_root(strlit5252);
  }
// compiled string node returning strlit5252 (depth = 7)
  int op_slot_right_5251 = gc_frame_newslot(strlit5252);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5254 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5257 == NULL) {
    strlit5257 = alloc_String(")downTo(");
    gc_root(strlit5257);
  }
// compiled string node returning strlit5257 (depth = 9)
  int op_slot_right_5256 = gc_frame_newslot(strlit5257);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_upper (depth = 10)
  int op_slot_right_5259 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 10)
  if (strlit5261 == NULL) {
    strlit5261 = alloc_String(" in range.from(");
    gc_root(strlit5261);
  }
// compiled string node returning strlit5261 (depth = 10)
  int op_slot_left_5259 = gc_frame_newslot(strlit5261);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5262 = callmethod(strlit5261, "++(1)", 1, partcv, params);
// compiled op node returning opresult5262 (depth = 9)
  int op_slot_left_5256 = gc_frame_newslot(opresult5262);
  params[0] = strlit5257;
  partcv[0] = 1;
  Object opresult5263 = callmethod(opresult5262, "++(1)", 1, partcv, params);
// compiled op node returning opresult5263 (depth = 8)
  int op_slot_left_5254 = gc_frame_newslot(opresult5263);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5264 = callmethod(opresult5263, "++(1)", 1, partcv, params);
// compiled op node returning opresult5264 (depth = 7)
  int op_slot_left_5251 = gc_frame_newslot(opresult5264);
  params[0] = strlit5252;
  partcv[0] = 1;
  Object opresult5265 = callmethod(opresult5264, "++(1)", 1, partcv, params);
// compiled op node returning opresult5265 (depth = 6)
  int op_slot_right_5250 = gc_frame_newslot(opresult5265);
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5268 == NULL) {
    strlit5268 = alloc_String("");
    gc_root(strlit5268);
  }
// compiled string node returning strlit5268 (depth = 7)
  int op_slot_right_5267 = gc_frame_newslot(strlit5268);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5270 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit5272 == NULL) {
    strlit5272 = alloc_String("lower bound ");
    gc_root(strlit5272);
  }
// compiled string node returning strlit5272 (depth = 8)
  int op_slot_left_5270 = gc_frame_newslot(strlit5272);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5273 = callmethod(strlit5272, "++(1)", 1, partcv, params);
// compiled op node returning opresult5273 (depth = 7)
  int op_slot_left_5267 = gc_frame_newslot(opresult5273);
  params[0] = strlit5268;
  partcv[0] = 1;
  Object opresult5274 = callmethod(opresult5273, "++(1)", 1, partcv, params);
// compiled op node returning opresult5274 (depth = 6)
  int op_slot_left_5250 = gc_frame_newslot(opresult5274);
  params[0] = opresult5265;
  partcv[0] = 1;
  Object opresult5275 = callmethod(opresult5274, "++(1)", 1, partcv, params);
// compiled op node returning opresult5275 (depth = 5)
  gc_frame_newslot(opresult5275);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5275;
  partcv[0] = 1;
  Object call5276 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5249);
// compiled call node returning call5276 (depth = 4)
  gc_frame_end(frame);
  return call5276;
}
Object meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from(1)downTo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)downTo(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)downTo(_)");
  Object params[2];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var_Number = getfromclosure(closure, 2);
  Object *var_RequestError = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from(_)downTo(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_upper = &(stackframe->slots[0]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *var_lower = &(stackframe->slots[1]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part downTo(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4870 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4870 = alloc_userobj2(21,22, objclass4870);
  gc_frame_newslot(obj4870);
  if (objclass4870 == NULL) {
    glfree(obj4870->class->name);
    obj4870->class->name = "range.from(_)downTo(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4870, self, 0);
  addmethodreal(obj4870,"outer", &reader_collectionsPrelude_outer_4871);
  Object oldself4870 = self;
  struct StackFrameObject *oldstackframe4870 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4870);
  gc_frame_newslot((Object)stackframe);
  self = obj4870;
  Object *oldselfslot4870 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4870 = (*(struct UserObject *)self).data[0], lowerouter4870 = thisouter4870;
  if (inheritingObject4870) {
    struct UserObject *inho4870 = (struct UserObject *)inheritingObject4870;
    while (inho4870->super != GraceDefaultObject) inho4870 = (struct UserObject *)inho4870->super;
    inho4870->super = obj4870;
    self = inheritingObject4870;
    *selfslot = self;
    lowerouter4870 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4870;
  }
  if (objclass4870 == NULL) {
  Method *reader4872 = addmethodrealflags(obj4870, "start",&reader_collectionsPrelude_start_4872, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4872->definitionModule = modulename;
  reader4872->definitionLine = 1751;
  }
  adddatum2(obj4870, alloc_Undefined(), 1);
  if (objclass4870 == NULL) {
  Method *reader4873 = addmethodrealflags(obj4870, "stop",&reader_collectionsPrelude_stop_4873, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4873->definitionModule = modulename;
  reader4873->definitionLine = 1760;
  }
  adddatum2(obj4870, alloc_Undefined(), 2);
  if (objclass4870 == NULL) {
  Method *reader4874 = addmethodrealflags(obj4870, "size",&reader_collectionsPrelude_size_4874, MFLAG_DEF);
  reader4874->definitionModule = modulename;
  reader4874->definitionLine = 1765;
  }
  adddatum2(obj4870, alloc_Undefined(), 3);
// method "iterator"
  block_savedest(obj4870);
  Object closure4875 = createclosure(1, "iterator");
  setclosureframe(closure4875, stackframe);
  addtoclosure(closure4875, var_IteratorExhausted);
  struct UserObject *uo4875 = (struct UserObject*)obj4870;
  uo4875->data[4] = (Object)closure4875;
  Method *meth_meth_collectionsPrelude_4875_iterator = addmethod2pos(obj4870, "iterator", &meth_collectionsPrelude_4875_iterator, 4);
  int argcv_meth_collectionsPrelude_4875_iterator[] = {0};
  meth_meth_collectionsPrelude_4875_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4875_iterator);
  meth_meth_collectionsPrelude_4875_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_4875_iterator->definitionLine = 1767;
  block_savedest(obj4870);
  Object closure4954 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure4954, stackframe);
  addtoclosure(closure4954, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_4875_iterator_object = addmethod2pos(obj4870, "iterator$object(1)", &meth_collectionsPrelude_4875_iterator_object, 4);
  meth_meth_collectionsPrelude_4875_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_4875_iterator_object->definitionLine = 1767;
// method "at(_)"
  block_savedest(obj4870);
  Object closure4955 = createclosure(1, "at(1)");
  setclosureframe(closure4955, stackframe);
  addtoclosure(closure4955, var_BoundsError);
  struct UserObject *uo4955 = (struct UserObject*)obj4870;
  uo4955->data[5] = (Object)closure4955;
  Method *meth_meth_collectionsPrelude_4955_at_40_1_41_ = addmethod2pos(obj4870, "at(1)", &meth_collectionsPrelude_4955_at_40_1_41_, 5);
  int argcv_meth_collectionsPrelude_4955_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4955_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4955_at_40_1_41_);
meth_meth_collectionsPrelude_4955_at_40_1_41_->type->types[0] = type_Number;
meth_meth_collectionsPrelude_4955_at_40_1_41_->type->names[0] = "ix";
  meth_meth_collectionsPrelude_4955_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4955_at_40_1_41_->definitionLine = 1779;
// method "contains(_)"
  struct UserObject *uo5009 = (struct UserObject*)obj4870;
  uo5009->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5009_contains_40_1_41_ = addmethod2pos(obj4870, "contains(1)", &meth_collectionsPrelude_5009_contains_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_5009_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5009_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5009_contains_40_1_41_);
  meth_meth_collectionsPrelude_5009_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5009_contains_40_1_41_->definitionLine = 1788;
// method "do(_)"
  struct UserObject *uo5051 = (struct UserObject*)obj4870;
  uo5051->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5051_do_40_1_41_ = addmethod2pos(obj4870, "do(1)", &meth_collectionsPrelude_5051_do_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_5051_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5051_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5051_do_40_1_41_);
  meth_meth_collectionsPrelude_5051_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5051_do_40_1_41_->definitionLine = 1797;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5074 = (struct UserObject*)obj4870;
  uo5074->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_ = addmethod2pos(obj4870, "keysAndValuesDo(1)", &meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_->definitionLine = 1804;
// method "reversed"
  block_savedest(obj4870);
  Object closure5103 = createclosure(2, "reversed");
  setclosureframe(closure5103, stackframe);
  addtoclosure(closure5103, var_lower);
  addtoclosure(closure5103, var_upper);
  struct UserObject *uo5103 = (struct UserObject*)obj4870;
  uo5103->data[9] = (Object)closure5103;
  Method *meth_meth_collectionsPrelude_5103_reversed = addmethod2pos(obj4870, "reversed", &meth_collectionsPrelude_5103_reversed, 9);
  int argcv_meth_collectionsPrelude_5103_reversed[] = {0};
  meth_meth_collectionsPrelude_5103_reversed->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5103_reversed);
  meth_meth_collectionsPrelude_5103_reversed->definitionModule = modulename;
  meth_meth_collectionsPrelude_5103_reversed->definitionLine = 1813;
// method "++(_)"
  struct UserObject *uo5108 = (struct UserObject*)obj4870;
  uo5108->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5108__43__43__40_1_41_ = addmethod2pos(obj4870, "++(1)", &meth_collectionsPrelude_5108__43__43__40_1_41_, 10);
  int argcv_meth_collectionsPrelude_5108__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5108__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5108__43__43__40_1_41_);
  meth_meth_collectionsPrelude_5108__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5108__43__43__40_1_41_->definitionLine = 1816;
// method "==(_)"
  struct UserObject *uo5115 = (struct UserObject*)obj4870;
  uo5115->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5115__61__61__40_1_41_ = addmethod2pos(obj4870, "==(1)", &meth_collectionsPrelude_5115__61__61__40_1_41_, 11);
  int argcv_meth_collectionsPrelude_5115__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5115__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5115__61__61__40_1_41_);
  meth_meth_collectionsPrelude_5115__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5115__61__61__40_1_41_->definitionLine = 1819;
// method "sorted"
  struct UserObject *uo5118 = (struct UserObject*)obj4870;
  uo5118->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5118_sorted = addmethod2pos(obj4870, "sorted", &meth_collectionsPrelude_5118_sorted, 12);
  int argcv_meth_collectionsPrelude_5118_sorted[] = {0};
  meth_meth_collectionsPrelude_5118_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5118_sorted);
  meth_meth_collectionsPrelude_5118_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_5118_sorted->definitionLine = 1822;
// method "sortedBy(_)"
  struct UserObject *uo5121 = (struct UserObject*)obj4870;
  uo5121->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5121_sortedBy_40_1_41_ = addmethod2pos(obj4870, "sortedBy(1)", &meth_collectionsPrelude_5121_sortedBy_40_1_41_, 13);
  int argcv_meth_collectionsPrelude_5121_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5121_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5121_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_5121_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5121_sortedBy_40_1_41_->definitionLine = 1824;
// method "keys"
  struct UserObject *uo5128 = (struct UserObject*)obj4870;
  uo5128->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5128_keys = addmethod2pos(obj4870, "keys", &meth_collectionsPrelude_5128_keys, 14);
  int argcv_meth_collectionsPrelude_5128_keys[] = {0};
  meth_meth_collectionsPrelude_5128_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5128_keys);
  meth_meth_collectionsPrelude_5128_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_5128_keys->definitionLine = 1826;
// method "values"
  struct UserObject *uo5135 = (struct UserObject*)obj4870;
  uo5135->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5135_values = addmethod2pos(obj4870, "values", &meth_collectionsPrelude_5135_values, 15);
  int argcv_meth_collectionsPrelude_5135_values[] = {0};
  meth_meth_collectionsPrelude_5135_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5135_values);
  meth_meth_collectionsPrelude_5135_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_5135_values->definitionLine = 1828;
// method "asString"
  block_savedest(obj4870);
  Object closure5136 = createclosure(2, "asString");
  setclosureframe(closure5136, stackframe);
  addtoclosure(closure5136, var_lower);
  addtoclosure(closure5136, var_upper);
  struct UserObject *uo5136 = (struct UserObject*)obj4870;
  uo5136->data[16] = (Object)closure5136;
  Method *meth_meth_collectionsPrelude_5136_asString = addmethod2pos(obj4870, "asString", &meth_collectionsPrelude_5136_asString, 16);
  int argcv_meth_collectionsPrelude_5136_asString[] = {0};
  meth_meth_collectionsPrelude_5136_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5136_asString);
  meth_meth_collectionsPrelude_5136_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_5136_asString->definitionLine = 1830;
  sourceObject = obj4870;
// Begin line 1746
  setline(1746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5152 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5153 = callmethodflags(module_collectionsPrelude, "indexable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5152);
// compiled call node returning call5153 (depth = 2)
  struct UserObject *obj4870_uo = (struct UserObject *)obj4870;
  obj4870_uo->super = call5153;
  sourceObject = obj4870;
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame5154 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5155 = alloc_Block(NULL, NULL, "collectionsPrelude", 1748);
  gc_frame_newslot(block5155);
// method "_apply(_)"
  block_savedest(block5155);
  Object closure5156 = createclosure(1, "_apply(1)");
  setclosureframe(closure5156, stackframe);
  addtoclosure(closure5156, selfslot);
  struct UserObject *uo5156 = (struct UserObject*)block5155;
  uo5156->data[0] = (Object)closure5156;
  Method *meth_meth_collectionsPrelude_5156__apply_40_1_41_ = addmethod2pos(block5155, "_apply(1)", &meth_collectionsPrelude_5156__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5156__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5156__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5156__apply_40_1_41_);
meth_meth_collectionsPrelude_5156__apply_40_1_41_->type->types[0] = type_Number;
meth_meth_collectionsPrelude_5156__apply_40_1_41_->type->names[0] = "__10";
  meth_meth_collectionsPrelude_5156__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5156__apply_40_1_41_->definitionLine = 1769;
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5158 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5159 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5160 == NULL) {
    strlit5160 = alloc_String("__10");
    gc_root(strlit5160);
  }
// compiled string node returning strlit5160 (depth = 6)
  gc_frame_newslot(strlit5160);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5161 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5162 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5161);
// compiled member node returning call5162 (depth = 6)
  params[0] = strlit5160;
  partcv[0] = 1;
  Object call5163 = callmethodflags(call5162, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5159);
// compiled call node returning call5163 (depth = 5)
  gc_frame_newslot(call5163);
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5164 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5165 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5164);
// compiled member node returning call5165 (depth = 5)
  params[0] = call5163;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5166 = callmethodflags(call5165, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5158);
// compiled call node returning call5166 (depth = 4)
((struct UserObject *)block5155)->data[1] = call5166;
// compiled block node returning block5155 (depth = 3)
  gc_frame_newslot(block5155);
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5167 = alloc_Block(NULL, NULL, "collectionsPrelude", 1749);
  gc_frame_newslot(block5167);
// method "_apply(_)"
  block_savedest(block5167);
  Object closure5168 = createclosure(4, "_apply(1)");
  setclosureframe(closure5168, stackframe);
  addtoclosure(closure5168, var_lower);
  addtoclosure(closure5168, var_upper);
  addtoclosure(closure5168, var_RequestError);
  addtoclosure(closure5168, selfslot);
  struct UserObject *uo5168 = (struct UserObject*)block5167;
  uo5168->data[0] = (Object)closure5168;
  Method *meth_meth_collectionsPrelude_5168__apply_40_1_41_ = addmethod2pos(block5167, "_apply(1)", &meth_collectionsPrelude_5168__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5168__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5168__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5168__apply_40_1_41_);
  meth_meth_collectionsPrelude_5168__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5168__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block5167 (depth = 3)
  gc_frame_newslot(block5167);
  params[0] = block5155;
  params[1] = block5167;
  Object matchres5154 = matchCase(*var_upper, params, 2);
  gc_frame_end(frame5154);
// compiled matchcase node returning matchres5154 (depth = 2)
  sourceObject = obj4870;
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5198 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  partcv[0] = 0;
  Object call5199 = callmethodflags(*var_upper, "truncated", 1, partcv, params, 0);
  gc_frame_end(callframe5198);
// compiled member node returning call5199 (depth = 2)
  adddatum2(obj4870, call5199, 1);
  sourceObject = obj4870;
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_5201 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
  int callframe5203 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5204 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5203);
// compiled member node returning call5204 (depth = 4)
  int op_slot_left_5201 = gc_frame_newslot(call5204);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5205 = callmethod(call5204, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5205 (depth = 3)
  Object if5200 = done;
struct StackFrameObject *iftmpstackframe5200 = stackframe;
  if (istrue(opresult5205)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5200);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5206 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5209 == NULL) {
    strlit5209 = alloc_String(") is not an integer");
    gc_root(strlit5209);
  }
// compiled string node returning strlit5209 (depth = 6)
  int op_slot_right_5208 = gc_frame_newslot(strlit5209);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5211 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5214 == NULL) {
    strlit5214 = alloc_String(")downTo(");
    gc_root(strlit5214);
  }
// compiled string node returning strlit5214 (depth = 8)
  int op_slot_right_5213 = gc_frame_newslot(strlit5214);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5216 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5218 == NULL) {
    strlit5218 = alloc_String(" in range.from(");
    gc_root(strlit5218);
  }
// compiled string node returning strlit5218 (depth = 9)
  int op_slot_left_5216 = gc_frame_newslot(strlit5218);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5219 = callmethod(strlit5218, "++(1)", 1, partcv, params);
// compiled op node returning opresult5219 (depth = 8)
  int op_slot_left_5213 = gc_frame_newslot(opresult5219);
  params[0] = strlit5214;
  partcv[0] = 1;
  Object opresult5220 = callmethod(opresult5219, "++(1)", 1, partcv, params);
// compiled op node returning opresult5220 (depth = 7)
  int op_slot_left_5211 = gc_frame_newslot(opresult5220);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5221 = callmethod(opresult5220, "++(1)", 1, partcv, params);
// compiled op node returning opresult5221 (depth = 6)
  int op_slot_left_5208 = gc_frame_newslot(opresult5221);
  params[0] = strlit5209;
  partcv[0] = 1;
  Object opresult5222 = callmethod(opresult5221, "++(1)", 1, partcv, params);
// compiled op node returning opresult5222 (depth = 5)
  int op_slot_right_5207 = gc_frame_newslot(opresult5222);
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5225 == NULL) {
    strlit5225 = alloc_String("");
    gc_root(strlit5225);
  }
// compiled string node returning strlit5225 (depth = 6)
  int op_slot_right_5224 = gc_frame_newslot(strlit5225);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_5227 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit5229 == NULL) {
    strlit5229 = alloc_String("upper bound ");
    gc_root(strlit5229);
  }
// compiled string node returning strlit5229 (depth = 7)
  int op_slot_left_5227 = gc_frame_newslot(strlit5229);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5230 = callmethod(strlit5229, "++(1)", 1, partcv, params);
// compiled op node returning opresult5230 (depth = 6)
  int op_slot_left_5224 = gc_frame_newslot(opresult5230);
  params[0] = strlit5225;
  partcv[0] = 1;
  Object opresult5231 = callmethod(opresult5230, "++(1)", 1, partcv, params);
// compiled op node returning opresult5231 (depth = 5)
  int op_slot_left_5207 = gc_frame_newslot(opresult5231);
  params[0] = opresult5222;
  partcv[0] = 1;
  Object opresult5232 = callmethod(opresult5231, "++(1)", 1, partcv, params);
// compiled op node returning opresult5232 (depth = 4)
  gc_frame_newslot(opresult5232);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5232;
  partcv[0] = 1;
  Object call5233 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5206);
// compiled call node returning call5233 (depth = 3)
    gc_frame_newslot(call5233);
    if5200 = call5233;
  } else {
  }
stackframe = iftmpstackframe5200;
// compiled if node returning if5200 (depth = 2)
  sourceObject = obj4870;
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame5234 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5235 = alloc_Block(NULL, NULL, "collectionsPrelude", 1757);
  gc_frame_newslot(block5235);
// method "_apply(_)"
  block_savedest(block5235);
  Object closure5236 = createclosure(1, "_apply(1)");
  setclosureframe(closure5236, stackframe);
  addtoclosure(closure5236, selfslot);
  struct UserObject *uo5236 = (struct UserObject*)block5235;
  uo5236->data[0] = (Object)closure5236;
  Method *meth_meth_collectionsPrelude_5236__apply_40_1_41_ = addmethod2pos(block5235, "_apply(1)", &meth_collectionsPrelude_5236__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5236__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5236__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5236__apply_40_1_41_);
meth_meth_collectionsPrelude_5236__apply_40_1_41_->type->types[0] = type_Number;
meth_meth_collectionsPrelude_5236__apply_40_1_41_->type->names[0] = "__12";
  meth_meth_collectionsPrelude_5236__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5236__apply_40_1_41_->definitionLine = 1769;
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5238 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5239 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5240 == NULL) {
    strlit5240 = alloc_String("__12");
    gc_root(strlit5240);
  }
// compiled string node returning strlit5240 (depth = 6)
  gc_frame_newslot(strlit5240);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5241 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5242 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5241);
// compiled member node returning call5242 (depth = 6)
  params[0] = strlit5240;
  partcv[0] = 1;
  Object call5243 = callmethodflags(call5242, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5239);
// compiled call node returning call5243 (depth = 5)
  gc_frame_newslot(call5243);
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5244 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5245 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5244);
// compiled member node returning call5245 (depth = 5)
  params[0] = call5243;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5246 = callmethodflags(call5245, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5238);
// compiled call node returning call5246 (depth = 4)
((struct UserObject *)block5235)->data[1] = call5246;
// compiled block node returning block5235 (depth = 3)
  gc_frame_newslot(block5235);
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5247 = alloc_Block(NULL, NULL, "collectionsPrelude", 1758);
  gc_frame_newslot(block5247);
// method "_apply(_)"
  block_savedest(block5247);
  Object closure5248 = createclosure(4, "_apply(1)");
  setclosureframe(closure5248, stackframe);
  addtoclosure(closure5248, var_lower);
  addtoclosure(closure5248, var_upper);
  addtoclosure(closure5248, var_RequestError);
  addtoclosure(closure5248, selfslot);
  struct UserObject *uo5248 = (struct UserObject*)block5247;
  uo5248->data[0] = (Object)closure5248;
  Method *meth_meth_collectionsPrelude_5248__apply_40_1_41_ = addmethod2pos(block5247, "_apply(1)", &meth_collectionsPrelude_5248__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5248__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5248__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5248__apply_40_1_41_);
  meth_meth_collectionsPrelude_5248__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5248__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block5247 (depth = 3)
  gc_frame_newslot(block5247);
  params[0] = block5235;
  params[1] = block5247;
  Object matchres5234 = matchCase(*var_lower, params, 2);
  gc_frame_end(frame5234);
// compiled matchcase node returning matchres5234 (depth = 2)
  sourceObject = obj4870;
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5278 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  partcv[0] = 0;
  Object call5279 = callmethodflags(*var_lower, "truncated", 1, partcv, params, 0);
  gc_frame_end(callframe5278);
// compiled member node returning call5279 (depth = 2)
  adddatum2(obj4870, call5279, 2);
  sourceObject = obj4870;
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5281 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
  int callframe5283 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5284 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5283);
// compiled member node returning call5284 (depth = 4)
  int op_slot_left_5281 = gc_frame_newslot(call5284);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5285 = callmethod(call5284, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5285 (depth = 3)
  Object if5280 = done;
struct StackFrameObject *iftmpstackframe5280 = stackframe;
  if (istrue(opresult5285)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5280);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5286 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5289 == NULL) {
    strlit5289 = alloc_String(") is not an integer");
    gc_root(strlit5289);
  }
// compiled string node returning strlit5289 (depth = 6)
  int op_slot_right_5288 = gc_frame_newslot(strlit5289);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5291 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5294 == NULL) {
    strlit5294 = alloc_String(")downTo(");
    gc_root(strlit5294);
  }
// compiled string node returning strlit5294 (depth = 8)
  int op_slot_right_5293 = gc_frame_newslot(strlit5294);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5296 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5298 == NULL) {
    strlit5298 = alloc_String(" in range.from(");
    gc_root(strlit5298);
  }
// compiled string node returning strlit5298 (depth = 9)
  int op_slot_left_5296 = gc_frame_newslot(strlit5298);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5299 = callmethod(strlit5298, "++(1)", 1, partcv, params);
// compiled op node returning opresult5299 (depth = 8)
  int op_slot_left_5293 = gc_frame_newslot(opresult5299);
  params[0] = strlit5294;
  partcv[0] = 1;
  Object opresult5300 = callmethod(opresult5299, "++(1)", 1, partcv, params);
// compiled op node returning opresult5300 (depth = 7)
  int op_slot_left_5291 = gc_frame_newslot(opresult5300);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5301 = callmethod(opresult5300, "++(1)", 1, partcv, params);
// compiled op node returning opresult5301 (depth = 6)
  int op_slot_left_5288 = gc_frame_newslot(opresult5301);
  params[0] = strlit5289;
  partcv[0] = 1;
  Object opresult5302 = callmethod(opresult5301, "++(1)", 1, partcv, params);
// compiled op node returning opresult5302 (depth = 5)
  int op_slot_right_5287 = gc_frame_newslot(opresult5302);
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5305 == NULL) {
    strlit5305 = alloc_String("");
    gc_root(strlit5305);
  }
// compiled string node returning strlit5305 (depth = 6)
  int op_slot_right_5304 = gc_frame_newslot(strlit5305);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5307 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit5309 == NULL) {
    strlit5309 = alloc_String("lower bound ");
    gc_root(strlit5309);
  }
// compiled string node returning strlit5309 (depth = 7)
  int op_slot_left_5307 = gc_frame_newslot(strlit5309);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5310 = callmethod(strlit5309, "++(1)", 1, partcv, params);
// compiled op node returning opresult5310 (depth = 6)
  int op_slot_left_5304 = gc_frame_newslot(opresult5310);
  params[0] = strlit5305;
  partcv[0] = 1;
  Object opresult5311 = callmethod(opresult5310, "++(1)", 1, partcv, params);
// compiled op node returning opresult5311 (depth = 5)
  int op_slot_left_5287 = gc_frame_newslot(opresult5311);
  params[0] = opresult5302;
  partcv[0] = 1;
  Object opresult5312 = callmethod(opresult5311, "++(1)", 1, partcv, params);
// compiled op node returning opresult5312 (depth = 4)
  gc_frame_newslot(opresult5312);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5312;
  partcv[0] = 1;
  Object call5313 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5286);
// compiled call node returning call5313 (depth = 3)
    gc_frame_newslot(call5313);
    if5280 = call5313;
  } else {
  }
stackframe = iftmpstackframe5280;
// compiled if node returning if5280 (depth = 2)
  sourceObject = obj4870;
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5316 = alloc_Float64(0);
// compiled num node returning num5316 (depth = 4)
  int op_slot_right_5315 = gc_frame_newslot(num5316);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5319 = alloc_Float64(1);
// compiled num node returning num5319 (depth = 5)
  int op_slot_right_5318 = gc_frame_newslot(num5319);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5321 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_5321 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5323 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5323 (depth = 5)
  int op_slot_left_5318 = gc_frame_newslot(diff5323);
  params[0] = num5319;
  partcv[0] = 1;
  Object sum5324 = callmethod(diff5323, "+(1)", 1, partcv, params);
// compiled op node returning sum5324 (depth = 4)
  int op_slot_left_5315 = gc_frame_newslot(sum5324);
  params[0] = num5316;
  partcv[0] = 1;
  Object opresult5325 = callmethod(sum5324, "<(1)", 1, partcv, params);
// compiled op node returning opresult5325 (depth = 3)
  Object if5314 = done;
struct StackFrameObject *iftmpstackframe5314 = stackframe;
  if (istrue(opresult5325)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5314);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile num node (depth = 3)
  Object num5326 = alloc_Float64(0);
// compiled num node returning num5326 (depth = 3)
    gc_frame_newslot(num5326);
    if5314 = num5326;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5314);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5328 = alloc_Float64(1);
// compiled num node returning num5328 (depth = 4)
  int op_slot_right_5327 = gc_frame_newslot(num5328);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_5330 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_5330 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5332 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5332 (depth = 4)
  int op_slot_left_5327 = gc_frame_newslot(diff5332);
  params[0] = num5328;
  partcv[0] = 1;
  Object sum5333 = callmethod(diff5332, "+(1)", 1, partcv, params);
// compiled op node returning sum5333 (depth = 3)
    gc_frame_newslot(sum5333);
    if5314 = sum5333;
  }
stackframe = iftmpstackframe5314;
// compiled if node returning if5314 (depth = 2)
  adddatum2(obj4870, if5314, 3);
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  objclass4870 = obj4870->class;
  objclass4870->definitionModule = modulename;
  objclass4870->definitionLine = 1745;
  (*(struct UserObject *)self).data[0] = lowerouter4870;
  self = oldself4870;
  selfslot = oldselfslot4870;
  stackframe = oldstackframe4870;
  gc_frame_end(frame);
  return obj4870;
}
Object meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from(1)downTo(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method from(_)downTo(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method from(_)downTo(_)");
  Object params[2];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var_Number = getfromclosure(closure, 2);
  Object *var_RequestError = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from(_)downTo(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_upper = &(stackframe->slots[0]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *var_lower = &(stackframe->slots[1]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part downTo(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4870 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4870 = alloc_userobj2(21,22, objclass4870);
  gc_frame_newslot(obj4870);
  if (objclass4870 == NULL) {
    glfree(obj4870->class->name);
    obj4870->class->name = "range.from(_)downTo(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4870, self, 0);
  addmethodreal(obj4870,"outer", &reader_collectionsPrelude_outer_4871);
  Object oldself4870 = self;
  struct StackFrameObject *oldstackframe4870 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4870);
  gc_frame_newslot((Object)stackframe);
  self = obj4870;
  Object *oldselfslot4870 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4870 = (*(struct UserObject *)self).data[0], lowerouter4870 = thisouter4870;
  if (inheritingObject4870) {
    struct UserObject *inho4870 = (struct UserObject *)inheritingObject4870;
    while (inho4870->super != GraceDefaultObject) inho4870 = (struct UserObject *)inho4870->super;
    inho4870->super = obj4870;
    self = inheritingObject4870;
    *selfslot = self;
    lowerouter4870 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4870;
  }
  if (objclass4870 == NULL) {
  Method *reader4872 = addmethodrealflags(obj4870, "start",&reader_collectionsPrelude_start_4872, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4872->definitionModule = modulename;
  reader4872->definitionLine = 1751;
  }
  adddatum2(obj4870, alloc_Undefined(), 1);
  if (objclass4870 == NULL) {
  Method *reader4873 = addmethodrealflags(obj4870, "stop",&reader_collectionsPrelude_stop_4873, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4873->definitionModule = modulename;
  reader4873->definitionLine = 1760;
  }
  adddatum2(obj4870, alloc_Undefined(), 2);
  if (objclass4870 == NULL) {
  Method *reader4874 = addmethodrealflags(obj4870, "size",&reader_collectionsPrelude_size_4874, MFLAG_DEF);
  reader4874->definitionModule = modulename;
  reader4874->definitionLine = 1765;
  }
  adddatum2(obj4870, alloc_Undefined(), 3);
// method "iterator"
  block_savedest(obj4870);
  Object closure4875 = createclosure(1, "iterator");
  setclosureframe(closure4875, stackframe);
  addtoclosure(closure4875, var_IteratorExhausted);
  struct UserObject *uo4875 = (struct UserObject*)obj4870;
  uo4875->data[4] = (Object)closure4875;
  Method *meth_meth_collectionsPrelude_4875_iterator = addmethod2pos(obj4870, "iterator", &meth_collectionsPrelude_4875_iterator, 4);
  int argcv_meth_collectionsPrelude_4875_iterator[] = {0};
  meth_meth_collectionsPrelude_4875_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4875_iterator);
  meth_meth_collectionsPrelude_4875_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_4875_iterator->definitionLine = 1767;
  block_savedest(obj4870);
  Object closure4954 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure4954, stackframe);
  addtoclosure(closure4954, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_4875_iterator_object = addmethod2pos(obj4870, "iterator$object(1)", &meth_collectionsPrelude_4875_iterator_object, 4);
  meth_meth_collectionsPrelude_4875_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_4875_iterator_object->definitionLine = 1767;
// method "at(_)"
  block_savedest(obj4870);
  Object closure4955 = createclosure(1, "at(1)");
  setclosureframe(closure4955, stackframe);
  addtoclosure(closure4955, var_BoundsError);
  struct UserObject *uo4955 = (struct UserObject*)obj4870;
  uo4955->data[5] = (Object)closure4955;
  Method *meth_meth_collectionsPrelude_4955_at_40_1_41_ = addmethod2pos(obj4870, "at(1)", &meth_collectionsPrelude_4955_at_40_1_41_, 5);
  int argcv_meth_collectionsPrelude_4955_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_4955_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4955_at_40_1_41_);
meth_meth_collectionsPrelude_4955_at_40_1_41_->type->types[0] = type_Number;
meth_meth_collectionsPrelude_4955_at_40_1_41_->type->names[0] = "ix";
  meth_meth_collectionsPrelude_4955_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4955_at_40_1_41_->definitionLine = 1779;
// method "contains(_)"
  struct UserObject *uo5009 = (struct UserObject*)obj4870;
  uo5009->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5009_contains_40_1_41_ = addmethod2pos(obj4870, "contains(1)", &meth_collectionsPrelude_5009_contains_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_5009_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5009_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5009_contains_40_1_41_);
  meth_meth_collectionsPrelude_5009_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5009_contains_40_1_41_->definitionLine = 1788;
// method "do(_)"
  struct UserObject *uo5051 = (struct UserObject*)obj4870;
  uo5051->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5051_do_40_1_41_ = addmethod2pos(obj4870, "do(1)", &meth_collectionsPrelude_5051_do_40_1_41_, 7);
  int argcv_meth_collectionsPrelude_5051_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5051_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5051_do_40_1_41_);
  meth_meth_collectionsPrelude_5051_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5051_do_40_1_41_->definitionLine = 1797;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5074 = (struct UserObject*)obj4870;
  uo5074->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_ = addmethod2pos(obj4870, "keysAndValuesDo(1)", &meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_, 8);
  int argcv_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5074_keysAndValuesDo_40_1_41_->definitionLine = 1804;
// method "reversed"
  block_savedest(obj4870);
  Object closure5103 = createclosure(2, "reversed");
  setclosureframe(closure5103, stackframe);
  addtoclosure(closure5103, var_lower);
  addtoclosure(closure5103, var_upper);
  struct UserObject *uo5103 = (struct UserObject*)obj4870;
  uo5103->data[9] = (Object)closure5103;
  Method *meth_meth_collectionsPrelude_5103_reversed = addmethod2pos(obj4870, "reversed", &meth_collectionsPrelude_5103_reversed, 9);
  int argcv_meth_collectionsPrelude_5103_reversed[] = {0};
  meth_meth_collectionsPrelude_5103_reversed->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5103_reversed);
  meth_meth_collectionsPrelude_5103_reversed->definitionModule = modulename;
  meth_meth_collectionsPrelude_5103_reversed->definitionLine = 1813;
// method "++(_)"
  struct UserObject *uo5108 = (struct UserObject*)obj4870;
  uo5108->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5108__43__43__40_1_41_ = addmethod2pos(obj4870, "++(1)", &meth_collectionsPrelude_5108__43__43__40_1_41_, 10);
  int argcv_meth_collectionsPrelude_5108__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5108__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5108__43__43__40_1_41_);
  meth_meth_collectionsPrelude_5108__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5108__43__43__40_1_41_->definitionLine = 1816;
// method "==(_)"
  struct UserObject *uo5115 = (struct UserObject*)obj4870;
  uo5115->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5115__61__61__40_1_41_ = addmethod2pos(obj4870, "==(1)", &meth_collectionsPrelude_5115__61__61__40_1_41_, 11);
  int argcv_meth_collectionsPrelude_5115__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5115__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5115__61__61__40_1_41_);
  meth_meth_collectionsPrelude_5115__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5115__61__61__40_1_41_->definitionLine = 1819;
// method "sorted"
  struct UserObject *uo5118 = (struct UserObject*)obj4870;
  uo5118->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5118_sorted = addmethod2pos(obj4870, "sorted", &meth_collectionsPrelude_5118_sorted, 12);
  int argcv_meth_collectionsPrelude_5118_sorted[] = {0};
  meth_meth_collectionsPrelude_5118_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5118_sorted);
  meth_meth_collectionsPrelude_5118_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_5118_sorted->definitionLine = 1822;
// method "sortedBy(_)"
  struct UserObject *uo5121 = (struct UserObject*)obj4870;
  uo5121->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5121_sortedBy_40_1_41_ = addmethod2pos(obj4870, "sortedBy(1)", &meth_collectionsPrelude_5121_sortedBy_40_1_41_, 13);
  int argcv_meth_collectionsPrelude_5121_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5121_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5121_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_5121_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5121_sortedBy_40_1_41_->definitionLine = 1824;
// method "keys"
  struct UserObject *uo5128 = (struct UserObject*)obj4870;
  uo5128->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5128_keys = addmethod2pos(obj4870, "keys", &meth_collectionsPrelude_5128_keys, 14);
  int argcv_meth_collectionsPrelude_5128_keys[] = {0};
  meth_meth_collectionsPrelude_5128_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5128_keys);
  meth_meth_collectionsPrelude_5128_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_5128_keys->definitionLine = 1826;
// method "values"
  struct UserObject *uo5135 = (struct UserObject*)obj4870;
  uo5135->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5135_values = addmethod2pos(obj4870, "values", &meth_collectionsPrelude_5135_values, 15);
  int argcv_meth_collectionsPrelude_5135_values[] = {0};
  meth_meth_collectionsPrelude_5135_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5135_values);
  meth_meth_collectionsPrelude_5135_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_5135_values->definitionLine = 1828;
// method "asString"
  block_savedest(obj4870);
  Object closure5136 = createclosure(2, "asString");
  setclosureframe(closure5136, stackframe);
  addtoclosure(closure5136, var_lower);
  addtoclosure(closure5136, var_upper);
  struct UserObject *uo5136 = (struct UserObject*)obj4870;
  uo5136->data[16] = (Object)closure5136;
  Method *meth_meth_collectionsPrelude_5136_asString = addmethod2pos(obj4870, "asString", &meth_collectionsPrelude_5136_asString, 16);
  int argcv_meth_collectionsPrelude_5136_asString[] = {0};
  meth_meth_collectionsPrelude_5136_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5136_asString);
  meth_meth_collectionsPrelude_5136_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_5136_asString->definitionLine = 1830;
  sourceObject = obj4870;
// Begin line 1746
  setline(1746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5152 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_collectionsPrelude (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5153 = callmethodflags(module_collectionsPrelude, "indexable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5152);
// compiled call node returning call5153 (depth = 2)
  struct UserObject *obj4870_uo = (struct UserObject *)obj4870;
  obj4870_uo->super = call5153;
  sourceObject = obj4870;
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame5154 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5155 = alloc_Block(NULL, NULL, "collectionsPrelude", 1748);
  gc_frame_newslot(block5155);
// method "_apply(_)"
  block_savedest(block5155);
  Object closure5156 = createclosure(1, "_apply(1)");
  setclosureframe(closure5156, stackframe);
  addtoclosure(closure5156, selfslot);
  struct UserObject *uo5156 = (struct UserObject*)block5155;
  uo5156->data[0] = (Object)closure5156;
  Method *meth_meth_collectionsPrelude_5156__apply_40_1_41_ = addmethod2pos(block5155, "_apply(1)", &meth_collectionsPrelude_5156__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5156__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5156__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5156__apply_40_1_41_);
meth_meth_collectionsPrelude_5156__apply_40_1_41_->type->types[0] = type_Number;
meth_meth_collectionsPrelude_5156__apply_40_1_41_->type->names[0] = "__10";
  meth_meth_collectionsPrelude_5156__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5156__apply_40_1_41_->definitionLine = 1769;
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5158 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5159 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5160 == NULL) {
    strlit5160 = alloc_String("__10");
    gc_root(strlit5160);
  }
// compiled string node returning strlit5160 (depth = 6)
  gc_frame_newslot(strlit5160);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5161 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5162 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5161);
// compiled member node returning call5162 (depth = 6)
  params[0] = strlit5160;
  partcv[0] = 1;
  Object call5163 = callmethodflags(call5162, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5159);
// compiled call node returning call5163 (depth = 5)
  gc_frame_newslot(call5163);
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5164 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5165 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5164);
// compiled member node returning call5165 (depth = 5)
  params[0] = call5163;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5166 = callmethodflags(call5165, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5158);
// compiled call node returning call5166 (depth = 4)
((struct UserObject *)block5155)->data[1] = call5166;
// compiled block node returning block5155 (depth = 3)
  gc_frame_newslot(block5155);
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5167 = alloc_Block(NULL, NULL, "collectionsPrelude", 1749);
  gc_frame_newslot(block5167);
// method "_apply(_)"
  block_savedest(block5167);
  Object closure5168 = createclosure(4, "_apply(1)");
  setclosureframe(closure5168, stackframe);
  addtoclosure(closure5168, var_lower);
  addtoclosure(closure5168, var_upper);
  addtoclosure(closure5168, var_RequestError);
  addtoclosure(closure5168, selfslot);
  struct UserObject *uo5168 = (struct UserObject*)block5167;
  uo5168->data[0] = (Object)closure5168;
  Method *meth_meth_collectionsPrelude_5168__apply_40_1_41_ = addmethod2pos(block5167, "_apply(1)", &meth_collectionsPrelude_5168__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5168__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5168__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5168__apply_40_1_41_);
  meth_meth_collectionsPrelude_5168__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5168__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block5167 (depth = 3)
  gc_frame_newslot(block5167);
  params[0] = block5155;
  params[1] = block5167;
  Object matchres5154 = matchCase(*var_upper, params, 2);
  gc_frame_end(frame5154);
// compiled matchcase node returning matchres5154 (depth = 2)
  sourceObject = obj4870;
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5198 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  partcv[0] = 0;
  Object call5199 = callmethodflags(*var_upper, "truncated", 1, partcv, params, 0);
  gc_frame_end(callframe5198);
// compiled member node returning call5199 (depth = 2)
  adddatum2(obj4870, call5199, 1);
  sourceObject = obj4870;
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_5201 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
  int callframe5203 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5204 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5203);
// compiled member node returning call5204 (depth = 4)
  int op_slot_left_5201 = gc_frame_newslot(call5204);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5205 = callmethod(call5204, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5205 (depth = 3)
  Object if5200 = done;
struct StackFrameObject *iftmpstackframe5200 = stackframe;
  if (istrue(opresult5205)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5200);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5206 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5209 == NULL) {
    strlit5209 = alloc_String(") is not an integer");
    gc_root(strlit5209);
  }
// compiled string node returning strlit5209 (depth = 6)
  int op_slot_right_5208 = gc_frame_newslot(strlit5209);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5211 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5214 == NULL) {
    strlit5214 = alloc_String(")downTo(");
    gc_root(strlit5214);
  }
// compiled string node returning strlit5214 (depth = 8)
  int op_slot_right_5213 = gc_frame_newslot(strlit5214);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5216 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5218 == NULL) {
    strlit5218 = alloc_String(" in range.from(");
    gc_root(strlit5218);
  }
// compiled string node returning strlit5218 (depth = 9)
  int op_slot_left_5216 = gc_frame_newslot(strlit5218);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5219 = callmethod(strlit5218, "++(1)", 1, partcv, params);
// compiled op node returning opresult5219 (depth = 8)
  int op_slot_left_5213 = gc_frame_newslot(opresult5219);
  params[0] = strlit5214;
  partcv[0] = 1;
  Object opresult5220 = callmethod(opresult5219, "++(1)", 1, partcv, params);
// compiled op node returning opresult5220 (depth = 7)
  int op_slot_left_5211 = gc_frame_newslot(opresult5220);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5221 = callmethod(opresult5220, "++(1)", 1, partcv, params);
// compiled op node returning opresult5221 (depth = 6)
  int op_slot_left_5208 = gc_frame_newslot(opresult5221);
  params[0] = strlit5209;
  partcv[0] = 1;
  Object opresult5222 = callmethod(opresult5221, "++(1)", 1, partcv, params);
// compiled op node returning opresult5222 (depth = 5)
  int op_slot_right_5207 = gc_frame_newslot(opresult5222);
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5225 == NULL) {
    strlit5225 = alloc_String("");
    gc_root(strlit5225);
  }
// compiled string node returning strlit5225 (depth = 6)
  int op_slot_right_5224 = gc_frame_newslot(strlit5225);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_5227 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit5229 == NULL) {
    strlit5229 = alloc_String("upper bound ");
    gc_root(strlit5229);
  }
// compiled string node returning strlit5229 (depth = 7)
  int op_slot_left_5227 = gc_frame_newslot(strlit5229);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5230 = callmethod(strlit5229, "++(1)", 1, partcv, params);
// compiled op node returning opresult5230 (depth = 6)
  int op_slot_left_5224 = gc_frame_newslot(opresult5230);
  params[0] = strlit5225;
  partcv[0] = 1;
  Object opresult5231 = callmethod(opresult5230, "++(1)", 1, partcv, params);
// compiled op node returning opresult5231 (depth = 5)
  int op_slot_left_5207 = gc_frame_newslot(opresult5231);
  params[0] = opresult5222;
  partcv[0] = 1;
  Object opresult5232 = callmethod(opresult5231, "++(1)", 1, partcv, params);
// compiled op node returning opresult5232 (depth = 4)
  gc_frame_newslot(opresult5232);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5232;
  partcv[0] = 1;
  Object call5233 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5206);
// compiled call node returning call5233 (depth = 3)
    gc_frame_newslot(call5233);
    if5200 = call5233;
  } else {
  }
stackframe = iftmpstackframe5200;
// compiled if node returning if5200 (depth = 2)
  sourceObject = obj4870;
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame5234 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5235 = alloc_Block(NULL, NULL, "collectionsPrelude", 1757);
  gc_frame_newslot(block5235);
// method "_apply(_)"
  block_savedest(block5235);
  Object closure5236 = createclosure(1, "_apply(1)");
  setclosureframe(closure5236, stackframe);
  addtoclosure(closure5236, selfslot);
  struct UserObject *uo5236 = (struct UserObject*)block5235;
  uo5236->data[0] = (Object)closure5236;
  Method *meth_meth_collectionsPrelude_5236__apply_40_1_41_ = addmethod2pos(block5235, "_apply(1)", &meth_collectionsPrelude_5236__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5236__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5236__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5236__apply_40_1_41_);
meth_meth_collectionsPrelude_5236__apply_40_1_41_->type->types[0] = type_Number;
meth_meth_collectionsPrelude_5236__apply_40_1_41_->type->names[0] = "__12";
  meth_meth_collectionsPrelude_5236__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5236__apply_40_1_41_->definitionLine = 1769;
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5238 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5239 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5240 == NULL) {
    strlit5240 = alloc_String("__12");
    gc_root(strlit5240);
  }
// compiled string node returning strlit5240 (depth = 6)
  gc_frame_newslot(strlit5240);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5241 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5242 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5241);
// compiled member node returning call5242 (depth = 6)
  params[0] = strlit5240;
  partcv[0] = 1;
  Object call5243 = callmethodflags(call5242, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5239);
// compiled call node returning call5243 (depth = 5)
  gc_frame_newslot(call5243);
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5244 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5245 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5244);
// compiled member node returning call5245 (depth = 5)
  params[0] = call5243;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5246 = callmethodflags(call5245, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5238);
// compiled call node returning call5246 (depth = 4)
((struct UserObject *)block5235)->data[1] = call5246;
// compiled block node returning block5235 (depth = 3)
  gc_frame_newslot(block5235);
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5247 = alloc_Block(NULL, NULL, "collectionsPrelude", 1758);
  gc_frame_newslot(block5247);
// method "_apply(_)"
  block_savedest(block5247);
  Object closure5248 = createclosure(4, "_apply(1)");
  setclosureframe(closure5248, stackframe);
  addtoclosure(closure5248, var_lower);
  addtoclosure(closure5248, var_upper);
  addtoclosure(closure5248, var_RequestError);
  addtoclosure(closure5248, selfslot);
  struct UserObject *uo5248 = (struct UserObject*)block5247;
  uo5248->data[0] = (Object)closure5248;
  Method *meth_meth_collectionsPrelude_5248__apply_40_1_41_ = addmethod2pos(block5247, "_apply(1)", &meth_collectionsPrelude_5248__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5248__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5248__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5248__apply_40_1_41_);
  meth_meth_collectionsPrelude_5248__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5248__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block5247 (depth = 3)
  gc_frame_newslot(block5247);
  params[0] = block5235;
  params[1] = block5247;
  Object matchres5234 = matchCase(*var_lower, params, 2);
  gc_frame_end(frame5234);
// compiled matchcase node returning matchres5234 (depth = 2)
  sourceObject = obj4870;
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5278 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  partcv[0] = 0;
  Object call5279 = callmethodflags(*var_lower, "truncated", 1, partcv, params, 0);
  gc_frame_end(callframe5278);
// compiled member node returning call5279 (depth = 2)
  adddatum2(obj4870, call5279, 2);
  sourceObject = obj4870;
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5281 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
  int callframe5283 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5284 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5283);
// compiled member node returning call5284 (depth = 4)
  int op_slot_left_5281 = gc_frame_newslot(call5284);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5285 = callmethod(call5284, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5285 (depth = 3)
  Object if5280 = done;
struct StackFrameObject *iftmpstackframe5280 = stackframe;
  if (istrue(opresult5285)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5280);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5286 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5289 == NULL) {
    strlit5289 = alloc_String(") is not an integer");
    gc_root(strlit5289);
  }
// compiled string node returning strlit5289 (depth = 6)
  int op_slot_right_5288 = gc_frame_newslot(strlit5289);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5291 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5294 == NULL) {
    strlit5294 = alloc_String(")downTo(");
    gc_root(strlit5294);
  }
// compiled string node returning strlit5294 (depth = 8)
  int op_slot_right_5293 = gc_frame_newslot(strlit5294);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5296 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5298 == NULL) {
    strlit5298 = alloc_String(" in range.from(");
    gc_root(strlit5298);
  }
// compiled string node returning strlit5298 (depth = 9)
  int op_slot_left_5296 = gc_frame_newslot(strlit5298);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5299 = callmethod(strlit5298, "++(1)", 1, partcv, params);
// compiled op node returning opresult5299 (depth = 8)
  int op_slot_left_5293 = gc_frame_newslot(opresult5299);
  params[0] = strlit5294;
  partcv[0] = 1;
  Object opresult5300 = callmethod(opresult5299, "++(1)", 1, partcv, params);
// compiled op node returning opresult5300 (depth = 7)
  int op_slot_left_5291 = gc_frame_newslot(opresult5300);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5301 = callmethod(opresult5300, "++(1)", 1, partcv, params);
// compiled op node returning opresult5301 (depth = 6)
  int op_slot_left_5288 = gc_frame_newslot(opresult5301);
  params[0] = strlit5289;
  partcv[0] = 1;
  Object opresult5302 = callmethod(opresult5301, "++(1)", 1, partcv, params);
// compiled op node returning opresult5302 (depth = 5)
  int op_slot_right_5287 = gc_frame_newslot(opresult5302);
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5305 == NULL) {
    strlit5305 = alloc_String("");
    gc_root(strlit5305);
  }
// compiled string node returning strlit5305 (depth = 6)
  int op_slot_right_5304 = gc_frame_newslot(strlit5305);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5307 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit5309 == NULL) {
    strlit5309 = alloc_String("lower bound ");
    gc_root(strlit5309);
  }
// compiled string node returning strlit5309 (depth = 7)
  int op_slot_left_5307 = gc_frame_newslot(strlit5309);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5310 = callmethod(strlit5309, "++(1)", 1, partcv, params);
// compiled op node returning opresult5310 (depth = 6)
  int op_slot_left_5304 = gc_frame_newslot(opresult5310);
  params[0] = strlit5305;
  partcv[0] = 1;
  Object opresult5311 = callmethod(opresult5310, "++(1)", 1, partcv, params);
// compiled op node returning opresult5311 (depth = 5)
  int op_slot_left_5287 = gc_frame_newslot(opresult5311);
  params[0] = opresult5302;
  partcv[0] = 1;
  Object opresult5312 = callmethod(opresult5311, "++(1)", 1, partcv, params);
// compiled op node returning opresult5312 (depth = 4)
  gc_frame_newslot(opresult5312);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5312;
  partcv[0] = 1;
  Object call5313 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5286);
// compiled call node returning call5313 (depth = 3)
    gc_frame_newslot(call5313);
    if5280 = call5313;
  } else {
  }
stackframe = iftmpstackframe5280;
// compiled if node returning if5280 (depth = 2)
  sourceObject = obj4870;
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5316 = alloc_Float64(0);
// compiled num node returning num5316 (depth = 4)
  int op_slot_right_5315 = gc_frame_newslot(num5316);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5319 = alloc_Float64(1);
// compiled num node returning num5319 (depth = 5)
  int op_slot_right_5318 = gc_frame_newslot(num5319);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5321 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_5321 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5323 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5323 (depth = 5)
  int op_slot_left_5318 = gc_frame_newslot(diff5323);
  params[0] = num5319;
  partcv[0] = 1;
  Object sum5324 = callmethod(diff5323, "+(1)", 1, partcv, params);
// compiled op node returning sum5324 (depth = 4)
  int op_slot_left_5315 = gc_frame_newslot(sum5324);
  params[0] = num5316;
  partcv[0] = 1;
  Object opresult5325 = callmethod(sum5324, "<(1)", 1, partcv, params);
// compiled op node returning opresult5325 (depth = 3)
  Object if5314 = done;
struct StackFrameObject *iftmpstackframe5314 = stackframe;
  if (istrue(opresult5325)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5314);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile num node (depth = 3)
  Object num5326 = alloc_Float64(0);
// compiled num node returning num5326 (depth = 3)
    gc_frame_newslot(num5326);
    if5314 = num5326;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5314);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5328 = alloc_Float64(1);
// compiled num node returning num5328 (depth = 4)
  int op_slot_right_5327 = gc_frame_newslot(num5328);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_5330 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_5330 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5332 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5332 (depth = 4)
  int op_slot_left_5327 = gc_frame_newslot(diff5332);
  params[0] = num5328;
  partcv[0] = 1;
  Object sum5333 = callmethod(diff5332, "+(1)", 1, partcv, params);
// compiled op node returning sum5333 (depth = 3)
    gc_frame_newslot(sum5333);
    if5314 = sum5333;
  }
stackframe = iftmpstackframe5314;
// compiled if node returning if5314 (depth = 2)
  adddatum2(obj4870, if5314, 3);
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  sourceObject = obj4870;
  objclass4870 = obj4870->class;
  objclass4870->definitionModule = modulename;
  objclass4870->definitionLine = 1745;
  (*(struct UserObject *)self).data[0] = lowerouter4870;
  self = oldself4870;
  selfslot = oldselfslot4870;
  stackframe = oldstackframe4870;
  gc_frame_end(frame);
  return obj4870;
}
Object meth_collectionsPrelude_4394_range(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_BoundsError = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4395 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4395 = alloc_userobj2(5,6, objclass4395);
  gc_frame_newslot(obj4395);
  if (objclass4395 == NULL) {
    glfree(obj4395->class->name);
    obj4395->class->name = "range";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4395, self, 0);
  addmethodreal(obj4395,"outer", &reader_collectionsPrelude_outer_4396);
  Object oldself4395 = self;
  struct StackFrameObject *oldstackframe4395 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4395);
  gc_frame_newslot((Object)stackframe);
  self = obj4395;
  Object *oldselfslot4395 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4395 = (*(struct UserObject *)self).data[0], lowerouter4395 = thisouter4395;
  if (inheritingObject4395) {
    struct UserObject *inho4395 = (struct UserObject *)inheritingObject4395;
    while (inho4395->super != GraceDefaultObject) inho4395 = (struct UserObject *)inho4395->super;
    inho4395->super = obj4395;
    self = inheritingObject4395;
    *selfslot = self;
    lowerouter4395 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4395;
  }
// method "from(_)to(_)"
  block_savedest(obj4395);
  Object closure4397 = createclosure(2, "from(1)to(1)");
  setclosureframe(closure4397, stackframe);
  addtoclosure(closure4397, var_Number);
  addtoclosure(closure4397, var_RequestError);
  struct UserObject *uo4397 = (struct UserObject*)obj4395;
  uo4397->data[1] = (Object)closure4397;
  Method *meth_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_ = addmethod2pos(obj4395, "from(1)to(1)", &meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_, 1);
  int argcv_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_);
  meth_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_->definitionLine = 1641;
// method "uncheckedFrom(_)to(_)"
  block_savedest(obj4395);
  Object closure4542 = createclosure(2, "uncheckedFrom(1)to(1)");
  setclosureframe(closure4542, stackframe);
  addtoclosure(closure4542, var_IteratorExhausted);
  addtoclosure(closure4542, var_BoundsError);
  struct UserObject *uo4542 = (struct UserObject*)obj4395;
  uo4542->data[2] = (Object)closure4542;
  Method *meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_ = addmethod2pos(obj4395, "uncheckedFrom(1)to(1)", &meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_, 2);
  int argcv_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_);
  meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_->definitionLine = 1664;
  block_savedest(obj4395);
  Object closure4868 = createclosure(2, "uncheckedFrom(1)to(1)$object(1)");
  setclosureframe(closure4868, stackframe);
  addtoclosure(closure4868, var_IteratorExhausted);
  addtoclosure(closure4868, var_BoundsError);
  Method *meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41__object = addmethod2pos(obj4395, "uncheckedFrom(1)to(1)$object(1)", &meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41__object, 2);
  meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41__object->definitionLine = 1664;
// method "from(_)downTo(_)"
  block_savedest(obj4395);
  Object closure4869 = createclosure(4, "from(1)downTo(1)");
  setclosureframe(closure4869, stackframe);
  addtoclosure(closure4869, var_IteratorExhausted);
  addtoclosure(closure4869, var_BoundsError);
  addtoclosure(closure4869, var_Number);
  addtoclosure(closure4869, var_RequestError);
  struct UserObject *uo4869 = (struct UserObject*)obj4395;
  uo4869->data[3] = (Object)closure4869;
  Method *meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_ = addmethod2pos(obj4395, "from(1)downTo(1)", &meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_, 3);
  int argcv_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_);
  meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_->definitionLine = 1744;
  block_savedest(obj4395);
  Object closure5334 = createclosure(4, "from(1)downTo(1)$object(1)");
  setclosureframe(closure5334, stackframe);
  addtoclosure(closure5334, var_IteratorExhausted);
  addtoclosure(closure5334, var_BoundsError);
  addtoclosure(closure5334, var_Number);
  addtoclosure(closure5334, var_RequestError);
  Method *meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41__object = addmethod2pos(obj4395, "from(1)downTo(1)$object(1)", &meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41__object, 3);
  meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41__object->definitionLine = 1744;
  sourceObject = obj4395;
  sourceObject = obj4395;
  sourceObject = obj4395;
  objclass4395 = obj4395->class;
  objclass4395->definitionModule = modulename;
  objclass4395->definitionLine = 1640;
  (*(struct UserObject *)self).data[0] = lowerouter4395;
  self = oldself4395;
  selfslot = oldselfslot4395;
  stackframe = oldstackframe4395;
  gc_frame_end(frame);
  return obj4395;
}
Object meth_collectionsPrelude_4394_range_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_BoundsError = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4395 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4395 = alloc_userobj2(5,6, objclass4395);
  gc_frame_newslot(obj4395);
  if (objclass4395 == NULL) {
    glfree(obj4395->class->name);
    obj4395->class->name = "range";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj4395, self, 0);
  addmethodreal(obj4395,"outer", &reader_collectionsPrelude_outer_4396);
  Object oldself4395 = self;
  struct StackFrameObject *oldstackframe4395 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4395);
  gc_frame_newslot((Object)stackframe);
  self = obj4395;
  Object *oldselfslot4395 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4395 = (*(struct UserObject *)self).data[0], lowerouter4395 = thisouter4395;
  if (inheritingObject4395) {
    struct UserObject *inho4395 = (struct UserObject *)inheritingObject4395;
    while (inho4395->super != GraceDefaultObject) inho4395 = (struct UserObject *)inho4395->super;
    inho4395->super = obj4395;
    self = inheritingObject4395;
    *selfslot = self;
    lowerouter4395 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4395;
  }
// method "from(_)to(_)"
  block_savedest(obj4395);
  Object closure4397 = createclosure(2, "from(1)to(1)");
  setclosureframe(closure4397, stackframe);
  addtoclosure(closure4397, var_Number);
  addtoclosure(closure4397, var_RequestError);
  struct UserObject *uo4397 = (struct UserObject*)obj4395;
  uo4397->data[1] = (Object)closure4397;
  Method *meth_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_ = addmethod2pos(obj4395, "from(1)to(1)", &meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_, 1);
  int argcv_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_);
  meth_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4397_from_40_1_41_to_40_1_41_->definitionLine = 1641;
// method "uncheckedFrom(_)to(_)"
  block_savedest(obj4395);
  Object closure4542 = createclosure(2, "uncheckedFrom(1)to(1)");
  setclosureframe(closure4542, stackframe);
  addtoclosure(closure4542, var_IteratorExhausted);
  addtoclosure(closure4542, var_BoundsError);
  struct UserObject *uo4542 = (struct UserObject*)obj4395;
  uo4542->data[2] = (Object)closure4542;
  Method *meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_ = addmethod2pos(obj4395, "uncheckedFrom(1)to(1)", &meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_, 2);
  int argcv_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_);
  meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41_->definitionLine = 1664;
  block_savedest(obj4395);
  Object closure4868 = createclosure(2, "uncheckedFrom(1)to(1)$object(1)");
  setclosureframe(closure4868, stackframe);
  addtoclosure(closure4868, var_IteratorExhausted);
  addtoclosure(closure4868, var_BoundsError);
  Method *meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41__object = addmethod2pos(obj4395, "uncheckedFrom(1)to(1)$object(1)", &meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41__object, 2);
  meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_4542_uncheckedFrom_40_1_41_to_40_1_41__object->definitionLine = 1664;
// method "from(_)downTo(_)"
  block_savedest(obj4395);
  Object closure4869 = createclosure(4, "from(1)downTo(1)");
  setclosureframe(closure4869, stackframe);
  addtoclosure(closure4869, var_IteratorExhausted);
  addtoclosure(closure4869, var_BoundsError);
  addtoclosure(closure4869, var_Number);
  addtoclosure(closure4869, var_RequestError);
  struct UserObject *uo4869 = (struct UserObject*)obj4395;
  uo4869->data[3] = (Object)closure4869;
  Method *meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_ = addmethod2pos(obj4395, "from(1)downTo(1)", &meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_, 3);
  int argcv_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_);
  meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41_->definitionLine = 1744;
  block_savedest(obj4395);
  Object closure5334 = createclosure(4, "from(1)downTo(1)$object(1)");
  setclosureframe(closure5334, stackframe);
  addtoclosure(closure5334, var_IteratorExhausted);
  addtoclosure(closure5334, var_BoundsError);
  addtoclosure(closure5334, var_Number);
  addtoclosure(closure5334, var_RequestError);
  Method *meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41__object = addmethod2pos(obj4395, "from(1)downTo(1)$object(1)", &meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41__object, 3);
  meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_4869_from_40_1_41_downTo_40_1_41__object->definitionLine = 1744;
  sourceObject = obj4395;
  sourceObject = obj4395;
  sourceObject = obj4395;
  objclass4395 = obj4395->class;
  objclass4395->definitionModule = modulename;
  objclass4395->definitionLine = 1640;
  (*(struct UserObject *)self).data[0] = lowerouter4395;
  self = oldself4395;
  selfslot = oldselfslot4395;
  stackframe = oldstackframe4395;
  gc_frame_end(frame);
  return obj4395;
}
Object meth_collectionsPrelude_5341_BoundsError(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "BoundsError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_BoundsError (depth = 3)
  gc_frame_end(frame);
  return *var_BoundsError;
}
Object meth_collectionsPrelude_5347_IteratorExhausted(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "IteratorExhausted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_IteratorExhausted (depth = 3)
  gc_frame_end(frame);
  return *var_IteratorExhausted;
}
Object meth_collectionsPrelude_5353_SubobjectResponsibility(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SubobjectResponsibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SubobjectResponsibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SubobjectResponsibility (depth = 3)
  gc_frame_end(frame);
  return *var_SubobjectResponsibility;
}
Object meth_collectionsPrelude_5359_NoSuchObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "NoSuchObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NoSuchObject (depth = 3)
  gc_frame_end(frame);
  return *var_NoSuchObject;
}
Object meth_collectionsPrelude_5365_RequestError(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "RequestError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_RequestError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_RequestError (depth = 3)
  gc_frame_end(frame);
  return *var_RequestError;
}
Object meth_collectionsPrelude_5371_ConcurrentModification(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ConcurrentModification");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ConcurrentModification (depth = 3)
  gc_frame_end(frame);
  return *var_ConcurrentModification;
}
Object meth_collectionsPrelude_5377_SizeUnknown(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SizeUnknown");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SizeUnknown (depth = 3)
  gc_frame_end(frame);
  return *var_SizeUnknown;
}
Object meth_collectionsPrelude_5380_Function0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Function0");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Function0 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Function0 (depth = 3)
  gc_frame_end(frame);
  return *var_Function0;
}
Object meth_collectionsPrelude_5383_Function1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Function1");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Function1 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Function1 (depth = 3)
  gc_frame_end(frame);
  return *var_Function1;
}
Object meth_collectionsPrelude_5386_Function2(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Function2");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Function2 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Function2 (depth = 3)
  gc_frame_end(frame);
  return *var_Function2;
}
Object meth_collectionsPrelude_5388_Procedure0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Procedure0");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Procedure0 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Procedure0 (depth = 3)
  gc_frame_end(frame);
  return *var_Procedure0;
}
Object meth_collectionsPrelude_5390_Procedure1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Procedure1");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Procedure1 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Procedure1 (depth = 3)
  gc_frame_end(frame);
  return *var_Procedure1;
}
Object meth_collectionsPrelude_5392_Procedure2(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Procedure2");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Procedure2 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Procedure2 (depth = 3)
  gc_frame_end(frame);
  return *var_Procedure2;
}
Object meth_collectionsPrelude_5394_Predicate1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Predicate1");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Predicate1 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Predicate1 (depth = 3)
  gc_frame_end(frame);
  return *var_Predicate1;
}
Object meth_collectionsPrelude_5396_SelfType(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SelfType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SelfType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SelfType (depth = 3)
  gc_frame_end(frame);
  return *var_SelfType;
}
Object meth_collectionsPrelude_5402_Collection(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Collection");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  gc_frame_end(frame);
  return *var_Collection;
}
Object meth_collectionsPrelude_5408_Expandable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Expandable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Expandable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Expandable (depth = 3)
  gc_frame_end(frame);
  return *var_Expandable;
}
Object meth_collectionsPrelude_5410_Iterable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Iterable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Iterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterable (depth = 3)
  gc_frame_end(frame);
  return *var_Iterable;
}
Object meth_collectionsPrelude_5416_Enumerable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Enumerable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Enumerable (depth = 3)
  gc_frame_end(frame);
  return *var_Enumerable;
}
Object meth_collectionsPrelude_5422_Sequence(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Sequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Sequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Sequence (depth = 3)
  gc_frame_end(frame);
  return *var_Sequence;
}
Object meth_collectionsPrelude_5428_List(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "List");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_List = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_List (depth = 3)
  gc_frame_end(frame);
  return *var_List;
}
Object meth_collectionsPrelude_5434_Set(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Set");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Set = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Set (depth = 3)
  gc_frame_end(frame);
  return *var_Set;
}
Object meth_collectionsPrelude_5440_Dictionary(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Dictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Dictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Dictionary (depth = 3)
  gc_frame_end(frame);
  return *var_Dictionary;
}
Object meth_collectionsPrelude_5443_Iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Iterator = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterator (depth = 3)
  gc_frame_end(frame);
  return *var_Iterator;
}
Object meth_collectionsPrelude_5446_size(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num5447 = alloc_Float64(0);
// compiled num node returning num5447 (depth = 3)
  gc_frame_end(frame);
  return num5447;
}
Object meth_collectionsPrelude_5448_isEmpty(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5449 = alloc_Boolean(1);
// compiled identifier node returning bool5449 (depth = 3)
  gc_frame_end(frame);
  return bool5449;
}
Object meth_collectionsPrelude_5450_at_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5451 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5453 == NULL) {
    strlit5453 = alloc_String(" of empty sequence");
    gc_root(strlit5453);
  }
// compiled string node returning strlit5453 (depth = 5)
  int op_slot_right_5452 = gc_frame_newslot(strlit5453);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_5455 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 6)
  if (strlit5457 == NULL) {
    strlit5457 = alloc_String("index ");
    gc_root(strlit5457);
  }
// compiled string node returning strlit5457 (depth = 6)
  int op_slot_left_5455 = gc_frame_newslot(strlit5457);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult5458 = callmethod(strlit5457, "++(1)", 1, partcv, params);
// compiled op node returning opresult5458 (depth = 5)
  int op_slot_left_5452 = gc_frame_newslot(opresult5458);
  params[0] = strlit5453;
  partcv[0] = 1;
  Object opresult5459 = callmethod(opresult5458, "++(1)", 1, partcv, params);
// compiled op node returning opresult5459 (depth = 4)
  gc_frame_newslot(opresult5459);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult5459;
  partcv[0] = 1;
  Object call5460 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5451);
// compiled call node returning call5460 (depth = 3)
  gc_frame_end(frame);
  return call5460;
}
Object meth_collectionsPrelude_5461_keys(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_5462_values(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_5463_keysAndValuesDo_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_done (depth = 3)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude_5464_reversed(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_5465__43__43__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5466 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5467 = gc_frame_new();
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_collectionsPrelude (depth = 5)
  partcv[0] = 0;
  Object call5468 = callmethodflags(module_collectionsPrelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5467);
// compiled member node returning call5468 (depth = 4)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5469 = callmethodflags(call5468, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5466);
// compiled call node returning call5469 (depth = 3)
  gc_frame_end(frame);
  return call5469;
}
Object meth_collectionsPrelude_5470_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5471 == NULL) {
    strlit5471 = alloc_String("""\xe2""""\x9f""""\xa8""""\xe2""""\x9f""""\xa9""");
    gc_root(strlit5471);
  }
// compiled string node returning strlit5471 (depth = 3)
  gc_frame_end(frame);
  return strlit5471;
}
Object meth_collectionsPrelude_5472_contains_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5473 = alloc_Boolean(0);
// compiled identifier node returning bool5473 (depth = 3)
  gc_frame_end(frame);
  return bool5473;
}
Object meth_collectionsPrelude_5474_do_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_done (depth = 3)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude_5478__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5479 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  partcv[0] = 0;
  Object call5480 = callmethodflags(*var_o, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe5479);
// compiled member node returning call5480 (depth = 5)
  gc_frame_end(frame);
  return call5480;
}
Object meth_collectionsPrelude_5492__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool5493 = alloc_Boolean(0);
// compiled identifier node returning bool5493 (depth = 5)
  gc_frame_end(frame);
  return bool5493;
}
Object meth_collectionsPrelude_5475__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int frame5476 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5477 = alloc_Block(NULL, NULL, "collectionsPrelude", 448);
  gc_frame_newslot(block5477);
// method "_apply(_)"
  block_savedest(block5477);
  Object closure5478 = createclosure(1, "_apply(1)");
  setclosureframe(closure5478, stackframe);
  addtoclosure(closure5478, selfslot);
  struct UserObject *uo5478 = (struct UserObject*)block5477;
  uo5478->data[0] = (Object)closure5478;
  Method *meth_meth_collectionsPrelude_5478__apply_40_1_41_ = addmethod2pos(block5477, "_apply(1)", &meth_collectionsPrelude_5478__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5478__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5478__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5478__apply_40_1_41_);
  meth_meth_collectionsPrelude_5478__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5478__apply_40_1_41_->definitionLine = 1769;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5482 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe5483 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5484 == NULL) {
    strlit5484 = alloc_String("o");
    gc_root(strlit5484);
  }
// compiled string node returning strlit5484 (depth = 7)
  gc_frame_newslot(strlit5484);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5485 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5486 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5485);
// compiled member node returning call5486 (depth = 7)
  params[0] = strlit5484;
  partcv[0] = 1;
  Object call5487 = callmethodflags(call5486, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5483);
// compiled call node returning call5487 (depth = 6)
  gc_frame_newslot(call5487);
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Collection (depth = 6)
  gc_frame_newslot(*var_Collection);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5488 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5489 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5488);
// compiled member node returning call5489 (depth = 6)
  params[0] = call5487;
  params[1] = *var_Collection;
  partcv[0] = 2;
  Object call5490 = callmethodflags(call5489, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5482);
// compiled call node returning call5490 (depth = 5)
((struct UserObject *)block5477)->data[1] = call5490;
// compiled block node returning block5477 (depth = 4)
  gc_frame_newslot(block5477);
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5491 = alloc_Block(NULL, NULL, "collectionsPrelude", 451);
  gc_frame_newslot(block5491);
// method "_apply(_)"
  block_savedest(block5491);
  Object closure5492 = createclosure(1, "_apply(1)");
  setclosureframe(closure5492, stackframe);
  addtoclosure(closure5492, selfslot);
  struct UserObject *uo5492 = (struct UserObject*)block5491;
  uo5492->data[0] = (Object)closure5492;
  Method *meth_meth_collectionsPrelude_5492__apply_40_1_41_ = addmethod2pos(block5491, "_apply(1)", &meth_collectionsPrelude_5492__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5492__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5492__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5492__apply_40_1_41_);
  meth_meth_collectionsPrelude_5492__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5492__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block5491 (depth = 4)
  gc_frame_newslot(block5491);
  params[0] = block5477;
  params[1] = block5491;
  Object matchres5476 = matchCase(*var_other, params, 2);
  gc_frame_end(frame5476);
// compiled matchcase node returning matchres5476 (depth = 3)
  gc_frame_end(frame);
  return matchres5476;
}
Object meth_collectionsPrelude_5498_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5499 == NULL) {
    strlit5499 = alloc_String("emptySequenceIterator");
    gc_root(strlit5499);
  }
// compiled string node returning strlit5499 (depth = 3)
  gc_frame_end(frame);
  return strlit5499;
}
Object meth_collectionsPrelude_5500_hasNext(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5501 = alloc_Boolean(0);
// compiled identifier node returning bool5501 (depth = 3)
  gc_frame_end(frame);
  return bool5501;
}
Object meth_collectionsPrelude_5502_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5503 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5504 == NULL) {
    strlit5504 = alloc_String("on empty sequence");
    gc_root(strlit5504);
  }
// compiled string node returning strlit5504 (depth = 4)
  gc_frame_newslot(strlit5504);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = strlit5504;
  partcv[0] = 1;
  Object call5505 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5503);
// compiled call node returning call5505 (depth = 3)
  gc_frame_end(frame);
  return call5505;
}
Object meth_collectionsPrelude_5495_iterator(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5496 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5496 = alloc_userobj2(3,4, objclass5496);
  gc_frame_newslot(obj5496);
  if (objclass5496 == NULL) {
    glfree(obj5496->class->name);
    obj5496->class->name = "emptySequence.iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5496, self, 0);
  addmethodreal(obj5496,"outer", &reader_collectionsPrelude_outer_5497);
  Object oldself5496 = self;
  struct StackFrameObject *oldstackframe5496 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5496);
  gc_frame_newslot((Object)stackframe);
  self = obj5496;
  Object *oldselfslot5496 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5496 = (*(struct UserObject *)self).data[0], lowerouter5496 = thisouter5496;
  if (inheritingObject5496) {
    struct UserObject *inho5496 = (struct UserObject *)inheritingObject5496;
    while (inho5496->super != GraceDefaultObject) inho5496 = (struct UserObject *)inho5496->super;
    inho5496->super = obj5496;
    self = inheritingObject5496;
    *selfslot = self;
    lowerouter5496 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5496;
  }
// method "asString"
  struct UserObject *uo5498 = (struct UserObject*)obj5496;
  uo5498->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5498_asString = addmethod2pos(obj5496, "asString", &meth_collectionsPrelude_5498_asString, 1);
  int argcv_meth_collectionsPrelude_5498_asString[] = {0};
  meth_meth_collectionsPrelude_5498_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5498_asString);
  meth_meth_collectionsPrelude_5498_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_5498_asString->definitionLine = 456;
// method "hasNext"
  struct UserObject *uo5500 = (struct UserObject*)obj5496;
  uo5500->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5500_hasNext = addmethod2pos(obj5496, "hasNext", &meth_collectionsPrelude_5500_hasNext, 2);
  int argcv_meth_collectionsPrelude_5500_hasNext[] = {0};
  meth_meth_collectionsPrelude_5500_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5500_hasNext);
  meth_meth_collectionsPrelude_5500_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_5500_hasNext->definitionLine = 457;
// method "next"
  block_savedest(obj5496);
  Object closure5502 = createclosure(1, "next");
  setclosureframe(closure5502, stackframe);
  addtoclosure(closure5502, var_IteratorExhausted);
  struct UserObject *uo5502 = (struct UserObject*)obj5496;
  uo5502->data[3] = (Object)closure5502;
  Method *meth_meth_collectionsPrelude_5502_next = addmethod2pos(obj5496, "next", &meth_collectionsPrelude_5502_next, 3);
  int argcv_meth_collectionsPrelude_5502_next[] = {0};
  meth_meth_collectionsPrelude_5502_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5502_next);
  meth_meth_collectionsPrelude_5502_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_5502_next->definitionLine = 458;
  sourceObject = obj5496;
  sourceObject = obj5496;
  sourceObject = obj5496;
  objclass5496 = obj5496->class;
  objclass5496->definitionModule = modulename;
  objclass5496->definitionLine = 455;
  (*(struct UserObject *)self).data[0] = lowerouter5496;
  self = oldself5496;
  selfslot = oldselfslot5496;
  stackframe = oldstackframe5496;
  gc_frame_end(frame);
  return obj5496;
}
Object meth_collectionsPrelude_5495_iterator_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5496 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5496 = alloc_userobj2(3,4, objclass5496);
  gc_frame_newslot(obj5496);
  if (objclass5496 == NULL) {
    glfree(obj5496->class->name);
    obj5496->class->name = "emptySequence.iterator";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5496, self, 0);
  addmethodreal(obj5496,"outer", &reader_collectionsPrelude_outer_5497);
  Object oldself5496 = self;
  struct StackFrameObject *oldstackframe5496 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5496);
  gc_frame_newslot((Object)stackframe);
  self = obj5496;
  Object *oldselfslot5496 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5496 = (*(struct UserObject *)self).data[0], lowerouter5496 = thisouter5496;
  if (inheritingObject5496) {
    struct UserObject *inho5496 = (struct UserObject *)inheritingObject5496;
    while (inho5496->super != GraceDefaultObject) inho5496 = (struct UserObject *)inho5496->super;
    inho5496->super = obj5496;
    self = inheritingObject5496;
    *selfslot = self;
    lowerouter5496 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5496;
  }
// method "asString"
  struct UserObject *uo5498 = (struct UserObject*)obj5496;
  uo5498->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5498_asString = addmethod2pos(obj5496, "asString", &meth_collectionsPrelude_5498_asString, 1);
  int argcv_meth_collectionsPrelude_5498_asString[] = {0};
  meth_meth_collectionsPrelude_5498_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5498_asString);
  meth_meth_collectionsPrelude_5498_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_5498_asString->definitionLine = 456;
// method "hasNext"
  struct UserObject *uo5500 = (struct UserObject*)obj5496;
  uo5500->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5500_hasNext = addmethod2pos(obj5496, "hasNext", &meth_collectionsPrelude_5500_hasNext, 2);
  int argcv_meth_collectionsPrelude_5500_hasNext[] = {0};
  meth_meth_collectionsPrelude_5500_hasNext->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5500_hasNext);
  meth_meth_collectionsPrelude_5500_hasNext->definitionModule = modulename;
  meth_meth_collectionsPrelude_5500_hasNext->definitionLine = 457;
// method "next"
  block_savedest(obj5496);
  Object closure5502 = createclosure(1, "next");
  setclosureframe(closure5502, stackframe);
  addtoclosure(closure5502, var_IteratorExhausted);
  struct UserObject *uo5502 = (struct UserObject*)obj5496;
  uo5502->data[3] = (Object)closure5502;
  Method *meth_meth_collectionsPrelude_5502_next = addmethod2pos(obj5496, "next", &meth_collectionsPrelude_5502_next, 3);
  int argcv_meth_collectionsPrelude_5502_next[] = {0};
  meth_meth_collectionsPrelude_5502_next->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5502_next);
  meth_meth_collectionsPrelude_5502_next->definitionModule = modulename;
  meth_meth_collectionsPrelude_5502_next->definitionLine = 458;
  sourceObject = obj5496;
  sourceObject = obj5496;
  sourceObject = obj5496;
  objclass5496 = obj5496->class;
  objclass5496->definitionModule = modulename;
  objclass5496->definitionLine = 455;
  (*(struct UserObject *)self).data[0] = lowerouter5496;
  self = oldself5496;
  selfslot = oldselfslot5496;
  stackframe = oldstackframe5496;
  gc_frame_end(frame);
  return obj5496;
}
Object meth_collectionsPrelude_5507_sorted(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_5508_sortedBy_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_5511_emptySequence(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySequence (depth = 3)
  gc_frame_end(frame);
  return *var_emptySequence;
}
Object meth_collectionsPrelude_5514_MinimalyIterable(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "MinimalyIterable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_MinimalyIterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_MinimalyIterable (depth = 3)
  gc_frame_end(frame);
  return *var_MinimalyIterable;
}
Object meth_collectionsPrelude_5520_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5521 == NULL) {
    strlit5521 = alloc_String("unused");
    gc_root(strlit5521);
  }
// compiled string node returning strlit5521 (depth = 3)
  gc_frame_end(frame);
  return strlit5521;
}
Object meth_collectionsPrelude_5522__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5523 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5524 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5523);
// compiled call node returning call5524 (depth = 3)
  gc_frame_end(frame);
  return call5524;
}
Object meth_collectionsPrelude_5526_unused(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unused");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unused (depth = 3)
  gc_frame_end(frame);
  return *var_unused;
}
Object meth_collectionsPrelude_5532_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5533 == NULL) {
    strlit5533 = alloc_String("removed");
    gc_root(strlit5533);
  }
// compiled string node returning strlit5533 (depth = 3)
  gc_frame_end(frame);
  return strlit5533;
}
Object meth_collectionsPrelude_5534__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5535 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5536 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5535);
// compiled call node returning call5536 (depth = 3)
  gc_frame_end(frame);
  return call5536;
}
Object meth_collectionsPrelude_5538_removed(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_removed (depth = 3)
  gc_frame_end(frame);
  return *var_removed;
}
Object meth_collectionsPrelude_5541_Binding(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Binding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Binding (depth = 3)
  gc_frame_end(frame);
  return *var_Binding;
}
Object meth_collectionsPrelude_5544_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5545 == NULL) {
    strlit5545 = alloc_String("the binding class");
    gc_root(strlit5545);
  }
// compiled string node returning strlit5545 (depth = 3)
  gc_frame_end(frame);
  return strlit5545;
}
Object meth_collectionsPrelude_5549_key(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_k (depth = 3)
  gc_frame_end(frame);
  return *var_k;
}
Object meth_collectionsPrelude_5550_value(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_end(frame);
  return *var_v;
}
Object meth_collectionsPrelude_5551_asString(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5553 == NULL) {
    strlit5553 = alloc_String("");
    gc_root(strlit5553);
  }
// compiled string node returning strlit5553 (depth = 4)
  int op_slot_right_5552 = gc_frame_newslot(strlit5553);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  int op_slot_right_5555 = gc_frame_newslot(*var_v);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5558 == NULL) {
    strlit5558 = alloc_String("::");
    gc_root(strlit5558);
  }
// compiled string node returning strlit5558 (depth = 6)
  int op_slot_right_5557 = gc_frame_newslot(strlit5558);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  int op_slot_right_5560 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 7)
  if (strlit5562 == NULL) {
    strlit5562 = alloc_String("");
    gc_root(strlit5562);
  }
// compiled string node returning strlit5562 (depth = 7)
  int op_slot_left_5560 = gc_frame_newslot(strlit5562);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult5563 = callmethod(strlit5562, "++(1)", 1, partcv, params);
// compiled op node returning opresult5563 (depth = 6)
  int op_slot_left_5557 = gc_frame_newslot(opresult5563);
  params[0] = strlit5558;
  partcv[0] = 1;
  Object opresult5564 = callmethod(opresult5563, "++(1)", 1, partcv, params);
// compiled op node returning opresult5564 (depth = 5)
  int op_slot_left_5555 = gc_frame_newslot(opresult5564);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult5565 = callmethod(opresult5564, "++(1)", 1, partcv, params);
// compiled op node returning opresult5565 (depth = 4)
  int op_slot_left_5552 = gc_frame_newslot(opresult5565);
  params[0] = strlit5553;
  partcv[0] = 1;
  Object opresult5566 = callmethod(opresult5565, "++(1)", 1, partcv, params);
// compiled op node returning opresult5566 (depth = 3)
  gc_frame_end(frame);
  return opresult5566;
}
Object meth_collectionsPrelude_5567_hashcode(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hashcode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5569 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  partcv[0] = 0;
  Object call5570 = callmethodflags(*var_v, "hashcode", 1, partcv, params, 0);
  gc_frame_end(callframe5569);
// compiled member node returning call5570 (depth = 4)
  int op_slot_right_5568 = gc_frame_newslot(call5570);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5573 = alloc_Float64(1021);
// compiled num node returning num5573 (depth = 5)
  int op_slot_right_5572 = gc_frame_newslot(num5573);
// starting to compile member node (depth = 5)
  int callframe5575 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  partcv[0] = 0;
  Object call5576 = callmethodflags(*var_k, "hashcode", 1, partcv, params, 0);
  gc_frame_end(callframe5575);
// compiled member node returning call5576 (depth = 5)
  int op_slot_left_5572 = gc_frame_newslot(call5576);
  params[0] = num5573;
  partcv[0] = 1;
  Object prod5577 = callmethod(call5576, "*(1)", 1, partcv, params);
// compiled op node returning prod5577 (depth = 4)
  int op_slot_left_5568 = gc_frame_newslot(prod5577);
  params[0] = call5570;
  partcv[0] = 1;
  Object sum5578 = callmethod(prod5577, "+(1)", 1, partcv, params);
// compiled op node returning sum5578 (depth = 3)
  gc_frame_end(frame);
  return sum5578;
}
Object meth_collectionsPrelude_5579_hash(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  partcv[0] = 0;
  Object call5582 = callmethodflags(*var_v, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe5581);
// compiled member node returning call5582 (depth = 4)
  int op_slot_right_5580 = gc_frame_newslot(call5582);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5585 = alloc_Float64(1021);
// compiled num node returning num5585 (depth = 5)
  int op_slot_right_5584 = gc_frame_newslot(num5585);
// starting to compile member node (depth = 5)
  int callframe5587 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  partcv[0] = 0;
  Object call5588 = callmethodflags(*var_k, "hash", 1, partcv, params, 0);
  gc_frame_end(callframe5587);
// compiled member node returning call5588 (depth = 5)
  int op_slot_left_5584 = gc_frame_newslot(call5588);
  params[0] = num5585;
  partcv[0] = 1;
  Object prod5589 = callmethod(call5588, "*(1)", 1, partcv, params);
// compiled op node returning prod5589 (depth = 4)
  int op_slot_left_5580 = gc_frame_newslot(prod5589);
  params[0] = call5582;
  partcv[0] = 1;
  Object sum5590 = callmethod(prod5589, "+(1)", 1, partcv, params);
// compiled op node returning sum5590 (depth = 3)
  gc_frame_end(frame);
  return sum5590;
}
Object meth_collectionsPrelude_5594__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5597 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call5598 = callmethodflags(*var_o, "value", 1, partcv, params, 0);
  gc_frame_end(callframe5597);
// compiled member node returning call5598 (depth = 7)
  int op_slot_right_5596 = gc_frame_newslot(call5598);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  int op_slot_left_5596 = gc_frame_newslot(*var_v);
  params[0] = call5598;
  partcv[0] = 1;
  Object opresult5600 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult5600 (depth = 6)
  int op_slot_right_5595 = gc_frame_newslot(opresult5600);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5603 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call5604 = callmethodflags(*var_o, "key", 1, partcv, params, 0);
  gc_frame_end(callframe5603);
// compiled member node returning call5604 (depth = 7)
  int op_slot_right_5602 = gc_frame_newslot(call5604);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  int op_slot_left_5602 = gc_frame_newslot(*var_k);
  params[0] = call5604;
  partcv[0] = 1;
  Object opresult5606 = callmethod(*var_k, "==(1)", 1, partcv, params);
// compiled op node returning opresult5606 (depth = 6)
  int op_slot_left_5595 = gc_frame_newslot(opresult5606);
  params[0] = opresult5600;
  partcv[0] = 1;
  Object opresult5607 = callmethod(opresult5606, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5607 (depth = 5)
  gc_frame_end(frame);
  return opresult5607;
}
Object meth_collectionsPrelude_5619__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___2 = &(stackframe->slots[0]);
  *var___2 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5620 = alloc_Boolean(0);
// compiled identifier node returning bool5620 (depth = 6)
  block_return(realself, bool5620);
// compiled return node returning undefined (depth = 5)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_5591__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  Object *var_Binding = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int frame5592 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5593 = alloc_Block(NULL, NULL, "collectionsPrelude", 1236);
  gc_frame_newslot(block5593);
// method "_apply(_)"
  block_savedest(block5593);
  Object closure5594 = createclosure(3, "_apply(1)");
  setclosureframe(closure5594, stackframe);
  addtoclosure(closure5594, var_v);
  addtoclosure(closure5594, var_k);
  addtoclosure(closure5594, selfslot);
  struct UserObject *uo5594 = (struct UserObject*)block5593;
  uo5594->data[0] = (Object)closure5594;
  Method *meth_meth_collectionsPrelude_5594__apply_40_1_41_ = addmethod2pos(block5593, "_apply(1)", &meth_collectionsPrelude_5594__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5594__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5594__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5594__apply_40_1_41_);
  meth_meth_collectionsPrelude_5594__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5594__apply_40_1_41_->definitionLine = 1769;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5609 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe5610 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5611 == NULL) {
    strlit5611 = alloc_String("o");
    gc_root(strlit5611);
  }
// compiled string node returning strlit5611 (depth = 7)
  gc_frame_newslot(strlit5611);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5612 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5613 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5612);
// compiled member node returning call5613 (depth = 7)
  params[0] = strlit5611;
  partcv[0] = 1;
  Object call5614 = callmethodflags(call5613, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5610);
// compiled call node returning call5614 (depth = 6)
  gc_frame_newslot(call5614);
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Binding (depth = 6)
  gc_frame_newslot(*var_Binding);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5615 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5616 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5615);
// compiled member node returning call5616 (depth = 6)
  params[0] = call5614;
  params[1] = *var_Binding;
  partcv[0] = 2;
  Object call5617 = callmethodflags(call5616, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5609);
// compiled call node returning call5617 (depth = 5)
((struct UserObject *)block5593)->data[1] = call5617;
// compiled block node returning block5593 (depth = 4)
  gc_frame_newslot(block5593);
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5618 = alloc_Block(NULL, NULL, "collectionsPrelude", 1237);
  gc_frame_newslot(block5618);
// method "_apply(_)"
  block_savedest(block5618);
  Object closure5619 = createclosure(1, "_apply(1)");
  setclosureframe(closure5619, stackframe);
  addtoclosure(closure5619, selfslot);
  struct UserObject *uo5619 = (struct UserObject*)block5618;
  uo5619->data[0] = (Object)closure5619;
  Method *meth_meth_collectionsPrelude_5619__apply_40_1_41_ = addmethod2pos(block5618, "_apply(1)", &meth_collectionsPrelude_5619__apply_40_1_41_, 0);
  int argcv_meth_collectionsPrelude_5619__apply_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5619__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5619__apply_40_1_41_);
  meth_meth_collectionsPrelude_5619__apply_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5619__apply_40_1_41_->definitionLine = 1769;
// compiled block node returning block5618 (depth = 4)
  gc_frame_newslot(block5618);
  params[0] = block5593;
  params[1] = block5618;
  Object matchres5592 = matchCase(*var_other, params, 2);
  gc_frame_end(frame5592);
// compiled matchcase node returning matchres5592 (depth = 3)
  gc_frame_end(frame);
  return matchres5592;
}
Object meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key(1)value(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method key(_)value(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method key(_)value(_)");
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for key(_)value(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part key(_)");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part value(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5547 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5547 = alloc_userobj2(6,7, objclass5547);
  gc_frame_newslot(obj5547);
  if (objclass5547 == NULL) {
    glfree(obj5547->class->name);
    obj5547->class->name = "binding.key(_)value(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5547, self, 0);
  addmethodreal(obj5547,"outer", &reader_collectionsPrelude_outer_5548);
  Object oldself5547 = self;
  struct StackFrameObject *oldstackframe5547 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5547);
  gc_frame_newslot((Object)stackframe);
  self = obj5547;
  Object *oldselfslot5547 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5547 = (*(struct UserObject *)self).data[0], lowerouter5547 = thisouter5547;
  if (inheritingObject5547) {
    struct UserObject *inho5547 = (struct UserObject *)inheritingObject5547;
    while (inho5547->super != GraceDefaultObject) inho5547 = (struct UserObject *)inho5547->super;
    inho5547->super = obj5547;
    self = inheritingObject5547;
    *selfslot = self;
    lowerouter5547 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5547;
  }
// method "key"
  block_savedest(obj5547);
  Object closure5549 = createclosure(1, "key");
  setclosureframe(closure5549, stackframe);
  addtoclosure(closure5549, var_k);
  struct UserObject *uo5549 = (struct UserObject*)obj5547;
  uo5549->data[1] = (Object)closure5549;
  Method *meth_meth_collectionsPrelude_5549_key = addmethod2pos(obj5547, "key", &meth_collectionsPrelude_5549_key, 1);
  int argcv_meth_collectionsPrelude_5549_key[] = {0};
  meth_meth_collectionsPrelude_5549_key->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5549_key);
  meth_meth_collectionsPrelude_5549_key->definitionModule = modulename;
  meth_meth_collectionsPrelude_5549_key->definitionLine = 1229;
// method "value"
  block_savedest(obj5547);
  Object closure5550 = createclosure(1, "value");
  setclosureframe(closure5550, stackframe);
  addtoclosure(closure5550, var_v);
  struct UserObject *uo5550 = (struct UserObject*)obj5547;
  uo5550->data[2] = (Object)closure5550;
  Method *meth_meth_collectionsPrelude_5550_value = addmethod2pos(obj5547, "value", &meth_collectionsPrelude_5550_value, 2);
  int argcv_meth_collectionsPrelude_5550_value[] = {0};
  meth_meth_collectionsPrelude_5550_value->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5550_value);
  meth_meth_collectionsPrelude_5550_value->definitionModule = modulename;
  meth_meth_collectionsPrelude_5550_value->definitionLine = 1230;
// method "asString"
  block_savedest(obj5547);
  Object closure5551 = createclosure(2, "asString");
  setclosureframe(closure5551, stackframe);
  addtoclosure(closure5551, var_v);
  addtoclosure(closure5551, var_k);
  struct UserObject *uo5551 = (struct UserObject*)obj5547;
  uo5551->data[3] = (Object)closure5551;
  Method *meth_meth_collectionsPrelude_5551_asString = addmethod2pos(obj5547, "asString", &meth_collectionsPrelude_5551_asString, 3);
  int argcv_meth_collectionsPrelude_5551_asString[] = {0};
  meth_meth_collectionsPrelude_5551_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5551_asString);
  meth_meth_collectionsPrelude_5551_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_5551_asString->definitionLine = 1231;
// method "hashcode"
  block_savedest(obj5547);
  Object closure5567 = createclosure(2, "hashcode");
  setclosureframe(closure5567, stackframe);
  addtoclosure(closure5567, var_v);
  addtoclosure(closure5567, var_k);
  struct UserObject *uo5567 = (struct UserObject*)obj5547;
  uo5567->data[4] = (Object)closure5567;
  Method *meth_meth_collectionsPrelude_5567_hashcode = addmethod2pos(obj5547, "hashcode", &meth_collectionsPrelude_5567_hashcode, 4);
  int argcv_meth_collectionsPrelude_5567_hashcode[] = {0};
  meth_meth_collectionsPrelude_5567_hashcode->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5567_hashcode);
  meth_meth_collectionsPrelude_5567_hashcode->definitionModule = modulename;
  meth_meth_collectionsPrelude_5567_hashcode->definitionLine = 1232;
// method "hash"
  block_savedest(obj5547);
  Object closure5579 = createclosure(2, "hash");
  setclosureframe(closure5579, stackframe);
  addtoclosure(closure5579, var_v);
  addtoclosure(closure5579, var_k);
  struct UserObject *uo5579 = (struct UserObject*)obj5547;
  uo5579->data[5] = (Object)closure5579;
  Method *meth_meth_collectionsPrelude_5579_hash = addmethod2pos(obj5547, "hash", &meth_collectionsPrelude_5579_hash, 5);
  int argcv_meth_collectionsPrelude_5579_hash[] = {0};
  meth_meth_collectionsPrelude_5579_hash->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5579_hash);
  meth_meth_collectionsPrelude_5579_hash->definitionModule = modulename;
  meth_meth_collectionsPrelude_5579_hash->definitionLine = 1233;
// method "==(_)"
  block_savedest(obj5547);
  Object closure5591 = createclosure(3, "==(1)");
  setclosureframe(closure5591, stackframe);
  addtoclosure(closure5591, var_v);
  addtoclosure(closure5591, var_k);
  addtoclosure(closure5591, var_Binding);
  struct UserObject *uo5591 = (struct UserObject*)obj5547;
  uo5591->data[6] = (Object)closure5591;
  Method *meth_meth_collectionsPrelude_5591__61__61__40_1_41_ = addmethod2pos(obj5547, "==(1)", &meth_collectionsPrelude_5591__61__61__40_1_41_, 6);
  int argcv_meth_collectionsPrelude_5591__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5591__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5591__61__61__40_1_41_);
  meth_meth_collectionsPrelude_5591__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5591__61__61__40_1_41_->definitionLine = 1234;
  sourceObject = obj5547;
  sourceObject = obj5547;
  sourceObject = obj5547;
  sourceObject = obj5547;
  sourceObject = obj5547;
  sourceObject = obj5547;
  objclass5547 = obj5547->class;
  objclass5547->definitionModule = modulename;
  objclass5547->definitionLine = 1228;
  (*(struct UserObject *)self).data[0] = lowerouter5547;
  self = oldself5547;
  selfslot = oldselfslot5547;
  stackframe = oldstackframe5547;
  gc_frame_end(frame);
  return obj5547;
}
Object meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41__object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key(1)value(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method key(_)value(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method key(_)value(_)");
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for key(_)value(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part key(_)");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part value(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5547 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5547 = alloc_userobj2(6,7, objclass5547);
  gc_frame_newslot(obj5547);
  if (objclass5547 == NULL) {
    glfree(obj5547->class->name);
    obj5547->class->name = "binding.key(_)value(_)";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5547, self, 0);
  addmethodreal(obj5547,"outer", &reader_collectionsPrelude_outer_5548);
  Object oldself5547 = self;
  struct StackFrameObject *oldstackframe5547 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5547);
  gc_frame_newslot((Object)stackframe);
  self = obj5547;
  Object *oldselfslot5547 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5547 = (*(struct UserObject *)self).data[0], lowerouter5547 = thisouter5547;
  if (inheritingObject5547) {
    struct UserObject *inho5547 = (struct UserObject *)inheritingObject5547;
    while (inho5547->super != GraceDefaultObject) inho5547 = (struct UserObject *)inho5547->super;
    inho5547->super = obj5547;
    self = inheritingObject5547;
    *selfslot = self;
    lowerouter5547 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5547;
  }
// method "key"
  block_savedest(obj5547);
  Object closure5549 = createclosure(1, "key");
  setclosureframe(closure5549, stackframe);
  addtoclosure(closure5549, var_k);
  struct UserObject *uo5549 = (struct UserObject*)obj5547;
  uo5549->data[1] = (Object)closure5549;
  Method *meth_meth_collectionsPrelude_5549_key = addmethod2pos(obj5547, "key", &meth_collectionsPrelude_5549_key, 1);
  int argcv_meth_collectionsPrelude_5549_key[] = {0};
  meth_meth_collectionsPrelude_5549_key->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5549_key);
  meth_meth_collectionsPrelude_5549_key->definitionModule = modulename;
  meth_meth_collectionsPrelude_5549_key->definitionLine = 1229;
// method "value"
  block_savedest(obj5547);
  Object closure5550 = createclosure(1, "value");
  setclosureframe(closure5550, stackframe);
  addtoclosure(closure5550, var_v);
  struct UserObject *uo5550 = (struct UserObject*)obj5547;
  uo5550->data[2] = (Object)closure5550;
  Method *meth_meth_collectionsPrelude_5550_value = addmethod2pos(obj5547, "value", &meth_collectionsPrelude_5550_value, 2);
  int argcv_meth_collectionsPrelude_5550_value[] = {0};
  meth_meth_collectionsPrelude_5550_value->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5550_value);
  meth_meth_collectionsPrelude_5550_value->definitionModule = modulename;
  meth_meth_collectionsPrelude_5550_value->definitionLine = 1230;
// method "asString"
  block_savedest(obj5547);
  Object closure5551 = createclosure(2, "asString");
  setclosureframe(closure5551, stackframe);
  addtoclosure(closure5551, var_v);
  addtoclosure(closure5551, var_k);
  struct UserObject *uo5551 = (struct UserObject*)obj5547;
  uo5551->data[3] = (Object)closure5551;
  Method *meth_meth_collectionsPrelude_5551_asString = addmethod2pos(obj5547, "asString", &meth_collectionsPrelude_5551_asString, 3);
  int argcv_meth_collectionsPrelude_5551_asString[] = {0};
  meth_meth_collectionsPrelude_5551_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5551_asString);
  meth_meth_collectionsPrelude_5551_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_5551_asString->definitionLine = 1231;
// method "hashcode"
  block_savedest(obj5547);
  Object closure5567 = createclosure(2, "hashcode");
  setclosureframe(closure5567, stackframe);
  addtoclosure(closure5567, var_v);
  addtoclosure(closure5567, var_k);
  struct UserObject *uo5567 = (struct UserObject*)obj5547;
  uo5567->data[4] = (Object)closure5567;
  Method *meth_meth_collectionsPrelude_5567_hashcode = addmethod2pos(obj5547, "hashcode", &meth_collectionsPrelude_5567_hashcode, 4);
  int argcv_meth_collectionsPrelude_5567_hashcode[] = {0};
  meth_meth_collectionsPrelude_5567_hashcode->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5567_hashcode);
  meth_meth_collectionsPrelude_5567_hashcode->definitionModule = modulename;
  meth_meth_collectionsPrelude_5567_hashcode->definitionLine = 1232;
// method "hash"
  block_savedest(obj5547);
  Object closure5579 = createclosure(2, "hash");
  setclosureframe(closure5579, stackframe);
  addtoclosure(closure5579, var_v);
  addtoclosure(closure5579, var_k);
  struct UserObject *uo5579 = (struct UserObject*)obj5547;
  uo5579->data[5] = (Object)closure5579;
  Method *meth_meth_collectionsPrelude_5579_hash = addmethod2pos(obj5547, "hash", &meth_collectionsPrelude_5579_hash, 5);
  int argcv_meth_collectionsPrelude_5579_hash[] = {0};
  meth_meth_collectionsPrelude_5579_hash->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5579_hash);
  meth_meth_collectionsPrelude_5579_hash->definitionModule = modulename;
  meth_meth_collectionsPrelude_5579_hash->definitionLine = 1233;
// method "==(_)"
  block_savedest(obj5547);
  Object closure5591 = createclosure(3, "==(1)");
  setclosureframe(closure5591, stackframe);
  addtoclosure(closure5591, var_v);
  addtoclosure(closure5591, var_k);
  addtoclosure(closure5591, var_Binding);
  struct UserObject *uo5591 = (struct UserObject*)obj5547;
  uo5591->data[6] = (Object)closure5591;
  Method *meth_meth_collectionsPrelude_5591__61__61__40_1_41_ = addmethod2pos(obj5547, "==(1)", &meth_collectionsPrelude_5591__61__61__40_1_41_, 6);
  int argcv_meth_collectionsPrelude_5591__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5591__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5591__61__61__40_1_41_);
  meth_meth_collectionsPrelude_5591__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5591__61__61__40_1_41_->definitionLine = 1234;
  sourceObject = obj5547;
  sourceObject = obj5547;
  sourceObject = obj5547;
  sourceObject = obj5547;
  sourceObject = obj5547;
  sourceObject = obj5547;
  objclass5547 = obj5547->class;
  objclass5547->definitionModule = modulename;
  objclass5547->definitionLine = 1228;
  (*(struct UserObject *)self).data[0] = lowerouter5547;
  self = oldself5547;
  selfslot = oldselfslot5547;
  stackframe = oldstackframe5547;
  gc_frame_end(frame);
  return obj5547;
}
Object meth_collectionsPrelude_5623_binding(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "binding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_binding (depth = 3)
  gc_frame_end(frame);
  return *var_binding;
}
Object meth_collectionsPrelude_5626_ComparableToDictionary(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ComparableToDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ComparableToDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ComparableToDictionary (depth = 3)
  gc_frame_end(frame);
  return *var_ComparableToDictionary;
}
Object module_collectionsPrelude_init() {
  if (module_collectionsPrelude) return module_collectionsPrelude;
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(60, 60);
  module_collectionsPrelude = self;
  self->class->definitionModule = "collectionsPrelude";
  gc_root(self);
  prelude = grace_prelude();
  adddatum2(self, grace_prelude(), 0);
  Object ObjectType = alloc_ObjectType();
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule("collectionsPrelude");
  setsource(originalSourceLines);
  setclassname(self, "Module<collectionsPrelude>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(60, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[2];
// definebindings:
  Object *var_BoundsError = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "BoundsError");
  Object *var_IteratorExhausted = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "IteratorExhausted");
  Object *var_SubobjectResponsibility = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "SubobjectResponsibility");
  Object *var_NoSuchObject = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "NoSuchObject");
  Object *var_RequestError = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "RequestError");
  Object *var_ConcurrentModification = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ConcurrentModification");
  Object *var_SizeUnknown = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "SizeUnknown");
  Object *var_Function0 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "Function0");
  Object *var_Function1 = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "Function1");
  Object *var_Function2 = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "Function2");
  Object *var_Procedure0 = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "Procedure0");
  Object *var_Procedure1 = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "Procedure1");
  Object *var_Procedure2 = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "Procedure2");
  Object *var_Predicate1 = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "Predicate1");
  Object *var_SelfType = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "SelfType");
  Object *var_Collection = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "Collection");
  Object *var_Expandable = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "Expandable");
  Object *var_Iterable = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "Iterable");
  Object *var_Enumerable = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "Enumerable");
  Object *var_Sequence = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "Sequence");
  Object *var_List = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "List");
  Object *var_Set = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "Set");
  Object *var_Dictionary = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "Dictionary");
  Object *var_Iterator = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "Iterator");
  Object *var_emptySequence = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "emptySequence");
  Object *var_MinimalyIterable = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "MinimalyIterable");
  Object *var_unused = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "unused");
  Object *var_removed = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "removed");
  Object *var_Binding = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "Binding");
  Object *var_binding = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "binding");
  Object *var_ComparableToDictionary = &(stackframe->slots[31]);
  setframeelementname(stackframe, 31, "ComparableToDictionary");
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "required"
  block_savedest(self);
  Object closure1 = createclosure(1, "required");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_SubobjectResponsibility);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_collectionsPrelude_1_required = addmethod2pos(self, "required", &meth_collectionsPrelude_1_required, 1);
  int argcv_meth_collectionsPrelude_1_required[] = {0};
  meth_meth_collectionsPrelude_1_required->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1_required);
  meth_meth_collectionsPrelude_1_required->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_1_required->definitionModule = modulename;
  meth_meth_collectionsPrelude_1_required->definitionLine = 11;
// compiled method node returning  (depth = 1)
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazySequenceOver(_)mappedBy(_)"
  struct UserObject *uo5 = (struct UserObject*)self;
  uo5->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41_ = addmethod2pos(self, "lazySequenceOver(1)mappedBy(1)", &meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41_, 2);
  int argcv_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41_);
  meth_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41_->definitionLine = 179;
  Method *meth_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41__object = addmethod2pos(self, "lazySequenceOver(1)mappedBy(1)$object(1)", &meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41__object, 2);
  int argcv_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41__object[] = {1, 1};
  meth_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41__object->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41__object);
  meth_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41__object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_5_lazySequenceOver_40_1_41_mappedBy_40_1_41__object->definitionLine = 179;
// compiled method node returning  (depth = 1)
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazySequenceOver(_)filteredBy(_)"
  struct UserObject *uo47 = (struct UserObject*)self;
  uo47->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41_ = addmethod2pos(self, "lazySequenceOver(1)filteredBy(1)", &meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41_, 3);
  int argcv_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41_);
  meth_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41_->definitionLine = 193;
  Method *meth_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41__object = addmethod2pos(self, "lazySequenceOver(1)filteredBy(1)$object(1)", &meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41__object, 3);
  int argcv_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41__object[] = {1, 1};
  meth_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41__object->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41__object);
  meth_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41__object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_47_lazySequenceOver_40_1_41_filteredBy_40_1_41__object->definitionLine = 193;
// compiled method node returning  (depth = 1)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "iteratorConcat(_,_)"
  struct UserObject *uo151 = (struct UserObject*)self;
  uo151->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_151_iteratorConcat_40_2_41_ = addmethod2pos(self, "iteratorConcat(2)", &meth_collectionsPrelude_151_iteratorConcat_40_2_41_, 4);
  int argcv_meth_collectionsPrelude_151_iteratorConcat_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_151_iteratorConcat_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_151_iteratorConcat_40_2_41_);
  meth_meth_collectionsPrelude_151_iteratorConcat_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_151_iteratorConcat_40_2_41_->definitionLine = 238;
  Method *meth_meth_collectionsPrelude_151_iteratorConcat_40_2_41__object = addmethod2pos(self, "iteratorConcat(2)$object(1)", &meth_collectionsPrelude_151_iteratorConcat_40_2_41__object, 4);
  int argcv_meth_collectionsPrelude_151_iteratorConcat_40_2_41__object[] = {2};
  meth_meth_collectionsPrelude_151_iteratorConcat_40_2_41__object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_151_iteratorConcat_40_2_41__object);
  meth_meth_collectionsPrelude_151_iteratorConcat_40_2_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_151_iteratorConcat_40_2_41__object->definitionLine = 238;
// compiled method node returning  (depth = 1)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazyConcatenation(_,_)"
  struct UserObject *uo188 = (struct UserObject*)self;
  uo188->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_188_lazyConcatenation_40_2_41_ = addmethod2pos(self, "lazyConcatenation(2)", &meth_collectionsPrelude_188_lazyConcatenation_40_2_41_, 5);
  int argcv_meth_collectionsPrelude_188_lazyConcatenation_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_188_lazyConcatenation_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_188_lazyConcatenation_40_2_41_);
  meth_meth_collectionsPrelude_188_lazyConcatenation_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_188_lazyConcatenation_40_2_41_->definitionLine = 253;
  Method *meth_meth_collectionsPrelude_188_lazyConcatenation_40_2_41__object = addmethod2pos(self, "lazyConcatenation(2)$object(1)", &meth_collectionsPrelude_188_lazyConcatenation_40_2_41__object, 5);
  int argcv_meth_collectionsPrelude_188_lazyConcatenation_40_2_41__object[] = {2};
  meth_meth_collectionsPrelude_188_lazyConcatenation_40_2_41__object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_188_lazyConcatenation_40_2_41__object);
  meth_meth_collectionsPrelude_188_lazyConcatenation_40_2_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_188_lazyConcatenation_40_2_41__object->definitionLine = 253;
// compiled method node returning  (depth = 1)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "collection"
  block_savedest(self);
  Object closure225 = createclosure(2, "collection");
  setclosureframe(closure225, stackframe);
  addtoclosure(closure225, var_SizeUnknown);
  addtoclosure(closure225, var_BoundsError);
  struct UserObject *uo225 = (struct UserObject*)self;
  uo225->data[6] = (Object)closure225;
  Method *meth_meth_collectionsPrelude_225_collection = addmethod2pos(self, "collection", &meth_collectionsPrelude_225_collection, 6);
  int argcv_meth_collectionsPrelude_225_collection[] = {0};
  meth_meth_collectionsPrelude_225_collection->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_225_collection);
  meth_meth_collectionsPrelude_225_collection->definitionModule = modulename;
  meth_meth_collectionsPrelude_225_collection->definitionLine = 262;
  block_savedest(self);
  Object closure304 = createclosure(2, "collection$object(1)");
  setclosureframe(closure304, stackframe);
  addtoclosure(closure304, var_SizeUnknown);
  addtoclosure(closure304, var_BoundsError);
  Method *meth_meth_collectionsPrelude_225_collection_object = addmethod2pos(self, "collection$object(1)", &meth_collectionsPrelude_225_collection_object, 6);
  meth_meth_collectionsPrelude_225_collection_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_225_collection_object->definitionLine = 262;
// compiled method node returning  (depth = 1)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "enumerable"
  block_savedest(self);
  Object closure305 = createclosure(1, "enumerable");
  setclosureframe(closure305, stackframe);
  addtoclosure(closure305, var_SizeUnknown);
  struct UserObject *uo305 = (struct UserObject*)self;
  uo305->data[7] = (Object)closure305;
  Method *meth_meth_collectionsPrelude_305_enumerable = addmethod2pos(self, "enumerable", &meth_collectionsPrelude_305_enumerable, 7);
  int argcv_meth_collectionsPrelude_305_enumerable[] = {0};
  meth_meth_collectionsPrelude_305_enumerable->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_305_enumerable);
  meth_meth_collectionsPrelude_305_enumerable->definitionModule = modulename;
  meth_meth_collectionsPrelude_305_enumerable->definitionLine = 319;
  block_savedest(self);
  Object closure459 = createclosure(1, "enumerable$object(1)");
  setclosureframe(closure459, stackframe);
  addtoclosure(closure459, var_SizeUnknown);
  Method *meth_meth_collectionsPrelude_305_enumerable_object = addmethod2pos(self, "enumerable$object(1)", &meth_collectionsPrelude_305_enumerable_object, 7);
  meth_meth_collectionsPrelude_305_enumerable_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_305_enumerable_object->definitionLine = 319;
// compiled method node returning  (depth = 1)
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "indexable"
  block_savedest(self);
  Object closure460 = createclosure(1, "indexable");
  setclosureframe(closure460, stackframe);
  addtoclosure(closure460, var_NoSuchObject);
  struct UserObject *uo460 = (struct UserObject*)self;
  uo460->data[8] = (Object)closure460;
  Method *meth_meth_collectionsPrelude_460_indexable = addmethod2pos(self, "indexable", &meth_collectionsPrelude_460_indexable, 8);
  int argcv_meth_collectionsPrelude_460_indexable[] = {0};
  meth_meth_collectionsPrelude_460_indexable->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_460_indexable);
  meth_meth_collectionsPrelude_460_indexable->definitionModule = modulename;
  meth_meth_collectionsPrelude_460_indexable->definitionLine = 384;
  block_savedest(self);
  Object closure592 = createclosure(1, "indexable$object(1)");
  setclosureframe(closure592, stackframe);
  addtoclosure(closure592, var_NoSuchObject);
  Method *meth_meth_collectionsPrelude_460_indexable_object = addmethod2pos(self, "indexable$object(1)", &meth_collectionsPrelude_460_indexable_object, 8);
  meth_meth_collectionsPrelude_460_indexable_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_460_indexable_object->definitionLine = 384;
// compiled method node returning  (depth = 1)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "max(_,_)"
  struct UserObject *uo593 = (struct UserObject*)self;
  uo593->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_593_max_40_2_41_ = addmethod2pos(self, "max(2)", &meth_collectionsPrelude_593_max_40_2_41_, 9);
  int argcv_meth_collectionsPrelude_593_max_40_2_41_[] = {2};
  meth_meth_collectionsPrelude_593_max_40_2_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_593_max_40_2_41_);
  meth_meth_collectionsPrelude_593_max_40_2_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_593_max_40_2_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_593_max_40_2_41_->definitionLine = 429;
// compiled method node returning  (depth = 1)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "sequence"
  block_savedest(self);
  Object closure598 = createclosure(3, "sequence");
  setclosureframe(closure598, stackframe);
  addtoclosure(closure598, var_emptySequence);
  addtoclosure(closure598, var_BoundsError);
  addtoclosure(closure598, var_IteratorExhausted);
  struct UserObject *uo598 = (struct UserObject*)self;
  uo598->data[10] = (Object)closure598;
  Method *meth_meth_collectionsPrelude_598_sequence = addmethod2pos(self, "sequence", &meth_collectionsPrelude_598_sequence, 10);
  int argcv_meth_collectionsPrelude_598_sequence[] = {0};
  meth_meth_collectionsPrelude_598_sequence->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_598_sequence);
  meth_meth_collectionsPrelude_598_sequence->definitionModule = modulename;
  meth_meth_collectionsPrelude_598_sequence->definitionLine = 464;
  block_savedest(self);
  Object closure1020 = createclosure(3, "sequence$object(1)");
  setclosureframe(closure1020, stackframe);
  addtoclosure(closure1020, var_emptySequence);
  addtoclosure(closure1020, var_BoundsError);
  addtoclosure(closure1020, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_598_sequence_object = addmethod2pos(self, "sequence$object(1)", &meth_collectionsPrelude_598_sequence_object, 10);
  meth_meth_collectionsPrelude_598_sequence_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_598_sequence_object->definitionLine = 464;
// compiled method node returning  (depth = 1)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isEqual(_)toCollection(_)"
  block_savedest(self);
  Object closure1021 = createclosure(1, "isEqual(1)toCollection(1)");
  setclosureframe(closure1021, stackframe);
  addtoclosure(closure1021, var_MinimalyIterable);
  struct UserObject *uo1021 = (struct UserObject*)self;
  uo1021->data[11] = (Object)closure1021;
  Method *meth_meth_collectionsPrelude_1021_isEqual_40_1_41_toCollection_40_1_41_ = addmethod2pos(self, "isEqual(1)toCollection(1)", &meth_collectionsPrelude_1021_isEqual_40_1_41_toCollection_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_1021_isEqual_40_1_41_toCollection_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_1021_isEqual_40_1_41_toCollection_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_1021_isEqual_40_1_41_toCollection_40_1_41_);
  meth_meth_collectionsPrelude_1021_isEqual_40_1_41_toCollection_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_1021_isEqual_40_1_41_toCollection_40_1_41_->definitionLine = 605;
// compiled method node returning  (depth = 1)
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "list"
  block_savedest(self);
  Object closure1061 = createclosure(5, "list");
  setclosureframe(closure1061, stackframe);
  addtoclosure(closure1061, var_emptySequence);
  addtoclosure(closure1061, var_BoundsError);
  addtoclosure(closure1061, var_NoSuchObject);
  addtoclosure(closure1061, var_ConcurrentModification);
  addtoclosure(closure1061, var_IteratorExhausted);
  struct UserObject *uo1061 = (struct UserObject*)self;
  uo1061->data[12] = (Object)closure1061;
  Method *meth_meth_collectionsPrelude_1061_list = addmethod2pos(self, "list", &meth_collectionsPrelude_1061_list, 12);
  int argcv_meth_collectionsPrelude_1061_list[] = {0};
  meth_meth_collectionsPrelude_1061_list->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_1061_list);
  meth_meth_collectionsPrelude_1061_list->definitionModule = modulename;
  meth_meth_collectionsPrelude_1061_list->definitionLine = 620;
  block_savedest(self);
  Object closure2113 = createclosure(5, "list$object(1)");
  setclosureframe(closure2113, stackframe);
  addtoclosure(closure2113, var_emptySequence);
  addtoclosure(closure2113, var_BoundsError);
  addtoclosure(closure2113, var_NoSuchObject);
  addtoclosure(closure2113, var_ConcurrentModification);
  addtoclosure(closure2113, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_1061_list_object = addmethod2pos(self, "list$object(1)", &meth_collectionsPrelude_1061_list_object, 12);
  meth_meth_collectionsPrelude_1061_list_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_1061_list_object->definitionLine = 620;
// compiled method node returning  (depth = 1)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "set"
  block_savedest(self);
  Object closure2114 = createclosure(6, "set");
  setclosureframe(closure2114, stackframe);
  addtoclosure(closure2114, var_NoSuchObject);
  addtoclosure(closure2114, var_removed);
  addtoclosure(closure2114, var_unused);
  addtoclosure(closure2114, var_ConcurrentModification);
  addtoclosure(closure2114, var_IteratorExhausted);
  addtoclosure(closure2114, var_Collection);
  struct UserObject *uo2114 = (struct UserObject*)self;
  uo2114->data[13] = (Object)closure2114;
  Method *meth_meth_collectionsPrelude_2114_set = addmethod2pos(self, "set", &meth_collectionsPrelude_2114_set, 13);
  int argcv_meth_collectionsPrelude_2114_set[] = {0};
  meth_meth_collectionsPrelude_2114_set->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2114_set);
  meth_meth_collectionsPrelude_2114_set->definitionModule = modulename;
  meth_meth_collectionsPrelude_2114_set->definitionLine = 923;
  block_savedest(self);
  Object closure2970 = createclosure(6, "set$object(1)");
  setclosureframe(closure2970, stackframe);
  addtoclosure(closure2970, var_NoSuchObject);
  addtoclosure(closure2970, var_removed);
  addtoclosure(closure2970, var_unused);
  addtoclosure(closure2970, var_ConcurrentModification);
  addtoclosure(closure2970, var_IteratorExhausted);
  addtoclosure(closure2970, var_Collection);
  Method *meth_meth_collectionsPrelude_2114_set_object = addmethod2pos(self, "set$object(1)", &meth_collectionsPrelude_2114_set_object, 13);
  meth_meth_collectionsPrelude_2114_set_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_2114_set_object->definitionLine = 923;
// compiled method node returning  (depth = 1)
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dictionary"
  block_savedest(self);
  Object closure2971 = createclosure(7, "dictionary");
  setclosureframe(closure2971, stackframe);
  addtoclosure(closure2971, var_removed);
  addtoclosure(closure2971, var_unused);
  addtoclosure(closure2971, var_binding);
  addtoclosure(closure2971, var_NoSuchObject);
  addtoclosure(closure2971, var_ConcurrentModification);
  addtoclosure(closure2971, var_IteratorExhausted);
  addtoclosure(closure2971, var_ComparableToDictionary);
  struct UserObject *uo2971 = (struct UserObject*)self;
  uo2971->data[14] = (Object)closure2971;
  Method *meth_meth_collectionsPrelude_2971_dictionary = addmethod2pos(self, "dictionary", &meth_collectionsPrelude_2971_dictionary, 14);
  int argcv_meth_collectionsPrelude_2971_dictionary[] = {0};
  meth_meth_collectionsPrelude_2971_dictionary->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_2971_dictionary);
  meth_meth_collectionsPrelude_2971_dictionary->definitionModule = modulename;
  meth_meth_collectionsPrelude_2971_dictionary->definitionLine = 1247;
  block_savedest(self);
  Object closure4393 = createclosure(7, "dictionary$object(1)");
  setclosureframe(closure4393, stackframe);
  addtoclosure(closure4393, var_removed);
  addtoclosure(closure4393, var_unused);
  addtoclosure(closure4393, var_binding);
  addtoclosure(closure4393, var_NoSuchObject);
  addtoclosure(closure4393, var_ConcurrentModification);
  addtoclosure(closure4393, var_IteratorExhausted);
  addtoclosure(closure4393, var_ComparableToDictionary);
  Method *meth_meth_collectionsPrelude_2971_dictionary_object = addmethod2pos(self, "dictionary$object(1)", &meth_collectionsPrelude_2971_dictionary_object, 14);
  meth_meth_collectionsPrelude_2971_dictionary_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_2971_dictionary_object->definitionLine = 1247;
// compiled method node returning  (depth = 1)
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "range"
  block_savedest(self);
  Object closure4394 = createclosure(4, "range");
  setclosureframe(closure4394, stackframe);
  addtoclosure(closure4394, var_Number);
  addtoclosure(closure4394, var_RequestError);
  addtoclosure(closure4394, var_IteratorExhausted);
  addtoclosure(closure4394, var_BoundsError);
  struct UserObject *uo4394 = (struct UserObject*)self;
  uo4394->data[15] = (Object)closure4394;
  Method *meth_meth_collectionsPrelude_4394_range = addmethod2pos(self, "range", &meth_collectionsPrelude_4394_range, 15);
  int argcv_meth_collectionsPrelude_4394_range[] = {0};
  meth_meth_collectionsPrelude_4394_range->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_4394_range);
  meth_meth_collectionsPrelude_4394_range->definitionModule = modulename;
  meth_meth_collectionsPrelude_4394_range->definitionLine = 1640;
  block_savedest(self);
  Object closure5335 = createclosure(4, "range$object(1)");
  setclosureframe(closure5335, stackframe);
  addtoclosure(closure5335, var_Number);
  addtoclosure(closure5335, var_RequestError);
  addtoclosure(closure5335, var_IteratorExhausted);
  addtoclosure(closure5335, var_BoundsError);
  Method *meth_meth_collectionsPrelude_4394_range_object = addmethod2pos(self, "range$object(1)", &meth_collectionsPrelude_4394_range_object, 15);
  meth_meth_collectionsPrelude_4394_range_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_4394_range_object->definitionLine = 1640;
// compiled method node returning  (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5336 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5337 == NULL) {
    strlit5337 = alloc_String("BoundsError");
    gc_root(strlit5337);
  }
// compiled string node returning strlit5337 (depth = 3)
  gc_frame_newslot(strlit5337);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5338 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5339 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5338);
// compiled member node returning call5339 (depth = 3)
  params[0] = strlit5337;
  partcv[0] = 1;
  Object call5340 = callmethodflags(call5339, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5336);
// compiled call node returning call5340 (depth = 2)
  *var_BoundsError = call5340;
  if (call5340 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "BoundsError"
  block_savedest(self);
  Object closure5341 = createclosure(1, "BoundsError");
  setclosureframe(closure5341, stackframe);
  addtoclosure(closure5341, var_BoundsError);
  struct UserObject *uo5341 = (struct UserObject*)self;
  uo5341->data[16] = (Object)closure5341;
  Method *meth_meth_collectionsPrelude_5341_BoundsError = addmethod2pos(self, "BoundsError", &meth_collectionsPrelude_5341_BoundsError, 16);
  int argcv_meth_collectionsPrelude_5341_BoundsError[] = {0};
  meth_meth_collectionsPrelude_5341_BoundsError->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5341_BoundsError);
  meth_meth_collectionsPrelude_5341_BoundsError->definitionModule = modulename;
  meth_meth_collectionsPrelude_5341_BoundsError->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5342 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5343 == NULL) {
    strlit5343 = alloc_String("IteratorExhausted");
    gc_root(strlit5343);
  }
// compiled string node returning strlit5343 (depth = 3)
  gc_frame_newslot(strlit5343);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5344 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5345 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5344);
// compiled member node returning call5345 (depth = 3)
  params[0] = strlit5343;
  partcv[0] = 1;
  Object call5346 = callmethodflags(call5345, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5342);
// compiled call node returning call5346 (depth = 2)
  *var_IteratorExhausted = call5346;
  if (call5346 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "IteratorExhausted"
  block_savedest(self);
  Object closure5347 = createclosure(1, "IteratorExhausted");
  setclosureframe(closure5347, stackframe);
  addtoclosure(closure5347, var_IteratorExhausted);
  struct UserObject *uo5347 = (struct UserObject*)self;
  uo5347->data[17] = (Object)closure5347;
  Method *meth_meth_collectionsPrelude_5347_IteratorExhausted = addmethod2pos(self, "IteratorExhausted", &meth_collectionsPrelude_5347_IteratorExhausted, 17);
  int argcv_meth_collectionsPrelude_5347_IteratorExhausted[] = {0};
  meth_meth_collectionsPrelude_5347_IteratorExhausted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5347_IteratorExhausted);
  meth_meth_collectionsPrelude_5347_IteratorExhausted->definitionModule = modulename;
  meth_meth_collectionsPrelude_5347_IteratorExhausted->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5348 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5349 == NULL) {
    strlit5349 = alloc_String("SubobjectResponsibility");
    gc_root(strlit5349);
  }
// compiled string node returning strlit5349 (depth = 3)
  gc_frame_newslot(strlit5349);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5350 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5351 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5350);
// compiled member node returning call5351 (depth = 3)
  params[0] = strlit5349;
  partcv[0] = 1;
  Object call5352 = callmethodflags(call5351, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5348);
// compiled call node returning call5352 (depth = 2)
  *var_SubobjectResponsibility = call5352;
  if (call5352 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SubobjectResponsibility"
  block_savedest(self);
  Object closure5353 = createclosure(1, "SubobjectResponsibility");
  setclosureframe(closure5353, stackframe);
  addtoclosure(closure5353, var_SubobjectResponsibility);
  struct UserObject *uo5353 = (struct UserObject*)self;
  uo5353->data[18] = (Object)closure5353;
  Method *meth_meth_collectionsPrelude_5353_SubobjectResponsibility = addmethod2pos(self, "SubobjectResponsibility", &meth_collectionsPrelude_5353_SubobjectResponsibility, 18);
  int argcv_meth_collectionsPrelude_5353_SubobjectResponsibility[] = {0};
  meth_meth_collectionsPrelude_5353_SubobjectResponsibility->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5353_SubobjectResponsibility);
  meth_meth_collectionsPrelude_5353_SubobjectResponsibility->definitionModule = modulename;
  meth_meth_collectionsPrelude_5353_SubobjectResponsibility->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5354 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5355 == NULL) {
    strlit5355 = alloc_String("NoSuchObject");
    gc_root(strlit5355);
  }
// compiled string node returning strlit5355 (depth = 3)
  gc_frame_newslot(strlit5355);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5356 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5357 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5356);
// compiled member node returning call5357 (depth = 3)
  params[0] = strlit5355;
  partcv[0] = 1;
  Object call5358 = callmethodflags(call5357, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5354);
// compiled call node returning call5358 (depth = 2)
  *var_NoSuchObject = call5358;
  if (call5358 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "NoSuchObject"
  block_savedest(self);
  Object closure5359 = createclosure(1, "NoSuchObject");
  setclosureframe(closure5359, stackframe);
  addtoclosure(closure5359, var_NoSuchObject);
  struct UserObject *uo5359 = (struct UserObject*)self;
  uo5359->data[19] = (Object)closure5359;
  Method *meth_meth_collectionsPrelude_5359_NoSuchObject = addmethod2pos(self, "NoSuchObject", &meth_collectionsPrelude_5359_NoSuchObject, 19);
  int argcv_meth_collectionsPrelude_5359_NoSuchObject[] = {0};
  meth_meth_collectionsPrelude_5359_NoSuchObject->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5359_NoSuchObject);
  meth_meth_collectionsPrelude_5359_NoSuchObject->definitionModule = modulename;
  meth_meth_collectionsPrelude_5359_NoSuchObject->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5360 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5361 == NULL) {
    strlit5361 = alloc_String("RequestError");
    gc_root(strlit5361);
  }
// compiled string node returning strlit5361 (depth = 3)
  gc_frame_newslot(strlit5361);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5362 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5363 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5362);
// compiled member node returning call5363 (depth = 3)
  params[0] = strlit5361;
  partcv[0] = 1;
  Object call5364 = callmethodflags(call5363, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5360);
// compiled call node returning call5364 (depth = 2)
  *var_RequestError = call5364;
  if (call5364 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "RequestError"
  block_savedest(self);
  Object closure5365 = createclosure(1, "RequestError");
  setclosureframe(closure5365, stackframe);
  addtoclosure(closure5365, var_RequestError);
  struct UserObject *uo5365 = (struct UserObject*)self;
  uo5365->data[20] = (Object)closure5365;
  Method *meth_meth_collectionsPrelude_5365_RequestError = addmethod2pos(self, "RequestError", &meth_collectionsPrelude_5365_RequestError, 20);
  int argcv_meth_collectionsPrelude_5365_RequestError[] = {0};
  meth_meth_collectionsPrelude_5365_RequestError->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5365_RequestError);
  meth_meth_collectionsPrelude_5365_RequestError->definitionModule = modulename;
  meth_meth_collectionsPrelude_5365_RequestError->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5366 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5367 == NULL) {
    strlit5367 = alloc_String("ConcurrentModification");
    gc_root(strlit5367);
  }
// compiled string node returning strlit5367 (depth = 3)
  gc_frame_newslot(strlit5367);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5368 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5369 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5368);
// compiled member node returning call5369 (depth = 3)
  params[0] = strlit5367;
  partcv[0] = 1;
  Object call5370 = callmethodflags(call5369, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5366);
// compiled call node returning call5370 (depth = 2)
  *var_ConcurrentModification = call5370;
  if (call5370 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ConcurrentModification"
  block_savedest(self);
  Object closure5371 = createclosure(1, "ConcurrentModification");
  setclosureframe(closure5371, stackframe);
  addtoclosure(closure5371, var_ConcurrentModification);
  struct UserObject *uo5371 = (struct UserObject*)self;
  uo5371->data[21] = (Object)closure5371;
  Method *meth_meth_collectionsPrelude_5371_ConcurrentModification = addmethod2pos(self, "ConcurrentModification", &meth_collectionsPrelude_5371_ConcurrentModification, 21);
  int argcv_meth_collectionsPrelude_5371_ConcurrentModification[] = {0};
  meth_meth_collectionsPrelude_5371_ConcurrentModification->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5371_ConcurrentModification);
  meth_meth_collectionsPrelude_5371_ConcurrentModification->definitionModule = modulename;
  meth_meth_collectionsPrelude_5371_ConcurrentModification->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5372 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5373 == NULL) {
    strlit5373 = alloc_String("SizeUnknown");
    gc_root(strlit5373);
  }
// compiled string node returning strlit5373 (depth = 3)
  gc_frame_newslot(strlit5373);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5374 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5375 = callmethodflags(prelude, "Exception", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5374);
// compiled member node returning call5375 (depth = 3)
  params[0] = strlit5373;
  partcv[0] = 1;
  Object call5376 = callmethodflags(call5375, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5372);
// compiled call node returning call5376 (depth = 2)
  *var_SizeUnknown = call5376;
  if (call5376 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SizeUnknown"
  block_savedest(self);
  Object closure5377 = createclosure(1, "SizeUnknown");
  setclosureframe(closure5377, stackframe);
  addtoclosure(closure5377, var_SizeUnknown);
  struct UserObject *uo5377 = (struct UserObject*)self;
  uo5377->data[22] = (Object)closure5377;
  Method *meth_meth_collectionsPrelude_5377_SizeUnknown = addmethod2pos(self, "SizeUnknown", &meth_collectionsPrelude_5377_SizeUnknown, 22);
  int argcv_meth_collectionsPrelude_5377_SizeUnknown[] = {0};
  meth_meth_collectionsPrelude_5377_SizeUnknown->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5377_SizeUnknown);
  meth_meth_collectionsPrelude_5377_SizeUnknown->definitionModule = modulename;
  meth_meth_collectionsPrelude_5377_SizeUnknown->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Function0
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type5379 = alloc_Type("Function0", 1);
  add_Method((ClassData)type5379, "apply", NULL);
// compiled typeliteral node returning type5379 (depth = 2)
  *var_Function0 = type5379;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Function0"
  block_savedest(self);
  Object closure5380 = createclosure(1, "Function0");
  setclosureframe(closure5380, stackframe);
  addtoclosure(closure5380, var_Function0);
  struct UserObject *uo5380 = (struct UserObject*)self;
  uo5380->data[23] = (Object)closure5380;
  Method *meth_meth_collectionsPrelude_5380_Function0 = addmethod2pos(self, "Function0", &meth_collectionsPrelude_5380_Function0, 23);
  int argcv_meth_collectionsPrelude_5380_Function0[] = {0};
  meth_meth_collectionsPrelude_5380_Function0->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5380_Function0);
  meth_meth_collectionsPrelude_5380_Function0->definitionModule = modulename;
  meth_meth_collectionsPrelude_5380_Function0->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Function1
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type5382 = alloc_Type("Function1", 1);
  add_Method((ClassData)type5382, "apply(1)", NULL);
// compiled typeliteral node returning type5382 (depth = 2)
  *var_Function1 = type5382;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Function1"
  block_savedest(self);
  Object closure5383 = createclosure(1, "Function1");
  setclosureframe(closure5383, stackframe);
  addtoclosure(closure5383, var_Function1);
  struct UserObject *uo5383 = (struct UserObject*)self;
  uo5383->data[24] = (Object)closure5383;
  Method *meth_meth_collectionsPrelude_5383_Function1 = addmethod2pos(self, "Function1", &meth_collectionsPrelude_5383_Function1, 24);
  int argcv_meth_collectionsPrelude_5383_Function1[] = {0};
  meth_meth_collectionsPrelude_5383_Function1->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5383_Function1);
  meth_meth_collectionsPrelude_5383_Function1->definitionModule = modulename;
  meth_meth_collectionsPrelude_5383_Function1->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Function2
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type5385 = alloc_Type("Function2", 1);
  add_Method((ClassData)type5385, "apply(2)", NULL);
// compiled typeliteral node returning type5385 (depth = 2)
  *var_Function2 = type5385;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Function2"
  block_savedest(self);
  Object closure5386 = createclosure(1, "Function2");
  setclosureframe(closure5386, stackframe);
  addtoclosure(closure5386, var_Function2);
  struct UserObject *uo5386 = (struct UserObject*)self;
  uo5386->data[25] = (Object)closure5386;
  Method *meth_meth_collectionsPrelude_5386_Function2 = addmethod2pos(self, "Function2", &meth_collectionsPrelude_5386_Function2, 25);
  int argcv_meth_collectionsPrelude_5386_Function2[] = {0};
  meth_meth_collectionsPrelude_5386_Function2->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5386_Function2);
  meth_meth_collectionsPrelude_5386_Function2->definitionModule = modulename;
  meth_meth_collectionsPrelude_5386_Function2->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Procedure0
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Function0 (depth = 2)
  *var_Procedure0 = *var_Function0;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Procedure0"
  block_savedest(self);
  Object closure5388 = createclosure(1, "Procedure0");
  setclosureframe(closure5388, stackframe);
  addtoclosure(closure5388, var_Procedure0);
  struct UserObject *uo5388 = (struct UserObject*)self;
  uo5388->data[26] = (Object)closure5388;
  Method *meth_meth_collectionsPrelude_5388_Procedure0 = addmethod2pos(self, "Procedure0", &meth_collectionsPrelude_5388_Procedure0, 26);
  int argcv_meth_collectionsPrelude_5388_Procedure0[] = {0};
  meth_meth_collectionsPrelude_5388_Procedure0->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5388_Procedure0);
  meth_meth_collectionsPrelude_5388_Procedure0->definitionModule = modulename;
  meth_meth_collectionsPrelude_5388_Procedure0->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Procedure1
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Function1 (depth = 2)
  *var_Procedure1 = *var_Function1;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Procedure1"
  block_savedest(self);
  Object closure5390 = createclosure(1, "Procedure1");
  setclosureframe(closure5390, stackframe);
  addtoclosure(closure5390, var_Procedure1);
  struct UserObject *uo5390 = (struct UserObject*)self;
  uo5390->data[27] = (Object)closure5390;
  Method *meth_meth_collectionsPrelude_5390_Procedure1 = addmethod2pos(self, "Procedure1", &meth_collectionsPrelude_5390_Procedure1, 27);
  int argcv_meth_collectionsPrelude_5390_Procedure1[] = {0};
  meth_meth_collectionsPrelude_5390_Procedure1->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5390_Procedure1);
  meth_meth_collectionsPrelude_5390_Procedure1->definitionModule = modulename;
  meth_meth_collectionsPrelude_5390_Procedure1->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Procedure2
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Function1 (depth = 2)
  *var_Procedure2 = *var_Function1;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Procedure2"
  block_savedest(self);
  Object closure5392 = createclosure(1, "Procedure2");
  setclosureframe(closure5392, stackframe);
  addtoclosure(closure5392, var_Procedure2);
  struct UserObject *uo5392 = (struct UserObject*)self;
  uo5392->data[28] = (Object)closure5392;
  Method *meth_meth_collectionsPrelude_5392_Procedure2 = addmethod2pos(self, "Procedure2", &meth_collectionsPrelude_5392_Procedure2, 28);
  int argcv_meth_collectionsPrelude_5392_Procedure2[] = {0};
  meth_meth_collectionsPrelude_5392_Procedure2->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5392_Procedure2);
  meth_meth_collectionsPrelude_5392_Procedure2->definitionModule = modulename;
  meth_meth_collectionsPrelude_5392_Procedure2->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Predicate1
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Function1 (depth = 2)
  *var_Predicate1 = *var_Function1;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Predicate1"
  block_savedest(self);
  Object closure5394 = createclosure(1, "Predicate1");
  setclosureframe(closure5394, stackframe);
  addtoclosure(closure5394, var_Predicate1);
  struct UserObject *uo5394 = (struct UserObject*)self;
  uo5394->data[29] = (Object)closure5394;
  Method *meth_meth_collectionsPrelude_5394_Predicate1 = addmethod2pos(self, "Predicate1", &meth_collectionsPrelude_5394_Predicate1, 29);
  int argcv_meth_collectionsPrelude_5394_Predicate1[] = {0};
  meth_meth_collectionsPrelude_5394_Predicate1->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5394_Predicate1);
  meth_meth_collectionsPrelude_5394_Predicate1->definitionModule = modulename;
  meth_meth_collectionsPrelude_5394_Predicate1->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SelfType
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SelfType = *var_Unknown;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SelfType"
  block_savedest(self);
  Object closure5396 = createclosure(1, "SelfType");
  setclosureframe(closure5396, stackframe);
  addtoclosure(closure5396, var_SelfType);
  struct UserObject *uo5396 = (struct UserObject*)self;
  uo5396->data[30] = (Object)closure5396;
  Method *meth_meth_collectionsPrelude_5396_SelfType = addmethod2pos(self, "SelfType", &meth_collectionsPrelude_5396_SelfType, 30);
  int argcv_meth_collectionsPrelude_5396_SelfType[] = {0};
  meth_meth_collectionsPrelude_5396_SelfType->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5396_SelfType);
  meth_meth_collectionsPrelude_5396_SelfType->definitionModule = modulename;
  meth_meth_collectionsPrelude_5396_SelfType->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Collection
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
  Object type5399 = alloc_Type("‹anon›", 12);
  add_Method((ClassData)type5399, "iterator", NULL);
  add_Method((ClassData)type5399, "isEmpty", NULL);
  add_Method((ClassData)type5399, "size", NULL);
  add_Method((ClassData)type5399, "sizeIfUnknown(1)", NULL);
  add_Method((ClassData)type5399, "==(1)", NULL);
  add_Method((ClassData)type5399, "first", NULL);
  add_Method((ClassData)type5399, "do(1)", NULL);
  add_Method((ClassData)type5399, "do(1)separatedBy(1)", NULL);
  add_Method((ClassData)type5399, "++(1)", NULL);
  add_Method((ClassData)type5399, "fold(1)startingWith(1)", NULL);
  add_Method((ClassData)type5399, "map(1)", NULL);
  add_Method((ClassData)type5399, "filter(1)", NULL);
// compiled typeliteral node returning type5399 (depth = 3)
  int op_slot_right_5398 = gc_frame_newslot(type5399);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Object (depth = 3)
  int op_slot_left_5398 = gc_frame_newslot(*var_Object);
  params[0] = type5399;
  partcv[0] = 1;
  Object opresult5401 = callmethod(*var_Object, "&(1)", 1, partcv, params);
// compiled op node returning opresult5401 (depth = 2)
  *var_Collection = opresult5401;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Collection"
  block_savedest(self);
  Object closure5402 = createclosure(1, "Collection");
  setclosureframe(closure5402, stackframe);
  addtoclosure(closure5402, var_Collection);
  struct UserObject *uo5402 = (struct UserObject*)self;
  uo5402->data[31] = (Object)closure5402;
  Method *meth_meth_collectionsPrelude_5402_Collection = addmethod2pos(self, "Collection", &meth_collectionsPrelude_5402_Collection, 31);
  int argcv_meth_collectionsPrelude_5402_Collection[] = {0};
  meth_meth_collectionsPrelude_5402_Collection->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5402_Collection);
  meth_meth_collectionsPrelude_5402_Collection->definitionModule = modulename;
  meth_meth_collectionsPrelude_5402_Collection->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Expandable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
  Object type5405 = alloc_Type("‹anon›", 2);
  add_Method((ClassData)type5405, "add(1)", NULL);
  add_Method((ClassData)type5405, "addAll(1)", NULL);
// compiled typeliteral node returning type5405 (depth = 3)
  int op_slot_right_5404 = gc_frame_newslot(type5405);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5404 = gc_frame_newslot(*var_Collection);
  params[0] = type5405;
  partcv[0] = 1;
  Object opresult5407 = callmethod(*var_Collection, "&(1)", 1, partcv, params);
// compiled op node returning opresult5407 (depth = 2)
  *var_Expandable = opresult5407;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Expandable"
  block_savedest(self);
  Object closure5408 = createclosure(1, "Expandable");
  setclosureframe(closure5408, stackframe);
  addtoclosure(closure5408, var_Expandable);
  struct UserObject *uo5408 = (struct UserObject*)self;
  uo5408->data[32] = (Object)closure5408;
  Method *meth_meth_collectionsPrelude_5408_Expandable = addmethod2pos(self, "Expandable", &meth_collectionsPrelude_5408_Expandable, 32);
  int argcv_meth_collectionsPrelude_5408_Expandable[] = {0};
  meth_meth_collectionsPrelude_5408_Expandable->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5408_Expandable);
  meth_meth_collectionsPrelude_5408_Expandable->definitionModule = modulename;
  meth_meth_collectionsPrelude_5408_Expandable->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Iterable
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Collection (depth = 2)
  *var_Iterable = *var_Collection;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Iterable"
  block_savedest(self);
  Object closure5410 = createclosure(1, "Iterable");
  setclosureframe(closure5410, stackframe);
  addtoclosure(closure5410, var_Iterable);
  struct UserObject *uo5410 = (struct UserObject*)self;
  uo5410->data[33] = (Object)closure5410;
  Method *meth_meth_collectionsPrelude_5410_Iterable = addmethod2pos(self, "Iterable", &meth_collectionsPrelude_5410_Iterable, 33);
  int argcv_meth_collectionsPrelude_5410_Iterable[] = {0};
  meth_meth_collectionsPrelude_5410_Iterable->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5410_Iterable);
  meth_meth_collectionsPrelude_5410_Iterable->definitionModule = modulename;
  meth_meth_collectionsPrelude_5410_Iterable->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Enumerable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
  Object type5413 = alloc_Type("‹anon›", 6);
  add_Method((ClassData)type5413, "values", NULL);
  add_Method((ClassData)type5413, "asDictionary", NULL);
  add_Method((ClassData)type5413, "keysAndValuesDo(1)", NULL);
  add_Method((ClassData)type5413, "into(1)", NULL);
  add_Method((ClassData)type5413, "sortedBy(1)", NULL);
  add_Method((ClassData)type5413, "sorted", NULL);
// compiled typeliteral node returning type5413 (depth = 3)
  int op_slot_right_5412 = gc_frame_newslot(type5413);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5412 = gc_frame_newslot(*var_Collection);
  params[0] = type5413;
  partcv[0] = 1;
  Object opresult5415 = callmethod(*var_Collection, "&(1)", 1, partcv, params);
// compiled op node returning opresult5415 (depth = 2)
  *var_Enumerable = opresult5415;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Enumerable"
  block_savedest(self);
  Object closure5416 = createclosure(1, "Enumerable");
  setclosureframe(closure5416, stackframe);
  addtoclosure(closure5416, var_Enumerable);
  struct UserObject *uo5416 = (struct UserObject*)self;
  uo5416->data[34] = (Object)closure5416;
  Method *meth_meth_collectionsPrelude_5416_Enumerable = addmethod2pos(self, "Enumerable", &meth_collectionsPrelude_5416_Enumerable, 34);
  int argcv_meth_collectionsPrelude_5416_Enumerable[] = {0};
  meth_meth_collectionsPrelude_5416_Enumerable->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5416_Enumerable);
  meth_meth_collectionsPrelude_5416_Enumerable->definitionModule = modulename;
  meth_meth_collectionsPrelude_5416_Enumerable->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Sequence
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
  Object type5419 = alloc_Type("‹anon›", 13);
  add_Method((ClassData)type5419, "size", NULL);
  add_Method((ClassData)type5419, "at(1)", NULL);
  add_Method((ClassData)type5419, "indices", NULL);
  add_Method((ClassData)type5419, "keys", NULL);
  add_Method((ClassData)type5419, "second", NULL);
  add_Method((ClassData)type5419, "third", NULL);
  add_Method((ClassData)type5419, "fourth", NULL);
  add_Method((ClassData)type5419, "fifth", NULL);
  add_Method((ClassData)type5419, "last", NULL);
  add_Method((ClassData)type5419, "indexOf(1)ifAbsent(1)", NULL);
  add_Method((ClassData)type5419, "indexOf(1)", NULL);
  add_Method((ClassData)type5419, "contains(1)", NULL);
  add_Method((ClassData)type5419, "reversed", NULL);
// compiled typeliteral node returning type5419 (depth = 3)
  int op_slot_right_5418 = gc_frame_newslot(type5419);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Enumerable (depth = 3)
  int op_slot_left_5418 = gc_frame_newslot(*var_Enumerable);
  params[0] = type5419;
  partcv[0] = 1;
  Object opresult5421 = callmethod(*var_Enumerable, "&(1)", 1, partcv, params);
// compiled op node returning opresult5421 (depth = 2)
  *var_Sequence = opresult5421;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Sequence"
  block_savedest(self);
  Object closure5422 = createclosure(1, "Sequence");
  setclosureframe(closure5422, stackframe);
  addtoclosure(closure5422, var_Sequence);
  struct UserObject *uo5422 = (struct UserObject*)self;
  uo5422->data[35] = (Object)closure5422;
  Method *meth_meth_collectionsPrelude_5422_Sequence = addmethod2pos(self, "Sequence", &meth_collectionsPrelude_5422_Sequence, 35);
  int argcv_meth_collectionsPrelude_5422_Sequence[] = {0};
  meth_meth_collectionsPrelude_5422_Sequence->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5422_Sequence);
  meth_meth_collectionsPrelude_5422_Sequence->definitionModule = modulename;
  meth_meth_collectionsPrelude_5422_Sequence->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl List
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
  Object type5425 = alloc_Type("‹anon›", 22);
  add_Method((ClassData)type5425, "add(1)", NULL);
  add_Method((ClassData)type5425, "addAll(1)", NULL);
  add_Method((ClassData)type5425, "addFirst(1)", NULL);
  add_Method((ClassData)type5425, "addAllFirst(1)", NULL);
  add_Method((ClassData)type5425, "addLast(1)", NULL);
  add_Method((ClassData)type5425, "at(1)put(1)", NULL);
  add_Method((ClassData)type5425, "clear", NULL);
  add_Method((ClassData)type5425, "removeFirst", NULL);
  add_Method((ClassData)type5425, "removeAt(1)", NULL);
  add_Method((ClassData)type5425, "removeLast", NULL);
  add_Method((ClassData)type5425, "remove(1)", NULL);
  add_Method((ClassData)type5425, "remove(1)ifAbsent(1)", NULL);
  add_Method((ClassData)type5425, "removeAll(1)", NULL);
  add_Method((ClassData)type5425, "removeAll(1)ifAbsent(1)", NULL);
  add_Method((ClassData)type5425, "pop", NULL);
  add_Method((ClassData)type5425, "++(1)", NULL);
  add_Method((ClassData)type5425, "addAll(1)", NULL);
  add_Method((ClassData)type5425, "copy", NULL);
  add_Method((ClassData)type5425, "sort", NULL);
  add_Method((ClassData)type5425, "sortBy(1)", NULL);
  add_Method((ClassData)type5425, "reverse", NULL);
  add_Method((ClassData)type5425, "reversed", NULL);
// compiled typeliteral node returning type5425 (depth = 3)
  int op_slot_right_5424 = gc_frame_newslot(type5425);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Sequence (depth = 3)
  int op_slot_left_5424 = gc_frame_newslot(*var_Sequence);
  params[0] = type5425;
  partcv[0] = 1;
  Object opresult5427 = callmethod(*var_Sequence, "&(1)", 1, partcv, params);
// compiled op node returning opresult5427 (depth = 2)
  *var_List = opresult5427;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "List"
  block_savedest(self);
  Object closure5428 = createclosure(1, "List");
  setclosureframe(closure5428, stackframe);
  addtoclosure(closure5428, var_List);
  struct UserObject *uo5428 = (struct UserObject*)self;
  uo5428->data[36] = (Object)closure5428;
  Method *meth_meth_collectionsPrelude_5428_List = addmethod2pos(self, "List", &meth_collectionsPrelude_5428_List, 36);
  int argcv_meth_collectionsPrelude_5428_List[] = {0};
  meth_meth_collectionsPrelude_5428_List->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5428_List);
  meth_meth_collectionsPrelude_5428_List->definitionModule = modulename;
  meth_meth_collectionsPrelude_5428_List->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Set
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
  Object type5431 = alloc_Type("‹anon›", 18);
  add_Method((ClassData)type5431, "size", NULL);
  add_Method((ClassData)type5431, "add(1)", NULL);
  add_Method((ClassData)type5431, "addAll(1)", NULL);
  add_Method((ClassData)type5431, "remove(1)", NULL);
  add_Method((ClassData)type5431, "remove(1)ifAbsent(1)", NULL);
  add_Method((ClassData)type5431, "clear", NULL);
  add_Method((ClassData)type5431, "includes(1)", NULL);
  add_Method((ClassData)type5431, "find(1)ifNone(1)", NULL);
  add_Method((ClassData)type5431, "copy", NULL);
  add_Method((ClassData)type5431, "contains(1)", NULL);
  add_Method((ClassData)type5431, "**(1)", NULL);
  add_Method((ClassData)type5431, "--(1)", NULL);
  add_Method((ClassData)type5431, "++(1)", NULL);
  add_Method((ClassData)type5431, "isSubset(1)", NULL);
  add_Method((ClassData)type5431, "isSuperset(1)", NULL);
  add_Method((ClassData)type5431, "removeAll(1)", NULL);
  add_Method((ClassData)type5431, "removeAll(1)ifAbsent(1)", NULL);
  add_Method((ClassData)type5431, "into(1)", NULL);
// compiled typeliteral node returning type5431 (depth = 3)
  int op_slot_right_5430 = gc_frame_newslot(type5431);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5430 = gc_frame_newslot(*var_Collection);
  params[0] = type5431;
  partcv[0] = 1;
  Object opresult5433 = callmethod(*var_Collection, "&(1)", 1, partcv, params);
// compiled op node returning opresult5433 (depth = 2)
  *var_Set = opresult5433;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Set"
  block_savedest(self);
  Object closure5434 = createclosure(1, "Set");
  setclosureframe(closure5434, stackframe);
  addtoclosure(closure5434, var_Set);
  struct UserObject *uo5434 = (struct UserObject*)self;
  uo5434->data[37] = (Object)closure5434;
  Method *meth_meth_collectionsPrelude_5434_Set = addmethod2pos(self, "Set", &meth_collectionsPrelude_5434_Set, 37);
  int argcv_meth_collectionsPrelude_5434_Set[] = {0};
  meth_meth_collectionsPrelude_5434_Set->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5434_Set);
  meth_meth_collectionsPrelude_5434_Set->definitionModule = modulename;
  meth_meth_collectionsPrelude_5434_Set->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Dictionary
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
  Object type5437 = alloc_Type("‹anon›", 23);
  add_Method((ClassData)type5437, "size", NULL);
  add_Method((ClassData)type5437, "containsKey(1)", NULL);
  add_Method((ClassData)type5437, "containsValue(1)", NULL);
  add_Method((ClassData)type5437, "contains(1)", NULL);
  add_Method((ClassData)type5437, "at(1)ifAbsent(1)", NULL);
  add_Method((ClassData)type5437, "at(1)put(1)", NULL);
  add_Method((ClassData)type5437, "at(1)", NULL);
  add_Method((ClassData)type5437, "removeAllKeys(1)", NULL);
  add_Method((ClassData)type5437, "removeKey(1)", NULL);
  add_Method((ClassData)type5437, "removeAllValues(1)", NULL);
  add_Method((ClassData)type5437, "removeValue(1)", NULL);
  add_Method((ClassData)type5437, "clear", NULL);
  add_Method((ClassData)type5437, "keys", NULL);
  add_Method((ClassData)type5437, "values", NULL);
  add_Method((ClassData)type5437, "bindings", NULL);
  add_Method((ClassData)type5437, "keysAndValuesDo(1)", NULL);
  add_Method((ClassData)type5437, "keysDo(1)", NULL);
  add_Method((ClassData)type5437, "valuesDo(1)", NULL);
  add_Method((ClassData)type5437, "==(1)", NULL);
  add_Method((ClassData)type5437, "copy", NULL);
  add_Method((ClassData)type5437, "++(1)", NULL);
  add_Method((ClassData)type5437, "--(1)", NULL);
  add_Method((ClassData)type5437, "asDictionary", NULL);
// compiled typeliteral node returning type5437 (depth = 3)
  int op_slot_right_5436 = gc_frame_newslot(type5437);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5436 = gc_frame_newslot(*var_Collection);
  params[0] = type5437;
  partcv[0] = 1;
  Object opresult5439 = callmethod(*var_Collection, "&(1)", 1, partcv, params);
// compiled op node returning opresult5439 (depth = 2)
  *var_Dictionary = opresult5439;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Dictionary"
  block_savedest(self);
  Object closure5440 = createclosure(1, "Dictionary");
  setclosureframe(closure5440, stackframe);
  addtoclosure(closure5440, var_Dictionary);
  struct UserObject *uo5440 = (struct UserObject*)self;
  uo5440->data[38] = (Object)closure5440;
  Method *meth_meth_collectionsPrelude_5440_Dictionary = addmethod2pos(self, "Dictionary", &meth_collectionsPrelude_5440_Dictionary, 38);
  int argcv_meth_collectionsPrelude_5440_Dictionary[] = {0};
  meth_meth_collectionsPrelude_5440_Dictionary->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5440_Dictionary);
  meth_meth_collectionsPrelude_5440_Dictionary->definitionModule = modulename;
  meth_meth_collectionsPrelude_5440_Dictionary->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Iterator
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type5442 = alloc_Type("Iterator", 2);
  add_Method((ClassData)type5442, "hasNext", NULL);
  add_Method((ClassData)type5442, "next", NULL);
// compiled typeliteral node returning type5442 (depth = 2)
  *var_Iterator = type5442;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Iterator"
  block_savedest(self);
  Object closure5443 = createclosure(1, "Iterator");
  setclosureframe(closure5443, stackframe);
  addtoclosure(closure5443, var_Iterator);
  struct UserObject *uo5443 = (struct UserObject*)self;
  uo5443->data[39] = (Object)closure5443;
  Method *meth_meth_collectionsPrelude_5443_Iterator = addmethod2pos(self, "Iterator", &meth_collectionsPrelude_5443_Iterator, 39);
  int argcv_meth_collectionsPrelude_5443_Iterator[] = {0};
  meth_meth_collectionsPrelude_5443_Iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5443_Iterator);
  meth_meth_collectionsPrelude_5443_Iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_5443_Iterator->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5444 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5444 = alloc_userobj2(16,17, objclass5444);
  gc_frame_newslot(obj5444);
  if (objclass5444 == NULL) {
    glfree(obj5444->class->name);
    obj5444->class->name = "emptySequence";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5444, self, 0);
  addmethodreal(obj5444,"outer", &reader_collectionsPrelude_outer_5445);
  Object oldself5444 = self;
  struct StackFrameObject *oldstackframe5444 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5444);
  gc_frame_newslot((Object)stackframe);
  self = obj5444;
  Object *oldselfslot5444 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5444 = (*(struct UserObject *)self).data[0], lowerouter5444 = thisouter5444;
  if (inheritingObject5444) {
    struct UserObject *inho5444 = (struct UserObject *)inheritingObject5444;
    while (inho5444->super != GraceDefaultObject) inho5444 = (struct UserObject *)inho5444->super;
    inho5444->super = obj5444;
    self = inheritingObject5444;
    *selfslot = self;
    lowerouter5444 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5444;
  }
// method "size"
  struct UserObject *uo5446 = (struct UserObject*)obj5444;
  uo5446->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5446_size = addmethod2pos(obj5444, "size", &meth_collectionsPrelude_5446_size, 1);
  int argcv_meth_collectionsPrelude_5446_size[] = {0};
  meth_meth_collectionsPrelude_5446_size->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5446_size);
  meth_meth_collectionsPrelude_5446_size->definitionModule = modulename;
  meth_meth_collectionsPrelude_5446_size->definitionLine = 435;
// method "isEmpty"
  struct UserObject *uo5448 = (struct UserObject*)obj5444;
  uo5448->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5448_isEmpty = addmethod2pos(obj5444, "isEmpty", &meth_collectionsPrelude_5448_isEmpty, 2);
  int argcv_meth_collectionsPrelude_5448_isEmpty[] = {0};
  meth_meth_collectionsPrelude_5448_isEmpty->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5448_isEmpty);
  meth_meth_collectionsPrelude_5448_isEmpty->definitionModule = modulename;
  meth_meth_collectionsPrelude_5448_isEmpty->definitionLine = 436;
// method "at(_)"
  block_savedest(obj5444);
  Object closure5450 = createclosure(1, "at(1)");
  setclosureframe(closure5450, stackframe);
  addtoclosure(closure5450, var_BoundsError);
  struct UserObject *uo5450 = (struct UserObject*)obj5444;
  uo5450->data[3] = (Object)closure5450;
  Method *meth_meth_collectionsPrelude_5450_at_40_1_41_ = addmethod2pos(obj5444, "at(1)", &meth_collectionsPrelude_5450_at_40_1_41_, 3);
  int argcv_meth_collectionsPrelude_5450_at_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5450_at_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5450_at_40_1_41_);
  meth_meth_collectionsPrelude_5450_at_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5450_at_40_1_41_->definitionLine = 437;
// method "keys"
  struct UserObject *uo5461 = (struct UserObject*)obj5444;
  uo5461->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5461_keys = addmethod2pos(obj5444, "keys", &meth_collectionsPrelude_5461_keys, 4);
  int argcv_meth_collectionsPrelude_5461_keys[] = {0};
  meth_meth_collectionsPrelude_5461_keys->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5461_keys);
  meth_meth_collectionsPrelude_5461_keys->definitionModule = modulename;
  meth_meth_collectionsPrelude_5461_keys->definitionLine = 438;
// method "values"
  struct UserObject *uo5462 = (struct UserObject*)obj5444;
  uo5462->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5462_values = addmethod2pos(obj5444, "values", &meth_collectionsPrelude_5462_values, 5);
  int argcv_meth_collectionsPrelude_5462_values[] = {0};
  meth_meth_collectionsPrelude_5462_values->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5462_values);
  meth_meth_collectionsPrelude_5462_values->definitionModule = modulename;
  meth_meth_collectionsPrelude_5462_values->definitionLine = 439;
// method "keysAndValuesDo(_)"
  block_savedest(obj5444);
  Object closure5463 = createclosure(1, "keysAndValuesDo(1)");
  setclosureframe(closure5463, stackframe);
  addtoclosure(closure5463, var_done);
  struct UserObject *uo5463 = (struct UserObject*)obj5444;
  uo5463->data[6] = (Object)closure5463;
  Method *meth_meth_collectionsPrelude_5463_keysAndValuesDo_40_1_41_ = addmethod2pos(obj5444, "keysAndValuesDo(1)", &meth_collectionsPrelude_5463_keysAndValuesDo_40_1_41_, 6);
  int argcv_meth_collectionsPrelude_5463_keysAndValuesDo_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5463_keysAndValuesDo_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5463_keysAndValuesDo_40_1_41_);
  meth_meth_collectionsPrelude_5463_keysAndValuesDo_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5463_keysAndValuesDo_40_1_41_->definitionLine = 440;
// method "reversed"
  struct UserObject *uo5464 = (struct UserObject*)obj5444;
  uo5464->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5464_reversed = addmethod2pos(obj5444, "reversed", &meth_collectionsPrelude_5464_reversed, 7);
  int argcv_meth_collectionsPrelude_5464_reversed[] = {0};
  meth_meth_collectionsPrelude_5464_reversed->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5464_reversed);
  meth_meth_collectionsPrelude_5464_reversed->definitionModule = modulename;
  meth_meth_collectionsPrelude_5464_reversed->definitionLine = 441;
// method "++(_)"
  struct UserObject *uo5465 = (struct UserObject*)obj5444;
  uo5465->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5465__43__43__40_1_41_ = addmethod2pos(obj5444, "++(1)", &meth_collectionsPrelude_5465__43__43__40_1_41_, 8);
  int argcv_meth_collectionsPrelude_5465__43__43__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5465__43__43__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5465__43__43__40_1_41_);
  meth_meth_collectionsPrelude_5465__43__43__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5465__43__43__40_1_41_->definitionLine = 442;
// method "asString"
  struct UserObject *uo5470 = (struct UserObject*)obj5444;
  uo5470->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5470_asString = addmethod2pos(obj5444, "asString", &meth_collectionsPrelude_5470_asString, 9);
  int argcv_meth_collectionsPrelude_5470_asString[] = {0};
  meth_meth_collectionsPrelude_5470_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5470_asString);
  meth_meth_collectionsPrelude_5470_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_5470_asString->definitionLine = 443;
// method "contains(_)"
  struct UserObject *uo5472 = (struct UserObject*)obj5444;
  uo5472->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5472_contains_40_1_41_ = addmethod2pos(obj5444, "contains(1)", &meth_collectionsPrelude_5472_contains_40_1_41_, 10);
  int argcv_meth_collectionsPrelude_5472_contains_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5472_contains_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5472_contains_40_1_41_);
  meth_meth_collectionsPrelude_5472_contains_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5472_contains_40_1_41_->definitionLine = 444;
// method "do(_)"
  block_savedest(obj5444);
  Object closure5474 = createclosure(1, "do(1)");
  setclosureframe(closure5474, stackframe);
  addtoclosure(closure5474, var_done);
  struct UserObject *uo5474 = (struct UserObject*)obj5444;
  uo5474->data[11] = (Object)closure5474;
  Method *meth_meth_collectionsPrelude_5474_do_40_1_41_ = addmethod2pos(obj5444, "do(1)", &meth_collectionsPrelude_5474_do_40_1_41_, 11);
  int argcv_meth_collectionsPrelude_5474_do_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5474_do_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5474_do_40_1_41_);
  meth_meth_collectionsPrelude_5474_do_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5474_do_40_1_41_->definitionLine = 445;
// method "==(_)"
  block_savedest(obj5444);
  Object closure5475 = createclosure(1, "==(1)");
  setclosureframe(closure5475, stackframe);
  addtoclosure(closure5475, var_Collection);
  struct UserObject *uo5475 = (struct UserObject*)obj5444;
  uo5475->data[12] = (Object)closure5475;
  Method *meth_meth_collectionsPrelude_5475__61__61__40_1_41_ = addmethod2pos(obj5444, "==(1)", &meth_collectionsPrelude_5475__61__61__40_1_41_, 12);
  int argcv_meth_collectionsPrelude_5475__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5475__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5475__61__61__40_1_41_);
  meth_meth_collectionsPrelude_5475__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5475__61__61__40_1_41_->definitionLine = 446;
// method "iterator"
  block_savedest(obj5444);
  Object closure5495 = createclosure(1, "iterator");
  setclosureframe(closure5495, stackframe);
  addtoclosure(closure5495, var_IteratorExhausted);
  struct UserObject *uo5495 = (struct UserObject*)obj5444;
  uo5495->data[13] = (Object)closure5495;
  Method *meth_meth_collectionsPrelude_5495_iterator = addmethod2pos(obj5444, "iterator", &meth_collectionsPrelude_5495_iterator, 13);
  int argcv_meth_collectionsPrelude_5495_iterator[] = {0};
  meth_meth_collectionsPrelude_5495_iterator->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5495_iterator);
  meth_meth_collectionsPrelude_5495_iterator->definitionModule = modulename;
  meth_meth_collectionsPrelude_5495_iterator->definitionLine = 455;
  block_savedest(obj5444);
  Object closure5506 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure5506, stackframe);
  addtoclosure(closure5506, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_5495_iterator_object = addmethod2pos(obj5444, "iterator$object(1)", &meth_collectionsPrelude_5495_iterator_object, 13);
  meth_meth_collectionsPrelude_5495_iterator_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_5495_iterator_object->definitionLine = 455;
// method "sorted"
  struct UserObject *uo5507 = (struct UserObject*)obj5444;
  uo5507->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5507_sorted = addmethod2pos(obj5444, "sorted", &meth_collectionsPrelude_5507_sorted, 14);
  int argcv_meth_collectionsPrelude_5507_sorted[] = {0};
  meth_meth_collectionsPrelude_5507_sorted->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5507_sorted);
  meth_meth_collectionsPrelude_5507_sorted->definitionModule = modulename;
  meth_meth_collectionsPrelude_5507_sorted->definitionLine = 460;
// method "sortedBy(_)"
  struct UserObject *uo5508 = (struct UserObject*)obj5444;
  uo5508->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5508_sortedBy_40_1_41_ = addmethod2pos(obj5444, "sortedBy(1)", &meth_collectionsPrelude_5508_sortedBy_40_1_41_, 15);
  int argcv_meth_collectionsPrelude_5508_sortedBy_40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5508_sortedBy_40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5508_sortedBy_40_1_41_);
  meth_meth_collectionsPrelude_5508_sortedBy_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5508_sortedBy_40_1_41_->definitionLine = 461;
  sourceObject = obj5444;
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5509 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_collectionsPrelude (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5510 = callmethodflags(module_collectionsPrelude, "indexable$object(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5509);
// compiled call node returning call5510 (depth = 3)
  struct UserObject *obj5444_uo = (struct UserObject *)obj5444;
  obj5444_uo->super = call5510;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  sourceObject = obj5444;
  objclass5444 = obj5444->class;
  objclass5444->definitionModule = modulename;
  objclass5444->definitionLine = 433;
  (*(struct UserObject *)self).data[0] = lowerouter5444;
  self = oldself5444;
  selfslot = oldselfslot5444;
  stackframe = oldstackframe5444;
// compiled object node returning obj5444 (depth = 2)
  *var_emptySequence = obj5444;
  if (obj5444 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "emptySequence"
  block_savedest(self);
  Object closure5511 = createclosure(1, "emptySequence");
  setclosureframe(closure5511, stackframe);
  addtoclosure(closure5511, var_emptySequence);
  struct UserObject *uo5511 = (struct UserObject*)self;
  uo5511->data[40] = (Object)closure5511;
  Method *meth_meth_collectionsPrelude_5511_emptySequence = addmethod2pos(self, "emptySequence", &meth_collectionsPrelude_5511_emptySequence, 40);
  int argcv_meth_collectionsPrelude_5511_emptySequence[] = {0};
  meth_meth_collectionsPrelude_5511_emptySequence->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5511_emptySequence);
  meth_meth_collectionsPrelude_5511_emptySequence->definitionModule = modulename;
  meth_meth_collectionsPrelude_5511_emptySequence->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl MinimalyIterable
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type5513 = alloc_Type("MinimalyIterable", 1);
  add_Method((ClassData)type5513, "iterator", NULL);
// compiled typeliteral node returning type5513 (depth = 2)
  *var_MinimalyIterable = type5513;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "MinimalyIterable"
  block_savedest(self);
  Object closure5514 = createclosure(1, "MinimalyIterable");
  setclosureframe(closure5514, stackframe);
  addtoclosure(closure5514, var_MinimalyIterable);
  struct UserObject *uo5514 = (struct UserObject*)self;
  uo5514->data[41] = (Object)closure5514;
  Method *meth_meth_collectionsPrelude_5514_MinimalyIterable = addmethod2pos(self, "MinimalyIterable", &meth_collectionsPrelude_5514_MinimalyIterable, 41);
  int argcv_meth_collectionsPrelude_5514_MinimalyIterable[] = {0};
  meth_meth_collectionsPrelude_5514_MinimalyIterable->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5514_MinimalyIterable);
  meth_meth_collectionsPrelude_5514_MinimalyIterable->definitionModule = modulename;
  meth_meth_collectionsPrelude_5514_MinimalyIterable->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5515 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5515 = alloc_userobj2(6,6, objclass5515);
  gc_frame_newslot(obj5515);
  if (objclass5515 == NULL) {
    glfree(obj5515->class->name);
    obj5515->class->name = "unused";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5515, self, 0);
  addmethodreal(obj5515,"outer", &reader_collectionsPrelude_outer_5516);
  Object oldself5515 = self;
  struct StackFrameObject *oldstackframe5515 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5515);
  gc_frame_newslot((Object)stackframe);
  self = obj5515;
  Object *oldselfslot5515 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5515 = (*(struct UserObject *)self).data[0], lowerouter5515 = thisouter5515;
  if (inheritingObject5515) {
    struct UserObject *inho5515 = (struct UserObject *)inheritingObject5515;
    while (inho5515->super != GraceDefaultObject) inho5515 = (struct UserObject *)inho5515->super;
    inho5515->super = obj5515;
    self = inheritingObject5515;
    *selfslot = self;
    lowerouter5515 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5515;
  }
  if (objclass5515 == NULL) {
    Method *reader5517 = addmethodrealflags(obj5515, "unused", &reader_collectionsPrelude_unused_5517, MFLAG_CONFIDENTIAL);
    Method *writer5517 = addmethodrealflags(obj5515, "unused:=(1)", &writer_collectionsPrelude_unused_5517, MFLAG_CONFIDENTIAL);
    reader5517->definitionModule = modulename;
    writer5517->definitionModule = modulename;
    reader5517->definitionLine = 908;
    writer5517->definitionLine = 908;
  }
  obj5515->flags |= OFLAG_MUTABLE;
  adddatum2(obj5515, alloc_Undefined(), 1);
  if (objclass5515 == NULL) {
  Method *reader5518 = addmethodrealflags(obj5515, "key",&reader_collectionsPrelude_key_5518, MFLAG_DEF);
  reader5518->definitionModule = modulename;
  reader5518->definitionLine = 909;
  }
  adddatum2(obj5515, alloc_Undefined(), 2);
  if (objclass5515 == NULL) {
  Method *reader5519 = addmethodrealflags(obj5515, "value",&reader_collectionsPrelude_value_5519, MFLAG_DEF);
  reader5519->definitionModule = modulename;
  reader5519->definitionLine = 910;
  }
  adddatum2(obj5515, alloc_Undefined(), 3);
// method "asString"
  struct UserObject *uo5520 = (struct UserObject*)obj5515;
  uo5520->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5520_asString = addmethod2pos(obj5515, "asString", &meth_collectionsPrelude_5520_asString, 4);
  int argcv_meth_collectionsPrelude_5520_asString[] = {0};
  meth_meth_collectionsPrelude_5520_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5520_asString);
  meth_meth_collectionsPrelude_5520_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_5520_asString->definitionLine = 911;
// method "==(_)"
  struct UserObject *uo5522 = (struct UserObject*)obj5515;
  uo5522->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5522__61__61__40_1_41_ = addmethod2pos(obj5515, "==(1)", &meth_collectionsPrelude_5522__61__61__40_1_41_, 5);
  int argcv_meth_collectionsPrelude_5522__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5522__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5522__61__61__40_1_41_);
  meth_meth_collectionsPrelude_5522__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5522__61__61__40_1_41_->definitionLine = 912;
  sourceObject = obj5515;
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5525 = alloc_Boolean(1);
// compiled identifier node returning bool5525 (depth = 3)
  adddatum2(obj5515, bool5525, 1);
  sourceObject = obj5515;
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj5515, self, 2);
  sourceObject = obj5515;
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj5515, self, 3);
  sourceObject = obj5515;
  sourceObject = obj5515;
  objclass5515 = obj5515->class;
  objclass5515->definitionModule = modulename;
  objclass5515->definitionLine = 907;
  (*(struct UserObject *)self).data[0] = lowerouter5515;
  self = oldself5515;
  selfslot = oldselfslot5515;
  stackframe = oldstackframe5515;
// compiled object node returning obj5515 (depth = 2)
  *var_unused = obj5515;
  if (obj5515 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "unused"
  block_savedest(self);
  Object closure5526 = createclosure(1, "unused");
  setclosureframe(closure5526, stackframe);
  addtoclosure(closure5526, var_unused);
  struct UserObject *uo5526 = (struct UserObject*)self;
  uo5526->data[42] = (Object)closure5526;
  Method *meth_meth_collectionsPrelude_5526_unused = addmethod2pos(self, "unused", &meth_collectionsPrelude_5526_unused, 42);
  int argcv_meth_collectionsPrelude_5526_unused[] = {0};
  meth_meth_collectionsPrelude_5526_unused->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5526_unused);
  meth_meth_collectionsPrelude_5526_unused->definitionModule = modulename;
  meth_meth_collectionsPrelude_5526_unused->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5527 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5527 = alloc_userobj2(6,6, objclass5527);
  gc_frame_newslot(obj5527);
  if (objclass5527 == NULL) {
    glfree(obj5527->class->name);
    obj5527->class->name = "removed";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5527, self, 0);
  addmethodreal(obj5527,"outer", &reader_collectionsPrelude_outer_5528);
  Object oldself5527 = self;
  struct StackFrameObject *oldstackframe5527 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5527);
  gc_frame_newslot((Object)stackframe);
  self = obj5527;
  Object *oldselfslot5527 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5527 = (*(struct UserObject *)self).data[0], lowerouter5527 = thisouter5527;
  if (inheritingObject5527) {
    struct UserObject *inho5527 = (struct UserObject *)inheritingObject5527;
    while (inho5527->super != GraceDefaultObject) inho5527 = (struct UserObject *)inho5527->super;
    inho5527->super = obj5527;
    self = inheritingObject5527;
    *selfslot = self;
    lowerouter5527 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5527;
  }
  if (objclass5527 == NULL) {
    Method *reader5529 = addmethodrealflags(obj5527, "removed", &reader_collectionsPrelude_removed_5529, MFLAG_CONFIDENTIAL);
    Method *writer5529 = addmethodrealflags(obj5527, "removed:=(1)", &writer_collectionsPrelude_removed_5529, MFLAG_CONFIDENTIAL);
    reader5529->definitionModule = modulename;
    writer5529->definitionModule = modulename;
    reader5529->definitionLine = 916;
    writer5529->definitionLine = 916;
  }
  obj5527->flags |= OFLAG_MUTABLE;
  adddatum2(obj5527, alloc_Undefined(), 1);
  if (objclass5527 == NULL) {
  Method *reader5530 = addmethodrealflags(obj5527, "key",&reader_collectionsPrelude_key_5530, MFLAG_DEF);
  reader5530->definitionModule = modulename;
  reader5530->definitionLine = 917;
  }
  adddatum2(obj5527, alloc_Undefined(), 2);
  if (objclass5527 == NULL) {
  Method *reader5531 = addmethodrealflags(obj5527, "value",&reader_collectionsPrelude_value_5531, MFLAG_DEF);
  reader5531->definitionModule = modulename;
  reader5531->definitionLine = 918;
  }
  adddatum2(obj5527, alloc_Undefined(), 3);
// method "asString"
  struct UserObject *uo5532 = (struct UserObject*)obj5527;
  uo5532->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5532_asString = addmethod2pos(obj5527, "asString", &meth_collectionsPrelude_5532_asString, 4);
  int argcv_meth_collectionsPrelude_5532_asString[] = {0};
  meth_meth_collectionsPrelude_5532_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5532_asString);
  meth_meth_collectionsPrelude_5532_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_5532_asString->definitionLine = 919;
// method "==(_)"
  struct UserObject *uo5534 = (struct UserObject*)obj5527;
  uo5534->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5534__61__61__40_1_41_ = addmethod2pos(obj5527, "==(1)", &meth_collectionsPrelude_5534__61__61__40_1_41_, 5);
  int argcv_meth_collectionsPrelude_5534__61__61__40_1_41_[] = {1};
  meth_meth_collectionsPrelude_5534__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5534__61__61__40_1_41_);
  meth_meth_collectionsPrelude_5534__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5534__61__61__40_1_41_->definitionLine = 920;
  sourceObject = obj5527;
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5537 = alloc_Boolean(1);
// compiled identifier node returning bool5537 (depth = 3)
  adddatum2(obj5527, bool5537, 1);
  sourceObject = obj5527;
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj5527, self, 2);
  sourceObject = obj5527;
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj5527, self, 3);
  sourceObject = obj5527;
  sourceObject = obj5527;
  objclass5527 = obj5527->class;
  objclass5527->definitionModule = modulename;
  objclass5527->definitionLine = 915;
  (*(struct UserObject *)self).data[0] = lowerouter5527;
  self = oldself5527;
  selfslot = oldselfslot5527;
  stackframe = oldstackframe5527;
// compiled object node returning obj5527 (depth = 2)
  *var_removed = obj5527;
  if (obj5527 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "removed"
  block_savedest(self);
  Object closure5538 = createclosure(1, "removed");
  setclosureframe(closure5538, stackframe);
  addtoclosure(closure5538, var_removed);
  struct UserObject *uo5538 = (struct UserObject*)self;
  uo5538->data[43] = (Object)closure5538;
  Method *meth_meth_collectionsPrelude_5538_removed = addmethod2pos(self, "removed", &meth_collectionsPrelude_5538_removed, 43);
  int argcv_meth_collectionsPrelude_5538_removed[] = {0};
  meth_meth_collectionsPrelude_5538_removed->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5538_removed);
  meth_meth_collectionsPrelude_5538_removed->definitionModule = modulename;
  meth_meth_collectionsPrelude_5538_removed->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Binding
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type5540 = alloc_Type("Binding", 4);
  add_Method((ClassData)type5540, "key", NULL);
  add_Method((ClassData)type5540, "value", NULL);
  add_Method((ClassData)type5540, "hash", NULL);
  add_Method((ClassData)type5540, "==(1)", NULL);
// compiled typeliteral node returning type5540 (depth = 2)
  *var_Binding = type5540;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Binding"
  block_savedest(self);
  Object closure5541 = createclosure(1, "Binding");
  setclosureframe(closure5541, stackframe);
  addtoclosure(closure5541, var_Binding);
  struct UserObject *uo5541 = (struct UserObject*)self;
  uo5541->data[44] = (Object)closure5541;
  Method *meth_meth_collectionsPrelude_5541_Binding = addmethod2pos(self, "Binding", &meth_collectionsPrelude_5541_Binding, 44);
  int argcv_meth_collectionsPrelude_5541_Binding[] = {0};
  meth_meth_collectionsPrelude_5541_Binding->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5541_Binding);
  meth_meth_collectionsPrelude_5541_Binding->definitionModule = modulename;
  meth_meth_collectionsPrelude_5541_Binding->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5542 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5542 = alloc_userobj2(3,4, objclass5542);
  gc_frame_newslot(obj5542);
  if (objclass5542 == NULL) {
    glfree(obj5542->class->name);
    obj5542->class->name = "binding";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj5542, self, 0);
  addmethodreal(obj5542,"outer", &reader_collectionsPrelude_outer_5543);
  Object oldself5542 = self;
  struct StackFrameObject *oldstackframe5542 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5542);
  gc_frame_newslot((Object)stackframe);
  self = obj5542;
  Object *oldselfslot5542 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5542 = (*(struct UserObject *)self).data[0], lowerouter5542 = thisouter5542;
  if (inheritingObject5542) {
    struct UserObject *inho5542 = (struct UserObject *)inheritingObject5542;
    while (inho5542->super != GraceDefaultObject) inho5542 = (struct UserObject *)inho5542->super;
    inho5542->super = obj5542;
    self = inheritingObject5542;
    *selfslot = self;
    lowerouter5542 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5542;
  }
// method "asString"
  struct UserObject *uo5544 = (struct UserObject*)obj5542;
  uo5544->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_5544_asString = addmethod2pos(obj5542, "asString", &meth_collectionsPrelude_5544_asString, 1);
  int argcv_meth_collectionsPrelude_5544_asString[] = {0};
  meth_meth_collectionsPrelude_5544_asString->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5544_asString);
  meth_meth_collectionsPrelude_5544_asString->definitionModule = modulename;
  meth_meth_collectionsPrelude_5544_asString->definitionLine = 1226;
// method "key(_)value(_)"
  block_savedest(obj5542);
  Object closure5546 = createclosure(1, "key(1)value(1)");
  setclosureframe(closure5546, stackframe);
  addtoclosure(closure5546, var_Binding);
  struct UserObject *uo5546 = (struct UserObject*)obj5542;
  uo5546->data[2] = (Object)closure5546;
  Method *meth_meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41_ = addmethod2pos(obj5542, "key(1)value(1)", &meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41_, 2);
  int argcv_meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41_[] = {1, 1};
  meth_meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41_->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41_);
  meth_meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41_->definitionModule = modulename;
  meth_meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41_->definitionLine = 1228;
  block_savedest(obj5542);
  Object closure5622 = createclosure(1, "key(1)value(1)$object(1)");
  setclosureframe(closure5622, stackframe);
  addtoclosure(closure5622, var_Binding);
  Method *meth_meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41__object = addmethod2pos(obj5542, "key(1)value(1)$object(1)", &meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41__object, 2);
  meth_meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41__object->definitionModule = modulename;
  meth_meth_collectionsPrelude_5546_key_40_1_41_value_40_1_41__object->definitionLine = 1228;
  sourceObject = obj5542;
  sourceObject = obj5542;
  objclass5542 = obj5542->class;
  objclass5542->definitionModule = modulename;
  objclass5542->definitionLine = 1225;
  (*(struct UserObject *)self).data[0] = lowerouter5542;
  self = oldself5542;
  selfslot = oldselfslot5542;
  stackframe = oldstackframe5542;
// compiled object node returning obj5542 (depth = 2)
  *var_binding = obj5542;
  if (obj5542 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "binding"
  block_savedest(self);
  Object closure5623 = createclosure(1, "binding");
  setclosureframe(closure5623, stackframe);
  addtoclosure(closure5623, var_binding);
  struct UserObject *uo5623 = (struct UserObject*)self;
  uo5623->data[45] = (Object)closure5623;
  Method *meth_meth_collectionsPrelude_5623_binding = addmethod2pos(self, "binding", &meth_collectionsPrelude_5623_binding, 45);
  int argcv_meth_collectionsPrelude_5623_binding[] = {0};
  meth_meth_collectionsPrelude_5623_binding->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5623_binding);
  meth_meth_collectionsPrelude_5623_binding->definitionModule = modulename;
  meth_meth_collectionsPrelude_5623_binding->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl ComparableToDictionary
// starting to compile typeliteral node (depth = 2)
//   Type literal 
  Object type5625 = alloc_Type("ComparableToDictionary", 2);
  add_Method((ClassData)type5625, "size", NULL);
  add_Method((ClassData)type5625, "at(1)ifAbsent(1)", NULL);
// compiled typeliteral node returning type5625 (depth = 2)
  *var_ComparableToDictionary = type5625;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ComparableToDictionary"
  block_savedest(self);
  Object closure5626 = createclosure(1, "ComparableToDictionary");
  setclosureframe(closure5626, stackframe);
  addtoclosure(closure5626, var_ComparableToDictionary);
  struct UserObject *uo5626 = (struct UserObject*)self;
  uo5626->data[46] = (Object)closure5626;
  Method *meth_meth_collectionsPrelude_5626_ComparableToDictionary = addmethod2pos(self, "ComparableToDictionary", &meth_collectionsPrelude_5626_ComparableToDictionary, 46);
  int argcv_meth_collectionsPrelude_5626_ComparableToDictionary[] = {0};
  meth_meth_collectionsPrelude_5626_ComparableToDictionary->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_5626_ComparableToDictionary);
  meth_meth_collectionsPrelude_5626_ComparableToDictionary->definitionModule = modulename;
  meth_meth_collectionsPrelude_5626_ComparableToDictionary->definitionLine = 1769;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
  gc_frame_end(frame);
  return self;
}
