#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1e6315be77eff662cf99876c2ac8964a81f2abc7";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "errormessages";
Object module_standardGrace_init();
extern Object module_standardGrace;
Object module_errormessages = NULL;
static char *originalSourceLines[] = {
  "#pragma ExtendedLineups",
  "import \"io\" as io",
  "import \"sys\" as sys",
  "import \"util\" as util",
  "",
  "// Contains modified lines used as suggestions for error messages.",
  "// When a line is added using one of the utility methods such as",
  "// insert()afterToken()onLine(), the line is copied from util.lines to the",
  "// internal lines array in the suggestion, and when a line that is already in",
  "// the array is modified, the internal lines array is updated.",
  "// There is no sorting of the order of the lines at any point, so",
  "// lines must be added in ascending order.",
  "def suggestion is public = object {",
  "  class new {",
  "    def lineNumbers is confidential = []",
  "    def lines is confidential = []",
  "",
  "    // Methods that deal with inserting/replacing/deleting character positions",
  "    // and ranges. These methods are usually called by lexing error messages",
  "    // due to lack of access to tokens, and by insert/replace/delete methods",
  "    // that operate on tokens.",
  "",
  "    method replaceRange(start, end)with(s)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        if(start == 1) then {",
  "            addLine(lineNumber, s ++ line.substringFrom(end + 1)to(line.size))",
  "        } else {",
  "            addLine(lineNumber, line.substringFrom(1)to(start - 1)",
  "                ++ s ++ line.substringFrom(end + 1)to(line.size))",
  "        }",
  "    }",
  "",
  "    method replaceChar(pos)with(s)onLine(lineNumber) {",
  "        replaceRange(pos, pos)with(s)onLine(lineNumber)",
  "    }",
  "",
  "    method replaceUntil(until)with(s)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        def len = until.size",
  "        for (1..line.size) do {i->",
  "            if (line.substringFrom(i)to(i + len - 1) == until) then {",
  "                replaceRange(1, i + len - 1)with(s)onLine(lineNumber)",
  "                return true",
  "            }",
  "        }",
  "        return false",
  "    }",
  "",
  "    method deleteRange(start, end)onLine(lineNumber) {",
  "        var start' := start",
  "        def line = getLine(lineNumber)",
  "        if((start' > 1) && (end == line.size)) then {",
  "            // Check for removing the whole line, then remove the indent also.",
  "            var indent := true",
  "            for(1..(start'-1)) do { i ->",
  "                if(line.at(i) != \" \") then {",
  "                    indent := false",
  "                }",
  "            }",
  "            if(indent == true) then {",
  "                start' := 1",
  "            }",
  "        }",
  "        replaceRange(start', end)with(\"\")onLine(lineNumber)",
  "    }",
  "",
  "    method deleteChar(pos)onLine(lineNumber) {",
  "        replaceRange(pos, pos)with(\"\")onLine(lineNumber)",
  "    }",
  "",
  "    method append(s)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        addLine(lineNumber, line ++ s)",
  "    }",
  "",
  "    method insert(s)atPosition(pos)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        if(pos == 1) then {",
  "            addLine(lineNumber, s ++ line)",
  "        } else {",
  "            addLine(lineNumber, line.substringFrom(1)to(pos - 1) ++ s",
  "                ++ line.substringFrom(pos)to(line.size))",
  "        }",
  "    }",
  "",
  "    // Methods that deal with inserting/replacing/deleteing tokens or ranges of",
  "    // tokens. These methods call the underlying methods that operate on",
  "    // characters.",
  "",
  "    method getTokenStart(token)includeLeadingSpace(includeLeading) {",
  "        var start := token.linePos",
  "        // Include leading whitespace.",
  "        if(includeLeading == true) then {",
  "            if((token.prev != false) && ({token.prev.line == token.line})) then {",
  "                start := token.prev.linePos + token.prev.size",
  "            }",
  "        }",
  "        // Include indentation if this is the only token on the line.",
  "        if(token.linePos == (token.indent + 1)) then {",
  "            if ((token.next == false) || {token.next.line != token.line}) then {",
  "                start := 1",
  "            }",
  "        }",
  "        start",
  "    }",
  "",
  "    method getTokenEnd(token)includeTrailingSpace(includeTrailing) {",
  "        var end := token.linePos + token.size - 1",
  "        // Include trailing space.",
  "        if(includeTrailing == true) then {",
  "            if((token.next != false) && ({token.next.line == token.line})) then {",
  "                end := token.next.linePos - 1;",
  "            } else {",
  "                end := getLine(token.line).size",
  "            }",
  "        }",
  "        end",
  "    }",
  "",
  "    method replaceToken(token)leading(replaceLeading)trailing(replaceTrailing)with(s) {",
  "        def start = getTokenStart(token)includeLeadingSpace(replaceLeading)",
  "        def end = getTokenEnd(token)includeTrailingSpace(replaceTrailing)",
  "        replaceRange(start, end)with(s)onLine(token.line)",
  "    }",
  "",
  "    method replaceToken(token)with(s) {",
  "        replaceToken(token)leading(false)trailing(false)with(s)",
  "    }",
  "",
  "    method replaceTokenRange(start, end)leading(replaceLeading)trailing(replaceTrailing)with(s) {",
  "        if(start == end) then {",
  "            replaceToken(start)leading(replaceLeading)trailing(replaceTrailing)with(s)",
  "        } else {",
  "            // Get the ident and position now in case deleteTokenRange changes it.",
  "            def insertPos = getTokenStart(start)includeLeadingSpace(replaceLeading)",
  "            def indent = getLine(start.line).substringFrom(1)to(start.indent)",
  "            deleteTokenRange(start, end)leading(replaceLeading)trailing(replaceTrailing)",
  "            // If delete token range deleted the indent, then add it back.",
  "            if(getLine(start.line) == \"\") then {",
  "                insert(indent ++ s)atPosition(insertPos)onLine(start.line)",
  "            } else {",
  "                insert(s)atPosition(insertPos)onLine(start.line)",
  "            }",
  "        }",
  "    }",
  "",
  "    method replaceTokenRange(start, end)with(s) {",
  "        replaceTokenRange(start, end)leading(false)trailing(false)with(s)",
  "    }",
  "",
  "    // Deletes a token, and optionally leading and/or trailing spaces.",
  "    method deleteToken(token)leading(deleteLeading)trailing(deleteTrailing) {",
  "        def start = getTokenStart(token)includeLeadingSpace(deleteLeading)",
  "        def end = getTokenEnd(token)includeTrailingSpace(deleteTrailing)",
  "        deleteRange(start, end)onLine(token.line)",
  "    }",
  "",
  "    method deleteToken(token) {",
  "        deleteToken(token)leading(false)trailing(false)",
  "    }",
  "",
  "    // Deletes a range of tokens, and optionally leading and/or trailing spaces.",
  "    method deleteTokenRange(start, end)leading(deleteLeading)trailing(deleteTrailing) {",
  "        if(start == end) then {",
  "            deleteToken(start)leading(deleteLeading)trailing(deleteTrailing)",
  "        } else {",
  "            var line := start.line",
  "            var startPos := getTokenStart(start)includeLeadingSpace(deleteLeading)",
  "            var endPos := getTokenEnd(start)includeTrailingSpace(deleteTrailing)",
  "            var tok := start.next",
  "            while {tok != end} do {",
  "                if(tok.line != line) then {",
  "                    deleteRange(startPos, endPos)onLine(line)",
  "                    line := tok.line",
  "                    startPos := getTokenStart(tok)includeLeadingSpace(deleteLeading)",
  "                }",
  "                endPos := getTokenEnd(tok)includeTrailingSpace(deleteTrailing)",
  "                tok := tok.next",
  "            }",
  "            if(end.line != line) then {",
  "                deleteRange(startPos, endPos)onLine(line)",
  "            }",
  "            endPos := getTokenEnd(end)includeTrailingSpace(deleteTrailing)",
  "            deleteRange(startPos, endPos)onLine(end.line)",
  "        }",
  "    }",
  "",
  "    method deleteTokenRange(start, end) {",
  "        deleteTokenRange(start, end)leading(false)trailing(false)",
  "    }",
  "",
  "    method deleteLine(lineNumber) {",
  "        addLine(lineNumber, \"\")",
  "    }",
  "",
  "    method insert(s)afterToken(token)andTrailingSpace(afterTrailing) {",
  "        def pos = getTokenEnd(token)includeTrailingSpace(afterTrailing) + 1",
  "        insert(s)atPosition(pos)onLine(token.line)",
  "    }",
  "",
  "    method insert(s)afterToken(token) {",
  "        insert(s)afterToken(token)andTrailingSpace(false)",
  "    }",
  "",
  "    method insert(s)beforeToken(token) {",
  "        insert(s)atPosition(token.linePos)onLine(token.line)",
  "    }",
  "",
  "    // Insert a new line. This stores the line with the same number as the line it comes after.",
  "    method insertNewLine(line)after(lineNumber) {",
  "        addLine(lineNumber, line)",
  "    }",
  "",
  "    // Manually add a line to the suggestion. This will overwrite any previous",
  "    // changes that may have been made to this line.",
  "    method addLine(lineNumber, line) {",
  "        var i := findLine(lineNumber)",
  "        if(i != false) then {",
  "            lines.at(i)put(line)",
  "        } else {",
  "            // Add new lines to make the list big enough.",
  "            lineNumbers.push(lineNumber)",
  "            lines.push(line)",
  "            if (lines.size > 1) then {",
  "                // Re-order the list.",
  "                i := lines.size",
  "                while {(i > 1) && {lineNumber < lineNumbers.at(i - 1)}} do {",
  "                    lineNumbers.at(i) put(lineNumbers.at(i - 1))",
  "                    lines.at(i) put (lines.at(i - 1))",
  "                    i := i - 1",
  "                }",
  "                lineNumbers.at(i) put (lineNumber)",
  "                lines.at(i) put (line)",
  "            }",
  "        }",
  "    }",
  "",
  "    // Internal method used to find the index of a line in the lines array.",
  "    // Returns false if the line is not found.",
  "    method findLine(lineNumber) is confidential {",
  "        for(lineNumbers.indices) do { i ->",
  "            if(lineNumbers.at(i) == lineNumber) then {",
  "                return i",
  "            }",
  "        }",
  "        false",
  "    }",
  "",
  "    // Internal method used to get the contents of a line so far.",
  "    // If the line is not part of this suggestion then it gets the unmodified line.",
  "    method getLine(lineNumber) is confidential {",
  "        def i = findLine(lineNumber)",
  "        if(i == false) then {",
  "            util.lines.at(lineNumber)",
  "        } else {",
  "            lines.at(i)",
  "        }",
  "    }",
  "",
  "    method print {",
  "        for(1..lines.size) do { i ->",
  "            if ((i > 1) && {(lineNumbers.at(i) > (lineNumbers.at(i-1) + 1))}) then {",
  "                var s := \"\"",
  "                repeat (lineNumbers.at(i-1).asString.size) times {",
  "                    s := s ++ \" \"",
  "                }",
  "                io.error.write(\"    {s}...\\n\")",
  "            }",
  "            // Handle insertion of new lines.",
  "            if(lineNumbers.at(i).truncated != lineNumbers.at(i)) then {",
  "                io.error.write(\" *{lineNumbers.at(i).truncated}: {lines.at(i)}\\n\")",
  "            } else {",
  "                io.error.write(\"  {lineNumbers.at(i)}: {lines.at(i)}\\n\")",
  "            }",
  "        }",
  "    }",
  "  }",
  "}",
  "",
  "method readableStringFrom(xs:Collection) {",
  "    // returns a string describing the contents of xs,",
  "    // separating items with commas and the word \"and\"",
  "    var result := \"\"",
  "    var count := xs.size",
  "    xs.do { v ->",
  "        result := result ++ v.asString",
  "        count := count - 1",
  "        if (count == 1) then {",
  "            if (xs.size > 2) then { result := result ++ \",\" }",
  "            result := result ++ \" and \"",
  "        } elseif { count > 1 } then {",
  "            result := result ++ \", \"",
  "        }",
  "    }",
  "    result",
  "}",
  "",
  "method name (p:String) mightBeIntendedToBe (target:String) {",
  "    if (p == \"module()object\") then { return false }",
  "    if (p.contains \"$\") then { return false }",
  "    def parenIx = p.indexOf \"(\" ifAbsent { p.size + 1 }",
  "    def pPrefix = p.substringFrom 1 to (parenIx - 1)",
  "    if (target.startsWith(pPrefix)) then { return true }",
  "    if (target.size > (p.size * 2)) then { return false }",
  "    def rng = name (p) matches (target) within 2",
  "    if (rng == 0) then { return false }",
  "    if (rng > (p.size * 2)) then { return false }  // found too far along",
  "    return true",
  "}",
  "",
  "",
  "method name (p:String) matches (t:String) within (k:Number) {",
  "    // This is algorithm EDP from Jokinen, Jorma, Tarhio and Ukkinen:",
  "    // \"A comparison of Approximate String Matching Algorithms\"",
  "    // Software—Practice and Experience Vol 1(1), January 1988, pp.1–19",
  "    //",
  "    // Implements the \"Enhanced Dynamic Programming\" (EDP) algorithm for",
  "    // approximate string matching.  If pattern p matches text t within",
  "    // an edit distance ≤ k, this method returns j, the index of the highest",
  "    // character of t involved in the match.  Its time compelxity is O(k*|p|).",
  "    //",
  "    // The algorithm builds a dynamic progarmming table D such that",
  "    // D[i,j] is the minimum edit distance between p[1] p[2] ... p[i]",
  "    // and any substring of t ending at t[j].   However, it isn't necessary",
  "    // to store the whole table D.  Because D[i,j] depends on only D[i-1, j],",
  "    // D[i-1, j-1] and D[i, j-1], we can store only the current",
  "    // column, which we do in h, and the value of D[i-1,j-1], which is",
  "    // cached in c.  Moreover, since we are not interested in edit",
  "    // distances > k, it's necessary to evaluate only those elements",
  "    // of the table around the diagonal.",
  "",
  "",
  "    def m = p.size",
  "    def n = t.size",
  "    if ((m ≤ k)) then {",
  "        return min(m, n)   // can match first min(m, n) chars of t",
  "    }",
  "    var top := k + 1  // the location where the topmost diagonal under",
  "                      // threshold intersects the current column",
  "    var maxResult := 0",
  "    def h = emptyList",
  "    for (0..m) do { i -> h.at(i+1) put(i) }",
  "    try {",
  "        for (1..n) do { j ->",
  "            var c := 0",
  "            for (1..top) do { i ->",
  "                def e = if (p.at(i) == t.at(j)) then {",
  "                    c",
  "                } else {",
  "                    min3(h.at(i), h.at(i+1), c) + 1",
  "                }",
  "                c := h.at(i+1)",
  "                h.at(i+1) put (e)",
  "            }",
  "            while { h.at(top+1) > k } do { top := top - 1 }",
  "            if (top == m) then {",
  "                maxResult := max(maxResult, j)       //  j is the index of",
  "                    //  the last character of t that was used in the match",
  "            } else {",
  "                top := top + 1",
  "            }",
  "        }",
  "    } catch { e:BoundsError ->",
  "        print \"BoundsError in name({p})matches({t})within({k})\"",
  "        e.printBacktrace",
  "        return 0 }   // if the code is buggy, don't crash",
  "    return maxResult",
  "}",
  "",
  "method min3(a, b, c) is confidential {",
  "    def sf = if (a < b) then { a } else { b }",
  "    if (sf < c) then { sf } else { c }",
  "}",
  "",
  "",
  "// Methods to actually display an error message and suggestions, then exit.",
  "",
  "method syntaxError (message) atRange (r) {",
  "    def more = if (r.start.line < r.end.line) then {",
  "        \"  This statement spans multiple lines; is that what you intended?\"",
  "    } else {",
  "        \"\"",
  "    }",
  "    syntaxError (message ++ more) atRange (r) withSuggestions []",
  "}",
  "method syntaxError (message) atRange (r) withSuggestion (s) {",
  "    syntaxError (message) atRange (r) withSuggestions [s]",
  "}",
  "method syntaxError (message) atRange (r) withSuggestions (s) {",
  "    syntaxError (message)",
  "          atRange (r.start.line, r.start.column, r.end.line, r.end.column)",
  "          withSuggestions (s)",
  "}",
  "",
  "method syntaxError(message)atRange(errlinenum, startpos, endpos) {",
  "    syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestion(suggestion') {",
  "    syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestions([suggestion'])",
  "}",
  "",
  "method syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestions(suggestions) {",
  "    syntaxError (message)",
  "          atRange (errlinenum, startpos, errlinenum, endpos)",
  "          withSuggestions (suggestions)",
  "}",
  "",
  "method syntaxError (message)",
  "          atRange (startline, startpos, endline, endpos)",
  "          withSuggestions (suggestions) {",
  "",
  "    // this variant allows for range to start and end on different lines.",
  "    def loc = if (startline == endline) then {",
  "        if (startpos == endpos)",
  "              then { startpos.asString }",
  "              else { \"{startpos}-{endpos}\" }",
  "    } else { \"{startpos}-{endline}:{endpos}\" }",
  "    var arr := \"----\"",
  "    for (2..(startpos + startline.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (startpos..endpos) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.syntaxError(message, startline, \":{loc}\", arr, suggestions)",
  "}",
  "",
  "method error (message) atRange (r) {",
  "    error (message)",
  "        atRange (r.start.line, r.start.column, r.end.line, r.end.column)",
  "        withSuggestions []",
  "}",
  "method error (message)",
  "          atRange (startline, startpos, endline, endpos)",
  "          withSuggestions (suggestions) {",
  "",
  "    // this variant allows for range to start and end on different lines.",
  "    def loc = if (startline == endline) then {",
  "        if (startpos == endpos)",
  "              then { startpos.asString }",
  "              else { \"{startpos}-{endpos}\" }",
  "    } else { \"{startpos}-{endline}:{endpos}\" }",
  "    var arr := \"----\"",
  "    for (2..(startpos + startline.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (startpos..endpos) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.generalError(message, startline, \":{loc}\", arr, suggestions)",
  "}",
  "method error(message)atRange(errlinenum, startpos, endpos)withSuggestions(suggestions) {",
  "    error (message)",
  "          atRange (errlinenum, startpos, errlinenum, endpos)",
  "          withSuggestions (suggestions)",
  "}",
  "method error(message) atRange(errlinenum, startpos, endpos) {",
  "    error (message) atRange(errlinenum, startpos, endpos) withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atPosition(errlinenum, errpos) {",
  "    syntaxError(message)atPosition(errlinenum, errpos)withSuggestions([])",
  "}",
  "",
  "method error(message) atPosition(errlinenum, errpos) {",
  "    error(message) atPosition(errlinenum, errpos) withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atPosition(errlinenum, errpos)withSuggestion(suggestion') {",
  "    syntaxError(message)atPosition(errlinenum, errpos)withSuggestions([suggestion'])",
  "}",
  "",
  "method syntaxError(message)atPosition(errlinenum, errpos)withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (2..(errpos + errlinenum.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    arr := arr ++ \"^\"",
  "    util.syntaxError(message, errlinenum, \":{errpos}\", arr, suggestions)",
  "}",
  "",
  "method error(message) atPosition(errlinenum, errpos)",
  "        withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (2..(errpos + errlinenum.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    arr := arr ++ \"^\"",
  "    util.generalError(message, errlinenum, \":{errpos}\", arr, suggestions)",
  "}",
  "",
  "method error(message) {",
  "    util.generalError(message, 0, \"\", \"\", [])",
  "}",
  "",
  "method error(message)atLine(errlinenum)withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (1..errlinenum.asString.size) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    if (errlinenum > 0) then {",
  "            arr := arr ++ (\"^\" * util.lines.at(errlinenum).size)",
  "    }",
  "    util.generalError(message, errlinenum, \"\", arr, suggestions)",
  "}",
  "",
  "method error(message)atLine(errlinenum) {",
  "    error(message)atLine(errlinenum)withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atLine(errlinenum) {",
  "    syntaxError(message)atLine(errlinenum)withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atLine(errlinenum)withSuggestion(suggestion') {",
  "    syntaxError(message)atLine(errlinenum)withSuggestions([suggestion'])",
  "}",
  "",
  "method syntaxError(message)atLine(errlinenum)withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (1..errlinenum.asString.size) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (1..util.lines.at(errlinenum).size) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.syntaxError(message, errlinenum, \"\", arr, suggestions)",
  "}",
  NULL
};
Object reader_errormessages_outer_757(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_errormessages_outer_760(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_errormessages_lineNumbers_761(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_errormessages_lines_762(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
static Object strlit2;
static Object strlit32;
static Object strlit37;
static Object strlit47;
static Object strlit56;
static Object strlit62;
static Object strlit66;
static Object strlit250;
static Object strlit255;
static Object strlit260;
static Object strlit264;
static Object strlit278;
static Object strlit309;
static Object strlit310;
static Object strlit363;
static Object strlit368;
static Object strlit372;
static Object strlit378;
static Object strlit383;
static Object strlit388;
static Object strlit392;
static Object strlit399;
static Object strlit415;
static Object strlit428;
static Object strlit436;
static Object strlit440;
static Object strlit476;
static Object strlit481;
static Object strlit485;
static Object strlit491;
static Object strlit496;
static Object strlit501;
static Object strlit505;
static Object strlit512;
static Object strlit528;
static Object strlit541;
static Object strlit549;
static Object strlit553;
static Object strlit577;
static Object strlit593;
static Object strlit600;
static Object strlit606;
static Object strlit610;
static Object strlit615;
static Object strlit631;
static Object strlit638;
static Object strlit644;
static Object strlit648;
static Object strlit655;
static Object strlit656;
static Object strlit660;
static Object strlit673;
static Object strlit693;
static Object strlit699;
static Object strlit714;
static Object strlit727;
static Object strlit747;
static Object strlit754;
Object module_io;
Object module_io_init();
Object module_sys;
Object module_sys_init();
Object module_util;
Object module_util_init();
static ClassData objclass756;
static ClassData objclass759;
static Object strlit881;
static Object strlit898;
static Object strlit902;
static Object strlit1113;
static Object strlit1218;
static Object strlit1422;
static Object strlit1439;
static Object strlit1447;
static Object strlit1451;
static Object strlit1473;
static Object strlit1482;
static Object strlit1492;
static Object strlit1502;
static Object strlit1511;
static Object strlit1519;
Object meth_errormessages_7__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object *var_count = getfromclosure(closure, 1);
  Object *var_xs = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  partcv[0] = 0;
  Object call10 = callmethodflags(*var_v, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe9);
// compiled member node returning call10 (depth = 6)
  int op_slot_right_8 = gc_frame_newslot(call10);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  int op_slot_left_8 = gc_frame_newslot(*var_result);
  params[0] = call10;
  partcv[0] = 1;
  Object opresult12 = callmethod(*var_result, "++(1)", 1, partcv, params);
// compiled op node returning opresult12 (depth = 5)
  *var_result = opresult12;
  if (opresult12 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num15 = alloc_Float64(1);
// compiled num node returning num15 (depth = 6)
  int op_slot_right_14 = gc_frame_newslot(num15);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_count (depth = 6)
  int op_slot_left_14 = gc_frame_newslot(*var_count);
  params[0] = num15;
  partcv[0] = 1;
  Object diff17 = callmethod(*var_count, "-(1)", 1, partcv, params);
// compiled op node returning diff17 (depth = 5)
  *var_count = diff17;
  if (diff17 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num21 = alloc_Float64(1);
// compiled num node returning num21 (depth = 6)
  int op_slot_right_20 = gc_frame_newslot(num21);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_count (depth = 6)
  int op_slot_left_20 = gc_frame_newslot(*var_count);
  params[0] = num21;
  partcv[0] = 1;
  Object opresult23 = callmethod(*var_count, "==(1)", 1, partcv, params);
// compiled op node returning opresult23 (depth = 5)
  Object if19 = done;
  if (istrue(opresult23)) {
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num26 = alloc_Float64(2);
// compiled num node returning num26 (depth = 7)
  int op_slot_right_25 = gc_frame_newslot(num26);
// starting to compile member node (depth = 7)
  int callframe28 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_xs (depth = 8)
  partcv[0] = 0;
  Object call29 = callmethodflags(*var_xs, "size", 1, partcv, params, 0);
  gc_frame_end(callframe28);
// compiled member node returning call29 (depth = 7)
  int op_slot_left_25 = gc_frame_newslot(call29);
  params[0] = num26;
  partcv[0] = 1;
  Object opresult30 = callmethod(call29, ">(1)", 1, partcv, params);
// compiled op node returning opresult30 (depth = 6)
  Object if24 = done;
  if (istrue(opresult30)) {
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit32 == NULL) {
    strlit32 = alloc_String(",");
    gc_root(strlit32);
  }
// compiled string node returning strlit32 (depth = 8)
  int op_slot_right_31 = gc_frame_newslot(strlit32);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_result (depth = 8)
  int op_slot_left_31 = gc_frame_newslot(*var_result);
  params[0] = strlit32;
  partcv[0] = 1;
  Object opresult34 = callmethod(*var_result, "++(1)", 1, partcv, params);
// compiled op node returning opresult34 (depth = 7)
  *var_result = opresult34;
  if (opresult34 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if24 = done;
  } else {
  }
// compiled if node returning if24 (depth = 5)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit37 == NULL) {
    strlit37 = alloc_String(" and ");
    gc_root(strlit37);
  }
// compiled string node returning strlit37 (depth = 7)
  int op_slot_right_36 = gc_frame_newslot(strlit37);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_result (depth = 7)
  int op_slot_left_36 = gc_frame_newslot(*var_result);
  params[0] = strlit37;
  partcv[0] = 1;
  Object opresult39 = callmethod(*var_result, "++(1)", 1, partcv, params);
// compiled op node returning opresult39 (depth = 6)
  *var_result = opresult39;
  if (opresult39 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if19 = done;
  } else {
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num43 = alloc_Float64(1);
// compiled num node returning num43 (depth = 7)
  int op_slot_right_42 = gc_frame_newslot(num43);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_count (depth = 7)
  int op_slot_left_42 = gc_frame_newslot(*var_count);
  params[0] = num43;
  partcv[0] = 1;
  Object opresult45 = callmethod(*var_count, ">(1)", 1, partcv, params);
// compiled op node returning opresult45 (depth = 6)
  Object if41 = done;
  if (istrue(opresult45)) {
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit47 == NULL) {
    strlit47 = alloc_String(", ");
    gc_root(strlit47);
  }
// compiled string node returning strlit47 (depth = 8)
  int op_slot_right_46 = gc_frame_newslot(strlit47);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_result (depth = 8)
  int op_slot_left_46 = gc_frame_newslot(*var_result);
  params[0] = strlit47;
  partcv[0] = 1;
  Object opresult49 = callmethod(*var_result, "++(1)", 1, partcv, params);
// compiled op node returning opresult49 (depth = 7)
  *var_result = opresult49;
  if (opresult49 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if41 = done;
  } else {
  }
// compiled if node returning if41 (depth = 5)
    gc_frame_newslot(if41);
    if19 = if41;
  }
// compiled if node returning if19 (depth = 4)
  gc_frame_end(frame);
  return if19;
}
Object meth_errormessages_1_readableStringFrom_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "readableStringFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method readableStringFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for readableStringFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_xs = &(stackframe->slots[0]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part readableStringFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
  Object *var_count = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "count");
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2 == NULL) {
    strlit2 = alloc_String("");
    gc_root(strlit2);
  }
// compiled string node returning strlit2 (depth = 3)
  *var_result = strlit2;
  if (strlit2 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_xs (depth = 4)
  partcv[0] = 0;
  Object call4 = callmethodflags(*var_xs, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3);
// compiled member node returning call4 (depth = 3)
  *var_count = call4;
  if (call4 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6 = alloc_Block(NULL, NULL, "errormessages", 285);
  gc_frame_newslot(block6);
// method "_apply(_)"
  block_savedest(block6);
  Object closure7 = createclosure(4, "_apply(1)");
  setclosureframe(closure7, stackframe);
  addtoclosure(closure7, var_result);
  addtoclosure(closure7, var_count);
  addtoclosure(closure7, var_xs);
  addtoclosure(closure7, selfslot);
  struct UserObject *uo7 = (struct UserObject*)block6;
  uo7->data[0] = (Object)closure7;
  Method *meth_meth_errormessages_7__apply_40_1_41_ = addmethod2pos(block6, "_apply(1)", &meth_errormessages_7__apply_40_1_41_, 0);
  int argcv_meth_errormessages_7__apply_40_1_41_[] = {1};
  meth_meth_errormessages_7__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_7__apply_40_1_41_);
  meth_meth_errormessages_7__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_7__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block6 (depth = 3)
  gc_frame_newslot(block6);
// call case 6: other requests
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  params[0] = block6;
  partcv[0] = 1;
  Object call52 = callmethodflags(*var_xs, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5);
// compiled call node returning call52 (depth = 2)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_errormessages_68__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num70 = alloc_Float64(1);
// compiled num node returning num70 (depth = 6)
  int op_slot_right_69 = gc_frame_newslot(num70);
// starting to compile member node (depth = 6)
  int callframe72 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call73 = callmethodflags(*var_p, "size", 1, partcv, params, 0);
  gc_frame_end(callframe72);
// compiled member node returning call73 (depth = 6)
  int op_slot_left_69 = gc_frame_newslot(call73);
  params[0] = num70;
  partcv[0] = 1;
  Object sum74 = callmethod(call73, "+(1)", 1, partcv, params);
// compiled op node returning sum74 (depth = 5)
  gc_frame_end(frame);
  return sum74;
}
Object meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name(1)mightBeIntendedToBe(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name(_)mightBeIntendedToBe(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name(_)mightBeIntendedToBe(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for name(_)mightBeIntendedToBe(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part name(_)");
  Object *var_target = &(stackframe->slots[1]);
  *var_target = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part mightBeIntendedToBe(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_parenIx = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "parenIx");
  Object *var_pPrefix = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "pPrefix");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_rng = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "rng");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit56 == NULL) {
    strlit56 = alloc_String("module()object");
    gc_root(strlit56);
  }
// compiled string node returning strlit56 (depth = 4)
  int op_slot_right_55 = gc_frame_newslot(strlit56);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  int op_slot_left_55 = gc_frame_newslot(*var_p);
  params[0] = strlit56;
  partcv[0] = 1;
  Object opresult58 = callmethod(*var_p, "==(1)", 1, partcv, params);
// compiled op node returning opresult58 (depth = 3)
  Object if54 = done;
  if (istrue(opresult58)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool59 = alloc_Boolean(0);
// compiled identifier node returning bool59 (depth = 4)
  return bool59;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if54 = undefined;
  } else {
  }
// compiled if node returning if54 (depth = 2)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe61 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit62 == NULL) {
    strlit62 = alloc_String("$");
    gc_root(strlit62);
  }
// compiled string node returning strlit62 (depth = 4)
  gc_frame_newslot(strlit62);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  params[0] = strlit62;
  partcv[0] = 1;
  Object call63 = callmethodflags(*var_p, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe61);
// compiled call node returning call63 (depth = 3)
  Object if60 = done;
  if (istrue(call63)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool64 = alloc_Boolean(0);
// compiled identifier node returning bool64 (depth = 4)
  return bool64;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if60 = undefined;
  } else {
  }
// compiled if node returning if60 (depth = 2)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe65 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit66 == NULL) {
    strlit66 = alloc_String("(");
    gc_root(strlit66);
  }
// compiled string node returning strlit66 (depth = 4)
  gc_frame_newslot(strlit66);
// starting to compile block node (depth = 4)
  Object block67 = alloc_Block(NULL, NULL, "errormessages", 301);
  gc_frame_newslot(block67);
// method "_apply"
  block_savedest(block67);
  Object closure68 = createclosure(2, "_apply");
  setclosureframe(closure68, stackframe);
  addtoclosure(closure68, var_p);
  addtoclosure(closure68, selfslot);
  struct UserObject *uo68 = (struct UserObject*)block67;
  uo68->data[0] = (Object)closure68;
  Method *meth_meth_errormessages_68__apply = addmethod2pos(block67, "_apply", &meth_errormessages_68__apply, 0);
  int argcv_meth_errormessages_68__apply[] = {0};
  meth_meth_errormessages_68__apply->type = alloc_MethodType(1, argcv_meth_errormessages_68__apply);
  meth_meth_errormessages_68__apply->definitionModule = modulename;
  meth_meth_errormessages_68__apply->definitionLine = 528;
// compiled block node returning block67 (depth = 4)
  gc_frame_newslot(block67);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  params[0] = strlit66;
  params[1] = block67;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call76 = callmethodflags(*var_p, "indexOf(1)ifAbsent(1)", 2, partcv, params, 0);
  gc_frame_end(callframe65);
// compiled call node returning call76 (depth = 3)
  *var_parenIx = call76;
  if (call76 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe77 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num78 = alloc_Float64(1);
// compiled num node returning num78 (depth = 4)
  gc_frame_newslot(num78);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num80 = alloc_Float64(1);
// compiled num node returning num80 (depth = 5)
  int op_slot_right_79 = gc_frame_newslot(num80);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_parenIx (depth = 5)
  int op_slot_left_79 = gc_frame_newslot(*var_parenIx);
  params[0] = num80;
  partcv[0] = 1;
  Object diff82 = callmethod(*var_parenIx, "-(1)", 1, partcv, params);
// compiled op node returning diff82 (depth = 4)
  gc_frame_newslot(diff82);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  params[0] = num78;
  params[1] = diff82;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call83 = callmethodflags(*var_p, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe77);
// compiled call node returning call83 (depth = 3)
  *var_pPrefix = call83;
  if (call83 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe85 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pPrefix (depth = 4)
  gc_frame_newslot(*var_pPrefix);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_target (depth = 4)
  params[0] = *var_pPrefix;
  partcv[0] = 1;
  Object call86 = callmethodflags(*var_target, "startsWith(1)", 1, partcv, params, 0);
  gc_frame_end(callframe85);
// compiled call node returning call86 (depth = 3)
  Object if84 = done;
  if (istrue(call86)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool87 = alloc_Boolean(1);
// compiled identifier node returning bool87 (depth = 4)
  return bool87;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if84 = undefined;
  } else {
  }
// compiled if node returning if84 (depth = 2)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num91 = alloc_Float64(2);
// compiled num node returning num91 (depth = 5)
  int op_slot_right_90 = gc_frame_newslot(num91);
// starting to compile member node (depth = 5)
  int callframe93 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  partcv[0] = 0;
  Object call94 = callmethodflags(*var_p, "size", 1, partcv, params, 0);
  gc_frame_end(callframe93);
// compiled member node returning call94 (depth = 5)
  int op_slot_left_90 = gc_frame_newslot(call94);
  params[0] = num91;
  partcv[0] = 1;
  Object prod95 = callmethod(call94, "*(1)", 1, partcv, params);
// compiled op node returning prod95 (depth = 4)
  int op_slot_right_89 = gc_frame_newslot(prod95);
// starting to compile member node (depth = 4)
  int callframe97 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_target (depth = 5)
  partcv[0] = 0;
  Object call98 = callmethodflags(*var_target, "size", 1, partcv, params, 0);
  gc_frame_end(callframe97);
// compiled member node returning call98 (depth = 4)
  int op_slot_left_89 = gc_frame_newslot(call98);
  params[0] = prod95;
  partcv[0] = 1;
  Object opresult99 = callmethod(call98, ">(1)", 1, partcv, params);
// compiled op node returning opresult99 (depth = 3)
  Object if88 = done;
  if (istrue(opresult99)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool100 = alloc_Boolean(0);
// compiled identifier node returning bool100 (depth = 4)
  return bool100;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if88 = undefined;
  } else {
  }
// compiled if node returning if88 (depth = 2)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe101 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  gc_frame_newslot(*var_p);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_target (depth = 4)
  gc_frame_newslot(*var_target);
// starting to compile num node (depth = 4)
  Object num102 = alloc_Float64(2);
// compiled num node returning num102 (depth = 4)
  gc_frame_newslot(num102);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_errormessages (depth = 4)
  params[0] = *var_p;
  params[1] = *var_target;
  params[2] = num102;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call103 = callmethodflags(module_errormessages, "name(1)matches(1)within(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe101);
// compiled call node returning call103 (depth = 3)
  *var_rng = call103;
  if (call103 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num106 = alloc_Float64(0);
// compiled num node returning num106 (depth = 4)
  int op_slot_right_105 = gc_frame_newslot(num106);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_rng (depth = 4)
  int op_slot_left_105 = gc_frame_newslot(*var_rng);
  params[0] = num106;
  partcv[0] = 1;
  Object opresult108 = callmethod(*var_rng, "==(1)", 1, partcv, params);
// compiled op node returning opresult108 (depth = 3)
  Object if104 = done;
  if (istrue(opresult108)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool109 = alloc_Boolean(0);
// compiled identifier node returning bool109 (depth = 4)
  return bool109;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if104 = undefined;
  } else {
  }
// compiled if node returning if104 (depth = 2)
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num113 = alloc_Float64(2);
// compiled num node returning num113 (depth = 5)
  int op_slot_right_112 = gc_frame_newslot(num113);
// starting to compile member node (depth = 5)
  int callframe115 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  partcv[0] = 0;
  Object call116 = callmethodflags(*var_p, "size", 1, partcv, params, 0);
  gc_frame_end(callframe115);
// compiled member node returning call116 (depth = 5)
  int op_slot_left_112 = gc_frame_newslot(call116);
  params[0] = num113;
  partcv[0] = 1;
  Object prod117 = callmethod(call116, "*(1)", 1, partcv, params);
// compiled op node returning prod117 (depth = 4)
  int op_slot_right_111 = gc_frame_newslot(prod117);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_rng (depth = 4)
  int op_slot_left_111 = gc_frame_newslot(*var_rng);
  params[0] = prod117;
  partcv[0] = 1;
  Object opresult119 = callmethod(*var_rng, ">(1)", 1, partcv, params);
// compiled op node returning opresult119 (depth = 3)
  Object if110 = done;
  if (istrue(opresult119)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool120 = alloc_Boolean(0);
// compiled identifier node returning bool120 (depth = 4)
  return bool120;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if110 = undefined;
  } else {
  }
// compiled if node returning if110 (depth = 2)
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool121 = alloc_Boolean(1);
// compiled identifier node returning bool121 (depth = 3)
  return bool121;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_errormessages_146__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_h = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe147 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num149 = alloc_Float64(1);
// compiled num node returning num149 (depth = 6)
  int op_slot_right_148 = gc_frame_newslot(num149);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_148 = gc_frame_newslot(*var_i);
  params[0] = num149;
  partcv[0] = 1;
  Object sum151 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum151 (depth = 5)
  gc_frame_newslot(sum151);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_h (depth = 5)
  params[0] = sum151;
  params[1] = *var_i;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call152 = callmethodflags(*var_h, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe147);
// compiled call node returning call152 (depth = 4)
  gc_frame_end(frame);
  return call152;
}
Object meth_errormessages_172__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[3];
  int partcv[2];
  Object *var_j = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_p = getfromclosure(closure, 2);
  Object *var_c = getfromclosure(closure, 3);
  Object *var_h = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_e = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "e");
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe175 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_j (depth = 12)
  gc_frame_newslot(*var_j);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  params[0] = *var_j;
  partcv[0] = 1;
  Object call176 = callmethodflags(*var_t, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe175);
// compiled call node returning call176 (depth = 11)
  int op_slot_right_174 = gc_frame_newslot(call176);
// starting to compile call node (depth = 11)
  int callframe178 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call179 = callmethodflags(*var_p, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe178);
// compiled call node returning call179 (depth = 11)
  int op_slot_left_174 = gc_frame_newslot(call179);
  params[0] = call176;
  partcv[0] = 1;
  Object opresult180 = callmethod(call179, "==(1)", 1, partcv, params);
// compiled op node returning opresult180 (depth = 10)
  Object if173 = done;
struct StackFrameObject *iftmpstackframe173 = stackframe;
  if (istrue(opresult180)) {
stackframe = alloc_StackFrame(0, iftmpstackframe173);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
    gc_frame_newslot(*var_c);
    if173 = *var_c;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe173);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num182 = alloc_Float64(1);
// compiled num node returning num182 (depth = 11)
  int op_slot_right_181 = gc_frame_newslot(num182);
// starting to compile call node (depth = 11)
  int callframe184 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe185 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_h (depth = 13)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call186 = callmethodflags(*var_h, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe185);
// compiled call node returning call186 (depth = 12)
  gc_frame_newslot(call186);
// starting to compile call node (depth = 12)
  int callframe187 = gc_frame_new();
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num189 = alloc_Float64(1);
// compiled num node returning num189 (depth = 14)
  int op_slot_right_188 = gc_frame_newslot(num189);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_i (depth = 14)
  int op_slot_left_188 = gc_frame_newslot(*var_i);
  params[0] = num189;
  partcv[0] = 1;
  Object sum191 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum191 (depth = 13)
  gc_frame_newslot(sum191);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_h (depth = 13)
  params[0] = sum191;
  partcv[0] = 1;
  Object call192 = callmethodflags(*var_h, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe187);
// compiled call node returning call192 (depth = 12)
  gc_frame_newslot(call192);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning module_errormessages (depth = 12)
  params[0] = call186;
  params[1] = call192;
  params[2] = *var_c;
  partcv[0] = 3;
  Object call193 = callmethodflags(module_errormessages, "min3(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe184);
// compiled call node returning call193 (depth = 11)
  int op_slot_left_181 = gc_frame_newslot(call193);
  params[0] = num182;
  partcv[0] = 1;
  Object sum194 = callmethod(call193, "+(1)", 1, partcv, params);
// compiled op node returning sum194 (depth = 10)
    gc_frame_newslot(sum194);
    if173 = sum194;
  }
stackframe = iftmpstackframe173;
// compiled if node returning if173 (depth = 9)
  *var_e = if173;
  if (if173 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe195 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num197 = alloc_Float64(1);
// compiled num node returning num197 (depth = 11)
  int op_slot_right_196 = gc_frame_newslot(num197);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_left_196 = gc_frame_newslot(*var_i);
  params[0] = num197;
  partcv[0] = 1;
  Object sum199 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum199 (depth = 10)
  gc_frame_newslot(sum199);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_h (depth = 10)
  params[0] = sum199;
  partcv[0] = 1;
  Object call200 = callmethodflags(*var_h, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe195);
// compiled call node returning call200 (depth = 9)
  *var_c = call200;
  if (call200 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe202 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num204 = alloc_Float64(1);
// compiled num node returning num204 (depth = 10)
  int op_slot_right_203 = gc_frame_newslot(num204);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_203 = gc_frame_newslot(*var_i);
  params[0] = num204;
  partcv[0] = 1;
  Object sum206 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum206 (depth = 9)
  gc_frame_newslot(sum206);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_e (depth = 9)
  gc_frame_newslot(*var_e);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_h (depth = 9)
  params[0] = sum206;
  params[1] = *var_e;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call207 = callmethodflags(*var_h, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe202);
// compiled call node returning call207 (depth = 8)
  gc_frame_end(frame);
  return call207;
}
Object meth_errormessages_212__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_top = getfromclosure(closure, 1);
  Object *var_h = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_k (depth = 9)
  int op_slot_right_213 = gc_frame_newslot(*var_k);
// starting to compile call node (depth = 9)
  int callframe215 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num217 = alloc_Float64(1);
// compiled num node returning num217 (depth = 11)
  int op_slot_right_216 = gc_frame_newslot(num217);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_top (depth = 11)
  int op_slot_left_216 = gc_frame_newslot(*var_top);
  params[0] = num217;
  partcv[0] = 1;
  Object sum219 = callmethod(*var_top, "+(1)", 1, partcv, params);
// compiled op node returning sum219 (depth = 10)
  gc_frame_newslot(sum219);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_h (depth = 10)
  params[0] = sum219;
  partcv[0] = 1;
  Object call220 = callmethodflags(*var_h, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe215);
// compiled call node returning call220 (depth = 9)
  int op_slot_left_213 = gc_frame_newslot(call220);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult221 = callmethod(call220, ">(1)", 1, partcv, params);
// compiled op node returning opresult221 (depth = 8)
  gc_frame_end(frame);
  return opresult221;
}
Object meth_errormessages_224__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_top = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num226 = alloc_Float64(1);
// compiled num node returning num226 (depth = 10)
  int op_slot_right_225 = gc_frame_newslot(num226);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_top (depth = 10)
  int op_slot_left_225 = gc_frame_newslot(*var_top);
  params[0] = num226;
  partcv[0] = 1;
  Object diff228 = callmethod(*var_top, "-(1)", 1, partcv, params);
// compiled op node returning diff228 (depth = 9)
  *var_top = diff228;
  if (diff228 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_164__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_top = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_p = getfromclosure(closure, 2);
  Object *var_h = getfromclosure(closure, 3);
  Object *var_k = getfromclosure(closure, 4);
  Object *var_m = getfromclosure(closure, 5);
  Object *var_maxResult = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_j = &(stackframe->slots[0]);
  *var_j = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_c = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "c");
// definebindings:
// definebindings:
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile num node (depth = 7)
  Object num165 = alloc_Float64(0);
// compiled num node returning num165 (depth = 7)
  *var_c = num165;
  if (num165 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe166 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_top (depth = 8)
  int op_slot_right_167 = gc_frame_newslot(*var_top);
// starting to compile num node (depth = 8)
  Object num169 = alloc_Float64(1);
// compiled num node returning num169 (depth = 8)
  int op_slot_left_167 = gc_frame_newslot(num169);
  params[0] = *var_top;
  partcv[0] = 1;
  Object opresult170 = callmethod(num169, "..(1)", 1, partcv, params);
// compiled op node returning opresult170 (depth = 7)
  gc_frame_newslot(opresult170);
// starting to compile block node (depth = 7)
  Object block171 = alloc_Block(NULL, NULL, "errormessages", 346);
  gc_frame_newslot(block171);
// method "_apply(_)"
  block_savedest(block171);
  Object closure172 = createclosure(6, "_apply(1)");
  setclosureframe(closure172, stackframe);
  addtoclosure(closure172, var_j);
  addtoclosure(closure172, var_t);
  addtoclosure(closure172, var_p);
  addtoclosure(closure172, var_c);
  addtoclosure(closure172, var_h);
  addtoclosure(closure172, selfslot);
  struct UserObject *uo172 = (struct UserObject*)block171;
  uo172->data[0] = (Object)closure172;
  Method *meth_meth_errormessages_172__apply_40_1_41_ = addmethod2pos(block171, "_apply(1)", &meth_errormessages_172__apply_40_1_41_, 0);
  int argcv_meth_errormessages_172__apply_40_1_41_[] = {1};
  meth_meth_errormessages_172__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_172__apply_40_1_41_);
  meth_meth_errormessages_172__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_172__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block171 (depth = 7)
  gc_frame_newslot(block171);
// call case 5: prelude request
  params[0] = opresult170;
  params[1] = block171;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call209 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe166);
// compiled call node returning call209 (depth = 6)
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe210 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block211 = alloc_Block(NULL, NULL, "errormessages", 355);
  gc_frame_newslot(block211);
// method "_apply"
  block_savedest(block211);
  Object closure212 = createclosure(4, "_apply");
  setclosureframe(closure212, stackframe);
  addtoclosure(closure212, var_k);
  addtoclosure(closure212, var_top);
  addtoclosure(closure212, var_h);
  addtoclosure(closure212, selfslot);
  struct UserObject *uo212 = (struct UserObject*)block211;
  uo212->data[0] = (Object)closure212;
  Method *meth_meth_errormessages_212__apply = addmethod2pos(block211, "_apply", &meth_errormessages_212__apply, 0);
  int argcv_meth_errormessages_212__apply[] = {0};
  meth_meth_errormessages_212__apply->type = alloc_MethodType(1, argcv_meth_errormessages_212__apply);
  meth_meth_errormessages_212__apply->definitionModule = modulename;
  meth_meth_errormessages_212__apply->definitionLine = 528;
// compiled block node returning block211 (depth = 7)
  gc_frame_newslot(block211);
// starting to compile block node (depth = 7)
  Object block223 = alloc_Block(NULL, NULL, "errormessages", 355);
  gc_frame_newslot(block223);
// method "_apply"
  block_savedest(block223);
  Object closure224 = createclosure(2, "_apply");
  setclosureframe(closure224, stackframe);
  addtoclosure(closure224, var_top);
  addtoclosure(closure224, selfslot);
  struct UserObject *uo224 = (struct UserObject*)block223;
  uo224->data[0] = (Object)closure224;
  Method *meth_meth_errormessages_224__apply = addmethod2pos(block223, "_apply", &meth_errormessages_224__apply, 0);
  int argcv_meth_errormessages_224__apply[] = {0};
  meth_meth_errormessages_224__apply->type = alloc_MethodType(1, argcv_meth_errormessages_224__apply);
  meth_meth_errormessages_224__apply->definitionModule = modulename;
  meth_meth_errormessages_224__apply->definitionLine = 528;
// compiled block node returning block223 (depth = 7)
  gc_frame_newslot(block223);
// call case 5: prelude request
  params[0] = block211;
  params[1] = block223;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call231 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe210);
// compiled call node returning call231 (depth = 6)
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_m (depth = 8)
  int op_slot_right_233 = gc_frame_newslot(*var_m);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_top (depth = 8)
  int op_slot_left_233 = gc_frame_newslot(*var_top);
  params[0] = *var_m;
  partcv[0] = 1;
  Object opresult235 = callmethod(*var_top, "==(1)", 1, partcv, params);
// compiled op node returning opresult235 (depth = 7)
  Object if232 = done;
  if (istrue(opresult235)) {
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe236 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_maxResult (depth = 9)
  gc_frame_newslot(*var_maxResult);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_j (depth = 9)
  gc_frame_newslot(*var_j);
// call case 5: prelude request
  params[0] = *var_maxResult;
  params[1] = *var_j;
  partcv[0] = 2;
  Object call237 = callmethodflags(prelude, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe236);
// compiled call node returning call237 (depth = 8)
  *var_maxResult = call237;
  if (call237 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if232 = done;
  } else {
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num240 = alloc_Float64(1);
// compiled num node returning num240 (depth = 9)
  int op_slot_right_239 = gc_frame_newslot(num240);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_top (depth = 9)
  int op_slot_left_239 = gc_frame_newslot(*var_top);
  params[0] = num240;
  partcv[0] = 1;
  Object sum242 = callmethod(*var_top, "+(1)", 1, partcv, params);
// compiled op node returning sum242 (depth = 8)
  *var_top = sum242;
  if (sum242 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if232 = done;
  }
// compiled if node returning if232 (depth = 6)
  gc_frame_end(frame);
  return if232;
}
Object meth_errormessages_157__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_top = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_p = getfromclosure(closure, 3);
  Object *var_h = getfromclosure(closure, 4);
  Object *var_k = getfromclosure(closure, 5);
  Object *var_m = getfromclosure(closure, 6);
  Object *var_maxResult = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe158 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_159 = gc_frame_newslot(*var_n);
// starting to compile num node (depth = 6)
  Object num161 = alloc_Float64(1);
// compiled num node returning num161 (depth = 6)
  int op_slot_left_159 = gc_frame_newslot(num161);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult162 = callmethod(num161, "..(1)", 1, partcv, params);
// compiled op node returning opresult162 (depth = 5)
  gc_frame_newslot(opresult162);
// starting to compile block node (depth = 5)
  Object block163 = alloc_Block(NULL, NULL, "errormessages", 344);
  gc_frame_newslot(block163);
// method "_apply(_)"
  block_savedest(block163);
  Object closure164 = createclosure(8, "_apply(1)");
  setclosureframe(closure164, stackframe);
  addtoclosure(closure164, var_top);
  addtoclosure(closure164, var_t);
  addtoclosure(closure164, var_p);
  addtoclosure(closure164, var_h);
  addtoclosure(closure164, var_k);
  addtoclosure(closure164, var_m);
  addtoclosure(closure164, var_maxResult);
  addtoclosure(closure164, selfslot);
  struct UserObject *uo164 = (struct UserObject*)block163;
  uo164->data[0] = (Object)closure164;
  Method *meth_meth_errormessages_164__apply_40_1_41_ = addmethod2pos(block163, "_apply(1)", &meth_errormessages_164__apply_40_1_41_, 0);
  int argcv_meth_errormessages_164__apply_40_1_41_[] = {1};
  meth_meth_errormessages_164__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_164__apply_40_1_41_);
  meth_meth_errormessages_164__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_164__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block163 (depth = 5)
  gc_frame_newslot(block163);
// call case 5: prelude request
  params[0] = opresult162;
  params[1] = block163;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call245 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe158);
// compiled call node returning call245 (depth = 4)
  gc_frame_end(frame);
  return call245;
}
Object meth_errormessages_248__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_p = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit250 == NULL) {
    strlit250 = alloc_String(")");
    gc_root(strlit250);
  }
// compiled string node returning strlit250 (depth = 6)
  int op_slot_right_249 = gc_frame_newslot(strlit250);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  int op_slot_right_252 = gc_frame_newslot(*var_k);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit255 == NULL) {
    strlit255 = alloc_String(")within(");
    gc_root(strlit255);
  }
// compiled string node returning strlit255 (depth = 8)
  int op_slot_right_254 = gc_frame_newslot(strlit255);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_right_257 = gc_frame_newslot(*var_t);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit260 == NULL) {
    strlit260 = alloc_String(")matches(");
    gc_root(strlit260);
  }
// compiled string node returning strlit260 (depth = 10)
  int op_slot_right_259 = gc_frame_newslot(strlit260);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  int op_slot_right_262 = gc_frame_newslot(*var_p);
// starting to compile string node (depth = 11)
  if (strlit264 == NULL) {
    strlit264 = alloc_String("BoundsError in name(");
    gc_root(strlit264);
  }
// compiled string node returning strlit264 (depth = 11)
  int op_slot_left_262 = gc_frame_newslot(strlit264);
  params[0] = *var_p;
  partcv[0] = 1;
  Object opresult265 = callmethod(strlit264, "++(1)", 1, partcv, params);
// compiled op node returning opresult265 (depth = 10)
  int op_slot_left_259 = gc_frame_newslot(opresult265);
  params[0] = strlit260;
  partcv[0] = 1;
  Object opresult266 = callmethod(opresult265, "++(1)", 1, partcv, params);
// compiled op node returning opresult266 (depth = 9)
  int op_slot_left_257 = gc_frame_newslot(opresult266);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult267 = callmethod(opresult266, "++(1)", 1, partcv, params);
// compiled op node returning opresult267 (depth = 8)
  int op_slot_left_254 = gc_frame_newslot(opresult267);
  params[0] = strlit255;
  partcv[0] = 1;
  Object opresult268 = callmethod(opresult267, "++(1)", 1, partcv, params);
// compiled op node returning opresult268 (depth = 7)
  int op_slot_left_252 = gc_frame_newslot(opresult268);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult269 = callmethod(opresult268, "++(1)", 1, partcv, params);
// compiled op node returning opresult269 (depth = 6)
  int op_slot_left_249 = gc_frame_newslot(opresult269);
  params[0] = strlit250;
  partcv[0] = 1;
  Object opresult270 = callmethod(opresult269, "++(1)", 1, partcv, params);
// compiled op node returning opresult270 (depth = 5)
  params[0] = opresult270;
  Object call271 = gracelib_print(NULL, 1,  params);
// compiled call node returning call271 (depth = 4)
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe272 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_e (depth = 5)
  partcv[0] = 0;
  Object call273 = callmethodflags(*var_e, "printBacktrace", 1, partcv, params, 0);
  gc_frame_end(callframe272);
// compiled member node returning call273 (depth = 4)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num274 = alloc_Float64(0);
// compiled num node returning num274 (depth = 5)
  block_return(realself, num274);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(9, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name(1)matches(1)within(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name(_)matches(_)within(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name(_)matches(_)within(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name(_)matches(_)within(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for name(_)matches(_)within(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part name(_)");
  Object *var_t = &(stackframe->slots[1]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part matches(_)");
  Object *var_k = &(stackframe->slots[2]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part within(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_m = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "m");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
// definebindings:
// definebindings:
  Object *var_top = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "top");
  Object *var_maxResult = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "maxResult");
  Object *var_h = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "h");
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe123 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  partcv[0] = 0;
  Object call124 = callmethodflags(*var_p, "size", 1, partcv, params, 0);
  gc_frame_end(callframe123);
// compiled member node returning call124 (depth = 3)
  *var_m = call124;
  if (call124 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe125 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  partcv[0] = 0;
  Object call126 = callmethodflags(*var_t, "size", 1, partcv, params, 0);
  gc_frame_end(callframe125);
// compiled member node returning call126 (depth = 3)
  *var_n = call126;
  if (call126 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_128 = gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_m (depth = 4)
  int op_slot_left_128 = gc_frame_newslot(*var_m);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult130 = callmethod(*var_m, "≤(1)", 1, partcv, params);
// compiled op node returning opresult130 (depth = 3)
  Object if127 = done;
  if (istrue(opresult130)) {
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe131 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  gc_frame_newslot(*var_m);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 5: prelude request
  params[0] = *var_m;
  params[1] = *var_n;
  partcv[0] = 2;
  Object call132 = callmethodflags(prelude, "min(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe131);
// compiled call node returning call132 (depth = 4)
  return call132;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if127 = undefined;
  } else {
  }
// compiled if node returning if127 (depth = 2)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num134 = alloc_Float64(1);
// compiled num node returning num134 (depth = 4)
  int op_slot_right_133 = gc_frame_newslot(num134);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_left_133 = gc_frame_newslot(*var_k);
  params[0] = num134;
  partcv[0] = 1;
  Object sum136 = callmethod(*var_k, "+(1)", 1, partcv, params);
// compiled op node returning sum136 (depth = 3)
  *var_top = sum136;
  if (sum136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num137 = alloc_Float64(0);
// compiled num node returning num137 (depth = 3)
  *var_maxResult = num137;
  if (num137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe138 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call139 = callmethodflags(prelude, "emptyList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe138);
// compiled member node returning call139 (depth = 3)
  *var_h = call139;
  if (call139 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe140 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_m (depth = 4)
  int op_slot_right_141 = gc_frame_newslot(*var_m);
// starting to compile num node (depth = 4)
  Object num143 = alloc_Float64(0);
// compiled num node returning num143 (depth = 4)
  int op_slot_left_141 = gc_frame_newslot(num143);
  params[0] = *var_m;
  partcv[0] = 1;
  Object opresult144 = callmethod(num143, "..(1)", 1, partcv, params);
// compiled op node returning opresult144 (depth = 3)
  gc_frame_newslot(opresult144);
// starting to compile block node (depth = 3)
  Object block145 = alloc_Block(NULL, NULL, "errormessages", 342);
  gc_frame_newslot(block145);
// method "_apply(_)"
  block_savedest(block145);
  Object closure146 = createclosure(2, "_apply(1)");
  setclosureframe(closure146, stackframe);
  addtoclosure(closure146, var_h);
  addtoclosure(closure146, selfslot);
  struct UserObject *uo146 = (struct UserObject*)block145;
  uo146->data[0] = (Object)closure146;
  Method *meth_meth_errormessages_146__apply_40_1_41_ = addmethod2pos(block145, "_apply(1)", &meth_errormessages_146__apply_40_1_41_, 0);
  int argcv_meth_errormessages_146__apply_40_1_41_[] = {1};
  meth_meth_errormessages_146__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_146__apply_40_1_41_);
  meth_meth_errormessages_146__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_146__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block145 (depth = 3)
  gc_frame_newslot(block145);
// call case 5: prelude request
  params[0] = opresult144;
  params[1] = block145;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call154 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe140);
// compiled call node returning call154 (depth = 2)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block156 = alloc_Block(NULL, NULL, "errormessages", 343);
  gc_frame_newslot(block156);
// method "_apply"
  block_savedest(block156);
  Object closure157 = createclosure(9, "_apply");
  setclosureframe(closure157, stackframe);
  addtoclosure(closure157, var_n);
  addtoclosure(closure157, var_top);
  addtoclosure(closure157, var_t);
  addtoclosure(closure157, var_p);
  addtoclosure(closure157, var_h);
  addtoclosure(closure157, var_k);
  addtoclosure(closure157, var_m);
  addtoclosure(closure157, var_maxResult);
  addtoclosure(closure157, selfslot);
  struct UserObject *uo157 = (struct UserObject*)block156;
  uo157->data[0] = (Object)closure157;
  Method *meth_meth_errormessages_157__apply = addmethod2pos(block156, "_apply", &meth_errormessages_157__apply, 0);
  int argcv_meth_errormessages_157__apply[] = {0};
  meth_meth_errormessages_157__apply->type = alloc_MethodType(1, argcv_meth_errormessages_157__apply);
  meth_meth_errormessages_157__apply->definitionModule = modulename;
  meth_meth_errormessages_157__apply->definitionLine = 528;
// compiled block node returning block156 (depth = 3)
  int frame155 = gc_frame_new();
  gc_frame_newslot(block156);
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block247 = alloc_Block(NULL, NULL, "errormessages", 363);
  gc_frame_newslot(block247);
// method "_apply(_)"
  block_savedest(block247);
  Object closure248 = createclosure(4, "_apply(1)");
  setclosureframe(closure248, stackframe);
  addtoclosure(closure248, var_k);
  addtoclosure(closure248, var_t);
  addtoclosure(closure248, var_p);
  addtoclosure(closure248, selfslot);
  struct UserObject *uo248 = (struct UserObject*)block247;
  uo248->data[0] = (Object)closure248;
  Method *meth_meth_errormessages_248__apply_40_1_41_ = addmethod2pos(block247, "_apply(1)", &meth_errormessages_248__apply_40_1_41_, 0);
  int argcv_meth_errormessages_248__apply_40_1_41_[] = {1};
  meth_meth_errormessages_248__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_248__apply_40_1_41_);
  meth_meth_errormessages_248__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_248__apply_40_1_41_->definitionLine = 528;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe276 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe277 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit278 == NULL) {
    strlit278 = alloc_String("e");
    gc_root(strlit278);
  }
// compiled string node returning strlit278 (depth = 6)
  gc_frame_newslot(strlit278);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe279 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call280 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe279);
// compiled member node returning call280 (depth = 6)
  params[0] = strlit278;
  partcv[0] = 1;
  Object call281 = callmethodflags(call280, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe277);
// compiled call node returning call281 (depth = 5)
  gc_frame_newslot(call281);
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe282 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call283 = callmethodflags(prelude, "BoundsError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe282);
// compiled member node returning call283 (depth = 5)
  gc_frame_newslot(call283);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe284 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call285 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe284);
// compiled member node returning call285 (depth = 5)
  params[0] = call281;
  params[1] = call283;
  partcv[0] = 2;
  Object call286 = callmethodflags(call285, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe276);
// compiled call node returning call286 (depth = 4)
((struct UserObject *)block247)->data[1] = call286;
// compiled block node returning block247 (depth = 3)
  gc_frame_newslot(block247);
  params[0] = block247;
  setline(343);
  Object catchres155 = tryCatch(block156, params, 1,NULL);
  gc_frame_end(frame155);
// compiled trycatch node returning catchres155 (depth = 2)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_maxResult (depth = 3)
  return *var_maxResult;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_errormessages_287_min3_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "min3(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method min3(_,_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for min3(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *var_c = &(stackframe->slots[2]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part min3(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sf = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "sf");
// definebindings:
// definebindings:
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  int op_slot_right_289 = gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  int op_slot_left_289 = gc_frame_newslot(*var_a);
  params[0] = *var_b;
  partcv[0] = 1;
  Object opresult291 = callmethod(*var_a, "<(1)", 1, partcv, params);
// compiled op node returning opresult291 (depth = 4)
  Object if288 = done;
struct StackFrameObject *iftmpstackframe288 = stackframe;
  if (istrue(opresult291)) {
stackframe = alloc_StackFrame(0, iftmpstackframe288);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
    gc_frame_newslot(*var_a);
    if288 = *var_a;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe288);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
    gc_frame_newslot(*var_b);
    if288 = *var_b;
  }
stackframe = iftmpstackframe288;
// compiled if node returning if288 (depth = 3)
  *var_sf = if288;
  if (if288 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_right_293 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sf (depth = 4)
  int op_slot_left_293 = gc_frame_newslot(*var_sf);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult295 = callmethod(*var_sf, "<(1)", 1, partcv, params);
// compiled op node returning opresult295 (depth = 3)
  Object if292 = done;
  if (istrue(opresult295)) {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sf (depth = 3)
    gc_frame_newslot(*var_sf);
    if292 = *var_sf;
  } else {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
    gc_frame_newslot(*var_c);
    if292 = *var_c;
  }
// compiled if node returning if292 (depth = 2)
  gc_frame_end(frame);
  return if292;
}
Object meth_errormessages_296_syntaxError_40_1_41_atRange_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_more = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "more");
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe299 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe300 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  partcv[0] = 0;
  Object call301 = callmethodflags(*var_r, "end", 1, partcv, params, 0);
  gc_frame_end(callframe300);
// compiled member node returning call301 (depth = 6)
  partcv[0] = 0;
  Object call302 = callmethodflags(call301, "line", 1, partcv, params, 0);
  gc_frame_end(callframe299);
// compiled member node returning call302 (depth = 5)
  int op_slot_right_298 = gc_frame_newslot(call302);
// starting to compile member node (depth = 5)
  int callframe304 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe305 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  partcv[0] = 0;
  Object call306 = callmethodflags(*var_r, "start", 1, partcv, params, 0);
  gc_frame_end(callframe305);
// compiled member node returning call306 (depth = 6)
  partcv[0] = 0;
  Object call307 = callmethodflags(call306, "line", 1, partcv, params, 0);
  gc_frame_end(callframe304);
// compiled member node returning call307 (depth = 5)
  int op_slot_left_298 = gc_frame_newslot(call307);
  params[0] = call302;
  partcv[0] = 1;
  Object opresult308 = callmethod(call307, "<(1)", 1, partcv, params);
// compiled op node returning opresult308 (depth = 4)
  Object if297 = done;
struct StackFrameObject *iftmpstackframe297 = stackframe;
  if (istrue(opresult308)) {
stackframe = alloc_StackFrame(0, iftmpstackframe297);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit309 == NULL) {
    strlit309 = alloc_String("  This statement spans multiple lines; is that what you intended?");
    gc_root(strlit309);
  }
// compiled string node returning strlit309 (depth = 4)
    gc_frame_newslot(strlit309);
    if297 = strlit309;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe297);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit310 == NULL) {
    strlit310 = alloc_String("");
    gc_root(strlit310);
  }
// compiled string node returning strlit310 (depth = 4)
    gc_frame_newslot(strlit310);
    if297 = strlit310;
  }
stackframe = iftmpstackframe297;
// compiled if node returning if297 (depth = 3)
  *var_more = if297;
  if (if297 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe311 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_more (depth = 4)
  int op_slot_right_312 = gc_frame_newslot(*var_more);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_message (depth = 4)
  int op_slot_left_312 = gc_frame_newslot(*var_message);
  params[0] = *var_more;
  partcv[0] = 1;
  Object opresult314 = callmethod(*var_message, "++(1)", 1, partcv, params);
// compiled op node returning opresult314 (depth = 3)
  gc_frame_newslot(opresult314);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  gc_frame_newslot(*var_r);
// starting to compile array node (depth = 3)
  Object array315 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array315 (depth = 3)
  gc_frame_newslot(array315);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = opresult314;
  params[1] = *var_r;
  params[2] = array315;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call316 = callmethodflags(module_errormessages, "syntaxError(1)atRange(1)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe311);
// compiled call node returning call316 (depth = 2)
  gc_frame_end(frame);
  return call316;
}
Object meth_errormessages_317_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(1)withSuggestion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestion(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestion(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestion(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_)withSuggestion(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestion(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe318 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  gc_frame_newslot(*var_r);
// starting to compile array node (depth = 3)
  Object array319 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  callmethodflags(array319, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array319 (depth = 3)
  gc_frame_newslot(array319);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_r;
  params[2] = array319;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call320 = callmethodflags(module_errormessages, "syntaxError(1)atRange(1)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe318);
// compiled call node returning call320 (depth = 2)
  gc_frame_end(frame);
  return call320;
}
Object meth_errormessages_321_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(1)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_)withSuggestions(_)");
  Object params[6];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe322 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe323 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe324 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  partcv[0] = 0;
  Object call325 = callmethodflags(*var_r, "start", 1, partcv, params, 0);
  gc_frame_end(callframe324);
// compiled member node returning call325 (depth = 4)
  partcv[0] = 0;
  Object call326 = callmethodflags(call325, "line", 1, partcv, params, 0);
  gc_frame_end(callframe323);
// compiled member node returning call326 (depth = 3)
  gc_frame_newslot(call326);
// starting to compile member node (depth = 3)
  int callframe327 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe328 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  partcv[0] = 0;
  Object call329 = callmethodflags(*var_r, "start", 1, partcv, params, 0);
  gc_frame_end(callframe328);
// compiled member node returning call329 (depth = 4)
  partcv[0] = 0;
  Object call330 = callmethodflags(call329, "column", 1, partcv, params, 0);
  gc_frame_end(callframe327);
// compiled member node returning call330 (depth = 3)
  gc_frame_newslot(call330);
// starting to compile member node (depth = 3)
  int callframe331 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe332 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  partcv[0] = 0;
  Object call333 = callmethodflags(*var_r, "end", 1, partcv, params, 0);
  gc_frame_end(callframe332);
// compiled member node returning call333 (depth = 4)
  partcv[0] = 0;
  Object call334 = callmethodflags(call333, "line", 1, partcv, params, 0);
  gc_frame_end(callframe331);
// compiled member node returning call334 (depth = 3)
  gc_frame_newslot(call334);
// starting to compile member node (depth = 3)
  int callframe335 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe336 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  partcv[0] = 0;
  Object call337 = callmethodflags(*var_r, "end", 1, partcv, params, 0);
  gc_frame_end(callframe336);
// compiled member node returning call337 (depth = 4)
  partcv[0] = 0;
  Object call338 = callmethodflags(call337, "column", 1, partcv, params, 0);
  gc_frame_end(callframe335);
// compiled member node returning call338 (depth = 3)
  gc_frame_newslot(call338);
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = call326;
  params[2] = call330;
  params[3] = call334;
  params[4] = call338;
  params[5] = *var_s;
  partcv[0] = 1;
  partcv[1] = 4;
  partcv[2] = 1;
  Object call339 = callmethodflags(module_errormessages, "syntaxError(1)atRange(4)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe322);
// compiled call node returning call339 (depth = 2)
  gc_frame_end(frame);
  return call339;
}
Object meth_errormessages_340_syntaxError_40_1_41_atRange_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)");
  Object params[5];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_,_,_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe341 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// starting to compile array node (depth = 3)
  Object array342 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array342 (depth = 3)
  gc_frame_newslot(array342);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_endpos;
  params[4] = array342;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call343 = callmethodflags(module_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe341);
// compiled call node returning call343 (depth = 2)
  gc_frame_end(frame);
  return call343;
}
Object meth_errormessages_344_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(3)withSuggestion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestion(_)");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestion(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestion(_)");
  Object params[5];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_,_,_)withSuggestion(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_)");
  Object *var_suggestion_39_ = &(stackframe->slots[4]);
  *var_suggestion_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestion(_)");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe345 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// starting to compile array node (depth = 3)
  Object array346 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion_39_ (depth = 4)
  params[0] = *var_suggestion_39_;
  partcv[0] = 1;
  callmethodflags(array346, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array346 (depth = 3)
  gc_frame_newslot(array346);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_endpos;
  params[4] = array346;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call347 = callmethodflags(module_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe345);
// compiled call node returning call347 (depth = 2)
  gc_frame_end(frame);
  return call347;
}
Object meth_errormessages_348_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atRange(3)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_)withSuggestions(_)");
  Object params[6];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_,_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_)");
  Object *var_suggestions = &(stackframe->slots[4]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe349 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_errlinenum;
  params[4] = *var_endpos;
  params[5] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 4;
  partcv[2] = 1;
  Object call350 = callmethodflags(module_errormessages, "syntaxError(1)atRange(4)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe349);
// compiled call node returning call350 (depth = 2)
  gc_frame_end(frame);
  return call350;
}
Object meth_errormessages_413__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit415 == NULL) {
    strlit415 = alloc_String("-");
    gc_root(strlit415);
  }
// compiled string node returning strlit415 (depth = 6)
  int op_slot_right_414 = gc_frame_newslot(strlit415);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_414 = gc_frame_newslot(*var_arr);
  params[0] = strlit415;
  partcv[0] = 1;
  Object opresult417 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult417 (depth = 5)
  *var_arr = opresult417;
  if (opresult417 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_426__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___2 = &(stackframe->slots[0]);
  *var___2 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit428 == NULL) {
    strlit428 = alloc_String("^");
    gc_root(strlit428);
  }
// compiled string node returning strlit428 (depth = 6)
  int op_slot_right_427 = gc_frame_newslot(strlit428);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_427 = gc_frame_newslot(*var_arr);
  params[0] = strlit428;
  partcv[0] = 1;
  Object opresult430 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult430 (depth = 5)
  *var_arr = opresult430;
  if (opresult430 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_351_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "syntaxError(1)atRange(4)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 4)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atRange(_,_,_,_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atRange(_,_,_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_startline = &(stackframe->slots[1]);
  *var_startline = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endline = &(stackframe->slots[3]);
  *var_endline = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[4]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 4)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_,_)");
  Object *var_suggestions = &(stackframe->slots[5]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_loc = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "loc");
  Object *var_arr = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "arr");
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_endline (depth = 5)
  int op_slot_right_353 = gc_frame_newslot(*var_endline);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startline (depth = 5)
  int op_slot_left_353 = gc_frame_newslot(*var_startline);
  params[0] = *var_endline;
  partcv[0] = 1;
  Object opresult355 = callmethod(*var_startline, "==(1)", 1, partcv, params);
// compiled op node returning opresult355 (depth = 4)
  Object if352 = done;
struct StackFrameObject *iftmpstackframe352 = stackframe;
  if (istrue(opresult355)) {
stackframe = alloc_StackFrame(0, iftmpstackframe352);
gc_frame_newslot((Object)stackframe);
// definebindings:
// definebindings:
// definebindings:
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endpos (depth = 6)
  int op_slot_right_357 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startpos (depth = 6)
  int op_slot_left_357 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult359 = callmethod(*var_startpos, "==(1)", 1, partcv, params);
// compiled op node returning opresult359 (depth = 5)
  Object if356 = done;
  if (istrue(opresult359)) {
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe360 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startpos (depth = 6)
  partcv[0] = 0;
  Object call361 = callmethodflags(*var_startpos, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe360);
// compiled member node returning call361 (depth = 5)
    gc_frame_newslot(call361);
    if356 = call361;
  } else {
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit363 == NULL) {
    strlit363 = alloc_String("");
    gc_root(strlit363);
  }
// compiled string node returning strlit363 (depth = 6)
  int op_slot_right_362 = gc_frame_newslot(strlit363);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_endpos (depth = 7)
  int op_slot_right_365 = gc_frame_newslot(*var_endpos);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit368 == NULL) {
    strlit368 = alloc_String("-");
    gc_root(strlit368);
  }
// compiled string node returning strlit368 (depth = 8)
  int op_slot_right_367 = gc_frame_newslot(strlit368);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_startpos (depth = 9)
  int op_slot_right_370 = gc_frame_newslot(*var_startpos);
// starting to compile string node (depth = 9)
  if (strlit372 == NULL) {
    strlit372 = alloc_String("");
    gc_root(strlit372);
  }
// compiled string node returning strlit372 (depth = 9)
  int op_slot_left_370 = gc_frame_newslot(strlit372);
  params[0] = *var_startpos;
  partcv[0] = 1;
  Object opresult373 = callmethod(strlit372, "++(1)", 1, partcv, params);
// compiled op node returning opresult373 (depth = 8)
  int op_slot_left_367 = gc_frame_newslot(opresult373);
  params[0] = strlit368;
  partcv[0] = 1;
  Object opresult374 = callmethod(opresult373, "++(1)", 1, partcv, params);
// compiled op node returning opresult374 (depth = 7)
  int op_slot_left_365 = gc_frame_newslot(opresult374);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult375 = callmethod(opresult374, "++(1)", 1, partcv, params);
// compiled op node returning opresult375 (depth = 6)
  int op_slot_left_362 = gc_frame_newslot(opresult375);
  params[0] = strlit363;
  partcv[0] = 1;
  Object opresult376 = callmethod(opresult375, "++(1)", 1, partcv, params);
// compiled op node returning opresult376 (depth = 5)
    gc_frame_newslot(opresult376);
    if356 = opresult376;
  }
// compiled if node returning if356 (depth = 4)
    gc_frame_newslot(if356);
    if352 = if356;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe352);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit378 == NULL) {
    strlit378 = alloc_String("");
    gc_root(strlit378);
  }
// compiled string node returning strlit378 (depth = 5)
  int op_slot_right_377 = gc_frame_newslot(strlit378);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endpos (depth = 6)
  int op_slot_right_380 = gc_frame_newslot(*var_endpos);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit383 == NULL) {
    strlit383 = alloc_String(":");
    gc_root(strlit383);
  }
// compiled string node returning strlit383 (depth = 7)
  int op_slot_right_382 = gc_frame_newslot(strlit383);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_endline (depth = 8)
  int op_slot_right_385 = gc_frame_newslot(*var_endline);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit388 == NULL) {
    strlit388 = alloc_String("-");
    gc_root(strlit388);
  }
// compiled string node returning strlit388 (depth = 9)
  int op_slot_right_387 = gc_frame_newslot(strlit388);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_startpos (depth = 10)
  int op_slot_right_390 = gc_frame_newslot(*var_startpos);
// starting to compile string node (depth = 10)
  if (strlit392 == NULL) {
    strlit392 = alloc_String("");
    gc_root(strlit392);
  }
// compiled string node returning strlit392 (depth = 10)
  int op_slot_left_390 = gc_frame_newslot(strlit392);
  params[0] = *var_startpos;
  partcv[0] = 1;
  Object opresult393 = callmethod(strlit392, "++(1)", 1, partcv, params);
// compiled op node returning opresult393 (depth = 9)
  int op_slot_left_387 = gc_frame_newslot(opresult393);
  params[0] = strlit388;
  partcv[0] = 1;
  Object opresult394 = callmethod(opresult393, "++(1)", 1, partcv, params);
// compiled op node returning opresult394 (depth = 8)
  int op_slot_left_385 = gc_frame_newslot(opresult394);
  params[0] = *var_endline;
  partcv[0] = 1;
  Object opresult395 = callmethod(opresult394, "++(1)", 1, partcv, params);
// compiled op node returning opresult395 (depth = 7)
  int op_slot_left_382 = gc_frame_newslot(opresult395);
  params[0] = strlit383;
  partcv[0] = 1;
  Object opresult396 = callmethod(opresult395, "++(1)", 1, partcv, params);
// compiled op node returning opresult396 (depth = 6)
  int op_slot_left_380 = gc_frame_newslot(opresult396);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult397 = callmethod(opresult396, "++(1)", 1, partcv, params);
// compiled op node returning opresult397 (depth = 5)
  int op_slot_left_377 = gc_frame_newslot(opresult397);
  params[0] = strlit378;
  partcv[0] = 1;
  Object opresult398 = callmethod(opresult397, "++(1)", 1, partcv, params);
// compiled op node returning opresult398 (depth = 4)
    gc_frame_newslot(opresult398);
    if352 = opresult398;
  }
stackframe = iftmpstackframe352;
// compiled if node returning if352 (depth = 3)
  *var_loc = if352;
  if (if352 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit399 == NULL) {
    strlit399 = alloc_String("----");
    gc_root(strlit399);
  }
// compiled string node returning strlit399 (depth = 3)
  *var_arr = strlit399;
  if (strlit399 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe400 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe403 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe404 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startline (depth = 7)
  partcv[0] = 0;
  Object call405 = callmethodflags(*var_startline, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe404);
// compiled member node returning call405 (depth = 6)
  partcv[0] = 0;
  Object call406 = callmethodflags(call405, "size", 1, partcv, params, 0);
  gc_frame_end(callframe403);
// compiled member node returning call406 (depth = 5)
  int op_slot_right_402 = gc_frame_newslot(call406);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_402 = gc_frame_newslot(*var_startpos);
  params[0] = call406;
  partcv[0] = 1;
  Object sum408 = callmethod(*var_startpos, "+(1)", 1, partcv, params);
// compiled op node returning sum408 (depth = 4)
  int op_slot_right_401 = gc_frame_newslot(sum408);
// starting to compile num node (depth = 4)
  Object num410 = alloc_Float64(2);
// compiled num node returning num410 (depth = 4)
  int op_slot_left_401 = gc_frame_newslot(num410);
  params[0] = sum408;
  partcv[0] = 1;
  Object opresult411 = callmethod(num410, "..(1)", 1, partcv, params);
// compiled op node returning opresult411 (depth = 3)
  gc_frame_newslot(opresult411);
// starting to compile block node (depth = 3)
  Object block412 = alloc_Block(NULL, NULL, "errormessages", 420);
  gc_frame_newslot(block412);
// method "_apply(_)"
  block_savedest(block412);
  Object closure413 = createclosure(2, "_apply(1)");
  setclosureframe(closure413, stackframe);
  addtoclosure(closure413, var_arr);
  addtoclosure(closure413, selfslot);
  struct UserObject *uo413 = (struct UserObject*)block412;
  uo413->data[0] = (Object)closure413;
  Method *meth_meth_errormessages_413__apply_40_1_41_ = addmethod2pos(block412, "_apply(1)", &meth_errormessages_413__apply_40_1_41_, 0);
  int argcv_meth_errormessages_413__apply_40_1_41_[] = {1};
  meth_meth_errormessages_413__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_413__apply_40_1_41_);
  meth_meth_errormessages_413__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_413__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block412 (depth = 3)
  gc_frame_newslot(block412);
// call case 5: prelude request
  params[0] = opresult411;
  params[1] = block412;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call420 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe400);
// compiled call node returning call420 (depth = 2)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe421 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_endpos (depth = 4)
  int op_slot_right_422 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startpos (depth = 4)
  int op_slot_left_422 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult424 = callmethod(*var_startpos, "..(1)", 1, partcv, params);
// compiled op node returning opresult424 (depth = 3)
  gc_frame_newslot(opresult424);
// starting to compile block node (depth = 3)
  Object block425 = alloc_Block(NULL, NULL, "errormessages", 423);
  gc_frame_newslot(block425);
// method "_apply(_)"
  block_savedest(block425);
  Object closure426 = createclosure(2, "_apply(1)");
  setclosureframe(closure426, stackframe);
  addtoclosure(closure426, var_arr);
  addtoclosure(closure426, selfslot);
  struct UserObject *uo426 = (struct UserObject*)block425;
  uo426->data[0] = (Object)closure426;
  Method *meth_meth_errormessages_426__apply_40_1_41_ = addmethod2pos(block425, "_apply(1)", &meth_errormessages_426__apply_40_1_41_, 0);
  int argcv_meth_errormessages_426__apply_40_1_41_[] = {1};
  meth_meth_errormessages_426__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_426__apply_40_1_41_);
  meth_meth_errormessages_426__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_426__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block425 (depth = 3)
  gc_frame_newslot(block425);
// call case 5: prelude request
  params[0] = opresult424;
  params[1] = block425;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call433 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe421);
// compiled call node returning call433 (depth = 2)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe434 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startline (depth = 3)
  gc_frame_newslot(*var_startline);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit436 == NULL) {
    strlit436 = alloc_String("");
    gc_root(strlit436);
  }
// compiled string node returning strlit436 (depth = 4)
  int op_slot_right_435 = gc_frame_newslot(strlit436);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loc (depth = 5)
  int op_slot_right_438 = gc_frame_newslot(*var_loc);
// starting to compile string node (depth = 5)
  if (strlit440 == NULL) {
    strlit440 = alloc_String(":");
    gc_root(strlit440);
  }
// compiled string node returning strlit440 (depth = 5)
  int op_slot_left_438 = gc_frame_newslot(strlit440);
  params[0] = *var_loc;
  partcv[0] = 1;
  Object opresult441 = callmethod(strlit440, "++(1)", 1, partcv, params);
// compiled op node returning opresult441 (depth = 4)
  int op_slot_left_435 = gc_frame_newslot(opresult441);
  params[0] = strlit436;
  partcv[0] = 1;
  Object opresult442 = callmethod(opresult441, "++(1)", 1, partcv, params);
// compiled op node returning opresult442 (depth = 3)
  gc_frame_newslot(opresult442);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_startline;
  params[2] = opresult442;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call443 = callmethodflags(*var_util, "syntaxError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe434);
// compiled call node returning call443 (depth = 2)
  gc_frame_end(frame);
  return call443;
}
Object meth_errormessages_444_error_40_1_41_atRange_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error(1)atRange(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_)");
  Object params[6];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atRange(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe445 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe446 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe447 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  partcv[0] = 0;
  Object call448 = callmethodflags(*var_r, "start", 1, partcv, params, 0);
  gc_frame_end(callframe447);
// compiled member node returning call448 (depth = 4)
  partcv[0] = 0;
  Object call449 = callmethodflags(call448, "line", 1, partcv, params, 0);
  gc_frame_end(callframe446);
// compiled member node returning call449 (depth = 3)
  gc_frame_newslot(call449);
// starting to compile member node (depth = 3)
  int callframe450 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe451 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  partcv[0] = 0;
  Object call452 = callmethodflags(*var_r, "start", 1, partcv, params, 0);
  gc_frame_end(callframe451);
// compiled member node returning call452 (depth = 4)
  partcv[0] = 0;
  Object call453 = callmethodflags(call452, "column", 1, partcv, params, 0);
  gc_frame_end(callframe450);
// compiled member node returning call453 (depth = 3)
  gc_frame_newslot(call453);
// starting to compile member node (depth = 3)
  int callframe454 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe455 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  partcv[0] = 0;
  Object call456 = callmethodflags(*var_r, "end", 1, partcv, params, 0);
  gc_frame_end(callframe455);
// compiled member node returning call456 (depth = 4)
  partcv[0] = 0;
  Object call457 = callmethodflags(call456, "line", 1, partcv, params, 0);
  gc_frame_end(callframe454);
// compiled member node returning call457 (depth = 3)
  gc_frame_newslot(call457);
// starting to compile member node (depth = 3)
  int callframe458 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe459 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_r (depth = 5)
  partcv[0] = 0;
  Object call460 = callmethodflags(*var_r, "end", 1, partcv, params, 0);
  gc_frame_end(callframe459);
// compiled member node returning call460 (depth = 4)
  partcv[0] = 0;
  Object call461 = callmethodflags(call460, "column", 1, partcv, params, 0);
  gc_frame_end(callframe458);
// compiled member node returning call461 (depth = 3)
  gc_frame_newslot(call461);
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array462 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array462 (depth = 3)
  gc_frame_newslot(array462);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = call449;
  params[2] = call453;
  params[3] = call457;
  params[4] = call461;
  params[5] = array462;
  partcv[0] = 1;
  partcv[1] = 4;
  partcv[2] = 1;
  Object call463 = callmethodflags(module_errormessages, "error(1)atRange(4)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe445);
// compiled call node returning call463 (depth = 2)
  gc_frame_end(frame);
  return call463;
}
Object meth_errormessages_526__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___3 = &(stackframe->slots[0]);
  *var___3 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit528 == NULL) {
    strlit528 = alloc_String("-");
    gc_root(strlit528);
  }
// compiled string node returning strlit528 (depth = 6)
  int op_slot_right_527 = gc_frame_newslot(strlit528);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_527 = gc_frame_newslot(*var_arr);
  params[0] = strlit528;
  partcv[0] = 1;
  Object opresult530 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult530 (depth = 5)
  *var_arr = opresult530;
  if (opresult530 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_539__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___4 = &(stackframe->slots[0]);
  *var___4 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit541 == NULL) {
    strlit541 = alloc_String("^");
    gc_root(strlit541);
  }
// compiled string node returning strlit541 (depth = 6)
  int op_slot_right_540 = gc_frame_newslot(strlit541);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_540 = gc_frame_newslot(*var_arr);
  params[0] = strlit541;
  partcv[0] = 1;
  Object opresult543 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult543 (depth = 5)
  *var_arr = opresult543;
  if (opresult543 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_464_error_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error(1)atRange(4)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 4)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_,_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atRange(_,_,_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_startline = &(stackframe->slots[1]);
  *var_startline = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endline = &(stackframe->slots[3]);
  *var_endline = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[4]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 4)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_,_)");
  Object *var_suggestions = &(stackframe->slots[5]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_loc = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "loc");
  Object *var_arr = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "arr");
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_endline (depth = 5)
  int op_slot_right_466 = gc_frame_newslot(*var_endline);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startline (depth = 5)
  int op_slot_left_466 = gc_frame_newslot(*var_startline);
  params[0] = *var_endline;
  partcv[0] = 1;
  Object opresult468 = callmethod(*var_startline, "==(1)", 1, partcv, params);
// compiled op node returning opresult468 (depth = 4)
  Object if465 = done;
struct StackFrameObject *iftmpstackframe465 = stackframe;
  if (istrue(opresult468)) {
stackframe = alloc_StackFrame(0, iftmpstackframe465);
gc_frame_newslot((Object)stackframe);
// definebindings:
// definebindings:
// definebindings:
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endpos (depth = 6)
  int op_slot_right_470 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startpos (depth = 6)
  int op_slot_left_470 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult472 = callmethod(*var_startpos, "==(1)", 1, partcv, params);
// compiled op node returning opresult472 (depth = 5)
  Object if469 = done;
  if (istrue(opresult472)) {
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe473 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startpos (depth = 6)
  partcv[0] = 0;
  Object call474 = callmethodflags(*var_startpos, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe473);
// compiled member node returning call474 (depth = 5)
    gc_frame_newslot(call474);
    if469 = call474;
  } else {
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit476 == NULL) {
    strlit476 = alloc_String("");
    gc_root(strlit476);
  }
// compiled string node returning strlit476 (depth = 6)
  int op_slot_right_475 = gc_frame_newslot(strlit476);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_endpos (depth = 7)
  int op_slot_right_478 = gc_frame_newslot(*var_endpos);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit481 == NULL) {
    strlit481 = alloc_String("-");
    gc_root(strlit481);
  }
// compiled string node returning strlit481 (depth = 8)
  int op_slot_right_480 = gc_frame_newslot(strlit481);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_startpos (depth = 9)
  int op_slot_right_483 = gc_frame_newslot(*var_startpos);
// starting to compile string node (depth = 9)
  if (strlit485 == NULL) {
    strlit485 = alloc_String("");
    gc_root(strlit485);
  }
// compiled string node returning strlit485 (depth = 9)
  int op_slot_left_483 = gc_frame_newslot(strlit485);
  params[0] = *var_startpos;
  partcv[0] = 1;
  Object opresult486 = callmethod(strlit485, "++(1)", 1, partcv, params);
// compiled op node returning opresult486 (depth = 8)
  int op_slot_left_480 = gc_frame_newslot(opresult486);
  params[0] = strlit481;
  partcv[0] = 1;
  Object opresult487 = callmethod(opresult486, "++(1)", 1, partcv, params);
// compiled op node returning opresult487 (depth = 7)
  int op_slot_left_478 = gc_frame_newslot(opresult487);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult488 = callmethod(opresult487, "++(1)", 1, partcv, params);
// compiled op node returning opresult488 (depth = 6)
  int op_slot_left_475 = gc_frame_newslot(opresult488);
  params[0] = strlit476;
  partcv[0] = 1;
  Object opresult489 = callmethod(opresult488, "++(1)", 1, partcv, params);
// compiled op node returning opresult489 (depth = 5)
    gc_frame_newslot(opresult489);
    if469 = opresult489;
  }
// compiled if node returning if469 (depth = 4)
    gc_frame_newslot(if469);
    if465 = if469;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe465);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit491 == NULL) {
    strlit491 = alloc_String("");
    gc_root(strlit491);
  }
// compiled string node returning strlit491 (depth = 5)
  int op_slot_right_490 = gc_frame_newslot(strlit491);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endpos (depth = 6)
  int op_slot_right_493 = gc_frame_newslot(*var_endpos);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit496 == NULL) {
    strlit496 = alloc_String(":");
    gc_root(strlit496);
  }
// compiled string node returning strlit496 (depth = 7)
  int op_slot_right_495 = gc_frame_newslot(strlit496);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_endline (depth = 8)
  int op_slot_right_498 = gc_frame_newslot(*var_endline);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit501 == NULL) {
    strlit501 = alloc_String("-");
    gc_root(strlit501);
  }
// compiled string node returning strlit501 (depth = 9)
  int op_slot_right_500 = gc_frame_newslot(strlit501);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_startpos (depth = 10)
  int op_slot_right_503 = gc_frame_newslot(*var_startpos);
// starting to compile string node (depth = 10)
  if (strlit505 == NULL) {
    strlit505 = alloc_String("");
    gc_root(strlit505);
  }
// compiled string node returning strlit505 (depth = 10)
  int op_slot_left_503 = gc_frame_newslot(strlit505);
  params[0] = *var_startpos;
  partcv[0] = 1;
  Object opresult506 = callmethod(strlit505, "++(1)", 1, partcv, params);
// compiled op node returning opresult506 (depth = 9)
  int op_slot_left_500 = gc_frame_newslot(opresult506);
  params[0] = strlit501;
  partcv[0] = 1;
  Object opresult507 = callmethod(opresult506, "++(1)", 1, partcv, params);
// compiled op node returning opresult507 (depth = 8)
  int op_slot_left_498 = gc_frame_newslot(opresult507);
  params[0] = *var_endline;
  partcv[0] = 1;
  Object opresult508 = callmethod(opresult507, "++(1)", 1, partcv, params);
// compiled op node returning opresult508 (depth = 7)
  int op_slot_left_495 = gc_frame_newslot(opresult508);
  params[0] = strlit496;
  partcv[0] = 1;
  Object opresult509 = callmethod(opresult508, "++(1)", 1, partcv, params);
// compiled op node returning opresult509 (depth = 6)
  int op_slot_left_493 = gc_frame_newslot(opresult509);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult510 = callmethod(opresult509, "++(1)", 1, partcv, params);
// compiled op node returning opresult510 (depth = 5)
  int op_slot_left_490 = gc_frame_newslot(opresult510);
  params[0] = strlit491;
  partcv[0] = 1;
  Object opresult511 = callmethod(opresult510, "++(1)", 1, partcv, params);
// compiled op node returning opresult511 (depth = 4)
    gc_frame_newslot(opresult511);
    if465 = opresult511;
  }
stackframe = iftmpstackframe465;
// compiled if node returning if465 (depth = 3)
  *var_loc = if465;
  if (if465 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit512 == NULL) {
    strlit512 = alloc_String("----");
    gc_root(strlit512);
  }
// compiled string node returning strlit512 (depth = 3)
  *var_arr = strlit512;
  if (strlit512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe513 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe516 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe517 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startline (depth = 7)
  partcv[0] = 0;
  Object call518 = callmethodflags(*var_startline, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe517);
// compiled member node returning call518 (depth = 6)
  partcv[0] = 0;
  Object call519 = callmethodflags(call518, "size", 1, partcv, params, 0);
  gc_frame_end(callframe516);
// compiled member node returning call519 (depth = 5)
  int op_slot_right_515 = gc_frame_newslot(call519);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_515 = gc_frame_newslot(*var_startpos);
  params[0] = call519;
  partcv[0] = 1;
  Object sum521 = callmethod(*var_startpos, "+(1)", 1, partcv, params);
// compiled op node returning sum521 (depth = 4)
  int op_slot_right_514 = gc_frame_newslot(sum521);
// starting to compile num node (depth = 4)
  Object num523 = alloc_Float64(2);
// compiled num node returning num523 (depth = 4)
  int op_slot_left_514 = gc_frame_newslot(num523);
  params[0] = sum521;
  partcv[0] = 1;
  Object opresult524 = callmethod(num523, "..(1)", 1, partcv, params);
// compiled op node returning opresult524 (depth = 3)
  gc_frame_newslot(opresult524);
// starting to compile block node (depth = 3)
  Object block525 = alloc_Block(NULL, NULL, "errormessages", 445);
  gc_frame_newslot(block525);
// method "_apply(_)"
  block_savedest(block525);
  Object closure526 = createclosure(2, "_apply(1)");
  setclosureframe(closure526, stackframe);
  addtoclosure(closure526, var_arr);
  addtoclosure(closure526, selfslot);
  struct UserObject *uo526 = (struct UserObject*)block525;
  uo526->data[0] = (Object)closure526;
  Method *meth_meth_errormessages_526__apply_40_1_41_ = addmethod2pos(block525, "_apply(1)", &meth_errormessages_526__apply_40_1_41_, 0);
  int argcv_meth_errormessages_526__apply_40_1_41_[] = {1};
  meth_meth_errormessages_526__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_526__apply_40_1_41_);
  meth_meth_errormessages_526__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_526__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block525 (depth = 3)
  gc_frame_newslot(block525);
// call case 5: prelude request
  params[0] = opresult524;
  params[1] = block525;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call533 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe513);
// compiled call node returning call533 (depth = 2)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe534 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_endpos (depth = 4)
  int op_slot_right_535 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startpos (depth = 4)
  int op_slot_left_535 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult537 = callmethod(*var_startpos, "..(1)", 1, partcv, params);
// compiled op node returning opresult537 (depth = 3)
  gc_frame_newslot(opresult537);
// starting to compile block node (depth = 3)
  Object block538 = alloc_Block(NULL, NULL, "errormessages", 448);
  gc_frame_newslot(block538);
// method "_apply(_)"
  block_savedest(block538);
  Object closure539 = createclosure(2, "_apply(1)");
  setclosureframe(closure539, stackframe);
  addtoclosure(closure539, var_arr);
  addtoclosure(closure539, selfslot);
  struct UserObject *uo539 = (struct UserObject*)block538;
  uo539->data[0] = (Object)closure539;
  Method *meth_meth_errormessages_539__apply_40_1_41_ = addmethod2pos(block538, "_apply(1)", &meth_errormessages_539__apply_40_1_41_, 0);
  int argcv_meth_errormessages_539__apply_40_1_41_[] = {1};
  meth_meth_errormessages_539__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_539__apply_40_1_41_);
  meth_meth_errormessages_539__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_539__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block538 (depth = 3)
  gc_frame_newslot(block538);
// call case 5: prelude request
  params[0] = opresult537;
  params[1] = block538;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call546 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe534);
// compiled call node returning call546 (depth = 2)
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe547 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startline (depth = 3)
  gc_frame_newslot(*var_startline);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit549 == NULL) {
    strlit549 = alloc_String("");
    gc_root(strlit549);
  }
// compiled string node returning strlit549 (depth = 4)
  int op_slot_right_548 = gc_frame_newslot(strlit549);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loc (depth = 5)
  int op_slot_right_551 = gc_frame_newslot(*var_loc);
// starting to compile string node (depth = 5)
  if (strlit553 == NULL) {
    strlit553 = alloc_String(":");
    gc_root(strlit553);
  }
// compiled string node returning strlit553 (depth = 5)
  int op_slot_left_551 = gc_frame_newslot(strlit553);
  params[0] = *var_loc;
  partcv[0] = 1;
  Object opresult554 = callmethod(strlit553, "++(1)", 1, partcv, params);
// compiled op node returning opresult554 (depth = 4)
  int op_slot_left_548 = gc_frame_newslot(opresult554);
  params[0] = strlit549;
  partcv[0] = 1;
  Object opresult555 = callmethod(opresult554, "++(1)", 1, partcv, params);
// compiled op node returning opresult555 (depth = 3)
  gc_frame_newslot(opresult555);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_startline;
  params[2] = opresult555;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call556 = callmethodflags(*var_util, "generalError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe547);
// compiled call node returning call556 (depth = 2)
  gc_frame_end(frame);
  return call556;
}
Object meth_errormessages_557_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error(1)atRange(3)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_)withSuggestions(_)");
  Object params[6];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atRange(_,_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_)");
  Object *var_suggestions = &(stackframe->slots[4]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe558 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_errlinenum;
  params[4] = *var_endpos;
  params[5] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 4;
  partcv[2] = 1;
  Object call559 = callmethodflags(module_errormessages, "error(1)atRange(4)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe558);
// compiled call node returning call559 (depth = 2)
  gc_frame_end(frame);
  return call559;
}
Object meth_errormessages_560_error_40_1_41_atRange_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error(1)atRange(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_)");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atRange(_,_,_)");
  Object params[5];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atRange(_,_,_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part atRange(_,_,_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe561 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// starting to compile array node (depth = 3)
  Object array562 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array562 (depth = 3)
  gc_frame_newslot(array562);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_endpos;
  params[4] = array562;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call563 = callmethodflags(module_errormessages, "error(1)atRange(3)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe561);
// compiled call node returning call563 (depth = 2)
  gc_frame_end(frame);
  return call563;
}
Object meth_errormessages_564_syntaxError_40_1_41_atPosition_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atPosition(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atPosition(_,_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe565 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errpos (depth = 3)
  gc_frame_newslot(*var_errpos);
// starting to compile array node (depth = 3)
  Object array566 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array566 (depth = 3)
  gc_frame_newslot(array566);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_errpos;
  params[3] = array566;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call567 = callmethodflags(module_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe565);
// compiled call node returning call567 (depth = 2)
  gc_frame_end(frame);
  return call567;
}
Object meth_errormessages_568_error_40_1_41_atPosition_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error(1)atPosition(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atPosition(_,_)");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atPosition(_,_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atPosition(_,_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe569 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errpos (depth = 3)
  gc_frame_newslot(*var_errpos);
// starting to compile array node (depth = 3)
  Object array570 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array570 (depth = 3)
  gc_frame_newslot(array570);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_errpos;
  params[3] = array570;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call571 = callmethodflags(module_errormessages, "error(1)atPosition(2)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe569);
// compiled call node returning call571 (depth = 2)
  gc_frame_end(frame);
  return call571;
}
Object meth_errormessages_572_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atPosition(2)withSuggestion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestion(_)");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestion(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestion(_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atPosition(_,_)withSuggestion(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_,_)");
  Object *var_suggestion_39_ = &(stackframe->slots[3]);
  *var_suggestion_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestion(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe573 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errpos (depth = 3)
  gc_frame_newslot(*var_errpos);
// starting to compile array node (depth = 3)
  Object array574 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion_39_ (depth = 4)
  params[0] = *var_suggestion_39_;
  partcv[0] = 1;
  callmethodflags(array574, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array574 (depth = 3)
  gc_frame_newslot(array574);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_errpos;
  params[3] = array574;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call575 = callmethodflags(module_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe573);
// compiled call node returning call575 (depth = 2)
  gc_frame_end(frame);
  return call575;
}
Object meth_errormessages_591__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___5 = &(stackframe->slots[0]);
  *var___5 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit593 == NULL) {
    strlit593 = alloc_String("-");
    gc_root(strlit593);
  }
// compiled string node returning strlit593 (depth = 6)
  int op_slot_right_592 = gc_frame_newslot(strlit593);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_592 = gc_frame_newslot(*var_arr);
  params[0] = strlit593;
  partcv[0] = 1;
  Object opresult595 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult595 (depth = 5)
  *var_arr = opresult595;
  if (opresult595 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_576_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "syntaxError(1)atPosition(2)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atPosition(_,_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atPosition(_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_,_)");
  Object *var_suggestions = &(stackframe->slots[3]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_arr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "arr");
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit577 == NULL) {
    strlit577 = alloc_String("----");
    gc_root(strlit577);
  }
// compiled string node returning strlit577 (depth = 3)
  *var_arr = strlit577;
  if (strlit577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe578 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe581 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe582 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errlinenum (depth = 7)
  partcv[0] = 0;
  Object call583 = callmethodflags(*var_errlinenum, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe582);
// compiled member node returning call583 (depth = 6)
  partcv[0] = 0;
  Object call584 = callmethodflags(call583, "size", 1, partcv, params, 0);
  gc_frame_end(callframe581);
// compiled member node returning call584 (depth = 5)
  int op_slot_right_580 = gc_frame_newslot(call584);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_left_580 = gc_frame_newslot(*var_errpos);
  params[0] = call584;
  partcv[0] = 1;
  Object sum586 = callmethod(*var_errpos, "+(1)", 1, partcv, params);
// compiled op node returning sum586 (depth = 4)
  int op_slot_right_579 = gc_frame_newslot(sum586);
// starting to compile num node (depth = 4)
  Object num588 = alloc_Float64(2);
// compiled num node returning num588 (depth = 4)
  int op_slot_left_579 = gc_frame_newslot(num588);
  params[0] = sum586;
  partcv[0] = 1;
  Object opresult589 = callmethod(num588, "..(1)", 1, partcv, params);
// compiled op node returning opresult589 (depth = 3)
  gc_frame_newslot(opresult589);
// starting to compile block node (depth = 3)
  Object block590 = alloc_Block(NULL, NULL, "errormessages", 476);
  gc_frame_newslot(block590);
// method "_apply(_)"
  block_savedest(block590);
  Object closure591 = createclosure(2, "_apply(1)");
  setclosureframe(closure591, stackframe);
  addtoclosure(closure591, var_arr);
  addtoclosure(closure591, selfslot);
  struct UserObject *uo591 = (struct UserObject*)block590;
  uo591->data[0] = (Object)closure591;
  Method *meth_meth_errormessages_591__apply_40_1_41_ = addmethod2pos(block590, "_apply(1)", &meth_errormessages_591__apply_40_1_41_, 0);
  int argcv_meth_errormessages_591__apply_40_1_41_[] = {1};
  meth_meth_errormessages_591__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_591__apply_40_1_41_);
  meth_meth_errormessages_591__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_591__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block590 (depth = 3)
  gc_frame_newslot(block590);
// call case 5: prelude request
  params[0] = opresult589;
  params[1] = block590;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call598 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe578);
// compiled call node returning call598 (depth = 2)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit600 == NULL) {
    strlit600 = alloc_String("^");
    gc_root(strlit600);
  }
// compiled string node returning strlit600 (depth = 4)
  int op_slot_right_599 = gc_frame_newslot(strlit600);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arr (depth = 4)
  int op_slot_left_599 = gc_frame_newslot(*var_arr);
  params[0] = strlit600;
  partcv[0] = 1;
  Object opresult602 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult602 (depth = 3)
  *var_arr = opresult602;
  if (opresult602 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe604 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit606 == NULL) {
    strlit606 = alloc_String("");
    gc_root(strlit606);
  }
// compiled string node returning strlit606 (depth = 4)
  int op_slot_right_605 = gc_frame_newslot(strlit606);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_right_608 = gc_frame_newslot(*var_errpos);
// starting to compile string node (depth = 5)
  if (strlit610 == NULL) {
    strlit610 = alloc_String(":");
    gc_root(strlit610);
  }
// compiled string node returning strlit610 (depth = 5)
  int op_slot_left_608 = gc_frame_newslot(strlit610);
  params[0] = *var_errpos;
  partcv[0] = 1;
  Object opresult611 = callmethod(strlit610, "++(1)", 1, partcv, params);
// compiled op node returning opresult611 (depth = 4)
  int op_slot_left_605 = gc_frame_newslot(opresult611);
  params[0] = strlit606;
  partcv[0] = 1;
  Object opresult612 = callmethod(opresult611, "++(1)", 1, partcv, params);
// compiled op node returning opresult612 (depth = 3)
  gc_frame_newslot(opresult612);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = opresult612;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call613 = callmethodflags(*var_util, "syntaxError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe604);
// compiled call node returning call613 (depth = 2)
  gc_frame_end(frame);
  return call613;
}
Object meth_errormessages_629__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___6 = &(stackframe->slots[0]);
  *var___6 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit631 == NULL) {
    strlit631 = alloc_String("-");
    gc_root(strlit631);
  }
// compiled string node returning strlit631 (depth = 6)
  int op_slot_right_630 = gc_frame_newslot(strlit631);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_630 = gc_frame_newslot(*var_arr);
  params[0] = strlit631;
  partcv[0] = 1;
  Object opresult633 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult633 (depth = 5)
  *var_arr = opresult633;
  if (opresult633 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_614_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error(1)atPosition(2)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atPosition(_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atPosition(_,_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atPosition(_,_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atPosition(_,_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_,_)");
  Object *var_suggestions = &(stackframe->slots[3]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_arr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "arr");
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit615 == NULL) {
    strlit615 = alloc_String("----");
    gc_root(strlit615);
  }
// compiled string node returning strlit615 (depth = 3)
  *var_arr = strlit615;
  if (strlit615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe616 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe619 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe620 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errlinenum (depth = 7)
  partcv[0] = 0;
  Object call621 = callmethodflags(*var_errlinenum, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe620);
// compiled member node returning call621 (depth = 6)
  partcv[0] = 0;
  Object call622 = callmethodflags(call621, "size", 1, partcv, params, 0);
  gc_frame_end(callframe619);
// compiled member node returning call622 (depth = 5)
  int op_slot_right_618 = gc_frame_newslot(call622);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_left_618 = gc_frame_newslot(*var_errpos);
  params[0] = call622;
  partcv[0] = 1;
  Object sum624 = callmethod(*var_errpos, "+(1)", 1, partcv, params);
// compiled op node returning sum624 (depth = 4)
  int op_slot_right_617 = gc_frame_newslot(sum624);
// starting to compile num node (depth = 4)
  Object num626 = alloc_Float64(2);
// compiled num node returning num626 (depth = 4)
  int op_slot_left_617 = gc_frame_newslot(num626);
  params[0] = sum624;
  partcv[0] = 1;
  Object opresult627 = callmethod(num626, "..(1)", 1, partcv, params);
// compiled op node returning opresult627 (depth = 3)
  gc_frame_newslot(opresult627);
// starting to compile block node (depth = 3)
  Object block628 = alloc_Block(NULL, NULL, "errormessages", 486);
  gc_frame_newslot(block628);
// method "_apply(_)"
  block_savedest(block628);
  Object closure629 = createclosure(2, "_apply(1)");
  setclosureframe(closure629, stackframe);
  addtoclosure(closure629, var_arr);
  addtoclosure(closure629, selfslot);
  struct UserObject *uo629 = (struct UserObject*)block628;
  uo629->data[0] = (Object)closure629;
  Method *meth_meth_errormessages_629__apply_40_1_41_ = addmethod2pos(block628, "_apply(1)", &meth_errormessages_629__apply_40_1_41_, 0);
  int argcv_meth_errormessages_629__apply_40_1_41_[] = {1};
  meth_meth_errormessages_629__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_629__apply_40_1_41_);
  meth_meth_errormessages_629__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_629__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block628 (depth = 3)
  gc_frame_newslot(block628);
// call case 5: prelude request
  params[0] = opresult627;
  params[1] = block628;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call636 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe616);
// compiled call node returning call636 (depth = 2)
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit638 == NULL) {
    strlit638 = alloc_String("^");
    gc_root(strlit638);
  }
// compiled string node returning strlit638 (depth = 4)
  int op_slot_right_637 = gc_frame_newslot(strlit638);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arr (depth = 4)
  int op_slot_left_637 = gc_frame_newslot(*var_arr);
  params[0] = strlit638;
  partcv[0] = 1;
  Object opresult640 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult640 (depth = 3)
  *var_arr = opresult640;
  if (opresult640 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe642 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit644 == NULL) {
    strlit644 = alloc_String("");
    gc_root(strlit644);
  }
// compiled string node returning strlit644 (depth = 4)
  int op_slot_right_643 = gc_frame_newslot(strlit644);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_right_646 = gc_frame_newslot(*var_errpos);
// starting to compile string node (depth = 5)
  if (strlit648 == NULL) {
    strlit648 = alloc_String(":");
    gc_root(strlit648);
  }
// compiled string node returning strlit648 (depth = 5)
  int op_slot_left_646 = gc_frame_newslot(strlit648);
  params[0] = *var_errpos;
  partcv[0] = 1;
  Object opresult649 = callmethod(strlit648, "++(1)", 1, partcv, params);
// compiled op node returning opresult649 (depth = 4)
  int op_slot_left_643 = gc_frame_newslot(opresult649);
  params[0] = strlit644;
  partcv[0] = 1;
  Object opresult650 = callmethod(opresult649, "++(1)", 1, partcv, params);
// compiled op node returning opresult650 (depth = 3)
  gc_frame_newslot(opresult650);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = opresult650;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call651 = callmethodflags(*var_util, "generalError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe642);
// compiled call node returning call651 (depth = 2)
  gc_frame_end(frame);
  return call651;
}
Object meth_errormessages_652_error_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)");
  Object params[5];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for error(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe653 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile num node (depth = 3)
  Object num654 = alloc_Float64(0);
// compiled num node returning num654 (depth = 3)
  gc_frame_newslot(num654);
// starting to compile string node (depth = 3)
  if (strlit655 == NULL) {
    strlit655 = alloc_String("");
    gc_root(strlit655);
  }
// compiled string node returning strlit655 (depth = 3)
  gc_frame_newslot(strlit655);
// starting to compile string node (depth = 3)
  if (strlit656 == NULL) {
    strlit656 = alloc_String("");
    gc_root(strlit656);
  }
// compiled string node returning strlit656 (depth = 3)
  gc_frame_newslot(strlit656);
// starting to compile array node (depth = 3)
  Object array657 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array657 (depth = 3)
  gc_frame_newslot(array657);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = num654;
  params[2] = strlit655;
  params[3] = strlit656;
  params[4] = array657;
  partcv[0] = 5;
  Object call658 = callmethodflags(*var_util, "generalError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe653);
// compiled call node returning call658 (depth = 2)
  gc_frame_end(frame);
  return call658;
}
Object meth_errormessages_671__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___7 = &(stackframe->slots[0]);
  *var___7 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit673 == NULL) {
    strlit673 = alloc_String("-");
    gc_root(strlit673);
  }
// compiled string node returning strlit673 (depth = 6)
  int op_slot_right_672 = gc_frame_newslot(strlit673);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_672 = gc_frame_newslot(*var_arr);
  params[0] = strlit673;
  partcv[0] = 1;
  Object opresult675 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult675 (depth = 5)
  *var_arr = opresult675;
  if (opresult675 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_659_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error(1)atLine(1)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atLine(_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atLine(_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atLine(_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atLine(_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atLine(_)");
  Object *var_suggestions = &(stackframe->slots[2]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_arr = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arr");
// definebindings:
// definebindings:
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit660 == NULL) {
    strlit660 = alloc_String("----");
    gc_root(strlit660);
  }
// compiled string node returning strlit660 (depth = 3)
  *var_arr = strlit660;
  if (strlit660 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe661 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe663 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe664 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errlinenum (depth = 6)
  partcv[0] = 0;
  Object call665 = callmethodflags(*var_errlinenum, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe664);
// compiled member node returning call665 (depth = 5)
  partcv[0] = 0;
  Object call666 = callmethodflags(call665, "size", 1, partcv, params, 0);
  gc_frame_end(callframe663);
// compiled member node returning call666 (depth = 4)
  int op_slot_right_662 = gc_frame_newslot(call666);
// starting to compile num node (depth = 4)
  Object num668 = alloc_Float64(1);
// compiled num node returning num668 (depth = 4)
  int op_slot_left_662 = gc_frame_newslot(num668);
  params[0] = call666;
  partcv[0] = 1;
  Object opresult669 = callmethod(num668, "..(1)", 1, partcv, params);
// compiled op node returning opresult669 (depth = 3)
  gc_frame_newslot(opresult669);
// starting to compile block node (depth = 3)
  Object block670 = alloc_Block(NULL, NULL, "errormessages", 499);
  gc_frame_newslot(block670);
// method "_apply(_)"
  block_savedest(block670);
  Object closure671 = createclosure(2, "_apply(1)");
  setclosureframe(closure671, stackframe);
  addtoclosure(closure671, var_arr);
  addtoclosure(closure671, selfslot);
  struct UserObject *uo671 = (struct UserObject*)block670;
  uo671->data[0] = (Object)closure671;
  Method *meth_meth_errormessages_671__apply_40_1_41_ = addmethod2pos(block670, "_apply(1)", &meth_errormessages_671__apply_40_1_41_, 0);
  int argcv_meth_errormessages_671__apply_40_1_41_[] = {1};
  meth_meth_errormessages_671__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_671__apply_40_1_41_);
  meth_meth_errormessages_671__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_671__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block670 (depth = 3)
  gc_frame_newslot(block670);
// call case 5: prelude request
  params[0] = opresult669;
  params[1] = block670;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call678 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe661);
// compiled call node returning call678 (depth = 2)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num681 = alloc_Float64(0);
// compiled num node returning num681 (depth = 4)
  int op_slot_right_680 = gc_frame_newslot(num681);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errlinenum (depth = 4)
  int op_slot_left_680 = gc_frame_newslot(*var_errlinenum);
  params[0] = num681;
  partcv[0] = 1;
  Object opresult683 = callmethod(*var_errlinenum, ">(1)", 1, partcv, params);
// compiled op node returning opresult683 (depth = 3)
  Object if679 = done;
  if (istrue(opresult683)) {
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe686 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe687 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errlinenum (depth = 8)
  gc_frame_newslot(*var_errlinenum);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe688 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  partcv[0] = 0;
  Object call689 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe688);
// compiled member node returning call689 (depth = 8)
  params[0] = *var_errlinenum;
  partcv[0] = 1;
  Object call690 = callmethodflags(call689, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe687);
// compiled call node returning call690 (depth = 7)
  partcv[0] = 0;
  Object call691 = callmethodflags(call690, "size", 1, partcv, params, 0);
  gc_frame_end(callframe686);
// compiled member node returning call691 (depth = 6)
  int op_slot_right_685 = gc_frame_newslot(call691);
// starting to compile string node (depth = 6)
  if (strlit693 == NULL) {
    strlit693 = alloc_String("^");
    gc_root(strlit693);
  }
// compiled string node returning strlit693 (depth = 6)
  int op_slot_left_685 = gc_frame_newslot(strlit693);
  params[0] = call691;
  partcv[0] = 1;
  Object prod694 = callmethod(strlit693, "*(1)", 1, partcv, params);
// compiled op node returning prod694 (depth = 5)
  int op_slot_right_684 = gc_frame_newslot(prod694);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_arr (depth = 5)
  int op_slot_left_684 = gc_frame_newslot(*var_arr);
  params[0] = prod694;
  partcv[0] = 1;
  Object opresult696 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult696 (depth = 4)
  *var_arr = opresult696;
  if (opresult696 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if679 = done;
  } else {
  }
// compiled if node returning if679 (depth = 2)
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe698 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile string node (depth = 3)
  if (strlit699 == NULL) {
    strlit699 = alloc_String("");
    gc_root(strlit699);
  }
// compiled string node returning strlit699 (depth = 3)
  gc_frame_newslot(strlit699);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = strlit699;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call700 = callmethodflags(*var_util, "generalError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe698);
// compiled call node returning call700 (depth = 2)
  gc_frame_end(frame);
  return call700;
}
Object meth_errormessages_701_error_40_1_41_atLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error(1)atLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error(_)atLine(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error(_)atLine(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part error(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atLine(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe702 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile array node (depth = 3)
  Object array703 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array703 (depth = 3)
  gc_frame_newslot(array703);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = array703;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call704 = callmethodflags(module_errormessages, "error(1)atLine(1)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe702);
// compiled call node returning call704 (depth = 2)
  gc_frame_end(frame);
  return call704;
}
Object meth_errormessages_705_syntaxError_40_1_41_atLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atLine(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atLine(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe706 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile array node (depth = 3)
  Object array707 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array707 (depth = 3)
  gc_frame_newslot(array707);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = array707;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call708 = callmethodflags(module_errormessages, "syntaxError(1)atLine(1)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe706);
// compiled call node returning call708 (depth = 2)
  gc_frame_end(frame);
  return call708;
}
Object meth_errormessages_709_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError(1)atLine(1)withSuggestion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestion(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestion(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestion(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atLine(_)withSuggestion(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atLine(_)");
  Object *var_suggestion_39_ = &(stackframe->slots[2]);
  *var_suggestion_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestion(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe710 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile array node (depth = 3)
  Object array711 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion_39_ (depth = 4)
  params[0] = *var_suggestion_39_;
  partcv[0] = 1;
  callmethodflags(array711, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array711 (depth = 3)
  gc_frame_newslot(array711);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = array711;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call712 = callmethodflags(module_errormessages, "syntaxError(1)atLine(1)withSuggestions(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe710);
// compiled call node returning call712 (depth = 2)
  gc_frame_end(frame);
  return call712;
}
Object meth_errormessages_725__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___8 = &(stackframe->slots[0]);
  *var___8 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit727 == NULL) {
    strlit727 = alloc_String("-");
    gc_root(strlit727);
  }
// compiled string node returning strlit727 (depth = 6)
  int op_slot_right_726 = gc_frame_newslot(strlit727);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_726 = gc_frame_newslot(*var_arr);
  params[0] = strlit727;
  partcv[0] = 1;
  Object opresult729 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult729 (depth = 5)
  *var_arr = opresult729;
  if (opresult729 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_745__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___9 = &(stackframe->slots[0]);
  *var___9 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit747 == NULL) {
    strlit747 = alloc_String("^");
    gc_root(strlit747);
  }
// compiled string node returning strlit747 (depth = 6)
  int op_slot_right_746 = gc_frame_newslot(strlit747);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_746 = gc_frame_newslot(*var_arr);
  params[0] = strlit747;
  partcv[0] = 1;
  Object opresult749 = callmethod(*var_arr, "++(1)", 1, partcv, params);
// compiled op node returning opresult749 (depth = 5)
  *var_arr = opresult749;
  if (opresult749 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_713_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "syntaxError(1)atLine(1)withSuggestions(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestions(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestions(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError(_)atLine(_)withSuggestions(_)");
  Object params[5];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError(_)atLine(_)withSuggestions(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part syntaxError(_)");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atLine(_)");
  Object *var_suggestions = &(stackframe->slots[2]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withSuggestions(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_arr = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arr");
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit714 == NULL) {
    strlit714 = alloc_String("----");
    gc_root(strlit714);
  }
// compiled string node returning strlit714 (depth = 3)
  *var_arr = strlit714;
  if (strlit714 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe715 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe717 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe718 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errlinenum (depth = 6)
  partcv[0] = 0;
  Object call719 = callmethodflags(*var_errlinenum, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe718);
// compiled member node returning call719 (depth = 5)
  partcv[0] = 0;
  Object call720 = callmethodflags(call719, "size", 1, partcv, params, 0);
  gc_frame_end(callframe717);
// compiled member node returning call720 (depth = 4)
  int op_slot_right_716 = gc_frame_newslot(call720);
// starting to compile num node (depth = 4)
  Object num722 = alloc_Float64(1);
// compiled num node returning num722 (depth = 4)
  int op_slot_left_716 = gc_frame_newslot(num722);
  params[0] = call720;
  partcv[0] = 1;
  Object opresult723 = callmethod(num722, "..(1)", 1, partcv, params);
// compiled op node returning opresult723 (depth = 3)
  gc_frame_newslot(opresult723);
// starting to compile block node (depth = 3)
  Object block724 = alloc_Block(NULL, NULL, "errormessages", 522);
  gc_frame_newslot(block724);
// method "_apply(_)"
  block_savedest(block724);
  Object closure725 = createclosure(2, "_apply(1)");
  setclosureframe(closure725, stackframe);
  addtoclosure(closure725, var_arr);
  addtoclosure(closure725, selfslot);
  struct UserObject *uo725 = (struct UserObject*)block724;
  uo725->data[0] = (Object)closure725;
  Method *meth_meth_errormessages_725__apply_40_1_41_ = addmethod2pos(block724, "_apply(1)", &meth_errormessages_725__apply_40_1_41_, 0);
  int argcv_meth_errormessages_725__apply_40_1_41_[] = {1};
  meth_meth_errormessages_725__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_725__apply_40_1_41_);
  meth_meth_errormessages_725__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_725__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block724 (depth = 3)
  gc_frame_newslot(block724);
// call case 5: prelude request
  params[0] = opresult723;
  params[1] = block724;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call732 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe715);
// compiled call node returning call732 (depth = 2)
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe733 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe735 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe736 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errlinenum (depth = 6)
  gc_frame_newslot(*var_errlinenum);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe737 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call738 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe737);
// compiled member node returning call738 (depth = 6)
  params[0] = *var_errlinenum;
  partcv[0] = 1;
  Object call739 = callmethodflags(call738, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe736);
// compiled call node returning call739 (depth = 5)
  partcv[0] = 0;
  Object call740 = callmethodflags(call739, "size", 1, partcv, params, 0);
  gc_frame_end(callframe735);
// compiled member node returning call740 (depth = 4)
  int op_slot_right_734 = gc_frame_newslot(call740);
// starting to compile num node (depth = 4)
  Object num742 = alloc_Float64(1);
// compiled num node returning num742 (depth = 4)
  int op_slot_left_734 = gc_frame_newslot(num742);
  params[0] = call740;
  partcv[0] = 1;
  Object opresult743 = callmethod(num742, "..(1)", 1, partcv, params);
// compiled op node returning opresult743 (depth = 3)
  gc_frame_newslot(opresult743);
// starting to compile block node (depth = 3)
  Object block744 = alloc_Block(NULL, NULL, "errormessages", 525);
  gc_frame_newslot(block744);
// method "_apply(_)"
  block_savedest(block744);
  Object closure745 = createclosure(2, "_apply(1)");
  setclosureframe(closure745, stackframe);
  addtoclosure(closure745, var_arr);
  addtoclosure(closure745, selfslot);
  struct UserObject *uo745 = (struct UserObject*)block744;
  uo745->data[0] = (Object)closure745;
  Method *meth_meth_errormessages_745__apply_40_1_41_ = addmethod2pos(block744, "_apply(1)", &meth_errormessages_745__apply_40_1_41_, 0);
  int argcv_meth_errormessages_745__apply_40_1_41_[] = {1};
  meth_meth_errormessages_745__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_745__apply_40_1_41_);
  meth_meth_errormessages_745__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_745__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block744 (depth = 3)
  gc_frame_newslot(block744);
// call case 5: prelude request
  params[0] = opresult743;
  params[1] = block744;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call752 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe733);
// compiled call node returning call752 (depth = 2)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe753 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile string node (depth = 3)
  if (strlit754 == NULL) {
    strlit754 = alloc_String("");
    gc_root(strlit754);
  }
// compiled string node returning strlit754 (depth = 3)
  gc_frame_newslot(strlit754);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = strlit754;
  params[3] = *var_arr;
  params[4] = *var_suggestions;
  partcv[0] = 5;
  Object call755 = callmethodflags(*var_util, "syntaxError(5)", 1, partcv, params, 0);
  gc_frame_end(callframe753);
// compiled call node returning call755 (depth = 2)
  gc_frame_end(frame);
  return call755;
}
Object meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceRange(2)with(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method replaceRange(_,_)with(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceRange(_,_)with(_)onLine(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceRange(_,_)with(_)onLine(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for replaceRange(_,_)with(_)onLine(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part replaceRange(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *var_lineNumber = &(stackframe->slots[3]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
// definebindings:
// definebindings:
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe764 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call765 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe764);
// compiled call node returning call765 (depth = 4)
  *var_line = call765;
  if (call765 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num768 = alloc_Float64(1);
// compiled num node returning num768 (depth = 5)
  int op_slot_right_767 = gc_frame_newslot(num768);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  int op_slot_left_767 = gc_frame_newslot(*var_start);
  params[0] = num768;
  partcv[0] = 1;
  Object opresult770 = callmethod(*var_start, "==(1)", 1, partcv, params);
// compiled op node returning opresult770 (depth = 4)
  Object if766 = done;
  if (istrue(opresult770)) {
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe771 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe773 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num775 = alloc_Float64(1);
// compiled num node returning num775 (depth = 8)
  int op_slot_right_774 = gc_frame_newslot(num775);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_774 = gc_frame_newslot(*var_end);
  params[0] = num775;
  partcv[0] = 1;
  Object sum777 = callmethod(*var_end, "+(1)", 1, partcv, params);
// compiled op node returning sum777 (depth = 7)
  gc_frame_newslot(sum777);
// starting to compile member node (depth = 7)
  int callframe778 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  partcv[0] = 0;
  Object call779 = callmethodflags(*var_line, "size", 1, partcv, params, 0);
  gc_frame_end(callframe778);
// compiled member node returning call779 (depth = 7)
  gc_frame_newslot(call779);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  params[0] = sum777;
  params[1] = call779;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call780 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe773);
// compiled call node returning call780 (depth = 6)
  int op_slot_right_772 = gc_frame_newslot(call780);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_772 = gc_frame_newslot(*var_s);
  params[0] = call780;
  partcv[0] = 1;
  Object opresult782 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult782 (depth = 5)
  gc_frame_newslot(opresult782);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult782;
  partcv[0] = 2;
  Object call783 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe771);
// compiled call node returning call783 (depth = 4)
    gc_frame_newslot(call783);
    if766 = call783;
  } else {
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe784 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe786 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num788 = alloc_Float64(1);
// compiled num node returning num788 (depth = 8)
  int op_slot_right_787 = gc_frame_newslot(num788);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_787 = gc_frame_newslot(*var_end);
  params[0] = num788;
  partcv[0] = 1;
  Object sum790 = callmethod(*var_end, "+(1)", 1, partcv, params);
// compiled op node returning sum790 (depth = 7)
  gc_frame_newslot(sum790);
// starting to compile member node (depth = 7)
  int callframe791 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  partcv[0] = 0;
  Object call792 = callmethodflags(*var_line, "size", 1, partcv, params, 0);
  gc_frame_end(callframe791);
// compiled member node returning call792 (depth = 7)
  gc_frame_newslot(call792);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  params[0] = sum790;
  params[1] = call792;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call793 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe786);
// compiled call node returning call793 (depth = 6)
  int op_slot_right_785 = gc_frame_newslot(call793);
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_795 = gc_frame_newslot(*var_s);
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe797 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num798 = alloc_Float64(1);
// compiled num node returning num798 (depth = 8)
  gc_frame_newslot(num798);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num800 = alloc_Float64(1);
// compiled num node returning num800 (depth = 9)
  int op_slot_right_799 = gc_frame_newslot(num800);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_start (depth = 9)
  int op_slot_left_799 = gc_frame_newslot(*var_start);
  params[0] = num800;
  partcv[0] = 1;
  Object diff802 = callmethod(*var_start, "-(1)", 1, partcv, params);
// compiled op node returning diff802 (depth = 8)
  gc_frame_newslot(diff802);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  params[0] = num798;
  params[1] = diff802;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call803 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe797);
// compiled call node returning call803 (depth = 7)
  int op_slot_left_795 = gc_frame_newslot(call803);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult804 = callmethod(call803, "++(1)", 1, partcv, params);
// compiled op node returning opresult804 (depth = 6)
  int op_slot_left_785 = gc_frame_newslot(opresult804);
  params[0] = call793;
  partcv[0] = 1;
  Object opresult805 = callmethod(opresult804, "++(1)", 1, partcv, params);
// compiled op node returning opresult805 (depth = 5)
  gc_frame_newslot(opresult805);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult805;
  partcv[0] = 2;
  Object call806 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe784);
// compiled call node returning call806 (depth = 4)
    gc_frame_newslot(call806);
    if766 = call806;
  }
// compiled if node returning if766 (depth = 3)
  gc_frame_end(frame);
  return if766;
}
Object meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceChar(1)with(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceChar(_)with(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceChar(_)with(_)onLine(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceChar(_)with(_)onLine(_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for replaceChar(_)with(_)onLine(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_pos = &(stackframe->slots[0]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part replaceChar(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe808 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_pos;
  params[1] = *var_pos;
  params[2] = *var_s;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call809 = callmethodflags(self, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe808);
// compiled call node returning call809 (depth = 3)
  gc_frame_end(frame);
  return call809;
}
Object meth_errormessages_823__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[4];
  int partcv[3];
  Object *var_until = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_line = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object *var_lineNumber = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_until (depth = 7)
  int op_slot_right_825 = gc_frame_newslot(*var_until);
// starting to compile call node (depth = 7)
  int callframe827 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num829 = alloc_Float64(1);
// compiled num node returning num829 (depth = 9)
  int op_slot_right_828 = gc_frame_newslot(num829);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_len (depth = 10)
  int op_slot_right_831 = gc_frame_newslot(*var_len);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_831 = gc_frame_newslot(*var_i);
  params[0] = *var_len;
  partcv[0] = 1;
  Object sum833 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum833 (depth = 9)
  int op_slot_left_828 = gc_frame_newslot(sum833);
  params[0] = num829;
  partcv[0] = 1;
  Object diff834 = callmethod(sum833, "-(1)", 1, partcv, params);
// compiled op node returning diff834 (depth = 8)
  gc_frame_newslot(diff834);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  params[0] = *var_i;
  params[1] = diff834;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call835 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe827);
// compiled call node returning call835 (depth = 7)
  int op_slot_left_825 = gc_frame_newslot(call835);
  params[0] = *var_until;
  partcv[0] = 1;
  Object opresult836 = callmethod(call835, "==(1)", 1, partcv, params);
// compiled op node returning opresult836 (depth = 6)
  Object if824 = done;
  if (istrue(opresult836)) {
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe837 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num838 = alloc_Float64(1);
// compiled num node returning num838 (depth = 7)
  gc_frame_newslot(num838);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num840 = alloc_Float64(1);
// compiled num node returning num840 (depth = 8)
  int op_slot_right_839 = gc_frame_newslot(num840);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_len (depth = 9)
  int op_slot_right_842 = gc_frame_newslot(*var_len);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_842 = gc_frame_newslot(*var_i);
  params[0] = *var_len;
  partcv[0] = 1;
  Object sum844 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum844 (depth = 8)
  int op_slot_left_839 = gc_frame_newslot(sum844);
  params[0] = num840;
  partcv[0] = 1;
  Object diff845 = callmethod(sum844, "-(1)", 1, partcv, params);
// compiled op node returning diff845 (depth = 7)
  gc_frame_newslot(diff845);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = num838;
  params[1] = diff845;
  params[2] = *var_s;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call846 = callmethodflags(self, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe837);
// compiled call node returning call846 (depth = 6)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool847 = alloc_Boolean(1);
// compiled identifier node returning bool847 (depth = 7)
  block_return(realself, bool847);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if824 = undefined;
  } else {
  }
// compiled if node returning if824 (depth = 5)
  gc_frame_end(frame);
  return if824;
}
Object meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceUntil(1)with(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceUntil(_)with(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceUntil(_)with(_)onLine(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceUntil(_)with(_)onLine(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for replaceUntil(_)with(_)onLine(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_until = &(stackframe->slots[0]);
  *var_until = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part replaceUntil(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
  Object *var_len = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "len");
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe811 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call812 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe811);
// compiled call node returning call812 (depth = 4)
  *var_line = call812;
  if (call812 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe813 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_until (depth = 5)
  partcv[0] = 0;
  Object call814 = callmethodflags(*var_until, "size", 1, partcv, params, 0);
  gc_frame_end(callframe813);
// compiled member node returning call814 (depth = 4)
  *var_len = call814;
  if (call814 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe815 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe817 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  partcv[0] = 0;
  Object call818 = callmethodflags(*var_line, "size", 1, partcv, params, 0);
  gc_frame_end(callframe817);
// compiled member node returning call818 (depth = 5)
  int op_slot_right_816 = gc_frame_newslot(call818);
// starting to compile num node (depth = 5)
  Object num820 = alloc_Float64(1);
// compiled num node returning num820 (depth = 5)
  int op_slot_left_816 = gc_frame_newslot(num820);
  params[0] = call818;
  partcv[0] = 1;
  Object opresult821 = callmethod(num820, "..(1)", 1, partcv, params);
// compiled op node returning opresult821 (depth = 4)
  gc_frame_newslot(opresult821);
// starting to compile block node (depth = 4)
  Object block822 = alloc_Block(NULL, NULL, "errormessages", 40);
  gc_frame_newslot(block822);
// method "_apply(_)"
  block_savedest(block822);
  Object closure823 = createclosure(6, "_apply(1)");
  setclosureframe(closure823, stackframe);
  addtoclosure(closure823, var_until);
  addtoclosure(closure823, var_len);
  addtoclosure(closure823, var_line);
  addtoclosure(closure823, var_s);
  addtoclosure(closure823, var_lineNumber);
  addtoclosure(closure823, selfslot);
  struct UserObject *uo823 = (struct UserObject*)block822;
  uo823->data[0] = (Object)closure823;
  Method *meth_meth_errormessages_823__apply_40_1_41_ = addmethod2pos(block822, "_apply(1)", &meth_errormessages_823__apply_40_1_41_, 0);
  int argcv_meth_errormessages_823__apply_40_1_41_[] = {1};
  meth_meth_errormessages_823__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_823__apply_40_1_41_);
  meth_meth_errormessages_823__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_823__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block822 (depth = 4)
  gc_frame_newslot(block822);
// call case 5: prelude request
  params[0] = opresult821;
  params[1] = block822;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call849 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe815);
// compiled call node returning call849 (depth = 3)
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool850 = alloc_Boolean(0);
// compiled identifier node returning bool850 (depth = 4)
  return bool850;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_errormessages_878__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_indent = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit881 == NULL) {
    strlit881 = alloc_String(" ");
    gc_root(strlit881);
  }
// compiled string node returning strlit881 (depth = 8)
  int op_slot_right_880 = gc_frame_newslot(strlit881);
// starting to compile call node (depth = 8)
  int callframe883 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call884 = callmethodflags(*var_line, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe883);
// compiled call node returning call884 (depth = 8)
  int op_slot_left_880 = gc_frame_newslot(call884);
  params[0] = strlit881;
  partcv[0] = 1;
  Object opresult885 = callmethod(call884, "≠(1)", 1, partcv, params);
// compiled op node returning opresult885 (depth = 7)
  Object if879 = done;
  if (istrue(opresult885)) {
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool886 = alloc_Boolean(0);
// compiled identifier node returning bool886 (depth = 8)
  *var_indent = bool886;
  if (bool886 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if879 = done;
  } else {
  }
// compiled if node returning if879 (depth = 6)
  gc_frame_end(frame);
  return if879;
}
Object meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteRange(2)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method deleteRange(_,_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteRange(_,_)onLine(_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for deleteRange(_,_)onLine(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part deleteRange(_,_)");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_start_39_ = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "start'");
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
// definebindings:
  Object *var_indent = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "indent");
// definebindings:
// definebindings:
// definebindings:
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  *var_start_39_ = *var_start;
  if (*var_start == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe852 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call853 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe852);
// compiled call node returning call853 (depth = 4)
  *var_line = call853;
  if (call853 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe857 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  partcv[0] = 0;
  Object call858 = callmethodflags(*var_line, "size", 1, partcv, params, 0);
  gc_frame_end(callframe857);
// compiled member node returning call858 (depth = 6)
  int op_slot_right_856 = gc_frame_newslot(call858);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  int op_slot_left_856 = gc_frame_newslot(*var_end);
  params[0] = call858;
  partcv[0] = 1;
  Object opresult860 = callmethod(*var_end, "==(1)", 1, partcv, params);
// compiled op node returning opresult860 (depth = 5)
  int op_slot_right_855 = gc_frame_newslot(opresult860);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num863 = alloc_Float64(1);
// compiled num node returning num863 (depth = 6)
  int op_slot_right_862 = gc_frame_newslot(num863);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start_39_ (depth = 6)
  int op_slot_left_862 = gc_frame_newslot(*var_start_39_);
  params[0] = num863;
  partcv[0] = 1;
  Object opresult865 = callmethod(*var_start_39_, ">(1)", 1, partcv, params);
// compiled op node returning opresult865 (depth = 5)
  int op_slot_left_855 = gc_frame_newslot(opresult865);
  params[0] = opresult860;
  partcv[0] = 1;
  Object opresult866 = callmethod(opresult865, "&&(1)", 1, partcv, params);
// compiled op node returning opresult866 (depth = 4)
  Object if854 = done;
  if (istrue(opresult866)) {
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool867 = alloc_Boolean(1);
// compiled identifier node returning bool867 (depth = 5)
  *var_indent = bool867;
  if (bool867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe868 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num871 = alloc_Float64(1);
// compiled num node returning num871 (depth = 7)
  int op_slot_right_870 = gc_frame_newslot(num871);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start_39_ (depth = 7)
  int op_slot_left_870 = gc_frame_newslot(*var_start_39_);
  params[0] = num871;
  partcv[0] = 1;
  Object diff873 = callmethod(*var_start_39_, "-(1)", 1, partcv, params);
// compiled op node returning diff873 (depth = 6)
  int op_slot_right_869 = gc_frame_newslot(diff873);
// starting to compile num node (depth = 6)
  Object num875 = alloc_Float64(1);
// compiled num node returning num875 (depth = 6)
  int op_slot_left_869 = gc_frame_newslot(num875);
  params[0] = diff873;
  partcv[0] = 1;
  Object opresult876 = callmethod(num875, "..(1)", 1, partcv, params);
// compiled op node returning opresult876 (depth = 5)
  gc_frame_newslot(opresult876);
// starting to compile block node (depth = 5)
  Object block877 = alloc_Block(NULL, NULL, "errormessages", 55);
  gc_frame_newslot(block877);
// method "_apply(_)"
  block_savedest(block877);
  Object closure878 = createclosure(3, "_apply(1)");
  setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_line);
  addtoclosure(closure878, var_indent);
  addtoclosure(closure878, selfslot);
  struct UserObject *uo878 = (struct UserObject*)block877;
  uo878->data[0] = (Object)closure878;
  Method *meth_meth_errormessages_878__apply_40_1_41_ = addmethod2pos(block877, "_apply(1)", &meth_errormessages_878__apply_40_1_41_, 0);
  int argcv_meth_errormessages_878__apply_40_1_41_[] = {1};
  meth_meth_errormessages_878__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_878__apply_40_1_41_);
  meth_meth_errormessages_878__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_878__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block877 (depth = 5)
  gc_frame_newslot(block877);
// call case 5: prelude request
  params[0] = opresult876;
  params[1] = block877;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call889 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe868);
// compiled call node returning call889 (depth = 4)
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool892 = alloc_Boolean(1);
// compiled identifier node returning bool892 (depth = 6)
  int op_slot_right_891 = gc_frame_newslot(bool892);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indent (depth = 6)
  int op_slot_left_891 = gc_frame_newslot(*var_indent);
  params[0] = bool892;
  partcv[0] = 1;
  Object opresult894 = callmethod(*var_indent, "==(1)", 1, partcv, params);
// compiled op node returning opresult894 (depth = 5)
  Object if890 = done;
  if (istrue(opresult894)) {
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile num node (depth = 6)
  Object num895 = alloc_Float64(1);
// compiled num node returning num895 (depth = 6)
  *var_start_39_ = num895;
  if (num895 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if890 = done;
  } else {
  }
// compiled if node returning if890 (depth = 4)
    gc_frame_newslot(if890);
    if854 = if890;
  } else {
  }
// compiled if node returning if854 (depth = 3)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe897 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start_39_ (depth = 4)
  gc_frame_newslot(*var_start_39_);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile string node (depth = 4)
  if (strlit898 == NULL) {
    strlit898 = alloc_String("");
    gc_root(strlit898);
  }
// compiled string node returning strlit898 (depth = 4)
  gc_frame_newslot(strlit898);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_start_39_;
  params[1] = *var_end;
  params[2] = strlit898;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call899 = callmethodflags(self, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe897);
// compiled call node returning call899 (depth = 3)
  gc_frame_end(frame);
  return call899;
}
Object meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteChar(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteChar(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteChar(_)onLine(_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for deleteChar(_)onLine(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_pos = &(stackframe->slots[0]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part deleteChar(_)");
  Object *var_lineNumber = &(stackframe->slots[1]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe901 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile string node (depth = 4)
  if (strlit902 == NULL) {
    strlit902 = alloc_String("");
    gc_root(strlit902);
  }
// compiled string node returning strlit902 (depth = 4)
  gc_frame_newslot(strlit902);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_pos;
  params[1] = *var_pos;
  params[2] = strlit902;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call903 = callmethodflags(self, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe901);
// compiled call node returning call903 (depth = 3)
  gc_frame_end(frame);
  return call903;
}
Object meth_errormessages_904_append_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "append(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method append(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method append(_)onLine(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for append(_)onLine(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part append(_)");
  Object *var_lineNumber = &(stackframe->slots[1]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_line = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "line");
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe905 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call906 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe905);
// compiled call node returning call906 (depth = 4)
  *var_line = call906;
  if (call906 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe907 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_right_908 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  int op_slot_left_908 = gc_frame_newslot(*var_line);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult910 = callmethod(*var_line, "++(1)", 1, partcv, params);
// compiled op node returning opresult910 (depth = 4)
  gc_frame_newslot(opresult910);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult910;
  partcv[0] = 2;
  Object call911 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe907);
// compiled call node returning call911 (depth = 3)
  gc_frame_end(frame);
  return call911;
}
Object meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert(1)atPosition(1)onLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)atPosition(_)onLine(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)atPosition(_)onLine(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)atPosition(_)onLine(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for insert(_)atPosition(_)onLine(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part insert(_)");
  Object *var_pos = &(stackframe->slots[1]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atPosition(_)");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLine(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
// definebindings:
// definebindings:
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe913 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call914 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe913);
// compiled call node returning call914 (depth = 4)
  *var_line = call914;
  if (call914 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num917 = alloc_Float64(1);
// compiled num node returning num917 (depth = 5)
  int op_slot_right_916 = gc_frame_newslot(num917);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_pos (depth = 5)
  int op_slot_left_916 = gc_frame_newslot(*var_pos);
  params[0] = num917;
  partcv[0] = 1;
  Object opresult919 = callmethod(*var_pos, "==(1)", 1, partcv, params);
// compiled op node returning opresult919 (depth = 4)
  Object if915 = done;
  if (istrue(opresult919)) {
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe920 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  int op_slot_right_921 = gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_921 = gc_frame_newslot(*var_s);
  params[0] = *var_line;
  partcv[0] = 1;
  Object opresult923 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult923 (depth = 5)
  gc_frame_newslot(opresult923);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult923;
  partcv[0] = 2;
  Object call924 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe920);
// compiled call node returning call924 (depth = 4)
    gc_frame_newslot(call924);
    if915 = call924;
  } else {
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe925 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe927 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_pos (depth = 7)
  gc_frame_newslot(*var_pos);
// starting to compile member node (depth = 7)
  int callframe928 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  partcv[0] = 0;
  Object call929 = callmethodflags(*var_line, "size", 1, partcv, params, 0);
  gc_frame_end(callframe928);
// compiled member node returning call929 (depth = 7)
  gc_frame_newslot(call929);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  params[0] = *var_pos;
  params[1] = call929;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call930 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe927);
// compiled call node returning call930 (depth = 6)
  int op_slot_right_926 = gc_frame_newslot(call930);
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_932 = gc_frame_newslot(*var_s);
// starting to compile call node (depth = 7)
  int callframe934 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num935 = alloc_Float64(1);
// compiled num node returning num935 (depth = 8)
  gc_frame_newslot(num935);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num937 = alloc_Float64(1);
// compiled num node returning num937 (depth = 9)
  int op_slot_right_936 = gc_frame_newslot(num937);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_pos (depth = 9)
  int op_slot_left_936 = gc_frame_newslot(*var_pos);
  params[0] = num937;
  partcv[0] = 1;
  Object diff939 = callmethod(*var_pos, "-(1)", 1, partcv, params);
// compiled op node returning diff939 (depth = 8)
  gc_frame_newslot(diff939);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  params[0] = num935;
  params[1] = diff939;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call940 = callmethodflags(*var_line, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe934);
// compiled call node returning call940 (depth = 7)
  int op_slot_left_932 = gc_frame_newslot(call940);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult941 = callmethod(call940, "++(1)", 1, partcv, params);
// compiled op node returning opresult941 (depth = 6)
  int op_slot_left_926 = gc_frame_newslot(opresult941);
  params[0] = call930;
  partcv[0] = 1;
  Object opresult942 = callmethod(opresult941, "++(1)", 1, partcv, params);
// compiled op node returning opresult942 (depth = 5)
  gc_frame_newslot(opresult942);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult942;
  partcv[0] = 2;
  Object call943 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe925);
// compiled call node returning call943 (depth = 4)
    gc_frame_newslot(call943);
    if915 = call943;
  }
// compiled if node returning if915 (depth = 3)
  gc_frame_end(frame);
  return if915;
}
Object meth_errormessages_955__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe957 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  partcv[0] = 0;
  Object call958 = callmethodflags(*var_token, "line", 1, partcv, params, 0);
  gc_frame_end(callframe957);
// compiled member node returning call958 (depth = 8)
  int op_slot_right_956 = gc_frame_newslot(call958);
// starting to compile member node (depth = 8)
  int callframe960 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe961 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_token (depth = 10)
  partcv[0] = 0;
  Object call962 = callmethodflags(*var_token, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe961);
// compiled member node returning call962 (depth = 9)
  partcv[0] = 0;
  Object call963 = callmethodflags(call962, "line", 1, partcv, params, 0);
  gc_frame_end(callframe960);
// compiled member node returning call963 (depth = 8)
  int op_slot_left_956 = gc_frame_newslot(call963);
  params[0] = call958;
  partcv[0] = 1;
  Object opresult964 = callmethod(call963, "==(1)", 1, partcv, params);
// compiled op node returning opresult964 (depth = 7)
  gc_frame_end(frame);
  return opresult964;
}
Object meth_errormessages_1001__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1003 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  partcv[0] = 0;
  Object call1004 = callmethodflags(*var_token, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1003);
// compiled member node returning call1004 (depth = 8)
  int op_slot_right_1002 = gc_frame_newslot(call1004);
// starting to compile member node (depth = 8)
  int callframe1006 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1007 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_token (depth = 10)
  partcv[0] = 0;
  Object call1008 = callmethodflags(*var_token, "next", 1, partcv, params, 0);
  gc_frame_end(callframe1007);
// compiled member node returning call1008 (depth = 9)
  partcv[0] = 0;
  Object call1009 = callmethodflags(call1008, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1006);
// compiled member node returning call1009 (depth = 8)
  int op_slot_left_1002 = gc_frame_newslot(call1009);
  params[0] = call1004;
  partcv[0] = 1;
  Object opresult1010 = callmethod(call1009, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1010 (depth = 7)
  gc_frame_end(frame);
  return opresult1010;
}
Object meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "getTokenStart(1)includeLeadingSpace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenStart(_)includeLeadingSpace(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenStart(_)includeLeadingSpace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for getTokenStart(_)includeLeadingSpace(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part getTokenStart(_)");
  Object *var_includeLeading = &(stackframe->slots[1]);
  *var_includeLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part includeLeadingSpace(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe945 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  partcv[0] = 0;
  Object call946 = callmethodflags(*var_token, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe945);
// compiled member node returning call946 (depth = 4)
  *var_start = call946;
  if (call946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool949 = alloc_Boolean(1);
// compiled identifier node returning bool949 (depth = 5)
  int op_slot_right_948 = gc_frame_newslot(bool949);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_includeLeading (depth = 5)
  int op_slot_left_948 = gc_frame_newslot(*var_includeLeading);
  params[0] = bool949;
  partcv[0] = 1;
  Object opresult951 = callmethod(*var_includeLeading, "==(1)", 1, partcv, params);
// compiled op node returning opresult951 (depth = 4)
  Object if947 = done;
  if (istrue(opresult951)) {
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block954 = alloc_Block(NULL, NULL, "errormessages", 94);
  gc_frame_newslot(block954);
// method "_apply"
  block_savedest(block954);
  Object closure955 = createclosure(2, "_apply");
  setclosureframe(closure955, stackframe);
  addtoclosure(closure955, var_token);
  addtoclosure(closure955, selfslot);
  struct UserObject *uo955 = (struct UserObject*)block954;
  uo955->data[0] = (Object)closure955;
  Method *meth_meth_errormessages_955__apply = addmethod2pos(block954, "_apply", &meth_errormessages_955__apply, 0);
  int argcv_meth_errormessages_955__apply[] = {0};
  meth_meth_errormessages_955__apply->type = alloc_MethodType(1, argcv_meth_errormessages_955__apply);
  meth_meth_errormessages_955__apply->definitionModule = modulename;
  meth_meth_errormessages_955__apply->definitionLine = 528;
// compiled block node returning block954 (depth = 6)
  int op_slot_right_953 = gc_frame_newslot(block954);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool968 = alloc_Boolean(0);
// compiled identifier node returning bool968 (depth = 7)
  int op_slot_right_967 = gc_frame_newslot(bool968);
// starting to compile member node (depth = 7)
  int callframe970 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call971 = callmethodflags(*var_token, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe970);
// compiled member node returning call971 (depth = 7)
  int op_slot_left_967 = gc_frame_newslot(call971);
  params[0] = bool968;
  partcv[0] = 1;
  Object opresult972 = callmethod(call971, "≠(1)", 1, partcv, params);
// compiled op node returning opresult972 (depth = 6)
  int op_slot_left_953 = gc_frame_newslot(opresult972);
  params[0] = block954;
  partcv[0] = 1;
  Object opresult973 = callmethod(opresult972, "&&(1)", 1, partcv, params);
// compiled op node returning opresult973 (depth = 5)
  Object if952 = done;
  if (istrue(opresult973)) {
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe975 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe976 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  partcv[0] = 0;
  Object call977 = callmethodflags(*var_token, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe976);
// compiled member node returning call977 (depth = 8)
  partcv[0] = 0;
  Object call978 = callmethodflags(call977, "size", 1, partcv, params, 0);
  gc_frame_end(callframe975);
// compiled member node returning call978 (depth = 7)
  int op_slot_right_974 = gc_frame_newslot(call978);
// starting to compile member node (depth = 7)
  int callframe980 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe981 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  partcv[0] = 0;
  Object call982 = callmethodflags(*var_token, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe981);
// compiled member node returning call982 (depth = 8)
  partcv[0] = 0;
  Object call983 = callmethodflags(call982, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe980);
// compiled member node returning call983 (depth = 7)
  int op_slot_left_974 = gc_frame_newslot(call983);
  params[0] = call978;
  partcv[0] = 1;
  Object sum984 = callmethod(call983, "+(1)", 1, partcv, params);
// compiled op node returning sum984 (depth = 6)
  *var_start = sum984;
  if (sum984 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if952 = done;
  } else {
  }
// compiled if node returning if952 (depth = 4)
    gc_frame_newslot(if952);
    if947 = if952;
  } else {
  }
// compiled if node returning if947 (depth = 3)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num989 = alloc_Float64(1);
// compiled num node returning num989 (depth = 6)
  int op_slot_right_988 = gc_frame_newslot(num989);
// starting to compile member node (depth = 6)
  int callframe991 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  partcv[0] = 0;
  Object call992 = callmethodflags(*var_token, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe991);
// compiled member node returning call992 (depth = 6)
  int op_slot_left_988 = gc_frame_newslot(call992);
  params[0] = num989;
  partcv[0] = 1;
  Object sum993 = callmethod(call992, "+(1)", 1, partcv, params);
// compiled op node returning sum993 (depth = 5)
  int op_slot_right_987 = gc_frame_newslot(sum993);
// starting to compile member node (depth = 5)
  int callframe995 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  partcv[0] = 0;
  Object call996 = callmethodflags(*var_token, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe995);
// compiled member node returning call996 (depth = 5)
  int op_slot_left_987 = gc_frame_newslot(call996);
  params[0] = sum993;
  partcv[0] = 1;
  Object opresult997 = callmethod(call996, "==(1)", 1, partcv, params);
// compiled op node returning opresult997 (depth = 4)
  Object if986 = done;
  if (istrue(opresult997)) {
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block1000 = alloc_Block(NULL, NULL, "errormessages", 100);
  gc_frame_newslot(block1000);
// method "_apply"
  block_savedest(block1000);
  Object closure1001 = createclosure(2, "_apply");
  setclosureframe(closure1001, stackframe);
  addtoclosure(closure1001, var_token);
  addtoclosure(closure1001, selfslot);
  struct UserObject *uo1001 = (struct UserObject*)block1000;
  uo1001->data[0] = (Object)closure1001;
  Method *meth_meth_errormessages_1001__apply = addmethod2pos(block1000, "_apply", &meth_errormessages_1001__apply, 0);
  int argcv_meth_errormessages_1001__apply[] = {0};
  meth_meth_errormessages_1001__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1001__apply);
  meth_meth_errormessages_1001__apply->definitionModule = modulename;
  meth_meth_errormessages_1001__apply->definitionLine = 528;
// compiled block node returning block1000 (depth = 6)
  int op_slot_right_999 = gc_frame_newslot(block1000);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1014 = alloc_Boolean(0);
// compiled identifier node returning bool1014 (depth = 7)
  int op_slot_right_1013 = gc_frame_newslot(bool1014);
// starting to compile member node (depth = 7)
  int callframe1016 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call1017 = callmethodflags(*var_token, "next", 1, partcv, params, 0);
  gc_frame_end(callframe1016);
// compiled member node returning call1017 (depth = 7)
  int op_slot_left_1013 = gc_frame_newslot(call1017);
  params[0] = bool1014;
  partcv[0] = 1;
  Object opresult1018 = callmethod(call1017, "==(1)", 1, partcv, params);
// compiled op node returning opresult1018 (depth = 6)
  int op_slot_left_999 = gc_frame_newslot(opresult1018);
  params[0] = block1000;
  partcv[0] = 1;
  Object opresult1019 = callmethod(opresult1018, "||(1)", 1, partcv, params);
// compiled op node returning opresult1019 (depth = 5)
  Object if998 = done;
  if (istrue(opresult1019)) {
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1020 = alloc_Float64(1);
// compiled num node returning num1020 (depth = 6)
  *var_start = num1020;
  if (num1020 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if998 = done;
  } else {
  }
// compiled if node returning if998 (depth = 4)
    gc_frame_newslot(if998);
    if986 = if998;
  } else {
  }
// compiled if node returning if986 (depth = 3)
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_start (depth = 3)
  gc_frame_end(frame);
  return *var_start;
}
Object meth_errormessages_1042__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1044 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  partcv[0] = 0;
  Object call1045 = callmethodflags(*var_token, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1044);
// compiled member node returning call1045 (depth = 8)
  int op_slot_right_1043 = gc_frame_newslot(call1045);
// starting to compile member node (depth = 8)
  int callframe1047 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1048 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_token (depth = 10)
  partcv[0] = 0;
  Object call1049 = callmethodflags(*var_token, "next", 1, partcv, params, 0);
  gc_frame_end(callframe1048);
// compiled member node returning call1049 (depth = 9)
  partcv[0] = 0;
  Object call1050 = callmethodflags(call1049, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1047);
// compiled member node returning call1050 (depth = 8)
  int op_slot_left_1043 = gc_frame_newslot(call1050);
  params[0] = call1045;
  partcv[0] = 1;
  Object opresult1051 = callmethod(call1050, "==(1)", 1, partcv, params);
// compiled op node returning opresult1051 (depth = 7)
  gc_frame_end(frame);
  return opresult1051;
}
Object meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "getTokenEnd(1)includeTrailingSpace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenEnd(_)includeTrailingSpace(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenEnd(_)includeTrailingSpace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for getTokenEnd(_)includeTrailingSpace(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part getTokenEnd(_)");
  Object *var_includeTrailing = &(stackframe->slots[1]);
  *var_includeTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part includeTrailingSpace(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_end = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "end");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1024 = alloc_Float64(1);
// compiled num node returning num1024 (depth = 5)
  int op_slot_right_1023 = gc_frame_newslot(num1024);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1027 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  partcv[0] = 0;
  Object call1028 = callmethodflags(*var_token, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1027);
// compiled member node returning call1028 (depth = 6)
  int op_slot_right_1026 = gc_frame_newslot(call1028);
// starting to compile member node (depth = 6)
  int callframe1030 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  partcv[0] = 0;
  Object call1031 = callmethodflags(*var_token, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1030);
// compiled member node returning call1031 (depth = 6)
  int op_slot_left_1026 = gc_frame_newslot(call1031);
  params[0] = call1028;
  partcv[0] = 1;
  Object sum1032 = callmethod(call1031, "+(1)", 1, partcv, params);
// compiled op node returning sum1032 (depth = 5)
  int op_slot_left_1023 = gc_frame_newslot(sum1032);
  params[0] = num1024;
  partcv[0] = 1;
  Object diff1033 = callmethod(sum1032, "-(1)", 1, partcv, params);
// compiled op node returning diff1033 (depth = 4)
  *var_end = diff1033;
  if (diff1033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1036 = alloc_Boolean(1);
// compiled identifier node returning bool1036 (depth = 5)
  int op_slot_right_1035 = gc_frame_newslot(bool1036);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_includeTrailing (depth = 5)
  int op_slot_left_1035 = gc_frame_newslot(*var_includeTrailing);
  params[0] = bool1036;
  partcv[0] = 1;
  Object opresult1038 = callmethod(*var_includeTrailing, "==(1)", 1, partcv, params);
// compiled op node returning opresult1038 (depth = 4)
  Object if1034 = done;
  if (istrue(opresult1038)) {
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block1041 = alloc_Block(NULL, NULL, "errormessages", 111);
  gc_frame_newslot(block1041);
// method "_apply"
  block_savedest(block1041);
  Object closure1042 = createclosure(2, "_apply");
  setclosureframe(closure1042, stackframe);
  addtoclosure(closure1042, var_token);
  addtoclosure(closure1042, selfslot);
  struct UserObject *uo1042 = (struct UserObject*)block1041;
  uo1042->data[0] = (Object)closure1042;
  Method *meth_meth_errormessages_1042__apply = addmethod2pos(block1041, "_apply", &meth_errormessages_1042__apply, 0);
  int argcv_meth_errormessages_1042__apply[] = {0};
  meth_meth_errormessages_1042__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1042__apply);
  meth_meth_errormessages_1042__apply->definitionModule = modulename;
  meth_meth_errormessages_1042__apply->definitionLine = 528;
// compiled block node returning block1041 (depth = 6)
  int op_slot_right_1040 = gc_frame_newslot(block1041);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1055 = alloc_Boolean(0);
// compiled identifier node returning bool1055 (depth = 7)
  int op_slot_right_1054 = gc_frame_newslot(bool1055);
// starting to compile member node (depth = 7)
  int callframe1057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call1058 = callmethodflags(*var_token, "next", 1, partcv, params, 0);
  gc_frame_end(callframe1057);
// compiled member node returning call1058 (depth = 7)
  int op_slot_left_1054 = gc_frame_newslot(call1058);
  params[0] = bool1055;
  partcv[0] = 1;
  Object opresult1059 = callmethod(call1058, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1059 (depth = 6)
  int op_slot_left_1040 = gc_frame_newslot(opresult1059);
  params[0] = block1041;
  partcv[0] = 1;
  Object opresult1060 = callmethod(opresult1059, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1060 (depth = 5)
  Object if1039 = done;
  if (istrue(opresult1060)) {
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1062 = alloc_Float64(1);
// compiled num node returning num1062 (depth = 7)
  int op_slot_right_1061 = gc_frame_newslot(num1062);
// starting to compile member node (depth = 7)
  int callframe1064 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1065 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  partcv[0] = 0;
  Object call1066 = callmethodflags(*var_token, "next", 1, partcv, params, 0);
  gc_frame_end(callframe1065);
// compiled member node returning call1066 (depth = 8)
  partcv[0] = 0;
  Object call1067 = callmethodflags(call1066, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1064);
// compiled member node returning call1067 (depth = 7)
  int op_slot_left_1061 = gc_frame_newslot(call1067);
  params[0] = num1062;
  partcv[0] = 1;
  Object diff1068 = callmethod(call1067, "-(1)", 1, partcv, params);
// compiled op node returning diff1068 (depth = 6)
  *var_end = diff1068;
  if (diff1068 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1039 = done;
  } else {
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1070 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1071 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe1072 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  partcv[0] = 0;
  Object call1073 = callmethodflags(*var_token, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1072);
// compiled member node returning call1073 (depth = 8)
  gc_frame_newslot(call1073);
// call case 4: self request
  params[0] = call1073;
  partcv[0] = 1;
  Object call1074 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1071);
// compiled call node returning call1074 (depth = 7)
  partcv[0] = 0;
  Object call1075 = callmethodflags(call1074, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1070);
// compiled member node returning call1075 (depth = 6)
  *var_end = call1075;
  if (call1075 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1039 = done;
  }
// compiled if node returning if1039 (depth = 4)
    gc_frame_newslot(if1039);
    if1034 = if1039;
  } else {
  }
// compiled if node returning if1034 (depth = 3)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_end (depth = 3)
  gc_frame_end(frame);
  return *var_end;
}
Object meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceToken(1)leading(1)trailing(1)with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[3] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)leading(_)trailing(_)with(_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 4 && args)
    graceRaise(RequestError(), "missing argument list for replaceToken(_)leading(_)trailing(_)with(_) (probably reflection error): got %i lists, expected 4.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part replaceToken(_)");
  Object *var_replaceLeading = &(stackframe->slots[1]);
  *var_replaceLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part leading(_)");
  Object *var_replaceTrailing = &(stackframe->slots[2]);
  *var_replaceTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part trailing(_)");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[3] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_start = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "start");
  Object *var_end = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "end");
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1078 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceLeading (depth = 5)
  gc_frame_newslot(*var_replaceLeading);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_replaceLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1079 = callmethodflags(self, "getTokenStart(1)includeLeadingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1078);
// compiled call node returning call1079 (depth = 4)
  *var_start = call1079;
  if (call1079 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1080 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceTrailing (depth = 5)
  gc_frame_newslot(*var_replaceTrailing);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_replaceTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1081 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1080);
// compiled call node returning call1081 (depth = 4)
  *var_end = call1081;
  if (call1081 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1082 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile member node (depth = 4)
  int callframe1083 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  partcv[0] = 0;
  Object call1084 = callmethodflags(*var_token, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1083);
// compiled member node returning call1084 (depth = 4)
  gc_frame_newslot(call1084);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = *var_s;
  params[3] = call1084;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1085 = callmethodflags(self, "replaceRange(2)with(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1082);
// compiled call node returning call1085 (depth = 3)
  gc_frame_end(frame);
  return call1085;
}
Object meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceToken(1)with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)with(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken(_)with(_)");
  Object params[4];
  int partcv[4];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for replaceToken(_)with(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part replaceToken(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1087 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 4)
  Object bool1088 = alloc_Boolean(0);
// compiled identifier node returning bool1088 (depth = 4)
  gc_frame_newslot(bool1088);
// starting to compile identifier node (depth = 4)
  Object bool1089 = alloc_Boolean(0);
// compiled identifier node returning bool1089 (depth = 4)
  gc_frame_newslot(bool1089);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_token;
  params[1] = bool1088;
  params[2] = bool1089;
  params[3] = *var_s;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1090 = callmethodflags(self, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1087);
// compiled call node returning call1090 (depth = 3)
  gc_frame_end(frame);
  return call1090;
}
Object meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(8, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceTokenRange(2)leading(1)trailing(1)with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)leading(_)trailing(_)with(_)");
  if (nparts > 0 && argcv[3] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)leading(_)trailing(_)with(_)");
  Object params[4];
  int partcv[4];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 4 && args)
    graceRaise(RequestError(), "missing argument list for replaceTokenRange(_,_)leading(_)trailing(_)with(_) (probably reflection error): got %i lists, expected 4.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part replaceTokenRange(_,_)");
  Object *var_replaceLeading = &(stackframe->slots[2]);
  *var_replaceLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part leading(_)");
  Object *var_replaceTrailing = &(stackframe->slots[3]);
  *var_replaceTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part trailing(_)");
  Object *var_s = &(stackframe->slots[4]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[3] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_insertPos = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "insertPos");
  Object *var_indent = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "indent");
// definebindings:
// definebindings:
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_end (depth = 5)
  int op_slot_right_1093 = gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  int op_slot_left_1093 = gc_frame_newslot(*var_start);
  params[0] = *var_end;
  partcv[0] = 1;
  Object opresult1095 = callmethod(*var_start, "==(1)", 1, partcv, params);
// compiled op node returning opresult1095 (depth = 4)
  Object if1092 = done;
  if (istrue(opresult1095)) {
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1096 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceLeading (depth = 5)
  gc_frame_newslot(*var_replaceLeading);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceTrailing (depth = 5)
  gc_frame_newslot(*var_replaceTrailing);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_replaceLeading;
  params[2] = *var_replaceTrailing;
  params[3] = *var_s;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1097 = callmethodflags(self, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1096);
// compiled call node returning call1097 (depth = 4)
    gc_frame_newslot(call1097);
    if1092 = call1097;
  } else {
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1098 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_replaceLeading (depth = 6)
  gc_frame_newslot(*var_replaceLeading);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_replaceLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1099 = callmethodflags(self, "getTokenStart(1)includeLeadingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1098);
// compiled call node returning call1099 (depth = 5)
  *var_insertPos = call1099;
  if (call1099 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1100 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num1101 = alloc_Float64(1);
// compiled num node returning num1101 (depth = 6)
  gc_frame_newslot(num1101);
// starting to compile member node (depth = 6)
  int callframe1102 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start (depth = 7)
  partcv[0] = 0;
  Object call1103 = callmethodflags(*var_start, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe1102);
// compiled member node returning call1103 (depth = 6)
  gc_frame_newslot(call1103);
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe1104 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe1105 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  partcv[0] = 0;
  Object call1106 = callmethodflags(*var_start, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1105);
// compiled member node returning call1106 (depth = 7)
  gc_frame_newslot(call1106);
// call case 4: self request
  params[0] = call1106;
  partcv[0] = 1;
  Object call1107 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1104);
// compiled call node returning call1107 (depth = 6)
  params[0] = num1101;
  params[1] = call1103;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1108 = callmethodflags(call1107, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1100);
// compiled call node returning call1108 (depth = 5)
  *var_indent = call1108;
  if (call1108 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1109 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_end (depth = 5)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceLeading (depth = 5)
  gc_frame_newslot(*var_replaceLeading);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceTrailing (depth = 5)
  gc_frame_newslot(*var_replaceTrailing);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = *var_replaceLeading;
  params[3] = *var_replaceTrailing;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1110 = callmethodflags(self, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1109);
// compiled call node returning call1110 (depth = 4)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1113 == NULL) {
    strlit1113 = alloc_String("");
    gc_root(strlit1113);
  }
// compiled string node returning strlit1113 (depth = 6)
  int op_slot_right_1112 = gc_frame_newslot(strlit1113);
// starting to compile call node (depth = 6)
  int callframe1115 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe1116 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  partcv[0] = 0;
  Object call1117 = callmethodflags(*var_start, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1116);
// compiled member node returning call1117 (depth = 7)
  gc_frame_newslot(call1117);
// call case 4: self request
  params[0] = call1117;
  partcv[0] = 1;
  Object call1118 = callmethodflags(self, "getLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1115);
// compiled call node returning call1118 (depth = 6)
  int op_slot_left_1112 = gc_frame_newslot(call1118);
  params[0] = strlit1113;
  partcv[0] = 1;
  Object opresult1119 = callmethod(call1118, "==(1)", 1, partcv, params);
// compiled op node returning opresult1119 (depth = 5)
  Object if1111 = done;
  if (istrue(opresult1119)) {
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1120 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_1121 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_indent (depth = 7)
  int op_slot_left_1121 = gc_frame_newslot(*var_indent);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult1123 = callmethod(*var_indent, "++(1)", 1, partcv, params);
// compiled op node returning opresult1123 (depth = 6)
  gc_frame_newslot(opresult1123);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertPos (depth = 6)
  gc_frame_newslot(*var_insertPos);
// starting to compile member node (depth = 6)
  int callframe1124 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start (depth = 7)
  partcv[0] = 0;
  Object call1125 = callmethodflags(*var_start, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1124);
// compiled member node returning call1125 (depth = 6)
  gc_frame_newslot(call1125);
// call case 4: self request
  params[0] = opresult1123;
  params[1] = *var_insertPos;
  params[2] = call1125;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1126 = callmethodflags(self, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1120);
// compiled call node returning call1126 (depth = 5)
    gc_frame_newslot(call1126);
    if1111 = call1126;
  } else {
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1127 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertPos (depth = 6)
  gc_frame_newslot(*var_insertPos);
// starting to compile member node (depth = 6)
  int callframe1128 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start (depth = 7)
  partcv[0] = 0;
  Object call1129 = callmethodflags(*var_start, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1128);
// compiled member node returning call1129 (depth = 6)
  gc_frame_newslot(call1129);
// call case 4: self request
  params[0] = *var_s;
  params[1] = *var_insertPos;
  params[2] = call1129;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1130 = callmethodflags(self, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1127);
// compiled call node returning call1130 (depth = 5)
    gc_frame_newslot(call1130);
    if1111 = call1130;
  }
// compiled if node returning if1111 (depth = 4)
    gc_frame_newslot(if1111);
    if1092 = if1111;
  }
// compiled if node returning if1092 (depth = 3)
  gc_frame_end(frame);
  return if1092;
}
Object meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceTokenRange(2)with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)with(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange(_,_)with(_)");
  Object params[5];
  int partcv[4];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for replaceTokenRange(_,_)with(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part replaceTokenRange(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1132 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 4)
  Object bool1133 = alloc_Boolean(0);
// compiled identifier node returning bool1133 (depth = 4)
  gc_frame_newslot(bool1133);
// starting to compile identifier node (depth = 4)
  Object bool1134 = alloc_Boolean(0);
// compiled identifier node returning bool1134 (depth = 4)
  gc_frame_newslot(bool1134);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = bool1133;
  params[3] = bool1134;
  params[4] = *var_s;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1135 = callmethodflags(self, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1132);
// compiled call node returning call1135 (depth = 3)
  gc_frame_end(frame);
  return call1135;
}
Object meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteToken(1)leading(1)trailing(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken(_)leading(_)trailing(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken(_)leading(_)trailing(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken(_)leading(_)trailing(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for deleteToken(_)leading(_)trailing(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part deleteToken(_)");
  Object *var_deleteLeading = &(stackframe->slots[1]);
  *var_deleteLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part leading(_)");
  Object *var_deleteTrailing = &(stackframe->slots[2]);
  *var_deleteTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part trailing(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_start = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "start");
  Object *var_end = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "end");
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1137 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteLeading (depth = 5)
  gc_frame_newslot(*var_deleteLeading);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_deleteLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1138 = callmethodflags(self, "getTokenStart(1)includeLeadingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1137);
// compiled call node returning call1138 (depth = 4)
  *var_start = call1138;
  if (call1138 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1139 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteTrailing (depth = 5)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1140 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1139);
// compiled call node returning call1140 (depth = 4)
  *var_end = call1140;
  if (call1140 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1141 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile member node (depth = 4)
  int callframe1142 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  partcv[0] = 0;
  Object call1143 = callmethodflags(*var_token, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1142);
// compiled member node returning call1143 (depth = 4)
  gc_frame_newslot(call1143);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = call1143;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1144 = callmethodflags(self, "deleteRange(2)onLine(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1141);
// compiled call node returning call1144 (depth = 3)
  gc_frame_end(frame);
  return call1144;
}
Object meth_errormessages_1145_deleteToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deleteToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part deleteToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1146 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 4)
  Object bool1147 = alloc_Boolean(0);
// compiled identifier node returning bool1147 (depth = 4)
  gc_frame_newslot(bool1147);
// starting to compile identifier node (depth = 4)
  Object bool1148 = alloc_Boolean(0);
// compiled identifier node returning bool1148 (depth = 4)
  gc_frame_newslot(bool1148);
// call case 4: self request
  params[0] = *var_token;
  params[1] = bool1147;
  params[2] = bool1148;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1149 = callmethodflags(self, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1146);
// compiled call node returning call1149 (depth = 3)
  gc_frame_end(frame);
  return call1149;
}
Object meth_errormessages_1167__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_end (depth = 7)
  int op_slot_right_1168 = gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  int op_slot_left_1168 = gc_frame_newslot(*var_tok);
  params[0] = *var_end;
  partcv[0] = 1;
  Object opresult1170 = callmethod(*var_tok, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1170 (depth = 6)
  gc_frame_end(frame);
  return opresult1170;
}
Object meth_errormessages_1173__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_startPos = getfromclosure(closure, 2);
  Object *var_endPos = getfromclosure(closure, 3);
  Object *var_deleteLeading = getfromclosure(closure, 4);
  Object *var_deleteTrailing = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  int op_slot_right_1175 = gc_frame_newslot(*var_line);
// starting to compile member node (depth = 8)
  int callframe1177 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  partcv[0] = 0;
  Object call1178 = callmethodflags(*var_tok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1177);
// compiled member node returning call1178 (depth = 8)
  int op_slot_left_1175 = gc_frame_newslot(call1178);
  params[0] = *var_line;
  partcv[0] = 1;
  Object opresult1179 = callmethod(call1178, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1179 (depth = 7)
  Object if1174 = done;
  if (istrue(opresult1179)) {
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1180 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startPos (depth = 8)
  gc_frame_newslot(*var_startPos);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_endPos (depth = 8)
  gc_frame_newslot(*var_endPos);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  gc_frame_newslot(*var_line);
// call case 4: self request
  params[0] = *var_startPos;
  params[1] = *var_endPos;
  params[2] = *var_line;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1181 = callmethodflags(self, "deleteRange(2)onLine(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1180);
// compiled call node returning call1181 (depth = 7)
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1182 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  partcv[0] = 0;
  Object call1183 = callmethodflags(*var_tok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1182);
// compiled member node returning call1183 (depth = 8)
  *var_line = call1183;
  if (call1183 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1185 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_deleteLeading (depth = 9)
  gc_frame_newslot(*var_deleteLeading);
// call case 4: self request
  params[0] = *var_tok;
  params[1] = *var_deleteLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1186 = callmethodflags(self, "getTokenStart(1)includeLeadingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1185);
// compiled call node returning call1186 (depth = 8)
  *var_startPos = call1186;
  if (call1186 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1174 = done;
  } else {
  }
// compiled if node returning if1174 (depth = 6)
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1188 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_deleteTrailing (depth = 8)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_tok;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1189 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1188);
// compiled call node returning call1189 (depth = 7)
  *var_endPos = call1189;
  if (call1189 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1191 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  partcv[0] = 0;
  Object call1192 = callmethodflags(*var_tok, "next", 1, partcv, params, 0);
  gc_frame_end(callframe1191);
// compiled member node returning call1192 (depth = 7)
  *var_tok = call1192;
  if (call1192 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(9, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteTokenRange(2)leading(1)trailing(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange(_,_)leading(_)trailing(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange(_,_)leading(_)trailing(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange(_,_)leading(_)trailing(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for deleteTokenRange(_,_)leading(_)trailing(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part deleteTokenRange(_,_)");
  Object *var_deleteLeading = &(stackframe->slots[2]);
  *var_deleteLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part leading(_)");
  Object *var_deleteTrailing = &(stackframe->slots[3]);
  *var_deleteTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part trailing(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
  Object *var_startPos = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "startPos");
  Object *var_endPos = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "endPos");
  Object *var_tok = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "tok");
// definebindings:
// definebindings:
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_end (depth = 5)
  int op_slot_right_1152 = gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  int op_slot_left_1152 = gc_frame_newslot(*var_start);
  params[0] = *var_end;
  partcv[0] = 1;
  Object opresult1154 = callmethod(*var_start, "==(1)", 1, partcv, params);
// compiled op node returning opresult1154 (depth = 4)
  Object if1151 = done;
  if (istrue(opresult1154)) {
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1155 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteLeading (depth = 5)
  gc_frame_newslot(*var_deleteLeading);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteTrailing (depth = 5)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_deleteLeading;
  params[2] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1156 = callmethodflags(self, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1155);
// compiled call node returning call1156 (depth = 4)
    gc_frame_newslot(call1156);
    if1151 = call1156;
  } else {
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1157 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  partcv[0] = 0;
  Object call1158 = callmethodflags(*var_start, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1157);
// compiled member node returning call1158 (depth = 5)
  *var_line = call1158;
  if (call1158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1159 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_deleteLeading (depth = 6)
  gc_frame_newslot(*var_deleteLeading);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_deleteLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1160 = callmethodflags(self, "getTokenStart(1)includeLeadingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1159);
// compiled call node returning call1160 (depth = 5)
  *var_startPos = call1160;
  if (call1160 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1161 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_deleteTrailing (depth = 6)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1162 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1161);
// compiled call node returning call1162 (depth = 5)
  *var_endPos = call1162;
  if (call1162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1163 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  partcv[0] = 0;
  Object call1164 = callmethodflags(*var_start, "next", 1, partcv, params, 0);
  gc_frame_end(callframe1163);
// compiled member node returning call1164 (depth = 5)
  *var_tok = call1164;
  if (call1164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1165 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1166 = alloc_Block(NULL, NULL, "errormessages", 171);
  gc_frame_newslot(block1166);
// method "_apply"
  block_savedest(block1166);
  Object closure1167 = createclosure(3, "_apply");
  setclosureframe(closure1167, stackframe);
  addtoclosure(closure1167, var_end);
  addtoclosure(closure1167, var_tok);
  addtoclosure(closure1167, selfslot);
  struct UserObject *uo1167 = (struct UserObject*)block1166;
  uo1167->data[0] = (Object)closure1167;
  Method *meth_meth_errormessages_1167__apply = addmethod2pos(block1166, "_apply", &meth_errormessages_1167__apply, 0);
  int argcv_meth_errormessages_1167__apply[] = {0};
  meth_meth_errormessages_1167__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1167__apply);
  meth_meth_errormessages_1167__apply->definitionModule = modulename;
  meth_meth_errormessages_1167__apply->definitionLine = 528;
// compiled block node returning block1166 (depth = 5)
  gc_frame_newslot(block1166);
// starting to compile block node (depth = 5)
  Object block1172 = alloc_Block(NULL, NULL, "errormessages", 171);
  gc_frame_newslot(block1172);
// method "_apply"
  block_savedest(block1172);
  Object closure1173 = createclosure(7, "_apply");
  setclosureframe(closure1173, stackframe);
  addtoclosure(closure1173, var_line);
  addtoclosure(closure1173, var_tok);
  addtoclosure(closure1173, var_startPos);
  addtoclosure(closure1173, var_endPos);
  addtoclosure(closure1173, var_deleteLeading);
  addtoclosure(closure1173, var_deleteTrailing);
  addtoclosure(closure1173, selfslot);
  struct UserObject *uo1173 = (struct UserObject*)block1172;
  uo1173->data[0] = (Object)closure1173;
  Method *meth_meth_errormessages_1173__apply = addmethod2pos(block1172, "_apply", &meth_errormessages_1173__apply, 0);
  int argcv_meth_errormessages_1173__apply[] = {0};
  meth_meth_errormessages_1173__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1173__apply);
  meth_meth_errormessages_1173__apply->definitionModule = modulename;
  meth_meth_errormessages_1173__apply->definitionLine = 528;
// compiled block node returning block1172 (depth = 5)
  gc_frame_newslot(block1172);
// call case 5: prelude request
  params[0] = block1166;
  params[1] = block1172;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1195 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1165);
// compiled call node returning call1195 (depth = 4)
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  int op_slot_right_1197 = gc_frame_newslot(*var_line);
// starting to compile member node (depth = 6)
  int callframe1199 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_end (depth = 7)
  partcv[0] = 0;
  Object call1200 = callmethodflags(*var_end, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1199);
// compiled member node returning call1200 (depth = 6)
  int op_slot_left_1197 = gc_frame_newslot(call1200);
  params[0] = *var_line;
  partcv[0] = 1;
  Object opresult1201 = callmethod(call1200, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1201 (depth = 5)
  Object if1196 = done;
  if (istrue(opresult1201)) {
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1202 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startPos (depth = 6)
  gc_frame_newslot(*var_startPos);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endPos (depth = 6)
  gc_frame_newslot(*var_endPos);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  gc_frame_newslot(*var_line);
// call case 4: self request
  params[0] = *var_startPos;
  params[1] = *var_endPos;
  params[2] = *var_line;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1203 = callmethodflags(self, "deleteRange(2)onLine(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1202);
// compiled call node returning call1203 (depth = 5)
    gc_frame_newslot(call1203);
    if1196 = call1203;
  } else {
  }
// compiled if node returning if1196 (depth = 4)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1204 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_deleteTrailing (depth = 6)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_end;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1205 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1204);
// compiled call node returning call1205 (depth = 5)
  *var_endPos = call1205;
  if (call1205 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1207 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startPos (depth = 5)
  gc_frame_newslot(*var_startPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_endPos (depth = 5)
  gc_frame_newslot(*var_endPos);
// starting to compile member node (depth = 5)
  int callframe1208 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  partcv[0] = 0;
  Object call1209 = callmethodflags(*var_end, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1208);
// compiled member node returning call1209 (depth = 5)
  gc_frame_newslot(call1209);
// call case 4: self request
  params[0] = *var_startPos;
  params[1] = *var_endPos;
  params[2] = call1209;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1210 = callmethodflags(self, "deleteRange(2)onLine(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1207);
// compiled call node returning call1210 (depth = 4)
    gc_frame_newslot(call1210);
    if1151 = call1210;
  }
// compiled if node returning if1151 (depth = 3)
  gc_frame_end(frame);
  return if1151;
}
Object meth_errormessages_1211_deleteTokenRange_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteTokenRange(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange(_,_)");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deleteTokenRange(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part deleteTokenRange(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1212 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 4)
  Object bool1213 = alloc_Boolean(0);
// compiled identifier node returning bool1213 (depth = 4)
  gc_frame_newslot(bool1213);
// starting to compile identifier node (depth = 4)
  Object bool1214 = alloc_Boolean(0);
// compiled identifier node returning bool1214 (depth = 4)
  gc_frame_newslot(bool1214);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = bool1213;
  params[3] = bool1214;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1215 = callmethodflags(self, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1212);
// compiled call node returning call1215 (depth = 3)
  gc_frame_end(frame);
  return call1215;
}
Object meth_errormessages_1216_deleteLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteLine(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deleteLine(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part deleteLine(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1217 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// starting to compile string node (depth = 4)
  if (strlit1218 == NULL) {
    strlit1218 = alloc_String("");
    gc_root(strlit1218);
  }
// compiled string node returning strlit1218 (depth = 4)
  gc_frame_newslot(strlit1218);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = strlit1218;
  partcv[0] = 2;
  Object call1219 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1217);
// compiled call node returning call1219 (depth = 3)
  gc_frame_end(frame);
  return call1219;
}
Object meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert(1)afterToken(1)andTrailingSpace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)afterToken(_)andTrailingSpace(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)afterToken(_)andTrailingSpace(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)afterToken(_)andTrailingSpace(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for insert(_)afterToken(_)andTrailingSpace(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part insert(_)");
  Object *var_token = &(stackframe->slots[1]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part afterToken(_)");
  Object *var_afterTrailing = &(stackframe->slots[2]);
  *var_afterTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part andTrailingSpace(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_pos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "pos");
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1222 = alloc_Float64(1);
// compiled num node returning num1222 (depth = 5)
  int op_slot_right_1221 = gc_frame_newslot(num1222);
// starting to compile call node (depth = 5)
  int callframe1224 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_afterTrailing (depth = 6)
  gc_frame_newslot(*var_afterTrailing);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_afterTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1225 = callmethodflags(self, "getTokenEnd(1)includeTrailingSpace(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1224);
// compiled call node returning call1225 (depth = 5)
  int op_slot_left_1221 = gc_frame_newslot(call1225);
  params[0] = num1222;
  partcv[0] = 1;
  Object sum1226 = callmethod(call1225, "+(1)", 1, partcv, params);
// compiled op node returning sum1226 (depth = 4)
  *var_pos = sum1226;
  if (sum1226 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1227 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile member node (depth = 4)
  int callframe1228 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  partcv[0] = 0;
  Object call1229 = callmethodflags(*var_token, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1228);
// compiled member node returning call1229 (depth = 4)
  gc_frame_newslot(call1229);
// call case 4: self request
  params[0] = *var_s;
  params[1] = *var_pos;
  params[2] = call1229;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1230 = callmethodflags(self, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1227);
// compiled call node returning call1230 (depth = 3)
  gc_frame_end(frame);
  return call1230;
}
Object meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert(1)afterToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)afterToken(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)afterToken(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for insert(_)afterToken(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part insert(_)");
  Object *var_token = &(stackframe->slots[1]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part afterToken(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1232 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 4)
  Object bool1233 = alloc_Boolean(0);
// compiled identifier node returning bool1233 (depth = 4)
  gc_frame_newslot(bool1233);
// call case 4: self request
  params[0] = *var_s;
  params[1] = *var_token;
  params[2] = bool1233;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1234 = callmethodflags(self, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1232);
// compiled call node returning call1234 (depth = 3)
  gc_frame_end(frame);
  return call1234;
}
Object meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert(1)beforeToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)beforeToken(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert(_)beforeToken(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for insert(_)beforeToken(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part insert(_)");
  Object *var_token = &(stackframe->slots[1]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part beforeToken(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1236 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile member node (depth = 4)
  int callframe1237 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  partcv[0] = 0;
  Object call1238 = callmethodflags(*var_token, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1237);
// compiled member node returning call1238 (depth = 4)
  gc_frame_newslot(call1238);
// starting to compile member node (depth = 4)
  int callframe1239 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  partcv[0] = 0;
  Object call1240 = callmethodflags(*var_token, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1239);
// compiled member node returning call1240 (depth = 4)
  gc_frame_newslot(call1240);
// call case 4: self request
  params[0] = *var_s;
  params[1] = call1238;
  params[2] = call1240;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1241 = callmethodflags(self, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1236);
// compiled call node returning call1241 (depth = 3)
  gc_frame_end(frame);
  return call1241;
}
Object meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insertNewLine(1)after(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insertNewLine(_)after(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insertNewLine(_)after(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for insertNewLine(_)after(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_line = &(stackframe->slots[0]);
  *var_line = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part insertNewLine(_)");
  Object *var_lineNumber = &(stackframe->slots[1]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part after(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1243 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call1244 = callmethodflags(self, "addLine(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1243);
// compiled call node returning call1244 (depth = 3)
  gc_frame_end(frame);
  return call1244;
}
Object meth_errormessages_1284__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_lineNumber = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1286 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1288 = alloc_Float64(1);
// compiled num node returning num1288 (depth = 12)
  int op_slot_right_1287 = gc_frame_newslot(num1288);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_1287 = gc_frame_newslot(*var_i);
  params[0] = num1288;
  partcv[0] = 1;
  Object diff1290 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1290 (depth = 11)
  gc_frame_newslot(diff1290);
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe1291 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1292 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1291);
// compiled member node returning call1292 (depth = 11)
  params[0] = diff1290;
  partcv[0] = 1;
  Object call1293 = callmethodflags(call1292, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1286);
// compiled call node returning call1293 (depth = 10)
  int op_slot_right_1285 = gc_frame_newslot(call1293);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  int op_slot_left_1285 = gc_frame_newslot(*var_lineNumber);
  params[0] = call1293;
  partcv[0] = 1;
  Object opresult1295 = callmethod(*var_lineNumber, "<(1)", 1, partcv, params);
// compiled op node returning opresult1295 (depth = 9)
  gc_frame_end(frame);
  return opresult1295;
}
Object meth_errormessages_1281__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_lineNumber = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile block node (depth = 8)
  Object block1283 = alloc_Block(NULL, NULL, "errormessages", 227);
  gc_frame_newslot(block1283);
// method "_apply"
  block_savedest(block1283);
  Object closure1284 = createclosure(3, "_apply");
  setclosureframe(closure1284, stackframe);
  addtoclosure(closure1284, var_i);
  addtoclosure(closure1284, var_lineNumber);
  addtoclosure(closure1284, selfslot);
  struct UserObject *uo1284 = (struct UserObject*)block1283;
  uo1284->data[0] = (Object)closure1284;
  Method *meth_meth_errormessages_1284__apply = addmethod2pos(block1283, "_apply", &meth_errormessages_1284__apply, 0);
  int argcv_meth_errormessages_1284__apply[] = {0};
  meth_meth_errormessages_1284__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1284__apply);
  meth_meth_errormessages_1284__apply->definitionModule = modulename;
  meth_meth_errormessages_1284__apply->definitionLine = 528;
// compiled block node returning block1283 (depth = 8)
  int op_slot_right_1282 = gc_frame_newslot(block1283);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1299 = alloc_Float64(1);
// compiled num node returning num1299 (depth = 9)
  int op_slot_right_1298 = gc_frame_newslot(num1299);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1298 = gc_frame_newslot(*var_i);
  params[0] = num1299;
  partcv[0] = 1;
  Object opresult1301 = callmethod(*var_i, ">(1)", 1, partcv, params);
// compiled op node returning opresult1301 (depth = 8)
  int op_slot_left_1282 = gc_frame_newslot(opresult1301);
  params[0] = block1283;
  partcv[0] = 1;
  Object opresult1302 = callmethod(opresult1301, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1302 (depth = 7)
  gc_frame_end(frame);
  return opresult1302;
}
Object meth_errormessages_1305__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1306 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 8)
  int callframe1307 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1309 = alloc_Float64(1);
// compiled num node returning num1309 (depth = 10)
  int op_slot_right_1308 = gc_frame_newslot(num1309);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1308 = gc_frame_newslot(*var_i);
  params[0] = num1309;
  partcv[0] = 1;
  Object diff1311 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1311 (depth = 9)
  gc_frame_newslot(diff1311);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1312 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1313 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1312);
// compiled member node returning call1313 (depth = 9)
  params[0] = diff1311;
  partcv[0] = 1;
  Object call1314 = callmethodflags(call1313, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1307);
// compiled call node returning call1314 (depth = 8)
  gc_frame_newslot(call1314);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1315 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1316 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1315);
// compiled member node returning call1316 (depth = 8)
  params[0] = *var_i;
  params[1] = call1314;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1317 = callmethodflags(call1316, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1306);
// compiled call node returning call1317 (depth = 7)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1318 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 8)
  int callframe1319 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1321 = alloc_Float64(1);
// compiled num node returning num1321 (depth = 10)
  int op_slot_right_1320 = gc_frame_newslot(num1321);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1320 = gc_frame_newslot(*var_i);
  params[0] = num1321;
  partcv[0] = 1;
  Object diff1323 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1323 (depth = 9)
  gc_frame_newslot(diff1323);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1325 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1324);
// compiled member node returning call1325 (depth = 9)
  params[0] = diff1323;
  partcv[0] = 1;
  Object call1326 = callmethodflags(call1325, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1319);
// compiled call node returning call1326 (depth = 8)
  gc_frame_newslot(call1326);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1328 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1327);
// compiled member node returning call1328 (depth = 8)
  params[0] = *var_i;
  params[1] = call1326;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1329 = callmethodflags(call1328, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1318);
// compiled call node returning call1329 (depth = 7)
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1331 = alloc_Float64(1);
// compiled num node returning num1331 (depth = 9)
  int op_slot_right_1330 = gc_frame_newslot(num1331);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1330 = gc_frame_newslot(*var_i);
  params[0] = num1331;
  partcv[0] = 1;
  Object diff1333 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1333 (depth = 8)
  *var_i = diff1333;
  if (diff1333 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_1245_addLine_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLine(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method addLine(_,_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addLine(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  Object *var_line = &(stackframe->slots[1]);
  *var_line = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part addLine(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_i = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "i");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1246 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1247 = callmethodflags(self, "findLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1246);
// compiled call node returning call1247 (depth = 4)
  *var_i = call1247;
  if (call1247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1250 = alloc_Boolean(0);
// compiled identifier node returning bool1250 (depth = 5)
  int op_slot_right_1249 = gc_frame_newslot(bool1250);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1249 = gc_frame_newslot(*var_i);
  params[0] = bool1250;
  partcv[0] = 1;
  Object opresult1252 = callmethod(*var_i, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1252 (depth = 4)
  Object if1248 = done;
  if (istrue(opresult1252)) {
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1253 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1254 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1255 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1254);
// compiled member node returning call1255 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_line;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1256 = callmethodflags(call1255, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1253);
// compiled call node returning call1256 (depth = 4)
    gc_frame_newslot(call1256);
    if1248 = call1256;
  } else {
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1257 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1258 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1259 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1258);
// compiled member node returning call1259 (depth = 5)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1260 = callmethodflags(call1259, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1257);
// compiled call node returning call1260 (depth = 4)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1261 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1262 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1263 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1262);
// compiled member node returning call1263 (depth = 5)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1264 = callmethodflags(call1263, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1261);
// compiled call node returning call1264 (depth = 4)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1267 = alloc_Float64(1);
// compiled num node returning num1267 (depth = 6)
  int op_slot_right_1266 = gc_frame_newslot(num1267);
// starting to compile member node (depth = 6)
  int callframe1269 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1270 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1271 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1270);
// compiled member node returning call1271 (depth = 7)
  partcv[0] = 0;
  Object call1272 = callmethodflags(call1271, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1269);
// compiled member node returning call1272 (depth = 6)
  int op_slot_left_1266 = gc_frame_newslot(call1272);
  params[0] = num1267;
  partcv[0] = 1;
  Object opresult1273 = callmethod(call1272, ">(1)", 1, partcv, params);
// compiled op node returning opresult1273 (depth = 5)
  Object if1265 = done;
  if (istrue(opresult1273)) {
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1274 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1275 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1276 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1275);
// compiled member node returning call1276 (depth = 7)
  partcv[0] = 0;
  Object call1277 = callmethodflags(call1276, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1274);
// compiled member node returning call1277 (depth = 6)
  *var_i = call1277;
  if (call1277 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1279 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1280 = alloc_Block(NULL, NULL, "errormessages", 227);
  gc_frame_newslot(block1280);
// method "_apply"
  block_savedest(block1280);
  Object closure1281 = createclosure(3, "_apply");
  setclosureframe(closure1281, stackframe);
  addtoclosure(closure1281, var_i);
  addtoclosure(closure1281, var_lineNumber);
  addtoclosure(closure1281, selfslot);
  struct UserObject *uo1281 = (struct UserObject*)block1280;
  uo1281->data[0] = (Object)closure1281;
  Method *meth_meth_errormessages_1281__apply = addmethod2pos(block1280, "_apply", &meth_errormessages_1281__apply, 0);
  int argcv_meth_errormessages_1281__apply[] = {0};
  meth_meth_errormessages_1281__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1281__apply);
  meth_meth_errormessages_1281__apply->definitionModule = modulename;
  meth_meth_errormessages_1281__apply->definitionLine = 528;
// compiled block node returning block1280 (depth = 6)
  gc_frame_newslot(block1280);
// starting to compile block node (depth = 6)
  Object block1304 = alloc_Block(NULL, NULL, "errormessages", 227);
  gc_frame_newslot(block1304);
// method "_apply"
  block_savedest(block1304);
  Object closure1305 = createclosure(2, "_apply");
  setclosureframe(closure1305, stackframe);
  addtoclosure(closure1305, var_i);
  addtoclosure(closure1305, selfslot);
  struct UserObject *uo1305 = (struct UserObject*)block1304;
  uo1305->data[0] = (Object)closure1305;
  Method *meth_meth_errormessages_1305__apply = addmethod2pos(block1304, "_apply", &meth_errormessages_1305__apply, 0);
  int argcv_meth_errormessages_1305__apply[] = {0};
  meth_meth_errormessages_1305__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1305__apply);
  meth_meth_errormessages_1305__apply->definitionModule = modulename;
  meth_meth_errormessages_1305__apply->definitionLine = 528;
// compiled block node returning block1304 (depth = 6)
  gc_frame_newslot(block1304);
// call case 5: prelude request
  params[0] = block1280;
  params[1] = block1304;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1336 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1279);
// compiled call node returning call1336 (depth = 5)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1337 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1338 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1339 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1338);
// compiled member node returning call1339 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1340 = callmethodflags(call1339, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1337);
// compiled call node returning call1340 (depth = 5)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1341 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1342 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1343 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1342);
// compiled member node returning call1343 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_line;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1344 = callmethodflags(call1343, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1341);
// compiled call node returning call1344 (depth = 5)
    gc_frame_newslot(call1344);
    if1265 = call1344;
  } else {
  }
// compiled if node returning if1265 (depth = 4)
    gc_frame_newslot(if1265);
    if1248 = if1265;
  }
// compiled if node returning if1248 (depth = 3)
  gc_frame_end(frame);
  return if1248;
}
Object meth_errormessages_1352__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  int op_slot_right_1354 = gc_frame_newslot(*var_lineNumber);
// starting to compile call node (depth = 7)
  int callframe1356 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1357 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1358 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1357);
// compiled member node returning call1358 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1359 = callmethodflags(call1358, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1356);
// compiled call node returning call1359 (depth = 7)
  int op_slot_left_1354 = gc_frame_newslot(call1359);
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object opresult1360 = callmethod(call1359, "==(1)", 1, partcv, params);
// compiled op node returning opresult1360 (depth = 6)
  Object if1353 = done;
  if (istrue(opresult1360)) {
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  block_return(realself, *var_i);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if1353 = undefined;
  } else {
  }
// compiled if node returning if1353 (depth = 5)
  gc_frame_end(frame);
  return if1353;
}
Object meth_errormessages_1345_findLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findLine(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findLine(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findLine(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1346 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1347 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1348 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1349 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1348);
// compiled member node returning call1349 (depth = 5)
  partcv[0] = 0;
  Object call1350 = callmethodflags(call1349, "indices", 1, partcv, params, 0);
  gc_frame_end(callframe1347);
// compiled member node returning call1350 (depth = 4)
  gc_frame_newslot(call1350);
// starting to compile block node (depth = 4)
  Object block1351 = alloc_Block(NULL, NULL, "errormessages", 241);
  gc_frame_newslot(block1351);
// method "_apply(_)"
  block_savedest(block1351);
  Object closure1352 = createclosure(2, "_apply(1)");
  setclosureframe(closure1352, stackframe);
  addtoclosure(closure1352, var_lineNumber);
  addtoclosure(closure1352, selfslot);
  struct UserObject *uo1352 = (struct UserObject*)block1351;
  uo1352->data[0] = (Object)closure1352;
  Method *meth_meth_errormessages_1352__apply_40_1_41_ = addmethod2pos(block1351, "_apply(1)", &meth_errormessages_1352__apply_40_1_41_, 0);
  int argcv_meth_errormessages_1352__apply_40_1_41_[] = {1};
  meth_meth_errormessages_1352__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1352__apply_40_1_41_);
  meth_meth_errormessages_1352__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1352__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block1351 (depth = 4)
  gc_frame_newslot(block1351);
// call case 5: prelude request
  params[0] = call1350;
  params[1] = block1351;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1362 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1346);
// compiled call node returning call1362 (depth = 3)
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1363 = alloc_Boolean(0);
// compiled identifier node returning bool1363 (depth = 3)
  gc_frame_end(frame);
  return bool1363;
}
Object meth_errormessages_1364_getLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "getLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getLine(_)");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for getLine(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part getLine(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// definebindings:
// definebindings:
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1365 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1366 = callmethodflags(self, "findLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1365);
// compiled call node returning call1366 (depth = 4)
  *var_i = call1366;
  if (call1366 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1369 = alloc_Boolean(0);
// compiled identifier node returning bool1369 (depth = 5)
  int op_slot_right_1368 = gc_frame_newslot(bool1369);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1368 = gc_frame_newslot(*var_i);
  params[0] = bool1369;
  partcv[0] = 1;
  Object opresult1371 = callmethod(*var_i, "==(1)", 1, partcv, params);
// compiled op node returning opresult1371 (depth = 4)
  Object if1367 = done;
  if (istrue(opresult1371)) {
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1372 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1373 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call1374 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe1373);
// compiled member node returning call1374 (depth = 5)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1375 = callmethodflags(call1374, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1372);
// compiled call node returning call1375 (depth = 4)
    gc_frame_newslot(call1375);
    if1367 = call1375;
  } else {
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1376 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1377 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1378 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1377);
// compiled member node returning call1378 (depth = 5)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1379 = callmethodflags(call1378, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1376);
// compiled call node returning call1379 (depth = 4)
    gc_frame_newslot(call1379);
    if1367 = call1379;
  }
// compiled if node returning if1367 (depth = 3)
  gc_frame_end(frame);
  return if1367;
}
Object meth_errormessages_1395__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1398 = alloc_Float64(1);
// compiled num node returning num1398 (depth = 10)
  int op_slot_right_1397 = gc_frame_newslot(num1398);
// starting to compile call node (depth = 10)
  int callframe1400 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1402 = alloc_Float64(1);
// compiled num node returning num1402 (depth = 12)
  int op_slot_right_1401 = gc_frame_newslot(num1402);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_1401 = gc_frame_newslot(*var_i);
  params[0] = num1402;
  partcv[0] = 1;
  Object diff1404 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1404 (depth = 11)
  gc_frame_newslot(diff1404);
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe1405 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1406 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1405);
// compiled member node returning call1406 (depth = 11)
  params[0] = diff1404;
  partcv[0] = 1;
  Object call1407 = callmethodflags(call1406, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1400);
// compiled call node returning call1407 (depth = 10)
  int op_slot_left_1397 = gc_frame_newslot(call1407);
  params[0] = num1398;
  partcv[0] = 1;
  Object sum1408 = callmethod(call1407, "+(1)", 1, partcv, params);
// compiled op node returning sum1408 (depth = 9)
  int op_slot_right_1396 = gc_frame_newslot(sum1408);
// starting to compile call node (depth = 9)
  int callframe1410 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1412 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1411);
// compiled member node returning call1412 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1413 = callmethodflags(call1412, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1410);
// compiled call node returning call1413 (depth = 9)
  int op_slot_left_1396 = gc_frame_newslot(call1413);
  params[0] = sum1408;
  partcv[0] = 1;
  Object opresult1414 = callmethod(call1413, ">(1)", 1, partcv, params);
// compiled op node returning opresult1414 (depth = 8)
  gc_frame_end(frame);
  return opresult1414;
}
Object meth_errormessages_1437__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1439 == NULL) {
    strlit1439 = alloc_String(" ");
    gc_root(strlit1439);
  }
// compiled string node returning strlit1439 (depth = 10)
  int op_slot_right_1438 = gc_frame_newslot(strlit1439);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1438 = gc_frame_newslot(*var_s);
  params[0] = strlit1439;
  partcv[0] = 1;
  Object opresult1441 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1441 (depth = 9)
  *var_s = opresult1441;
  if (opresult1441 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_1391__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_io = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// definebindings:
// definebindings:
// definebindings:
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block1394 = alloc_Block(NULL, NULL, "errormessages", 262);
  gc_frame_newslot(block1394);
// method "_apply"
  block_savedest(block1394);
  Object closure1395 = createclosure(2, "_apply");
  setclosureframe(closure1395, stackframe);
  addtoclosure(closure1395, var_i);
  addtoclosure(closure1395, selfslot);
  struct UserObject *uo1395 = (struct UserObject*)block1394;
  uo1395->data[0] = (Object)closure1395;
  Method *meth_meth_errormessages_1395__apply = addmethod2pos(block1394, "_apply", &meth_errormessages_1395__apply, 0);
  int argcv_meth_errormessages_1395__apply[] = {0};
  meth_meth_errormessages_1395__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1395__apply);
  meth_meth_errormessages_1395__apply->definitionModule = modulename;
  meth_meth_errormessages_1395__apply->definitionLine = 528;
// compiled block node returning block1394 (depth = 7)
  int op_slot_right_1393 = gc_frame_newslot(block1394);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1418 = alloc_Float64(1);
// compiled num node returning num1418 (depth = 8)
  int op_slot_right_1417 = gc_frame_newslot(num1418);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_1417 = gc_frame_newslot(*var_i);
  params[0] = num1418;
  partcv[0] = 1;
  Object opresult1420 = callmethod(*var_i, ">(1)", 1, partcv, params);
// compiled op node returning opresult1420 (depth = 7)
  int op_slot_left_1393 = gc_frame_newslot(opresult1420);
  params[0] = block1394;
  partcv[0] = 1;
  Object opresult1421 = callmethod(opresult1420, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1421 (depth = 6)
  Object if1392 = done;
  if (istrue(opresult1421)) {
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1422 == NULL) {
    strlit1422 = alloc_String("");
    gc_root(strlit1422);
  }
// compiled string node returning strlit1422 (depth = 7)
  *var_s = strlit1422;
  if (strlit1422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1423 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe1424 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1425 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe1426 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1428 = alloc_Float64(1);
// compiled num node returning num1428 (depth = 11)
  int op_slot_right_1427 = gc_frame_newslot(num1428);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_left_1427 = gc_frame_newslot(*var_i);
  params[0] = num1428;
  partcv[0] = 1;
  Object diff1430 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1430 (depth = 10)
  gc_frame_newslot(diff1430);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1431 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1432 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1431);
// compiled member node returning call1432 (depth = 10)
  params[0] = diff1430;
  partcv[0] = 1;
  Object call1433 = callmethodflags(call1432, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1426);
// compiled call node returning call1433 (depth = 9)
  partcv[0] = 0;
  Object call1434 = callmethodflags(call1433, "asString", 1, partcv, params, 0);
  gc_frame_end(callframe1425);
// compiled member node returning call1434 (depth = 8)
  partcv[0] = 0;
  Object call1435 = callmethodflags(call1434, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1424);
// compiled member node returning call1435 (depth = 7)
  gc_frame_newslot(call1435);
// starting to compile block node (depth = 7)
  Object block1436 = alloc_Block(NULL, NULL, "errormessages", 264);
  gc_frame_newslot(block1436);
// method "_apply"
  block_savedest(block1436);
  Object closure1437 = createclosure(2, "_apply");
  setclosureframe(closure1437, stackframe);
  addtoclosure(closure1437, var_s);
  addtoclosure(closure1437, selfslot);
  struct UserObject *uo1437 = (struct UserObject*)block1436;
  uo1437->data[0] = (Object)closure1437;
  Method *meth_meth_errormessages_1437__apply = addmethod2pos(block1436, "_apply", &meth_errormessages_1437__apply, 0);
  int argcv_meth_errormessages_1437__apply[] = {0};
  meth_meth_errormessages_1437__apply->type = alloc_MethodType(1, argcv_meth_errormessages_1437__apply);
  meth_meth_errormessages_1437__apply->definitionModule = modulename;
  meth_meth_errormessages_1437__apply->definitionLine = 528;
// compiled block node returning block1436 (depth = 7)
  gc_frame_newslot(block1436);
// call case 5: prelude request
  params[0] = call1435;
  params[1] = block1436;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1444 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1423);
// compiled call node returning call1444 (depth = 6)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1445 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1447 == NULL) {
    strlit1447 = alloc_String("...""\x0a""");
    gc_root(strlit1447);
  }
// compiled string node returning strlit1447 (depth = 8)
  int op_slot_right_1446 = gc_frame_newslot(strlit1447);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_1449 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit1451 == NULL) {
    strlit1451 = alloc_String("    ");
    gc_root(strlit1451);
  }
// compiled string node returning strlit1451 (depth = 9)
  int op_slot_left_1449 = gc_frame_newslot(strlit1451);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult1452 = callmethod(strlit1451, "++(1)", 1, partcv, params);
// compiled op node returning opresult1452 (depth = 8)
  int op_slot_left_1446 = gc_frame_newslot(opresult1452);
  params[0] = strlit1447;
  partcv[0] = 1;
  Object opresult1453 = callmethod(opresult1452, "++(1)", 1, partcv, params);
// compiled op node returning opresult1453 (depth = 7)
  gc_frame_newslot(opresult1453);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1454 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_io (depth = 8)
  partcv[0] = 0;
  Object call1455 = callmethodflags(*var_io, "error", 1, partcv, params, 0);
  gc_frame_end(callframe1454);
// compiled member node returning call1455 (depth = 7)
  params[0] = opresult1453;
  partcv[0] = 1;
  Object call1456 = callmethodflags(call1455, "write(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1445);
// compiled call node returning call1456 (depth = 6)
    gc_frame_newslot(call1456);
    if1392 = call1456;
  } else {
  }
// compiled if node returning if1392 (depth = 5)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1459 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1460 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1461 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1460);
// compiled member node returning call1461 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1462 = callmethodflags(call1461, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1459);
// compiled call node returning call1462 (depth = 7)
  int op_slot_right_1458 = gc_frame_newslot(call1462);
// starting to compile member node (depth = 7)
  int callframe1464 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe1465 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1466 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1467 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1466);
// compiled member node returning call1467 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1468 = callmethodflags(call1467, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1465);
// compiled call node returning call1468 (depth = 8)
  partcv[0] = 0;
  Object call1469 = callmethodflags(call1468, "truncated", 1, partcv, params, 0);
  gc_frame_end(callframe1464);
// compiled member node returning call1469 (depth = 7)
  int op_slot_left_1458 = gc_frame_newslot(call1469);
  params[0] = call1462;
  partcv[0] = 1;
  Object opresult1470 = callmethod(call1469, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1470 (depth = 6)
  Object if1457 = done;
  if (istrue(opresult1470)) {
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1471 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1473 == NULL) {
    strlit1473 = alloc_String("""\x0a""");
    gc_root(strlit1473);
  }
// compiled string node returning strlit1473 (depth = 8)
  int op_slot_right_1472 = gc_frame_newslot(strlit1473);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1476 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1477 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1478 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1477);
// compiled member node returning call1478 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1479 = callmethodflags(call1478, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1476);
// compiled call node returning call1479 (depth = 9)
  int op_slot_right_1475 = gc_frame_newslot(call1479);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1482 == NULL) {
    strlit1482 = alloc_String(": ");
    gc_root(strlit1482);
  }
// compiled string node returning strlit1482 (depth = 10)
  int op_slot_right_1481 = gc_frame_newslot(strlit1482);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe1485 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 12)
  int callframe1486 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe1487 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1488 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1487);
// compiled member node returning call1488 (depth = 13)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1489 = callmethodflags(call1488, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1486);
// compiled call node returning call1489 (depth = 12)
  partcv[0] = 0;
  Object call1490 = callmethodflags(call1489, "truncated", 1, partcv, params, 0);
  gc_frame_end(callframe1485);
// compiled member node returning call1490 (depth = 11)
  int op_slot_right_1484 = gc_frame_newslot(call1490);
// starting to compile string node (depth = 11)
  if (strlit1492 == NULL) {
    strlit1492 = alloc_String(" *");
    gc_root(strlit1492);
  }
// compiled string node returning strlit1492 (depth = 11)
  int op_slot_left_1484 = gc_frame_newslot(strlit1492);
  params[0] = call1490;
  partcv[0] = 1;
  Object opresult1493 = callmethod(strlit1492, "++(1)", 1, partcv, params);
// compiled op node returning opresult1493 (depth = 10)
  int op_slot_left_1481 = gc_frame_newslot(opresult1493);
  params[0] = strlit1482;
  partcv[0] = 1;
  Object opresult1494 = callmethod(opresult1493, "++(1)", 1, partcv, params);
// compiled op node returning opresult1494 (depth = 9)
  int op_slot_left_1475 = gc_frame_newslot(opresult1494);
  params[0] = call1479;
  partcv[0] = 1;
  Object opresult1495 = callmethod(opresult1494, "++(1)", 1, partcv, params);
// compiled op node returning opresult1495 (depth = 8)
  int op_slot_left_1472 = gc_frame_newslot(opresult1495);
  params[0] = strlit1473;
  partcv[0] = 1;
  Object opresult1496 = callmethod(opresult1495, "++(1)", 1, partcv, params);
// compiled op node returning opresult1496 (depth = 7)
  gc_frame_newslot(opresult1496);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1497 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_io (depth = 8)
  partcv[0] = 0;
  Object call1498 = callmethodflags(*var_io, "error", 1, partcv, params, 0);
  gc_frame_end(callframe1497);
// compiled member node returning call1498 (depth = 7)
  params[0] = opresult1496;
  partcv[0] = 1;
  Object call1499 = callmethodflags(call1498, "write(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1471);
// compiled call node returning call1499 (depth = 6)
    gc_frame_newslot(call1499);
    if1457 = call1499;
  } else {
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1500 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1502 == NULL) {
    strlit1502 = alloc_String("""\x0a""");
    gc_root(strlit1502);
  }
// compiled string node returning strlit1502 (depth = 8)
  int op_slot_right_1501 = gc_frame_newslot(strlit1502);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1505 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1506 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1507 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1506);
// compiled member node returning call1507 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1508 = callmethodflags(call1507, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1505);
// compiled call node returning call1508 (depth = 9)
  int op_slot_right_1504 = gc_frame_newslot(call1508);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1511 == NULL) {
    strlit1511 = alloc_String(": ");
    gc_root(strlit1511);
  }
// compiled string node returning strlit1511 (depth = 10)
  int op_slot_right_1510 = gc_frame_newslot(strlit1511);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1514 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe1515 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1516 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1515);
// compiled member node returning call1516 (depth = 12)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1517 = callmethodflags(call1516, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1514);
// compiled call node returning call1517 (depth = 11)
  int op_slot_right_1513 = gc_frame_newslot(call1517);
// starting to compile string node (depth = 11)
  if (strlit1519 == NULL) {
    strlit1519 = alloc_String("  ");
    gc_root(strlit1519);
  }
// compiled string node returning strlit1519 (depth = 11)
  int op_slot_left_1513 = gc_frame_newslot(strlit1519);
  params[0] = call1517;
  partcv[0] = 1;
  Object opresult1520 = callmethod(strlit1519, "++(1)", 1, partcv, params);
// compiled op node returning opresult1520 (depth = 10)
  int op_slot_left_1510 = gc_frame_newslot(opresult1520);
  params[0] = strlit1511;
  partcv[0] = 1;
  Object opresult1521 = callmethod(opresult1520, "++(1)", 1, partcv, params);
// compiled op node returning opresult1521 (depth = 9)
  int op_slot_left_1504 = gc_frame_newslot(opresult1521);
  params[0] = call1508;
  partcv[0] = 1;
  Object opresult1522 = callmethod(opresult1521, "++(1)", 1, partcv, params);
// compiled op node returning opresult1522 (depth = 8)
  int op_slot_left_1501 = gc_frame_newslot(opresult1522);
  params[0] = strlit1502;
  partcv[0] = 1;
  Object opresult1523 = callmethod(opresult1522, "++(1)", 1, partcv, params);
// compiled op node returning opresult1523 (depth = 7)
  gc_frame_newslot(opresult1523);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1524 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_io (depth = 8)
  partcv[0] = 0;
  Object call1525 = callmethodflags(*var_io, "error", 1, partcv, params, 0);
  gc_frame_end(callframe1524);
// compiled member node returning call1525 (depth = 7)
  params[0] = opresult1523;
  partcv[0] = 1;
  Object call1526 = callmethodflags(call1525, "write(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1500);
// compiled call node returning call1526 (depth = 6)
    gc_frame_newslot(call1526);
    if1457 = call1526;
  }
// compiled if node returning if1457 (depth = 5)
  gc_frame_end(frame);
  return if1457;
}
Object meth_errormessages_1380_print(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "print");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_io = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1381 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1383 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1385 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1384);
// compiled member node returning call1385 (depth = 6)
  partcv[0] = 0;
  Object call1386 = callmethodflags(call1385, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1383);
// compiled member node returning call1386 (depth = 5)
  int op_slot_right_1382 = gc_frame_newslot(call1386);
// starting to compile num node (depth = 5)
  Object num1388 = alloc_Float64(1);
// compiled num node returning num1388 (depth = 5)
  int op_slot_left_1382 = gc_frame_newslot(num1388);
  params[0] = call1386;
  partcv[0] = 1;
  Object opresult1389 = callmethod(num1388, "..(1)", 1, partcv, params);
// compiled op node returning opresult1389 (depth = 4)
  gc_frame_newslot(opresult1389);
// starting to compile block node (depth = 4)
  Object block1390 = alloc_Block(NULL, NULL, "errormessages", 261);
  gc_frame_newslot(block1390);
// method "_apply(_)"
  block_savedest(block1390);
  Object closure1391 = createclosure(2, "_apply(1)");
  setclosureframe(closure1391, stackframe);
  addtoclosure(closure1391, var_io);
  addtoclosure(closure1391, selfslot);
  struct UserObject *uo1391 = (struct UserObject*)block1390;
  uo1391->data[0] = (Object)closure1391;
  Method *meth_meth_errormessages_1391__apply_40_1_41_ = addmethod2pos(block1390, "_apply(1)", &meth_errormessages_1391__apply_40_1_41_, 0);
  int argcv_meth_errormessages_1391__apply_40_1_41_[] = {1};
  meth_meth_errormessages_1391__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1391__apply_40_1_41_);
  meth_meth_errormessages_1391__apply_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1391__apply_40_1_41_->definitionLine = 528;
// compiled block node returning block1390 (depth = 4)
  gc_frame_newslot(block1390);
// call case 5: prelude request
  params[0] = opresult1389;
  params[1] = block1390;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1528 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1381);
// compiled call node returning call1528 (depth = 3)
  gc_frame_end(frame);
  return call1528;
}
Object meth_errormessages_758_new(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_io = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject759 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj759 = alloc_userobj2(28,29, objclass759);
  gc_frame_newslot(obj759);
  if (objclass759 == NULL) {
    glfree(obj759->class->name);
    obj759->class->name = "suggestion.new";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj759, self, 0);
  addmethodreal(obj759,"outer", &reader_errormessages_outer_760);
  Object oldself759 = self;
  struct StackFrameObject *oldstackframe759 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe759);
  gc_frame_newslot((Object)stackframe);
  self = obj759;
  Object *oldselfslot759 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter759 = (*(struct UserObject *)self).data[0], lowerouter759 = thisouter759;
  if (inheritingObject759) {
    struct UserObject *inho759 = (struct UserObject *)inheritingObject759;
    while (inho759->super != GraceDefaultObject) inho759 = (struct UserObject *)inho759->super;
    inho759->super = obj759;
    self = inheritingObject759;
    *selfslot = self;
    lowerouter759 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter759;
  }
  if (objclass759 == NULL) {
  Method *reader761 = addmethodrealflags(obj759, "lineNumbers",&reader_errormessages_lineNumbers_761, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader761->definitionModule = modulename;
  reader761->definitionLine = 15;
  }
  adddatum2(obj759, alloc_Undefined(), 1);
  if (objclass759 == NULL) {
  Method *reader762 = addmethodrealflags(obj759, "lines",&reader_errormessages_lines_762, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader762->definitionModule = modulename;
  reader762->definitionLine = 16;
  }
  adddatum2(obj759, alloc_Undefined(), 2);
// method "replaceRange(_,_)with(_)onLine(_)"
  struct UserObject *uo763 = (struct UserObject*)obj759;
  uo763->data[3] = emptyclosure;
  Method *meth_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "replaceRange(2)with(1)onLine(1)", &meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_, 3);
  int argcv_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_[] = {2, 1, 1};
  meth_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->definitionLine = 23;
// method "replaceChar(_)with(_)onLine(_)"
  struct UserObject *uo807 = (struct UserObject*)obj759;
  uo807->data[4] = emptyclosure;
  Method *meth_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "replaceChar(1)with(1)onLine(1)", &meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_, 4);
  int argcv_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->definitionLine = 33;
// method "replaceUntil(_)with(_)onLine(_)"
  struct UserObject *uo810 = (struct UserObject*)obj759;
  uo810->data[5] = emptyclosure;
  Method *meth_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "replaceUntil(1)with(1)onLine(1)", &meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_, 5);
  int argcv_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->definitionLine = 37;
// method "deleteRange(_,_)onLine(_)"
  struct UserObject *uo851 = (struct UserObject*)obj759;
  uo851->data[6] = emptyclosure;
  Method *meth_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_ = addmethod2pos(obj759, "deleteRange(2)onLine(1)", &meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_, 6);
  int argcv_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_[] = {2, 1};
  meth_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_);
  meth_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_->definitionLine = 49;
// method "deleteChar(_)onLine(_)"
  struct UserObject *uo900 = (struct UserObject*)obj759;
  uo900->data[7] = emptyclosure;
  Method *meth_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "deleteChar(1)onLine(1)", &meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_, 7);
  int argcv_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_->definitionLine = 67;
// method "append(_)onLine(_)"
  struct UserObject *uo904 = (struct UserObject*)obj759;
  uo904->data[8] = emptyclosure;
  Method *meth_meth_errormessages_904_append_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "append(1)onLine(1)", &meth_errormessages_904_append_40_1_41_onLine_40_1_41_, 8);
  int argcv_meth_errormessages_904_append_40_1_41_onLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_904_append_40_1_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_904_append_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_904_append_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_904_append_40_1_41_onLine_40_1_41_->definitionLine = 71;
// method "insert(_)atPosition(_)onLine(_)"
  struct UserObject *uo912 = (struct UserObject*)obj759;
  uo912->data[9] = emptyclosure;
  Method *meth_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "insert(1)atPosition(1)onLine(1)", &meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_, 9);
  int argcv_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->definitionLine = 76;
// method "getTokenStart(_)includeLeadingSpace(_)"
  struct UserObject *uo944 = (struct UserObject*)obj759;
  uo944->data[10] = emptyclosure;
  Method *meth_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_ = addmethod2pos(obj759, "getTokenStart(1)includeLeadingSpace(1)", &meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_, 10);
  int argcv_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_[] = {1, 1};
  meth_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_);
  meth_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->definitionLine = 90;
// method "getTokenEnd(_)includeTrailingSpace(_)"
  struct UserObject *uo1022 = (struct UserObject*)obj759;
  uo1022->data[11] = emptyclosure;
  Method *meth_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_ = addmethod2pos(obj759, "getTokenEnd(1)includeTrailingSpace(1)", &meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_, 11);
  int argcv_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_);
  meth_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->definitionLine = 107;
// method "replaceToken(_)leading(_)trailing(_)with(_)"
  struct UserObject *uo1077 = (struct UserObject*)obj759;
  uo1077->data[12] = emptyclosure;
  Method *meth_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_ = addmethod2pos(obj759, "replaceToken(1)leading(1)trailing(1)with(1)", &meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_, 12);
  int argcv_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_[] = {1, 1, 1, 1};
  meth_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->type = alloc_MethodType(4, argcv_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionLine = 120;
// method "replaceToken(_)with(_)"
  struct UserObject *uo1086 = (struct UserObject*)obj759;
  uo1086->data[13] = emptyclosure;
  Method *meth_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_ = addmethod2pos(obj759, "replaceToken(1)with(1)", &meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_, 13);
  int argcv_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_->definitionLine = 126;
// method "replaceTokenRange(_,_)leading(_)trailing(_)with(_)"
  struct UserObject *uo1091 = (struct UserObject*)obj759;
  uo1091->data[14] = emptyclosure;
  Method *meth_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_ = addmethod2pos(obj759, "replaceTokenRange(2)leading(1)trailing(1)with(1)", &meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_, 14);
  int argcv_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_[] = {2, 1, 1, 1};
  meth_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->type = alloc_MethodType(4, argcv_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionLine = 130;
// method "replaceTokenRange(_,_)with(_)"
  struct UserObject *uo1131 = (struct UserObject*)obj759;
  uo1131->data[15] = emptyclosure;
  Method *meth_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_ = addmethod2pos(obj759, "replaceTokenRange(2)with(1)", &meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_, 15);
  int argcv_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_[] = {2, 1};
  meth_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_);
  meth_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_->definitionLine = 147;
// method "deleteToken(_)leading(_)trailing(_)"
  struct UserObject *uo1136 = (struct UserObject*)obj759;
  uo1136->data[16] = emptyclosure;
  Method *meth_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_ = addmethod2pos(obj759, "deleteToken(1)leading(1)trailing(1)", &meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_, 16);
  int argcv_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_);
  meth_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->definitionLine = 152;
// method "deleteToken(_)"
  struct UserObject *uo1145 = (struct UserObject*)obj759;
  uo1145->data[17] = emptyclosure;
  Method *meth_meth_errormessages_1145_deleteToken_40_1_41_ = addmethod2pos(obj759, "deleteToken(1)", &meth_errormessages_1145_deleteToken_40_1_41_, 17);
  int argcv_meth_errormessages_1145_deleteToken_40_1_41_[] = {1};
  meth_meth_errormessages_1145_deleteToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1145_deleteToken_40_1_41_);
  meth_meth_errormessages_1145_deleteToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1145_deleteToken_40_1_41_->definitionLine = 158;
// method "deleteTokenRange(_,_)leading(_)trailing(_)"
  struct UserObject *uo1150 = (struct UserObject*)obj759;
  uo1150->data[18] = emptyclosure;
  Method *meth_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_ = addmethod2pos(obj759, "deleteTokenRange(2)leading(1)trailing(1)", &meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_, 18);
  int argcv_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_[] = {2, 1, 1};
  meth_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_);
  meth_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->definitionLine = 163;
// method "deleteTokenRange(_,_)"
  struct UserObject *uo1211 = (struct UserObject*)obj759;
  uo1211->data[19] = emptyclosure;
  Method *meth_meth_errormessages_1211_deleteTokenRange_40_2_41_ = addmethod2pos(obj759, "deleteTokenRange(2)", &meth_errormessages_1211_deleteTokenRange_40_2_41_, 19);
  int argcv_meth_errormessages_1211_deleteTokenRange_40_2_41_[] = {2};
  meth_meth_errormessages_1211_deleteTokenRange_40_2_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1211_deleteTokenRange_40_2_41_);
  meth_meth_errormessages_1211_deleteTokenRange_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_1211_deleteTokenRange_40_2_41_->definitionLine = 188;
// method "deleteLine(_)"
  struct UserObject *uo1216 = (struct UserObject*)obj759;
  uo1216->data[20] = emptyclosure;
  Method *meth_meth_errormessages_1216_deleteLine_40_1_41_ = addmethod2pos(obj759, "deleteLine(1)", &meth_errormessages_1216_deleteLine_40_1_41_, 20);
  int argcv_meth_errormessages_1216_deleteLine_40_1_41_[] = {1};
  meth_meth_errormessages_1216_deleteLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1216_deleteLine_40_1_41_);
  meth_meth_errormessages_1216_deleteLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1216_deleteLine_40_1_41_->definitionLine = 192;
// method "insert(_)afterToken(_)andTrailingSpace(_)"
  struct UserObject *uo1220 = (struct UserObject*)obj759;
  uo1220->data[21] = emptyclosure;
  Method *meth_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_ = addmethod2pos(obj759, "insert(1)afterToken(1)andTrailingSpace(1)", &meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_, 21);
  int argcv_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_);
  meth_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->definitionLine = 196;
// method "insert(_)afterToken(_)"
  struct UserObject *uo1231 = (struct UserObject*)obj759;
  uo1231->data[22] = emptyclosure;
  Method *meth_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_ = addmethod2pos(obj759, "insert(1)afterToken(1)", &meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_, 22);
  int argcv_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_);
  meth_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_->definitionLine = 201;
// method "insert(_)beforeToken(_)"
  struct UserObject *uo1235 = (struct UserObject*)obj759;
  uo1235->data[23] = emptyclosure;
  Method *meth_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_ = addmethod2pos(obj759, "insert(1)beforeToken(1)", &meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_, 23);
  int argcv_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_);
  meth_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_->definitionLine = 205;
// method "insertNewLine(_)after(_)"
  struct UserObject *uo1242 = (struct UserObject*)obj759;
  uo1242->data[24] = emptyclosure;
  Method *meth_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_ = addmethod2pos(obj759, "insertNewLine(1)after(1)", &meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_, 24);
  int argcv_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_);
  meth_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_->definitionLine = 210;
// method "addLine(_,_)"
  struct UserObject *uo1245 = (struct UserObject*)obj759;
  uo1245->data[25] = emptyclosure;
  Method *meth_meth_errormessages_1245_addLine_40_2_41_ = addmethod2pos(obj759, "addLine(2)", &meth_errormessages_1245_addLine_40_2_41_, 25);
  int argcv_meth_errormessages_1245_addLine_40_2_41_[] = {2};
  meth_meth_errormessages_1245_addLine_40_2_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1245_addLine_40_2_41_);
  meth_meth_errormessages_1245_addLine_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_1245_addLine_40_2_41_->definitionLine = 216;
// method "findLine(_)"
  struct UserObject *uo1345 = (struct UserObject*)obj759;
  uo1345->data[26] = emptyclosure;
  Method *meth_meth_errormessages_1345_findLine_40_1_41_ = addmethod2pos(obj759, "findLine(1)", &meth_errormessages_1345_findLine_40_1_41_, 26);
  int argcv_meth_errormessages_1345_findLine_40_1_41_[] = {1};
  meth_meth_errormessages_1345_findLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1345_findLine_40_1_41_);
  meth_meth_errormessages_1345_findLine_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_1345_findLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1345_findLine_40_1_41_->definitionLine = 240;
// method "getLine(_)"
  block_savedest(obj759);
  Object closure1364 = createclosure(1, "getLine(1)");
  setclosureframe(closure1364, stackframe);
  addtoclosure(closure1364, var_util);
  struct UserObject *uo1364 = (struct UserObject*)obj759;
  uo1364->data[27] = (Object)closure1364;
  Method *meth_meth_errormessages_1364_getLine_40_1_41_ = addmethod2pos(obj759, "getLine(1)", &meth_errormessages_1364_getLine_40_1_41_, 27);
  int argcv_meth_errormessages_1364_getLine_40_1_41_[] = {1};
  meth_meth_errormessages_1364_getLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1364_getLine_40_1_41_);
  meth_meth_errormessages_1364_getLine_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_1364_getLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1364_getLine_40_1_41_->definitionLine = 251;
// method "print"
  block_savedest(obj759);
  Object closure1380 = createclosure(1, "print");
  setclosureframe(closure1380, stackframe);
  addtoclosure(closure1380, var_io);
  struct UserObject *uo1380 = (struct UserObject*)obj759;
  uo1380->data[28] = (Object)closure1380;
  Method *meth_meth_errormessages_1380_print = addmethod2pos(obj759, "print", &meth_errormessages_1380_print, 28);
  int argcv_meth_errormessages_1380_print[] = {0};
  meth_meth_errormessages_1380_print->type = alloc_MethodType(1, argcv_meth_errormessages_1380_print);
  meth_meth_errormessages_1380_print->definitionModule = modulename;
  meth_meth_errormessages_1380_print->definitionLine = 260;
  sourceObject = obj759;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1529 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1529 (depth = 3)
  adddatum2(obj759, array1529, 1);
  sourceObject = obj759;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1530 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1530 (depth = 3)
  adddatum2(obj759, array1530, 2);
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  objclass759 = obj759->class;
  objclass759->definitionModule = modulename;
  objclass759->definitionLine = 14;
  (*(struct UserObject *)self).data[0] = lowerouter759;
  self = oldself759;
  selfslot = oldselfslot759;
  stackframe = oldstackframe759;
  gc_frame_end(frame);
  return obj759;
}
Object meth_errormessages_758_new_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_io = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject759 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj759 = alloc_userobj2(28,29, objclass759);
  gc_frame_newslot(obj759);
  if (objclass759 == NULL) {
    glfree(obj759->class->name);
    obj759->class->name = "suggestion.new";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj759, self, 0);
  addmethodreal(obj759,"outer", &reader_errormessages_outer_760);
  Object oldself759 = self;
  struct StackFrameObject *oldstackframe759 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe759);
  gc_frame_newslot((Object)stackframe);
  self = obj759;
  Object *oldselfslot759 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter759 = (*(struct UserObject *)self).data[0], lowerouter759 = thisouter759;
  if (inheritingObject759) {
    struct UserObject *inho759 = (struct UserObject *)inheritingObject759;
    while (inho759->super != GraceDefaultObject) inho759 = (struct UserObject *)inho759->super;
    inho759->super = obj759;
    self = inheritingObject759;
    *selfslot = self;
    lowerouter759 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter759;
  }
  if (objclass759 == NULL) {
  Method *reader761 = addmethodrealflags(obj759, "lineNumbers",&reader_errormessages_lineNumbers_761, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader761->definitionModule = modulename;
  reader761->definitionLine = 15;
  }
  adddatum2(obj759, alloc_Undefined(), 1);
  if (objclass759 == NULL) {
  Method *reader762 = addmethodrealflags(obj759, "lines",&reader_errormessages_lines_762, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader762->definitionModule = modulename;
  reader762->definitionLine = 16;
  }
  adddatum2(obj759, alloc_Undefined(), 2);
// method "replaceRange(_,_)with(_)onLine(_)"
  struct UserObject *uo763 = (struct UserObject*)obj759;
  uo763->data[3] = emptyclosure;
  Method *meth_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "replaceRange(2)with(1)onLine(1)", &meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_, 3);
  int argcv_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_[] = {2, 1, 1};
  meth_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_763_replaceRange_40_2_41_with_40_1_41_onLine_40_1_41_->definitionLine = 23;
// method "replaceChar(_)with(_)onLine(_)"
  struct UserObject *uo807 = (struct UserObject*)obj759;
  uo807->data[4] = emptyclosure;
  Method *meth_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "replaceChar(1)with(1)onLine(1)", &meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_, 4);
  int argcv_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_807_replaceChar_40_1_41_with_40_1_41_onLine_40_1_41_->definitionLine = 33;
// method "replaceUntil(_)with(_)onLine(_)"
  struct UserObject *uo810 = (struct UserObject*)obj759;
  uo810->data[5] = emptyclosure;
  Method *meth_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "replaceUntil(1)with(1)onLine(1)", &meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_, 5);
  int argcv_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_810_replaceUntil_40_1_41_with_40_1_41_onLine_40_1_41_->definitionLine = 37;
// method "deleteRange(_,_)onLine(_)"
  struct UserObject *uo851 = (struct UserObject*)obj759;
  uo851->data[6] = emptyclosure;
  Method *meth_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_ = addmethod2pos(obj759, "deleteRange(2)onLine(1)", &meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_, 6);
  int argcv_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_[] = {2, 1};
  meth_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_);
  meth_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_851_deleteRange_40_2_41_onLine_40_1_41_->definitionLine = 49;
// method "deleteChar(_)onLine(_)"
  struct UserObject *uo900 = (struct UserObject*)obj759;
  uo900->data[7] = emptyclosure;
  Method *meth_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "deleteChar(1)onLine(1)", &meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_, 7);
  int argcv_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_900_deleteChar_40_1_41_onLine_40_1_41_->definitionLine = 67;
// method "append(_)onLine(_)"
  struct UserObject *uo904 = (struct UserObject*)obj759;
  uo904->data[8] = emptyclosure;
  Method *meth_meth_errormessages_904_append_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "append(1)onLine(1)", &meth_errormessages_904_append_40_1_41_onLine_40_1_41_, 8);
  int argcv_meth_errormessages_904_append_40_1_41_onLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_904_append_40_1_41_onLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_904_append_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_904_append_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_904_append_40_1_41_onLine_40_1_41_->definitionLine = 71;
// method "insert(_)atPosition(_)onLine(_)"
  struct UserObject *uo912 = (struct UserObject*)obj759;
  uo912->data[9] = emptyclosure;
  Method *meth_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_ = addmethod2pos(obj759, "insert(1)atPosition(1)onLine(1)", &meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_, 9);
  int argcv_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_);
  meth_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_912_insert_40_1_41_atPosition_40_1_41_onLine_40_1_41_->definitionLine = 76;
// method "getTokenStart(_)includeLeadingSpace(_)"
  struct UserObject *uo944 = (struct UserObject*)obj759;
  uo944->data[10] = emptyclosure;
  Method *meth_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_ = addmethod2pos(obj759, "getTokenStart(1)includeLeadingSpace(1)", &meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_, 10);
  int argcv_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_[] = {1, 1};
  meth_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_);
  meth_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_944_getTokenStart_40_1_41_includeLeadingSpace_40_1_41_->definitionLine = 90;
// method "getTokenEnd(_)includeTrailingSpace(_)"
  struct UserObject *uo1022 = (struct UserObject*)obj759;
  uo1022->data[11] = emptyclosure;
  Method *meth_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_ = addmethod2pos(obj759, "getTokenEnd(1)includeTrailingSpace(1)", &meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_, 11);
  int argcv_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_);
  meth_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1022_getTokenEnd_40_1_41_includeTrailingSpace_40_1_41_->definitionLine = 107;
// method "replaceToken(_)leading(_)trailing(_)with(_)"
  struct UserObject *uo1077 = (struct UserObject*)obj759;
  uo1077->data[12] = emptyclosure;
  Method *meth_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_ = addmethod2pos(obj759, "replaceToken(1)leading(1)trailing(1)with(1)", &meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_, 12);
  int argcv_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_[] = {1, 1, 1, 1};
  meth_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->type = alloc_MethodType(4, argcv_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1077_replaceToken_40_1_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionLine = 120;
// method "replaceToken(_)with(_)"
  struct UserObject *uo1086 = (struct UserObject*)obj759;
  uo1086->data[13] = emptyclosure;
  Method *meth_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_ = addmethod2pos(obj759, "replaceToken(1)with(1)", &meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_, 13);
  int argcv_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1086_replaceToken_40_1_41_with_40_1_41_->definitionLine = 126;
// method "replaceTokenRange(_,_)leading(_)trailing(_)with(_)"
  struct UserObject *uo1091 = (struct UserObject*)obj759;
  uo1091->data[14] = emptyclosure;
  Method *meth_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_ = addmethod2pos(obj759, "replaceTokenRange(2)leading(1)trailing(1)with(1)", &meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_, 14);
  int argcv_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_[] = {2, 1, 1, 1};
  meth_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->type = alloc_MethodType(4, argcv_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_);
  meth_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1091_replaceTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_with_40_1_41_->definitionLine = 130;
// method "replaceTokenRange(_,_)with(_)"
  struct UserObject *uo1131 = (struct UserObject*)obj759;
  uo1131->data[15] = emptyclosure;
  Method *meth_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_ = addmethod2pos(obj759, "replaceTokenRange(2)with(1)", &meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_, 15);
  int argcv_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_[] = {2, 1};
  meth_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_);
  meth_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1131_replaceTokenRange_40_2_41_with_40_1_41_->definitionLine = 147;
// method "deleteToken(_)leading(_)trailing(_)"
  struct UserObject *uo1136 = (struct UserObject*)obj759;
  uo1136->data[16] = emptyclosure;
  Method *meth_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_ = addmethod2pos(obj759, "deleteToken(1)leading(1)trailing(1)", &meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_, 16);
  int argcv_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_);
  meth_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1136_deleteToken_40_1_41_leading_40_1_41_trailing_40_1_41_->definitionLine = 152;
// method "deleteToken(_)"
  struct UserObject *uo1145 = (struct UserObject*)obj759;
  uo1145->data[17] = emptyclosure;
  Method *meth_meth_errormessages_1145_deleteToken_40_1_41_ = addmethod2pos(obj759, "deleteToken(1)", &meth_errormessages_1145_deleteToken_40_1_41_, 17);
  int argcv_meth_errormessages_1145_deleteToken_40_1_41_[] = {1};
  meth_meth_errormessages_1145_deleteToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1145_deleteToken_40_1_41_);
  meth_meth_errormessages_1145_deleteToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1145_deleteToken_40_1_41_->definitionLine = 158;
// method "deleteTokenRange(_,_)leading(_)trailing(_)"
  struct UserObject *uo1150 = (struct UserObject*)obj759;
  uo1150->data[18] = emptyclosure;
  Method *meth_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_ = addmethod2pos(obj759, "deleteTokenRange(2)leading(1)trailing(1)", &meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_, 18);
  int argcv_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_[] = {2, 1, 1};
  meth_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_);
  meth_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1150_deleteTokenRange_40_2_41_leading_40_1_41_trailing_40_1_41_->definitionLine = 163;
// method "deleteTokenRange(_,_)"
  struct UserObject *uo1211 = (struct UserObject*)obj759;
  uo1211->data[19] = emptyclosure;
  Method *meth_meth_errormessages_1211_deleteTokenRange_40_2_41_ = addmethod2pos(obj759, "deleteTokenRange(2)", &meth_errormessages_1211_deleteTokenRange_40_2_41_, 19);
  int argcv_meth_errormessages_1211_deleteTokenRange_40_2_41_[] = {2};
  meth_meth_errormessages_1211_deleteTokenRange_40_2_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1211_deleteTokenRange_40_2_41_);
  meth_meth_errormessages_1211_deleteTokenRange_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_1211_deleteTokenRange_40_2_41_->definitionLine = 188;
// method "deleteLine(_)"
  struct UserObject *uo1216 = (struct UserObject*)obj759;
  uo1216->data[20] = emptyclosure;
  Method *meth_meth_errormessages_1216_deleteLine_40_1_41_ = addmethod2pos(obj759, "deleteLine(1)", &meth_errormessages_1216_deleteLine_40_1_41_, 20);
  int argcv_meth_errormessages_1216_deleteLine_40_1_41_[] = {1};
  meth_meth_errormessages_1216_deleteLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1216_deleteLine_40_1_41_);
  meth_meth_errormessages_1216_deleteLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1216_deleteLine_40_1_41_->definitionLine = 192;
// method "insert(_)afterToken(_)andTrailingSpace(_)"
  struct UserObject *uo1220 = (struct UserObject*)obj759;
  uo1220->data[21] = emptyclosure;
  Method *meth_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_ = addmethod2pos(obj759, "insert(1)afterToken(1)andTrailingSpace(1)", &meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_, 21);
  int argcv_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_);
  meth_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1220_insert_40_1_41_afterToken_40_1_41_andTrailingSpace_40_1_41_->definitionLine = 196;
// method "insert(_)afterToken(_)"
  struct UserObject *uo1231 = (struct UserObject*)obj759;
  uo1231->data[22] = emptyclosure;
  Method *meth_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_ = addmethod2pos(obj759, "insert(1)afterToken(1)", &meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_, 22);
  int argcv_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_);
  meth_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1231_insert_40_1_41_afterToken_40_1_41_->definitionLine = 201;
// method "insert(_)beforeToken(_)"
  struct UserObject *uo1235 = (struct UserObject*)obj759;
  uo1235->data[23] = emptyclosure;
  Method *meth_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_ = addmethod2pos(obj759, "insert(1)beforeToken(1)", &meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_, 23);
  int argcv_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_);
  meth_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1235_insert_40_1_41_beforeToken_40_1_41_->definitionLine = 205;
// method "insertNewLine(_)after(_)"
  struct UserObject *uo1242 = (struct UserObject*)obj759;
  uo1242->data[24] = emptyclosure;
  Method *meth_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_ = addmethod2pos(obj759, "insertNewLine(1)after(1)", &meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_, 24);
  int argcv_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_[] = {1, 1};
  meth_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_);
  meth_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1242_insertNewLine_40_1_41_after_40_1_41_->definitionLine = 210;
// method "addLine(_,_)"
  struct UserObject *uo1245 = (struct UserObject*)obj759;
  uo1245->data[25] = emptyclosure;
  Method *meth_meth_errormessages_1245_addLine_40_2_41_ = addmethod2pos(obj759, "addLine(2)", &meth_errormessages_1245_addLine_40_2_41_, 25);
  int argcv_meth_errormessages_1245_addLine_40_2_41_[] = {2};
  meth_meth_errormessages_1245_addLine_40_2_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1245_addLine_40_2_41_);
  meth_meth_errormessages_1245_addLine_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_1245_addLine_40_2_41_->definitionLine = 216;
// method "findLine(_)"
  struct UserObject *uo1345 = (struct UserObject*)obj759;
  uo1345->data[26] = emptyclosure;
  Method *meth_meth_errormessages_1345_findLine_40_1_41_ = addmethod2pos(obj759, "findLine(1)", &meth_errormessages_1345_findLine_40_1_41_, 26);
  int argcv_meth_errormessages_1345_findLine_40_1_41_[] = {1};
  meth_meth_errormessages_1345_findLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1345_findLine_40_1_41_);
  meth_meth_errormessages_1345_findLine_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_1345_findLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1345_findLine_40_1_41_->definitionLine = 240;
// method "getLine(_)"
  block_savedest(obj759);
  Object closure1364 = createclosure(1, "getLine(1)");
  setclosureframe(closure1364, stackframe);
  addtoclosure(closure1364, var_util);
  struct UserObject *uo1364 = (struct UserObject*)obj759;
  uo1364->data[27] = (Object)closure1364;
  Method *meth_meth_errormessages_1364_getLine_40_1_41_ = addmethod2pos(obj759, "getLine(1)", &meth_errormessages_1364_getLine_40_1_41_, 27);
  int argcv_meth_errormessages_1364_getLine_40_1_41_[] = {1};
  meth_meth_errormessages_1364_getLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1364_getLine_40_1_41_);
  meth_meth_errormessages_1364_getLine_40_1_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_1364_getLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1364_getLine_40_1_41_->definitionLine = 251;
// method "print"
  block_savedest(obj759);
  Object closure1380 = createclosure(1, "print");
  setclosureframe(closure1380, stackframe);
  addtoclosure(closure1380, var_io);
  struct UserObject *uo1380 = (struct UserObject*)obj759;
  uo1380->data[28] = (Object)closure1380;
  Method *meth_meth_errormessages_1380_print = addmethod2pos(obj759, "print", &meth_errormessages_1380_print, 28);
  int argcv_meth_errormessages_1380_print[] = {0};
  meth_meth_errormessages_1380_print->type = alloc_MethodType(1, argcv_meth_errormessages_1380_print);
  meth_meth_errormessages_1380_print->definitionModule = modulename;
  meth_meth_errormessages_1380_print->definitionLine = 260;
  sourceObject = obj759;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1529 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1529 (depth = 3)
  adddatum2(obj759, array1529, 1);
  sourceObject = obj759;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1530 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1530 (depth = 3)
  adddatum2(obj759, array1530, 2);
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  sourceObject = obj759;
  objclass759 = obj759->class;
  objclass759->definitionModule = modulename;
  objclass759->definitionLine = 14;
  (*(struct UserObject *)self).data[0] = lowerouter759;
  self = oldself759;
  selfslot = oldselfslot759;
  stackframe = oldstackframe759;
  gc_frame_end(frame);
  return obj759;
}
Object meth_errormessages_1532_suggestion(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "suggestion");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_suggestion = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_end(frame);
  return *var_suggestion;
}
Object module_errormessages_init() {
  if (module_errormessages) return module_errormessages;
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(32, 32);
  module_errormessages = self;
  self->class->definitionModule = "errormessages";
  gc_root(self);
  prelude = module_standardGrace_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule("errormessages");
  setsource(originalSourceLines);
  setclassname(self, "Module<errormessages>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(32, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[1];
// definebindings:
  Object *var_io = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "io");
  Object *var_sys = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sys");
  Object *var_util = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "util");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "readableStringFrom(_)"
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = emptyclosure;
  Method *meth_meth_errormessages_1_readableStringFrom_40_1_41_ = addmethod2pos(self, "readableStringFrom(1)", &meth_errormessages_1_readableStringFrom_40_1_41_, 1);
  int argcv_meth_errormessages_1_readableStringFrom_40_1_41_[] = {1};
  meth_meth_errormessages_1_readableStringFrom_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_1_readableStringFrom_40_1_41_);
  meth_meth_errormessages_1_readableStringFrom_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_1_readableStringFrom_40_1_41_->definitionLine = 280;
// compiled method node returning  (depth = 1)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "name(_)mightBeIntendedToBe(_)"
  struct UserObject *uo53 = (struct UserObject*)self;
  uo53->data[2] = emptyclosure;
  Method *meth_meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_ = addmethod2pos(self, "name(1)mightBeIntendedToBe(1)", &meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_, 2);
  int argcv_meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_[] = {1, 1};
  meth_meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_);
meth_meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_->type->types[0] = type_String;
meth_meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_->type->names[0] = "p";
meth_meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_->type->types[1] = type_String;
meth_meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_->type->names[1] = "target";
  meth_meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_53_name_40_1_41_mightBeIntendedToBe_40_1_41_->definitionLine = 298;
// compiled method node returning  (depth = 1)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "name(_)matches(_)within(_)"
  struct UserObject *uo122 = (struct UserObject*)self;
  uo122->data[3] = emptyclosure;
  Method *meth_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_ = addmethod2pos(self, "name(1)matches(1)within(1)", &meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_, 3);
  int argcv_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_);
meth_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_->type->types[0] = type_String;
meth_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_->type->names[0] = "p";
meth_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_->type->types[1] = type_String;
meth_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_->type->names[1] = "t";
meth_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_->type->types[2] = type_Number;
meth_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_->type->names[2] = "k";
  meth_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_122_name_40_1_41_matches_40_1_41_within_40_1_41_->definitionLine = 312;
// compiled method node returning  (depth = 1)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "min3(_,_,_)"
  struct UserObject *uo287 = (struct UserObject*)self;
  uo287->data[4] = emptyclosure;
  Method *meth_meth_errormessages_287_min3_40_3_41_ = addmethod2pos(self, "min3(3)", &meth_errormessages_287_min3_40_3_41_, 4);
  int argcv_meth_errormessages_287_min3_40_3_41_[] = {3};
  meth_meth_errormessages_287_min3_40_3_41_->type = alloc_MethodType(1, argcv_meth_errormessages_287_min3_40_3_41_);
  meth_meth_errormessages_287_min3_40_3_41_->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_287_min3_40_3_41_->definitionModule = modulename;
  meth_meth_errormessages_287_min3_40_3_41_->definitionLine = 370;
// compiled method node returning  (depth = 1)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_)"
  struct UserObject *uo296 = (struct UserObject*)self;
  uo296->data[5] = emptyclosure;
  Method *meth_meth_errormessages_296_syntaxError_40_1_41_atRange_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(1)", &meth_errormessages_296_syntaxError_40_1_41_atRange_40_1_41_, 5);
  int argcv_meth_errormessages_296_syntaxError_40_1_41_atRange_40_1_41_[] = {1, 1};
  meth_meth_errormessages_296_syntaxError_40_1_41_atRange_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_296_syntaxError_40_1_41_atRange_40_1_41_);
  meth_meth_errormessages_296_syntaxError_40_1_41_atRange_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_296_syntaxError_40_1_41_atRange_40_1_41_->definitionLine = 378;
// compiled method node returning  (depth = 1)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_)withSuggestion(_)"
  struct UserObject *uo317 = (struct UserObject*)self;
  uo317->data[6] = emptyclosure;
  Method *meth_meth_errormessages_317_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(1)withSuggestion(1)", &meth_errormessages_317_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_, 6);
  int argcv_meth_errormessages_317_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_317_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_317_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_);
  meth_meth_errormessages_317_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_317_syntaxError_40_1_41_atRange_40_1_41_withSuggestion_40_1_41_->definitionLine = 386;
// compiled method node returning  (depth = 1)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_)withSuggestions(_)"
  struct UserObject *uo321 = (struct UserObject*)self;
  uo321->data[7] = emptyclosure;
  Method *meth_meth_errormessages_321_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(1)withSuggestions(1)", &meth_errormessages_321_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_, 7);
  int argcv_meth_errormessages_321_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_321_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_321_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_321_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_321_syntaxError_40_1_41_atRange_40_1_41_withSuggestions_40_1_41_->definitionLine = 389;
// compiled method node returning  (depth = 1)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_,_,_)"
  struct UserObject *uo340 = (struct UserObject*)self;
  uo340->data[8] = emptyclosure;
  Method *meth_meth_errormessages_340_syntaxError_40_1_41_atRange_40_3_41_ = addmethod2pos(self, "syntaxError(1)atRange(3)", &meth_errormessages_340_syntaxError_40_1_41_atRange_40_3_41_, 8);
  int argcv_meth_errormessages_340_syntaxError_40_1_41_atRange_40_3_41_[] = {1, 3};
  meth_meth_errormessages_340_syntaxError_40_1_41_atRange_40_3_41_->type = alloc_MethodType(2, argcv_meth_errormessages_340_syntaxError_40_1_41_atRange_40_3_41_);
  meth_meth_errormessages_340_syntaxError_40_1_41_atRange_40_3_41_->definitionModule = modulename;
  meth_meth_errormessages_340_syntaxError_40_1_41_atRange_40_3_41_->definitionLine = 395;
// compiled method node returning  (depth = 1)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_,_,_)withSuggestion(_)"
  struct UserObject *uo344 = (struct UserObject*)self;
  uo344->data[9] = emptyclosure;
  Method *meth_meth_errormessages_344_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(3)withSuggestion(1)", &meth_errormessages_344_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_, 9);
  int argcv_meth_errormessages_344_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_[] = {1, 3, 1};
  meth_meth_errormessages_344_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_344_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_);
  meth_meth_errormessages_344_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_344_syntaxError_40_1_41_atRange_40_3_41_withSuggestion_40_1_41_->definitionLine = 399;
// compiled method node returning  (depth = 1)
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_,_,_)withSuggestions(_)"
  struct UserObject *uo348 = (struct UserObject*)self;
  uo348->data[10] = emptyclosure;
  Method *meth_meth_errormessages_348_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(3)withSuggestions(1)", &meth_errormessages_348_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_, 10);
  int argcv_meth_errormessages_348_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_[] = {1, 3, 1};
  meth_meth_errormessages_348_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_348_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_348_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_348_syntaxError_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->definitionLine = 403;
// compiled method node returning  (depth = 1)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atRange(_,_,_,_)withSuggestions(_)"
  block_savedest(self);
  Object closure351 = createclosure(1, "syntaxError(1)atRange(4)withSuggestions(1)");
  setclosureframe(closure351, stackframe);
  addtoclosure(closure351, var_util);
  struct UserObject *uo351 = (struct UserObject*)self;
  uo351->data[11] = (Object)closure351;
  Method *meth_meth_errormessages_351_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_ = addmethod2pos(self, "syntaxError(1)atRange(4)withSuggestions(1)", &meth_errormessages_351_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_, 11);
  int argcv_meth_errormessages_351_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_[] = {1, 4, 1};
  meth_meth_errormessages_351_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_351_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_351_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_351_syntaxError_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_->definitionLine = 409;
// compiled method node returning  (depth = 1)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atRange(_)"
  struct UserObject *uo444 = (struct UserObject*)self;
  uo444->data[12] = emptyclosure;
  Method *meth_meth_errormessages_444_error_40_1_41_atRange_40_1_41_ = addmethod2pos(self, "error(1)atRange(1)", &meth_errormessages_444_error_40_1_41_atRange_40_1_41_, 12);
  int argcv_meth_errormessages_444_error_40_1_41_atRange_40_1_41_[] = {1, 1};
  meth_meth_errormessages_444_error_40_1_41_atRange_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_444_error_40_1_41_atRange_40_1_41_);
  meth_meth_errormessages_444_error_40_1_41_atRange_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_444_error_40_1_41_atRange_40_1_41_->definitionLine = 429;
// compiled method node returning  (depth = 1)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atRange(_,_,_,_)withSuggestions(_)"
  block_savedest(self);
  Object closure464 = createclosure(1, "error(1)atRange(4)withSuggestions(1)");
  setclosureframe(closure464, stackframe);
  addtoclosure(closure464, var_util);
  struct UserObject *uo464 = (struct UserObject*)self;
  uo464->data[13] = (Object)closure464;
  Method *meth_meth_errormessages_464_error_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_ = addmethod2pos(self, "error(1)atRange(4)withSuggestions(1)", &meth_errormessages_464_error_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_, 13);
  int argcv_meth_errormessages_464_error_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_[] = {1, 4, 1};
  meth_meth_errormessages_464_error_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_464_error_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_464_error_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_464_error_40_1_41_atRange_40_4_41_withSuggestions_40_1_41_->definitionLine = 434;
// compiled method node returning  (depth = 1)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atRange(_,_,_)withSuggestions(_)"
  struct UserObject *uo557 = (struct UserObject*)self;
  uo557->data[14] = emptyclosure;
  Method *meth_meth_errormessages_557_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_ = addmethod2pos(self, "error(1)atRange(3)withSuggestions(1)", &meth_errormessages_557_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_, 14);
  int argcv_meth_errormessages_557_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_[] = {1, 3, 1};
  meth_meth_errormessages_557_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_557_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_557_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_557_error_40_1_41_atRange_40_3_41_withSuggestions_40_1_41_->definitionLine = 453;
// compiled method node returning  (depth = 1)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atRange(_,_,_)"
  struct UserObject *uo560 = (struct UserObject*)self;
  uo560->data[15] = emptyclosure;
  Method *meth_meth_errormessages_560_error_40_1_41_atRange_40_3_41_ = addmethod2pos(self, "error(1)atRange(3)", &meth_errormessages_560_error_40_1_41_atRange_40_3_41_, 15);
  int argcv_meth_errormessages_560_error_40_1_41_atRange_40_3_41_[] = {1, 3};
  meth_meth_errormessages_560_error_40_1_41_atRange_40_3_41_->type = alloc_MethodType(2, argcv_meth_errormessages_560_error_40_1_41_atRange_40_3_41_);
  meth_meth_errormessages_560_error_40_1_41_atRange_40_3_41_->definitionModule = modulename;
  meth_meth_errormessages_560_error_40_1_41_atRange_40_3_41_->definitionLine = 458;
// compiled method node returning  (depth = 1)
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atPosition(_,_)"
  struct UserObject *uo564 = (struct UserObject*)self;
  uo564->data[16] = emptyclosure;
  Method *meth_meth_errormessages_564_syntaxError_40_1_41_atPosition_40_2_41_ = addmethod2pos(self, "syntaxError(1)atPosition(2)", &meth_errormessages_564_syntaxError_40_1_41_atPosition_40_2_41_, 16);
  int argcv_meth_errormessages_564_syntaxError_40_1_41_atPosition_40_2_41_[] = {1, 2};
  meth_meth_errormessages_564_syntaxError_40_1_41_atPosition_40_2_41_->type = alloc_MethodType(2, argcv_meth_errormessages_564_syntaxError_40_1_41_atPosition_40_2_41_);
  meth_meth_errormessages_564_syntaxError_40_1_41_atPosition_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_564_syntaxError_40_1_41_atPosition_40_2_41_->definitionLine = 462;
// compiled method node returning  (depth = 1)
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atPosition(_,_)"
  struct UserObject *uo568 = (struct UserObject*)self;
  uo568->data[17] = emptyclosure;
  Method *meth_meth_errormessages_568_error_40_1_41_atPosition_40_2_41_ = addmethod2pos(self, "error(1)atPosition(2)", &meth_errormessages_568_error_40_1_41_atPosition_40_2_41_, 17);
  int argcv_meth_errormessages_568_error_40_1_41_atPosition_40_2_41_[] = {1, 2};
  meth_meth_errormessages_568_error_40_1_41_atPosition_40_2_41_->type = alloc_MethodType(2, argcv_meth_errormessages_568_error_40_1_41_atPosition_40_2_41_);
  meth_meth_errormessages_568_error_40_1_41_atPosition_40_2_41_->definitionModule = modulename;
  meth_meth_errormessages_568_error_40_1_41_atPosition_40_2_41_->definitionLine = 466;
// compiled method node returning  (depth = 1)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atPosition(_,_)withSuggestion(_)"
  struct UserObject *uo572 = (struct UserObject*)self;
  uo572->data[18] = emptyclosure;
  Method *meth_meth_errormessages_572_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_ = addmethod2pos(self, "syntaxError(1)atPosition(2)withSuggestion(1)", &meth_errormessages_572_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_, 18);
  int argcv_meth_errormessages_572_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_[] = {1, 2, 1};
  meth_meth_errormessages_572_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_572_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_);
  meth_meth_errormessages_572_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_572_syntaxError_40_1_41_atPosition_40_2_41_withSuggestion_40_1_41_->definitionLine = 470;
// compiled method node returning  (depth = 1)
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atPosition(_,_)withSuggestions(_)"
  block_savedest(self);
  Object closure576 = createclosure(1, "syntaxError(1)atPosition(2)withSuggestions(1)");
  setclosureframe(closure576, stackframe);
  addtoclosure(closure576, var_util);
  struct UserObject *uo576 = (struct UserObject*)self;
  uo576->data[19] = (Object)closure576;
  Method *meth_meth_errormessages_576_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_ = addmethod2pos(self, "syntaxError(1)atPosition(2)withSuggestions(1)", &meth_errormessages_576_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_, 19);
  int argcv_meth_errormessages_576_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_[] = {1, 2, 1};
  meth_meth_errormessages_576_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_576_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_576_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_576_syntaxError_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->definitionLine = 474;
// compiled method node returning  (depth = 1)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atPosition(_,_)withSuggestions(_)"
  block_savedest(self);
  Object closure614 = createclosure(1, "error(1)atPosition(2)withSuggestions(1)");
  setclosureframe(closure614, stackframe);
  addtoclosure(closure614, var_util);
  struct UserObject *uo614 = (struct UserObject*)self;
  uo614->data[20] = (Object)closure614;
  Method *meth_meth_errormessages_614_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_ = addmethod2pos(self, "error(1)atPosition(2)withSuggestions(1)", &meth_errormessages_614_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_, 20);
  int argcv_meth_errormessages_614_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_[] = {1, 2, 1};
  meth_meth_errormessages_614_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_614_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_614_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_614_error_40_1_41_atPosition_40_2_41_withSuggestions_40_1_41_->definitionLine = 483;
// compiled method node returning  (depth = 1)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)"
  block_savedest(self);
  Object closure652 = createclosure(1, "error(1)");
  setclosureframe(closure652, stackframe);
  addtoclosure(closure652, var_util);
  struct UserObject *uo652 = (struct UserObject*)self;
  uo652->data[21] = (Object)closure652;
  Method *meth_meth_errormessages_652_error_40_1_41_ = addmethod2pos(self, "error(1)", &meth_errormessages_652_error_40_1_41_, 21);
  int argcv_meth_errormessages_652_error_40_1_41_[] = {1};
  meth_meth_errormessages_652_error_40_1_41_->type = alloc_MethodType(1, argcv_meth_errormessages_652_error_40_1_41_);
  meth_meth_errormessages_652_error_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_652_error_40_1_41_->definitionLine = 493;
// compiled method node returning  (depth = 1)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atLine(_)withSuggestions(_)"
  block_savedest(self);
  Object closure659 = createclosure(1, "error(1)atLine(1)withSuggestions(1)");
  setclosureframe(closure659, stackframe);
  addtoclosure(closure659, var_util);
  struct UserObject *uo659 = (struct UserObject*)self;
  uo659->data[22] = (Object)closure659;
  Method *meth_meth_errormessages_659_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_ = addmethod2pos(self, "error(1)atLine(1)withSuggestions(1)", &meth_errormessages_659_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_, 22);
  int argcv_meth_errormessages_659_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_659_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_659_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_659_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_659_error_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->definitionLine = 497;
// compiled method node returning  (depth = 1)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error(_)atLine(_)"
  struct UserObject *uo701 = (struct UserObject*)self;
  uo701->data[23] = emptyclosure;
  Method *meth_meth_errormessages_701_error_40_1_41_atLine_40_1_41_ = addmethod2pos(self, "error(1)atLine(1)", &meth_errormessages_701_error_40_1_41_atLine_40_1_41_, 23);
  int argcv_meth_errormessages_701_error_40_1_41_atLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_701_error_40_1_41_atLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_701_error_40_1_41_atLine_40_1_41_);
  meth_meth_errormessages_701_error_40_1_41_atLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_701_error_40_1_41_atLine_40_1_41_->definitionLine = 508;
// compiled method node returning  (depth = 1)
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atLine(_)"
  struct UserObject *uo705 = (struct UserObject*)self;
  uo705->data[24] = emptyclosure;
  Method *meth_meth_errormessages_705_syntaxError_40_1_41_atLine_40_1_41_ = addmethod2pos(self, "syntaxError(1)atLine(1)", &meth_errormessages_705_syntaxError_40_1_41_atLine_40_1_41_, 24);
  int argcv_meth_errormessages_705_syntaxError_40_1_41_atLine_40_1_41_[] = {1, 1};
  meth_meth_errormessages_705_syntaxError_40_1_41_atLine_40_1_41_->type = alloc_MethodType(2, argcv_meth_errormessages_705_syntaxError_40_1_41_atLine_40_1_41_);
  meth_meth_errormessages_705_syntaxError_40_1_41_atLine_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_705_syntaxError_40_1_41_atLine_40_1_41_->definitionLine = 512;
// compiled method node returning  (depth = 1)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atLine(_)withSuggestion(_)"
  struct UserObject *uo709 = (struct UserObject*)self;
  uo709->data[25] = emptyclosure;
  Method *meth_meth_errormessages_709_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_ = addmethod2pos(self, "syntaxError(1)atLine(1)withSuggestion(1)", &meth_errormessages_709_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_, 25);
  int argcv_meth_errormessages_709_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_709_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_709_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_);
  meth_meth_errormessages_709_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_709_syntaxError_40_1_41_atLine_40_1_41_withSuggestion_40_1_41_->definitionLine = 516;
// compiled method node returning  (depth = 1)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError(_)atLine(_)withSuggestions(_)"
  block_savedest(self);
  Object closure713 = createclosure(1, "syntaxError(1)atLine(1)withSuggestions(1)");
  setclosureframe(closure713, stackframe);
  addtoclosure(closure713, var_util);
  struct UserObject *uo713 = (struct UserObject*)self;
  uo713->data[26] = (Object)closure713;
  Method *meth_meth_errormessages_713_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_ = addmethod2pos(self, "syntaxError(1)atLine(1)withSuggestions(1)", &meth_errormessages_713_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_, 26);
  int argcv_meth_errormessages_713_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_[] = {1, 1, 1};
  meth_meth_errormessages_713_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->type = alloc_MethodType(3, argcv_meth_errormessages_713_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_);
  meth_meth_errormessages_713_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->definitionModule = modulename;
  meth_meth_errormessages_713_syntaxError_40_1_41_atLine_40_1_41_withSuggestions_40_1_41_->definitionLine = 520;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of sys as sys
  if (module_sys == NULL)
    module_sys = module_sys_init();
  *var_sys = module_sys;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject756 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj756 = alloc_userobj2(2,4, objclass756);
  gc_frame_newslot(obj756);
  if (objclass756 == NULL) {
    glfree(obj756->class->name);
    obj756->class->name = "suggestion";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj756, self, 0);
  addmethodreal(obj756,"outer", &reader_errormessages_outer_757);
  Object oldself756 = self;
  struct StackFrameObject *oldstackframe756 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe756);
  gc_frame_newslot((Object)stackframe);
  self = obj756;
  Object *oldselfslot756 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter756 = (*(struct UserObject *)self).data[0], lowerouter756 = thisouter756;
  if (inheritingObject756) {
    struct UserObject *inho756 = (struct UserObject *)inheritingObject756;
    while (inho756->super != GraceDefaultObject) inho756 = (struct UserObject *)inho756->super;
    inho756->super = obj756;
    self = inheritingObject756;
    *selfslot = self;
    lowerouter756 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter756;
  }
// method "new"
  block_savedest(obj756);
  Object closure758 = createclosure(2, "new");
  setclosureframe(closure758, stackframe);
  addtoclosure(closure758, var_util);
  addtoclosure(closure758, var_io);
  struct UserObject *uo758 = (struct UserObject*)obj756;
  uo758->data[1] = (Object)closure758;
  Method *meth_meth_errormessages_758_new = addmethod2pos(obj756, "new", &meth_errormessages_758_new, 1);
  int argcv_meth_errormessages_758_new[] = {0};
  meth_meth_errormessages_758_new->type = alloc_MethodType(1, argcv_meth_errormessages_758_new);
  meth_meth_errormessages_758_new->definitionModule = modulename;
  meth_meth_errormessages_758_new->definitionLine = 14;
  block_savedest(obj756);
  Object closure1531 = createclosure(2, "new$object(1)");
  setclosureframe(closure1531, stackframe);
  addtoclosure(closure1531, var_util);
  addtoclosure(closure1531, var_io);
  Method *meth_meth_errormessages_758_new_object = addmethod2pos(obj756, "new$object(1)", &meth_errormessages_758_new_object, 1);
  meth_meth_errormessages_758_new_object->definitionModule = modulename;
  meth_meth_errormessages_758_new_object->definitionLine = 14;
  sourceObject = obj756;
  objclass756 = obj756->class;
  objclass756->definitionModule = modulename;
  objclass756->definitionLine = 13;
  (*(struct UserObject *)self).data[0] = lowerouter756;
  self = oldself756;
  selfslot = oldselfslot756;
  stackframe = oldstackframe756;
// compiled object node returning obj756 (depth = 2)
  *var_suggestion = obj756;
  if (obj756 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "suggestion"
  block_savedest(self);
  Object closure1532 = createclosure(1, "suggestion");
  setclosureframe(closure1532, stackframe);
  addtoclosure(closure1532, var_suggestion);
  struct UserObject *uo1532 = (struct UserObject*)self;
  uo1532->data[27] = (Object)closure1532;
  Method *meth_meth_errormessages_1532_suggestion = addmethod2pos(self, "suggestion", &meth_errormessages_1532_suggestion, 27);
  int argcv_meth_errormessages_1532_suggestion[] = {0};
  meth_meth_errormessages_1532_suggestion->type = alloc_MethodType(1, argcv_meth_errormessages_1532_suggestion);
  meth_meth_errormessages_1532_suggestion->definitionModule = modulename;
  meth_meth_errormessages_1532_suggestion->definitionLine = 528;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
  gc_frame_end(frame);
  return self;
}
