#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1e6315be77eff662cf99876c2ac8964a81f2abc7";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "parser";
Object module_standardGrace_init();
extern Object module_standardGrace;
Object module_parser = NULL;
static char *originalSourceLines[] = {
  "#pragma ExtendedLineups",
  "import \"io\" as io",
  "import \"ast\" as ast",
  "import \"util\" as util",
  "import \"errormessages\" as errormessages",
  "",
  "var lastLine := 0",
  "var lastIndent := 0",
  "var indentFreePass := false",
  "var minIndentLevel := 0",
  "var statementIndent := 0",
  "var tokens := false",
  "var moduleObject",
  "var comments := emptyList   // so we can request `removeAt`",
  "",
  "var auto_count := 0",
  "def noBlocks = false",
  "def blocksOK = true",
  "",
  "",
  "var values := [ ]",
  "",
  "//  The alternative definition below allows pushes and pops of `values`",
  "//  to be traced.  It can be useful for debugging the parser.",
  "//  def values = object {",
  "//      def realValues = [ ]",
  "//      var tracing is public := false",
  "//      method push(v) {",
  "//          if (tracing) then {",
  "//              print \"pushed {v.toGrace 0} (line {v.line})\"",
  "//          }",
  "//          realValues.push(v)",
  "//      }",
  "//      method pop {",
  "//          def res = realValues.pop",
  "//          if (tracing) then {",
  "//              print \"popped {res.toGrace 0} (line {res.line})\"",
  "//          }",
  "//          res",
  "//      }",
  "//      method size { realValues.size }",
  "//      method filter(b) { realValues.filter(b) }",
  "//      method isEmpty { realValues.isEmpty }",
  "//      method last { realValues.last }",
  "//      method do(b) { realValues.do(b) }",
  "//  }",
  "",
  "// sym is a module-level field containing the current token",
  "var sym := object {",
  "    def kind is public = \"start\"",
  "    def line is public = 0",
  "    def linePos is public = 0",
  "    def indent is public = 0",
  "    def value is public = \"\"",
  "    def size is public = 0",
  "    method ==(other) {",
  "        if (other == false) then {",
  "            false",
  "        } else {",
  "            (other.line == line) && (other.linePos == linePos)",
  "        }",
  "    }",
  "}",
  "",
  "var lastToken := sym",
  "var previousCommentToken := lastToken",
  "var statementToken := lastToken     // the token starting the current statement",
  "var comment := false",
  "",
  "method next {",
  "    // Advance to the next token in the stream, assigning it to sym.",
  "    // Put the position in the input into util module variables.",
  "",
  "    if (tokens.size > 0) then {",
  "        lastToken := sym",
  "        lastLine := lastToken.line",
  "        lastIndent := lastToken.indent",
  "        sym := tokens.poll",
  "        pushComments",
  "        util.setPosition(sym.line, sym.linePos)",
  "    } else {",
  "        errormessages.syntaxError(\"unexpectedly found the end of the input. \" ",
  "            ++ \"This is often caused by a missing '\\}'\")",
  "            atPosition(sym.line, sym.linePos)",
  "    }",
  "}",
  "",
  "method indentHasIncreased {",
  "    // is lastToken on a line that is a continuation of the previous line?",
  "",
  "    if (lastIndent == 0) then {",
  "        return false        // this ensures that there will be a previous symbol",
  "                            // on a prior line, and we won't hit start of input.",
  "    }",
  "    var s := sym.prev",
  "    do { s := s.prev } while { s.line == lastLine }",
  "    if ( s.kind == \"lbrace\" ) then { return false }",
  "    if ( s.kind == \"comment\" ) then { return false }",
  "    return s.indent < lastIndent",
  "}",
  "",
  "method saveParsePosition {",
  "    def lexerState = tokens.savePosition",
  "    return [lexerState, values.size]",
  "}",
  "",
  "method restoreParsePosition(saved) {",
  "    tokens.restorePosition(saved.first)",
  "    sym := tokens.first.prev",
  "    lastToken := sym.prev",
  "    def oldValueStackSize = saved.second",
  "    if (oldValueStackSize > values.size) then {",
  "        ProgrammingError.raise \"can't restore parse position; the values stack has been popped\"",
  "    }",
  "    while {oldValueStackSize ≠ values.size} do { values.pop }",
  "}",
  "",
  "method findNextToken(tokenMatcher) {",
  "    // Search for the next token for which the given block returns true.",
  "    // Used for generating suggestions.",
  "",
  "    if (tokenMatcher.apply(sym)) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(false != n) && { false == nextTok } && { n.indent >= lastToken.indent }} do {",
  "        if (tokenMatcher.apply(n)) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextTokenIndentedAt(tok) {",
  "    if (((sym.line > tok.line) && (sym.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(false != n) && { false == nextTok }} do {",
  "        if (((n.line > tok.line) && (n.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextValidToken(validFollowTokens) {",
  "    // Tokens that cannot start an expression.",
  "    def invalidTokens = set [\"dot\", \"comma\", \"colon\", \"rparen\",",
  "            \"rbrace\", \"rsquare\", \"arrow\", \"bind\"];",
  "    var validToken := sym",
  "    while {validToken.kind != \"eof\"} do {",
  "        // If the token is a valid follow token, then return that token.",
  "        if (validFollowTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // If the token is not an invalid token for starting an expression, return that token.",
  "        if (!invalidTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // The token is invalid, go to the next one.",
  "        validToken := validToken.next",
  "    }",
  "    return validToken",
  "}",
  "",
  "method findClosingBrace(token, inserted) {",
  "    // Finds the closing brace for token (that is the beginning of a control",
  "    // structure) -- an opening brace. Returns an object with two fields: found",
  "    // and tok. If a closing brace is found, found is set to true, and tok is set to",
  "    // the closing brace. Otherwise found is set to false, and tok is set to the",
  "    // token that the closing brace should appear after.",
  "",
  "    var n := sym",
  "    var numOpening := if (inserted) then {1} else {0}",
  "    var numClosing := 0",
  "    def result = object {",
  "        var found is public",
  "        var tok is public",
  "    }",
  "    // Skip all tokens on the same line first.",
  "    while {(n.kind != \"eof\") && (n.line == token.line)} do {",
  "        if (n.kind == \"lbrace\") then {",
  "            numOpening := numOpening + 1",
  "        } elseif { n.kind == \"rbrace\" } then {",
  "            numClosing := numClosing + 1",
  "        }",
  "        n := n.next",
  "    }",
  "    // Skip all tokens that have greater indent than the target closing brace.",
  "    while {(n.kind != \"eof\") && (n.indent > token.indent)} do {",
  "        if (n.kind == \"lbrace\") then {",
  "            numOpening := numOpening + 1",
  "        } elseif { n.kind == \"rbrace\" } then {",
  "            numClosing := numClosing + 1 ",
  "        }",
  "        n := n.next",
  "    }",
  "    if (n.kind == \"rbrace\") then {",
  "        result.found := true",
  "        result.tok := n",
  "    } elseif {(n.prev.kind == \"rbrace\") && (numOpening == numClosing)} then {",
  "        // Check that the number of opening and closing braces matches.",
  "        result.found := true",
  "        result.tok := n.prev",
  "    } else {",
  "        result.found := false",
  "        result.tok := n.prev",
  "    }",
  "    result",
  "}",
  "",
  "",
  "method accept(t) {",
  "    // True if the current token has kind t, where",
  "    // t is \"num\", \"string\", \"keyword\", etc.",
  "    sym.kind == t",
  "}",
  "",
  "method acceptKeyword (kw) {",
  "    if (sym.kind != \"keyword\") then { return false }",
  "    return sym.value == kw",
  "}",
  "",
  "method acceptKeyword (kw1) or (kw2) {",
  "    if (sym.kind != \"keyword\") then { return false }",
  "    if (sym.value == kw1) then { return true }",
  "    return sym.value == kw2",
  "}",
  "",
  "method acceptSameLine (t) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line (either because it's on the same physical line, or because",
  "    // it's on an indented continuation line).",
  "",
  "    (sym.kind == t) && ",
  "        ((lastLine == sym.line) || (sym.indent > lastIndent))",
  "}",
  "method acceptWithoutSpaces (t) {",
  "    // True if the current token is a t, and follows the previous token",
  "    // without any intervening spaces or continuation lines.",
  "",
  "    (sym.kind == t) && ",
  "        (lastLine == sym.line) && (sym.linePos == (lastToken.linePos + lastToken.size))",
  "}",
  "method accept (t) onLineOf (other) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line as other (either because it's on the same physical",
  "    // line, or because it's on an indented continuation line).",
  "    (sym.kind == t) && ((other.line == sym.line) ||",
  "        (sym.indent > other.indent))",
  "}",
  "method accept (t) onLineOfLastOr (other) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line as the last token, or the other token.",
  "    if (sym.kind != t) then { return false }",
  "    if (lastLine == sym.line) then { return true }",
  "    if (sym.indent > lastIndent) then { return true }  // continuation last",
  "    if (other.line == sym.line) then { return true }",
  "    if (sym.indent > other.indent) then { return true }      // continuation of other",
  "    return false",
  "}",
  "method acceptArgumentOnLineOf(tok) {",
  "    // True if the current token can start an argument to a request",
  "    if (accept \"string\" onLineOf(tok)) then { return true }",
  "    if (accept \"num\" onLineOf(tok)) then { return true }",
  "    if (accept \"lbrace\" onLineOf(tok)) then { return true }",
  "    if (accept \"lsquare\" onLineOf(tok)) then { return true }",
  "    if (accept \"identifier\" onLineOf(tok)) then { ",
  "        return (sym.value == \"true\") || (sym.value == \"false\")",
  "    }",
  "    return false",
  "}",
  "method tokenOnSameLine {",
  "    // returns true if there is a token on the current logical line",
  "    (lastLine == sym.line) || (sym.indent > lastIndent)",
  "}",
  "method tokenOnLineOfLastOr (other) {",
  "    // returns true if there is a token on the current logical line, or one",
  "    // the same line as `other`",
  "    if (lastLine == sym.line) then { return true }",
  "    if (sym.indent > lastIndent) then { return true }   // continuation of last",
  "    if (other.line == sym.line) then { return true }",
  "    if (sym.indent > other.indent) then { return true } // continuation of other",
  "    return false",
  "}",
  "method didConsume (aParsingBlock) {",
  "    // returns true if executing aParsingBlock consumes at least one token.",
  "    def sz = tokens.size",
  "    aParsingBlock.apply",
  "    tokens.size != sz",
  "}",
  "method didNotConsume (aParsingBlock) {",
  "    // returns true if executing aParsingBlock fails to consume any tokens.",
  "    def sz = tokens.size",
  "    aParsingBlock.apply",
  "    tokens.size == sz",
  "}",
  "method pushnum {",
  "    // Push the current token onto the output stack as a number",
  "    var o := ast.numNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "method pushstring {",
  "    // Push the current token onto the output stack as a string",
  "    var o := ast.stringNode.new(sym.value)",
  "    o.end := ast.line (sym.line) column (sym.endPos)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an identifier.",
  "// false means that this identifier has not been assigned a dtype (yet).",
  "method pushidentifier {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    def o = if (sym.value == \"_\") then {",
  "        ast.identifierNode.wildcard(false)",
  "    } else {",
  "        ast.identifierNode.new(sym.value, false)",
  "    }",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "method checkAnnotation(ann) {",
  "    if (ann.kind == \"call\") then {",
  "        for (ann.parts) do {p->",
  "            for (p.args) do {a->",
  "                if ((a.kind == \"identifier\") && {false != a.dtype}) then {",
  "                    var tok := sym",
  "                    // Look back from the current token to try and find the tokens that cause this error.",
  "                    while {tok.value != \":\"} do { tok := tok.prev }",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(tok, tok.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"an argument to an annotation cannot have a type.\")",
  "                          atRange(tok.line, tok.linePos, tok.next.endPos)",
  "                          withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    ann",
  "}",
  "method doannotation {",
  "    if (acceptKeyword \"is\" .not) then {",
  "        return false",
  "    }",
  "    next",
  "    def anns = [ ]",
  "    if (didNotConsume {expression(noBlocks)}) then {",
  "        errorMissingAnnotation",
  "    }",
  "    while {accept(\"comma\")} do {",
  "        anns.push(checkAnnotation(values.pop))",
  "        next",
  "        if (didNotConsume {expression(noBlocks)}) then {",
  "            errorMissingAnnotation",
  "        }",
  "    }",
  "    anns.push(checkAnnotation(values.pop))",
  "    anns",
  "}",
  "",
  "method errorMissingAnnotation {",
  "    def suggestions = [ ]",
  "    var suggestion := errormessages.suggestion.new",
  "    def nextTok = findNextValidToken( [\"bind\"] )",
  "    if (nextTok == sym) then {",
  "        suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "    } else {",
  "        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "    }",
  "    suggestions.push(suggestion)",
  "    suggestion := errormessages.suggestion.new",
  "    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "    suggestions.push(suggestion)",
  "    errormessages.syntaxError(\"one or more annotations separated by commas must follow 'is'.\")",
  "        atRange(lastToken.line, lastToken.linePos, lastToken.endPos)",
  "        withSuggestions(suggestions)",
  "}",
  "",
  "method dotypeterm {",
  "    if (accept \"identifier\") then {",
  "        pushidentifier",
  "        generic",
  "        dotrest(noBlocks)",
  "    } else {",
  "        if (acceptKeyword \"type\" or \"interface\") then {",
  "            dotypeLiteral",
  "        }",
  "    }",
  "}",
  "",
  "method typeexpression {",
  "    var sz := values.size",
  "    if (accept \"lparen\") then {",
  "        def prevStatementToken = statementToken",
  "        statementToken := sym",
  "        next",
  "        if (didNotConsume {typeexpression}) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«type expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev) leading (true)",
  "                    trailing(false) with \"«type expression»\"",
  "            }",
  "            errormessages.syntaxError \"parentheses must contain a valid type expression.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        if (sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError \"a type expression beginning with a '(' must end with a ')'.\"",
  "                atRange(lastToken.line, lastToken.linePos, lastToken.endPos)",
  "                withSuggestion(suggestion)",
  "        }",
  "        statementToken := prevStatementToken",
  "        next",
  "    } else {",
  "        dotypeterm",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(noBlocks)",
  "        typeexpressionrest",
  "    }",
  "    // TODO: check that the expression doesn't contain requests or var references.",
  "    // This has to happen in the identifier resolution phase.",
  "}",
  "",
  "method newIf(cond, thenList, elseList) {",
  "    def thenBlock = ast.blockNode.new(emptySequence, thenList)",
  "    def elseBlock = ast.blockNode.new(emptySequence, elseList)",
  "    ast.ifNode.new(cond, thenBlock, elseBlock)",
  "}",
  "",
  "method reportSyntaxError(message) before (expectedTokens) {",
  "    def suggestions = [ ]",
  "    var suggestion := errormessages.suggestion.new",
  "    def nextTok = findNextValidToken (expectedTokens)",
  "    if (nextTok == sym) then {",
  "        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "    } else {",
  "        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "    }",
  "    suggestions.push(suggestion)",
  "    suggestion := errormessages.suggestion.new",
  "    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "    suggestions.push(suggestion)",
  "    errormessages.syntaxError(message)",
  "        atPosition(sym.line, sym.linePos)",
  "        withSuggestions(suggestions)",
  "}",
  "",
  "method reportMissingArrow {",
  "    def suggestion = errormessages.suggestion.new",
  "    if ((sym.kind == \"bind\") || (sym.value == \"=\")) then {",
  "        suggestion.replaceToken(sym)with(\"->\")",
  "    } else {",
  "        suggestion.insert(\" ->\")afterToken(lastToken)",
  "    }",
  "    errormessages.syntaxError(\"in a block with parameters, the parameters must be followed by '->'\")",
  "        atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "}",
  "",
  "method reportBadRhs {",
  "    // a bind symbol := was not followed by a valid expression.",
  "",
  "    def suggestions = [ ]",
  "    var suggestion := errormessages.suggestion.new",
  "    def nextTok = findNextValidToken( [\"rbrace\"] )",
  "    if (nextTok == sym) then {",
  "        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "    } else {",
  "        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "    }",
  "    suggestions.push(suggestion)",
  "    suggestion := errormessages.suggestion.new",
  "    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "    suggestions.push(suggestion)",
  "    errormessages.syntaxError(\"a valid expression must follow ':='.\")",
  "        atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "}",
  "",
  "method block {",
  "    // Parses a block.  Since a block is (a) treated as a statement, and",
  "    // (b) may have statements inside, we save and restore the setting of the",
  "    // global variables relevant to the statement context.",
  "",
  "    if (accept \"lbrace\") then {",
  "        def btok = sym",
  "        next",
  "        def oldMinIndent = minIndentLevel",
  "        def minInd = statementIndent + 2",
  "        def oldStatementToken = statementToken",
  "        def oldStatementIndent = statementIndent",
  "        statementToken := sym",
  "        var isMatchingBlock := false",
  "",
  "        // a block may start with or without parameters.  We assume that",
  "        // parameters are present, parse the first expression, and then check.",
  "        // If it wasn't a parameter, we back-up the parse position.",
  "        def savedPosition = saveParsePosition",
  "        def params = blockParameters",
  "        if (params.isEmpty) then {",
  "            restoreParsePosition(savedPosition)",
  "        }",
  "",
  "        def blockNode = blockBody (params) beginningWith (btok)",
  "        values.push(blockNode)",
  "        minIndentLevel := oldMinIndent",
  "        statementIndent := oldStatementIndent",
  "        statementToken := oldStatementToken",
  "    }",
  "}",
  "",
  "method blockParameters {",
  "    // parse all the parameters of this block, and return them as a",
  "    // collection of identifier nodes.",
  "    def params = [ ]",
  "    while {blockParameter(params)} do {",
  "        if (accept \"arrow\") then {",
  "            next",
  "            return params",
  "        }",
  "        if (accept \"comma\") then {",
  "            next",
  "        } else {",
  "            reportMissingArrow",
  "        }",
  "    }",
  "    return params",
  "}",
  "",
  "method blockParameter(params) -> Boolean {",
  "    // parse one parameter, if possible, push it onto params, and",
  "    // return true. If the next expression is not a parameter, return false.",
  "",
  "    var paramIsPattern := sym.kind == \"lparen\"",
  "    // Parsing the expression ‹(a)› will return an identifierNode‹a› .",
  "    // Checking for a paren lets us distinguish parameter from pattern.",
  "    if (didConsume {expression(blocksOK)}) then {",
  "        if (accept \"comma\" || accept \"arrow\" || accept \"colon\") then {",
  "            // we have found a parameter",
  "            var thisParam := values.pop",
  "            if (paramIsPattern || thisParam.isIdentifier.not) then {",
  "                paramIsPattern := true",
  "                thisParam := ast.identifierNode.wildcard(thisParam)",
  "                    // put the pattern in the type field",
  "            }",
  "            thisParam.isBindingOccurrence := true",
  "            if (paramIsPattern && accept \"colon\") then {",
  "                reportSyntaxError(\"a block parameter that's an  expression is assumed to mean \" ++",
  "                      \"_:‹expression›, and so cannot be followed by a colon\")",
  "                      before [\"arrow\", \"comma\"]",
  "            }",
  "            if (accept \"colon\") then {",
  "                // We allow an expression for v: <PatternExpression>",
  "                next",
  "                if (didConsume {expression(blocksOK)} .not) then {",
  "                    reportSyntaxError \"a block parameter must have a pattern or type expression after the ':'.\" before [\"arrow\", \"rbrace\"]",
  "                }",
  "                thisParam.dtype := values.pop",
  "            }",
  "            params.push(thisParam)",
  "            return true",
  "        } else {",
  "            // we just parsed the first expression in the block",
  "            return false",
  "        }",
  "    } else {",
  "        return false    // we didn't parse anything",
  "    }",
  "}",
  "",
  "method blockBody(params) beginningWith (btok) {",
  "    // returns a block AST node.",
  "",
  "    def originalValues = values",
  "    values := []",
  "    if (sym.line == lastToken.line) then {",
  "        indentFreePass := true",
  "    }",
  "    while {accept \"rbrace\".not} do {",
  "        // Take the body of the block",
  "        if (didNotConsume {statement}) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert \"}\" afterToken (lastToken)",
  "            errormessages.syntaxError \"a block must end with a '}'.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "    }",
  "    next",
  "    def body = values",
  "    values := originalValues",
  "    return ast.blockNode.new(params, body).setPositionFrom(btok)",
  "}",
  "",
  "",
  "// Accept an \"if\" statement. This is a special syntactic case, rather",
  "// than just a call with a multi-part method name - it might be possible",
  "// to change that and compensate later on.",
  "method doif {",
  "    if (accept(\"identifier\") && (sym.value == \"if\")) then {",
  "        def btok = sym",
  "        def minStartColumn = sym.indent + 3",
  "            // if the `if` has indent 0, then `then`, `else` etc. must",
  "            // start in column 3 or more.",
  "        next",
  "        def opener = if ((sym.kind == \"lparen\") || {sym.kind == \"lbrace\"})",
  "                        then { sym.value } else { \"-missing-\" }",
  "        def closer = if (opener == \"(\") then { \")\" }",
  "                        else { if (opener == \"\\{\") then { \"\\}\" } else { \"-nothing-\" } }",
  "        if (opener == \"-missing-\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen or then.",
  "            def nextTok = findNextToken({ t -> (t.line == btok.line)",
  "                && ((t.kind == \"rparen\") || (t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" («condition») then \\{\")afterToken(btok)",
  "            } elseif { nextTok.kind == \"rparen\" } then {",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"(«condition»\")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                }",
  "            } elseif { nextTok.kind == \"lbrace\" } then {",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\" («condition») then\")afterToken(btok)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            } elseif { nextTok.kind == \"identifier\" } then {",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"(«condition») \")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"an if statement must have a condition \" ++",
  "                \"in parentheses or braces after the 'if'.\")",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (didNotConsume {expression(blocksOK)}) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen.",
  "            var nextTok := findNextToken({ t -> (t.line == lastToken.line) && (t.kind == \"rparen\") })",
  "            if (false == nextTok) then {",
  "                nextTok := findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"an if statement must have a \" ++",
  "                      \"condition in parentheses or braces after the 'if'.\")",
  "                      atPosition(sym.line, sym.linePos)",
  "                      withSuggestion(suggestion)",
  "            } else {",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"an if statement must have a \" ++",
  "                        \"condition in parentheses or braces after the 'if'.\")",
  "                        atPosition(sym.line, sym.linePos)",
  "                        withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                        leading(false)trailing(true)with(\"«expression»\")",
  "                    errormessages.syntaxError(\"an if statement must have a \" ++",
  "                        \"condition in parentheses or braces after the 'if'.\")",
  "                        atRange(sym.line, sym.linePos, nextTok.linePos - 1)",
  "                        withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if (sym.value != closer) then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a \"++",
  "                  \"'{opener}' must end with a '{closer}'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var cond := values.pop",
  "        var body := []",
  "",
  "        var elseblock := []",
  "        var curelse := elseblock",
  "            // These two variables are for else/elseif handling. An 'elseif' is",
  "            // turned into nested 'if' statements for the AST; `curelse` points",
  "            // to the most deeply-nested of those (where any eventual \"else\"",
  "            // blocks will go). `elseblock` contains the statements of the",
  "            // top-level 'else' block --- if there are any 'elseif's, that top-",
  "            // level 'else' will comprise just one statement: another if.",
  "        var v",
  "        def localMin = minIndentLevel",
  "        def localStatementIndent = statementIndent",
  "        var minInd := statementIndent + 2",
  "        if (accept(\"identifier\") && (sym.value == \"then\")) then {",
  "            if (sym.linePos < minStartColumn) then {",
  "                errormessages.syntaxError(\"the 'then' part of an \" ++",
  "                    \"'if(_)then(_)…' must be indented more than the 'if'\")",
  "                    atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "            }",
  "            next",
  "            if (sym.kind != \"lbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if (closingBrace.found.not) then {",
  "                    if (closingBrace.tok == lastToken) then {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"an if statement must have a '\\{' after the 'then'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            if (sym.line == lastToken.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := minInd",
  "            }",
  "            while {(accept(\"rbrace\")).not} do {",
  "                if (didNotConsume {statement}) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, false)",
  "                    if (closingBrace.found.not) then {",
  "                        if (closingBrace.tok == lastToken) then {",
  "                            suggestion.insert(\"}\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        }",
  "                    }",
  "                    suggestion.deleteToken(sym)",
  "                    errormessages.syntaxError(\"an if statement must end with a '}'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                v := values.pop",
  "                body.push(v)",
  "            }",
  "            next",
  "            var econd",
  "            var eif",
  "            var newelse",
  "            var ebody",
  "            while {accept(\"identifier\") && (sym.value == \"elseif\")} do {",
  "                // Currently, the parser just accepts arbitrarily many",
  "                // \"elseifs\", turning them into ifs inside the else.",
  "                // TODO: allow blocks after elseif to contain a sequence of expressions.",
  "                if (sym.linePos < minStartColumn) then {",
  "                    errormessages.syntaxError(\"the 'elseif' part of an \" ++",
  "                        \"'if(_)then(_)…elseif(_)' must be indented more than the 'if'\")",
  "                        atRange(sym.line, sym.linePos, sym.linePos + 5)",
  "                }",
  "                statementToken := sym",
  "                next",
  "                if (sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rbrace or then.",
  "                    def nextTok = findNextToken({ t -> (t.line == statementToken.line)",
  "                        && ((t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                        || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "                    if (false == nextTok) then {",
  "                        suggestion.insert(\" \\{ «expression» \\} then \\{\")afterToken(statementToken)",
  "                    } elseif { nextTok.kind == \"rbrace\" } then {",
  "                        if (nextTok == sym) then {",
  "                            suggestion.insert(\"\\{ «expression» \\}\")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"\\{ \")beforeToken(sym)",
  "                        }",
  "                    } elseif { nextTok.kind == \"lbrace\" } then {",
  "                        if (nextTok == sym) then {",
  "                            suggestion.insert(\" \\{ «expression» \\} then\")afterToken(statementToken)",
  "                        } else {",
  "                            suggestion.insert(\"\\{ \")beforeToken(sym)",
  "                            suggestion.insert(\" \\} then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    } elseif { nextTok.kind == \"identifier\" } then {",
  "                        if (nextTok == sym) then {",
  "                            suggestion.insert(\"\\{ «expression» \\} \")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"\\{ \")beforeToken(sym)",
  "                            suggestion.insert(\" \\}\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have a \" ++",
  "                          \"condition in braces after the 'elseif'.\")",
  "                          atPosition(sym.line, sym.linePos)",
  "                          withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if (didNotConsume {expression(blocksOK)}) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rbrace or then.",
  "                    var nextTok := findNextToken({ t -> (t.line == lastToken.line) && ",
  "                        (t.kind == \"rbrace\")})",
  "                    if (false == nextTok) then {",
  "                        nextTok := findNextValidToken( [\"rbrace\"] )",
  "                        if (nextTok == sym) then {",
  "                            suggestion.insert(\"«expression» \\} then \\{\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression» \\} then \\{\")",
  "                        }",
  "                        errormessages.syntaxError(\"an elseif clause must have an expression in braces after the 'elseif'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    } else {",
  "                        if (nextTok == sym) then {",
  "                            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                            errormessages.syntaxError(\"an elseif clause must have an expression in braces after the 'elseif'.\")atPosition(",
  "                                sym.line, sym.linePos)withSuggestion(suggestion)",
  "                        } else {",
  "                            //checkInvalidExpression",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                            errormessages.syntaxError(\"(4) an elseif statement must have an expression in braces after the 'elseif'.\")atRange(",
  "                                sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                }",
  "                if (sym.value != \"\\}\") then {",
  "                    checkBadOperators",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a condition beginning with a \" ++",
  "                        \"'\\{' must end with a '\\}'.\")",
  "                        atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestion(suggestion)",
  "                }",
  "                next",
  "                econd := values.pop",
  "                if (accept \"identifier\" && (sym.value == \"then\")) then {",
  "                    if (sym.linePos < minStartColumn) then {",
  "                        errormessages.syntaxError(\"the 'then' part of an \" ++",
  "                            \"'if(_)…elseif(_)then(_)' must be indented more than the 'if'\")",
  "                            atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "                    }",
  "                    next",
  "                    ebody := []",
  "                } else {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if (sym.kind == \"lbrace\") then {",
  "                        def closingBrace = findClosingBrace(statementToken, false)",
  "                        if (closingBrace.found.not) then {",
  "                            if (closingBrace.tok == sym) then {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                            } else {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        }",
  "                    } else {",
  "                        def closingBrace = findClosingBrace(statementToken, true)",
  "                        if (closingBrace.found.not) then {",
  "                            if (closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif clause must have 'then' after the expression in braces.\")",
  "                          atPosition(sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                if (sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if (closingBrace.found.not) then {",
  "                        if (closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif clause must have a '\\{' after the 'then'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if (didNotConsume {statement}) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if (closingBrace.found.not) then {",
  "                            if (closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"an 'elseif' clause must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    ebody.push(v)",
  "                }",
  "                next",
  "                newelse := []",
  "                eif := newIf(econd, ebody, newelse)",
  "                // Construct the inner \"if\" AST node, and then push it",
  "                // inside the current \"else\" block.",
  "                curelse.push(eif)",
  "                // Update curelse to point to the new, empty, nested",
  "                // else block.",
  "                curelse := newelse",
  "            }",
  "            if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "                if (sym.linePos < minStartColumn) then {",
  "                    errormessages.syntaxError(\"the 'else' part of an \" ++",
  "                        \"'if(_)then(_)…else(_)' must be indented more than the 'if'\")",
  "                        atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "                }",
  "                next",
  "                if (sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if (closingBrace.found.not) then {",
  "                        if (closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"an else clause must start with a '\\{' after the 'else'.\")",
  "                          atPosition(lastToken.line, lastToken.linePos + lastToken.size - 1)",
  "                          withSuggestion(suggestion)",
  "                }",
  "                next",
  "                // Just take all the statements and put them into",
  "                // curelse.",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if (didNotConsume {statement}) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if (closingBrace.found.not) then {",
  "                            if (sym.kind == \"eof\") then {",
  "                                errormessages.syntaxError(\"end of program \" ++",
  "                                    \"found while searching for the '}' to close \" ++",
  "                                      \"an 'else' statement.\")",
  "                                        atPosition(sym.line, sym.linePos)",
  "                            }",
  "                            if (closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"an else statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    curelse.push(v)",
  "                }",
  "                next",
  "            }",
  "            util.setPosition(btok.line, btok.linePos)",
  "            var o := newIf(cond, body, elseblock)",
  "            values.push(o)",
  "        } else {",
  "            // Raise an error here, or it will spin nastily forever.",
  "            def suggestion = errormessages.suggestion.new",
  "            if (sym.kind == \"lbrace\") then {",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if (closingBrace.found.not) then {",
  "                    if (closingBrace.tok == sym) then {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                    } else {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                }",
  "            } else {",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if (closingBrace.found.not) then {",
  "                    if (closingBrace.tok == lastToken) then {",
  "                        suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"an if statement must have 'then' after \" ++",
  "                  \"the condition in parentheses.\")",
  "                  atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        minIndentLevel := localMin",
  "        statementIndent := localStatementIndent",
  "    }",
  "}",
  "",
  "// Accept an identifier. Handle \"if\" specially by",
  "// passing it to the method above.",
  "method identifier {",
  "    if (accept \"identifier\") then {",
  "        if (sym.value == \"if\") then {",
  "            doif",
  "        } else {",
  "            pushidentifier",
  "        }",
  "    }",
  "}",
  "",
  "method prefixop {",
  "    def startIndent = minIndentLevel",
  "    if (accept \"op\") then {",
  "        var op := sym.value",
  "        next",
  "        if (accept \"lparen\") then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"parentheses must contain a valid expression.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if (sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if (didNotConsume {term}) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                if (lastToken.prev.kind == \"bind\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestion.deleteToken(lastToken.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"a prefix operator must be followed by an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "        dotrest(blocksOK)",
  "        callrest(blocksOK)",
  "        def rcvr = values.pop",
  "        def call = ast.callNode.new(rcvr,",
  "            [ ast.requestPart.request(\"prefix\" ++ op) withArgs( [] ) ] )",
  "        call.end := ast.line (lastLine) column (lastToken.endPos)",
  "        values.push(call)",
  "        minIndentLevel := startIndent",
  "    }",
  "}",
  "",
  "method generic {",
  "    if (accept \"lgeneric\") then {",
  "        def id = values.pop",
  "        def gens = [ ]",
  "        def startToken = sym",
  "        next",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            while {accept(\"dot\")} do {",
  "                next",
  "                def memberIn = values.pop",
  "                if (sym.kind != \"identifier\") then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«type name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a type name must follow the '.'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + 1)withSuggestions(suggestions)",
  "                }",
  "                identifier",
  "                def memberName = values.pop",
  "                def memberNd = ast.memberNode.new(memberName.value, memberIn)",
  "                memberNd.line := memberName.line",
  "                memberNd.linePos := memberName.linePos",
  "                values.push(memberNd)",
  "            }",
  "            generic",
  "            gens.push(values.pop)",
  "            if (accept \"comma\") then {",
  "                next",
  "            } else {",
  "                if (sym.kind != \"rgeneric\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\">\")afterToken(lastToken)",
  "                    def suggestion2 = errormessages.suggestion.new",
  "                    suggestion2.insert(\" \")beforeToken(startToken)",
  "                    def suggestions = [suggestion, suggestion2]",
  "                    errormessages.syntaxError(\"a type containing a '⟦' must end with a '⟧'.\")",
  "                          atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                          withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if (sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            def suggestion2 = errormessages.suggestion.new",
  "            suggestion2.insert(\" \")beforeToken(startToken)",
  "            def suggestions = [suggestion, suggestion2]",
  "            errormessages.syntaxError(\"a type containing a '⟦' must end with a '⟧'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestions(suggestions)",
  "        }",
  "        next",
  "        values.push(ast.genericNode.new(id, gens))",
  "    }",
  "}",
  "method trycatch {",
  "    if (!(accept \"identifier\" && {sym.value == \"try\"})) then {",
  "        return",
  "    }",
  "    def localmin = minIndentLevel",
  "    def tryTok = sym",
  "    next",
  "    if (accept \"lbrace\") then {",
  "        block",
  "    } else {",
  "        if (sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or catch.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == tryTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"catch\")) })",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" \\{}\")afterToken(tryTok)",
  "            } elseif { nextTok.kind == \"rbrace\" } then {",
  "                suggestion.insert(\" \\{\")afterToken(tryTok)",
  "            } elseif { nextTok.kind == \"rparen\" } then {",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif { nextTok.kind == \"identifier\" } then {",
  "                suggestion.insert(\" \\{\")afterToken(tryTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"a try(_)catch(_) statement must have \" ++",
  "                \"a block or an expression in parentheses after the 'try'.\")",
  "                atPosition(tryTok.line, tryTok.endPos + 1)",
  "                withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (didNotConsume {expression(blocksOK)}) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"a 'try(_)catch(_)…' statement must have \" ++",
  "                \"a block or an expression in parentheses after the 'try'.\")",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        if (sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")",
  "                atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"catch\")} do {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if (sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a 'try(_)catch(_)…' statement must have \" ++",
  "                  \"either a matching block or an expression in parentheses after the 'catch'.\")",
  "                    atPosition(sym.line, sym.linePos) withSuggestions (suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\")onLineOf(tryTok) && (sym.value == \"case\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.replaceToken(sym)with(\"catch\")",
  "        errormessages.syntaxError(\"a 'try(_)catch(_)…' statement starts with a \"",
  "                ++ \"'try', followed by zero or more 'catch' blocks; there \"",
  "                ++ \"are no 'case' blocks.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "            withSuggestion(suggestion)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a 'try(_)catch(_)…finally(_)' statement \" ++",
  "                    \"must have either a block, or an expression in parentheses, \" ++",
  "                    \"after the 'finally'.\")",
  "                    atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "            }",
  "            if (sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a try(_)catch(_)…finally(_) statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    util.setPosition(tryTok.line, tryTok.linePos)",
  "    values.push(ast.tryCatchNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method matchcase {",
  "    if (!(accept(\"identifier\") && (sym.value == \"match\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def matchTok = sym",
  "    next",
  "    if (sym.kind != \"lparen\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        // Look ahead for a rparen or case.",
  "        def nextTok = findNextToken({ t -> ((t.kind == \"rparen\") && (t.line == matchTok.line))",
  "            || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "        if (false == nextTok) then {",
  "            suggestion.insert(\"(«expression»)\")afterToken(matchTok)",
  "        } elseif { nextTok.kind == \"rparen\" } then {",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "            } else {",
  "                suggestion.insert(\"(\")beforeToken(sym)",
  "            }",
  "        } elseif { nextTok.kind == \"identifier\" } then {",
  "            suggestion.insert(\"(\")beforeToken(sym)",
  "            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "        }",
  "        errormessages.syntaxError(\"a match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            matchTok.line, matchTok.linePos + matchTok.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if (didNotConsume {expression(blocksOK)}) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextValidToken( [\"rparen\"] )",
  "        if (nextTok == sym) then {",
  "            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "        }",
  "        errormessages.syntaxError(\"a match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            sym.line, sym.linePos)withSuggestion(suggestion)",
  "    }",
  "    def matchee = values.pop",
  "    if (sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    def cases = []",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if (sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    util.setPosition(matchTok.line, matchTok.linePos)",
  "    values.push(ast.matchCaseNode.new(matchee, cases))",
  "    minIndentLevel := localmin",
  "}",
  "// Accept a term. Terms consist only of single syntactic units and",
  "// do not contain any operators or parentheses, unlike expression.",
  "method term {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept \"num\") then {",
  "        pushnum",
  "    } elseif { accept \"string\" } then {",
  "        pushstring",
  "    } elseif { accept \"identifier\" && (sym.value == \"match\") } then {",
  "        matchcase",
  "    } elseif { accept(\"identifier\") && (sym.value == \"try\") } then {",
  "        trycatch",
  "    } elseif { accept \"identifier\" } then {",
  "        identifier",
  "    } elseif { acceptKeyword \"object\" } then {",
  "        doobject",
  "    } elseif { acceptKeyword \"type\" or \"interface\" } then {",
  "        dotypeLiteral",
  "    } elseif { accept \"lbrace\" } then {",
  "        block",
  "    } elseif { accept \"lsquare\" } then {",
  "        doarray",
  "    } elseif { accept \"op\" } then {",
  "        // Prefix operator",
  "        prefixop",
  "    }",
  "}",
  "",
  "// Accept an expression. Expressions may consist of parenthesised",
  "// subexpressions or terms, which may be followed by method invocations",
  "// (dotrest), postcircumfix square brackets, the rest of a method call,",
  "// or an operator expression.",
  "method expression(acceptBlocks) {",
  "    var sz := values.size",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept \"lparen\") then {",
  "        def tmpStatementToken = statementToken",
  "        statementToken := sym",
  "        util.setPosition(sym.line, sym.linePos)",
  "        next",
  "        if (didConsume{expression(acceptBlocks)}.not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                      leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"parentheses must contain a valid expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if (sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        statementToken := tmpStatementToken",
  "        next",
  "    } else {",
  "        term",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        valueexpressionrest",
  "    }",
  "}",
  "",
  "// Calculate the precedence of an operator. In this case, only",
  "// multiplication and division have nontrivial precedence. Used in",
  "// expressionrest.",
  "method oprec(o) {",
  "    if (o == \"*\") then {",
  "        return 10",
  "    } elseif { o == \"/\" } then {",
  "        return 10",
  "    }",
  "    return 5",
  "}",
  "",
  "// Return the precedence of the operator at the top of the \"ops\" stack.",
  "method toprec(ops) {",
  "    if (ops.size > 0) then {",
  "        var o := ops.last",
  "        return oprec(o)",
  "    }",
  "    0",
  "}",
  "",
  "",
  "method typeexpressionrest {",
  "    if (acceptSameLine(\"op\")) then {",
  "        expressionrest \"type expression\" recursingWith {typeexpression} blocks (noBlocks)",
  "    }",
  "}",
  "",
  "method valueexpressionrest {",
  "    if (accept \"op\") then {",
  "        expressionrest \"expression\" recursingWith {expression(blocksOK)} blocks (blocksOK)",
  "    }",
  "}",
  "",
  "method expressionrest(name) recursingWith (recurse) blocks (acceptBlocks) {",
  "    // Process the rest of an operator expression using the shunting-yard",
  "    // algorithm. This method uses the oprec and toprec methods above to",
  "    // ensure the correct precedence, and treats all operators as",
  "    // left-associative.  It is parameterised so that it",
  "    // can be used for both type- and value- expressions.",
  "    ",
  "    def startIndent = minIndentLevel",
  "    var terms := [] // List of operands yet to be used",
  "    var ops := [] // Operator stack",
  "    var o",
  "    var o2",
  "    var tmp2",
  "    var tmp := values.pop",
  "    terms.push(tmp)",
  "    var prec",
  "    var allarith := true // Consists only of arithmetic operators",
  "    var opcount := 0",
  "    var opdtype := \"\" // The single operator being used in this expression",
  "    while {accept(\"op\")onLineOfLastOr(statementToken) && ",
  "            {sym.value != \"=\"}} do {",
  "        opcount := opcount + 1",
  "        o := sym.value",
  "        next",
  "        prec := oprec(o)",
  "        if ((o != \"*\") && (o != \"/\") && (o != \"+\") && (o != \"-\")) then {",
  "            allarith := false",
  "        }",
  "        if ((opdtype != \"\") && (opdtype != o) && (allarith.not)) then {",
  "            // If: this is not the first operator, it is not the same",
  "            // as the last operator, and the expression has not been",
  "            // entirely arithmetic, raise a syntax error.",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(sym)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken.prev)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev.prev.prev)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"an expression containing both arithmetic \" ++",
  "                  \"and non-arithmetic operators requires parentheses.\") atRange (",
  "                  lastToken.prev.prev.prev.line, lastToken.prev.prev.prev.linePos,",
  "                  lastToken.linePos) withSuggestions (suggestions)",
  "        }",
  "        opdtype := o",
  "        while {(ops.size > 0) && (prec <= toprec(ops))} do {",
  "            // Do the shunting: for as long as the current operator",
  "            // has lesser or equal precedence than the one on the",
  "            // top of the stack, take the operator off the stack and",
  "            // replace its two operands with the combined operator node.",
  "            // This corresponds to left-associative operators only.",
  "            o2 := ops.pop",
  "            tmp2 := terms.pop",
  "            tmp := terms.pop",
  "            util.setPosition(tmp.line, tmp.linePos)",
  "            tmp := ast.opNode.new(o2, tmp, tmp2)",
  "            terms.push(tmp)",
  "        }",
  "        ops.push(o)",
  "        if (accept \"lparen\") then {",
  "            // When a parenthesis is found, take an expression from",
  "            // *within* the parentheses and add it to the stack. Do",
  "            // not delegate entirely to expression, because it will",
  "            // then consume all the following operators and break",
  "            // precedence. Possibly parenthesised expressions could",
  "            // be allowed in term above?",
  "            next",
  "            if (didConsume(recurse).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\"«{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«{name}»\")",
  "                }",
  "                errormessages.syntaxError(\"parentheses must contain a valid {name}.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if (sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if (! tokenOnLineOfLastOr(statementToken)) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \" ++ util.lines.at(sym.line))afterToken(lastToken)",
  "                suggestion.deleteLine(sym.line)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a valid expression must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            if (didNotConsume {term}) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"comma\", \"rparen\", \"rsquare\", \"rbrace\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «{name}»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a valid {name} must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "",
  "        // Regardless of where the last value came from, it may have",
  "        // method invocations, indexes, or method call happening to it,",
  "        // which should be applied and the result put into the operands",
  "        // list.",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        tmp := values.pop",
  "        terms.push(tmp)",
  "    }",
  "    while {ops.size > 0} do {",
  "        // Shunt off any remaining operators at the end",
  "        o := ops.pop",
  "        tmp2 := terms.pop",
  "        tmp := terms.pop",
  "        util.setPosition(tmp.line, tmp.linePos)",
  "        tmp := ast.opNode.new(o, tmp, tmp2)",
  "        terms.push(tmp)",
  "    }",
  "    tmp := terms.pop",
  "    values.push(tmp)",
  "    if (terms.size > 0) then {",
  "        errormessages.syntaxError(\"values left on term stack.\")atPosition(sym.line, sym.linePos)",
  "    }",
  "    minIndentLevel := startIndent",
  "}",
  "",
  "method dotrest(acceptBlocks) {",
  "    // Accept a method request starting with \".\". The receiver of the request",
  "    // is assumed to be on the values stack, and will be replaced by a",
  "    // memberNode representing this request, consuming the dot and all the",
  "    // parts of a following method name and its arguments.   Any following",
  "    // dotted requests will also be parsed, by recursive invocations.",
  "",
  "    if (acceptSameLine(\"dot\")) then {",
  "        def startIndent = minIndentLevel",
  "        util.setPosition(sym.line, sym.linePos)",
  "        var lookuptarget := values.pop",
  "        next",
  "        if (accept \"identifier\") then {",
  "            util.setPosition(sym.line, sym.linePos)",
  "            def dro = ast.memberNode.new(sym.value, lookuptarget)",
  "            values.push(dro)",
  "            next",
  "            if (accept \"dot\") then {",
  "                dotrest(acceptBlocks)",
  "            } elseif { accept \"lgeneric\" } then {",
  "                dro.generics := typeArgs",
  "            }",
  "            if (accept \"lparen\" || (acceptBlocks && accept \"lbrace\") ||",
  "                  accept \"num\" || accept \"string\" || accept \"lsquare\") then {",
  "                callrest(acceptBlocks)",
  "            }",
  "        } else {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\"«method name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a field or method name must follow a '.'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        minIndentLevel := startIndent",
  "    }",
  "}",
  "",
  "method callrest(acceptBlocks) {",
  "    // Accept a method request with arguments, if they are present.",
  "    // Method requests without arguments are left as \"member\" AST nodes",
  "",
  "    // The top of the values stack may be an identifierNode, which will become",
  "    // the method name of an implicit request, or a memberNode, whose receiver",
  "    // will become the receiver of the parsed call, and whose and nameString",
  "    // will become the first part-name of the method name.  It may also",
  "    // be some other expression (such as a literal), in which case there",
  "    // can be no arguments, and there is nothing to do.",
  "    // Leaves the stack depth unchanged.",
  "",
  "    if (values.size == 0) then {",
  "        return",
  "    }",
  "    var meth := values.pop",
  "    if (meth.kind != \"identifier\") then {",
  "        if (meth.kind != \"member\") then {",
  "            values.push(meth)",
  "            return",
  "        }",
  "    }",
  "    def lnum = meth.line",
  "    def lpos = meth.linePos",
  "    var methn := meth.nameString",
  "    def argumentParts = []",
  "    def part = ast.requestPart.request(methn) withArgs [].setPositionFrom(meth)",
  "    argumentParts.push(part)",
  "    var foundArgs := false",
  "    var tok := lastToken",
  "    var genericIdents := false",
  "    def g = meth.generics",
  "        // when used to parse a value expression, generic arguments have already",
  "        // been parse and are in `meth`.  When used to parse a type expression,",
  "        // they are in the unparsed input.  This is probably a bug!",
  "    if (false == g) then {",
  "        if (acceptSameLine \"lgeneric\") then {",
  "            genericIdents := typeArgs",
  "        }",
  "    } else {",
  "        genericIdents := g",
  "    }",
  "    foundArgs := parseArgumentsFor(meth) into (part) acceptBlocks (acceptBlocks)",
  "    ",
  "    if (foundArgs) then {",
  "        def realRcvr = if (meth.isIdentifier) then {",
  "            ast.implicit.setPositionFrom(meth)",
  "        } else {",
  "            meth.receiver",
  "        }",
  "        meth := ast.callNode.new(realRcvr, argumentParts).setPositionFrom(realRcvr)",
  "",
  "        while {accept \"identifier\" onLineOfLastOr (statementToken)} do {",
  "            // parse more parts of a multi-part request",
  "            def argList = [ ]",
  "            def namePart = ast.requestPart.request(sym.value) withArgs(argList).setPositionFrom(sym)",
  "            next",
  "            def argsFound = parseArgumentsFor(meth) into (namePart) acceptBlocks (acceptBlocks)",
  "            if (argsFound.not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert \"(‹expression›)\" afterToken (lastToken)",
  "                def more = if (indentHasIncreased) then {",
  "                    \"  The indentation tells me that this is a continuation of\" ++",
  "                        \" the previous line; is that what you intended?\"",
  "                } else { \"\" }",
  "                def reqStart = ast.line (lnum) column (lpos)",
  "                def reqEnd = ast.line (lastToken.line) column (lastToken.endPos)",
  "                def reqRange = ast.start (reqStart) end (reqEnd)",
  "                errormessages.syntaxError(\"a multi-part method request must end with an argument list,\" ++",
  "                    \" either parenthesized or self-delimiting.\" ++ more)",
  "                        atRange(reqRange) withSuggestion (suggestion)",
  "            }",
  "            argumentParts.addLast(namePart)",
  "        }",
  "        meth.end := ast.line (lastLine) column (lastToken.endPos)",
  "        // we do this indside the if, because outside meth might be an",
  "        // identifierNode or a memberNode",
  "    }",
  "    meth.generics := genericIdents",
  "    values.push(meth)",
  "    dotrest(acceptBlocks)",
  "}",
  "",
  "method parseArgumentsFor(meth) into (part) acceptBlocks (acceptBlocks) {",
  "    // `meth` is a memberNode or an identifier.",
  "    // Parses the arguments for `part`, a requestPart of a method request.",
  "    // If arguments are present, adds them to `part.args` and answers true.",
  "    // Answers false if no arguments are present.",
  "",
  "",
  "    var tok := lastToken",
  "    if (acceptSameLine \"lparen\") then {",
  "        tok := sym",
  "        parenthesizedArgs(part) startingWith (tok)",
  "        true",
  "    } elseif { acceptBlocks.not && { accept \"lbrace\" onLineOf (statementToken) } } then {",
  "        false",
  "    } elseif { acceptArgumentOnLineOf (tok) } then {",
  "        tok := sym",
  "        term",
  "        part.args.push(values.pop)",
  "        true",
  "    } else {",
  "        false",
  "    }",
  "}",
  "",
  "method parenthesizedArgs(part) startingWith (tok) {",
  "    next",
  "    if (didConsume {expression(blocksOK)}) then {",
  "        while {accept \"comma\"} do {",
  "            part.args.push(values.pop)",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert \" «expression»\" afterToken (lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                        leading (true) trailing (false) with \" «expression»\"",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"an argument list must have an expression after a ','.\")",
  "                      atPosition(sym.line, sym.linePos)",
  "                      withSuggestions(suggestions)",
  "            }",
  "        }",
  "        part.args.push(values.pop)",
  "    }",
  "    if (sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        def rng = ast.start (ast.line (tok.line) column (tok.linePos))",
  "                        end (ast.line (lastToken.line) column (lastToken.linePos + lastToken.size))",
  "        errormessages.syntaxError \"an argument list beginning with a '(' must end with a ')'.\"",
  "              atRange (rng) withSuggestion (suggestion)",
  "    }",
  "    if (sym.line == part.line) then {",
  "        part.lineLength := sym.linePos - part.linePos",
  "    }",
  "    next",
  "}",
  "",
  "method typeArgs {",
  "    // Parses one or more type arguments, if present, and returns them as a list.",
  "",
  "    def args = [ ]",
  "    if (sym.kind != \"lgeneric\") then { return args }",
  "    def startToken = sym",
  "    next",
  "    while {didConsume{typeArg}} do {",
  "        args.add(values.pop)",
  "        if (sym.kind == \"comma\") then { next }",
  "    }",
  "    if (sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert \"⟦\" afterToken(lastToken)",
  "        def suggestion2 = errormessages.suggestion.new",
  "        suggestion2.insert \" \" beforeToken(startToken)",
  "        def suggestions = [suggestion, suggestion2]",
  "        errormessages.syntaxError \"a method request containing a '⟦' must have a matching '⟧'. \"",
  "              atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "              withSuggestions(suggestions)",
  "    }",
  "    next",
  "    return args",
  "}",
  "",
  "method typeArg {",
  "    // Parses a single type argument, and leaves it on the values stack.",
  "    // TODO: 'identifier' could be a dotted identifier, ",
  "    //        or perhaps a type expression?",
  "",
  "    if (accept \"identifier\") then {",
  "        identifier",
  "        if (sym.kind == \"lgeneric\") then {",
  "            values.push(ast.genericNode.new(values.pop, typeArgs))",
  "        }",
  "    } else {",
  "        dotypeLiteral",
  "    }",
  "}",
  "",
  "method errorDefNoName {",
  "    def suggestion = errormessages.suggestion.new",
  "    def nextToken = findNextToken({ t -> (t.kind == \"op\")",
  "        && (t.value == \"=\") && (t.line == sym.line)})",
  "    if (false == nextToken) then {",
  "        suggestion.insert(\" «name» =\")afterToken(lastToken)",
  "    } elseif { nextToken == sym } then {",
  "        suggestion.insert(\" «name»\")afterToken(lastToken)",
  "    } else {",
  "        suggestion.replaceTokenRange(sym, nextToken.prev)",
  "              leading(false)trailing(true)with(\"«name» \")",
  "    }",
  "    errormessages.syntaxError(\"a definition must have a name, '=', \" ++",
  "          \"and a value after the 'def'.\") atPosition(sym.line, sym.linePos)",
  "          withSuggestion(suggestion)",
  "}",
  "",
  "method errorDefNoExpression {",
  "    def suggestion = errormessages.suggestion.new",
  "    def nextTok = findNextValidToken( [ ] )",
  "    if (nextTok == sym) then {",
  "        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "    } else {",
  "        suggestion.replaceTokenRange(sym, nextTok.prev)",
  "              leading(true)trailing(false)with(\" «expression»\")",
  "    }",
  "    errormessages.syntaxError(\"a definition must have a value after the '='.\")",
  "          atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "          withSuggestion(suggestion)",
  "}",
  "",
  "method errorDefUsesAssign(defTok) {",
  "    def suggestions = [ ]",
  "    var suggestion := errormessages.suggestion.new",
  "    suggestion.replaceToken(sym)with(\"=\")",
  "    suggestions.push(suggestion)",
  "    suggestion := errormessages.suggestion.new",
  "    suggestion.replaceToken(defTok)with(\"var\")",
  "    suggestions.push(suggestion)",
  "    errormessages.syntaxError(\"a definition must use '=' instead of ':='. \" ++",
  "        \"A variable declaration uses 'var' and ':='.\")atRange(",
  "        sym.line, sym.linePos, sym.linePos + 1) withSuggestions(suggestions)",
  "}",
  "",
  "method errorDefMissingRhs(defTok) {",
  "    def suggestions = [ ]",
  "    var suggestion := errormessages.suggestion.new",
  "    suggestion.insert(\" = «expression»\")afterToken(lastToken)",
  "    suggestions.push(suggestion)",
  "    suggestion := errormessages.suggestion.new",
  "    suggestion.replaceToken(defTok)with(\"var\")",
  "    suggestions.push(suggestion)",
  "    errormessages.syntaxError(\"a definition must have '=' and a value after the name. \"",
  "        ++ \"A variable declaration does not require a value but uses 'var', not 'def'.\")",
  "        atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "}",
  "",
  "method defdec {",
  "    // Accept definition of a constant",
  "",
  "    if (acceptKeyword \"def\") then {",
  "        def startIndent = minIndentLevel",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def defTok = sym",
  "        next",
  "        if (sym.kind != \"identifier\") then {",
  "            errorDefNoName",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        var dtype := optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept(\"op\") && (sym.value == \"=\")) then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                errorDefNoExpression",
  "            }",
  "            val := values.pop",
  "        } elseif { accept \"bind\" } then {",
  "            errorDefUsesAssign(defTok)",
  "        } else {",
  "            errorDefMissingRhs(defTok)",
  "        }",
  "        util.setPosition(defTok.line, defTok.linePos)",
  "        var o := ast.defDecNode.new(name, val, dtype)",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        o.startToken := defTok",
  "        values.push(o)",
  "        reconcileComments",
  "        minIndentLevel := startIndent",
  "    }",
  "}",
  "",
  "method vardec {",
  "    // Accept a var declaration",
  "",
  "    if (acceptKeyword \"var\") then {",
  "        def startIndent = minIndentLevel",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def varTok = sym",
  "        next",
  "        if (sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"bind\")",
  "                && (t.line == sym.line)})",
  "            if ((false == nextToken) || {nextToken == sym}) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)",
  "                      leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError \"a variable declaration must have a name after the 'var'.\"",
  "                  atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept \"bind\") then {",
  "            next",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [ ] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a variable declaration must have a value after the ':='. \"",
  "                    ++ \"A variable without a value can be declared with 'var' followed only by the variable name.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            val := values.pop",
  "        } else {",
  "            if (accept(\"op\") && (sym.value == \"=\")) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)with(\":=\")",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(varTok)with(\"def\")",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.\")",
  "                    atRange(sym.line, sym.linePos, sym.linePos)",
  "                    withSuggestions(suggestions)",
  "            }",
  "        }",
  "        util.setPosition(line, pos)",
  "        def o = ast.varDecNode.new(name, val, dtype)",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        values.push(o)",
  "        reconcileComments",
  "        minIndentLevel := startIndent",
  "    }",
  "}",
  "",
  "method doarray {",
  "    // Accept a square-bracketed collection literal like [1,2,3].",
  "",
  "    if (accept \"lsquare\") then {",
  "        def lSq = sym",
  "        next",
  "        var tmp",
  "        var params := []",
  "        if (didConsume {expression(blocksOK)}) then {",
  "            while {accept(\"comma\")} do {",
  "                tmp := values.pop",
  "                params.push(tmp)",
  "                next",
  "                if (didNotConsume {expression(blocksOK)}) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rsquare\"] )",
  "                    if (nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a collection must contain zero or more expressions separated by commas.\")",
  "                        atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "                }",
  "            }",
  "            tmp := values.pop",
  "            params.push(tmp)",
  "        }",
  "        if (sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a collection beginning with a '[' must end with a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        def o = ast.arrayNode.new(params).setPositionFrom(lSq)",
  "        values.push(o)",
  "        next",
  "    }",
  "}",
  "",
  "method dodialect {",
  "    // Parses \"dialect «quoted-string»\"",
  "",
  "    if (acceptKeyword \"dialect\") then {",
  "        next",
  "        if (sym.kind != \"string\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            var errorPos",
  "            if ((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«dialect name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"a dialect statement must have the name \" ++",
  "                \"of the dialect in quotes after the word 'dialect'.\")",
  "                atPosition(lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        if (values.isEmpty) then {",
  "            def dn = ast.dialectNode.fromToken(sym)",
  "            next",
  "            moduleObject.theDialect := dn",
  "        } else {",
  "            errormessages.syntaxError(\"a dialect statement must be at the start of the module.\")",
  "                  atLine(lastToken.line)",
  "        }",
  "    }",
  "}",
  "",
  "method inheritOrUse {",
  "    // Parses \"inherit «object expression»\"",
  "",
  "    if (! accept \"keyword\") then { return }",
  "    if ((sym.value == \"inherit\") || (sym.value == \"use\")) then {",
  "        statementToken := sym",
  "        def btok = sym",
  "        checkIndent",
  "        next",
  "        if (didNotConsume {expression(noBlocks)}) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rsquare\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\" «parent»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «parent»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            var msg := \"The {btok.value} keyword must be followed by an expression that creates \"",
  "            if (btok.value == \"use\") then {",
  "                msg := msg ++ \"the trait being used.\"",
  "            } else {",
  "                msg := msg ++ \"the object being inherited.\"",
  "            }",
  "            errormessages.syntaxError(msg)",
  "                atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(btok.line, btok.linePos)",
  "        def inhNode = ast.inheritNode.new(values.pop)",
  "        if (btok.value == \"use\") then {",
  "            inhNode.isUse := true",
  "        }",
  "        while { inheritModifier(inhNode) onLineOf(btok) } do { }",
  "        values.push(inhNode)",
  "    }",
  "}",
  "",
  "method inheritModifier(node) onLineOf(startToken) {",
  "    // parse an alias or exclude modifier on an `inherit` clause",
  "    if (! accept \"keyword\" onLineOf(startToken) ) then { ",
  "        return false",
  "    }",
  "    if (sym.value == \"alias\") then { ",
  "        parseAlias(node) ",
  "    } elseif {sym.value == \"exclude\"} then {",
  "        parseExclude(node)",
  "    } else {",
  "        false",
  "    }",
  "}",
  "",
  "method parseAlias(node) {",
  "    next    // skip the alias keyword",
  "    def newMeth = methodsignature(true)",
  "    if (accept \"op\" && (sym.value == \"=\")) then {",
  "        next",
  "        def oldMeth = methodsignature(true).appliedOccurence",
  "        if (newMeth.numParams ≠ oldMeth.numParams) then {",
  "            errormessages.syntaxError \"a method and its alias must have the same number of parameters\"",
  "                atRange (newMeth.line, newMeth.linePos, oldMeth.endPos)",
  "        }",
  "        node.addAlias (newMeth.asIdentifier) for (oldMeth.asIdentifier)",
  "    } else {",
  "        errormessages.syntaxError (\"an alias modifier must take the form \" ++",
  "            \"'‹newMethodName› = ‹oldMethodName›'\")",
  "            atPosition (lastToken.line, lastToken.linePos + lastToken.size)",
  "    }",
  "    return true",
  "}",
  "method parseExclude(node) {",
  "    next    // skip the exclude keyword",
  "    def excludedMeth = methodsignature(true).appliedOccurence",
  "    node.addExclusion (excludedMeth.asIdentifier)",
  "    return true",
  "}",
  "",
  "method doobject {",
  "    // Parse an object constructor.",
  "    // this method is called doobject because \"object\" is a keyword",
  "",
  "    if (acceptKeyword \"object\") then {",
  "        next",
  "        parseObjectConstructorBody \"an object constructor\" ",
  "            startingWith (lastToken) after \"'object'\"",
  "    }",
  "}",
  "",
  "method parseObjectConstructorBody(constructName) startingWith (btok) after (prev) {",
  "    // Parse the body of an object constructor, leaving the node on the",
  "    // values stack.  Common code for parsing object and class",
  "    // bodies; constructName says which, so that error messages are correct.",
  "    // btok is the keyword token that started the construct: class, object, or trait.",
  "    def localMinIndentLevel = minIndentLevel",
  "    def anns = doannotation",
  "    if (sym.kind != \"lbrace\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextToken { t -> t.kind == \"rbrace\" }",
  "        if (false == nextTok) then {",
  "            suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.insert(\" \\{\")afterToken(lastToken)",
  "        }",
  "        errormessages.syntaxError \"{constructName} must have a '\\{' after the {prev}.\"",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "            withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if (sym.line == statementToken.line) then {",
  "        minIndentLevel := sym.linePos - 2",
  "    } else {",
  "        minIndentLevel := statementToken.indent + 2",
  "    }",
  "    def originalValues = values",
  "    values := []",
  "    var superObject := false",
  "    def usedTraits = []",
  "    var inPreamble := true  // => processing inherit and use statements",
  "    while {(accept(\"rbrace\")).not && {sym.kind != \"eof\"}} do {",
  "        pushComments",
  "        if (didConsume {inheritOrUse}) then {",
  "            def parentNode = values.pop",
  "            if (inPreamble) then {",
  "                if (parentNode.isUse) then {",
  "                    usedTraits.add(parentNode)",
  "                } elseif { usedTraits.isEmpty } then {",
  "                    superObject := parentNode",
  "                } else {",
  "                    errormessages.syntaxError(\"'inherit' must come \" ++",
  "                        \"before 'use' in {constructName}\")",
  "                        atRange(parentNode.line, parentNode.linePos,",
  "                        parentNode.linePos + 7)",
  "                }",
  "            } else {",
  "                errormessages.syntaxError(\"'{parentNode.statementName}' must \" ++",
  "                    \"come at the start of {constructName}\")",
  "                    atRange(parentNode.line, parentNode.linePos,",
  "                            parentNode.linePos + parentNode.statementName.size)",
  "            }",
  "        } elseif { didConsume {methoddec} } then {",
  "            inPreamble := false",
  "        } elseif { didConsume {statement} } then {",
  "            inPreamble := false",
  "        } else {",
  "            errormessages.syntaxError(\"unexpected symbol '{sym.value}' in body \" ++",
  "                \"of of {constructName}\")",
  "                atRange(sym.line, sym.linePos, sym.endPos)",
  "        }",
  "    }",
  "    def body = values",
  "    values := originalValues",
  "    next",
  "    def objNode = ast.objectNode.new(body, superObject).setPositionFrom(btok)",
  "    if (false != anns) then { objNode.annotations.addAll(anns) }",
  "    objNode.usedTraits := usedTraits",
  "    values.push(objNode)",
  "    minIndentLevel := localMinIndentLevel",
  "}",
  "",
  "method doclass {",
  "    // Accepts a class declaration.",
  "    // Class declarations were formerly of the form:",
  "    //",
  "    //   class objName.methodName (param1, param2) {",
  "    //     inherit <expr>",
  "    //     var x",
  "    //     method y(z) { … }",
  "    // }",
  "    // Such declarations are no longer supported, and produce an",
  "    // error message starting with \"dotted classes are no longer supported\"",
  "    //",
  "    // Classes are now of the form:",
  "    //",
  "    // class methodName (param1, param2) {",
  "    //     inherit <expr>",
  "    //     var x",
  "    //     method y(z) { … }",
  "    // }",
  "    //",
  "    // A class is compiled into a methodNode that contains",
  "    // an objectNode, i.e., it is treated as syntactic sugar for",
  "    //",
  "    // method methodName (param1, param2) {",
  "    //     object {",
  "    //         inherit <expr>",
  "    //         var x",
  "    //         method y(z) { … }",
  "    //     }",
  "    // }",
  "    //",
  "    // Arguably, this is wrong.  Perhaps the parser should create classNodes,",
  "    // which would later be removed by the AST re-writing step?",
  "    // So that syntactic-classes can be found if necessary, methodNodes",
  "    // generated by the class syntax answer true to `inClass`.",
  "",
  "    def btok = sym",
  "    next",
  "    def localMinIndentLevel = minIndentLevel",
  "    if (sym.kind != \"identifier\") then {",
  "        def suggestions = [ ]",
  "        if (sym.kind == \"lbrace\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «class name».new\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(lastToken)with(\"object\")",
  "            suggestions.push(suggestion)",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «class name».new \\{}\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "        }",
  "        errormessages.syntaxError \"a class must have a name after the keyword 'class'.\"",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "            withSuggestions(suggestions)",
  "    }",
  "    if (tokens.first.kind == \"dot\") then {",
  "        errormessages.syntaxError(\"dotted classes are no longer supported. \" ++",
  "                \"Consider using a class, or a class inside an object constructor.\")",
  "                atPosition(tokens.first.line, tokens.first.linePos)",
  "    }",
  "    def meth = methodsignature(false)",
  "    meth.setPositionFrom(btok)",
  "    parseObjectConstructorBody \"a class\" startingWith (btok) after \"method header\"",
  "    def objNode = values.pop",
  "    meth.body := [objNode]",
  "    meth.usesClassSyntax := true",
  "    meth.annotations.addAll(objNode.annotations)  // TODO: sort this out!",
  "        // In a class declaration, there is just one place for annotations.",
  "        // These might include annotations on the method (such as",
  "        // confidential), and annotations on the object (such as imutable)",
  "    objNode.name := meth.canonicalName",
  "    if (btok.value == \"class\") then {",
  "        objNode.inClass := true",
  "    } elseif { btok.value == \"trait\" } then {",
  "        objNode.inTrait := true",
  "    }",
  "    values.push(meth)",
  "    reconcileComments",
  "    minIndentLevel := localMinIndentLevel",
  "}",
  "",
  "method dofactoryMethod {",
  "    // Accept a factory method declaration",
  "    if ((acceptKeyword \"factory\") && {",
  "            tokens.first.kind == \"keyword\"} && {",
  "            tokens.first.value == \"method\"}) then {",
  "        def btok = sym",
  "        next",
  "        errormessages.syntaxError(\"the keyword combination 'factory method' is \" ++",
  "                \"no longer supported. Use 'class' instead.\")",
  "                atRange(btok.line, btok.linePos, sym.line, sym.endPos)",
  "    }",
  "}",
  "",
  "method methoddec {",
  "    // Parse a method declaration",
  "",
  "    if (acceptKeyword \"method\") then {",
  "        def btok = sym",
  "        checkIndent",
  "        statementToken := sym",
  "        next",
  "        def methNode = methodsignature(false).setPositionFrom(btok)",
  "        var localMin",
  "        def anns = doannotation",
  "        def originalValues = values",
  "        values := []",
  "        if (accept \"lbrace\") then {",
  "            next",
  "            localMin := minIndentLevel",
  "            // sym is now the first token in the method body",
  "            if (sym.line == btok.line) then {",
  "                // first statement is on the same line as `method` keyword",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := btok.indent + 2",
  "            }",
  "            while { didConsume { statement } } do { }",
  "                // The body is a sequence of statements; the method ends",
  "                // when no further statement is found.",
  "            if (sym.kind != \"rbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if (closingBrace.found.not) then {",
  "                    if (sym.kind == \"eof\") then {",
  "                        errormessages.syntaxError(\"end of program \" ++",
  "                            \"found while searching for the '}' to close \" ++",
  "                              \"a method declaration.\")",
  "                                atPosition(sym.line, sym.linePos)",
  "                    }",
  "                    if (closingBrace.tok == sym) then {",
  "                        suggestion.insert(\"}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                }",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"a method must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            minIndentLevel := localMin",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            def closingBrace = findClosingBrace(btok, true)",
  "            if (closingBrace.found.not) then {",
  "                if (closingBrace.tok == lastToken) then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "            }",
  "            errormessages.syntaxError(\"a method must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        methNode.body := values",
  "        values := originalValues",
  "        util.setline(btok.line)",
  "        if (false != anns) then { methNode.annotations.addAll(anns) }",
  "        values.push(methNode)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "",
  "method methodDecRest(tm, sameline) {",
  "    // Process the remainder of a method header. These follow",
  "    // mostly the same rules as calls, but aren't strictly enforced to be on",
  "    // a single line (because they are ended by \"{\"). ",
  "    //",
  "    // tm is a methodNode.  This method modifies tm.params in place.",
  "",
  "    var signature := tm.signature",
  "    while {(!sameline && accept(\"identifier\")) || acceptSameLine(\"identifier\")} do {",
  "        pushidentifier",
  "        def part = ast.signaturePart.partName(values.pop.nameString)",
  "        if ((accept(\"lparen\")).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"()\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"the declaration of a method with multiple \" ++",
  "                  \"parameter lists must have parentheses around each parameter list.\")",
  "                  atPosition(sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var comma := false",
  "        while {accept(\"identifier\")",
  "                || (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            if (accept \"op\") then {",
  "                next",
  "                errormessages.syntaxError(\"variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making {sym.value} an Iterable.\")",
  "                    atPosition(lastToken.line, lastToken.linePos)",
  "            }",
  "            pushidentifier",
  "            def nxt = values.pop",
  "            nxt.isBindingOccurrence := true",
  "            nxt.dtype := optionalTypeAnnotation",
  "            part.params.push(nxt)",
  "            if (accept \"comma\") then {",
  "                comma := sym",
  "                next",
  "            }",
  "        }",
  "        if (sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        signature.push(part)",
  "    }",
  "}",
  "",
  "method optionalTypeAnnotation {",
  "    // Accept a type annotation if present.",
  "    // Returns the type, or false if there is no annotation",
  "    if (accept \"colon\") then {",
  "        next",
  "        if (didConsume { typeexpression }) then {",
  "            values.pop",
  "        } else {",
  "            checkBadTypeLiteral",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } else {",
  "        false",
  "    }",
  "}",
  "",
  "method methodsignature(sameline) {",
  "    // Accept a method signature",
  "    if ((sym.kind != \"identifier\") && (sym.kind != \"op\") && (sym.kind != \"lsquare\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a method name must start with an identifier, or be an operator.\")",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestion(suggestion)",
  "    }",
  "    def startToken = sym",
  "    def part = ast.signaturePart.partName(startToken.value)",
  "    next",
  "    def result = ast.methodNode.new( [ part ], [], false)",
  "    if ((startToken.value == \"[\") && {sym.kind == \"rsquare\"}) then {",
  "        errormessages.syntaxError(\"methods named '[]' and '[]:=' are no longer part of Grace.\")",
  "            atRange(lastToken.line, lastToken.linePos, sym.linePos)",
  "    }",
  "    if (accept \"lgeneric\") then { result.typeParams := typeparameters }",
  "    if (accept \"bind\") then {",
  "        part.name := part.name ++ \":=\"",
  "        next",
  "    } elseif { accept \"op\"  && (startToken.value == \"prefix\") } then {",
  "        part.name := part.name ++ sym.value",
  "        next",
  "    }",
  "    if (accept \"lparen\") then {",
  "        def lparen = sym",
  "        next",
  "        var id",
  "        var comma := false",
  "        while {accept(\"identifier\") ||",
  "                (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            // Parse the parameter list, including optional dtype",
  "            // annotations.",
  "            if (accept \"op\") then {",
  "                next",
  "                errormessages.syntaxError(\"variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making {sym.value} an Iterable.\")",
  "                    atPosition(lastToken.line, lastToken.linePos)",
  "            }",
  "            pushidentifier",
  "            id := values.pop",
  "            id.isBindingOccurrence := true",
  "            id.dtype := optionalTypeAnnotation",
  "            part.params.push(id)",
  "            if (accept \"comma\") then {",
  "                comma := sym",
  "                next",
  "            } elseif { sym.kind != \"rparen\" } then {",
  "                if (sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if (sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == lastToken.line) })",
  "            if (false == rparen) then {",
  "                suggestion.replaceToken(lastToken)with(\")\")",
  "            } else {",
  "                suggestion.deleteToken(sym)",
  "            }",
  "            errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atRange(",
  "                lastToken.line, lastToken.linePos, lastToken.linePos)withSuggestion(suggestion)",
  "        }",
  "        if (sym.line == part.line) then {",
  "            part.lineLength := sym.linePos - part.linePos",
  "        }",
  "        next",
  "        if ((!sameline && accept(\"identifier\")) ||",
  "            acceptSameLine(\"identifier\")) then {",
  "            // The presence of an identifier here means",
  "            // a multi-part method name.",
  "            methodDecRest(result, sameline)",
  "        }",
  "    }",
  "    if (accept \"arrow\") then {",
  "        // parse the return type",
  "        next",
  "        if (didNotConsume {typeexpression} ) then {",
  "            errormessages.syntaxError(\"after an arrow, write the method's return \" ++",
  "                  \"type. If you don't want to state the return type, omit the arrow.\")",
  "                  atRange(sym.line, sym.linePos, sym.endPos)",
  "        }",
  "        result.dtype := values.pop",
  "    }",
  "    result",
  "}",
  "",
  "method typeparameters {",
  "    def openBracket = sym",
  "    next",
  "    def typeIds = [ ]",
  "    while {accept(\"identifier\")} do {",
  "        identifier",
  "        def id = values.pop",
  "        id.isBindingOccurrence := true",
  "        typeIds.push(id)",
  "        if (accept \"comma\") then {",
  "            next",
  "        }",
  "    }",
  "    typeIds.do { each -> each.isBindingOccurrence := true }",
  "    def result = ast.typeParametersNode.new(typeIds).setPositionFrom(openBracket)",
  "    if (sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert \"⟧\" afterToken (lastToken)",
  "        errormessages.syntaxError(\"a list of type parameters starting with '⟦' must end with '⟧'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    result",
  "}",
  "",
  "method doimport {",
  "    // Accept an import statement, which has the form",
  "    //      import ‹string› as ‹identifier›:‹type expression› is ‹annotation›",
  "    if (acceptKeyword \"import\") then {",
  "        def importSym = sym",
  "        next",
  "        if (sym.kind != \"string\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if ((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«module name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushstring",
  "        def p = values.pop",
  "        if ((sym.kind != \"identifier\") || (sym.value != \"as\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            if ((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.insert(\" as\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" as {p.value}\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have 'as', and an identifier after the name of the module in quotes.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (sym.kind != \"identifier\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if ((sym.kind == \"string\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"{sym.value}\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" {p.value}\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have an identifier after 'as'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        def name = values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        def o = ast.importNode.new(p.value, name, dtype).setPositionFrom(importSym)",
  "        def anns = doannotation",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method doreturn {",
  "    // Accept a return statement; 'return' is followed by an optional expression.",
  "    if (acceptKeyword \"return\") then {",
  "        def retTok = sym",
  "        next",
  "        var retval",
  "        if ((tokenOnSameLine) && {accept(\"rbrace\").not}) then {",
  "            if (didNotConsume {expression(blocksOK)}) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                if (nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                }",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError (\"a return statement must have \" ++",
  "                    \"an expression or a newline after the word 'return'.\")",
  "                    atRange (sym.line, sym.linePos, sym.endPos)",
  "                    withSuggestions (suggestions)",
  "            }",
  "            retval := values.pop",
  "        } else {",
  "            retval := ast.identifierNode.new(\"done\", false).setStart(ast.noPosition)",
  "            retval.end := ast.noPosition",
  "        }",
  "        util.setPosition(retTok.line, retTok.linePos)",
  "        var o := ast.returnNode.new(retval)",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "method domethodtype {",
  "    // parses a method in a type literal",
  "    def methodTypeTok = sym",
  "    var methNode := methodsignature(true)",
  "    var dtype := methNode.dtype",
  "    if (false == methNode.dtype) then {",
  "        dtype := ast.identifierNode.new(\"Done\", false)",
  "    }",
  "    def o = ast.methodTypeNode.new(methNode.signature, dtype)",
  "                                            .setPositionFrom(methodTypeTok)",
  "    o.typeParams := methNode.typeParams",
  "    values.push(o)",
  "    reconcileComments",
  "    if (accept \"semicolon\") then {",
  "        next",
  "    } else {",
  "        if (!accept(\"rbrace\")) then {",
  "            if (lastToken.line == sym.line) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def newLine = util.lines.at(sym.line).substringFrom(1)to(lastToken.linePos - 1) ++ sym.value",
  "                suggestion.addLine(sym.line + 0.1, newLine)",
  "                suggestion.deleteToken(sym)leading(true)trailing(true)",
  "                errormessages.syntaxError(\"methods in a type literal must be on separate lines, or separated by semicolons.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method dotypeLiteral {",
  "    // parses a type literal between braces, with optional leading",
  "    // 'type' or 'interface' keyword.",
  "    def typeLiteralTok = sym",
  "    if (acceptKeyword \"type\" or \"interface\") then {",
  "        next",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceToken(sym) with(\"\\{\")",
  "            errormessages.syntaxError \"{typeLiteralTok.value} literals must open with a brace.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "            return",
  "        }",
  "    }",
  "    if (accept \"lbrace\") then {",
  "        def meths = []",
  "        def types = []",
  "        def mc = auto_count",
  "        auto_count := auto_count + 1",
  "        next",
  "        while {accept(\"rbrace\").not} do {",
  "            if (acceptKeyword \"type\") then {",
  "                typedec",
  "                types.push(values.pop)",
  "            } else {",
  "                domethodtype",
  "                meths.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setPosition(typeLiteralTok.line, typeLiteralTok.linePos)",
  "        def t = ast.typeLiteralNode.new(meths, types)",
  "        values.push(t)",
  "    }",
  "}",
  "",
  "method typedec {",
  "    // Accept a declaration: 'type = <type expression>'",
  "    if (acceptKeyword \"type\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        next",
  "        if (sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a type declaration must have a name after the 'type'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        util.setPosition(line, pos)",
  "        def nt = ast.typeDecNode.new(values.pop, false)",
  "        if (accept \"lgeneric\") then { nt.typeParams := typeparameters }",
  "        nt.name.isBindingOccurrence := true",
  "        def anns = doannotation",
  "        if ((sym.kind != \"op\") || (sym.value != \"=\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextToken { t ->",
  "                (t.kind == \"lbrace\") || (t.kind == \"keyword\")",
  "            }",
  "            if ((false == nextTok) || {nextTok == sym}) then {",
  "                suggestion.insert(\" =\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)with(\"=\")",
  "            }",
  "            errormessages.syntaxError \"a type declaration must have an '=' after the type name.\"",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        next",
  "        // Special case for type Literals without leading 'type' keyword.",
  "        if (accept \"lbrace\") then {",
  "            dotypeLiteral",
  "        } else {",
  "            expression(noBlocks)",
  "        }",
  "        nt.value := values.pop",
  "        if (false != anns) then {",
  "            nt.annotations.addAll(anns)",
  "        }",
  "        values.push(nt)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method checkIndent {",
  "    if (indentFreePass) then {",
  "        indentFreePass := false",
  "    } elseif { sym.kind == \"semicolon\" } then {",
  "        // pass",
  "    } elseif {(sym.kind == \"rbrace\") || (sym.kind == \"rparen\")",
  "          || (sym.kind == \"rsquare\")} then {",
  "        // pass",
  "    } elseif { sym.kind == \"eof\" } then {",
  "    } elseif { sym.indent < minIndentLevel } then {",
  "        if ((sym.linePos - 1) != minIndentLevel) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            def correctIndent = \" \" * (minIndentLevel - (sym.linePos - 1))",
  "            suggestion.insert (correctIndent) atPosition 1 onLine(sym.line)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            // Find the indent level for the opening brace.",
  "            var tok := lastToken",
  "            while {(tok.linePos != (tok.indent + 1)) || (tok.indent >= minIndentLevel)} do { ",
  "                tok := tok.prev ",
  "            }",
  "            def line = (\" \" * tok.indent) ++ \"}\"",
  "            suggestion.addLine(sym.line - 0.9, line)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"the indentation for this line must be \" ++",
  "                  \"at least {minIndentLevel}. This is often caused by a missing '}'.\")",
  "                  atPosition(sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } elseif { sym.indent > minIndentLevel } then {",
  "        // The lexer rejects indentation changes of 1, so we don't",
  "        // need to check for that error here.",
  "        minIndentLevel := sym.indent",
  "    }",
  "}",
  "",
  "method statement {",
  "    // Accept a statement. A statement is any of the above that may exist",
  "    // at the top level, and includes expressions.",
  "    // A statement may also be a bind statement x := y, which creates a",
  "    // bind AST node out of the expressions on either side (which at this point",
  "    // can be any arbitrary expression).",
  "",
  "    statementIndent := sym.indent",
  "    statementToken := sym",
  "    def btok = sym",
  "    pushComments",
  "    checkIndent",
  "    if (accept \"keyword\") then {",
  "        if (sym.value == \"var\") then {",
  "            vardec",
  "        } elseif { sym.value == \"def\" } then {",
  "            defdec",
  "        } elseif { sym.value == \"import\" } then {",
  "            doimport",
  "        } elseif { sym.value == \"dialect\" } then {",
  "            dodialect",
  "        } elseif { sym.value == \"type\" } then {",
  "            typedec",
  "        } elseif { sym.value == \"class\" } then {",
  "            doclass",
  "        } elseif { sym.value == \"trait\" } then {",
  "            doclass",
  "        } elseif { sym.value == \"factory\" } then {",
  "            dofactoryMethod",
  "        } elseif { sym.value == \"return\" } then {",
  "            doreturn",
  "        } else {",
  "            expression(blocksOK)",
  "        }",
  "    } else {",
  "        if (didConsume {expression(blocksOK)}) then {",
  "            if (((values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"member\"))",
  "                && accept(\"bind\")) then {",
  "                var dest := values.pop",
  "                if (dest.kind == \"lbrace\") then {",
  "                    print \"sym = {sym}, sym.line = {sym.line}\"",
  "                    ProgrammingError.raise \"popped lbrace token while parsing statement\"",
  "                }",
  "                next",
  "                if (didNotConsume {expression(blocksOK)}) then {",
  "                    reportBadRhs",
  "                }",
  "                var val := values.pop",
  "                util.setPosition(btok.line, btok.linePos)",
  "                var o := ast.bindNode.new(dest, val)",
  "                values.push(o)",
  "            }",
  "        }",
  "    }",
  "    reconcileComments",
  "    if (accept \"eof\") then {",
  "        return true",
  "    }",
  "    if (accept \"semicolon\") then {",
  "        def oldLine = sym.line",
  "        next",
  "        if (sym.line == oldLine) then {",
  "            indentFreePass := true",
  "        }",
  "    } else {",
  "        checkUnexpectedTokenAfterStatement",
  "    }",
  "}",
  "",
  "method pushComments {",
  "    // Push a comment onto the comments stack as a commentNode. If",
  "    // there are consecutive comments following, deal with them all.",
  "    // Adjacent comments extend the first; a break of a blank line",
  "    // starts a new comment node.",
  "",
  "    if ( ! accept \"comment\" ) then { return }",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.commentNode.new(sym.value)",
  "    if ((lastToken.line == sym.line) && (lastToken.kind != \"comment\")) then {",
  "        o.isPartialLine := true",
  "    } elseif { lastToken.line < (sym.line - 1) } then {",
  "        o.isPreceededByBlankLine := true",
  "    }",
  "    comments.push(o)",
  "    while { ",
  "        previousCommentToken := sym",
  "        sym := tokens.poll",
  "        accept \"comment\"",
  "    } do {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        o := ast.commentNode.new(sym.value)",
  "        if ( comments.last.endLine == (sym.line - 1) ) then {",
  "            comments.last.extendCommentUsing(o)",
  "        } else {",
  "            comments.push(o)",
  "            if ( lastToken.line < (sym.line - 1) ) then {",
  "                o.isPreceededByBlankLine := true",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method reconcileComments {",
  "    // Should be requested after a new node that represents a \"syntactic unit\"",
  "    // to which comments can be attached is pushed onto `values`",
  "    // Finds comments associated with that node, removes them from comments",
  "    // stack, and puts them in that node's comments attribute.",
  "",
  "    pushComments",
  "    def node = if (values.isEmpty) then {",
  "        moduleObject ",
  "    } else {",
  "        values.last",
  "    }",
  "    if (node.kind == \"lbrace\") then {",
  "        // lbrace nodes are not AST nodes.  They are used to mark the stack for",
  "        // nested expressions.  Hence, no comments should be attached to them.",
  "        return",
  "    }",
  "    def oLine = node.line",
  "    def preComments = emptyList",
  "    def postComments = emptyList",
  "",
  "    var ix := comments.size",
  "    while { ix > 0 } do {",
  "        def each = comments.at(ix)",
  "        def isPostComment = (each.line == oLine) || (each.line == (oLine+1))",
  "        def isPreComment = each.isPreceededByBlankLine && (each.endLine == (oLine-1))",
  "        if (isPostComment) then {",
  "            postComments.push(comments.removeAt(ix))",
  "        } elseif { isPreComment } then {",
  "            preComments.addFirst(comments.removeAt(ix))",
  "        } elseif { each.endLine < (oLine-1) } then {",
  "            ix := 0     // exit from while",
  "        }",
  "        ix := ix - 1",
  "    }",
  "",
  "    def postSz = postComments.size",
  "    def preSz = preComments.size",
  "",
  "    if ((postSz > 1) && (preSz > 1)) then {",
  "        preComments.last.value := preComments.last.value ++ \"\\n\"",
  "    }",
  "    node.addComments(preComments)",
  "    node.addComments(postComments)",
  "}",
  "",
  "method checkBadOperators {",
  "    if (sym.value == \"=\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"=\")afterToken(sym)",
  "        errormessages.syntaxError(\"use '==' to test equality, not '='.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkBadTypeLiteral {",
  "    if (sym.kind == \"lbrace\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"type \") beforeToken(sym)",
  "        errormessages.syntaxError(\"type literals must start with the keyword 'type'.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkUnexpectedTokenAfterStatement {",
  "    if (sym.line == lastToken.line) then {",
  "        if ((sym.kind == \"op\") && (sym.value == \"=\")",
  "            && (lastToken.kind == \"identifier\")) then {",
  "            def sugg = errormessages.suggestion.new",
  "            def suggestions = [ ]",
  "            sugg.replaceToken(sym)leading(false)trailing(false)with(\":=\")",
  "            suggestions.push(sugg)",
  "            def sugg2 = errormessages.suggestion.new",
  "            sugg2.replaceToken(sym)leading(false)trailing(false)with \"==\"",
  "            suggestions.push(sugg2)",
  "            errormessages.syntaxError(\"assignment uses ':=', not '='.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestions (suggestions)",
  "        }",
  "        if (sym.kind != \"rbrace\") then {",
  "            def suggestions = [ ]",
  "            var suggestion",
  "            if ( (values.size > 0) && { (values.last.kind == \"identifier\") || { values.last.kind == \"member\" }} && { sym.kind == \"identifier\" } ) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                suggestions.push(suggestion)",
  "                if (false != sym.next) then {",
  "                    def n = sym.next",
  "                    if (n.line == sym.line) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value}\")",
  "                        suggestion.append \")\" onLine(sym.line)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                }",
  "                if (values.last.kind == \"identifier\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(false)trailing(false)with(\"\\\"{sym.value}\\\"\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "            }",
  "            def nextTok = findNextValidToken( [\"rbrace\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lastToken.line, util.lines.at(lastToken.line).substringFrom(1)to(lastToken.endPos))",
  "                def newLine = util.lines.at(sym.line).substringFrom(sym.linePos)to(util.lines.at(sym.line).size)",
  "                suggestion.addLine(lastToken.line + 0.1, newLine)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(",
  "                \"multiple statements must be separated by a newline or a semicolon. \" ++",
  "                  \"This error is often caused by unbalanced parentheses, \" ++",
  "                    \"or by omitting a part of a method name.\")",
  "                      atPosition (sym.line, sym.linePos) withSuggestions (suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "",
  "method parse(toks) {",
  "    // Parses toks, a linked list of tokens, and returns an AST moduleNode",
  "    // corresponding to it.",
  "",
  "    util.log_verbose \"parsing.\"",
  "    moduleObject := ast.moduleNode.body(values) named (util.modname)",
  "",
  "    if (toks.size == 0) then {",
  "        return moduleObject",
  "    }",
  "    tokens := toks",
  "    next",
  "",
  "    if (sym.indent > 0) then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.deleteRange(1, sym.indent) onLine(sym.line)",
  "        errormessages.syntaxError \"the first line must not be indented.\"",
  "            atRange(sym.line, 1, sym.indent)",
  "            withSuggestion(sugg)",
  "    }",
  "    var oldlength := tokens.size",
  "    while {tokens.size > 0} do {",
  "        pushComments",
  "        methoddec",
  "        pushComments",
  "        if (didConsume { inheritOrUse }) then {",
  "            def parentNode = values.pop",
  "            if (parentNode.isUse) then {",
  "                moduleObject.usedTraits.add(parentNode)",
  "            } elseif { moduleObject.usedTraits.isEmpty } then {",
  "                moduleObject.superclass := parentNode",
  "            } else {",
  "                errormessages.syntaxError(\"'inherit' must come \" ++",
  "                    \"before 'use' in a module.\")",
  "                    atRange(parentNode.line, parentNode.linePos,",
  "                    parentNode.linePos + 6)",
  "            }",
  "        }",
  "        statement",
  "        pushComments",
  "        if (tokens.size == oldlength) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.deleteToken(sym)",
  "            errormessages.syntaxError (\"invalid statement. This is often \" ++",
  "                \"caused by an extra '}', ')', or ']'.\")",
  "                atRange (sym.line, sym.linePos, sym.endPos)",
  "                withSuggestion (suggestion)",
  "        }",
  "        oldlength := tokens.size",
  "    }",
  "    statement",
  "    pushComments",
  "    return moduleObject",
  "}",
  NULL
};
Object reader_parser_outer_307(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_found_308(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_found_308(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_tok_309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_tok_309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_9777(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_9778(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_line_9779(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_parser_linePos_9780(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_parser_indent_9781(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_parser_value_9782(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_parser_size_9783(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
static Object strlit29;
static Object strlit31;
static Object strlit65;
static Object strlit73;
static Object strlit112;
static Object strlit182;
static Object strlit230;
static Object strlit263;
static Object strlit264;
static Object strlit265;
static Object strlit266;
static Object strlit267;
static Object strlit268;
static Object strlit269;
static Object strlit270;
static Object strlit276;
static ClassData objclass306;
static Object strlit323;
static Object strlit334;
static Object strlit346;
static Object strlit374;
static Object strlit385;
static Object strlit397;
static Object strlit414;
static Object strlit431;
static Object strlit462;
static Object strlit476;
static Object strlit615;
static Object strlit620;
static Object strlit625;
static Object strlit630;
static Object strlit635;
static Object strlit639;
static Object strlit646;
static Object strlit760;
static Object strlit784;
static Object strlit812;
static Object strlit822;
static Object strlit846;
static Object strlit864;
static Object strlit885;
static Object strlit924;
static Object strlit931;
static Object strlit938;
static Object strlit956;
static Object strlit967;
static Object strlit977;
static Object strlit978;
static Object strlit987;
static Object strlit1006;
static Object strlit1013;
static Object strlit1020;
static Object strlit1023;
static Object strlit1031;
static Object strlit1043;
static Object strlit1046;
static Object strlit1099;
static Object strlit1106;
static Object strlit1137;
static Object strlit1144;
static Object strlit1151;
static Object strlit1154;
static Object strlit1157;
static Object strlit1171;
static Object strlit1178;
static Object strlit1185;
static Object strlit1203;
static Object strlit1212;
static Object strlit1250;
static Object strlit1256;
static Object strlit1266;
static Object strlit1282;
static Object strlit1287;
static Object strlit1291;
static Object strlit1318;
static Object strlit1324;
static Object strlit1326;
static Object strlit1329;
static Object strlit1330;
static Object strlit1334;
static Object strlit1349;
static Object strlit1351;
static Object strlit1352;
static Object strlit1381;
static Object strlit1400;
static Object strlit1403;
static Object strlit1424;
static Object strlit1431;
static Object strlit1447;
static Object strlit1455;
static Object strlit1463;
static Object strlit1466;
static Object strlit1469;
static Object strlit1472;
static Object strlit1475;
static Object strlit1476;
static Object strlit1479;
static Object strlit1493;
static Object strlit1500;
static Object strlit1509;
static Object strlit1517;
static Object strlit1524;
static Object strlit1549;
static Object strlit1553;
static Object strlit1563;
static Object strlit1566;
static Object strlit1570;
static Object strlit1580;
static Object strlit1583;
static Object strlit1586;
static Object strlit1593;
static Object strlit1603;
static Object strlit1606;
static Object strlit1609;
static Object strlit1616;
static Object strlit1618;
static Object strlit1644;
static Object strlit1667;
static Object strlit1675;
static Object strlit1682;
static Object strlit1686;
static Object strlit1688;
static Object strlit1700;
static Object strlit1704;
static Object strlit1706;
static Object strlit1718;
static Object strlit1722;
static Object strlit1724;
static Object strlit1750;
static Object strlit1755;
static Object strlit1760;
static Object strlit1764;
static Object strlit1770;
static Object strlit1795;
static Object strlit1802;
static Object strlit1813;
static Object strlit1815;
static Object strlit1832;
static Object strlit1858;
static Object strlit1869;
static Object strlit1874;
static Object strlit1879;
static Object strlit1882;
static Object strlit1916;
static Object strlit1949;
static Object strlit1960;
static Object strlit1965;
static Object strlit1985;
static Object strlit1992;
static Object strlit2006;
static Object strlit2008;
static Object strlit2026;
static Object strlit2042;
static Object strlit2049;
static Object strlit2058;
static Object strlit2065;
static Object strlit2089;
static Object strlit2093;
static Object strlit2103;
static Object strlit2106;
static Object strlit2110;
static Object strlit2120;
static Object strlit2123;
static Object strlit2126;
static Object strlit2133;
static Object strlit2143;
static Object strlit2146;
static Object strlit2149;
static Object strlit2156;
static Object strlit2158;
static Object strlit2184;
static Object strlit2207;
static Object strlit2215;
static Object strlit2222;
static Object strlit2225;
static Object strlit2236;
static Object strlit2239;
static Object strlit2250;
static Object strlit2253;
static Object strlit2267;
static Object strlit2279;
static Object strlit2283;
static Object strlit2285;
static Object strlit2305;
static Object strlit2312;
static Object strlit2323;
static Object strlit2325;
static Object strlit2348;
static Object strlit2370;
static Object strlit2375;
static Object strlit2386;
static Object strlit2391;
static Object strlit2408;
static Object strlit2411;
static Object strlit2422;
static Object strlit2425;
static Object strlit2428;
static Object strlit2436;
static Object strlit2462;
static Object strlit2473;
static Object strlit2478;
static Object strlit2483;
static Object strlit2486;
static Object strlit2520;
static Object strlit2553;
static Object strlit2564;
static Object strlit2569;
static Object strlit2597;
static Object strlit2604;
static Object strlit2615;
static Object strlit2617;
static Object strlit2634;
static Object strlit2660;
static Object strlit2671;
static Object strlit2676;
static Object strlit2681;
static Object strlit2684;
static Object strlit2722;
static Object strlit2750;
static Object strlit2757;
static Object strlit2760;
static Object strlit2762;
static Object strlit2777;
static Object strlit2788;
static Object strlit2793;
static Object strlit2824;
static Object strlit2846;
static Object strlit2851;
static Object strlit2862;
static Object strlit2867;
static Object strlit2884;
static Object strlit2887;
static Object strlit2898;
static Object strlit2901;
static Object strlit2905;
static Object strlit2907;
static Object strlit2919;
static Object strlit2923;
static Object strlit2935;
static Object strlit2943;
static Object strlit2961;
static Object strlit2968;
static Object strlit2975;
static Object strlit2978;
static Object strlit2986;
static Object strlit2998;
static Object strlit3001;
static Object strlit3029;
static Object strlit3036;
static Object strlit3043;
static Object strlit3049;
static Object strlit3076;
static Object strlit3098;
static Object strlit3119;
static Object strlit3130;
static Object strlit3141;
static Object strlit3152;
static Object strlit3163;
static Object strlit3177;
static Object strlit3217;
static Object strlit3223;
static Object strlit3233;
static Object strlit3240;
static Object strlit3244;
static Object strlit3259;
static Object strlit3269;
static Object strlit3276;
static Object strlit3280;
static Object strlit3306;
static Object strlit3314;
static Object strlit3322;
static Object strlit3328;
static Object strlit3343;
static Object strlit3350;
static Object strlit3368;
static Object strlit3376;
static Object strlit3391;
static Object strlit3395;
static Object strlit3401;
static Object strlit3405;
static Object strlit3415;
static Object strlit3419;
static Object strlit3424;
static Object strlit3430;
static Object strlit3433;
static Object strlit3437;
static Object strlit3439;
static Object strlit3466;
static Object strlit3473;
static Object strlit3480;
static Object strlit3484;
static Object strlit3486;
static Object strlit3495;
static Object strlit3507;
static Object strlit3510;
static Object strlit3532;
static Object strlit3539;
static Object strlit3549;
static Object strlit3555;
static Object strlit3573;
static Object strlit3580;
static Object strlit3587;
static Object strlit3590;
static Object strlit3598;
static Object strlit3610;
static Object strlit3613;
static Object strlit3639;
static Object strlit3644;
static Object strlit3653;
static Object strlit3663;
static Object strlit3668;
static Object strlit3673;
static Object strlit3679;
static Object strlit3681;
static Object strlit3697;
static Object strlit3704;
static Object strlit3712;
static Object strlit3716;
static Object strlit3719;
static Object strlit3721;
static Object strlit3738;
static Object strlit3745;
static Object strlit3752;
static Object strlit3758;
static Object strlit3776;
static Object strlit3783;
static Object strlit3790;
static Object strlit3794;
static Object strlit3797;
static Object strlit3799;
static Object strlit3809;
static Object strlit3821;
static Object strlit3824;
static Object strlit3850;
static Object strlit3855;
static Object strlit3864;
static Object strlit3874;
static Object strlit3879;
static Object strlit3884;
static Object strlit3889;
static Object strlit3916;
static Object strlit3923;
static Object strlit3932;
static Object strlit3947;
static Object strlit3954;
static Object strlit3971;
static Object strlit3986;
static Object strlit3990;
static Object strlit4000;
static Object strlit4003;
static Object strlit4007;
static Object strlit4013;
static Object strlit4016;
static Object strlit4022;
static Object strlit4049;
static Object strlit4056;
static Object strlit4063;
static Object strlit4066;
static Object strlit4076;
static Object strlit4088;
static Object strlit4091;
static Object strlit4110;
static Object strlit4117;
static Object strlit4127;
static Object strlit4133;
static Object strlit4151;
static Object strlit4158;
static Object strlit4165;
static Object strlit4168;
static Object strlit4176;
static Object strlit4188;
static Object strlit4191;
static Object strlit4217;
static Object strlit4222;
static Object strlit4231;
static Object strlit4241;
static Object strlit4246;
static Object strlit4251;
static Object strlit4256;
static Object strlit4290;
static Object strlit4296;
static Object strlit4303;
static Object strlit4310;
static Object strlit4318;
static Object strlit4325;
static Object strlit4332;
static Object strlit4338;
static Object strlit4344;
static Object strlit4345;
static Object strlit4351;
static Object strlit4357;
static Object strlit4363;
static Object strlit4378;
static Object strlit4405;
static Object strlit4412;
static Object strlit4419;
static Object strlit4422;
static Object strlit4430;
static Object strlit4442;
static Object strlit4445;
static Object strlit4476;
static Object strlit4482;
static Object strlit4503;
static Object strlit4506;
static Object strlit4516;
static Object strlit4519;
static Object strlit4535;
static Object strlit4543;
static Object strlit4551;
static Object strlit4573;
static Object strlit4579;
static Object strlit4585;
static Object strlit4590;
static Object strlit4609;
static Object strlit4620;
static Object strlit4623;
static Object strlit4635;
static Object strlit4640;
static Object strlit4652;
static Object strlit4654;
static Object strlit4724;
static Object strlit4739;
static Object strlit4747;
static Object strlit4751;
static Object strlit4761;
static Object strlit4765;
static Object strlit4771;
static Object strlit4775;
static Object strlit4785;
static Object strlit4797;
static Object strlit4800;
static Object strlit4836;
static Object strlit4840;
static Object strlit4860;
static Object strlit4871;
static Object strlit4877;
static Object strlit4905;
static Object strlit4906;
static Object strlit4907;
static Object strlit4908;
static Object strlit4916;
static Object strlit4920;
static Object strlit4930;
static Object strlit4934;
static Object strlit4955;
static Object strlit4962;
static Object strlit4966;
static Object strlit5041;
static Object strlit5051;
static Object strlit5065;
static Object strlit5085;
static Object strlit5091;
static Object strlit5100;
static Object strlit5105;
static Object strlit5110;
static Object strlit5116;
static Object strlit5122;
static Object strlit5145;
static Object strlit5150;
static Object strlit5169;
static Object strlit5176;
static Object strlit5210;
static Object strlit5240;
static Object strlit5266;
static Object strlit5272;
static Object strlit5274;
static Object strlit5276;
static Object strlit5291;
static Object strlit5293;
static Object strlit5316;
static Object strlit5327;
static Object strlit5364;
static Object strlit5392;
static Object strlit5399;
static Object strlit5406;
static Object strlit5424;
static Object strlit5440;
static Object strlit5452;
static Object strlit5474;
static Object strlit5499;
static Object strlit5525;
static Object strlit5536;
static Object strlit5546;
static Object strlit5553;
static Object strlit5557;
static Object strlit5573;
static Object strlit5579;
static Object strlit5615;
static Object strlit5622;
static Object strlit5637;
static Object strlit5644;
static Object strlit5651;
static Object strlit5655;
static Object strlit5657;
static Object strlit5677;
static Object strlit5684;
static Object strlit5687;
static Object strlit5705;
static Object strlit5715;
static Object strlit5721;
static Object strlit5723;
static Object strlit5743;
static Object strlit5753;
static Object strlit5759;
static Object strlit5761;
static Object strlit5771;
static Object strlit5781;
static Object strlit5803;
static Object strlit5810;
static Object strlit5830;
static Object strlit5865;
static Object strlit5875;
static Object strlit5897;
static Object strlit5920;
static Object strlit5927;
static Object strlit5930;
static Object strlit5950;
static Object strlit5975;
static Object strlit5982;
static Object strlit6001;
static Object strlit6003;
static Object strlit6021;
static Object strlit6028;
static Object strlit6037;
static Object strlit6047;
static Object strlit6052;
static Object strlit6083;
static Object strlit6100;
static Object strlit6127;
static Object strlit6134;
static Object strlit6141;
static Object strlit6159;
static Object strlit6174;
static Object strlit6184;
static Object strlit6187;
static Object strlit6211;
static Object strlit6217;
static Object strlit6237;
static Object strlit6245;
static Object strlit6251;
static Object strlit6259;
static Object strlit6275;
static Object strlit6277;
static Object strlit6294;
static Object strlit6302;
static Object strlit6308;
static Object strlit6315;
static Object strlit6341;
static Object strlit6348;
static Object strlit6355;
static Object strlit6373;
static Object strlit6379;
static Object strlit6384;
static Object strlit6390;
static Object strlit6395;
static Object strlit6428;
static Object strlit6452;
static Object strlit6458;
static Object strlit6467;
static Object strlit6484;
static Object strlit6491;
static Object strlit6510;
static Object strlit6526;
static Object strlit6528;
static Object strlit6557;
static Object strlit6562;
static Object strlit6563;
static Object strlit6570;
static Object strlit6583;
static Object strlit6596;
static Object strlit6599;
static Object strlit6603;
static Object strlit6608;
static Object strlit6612;
static Object strlit6663;
static Object strlit6672;
static Object strlit6704;
static Object strlit6708;
static Object strlit6712;
static Object strlit6728;
static Object strlit6732;
static Object strlit6737;
static Object strlit6743;
static Object strlit6784;
static Object strlit6788;
static Object strlit6793;
static Object strlit6799;
static Object strlit6840;
static Object strlit6848;
static Object strlit6858;
static Object strlit6868;
static Object strlit6877;
static Object strlit6882;
static Object strlit6899;
static Object strlit6908;
static Object strlit6910;
static Object strlit6927;
static Object strlit6928;
static Object strlit6950;
static Object strlit6960;
static Object strlit6979;
static Object strlit6992;
static Object strlit7002;
static Object strlit7010;
static Object strlit7012;
static Object strlit7026;
static Object strlit7044;
static Object strlit7088;
static Object strlit7107;
static Object strlit7114;
static Object strlit7117;
static Object strlit7119;
static Object strlit7134;
static Object strlit7145;
static Object strlit7150;
static Object strlit7178;
static Object strlit7190;
static Object strlit7193;
static Object strlit7197;
static Object strlit7201;
static Object strlit7240;
static Object strlit7245;
static Object strlit7268;
static Object strlit7276;
static Object strlit7280;
static Object strlit7282;
static Object strlit7298;
static Object strlit7305;
static Object strlit7310;
static Object strlit7318;
static Object strlit7324;
static Object strlit7330;
static Object strlit7355;
static Object strlit7364;
static Object strlit7374;
static Object strlit7377;
static Object strlit7397;
static Object strlit7419;
static Object strlit7435;
static Object strlit7446;
static Object strlit7454;
static Object strlit7461;
static Object strlit7473;
static Object strlit7476;
static Object strlit7511;
static Object strlit7519;
static Object strlit7526;
static Object strlit7536;
static Object strlit7544;
static Object strlit7548;
static Object strlit7559;
static Object strlit7566;
static Object strlit7582;
static Object strlit7593;
static Object strlit7600;
static Object strlit7605;
static Object strlit7613;
static Object strlit7619;
static Object strlit7625;
static Object strlit7651;
static Object strlit7658;
static Object strlit7665;
static Object strlit7675;
static Object strlit7678;
static Object strlit7693;
static Object strlit7715;
static Object strlit7729;
static Object strlit7734;
static Object strlit7764;
static Object strlit7769;
static Object strlit7780;
static Object strlit7794;
static Object strlit7796;
static Object strlit7817;
static Object strlit7833;
static Object strlit7855;
static Object strlit7865;
static Object strlit7868;
static Object strlit7884;
static Object strlit7890;
static Object strlit7910;
static Object strlit7918;
static Object strlit7924;
static Object strlit7932;
static Object strlit7947;
static Object strlit7958;
static Object strlit7965;
static Object strlit7986;
static Object strlit7993;
static Object strlit7997;
static Object strlit8003;
static Object strlit8008;
static Object strlit8027;
static Object strlit8047;
static Object strlit8055;
static Object strlit8061;
static Object strlit8070;
static Object strlit8076;
static Object strlit8093;
static Object strlit8132;
static Object strlit8142;
static Object strlit8165;
static Object strlit8172;
static Object strlit8190;
static Object strlit8209;
static Object strlit8211;
static Object strlit8227;
static Object strlit8264;
static Object strlit8288;
static Object strlit8295;
static Object strlit8343;
static Object strlit8352;
static Object strlit8353;
static Object strlit8360;
static Object strlit8368;
static Object strlit8372;
static Object strlit8378;
static Object strlit8388;
static Object strlit8404;
static Object strlit8412;
static Object strlit8445;
static Object strlit8455;
static Object strlit8465;
static Object strlit8468;
static Object strlit8496;
static Object strlit8512;
static Object strlit8519;
static Object strlit8534;
static Object strlit8541;
static Object strlit8564;
static Object strlit8569;
static Object strlit8572;
static Object strlit8591;
static Object strlit8620;
static Object strlit8628;
static Object strlit8636;
static Object strlit8643;
static Object strlit8652;
static Object strlit8689;
static Object strlit8734;
static Object strlit8740;
static Object strlit8756;
static Object strlit8760;
static Object strlit8764;
static Object strlit8791;
static Object strlit8795;
static Object strlit8804;
static Object strlit8813;
static Object strlit8822;
static Object strlit8831;
static Object strlit8840;
static Object strlit8849;
static Object strlit8858;
static Object strlit8867;
static Object strlit8887;
static Object strlit8892;
static Object strlit8901;
static Object strlit8914;
static Object strlit8920;
static Object strlit8927;
static Object strlit8931;
static Object strlit8938;
static Object strlit8972;
static Object strlit8977;
static Object strlit8997;
static Object strlit9015;
static Object strlit9057;
static Object strlit9122;
static Object strlit9225;
static Object strlit9242;
static Object strlit9252;
static Object strlit9255;
static Object strlit9266;
static Object strlit9276;
static Object strlit9279;
static Object strlit9299;
static Object strlit9307;
static Object strlit9314;
static Object strlit9329;
static Object strlit9340;
static Object strlit9345;
static Object strlit9355;
static Object strlit9366;
static Object strlit9380;
static Object strlit9390;
static Object strlit9417;
static Object strlit9423;
static Object strlit9455;
static Object strlit9461;
static Object strlit9466;
static Object strlit9474;
static Object strlit9490;
static Object strlit9496;
static Object strlit9504;
static Object strlit9573;
static Object strlit9576;
static Object strlit9578;
static Object strlit9588;
static Object strlit9626;
static Object strlit9679;
static Object strlit9681;
static Object strlit9712;
static Object strlit9714;
Object module_io;
Object module_io_init();
Object module_ast;
Object module_ast_init();
Object module_util;
Object module_util_init();
Object module_errormessages;
Object module_errormessages_init();
static ClassData objclass9776;
static Object strlit9808;
static Object strlit9812;
Object meth_parser_1_next(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_lastLine = getfromclosure(closure, 3);
  Object *var_lastIndent = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4 = alloc_Float64(0);
// compiled num node returning num4 (depth = 4)
  int op_slot_right_3 = gc_frame_newslot(num4);
// starting to compile member node (depth = 4)
  int callframe6 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call7 = callmethodflags(*var_tokens, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6);
// compiled member node returning call7 (depth = 4)
  int op_slot_left_3 = gc_frame_newslot(call7);
  params[0] = num4;
  partcv[0] = 1;
  Object opresult8 = callmethod(call7, ">(1)", 1, partcv, params);
// compiled op node returning opresult8 (depth = 3)
  Object if2 = done;
  if (istrue(opresult8)) {
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call11 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe10);
// compiled member node returning call11 (depth = 4)
  *var_lastLine = call11;
  if (call11 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe13 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call14 = callmethodflags(*var_lastToken, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe13);
// compiled member node returning call14 (depth = 4)
  *var_lastIndent = call14;
  if (call14 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe16 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call17 = callmethodflags(*var_tokens, "poll", 1, partcv, params, 0);
  gc_frame_end(callframe16);
// compiled member node returning call17 (depth = 4)
  *var_sym = call17;
  if (call17 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe19 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call20 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe19);
// compiled member node returning call20 (depth = 3)
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe21 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe22 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call23 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe22);
// compiled member node returning call23 (depth = 4)
  gc_frame_newslot(call23);
// starting to compile member node (depth = 4)
  int callframe24 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call25 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe24);
// compiled member node returning call25 (depth = 4)
  gc_frame_newslot(call25);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call23;
  params[1] = call25;
  partcv[0] = 2;
  Object call26 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe21);
// compiled call node returning call26 (depth = 3)
    gc_frame_newslot(call26);
    if2 = call26;
  } else {
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe27 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit29 == NULL) {
    strlit29 = alloc_String("This is often caused by a missing '}'");
    gc_root(strlit29);
  }
// compiled string node returning strlit29 (depth = 5)
  int op_slot_right_28 = gc_frame_newslot(strlit29);
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit31 == NULL) {
    strlit31 = alloc_String("unexpectedly found the end of the input. ");
    gc_root(strlit31);
  }
// compiled string node returning strlit31 (depth = 5)
  int op_slot_left_28 = gc_frame_newslot(strlit31);
  params[0] = strlit29;
  partcv[0] = 1;
  Object opresult32 = callmethod(strlit31, "++(1)", 1, partcv, params);
// compiled op node returning opresult32 (depth = 4)
  gc_frame_newslot(opresult32);
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe33 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call34 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe33);
// compiled member node returning call34 (depth = 4)
  gc_frame_newslot(call34);
// starting to compile member node (depth = 4)
  int callframe35 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call36 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe35);
// compiled member node returning call36 (depth = 4)
  gc_frame_newslot(call36);
// call case 6: other requests
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult32;
  params[1] = call34;
  params[2] = call36;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call37 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe27);
// compiled call node returning call37 (depth = 3)
    gc_frame_newslot(call37);
    if2 = call37;
  }
// compiled if node returning if2 (depth = 2)
  gc_frame_end(frame);
  return if2;
}
Object meth_parser_49__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe50 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call51 = callmethodflags(*var_s, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe50);
// compiled member node returning call51 (depth = 5)
  *var_s = call51;
  if (call51 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_55__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_right_56 = gc_frame_newslot(*var_lastLine);
// starting to compile member node (depth = 5)
  int callframe58 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call59 = callmethodflags(*var_s, "line", 1, partcv, params, 0);
  gc_frame_end(callframe58);
// compiled member node returning call59 (depth = 5)
  int op_slot_left_56 = gc_frame_newslot(call59);
  params[0] = *var_lastLine;
  partcv[0] = 1;
  Object opresult60 = callmethod(call59, "==(1)", 1, partcv, params);
// compiled op node returning opresult60 (depth = 4)
  gc_frame_end(frame);
  return opresult60;
}
Object meth_parser_38_indentHasIncreased(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentHasIncreased");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num41 = alloc_Float64(0);
// compiled num node returning num41 (depth = 4)
  int op_slot_right_40 = gc_frame_newslot(num41);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_left_40 = gc_frame_newslot(*var_lastIndent);
  params[0] = num41;
  partcv[0] = 1;
  Object opresult43 = callmethod(*var_lastIndent, "==(1)", 1, partcv, params);
// compiled op node returning opresult43 (depth = 3)
  Object if39 = done;
  if (istrue(opresult43)) {
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool44 = alloc_Boolean(0);
// compiled identifier node returning bool44 (depth = 4)
  return bool44;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if39 = undefined;
  } else {
  }
// compiled if node returning if39 (depth = 2)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe45 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call46 = callmethodflags(*var_sym, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe45);
// compiled member node returning call46 (depth = 3)
  *var_s = call46;
  if (call46 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe47 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block48 = alloc_Block(NULL, NULL, "parser", 96);
  gc_frame_newslot(block48);
// method "_apply"
  block_savedest(block48);
  Object closure49 = createclosure(2, "_apply");
  setclosureframe(closure49, stackframe);
  addtoclosure(closure49, var_s);
  addtoclosure(closure49, selfslot);
  struct UserObject *uo49 = (struct UserObject*)block48;
  uo49->data[0] = (Object)closure49;
  Method *meth_meth_parser_49__apply = addmethod2pos(block48, "_apply", &meth_parser_49__apply, 0);
  int argcv_meth_parser_49__apply[] = {0};
  meth_meth_parser_49__apply->type = alloc_MethodType(1, argcv_meth_parser_49__apply);
  meth_meth_parser_49__apply->definitionModule = modulename;
  meth_meth_parser_49__apply->definitionLine = 183;
// compiled block node returning block48 (depth = 3)
  gc_frame_newslot(block48);
// starting to compile block node (depth = 3)
  Object block54 = alloc_Block(NULL, NULL, "parser", 96);
  gc_frame_newslot(block54);
// method "_apply"
  block_savedest(block54);
  Object closure55 = createclosure(3, "_apply");
  setclosureframe(closure55, stackframe);
  addtoclosure(closure55, var_lastLine);
  addtoclosure(closure55, var_s);
  addtoclosure(closure55, selfslot);
  struct UserObject *uo55 = (struct UserObject*)block54;
  uo55->data[0] = (Object)closure55;
  Method *meth_meth_parser_55__apply = addmethod2pos(block54, "_apply", &meth_parser_55__apply, 0);
  int argcv_meth_parser_55__apply[] = {0};
  meth_meth_parser_55__apply->type = alloc_MethodType(1, argcv_meth_parser_55__apply);
  meth_meth_parser_55__apply->definitionModule = modulename;
  meth_meth_parser_55__apply->definitionLine = 183;
// compiled block node returning block54 (depth = 3)
  gc_frame_newslot(block54);
// call case 5: prelude request
  params[0] = block48;
  params[1] = block54;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call62 = callmethodflags(prelude, "do(1)while(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe47);
// compiled call node returning call62 (depth = 2)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit65 == NULL) {
    strlit65 = alloc_String("lbrace");
    gc_root(strlit65);
  }
// compiled string node returning strlit65 (depth = 4)
  int op_slot_right_64 = gc_frame_newslot(strlit65);
// starting to compile member node (depth = 4)
  int callframe67 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call68 = callmethodflags(*var_s, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe67);
// compiled member node returning call68 (depth = 4)
  int op_slot_left_64 = gc_frame_newslot(call68);
  params[0] = strlit65;
  partcv[0] = 1;
  Object opresult69 = callmethod(call68, "==(1)", 1, partcv, params);
// compiled op node returning opresult69 (depth = 3)
  Object if63 = done;
  if (istrue(opresult69)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool70 = alloc_Boolean(0);
// compiled identifier node returning bool70 (depth = 4)
  return bool70;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if63 = undefined;
  } else {
  }
// compiled if node returning if63 (depth = 2)
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit73 == NULL) {
    strlit73 = alloc_String("comment");
    gc_root(strlit73);
  }
// compiled string node returning strlit73 (depth = 4)
  int op_slot_right_72 = gc_frame_newslot(strlit73);
// starting to compile member node (depth = 4)
  int callframe75 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call76 = callmethodflags(*var_s, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe75);
// compiled member node returning call76 (depth = 4)
  int op_slot_left_72 = gc_frame_newslot(call76);
  params[0] = strlit73;
  partcv[0] = 1;
  Object opresult77 = callmethod(call76, "==(1)", 1, partcv, params);
// compiled op node returning opresult77 (depth = 3)
  Object if71 = done;
  if (istrue(opresult77)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool78 = alloc_Boolean(0);
// compiled identifier node returning bool78 (depth = 4)
  return bool78;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if71 = undefined;
  } else {
  }
// compiled if node returning if71 (depth = 2)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_79 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
  int callframe81 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call82 = callmethodflags(*var_s, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe81);
// compiled member node returning call82 (depth = 4)
  int op_slot_left_79 = gc_frame_newslot(call82);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult83 = callmethod(call82, "<(1)", 1, partcv, params);
// compiled op node returning opresult83 (depth = 3)
  return opresult83;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_84_saveParsePosition(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "saveParsePosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_lexerState = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lexerState");
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe85 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  partcv[0] = 0;
  Object call86 = callmethodflags(*var_tokens, "savePosition", 1, partcv, params, 0);
  gc_frame_end(callframe85);
// compiled member node returning call86 (depth = 3)
  *var_lexerState = call86;
  if (call86 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile array node (depth = 3)
  Object array87 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lexerState (depth = 4)
  params[0] = *var_lexerState;
  partcv[0] = 1;
  callmethodflags(array87, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile member node (depth = 4)
  int callframe88 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call89 = callmethodflags(*var_values, "size", 1, partcv, params, 0);
  gc_frame_end(callframe88);
// compiled member node returning call89 (depth = 4)
  params[0] = call89;
  partcv[0] = 1;
  callmethodflags(array87, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array87 (depth = 3)
  return array87;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_118__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_oldValueStackSize = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe120 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call121 = callmethodflags(*var_values, "size", 1, partcv, params, 0);
  gc_frame_end(callframe120);
// compiled member node returning call121 (depth = 5)
  int op_slot_right_119 = gc_frame_newslot(call121);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldValueStackSize (depth = 5)
  int op_slot_left_119 = gc_frame_newslot(*var_oldValueStackSize);
  params[0] = call121;
  partcv[0] = 1;
  Object opresult123 = callmethod(*var_oldValueStackSize, "≠(1)", 1, partcv, params);
// compiled op node returning opresult123 (depth = 4)
  gc_frame_end(frame);
  return opresult123;
}
Object meth_parser_126__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 4)
  int callframe127 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call128 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe127);
// compiled member node returning call128 (depth = 4)
  gc_frame_end(frame);
  return call128;
}
Object meth_parser_90_restoreParsePosition_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "restoreParsePosition(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method restoreParsePosition(_)");
  Object params[2];
  int partcv[2];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for restoreParsePosition(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_saved = &(stackframe->slots[0]);
  *var_saved = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part restoreParsePosition(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_oldValueStackSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oldValueStackSize");
// definebindings:
// definebindings:
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe91 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe92 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_saved (depth = 4)
  partcv[0] = 0;
  Object call93 = callmethodflags(*var_saved, "first", 1, partcv, params, 0);
  gc_frame_end(callframe92);
// compiled member node returning call93 (depth = 3)
  gc_frame_newslot(call93);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  params[0] = call93;
  partcv[0] = 1;
  Object call94 = callmethodflags(*var_tokens, "restorePosition(1)", 1, partcv, params, 0);
  gc_frame_end(callframe91);
// compiled call node returning call94 (depth = 2)
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe95 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe96 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call97 = callmethodflags(*var_tokens, "first", 1, partcv, params, 0);
  gc_frame_end(callframe96);
// compiled member node returning call97 (depth = 4)
  partcv[0] = 0;
  Object call98 = callmethodflags(call97, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe95);
// compiled member node returning call98 (depth = 3)
  *var_sym = call98;
  if (call98 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe100 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call101 = callmethodflags(*var_sym, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe100);
// compiled member node returning call101 (depth = 3)
  *var_lastToken = call101;
  if (call101 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe103 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_saved (depth = 4)
  partcv[0] = 0;
  Object call104 = callmethodflags(*var_saved, "second", 1, partcv, params, 0);
  gc_frame_end(callframe103);
// compiled member node returning call104 (depth = 3)
  *var_oldValueStackSize = call104;
  if (call104 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe107 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call108 = callmethodflags(*var_values, "size", 1, partcv, params, 0);
  gc_frame_end(callframe107);
// compiled member node returning call108 (depth = 4)
  int op_slot_right_106 = gc_frame_newslot(call108);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldValueStackSize (depth = 4)
  int op_slot_left_106 = gc_frame_newslot(*var_oldValueStackSize);
  params[0] = call108;
  partcv[0] = 1;
  Object opresult110 = callmethod(*var_oldValueStackSize, ">(1)", 1, partcv, params);
// compiled op node returning opresult110 (depth = 3)
  Object if105 = done;
  if (istrue(opresult110)) {
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe111 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit112 == NULL) {
    strlit112 = alloc_String("can't restore parse position; the values stack has been popped");
    gc_root(strlit112);
  }
// compiled string node returning strlit112 (depth = 4)
  gc_frame_newslot(strlit112);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe113 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call114 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe113);
// compiled member node returning call114 (depth = 4)
  params[0] = strlit112;
  partcv[0] = 1;
  Object call115 = callmethodflags(call114, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe111);
// compiled call node returning call115 (depth = 3)
    gc_frame_newslot(call115);
    if105 = call115;
  } else {
  }
// compiled if node returning if105 (depth = 2)
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe116 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block117 = alloc_Block(NULL, NULL, "parser", 115);
  gc_frame_newslot(block117);
// method "_apply"
  block_savedest(block117);
  Object closure118 = createclosure(3, "_apply");
  setclosureframe(closure118, stackframe);
  addtoclosure(closure118, var_values);
  addtoclosure(closure118, var_oldValueStackSize);
  addtoclosure(closure118, selfslot);
  struct UserObject *uo118 = (struct UserObject*)block117;
  uo118->data[0] = (Object)closure118;
  Method *meth_meth_parser_118__apply = addmethod2pos(block117, "_apply", &meth_parser_118__apply, 0);
  int argcv_meth_parser_118__apply[] = {0};
  meth_meth_parser_118__apply->type = alloc_MethodType(1, argcv_meth_parser_118__apply);
  meth_meth_parser_118__apply->definitionModule = modulename;
  meth_meth_parser_118__apply->definitionLine = 183;
// compiled block node returning block117 (depth = 3)
  gc_frame_newslot(block117);
// starting to compile block node (depth = 3)
  Object block125 = alloc_Block(NULL, NULL, "parser", 115);
  gc_frame_newslot(block125);
// method "_apply"
  block_savedest(block125);
  Object closure126 = createclosure(2, "_apply");
  setclosureframe(closure126, stackframe);
  addtoclosure(closure126, var_values);
  addtoclosure(closure126, selfslot);
  struct UserObject *uo126 = (struct UserObject*)block125;
  uo126->data[0] = (Object)closure126;
  Method *meth_meth_parser_126__apply = addmethod2pos(block125, "_apply", &meth_parser_126__apply, 0);
  int argcv_meth_parser_126__apply[] = {0};
  meth_meth_parser_126__apply->type = alloc_MethodType(1, argcv_meth_parser_126__apply);
  meth_meth_parser_126__apply->definitionModule = modulename;
  meth_meth_parser_126__apply->definitionLine = 183;
// compiled block node returning block125 (depth = 3)
  gc_frame_newslot(block125);
// call case 5: prelude request
  params[0] = block117;
  params[1] = block125;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call130 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe116);
// compiled call node returning call130 (depth = 2)
  gc_frame_end(frame);
  return call130;
}
Object meth_parser_141__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe143 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call144 = callmethodflags(*var_lastToken, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe143);
// compiled member node returning call144 (depth = 7)
  int op_slot_right_142 = gc_frame_newslot(call144);
// starting to compile member node (depth = 7)
  int callframe146 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call147 = callmethodflags(*var_n, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe146);
// compiled member node returning call147 (depth = 7)
  int op_slot_left_142 = gc_frame_newslot(call147);
  params[0] = call144;
  partcv[0] = 1;
  Object opresult148 = callmethod(call147, "≥(1)", 1, partcv, params);
// compiled op node returning opresult148 (depth = 6)
  gc_frame_end(frame);
  return opresult148;
}
Object meth_parser_153__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_154 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool156 = alloc_Boolean(0);
// compiled identifier node returning bool156 (depth = 8)
  int op_slot_left_154 = gc_frame_newslot(bool156);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult157 = callmethod(bool156, "==(1)", 1, partcv, params);
// compiled op node returning opresult157 (depth = 7)
  gc_frame_end(frame);
  return opresult157;
}
Object meth_parser_138__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block140 = alloc_Block(NULL, NULL, "parser", 127);
  gc_frame_newslot(block140);
// method "_apply"
  block_savedest(block140);
  Object closure141 = createclosure(3, "_apply");
  setclosureframe(closure141, stackframe);
  addtoclosure(closure141, var_lastToken);
  addtoclosure(closure141, var_n);
  addtoclosure(closure141, selfslot);
  struct UserObject *uo141 = (struct UserObject*)block140;
  uo141->data[0] = (Object)closure141;
  Method *meth_meth_parser_141__apply = addmethod2pos(block140, "_apply", &meth_parser_141__apply, 0);
  int argcv_meth_parser_141__apply[] = {0};
  meth_meth_parser_141__apply->type = alloc_MethodType(1, argcv_meth_parser_141__apply);
  meth_meth_parser_141__apply->definitionModule = modulename;
  meth_meth_parser_141__apply->definitionLine = 183;
// compiled block node returning block140 (depth = 5)
  int op_slot_right_139 = gc_frame_newslot(block140);
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block152 = alloc_Block(NULL, NULL, "parser", 127);
  gc_frame_newslot(block152);
// method "_apply"
  block_savedest(block152);
  Object closure153 = createclosure(2, "_apply");
  setclosureframe(closure153, stackframe);
  addtoclosure(closure153, var_nextTok);
  addtoclosure(closure153, selfslot);
  struct UserObject *uo153 = (struct UserObject*)block152;
  uo153->data[0] = (Object)closure153;
  Method *meth_meth_parser_153__apply = addmethod2pos(block152, "_apply", &meth_parser_153__apply, 0);
  int argcv_meth_parser_153__apply[] = {0};
  meth_meth_parser_153__apply->type = alloc_MethodType(1, argcv_meth_parser_153__apply);
  meth_meth_parser_153__apply->definitionModule = modulename;
  meth_meth_parser_153__apply->definitionLine = 183;
// compiled block node returning block152 (depth = 6)
  int op_slot_right_151 = gc_frame_newslot(block152);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_right_160 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 7)
  Object bool162 = alloc_Boolean(0);
// compiled identifier node returning bool162 (depth = 7)
  int op_slot_left_160 = gc_frame_newslot(bool162);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult163 = callmethod(bool162, "≠(1)", 1, partcv, params);
// compiled op node returning opresult163 (depth = 6)
  int op_slot_left_151 = gc_frame_newslot(opresult163);
  params[0] = block152;
  partcv[0] = 1;
  Object opresult164 = callmethod(opresult163, "&&(1)", 1, partcv, params);
// compiled op node returning opresult164 (depth = 5)
  int op_slot_left_139 = gc_frame_newslot(opresult164);
  params[0] = block140;
  partcv[0] = 1;
  Object opresult165 = callmethod(opresult164, "&&(1)", 1, partcv, params);
// compiled op node returning opresult165 (depth = 4)
  gc_frame_end(frame);
  return opresult165;
}
Object meth_parser_168__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_tokenMatcher = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe170 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokenMatcher (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call171 = callmethodflags(*var_tokenMatcher, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe170);
// compiled call node returning call171 (depth = 5)
  Object if169 = done;
  if (istrue(call171)) {
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if169 = done;
  } else {
  }
// compiled if node returning if169 (depth = 4)
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe173 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call174 = callmethodflags(*var_n, "next", 1, partcv, params, 0);
  gc_frame_end(callframe173);
// compiled member node returning call174 (depth = 5)
  *var_n = call174;
  if (call174 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_131_findNextToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextToken(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokenMatcher = &(stackframe->slots[0]);
  *var_tokenMatcher = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findNextToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe133 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokenMatcher (depth = 4)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call134 = callmethodflags(*var_tokenMatcher, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe133);
// compiled call node returning call134 (depth = 3)
  Object if132 = done;
  if (istrue(call134)) {
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if132 = undefined;
  } else {
  }
// compiled if node returning if132 (depth = 2)
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool135 = alloc_Boolean(0);
// compiled identifier node returning bool135 (depth = 3)
  *var_nextTok = bool135;
  if (bool135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe136 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block137 = alloc_Block(NULL, NULL, "parser", 127);
  gc_frame_newslot(block137);
// method "_apply"
  block_savedest(block137);
  Object closure138 = createclosure(4, "_apply");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_lastToken);
  addtoclosure(closure138, var_n);
  addtoclosure(closure138, var_nextTok);
  addtoclosure(closure138, selfslot);
  struct UserObject *uo138 = (struct UserObject*)block137;
  uo138->data[0] = (Object)closure138;
  Method *meth_meth_parser_138__apply = addmethod2pos(block137, "_apply", &meth_parser_138__apply, 0);
  int argcv_meth_parser_138__apply[] = {0};
  meth_meth_parser_138__apply->type = alloc_MethodType(1, argcv_meth_parser_138__apply);
  meth_meth_parser_138__apply->definitionModule = modulename;
  meth_meth_parser_138__apply->definitionLine = 183;
// compiled block node returning block137 (depth = 3)
  gc_frame_newslot(block137);
// starting to compile block node (depth = 3)
  Object block167 = alloc_Block(NULL, NULL, "parser", 127);
  gc_frame_newslot(block167);
// method "_apply"
  block_savedest(block167);
  Object closure168 = createclosure(4, "_apply");
  setclosureframe(closure168, stackframe);
  addtoclosure(closure168, var_n);
  addtoclosure(closure168, var_tokenMatcher);
  addtoclosure(closure168, var_nextTok);
  addtoclosure(closure168, selfslot);
  struct UserObject *uo168 = (struct UserObject*)block167;
  uo168->data[0] = (Object)closure168;
  Method *meth_meth_parser_168__apply = addmethod2pos(block167, "_apply", &meth_parser_168__apply, 0);
  int argcv_meth_parser_168__apply[] = {0};
  meth_meth_parser_168__apply->type = alloc_MethodType(1, argcv_meth_parser_168__apply);
  meth_meth_parser_168__apply->definitionModule = modulename;
  meth_meth_parser_168__apply->definitionLine = 183;
// compiled block node returning block167 (depth = 3)
  gc_frame_newslot(block167);
// call case 5: prelude request
  params[0] = block137;
  params[1] = block167;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call177 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe136);
// compiled call node returning call177 (depth = 2)
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser_212__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_213 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool215 = alloc_Boolean(0);
// compiled identifier node returning bool215 (depth = 7)
  int op_slot_left_213 = gc_frame_newslot(bool215);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult216 = callmethod(bool215, "==(1)", 1, partcv, params);
// compiled op node returning opresult216 (depth = 6)
  gc_frame_end(frame);
  return opresult216;
}
Object meth_parser_209__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block211 = alloc_Block(NULL, NULL, "parser", 142);
  gc_frame_newslot(block211);
// method "_apply"
  block_savedest(block211);
  Object closure212 = createclosure(2, "_apply");
  setclosureframe(closure212, stackframe);
  addtoclosure(closure212, var_nextTok);
  addtoclosure(closure212, selfslot);
  struct UserObject *uo212 = (struct UserObject*)block211;
  uo212->data[0] = (Object)closure212;
  Method *meth_meth_parser_212__apply = addmethod2pos(block211, "_apply", &meth_parser_212__apply, 0);
  int argcv_meth_parser_212__apply[] = {0};
  meth_meth_parser_212__apply->type = alloc_MethodType(1, argcv_meth_parser_212__apply);
  meth_meth_parser_212__apply->definitionModule = modulename;
  meth_meth_parser_212__apply->definitionLine = 183;
// compiled block node returning block211 (depth = 5)
  int op_slot_right_210 = gc_frame_newslot(block211);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_219 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 6)
  Object bool221 = alloc_Boolean(0);
// compiled identifier node returning bool221 (depth = 6)
  int op_slot_left_219 = gc_frame_newslot(bool221);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult222 = callmethod(bool221, "≠(1)", 1, partcv, params);
// compiled op node returning opresult222 (depth = 5)
  int op_slot_left_210 = gc_frame_newslot(opresult222);
  params[0] = block211;
  partcv[0] = 1;
  Object opresult223 = callmethod(opresult222, "&&(1)", 1, partcv, params);
// compiled op node returning opresult223 (depth = 4)
  gc_frame_end(frame);
  return opresult223;
}
Object meth_parser_226__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_n = getfromclosure(closure, 2);
  Object *var_nextTok = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit230 == NULL) {
    strlit230 = alloc_String("eof");
    gc_root(strlit230);
  }
// compiled string node returning strlit230 (depth = 7)
  int op_slot_right_229 = gc_frame_newslot(strlit230);
// starting to compile member node (depth = 7)
  int callframe232 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call233 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe232);
// compiled member node returning call233 (depth = 7)
  int op_slot_left_229 = gc_frame_newslot(call233);
  params[0] = strlit230;
  partcv[0] = 1;
  Object opresult234 = callmethod(call233, "==(1)", 1, partcv, params);
// compiled op node returning opresult234 (depth = 6)
  int op_slot_right_228 = gc_frame_newslot(opresult234);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe238 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  partcv[0] = 0;
  Object call239 = callmethodflags(*var_tok, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe238);
// compiled member node returning call239 (depth = 8)
  int op_slot_right_237 = gc_frame_newslot(call239);
// starting to compile member node (depth = 8)
  int callframe241 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call242 = callmethodflags(*var_n, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe241);
// compiled member node returning call242 (depth = 8)
  int op_slot_left_237 = gc_frame_newslot(call242);
  params[0] = call239;
  partcv[0] = 1;
  Object opresult243 = callmethod(call242, "≤(1)", 1, partcv, params);
// compiled op node returning opresult243 (depth = 7)
  int op_slot_right_236 = gc_frame_newslot(opresult243);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe246 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  partcv[0] = 0;
  Object call247 = callmethodflags(*var_tok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe246);
// compiled member node returning call247 (depth = 8)
  int op_slot_right_245 = gc_frame_newslot(call247);
// starting to compile member node (depth = 8)
  int callframe249 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call250 = callmethodflags(*var_n, "line", 1, partcv, params, 0);
  gc_frame_end(callframe249);
// compiled member node returning call250 (depth = 8)
  int op_slot_left_245 = gc_frame_newslot(call250);
  params[0] = call247;
  partcv[0] = 1;
  Object opresult251 = callmethod(call250, ">(1)", 1, partcv, params);
// compiled op node returning opresult251 (depth = 7)
  int op_slot_left_236 = gc_frame_newslot(opresult251);
  params[0] = opresult243;
  partcv[0] = 1;
  Object opresult252 = callmethod(opresult251, "&&(1)", 1, partcv, params);
// compiled op node returning opresult252 (depth = 6)
  int op_slot_left_228 = gc_frame_newslot(opresult252);
  params[0] = opresult234;
  partcv[0] = 1;
  Object opresult253 = callmethod(opresult252, "||(1)", 1, partcv, params);
// compiled op node returning opresult253 (depth = 5)
  Object if227 = done;
  if (istrue(opresult253)) {
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if227 = done;
  } else {
  }
// compiled if node returning if227 (depth = 4)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe255 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call256 = callmethodflags(*var_n, "next", 1, partcv, params, 0);
  gc_frame_end(callframe255);
// compiled member node returning call256 (depth = 5)
  *var_n = call256;
  if (call256 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_178_findNextTokenIndentedAt_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextTokenIndentedAt(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextTokenIndentedAt(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextTokenIndentedAt(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findNextTokenIndentedAt(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit182 == NULL) {
    strlit182 = alloc_String("eof");
    gc_root(strlit182);
  }
// compiled string node returning strlit182 (depth = 5)
  int op_slot_right_181 = gc_frame_newslot(strlit182);
// starting to compile member node (depth = 5)
  int callframe184 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call185 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe184);
// compiled member node returning call185 (depth = 5)
  int op_slot_left_181 = gc_frame_newslot(call185);
  params[0] = strlit182;
  partcv[0] = 1;
  Object opresult186 = callmethod(call185, "==(1)", 1, partcv, params);
// compiled op node returning opresult186 (depth = 4)
  int op_slot_right_180 = gc_frame_newslot(opresult186);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe190 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  partcv[0] = 0;
  Object call191 = callmethodflags(*var_tok, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe190);
// compiled member node returning call191 (depth = 6)
  int op_slot_right_189 = gc_frame_newslot(call191);
// starting to compile member node (depth = 6)
  int callframe193 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call194 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe193);
// compiled member node returning call194 (depth = 6)
  int op_slot_left_189 = gc_frame_newslot(call194);
  params[0] = call191;
  partcv[0] = 1;
  Object opresult195 = callmethod(call194, "≤(1)", 1, partcv, params);
// compiled op node returning opresult195 (depth = 5)
  int op_slot_right_188 = gc_frame_newslot(opresult195);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe198 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  partcv[0] = 0;
  Object call199 = callmethodflags(*var_tok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe198);
// compiled member node returning call199 (depth = 6)
  int op_slot_right_197 = gc_frame_newslot(call199);
// starting to compile member node (depth = 6)
  int callframe201 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call202 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe201);
// compiled member node returning call202 (depth = 6)
  int op_slot_left_197 = gc_frame_newslot(call202);
  params[0] = call199;
  partcv[0] = 1;
  Object opresult203 = callmethod(call202, ">(1)", 1, partcv, params);
// compiled op node returning opresult203 (depth = 5)
  int op_slot_left_188 = gc_frame_newslot(opresult203);
  params[0] = opresult195;
  partcv[0] = 1;
  Object opresult204 = callmethod(opresult203, "&&(1)", 1, partcv, params);
// compiled op node returning opresult204 (depth = 4)
  int op_slot_left_180 = gc_frame_newslot(opresult204);
  params[0] = opresult186;
  partcv[0] = 1;
  Object opresult205 = callmethod(opresult204, "||(1)", 1, partcv, params);
// compiled op node returning opresult205 (depth = 3)
  Object if179 = done;
  if (istrue(opresult205)) {
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if179 = undefined;
  } else {
  }
// compiled if node returning if179 (depth = 2)
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool206 = alloc_Boolean(0);
// compiled identifier node returning bool206 (depth = 3)
  *var_nextTok = bool206;
  if (bool206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe207 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block208 = alloc_Block(NULL, NULL, "parser", 142);
  gc_frame_newslot(block208);
// method "_apply"
  block_savedest(block208);
  Object closure209 = createclosure(3, "_apply");
  setclosureframe(closure209, stackframe);
  addtoclosure(closure209, var_nextTok);
  addtoclosure(closure209, var_n);
  addtoclosure(closure209, selfslot);
  struct UserObject *uo209 = (struct UserObject*)block208;
  uo209->data[0] = (Object)closure209;
  Method *meth_meth_parser_209__apply = addmethod2pos(block208, "_apply", &meth_parser_209__apply, 0);
  int argcv_meth_parser_209__apply[] = {0};
  meth_meth_parser_209__apply->type = alloc_MethodType(1, argcv_meth_parser_209__apply);
  meth_meth_parser_209__apply->definitionModule = modulename;
  meth_meth_parser_209__apply->definitionLine = 183;
// compiled block node returning block208 (depth = 3)
  gc_frame_newslot(block208);
// starting to compile block node (depth = 3)
  Object block225 = alloc_Block(NULL, NULL, "parser", 142);
  gc_frame_newslot(block225);
// method "_apply"
  block_savedest(block225);
  Object closure226 = createclosure(5, "_apply");
  setclosureframe(closure226, stackframe);
  addtoclosure(closure226, var_sym);
  addtoclosure(closure226, var_tok);
  addtoclosure(closure226, var_n);
  addtoclosure(closure226, var_nextTok);
  addtoclosure(closure226, selfslot);
  struct UserObject *uo226 = (struct UserObject*)block225;
  uo226->data[0] = (Object)closure226;
  Method *meth_meth_parser_226__apply = addmethod2pos(block225, "_apply", &meth_parser_226__apply, 0);
  int argcv_meth_parser_226__apply[] = {0};
  meth_meth_parser_226__apply->type = alloc_MethodType(1, argcv_meth_parser_226__apply);
  meth_meth_parser_226__apply->definitionModule = modulename;
  meth_meth_parser_226__apply->definitionLine = 183;
// compiled block node returning block225 (depth = 3)
  gc_frame_newslot(block225);
// call case 5: prelude request
  params[0] = block208;
  params[1] = block225;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call259 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe207);
// compiled call node returning call259 (depth = 2)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser_274__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit276 == NULL) {
    strlit276 = alloc_String("eof");
    gc_root(strlit276);
  }
// compiled string node returning strlit276 (depth = 5)
  int op_slot_right_275 = gc_frame_newslot(strlit276);
// starting to compile member node (depth = 5)
  int callframe278 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  partcv[0] = 0;
  Object call279 = callmethodflags(*var_validToken, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe278);
// compiled member node returning call279 (depth = 5)
  int op_slot_left_275 = gc_frame_newslot(call279);
  params[0] = strlit276;
  partcv[0] = 1;
  Object opresult280 = callmethod(call279, "≠(1)", 1, partcv, params);
// compiled op node returning opresult280 (depth = 4)
  gc_frame_end(frame);
  return opresult280;
}
Object meth_parser_283__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object *var_validFollowTokens = getfromclosure(closure, 1);
  Object *var_invalidTokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe285 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe286 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  partcv[0] = 0;
  Object call287 = callmethodflags(*var_validToken, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe286);
// compiled member node returning call287 (depth = 6)
  gc_frame_newslot(call287);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validFollowTokens (depth = 6)
  params[0] = call287;
  partcv[0] = 1;
  Object call288 = callmethodflags(*var_validFollowTokens, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe285);
// compiled call node returning call288 (depth = 5)
  Object if284 = done;
  if (istrue(call288)) {
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if284 = undefined;
  } else {
  }
// compiled if node returning if284 (depth = 4)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe290 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe291 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe292 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_validToken (depth = 8)
  partcv[0] = 0;
  Object call293 = callmethodflags(*var_validToken, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe292);
// compiled member node returning call293 (depth = 7)
  gc_frame_newslot(call293);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_invalidTokens (depth = 7)
  params[0] = call293;
  partcv[0] = 1;
  Object call294 = callmethodflags(*var_invalidTokens, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe291);
// compiled call node returning call294 (depth = 6)
  partcv[0] = 0;
  Object call295 = callmethodflags(call294, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe290);
// compiled call node returning call295 (depth = 5)
  Object if289 = done;
  if (istrue(call295)) {
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if289 = undefined;
  } else {
  }
// compiled if node returning if289 (depth = 4)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe296 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  partcv[0] = 0;
  Object call297 = callmethodflags(*var_validToken, "next", 1, partcv, params, 0);
  gc_frame_end(callframe296);
// compiled member node returning call297 (depth = 5)
  *var_validToken = call297;
  if (call297 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_260_findNextValidToken_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextValidToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextValidToken(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextValidToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_validFollowTokens = &(stackframe->slots[0]);
  *var_validFollowTokens = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findNextValidToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_invalidTokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "invalidTokens");
  Object *var_validToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "validToken");
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe261 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array262 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 5)
  if (strlit263 == NULL) {
    strlit263 = alloc_String("dot");
    gc_root(strlit263);
  }
// compiled string node returning strlit263 (depth = 5)
  params[0] = strlit263;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit264 == NULL) {
    strlit264 = alloc_String("comma");
    gc_root(strlit264);
  }
// compiled string node returning strlit264 (depth = 5)
  params[0] = strlit264;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit265 == NULL) {
    strlit265 = alloc_String("colon");
    gc_root(strlit265);
  }
// compiled string node returning strlit265 (depth = 5)
  params[0] = strlit265;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit266 == NULL) {
    strlit266 = alloc_String("rparen");
    gc_root(strlit266);
  }
// compiled string node returning strlit266 (depth = 5)
  params[0] = strlit266;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit267 == NULL) {
    strlit267 = alloc_String("rbrace");
    gc_root(strlit267);
  }
// compiled string node returning strlit267 (depth = 5)
  params[0] = strlit267;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit268 == NULL) {
    strlit268 = alloc_String("rsquare");
    gc_root(strlit268);
  }
// compiled string node returning strlit268 (depth = 5)
  params[0] = strlit268;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit269 == NULL) {
    strlit269 = alloc_String("arrow");
    gc_root(strlit269);
  }
// compiled string node returning strlit269 (depth = 5)
  params[0] = strlit269;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit270 == NULL) {
    strlit270 = alloc_String("bind");
    gc_root(strlit270);
  }
// compiled string node returning strlit270 (depth = 5)
  params[0] = strlit270;
  partcv[0] = 1;
  callmethodflags(array262, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array262 (depth = 4)
  gc_frame_newslot(array262);
// call case 5: prelude request
  params[0] = array262;
  partcv[0] = 1;
  Object call271 = callmethodflags(prelude, "set(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe261);
// compiled call node returning call271 (depth = 3)
  *var_invalidTokens = call271;
  if (call271 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_validToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe272 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block273 = alloc_Block(NULL, NULL, "parser", 156);
  gc_frame_newslot(block273);
// method "_apply"
  block_savedest(block273);
  Object closure274 = createclosure(2, "_apply");
  setclosureframe(closure274, stackframe);
  addtoclosure(closure274, var_validToken);
  addtoclosure(closure274, selfslot);
  struct UserObject *uo274 = (struct UserObject*)block273;
  uo274->data[0] = (Object)closure274;
  Method *meth_meth_parser_274__apply = addmethod2pos(block273, "_apply", &meth_parser_274__apply, 0);
  int argcv_meth_parser_274__apply[] = {0};
  meth_meth_parser_274__apply->type = alloc_MethodType(1, argcv_meth_parser_274__apply);
  meth_meth_parser_274__apply->definitionModule = modulename;
  meth_meth_parser_274__apply->definitionLine = 183;
// compiled block node returning block273 (depth = 3)
  gc_frame_newslot(block273);
// starting to compile block node (depth = 3)
  Object block282 = alloc_Block(NULL, NULL, "parser", 156);
  gc_frame_newslot(block282);
// method "_apply"
  block_savedest(block282);
  Object closure283 = createclosure(4, "_apply");
  setclosureframe(closure283, stackframe);
  addtoclosure(closure283, var_validToken);
  addtoclosure(closure283, var_validFollowTokens);
  addtoclosure(closure283, var_invalidTokens);
  addtoclosure(closure283, selfslot);
  struct UserObject *uo283 = (struct UserObject*)block282;
  uo283->data[0] = (Object)closure283;
  Method *meth_meth_parser_283__apply = addmethod2pos(block282, "_apply", &meth_parser_283__apply, 0);
  int argcv_meth_parser_283__apply[] = {0};
  meth_meth_parser_283__apply->type = alloc_MethodType(1, argcv_meth_parser_283__apply);
  meth_meth_parser_283__apply->definitionModule = modulename;
  meth_meth_parser_283__apply->definitionLine = 183;
// compiled block node returning block282 (depth = 3)
  gc_frame_newslot(block282);
// call case 5: prelude request
  params[0] = block273;
  params[1] = block282;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call300 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe272);
// compiled call node returning call300 (depth = 2)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_validToken (depth = 3)
  return *var_validToken;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_312__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe315 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  partcv[0] = 0;
  Object call316 = callmethodflags(*var_token, "line", 1, partcv, params, 0);
  gc_frame_end(callframe315);
// compiled member node returning call316 (depth = 6)
  int op_slot_right_314 = gc_frame_newslot(call316);
// starting to compile member node (depth = 6)
  int callframe318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call319 = callmethodflags(*var_n, "line", 1, partcv, params, 0);
  gc_frame_end(callframe318);
// compiled member node returning call319 (depth = 6)
  int op_slot_left_314 = gc_frame_newslot(call319);
  params[0] = call316;
  partcv[0] = 1;
  Object opresult320 = callmethod(call319, "==(1)", 1, partcv, params);
// compiled op node returning opresult320 (depth = 5)
  int op_slot_right_313 = gc_frame_newslot(opresult320);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit323 == NULL) {
    strlit323 = alloc_String("eof");
    gc_root(strlit323);
  }
// compiled string node returning strlit323 (depth = 6)
  int op_slot_right_322 = gc_frame_newslot(strlit323);
// starting to compile member node (depth = 6)
  int callframe325 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call326 = callmethodflags(*var_n, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe325);
// compiled member node returning call326 (depth = 6)
  int op_slot_left_322 = gc_frame_newslot(call326);
  params[0] = strlit323;
  partcv[0] = 1;
  Object opresult327 = callmethod(call326, "≠(1)", 1, partcv, params);
// compiled op node returning opresult327 (depth = 5)
  int op_slot_left_313 = gc_frame_newslot(opresult327);
  params[0] = opresult320;
  partcv[0] = 1;
  Object opresult328 = callmethod(opresult327, "&&(1)", 1, partcv, params);
// compiled op node returning opresult328 (depth = 4)
  gc_frame_end(frame);
  return opresult328;
}
Object meth_parser_331__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit334 == NULL) {
    strlit334 = alloc_String("lbrace");
    gc_root(strlit334);
  }
// compiled string node returning strlit334 (depth = 6)
  int op_slot_right_333 = gc_frame_newslot(strlit334);
// starting to compile member node (depth = 6)
  int callframe336 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call337 = callmethodflags(*var_n, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe336);
// compiled member node returning call337 (depth = 6)
  int op_slot_left_333 = gc_frame_newslot(call337);
  params[0] = strlit334;
  partcv[0] = 1;
  Object opresult338 = callmethod(call337, "==(1)", 1, partcv, params);
// compiled op node returning opresult338 (depth = 5)
  Object if332 = done;
  if (istrue(opresult338)) {
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num340 = alloc_Float64(1);
// compiled num node returning num340 (depth = 7)
  int op_slot_right_339 = gc_frame_newslot(num340);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_339 = gc_frame_newslot(*var_numOpening);
  params[0] = num340;
  partcv[0] = 1;
  Object sum342 = callmethod(*var_numOpening, "+(1)", 1, partcv, params);
// compiled op node returning sum342 (depth = 6)
  *var_numOpening = sum342;
  if (sum342 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if332 = done;
  } else {
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit346 == NULL) {
    strlit346 = alloc_String("rbrace");
    gc_root(strlit346);
  }
// compiled string node returning strlit346 (depth = 7)
  int op_slot_right_345 = gc_frame_newslot(strlit346);
// starting to compile member node (depth = 7)
  int callframe348 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call349 = callmethodflags(*var_n, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe348);
// compiled member node returning call349 (depth = 7)
  int op_slot_left_345 = gc_frame_newslot(call349);
  params[0] = strlit346;
  partcv[0] = 1;
  Object opresult350 = callmethod(call349, "==(1)", 1, partcv, params);
// compiled op node returning opresult350 (depth = 6)
  Object if344 = done;
  if (istrue(opresult350)) {
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num352 = alloc_Float64(1);
// compiled num node returning num352 (depth = 8)
  int op_slot_right_351 = gc_frame_newslot(num352);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_351 = gc_frame_newslot(*var_numClosing);
  params[0] = num352;
  partcv[0] = 1;
  Object sum354 = callmethod(*var_numClosing, "+(1)", 1, partcv, params);
// compiled op node returning sum354 (depth = 7)
  *var_numClosing = sum354;
  if (sum354 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if344 = done;
  } else {
  }
// compiled if node returning if344 (depth = 5)
    gc_frame_newslot(if344);
    if332 = if344;
  }
// compiled if node returning if332 (depth = 4)
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe356 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call357 = callmethodflags(*var_n, "next", 1, partcv, params, 0);
  gc_frame_end(callframe356);
// compiled member node returning call357 (depth = 5)
  *var_n = call357;
  if (call357 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_363__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe366 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  partcv[0] = 0;
  Object call367 = callmethodflags(*var_token, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe366);
// compiled member node returning call367 (depth = 6)
  int op_slot_right_365 = gc_frame_newslot(call367);
// starting to compile member node (depth = 6)
  int callframe369 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call370 = callmethodflags(*var_n, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe369);
// compiled member node returning call370 (depth = 6)
  int op_slot_left_365 = gc_frame_newslot(call370);
  params[0] = call367;
  partcv[0] = 1;
  Object opresult371 = callmethod(call370, ">(1)", 1, partcv, params);
// compiled op node returning opresult371 (depth = 5)
  int op_slot_right_364 = gc_frame_newslot(opresult371);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit374 == NULL) {
    strlit374 = alloc_String("eof");
    gc_root(strlit374);
  }
// compiled string node returning strlit374 (depth = 6)
  int op_slot_right_373 = gc_frame_newslot(strlit374);
// starting to compile member node (depth = 6)
  int callframe376 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call377 = callmethodflags(*var_n, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe376);
// compiled member node returning call377 (depth = 6)
  int op_slot_left_373 = gc_frame_newslot(call377);
  params[0] = strlit374;
  partcv[0] = 1;
  Object opresult378 = callmethod(call377, "≠(1)", 1, partcv, params);
// compiled op node returning opresult378 (depth = 5)
  int op_slot_left_364 = gc_frame_newslot(opresult378);
  params[0] = opresult371;
  partcv[0] = 1;
  Object opresult379 = callmethod(opresult378, "&&(1)", 1, partcv, params);
// compiled op node returning opresult379 (depth = 4)
  gc_frame_end(frame);
  return opresult379;
}
Object meth_parser_382__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit385 == NULL) {
    strlit385 = alloc_String("lbrace");
    gc_root(strlit385);
  }
// compiled string node returning strlit385 (depth = 6)
  int op_slot_right_384 = gc_frame_newslot(strlit385);
// starting to compile member node (depth = 6)
  int callframe387 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call388 = callmethodflags(*var_n, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe387);
// compiled member node returning call388 (depth = 6)
  int op_slot_left_384 = gc_frame_newslot(call388);
  params[0] = strlit385;
  partcv[0] = 1;
  Object opresult389 = callmethod(call388, "==(1)", 1, partcv, params);
// compiled op node returning opresult389 (depth = 5)
  Object if383 = done;
  if (istrue(opresult389)) {
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num391 = alloc_Float64(1);
// compiled num node returning num391 (depth = 7)
  int op_slot_right_390 = gc_frame_newslot(num391);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_390 = gc_frame_newslot(*var_numOpening);
  params[0] = num391;
  partcv[0] = 1;
  Object sum393 = callmethod(*var_numOpening, "+(1)", 1, partcv, params);
// compiled op node returning sum393 (depth = 6)
  *var_numOpening = sum393;
  if (sum393 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if383 = done;
  } else {
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit397 == NULL) {
    strlit397 = alloc_String("rbrace");
    gc_root(strlit397);
  }
// compiled string node returning strlit397 (depth = 7)
  int op_slot_right_396 = gc_frame_newslot(strlit397);
// starting to compile member node (depth = 7)
  int callframe399 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call400 = callmethodflags(*var_n, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe399);
// compiled member node returning call400 (depth = 7)
  int op_slot_left_396 = gc_frame_newslot(call400);
  params[0] = strlit397;
  partcv[0] = 1;
  Object opresult401 = callmethod(call400, "==(1)", 1, partcv, params);
// compiled op node returning opresult401 (depth = 6)
  Object if395 = done;
  if (istrue(opresult401)) {
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num403 = alloc_Float64(1);
// compiled num node returning num403 (depth = 8)
  int op_slot_right_402 = gc_frame_newslot(num403);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_402 = gc_frame_newslot(*var_numClosing);
  params[0] = num403;
  partcv[0] = 1;
  Object sum405 = callmethod(*var_numClosing, "+(1)", 1, partcv, params);
// compiled op node returning sum405 (depth = 7)
  *var_numClosing = sum405;
  if (sum405 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if395 = done;
  } else {
  }
// compiled if node returning if395 (depth = 5)
    gc_frame_newslot(if395);
    if383 = if395;
  }
// compiled if node returning if383 (depth = 4)
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe407 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call408 = callmethodflags(*var_n, "next", 1, partcv, params, 0);
  gc_frame_end(callframe407);
// compiled member node returning call408 (depth = 5)
  *var_n = call408;
  if (call408 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_301_findClosingBrace_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findClosingBrace(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method findClosingBrace(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findClosingBrace(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  Object *var_inserted = &(stackframe->slots[1]);
  *var_inserted = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part findClosingBrace(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_numOpening = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "numOpening");
  Object *var_numClosing = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "numClosing");
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inserted (depth = 4)
  Object if302 = done;
struct StackFrameObject *iftmpstackframe302 = stackframe;
  if (istrue(*var_inserted)) {
stackframe = alloc_StackFrame(0, iftmpstackframe302);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile num node (depth = 4)
  Object num303 = alloc_Float64(1);
// compiled num node returning num303 (depth = 4)
    gc_frame_newslot(num303);
    if302 = num303;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe302);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile num node (depth = 4)
  Object num304 = alloc_Float64(0);
// compiled num node returning num304 (depth = 4)
    gc_frame_newslot(num304);
    if302 = num304;
  }
stackframe = iftmpstackframe302;
// compiled if node returning if302 (depth = 3)
  *var_numOpening = if302;
  if (if302 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num305 = alloc_Float64(0);
// compiled num node returning num305 (depth = 3)
  *var_numClosing = num305;
  if (num305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject306 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj306 = alloc_userobj2(4,4, objclass306);
  gc_frame_newslot(obj306);
  if (objclass306 == NULL) {
    glfree(obj306->class->name);
    obj306->class->name = "result";
  }
// OBJECT OUTER DEC outer
  adddatum2(obj306, self, 0);
  addmethodreal(obj306,"outer", &reader_parser_outer_307);
  Object oldself306 = self;
  struct StackFrameObject *oldstackframe306 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe306);
  gc_frame_newslot((Object)stackframe);
  self = obj306;
  Object *oldselfslot306 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter306 = (*(struct UserObject *)self).data[0], lowerouter306 = thisouter306;
  if (inheritingObject306) {
    struct UserObject *inho306 = (struct UserObject *)inheritingObject306;
    while (inho306->super != GraceDefaultObject) inho306 = (struct UserObject *)inho306->super;
    inho306->super = obj306;
    self = inheritingObject306;
    *selfslot = self;
    lowerouter306 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter306;
  }
  if (objclass306 == NULL) {
    Method *reader308 = addmethodrealflags(obj306, "found", &reader_parser_found_308, 0);
    Method *writer308 = addmethodrealflags(obj306, "found:=(1)", &writer_parser_found_308, 0);
    reader308->definitionModule = modulename;
    writer308->definitionModule = modulename;
    reader308->definitionLine = 182;
    writer308->definitionLine = 182;
  }
  obj306->flags |= OFLAG_MUTABLE;
  adddatum2(obj306, alloc_Undefined(), 1);
  if (objclass306 == NULL) {
    Method *reader309 = addmethodrealflags(obj306, "tok", &reader_parser_tok_309, 0);
    Method *writer309 = addmethodrealflags(obj306, "tok:=(1)", &writer_parser_tok_309, 0);
    reader309->definitionModule = modulename;
    writer309->definitionModule = modulename;
    reader309->definitionLine = 183;
    writer309->definitionLine = 183;
  }
  obj306->flags |= OFLAG_MUTABLE;
  adddatum2(obj306, alloc_Undefined(), 2);
  sourceObject = obj306;
  adddatum2(obj306, undefined, 1);
  sourceObject = obj306;
  adddatum2(obj306, undefined, 2);
  objclass306 = obj306->class;
  objclass306->definitionModule = modulename;
  objclass306->definitionLine = 181;
  (*(struct UserObject *)self).data[0] = lowerouter306;
  self = oldself306;
  selfslot = oldselfslot306;
  stackframe = oldstackframe306;
// compiled object node returning obj306 (depth = 3)
  *var_result = obj306;
  if (obj306 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe310 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block311 = alloc_Block(NULL, NULL, "parser", 186);
  gc_frame_newslot(block311);
// method "_apply"
  block_savedest(block311);
  Object closure312 = createclosure(3, "_apply");
  setclosureframe(closure312, stackframe);
  addtoclosure(closure312, var_token);
  addtoclosure(closure312, var_n);
  addtoclosure(closure312, selfslot);
  struct UserObject *uo312 = (struct UserObject*)block311;
  uo312->data[0] = (Object)closure312;
  Method *meth_meth_parser_312__apply = addmethod2pos(block311, "_apply", &meth_parser_312__apply, 0);
  int argcv_meth_parser_312__apply[] = {0};
  meth_meth_parser_312__apply->type = alloc_MethodType(1, argcv_meth_parser_312__apply);
  meth_meth_parser_312__apply->definitionModule = modulename;
  meth_meth_parser_312__apply->definitionLine = 183;
// compiled block node returning block311 (depth = 3)
  gc_frame_newslot(block311);
// starting to compile block node (depth = 3)
  Object block330 = alloc_Block(NULL, NULL, "parser", 186);
  gc_frame_newslot(block330);
// method "_apply"
  block_savedest(block330);
  Object closure331 = createclosure(4, "_apply");
  setclosureframe(closure331, stackframe);
  addtoclosure(closure331, var_n);
  addtoclosure(closure331, var_numOpening);
  addtoclosure(closure331, var_numClosing);
  addtoclosure(closure331, selfslot);
  struct UserObject *uo331 = (struct UserObject*)block330;
  uo331->data[0] = (Object)closure331;
  Method *meth_meth_parser_331__apply = addmethod2pos(block330, "_apply", &meth_parser_331__apply, 0);
  int argcv_meth_parser_331__apply[] = {0};
  meth_meth_parser_331__apply->type = alloc_MethodType(1, argcv_meth_parser_331__apply);
  meth_meth_parser_331__apply->definitionModule = modulename;
  meth_meth_parser_331__apply->definitionLine = 183;
// compiled block node returning block330 (depth = 3)
  gc_frame_newslot(block330);
// call case 5: prelude request
  params[0] = block311;
  params[1] = block330;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call360 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe310);
// compiled call node returning call360 (depth = 2)
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe361 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block362 = alloc_Block(NULL, NULL, "parser", 195);
  gc_frame_newslot(block362);
// method "_apply"
  block_savedest(block362);
  Object closure363 = createclosure(3, "_apply");
  setclosureframe(closure363, stackframe);
  addtoclosure(closure363, var_token);
  addtoclosure(closure363, var_n);
  addtoclosure(closure363, selfslot);
  struct UserObject *uo363 = (struct UserObject*)block362;
  uo363->data[0] = (Object)closure363;
  Method *meth_meth_parser_363__apply = addmethod2pos(block362, "_apply", &meth_parser_363__apply, 0);
  int argcv_meth_parser_363__apply[] = {0};
  meth_meth_parser_363__apply->type = alloc_MethodType(1, argcv_meth_parser_363__apply);
  meth_meth_parser_363__apply->definitionModule = modulename;
  meth_meth_parser_363__apply->definitionLine = 183;
// compiled block node returning block362 (depth = 3)
  gc_frame_newslot(block362);
// starting to compile block node (depth = 3)
  Object block381 = alloc_Block(NULL, NULL, "parser", 195);
  gc_frame_newslot(block381);
// method "_apply"
  block_savedest(block381);
  Object closure382 = createclosure(4, "_apply");
  setclosureframe(closure382, stackframe);
  addtoclosure(closure382, var_n);
  addtoclosure(closure382, var_numOpening);
  addtoclosure(closure382, var_numClosing);
  addtoclosure(closure382, selfslot);
  struct UserObject *uo382 = (struct UserObject*)block381;
  uo382->data[0] = (Object)closure382;
  Method *meth_meth_parser_382__apply = addmethod2pos(block381, "_apply", &meth_parser_382__apply, 0);
  int argcv_meth_parser_382__apply[] = {0};
  meth_meth_parser_382__apply->type = alloc_MethodType(1, argcv_meth_parser_382__apply);
  meth_meth_parser_382__apply->definitionModule = modulename;
  meth_meth_parser_382__apply->definitionLine = 183;
// compiled block node returning block381 (depth = 3)
  gc_frame_newslot(block381);
// call case 5: prelude request
  params[0] = block362;
  params[1] = block381;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call411 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe361);
// compiled call node returning call411 (depth = 2)
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit414 == NULL) {
    strlit414 = alloc_String("rbrace");
    gc_root(strlit414);
  }
// compiled string node returning strlit414 (depth = 4)
  int op_slot_right_413 = gc_frame_newslot(strlit414);
// starting to compile member node (depth = 4)
  int callframe416 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  partcv[0] = 0;
  Object call417 = callmethodflags(*var_n, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe416);
// compiled member node returning call417 (depth = 4)
  int op_slot_left_413 = gc_frame_newslot(call417);
  params[0] = strlit414;
  partcv[0] = 1;
  Object opresult418 = callmethod(call417, "==(1)", 1, partcv, params);
// compiled op node returning opresult418 (depth = 3)
  Object if412 = done;
  if (istrue(opresult418)) {
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe419 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool420 = alloc_Boolean(1);
// compiled identifier node returning bool420 (depth = 4)
  gc_frame_newslot(bool420);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = bool420;
  partcv[0] = 1;
  Object call421 = callmethodflags(*var_result, "found:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe419);
// compiled call node returning call421 (depth = 3)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe422 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call423 = callmethodflags(*var_result, "tok:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe422);
// compiled call node returning call423 (depth = 3)
    gc_frame_newslot(call423);
    if412 = call423;
  } else {
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numClosing (depth = 6)
  int op_slot_right_426 = gc_frame_newslot(*var_numClosing);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numOpening (depth = 6)
  int op_slot_left_426 = gc_frame_newslot(*var_numOpening);
  params[0] = *var_numClosing;
  partcv[0] = 1;
  Object opresult428 = callmethod(*var_numOpening, "==(1)", 1, partcv, params);
// compiled op node returning opresult428 (depth = 5)
  int op_slot_right_425 = gc_frame_newslot(opresult428);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit431 == NULL) {
    strlit431 = alloc_String("rbrace");
    gc_root(strlit431);
  }
// compiled string node returning strlit431 (depth = 6)
  int op_slot_right_430 = gc_frame_newslot(strlit431);
// starting to compile member node (depth = 6)
  int callframe433 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe434 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call435 = callmethodflags(*var_n, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe434);
// compiled member node returning call435 (depth = 7)
  partcv[0] = 0;
  Object call436 = callmethodflags(call435, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe433);
// compiled member node returning call436 (depth = 6)
  int op_slot_left_430 = gc_frame_newslot(call436);
  params[0] = strlit431;
  partcv[0] = 1;
  Object opresult437 = callmethod(call436, "==(1)", 1, partcv, params);
// compiled op node returning opresult437 (depth = 5)
  int op_slot_left_425 = gc_frame_newslot(opresult437);
  params[0] = opresult428;
  partcv[0] = 1;
  Object opresult438 = callmethod(opresult437, "&&(1)", 1, partcv, params);
// compiled op node returning opresult438 (depth = 4)
  Object if424 = done;
  if (istrue(opresult438)) {
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe439 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool440 = alloc_Boolean(1);
// compiled identifier node returning bool440 (depth = 5)
  gc_frame_newslot(bool440);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool440;
  partcv[0] = 1;
  Object call441 = callmethodflags(*var_result, "found:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe439);
// compiled call node returning call441 (depth = 4)
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe442 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe443 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call444 = callmethodflags(*var_n, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe443);
// compiled member node returning call444 (depth = 5)
  gc_frame_newslot(call444);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call444;
  partcv[0] = 1;
  Object call445 = callmethodflags(*var_result, "tok:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe442);
// compiled call node returning call445 (depth = 4)
    gc_frame_newslot(call445);
    if424 = call445;
  } else {
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe446 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool447 = alloc_Boolean(0);
// compiled identifier node returning bool447 (depth = 5)
  gc_frame_newslot(bool447);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool447;
  partcv[0] = 1;
  Object call448 = callmethodflags(*var_result, "found:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe446);
// compiled call node returning call448 (depth = 4)
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe449 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe450 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call451 = callmethodflags(*var_n, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe450);
// compiled member node returning call451 (depth = 5)
  gc_frame_newslot(call451);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call451;
  partcv[0] = 1;
  Object call452 = callmethodflags(*var_result, "tok:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe449);
// compiled call node returning call452 (depth = 4)
    gc_frame_newslot(call452);
    if424 = call452;
  }
// compiled if node returning if424 (depth = 3)
    gc_frame_newslot(if424);
    if412 = if424;
  }
// compiled if node returning if412 (depth = 2)
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_453_accept_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for accept(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  int op_slot_right_454 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 3)
  int callframe456 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call457 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe456);
// compiled member node returning call457 (depth = 3)
  int op_slot_left_454 = gc_frame_newslot(call457);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult458 = callmethod(call457, "==(1)", 1, partcv, params);
// compiled op node returning opresult458 (depth = 2)
  gc_frame_end(frame);
  return opresult458;
}
Object meth_parser_459_acceptKeyword_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptKeyword(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptKeyword(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptKeyword(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_kw = &(stackframe->slots[0]);
  *var_kw = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptKeyword(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit462 == NULL) {
    strlit462 = alloc_String("keyword");
    gc_root(strlit462);
  }
// compiled string node returning strlit462 (depth = 4)
  int op_slot_right_461 = gc_frame_newslot(strlit462);
// starting to compile member node (depth = 4)
  int callframe464 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call465 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe464);
// compiled member node returning call465 (depth = 4)
  int op_slot_left_461 = gc_frame_newslot(call465);
  params[0] = strlit462;
  partcv[0] = 1;
  Object opresult466 = callmethod(call465, "≠(1)", 1, partcv, params);
// compiled op node returning opresult466 (depth = 3)
  Object if460 = done;
  if (istrue(opresult466)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool467 = alloc_Boolean(0);
// compiled identifier node returning bool467 (depth = 4)
  return bool467;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if460 = undefined;
  } else {
  }
// compiled if node returning if460 (depth = 2)
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_kw (depth = 4)
  int op_slot_right_468 = gc_frame_newslot(*var_kw);
// starting to compile member node (depth = 4)
  int callframe470 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call471 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe470);
// compiled member node returning call471 (depth = 4)
  int op_slot_left_468 = gc_frame_newslot(call471);
  params[0] = *var_kw;
  partcv[0] = 1;
  Object opresult472 = callmethod(call471, "==(1)", 1, partcv, params);
// compiled op node returning opresult472 (depth = 3)
  return opresult472;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_473_acceptKeyword_40_1_41_or_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptKeyword(1)or(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptKeyword(_)or(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptKeyword(_)or(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for acceptKeyword(_)or(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_kw1 = &(stackframe->slots[0]);
  *var_kw1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptKeyword(_)");
  Object *var_kw2 = &(stackframe->slots[1]);
  *var_kw2 = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part or(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit476 == NULL) {
    strlit476 = alloc_String("keyword");
    gc_root(strlit476);
  }
// compiled string node returning strlit476 (depth = 4)
  int op_slot_right_475 = gc_frame_newslot(strlit476);
// starting to compile member node (depth = 4)
  int callframe478 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call479 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe478);
// compiled member node returning call479 (depth = 4)
  int op_slot_left_475 = gc_frame_newslot(call479);
  params[0] = strlit476;
  partcv[0] = 1;
  Object opresult480 = callmethod(call479, "≠(1)", 1, partcv, params);
// compiled op node returning opresult480 (depth = 3)
  Object if474 = done;
  if (istrue(opresult480)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool481 = alloc_Boolean(0);
// compiled identifier node returning bool481 (depth = 4)
  return bool481;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if474 = undefined;
  } else {
  }
// compiled if node returning if474 (depth = 2)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_kw1 (depth = 4)
  int op_slot_right_483 = gc_frame_newslot(*var_kw1);
// starting to compile member node (depth = 4)
  int callframe485 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call486 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe485);
// compiled member node returning call486 (depth = 4)
  int op_slot_left_483 = gc_frame_newslot(call486);
  params[0] = *var_kw1;
  partcv[0] = 1;
  Object opresult487 = callmethod(call486, "==(1)", 1, partcv, params);
// compiled op node returning opresult487 (depth = 3)
  Object if482 = done;
  if (istrue(opresult487)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool488 = alloc_Boolean(1);
// compiled identifier node returning bool488 (depth = 4)
  return bool488;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if482 = undefined;
  } else {
  }
// compiled if node returning if482 (depth = 2)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_kw2 (depth = 4)
  int op_slot_right_489 = gc_frame_newslot(*var_kw2);
// starting to compile member node (depth = 4)
  int callframe491 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call492 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe491);
// compiled member node returning call492 (depth = 4)
  int op_slot_left_489 = gc_frame_newslot(call492);
  params[0] = *var_kw2;
  partcv[0] = 1;
  Object opresult493 = callmethod(call492, "==(1)", 1, partcv, params);
// compiled op node returning opresult493 (depth = 3)
  return opresult493;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_494_acceptSameLine_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptSameLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptSameLine(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptSameLine(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptSameLine(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastIndent (depth = 5)
  int op_slot_right_497 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 5)
  int callframe499 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call500 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe499);
// compiled member node returning call500 (depth = 5)
  int op_slot_left_497 = gc_frame_newslot(call500);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult501 = callmethod(call500, ">(1)", 1, partcv, params);
// compiled op node returning opresult501 (depth = 4)
  int op_slot_right_496 = gc_frame_newslot(opresult501);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe504 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call505 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe504);
// compiled member node returning call505 (depth = 5)
  int op_slot_right_503 = gc_frame_newslot(call505);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_503 = gc_frame_newslot(*var_lastLine);
  params[0] = call505;
  partcv[0] = 1;
  Object opresult507 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult507 (depth = 4)
  int op_slot_left_496 = gc_frame_newslot(opresult507);
  params[0] = opresult501;
  partcv[0] = 1;
  Object opresult508 = callmethod(opresult507, "||(1)", 1, partcv, params);
// compiled op node returning opresult508 (depth = 3)
  int op_slot_right_495 = gc_frame_newslot(opresult508);
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_510 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe512 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call513 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe512);
// compiled member node returning call513 (depth = 4)
  int op_slot_left_510 = gc_frame_newslot(call513);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult514 = callmethod(call513, "==(1)", 1, partcv, params);
// compiled op node returning opresult514 (depth = 3)
  int op_slot_left_495 = gc_frame_newslot(opresult514);
  params[0] = opresult508;
  partcv[0] = 1;
  Object opresult515 = callmethod(opresult514, "&&(1)", 1, partcv, params);
// compiled op node returning opresult515 (depth = 2)
  gc_frame_end(frame);
  return opresult515;
}
Object meth_parser_516_acceptWithoutSpaces_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptWithoutSpaces(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptWithoutSpaces(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptWithoutSpaces(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptWithoutSpaces(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe520 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call521 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe520);
// compiled member node returning call521 (depth = 5)
  int op_slot_right_519 = gc_frame_newslot(call521);
// starting to compile member node (depth = 5)
  int callframe523 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call524 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe523);
// compiled member node returning call524 (depth = 5)
  int op_slot_left_519 = gc_frame_newslot(call524);
  params[0] = call521;
  partcv[0] = 1;
  Object sum525 = callmethod(call524, "+(1)", 1, partcv, params);
// compiled op node returning sum525 (depth = 4)
  int op_slot_right_518 = gc_frame_newslot(sum525);
// starting to compile member node (depth = 4)
  int callframe527 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call528 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe527);
// compiled member node returning call528 (depth = 4)
  int op_slot_left_518 = gc_frame_newslot(call528);
  params[0] = sum525;
  partcv[0] = 1;
  Object opresult529 = callmethod(call528, "==(1)", 1, partcv, params);
// compiled op node returning opresult529 (depth = 3)
  int op_slot_right_517 = gc_frame_newslot(opresult529);
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe533 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call534 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe533);
// compiled member node returning call534 (depth = 5)
  int op_slot_right_532 = gc_frame_newslot(call534);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_532 = gc_frame_newslot(*var_lastLine);
  params[0] = call534;
  partcv[0] = 1;
  Object opresult536 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult536 (depth = 4)
  int op_slot_right_531 = gc_frame_newslot(opresult536);
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  int op_slot_right_538 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 5)
  int callframe540 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call541 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe540);
// compiled member node returning call541 (depth = 5)
  int op_slot_left_538 = gc_frame_newslot(call541);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult542 = callmethod(call541, "==(1)", 1, partcv, params);
// compiled op node returning opresult542 (depth = 4)
  int op_slot_left_531 = gc_frame_newslot(opresult542);
  params[0] = opresult536;
  partcv[0] = 1;
  Object opresult543 = callmethod(opresult542, "&&(1)", 1, partcv, params);
// compiled op node returning opresult543 (depth = 3)
  int op_slot_left_517 = gc_frame_newslot(opresult543);
  params[0] = opresult529;
  partcv[0] = 1;
  Object opresult544 = callmethod(opresult543, "&&(1)", 1, partcv, params);
// compiled op node returning opresult544 (depth = 2)
  gc_frame_end(frame);
  return opresult544;
}
Object meth_parser_545_accept_40_1_41_onLineOf_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)onLineOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOf(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOf(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)onLineOf(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLineOf(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe549 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call550 = callmethodflags(*var_other, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe549);
// compiled member node returning call550 (depth = 5)
  int op_slot_right_548 = gc_frame_newslot(call550);
// starting to compile member node (depth = 5)
  int callframe552 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call553 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe552);
// compiled member node returning call553 (depth = 5)
  int op_slot_left_548 = gc_frame_newslot(call553);
  params[0] = call550;
  partcv[0] = 1;
  Object opresult554 = callmethod(call553, ">(1)", 1, partcv, params);
// compiled op node returning opresult554 (depth = 4)
  int op_slot_right_547 = gc_frame_newslot(opresult554);
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe557 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call558 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe557);
// compiled member node returning call558 (depth = 5)
  int op_slot_right_556 = gc_frame_newslot(call558);
// starting to compile member node (depth = 5)
  int callframe560 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call561 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe560);
// compiled member node returning call561 (depth = 5)
  int op_slot_left_556 = gc_frame_newslot(call561);
  params[0] = call558;
  partcv[0] = 1;
  Object opresult562 = callmethod(call561, "==(1)", 1, partcv, params);
// compiled op node returning opresult562 (depth = 4)
  int op_slot_left_547 = gc_frame_newslot(opresult562);
  params[0] = opresult554;
  partcv[0] = 1;
  Object opresult563 = callmethod(opresult562, "||(1)", 1, partcv, params);
// compiled op node returning opresult563 (depth = 3)
  int op_slot_right_546 = gc_frame_newslot(opresult563);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_565 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe567 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call568 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe567);
// compiled member node returning call568 (depth = 4)
  int op_slot_left_565 = gc_frame_newslot(call568);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult569 = callmethod(call568, "==(1)", 1, partcv, params);
// compiled op node returning opresult569 (depth = 3)
  int op_slot_left_546 = gc_frame_newslot(opresult569);
  params[0] = opresult563;
  partcv[0] = 1;
  Object opresult570 = callmethod(opresult569, "&&(1)", 1, partcv, params);
// compiled op node returning opresult570 (depth = 2)
  gc_frame_end(frame);
  return opresult570;
}
Object meth_parser_571_accept_40_1_41_onLineOfLastOr_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)onLineOfLastOr(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOfLastOr(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOfLastOr(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastLine = getfromclosure(closure, 1);
  Object *var_lastIndent = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)onLineOfLastOr(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLineOfLastOr(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_573 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe575 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call576 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe575);
// compiled member node returning call576 (depth = 4)
  int op_slot_left_573 = gc_frame_newslot(call576);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult577 = callmethod(call576, "≠(1)", 1, partcv, params);
// compiled op node returning opresult577 (depth = 3)
  Object if572 = done;
  if (istrue(opresult577)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool578 = alloc_Boolean(0);
// compiled identifier node returning bool578 (depth = 4)
  return bool578;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if572 = undefined;
  } else {
  }
// compiled if node returning if572 (depth = 2)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call582 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe581);
// compiled member node returning call582 (depth = 4)
  int op_slot_right_580 = gc_frame_newslot(call582);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_580 = gc_frame_newslot(*var_lastLine);
  params[0] = call582;
  partcv[0] = 1;
  Object opresult584 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult584 (depth = 3)
  Object if579 = done;
  if (istrue(opresult584)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool585 = alloc_Boolean(1);
// compiled identifier node returning bool585 (depth = 4)
  return bool585;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if579 = undefined;
  } else {
  }
// compiled if node returning if579 (depth = 2)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_587 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
  int callframe589 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call590 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe589);
// compiled member node returning call590 (depth = 4)
  int op_slot_left_587 = gc_frame_newslot(call590);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult591 = callmethod(call590, ">(1)", 1, partcv, params);
// compiled op node returning opresult591 (depth = 3)
  Object if586 = done;
  if (istrue(opresult591)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool592 = alloc_Boolean(1);
// compiled identifier node returning bool592 (depth = 4)
  return bool592;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if586 = undefined;
  } else {
  }
// compiled if node returning if586 (depth = 2)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe595 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call596 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe595);
// compiled member node returning call596 (depth = 4)
  int op_slot_right_594 = gc_frame_newslot(call596);
// starting to compile member node (depth = 4)
  int callframe598 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call599 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe598);
// compiled member node returning call599 (depth = 4)
  int op_slot_left_594 = gc_frame_newslot(call599);
  params[0] = call596;
  partcv[0] = 1;
  Object opresult600 = callmethod(call599, "==(1)", 1, partcv, params);
// compiled op node returning opresult600 (depth = 3)
  Object if593 = done;
  if (istrue(opresult600)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool601 = alloc_Boolean(1);
// compiled identifier node returning bool601 (depth = 4)
  return bool601;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if593 = undefined;
  } else {
  }
// compiled if node returning if593 (depth = 2)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe604 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call605 = callmethodflags(*var_other, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe604);
// compiled member node returning call605 (depth = 4)
  int op_slot_right_603 = gc_frame_newslot(call605);
// starting to compile member node (depth = 4)
  int callframe607 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call608 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe607);
// compiled member node returning call608 (depth = 4)
  int op_slot_left_603 = gc_frame_newslot(call608);
  params[0] = call605;
  partcv[0] = 1;
  Object opresult609 = callmethod(call608, ">(1)", 1, partcv, params);
// compiled op node returning opresult609 (depth = 3)
  Object if602 = done;
  if (istrue(opresult609)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool610 = alloc_Boolean(1);
// compiled identifier node returning bool610 (depth = 4)
  return bool610;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if602 = undefined;
  } else {
  }
// compiled if node returning if602 (depth = 2)
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool611 = alloc_Boolean(0);
// compiled identifier node returning bool611 (depth = 3)
  return bool611;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_612_acceptArgumentOnLineOf_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptArgumentOnLineOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptArgumentOnLineOf(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptArgumentOnLineOf(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptArgumentOnLineOf(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe614 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit615 == NULL) {
    strlit615 = alloc_String("string");
    gc_root(strlit615);
  }
// compiled string node returning strlit615 (depth = 4)
  gc_frame_newslot(strlit615);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit615;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call616 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe614);
// compiled call node returning call616 (depth = 3)
  Object if613 = done;
  if (istrue(call616)) {
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool617 = alloc_Boolean(1);
// compiled identifier node returning bool617 (depth = 4)
  return bool617;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if613 = undefined;
  } else {
  }
// compiled if node returning if613 (depth = 2)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe619 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit620 == NULL) {
    strlit620 = alloc_String("num");
    gc_root(strlit620);
  }
// compiled string node returning strlit620 (depth = 4)
  gc_frame_newslot(strlit620);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit620;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call621 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe619);
// compiled call node returning call621 (depth = 3)
  Object if618 = done;
  if (istrue(call621)) {
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool622 = alloc_Boolean(1);
// compiled identifier node returning bool622 (depth = 4)
  return bool622;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if618 = undefined;
  } else {
  }
// compiled if node returning if618 (depth = 2)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe624 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit625 == NULL) {
    strlit625 = alloc_String("lbrace");
    gc_root(strlit625);
  }
// compiled string node returning strlit625 (depth = 4)
  gc_frame_newslot(strlit625);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit625;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call626 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe624);
// compiled call node returning call626 (depth = 3)
  Object if623 = done;
  if (istrue(call626)) {
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool627 = alloc_Boolean(1);
// compiled identifier node returning bool627 (depth = 4)
  return bool627;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if623 = undefined;
  } else {
  }
// compiled if node returning if623 (depth = 2)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe629 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit630 == NULL) {
    strlit630 = alloc_String("lsquare");
    gc_root(strlit630);
  }
// compiled string node returning strlit630 (depth = 4)
  gc_frame_newslot(strlit630);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit630;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call631 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe629);
// compiled call node returning call631 (depth = 3)
  Object if628 = done;
  if (istrue(call631)) {
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool632 = alloc_Boolean(1);
// compiled identifier node returning bool632 (depth = 4)
  return bool632;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if628 = undefined;
  } else {
  }
// compiled if node returning if628 (depth = 2)
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe634 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit635 == NULL) {
    strlit635 = alloc_String("identifier");
    gc_root(strlit635);
  }
// compiled string node returning strlit635 (depth = 4)
  gc_frame_newslot(strlit635);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit635;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call636 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe634);
// compiled call node returning call636 (depth = 3)
  Object if633 = done;
  if (istrue(call636)) {
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit639 == NULL) {
    strlit639 = alloc_String("false");
    gc_root(strlit639);
  }
// compiled string node returning strlit639 (depth = 6)
  int op_slot_right_638 = gc_frame_newslot(strlit639);
// starting to compile member node (depth = 6)
  int callframe641 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call642 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe641);
// compiled member node returning call642 (depth = 6)
  int op_slot_left_638 = gc_frame_newslot(call642);
  params[0] = strlit639;
  partcv[0] = 1;
  Object opresult643 = callmethod(call642, "==(1)", 1, partcv, params);
// compiled op node returning opresult643 (depth = 5)
  int op_slot_right_637 = gc_frame_newslot(opresult643);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit646 == NULL) {
    strlit646 = alloc_String("true");
    gc_root(strlit646);
  }
// compiled string node returning strlit646 (depth = 6)
  int op_slot_right_645 = gc_frame_newslot(strlit646);
// starting to compile member node (depth = 6)
  int callframe648 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call649 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe648);
// compiled member node returning call649 (depth = 6)
  int op_slot_left_645 = gc_frame_newslot(call649);
  params[0] = strlit646;
  partcv[0] = 1;
  Object opresult650 = callmethod(call649, "==(1)", 1, partcv, params);
// compiled op node returning opresult650 (depth = 5)
  int op_slot_left_637 = gc_frame_newslot(opresult650);
  params[0] = opresult643;
  partcv[0] = 1;
  Object opresult651 = callmethod(opresult650, "||(1)", 1, partcv, params);
// compiled op node returning opresult651 (depth = 4)
  return opresult651;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if633 = undefined;
  } else {
  }
// compiled if node returning if633 (depth = 2)
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool652 = alloc_Boolean(0);
// compiled identifier node returning bool652 (depth = 3)
  return bool652;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_653_tokenOnSameLine(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokenOnSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_655 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
  int callframe657 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call658 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe657);
// compiled member node returning call658 (depth = 4)
  int op_slot_left_655 = gc_frame_newslot(call658);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult659 = callmethod(call658, ">(1)", 1, partcv, params);
// compiled op node returning opresult659 (depth = 3)
  int op_slot_right_654 = gc_frame_newslot(opresult659);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe662 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call663 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe662);
// compiled member node returning call663 (depth = 4)
  int op_slot_right_661 = gc_frame_newslot(call663);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_661 = gc_frame_newslot(*var_lastLine);
  params[0] = call663;
  partcv[0] = 1;
  Object opresult665 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult665 (depth = 3)
  int op_slot_left_654 = gc_frame_newslot(opresult665);
  params[0] = opresult659;
  partcv[0] = 1;
  Object opresult666 = callmethod(opresult665, "||(1)", 1, partcv, params);
// compiled op node returning opresult666 (depth = 2)
  gc_frame_end(frame);
  return opresult666;
}
Object meth_parser_667_tokenOnLineOfLastOr_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokenOnLineOfLastOr(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method tokenOnLineOfLastOr(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastLine = getfromclosure(closure, 1);
  Object *var_lastIndent = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokenOnLineOfLastOr(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part tokenOnLineOfLastOr(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe670 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call671 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe670);
// compiled member node returning call671 (depth = 4)
  int op_slot_right_669 = gc_frame_newslot(call671);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_669 = gc_frame_newslot(*var_lastLine);
  params[0] = call671;
  partcv[0] = 1;
  Object opresult673 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult673 (depth = 3)
  Object if668 = done;
  if (istrue(opresult673)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool674 = alloc_Boolean(1);
// compiled identifier node returning bool674 (depth = 4)
  return bool674;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if668 = undefined;
  } else {
  }
// compiled if node returning if668 (depth = 2)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_676 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
  int callframe678 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call679 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe678);
// compiled member node returning call679 (depth = 4)
  int op_slot_left_676 = gc_frame_newslot(call679);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult680 = callmethod(call679, ">(1)", 1, partcv, params);
// compiled op node returning opresult680 (depth = 3)
  Object if675 = done;
  if (istrue(opresult680)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool681 = alloc_Boolean(1);
// compiled identifier node returning bool681 (depth = 4)
  return bool681;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if675 = undefined;
  } else {
  }
// compiled if node returning if675 (depth = 2)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe684 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call685 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe684);
// compiled member node returning call685 (depth = 4)
  int op_slot_right_683 = gc_frame_newslot(call685);
// starting to compile member node (depth = 4)
  int callframe687 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call688 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe687);
// compiled member node returning call688 (depth = 4)
  int op_slot_left_683 = gc_frame_newslot(call688);
  params[0] = call685;
  partcv[0] = 1;
  Object opresult689 = callmethod(call688, "==(1)", 1, partcv, params);
// compiled op node returning opresult689 (depth = 3)
  Object if682 = done;
  if (istrue(opresult689)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool690 = alloc_Boolean(1);
// compiled identifier node returning bool690 (depth = 4)
  return bool690;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if682 = undefined;
  } else {
  }
// compiled if node returning if682 (depth = 2)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe693 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call694 = callmethodflags(*var_other, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe693);
// compiled member node returning call694 (depth = 4)
  int op_slot_right_692 = gc_frame_newslot(call694);
// starting to compile member node (depth = 4)
  int callframe696 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call697 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe696);
// compiled member node returning call697 (depth = 4)
  int op_slot_left_692 = gc_frame_newslot(call697);
  params[0] = call694;
  partcv[0] = 1;
  Object opresult698 = callmethod(call697, ">(1)", 1, partcv, params);
// compiled op node returning opresult698 (depth = 3)
  Object if691 = done;
  if (istrue(opresult698)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool699 = alloc_Boolean(1);
// compiled identifier node returning bool699 (depth = 4)
  return bool699;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if691 = undefined;
  } else {
  }
// compiled if node returning if691 (depth = 2)
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool700 = alloc_Boolean(0);
// compiled identifier node returning bool700 (depth = 3)
  return bool700;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_701_didConsume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "didConsume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method didConsume(_)");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for didConsume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aParsingBlock = &(stackframe->slots[0]);
  *var_aParsingBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part didConsume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe702 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  partcv[0] = 0;
  Object call703 = callmethodflags(*var_tokens, "size", 1, partcv, params, 0);
  gc_frame_end(callframe702);
// compiled member node returning call703 (depth = 3)
  *var_sz = call703;
  if (call703 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe704 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_aParsingBlock (depth = 3)
  partcv[0] = 0;
  Object call705 = callmethodflags(*var_aParsingBlock, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe704);
// compiled member node returning call705 (depth = 2)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_706 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
  int callframe708 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  partcv[0] = 0;
  Object call709 = callmethodflags(*var_tokens, "size", 1, partcv, params, 0);
  gc_frame_end(callframe708);
// compiled member node returning call709 (depth = 3)
  int op_slot_left_706 = gc_frame_newslot(call709);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult710 = callmethod(call709, "≠(1)", 1, partcv, params);
// compiled op node returning opresult710 (depth = 2)
  gc_frame_end(frame);
  return opresult710;
}
Object meth_parser_711_didNotConsume_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "didNotConsume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method didNotConsume(_)");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for didNotConsume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aParsingBlock = &(stackframe->slots[0]);
  *var_aParsingBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part didNotConsume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe712 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  partcv[0] = 0;
  Object call713 = callmethodflags(*var_tokens, "size", 1, partcv, params, 0);
  gc_frame_end(callframe712);
// compiled member node returning call713 (depth = 3)
  *var_sz = call713;
  if (call713 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe714 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_aParsingBlock (depth = 3)
  partcv[0] = 0;
  Object call715 = callmethodflags(*var_aParsingBlock, "apply", 1, partcv, params, 0);
  gc_frame_end(callframe714);
// compiled member node returning call715 (depth = 2)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_716 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
  int callframe718 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  partcv[0] = 0;
  Object call719 = callmethodflags(*var_tokens, "size", 1, partcv, params, 0);
  gc_frame_end(callframe718);
// compiled member node returning call719 (depth = 3)
  int op_slot_left_716 = gc_frame_newslot(call719);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult720 = callmethod(call719, "==(1)", 1, partcv, params);
// compiled op node returning opresult720 (depth = 2)
  gc_frame_end(frame);
  return opresult720;
}
Object meth_parser_721_pushnum(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushnum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe722 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe723 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call724 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe723);
// compiled member node returning call724 (depth = 4)
  gc_frame_newslot(call724);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe725 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call726 = callmethodflags(*var_ast, "numNode", 1, partcv, params, 0);
  gc_frame_end(callframe725);
// compiled member node returning call726 (depth = 4)
  params[0] = call724;
  partcv[0] = 1;
  Object call727 = callmethodflags(call726, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe722);
// compiled call node returning call727 (depth = 3)
  *var_o = call727;
  if (call727 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe728 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call729 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe728);
// compiled call node returning call729 (depth = 2)
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe730 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call731 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe730);
// compiled member node returning call731 (depth = 2)
  gc_frame_end(frame);
  return call731;
}
Object meth_parser_732_pushstring(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushstring");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe733 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe734 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call735 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe734);
// compiled member node returning call735 (depth = 4)
  gc_frame_newslot(call735);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe736 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call737 = callmethodflags(*var_ast, "stringNode", 1, partcv, params, 0);
  gc_frame_end(callframe736);
// compiled member node returning call737 (depth = 4)
  params[0] = call735;
  partcv[0] = 1;
  Object call738 = callmethodflags(call737, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe733);
// compiled call node returning call738 (depth = 3)
  *var_o = call738;
  if (call738 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe739 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe740 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe741 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call742 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe741);
// compiled member node returning call742 (depth = 4)
  gc_frame_newslot(call742);
// starting to compile member node (depth = 4)
  int callframe743 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call744 = callmethodflags(*var_sym, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe743);
// compiled member node returning call744 (depth = 4)
  gc_frame_newslot(call744);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ast (depth = 4)
  params[0] = call742;
  params[1] = call744;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call745 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe740);
// compiled call node returning call745 (depth = 3)
  gc_frame_newslot(call745);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  params[0] = call745;
  partcv[0] = 1;
  Object call746 = callmethodflags(*var_o, "end:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe739);
// compiled call node returning call746 (depth = 2)
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe747 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call748 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe747);
// compiled call node returning call748 (depth = 2)
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe749 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call750 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe749);
// compiled member node returning call750 (depth = 2)
  gc_frame_end(frame);
  return call750;
}
Object meth_parser_751_pushidentifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushidentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe752 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe753 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call754 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe753);
// compiled member node returning call754 (depth = 3)
  gc_frame_newslot(call754);
// starting to compile member node (depth = 3)
  int callframe755 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call756 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe755);
// compiled member node returning call756 (depth = 3)
  gc_frame_newslot(call756);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call754;
  params[1] = call756;
  partcv[0] = 2;
  Object call757 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe752);
// compiled call node returning call757 (depth = 2)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit760 == NULL) {
    strlit760 = alloc_String("_");
    gc_root(strlit760);
  }
// compiled string node returning strlit760 (depth = 5)
  int op_slot_right_759 = gc_frame_newslot(strlit760);
// starting to compile member node (depth = 5)
  int callframe762 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call763 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe762);
// compiled member node returning call763 (depth = 5)
  int op_slot_left_759 = gc_frame_newslot(call763);
  params[0] = strlit760;
  partcv[0] = 1;
  Object opresult764 = callmethod(call763, "==(1)", 1, partcv, params);
// compiled op node returning opresult764 (depth = 4)
  Object if758 = done;
struct StackFrameObject *iftmpstackframe758 = stackframe;
  if (istrue(opresult764)) {
stackframe = alloc_StackFrame(0, iftmpstackframe758);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe765 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool766 = alloc_Boolean(0);
// compiled identifier node returning bool766 (depth = 5)
  gc_frame_newslot(bool766);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe767 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call768 = callmethodflags(*var_ast, "identifierNode", 1, partcv, params, 0);
  gc_frame_end(callframe767);
// compiled member node returning call768 (depth = 5)
  params[0] = bool766;
  partcv[0] = 1;
  Object call769 = callmethodflags(call768, "wildcard(1)", 1, partcv, params, 0);
  gc_frame_end(callframe765);
// compiled call node returning call769 (depth = 4)
    gc_frame_newslot(call769);
    if758 = call769;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe758);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe770 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe771 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call772 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe771);
// compiled member node returning call772 (depth = 5)
  gc_frame_newslot(call772);
// starting to compile identifier node (depth = 5)
  Object bool773 = alloc_Boolean(0);
// compiled identifier node returning bool773 (depth = 5)
  gc_frame_newslot(bool773);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe774 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call775 = callmethodflags(*var_ast, "identifierNode", 1, partcv, params, 0);
  gc_frame_end(callframe774);
// compiled member node returning call775 (depth = 5)
  params[0] = call772;
  params[1] = bool773;
  partcv[0] = 2;
  Object call776 = callmethodflags(call775, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe770);
// compiled call node returning call776 (depth = 4)
    gc_frame_newslot(call776);
    if758 = call776;
  }
stackframe = iftmpstackframe758;
// compiled if node returning if758 (depth = 3)
  *var_o = if758;
  if (if758 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe777 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call778 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe777);
// compiled call node returning call778 (depth = 2)
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe779 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call780 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe779);
// compiled member node returning call780 (depth = 2)
  gc_frame_end(frame);
  return call780;
}
Object meth_parser_802__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe804 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  partcv[0] = 0;
  Object call805 = callmethodflags(*var_a, "dtype", 1, partcv, params, 0);
  gc_frame_end(callframe804);
// compiled member node returning call805 (depth = 11)
  int op_slot_right_803 = gc_frame_newslot(call805);
// starting to compile identifier node (depth = 11)
  Object bool807 = alloc_Boolean(0);
// compiled identifier node returning bool807 (depth = 11)
  int op_slot_left_803 = gc_frame_newslot(bool807);
  params[0] = call805;
  partcv[0] = 1;
  Object opresult808 = callmethod(bool807, "≠(1)", 1, partcv, params);
// compiled op node returning opresult808 (depth = 10)
  gc_frame_end(frame);
  return opresult808;
}
Object meth_parser_820__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit822 == NULL) {
    strlit822 = alloc_String(":");
    gc_root(strlit822);
  }
// compiled string node returning strlit822 (depth = 11)
  int op_slot_right_821 = gc_frame_newslot(strlit822);
// starting to compile member node (depth = 11)
  int callframe824 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  partcv[0] = 0;
  Object call825 = callmethodflags(*var_tok, "value", 1, partcv, params, 0);
  gc_frame_end(callframe824);
// compiled member node returning call825 (depth = 11)
  int op_slot_left_821 = gc_frame_newslot(call825);
  params[0] = strlit822;
  partcv[0] = 1;
  Object opresult826 = callmethod(call825, "≠(1)", 1, partcv, params);
// compiled op node returning opresult826 (depth = 10)
  gc_frame_end(frame);
  return opresult826;
}
Object meth_parser_829__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe830 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  partcv[0] = 0;
  Object call831 = callmethodflags(*var_tok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe830);
// compiled member node returning call831 (depth = 11)
  *var_tok = call831;
  if (call831 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_798__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_tok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block801 = alloc_Block(NULL, NULL, "parser", 335);
  gc_frame_newslot(block801);
// method "_apply"
  block_savedest(block801);
  Object closure802 = createclosure(2, "_apply");
  setclosureframe(closure802, stackframe);
  addtoclosure(closure802, var_a);
  addtoclosure(closure802, selfslot);
  struct UserObject *uo802 = (struct UserObject*)block801;
  uo802->data[0] = (Object)closure802;
  Method *meth_meth_parser_802__apply = addmethod2pos(block801, "_apply", &meth_parser_802__apply, 0);
  int argcv_meth_parser_802__apply[] = {0};
  meth_meth_parser_802__apply->type = alloc_MethodType(1, argcv_meth_parser_802__apply);
  meth_meth_parser_802__apply->definitionModule = modulename;
  meth_meth_parser_802__apply->definitionLine = 183;
// compiled block node returning block801 (depth = 9)
  int op_slot_right_800 = gc_frame_newslot(block801);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit812 == NULL) {
    strlit812 = alloc_String("identifier");
    gc_root(strlit812);
  }
// compiled string node returning strlit812 (depth = 10)
  int op_slot_right_811 = gc_frame_newslot(strlit812);
// starting to compile member node (depth = 10)
  int callframe814 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  partcv[0] = 0;
  Object call815 = callmethodflags(*var_a, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe814);
// compiled member node returning call815 (depth = 10)
  int op_slot_left_811 = gc_frame_newslot(call815);
  params[0] = strlit812;
  partcv[0] = 1;
  Object opresult816 = callmethod(call815, "==(1)", 1, partcv, params);
// compiled op node returning opresult816 (depth = 9)
  int op_slot_left_800 = gc_frame_newslot(opresult816);
  params[0] = block801;
  partcv[0] = 1;
  Object opresult817 = callmethod(opresult816, "&&(1)", 1, partcv, params);
// compiled op node returning opresult817 (depth = 8)
  Object if799 = done;
  if (istrue(opresult817)) {
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe818 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block819 = alloc_Block(NULL, NULL, "parser", 338);
  gc_frame_newslot(block819);
// method "_apply"
  block_savedest(block819);
  Object closure820 = createclosure(2, "_apply");
  setclosureframe(closure820, stackframe);
  addtoclosure(closure820, var_tok);
  addtoclosure(closure820, selfslot);
  struct UserObject *uo820 = (struct UserObject*)block819;
  uo820->data[0] = (Object)closure820;
  Method *meth_meth_parser_820__apply = addmethod2pos(block819, "_apply", &meth_parser_820__apply, 0);
  int argcv_meth_parser_820__apply[] = {0};
  meth_meth_parser_820__apply->type = alloc_MethodType(1, argcv_meth_parser_820__apply);
  meth_meth_parser_820__apply->definitionModule = modulename;
  meth_meth_parser_820__apply->definitionLine = 183;
// compiled block node returning block819 (depth = 9)
  gc_frame_newslot(block819);
// starting to compile block node (depth = 9)
  Object block828 = alloc_Block(NULL, NULL, "parser", 338);
  gc_frame_newslot(block828);
// method "_apply"
  block_savedest(block828);
  Object closure829 = createclosure(2, "_apply");
  setclosureframe(closure829, stackframe);
  addtoclosure(closure829, var_tok);
  addtoclosure(closure829, selfslot);
  struct UserObject *uo829 = (struct UserObject*)block828;
  uo829->data[0] = (Object)closure829;
  Method *meth_meth_parser_829__apply = addmethod2pos(block828, "_apply", &meth_parser_829__apply, 0);
  int argcv_meth_parser_829__apply[] = {0};
  meth_meth_parser_829__apply->type = alloc_MethodType(1, argcv_meth_parser_829__apply);
  meth_meth_parser_829__apply->definitionModule = modulename;
  meth_meth_parser_829__apply->definitionLine = 183;
// compiled block node returning block828 (depth = 9)
  gc_frame_newslot(block828);
// call case 5: prelude request
  params[0] = block819;
  params[1] = block828;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call834 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe818);
// compiled call node returning call834 (depth = 8)
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe835 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe836 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call837 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe836);
// compiled member node returning call837 (depth = 10)
  partcv[0] = 0;
  Object call838 = callmethodflags(call837, "new", 1, partcv, params, 0);
  gc_frame_end(callframe835);
// compiled member node returning call838 (depth = 9)
  *var_suggestion = call838;
  if (call838 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe839 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// starting to compile member node (depth = 9)
  int callframe840 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call841 = callmethodflags(*var_tok, "next", 1, partcv, params, 0);
  gc_frame_end(callframe840);
// compiled member node returning call841 (depth = 9)
  gc_frame_newslot(call841);
// starting to compile identifier node (depth = 9)
  Object bool842 = alloc_Boolean(1);
// compiled identifier node returning bool842 (depth = 9)
  gc_frame_newslot(bool842);
// starting to compile identifier node (depth = 9)
  Object bool843 = alloc_Boolean(0);
// compiled identifier node returning bool843 (depth = 9)
  gc_frame_newslot(bool843);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_tok;
  params[1] = call841;
  params[2] = bool842;
  params[3] = bool843;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call844 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe839);
// compiled call node returning call844 (depth = 8)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe845 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit846 == NULL) {
    strlit846 = alloc_String("an argument to an annotation cannot have a type.");
    gc_root(strlit846);
  }
// compiled string node returning strlit846 (depth = 9)
  gc_frame_newslot(strlit846);
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe847 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call848 = callmethodflags(*var_tok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe847);
// compiled member node returning call848 (depth = 9)
  gc_frame_newslot(call848);
// starting to compile member node (depth = 9)
  int callframe849 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call850 = callmethodflags(*var_tok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe849);
// compiled member node returning call850 (depth = 9)
  gc_frame_newslot(call850);
// starting to compile member node (depth = 9)
  int callframe851 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe852 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call853 = callmethodflags(*var_tok, "next", 1, partcv, params, 0);
  gc_frame_end(callframe852);
// compiled member node returning call853 (depth = 10)
  partcv[0] = 0;
  Object call854 = callmethodflags(call853, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe851);
// compiled member node returning call854 (depth = 9)
  gc_frame_newslot(call854);
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit846;
  params[1] = call848;
  params[2] = call850;
  params[3] = call854;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call855 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe845);
// compiled call node returning call855 (depth = 8)
    gc_frame_newslot(call855);
    if799 = call855;
  } else {
  }
// compiled if node returning if799 (depth = 7)
  gc_frame_end(frame);
  return if799;
}
Object meth_parser_793__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe794 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe795 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call796 = callmethodflags(*var_p, "args", 1, partcv, params, 0);
  gc_frame_end(callframe795);
// compiled member node returning call796 (depth = 6)
  gc_frame_newslot(call796);
// starting to compile block node (depth = 6)
  Object block797 = alloc_Block(NULL, NULL, "parser", 334);
  gc_frame_newslot(block797);
// method "_apply(_)"
  block_savedest(block797);
  Object closure798 = createclosure(3, "_apply(1)");
  setclosureframe(closure798, stackframe);
  addtoclosure(closure798, var_sym);
  addtoclosure(closure798, var_errormessages);
  addtoclosure(closure798, selfslot);
  struct UserObject *uo798 = (struct UserObject*)block797;
  uo798->data[0] = (Object)closure798;
  Method *meth_meth_parser_798__apply_40_1_41_ = addmethod2pos(block797, "_apply(1)", &meth_parser_798__apply_40_1_41_, 0);
  int argcv_meth_parser_798__apply_40_1_41_[] = {1};
  meth_meth_parser_798__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_798__apply_40_1_41_);
  meth_meth_parser_798__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_798__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block797 (depth = 6)
  gc_frame_newslot(block797);
// call case 5: prelude request
  params[0] = call796;
  params[1] = block797;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call857 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe794);
// compiled call node returning call857 (depth = 5)
  gc_frame_end(frame);
  return call857;
}
Object meth_parser_781_checkAnnotation_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkAnnotation(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method checkAnnotation(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkAnnotation(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part checkAnnotation(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit784 == NULL) {
    strlit784 = alloc_String("call");
    gc_root(strlit784);
  }
// compiled string node returning strlit784 (depth = 4)
  int op_slot_right_783 = gc_frame_newslot(strlit784);
// starting to compile member node (depth = 4)
  int callframe786 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ann (depth = 5)
  partcv[0] = 0;
  Object call787 = callmethodflags(*var_ann, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe786);
// compiled member node returning call787 (depth = 4)
  int op_slot_left_783 = gc_frame_newslot(call787);
  params[0] = strlit784;
  partcv[0] = 1;
  Object opresult788 = callmethod(call787, "==(1)", 1, partcv, params);
// compiled op node returning opresult788 (depth = 3)
  Object if782 = done;
  if (istrue(opresult788)) {
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe789 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe790 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ann (depth = 5)
  partcv[0] = 0;
  Object call791 = callmethodflags(*var_ann, "parts", 1, partcv, params, 0);
  gc_frame_end(callframe790);
// compiled member node returning call791 (depth = 4)
  gc_frame_newslot(call791);
// starting to compile block node (depth = 4)
  Object block792 = alloc_Block(NULL, NULL, "parser", 333);
  gc_frame_newslot(block792);
// method "_apply(_)"
  block_savedest(block792);
  Object closure793 = createclosure(3, "_apply(1)");
  setclosureframe(closure793, stackframe);
  addtoclosure(closure793, var_sym);
  addtoclosure(closure793, var_errormessages);
  addtoclosure(closure793, selfslot);
  struct UserObject *uo793 = (struct UserObject*)block792;
  uo793->data[0] = (Object)closure793;
  Method *meth_meth_parser_793__apply_40_1_41_ = addmethod2pos(block792, "_apply(1)", &meth_parser_793__apply_40_1_41_, 0);
  int argcv_meth_parser_793__apply_40_1_41_[] = {1};
  meth_meth_parser_793__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_793__apply_40_1_41_);
  meth_meth_parser_793__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_793__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block792 (depth = 4)
  gc_frame_newslot(block792);
// call case 5: prelude request
  params[0] = call791;
  params[1] = block792;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call859 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe789);
// compiled call node returning call859 (depth = 3)
    gc_frame_newslot(call859);
    if782 = call859;
  } else {
  }
// compiled if node returning if782 (depth = 2)
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ann (depth = 2)
  gc_frame_end(frame);
  return *var_ann;
}
Object meth_parser_874__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe875 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_noBlocks (depth = 6)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call876 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe875);
// compiled call node returning call876 (depth = 5)
  gc_frame_end(frame);
  return call876;
}
Object meth_parser_883__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe884 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit885 == NULL) {
    strlit885 = alloc_String("comma");
    gc_root(strlit885);
  }
// compiled string node returning strlit885 (depth = 5)
  gc_frame_newslot(strlit885);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit885;
  partcv[0] = 1;
  Object call886 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe884);
// compiled call node returning call886 (depth = 4)
  gc_frame_end(frame);
  return call886;
}
Object meth_parser_901__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe902 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_noBlocks (depth = 8)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call903 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe902);
// compiled call node returning call903 (depth = 7)
  gc_frame_end(frame);
  return call903;
}
Object meth_parser_889__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_anns = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe890 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe891 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe892 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call893 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe892);
// compiled member node returning call893 (depth = 6)
  gc_frame_newslot(call893);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = call893;
  partcv[0] = 1;
  Object call894 = callmethodflags(module_parser, "checkAnnotation(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe891);
// compiled call node returning call894 (depth = 5)
  gc_frame_newslot(call894);
// call case 6: other requests
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  params[0] = call894;
  partcv[0] = 1;
  Object call895 = callmethodflags(*var_anns, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe890);
// compiled call node returning call895 (depth = 4)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe896 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call897 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe896);
// compiled member node returning call897 (depth = 4)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe899 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block900 = alloc_Block(NULL, NULL, "parser", 362);
  gc_frame_newslot(block900);
// method "_apply"
  block_savedest(block900);
  Object closure901 = createclosure(2, "_apply");
  setclosureframe(closure901, stackframe);
  addtoclosure(closure901, var_noBlocks);
  addtoclosure(closure901, selfslot);
  struct UserObject *uo901 = (struct UserObject*)block900;
  uo901->data[0] = (Object)closure901;
  Method *meth_meth_parser_901__apply = addmethod2pos(block900, "_apply", &meth_parser_901__apply, 0);
  int argcv_meth_parser_901__apply[] = {0};
  meth_meth_parser_901__apply->type = alloc_MethodType(1, argcv_meth_parser_901__apply);
  meth_meth_parser_901__apply->definitionModule = modulename;
  meth_meth_parser_901__apply->definitionLine = 183;
// compiled block node returning block900 (depth = 6)
  gc_frame_newslot(block900);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block900;
  partcv[0] = 1;
  Object call905 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe899);
// compiled call node returning call905 (depth = 5)
  Object if898 = done;
  if (istrue(call905)) {
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe906 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call907 = callmethodflags(self, "errorMissingAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe906);
// compiled member node returning call907 (depth = 5)
    gc_frame_newslot(call907);
    if898 = call907;
  } else {
  }
// compiled if node returning if898 (depth = 4)
  gc_frame_end(frame);
  return if898;
}
Object meth_parser_860_doannotation(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doannotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_anns = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "anns");
// definebindings:
// definebindings:
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe862 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe863 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit864 == NULL) {
    strlit864 = alloc_String("is");
    gc_root(strlit864);
  }
// compiled string node returning strlit864 (depth = 5)
  gc_frame_newslot(strlit864);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit864;
  partcv[0] = 1;
  Object call865 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe863);
// compiled call node returning call865 (depth = 4)
  partcv[0] = 0;
  Object call866 = callmethodflags(call865, "not", 1, partcv, params, 0);
  gc_frame_end(callframe862);
// compiled member node returning call866 (depth = 3)
  Object if861 = done;
  if (istrue(call866)) {
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool867 = alloc_Boolean(0);
// compiled identifier node returning bool867 (depth = 4)
  return bool867;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if861 = undefined;
  } else {
  }
// compiled if node returning if861 (depth = 2)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call869 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe868);
// compiled member node returning call869 (depth = 2)
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array870 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array870 (depth = 3)
  *var_anns = array870;
  if (array870 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe872 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block873 = alloc_Block(NULL, NULL, "parser", 356);
  gc_frame_newslot(block873);
// method "_apply"
  block_savedest(block873);
  Object closure874 = createclosure(2, "_apply");
  setclosureframe(closure874, stackframe);
  addtoclosure(closure874, var_noBlocks);
  addtoclosure(closure874, selfslot);
  struct UserObject *uo874 = (struct UserObject*)block873;
  uo874->data[0] = (Object)closure874;
  Method *meth_meth_parser_874__apply = addmethod2pos(block873, "_apply", &meth_parser_874__apply, 0);
  int argcv_meth_parser_874__apply[] = {0};
  meth_meth_parser_874__apply->type = alloc_MethodType(1, argcv_meth_parser_874__apply);
  meth_meth_parser_874__apply->definitionModule = modulename;
  meth_meth_parser_874__apply->definitionLine = 183;
// compiled block node returning block873 (depth = 4)
  gc_frame_newslot(block873);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = block873;
  partcv[0] = 1;
  Object call878 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe872);
// compiled call node returning call878 (depth = 3)
  Object if871 = done;
  if (istrue(call878)) {
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe879 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call880 = callmethodflags(self, "errorMissingAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe879);
// compiled member node returning call880 (depth = 3)
    gc_frame_newslot(call880);
    if871 = call880;
  } else {
  }
// compiled if node returning if871 (depth = 2)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe881 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block882 = alloc_Block(NULL, NULL, "parser", 359);
  gc_frame_newslot(block882);
// method "_apply"
  block_savedest(block882);
  Object closure883 = createclosure(1, "_apply");
  setclosureframe(closure883, stackframe);
  addtoclosure(closure883, selfslot);
  struct UserObject *uo883 = (struct UserObject*)block882;
  uo883->data[0] = (Object)closure883;
  Method *meth_meth_parser_883__apply = addmethod2pos(block882, "_apply", &meth_parser_883__apply, 0);
  int argcv_meth_parser_883__apply[] = {0};
  meth_meth_parser_883__apply->type = alloc_MethodType(1, argcv_meth_parser_883__apply);
  meth_meth_parser_883__apply->definitionModule = modulename;
  meth_meth_parser_883__apply->definitionLine = 183;
// compiled block node returning block882 (depth = 3)
  gc_frame_newslot(block882);
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block888 = alloc_Block(NULL, NULL, "parser", 359);
  gc_frame_newslot(block888);
// method "_apply"
  block_savedest(block888);
  Object closure889 = createclosure(4, "_apply");
  setclosureframe(closure889, stackframe);
  addtoclosure(closure889, var_values);
  addtoclosure(closure889, var_anns);
  addtoclosure(closure889, var_noBlocks);
  addtoclosure(closure889, selfslot);
  struct UserObject *uo889 = (struct UserObject*)block888;
  uo889->data[0] = (Object)closure889;
  Method *meth_meth_parser_889__apply = addmethod2pos(block888, "_apply", &meth_parser_889__apply, 0);
  int argcv_meth_parser_889__apply[] = {0};
  meth_meth_parser_889__apply->type = alloc_MethodType(1, argcv_meth_parser_889__apply);
  meth_meth_parser_889__apply->definitionModule = modulename;
  meth_meth_parser_889__apply->definitionLine = 183;
// compiled block node returning block888 (depth = 3)
  gc_frame_newslot(block888);
// call case 5: prelude request
  params[0] = block882;
  params[1] = block888;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call909 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe881);
// compiled call node returning call909 (depth = 2)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe910 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe911 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe912 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call913 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe912);
// compiled member node returning call913 (depth = 4)
  gc_frame_newslot(call913);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = call913;
  partcv[0] = 1;
  Object call914 = callmethodflags(module_parser, "checkAnnotation(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe911);
// compiled call node returning call914 (depth = 3)
  gc_frame_newslot(call914);
// call case 6: other requests
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_anns (depth = 3)
  params[0] = call914;
  partcv[0] = 1;
  Object call915 = callmethodflags(*var_anns, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe910);
// compiled call node returning call915 (depth = 2)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_anns (depth = 2)
  gc_frame_end(frame);
  return *var_anns;
}
Object meth_parser_916_errorMissingAnnotation(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "errorMissingAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// definebindings:
// definebindings:
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array917 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array917 (depth = 3)
  *var_suggestions = array917;
  if (array917 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe918 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe919 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call920 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe919);
// compiled member node returning call920 (depth = 4)
  partcv[0] = 0;
  Object call921 = callmethodflags(call920, "new", 1, partcv, params, 0);
  gc_frame_end(callframe918);
// compiled member node returning call921 (depth = 3)
  *var_suggestion = call921;
  if (call921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe922 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array923 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 5)
  if (strlit924 == NULL) {
    strlit924 = alloc_String("bind");
    gc_root(strlit924);
  }
// compiled string node returning strlit924 (depth = 5)
  params[0] = strlit924;
  partcv[0] = 1;
  callmethodflags(array923, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array923 (depth = 4)
  gc_frame_newslot(array923);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = array923;
  partcv[0] = 1;
  Object call925 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe922);
// compiled call node returning call925 (depth = 3)
  *var_nextTok = call925;
  if (call925 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  int op_slot_right_927 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  int op_slot_left_927 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult929 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult929 (depth = 3)
  Object if926 = done;
  if (istrue(opresult929)) {
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe930 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit931 == NULL) {
    strlit931 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit931);
  }
// compiled string node returning strlit931 (depth = 4)
  gc_frame_newslot(strlit931);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit931;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call932 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe930);
// compiled call node returning call932 (depth = 3)
    gc_frame_newslot(call932);
    if926 = call932;
  } else {
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe933 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 4)
  int callframe934 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  partcv[0] = 0;
  Object call935 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe934);
// compiled member node returning call935 (depth = 4)
  gc_frame_newslot(call935);
// starting to compile identifier node (depth = 4)
  Object bool936 = alloc_Boolean(1);
// compiled identifier node returning bool936 (depth = 4)
  gc_frame_newslot(bool936);
// starting to compile identifier node (depth = 4)
  Object bool937 = alloc_Boolean(0);
// compiled identifier node returning bool937 (depth = 4)
  gc_frame_newslot(bool937);
// starting to compile string node (depth = 4)
  if (strlit938 == NULL) {
    strlit938 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit938);
  }
// compiled string node returning strlit938 (depth = 4)
  gc_frame_newslot(strlit938);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = call935;
  params[2] = bool936;
  params[3] = bool937;
  params[4] = strlit938;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call939 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe933);
// compiled call node returning call939 (depth = 3)
    gc_frame_newslot(call939);
    if926 = call939;
  }
// compiled if node returning if926 (depth = 2)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe940 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call941 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe940);
// compiled call node returning call941 (depth = 2)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe942 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe943 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call944 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe943);
// compiled member node returning call944 (depth = 4)
  partcv[0] = 0;
  Object call945 = callmethodflags(call944, "new", 1, partcv, params, 0);
  gc_frame_end(callframe942);
// compiled member node returning call945 (depth = 3)
  *var_suggestion = call945;
  if (call945 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe947 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 3)
  int callframe948 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  partcv[0] = 0;
  Object call949 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe948);
// compiled member node returning call949 (depth = 3)
  gc_frame_newslot(call949);
// starting to compile identifier node (depth = 3)
  Object bool950 = alloc_Boolean(1);
// compiled identifier node returning bool950 (depth = 3)
  gc_frame_newslot(bool950);
// starting to compile identifier node (depth = 3)
  Object bool951 = alloc_Boolean(0);
// compiled identifier node returning bool951 (depth = 3)
  gc_frame_newslot(bool951);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_lastToken;
  params[1] = call949;
  params[2] = bool950;
  params[3] = bool951;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call952 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe947);
// compiled call node returning call952 (depth = 2)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe953 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call954 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe953);
// compiled call node returning call954 (depth = 2)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe955 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit956 == NULL) {
    strlit956 = alloc_String("one or more annotations separated by commas must follow 'is'.");
    gc_root(strlit956);
  }
// compiled string node returning strlit956 (depth = 3)
  gc_frame_newslot(strlit956);
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe957 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  partcv[0] = 0;
  Object call958 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe957);
// compiled member node returning call958 (depth = 3)
  gc_frame_newslot(call958);
// starting to compile member node (depth = 3)
  int callframe959 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  partcv[0] = 0;
  Object call960 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe959);
// compiled member node returning call960 (depth = 3)
  gc_frame_newslot(call960);
// starting to compile member node (depth = 3)
  int callframe961 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  partcv[0] = 0;
  Object call962 = callmethodflags(*var_lastToken, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe961);
// compiled member node returning call962 (depth = 3)
  gc_frame_newslot(call962);
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = strlit956;
  params[1] = call958;
  params[2] = call960;
  params[3] = call962;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call963 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe955);
// compiled call node returning call963 (depth = 2)
  gc_frame_end(frame);
  return call963;
}
Object meth_parser_964_dotypeterm(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeterm");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe966 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit967 == NULL) {
    strlit967 = alloc_String("identifier");
    gc_root(strlit967);
  }
// compiled string node returning strlit967 (depth = 4)
  gc_frame_newslot(strlit967);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit967;
  partcv[0] = 1;
  Object call968 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe966);
// compiled call node returning call968 (depth = 3)
  Object if965 = done;
  if (istrue(call968)) {
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe969 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call970 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe969);
// compiled member node returning call970 (depth = 3)
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe971 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call972 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe971);
// compiled member node returning call972 (depth = 3)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe973 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call974 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe973);
// compiled call node returning call974 (depth = 3)
    gc_frame_newslot(call974);
    if965 = call974;
  } else {
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe976 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit977 == NULL) {
    strlit977 = alloc_String("type");
    gc_root(strlit977);
  }
// compiled string node returning strlit977 (depth = 5)
  gc_frame_newslot(strlit977);
// starting to compile string node (depth = 5)
  if (strlit978 == NULL) {
    strlit978 = alloc_String("interface");
    gc_root(strlit978);
  }
// compiled string node returning strlit978 (depth = 5)
  gc_frame_newslot(strlit978);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit977;
  params[1] = strlit978;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call979 = callmethodflags(module_parser, "acceptKeyword(1)or(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe976);
// compiled call node returning call979 (depth = 4)
  Object if975 = done;
  if (istrue(call979)) {
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe980 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call981 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe980);
// compiled member node returning call981 (depth = 4)
    gc_frame_newslot(call981);
    if975 = call981;
  } else {
  }
// compiled if node returning if975 (depth = 3)
    gc_frame_newslot(if975);
    if965 = if975;
  }
// compiled if node returning if965 (depth = 2)
  gc_frame_end(frame);
  return if965;
}
Object meth_parser_995__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe996 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call997 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe996);
// compiled member node returning call997 (depth = 6)
  gc_frame_end(frame);
  return call997;
}
Object meth_parser_982_typeexpression(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_noBlocks = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sz");
// definebindings:
  Object *var_prevStatementToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "prevStatementToken");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe983 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  partcv[0] = 0;
  Object call984 = callmethodflags(*var_values, "size", 1, partcv, params, 0);
  gc_frame_end(callframe983);
// compiled member node returning call984 (depth = 3)
  *var_sz = call984;
  if (call984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe986 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit987 == NULL) {
    strlit987 = alloc_String("lparen");
    gc_root(strlit987);
  }
// compiled string node returning strlit987 (depth = 4)
  gc_frame_newslot(strlit987);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit987;
  partcv[0] = 1;
  Object call988 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe986);
// compiled call node returning call988 (depth = 3)
  Object if985 = done;
  if (istrue(call988)) {
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_prevStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe990 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call991 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe990);
// compiled member node returning call991 (depth = 3)
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe993 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block994 = alloc_Block(NULL, NULL, "parser", 406);
  gc_frame_newslot(block994);
// method "_apply"
  block_savedest(block994);
  Object closure995 = createclosure(1, "_apply");
  setclosureframe(closure995, stackframe);
  addtoclosure(closure995, selfslot);
  struct UserObject *uo995 = (struct UserObject*)block994;
  uo995->data[0] = (Object)closure995;
  Method *meth_meth_parser_995__apply = addmethod2pos(block994, "_apply", &meth_parser_995__apply, 0);
  int argcv_meth_parser_995__apply[] = {0};
  meth_meth_parser_995__apply->type = alloc_MethodType(1, argcv_meth_parser_995__apply);
  meth_meth_parser_995__apply->definitionModule = modulename;
  meth_meth_parser_995__apply->definitionLine = 183;
// compiled block node returning block994 (depth = 5)
  gc_frame_newslot(block994);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block994;
  partcv[0] = 1;
  Object call999 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe993);
// compiled call node returning call999 (depth = 4)
  Object if992 = done;
  if (istrue(call999)) {
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1000 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1001 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call1002 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1001);
// compiled member node returning call1002 (depth = 6)
  partcv[0] = 0;
  Object call1003 = callmethodflags(call1002, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1000);
// compiled member node returning call1003 (depth = 5)
  *var_suggestion = call1003;
  if (call1003 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1004 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array1005 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit1006 == NULL) {
    strlit1006 = alloc_String("rparen");
    gc_root(strlit1006);
  }
// compiled string node returning strlit1006 (depth = 7)
  params[0] = strlit1006;
  partcv[0] = 1;
  callmethodflags(array1005, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1005 (depth = 6)
  gc_frame_newslot(array1005);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = array1005;
  partcv[0] = 1;
  Object call1007 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1004);
// compiled call node returning call1007 (depth = 5)
  *var_nextTok = call1007;
  if (call1007 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_1009 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1009 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1011 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1011 (depth = 5)
  Object if1008 = done;
  if (istrue(opresult1011)) {
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1012 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1013 == NULL) {
    strlit1013 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1013);
  }
// compiled string node returning strlit1013 (depth = 6)
  gc_frame_newslot(strlit1013);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1013;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1014 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1012);
// compiled call node returning call1014 (depth = 5)
    gc_frame_newslot(call1014);
    if1008 = call1014;
  } else {
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1015 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe1016 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call1017 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe1016);
// compiled member node returning call1017 (depth = 6)
  gc_frame_newslot(call1017);
// starting to compile identifier node (depth = 6)
  Object bool1018 = alloc_Boolean(1);
// compiled identifier node returning bool1018 (depth = 6)
  gc_frame_newslot(bool1018);
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool1019 = alloc_Boolean(0);
// compiled identifier node returning bool1019 (depth = 6)
  gc_frame_newslot(bool1019);
// starting to compile string node (depth = 6)
  if (strlit1020 == NULL) {
    strlit1020 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1020);
  }
// compiled string node returning strlit1020 (depth = 6)
  gc_frame_newslot(strlit1020);
// call case 6: other requests
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call1017;
  params[2] = bool1018;
  params[3] = bool1019;
  params[4] = strlit1020;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1021 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1015);
// compiled call node returning call1021 (depth = 5)
    gc_frame_newslot(call1021);
    if1008 = call1021;
  }
// compiled if node returning if1008 (depth = 4)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1022 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1023 == NULL) {
    strlit1023 = alloc_String("parentheses must contain a valid type expression.");
    gc_root(strlit1023);
  }
// compiled string node returning strlit1023 (depth = 5)
  gc_frame_newslot(strlit1023);
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1024 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1025 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1024);
// compiled member node returning call1025 (depth = 5)
  gc_frame_newslot(call1025);
// starting to compile member node (depth = 5)
  int callframe1026 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1027 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1026);
// compiled member node returning call1027 (depth = 5)
  gc_frame_newslot(call1027);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1023;
  params[1] = call1025;
  params[2] = call1027;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1028 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1022);
// compiled call node returning call1028 (depth = 4)
    gc_frame_newslot(call1028);
    if992 = call1028;
  } else {
  }
// compiled if node returning if992 (depth = 3)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1031 == NULL) {
    strlit1031 = alloc_String("rparen");
    gc_root(strlit1031);
  }
// compiled string node returning strlit1031 (depth = 5)
  int op_slot_right_1030 = gc_frame_newslot(strlit1031);
// starting to compile member node (depth = 5)
  int callframe1033 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1034 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1033);
// compiled member node returning call1034 (depth = 5)
  int op_slot_left_1030 = gc_frame_newslot(call1034);
  params[0] = strlit1031;
  partcv[0] = 1;
  Object opresult1035 = callmethod(call1034, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1035 (depth = 4)
  Object if1029 = done;
  if (istrue(opresult1035)) {
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1037 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1036);
// compiled member node returning call1037 (depth = 4)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1038 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1039 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call1040 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1039);
// compiled member node returning call1040 (depth = 6)
  partcv[0] = 0;
  Object call1041 = callmethodflags(call1040, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1038);
// compiled member node returning call1041 (depth = 5)
  *var_suggestion = call1041;
  if (call1041 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1042 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1043 == NULL) {
    strlit1043 = alloc_String(")");
    gc_root(strlit1043);
  }
// compiled string node returning strlit1043 (depth = 5)
  gc_frame_newslot(strlit1043);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1043;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1044 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1042);
// compiled call node returning call1044 (depth = 4)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1045 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1046 == NULL) {
    strlit1046 = alloc_String("a type expression beginning with a '(' must end with a ')'.");
    gc_root(strlit1046);
  }
// compiled string node returning strlit1046 (depth = 5)
  gc_frame_newslot(strlit1046);
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1047 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call1048 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1047);
// compiled member node returning call1048 (depth = 5)
  gc_frame_newslot(call1048);
// starting to compile member node (depth = 5)
  int callframe1049 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call1050 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1049);
// compiled member node returning call1050 (depth = 5)
  gc_frame_newslot(call1050);
// starting to compile member node (depth = 5)
  int callframe1051 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call1052 = callmethodflags(*var_lastToken, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe1051);
// compiled member node returning call1052 (depth = 5)
  gc_frame_newslot(call1052);
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1046;
  params[1] = call1048;
  params[2] = call1050;
  params[3] = call1052;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1053 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1045);
// compiled call node returning call1053 (depth = 4)
    gc_frame_newslot(call1053);
    if1029 = call1053;
  } else {
  }
// compiled if node returning if1029 (depth = 3)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_prevStatementToken (depth = 4)
  *var_statementToken = *var_prevStatementToken;
  if (*var_prevStatementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1055 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1056 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1055);
// compiled member node returning call1056 (depth = 3)
    gc_frame_newslot(call1056);
    if985 = call1056;
  } else {
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1057 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1058 = callmethodflags(self, "dotypeterm", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1057);
// compiled member node returning call1058 (depth = 3)
    gc_frame_newslot(call1058);
    if985 = call1058;
  }
// compiled if node returning if985 (depth = 2)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_1060 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
  int callframe1062 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call1063 = callmethodflags(*var_values, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1062);
// compiled member node returning call1063 (depth = 4)
  int op_slot_left_1060 = gc_frame_newslot(call1063);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult1064 = callmethod(call1063, ">(1)", 1, partcv, params);
// compiled op node returning opresult1064 (depth = 3)
  Object if1059 = done;
  if (istrue(opresult1064)) {
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1065 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1066 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1065);
// compiled call node returning call1066 (depth = 3)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1067 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1068 = callmethodflags(self, "typeexpressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1067);
// compiled member node returning call1068 (depth = 3)
    gc_frame_newslot(call1068);
    if1059 = call1068;
  } else {
  }
// compiled if node returning if1059 (depth = 2)
  gc_frame_end(frame);
  return if1059;
}
Object meth_parser_1069_newIf_40_3_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newIf(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method newIf(_,_,_)");
  Object params[3];
  int partcv[1];
  Object *var_ast = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for newIf(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenList = &(stackframe->slots[1]);
  *var_thenList = args[curarg];
  curarg++;
  Object *var_elseList = &(stackframe->slots[2]);
  *var_elseList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part newIf(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_thenBlock = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "thenBlock");
  Object *var_elseBlock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "elseBlock");
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1070 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1071 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1072 = callmethodflags(prelude, "emptySequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1071);
// compiled member node returning call1072 (depth = 4)
  gc_frame_newslot(call1072);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenList (depth = 4)
  gc_frame_newslot(*var_thenList);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1073 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call1074 = callmethodflags(*var_ast, "blockNode", 1, partcv, params, 0);
  gc_frame_end(callframe1073);
// compiled member node returning call1074 (depth = 4)
  params[0] = call1072;
  params[1] = *var_thenList;
  partcv[0] = 2;
  Object call1075 = callmethodflags(call1074, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1070);
// compiled call node returning call1075 (depth = 3)
  *var_thenBlock = call1075;
  if (call1075 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1076 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1077 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1078 = callmethodflags(prelude, "emptySequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1077);
// compiled member node returning call1078 (depth = 4)
  gc_frame_newslot(call1078);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseList (depth = 4)
  gc_frame_newslot(*var_elseList);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1079 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call1080 = callmethodflags(*var_ast, "blockNode", 1, partcv, params, 0);
  gc_frame_end(callframe1079);
// compiled member node returning call1080 (depth = 4)
  params[0] = call1078;
  params[1] = *var_elseList;
  partcv[0] = 2;
  Object call1081 = callmethodflags(call1080, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1076);
// compiled call node returning call1081 (depth = 3)
  *var_elseBlock = call1081;
  if (call1081 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1082 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenBlock (depth = 3)
  gc_frame_newslot(*var_thenBlock);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseBlock (depth = 3)
  gc_frame_newslot(*var_elseBlock);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1083 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ast (depth = 4)
  partcv[0] = 0;
  Object call1084 = callmethodflags(*var_ast, "ifNode", 1, partcv, params, 0);
  gc_frame_end(callframe1083);
// compiled member node returning call1084 (depth = 3)
  params[0] = *var_cond;
  params[1] = *var_thenBlock;
  params[2] = *var_elseBlock;
  partcv[0] = 3;
  Object call1085 = callmethodflags(call1084, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe1082);
// compiled call node returning call1085 (depth = 2)
  gc_frame_end(frame);
  return call1085;
}
Object meth_parser_1086_reportSyntaxError_40_1_41_before_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reportSyntaxError(1)before(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method reportSyntaxError(_)before(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method reportSyntaxError(_)before(_)");
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for reportSyntaxError(_)before(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part reportSyntaxError(_)");
  Object *var_expectedTokens = &(stackframe->slots[1]);
  *var_expectedTokens = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part before(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// definebindings:
// definebindings:
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array1087 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1087 (depth = 3)
  *var_suggestions = array1087;
  if (array1087 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1088 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1089 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call1090 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1089);
// compiled member node returning call1090 (depth = 4)
  partcv[0] = 0;
  Object call1091 = callmethodflags(call1090, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1088);
// compiled member node returning call1091 (depth = 3)
  *var_suggestion = call1091;
  if (call1091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1092 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expectedTokens (depth = 4)
  gc_frame_newslot(*var_expectedTokens);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_expectedTokens;
  partcv[0] = 1;
  Object call1093 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1092);
// compiled call node returning call1093 (depth = 3)
  *var_nextTok = call1093;
  if (call1093 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  int op_slot_right_1095 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  int op_slot_left_1095 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1097 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1097 (depth = 3)
  Object if1094 = done;
  if (istrue(opresult1097)) {
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1098 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1099 == NULL) {
    strlit1099 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1099);
  }
// compiled string node returning strlit1099 (depth = 4)
  gc_frame_newslot(strlit1099);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit1099;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1100 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1098);
// compiled call node returning call1100 (depth = 3)
    gc_frame_newslot(call1100);
    if1094 = call1100;
  } else {
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1101 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 4)
  int callframe1102 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  partcv[0] = 0;
  Object call1103 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe1102);
// compiled member node returning call1103 (depth = 4)
  gc_frame_newslot(call1103);
// starting to compile identifier node (depth = 4)
  Object bool1104 = alloc_Boolean(1);
// compiled identifier node returning bool1104 (depth = 4)
  gc_frame_newslot(bool1104);
// starting to compile identifier node (depth = 4)
  Object bool1105 = alloc_Boolean(0);
// compiled identifier node returning bool1105 (depth = 4)
  gc_frame_newslot(bool1105);
// starting to compile string node (depth = 4)
  if (strlit1106 == NULL) {
    strlit1106 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1106);
  }
// compiled string node returning strlit1106 (depth = 4)
  gc_frame_newslot(strlit1106);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = call1103;
  params[2] = bool1104;
  params[3] = bool1105;
  params[4] = strlit1106;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1107 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1101);
// compiled call node returning call1107 (depth = 3)
    gc_frame_newslot(call1107);
    if1094 = call1107;
  }
// compiled if node returning if1094 (depth = 2)
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1108 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1109 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1108);
// compiled call node returning call1109 (depth = 2)
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1110 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1111 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call1112 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1111);
// compiled member node returning call1112 (depth = 4)
  partcv[0] = 0;
  Object call1113 = callmethodflags(call1112, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1110);
// compiled member node returning call1113 (depth = 3)
  *var_suggestion = call1113;
  if (call1113 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1115 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 3)
  int callframe1116 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  partcv[0] = 0;
  Object call1117 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe1116);
// compiled member node returning call1117 (depth = 3)
  gc_frame_newslot(call1117);
// starting to compile identifier node (depth = 3)
  Object bool1118 = alloc_Boolean(1);
// compiled identifier node returning bool1118 (depth = 3)
  gc_frame_newslot(bool1118);
// starting to compile identifier node (depth = 3)
  Object bool1119 = alloc_Boolean(0);
// compiled identifier node returning bool1119 (depth = 3)
  gc_frame_newslot(bool1119);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_lastToken;
  params[1] = call1117;
  params[2] = bool1118;
  params[3] = bool1119;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1120 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1115);
// compiled call node returning call1120 (depth = 2)
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1121 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1122 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1121);
// compiled call node returning call1122 (depth = 2)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1123 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1124 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call1125 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1124);
// compiled member node returning call1125 (depth = 3)
  gc_frame_newslot(call1125);
// starting to compile member node (depth = 3)
  int callframe1126 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call1127 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1126);
// compiled member node returning call1127 (depth = 3)
  gc_frame_newslot(call1127);
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = *var_message;
  params[1] = call1125;
  params[2] = call1127;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1128 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1123);
// compiled call node returning call1128 (depth = 2)
  gc_frame_end(frame);
  return call1128;
}
Object meth_parser_1129_reportMissingArrow(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reportMissingArrow");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// definebindings:
// definebindings:
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1130 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1131 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call1132 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1131);
// compiled member node returning call1132 (depth = 4)
  partcv[0] = 0;
  Object call1133 = callmethodflags(call1132, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1130);
// compiled member node returning call1133 (depth = 3)
  *var_suggestion = call1133;
  if (call1133 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1137 == NULL) {
    strlit1137 = alloc_String("=");
    gc_root(strlit1137);
  }
// compiled string node returning strlit1137 (depth = 5)
  int op_slot_right_1136 = gc_frame_newslot(strlit1137);
// starting to compile member node (depth = 5)
  int callframe1139 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1140 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe1139);
// compiled member node returning call1140 (depth = 5)
  int op_slot_left_1136 = gc_frame_newslot(call1140);
  params[0] = strlit1137;
  partcv[0] = 1;
  Object opresult1141 = callmethod(call1140, "==(1)", 1, partcv, params);
// compiled op node returning opresult1141 (depth = 4)
  int op_slot_right_1135 = gc_frame_newslot(opresult1141);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1144 == NULL) {
    strlit1144 = alloc_String("bind");
    gc_root(strlit1144);
  }
// compiled string node returning strlit1144 (depth = 5)
  int op_slot_right_1143 = gc_frame_newslot(strlit1144);
// starting to compile member node (depth = 5)
  int callframe1146 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1147 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1146);
// compiled member node returning call1147 (depth = 5)
  int op_slot_left_1143 = gc_frame_newslot(call1147);
  params[0] = strlit1144;
  partcv[0] = 1;
  Object opresult1148 = callmethod(call1147, "==(1)", 1, partcv, params);
// compiled op node returning opresult1148 (depth = 4)
  int op_slot_left_1135 = gc_frame_newslot(opresult1148);
  params[0] = opresult1141;
  partcv[0] = 1;
  Object opresult1149 = callmethod(opresult1148, "||(1)", 1, partcv, params);
// compiled op node returning opresult1149 (depth = 3)
  Object if1134 = done;
  if (istrue(opresult1149)) {
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1150 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 4)
  if (strlit1151 == NULL) {
    strlit1151 = alloc_String("->");
    gc_root(strlit1151);
  }
// compiled string node returning strlit1151 (depth = 4)
  gc_frame_newslot(strlit1151);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = strlit1151;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1152 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1150);
// compiled call node returning call1152 (depth = 3)
    gc_frame_newslot(call1152);
    if1134 = call1152;
  } else {
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1153 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1154 == NULL) {
    strlit1154 = alloc_String(" ->");
    gc_root(strlit1154);
  }
// compiled string node returning strlit1154 (depth = 4)
  gc_frame_newslot(strlit1154);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit1154;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1155 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1153);
// compiled call node returning call1155 (depth = 3)
    gc_frame_newslot(call1155);
    if1134 = call1155;
  }
// compiled if node returning if1134 (depth = 2)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1156 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit1157 == NULL) {
    strlit1157 = alloc_String("in a block with parameters, the parameters must be followed by '->'");
    gc_root(strlit1157);
  }
// compiled string node returning strlit1157 (depth = 3)
  gc_frame_newslot(strlit1157);
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1158 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call1159 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1158);
// compiled member node returning call1159 (depth = 3)
  gc_frame_newslot(call1159);
// starting to compile member node (depth = 3)
  int callframe1160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call1161 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1160);
// compiled member node returning call1161 (depth = 3)
  gc_frame_newslot(call1161);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = strlit1157;
  params[1] = call1159;
  params[2] = call1161;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1162 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1156);
// compiled call node returning call1162 (depth = 2)
  gc_frame_end(frame);
  return call1162;
}
Object meth_parser_1163_reportBadRhs(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reportBadRhs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// definebindings:
// definebindings:
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array1164 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1164 (depth = 3)
  *var_suggestions = array1164;
  if (array1164 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1165 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1166 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call1167 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1166);
// compiled member node returning call1167 (depth = 4)
  partcv[0] = 0;
  Object call1168 = callmethodflags(call1167, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1165);
// compiled member node returning call1168 (depth = 3)
  *var_suggestion = call1168;
  if (call1168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1169 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array1170 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 5)
  if (strlit1171 == NULL) {
    strlit1171 = alloc_String("rbrace");
    gc_root(strlit1171);
  }
// compiled string node returning strlit1171 (depth = 5)
  params[0] = strlit1171;
  partcv[0] = 1;
  callmethodflags(array1170, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1170 (depth = 4)
  gc_frame_newslot(array1170);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = array1170;
  partcv[0] = 1;
  Object call1172 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1169);
// compiled call node returning call1172 (depth = 3)
  *var_nextTok = call1172;
  if (call1172 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  int op_slot_right_1174 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  int op_slot_left_1174 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1176 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1176 (depth = 3)
  Object if1173 = done;
  if (istrue(opresult1176)) {
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1177 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1178 == NULL) {
    strlit1178 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1178);
  }
// compiled string node returning strlit1178 (depth = 4)
  gc_frame_newslot(strlit1178);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit1178;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1179 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1177);
// compiled call node returning call1179 (depth = 3)
    gc_frame_newslot(call1179);
    if1173 = call1179;
  } else {
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1180 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 4)
  int callframe1181 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  partcv[0] = 0;
  Object call1182 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe1181);
// compiled member node returning call1182 (depth = 4)
  gc_frame_newslot(call1182);
// starting to compile identifier node (depth = 4)
  Object bool1183 = alloc_Boolean(1);
// compiled identifier node returning bool1183 (depth = 4)
  gc_frame_newslot(bool1183);
// starting to compile identifier node (depth = 4)
  Object bool1184 = alloc_Boolean(0);
// compiled identifier node returning bool1184 (depth = 4)
  gc_frame_newslot(bool1184);
// starting to compile string node (depth = 4)
  if (strlit1185 == NULL) {
    strlit1185 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1185);
  }
// compiled string node returning strlit1185 (depth = 4)
  gc_frame_newslot(strlit1185);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = call1182;
  params[2] = bool1183;
  params[3] = bool1184;
  params[4] = strlit1185;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1186 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1180);
// compiled call node returning call1186 (depth = 3)
    gc_frame_newslot(call1186);
    if1173 = call1186;
  }
// compiled if node returning if1173 (depth = 2)
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1187 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1188 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1187);
// compiled call node returning call1188 (depth = 2)
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1189 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1190 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call1191 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1190);
// compiled member node returning call1191 (depth = 4)
  partcv[0] = 0;
  Object call1192 = callmethodflags(call1191, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1189);
// compiled member node returning call1192 (depth = 3)
  *var_suggestion = call1192;
  if (call1192 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1194 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 3)
  int callframe1195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  partcv[0] = 0;
  Object call1196 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe1195);
// compiled member node returning call1196 (depth = 3)
  gc_frame_newslot(call1196);
// starting to compile identifier node (depth = 3)
  Object bool1197 = alloc_Boolean(1);
// compiled identifier node returning bool1197 (depth = 3)
  gc_frame_newslot(bool1197);
// starting to compile identifier node (depth = 3)
  Object bool1198 = alloc_Boolean(0);
// compiled identifier node returning bool1198 (depth = 3)
  gc_frame_newslot(bool1198);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_lastToken;
  params[1] = call1196;
  params[2] = bool1197;
  params[3] = bool1198;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1199 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1194);
// compiled call node returning call1199 (depth = 2)
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1200 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1201 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1200);
// compiled call node returning call1201 (depth = 2)
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1202 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit1203 == NULL) {
    strlit1203 = alloc_String("a valid expression must follow ':='.");
    gc_root(strlit1203);
  }
// compiled string node returning strlit1203 (depth = 3)
  gc_frame_newslot(strlit1203);
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1204 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call1205 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1204);
// compiled member node returning call1205 (depth = 3)
  gc_frame_newslot(call1205);
// starting to compile member node (depth = 3)
  int callframe1206 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call1207 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1206);
// compiled member node returning call1207 (depth = 3)
  gc_frame_newslot(call1207);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = strlit1203;
  params[1] = call1205;
  params[2] = call1207;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1208 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1202);
// compiled call node returning call1208 (depth = 2)
  gc_frame_end(frame);
  return call1208;
}
Object meth_parser_1209_block(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "block");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_statementIndent = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_oldMinIndent = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oldMinIndent");
  Object *var_minInd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "minInd");
  Object *var_oldStatementToken = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "oldStatementToken");
  Object *var_oldStatementIndent = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "oldStatementIndent");
  Object *var_isMatchingBlock = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "isMatchingBlock");
  Object *var_savedPosition = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "savedPosition");
  Object *var_params = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "params");
// definebindings:
// definebindings:
  Object *var_blockNode = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "blockNode");
// definebindings:
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1211 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1212 == NULL) {
    strlit1212 = alloc_String("lbrace");
    gc_root(strlit1212);
  }
// compiled string node returning strlit1212 (depth = 4)
  gc_frame_newslot(strlit1212);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit1212;
  partcv[0] = 1;
  Object call1213 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1211);
// compiled call node returning call1213 (depth = 3)
  Object if1210 = done;
  if (istrue(call1213)) {
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1214 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1215 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1214);
// compiled member node returning call1215 (depth = 3)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_oldMinIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1217 = alloc_Float64(2);
// compiled num node returning num1217 (depth = 5)
  int op_slot_right_1216 = gc_frame_newslot(num1217);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1216 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1217;
  partcv[0] = 1;
  Object sum1219 = callmethod(*var_statementIndent, "+(1)", 1, partcv, params);
// compiled op node returning sum1219 (depth = 4)
  *var_minInd = sum1219;
  if (sum1219 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_oldStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_oldStatementIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1221 = alloc_Boolean(0);
// compiled identifier node returning bool1221 (depth = 4)
  *var_isMatchingBlock = bool1221;
  if (bool1221 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1222 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1223 = callmethodflags(self, "saveParsePosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1222);
// compiled member node returning call1223 (depth = 4)
  *var_savedPosition = call1223;
  if (call1223 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1224 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1225 = callmethodflags(self, "blockParameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1224);
// compiled member node returning call1225 (depth = 4)
  *var_params = call1225;
  if (call1225 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1227 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  partcv[0] = 0;
  Object call1228 = callmethodflags(*var_params, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe1227);
// compiled member node returning call1228 (depth = 4)
  Object if1226 = done;
  if (istrue(call1228)) {
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1229 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_savedPosition (depth = 5)
  gc_frame_newslot(*var_savedPosition);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_savedPosition;
  partcv[0] = 1;
  Object call1230 = callmethodflags(module_parser, "restoreParsePosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1229);
// compiled call node returning call1230 (depth = 4)
    gc_frame_newslot(call1230);
    if1226 = call1230;
  } else {
  }
// compiled if node returning if1226 (depth = 3)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1231 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_params;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1232 = callmethodflags(module_parser, "blockBody(1)beginningWith(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1231);
// compiled call node returning call1232 (depth = 4)
  *var_blockNode = call1232;
  if (call1232 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1233 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blockNode (depth = 4)
  gc_frame_newslot(*var_blockNode);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_blockNode;
  partcv[0] = 1;
  Object call1234 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1233);
// compiled call node returning call1234 (depth = 3)
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldMinIndent (depth = 4)
  *var_minIndentLevel = *var_oldMinIndent;
  if (*var_oldMinIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldStatementIndent (depth = 4)
  *var_statementIndent = *var_oldStatementIndent;
  if (*var_oldStatementIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldStatementToken (depth = 4)
  *var_statementToken = *var_oldStatementToken;
  if (*var_oldStatementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1210 = done;
  } else {
  }
// compiled if node returning if1210 (depth = 2)
  gc_frame_end(frame);
  return if1210;
}
Object meth_parser_1242__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_params = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe1243 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_params;
  partcv[0] = 1;
  Object call1244 = callmethodflags(module_parser, "blockParameter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1243);
// compiled call node returning call1244 (depth = 4)
  gc_frame_end(frame);
  return call1244;
}
Object meth_parser_1247__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_params = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1249 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1250 == NULL) {
    strlit1250 = alloc_String("arrow");
    gc_root(strlit1250);
  }
// compiled string node returning strlit1250 (depth = 6)
  gc_frame_newslot(strlit1250);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1250;
  partcv[0] = 1;
  Object call1251 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1249);
// compiled call node returning call1251 (depth = 5)
  Object if1248 = done;
  if (istrue(call1251)) {
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1252 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1253 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1252);
// compiled member node returning call1253 (depth = 5)
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_params (depth = 6)
  block_return(realself, *var_params);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if1248 = undefined;
  } else {
  }
// compiled if node returning if1248 (depth = 4)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1255 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1256 == NULL) {
    strlit1256 = alloc_String("comma");
    gc_root(strlit1256);
  }
// compiled string node returning strlit1256 (depth = 6)
  gc_frame_newslot(strlit1256);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1256;
  partcv[0] = 1;
  Object call1257 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1255);
// compiled call node returning call1257 (depth = 5)
  Object if1254 = done;
  if (istrue(call1257)) {
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1258 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1259 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1258);
// compiled member node returning call1259 (depth = 5)
    gc_frame_newslot(call1259);
    if1254 = call1259;
  } else {
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1260 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1261 = callmethodflags(self, "reportMissingArrow", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1260);
// compiled member node returning call1261 (depth = 5)
    gc_frame_newslot(call1261);
    if1254 = call1261;
  }
// compiled if node returning if1254 (depth = 4)
  gc_frame_end(frame);
  return if1254;
}
Object meth_parser_1238_blockParameters(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "blockParameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_params = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "params");
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array1239 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1239 (depth = 3)
  *var_params = array1239;
  if (array1239 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1240 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1241 = alloc_Block(NULL, NULL, "parser", 529);
  gc_frame_newslot(block1241);
// method "_apply"
  block_savedest(block1241);
  Object closure1242 = createclosure(2, "_apply");
  setclosureframe(closure1242, stackframe);
  addtoclosure(closure1242, var_params);
  addtoclosure(closure1242, selfslot);
  struct UserObject *uo1242 = (struct UserObject*)block1241;
  uo1242->data[0] = (Object)closure1242;
  Method *meth_meth_parser_1242__apply = addmethod2pos(block1241, "_apply", &meth_parser_1242__apply, 0);
  int argcv_meth_parser_1242__apply[] = {0};
  meth_meth_parser_1242__apply->type = alloc_MethodType(1, argcv_meth_parser_1242__apply);
  meth_meth_parser_1242__apply->definitionModule = modulename;
  meth_meth_parser_1242__apply->definitionLine = 183;
// compiled block node returning block1241 (depth = 3)
  gc_frame_newslot(block1241);
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block1246 = alloc_Block(NULL, NULL, "parser", 529);
  gc_frame_newslot(block1246);
// method "_apply"
  block_savedest(block1246);
  Object closure1247 = createclosure(2, "_apply");
  setclosureframe(closure1247, stackframe);
  addtoclosure(closure1247, var_params);
  addtoclosure(closure1247, selfslot);
  struct UserObject *uo1247 = (struct UserObject*)block1246;
  uo1247->data[0] = (Object)closure1247;
  Method *meth_meth_parser_1247__apply = addmethod2pos(block1246, "_apply", &meth_parser_1247__apply, 0);
  int argcv_meth_parser_1247__apply[] = {0};
  meth_meth_parser_1247__apply->type = alloc_MethodType(1, argcv_meth_parser_1247__apply);
  meth_meth_parser_1247__apply->definitionModule = modulename;
  meth_meth_parser_1247__apply->definitionLine = 183;
// compiled block node returning block1246 (depth = 3)
  gc_frame_newslot(block1246);
// call case 5: prelude request
  params[0] = block1241;
  params[1] = block1246;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1263 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1240);
// compiled call node returning call1263 (depth = 2)
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params (depth = 3)
  return *var_params;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_1274__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe1275 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1276 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1275);
// compiled call node returning call1276 (depth = 5)
  gc_frame_end(frame);
  return call1276;
}
Object meth_parser_1342__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 9)
  int callframe1343 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1344 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1343);
// compiled call node returning call1344 (depth = 9)
  gc_frame_end(frame);
  return call1344;
}
Object meth_parser_1264_blockParameter_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockParameter(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method blockParameter(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blockParameter(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params = &(stackframe->slots[0]);
  *var_params = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part blockParameter(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_paramIsPattern = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "paramIsPattern");
// definebindings:
// definebindings:
  Object *var_thisParam = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "thisParam");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1266 == NULL) {
    strlit1266 = alloc_String("lparen");
    gc_root(strlit1266);
  }
// compiled string node returning strlit1266 (depth = 4)
  int op_slot_right_1265 = gc_frame_newslot(strlit1266);
// starting to compile member node (depth = 4)
  int callframe1268 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call1269 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1268);
// compiled member node returning call1269 (depth = 4)
  int op_slot_left_1265 = gc_frame_newslot(call1269);
  params[0] = strlit1266;
  partcv[0] = 1;
  Object opresult1270 = callmethod(call1269, "==(1)", 1, partcv, params);
// compiled op node returning opresult1270 (depth = 3)
  *var_paramIsPattern = opresult1270;
  if (opresult1270 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1272 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1273 = alloc_Block(NULL, NULL, "parser", 550);
  gc_frame_newslot(block1273);
// method "_apply"
  block_savedest(block1273);
  Object closure1274 = createclosure(2, "_apply");
  setclosureframe(closure1274, stackframe);
  addtoclosure(closure1274, var_blocksOK);
  addtoclosure(closure1274, selfslot);
  struct UserObject *uo1274 = (struct UserObject*)block1273;
  uo1274->data[0] = (Object)closure1274;
  Method *meth_meth_parser_1274__apply = addmethod2pos(block1273, "_apply", &meth_parser_1274__apply, 0);
  int argcv_meth_parser_1274__apply[] = {0};
  meth_meth_parser_1274__apply->type = alloc_MethodType(1, argcv_meth_parser_1274__apply);
  meth_meth_parser_1274__apply->definitionModule = modulename;
  meth_meth_parser_1274__apply->definitionLine = 183;
// compiled block node returning block1273 (depth = 4)
  gc_frame_newslot(block1273);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = block1273;
  partcv[0] = 1;
  Object call1278 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1272);
// compiled call node returning call1278 (depth = 3)
  Object if1271 = done;
  if (istrue(call1278)) {
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1281 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1282 == NULL) {
    strlit1282 = alloc_String("colon");
    gc_root(strlit1282);
  }
// compiled string node returning strlit1282 (depth = 6)
  gc_frame_newslot(strlit1282);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1282;
  partcv[0] = 1;
  Object call1283 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1281);
// compiled call node returning call1283 (depth = 5)
  int op_slot_right_1280 = gc_frame_newslot(call1283);
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1286 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1287 == NULL) {
    strlit1287 = alloc_String("arrow");
    gc_root(strlit1287);
  }
// compiled string node returning strlit1287 (depth = 7)
  gc_frame_newslot(strlit1287);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit1287;
  partcv[0] = 1;
  Object call1288 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1286);
// compiled call node returning call1288 (depth = 6)
  int op_slot_right_1285 = gc_frame_newslot(call1288);
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1290 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1291 == NULL) {
    strlit1291 = alloc_String("comma");
    gc_root(strlit1291);
  }
// compiled string node returning strlit1291 (depth = 7)
  gc_frame_newslot(strlit1291);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit1291;
  partcv[0] = 1;
  Object call1292 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1290);
// compiled call node returning call1292 (depth = 6)
  int op_slot_left_1285 = gc_frame_newslot(call1292);
  params[0] = call1288;
  partcv[0] = 1;
  Object opresult1293 = callmethod(call1292, "||(1)", 1, partcv, params);
// compiled op node returning opresult1293 (depth = 5)
  int op_slot_left_1280 = gc_frame_newslot(opresult1293);
  params[0] = call1283;
  partcv[0] = 1;
  Object opresult1294 = callmethod(opresult1293, "||(1)", 1, partcv, params);
// compiled op node returning opresult1294 (depth = 4)
  Object if1279 = done;
  if (istrue(opresult1294)) {
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1295 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call1296 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe1295);
// compiled member node returning call1296 (depth = 5)
  *var_thisParam = call1296;
  if (call1296 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1299 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1300 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_thisParam (depth = 8)
  partcv[0] = 0;
  Object call1301 = callmethodflags(*var_thisParam, "isIdentifier", 1, partcv, params, 0);
  gc_frame_end(callframe1300);
// compiled member node returning call1301 (depth = 7)
  partcv[0] = 0;
  Object call1302 = callmethodflags(call1301, "not", 1, partcv, params, 0);
  gc_frame_end(callframe1299);
// compiled member node returning call1302 (depth = 6)
  int op_slot_right_1298 = gc_frame_newslot(call1302);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_paramIsPattern (depth = 6)
  int op_slot_left_1298 = gc_frame_newslot(*var_paramIsPattern);
  params[0] = call1302;
  partcv[0] = 1;
  Object opresult1304 = callmethod(*var_paramIsPattern, "||(1)", 1, partcv, params);
// compiled op node returning opresult1304 (depth = 5)
  Object if1297 = done;
  if (istrue(opresult1304)) {
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1305 = alloc_Boolean(1);
// compiled identifier node returning bool1305 (depth = 6)
  *var_paramIsPattern = bool1305;
  if (bool1305 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1307 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_thisParam (depth = 7)
  gc_frame_newslot(*var_thisParam);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1308 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call1309 = callmethodflags(*var_ast, "identifierNode", 1, partcv, params, 0);
  gc_frame_end(callframe1308);
// compiled member node returning call1309 (depth = 7)
  params[0] = *var_thisParam;
  partcv[0] = 1;
  Object call1310 = callmethodflags(call1309, "wildcard(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1307);
// compiled call node returning call1310 (depth = 6)
  *var_thisParam = call1310;
  if (call1310 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1297 = done;
  } else {
  }
// compiled if node returning if1297 (depth = 4)
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1312 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool1313 = alloc_Boolean(1);
// compiled identifier node returning bool1313 (depth = 5)
  gc_frame_newslot(bool1313);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_thisParam (depth = 5)
  params[0] = bool1313;
  partcv[0] = 1;
  Object call1314 = callmethodflags(*var_thisParam, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1312);
// compiled call node returning call1314 (depth = 4)
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1317 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1318 == NULL) {
    strlit1318 = alloc_String("colon");
    gc_root(strlit1318);
  }
// compiled string node returning strlit1318 (depth = 7)
  gc_frame_newslot(strlit1318);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit1318;
  partcv[0] = 1;
  Object call1319 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1317);
// compiled call node returning call1319 (depth = 6)
  int op_slot_right_1316 = gc_frame_newslot(call1319);
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_paramIsPattern (depth = 6)
  int op_slot_left_1316 = gc_frame_newslot(*var_paramIsPattern);
  params[0] = call1319;
  partcv[0] = 1;
  Object opresult1321 = callmethod(*var_paramIsPattern, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1321 (depth = 5)
  Object if1315 = done;
  if (istrue(opresult1321)) {
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1322 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1324 == NULL) {
    strlit1324 = alloc_String("_:""\xe2""""\x80""""\xb9""expression""\xe2""""\x80""""\xba"", and so cannot be followed by a colon");
    gc_root(strlit1324);
  }
// compiled string node returning strlit1324 (depth = 7)
  int op_slot_right_1323 = gc_frame_newslot(strlit1324);
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1326 == NULL) {
    strlit1326 = alloc_String("a block parameter that's an  expression is assumed to mean ");
    gc_root(strlit1326);
  }
// compiled string node returning strlit1326 (depth = 7)
  int op_slot_left_1323 = gc_frame_newslot(strlit1326);
  params[0] = strlit1324;
  partcv[0] = 1;
  Object opresult1327 = callmethod(strlit1326, "++(1)", 1, partcv, params);
// compiled op node returning opresult1327 (depth = 6)
  gc_frame_newslot(opresult1327);
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array1328 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit1329 == NULL) {
    strlit1329 = alloc_String("arrow");
    gc_root(strlit1329);
  }
// compiled string node returning strlit1329 (depth = 7)
  params[0] = strlit1329;
  partcv[0] = 1;
  callmethodflags(array1328, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 7)
  if (strlit1330 == NULL) {
    strlit1330 = alloc_String("comma");
    gc_root(strlit1330);
  }
// compiled string node returning strlit1330 (depth = 7)
  params[0] = strlit1330;
  partcv[0] = 1;
  callmethodflags(array1328, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1328 (depth = 6)
  gc_frame_newslot(array1328);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = opresult1327;
  params[1] = array1328;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1331 = callmethodflags(module_parser, "reportSyntaxError(1)before(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1322);
// compiled call node returning call1331 (depth = 5)
    gc_frame_newslot(call1331);
    if1315 = call1331;
  } else {
  }
// compiled if node returning if1315 (depth = 4)
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1333 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1334 == NULL) {
    strlit1334 = alloc_String("colon");
    gc_root(strlit1334);
  }
// compiled string node returning strlit1334 (depth = 6)
  gc_frame_newslot(strlit1334);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1334;
  partcv[0] = 1;
  Object call1335 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1333);
// compiled call node returning call1335 (depth = 5)
  Object if1332 = done;
  if (istrue(call1335)) {
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1336 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1337 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1336);
// compiled member node returning call1337 (depth = 5)
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1339 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1340 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block1341 = alloc_Block(NULL, NULL, "parser", 568);
  gc_frame_newslot(block1341);
// method "_apply"
  block_savedest(block1341);
  Object closure1342 = createclosure(2, "_apply");
  setclosureframe(closure1342, stackframe);
  addtoclosure(closure1342, var_blocksOK);
  addtoclosure(closure1342, selfslot);
  struct UserObject *uo1342 = (struct UserObject*)block1341;
  uo1342->data[0] = (Object)closure1342;
  Method *meth_meth_parser_1342__apply = addmethod2pos(block1341, "_apply", &meth_parser_1342__apply, 0);
  int argcv_meth_parser_1342__apply[] = {0};
  meth_meth_parser_1342__apply->type = alloc_MethodType(1, argcv_meth_parser_1342__apply);
  meth_meth_parser_1342__apply->definitionModule = modulename;
  meth_meth_parser_1342__apply->definitionLine = 183;
// compiled block node returning block1341 (depth = 8)
  gc_frame_newslot(block1341);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block1341;
  partcv[0] = 1;
  Object call1346 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1340);
// compiled call node returning call1346 (depth = 7)
  partcv[0] = 0;
  Object call1347 = callmethodflags(call1346, "not", 1, partcv, params, 0);
  gc_frame_end(callframe1339);
// compiled member node returning call1347 (depth = 6)
  Object if1338 = done;
  if (istrue(call1347)) {
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1348 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1349 == NULL) {
    strlit1349 = alloc_String("a block parameter must have a pattern or type expression after the ':'.");
    gc_root(strlit1349);
  }
// compiled string node returning strlit1349 (depth = 7)
  gc_frame_newslot(strlit1349);
// starting to compile array node (depth = 7)
  Object array1350 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit1351 == NULL) {
    strlit1351 = alloc_String("arrow");
    gc_root(strlit1351);
  }
// compiled string node returning strlit1351 (depth = 8)
  params[0] = strlit1351;
  partcv[0] = 1;
  callmethodflags(array1350, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 8)
  if (strlit1352 == NULL) {
    strlit1352 = alloc_String("rbrace");
    gc_root(strlit1352);
  }
// compiled string node returning strlit1352 (depth = 8)
  params[0] = strlit1352;
  partcv[0] = 1;
  callmethodflags(array1350, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1350 (depth = 7)
  gc_frame_newslot(array1350);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit1349;
  params[1] = array1350;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1353 = callmethodflags(module_parser, "reportSyntaxError(1)before(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1348);
// compiled call node returning call1353 (depth = 6)
    gc_frame_newslot(call1353);
    if1338 = call1353;
  } else {
  }
// compiled if node returning if1338 (depth = 5)
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1354 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe1355 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call1356 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe1355);
// compiled member node returning call1356 (depth = 6)
  gc_frame_newslot(call1356);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_thisParam (depth = 6)
  params[0] = call1356;
  partcv[0] = 1;
  Object call1357 = callmethodflags(*var_thisParam, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1354);
// compiled call node returning call1357 (depth = 5)
    gc_frame_newslot(call1357);
    if1332 = call1357;
  } else {
  }
// compiled if node returning if1332 (depth = 4)
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1358 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_thisParam (depth = 5)
  gc_frame_newslot(*var_thisParam);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  params[0] = *var_thisParam;
  partcv[0] = 1;
  Object call1359 = callmethodflags(*var_params, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1358);
// compiled call node returning call1359 (depth = 4)
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1360 = alloc_Boolean(1);
// compiled identifier node returning bool1360 (depth = 5)
  return bool1360;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1279 = undefined;
  } else {
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1361 = alloc_Boolean(0);
// compiled identifier node returning bool1361 (depth = 5)
  return bool1361;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1279 = undefined;
  }
// compiled if node returning if1279 (depth = 3)
    gc_frame_newslot(if1279);
    if1271 = if1279;
  } else {
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1362 = alloc_Boolean(0);
// compiled identifier node returning bool1362 (depth = 4)
  return bool1362;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if1271 = undefined;
  }
// compiled if node returning if1271 (depth = 2)
  gc_frame_end(frame);
  return if1271;
}
Object meth_parser_1378__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 4)
  int callframe1379 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe1380 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1381 == NULL) {
    strlit1381 = alloc_String("rbrace");
    gc_root(strlit1381);
  }
// compiled string node returning strlit1381 (depth = 6)
  gc_frame_newslot(strlit1381);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1381;
  partcv[0] = 1;
  Object call1382 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1380);
// compiled call node returning call1382 (depth = 5)
  partcv[0] = 0;
  Object call1383 = callmethodflags(call1382, "not", 1, partcv, params, 0);
  gc_frame_end(callframe1379);
// compiled member node returning call1383 (depth = 4)
  gc_frame_end(frame);
  return call1383;
}
Object meth_parser_1390__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 7)
  int callframe1391 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1392 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1391);
// compiled member node returning call1392 (depth = 7)
  gc_frame_end(frame);
  return call1392;
}
Object meth_parser_1386__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// definebindings:
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1388 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1389 = alloc_Block(NULL, NULL, "parser", 594);
  gc_frame_newslot(block1389);
// method "_apply"
  block_savedest(block1389);
  Object closure1390 = createclosure(1, "_apply");
  setclosureframe(closure1390, stackframe);
  addtoclosure(closure1390, selfslot);
  struct UserObject *uo1390 = (struct UserObject*)block1389;
  uo1390->data[0] = (Object)closure1390;
  Method *meth_meth_parser_1390__apply = addmethod2pos(block1389, "_apply", &meth_parser_1390__apply, 0);
  int argcv_meth_parser_1390__apply[] = {0};
  meth_meth_parser_1390__apply->type = alloc_MethodType(1, argcv_meth_parser_1390__apply);
  meth_meth_parser_1390__apply->definitionModule = modulename;
  meth_meth_parser_1390__apply->definitionLine = 183;
// compiled block node returning block1389 (depth = 6)
  gc_frame_newslot(block1389);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block1389;
  partcv[0] = 1;
  Object call1394 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1388);
// compiled call node returning call1394 (depth = 5)
  Object if1387 = done;
  if (istrue(call1394)) {
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1395 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1396 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call1397 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1396);
// compiled member node returning call1397 (depth = 7)
  partcv[0] = 0;
  Object call1398 = callmethodflags(call1397, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1395);
// compiled member node returning call1398 (depth = 6)
  *var_suggestion = call1398;
  if (call1398 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1399 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1400 == NULL) {
    strlit1400 = alloc_String("}");
    gc_root(strlit1400);
  }
// compiled string node returning strlit1400 (depth = 6)
  gc_frame_newslot(strlit1400);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1400;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1401 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1399);
// compiled call node returning call1401 (depth = 5)
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1402 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1403 == NULL) {
    strlit1403 = alloc_String("a block must end with a '}'.");
    gc_root(strlit1403);
  }
// compiled string node returning strlit1403 (depth = 6)
  gc_frame_newslot(strlit1403);
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1404 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1405 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1404);
// compiled member node returning call1405 (depth = 6)
  gc_frame_newslot(call1405);
// starting to compile member node (depth = 6)
  int callframe1406 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1407 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1406);
// compiled member node returning call1407 (depth = 6)
  gc_frame_newslot(call1407);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit1403;
  params[1] = call1405;
  params[2] = call1407;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1408 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1402);
// compiled call node returning call1408 (depth = 5)
    gc_frame_newslot(call1408);
    if1387 = call1408;
  } else {
  }
// compiled if node returning if1387 (depth = 4)
  gc_frame_end(frame);
  return if1387;
}
Object meth_parser_1363_blockBody_40_1_41_beginningWith_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockBody(1)beginningWith(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method blockBody(_)beginningWith(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method blockBody(_)beginningWith(_)");
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_indentFreePass = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for blockBody(_)beginningWith(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_params = &(stackframe->slots[0]);
  *var_params = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part blockBody(_)");
  Object *var_btok = &(stackframe->slots[1]);
  *var_btok = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part beginningWith(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_originalValues = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "originalValues");
// definebindings:
// definebindings:
  Object *var_body = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "body");
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  *var_originalValues = *var_values;
  if (*var_values == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile array node (depth = 3)
  Object array1364 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1364 (depth = 3)
  *var_values = array1364;
  if (array1364 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1368 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call1369 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1368);
// compiled member node returning call1369 (depth = 4)
  int op_slot_right_1367 = gc_frame_newslot(call1369);
// starting to compile member node (depth = 4)
  int callframe1371 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call1372 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1371);
// compiled member node returning call1372 (depth = 4)
  int op_slot_left_1367 = gc_frame_newslot(call1372);
  params[0] = call1369;
  partcv[0] = 1;
  Object opresult1373 = callmethod(call1372, "==(1)", 1, partcv, params);
// compiled op node returning opresult1373 (depth = 3)
  Object if1366 = done;
  if (istrue(opresult1373)) {
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1374 = alloc_Boolean(1);
// compiled identifier node returning bool1374 (depth = 4)
  *var_indentFreePass = bool1374;
  if (bool1374 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1366 = done;
  } else {
  }
// compiled if node returning if1366 (depth = 2)
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1376 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1377 = alloc_Block(NULL, NULL, "parser", 592);
  gc_frame_newslot(block1377);
// method "_apply"
  block_savedest(block1377);
  Object closure1378 = createclosure(1, "_apply");
  setclosureframe(closure1378, stackframe);
  addtoclosure(closure1378, selfslot);
  struct UserObject *uo1378 = (struct UserObject*)block1377;
  uo1378->data[0] = (Object)closure1378;
  Method *meth_meth_parser_1378__apply = addmethod2pos(block1377, "_apply", &meth_parser_1378__apply, 0);
  int argcv_meth_parser_1378__apply[] = {0};
  meth_meth_parser_1378__apply->type = alloc_MethodType(1, argcv_meth_parser_1378__apply);
  meth_meth_parser_1378__apply->definitionModule = modulename;
  meth_meth_parser_1378__apply->definitionLine = 183;
// compiled block node returning block1377 (depth = 3)
  gc_frame_newslot(block1377);
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block1385 = alloc_Block(NULL, NULL, "parser", 592);
  gc_frame_newslot(block1385);
// method "_apply"
  block_savedest(block1385);
  Object closure1386 = createclosure(4, "_apply");
  setclosureframe(closure1386, stackframe);
  addtoclosure(closure1386, var_errormessages);
  addtoclosure(closure1386, var_lastToken);
  addtoclosure(closure1386, var_sym);
  addtoclosure(closure1386, selfslot);
  struct UserObject *uo1386 = (struct UserObject*)block1385;
  uo1386->data[0] = (Object)closure1386;
  Method *meth_meth_parser_1386__apply = addmethod2pos(block1385, "_apply", &meth_parser_1386__apply, 0);
  int argcv_meth_parser_1386__apply[] = {0};
  meth_meth_parser_1386__apply->type = alloc_MethodType(1, argcv_meth_parser_1386__apply);
  meth_meth_parser_1386__apply->definitionModule = modulename;
  meth_meth_parser_1386__apply->definitionLine = 183;
// compiled block node returning block1385 (depth = 3)
  gc_frame_newslot(block1385);
// call case 5: prelude request
  params[0] = block1377;
  params[1] = block1385;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1410 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1376);
// compiled call node returning call1410 (depth = 2)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe1411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1412 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1411);
// compiled member node returning call1412 (depth = 2)
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  *var_body = *var_values;
  if (*var_values == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_originalValues (depth = 3)
  *var_values = *var_originalValues;
  if (*var_originalValues == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1414 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe1415 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1416 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call1417 = callmethodflags(*var_ast, "blockNode", 1, partcv, params, 0);
  gc_frame_end(callframe1416);
// compiled member node returning call1417 (depth = 5)
  params[0] = *var_params;
  params[1] = *var_body;
  partcv[0] = 2;
  Object call1418 = callmethodflags(call1417, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1415);
// compiled call node returning call1418 (depth = 4)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call1419 = callmethodflags(call1418, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1414);
// compiled call node returning call1419 (depth = 3)
  return call1419;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_1445__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1447 == NULL) {
    strlit1447 = alloc_String("lbrace");
    gc_root(strlit1447);
  }
// compiled string node returning strlit1447 (depth = 8)
  int op_slot_right_1446 = gc_frame_newslot(strlit1447);
// starting to compile member node (depth = 8)
  int callframe1449 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1450 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1449);
// compiled member node returning call1450 (depth = 8)
  int op_slot_left_1446 = gc_frame_newslot(call1450);
  params[0] = strlit1447;
  partcv[0] = 1;
  Object opresult1451 = callmethod(call1450, "==(1)", 1, partcv, params);
// compiled op node returning opresult1451 (depth = 7)
  gc_frame_end(frame);
  return opresult1451;
}
Object meth_parser_1488__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_btok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1493 == NULL) {
    strlit1493 = alloc_String("then");
    gc_root(strlit1493);
  }
// compiled string node returning strlit1493 (depth = 11)
  int op_slot_right_1492 = gc_frame_newslot(strlit1493);
// starting to compile member node (depth = 11)
  int callframe1495 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call1496 = callmethodflags(*var_t, "value", 1, partcv, params, 0);
  gc_frame_end(callframe1495);
// compiled member node returning call1496 (depth = 11)
  int op_slot_left_1492 = gc_frame_newslot(call1496);
  params[0] = strlit1493;
  partcv[0] = 1;
  Object opresult1497 = callmethod(call1496, "==(1)", 1, partcv, params);
// compiled op node returning opresult1497 (depth = 10)
  int op_slot_right_1491 = gc_frame_newslot(opresult1497);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1500 == NULL) {
    strlit1500 = alloc_String("identifier");
    gc_root(strlit1500);
  }
// compiled string node returning strlit1500 (depth = 11)
  int op_slot_right_1499 = gc_frame_newslot(strlit1500);
// starting to compile member node (depth = 11)
  int callframe1502 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call1503 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1502);
// compiled member node returning call1503 (depth = 11)
  int op_slot_left_1499 = gc_frame_newslot(call1503);
  params[0] = strlit1500;
  partcv[0] = 1;
  Object opresult1504 = callmethod(call1503, "==(1)", 1, partcv, params);
// compiled op node returning opresult1504 (depth = 10)
  int op_slot_left_1491 = gc_frame_newslot(opresult1504);
  params[0] = opresult1497;
  partcv[0] = 1;
  Object opresult1505 = callmethod(opresult1504, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1505 (depth = 9)
  int op_slot_right_1490 = gc_frame_newslot(opresult1505);
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1509 == NULL) {
    strlit1509 = alloc_String("lbrace");
    gc_root(strlit1509);
  }
// compiled string node returning strlit1509 (depth = 11)
  int op_slot_right_1508 = gc_frame_newslot(strlit1509);
// starting to compile member node (depth = 11)
  int callframe1511 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call1512 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1511);
// compiled member node returning call1512 (depth = 11)
  int op_slot_left_1508 = gc_frame_newslot(call1512);
  params[0] = strlit1509;
  partcv[0] = 1;
  Object opresult1513 = callmethod(call1512, "==(1)", 1, partcv, params);
// compiled op node returning opresult1513 (depth = 10)
  int op_slot_right_1507 = gc_frame_newslot(opresult1513);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1517 == NULL) {
    strlit1517 = alloc_String("rbrace");
    gc_root(strlit1517);
  }
// compiled string node returning strlit1517 (depth = 12)
  int op_slot_right_1516 = gc_frame_newslot(strlit1517);
// starting to compile member node (depth = 12)
  int callframe1519 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1520 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1519);
// compiled member node returning call1520 (depth = 12)
  int op_slot_left_1516 = gc_frame_newslot(call1520);
  params[0] = strlit1517;
  partcv[0] = 1;
  Object opresult1521 = callmethod(call1520, "==(1)", 1, partcv, params);
// compiled op node returning opresult1521 (depth = 11)
  int op_slot_right_1515 = gc_frame_newslot(opresult1521);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1524 == NULL) {
    strlit1524 = alloc_String("rparen");
    gc_root(strlit1524);
  }
// compiled string node returning strlit1524 (depth = 12)
  int op_slot_right_1523 = gc_frame_newslot(strlit1524);
// starting to compile member node (depth = 12)
  int callframe1526 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1527 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1526);
// compiled member node returning call1527 (depth = 12)
  int op_slot_left_1523 = gc_frame_newslot(call1527);
  params[0] = strlit1524;
  partcv[0] = 1;
  Object opresult1528 = callmethod(call1527, "==(1)", 1, partcv, params);
// compiled op node returning opresult1528 (depth = 11)
  int op_slot_left_1515 = gc_frame_newslot(opresult1528);
  params[0] = opresult1521;
  partcv[0] = 1;
  Object opresult1529 = callmethod(opresult1528, "||(1)", 1, partcv, params);
// compiled op node returning opresult1529 (depth = 10)
  int op_slot_left_1507 = gc_frame_newslot(opresult1529);
  params[0] = opresult1513;
  partcv[0] = 1;
  Object opresult1530 = callmethod(opresult1529, "||(1)", 1, partcv, params);
// compiled op node returning opresult1530 (depth = 9)
  int op_slot_left_1490 = gc_frame_newslot(opresult1530);
  params[0] = opresult1505;
  partcv[0] = 1;
  Object opresult1531 = callmethod(opresult1530, "||(1)", 1, partcv, params);
// compiled op node returning opresult1531 (depth = 8)
  int op_slot_right_1489 = gc_frame_newslot(opresult1531);
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1534 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  partcv[0] = 0;
  Object call1535 = callmethodflags(*var_btok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1534);
// compiled member node returning call1535 (depth = 9)
  int op_slot_right_1533 = gc_frame_newslot(call1535);
// starting to compile member node (depth = 9)
  int callframe1537 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call1538 = callmethodflags(*var_t, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1537);
// compiled member node returning call1538 (depth = 9)
  int op_slot_left_1533 = gc_frame_newslot(call1538);
  params[0] = call1535;
  partcv[0] = 1;
  Object opresult1539 = callmethod(call1538, "==(1)", 1, partcv, params);
// compiled op node returning opresult1539 (depth = 8)
  int op_slot_left_1489 = gc_frame_newslot(opresult1539);
  params[0] = opresult1531;
  partcv[0] = 1;
  Object opresult1540 = callmethod(opresult1539, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1540 (depth = 7)
  gc_frame_end(frame);
  return opresult1540;
}
Object meth_parser_1630__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe1631 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blocksOK (depth = 7)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1632 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1631);
// compiled call node returning call1632 (depth = 6)
  gc_frame_end(frame);
  return call1632;
}
Object meth_parser_1641__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1644 == NULL) {
    strlit1644 = alloc_String("rparen");
    gc_root(strlit1644);
  }
// compiled string node returning strlit1644 (depth = 9)
  int op_slot_right_1643 = gc_frame_newslot(strlit1644);
// starting to compile member node (depth = 9)
  int callframe1646 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call1647 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1646);
// compiled member node returning call1647 (depth = 9)
  int op_slot_left_1643 = gc_frame_newslot(call1647);
  params[0] = strlit1644;
  partcv[0] = 1;
  Object opresult1648 = callmethod(call1647, "==(1)", 1, partcv, params);
// compiled op node returning opresult1648 (depth = 8)
  int op_slot_right_1642 = gc_frame_newslot(opresult1648);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1651 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call1652 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1651);
// compiled member node returning call1652 (depth = 9)
  int op_slot_right_1650 = gc_frame_newslot(call1652);
// starting to compile member node (depth = 9)
  int callframe1654 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call1655 = callmethodflags(*var_t, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1654);
// compiled member node returning call1655 (depth = 9)
  int op_slot_left_1650 = gc_frame_newslot(call1655);
  params[0] = call1652;
  partcv[0] = 1;
  Object opresult1656 = callmethod(call1655, "==(1)", 1, partcv, params);
// compiled op node returning opresult1656 (depth = 8)
  int op_slot_left_1642 = gc_frame_newslot(opresult1656);
  params[0] = opresult1648;
  partcv[0] = 1;
  Object opresult1657 = callmethod(opresult1656, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1657 (depth = 7)
  gc_frame_end(frame);
  return opresult1657;
}
Object meth_parser_1913__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe1914 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1915 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1916 == NULL) {
    strlit1916 = alloc_String("rbrace");
    gc_root(strlit1916);
  }
// compiled string node returning strlit1916 (depth = 8)
  gc_frame_newslot(strlit1916);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit1916;
  partcv[0] = 1;
  Object call1917 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1915);
// compiled call node returning call1917 (depth = 7)
  partcv[0] = 0;
  Object call1918 = callmethodflags(call1917, "not", 1, partcv, params, 0);
  gc_frame_end(callframe1914);
// compiled member node returning call1918 (depth = 6)
  gc_frame_end(frame);
  return call1918;
}
Object meth_parser_1925__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 9)
  int callframe1926 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1927 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1926);
// compiled member node returning call1927 (depth = 9)
  gc_frame_end(frame);
  return call1927;
}
Object meth_parser_1921__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1923 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block1924 = alloc_Block(NULL, NULL, "parser", 744);
  gc_frame_newslot(block1924);
// method "_apply"
  block_savedest(block1924);
  Object closure1925 = createclosure(1, "_apply");
  setclosureframe(closure1925, stackframe);
  addtoclosure(closure1925, selfslot);
  struct UserObject *uo1925 = (struct UserObject*)block1924;
  uo1925->data[0] = (Object)closure1925;
  Method *meth_meth_parser_1925__apply = addmethod2pos(block1924, "_apply", &meth_parser_1925__apply, 0);
  int argcv_meth_parser_1925__apply[] = {0};
  meth_meth_parser_1925__apply->type = alloc_MethodType(1, argcv_meth_parser_1925__apply);
  meth_meth_parser_1925__apply->definitionModule = modulename;
  meth_meth_parser_1925__apply->definitionLine = 183;
// compiled block node returning block1924 (depth = 8)
  gc_frame_newslot(block1924);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block1924;
  partcv[0] = 1;
  Object call1929 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1923);
// compiled call node returning call1929 (depth = 7)
  Object if1922 = done;
  if (istrue(call1929)) {
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1930 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1931 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call1932 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1931);
// compiled member node returning call1932 (depth = 9)
  partcv[0] = 0;
  Object call1933 = callmethodflags(call1932, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1930);
// compiled member node returning call1933 (depth = 8)
  *var_suggestion = call1933;
  if (call1933 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1934 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool1935 = alloc_Boolean(0);
// compiled identifier node returning bool1935 (depth = 9)
  gc_frame_newslot(bool1935);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_btok;
  params[1] = bool1935;
  partcv[0] = 2;
  Object call1936 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1934);
// compiled call node returning call1936 (depth = 8)
  *var_closingBrace = call1936;
  if (call1936 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1938 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1939 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call1940 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe1939);
// compiled member node returning call1940 (depth = 9)
  partcv[0] = 0;
  Object call1941 = callmethodflags(call1940, "not", 1, partcv, params, 0);
  gc_frame_end(callframe1938);
// compiled member node returning call1941 (depth = 8)
  Object if1937 = done;
  if (istrue(call1941)) {
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_1943 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
  int callframe1945 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call1946 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe1945);
// compiled member node returning call1946 (depth = 10)
  int op_slot_left_1943 = gc_frame_newslot(call1946);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult1947 = callmethod(call1946, "==(1)", 1, partcv, params);
// compiled op node returning opresult1947 (depth = 9)
  Object if1942 = done;
  if (istrue(opresult1947)) {
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1948 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1949 == NULL) {
    strlit1949 = alloc_String("}");
    gc_root(strlit1949);
  }
// compiled string node returning strlit1949 (depth = 10)
  gc_frame_newslot(strlit1949);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1949;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1950 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1948);
// compiled call node returning call1950 (depth = 9)
    gc_frame_newslot(call1950);
    if1942 = call1950;
  } else {
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1951 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1953 = alloc_Float64(0.1);
// compiled num node returning num1953 (depth = 11)
  int op_slot_right_1952 = gc_frame_newslot(num1953);
// starting to compile member node (depth = 11)
  int callframe1955 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe1956 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call1957 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe1956);
// compiled member node returning call1957 (depth = 12)
  partcv[0] = 0;
  Object call1958 = callmethodflags(call1957, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1955);
// compiled member node returning call1958 (depth = 11)
  int op_slot_left_1952 = gc_frame_newslot(call1958);
  params[0] = num1953;
  partcv[0] = 1;
  Object sum1959 = callmethod(call1958, "+(1)", 1, partcv, params);
// compiled op node returning sum1959 (depth = 10)
  gc_frame_newslot(sum1959);
// starting to compile string node (depth = 10)
  if (strlit1960 == NULL) {
    strlit1960 = alloc_String("}");
    gc_root(strlit1960);
  }
// compiled string node returning strlit1960 (depth = 10)
  gc_frame_newslot(strlit1960);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum1959;
  params[1] = strlit1960;
  partcv[0] = 2;
  Object call1961 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1951);
// compiled call node returning call1961 (depth = 9)
    gc_frame_newslot(call1961);
    if1942 = call1961;
  }
// compiled if node returning if1942 (depth = 8)
    gc_frame_newslot(if1942);
    if1937 = if1942;
  } else {
  }
// compiled if node returning if1937 (depth = 7)
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1962 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call1963 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1962);
// compiled call node returning call1963 (depth = 7)
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1964 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1965 == NULL) {
    strlit1965 = alloc_String("an if statement must end with a '}'.");
    gc_root(strlit1965);
  }
// compiled string node returning strlit1965 (depth = 8)
  gc_frame_newslot(strlit1965);
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe1966 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1967 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1966);
// compiled member node returning call1967 (depth = 8)
  gc_frame_newslot(call1967);
// starting to compile member node (depth = 8)
  int callframe1968 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1969 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1968);
// compiled member node returning call1969 (depth = 8)
  gc_frame_newslot(call1969);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1965;
  params[1] = call1967;
  params[2] = call1969;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1970 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1964);
// compiled call node returning call1970 (depth = 7)
    gc_frame_newslot(call1970);
    if1922 = call1970;
  } else {
  }
// compiled if node returning if1922 (depth = 6)
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1971 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call1972 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe1971);
// compiled member node returning call1972 (depth = 7)
  *var_v = call1972;
  if (call1972 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1974 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call1975 = callmethodflags(*var_body, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1974);
// compiled call node returning call1975 (depth = 6)
  gc_frame_end(frame);
  return call1975;
}
Object meth_parser_1982__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1985 == NULL) {
    strlit1985 = alloc_String("elseif");
    gc_root(strlit1985);
  }
// compiled string node returning strlit1985 (depth = 8)
  int op_slot_right_1984 = gc_frame_newslot(strlit1985);
// starting to compile member node (depth = 8)
  int callframe1987 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1988 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe1987);
// compiled member node returning call1988 (depth = 8)
  int op_slot_left_1984 = gc_frame_newslot(call1988);
  params[0] = strlit1985;
  partcv[0] = 1;
  Object opresult1989 = callmethod(call1988, "==(1)", 1, partcv, params);
// compiled op node returning opresult1989 (depth = 7)
  int op_slot_right_1983 = gc_frame_newslot(opresult1989);
// starting to compile call node (depth = 7)
  int callframe1991 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1992 == NULL) {
    strlit1992 = alloc_String("identifier");
    gc_root(strlit1992);
  }
// compiled string node returning strlit1992 (depth = 8)
  gc_frame_newslot(strlit1992);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit1992;
  partcv[0] = 1;
  Object call1993 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1991);
// compiled call node returning call1993 (depth = 7)
  int op_slot_left_1983 = gc_frame_newslot(call1993);
  params[0] = opresult1989;
  partcv[0] = 1;
  Object opresult1994 = callmethod(call1993, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1994 (depth = 6)
  gc_frame_end(frame);
  return opresult1994;
}
Object meth_parser_2037__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2042 == NULL) {
    strlit2042 = alloc_String("then");
    gc_root(strlit2042);
  }
// compiled string node returning strlit2042 (depth = 14)
  int op_slot_right_2041 = gc_frame_newslot(strlit2042);
// starting to compile member node (depth = 14)
  int callframe2044 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2045 = callmethodflags(*var_t, "value", 1, partcv, params, 0);
  gc_frame_end(callframe2044);
// compiled member node returning call2045 (depth = 14)
  int op_slot_left_2041 = gc_frame_newslot(call2045);
  params[0] = strlit2042;
  partcv[0] = 1;
  Object opresult2046 = callmethod(call2045, "==(1)", 1, partcv, params);
// compiled op node returning opresult2046 (depth = 13)
  int op_slot_right_2040 = gc_frame_newslot(opresult2046);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2049 == NULL) {
    strlit2049 = alloc_String("identifier");
    gc_root(strlit2049);
  }
// compiled string node returning strlit2049 (depth = 14)
  int op_slot_right_2048 = gc_frame_newslot(strlit2049);
// starting to compile member node (depth = 14)
  int callframe2051 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2052 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2051);
// compiled member node returning call2052 (depth = 14)
  int op_slot_left_2048 = gc_frame_newslot(call2052);
  params[0] = strlit2049;
  partcv[0] = 1;
  Object opresult2053 = callmethod(call2052, "==(1)", 1, partcv, params);
// compiled op node returning opresult2053 (depth = 13)
  int op_slot_left_2040 = gc_frame_newslot(opresult2053);
  params[0] = opresult2046;
  partcv[0] = 1;
  Object opresult2054 = callmethod(opresult2053, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2054 (depth = 12)
  int op_slot_right_2039 = gc_frame_newslot(opresult2054);
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2058 == NULL) {
    strlit2058 = alloc_String("lbrace");
    gc_root(strlit2058);
  }
// compiled string node returning strlit2058 (depth = 14)
  int op_slot_right_2057 = gc_frame_newslot(strlit2058);
// starting to compile member node (depth = 14)
  int callframe2060 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2061 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2060);
// compiled member node returning call2061 (depth = 14)
  int op_slot_left_2057 = gc_frame_newslot(call2061);
  params[0] = strlit2058;
  partcv[0] = 1;
  Object opresult2062 = callmethod(call2061, "==(1)", 1, partcv, params);
// compiled op node returning opresult2062 (depth = 13)
  int op_slot_right_2056 = gc_frame_newslot(opresult2062);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2065 == NULL) {
    strlit2065 = alloc_String("rbrace");
    gc_root(strlit2065);
  }
// compiled string node returning strlit2065 (depth = 14)
  int op_slot_right_2064 = gc_frame_newslot(strlit2065);
// starting to compile member node (depth = 14)
  int callframe2067 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2068 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2067);
// compiled member node returning call2068 (depth = 14)
  int op_slot_left_2064 = gc_frame_newslot(call2068);
  params[0] = strlit2065;
  partcv[0] = 1;
  Object opresult2069 = callmethod(call2068, "==(1)", 1, partcv, params);
// compiled op node returning opresult2069 (depth = 13)
  int op_slot_left_2056 = gc_frame_newslot(opresult2069);
  params[0] = opresult2062;
  partcv[0] = 1;
  Object opresult2070 = callmethod(opresult2069, "||(1)", 1, partcv, params);
// compiled op node returning opresult2070 (depth = 12)
  int op_slot_left_2039 = gc_frame_newslot(opresult2070);
  params[0] = opresult2054;
  partcv[0] = 1;
  Object opresult2071 = callmethod(opresult2070, "||(1)", 1, partcv, params);
// compiled op node returning opresult2071 (depth = 11)
  int op_slot_right_2038 = gc_frame_newslot(opresult2071);
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
  int callframe2074 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_statementToken (depth = 13)
  partcv[0] = 0;
  Object call2075 = callmethodflags(*var_statementToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2074);
// compiled member node returning call2075 (depth = 12)
  int op_slot_right_2073 = gc_frame_newslot(call2075);
// starting to compile member node (depth = 12)
  int callframe2077 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call2078 = callmethodflags(*var_t, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2077);
// compiled member node returning call2078 (depth = 12)
  int op_slot_left_2073 = gc_frame_newslot(call2078);
  params[0] = call2075;
  partcv[0] = 1;
  Object opresult2079 = callmethod(call2078, "==(1)", 1, partcv, params);
// compiled op node returning opresult2079 (depth = 11)
  int op_slot_left_2038 = gc_frame_newslot(opresult2079);
  params[0] = opresult2071;
  partcv[0] = 1;
  Object opresult2080 = callmethod(opresult2079, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2080 (depth = 10)
  gc_frame_end(frame);
  return opresult2080;
}
Object meth_parser_2170__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 9)
  int callframe2171 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2172 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2171);
// compiled call node returning call2172 (depth = 9)
  gc_frame_end(frame);
  return call2172;
}
Object meth_parser_2181__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2184 == NULL) {
    strlit2184 = alloc_String("rbrace");
    gc_root(strlit2184);
  }
// compiled string node returning strlit2184 (depth = 12)
  int op_slot_right_2183 = gc_frame_newslot(strlit2184);
// starting to compile member node (depth = 12)
  int callframe2186 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call2187 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2186);
// compiled member node returning call2187 (depth = 12)
  int op_slot_left_2183 = gc_frame_newslot(call2187);
  params[0] = strlit2184;
  partcv[0] = 1;
  Object opresult2188 = callmethod(call2187, "==(1)", 1, partcv, params);
// compiled op node returning opresult2188 (depth = 11)
  int op_slot_right_2182 = gc_frame_newslot(opresult2188);
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
  int callframe2191 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lastToken (depth = 13)
  partcv[0] = 0;
  Object call2192 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2191);
// compiled member node returning call2192 (depth = 12)
  int op_slot_right_2190 = gc_frame_newslot(call2192);
// starting to compile member node (depth = 12)
  int callframe2194 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call2195 = callmethodflags(*var_t, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2194);
// compiled member node returning call2195 (depth = 12)
  int op_slot_left_2190 = gc_frame_newslot(call2195);
  params[0] = call2192;
  partcv[0] = 1;
  Object opresult2196 = callmethod(call2195, "==(1)", 1, partcv, params);
// compiled op node returning opresult2196 (depth = 11)
  int op_slot_left_2182 = gc_frame_newslot(opresult2196);
  params[0] = opresult2188;
  partcv[0] = 1;
  Object opresult2197 = callmethod(opresult2196, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2197 (depth = 10)
  gc_frame_end(frame);
  return opresult2197;
}
Object meth_parser_2517__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 8)
  int callframe2518 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe2519 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2520 == NULL) {
    strlit2520 = alloc_String("rbrace");
    gc_root(strlit2520);
  }
// compiled string node returning strlit2520 (depth = 10)
  gc_frame_newslot(strlit2520);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = strlit2520;
  partcv[0] = 1;
  Object call2521 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2519);
// compiled call node returning call2521 (depth = 9)
  partcv[0] = 0;
  Object call2522 = callmethodflags(call2521, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2518);
// compiled member node returning call2522 (depth = 8)
  gc_frame_end(frame);
  return call2522;
}
Object meth_parser_2529__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 11)
  int callframe2530 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2531 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2530);
// compiled member node returning call2531 (depth = 11)
  gc_frame_end(frame);
  return call2531;
}
Object meth_parser_2525__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_ebody = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2527 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2528 = alloc_Block(NULL, NULL, "parser", 911);
  gc_frame_newslot(block2528);
// method "_apply"
  block_savedest(block2528);
  Object closure2529 = createclosure(1, "_apply");
  setclosureframe(closure2529, stackframe);
  addtoclosure(closure2529, selfslot);
  struct UserObject *uo2529 = (struct UserObject*)block2528;
  uo2529->data[0] = (Object)closure2529;
  Method *meth_meth_parser_2529__apply = addmethod2pos(block2528, "_apply", &meth_parser_2529__apply, 0);
  int argcv_meth_parser_2529__apply[] = {0};
  meth_meth_parser_2529__apply->type = alloc_MethodType(1, argcv_meth_parser_2529__apply);
  meth_meth_parser_2529__apply->definitionModule = modulename;
  meth_meth_parser_2529__apply->definitionLine = 183;
// compiled block node returning block2528 (depth = 10)
  gc_frame_newslot(block2528);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = block2528;
  partcv[0] = 1;
  Object call2533 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2527);
// compiled call node returning call2533 (depth = 9)
  Object if2526 = done;
  if (istrue(call2533)) {
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe2534 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2535 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2536 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2535);
// compiled member node returning call2536 (depth = 11)
  partcv[0] = 0;
  Object call2537 = callmethodflags(call2536, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2534);
// compiled member node returning call2537 (depth = 10)
  *var_suggestion = call2537;
  if (call2537 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2538 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 11)
  Object bool2539 = alloc_Boolean(0);
// compiled identifier node returning bool2539 (depth = 11)
  gc_frame_newslot(bool2539);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning module_parser (depth = 11)
  params[0] = *var_btok;
  params[1] = bool2539;
  partcv[0] = 2;
  Object call2540 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2538);
// compiled call node returning call2540 (depth = 10)
  *var_closingBrace = call2540;
  if (call2540 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe2542 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2543 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2544 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe2543);
// compiled member node returning call2544 (depth = 11)
  partcv[0] = 0;
  Object call2545 = callmethodflags(call2544, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2542);
// compiled member node returning call2545 (depth = 10)
  Object if2541 = done;
  if (istrue(call2545)) {
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  int op_slot_right_2547 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 12)
  int callframe2549 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2550 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2549);
// compiled member node returning call2550 (depth = 12)
  int op_slot_left_2547 = gc_frame_newslot(call2550);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2551 = callmethod(call2550, "==(1)", 1, partcv, params);
// compiled op node returning opresult2551 (depth = 11)
  Object if2546 = done;
  if (istrue(opresult2551)) {
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2552 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2553 == NULL) {
    strlit2553 = alloc_String("}");
    gc_root(strlit2553);
  }
// compiled string node returning strlit2553 (depth = 12)
  gc_frame_newslot(strlit2553);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2553;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2554 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2552);
// compiled call node returning call2554 (depth = 11)
    gc_frame_newslot(call2554);
    if2546 = call2554;
  } else {
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2555 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2557 = alloc_Float64(0.1);
// compiled num node returning num2557 (depth = 13)
  int op_slot_right_2556 = gc_frame_newslot(num2557);
// starting to compile member node (depth = 13)
  int callframe2559 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe2560 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  partcv[0] = 0;
  Object call2561 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2560);
// compiled member node returning call2561 (depth = 14)
  partcv[0] = 0;
  Object call2562 = callmethodflags(call2561, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2559);
// compiled member node returning call2562 (depth = 13)
  int op_slot_left_2556 = gc_frame_newslot(call2562);
  params[0] = num2557;
  partcv[0] = 1;
  Object sum2563 = callmethod(call2562, "+(1)", 1, partcv, params);
// compiled op node returning sum2563 (depth = 12)
  gc_frame_newslot(sum2563);
// starting to compile string node (depth = 12)
  if (strlit2564 == NULL) {
    strlit2564 = alloc_String("}");
    gc_root(strlit2564);
  }
// compiled string node returning strlit2564 (depth = 12)
  gc_frame_newslot(strlit2564);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = sum2563;
  params[1] = strlit2564;
  partcv[0] = 2;
  Object call2565 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2555);
// compiled call node returning call2565 (depth = 11)
    gc_frame_newslot(call2565);
    if2546 = call2565;
  }
// compiled if node returning if2546 (depth = 10)
    gc_frame_newslot(if2546);
    if2541 = if2546;
  } else {
  }
// compiled if node returning if2541 (depth = 9)
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2566 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2567 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2566);
// compiled call node returning call2567 (depth = 9)
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2568 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2569 == NULL) {
    strlit2569 = alloc_String("an 'elseif' clause must end with a '}'.");
    gc_root(strlit2569);
  }
// compiled string node returning strlit2569 (depth = 10)
  gc_frame_newslot(strlit2569);
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe2570 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2571 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2570);
// compiled member node returning call2571 (depth = 10)
  gc_frame_newslot(call2571);
// starting to compile member node (depth = 10)
  int callframe2572 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2573 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2572);
// compiled member node returning call2573 (depth = 10)
  gc_frame_newslot(call2573);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2569;
  params[1] = call2571;
  params[2] = call2573;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2574 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2568);
// compiled call node returning call2574 (depth = 9)
    gc_frame_newslot(call2574);
    if2526 = call2574;
  } else {
  }
// compiled if node returning if2526 (depth = 8)
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2575 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call2576 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe2575);
// compiled member node returning call2576 (depth = 9)
  *var_v = call2576;
  if (call2576 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2578 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_v (depth = 9)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ebody (depth = 9)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2579 = callmethodflags(*var_ebody, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2578);
// compiled call node returning call2579 (depth = 8)
  gc_frame_end(frame);
  return call2579;
}
Object meth_parser_1997__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_minStartColumn = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_econd = getfromclosure(closure, 7);
  Object *var_ebody = getfromclosure(closure, 8);
  Object *var_btok = getfromclosure(closure, 9);
  Object *var_minIndentLevel = getfromclosure(closure, 10);
  Object *var_minInd = getfromclosure(closure, 11);
  Object *var_v = getfromclosure(closure, 12);
  Object *var_newelse = getfromclosure(closure, 13);
  Object *var_eif = getfromclosure(closure, 14);
  Object *var_curelse = getfromclosure(closure, 15);
  Object self = *(getfromclosure(closure, 16));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_closingBrace = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minStartColumn (depth = 8)
  int op_slot_right_1999 = gc_frame_newslot(*var_minStartColumn);
// starting to compile member node (depth = 8)
  int callframe2001 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2002 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2001);
// compiled member node returning call2002 (depth = 8)
  int op_slot_left_1999 = gc_frame_newslot(call2002);
  params[0] = *var_minStartColumn;
  partcv[0] = 1;
  Object opresult2003 = callmethod(call2002, "<(1)", 1, partcv, params);
// compiled op node returning opresult2003 (depth = 7)
  Object if1998 = done;
  if (istrue(opresult2003)) {
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2004 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2006 == NULL) {
    strlit2006 = alloc_String("'if(_)then(_)""\xe2""""\x80""""\xa6""elseif(_)' must be indented more than the 'if'");
    gc_root(strlit2006);
  }
// compiled string node returning strlit2006 (depth = 9)
  int op_slot_right_2005 = gc_frame_newslot(strlit2006);
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2008 == NULL) {
    strlit2008 = alloc_String("the 'elseif' part of an ");
    gc_root(strlit2008);
  }
// compiled string node returning strlit2008 (depth = 9)
  int op_slot_left_2005 = gc_frame_newslot(strlit2008);
  params[0] = strlit2006;
  partcv[0] = 1;
  Object opresult2009 = callmethod(strlit2008, "++(1)", 1, partcv, params);
// compiled op node returning opresult2009 (depth = 8)
  gc_frame_newslot(opresult2009);
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2010 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2011 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2010);
// compiled member node returning call2011 (depth = 8)
  gc_frame_newslot(call2011);
// starting to compile member node (depth = 8)
  int callframe2012 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2013 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2012);
// compiled member node returning call2013 (depth = 8)
  gc_frame_newslot(call2013);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2015 = alloc_Float64(5);
// compiled num node returning num2015 (depth = 9)
  int op_slot_right_2014 = gc_frame_newslot(num2015);
// starting to compile member node (depth = 9)
  int callframe2017 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2018 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2017);
// compiled member node returning call2018 (depth = 9)
  int op_slot_left_2014 = gc_frame_newslot(call2018);
  params[0] = num2015;
  partcv[0] = 1;
  Object sum2019 = callmethod(call2018, "+(1)", 1, partcv, params);
// compiled op node returning sum2019 (depth = 8)
  gc_frame_newslot(sum2019);
// call case 6: other requests
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2009;
  params[1] = call2011;
  params[2] = call2013;
  params[3] = sum2019;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2020 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe2004);
// compiled call node returning call2020 (depth = 7)
    gc_frame_newslot(call2020);
    if1998 = call2020;
  } else {
  }
// compiled if node returning if1998 (depth = 6)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2022 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2023 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2022);
// compiled member node returning call2023 (depth = 6)
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2026 == NULL) {
    strlit2026 = alloc_String("lbrace");
    gc_root(strlit2026);
  }
// compiled string node returning strlit2026 (depth = 8)
  int op_slot_right_2025 = gc_frame_newslot(strlit2026);
// starting to compile member node (depth = 8)
  int callframe2028 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2029 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2028);
// compiled member node returning call2029 (depth = 8)
  int op_slot_left_2025 = gc_frame_newslot(call2029);
  params[0] = strlit2026;
  partcv[0] = 1;
  Object opresult2030 = callmethod(call2029, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2030 (depth = 7)
  Object if2024 = done;
  if (istrue(opresult2030)) {
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2031 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2032 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call2033 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2032);
// compiled member node returning call2033 (depth = 9)
  partcv[0] = 0;
  Object call2034 = callmethodflags(call2033, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2031);
// compiled member node returning call2034 (depth = 8)
  *var_suggestion = call2034;
  if (call2034 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2035 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2036 = alloc_Block(NULL, NULL, "parser", 780);
  gc_frame_newslot(block2036);
// method "_apply(_)"
  block_savedest(block2036);
  Object closure2037 = createclosure(2, "_apply(1)");
  setclosureframe(closure2037, stackframe);
  addtoclosure(closure2037, var_statementToken);
  addtoclosure(closure2037, selfslot);
  struct UserObject *uo2037 = (struct UserObject*)block2036;
  uo2037->data[0] = (Object)closure2037;
  Method *meth_meth_parser_2037__apply_40_1_41_ = addmethod2pos(block2036, "_apply(1)", &meth_parser_2037__apply_40_1_41_, 0);
  int argcv_meth_parser_2037__apply_40_1_41_[] = {1};
  meth_meth_parser_2037__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_2037__apply_40_1_41_);
  meth_meth_parser_2037__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_2037__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block2036 (depth = 9)
  gc_frame_newslot(block2036);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = block2036;
  partcv[0] = 1;
  Object call2082 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2035);
// compiled call node returning call2082 (depth = 8)
  *var_nextTok = call2082;
  if (call2082 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_right_2084 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 9)
  Object bool2086 = alloc_Boolean(0);
// compiled identifier node returning bool2086 (depth = 9)
  int op_slot_left_2084 = gc_frame_newslot(bool2086);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult2087 = callmethod(bool2086, "==(1)", 1, partcv, params);
// compiled op node returning opresult2087 (depth = 8)
  Object if2083 = done;
  if (istrue(opresult2087)) {
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2088 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2089 == NULL) {
    strlit2089 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" } then {");
    gc_root(strlit2089);
  }
// compiled string node returning strlit2089 (depth = 9)
  gc_frame_newslot(strlit2089);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_statementToken (depth = 9)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit2089;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2090 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2088);
// compiled call node returning call2090 (depth = 8)
    gc_frame_newslot(call2090);
    if2083 = call2090;
  } else {
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2093 == NULL) {
    strlit2093 = alloc_String("rbrace");
    gc_root(strlit2093);
  }
// compiled string node returning strlit2093 (depth = 10)
  int op_slot_right_2092 = gc_frame_newslot(strlit2093);
// starting to compile member node (depth = 10)
  int callframe2095 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call2096 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2095);
// compiled member node returning call2096 (depth = 10)
  int op_slot_left_2092 = gc_frame_newslot(call2096);
  params[0] = strlit2093;
  partcv[0] = 1;
  Object opresult2097 = callmethod(call2096, "==(1)", 1, partcv, params);
// compiled op node returning opresult2097 (depth = 9)
  Object if2091 = done;
  if (istrue(opresult2097)) {
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2099 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_2099 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2101 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2101 (depth = 10)
  Object if2098 = done;
  if (istrue(opresult2101)) {
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2102 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2103 == NULL) {
    strlit2103 = alloc_String("{ ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit2103);
  }
// compiled string node returning strlit2103 (depth = 11)
  gc_frame_newslot(strlit2103);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2103;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2104 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2102);
// compiled call node returning call2104 (depth = 10)
    gc_frame_newslot(call2104);
    if2098 = call2104;
  } else {
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2105 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2106 == NULL) {
    strlit2106 = alloc_String("{ ");
    gc_root(strlit2106);
  }
// compiled string node returning strlit2106 (depth = 11)
  gc_frame_newslot(strlit2106);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2106;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2107 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2105);
// compiled call node returning call2107 (depth = 10)
    gc_frame_newslot(call2107);
    if2098 = call2107;
  }
// compiled if node returning if2098 (depth = 9)
    gc_frame_newslot(if2098);
    if2091 = if2098;
  } else {
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2110 == NULL) {
    strlit2110 = alloc_String("lbrace");
    gc_root(strlit2110);
  }
// compiled string node returning strlit2110 (depth = 11)
  int op_slot_right_2109 = gc_frame_newslot(strlit2110);
// starting to compile member node (depth = 11)
  int callframe2112 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2113 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2112);
// compiled member node returning call2113 (depth = 11)
  int op_slot_left_2109 = gc_frame_newslot(call2113);
  params[0] = strlit2110;
  partcv[0] = 1;
  Object opresult2114 = callmethod(call2113, "==(1)", 1, partcv, params);
// compiled op node returning opresult2114 (depth = 10)
  Object if2108 = done;
  if (istrue(opresult2114)) {
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  int op_slot_right_2116 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  int op_slot_left_2116 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2118 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2118 (depth = 11)
  Object if2115 = done;
  if (istrue(opresult2118)) {
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2119 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2120 == NULL) {
    strlit2120 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" } then");
    gc_root(strlit2120);
  }
// compiled string node returning strlit2120 (depth = 12)
  gc_frame_newslot(strlit2120);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_statementToken (depth = 12)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2120;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2121 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2119);
// compiled call node returning call2121 (depth = 11)
    gc_frame_newslot(call2121);
    if2115 = call2121;
  } else {
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2122 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2123 == NULL) {
    strlit2123 = alloc_String("{ ");
    gc_root(strlit2123);
  }
// compiled string node returning strlit2123 (depth = 12)
  gc_frame_newslot(strlit2123);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2123;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2124 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2122);
// compiled call node returning call2124 (depth = 11)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2125 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2126 == NULL) {
    strlit2126 = alloc_String(" } then");
    gc_root(strlit2126);
  }
// compiled string node returning strlit2126 (depth = 12)
  gc_frame_newslot(strlit2126);
// starting to compile member node (depth = 12)
  int callframe2127 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call2128 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe2127);
// compiled member node returning call2128 (depth = 12)
  gc_frame_newslot(call2128);
// starting to compile identifier node (depth = 12)
  Object bool2129 = alloc_Boolean(1);
// compiled identifier node returning bool2129 (depth = 12)
  gc_frame_newslot(bool2129);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2126;
  params[1] = call2128;
  params[2] = bool2129;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2130 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2125);
// compiled call node returning call2130 (depth = 11)
    gc_frame_newslot(call2130);
    if2115 = call2130;
  }
// compiled if node returning if2115 (depth = 10)
    gc_frame_newslot(if2115);
    if2108 = if2115;
  } else {
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2133 == NULL) {
    strlit2133 = alloc_String("identifier");
    gc_root(strlit2133);
  }
// compiled string node returning strlit2133 (depth = 12)
  int op_slot_right_2132 = gc_frame_newslot(strlit2133);
// starting to compile member node (depth = 12)
  int callframe2135 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call2136 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2135);
// compiled member node returning call2136 (depth = 12)
  int op_slot_left_2132 = gc_frame_newslot(call2136);
  params[0] = strlit2133;
  partcv[0] = 1;
  Object opresult2137 = callmethod(call2136, "==(1)", 1, partcv, params);
// compiled op node returning opresult2137 (depth = 11)
  Object if2131 = done;
  if (istrue(opresult2137)) {
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  int op_slot_right_2139 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  int op_slot_left_2139 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2141 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2141 (depth = 12)
  Object if2138 = done;
  if (istrue(opresult2141)) {
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2142 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2143 == NULL) {
    strlit2143 = alloc_String("{ ""\xc2""""\xab""expression""\xc2""""\xbb"" } ");
    gc_root(strlit2143);
  }
// compiled string node returning strlit2143 (depth = 13)
  gc_frame_newslot(strlit2143);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2143;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2144 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2142);
// compiled call node returning call2144 (depth = 12)
    gc_frame_newslot(call2144);
    if2138 = call2144;
  } else {
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2145 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2146 == NULL) {
    strlit2146 = alloc_String("{ ");
    gc_root(strlit2146);
  }
// compiled string node returning strlit2146 (depth = 13)
  gc_frame_newslot(strlit2146);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2146;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2147 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2145);
// compiled call node returning call2147 (depth = 12)
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2148 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2149 == NULL) {
    strlit2149 = alloc_String(" }");
    gc_root(strlit2149);
  }
// compiled string node returning strlit2149 (depth = 13)
  gc_frame_newslot(strlit2149);
// starting to compile member node (depth = 13)
  int callframe2150 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  partcv[0] = 0;
  Object call2151 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe2150);
// compiled member node returning call2151 (depth = 13)
  gc_frame_newslot(call2151);
// starting to compile identifier node (depth = 13)
  Object bool2152 = alloc_Boolean(1);
// compiled identifier node returning bool2152 (depth = 13)
  gc_frame_newslot(bool2152);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2149;
  params[1] = call2151;
  params[2] = bool2152;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2153 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2148);
// compiled call node returning call2153 (depth = 12)
    gc_frame_newslot(call2153);
    if2138 = call2153;
  }
// compiled if node returning if2138 (depth = 11)
    gc_frame_newslot(if2138);
    if2131 = if2138;
  } else {
  }
// compiled if node returning if2131 (depth = 10)
    gc_frame_newslot(if2131);
    if2108 = if2131;
  }
// compiled if node returning if2108 (depth = 9)
    gc_frame_newslot(if2108);
    if2091 = if2108;
  }
// compiled if node returning if2091 (depth = 8)
    gc_frame_newslot(if2091);
    if2083 = if2091;
  }
// compiled if node returning if2083 (depth = 7)
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2154 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2156 == NULL) {
    strlit2156 = alloc_String("condition in braces after the 'elseif'.");
    gc_root(strlit2156);
  }
// compiled string node returning strlit2156 (depth = 9)
  int op_slot_right_2155 = gc_frame_newslot(strlit2156);
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2158 == NULL) {
    strlit2158 = alloc_String("an elseif statement must have a ");
    gc_root(strlit2158);
  }
// compiled string node returning strlit2158 (depth = 9)
  int op_slot_left_2155 = gc_frame_newslot(strlit2158);
  params[0] = strlit2156;
  partcv[0] = 1;
  Object opresult2159 = callmethod(strlit2158, "++(1)", 1, partcv, params);
// compiled op node returning opresult2159 (depth = 8)
  gc_frame_newslot(opresult2159);
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2161 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2160);
// compiled member node returning call2161 (depth = 8)
  gc_frame_newslot(call2161);
// starting to compile member node (depth = 8)
  int callframe2162 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2163 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2162);
// compiled member node returning call2163 (depth = 8)
  gc_frame_newslot(call2163);
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2159;
  params[1] = call2161;
  params[2] = call2163;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2164 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2154);
// compiled call node returning call2164 (depth = 7)
    gc_frame_newslot(call2164);
    if2024 = call2164;
  } else {
  }
// compiled if node returning if2024 (depth = 6)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2165 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2166 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2165);
// compiled member node returning call2166 (depth = 6)
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2168 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block2169 = alloc_Block(NULL, NULL, "parser", 812);
  gc_frame_newslot(block2169);
// method "_apply"
  block_savedest(block2169);
  Object closure2170 = createclosure(2, "_apply");
  setclosureframe(closure2170, stackframe);
  addtoclosure(closure2170, var_blocksOK);
  addtoclosure(closure2170, selfslot);
  struct UserObject *uo2170 = (struct UserObject*)block2169;
  uo2170->data[0] = (Object)closure2170;
  Method *meth_meth_parser_2170__apply = addmethod2pos(block2169, "_apply", &meth_parser_2170__apply, 0);
  int argcv_meth_parser_2170__apply[] = {0};
  meth_meth_parser_2170__apply->type = alloc_MethodType(1, argcv_meth_parser_2170__apply);
  meth_meth_parser_2170__apply->definitionModule = modulename;
  meth_meth_parser_2170__apply->definitionLine = 183;
// compiled block node returning block2169 (depth = 8)
  gc_frame_newslot(block2169);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block2169;
  partcv[0] = 1;
  Object call2174 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2168);
// compiled call node returning call2174 (depth = 7)
  Object if2167 = done;
  if (istrue(call2174)) {
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2175 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2176 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call2177 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2176);
// compiled member node returning call2177 (depth = 9)
  partcv[0] = 0;
  Object call2178 = callmethodflags(call2177, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2175);
// compiled member node returning call2178 (depth = 8)
  *var_suggestion = call2178;
  if (call2178 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2179 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2180 = alloc_Block(NULL, NULL, "parser", 815);
  gc_frame_newslot(block2180);
// method "_apply(_)"
  block_savedest(block2180);
  Object closure2181 = createclosure(2, "_apply(1)");
  setclosureframe(closure2181, stackframe);
  addtoclosure(closure2181, var_lastToken);
  addtoclosure(closure2181, selfslot);
  struct UserObject *uo2181 = (struct UserObject*)block2180;
  uo2181->data[0] = (Object)closure2181;
  Method *meth_meth_parser_2181__apply_40_1_41_ = addmethod2pos(block2180, "_apply(1)", &meth_parser_2181__apply_40_1_41_, 0);
  int argcv_meth_parser_2181__apply_40_1_41_[] = {1};
  meth_meth_parser_2181__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_2181__apply_40_1_41_);
  meth_meth_parser_2181__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_2181__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block2180 (depth = 9)
  gc_frame_newslot(block2180);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = block2180;
  partcv[0] = 1;
  Object call2199 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2179);
// compiled call node returning call2199 (depth = 8)
  *var_nextTok = call2199;
  if (call2199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_right_2201 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 9)
  Object bool2203 = alloc_Boolean(0);
// compiled identifier node returning bool2203 (depth = 9)
  int op_slot_left_2201 = gc_frame_newslot(bool2203);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult2204 = callmethod(bool2203, "==(1)", 1, partcv, params);
// compiled op node returning opresult2204 (depth = 8)
  Object if2200 = done;
  if (istrue(opresult2204)) {
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2205 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array2206 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit2207 == NULL) {
    strlit2207 = alloc_String("rbrace");
    gc_root(strlit2207);
  }
// compiled string node returning strlit2207 (depth = 11)
  params[0] = strlit2207;
  partcv[0] = 1;
  callmethodflags(array2206, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array2206 (depth = 10)
  gc_frame_newslot(array2206);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = array2206;
  partcv[0] = 1;
  Object call2208 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2205);
// compiled call node returning call2208 (depth = 9)
  *var_nextTok = call2208;
  if (call2208 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2211 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2211 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2213 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2213 (depth = 9)
  Object if2210 = done;
  if (istrue(opresult2213)) {
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2214 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2215 == NULL) {
    strlit2215 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"" } then {");
    gc_root(strlit2215);
  }
// compiled string node returning strlit2215 (depth = 10)
  gc_frame_newslot(strlit2215);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2215;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2216 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2214);
// compiled call node returning call2216 (depth = 9)
    gc_frame_newslot(call2216);
    if2210 = call2216;
  } else {
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2217 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe2218 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call2219 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe2218);
// compiled member node returning call2219 (depth = 10)
  gc_frame_newslot(call2219);
// starting to compile identifier node (depth = 10)
  Object bool2220 = alloc_Boolean(1);
// compiled identifier node returning bool2220 (depth = 10)
  gc_frame_newslot(bool2220);
// starting to compile identifier node (depth = 10)
  Object bool2221 = alloc_Boolean(0);
// compiled identifier node returning bool2221 (depth = 10)
  gc_frame_newslot(bool2221);
// starting to compile string node (depth = 10)
  if (strlit2222 == NULL) {
    strlit2222 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"" } then {");
    gc_root(strlit2222);
  }
// compiled string node returning strlit2222 (depth = 10)
  gc_frame_newslot(strlit2222);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2219;
  params[2] = bool2220;
  params[3] = bool2221;
  params[4] = strlit2222;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2223 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2217);
// compiled call node returning call2223 (depth = 9)
    gc_frame_newslot(call2223);
    if2210 = call2223;
  }
// compiled if node returning if2210 (depth = 8)
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2224 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2225 == NULL) {
    strlit2225 = alloc_String("an elseif clause must have an expression in braces after the 'elseif'.");
    gc_root(strlit2225);
  }
// compiled string node returning strlit2225 (depth = 9)
  gc_frame_newslot(strlit2225);
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe2226 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2227 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2226);
// compiled member node returning call2227 (depth = 9)
  gc_frame_newslot(call2227);
// starting to compile member node (depth = 9)
  int callframe2228 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2229 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2228);
// compiled member node returning call2229 (depth = 9)
  gc_frame_newslot(call2229);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2225;
  params[1] = call2227;
  params[2] = call2229;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2230 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2224);
// compiled call node returning call2230 (depth = 8)
    gc_frame_newslot(call2230);
    if2200 = call2230;
  } else {
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2232 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2232 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2234 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2234 (depth = 9)
  Object if2231 = done;
  if (istrue(opresult2234)) {
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2235 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2236 == NULL) {
    strlit2236 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2236);
  }
// compiled string node returning strlit2236 (depth = 10)
  gc_frame_newslot(strlit2236);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2236;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2237 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2235);
// compiled call node returning call2237 (depth = 9)
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2238 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2239 == NULL) {
    strlit2239 = alloc_String("an elseif clause must have an expression in braces after the 'elseif'.");
    gc_root(strlit2239);
  }
// compiled string node returning strlit2239 (depth = 10)
  gc_frame_newslot(strlit2239);
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe2240 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2241 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2240);
// compiled member node returning call2241 (depth = 10)
  gc_frame_newslot(call2241);
// starting to compile member node (depth = 10)
  int callframe2242 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2243 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2242);
// compiled member node returning call2243 (depth = 10)
  gc_frame_newslot(call2243);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2239;
  params[1] = call2241;
  params[2] = call2243;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2244 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2238);
// compiled call node returning call2244 (depth = 9)
    gc_frame_newslot(call2244);
    if2231 = call2244;
  } else {
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2245 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe2246 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call2247 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe2246);
// compiled member node returning call2247 (depth = 10)
  gc_frame_newslot(call2247);
// starting to compile identifier node (depth = 10)
  Object bool2248 = alloc_Boolean(0);
// compiled identifier node returning bool2248 (depth = 10)
  gc_frame_newslot(bool2248);
// starting to compile identifier node (depth = 10)
  Object bool2249 = alloc_Boolean(1);
// compiled identifier node returning bool2249 (depth = 10)
  gc_frame_newslot(bool2249);
// starting to compile string node (depth = 10)
  if (strlit2250 == NULL) {
    strlit2250 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2250);
  }
// compiled string node returning strlit2250 (depth = 10)
  gc_frame_newslot(strlit2250);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2247;
  params[2] = bool2248;
  params[3] = bool2249;
  params[4] = strlit2250;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2251 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2245);
// compiled call node returning call2251 (depth = 9)
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2252 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2253 == NULL) {
    strlit2253 = alloc_String("(4) an elseif statement must have an expression in braces after the 'elseif'.");
    gc_root(strlit2253);
  }
// compiled string node returning strlit2253 (depth = 10)
  gc_frame_newslot(strlit2253);
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe2254 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2255 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2254);
// compiled member node returning call2255 (depth = 10)
  gc_frame_newslot(call2255);
// starting to compile member node (depth = 10)
  int callframe2256 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2257 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2256);
// compiled member node returning call2257 (depth = 10)
  gc_frame_newslot(call2257);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2259 = alloc_Float64(1);
// compiled num node returning num2259 (depth = 11)
  int op_slot_right_2258 = gc_frame_newslot(num2259);
// starting to compile member node (depth = 11)
  int callframe2261 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2262 = callmethodflags(*var_nextTok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2261);
// compiled member node returning call2262 (depth = 11)
  int op_slot_left_2258 = gc_frame_newslot(call2262);
  params[0] = num2259;
  partcv[0] = 1;
  Object diff2263 = callmethod(call2262, "-(1)", 1, partcv, params);
// compiled op node returning diff2263 (depth = 10)
  gc_frame_newslot(diff2263);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2253;
  params[1] = call2255;
  params[2] = call2257;
  params[3] = diff2263;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2264 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2252);
// compiled call node returning call2264 (depth = 9)
    gc_frame_newslot(call2264);
    if2231 = call2264;
  }
// compiled if node returning if2231 (depth = 8)
    gc_frame_newslot(if2231);
    if2200 = if2231;
  }
// compiled if node returning if2200 (depth = 7)
    gc_frame_newslot(if2200);
    if2167 = if2200;
  } else {
  }
// compiled if node returning if2167 (depth = 6)
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2267 == NULL) {
    strlit2267 = alloc_String("}");
    gc_root(strlit2267);
  }
// compiled string node returning strlit2267 (depth = 8)
  int op_slot_right_2266 = gc_frame_newslot(strlit2267);
// starting to compile member node (depth = 8)
  int callframe2269 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2270 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe2269);
// compiled member node returning call2270 (depth = 8)
  int op_slot_left_2266 = gc_frame_newslot(call2270);
  params[0] = strlit2267;
  partcv[0] = 1;
  Object opresult2271 = callmethod(call2270, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2271 (depth = 7)
  Object if2265 = done;
  if (istrue(opresult2271)) {
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2272 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2273 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2272);
// compiled member node returning call2273 (depth = 7)
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2274 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2275 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call2276 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2275);
// compiled member node returning call2276 (depth = 9)
  partcv[0] = 0;
  Object call2277 = callmethodflags(call2276, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2274);
// compiled member node returning call2277 (depth = 8)
  *var_suggestion = call2277;
  if (call2277 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2278 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2279 == NULL) {
    strlit2279 = alloc_String(")");
    gc_root(strlit2279);
  }
// compiled string node returning strlit2279 (depth = 8)
  gc_frame_newslot(strlit2279);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2279;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2280 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2278);
// compiled call node returning call2280 (depth = 7)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2281 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2283 == NULL) {
    strlit2283 = alloc_String("'{' must end with a '}'.");
    gc_root(strlit2283);
  }
// compiled string node returning strlit2283 (depth = 9)
  int op_slot_right_2282 = gc_frame_newslot(strlit2283);
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2285 == NULL) {
    strlit2285 = alloc_String("a condition beginning with a ");
    gc_root(strlit2285);
  }
// compiled string node returning strlit2285 (depth = 9)
  int op_slot_left_2282 = gc_frame_newslot(strlit2285);
  params[0] = strlit2283;
  partcv[0] = 1;
  Object opresult2286 = callmethod(strlit2285, "++(1)", 1, partcv, params);
// compiled op node returning opresult2286 (depth = 8)
  gc_frame_newslot(opresult2286);
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2287 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2288 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2287);
// compiled member node returning call2288 (depth = 8)
  gc_frame_newslot(call2288);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2290 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2291 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2290);
// compiled member node returning call2291 (depth = 9)
  int op_slot_right_2289 = gc_frame_newslot(call2291);
// starting to compile member node (depth = 9)
  int callframe2293 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2294 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2293);
// compiled member node returning call2294 (depth = 9)
  int op_slot_left_2289 = gc_frame_newslot(call2294);
  params[0] = call2291;
  partcv[0] = 1;
  Object sum2295 = callmethod(call2294, "+(1)", 1, partcv, params);
// compiled op node returning sum2295 (depth = 8)
  gc_frame_newslot(sum2295);
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2286;
  params[1] = call2288;
  params[2] = sum2295;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2296 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2281);
// compiled call node returning call2296 (depth = 7)
    gc_frame_newslot(call2296);
    if2265 = call2296;
  } else {
  }
// compiled if node returning if2265 (depth = 6)
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2298 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2297);
// compiled member node returning call2298 (depth = 6)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2299 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call2300 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe2299);
// compiled member node returning call2300 (depth = 7)
  *var_econd = call2300;
  if (call2300 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2305 == NULL) {
    strlit2305 = alloc_String("then");
    gc_root(strlit2305);
  }
// compiled string node returning strlit2305 (depth = 9)
  int op_slot_right_2304 = gc_frame_newslot(strlit2305);
// starting to compile member node (depth = 9)
  int callframe2307 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2308 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe2307);
// compiled member node returning call2308 (depth = 9)
  int op_slot_left_2304 = gc_frame_newslot(call2308);
  params[0] = strlit2305;
  partcv[0] = 1;
  Object opresult2309 = callmethod(call2308, "==(1)", 1, partcv, params);
// compiled op node returning opresult2309 (depth = 8)
  int op_slot_right_2303 = gc_frame_newslot(opresult2309);
// starting to compile call node (depth = 8)
  int callframe2311 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2312 == NULL) {
    strlit2312 = alloc_String("identifier");
    gc_root(strlit2312);
  }
// compiled string node returning strlit2312 (depth = 9)
  gc_frame_newslot(strlit2312);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = strlit2312;
  partcv[0] = 1;
  Object call2313 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2311);
// compiled call node returning call2313 (depth = 8)
  int op_slot_left_2303 = gc_frame_newslot(call2313);
  params[0] = opresult2309;
  partcv[0] = 1;
  Object opresult2314 = callmethod(call2313, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2314 (depth = 7)
  Object if2302 = done;
  if (istrue(opresult2314)) {
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minStartColumn (depth = 9)
  int op_slot_right_2316 = gc_frame_newslot(*var_minStartColumn);
// starting to compile member node (depth = 9)
  int callframe2318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2319 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2318);
// compiled member node returning call2319 (depth = 9)
  int op_slot_left_2316 = gc_frame_newslot(call2319);
  params[0] = *var_minStartColumn;
  partcv[0] = 1;
  Object opresult2320 = callmethod(call2319, "<(1)", 1, partcv, params);
// compiled op node returning opresult2320 (depth = 8)
  Object if2315 = done;
  if (istrue(opresult2320)) {
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2321 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2323 == NULL) {
    strlit2323 = alloc_String("'if(_)""\xe2""""\x80""""\xa6""elseif(_)then(_)' must be indented more than the 'if'");
    gc_root(strlit2323);
  }
// compiled string node returning strlit2323 (depth = 10)
  int op_slot_right_2322 = gc_frame_newslot(strlit2323);
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2325 == NULL) {
    strlit2325 = alloc_String("the 'then' part of an ");
    gc_root(strlit2325);
  }
// compiled string node returning strlit2325 (depth = 10)
  int op_slot_left_2322 = gc_frame_newslot(strlit2325);
  params[0] = strlit2323;
  partcv[0] = 1;
  Object opresult2326 = callmethod(strlit2325, "++(1)", 1, partcv, params);
// compiled op node returning opresult2326 (depth = 9)
  gc_frame_newslot(opresult2326);
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe2327 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2328 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2327);
// compiled member node returning call2328 (depth = 9)
  gc_frame_newslot(call2328);
// starting to compile member node (depth = 9)
  int callframe2329 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2330 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2329);
// compiled member node returning call2330 (depth = 9)
  gc_frame_newslot(call2330);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2332 = alloc_Float64(3);
// compiled num node returning num2332 (depth = 10)
  int op_slot_right_2331 = gc_frame_newslot(num2332);
// starting to compile member node (depth = 10)
  int callframe2334 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2335 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2334);
// compiled member node returning call2335 (depth = 10)
  int op_slot_left_2331 = gc_frame_newslot(call2335);
  params[0] = num2332;
  partcv[0] = 1;
  Object sum2336 = callmethod(call2335, "+(1)", 1, partcv, params);
// compiled op node returning sum2336 (depth = 9)
  gc_frame_newslot(sum2336);
// call case 6: other requests
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult2326;
  params[1] = call2328;
  params[2] = call2330;
  params[3] = sum2336;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2337 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe2321);
// compiled call node returning call2337 (depth = 8)
    gc_frame_newslot(call2337);
    if2315 = call2337;
  } else {
  }
// compiled if node returning if2315 (depth = 7)
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2338 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2339 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2338);
// compiled member node returning call2339 (depth = 7)
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile array node (depth = 8)
  Object array2340 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2340 (depth = 8)
  *var_ebody = array2340;
  if (array2340 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2302 = done;
  } else {
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2342 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2343 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call2344 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2343);
// compiled member node returning call2344 (depth = 9)
  partcv[0] = 0;
  Object call2345 = callmethodflags(call2344, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2342);
// compiled member node returning call2345 (depth = 8)
  *var_suggestion = call2345;
  if (call2345 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2348 == NULL) {
    strlit2348 = alloc_String("lbrace");
    gc_root(strlit2348);
  }
// compiled string node returning strlit2348 (depth = 9)
  int op_slot_right_2347 = gc_frame_newslot(strlit2348);
// starting to compile member node (depth = 9)
  int callframe2350 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2351 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2350);
// compiled member node returning call2351 (depth = 9)
  int op_slot_left_2347 = gc_frame_newslot(call2351);
  params[0] = strlit2348;
  partcv[0] = 1;
  Object opresult2352 = callmethod(call2351, "==(1)", 1, partcv, params);
// compiled op node returning opresult2352 (depth = 8)
  Object if2346 = done;
  if (istrue(opresult2352)) {
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2353 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2354 = alloc_Boolean(0);
// compiled identifier node returning bool2354 (depth = 10)
  gc_frame_newslot(bool2354);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_statementToken;
  params[1] = bool2354;
  partcv[0] = 2;
  Object call2355 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2353);
// compiled call node returning call2355 (depth = 9)
  *var_closingBrace = call2355;
  if (call2355 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2357 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2358 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2359 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe2358);
// compiled member node returning call2359 (depth = 10)
  partcv[0] = 0;
  Object call2360 = callmethodflags(call2359, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2357);
// compiled member node returning call2360 (depth = 9)
  Object if2356 = done;
  if (istrue(call2360)) {
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2362 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
  int callframe2364 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2365 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2364);
// compiled member node returning call2365 (depth = 11)
  int op_slot_left_2362 = gc_frame_newslot(call2365);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2366 = callmethod(call2365, "==(1)", 1, partcv, params);
// compiled op node returning opresult2366 (depth = 10)
  Object if2361 = done;
  if (istrue(opresult2366)) {
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2367 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2368 = alloc_Boolean(1);
// compiled identifier node returning bool2368 (depth = 11)
  gc_frame_newslot(bool2368);
// starting to compile identifier node (depth = 11)
  Object bool2369 = alloc_Boolean(0);
// compiled identifier node returning bool2369 (depth = 11)
  gc_frame_newslot(bool2369);
// starting to compile string node (depth = 11)
  if (strlit2370 == NULL) {
    strlit2370 = alloc_String(" then {}");
    gc_root(strlit2370);
  }
// compiled string node returning strlit2370 (depth = 11)
  gc_frame_newslot(strlit2370);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2368;
  params[2] = bool2369;
  params[3] = strlit2370;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2371 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2367);
// compiled call node returning call2371 (depth = 10)
    gc_frame_newslot(call2371);
    if2361 = call2371;
  } else {
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2372 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2373 = alloc_Boolean(1);
// compiled identifier node returning bool2373 (depth = 11)
  gc_frame_newslot(bool2373);
// starting to compile identifier node (depth = 11)
  Object bool2374 = alloc_Boolean(0);
// compiled identifier node returning bool2374 (depth = 11)
  gc_frame_newslot(bool2374);
// starting to compile string node (depth = 11)
  if (strlit2375 == NULL) {
    strlit2375 = alloc_String(" then {");
    gc_root(strlit2375);
  }
// compiled string node returning strlit2375 (depth = 11)
  gc_frame_newslot(strlit2375);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2373;
  params[2] = bool2374;
  params[3] = strlit2375;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2376 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2372);
// compiled call node returning call2376 (depth = 10)
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2377 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2379 = alloc_Float64(0.1);
// compiled num node returning num2379 (depth = 12)
  int op_slot_right_2378 = gc_frame_newslot(num2379);
// starting to compile member node (depth = 12)
  int callframe2381 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2382 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2383 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2382);
// compiled member node returning call2383 (depth = 13)
  partcv[0] = 0;
  Object call2384 = callmethodflags(call2383, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2381);
// compiled member node returning call2384 (depth = 12)
  int op_slot_left_2378 = gc_frame_newslot(call2384);
  params[0] = num2379;
  partcv[0] = 1;
  Object sum2385 = callmethod(call2384, "+(1)", 1, partcv, params);
// compiled op node returning sum2385 (depth = 11)
  gc_frame_newslot(sum2385);
// starting to compile string node (depth = 11)
  if (strlit2386 == NULL) {
    strlit2386 = alloc_String("}");
    gc_root(strlit2386);
  }
// compiled string node returning strlit2386 (depth = 11)
  gc_frame_newslot(strlit2386);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2385;
  params[1] = strlit2386;
  partcv[0] = 2;
  Object call2387 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2377);
// compiled call node returning call2387 (depth = 10)
    gc_frame_newslot(call2387);
    if2361 = call2387;
  }
// compiled if node returning if2361 (depth = 9)
    gc_frame_newslot(if2361);
    if2356 = if2361;
  } else {
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2388 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
  Object bool2389 = alloc_Boolean(1);
// compiled identifier node returning bool2389 (depth = 10)
  gc_frame_newslot(bool2389);
// starting to compile identifier node (depth = 10)
  Object bool2390 = alloc_Boolean(0);
// compiled identifier node returning bool2390 (depth = 10)
  gc_frame_newslot(bool2390);
// starting to compile string node (depth = 10)
  if (strlit2391 == NULL) {
    strlit2391 = alloc_String(" then {");
    gc_root(strlit2391);
  }
// compiled string node returning strlit2391 (depth = 10)
  gc_frame_newslot(strlit2391);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = bool2389;
  params[2] = bool2390;
  params[3] = strlit2391;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2392 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2388);
// compiled call node returning call2392 (depth = 9)
    gc_frame_newslot(call2392);
    if2356 = call2392;
  }
// compiled if node returning if2356 (depth = 8)
    gc_frame_newslot(if2356);
    if2346 = if2356;
  } else {
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2393 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2394 = alloc_Boolean(1);
// compiled identifier node returning bool2394 (depth = 10)
  gc_frame_newslot(bool2394);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_statementToken;
  params[1] = bool2394;
  partcv[0] = 2;
  Object call2395 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2393);
// compiled call node returning call2395 (depth = 9)
  *var_closingBrace = call2395;
  if (call2395 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2397 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2398 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2399 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe2398);
// compiled member node returning call2399 (depth = 10)
  partcv[0] = 0;
  Object call2400 = callmethodflags(call2399, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2397);
// compiled member node returning call2400 (depth = 9)
  Object if2396 = done;
  if (istrue(call2400)) {
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2402 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
  int callframe2404 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2405 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2404);
// compiled member node returning call2405 (depth = 11)
  int op_slot_left_2402 = gc_frame_newslot(call2405);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2406 = callmethod(call2405, "==(1)", 1, partcv, params);
// compiled op node returning opresult2406 (depth = 10)
  Object if2401 = done;
  if (istrue(opresult2406)) {
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2407 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2408 == NULL) {
    strlit2408 = alloc_String(" then {}");
    gc_root(strlit2408);
  }
// compiled string node returning strlit2408 (depth = 11)
  gc_frame_newslot(strlit2408);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2408;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2409 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2407);
// compiled call node returning call2409 (depth = 10)
    gc_frame_newslot(call2409);
    if2401 = call2409;
  } else {
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2410 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2411 == NULL) {
    strlit2411 = alloc_String(" then {");
    gc_root(strlit2411);
  }
// compiled string node returning strlit2411 (depth = 11)
  gc_frame_newslot(strlit2411);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2411;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2412 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2410);
// compiled call node returning call2412 (depth = 10)
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2413 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2415 = alloc_Float64(0.1);
// compiled num node returning num2415 (depth = 12)
  int op_slot_right_2414 = gc_frame_newslot(num2415);
// starting to compile member node (depth = 12)
  int callframe2417 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2418 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2419 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2418);
// compiled member node returning call2419 (depth = 13)
  partcv[0] = 0;
  Object call2420 = callmethodflags(call2419, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2417);
// compiled member node returning call2420 (depth = 12)
  int op_slot_left_2414 = gc_frame_newslot(call2420);
  params[0] = num2415;
  partcv[0] = 1;
  Object sum2421 = callmethod(call2420, "+(1)", 1, partcv, params);
// compiled op node returning sum2421 (depth = 11)
  gc_frame_newslot(sum2421);
// starting to compile string node (depth = 11)
  if (strlit2422 == NULL) {
    strlit2422 = alloc_String("}");
    gc_root(strlit2422);
  }
// compiled string node returning strlit2422 (depth = 11)
  gc_frame_newslot(strlit2422);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2421;
  params[1] = strlit2422;
  partcv[0] = 2;
  Object call2423 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2413);
// compiled call node returning call2423 (depth = 10)
    gc_frame_newslot(call2423);
    if2401 = call2423;
  }
// compiled if node returning if2401 (depth = 9)
    gc_frame_newslot(if2401);
    if2396 = if2401;
  } else {
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2424 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2425 == NULL) {
    strlit2425 = alloc_String(" then {");
    gc_root(strlit2425);
  }
// compiled string node returning strlit2425 (depth = 10)
  gc_frame_newslot(strlit2425);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2425;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2426 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2424);
// compiled call node returning call2426 (depth = 9)
    gc_frame_newslot(call2426);
    if2396 = call2426;
  }
// compiled if node returning if2396 (depth = 8)
    gc_frame_newslot(if2396);
    if2346 = if2396;
  }
// compiled if node returning if2346 (depth = 7)
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2427 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2428 == NULL) {
    strlit2428 = alloc_String("an elseif clause must have 'then' after the expression in braces.");
    gc_root(strlit2428);
  }
// compiled string node returning strlit2428 (depth = 8)
  gc_frame_newslot(strlit2428);
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2429 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2430 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2429);
// compiled member node returning call2430 (depth = 8)
  gc_frame_newslot(call2430);
// starting to compile member node (depth = 8)
  int callframe2431 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2432 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2431);
// compiled member node returning call2432 (depth = 8)
  gc_frame_newslot(call2432);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2428;
  params[1] = call2430;
  params[2] = call2432;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2433 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2427);
// compiled call node returning call2433 (depth = 7)
    gc_frame_newslot(call2433);
    if2302 = call2433;
  }
// compiled if node returning if2302 (depth = 6)
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2436 == NULL) {
    strlit2436 = alloc_String("lbrace");
    gc_root(strlit2436);
  }
// compiled string node returning strlit2436 (depth = 8)
  int op_slot_right_2435 = gc_frame_newslot(strlit2436);
// starting to compile member node (depth = 8)
  int callframe2438 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2439 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2438);
// compiled member node returning call2439 (depth = 8)
  int op_slot_left_2435 = gc_frame_newslot(call2439);
  params[0] = strlit2436;
  partcv[0] = 1;
  Object opresult2440 = callmethod(call2439, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2440 (depth = 7)
  Object if2434 = done;
  if (istrue(opresult2440)) {
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2441 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2442 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call2443 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2442);
// compiled member node returning call2443 (depth = 9)
  partcv[0] = 0;
  Object call2444 = callmethodflags(call2443, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2441);
// compiled member node returning call2444 (depth = 8)
  *var_suggestion = call2444;
  if (call2444 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2445 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2446 = alloc_Boolean(1);
// compiled identifier node returning bool2446 (depth = 9)
  gc_frame_newslot(bool2446);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_btok;
  params[1] = bool2446;
  partcv[0] = 2;
  Object call2447 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2445);
// compiled call node returning call2447 (depth = 8)
  *var_closingBrace = call2447;
  if (call2447 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2449 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2450 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call2451 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe2450);
// compiled member node returning call2451 (depth = 9)
  partcv[0] = 0;
  Object call2452 = callmethodflags(call2451, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2449);
// compiled member node returning call2452 (depth = 8)
  Object if2448 = done;
  if (istrue(call2452)) {
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2454 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
  int callframe2456 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2457 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2456);
// compiled member node returning call2457 (depth = 10)
  int op_slot_left_2454 = gc_frame_newslot(call2457);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2458 = callmethod(call2457, "==(1)", 1, partcv, params);
// compiled op node returning opresult2458 (depth = 9)
  Object if2453 = done;
  if (istrue(opresult2458)) {
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2459 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2460 = alloc_Boolean(0);
// compiled identifier node returning bool2460 (depth = 10)
  gc_frame_newslot(bool2460);
// starting to compile identifier node (depth = 10)
  Object bool2461 = alloc_Boolean(1);
// compiled identifier node returning bool2461 (depth = 10)
  gc_frame_newslot(bool2461);
// starting to compile string node (depth = 10)
  if (strlit2462 == NULL) {
    strlit2462 = alloc_String("then {}");
    gc_root(strlit2462);
  }
// compiled string node returning strlit2462 (depth = 10)
  gc_frame_newslot(strlit2462);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2460;
  params[2] = bool2461;
  params[3] = strlit2462;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2463 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2459);
// compiled call node returning call2463 (depth = 9)
    gc_frame_newslot(call2463);
    if2453 = call2463;
  } else {
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2464 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2466 = alloc_Float64(0.1);
// compiled num node returning num2466 (depth = 11)
  int op_slot_right_2465 = gc_frame_newslot(num2466);
// starting to compile member node (depth = 11)
  int callframe2468 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2469 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2470 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2469);
// compiled member node returning call2470 (depth = 12)
  partcv[0] = 0;
  Object call2471 = callmethodflags(call2470, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2468);
// compiled member node returning call2471 (depth = 11)
  int op_slot_left_2465 = gc_frame_newslot(call2471);
  params[0] = num2466;
  partcv[0] = 1;
  Object sum2472 = callmethod(call2471, "+(1)", 1, partcv, params);
// compiled op node returning sum2472 (depth = 10)
  gc_frame_newslot(sum2472);
// starting to compile string node (depth = 10)
  if (strlit2473 == NULL) {
    strlit2473 = alloc_String("}");
    gc_root(strlit2473);
  }
// compiled string node returning strlit2473 (depth = 10)
  gc_frame_newslot(strlit2473);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2472;
  params[1] = strlit2473;
  partcv[0] = 2;
  Object call2474 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2464);
// compiled call node returning call2474 (depth = 9)
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2475 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2476 = alloc_Boolean(0);
// compiled identifier node returning bool2476 (depth = 10)
  gc_frame_newslot(bool2476);
// starting to compile identifier node (depth = 10)
  Object bool2477 = alloc_Boolean(1);
// compiled identifier node returning bool2477 (depth = 10)
  gc_frame_newslot(bool2477);
// starting to compile string node (depth = 10)
  if (strlit2478 == NULL) {
    strlit2478 = alloc_String("then {");
    gc_root(strlit2478);
  }
// compiled string node returning strlit2478 (depth = 10)
  gc_frame_newslot(strlit2478);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2476;
  params[2] = bool2477;
  params[3] = strlit2478;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2479 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2475);
// compiled call node returning call2479 (depth = 9)
    gc_frame_newslot(call2479);
    if2453 = call2479;
  }
// compiled if node returning if2453 (depth = 8)
    gc_frame_newslot(if2453);
    if2448 = if2453;
  } else {
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2480 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2481 = alloc_Boolean(0);
// compiled identifier node returning bool2481 (depth = 9)
  gc_frame_newslot(bool2481);
// starting to compile identifier node (depth = 9)
  Object bool2482 = alloc_Boolean(1);
// compiled identifier node returning bool2482 (depth = 9)
  gc_frame_newslot(bool2482);
// starting to compile string node (depth = 9)
  if (strlit2483 == NULL) {
    strlit2483 = alloc_String("then {");
    gc_root(strlit2483);
  }
// compiled string node returning strlit2483 (depth = 9)
  gc_frame_newslot(strlit2483);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2481;
  params[2] = bool2482;
  params[3] = strlit2483;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2484 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2480);
// compiled call node returning call2484 (depth = 8)
    gc_frame_newslot(call2484);
    if2448 = call2484;
  }
// compiled if node returning if2448 (depth = 7)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2485 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2486 == NULL) {
    strlit2486 = alloc_String("an elseif clause must have a '{' after the 'then'.");
    gc_root(strlit2486);
  }
// compiled string node returning strlit2486 (depth = 8)
  gc_frame_newslot(strlit2486);
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2487 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2488 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2487);
// compiled member node returning call2488 (depth = 8)
  gc_frame_newslot(call2488);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2490 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2491 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2490);
// compiled member node returning call2491 (depth = 9)
  int op_slot_right_2489 = gc_frame_newslot(call2491);
// starting to compile member node (depth = 9)
  int callframe2493 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2494 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2493);
// compiled member node returning call2494 (depth = 9)
  int op_slot_left_2489 = gc_frame_newslot(call2494);
  params[0] = call2491;
  partcv[0] = 1;
  Object sum2495 = callmethod(call2494, "+(1)", 1, partcv, params);
// compiled op node returning sum2495 (depth = 8)
  gc_frame_newslot(sum2495);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2486;
  params[1] = call2488;
  params[2] = sum2495;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2496 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2485);
// compiled call node returning call2496 (depth = 7)
    gc_frame_newslot(call2496);
    if2434 = call2496;
  } else {
  }
// compiled if node returning if2434 (depth = 6)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2497 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2498 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2497);
// compiled member node returning call2498 (depth = 6)
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2501 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2502 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2501);
// compiled member node returning call2502 (depth = 8)
  int op_slot_right_2500 = gc_frame_newslot(call2502);
// starting to compile member node (depth = 8)
  int callframe2504 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2505 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2504);
// compiled member node returning call2505 (depth = 8)
  int op_slot_left_2500 = gc_frame_newslot(call2505);
  params[0] = call2502;
  partcv[0] = 1;
  Object opresult2506 = callmethod(call2505, "==(1)", 1, partcv, params);
// compiled op node returning opresult2506 (depth = 7)
  Object if2499 = done;
  if (istrue(opresult2506)) {
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2508 = alloc_Float64(1);
// compiled num node returning num2508 (depth = 9)
  int op_slot_right_2507 = gc_frame_newslot(num2508);
// starting to compile member node (depth = 9)
  int callframe2510 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2511 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2510);
// compiled member node returning call2511 (depth = 9)
  int op_slot_left_2507 = gc_frame_newslot(call2511);
  params[0] = num2508;
  partcv[0] = 1;
  Object diff2512 = callmethod(call2511, "-(1)", 1, partcv, params);
// compiled op node returning diff2512 (depth = 8)
  *var_minIndentLevel = diff2512;
  if (diff2512 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2499 = done;
  } else {
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minInd (depth = 8)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2499 = done;
  }
// compiled if node returning if2499 (depth = 6)
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2515 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2516 = alloc_Block(NULL, NULL, "parser", 910);
  gc_frame_newslot(block2516);
// method "_apply"
  block_savedest(block2516);
  Object closure2517 = createclosure(1, "_apply");
  setclosureframe(closure2517, stackframe);
  addtoclosure(closure2517, selfslot);
  struct UserObject *uo2517 = (struct UserObject*)block2516;
  uo2517->data[0] = (Object)closure2517;
  Method *meth_meth_parser_2517__apply = addmethod2pos(block2516, "_apply", &meth_parser_2517__apply, 0);
  int argcv_meth_parser_2517__apply[] = {0};
  meth_meth_parser_2517__apply->type = alloc_MethodType(1, argcv_meth_parser_2517__apply);
  meth_meth_parser_2517__apply->definitionModule = modulename;
  meth_meth_parser_2517__apply->definitionLine = 183;
// compiled block node returning block2516 (depth = 7)
  gc_frame_newslot(block2516);
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 7)
  Object block2524 = alloc_Block(NULL, NULL, "parser", 910);
  gc_frame_newslot(block2524);
// method "_apply"
  block_savedest(block2524);
  Object closure2525 = createclosure(8, "_apply");
  setclosureframe(closure2525, stackframe);
  addtoclosure(closure2525, var_errormessages);
  addtoclosure(closure2525, var_btok);
  addtoclosure(closure2525, var_lastToken);
  addtoclosure(closure2525, var_sym);
  addtoclosure(closure2525, var_values);
  addtoclosure(closure2525, var_v);
  addtoclosure(closure2525, var_ebody);
  addtoclosure(closure2525, selfslot);
  struct UserObject *uo2525 = (struct UserObject*)block2524;
  uo2525->data[0] = (Object)closure2525;
  Method *meth_meth_parser_2525__apply = addmethod2pos(block2524, "_apply", &meth_parser_2525__apply, 0);
  int argcv_meth_parser_2525__apply[] = {0};
  meth_meth_parser_2525__apply->type = alloc_MethodType(1, argcv_meth_parser_2525__apply);
  meth_meth_parser_2525__apply->definitionModule = modulename;
  meth_meth_parser_2525__apply->definitionLine = 183;
// compiled block node returning block2524 (depth = 7)
  gc_frame_newslot(block2524);
// call case 5: prelude request
  params[0] = block2516;
  params[1] = block2524;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2581 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2515);
// compiled call node returning call2581 (depth = 6)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2582 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2583 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2582);
// compiled member node returning call2583 (depth = 6)
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile array node (depth = 7)
  Object array2584 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2584 (depth = 7)
  *var_newelse = array2584;
  if (array2584 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2586 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_econd (depth = 8)
  gc_frame_newslot(*var_econd);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ebody (depth = 8)
  gc_frame_newslot(*var_ebody);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newelse (depth = 8)
  gc_frame_newslot(*var_newelse);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_econd;
  params[1] = *var_ebody;
  params[2] = *var_newelse;
  partcv[0] = 3;
  Object call2587 = callmethodflags(module_parser, "newIf(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2586);
// compiled call node returning call2587 (depth = 7)
  *var_eif = call2587;
  if (call2587 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2589 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_eif (depth = 7)
  gc_frame_newslot(*var_eif);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_curelse (depth = 7)
  params[0] = *var_eif;
  partcv[0] = 1;
  Object call2590 = callmethodflags(*var_curelse, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2589);
// compiled call node returning call2590 (depth = 6)
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newelse (depth = 7)
  *var_curelse = *var_newelse;
  if (*var_newelse == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_2719__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 7)
  int callframe2720 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe2721 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2722 == NULL) {
    strlit2722 = alloc_String("rbrace");
    gc_root(strlit2722);
  }
// compiled string node returning strlit2722 (depth = 9)
  gc_frame_newslot(strlit2722);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = strlit2722;
  partcv[0] = 1;
  Object call2723 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2721);
// compiled call node returning call2723 (depth = 8)
  partcv[0] = 0;
  Object call2724 = callmethodflags(call2723, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2720);
// compiled member node returning call2724 (depth = 7)
  gc_frame_end(frame);
  return call2724;
}
Object meth_parser_2731__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 10)
  int callframe2732 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2733 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2732);
// compiled member node returning call2733 (depth = 10)
  gc_frame_end(frame);
  return call2733;
}
Object meth_parser_2727__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_curelse = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2729 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2730 = alloc_Block(NULL, NULL, "parser", 971);
  gc_frame_newslot(block2730);
// method "_apply"
  block_savedest(block2730);
  Object closure2731 = createclosure(1, "_apply");
  setclosureframe(closure2731, stackframe);
  addtoclosure(closure2731, selfslot);
  struct UserObject *uo2731 = (struct UserObject*)block2730;
  uo2731->data[0] = (Object)closure2731;
  Method *meth_meth_parser_2731__apply = addmethod2pos(block2730, "_apply", &meth_parser_2731__apply, 0);
  int argcv_meth_parser_2731__apply[] = {0};
  meth_meth_parser_2731__apply->type = alloc_MethodType(1, argcv_meth_parser_2731__apply);
  meth_meth_parser_2731__apply->definitionModule = modulename;
  meth_meth_parser_2731__apply->definitionLine = 183;
// compiled block node returning block2730 (depth = 9)
  gc_frame_newslot(block2730);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = block2730;
  partcv[0] = 1;
  Object call2735 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2729);
// compiled call node returning call2735 (depth = 8)
  Object if2728 = done;
  if (istrue(call2735)) {
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2736 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2737 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call2738 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2737);
// compiled member node returning call2738 (depth = 10)
  partcv[0] = 0;
  Object call2739 = callmethodflags(call2738, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2736);
// compiled member node returning call2739 (depth = 9)
  *var_suggestion = call2739;
  if (call2739 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2740 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 10)
  Object bool2741 = alloc_Boolean(0);
// compiled identifier node returning bool2741 (depth = 10)
  gc_frame_newslot(bool2741);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_btok;
  params[1] = bool2741;
  partcv[0] = 2;
  Object call2742 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2740);
// compiled call node returning call2742 (depth = 9)
  *var_closingBrace = call2742;
  if (call2742 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2744 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2745 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2746 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe2745);
// compiled member node returning call2746 (depth = 10)
  partcv[0] = 0;
  Object call2747 = callmethodflags(call2746, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2744);
// compiled member node returning call2747 (depth = 9)
  Object if2743 = done;
  if (istrue(call2747)) {
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2750 == NULL) {
    strlit2750 = alloc_String("eof");
    gc_root(strlit2750);
  }
// compiled string node returning strlit2750 (depth = 11)
  int op_slot_right_2749 = gc_frame_newslot(strlit2750);
// starting to compile member node (depth = 11)
  int callframe2752 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2753 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2752);
// compiled member node returning call2753 (depth = 11)
  int op_slot_left_2749 = gc_frame_newslot(call2753);
  params[0] = strlit2750;
  partcv[0] = 1;
  Object opresult2754 = callmethod(call2753, "==(1)", 1, partcv, params);
// compiled op node returning opresult2754 (depth = 10)
  Object if2748 = done;
  if (istrue(opresult2754)) {
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2755 = gc_frame_new();
// starting to compile op node (depth = 11)
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2757 == NULL) {
    strlit2757 = alloc_String("an 'else' statement.");
    gc_root(strlit2757);
  }
// compiled string node returning strlit2757 (depth = 12)
  int op_slot_right_2756 = gc_frame_newslot(strlit2757);
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2760 == NULL) {
    strlit2760 = alloc_String("found while searching for the '}' to close ");
    gc_root(strlit2760);
  }
// compiled string node returning strlit2760 (depth = 13)
  int op_slot_right_2759 = gc_frame_newslot(strlit2760);
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2762 == NULL) {
    strlit2762 = alloc_String("end of program ");
    gc_root(strlit2762);
  }
// compiled string node returning strlit2762 (depth = 13)
  int op_slot_left_2759 = gc_frame_newslot(strlit2762);
  params[0] = strlit2760;
  partcv[0] = 1;
  Object opresult2763 = callmethod(strlit2762, "++(1)", 1, partcv, params);
// compiled op node returning opresult2763 (depth = 12)
  int op_slot_left_2756 = gc_frame_newslot(opresult2763);
  params[0] = strlit2757;
  partcv[0] = 1;
  Object opresult2764 = callmethod(opresult2763, "++(1)", 1, partcv, params);
// compiled op node returning opresult2764 (depth = 11)
  gc_frame_newslot(opresult2764);
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
  int callframe2765 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2766 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2765);
// compiled member node returning call2766 (depth = 11)
  gc_frame_newslot(call2766);
// starting to compile member node (depth = 11)
  int callframe2767 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2768 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2767);
// compiled member node returning call2768 (depth = 11)
  gc_frame_newslot(call2768);
// call case 6: other requests
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = opresult2764;
  params[1] = call2766;
  params[2] = call2768;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call2769 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe2755);
// compiled call node returning call2769 (depth = 10)
    gc_frame_newslot(call2769);
    if2748 = call2769;
  } else {
  }
// compiled if node returning if2748 (depth = 9)
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2771 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
  int callframe2773 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2774 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2773);
// compiled member node returning call2774 (depth = 11)
  int op_slot_left_2771 = gc_frame_newslot(call2774);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2775 = callmethod(call2774, "==(1)", 1, partcv, params);
// compiled op node returning opresult2775 (depth = 10)
  Object if2770 = done;
  if (istrue(opresult2775)) {
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2776 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2777 == NULL) {
    strlit2777 = alloc_String("}");
    gc_root(strlit2777);
  }
// compiled string node returning strlit2777 (depth = 11)
  gc_frame_newslot(strlit2777);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2777;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2778 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2776);
// compiled call node returning call2778 (depth = 10)
    gc_frame_newslot(call2778);
    if2770 = call2778;
  } else {
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2779 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2781 = alloc_Float64(0.1);
// compiled num node returning num2781 (depth = 12)
  int op_slot_right_2780 = gc_frame_newslot(num2781);
// starting to compile member node (depth = 12)
  int callframe2783 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2784 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2785 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2784);
// compiled member node returning call2785 (depth = 13)
  partcv[0] = 0;
  Object call2786 = callmethodflags(call2785, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2783);
// compiled member node returning call2786 (depth = 12)
  int op_slot_left_2780 = gc_frame_newslot(call2786);
  params[0] = num2781;
  partcv[0] = 1;
  Object sum2787 = callmethod(call2786, "+(1)", 1, partcv, params);
// compiled op node returning sum2787 (depth = 11)
  gc_frame_newslot(sum2787);
// starting to compile string node (depth = 11)
  if (strlit2788 == NULL) {
    strlit2788 = alloc_String("}");
    gc_root(strlit2788);
  }
// compiled string node returning strlit2788 (depth = 11)
  gc_frame_newslot(strlit2788);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2787;
  params[1] = strlit2788;
  partcv[0] = 2;
  Object call2789 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2779);
// compiled call node returning call2789 (depth = 10)
    gc_frame_newslot(call2789);
    if2770 = call2789;
  }
// compiled if node returning if2770 (depth = 9)
    gc_frame_newslot(if2770);
    if2743 = if2770;
  } else {
  }
// compiled if node returning if2743 (depth = 8)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2790 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2791 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2790);
// compiled call node returning call2791 (depth = 8)
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2792 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2793 == NULL) {
    strlit2793 = alloc_String("an else statement must end with a '}'.");
    gc_root(strlit2793);
  }
// compiled string node returning strlit2793 (depth = 9)
  gc_frame_newslot(strlit2793);
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe2794 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2795 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2794);
// compiled member node returning call2795 (depth = 9)
  gc_frame_newslot(call2795);
// starting to compile member node (depth = 9)
  int callframe2796 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2797 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2796);
// compiled member node returning call2797 (depth = 9)
  gc_frame_newslot(call2797);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2793;
  params[1] = call2795;
  params[2] = call2797;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2798 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2792);
// compiled call node returning call2798 (depth = 8)
    gc_frame_newslot(call2798);
    if2728 = call2798;
  } else {
  }
// compiled if node returning if2728 (depth = 7)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2799 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call2800 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe2799);
// compiled member node returning call2800 (depth = 8)
  *var_v = call2800;
  if (call2800 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2802 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curelse (depth = 8)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2803 = callmethodflags(*var_curelse, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2802);
// compiled call node returning call2803 (depth = 7)
  gc_frame_end(frame);
  return call2803;
}
Object meth_parser_1420_doif(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(30, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doif");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  Object *var_statementIndent = getfromclosure(closure, 6);
  Object *var_statementToken = getfromclosure(closure, 7);
  Object *var_util = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_minStartColumn = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "minStartColumn");
  Object *var_opener = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "opener");
  Object *var_closer = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "closer");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_cond = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "cond");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_elseblock = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "elseblock");
  Object *var_curelse = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "curelse");
  Object *var_v = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "v");
  Object *var_localMin = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "localMin");
  Object *var_localStatementIndent = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "localStatementIndent");
  Object *var_minInd = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "minInd");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_closingBrace = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_econd = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "econd");
  Object *var_eif = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "eif");
  Object *var_newelse = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "newelse");
  Object *var_ebody = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "ebody");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "o");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1424 == NULL) {
    strlit1424 = alloc_String("if");
    gc_root(strlit1424);
  }
// compiled string node returning strlit1424 (depth = 5)
  int op_slot_right_1423 = gc_frame_newslot(strlit1424);
// starting to compile member node (depth = 5)
  int callframe1426 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1427 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe1426);
// compiled member node returning call1427 (depth = 5)
  int op_slot_left_1423 = gc_frame_newslot(call1427);
  params[0] = strlit1424;
  partcv[0] = 1;
  Object opresult1428 = callmethod(call1427, "==(1)", 1, partcv, params);
// compiled op node returning opresult1428 (depth = 4)
  int op_slot_right_1422 = gc_frame_newslot(opresult1428);
// starting to compile call node (depth = 4)
  int callframe1430 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1431 == NULL) {
    strlit1431 = alloc_String("identifier");
    gc_root(strlit1431);
  }
// compiled string node returning strlit1431 (depth = 5)
  gc_frame_newslot(strlit1431);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit1431;
  partcv[0] = 1;
  Object call1432 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1430);
// compiled call node returning call1432 (depth = 4)
  int op_slot_left_1422 = gc_frame_newslot(call1432);
  params[0] = opresult1428;
  partcv[0] = 1;
  Object opresult1433 = callmethod(call1432, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1433 (depth = 3)
  Object if1421 = done;
  if (istrue(opresult1433)) {
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1435 = alloc_Float64(3);
// compiled num node returning num1435 (depth = 5)
  int op_slot_right_1434 = gc_frame_newslot(num1435);
// starting to compile member node (depth = 5)
  int callframe1437 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1438 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe1437);
// compiled member node returning call1438 (depth = 5)
  int op_slot_left_1434 = gc_frame_newslot(call1438);
  params[0] = num1435;
  partcv[0] = 1;
  Object sum1439 = callmethod(call1438, "+(1)", 1, partcv, params);
// compiled op node returning sum1439 (depth = 4)
  *var_minStartColumn = sum1439;
  if (sum1439 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1440 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1441 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1440);
// compiled member node returning call1441 (depth = 3)
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block1444 = alloc_Block(NULL, NULL, "parser", 618);
  gc_frame_newslot(block1444);
// method "_apply"
  block_savedest(block1444);
  Object closure1445 = createclosure(2, "_apply");
  setclosureframe(closure1445, stackframe);
  addtoclosure(closure1445, var_sym);
  addtoclosure(closure1445, selfslot);
  struct UserObject *uo1445 = (struct UserObject*)block1444;
  uo1445->data[0] = (Object)closure1445;
  Method *meth_meth_parser_1445__apply = addmethod2pos(block1444, "_apply", &meth_parser_1445__apply, 0);
  int argcv_meth_parser_1445__apply[] = {0};
  meth_meth_parser_1445__apply->type = alloc_MethodType(1, argcv_meth_parser_1445__apply);
  meth_meth_parser_1445__apply->definitionModule = modulename;
  meth_meth_parser_1445__apply->definitionLine = 183;
// compiled block node returning block1444 (depth = 6)
  int op_slot_right_1443 = gc_frame_newslot(block1444);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1455 == NULL) {
    strlit1455 = alloc_String("lparen");
    gc_root(strlit1455);
  }
// compiled string node returning strlit1455 (depth = 7)
  int op_slot_right_1454 = gc_frame_newslot(strlit1455);
// starting to compile member node (depth = 7)
  int callframe1457 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1458 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1457);
// compiled member node returning call1458 (depth = 7)
  int op_slot_left_1454 = gc_frame_newslot(call1458);
  params[0] = strlit1455;
  partcv[0] = 1;
  Object opresult1459 = callmethod(call1458, "==(1)", 1, partcv, params);
// compiled op node returning opresult1459 (depth = 6)
  int op_slot_left_1443 = gc_frame_newslot(opresult1459);
  params[0] = block1444;
  partcv[0] = 1;
  Object opresult1460 = callmethod(opresult1459, "||(1)", 1, partcv, params);
// compiled op node returning opresult1460 (depth = 5)
  Object if1442 = done;
struct StackFrameObject *iftmpstackframe1442 = stackframe;
  if (istrue(opresult1460)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1442);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1461 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1462 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe1461);
// compiled member node returning call1462 (depth = 5)
    gc_frame_newslot(call1462);
    if1442 = call1462;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1442);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 5)
  if (strlit1463 == NULL) {
    strlit1463 = alloc_String("-missing-");
    gc_root(strlit1463);
  }
// compiled string node returning strlit1463 (depth = 5)
    gc_frame_newslot(strlit1463);
    if1442 = strlit1463;
  }
stackframe = iftmpstackframe1442;
// compiled if node returning if1442 (depth = 4)
  *var_opener = if1442;
  if (if1442 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1466 == NULL) {
    strlit1466 = alloc_String("(");
    gc_root(strlit1466);
  }
// compiled string node returning strlit1466 (depth = 6)
  int op_slot_right_1465 = gc_frame_newslot(strlit1466);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opener (depth = 6)
  int op_slot_left_1465 = gc_frame_newslot(*var_opener);
  params[0] = strlit1466;
  partcv[0] = 1;
  Object opresult1468 = callmethod(*var_opener, "==(1)", 1, partcv, params);
// compiled op node returning opresult1468 (depth = 5)
  Object if1464 = done;
struct StackFrameObject *iftmpstackframe1464 = stackframe;
  if (istrue(opresult1468)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1464);
gc_frame_newslot((Object)stackframe);
// definebindings:
// starting to compile string node (depth = 5)
  if (strlit1469 == NULL) {
    strlit1469 = alloc_String(")");
    gc_root(strlit1469);
  }
// compiled string node returning strlit1469 (depth = 5)
    gc_frame_newslot(strlit1469);
    if1464 = strlit1469;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1464);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// definebindings:
// definebindings:
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1472 == NULL) {
    strlit1472 = alloc_String("{");
    gc_root(strlit1472);
  }
// compiled string node returning strlit1472 (depth = 7)
  int op_slot_right_1471 = gc_frame_newslot(strlit1472);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_opener (depth = 7)
  int op_slot_left_1471 = gc_frame_newslot(*var_opener);
  params[0] = strlit1472;
  partcv[0] = 1;
  Object opresult1474 = callmethod(*var_opener, "==(1)", 1, partcv, params);
// compiled op node returning opresult1474 (depth = 6)
  Object if1470 = done;
  if (istrue(opresult1474)) {
// starting to compile string node (depth = 6)
  if (strlit1475 == NULL) {
    strlit1475 = alloc_String("}");
    gc_root(strlit1475);
  }
// compiled string node returning strlit1475 (depth = 6)
    gc_frame_newslot(strlit1475);
    if1470 = strlit1475;
  } else {
// starting to compile string node (depth = 6)
  if (strlit1476 == NULL) {
    strlit1476 = alloc_String("-nothing-");
    gc_root(strlit1476);
  }
// compiled string node returning strlit1476 (depth = 6)
    gc_frame_newslot(strlit1476);
    if1470 = strlit1476;
  }
// compiled if node returning if1470 (depth = 5)
    gc_frame_newslot(if1470);
    if1464 = if1470;
  }
stackframe = iftmpstackframe1464;
// compiled if node returning if1464 (depth = 4)
  *var_closer = if1464;
  if (if1464 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1479 == NULL) {
    strlit1479 = alloc_String("-missing-");
    gc_root(strlit1479);
  }
// compiled string node returning strlit1479 (depth = 5)
  int op_slot_right_1478 = gc_frame_newslot(strlit1479);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opener (depth = 5)
  int op_slot_left_1478 = gc_frame_newslot(*var_opener);
  params[0] = strlit1479;
  partcv[0] = 1;
  Object opresult1481 = callmethod(*var_opener, "==(1)", 1, partcv, params);
// compiled op node returning opresult1481 (depth = 4)
  Object if1477 = done;
  if (istrue(opresult1481)) {
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1482 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1483 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call1484 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1483);
// compiled member node returning call1484 (depth = 6)
  partcv[0] = 0;
  Object call1485 = callmethodflags(call1484, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1482);
// compiled member node returning call1485 (depth = 5)
  *var_suggestion = call1485;
  if (call1485 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1486 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1487 = alloc_Block(NULL, NULL, "parser", 625);
  gc_frame_newslot(block1487);
// method "_apply(_)"
  block_savedest(block1487);
  Object closure1488 = createclosure(2, "_apply(1)");
  setclosureframe(closure1488, stackframe);
  addtoclosure(closure1488, var_btok);
  addtoclosure(closure1488, selfslot);
  struct UserObject *uo1488 = (struct UserObject*)block1487;
  uo1488->data[0] = (Object)closure1488;
  Method *meth_meth_parser_1488__apply_40_1_41_ = addmethod2pos(block1487, "_apply(1)", &meth_parser_1488__apply_40_1_41_, 0);
  int argcv_meth_parser_1488__apply_40_1_41_[] = {1};
  meth_meth_parser_1488__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_1488__apply_40_1_41_);
  meth_meth_parser_1488__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1488__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block1487 (depth = 6)
  gc_frame_newslot(block1487);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block1487;
  partcv[0] = 1;
  Object call1542 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1486);
// compiled call node returning call1542 (depth = 5)
  *var_nextTok = call1542;
  if (call1542 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_1544 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool1546 = alloc_Boolean(0);
// compiled identifier node returning bool1546 (depth = 6)
  int op_slot_left_1544 = gc_frame_newslot(bool1546);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult1547 = callmethod(bool1546, "==(1)", 1, partcv, params);
// compiled op node returning opresult1547 (depth = 5)
  Object if1543 = done;
  if (istrue(opresult1547)) {
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1548 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1549 == NULL) {
    strlit1549 = alloc_String(" (""\xc2""""\xab""condition""\xc2""""\xbb"") then {");
    gc_root(strlit1549);
  }
// compiled string node returning strlit1549 (depth = 6)
  gc_frame_newslot(strlit1549);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1549;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1550 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1548);
// compiled call node returning call1550 (depth = 5)
    gc_frame_newslot(call1550);
    if1543 = call1550;
  } else {
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1553 == NULL) {
    strlit1553 = alloc_String("rparen");
    gc_root(strlit1553);
  }
// compiled string node returning strlit1553 (depth = 7)
  int op_slot_right_1552 = gc_frame_newslot(strlit1553);
// starting to compile member node (depth = 7)
  int callframe1555 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call1556 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1555);
// compiled member node returning call1556 (depth = 7)
  int op_slot_left_1552 = gc_frame_newslot(call1556);
  params[0] = strlit1553;
  partcv[0] = 1;
  Object opresult1557 = callmethod(call1556, "==(1)", 1, partcv, params);
// compiled op node returning opresult1557 (depth = 6)
  Object if1551 = done;
  if (istrue(opresult1557)) {
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_1559 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_1559 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1561 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1561 (depth = 7)
  Object if1558 = done;
  if (istrue(opresult1561)) {
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1562 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1563 == NULL) {
    strlit1563 = alloc_String("(""\xc2""""\xab""condition""\xc2""""\xbb""");
    gc_root(strlit1563);
  }
// compiled string node returning strlit1563 (depth = 8)
  gc_frame_newslot(strlit1563);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1563;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1564 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1562);
// compiled call node returning call1564 (depth = 7)
    gc_frame_newslot(call1564);
    if1558 = call1564;
  } else {
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1565 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1566 == NULL) {
    strlit1566 = alloc_String("(");
    gc_root(strlit1566);
  }
// compiled string node returning strlit1566 (depth = 8)
  gc_frame_newslot(strlit1566);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1566;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1567 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1565);
// compiled call node returning call1567 (depth = 7)
    gc_frame_newslot(call1567);
    if1558 = call1567;
  }
// compiled if node returning if1558 (depth = 6)
    gc_frame_newslot(if1558);
    if1551 = if1558;
  } else {
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1570 == NULL) {
    strlit1570 = alloc_String("lbrace");
    gc_root(strlit1570);
  }
// compiled string node returning strlit1570 (depth = 8)
  int op_slot_right_1569 = gc_frame_newslot(strlit1570);
// starting to compile member node (depth = 8)
  int callframe1572 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1573 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1572);
// compiled member node returning call1573 (depth = 8)
  int op_slot_left_1569 = gc_frame_newslot(call1573);
  params[0] = strlit1570;
  partcv[0] = 1;
  Object opresult1574 = callmethod(call1573, "==(1)", 1, partcv, params);
// compiled op node returning opresult1574 (depth = 7)
  Object if1568 = done;
  if (istrue(opresult1574)) {
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_1576 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_1576 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1578 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1578 (depth = 8)
  Object if1575 = done;
  if (istrue(opresult1578)) {
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1579 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1580 == NULL) {
    strlit1580 = alloc_String(" (""\xc2""""\xab""condition""\xc2""""\xbb"") then");
    gc_root(strlit1580);
  }
// compiled string node returning strlit1580 (depth = 9)
  gc_frame_newslot(strlit1580);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1580;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1581 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1579);
// compiled call node returning call1581 (depth = 8)
    gc_frame_newslot(call1581);
    if1575 = call1581;
  } else {
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1582 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1583 == NULL) {
    strlit1583 = alloc_String("(");
    gc_root(strlit1583);
  }
// compiled string node returning strlit1583 (depth = 9)
  gc_frame_newslot(strlit1583);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1583;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1584 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1582);
// compiled call node returning call1584 (depth = 8)
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1585 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1586 == NULL) {
    strlit1586 = alloc_String(") then");
    gc_root(strlit1586);
  }
// compiled string node returning strlit1586 (depth = 9)
  gc_frame_newslot(strlit1586);
// starting to compile member node (depth = 9)
  int callframe1587 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call1588 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe1587);
// compiled member node returning call1588 (depth = 9)
  gc_frame_newslot(call1588);
// starting to compile identifier node (depth = 9)
  Object bool1589 = alloc_Boolean(1);
// compiled identifier node returning bool1589 (depth = 9)
  gc_frame_newslot(bool1589);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1586;
  params[1] = call1588;
  params[2] = bool1589;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1590 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1585);
// compiled call node returning call1590 (depth = 8)
    gc_frame_newslot(call1590);
    if1575 = call1590;
  }
// compiled if node returning if1575 (depth = 7)
    gc_frame_newslot(if1575);
    if1568 = if1575;
  } else {
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1593 == NULL) {
    strlit1593 = alloc_String("identifier");
    gc_root(strlit1593);
  }
// compiled string node returning strlit1593 (depth = 9)
  int op_slot_right_1592 = gc_frame_newslot(strlit1593);
// starting to compile member node (depth = 9)
  int callframe1595 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call1596 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1595);
// compiled member node returning call1596 (depth = 9)
  int op_slot_left_1592 = gc_frame_newslot(call1596);
  params[0] = strlit1593;
  partcv[0] = 1;
  Object opresult1597 = callmethod(call1596, "==(1)", 1, partcv, params);
// compiled op node returning opresult1597 (depth = 8)
  Object if1591 = done;
  if (istrue(opresult1597)) {
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1599 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1599 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1601 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1601 (depth = 9)
  Object if1598 = done;
  if (istrue(opresult1601)) {
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1602 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1603 == NULL) {
    strlit1603 = alloc_String("(""\xc2""""\xab""condition""\xc2""""\xbb"") ");
    gc_root(strlit1603);
  }
// compiled string node returning strlit1603 (depth = 10)
  gc_frame_newslot(strlit1603);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1603;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1604 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1602);
// compiled call node returning call1604 (depth = 9)
    gc_frame_newslot(call1604);
    if1598 = call1604;
  } else {
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1605 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1606 == NULL) {
    strlit1606 = alloc_String("(");
    gc_root(strlit1606);
  }
// compiled string node returning strlit1606 (depth = 10)
  gc_frame_newslot(strlit1606);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1606;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1607 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1605);
// compiled call node returning call1607 (depth = 9)
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1608 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1609 == NULL) {
    strlit1609 = alloc_String(")");
    gc_root(strlit1609);
  }
// compiled string node returning strlit1609 (depth = 10)
  gc_frame_newslot(strlit1609);
// starting to compile member node (depth = 10)
  int callframe1610 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1611 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe1610);
// compiled member node returning call1611 (depth = 10)
  gc_frame_newslot(call1611);
// starting to compile identifier node (depth = 10)
  Object bool1612 = alloc_Boolean(1);
// compiled identifier node returning bool1612 (depth = 10)
  gc_frame_newslot(bool1612);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1609;
  params[1] = call1611;
  params[2] = bool1612;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1613 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1608);
// compiled call node returning call1613 (depth = 9)
    gc_frame_newslot(call1613);
    if1598 = call1613;
  }
// compiled if node returning if1598 (depth = 8)
    gc_frame_newslot(if1598);
    if1591 = if1598;
  } else {
  }
// compiled if node returning if1591 (depth = 7)
    gc_frame_newslot(if1591);
    if1568 = if1591;
  }
// compiled if node returning if1568 (depth = 6)
    gc_frame_newslot(if1568);
    if1551 = if1568;
  }
// compiled if node returning if1551 (depth = 5)
    gc_frame_newslot(if1551);
    if1543 = if1551;
  }
// compiled if node returning if1543 (depth = 4)
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1614 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1616 == NULL) {
    strlit1616 = alloc_String("in parentheses or braces after the 'if'.");
    gc_root(strlit1616);
  }
// compiled string node returning strlit1616 (depth = 6)
  int op_slot_right_1615 = gc_frame_newslot(strlit1616);
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1618 == NULL) {
    strlit1618 = alloc_String("an if statement must have a condition ");
    gc_root(strlit1618);
  }
// compiled string node returning strlit1618 (depth = 6)
  int op_slot_left_1615 = gc_frame_newslot(strlit1618);
  params[0] = strlit1616;
  partcv[0] = 1;
  Object opresult1619 = callmethod(strlit1618, "++(1)", 1, partcv, params);
// compiled op node returning opresult1619 (depth = 5)
  gc_frame_newslot(opresult1619);
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1620 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1621 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1620);
// compiled member node returning call1621 (depth = 5)
  gc_frame_newslot(call1621);
// starting to compile member node (depth = 5)
  int callframe1622 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1623 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1622);
// compiled member node returning call1623 (depth = 5)
  gc_frame_newslot(call1623);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1619;
  params[1] = call1621;
  params[2] = call1623;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1624 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1614);
// compiled call node returning call1624 (depth = 4)
    gc_frame_newslot(call1624);
    if1477 = call1624;
  } else {
  }
// compiled if node returning if1477 (depth = 3)
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1625 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1626 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1625);
// compiled member node returning call1626 (depth = 3)
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1628 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1629 = alloc_Block(NULL, NULL, "parser", 656);
  gc_frame_newslot(block1629);
// method "_apply"
  block_savedest(block1629);
  Object closure1630 = createclosure(2, "_apply");
  setclosureframe(closure1630, stackframe);
  addtoclosure(closure1630, var_blocksOK);
  addtoclosure(closure1630, selfslot);
  struct UserObject *uo1630 = (struct UserObject*)block1629;
  uo1630->data[0] = (Object)closure1630;
  Method *meth_meth_parser_1630__apply = addmethod2pos(block1629, "_apply", &meth_parser_1630__apply, 0);
  int argcv_meth_parser_1630__apply[] = {0};
  meth_meth_parser_1630__apply->type = alloc_MethodType(1, argcv_meth_parser_1630__apply);
  meth_meth_parser_1630__apply->definitionModule = modulename;
  meth_meth_parser_1630__apply->definitionLine = 183;
// compiled block node returning block1629 (depth = 5)
  gc_frame_newslot(block1629);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block1629;
  partcv[0] = 1;
  Object call1634 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1628);
// compiled call node returning call1634 (depth = 4)
  Object if1627 = done;
  if (istrue(call1634)) {
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1635 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1636 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call1637 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1636);
// compiled member node returning call1637 (depth = 6)
  partcv[0] = 0;
  Object call1638 = callmethodflags(call1637, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1635);
// compiled member node returning call1638 (depth = 5)
  *var_suggestion = call1638;
  if (call1638 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1639 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1640 = alloc_Block(NULL, NULL, "parser", 659);
  gc_frame_newslot(block1640);
// method "_apply(_)"
  block_savedest(block1640);
  Object closure1641 = createclosure(2, "_apply(1)");
  setclosureframe(closure1641, stackframe);
  addtoclosure(closure1641, var_lastToken);
  addtoclosure(closure1641, selfslot);
  struct UserObject *uo1641 = (struct UserObject*)block1640;
  uo1641->data[0] = (Object)closure1641;
  Method *meth_meth_parser_1641__apply_40_1_41_ = addmethod2pos(block1640, "_apply(1)", &meth_parser_1641__apply_40_1_41_, 0);
  int argcv_meth_parser_1641__apply_40_1_41_[] = {1};
  meth_meth_parser_1641__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_1641__apply_40_1_41_);
  meth_meth_parser_1641__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1641__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block1640 (depth = 6)
  gc_frame_newslot(block1640);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block1640;
  partcv[0] = 1;
  Object call1659 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1639);
// compiled call node returning call1659 (depth = 5)
  *var_nextTok = call1659;
  if (call1659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_1661 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool1663 = alloc_Boolean(0);
// compiled identifier node returning bool1663 (depth = 6)
  int op_slot_left_1661 = gc_frame_newslot(bool1663);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult1664 = callmethod(bool1663, "==(1)", 1, partcv, params);
// compiled op node returning opresult1664 (depth = 5)
  Object if1660 = done;
  if (istrue(opresult1664)) {
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1665 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array1666 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit1667 == NULL) {
    strlit1667 = alloc_String("rparen");
    gc_root(strlit1667);
  }
// compiled string node returning strlit1667 (depth = 8)
  params[0] = strlit1667;
  partcv[0] = 1;
  callmethodflags(array1666, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1666 (depth = 7)
  gc_frame_newslot(array1666);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = array1666;
  partcv[0] = 1;
  Object call1668 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1665);
// compiled call node returning call1668 (depth = 6)
  *var_nextTok = call1668;
  if (call1668 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1671 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1671 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1673 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1673 (depth = 6)
  Object if1670 = done;
  if (istrue(opresult1673)) {
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1674 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1675 == NULL) {
    strlit1675 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1675);
  }
// compiled string node returning strlit1675 (depth = 7)
  gc_frame_newslot(strlit1675);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1675;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1676 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1674);
// compiled call node returning call1676 (depth = 6)
    gc_frame_newslot(call1676);
    if1670 = call1676;
  } else {
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1677 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe1678 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call1679 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe1678);
// compiled member node returning call1679 (depth = 7)
  gc_frame_newslot(call1679);
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool1680 = alloc_Boolean(1);
// compiled identifier node returning bool1680 (depth = 7)
  gc_frame_newslot(bool1680);
// starting to compile identifier node (depth = 7)
  Object bool1681 = alloc_Boolean(0);
// compiled identifier node returning bool1681 (depth = 7)
  gc_frame_newslot(bool1681);
// starting to compile string node (depth = 7)
  if (strlit1682 == NULL) {
    strlit1682 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1682);
  }
// compiled string node returning strlit1682 (depth = 7)
  gc_frame_newslot(strlit1682);
// call case 6: other requests
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1679;
  params[2] = bool1680;
  params[3] = bool1681;
  params[4] = strlit1682;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1683 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1677);
// compiled call node returning call1683 (depth = 6)
    gc_frame_newslot(call1683);
    if1670 = call1683;
  }
// compiled if node returning if1670 (depth = 5)
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1684 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1686 == NULL) {
    strlit1686 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit1686);
  }
// compiled string node returning strlit1686 (depth = 7)
  int op_slot_right_1685 = gc_frame_newslot(strlit1686);
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1688 == NULL) {
    strlit1688 = alloc_String("an if statement must have a ");
    gc_root(strlit1688);
  }
// compiled string node returning strlit1688 (depth = 7)
  int op_slot_left_1685 = gc_frame_newslot(strlit1688);
  params[0] = strlit1686;
  partcv[0] = 1;
  Object opresult1689 = callmethod(strlit1688, "++(1)", 1, partcv, params);
// compiled op node returning opresult1689 (depth = 6)
  gc_frame_newslot(opresult1689);
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1690 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1691 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1690);
// compiled member node returning call1691 (depth = 6)
  gc_frame_newslot(call1691);
// starting to compile member node (depth = 6)
  int callframe1692 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1693 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1692);
// compiled member node returning call1693 (depth = 6)
  gc_frame_newslot(call1693);
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult1689;
  params[1] = call1691;
  params[2] = call1693;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1694 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1684);
// compiled call node returning call1694 (depth = 5)
    gc_frame_newslot(call1694);
    if1660 = call1694;
  } else {
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1696 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1696 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1698 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1698 (depth = 6)
  Object if1695 = done;
  if (istrue(opresult1698)) {
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1699 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1700 == NULL) {
    strlit1700 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1700);
  }
// compiled string node returning strlit1700 (depth = 7)
  gc_frame_newslot(strlit1700);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1700;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1701 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1699);
// compiled call node returning call1701 (depth = 6)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1702 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1704 == NULL) {
    strlit1704 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit1704);
  }
// compiled string node returning strlit1704 (depth = 8)
  int op_slot_right_1703 = gc_frame_newslot(strlit1704);
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1706 == NULL) {
    strlit1706 = alloc_String("an if statement must have a ");
    gc_root(strlit1706);
  }
// compiled string node returning strlit1706 (depth = 8)
  int op_slot_left_1703 = gc_frame_newslot(strlit1706);
  params[0] = strlit1704;
  partcv[0] = 1;
  Object opresult1707 = callmethod(strlit1706, "++(1)", 1, partcv, params);
// compiled op node returning opresult1707 (depth = 7)
  gc_frame_newslot(opresult1707);
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe1708 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1709 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1708);
// compiled member node returning call1709 (depth = 7)
  gc_frame_newslot(call1709);
// starting to compile member node (depth = 7)
  int callframe1710 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1711 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1710);
// compiled member node returning call1711 (depth = 7)
  gc_frame_newslot(call1711);
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult1707;
  params[1] = call1709;
  params[2] = call1711;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1712 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1702);
// compiled call node returning call1712 (depth = 6)
    gc_frame_newslot(call1712);
    if1695 = call1712;
  } else {
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1713 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe1714 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call1715 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe1714);
// compiled member node returning call1715 (depth = 7)
  gc_frame_newslot(call1715);
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool1716 = alloc_Boolean(0);
// compiled identifier node returning bool1716 (depth = 7)
  gc_frame_newslot(bool1716);
// starting to compile identifier node (depth = 7)
  Object bool1717 = alloc_Boolean(1);
// compiled identifier node returning bool1717 (depth = 7)
  gc_frame_newslot(bool1717);
// starting to compile string node (depth = 7)
  if (strlit1718 == NULL) {
    strlit1718 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1718);
  }
// compiled string node returning strlit1718 (depth = 7)
  gc_frame_newslot(strlit1718);
// call case 6: other requests
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1715;
  params[2] = bool1716;
  params[3] = bool1717;
  params[4] = strlit1718;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1719 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1713);
// compiled call node returning call1719 (depth = 6)
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1720 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1722 == NULL) {
    strlit1722 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit1722);
  }
// compiled string node returning strlit1722 (depth = 8)
  int op_slot_right_1721 = gc_frame_newslot(strlit1722);
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1724 == NULL) {
    strlit1724 = alloc_String("an if statement must have a ");
    gc_root(strlit1724);
  }
// compiled string node returning strlit1724 (depth = 8)
  int op_slot_left_1721 = gc_frame_newslot(strlit1724);
  params[0] = strlit1722;
  partcv[0] = 1;
  Object opresult1725 = callmethod(strlit1724, "++(1)", 1, partcv, params);
// compiled op node returning opresult1725 (depth = 7)
  gc_frame_newslot(opresult1725);
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe1726 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1727 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1726);
// compiled member node returning call1727 (depth = 7)
  gc_frame_newslot(call1727);
// starting to compile member node (depth = 7)
  int callframe1728 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1729 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1728);
// compiled member node returning call1729 (depth = 7)
  gc_frame_newslot(call1729);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1731 = alloc_Float64(1);
// compiled num node returning num1731 (depth = 8)
  int op_slot_right_1730 = gc_frame_newslot(num1731);
// starting to compile member node (depth = 8)
  int callframe1733 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1734 = callmethodflags(*var_nextTok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1733);
// compiled member node returning call1734 (depth = 8)
  int op_slot_left_1730 = gc_frame_newslot(call1734);
  params[0] = num1731;
  partcv[0] = 1;
  Object diff1735 = callmethod(call1734, "-(1)", 1, partcv, params);
// compiled op node returning diff1735 (depth = 7)
  gc_frame_newslot(diff1735);
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult1725;
  params[1] = call1727;
  params[2] = call1729;
  params[3] = diff1735;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1736 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1720);
// compiled call node returning call1736 (depth = 6)
    gc_frame_newslot(call1736);
    if1695 = call1736;
  }
// compiled if node returning if1695 (depth = 5)
    gc_frame_newslot(if1695);
    if1660 = if1695;
  }
// compiled if node returning if1660 (depth = 4)
    gc_frame_newslot(if1660);
    if1627 = if1660;
  } else {
  }
// compiled if node returning if1627 (depth = 3)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_closer (depth = 5)
  int op_slot_right_1738 = gc_frame_newslot(*var_closer);
// starting to compile member node (depth = 5)
  int callframe1740 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call1741 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe1740);
// compiled member node returning call1741 (depth = 5)
  int op_slot_left_1738 = gc_frame_newslot(call1741);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult1742 = callmethod(call1741, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1742 (depth = 4)
  Object if1737 = done;
  if (istrue(opresult1742)) {
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1743 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1744 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1743);
// compiled member node returning call1744 (depth = 4)
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1745 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1746 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call1747 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1746);
// compiled member node returning call1747 (depth = 6)
  partcv[0] = 0;
  Object call1748 = callmethodflags(call1747, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1745);
// compiled member node returning call1748 (depth = 5)
  *var_suggestion = call1748;
  if (call1748 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1749 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1750 == NULL) {
    strlit1750 = alloc_String(")");
    gc_root(strlit1750);
  }
// compiled string node returning strlit1750 (depth = 5)
  gc_frame_newslot(strlit1750);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1750;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1751 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1749);
// compiled call node returning call1751 (depth = 4)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1752 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1755 == NULL) {
    strlit1755 = alloc_String("'.");
    gc_root(strlit1755);
  }
// compiled string node returning strlit1755 (depth = 7)
  int op_slot_right_1754 = gc_frame_newslot(strlit1755);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closer (depth = 8)
  int op_slot_right_1757 = gc_frame_newslot(*var_closer);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1760 == NULL) {
    strlit1760 = alloc_String("' must end with a '");
    gc_root(strlit1760);
  }
// compiled string node returning strlit1760 (depth = 9)
  int op_slot_right_1759 = gc_frame_newslot(strlit1760);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_opener (depth = 10)
  int op_slot_right_1762 = gc_frame_newslot(*var_opener);
// starting to compile string node (depth = 10)
  if (strlit1764 == NULL) {
    strlit1764 = alloc_String("'");
    gc_root(strlit1764);
  }
// compiled string node returning strlit1764 (depth = 10)
  int op_slot_left_1762 = gc_frame_newslot(strlit1764);
  params[0] = *var_opener;
  partcv[0] = 1;
  Object opresult1765 = callmethod(strlit1764, "++(1)", 1, partcv, params);
// compiled op node returning opresult1765 (depth = 9)
  int op_slot_left_1759 = gc_frame_newslot(opresult1765);
  params[0] = strlit1760;
  partcv[0] = 1;
  Object opresult1766 = callmethod(opresult1765, "++(1)", 1, partcv, params);
// compiled op node returning opresult1766 (depth = 8)
  int op_slot_left_1757 = gc_frame_newslot(opresult1766);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult1767 = callmethod(opresult1766, "++(1)", 1, partcv, params);
// compiled op node returning opresult1767 (depth = 7)
  int op_slot_left_1754 = gc_frame_newslot(opresult1767);
  params[0] = strlit1755;
  partcv[0] = 1;
  Object opresult1768 = callmethod(opresult1767, "++(1)", 1, partcv, params);
// compiled op node returning opresult1768 (depth = 6)
  int op_slot_right_1753 = gc_frame_newslot(opresult1768);
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1770 == NULL) {
    strlit1770 = alloc_String("an expression beginning with a ");
    gc_root(strlit1770);
  }
// compiled string node returning strlit1770 (depth = 6)
  int op_slot_left_1753 = gc_frame_newslot(strlit1770);
  params[0] = opresult1768;
  partcv[0] = 1;
  Object opresult1771 = callmethod(strlit1770, "++(1)", 1, partcv, params);
// compiled op node returning opresult1771 (depth = 5)
  gc_frame_newslot(opresult1771);
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1772 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call1773 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1772);
// compiled member node returning call1773 (depth = 5)
  gc_frame_newslot(call1773);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1775 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1776 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1775);
// compiled member node returning call1776 (depth = 6)
  int op_slot_right_1774 = gc_frame_newslot(call1776);
// starting to compile member node (depth = 6)
  int callframe1778 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1779 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1778);
// compiled member node returning call1779 (depth = 6)
  int op_slot_left_1774 = gc_frame_newslot(call1779);
  params[0] = call1776;
  partcv[0] = 1;
  Object sum1780 = callmethod(call1779, "+(1)", 1, partcv, params);
// compiled op node returning sum1780 (depth = 5)
  gc_frame_newslot(sum1780);
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1771;
  params[1] = call1773;
  params[2] = sum1780;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1781 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1752);
// compiled call node returning call1781 (depth = 4)
    gc_frame_newslot(call1781);
    if1737 = call1781;
  } else {
  }
// compiled if node returning if1737 (depth = 3)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1782 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1783 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1782);
// compiled member node returning call1783 (depth = 3)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1784 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call1785 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe1784);
// compiled member node returning call1785 (depth = 4)
  *var_cond = call1785;
  if (call1785 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1786 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1786 (depth = 4)
  *var_body = array1786;
  if (array1786 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1787 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1787 (depth = 4)
  *var_elseblock = array1787;
  if (array1787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock (depth = 4)
  *var_curelse = *var_elseblock;
  if (*var_elseblock == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_v = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_localStatementIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1789 = alloc_Float64(2);
// compiled num node returning num1789 (depth = 5)
  int op_slot_right_1788 = gc_frame_newslot(num1789);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1788 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1789;
  partcv[0] = 1;
  Object sum1791 = callmethod(*var_statementIndent, "+(1)", 1, partcv, params);
// compiled op node returning sum1791 (depth = 4)
  *var_minInd = sum1791;
  if (sum1791 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1795 == NULL) {
    strlit1795 = alloc_String("then");
    gc_root(strlit1795);
  }
// compiled string node returning strlit1795 (depth = 6)
  int op_slot_right_1794 = gc_frame_newslot(strlit1795);
// starting to compile member node (depth = 6)
  int callframe1797 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1798 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe1797);
// compiled member node returning call1798 (depth = 6)
  int op_slot_left_1794 = gc_frame_newslot(call1798);
  params[0] = strlit1795;
  partcv[0] = 1;
  Object opresult1799 = callmethod(call1798, "==(1)", 1, partcv, params);
// compiled op node returning opresult1799 (depth = 5)
  int op_slot_right_1793 = gc_frame_newslot(opresult1799);
// starting to compile call node (depth = 5)
  int callframe1801 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1802 == NULL) {
    strlit1802 = alloc_String("identifier");
    gc_root(strlit1802);
  }
// compiled string node returning strlit1802 (depth = 6)
  gc_frame_newslot(strlit1802);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit1802;
  partcv[0] = 1;
  Object call1803 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1801);
// compiled call node returning call1803 (depth = 5)
  int op_slot_left_1793 = gc_frame_newslot(call1803);
  params[0] = opresult1799;
  partcv[0] = 1;
  Object opresult1804 = callmethod(call1803, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1804 (depth = 4)
  Object if1792 = done;
  if (istrue(opresult1804)) {
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_minStartColumn (depth = 6)
  int op_slot_right_1806 = gc_frame_newslot(*var_minStartColumn);
// starting to compile member node (depth = 6)
  int callframe1808 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1809 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1808);
// compiled member node returning call1809 (depth = 6)
  int op_slot_left_1806 = gc_frame_newslot(call1809);
  params[0] = *var_minStartColumn;
  partcv[0] = 1;
  Object opresult1810 = callmethod(call1809, "<(1)", 1, partcv, params);
// compiled op node returning opresult1810 (depth = 5)
  Object if1805 = done;
  if (istrue(opresult1810)) {
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1811 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1813 == NULL) {
    strlit1813 = alloc_String("'if(_)then(_)""\xe2""""\x80""""\xa6""' must be indented more than the 'if'");
    gc_root(strlit1813);
  }
// compiled string node returning strlit1813 (depth = 7)
  int op_slot_right_1812 = gc_frame_newslot(strlit1813);
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1815 == NULL) {
    strlit1815 = alloc_String("the 'then' part of an ");
    gc_root(strlit1815);
  }
// compiled string node returning strlit1815 (depth = 7)
  int op_slot_left_1812 = gc_frame_newslot(strlit1815);
  params[0] = strlit1813;
  partcv[0] = 1;
  Object opresult1816 = callmethod(strlit1815, "++(1)", 1, partcv, params);
// compiled op node returning opresult1816 (depth = 6)
  gc_frame_newslot(opresult1816);
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1817 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1818 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1817);
// compiled member node returning call1818 (depth = 6)
  gc_frame_newslot(call1818);
// starting to compile member node (depth = 6)
  int callframe1819 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1820 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1819);
// compiled member node returning call1820 (depth = 6)
  gc_frame_newslot(call1820);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1822 = alloc_Float64(3);
// compiled num node returning num1822 (depth = 7)
  int op_slot_right_1821 = gc_frame_newslot(num1822);
// starting to compile member node (depth = 7)
  int callframe1824 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1825 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1824);
// compiled member node returning call1825 (depth = 7)
  int op_slot_left_1821 = gc_frame_newslot(call1825);
  params[0] = num1822;
  partcv[0] = 1;
  Object sum1826 = callmethod(call1825, "+(1)", 1, partcv, params);
// compiled op node returning sum1826 (depth = 6)
  gc_frame_newslot(sum1826);
// call case 6: other requests
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult1816;
  params[1] = call1818;
  params[2] = call1820;
  params[3] = sum1826;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call1827 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe1811);
// compiled call node returning call1827 (depth = 5)
    gc_frame_newslot(call1827);
    if1805 = call1827;
  } else {
  }
// compiled if node returning if1805 (depth = 4)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1828 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1829 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1828);
// compiled member node returning call1829 (depth = 4)
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1832 == NULL) {
    strlit1832 = alloc_String("lbrace");
    gc_root(strlit1832);
  }
// compiled string node returning strlit1832 (depth = 6)
  int op_slot_right_1831 = gc_frame_newslot(strlit1832);
// starting to compile member node (depth = 6)
  int callframe1834 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1835 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe1834);
// compiled member node returning call1835 (depth = 6)
  int op_slot_left_1831 = gc_frame_newslot(call1835);
  params[0] = strlit1832;
  partcv[0] = 1;
  Object opresult1836 = callmethod(call1835, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1836 (depth = 5)
  Object if1830 = done;
  if (istrue(opresult1836)) {
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1837 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1838 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call1839 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe1838);
// compiled member node returning call1839 (depth = 7)
  partcv[0] = 0;
  Object call1840 = callmethodflags(call1839, "new", 1, partcv, params, 0);
  gc_frame_end(callframe1837);
// compiled member node returning call1840 (depth = 6)
  *var_suggestion = call1840;
  if (call1840 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1841 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool1842 = alloc_Boolean(1);
// compiled identifier node returning bool1842 (depth = 7)
  gc_frame_newslot(bool1842);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_btok;
  params[1] = bool1842;
  partcv[0] = 2;
  Object call1843 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1841);
// compiled call node returning call1843 (depth = 6)
  *var_closingBrace = call1843;
  if (call1843 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1845 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1846 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  partcv[0] = 0;
  Object call1847 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe1846);
// compiled member node returning call1847 (depth = 7)
  partcv[0] = 0;
  Object call1848 = callmethodflags(call1847, "not", 1, partcv, params, 0);
  gc_frame_end(callframe1845);
// compiled member node returning call1848 (depth = 6)
  Object if1844 = done;
  if (istrue(call1848)) {
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_1850 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
  int callframe1852 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call1853 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe1852);
// compiled member node returning call1853 (depth = 8)
  int op_slot_left_1850 = gc_frame_newslot(call1853);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult1854 = callmethod(call1853, "==(1)", 1, partcv, params);
// compiled op node returning opresult1854 (depth = 7)
  Object if1849 = done;
  if (istrue(opresult1854)) {
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1855 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool1856 = alloc_Boolean(0);
// compiled identifier node returning bool1856 (depth = 8)
  gc_frame_newslot(bool1856);
// starting to compile identifier node (depth = 8)
  Object bool1857 = alloc_Boolean(1);
// compiled identifier node returning bool1857 (depth = 8)
  gc_frame_newslot(bool1857);
// starting to compile string node (depth = 8)
  if (strlit1858 == NULL) {
    strlit1858 = alloc_String("then {}");
    gc_root(strlit1858);
  }
// compiled string node returning strlit1858 (depth = 8)
  gc_frame_newslot(strlit1858);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool1856;
  params[2] = bool1857;
  params[3] = strlit1858;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1859 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1855);
// compiled call node returning call1859 (depth = 7)
    gc_frame_newslot(call1859);
    if1849 = call1859;
  } else {
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1860 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1862 = alloc_Float64(0.1);
// compiled num node returning num1862 (depth = 9)
  int op_slot_right_1861 = gc_frame_newslot(num1862);
// starting to compile member node (depth = 9)
  int callframe1864 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1865 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call1866 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe1865);
// compiled member node returning call1866 (depth = 10)
  partcv[0] = 0;
  Object call1867 = callmethodflags(call1866, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1864);
// compiled member node returning call1867 (depth = 9)
  int op_slot_left_1861 = gc_frame_newslot(call1867);
  params[0] = num1862;
  partcv[0] = 1;
  Object sum1868 = callmethod(call1867, "+(1)", 1, partcv, params);
// compiled op node returning sum1868 (depth = 8)
  gc_frame_newslot(sum1868);
// starting to compile string node (depth = 8)
  if (strlit1869 == NULL) {
    strlit1869 = alloc_String("}");
    gc_root(strlit1869);
  }
// compiled string node returning strlit1869 (depth = 8)
  gc_frame_newslot(strlit1869);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum1868;
  params[1] = strlit1869;
  partcv[0] = 2;
  Object call1870 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1860);
// compiled call node returning call1870 (depth = 7)
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1871 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool1872 = alloc_Boolean(0);
// compiled identifier node returning bool1872 (depth = 8)
  gc_frame_newslot(bool1872);
// starting to compile identifier node (depth = 8)
  Object bool1873 = alloc_Boolean(1);
// compiled identifier node returning bool1873 (depth = 8)
  gc_frame_newslot(bool1873);
// starting to compile string node (depth = 8)
  if (strlit1874 == NULL) {
    strlit1874 = alloc_String("then {");
    gc_root(strlit1874);
  }
// compiled string node returning strlit1874 (depth = 8)
  gc_frame_newslot(strlit1874);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool1872;
  params[2] = bool1873;
  params[3] = strlit1874;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1875 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1871);
// compiled call node returning call1875 (depth = 7)
    gc_frame_newslot(call1875);
    if1849 = call1875;
  }
// compiled if node returning if1849 (depth = 6)
    gc_frame_newslot(if1849);
    if1844 = if1849;
  } else {
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1876 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool1877 = alloc_Boolean(0);
// compiled identifier node returning bool1877 (depth = 7)
  gc_frame_newslot(bool1877);
// starting to compile identifier node (depth = 7)
  Object bool1878 = alloc_Boolean(1);
// compiled identifier node returning bool1878 (depth = 7)
  gc_frame_newslot(bool1878);
// starting to compile string node (depth = 7)
  if (strlit1879 == NULL) {
    strlit1879 = alloc_String("then {");
    gc_root(strlit1879);
  }
// compiled string node returning strlit1879 (depth = 7)
  gc_frame_newslot(strlit1879);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool1877;
  params[2] = bool1878;
  params[3] = strlit1879;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1880 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1876);
// compiled call node returning call1880 (depth = 6)
    gc_frame_newslot(call1880);
    if1844 = call1880;
  }
// compiled if node returning if1844 (depth = 5)
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1881 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1882 == NULL) {
    strlit1882 = alloc_String("an if statement must have a '{' after the 'then'.");
    gc_root(strlit1882);
  }
// compiled string node returning strlit1882 (depth = 6)
  gc_frame_newslot(strlit1882);
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1883 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1884 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1883);
// compiled member node returning call1884 (depth = 6)
  gc_frame_newslot(call1884);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1886 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1887 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe1886);
// compiled member node returning call1887 (depth = 7)
  int op_slot_right_1885 = gc_frame_newslot(call1887);
// starting to compile member node (depth = 7)
  int callframe1889 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1890 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1889);
// compiled member node returning call1890 (depth = 7)
  int op_slot_left_1885 = gc_frame_newslot(call1890);
  params[0] = call1887;
  partcv[0] = 1;
  Object sum1891 = callmethod(call1890, "+(1)", 1, partcv, params);
// compiled op node returning sum1891 (depth = 6)
  gc_frame_newslot(sum1891);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit1882;
  params[1] = call1884;
  params[2] = sum1891;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1892 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1881);
// compiled call node returning call1892 (depth = 5)
    gc_frame_newslot(call1892);
    if1830 = call1892;
  } else {
  }
// compiled if node returning if1830 (depth = 4)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1893 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1894 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1893);
// compiled member node returning call1894 (depth = 4)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1897 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1898 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1897);
// compiled member node returning call1898 (depth = 6)
  int op_slot_right_1896 = gc_frame_newslot(call1898);
// starting to compile member node (depth = 6)
  int callframe1900 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1901 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe1900);
// compiled member node returning call1901 (depth = 6)
  int op_slot_left_1896 = gc_frame_newslot(call1901);
  params[0] = call1898;
  partcv[0] = 1;
  Object opresult1902 = callmethod(call1901, "==(1)", 1, partcv, params);
// compiled op node returning opresult1902 (depth = 5)
  Object if1895 = done;
  if (istrue(opresult1902)) {
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1904 = alloc_Float64(1);
// compiled num node returning num1904 (depth = 7)
  int op_slot_right_1903 = gc_frame_newslot(num1904);
// starting to compile member node (depth = 7)
  int callframe1906 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1907 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe1906);
// compiled member node returning call1907 (depth = 7)
  int op_slot_left_1903 = gc_frame_newslot(call1907);
  params[0] = num1904;
  partcv[0] = 1;
  Object diff1908 = callmethod(call1907, "-(1)", 1, partcv, params);
// compiled op node returning diff1908 (depth = 6)
  *var_minIndentLevel = diff1908;
  if (diff1908 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1895 = done;
  } else {
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_minInd (depth = 6)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1895 = done;
  }
// compiled if node returning if1895 (depth = 4)
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1911 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1912 = alloc_Block(NULL, NULL, "parser", 743);
  gc_frame_newslot(block1912);
// method "_apply"
  block_savedest(block1912);
  Object closure1913 = createclosure(1, "_apply");
  setclosureframe(closure1913, stackframe);
  addtoclosure(closure1913, selfslot);
  struct UserObject *uo1913 = (struct UserObject*)block1912;
  uo1913->data[0] = (Object)closure1913;
  Method *meth_meth_parser_1913__apply = addmethod2pos(block1912, "_apply", &meth_parser_1913__apply, 0);
  int argcv_meth_parser_1913__apply[] = {0};
  meth_meth_parser_1913__apply->type = alloc_MethodType(1, argcv_meth_parser_1913__apply);
  meth_meth_parser_1913__apply->definitionModule = modulename;
  meth_meth_parser_1913__apply->definitionLine = 183;
// compiled block node returning block1912 (depth = 5)
  gc_frame_newslot(block1912);
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block1920 = alloc_Block(NULL, NULL, "parser", 743);
  gc_frame_newslot(block1920);
// method "_apply"
  block_savedest(block1920);
  Object closure1921 = createclosure(8, "_apply");
  setclosureframe(closure1921, stackframe);
  addtoclosure(closure1921, var_errormessages);
  addtoclosure(closure1921, var_btok);
  addtoclosure(closure1921, var_lastToken);
  addtoclosure(closure1921, var_sym);
  addtoclosure(closure1921, var_values);
  addtoclosure(closure1921, var_v);
  addtoclosure(closure1921, var_body);
  addtoclosure(closure1921, selfslot);
  struct UserObject *uo1921 = (struct UserObject*)block1920;
  uo1921->data[0] = (Object)closure1921;
  Method *meth_meth_parser_1921__apply = addmethod2pos(block1920, "_apply", &meth_parser_1921__apply, 0);
  int argcv_meth_parser_1921__apply[] = {0};
  meth_meth_parser_1921__apply->type = alloc_MethodType(1, argcv_meth_parser_1921__apply);
  meth_meth_parser_1921__apply->definitionModule = modulename;
  meth_meth_parser_1921__apply->definitionLine = 183;
// compiled block node returning block1920 (depth = 5)
  gc_frame_newslot(block1920);
// call case 5: prelude request
  params[0] = block1912;
  params[1] = block1920;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1977 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1911);
// compiled call node returning call1977 (depth = 4)
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1978 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1979 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1978);
// compiled member node returning call1979 (depth = 4)
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_econd = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_eif = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_newelse = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_ebody = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1980 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1981 = alloc_Block(NULL, NULL, "parser", 766);
  gc_frame_newslot(block1981);
// method "_apply"
  block_savedest(block1981);
  Object closure1982 = createclosure(2, "_apply");
  setclosureframe(closure1982, stackframe);
  addtoclosure(closure1982, var_sym);
  addtoclosure(closure1982, selfslot);
  struct UserObject *uo1982 = (struct UserObject*)block1981;
  uo1982->data[0] = (Object)closure1982;
  Method *meth_meth_parser_1982__apply = addmethod2pos(block1981, "_apply", &meth_parser_1982__apply, 0);
  int argcv_meth_parser_1982__apply[] = {0};
  meth_meth_parser_1982__apply->type = alloc_MethodType(1, argcv_meth_parser_1982__apply);
  meth_meth_parser_1982__apply->definitionModule = modulename;
  meth_meth_parser_1982__apply->definitionLine = 183;
// compiled block node returning block1981 (depth = 5)
  gc_frame_newslot(block1981);
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block1996 = alloc_Block(NULL, NULL, "parser", 766);
  gc_frame_newslot(block1996);
// method "_apply"
  block_savedest(block1996);
  Object closure1997 = createclosure(17, "_apply");
  setclosureframe(closure1997, stackframe);
  addtoclosure(closure1997, var_minStartColumn);
  addtoclosure(closure1997, var_sym);
  addtoclosure(closure1997, var_errormessages);
  addtoclosure(closure1997, var_statementToken);
  addtoclosure(closure1997, var_blocksOK);
  addtoclosure(closure1997, var_lastToken);
  addtoclosure(closure1997, var_values);
  addtoclosure(closure1997, var_econd);
  addtoclosure(closure1997, var_ebody);
  addtoclosure(closure1997, var_btok);
  addtoclosure(closure1997, var_minIndentLevel);
  addtoclosure(closure1997, var_minInd);
  addtoclosure(closure1997, var_v);
  addtoclosure(closure1997, var_newelse);
  addtoclosure(closure1997, var_eif);
  addtoclosure(closure1997, var_curelse);
  addtoclosure(closure1997, selfslot);
  struct UserObject *uo1997 = (struct UserObject*)block1996;
  uo1997->data[0] = (Object)closure1997;
  Method *meth_meth_parser_1997__apply = addmethod2pos(block1996, "_apply", &meth_parser_1997__apply, 0);
  int argcv_meth_parser_1997__apply[] = {0};
  meth_meth_parser_1997__apply->type = alloc_MethodType(1, argcv_meth_parser_1997__apply);
  meth_meth_parser_1997__apply->definitionModule = modulename;
  meth_meth_parser_1997__apply->definitionLine = 183;
// compiled block node returning block1996 (depth = 5)
  gc_frame_newslot(block1996);
// call case 5: prelude request
  params[0] = block1981;
  params[1] = block1996;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2593 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1980);
// compiled call node returning call2593 (depth = 4)
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2597 == NULL) {
    strlit2597 = alloc_String("else");
    gc_root(strlit2597);
  }
// compiled string node returning strlit2597 (depth = 7)
  int op_slot_right_2596 = gc_frame_newslot(strlit2597);
// starting to compile member node (depth = 7)
  int callframe2599 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2600 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe2599);
// compiled member node returning call2600 (depth = 7)
  int op_slot_left_2596 = gc_frame_newslot(call2600);
  params[0] = strlit2597;
  partcv[0] = 1;
  Object opresult2601 = callmethod(call2600, "==(1)", 1, partcv, params);
// compiled op node returning opresult2601 (depth = 6)
  int op_slot_right_2595 = gc_frame_newslot(opresult2601);
// starting to compile call node (depth = 6)
  int callframe2603 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2604 == NULL) {
    strlit2604 = alloc_String("identifier");
    gc_root(strlit2604);
  }
// compiled string node returning strlit2604 (depth = 7)
  gc_frame_newslot(strlit2604);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit2604;
  partcv[0] = 1;
  Object call2605 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2603);
// compiled call node returning call2605 (depth = 6)
  int op_slot_left_2595 = gc_frame_newslot(call2605);
  params[0] = opresult2601;
  partcv[0] = 1;
  Object opresult2606 = callmethod(call2605, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2606 (depth = 5)
  Object if2594 = done;
  if (istrue(opresult2606)) {
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_minStartColumn (depth = 7)
  int op_slot_right_2608 = gc_frame_newslot(*var_minStartColumn);
// starting to compile member node (depth = 7)
  int callframe2610 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2611 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2610);
// compiled member node returning call2611 (depth = 7)
  int op_slot_left_2608 = gc_frame_newslot(call2611);
  params[0] = *var_minStartColumn;
  partcv[0] = 1;
  Object opresult2612 = callmethod(call2611, "<(1)", 1, partcv, params);
// compiled op node returning opresult2612 (depth = 6)
  Object if2607 = done;
  if (istrue(opresult2612)) {
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2613 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2615 == NULL) {
    strlit2615 = alloc_String("'if(_)then(_)""\xe2""""\x80""""\xa6""else(_)' must be indented more than the 'if'");
    gc_root(strlit2615);
  }
// compiled string node returning strlit2615 (depth = 8)
  int op_slot_right_2614 = gc_frame_newslot(strlit2615);
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2617 == NULL) {
    strlit2617 = alloc_String("the 'else' part of an ");
    gc_root(strlit2617);
  }
// compiled string node returning strlit2617 (depth = 8)
  int op_slot_left_2614 = gc_frame_newslot(strlit2617);
  params[0] = strlit2615;
  partcv[0] = 1;
  Object opresult2618 = callmethod(strlit2617, "++(1)", 1, partcv, params);
// compiled op node returning opresult2618 (depth = 7)
  gc_frame_newslot(opresult2618);
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2619 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2620 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2619);
// compiled member node returning call2620 (depth = 7)
  gc_frame_newslot(call2620);
// starting to compile member node (depth = 7)
  int callframe2621 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2622 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2621);
// compiled member node returning call2622 (depth = 7)
  gc_frame_newslot(call2622);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2624 = alloc_Float64(3);
// compiled num node returning num2624 (depth = 8)
  int op_slot_right_2623 = gc_frame_newslot(num2624);
// starting to compile member node (depth = 8)
  int callframe2626 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2627 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2626);
// compiled member node returning call2627 (depth = 8)
  int op_slot_left_2623 = gc_frame_newslot(call2627);
  params[0] = num2624;
  partcv[0] = 1;
  Object sum2628 = callmethod(call2627, "+(1)", 1, partcv, params);
// compiled op node returning sum2628 (depth = 7)
  gc_frame_newslot(sum2628);
// call case 6: other requests
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult2618;
  params[1] = call2620;
  params[2] = call2622;
  params[3] = sum2628;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2629 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe2613);
// compiled call node returning call2629 (depth = 6)
    gc_frame_newslot(call2629);
    if2607 = call2629;
  } else {
  }
// compiled if node returning if2607 (depth = 5)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2630 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2631 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2630);
// compiled member node returning call2631 (depth = 5)
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2634 == NULL) {
    strlit2634 = alloc_String("lbrace");
    gc_root(strlit2634);
  }
// compiled string node returning strlit2634 (depth = 7)
  int op_slot_right_2633 = gc_frame_newslot(strlit2634);
// starting to compile member node (depth = 7)
  int callframe2636 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2637 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2636);
// compiled member node returning call2637 (depth = 7)
  int op_slot_left_2633 = gc_frame_newslot(call2637);
  params[0] = strlit2634;
  partcv[0] = 1;
  Object opresult2638 = callmethod(call2637, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2638 (depth = 6)
  Object if2632 = done;
  if (istrue(opresult2638)) {
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2639 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2640 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call2641 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2640);
// compiled member node returning call2641 (depth = 8)
  partcv[0] = 0;
  Object call2642 = callmethodflags(call2641, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2639);
// compiled member node returning call2642 (depth = 7)
  *var_suggestion = call2642;
  if (call2642 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2643 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 8)
  Object bool2644 = alloc_Boolean(1);
// compiled identifier node returning bool2644 (depth = 8)
  gc_frame_newslot(bool2644);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_btok;
  params[1] = bool2644;
  partcv[0] = 2;
  Object call2645 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2643);
// compiled call node returning call2645 (depth = 7)
  *var_closingBrace = call2645;
  if (call2645 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2647 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2648 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call2649 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe2648);
// compiled member node returning call2649 (depth = 8)
  partcv[0] = 0;
  Object call2650 = callmethodflags(call2649, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2647);
// compiled member node returning call2650 (depth = 7)
  Object if2646 = done;
  if (istrue(call2650)) {
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  int op_slot_right_2652 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
  int callframe2654 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call2655 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2654);
// compiled member node returning call2655 (depth = 9)
  int op_slot_left_2652 = gc_frame_newslot(call2655);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2656 = callmethod(call2655, "==(1)", 1, partcv, params);
// compiled op node returning opresult2656 (depth = 8)
  Object if2651 = done;
  if (istrue(opresult2656)) {
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2657 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2658 = alloc_Boolean(0);
// compiled identifier node returning bool2658 (depth = 9)
  gc_frame_newslot(bool2658);
// starting to compile identifier node (depth = 9)
  Object bool2659 = alloc_Boolean(1);
// compiled identifier node returning bool2659 (depth = 9)
  gc_frame_newslot(bool2659);
// starting to compile string node (depth = 9)
  if (strlit2660 == NULL) {
    strlit2660 = alloc_String("else {}");
    gc_root(strlit2660);
  }
// compiled string node returning strlit2660 (depth = 9)
  gc_frame_newslot(strlit2660);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2658;
  params[2] = bool2659;
  params[3] = strlit2660;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2661 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2657);
// compiled call node returning call2661 (depth = 8)
    gc_frame_newslot(call2661);
    if2651 = call2661;
  } else {
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2662 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2664 = alloc_Float64(0.1);
// compiled num node returning num2664 (depth = 10)
  int op_slot_right_2663 = gc_frame_newslot(num2664);
// starting to compile member node (depth = 10)
  int callframe2666 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2667 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2668 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2667);
// compiled member node returning call2668 (depth = 11)
  partcv[0] = 0;
  Object call2669 = callmethodflags(call2668, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2666);
// compiled member node returning call2669 (depth = 10)
  int op_slot_left_2663 = gc_frame_newslot(call2669);
  params[0] = num2664;
  partcv[0] = 1;
  Object sum2670 = callmethod(call2669, "+(1)", 1, partcv, params);
// compiled op node returning sum2670 (depth = 9)
  gc_frame_newslot(sum2670);
// starting to compile string node (depth = 9)
  if (strlit2671 == NULL) {
    strlit2671 = alloc_String("}");
    gc_root(strlit2671);
  }
// compiled string node returning strlit2671 (depth = 9)
  gc_frame_newslot(strlit2671);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = sum2670;
  params[1] = strlit2671;
  partcv[0] = 2;
  Object call2672 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2662);
// compiled call node returning call2672 (depth = 8)
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2673 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2674 = alloc_Boolean(0);
// compiled identifier node returning bool2674 (depth = 9)
  gc_frame_newslot(bool2674);
// starting to compile identifier node (depth = 9)
  Object bool2675 = alloc_Boolean(1);
// compiled identifier node returning bool2675 (depth = 9)
  gc_frame_newslot(bool2675);
// starting to compile string node (depth = 9)
  if (strlit2676 == NULL) {
    strlit2676 = alloc_String("else {");
    gc_root(strlit2676);
  }
// compiled string node returning strlit2676 (depth = 9)
  gc_frame_newslot(strlit2676);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2674;
  params[2] = bool2675;
  params[3] = strlit2676;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2677 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2673);
// compiled call node returning call2677 (depth = 8)
    gc_frame_newslot(call2677);
    if2651 = call2677;
  }
// compiled if node returning if2651 (depth = 7)
    gc_frame_newslot(if2651);
    if2646 = if2651;
  } else {
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2678 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2679 = alloc_Boolean(0);
// compiled identifier node returning bool2679 (depth = 8)
  gc_frame_newslot(bool2679);
// starting to compile identifier node (depth = 8)
  Object bool2680 = alloc_Boolean(1);
// compiled identifier node returning bool2680 (depth = 8)
  gc_frame_newslot(bool2680);
// starting to compile string node (depth = 8)
  if (strlit2681 == NULL) {
    strlit2681 = alloc_String("else {");
    gc_root(strlit2681);
  }
// compiled string node returning strlit2681 (depth = 8)
  gc_frame_newslot(strlit2681);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2679;
  params[2] = bool2680;
  params[3] = strlit2681;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2682 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2678);
// compiled call node returning call2682 (depth = 7)
    gc_frame_newslot(call2682);
    if2646 = call2682;
  }
// compiled if node returning if2646 (depth = 6)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2683 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2684 == NULL) {
    strlit2684 = alloc_String("an else clause must start with a '{' after the 'else'.");
    gc_root(strlit2684);
  }
// compiled string node returning strlit2684 (depth = 7)
  gc_frame_newslot(strlit2684);
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2685 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2686 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2685);
// compiled member node returning call2686 (depth = 7)
  gc_frame_newslot(call2686);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2688 = alloc_Float64(1);
// compiled num node returning num2688 (depth = 8)
  int op_slot_right_2687 = gc_frame_newslot(num2688);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2691 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2692 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe2691);
// compiled member node returning call2692 (depth = 9)
  int op_slot_right_2690 = gc_frame_newslot(call2692);
// starting to compile member node (depth = 9)
  int callframe2694 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2695 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2694);
// compiled member node returning call2695 (depth = 9)
  int op_slot_left_2690 = gc_frame_newslot(call2695);
  params[0] = call2692;
  partcv[0] = 1;
  Object sum2696 = callmethod(call2695, "+(1)", 1, partcv, params);
// compiled op node returning sum2696 (depth = 8)
  int op_slot_left_2687 = gc_frame_newslot(sum2696);
  params[0] = num2688;
  partcv[0] = 1;
  Object diff2697 = callmethod(sum2696, "-(1)", 1, partcv, params);
// compiled op node returning diff2697 (depth = 7)
  gc_frame_newslot(diff2697);
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit2684;
  params[1] = call2686;
  params[2] = diff2697;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2698 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2683);
// compiled call node returning call2698 (depth = 6)
    gc_frame_newslot(call2698);
    if2632 = call2698;
  } else {
  }
// compiled if node returning if2632 (depth = 5)
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2699 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2700 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2699);
// compiled member node returning call2700 (depth = 5)
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2703 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2704 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2703);
// compiled member node returning call2704 (depth = 7)
  int op_slot_right_2702 = gc_frame_newslot(call2704);
// starting to compile member node (depth = 7)
  int callframe2706 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2707 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2706);
// compiled member node returning call2707 (depth = 7)
  int op_slot_left_2702 = gc_frame_newslot(call2707);
  params[0] = call2704;
  partcv[0] = 1;
  Object opresult2708 = callmethod(call2707, "==(1)", 1, partcv, params);
// compiled op node returning opresult2708 (depth = 6)
  Object if2701 = done;
  if (istrue(opresult2708)) {
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2710 = alloc_Float64(1);
// compiled num node returning num2710 (depth = 8)
  int op_slot_right_2709 = gc_frame_newslot(num2710);
// starting to compile member node (depth = 8)
  int callframe2712 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2713 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2712);
// compiled member node returning call2713 (depth = 8)
  int op_slot_left_2709 = gc_frame_newslot(call2713);
  params[0] = num2710;
  partcv[0] = 1;
  Object diff2714 = callmethod(call2713, "-(1)", 1, partcv, params);
// compiled op node returning diff2714 (depth = 7)
  *var_minIndentLevel = diff2714;
  if (diff2714 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2701 = done;
  } else {
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_minInd (depth = 7)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2701 = done;
  }
// compiled if node returning if2701 (depth = 5)
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2717 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2718 = alloc_Block(NULL, NULL, "parser", 970);
  gc_frame_newslot(block2718);
// method "_apply"
  block_savedest(block2718);
  Object closure2719 = createclosure(1, "_apply");
  setclosureframe(closure2719, stackframe);
  addtoclosure(closure2719, selfslot);
  struct UserObject *uo2719 = (struct UserObject*)block2718;
  uo2719->data[0] = (Object)closure2719;
  Method *meth_meth_parser_2719__apply = addmethod2pos(block2718, "_apply", &meth_parser_2719__apply, 0);
  int argcv_meth_parser_2719__apply[] = {0};
  meth_meth_parser_2719__apply->type = alloc_MethodType(1, argcv_meth_parser_2719__apply);
  meth_meth_parser_2719__apply->definitionModule = modulename;
  meth_meth_parser_2719__apply->definitionLine = 183;
// compiled block node returning block2718 (depth = 6)
  gc_frame_newslot(block2718);
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block2726 = alloc_Block(NULL, NULL, "parser", 970);
  gc_frame_newslot(block2726);
// method "_apply"
  block_savedest(block2726);
  Object closure2727 = createclosure(8, "_apply");
  setclosureframe(closure2727, stackframe);
  addtoclosure(closure2727, var_errormessages);
  addtoclosure(closure2727, var_btok);
  addtoclosure(closure2727, var_sym);
  addtoclosure(closure2727, var_lastToken);
  addtoclosure(closure2727, var_values);
  addtoclosure(closure2727, var_v);
  addtoclosure(closure2727, var_curelse);
  addtoclosure(closure2727, selfslot);
  struct UserObject *uo2727 = (struct UserObject*)block2726;
  uo2727->data[0] = (Object)closure2727;
  Method *meth_meth_parser_2727__apply = addmethod2pos(block2726, "_apply", &meth_parser_2727__apply, 0);
  int argcv_meth_parser_2727__apply[] = {0};
  meth_meth_parser_2727__apply->type = alloc_MethodType(1, argcv_meth_parser_2727__apply);
  meth_meth_parser_2727__apply->definitionModule = modulename;
  meth_meth_parser_2727__apply->definitionLine = 183;
// compiled block node returning block2726 (depth = 6)
  gc_frame_newslot(block2726);
// call case 5: prelude request
  params[0] = block2718;
  params[1] = block2726;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2805 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2717);
// compiled call node returning call2805 (depth = 5)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2806 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2807 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2806);
// compiled member node returning call2807 (depth = 5)
    gc_frame_newslot(call2807);
    if2594 = call2807;
  } else {
  }
// compiled if node returning if2594 (depth = 4)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2808 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2809 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call2810 = callmethodflags(*var_btok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2809);
// compiled member node returning call2810 (depth = 5)
  gc_frame_newslot(call2810);
// starting to compile member node (depth = 5)
  int callframe2811 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call2812 = callmethodflags(*var_btok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2811);
// compiled member node returning call2812 (depth = 5)
  gc_frame_newslot(call2812);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call2810;
  params[1] = call2812;
  partcv[0] = 2;
  Object call2813 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2808);
// compiled call node returning call2813 (depth = 4)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2814 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cond (depth = 6)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elseblock (depth = 6)
  gc_frame_newslot(*var_elseblock);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_cond;
  params[1] = *var_body;
  params[2] = *var_elseblock;
  partcv[0] = 3;
  Object call2815 = callmethodflags(module_parser, "newIf(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2814);
// compiled call node returning call2815 (depth = 5)
  *var_o = call2815;
  if (call2815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2816 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call2817 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2816);
// compiled call node returning call2817 (depth = 4)
    gc_frame_newslot(call2817);
    if1792 = call2817;
  } else {
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2818 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2819 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call2820 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2819);
// compiled member node returning call2820 (depth = 6)
  partcv[0] = 0;
  Object call2821 = callmethodflags(call2820, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2818);
// compiled member node returning call2821 (depth = 5)
  *var_suggestion = call2821;
  if (call2821 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2824 == NULL) {
    strlit2824 = alloc_String("lbrace");
    gc_root(strlit2824);
  }
// compiled string node returning strlit2824 (depth = 6)
  int op_slot_right_2823 = gc_frame_newslot(strlit2824);
// starting to compile member node (depth = 6)
  int callframe2826 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call2827 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2826);
// compiled member node returning call2827 (depth = 6)
  int op_slot_left_2823 = gc_frame_newslot(call2827);
  params[0] = strlit2824;
  partcv[0] = 1;
  Object opresult2828 = callmethod(call2827, "==(1)", 1, partcv, params);
// compiled op node returning opresult2828 (depth = 5)
  Object if2822 = done;
  if (istrue(opresult2828)) {
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2829 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2830 = alloc_Boolean(0);
// compiled identifier node returning bool2830 (depth = 7)
  gc_frame_newslot(bool2830);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_btok;
  params[1] = bool2830;
  partcv[0] = 2;
  Object call2831 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2829);
// compiled call node returning call2831 (depth = 6)
  *var_closingBrace = call2831;
  if (call2831 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2833 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2834 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  partcv[0] = 0;
  Object call2835 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe2834);
// compiled member node returning call2835 (depth = 7)
  partcv[0] = 0;
  Object call2836 = callmethodflags(call2835, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2833);
// compiled member node returning call2836 (depth = 6)
  Object if2832 = done;
  if (istrue(call2836)) {
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_2838 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe2840 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call2841 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2840);
// compiled member node returning call2841 (depth = 8)
  int op_slot_left_2838 = gc_frame_newslot(call2841);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2842 = callmethod(call2841, "==(1)", 1, partcv, params);
// compiled op node returning opresult2842 (depth = 7)
  Object if2837 = done;
  if (istrue(opresult2842)) {
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2843 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool2844 = alloc_Boolean(1);
// compiled identifier node returning bool2844 (depth = 8)
  gc_frame_newslot(bool2844);
// starting to compile identifier node (depth = 8)
  Object bool2845 = alloc_Boolean(0);
// compiled identifier node returning bool2845 (depth = 8)
  gc_frame_newslot(bool2845);
// starting to compile string node (depth = 8)
  if (strlit2846 == NULL) {
    strlit2846 = alloc_String(" then {}");
    gc_root(strlit2846);
  }
// compiled string node returning strlit2846 (depth = 8)
  gc_frame_newslot(strlit2846);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool2844;
  params[2] = bool2845;
  params[3] = strlit2846;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2847 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2843);
// compiled call node returning call2847 (depth = 7)
    gc_frame_newslot(call2847);
    if2837 = call2847;
  } else {
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2848 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool2849 = alloc_Boolean(1);
// compiled identifier node returning bool2849 (depth = 8)
  gc_frame_newslot(bool2849);
// starting to compile identifier node (depth = 8)
  Object bool2850 = alloc_Boolean(0);
// compiled identifier node returning bool2850 (depth = 8)
  gc_frame_newslot(bool2850);
// starting to compile string node (depth = 8)
  if (strlit2851 == NULL) {
    strlit2851 = alloc_String(" then {");
    gc_root(strlit2851);
  }
// compiled string node returning strlit2851 (depth = 8)
  gc_frame_newslot(strlit2851);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool2849;
  params[2] = bool2850;
  params[3] = strlit2851;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2852 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2848);
// compiled call node returning call2852 (depth = 7)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2853 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2855 = alloc_Float64(0.1);
// compiled num node returning num2855 (depth = 9)
  int op_slot_right_2854 = gc_frame_newslot(num2855);
// starting to compile member node (depth = 9)
  int callframe2857 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2858 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2859 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2858);
// compiled member node returning call2859 (depth = 10)
  partcv[0] = 0;
  Object call2860 = callmethodflags(call2859, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2857);
// compiled member node returning call2860 (depth = 9)
  int op_slot_left_2854 = gc_frame_newslot(call2860);
  params[0] = num2855;
  partcv[0] = 1;
  Object sum2861 = callmethod(call2860, "+(1)", 1, partcv, params);
// compiled op node returning sum2861 (depth = 8)
  gc_frame_newslot(sum2861);
// starting to compile string node (depth = 8)
  if (strlit2862 == NULL) {
    strlit2862 = alloc_String("}");
    gc_root(strlit2862);
  }
// compiled string node returning strlit2862 (depth = 8)
  gc_frame_newslot(strlit2862);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2861;
  params[1] = strlit2862;
  partcv[0] = 2;
  Object call2863 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2853);
// compiled call node returning call2863 (depth = 7)
    gc_frame_newslot(call2863);
    if2837 = call2863;
  }
// compiled if node returning if2837 (depth = 6)
    gc_frame_newslot(if2837);
    if2832 = if2837;
  } else {
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2864 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool2865 = alloc_Boolean(1);
// compiled identifier node returning bool2865 (depth = 7)
  gc_frame_newslot(bool2865);
// starting to compile identifier node (depth = 7)
  Object bool2866 = alloc_Boolean(0);
// compiled identifier node returning bool2866 (depth = 7)
  gc_frame_newslot(bool2866);
// starting to compile string node (depth = 7)
  if (strlit2867 == NULL) {
    strlit2867 = alloc_String(" then {");
    gc_root(strlit2867);
  }
// compiled string node returning strlit2867 (depth = 7)
  gc_frame_newslot(strlit2867);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool2865;
  params[2] = bool2866;
  params[3] = strlit2867;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2868 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2864);
// compiled call node returning call2868 (depth = 6)
    gc_frame_newslot(call2868);
    if2832 = call2868;
  }
// compiled if node returning if2832 (depth = 5)
    gc_frame_newslot(if2832);
    if2822 = if2832;
  } else {
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2869 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2870 = alloc_Boolean(1);
// compiled identifier node returning bool2870 (depth = 7)
  gc_frame_newslot(bool2870);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_btok;
  params[1] = bool2870;
  partcv[0] = 2;
  Object call2871 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2869);
// compiled call node returning call2871 (depth = 6)
  *var_closingBrace = call2871;
  if (call2871 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2873 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2874 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  partcv[0] = 0;
  Object call2875 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe2874);
// compiled member node returning call2875 (depth = 7)
  partcv[0] = 0;
  Object call2876 = callmethodflags(call2875, "not", 1, partcv, params, 0);
  gc_frame_end(callframe2873);
// compiled member node returning call2876 (depth = 6)
  Object if2872 = done;
  if (istrue(call2876)) {
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_2878 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
  int callframe2880 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call2881 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2880);
// compiled member node returning call2881 (depth = 8)
  int op_slot_left_2878 = gc_frame_newslot(call2881);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2882 = callmethod(call2881, "==(1)", 1, partcv, params);
// compiled op node returning opresult2882 (depth = 7)
  Object if2877 = done;
  if (istrue(opresult2882)) {
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2883 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2884 == NULL) {
    strlit2884 = alloc_String(" then {}");
    gc_root(strlit2884);
  }
// compiled string node returning strlit2884 (depth = 8)
  gc_frame_newslot(strlit2884);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2884;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2885 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2883);
// compiled call node returning call2885 (depth = 7)
    gc_frame_newslot(call2885);
    if2877 = call2885;
  } else {
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2886 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2887 == NULL) {
    strlit2887 = alloc_String(" then {");
    gc_root(strlit2887);
  }
// compiled string node returning strlit2887 (depth = 8)
  gc_frame_newslot(strlit2887);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2887;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2888 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2886);
// compiled call node returning call2888 (depth = 7)
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2889 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2891 = alloc_Float64(0.1);
// compiled num node returning num2891 (depth = 9)
  int op_slot_right_2890 = gc_frame_newslot(num2891);
// starting to compile member node (depth = 9)
  int callframe2893 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2894 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2895 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe2894);
// compiled member node returning call2895 (depth = 10)
  partcv[0] = 0;
  Object call2896 = callmethodflags(call2895, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2893);
// compiled member node returning call2896 (depth = 9)
  int op_slot_left_2890 = gc_frame_newslot(call2896);
  params[0] = num2891;
  partcv[0] = 1;
  Object sum2897 = callmethod(call2896, "+(1)", 1, partcv, params);
// compiled op node returning sum2897 (depth = 8)
  gc_frame_newslot(sum2897);
// starting to compile string node (depth = 8)
  if (strlit2898 == NULL) {
    strlit2898 = alloc_String("}");
    gc_root(strlit2898);
  }
// compiled string node returning strlit2898 (depth = 8)
  gc_frame_newslot(strlit2898);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2897;
  params[1] = strlit2898;
  partcv[0] = 2;
  Object call2899 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2889);
// compiled call node returning call2899 (depth = 7)
    gc_frame_newslot(call2899);
    if2877 = call2899;
  }
// compiled if node returning if2877 (depth = 6)
    gc_frame_newslot(if2877);
    if2872 = if2877;
  } else {
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2900 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2901 == NULL) {
    strlit2901 = alloc_String(" then {");
    gc_root(strlit2901);
  }
// compiled string node returning strlit2901 (depth = 7)
  gc_frame_newslot(strlit2901);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit2901;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2902 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2900);
// compiled call node returning call2902 (depth = 6)
    gc_frame_newslot(call2902);
    if2872 = call2902;
  }
// compiled if node returning if2872 (depth = 5)
    gc_frame_newslot(if2872);
    if2822 = if2872;
  }
// compiled if node returning if2822 (depth = 4)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2903 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2905 == NULL) {
    strlit2905 = alloc_String("the condition in parentheses.");
    gc_root(strlit2905);
  }
// compiled string node returning strlit2905 (depth = 6)
  int op_slot_right_2904 = gc_frame_newslot(strlit2905);
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2907 == NULL) {
    strlit2907 = alloc_String("an if statement must have 'then' after ");
    gc_root(strlit2907);
  }
// compiled string node returning strlit2907 (depth = 6)
  int op_slot_left_2904 = gc_frame_newslot(strlit2907);
  params[0] = strlit2905;
  partcv[0] = 1;
  Object opresult2908 = callmethod(strlit2907, "++(1)", 1, partcv, params);
// compiled op node returning opresult2908 (depth = 5)
  gc_frame_newslot(opresult2908);
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2909 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call2910 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2909);
// compiled member node returning call2910 (depth = 5)
  gc_frame_newslot(call2910);
// starting to compile member node (depth = 5)
  int callframe2911 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call2912 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2911);
// compiled member node returning call2912 (depth = 5)
  gc_frame_newslot(call2912);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult2908;
  params[1] = call2910;
  params[2] = call2912;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2913 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2903);
// compiled call node returning call2913 (depth = 4)
    gc_frame_newslot(call2913);
    if1792 = call2913;
  }
// compiled if node returning if1792 (depth = 3)
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMin (depth = 4)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localStatementIndent (depth = 4)
  *var_statementIndent = *var_localStatementIndent;
  if (*var_localStatementIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1421 = done;
  } else {
  }
// compiled if node returning if1421 (depth = 2)
  gc_frame_end(frame);
  return if1421;
}
Object meth_parser_2916_identifier(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2918 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2919 == NULL) {
    strlit2919 = alloc_String("identifier");
    gc_root(strlit2919);
  }
// compiled string node returning strlit2919 (depth = 4)
  gc_frame_newslot(strlit2919);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit2919;
  partcv[0] = 1;
  Object call2920 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2918);
// compiled call node returning call2920 (depth = 3)
  Object if2917 = done;
  if (istrue(call2920)) {
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2923 == NULL) {
    strlit2923 = alloc_String("if");
    gc_root(strlit2923);
  }
// compiled string node returning strlit2923 (depth = 5)
  int op_slot_right_2922 = gc_frame_newslot(strlit2923);
// starting to compile member node (depth = 5)
  int callframe2925 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call2926 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe2925);
// compiled member node returning call2926 (depth = 5)
  int op_slot_left_2922 = gc_frame_newslot(call2926);
  params[0] = strlit2923;
  partcv[0] = 1;
  Object opresult2927 = callmethod(call2926, "==(1)", 1, partcv, params);
// compiled op node returning opresult2927 (depth = 4)
  Object if2921 = done;
  if (istrue(opresult2927)) {
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2928 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2929 = callmethodflags(self, "doif", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2928);
// compiled member node returning call2929 (depth = 4)
    gc_frame_newslot(call2929);
    if2921 = call2929;
  } else {
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2930 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2931 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2930);
// compiled member node returning call2931 (depth = 4)
    gc_frame_newslot(call2931);
    if2921 = call2931;
  }
// compiled if node returning if2921 (depth = 3)
    gc_frame_newslot(if2921);
    if2917 = if2921;
  } else {
  }
// compiled if node returning if2917 (depth = 2)
  gc_frame_end(frame);
  return if2917;
}
Object meth_parser_2950__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe2951 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2952 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2951);
// compiled call node returning call2952 (depth = 7)
  gc_frame_end(frame);
  return call2952;
}
Object meth_parser_3017__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 7)
  int callframe3018 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3019 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3018);
// compiled member node returning call3019 (depth = 7)
  gc_frame_end(frame);
  return call3019;
}
Object meth_parser_2932_prefixop(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "prefixop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object *var_lastLine = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_startIndent = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startIndent");
// definebindings:
  Object *var_op = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "op");
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_rcvr = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "rcvr");
  Object *var_call = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "call");
// definebindings:
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_startIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2934 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2935 == NULL) {
    strlit2935 = alloc_String("op");
    gc_root(strlit2935);
  }
// compiled string node returning strlit2935 (depth = 4)
  gc_frame_newslot(strlit2935);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit2935;
  partcv[0] = 1;
  Object call2936 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2934);
// compiled call node returning call2936 (depth = 3)
  Object if2933 = done;
  if (istrue(call2936)) {
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2937 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call2938 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe2937);
// compiled member node returning call2938 (depth = 4)
  *var_op = call2938;
  if (call2938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2939 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2940 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2939);
// compiled member node returning call2940 (depth = 3)
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2942 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2943 == NULL) {
    strlit2943 = alloc_String("lparen");
    gc_root(strlit2943);
  }
// compiled string node returning strlit2943 (depth = 5)
  gc_frame_newslot(strlit2943);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit2943;
  partcv[0] = 1;
  Object call2944 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2942);
// compiled call node returning call2944 (depth = 4)
  Object if2941 = done;
  if (istrue(call2944)) {
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2945 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2946 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2945);
// compiled member node returning call2946 (depth = 4)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2948 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2949 = alloc_Block(NULL, NULL, "parser", 1055);
  gc_frame_newslot(block2949);
// method "_apply"
  block_savedest(block2949);
  Object closure2950 = createclosure(2, "_apply");
  setclosureframe(closure2950, stackframe);
  addtoclosure(closure2950, var_blocksOK);
  addtoclosure(closure2950, selfslot);
  struct UserObject *uo2950 = (struct UserObject*)block2949;
  uo2950->data[0] = (Object)closure2950;
  Method *meth_meth_parser_2950__apply = addmethod2pos(block2949, "_apply", &meth_parser_2950__apply, 0);
  int argcv_meth_parser_2950__apply[] = {0};
  meth_meth_parser_2950__apply->type = alloc_MethodType(1, argcv_meth_parser_2950__apply);
  meth_meth_parser_2950__apply->definitionModule = modulename;
  meth_meth_parser_2950__apply->definitionLine = 183;
// compiled block node returning block2949 (depth = 6)
  gc_frame_newslot(block2949);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block2949;
  partcv[0] = 1;
  Object call2954 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2948);
// compiled call node returning call2954 (depth = 5)
  Object if2947 = done;
  if (istrue(call2954)) {
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2955 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2956 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call2957 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2956);
// compiled member node returning call2957 (depth = 7)
  partcv[0] = 0;
  Object call2958 = callmethodflags(call2957, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2955);
// compiled member node returning call2958 (depth = 6)
  *var_suggestion = call2958;
  if (call2958 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2959 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array2960 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit2961 == NULL) {
    strlit2961 = alloc_String("rparen");
    gc_root(strlit2961);
  }
// compiled string node returning strlit2961 (depth = 8)
  params[0] = strlit2961;
  partcv[0] = 1;
  callmethodflags(array2960, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array2960 (depth = 7)
  gc_frame_newslot(array2960);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = array2960;
  partcv[0] = 1;
  Object call2962 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2959);
// compiled call node returning call2962 (depth = 6)
  *var_nextTok = call2962;
  if (call2962 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_2964 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_2964 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2966 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2966 (depth = 6)
  Object if2963 = done;
  if (istrue(opresult2966)) {
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2967 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2968 == NULL) {
    strlit2968 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2968);
  }
// compiled string node returning strlit2968 (depth = 7)
  gc_frame_newslot(strlit2968);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit2968;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2969 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2967);
// compiled call node returning call2969 (depth = 6)
    gc_frame_newslot(call2969);
    if2963 = call2969;
  } else {
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2970 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe2971 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call2972 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe2971);
// compiled member node returning call2972 (depth = 7)
  gc_frame_newslot(call2972);
// starting to compile identifier node (depth = 7)
  Object bool2973 = alloc_Boolean(1);
// compiled identifier node returning bool2973 (depth = 7)
  gc_frame_newslot(bool2973);
// starting to compile identifier node (depth = 7)
  Object bool2974 = alloc_Boolean(0);
// compiled identifier node returning bool2974 (depth = 7)
  gc_frame_newslot(bool2974);
// starting to compile string node (depth = 7)
  if (strlit2975 == NULL) {
    strlit2975 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2975);
  }
// compiled string node returning strlit2975 (depth = 7)
  gc_frame_newslot(strlit2975);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call2972;
  params[2] = bool2973;
  params[3] = bool2974;
  params[4] = strlit2975;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2976 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2970);
// compiled call node returning call2976 (depth = 6)
    gc_frame_newslot(call2976);
    if2963 = call2976;
  }
// compiled if node returning if2963 (depth = 5)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2977 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2978 == NULL) {
    strlit2978 = alloc_String("parentheses must contain a valid expression.");
    gc_root(strlit2978);
  }
// compiled string node returning strlit2978 (depth = 6)
  gc_frame_newslot(strlit2978);
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2979 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call2980 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe2979);
// compiled member node returning call2980 (depth = 6)
  gc_frame_newslot(call2980);
// starting to compile member node (depth = 6)
  int callframe2981 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call2982 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe2981);
// compiled member node returning call2982 (depth = 6)
  gc_frame_newslot(call2982);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit2978;
  params[1] = call2980;
  params[2] = call2982;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2983 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2977);
// compiled call node returning call2983 (depth = 5)
    gc_frame_newslot(call2983);
    if2947 = call2983;
  } else {
  }
// compiled if node returning if2947 (depth = 4)
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2986 == NULL) {
    strlit2986 = alloc_String("rparen");
    gc_root(strlit2986);
  }
// compiled string node returning strlit2986 (depth = 6)
  int op_slot_right_2985 = gc_frame_newslot(strlit2986);
// starting to compile member node (depth = 6)
  int callframe2988 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call2989 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe2988);
// compiled member node returning call2989 (depth = 6)
  int op_slot_left_2985 = gc_frame_newslot(call2989);
  params[0] = strlit2986;
  partcv[0] = 1;
  Object opresult2990 = callmethod(call2989, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2990 (depth = 5)
  Object if2984 = done;
  if (istrue(opresult2990)) {
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2991 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2992 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2991);
// compiled member node returning call2992 (depth = 5)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2993 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2994 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call2995 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe2994);
// compiled member node returning call2995 (depth = 7)
  partcv[0] = 0;
  Object call2996 = callmethodflags(call2995, "new", 1, partcv, params, 0);
  gc_frame_end(callframe2993);
// compiled member node returning call2996 (depth = 6)
  *var_suggestion = call2996;
  if (call2996 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2997 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2998 == NULL) {
    strlit2998 = alloc_String(")");
    gc_root(strlit2998);
  }
// compiled string node returning strlit2998 (depth = 6)
  gc_frame_newslot(strlit2998);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit2998;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2999 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2997);
// compiled call node returning call2999 (depth = 5)
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3000 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3001 == NULL) {
    strlit3001 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3001);
  }
// compiled string node returning strlit3001 (depth = 6)
  gc_frame_newslot(strlit3001);
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3002 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3003 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3002);
// compiled member node returning call3003 (depth = 6)
  gc_frame_newslot(call3003);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3005 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3006 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3005);
// compiled member node returning call3006 (depth = 7)
  int op_slot_right_3004 = gc_frame_newslot(call3006);
// starting to compile member node (depth = 7)
  int callframe3008 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3009 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3008);
// compiled member node returning call3009 (depth = 7)
  int op_slot_left_3004 = gc_frame_newslot(call3009);
  params[0] = call3006;
  partcv[0] = 1;
  Object sum3010 = callmethod(call3009, "+(1)", 1, partcv, params);
// compiled op node returning sum3010 (depth = 6)
  gc_frame_newslot(sum3010);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3001;
  params[1] = call3003;
  params[2] = sum3010;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3011 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3000);
// compiled call node returning call3011 (depth = 5)
    gc_frame_newslot(call3011);
    if2984 = call3011;
  } else {
  }
// compiled if node returning if2984 (depth = 4)
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3012 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3013 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3012);
// compiled member node returning call3013 (depth = 4)
    gc_frame_newslot(call3013);
    if2941 = call3013;
  } else {
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3015 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3016 = alloc_Block(NULL, NULL, "parser", 1075);
  gc_frame_newslot(block3016);
// method "_apply"
  block_savedest(block3016);
  Object closure3017 = createclosure(1, "_apply");
  setclosureframe(closure3017, stackframe);
  addtoclosure(closure3017, selfslot);
  struct UserObject *uo3017 = (struct UserObject*)block3016;
  uo3017->data[0] = (Object)closure3017;
  Method *meth_meth_parser_3017__apply = addmethod2pos(block3016, "_apply", &meth_parser_3017__apply, 0);
  int argcv_meth_parser_3017__apply[] = {0};
  meth_meth_parser_3017__apply->type = alloc_MethodType(1, argcv_meth_parser_3017__apply);
  meth_meth_parser_3017__apply->definitionModule = modulename;
  meth_meth_parser_3017__apply->definitionLine = 183;
// compiled block node returning block3016 (depth = 6)
  gc_frame_newslot(block3016);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block3016;
  partcv[0] = 1;
  Object call3021 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3015);
// compiled call node returning call3021 (depth = 5)
  Object if3014 = done;
  if (istrue(call3021)) {
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array3022 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3022 (depth = 6)
  *var_suggestions = array3022;
  if (array3022 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3023 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3024 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call3025 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3024);
// compiled member node returning call3025 (depth = 7)
  partcv[0] = 0;
  Object call3026 = callmethodflags(call3025, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3023);
// compiled member node returning call3026 (depth = 6)
  *var_suggestion = call3026;
  if (call3026 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3027 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array3028 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit3029 == NULL) {
    strlit3029 = alloc_String("rparen");
    gc_root(strlit3029);
  }
// compiled string node returning strlit3029 (depth = 8)
  params[0] = strlit3029;
  partcv[0] = 1;
  callmethodflags(array3028, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3028 (depth = 7)
  gc_frame_newslot(array3028);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = array3028;
  partcv[0] = 1;
  Object call3030 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3027);
// compiled call node returning call3030 (depth = 6)
  *var_nextTok = call3030;
  if (call3030 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3032 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3032 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3034 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3034 (depth = 6)
  Object if3031 = done;
  if (istrue(opresult3034)) {
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3035 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3036 == NULL) {
    strlit3036 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3036);
  }
// compiled string node returning strlit3036 (depth = 7)
  gc_frame_newslot(strlit3036);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3036;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3037 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3035);
// compiled call node returning call3037 (depth = 6)
    gc_frame_newslot(call3037);
    if3031 = call3037;
  } else {
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3038 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe3039 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call3040 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe3039);
// compiled member node returning call3040 (depth = 7)
  gc_frame_newslot(call3040);
// starting to compile identifier node (depth = 7)
  Object bool3041 = alloc_Boolean(1);
// compiled identifier node returning bool3041 (depth = 7)
  gc_frame_newslot(bool3041);
// starting to compile identifier node (depth = 7)
  Object bool3042 = alloc_Boolean(0);
// compiled identifier node returning bool3042 (depth = 7)
  gc_frame_newslot(bool3042);
// starting to compile string node (depth = 7)
  if (strlit3043 == NULL) {
    strlit3043 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3043);
  }
// compiled string node returning strlit3043 (depth = 7)
  gc_frame_newslot(strlit3043);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3040;
  params[2] = bool3041;
  params[3] = bool3042;
  params[4] = strlit3043;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3044 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3038);
// compiled call node returning call3044 (depth = 6)
    gc_frame_newslot(call3044);
    if3031 = call3044;
  }
// compiled if node returning if3031 (depth = 5)
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3045 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3046 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3045);
// compiled call node returning call3046 (depth = 5)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3049 == NULL) {
    strlit3049 = alloc_String("bind");
    gc_root(strlit3049);
  }
// compiled string node returning strlit3049 (depth = 7)
  int op_slot_right_3048 = gc_frame_newslot(strlit3049);
// starting to compile member node (depth = 7)
  int callframe3051 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3052 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3053 = callmethodflags(*var_lastToken, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe3052);
// compiled member node returning call3053 (depth = 8)
  partcv[0] = 0;
  Object call3054 = callmethodflags(call3053, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3051);
// compiled member node returning call3054 (depth = 7)
  int op_slot_left_3048 = gc_frame_newslot(call3054);
  params[0] = strlit3049;
  partcv[0] = 1;
  Object opresult3055 = callmethod(call3054, "==(1)", 1, partcv, params);
// compiled op node returning opresult3055 (depth = 6)
  Object if3047 = done;
  if (istrue(opresult3055)) {
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3056 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3058 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3057);
// compiled member node returning call3058 (depth = 8)
  partcv[0] = 0;
  Object call3059 = callmethodflags(call3058, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3056);
// compiled member node returning call3059 (depth = 7)
  *var_suggestion = call3059;
  if (call3059 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3061 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe3062 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call3063 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe3062);
// compiled member node returning call3063 (depth = 7)
  gc_frame_newslot(call3063);
// starting to compile identifier node (depth = 7)
  Object bool3064 = alloc_Boolean(1);
// compiled identifier node returning bool3064 (depth = 7)
  gc_frame_newslot(bool3064);
// starting to compile identifier node (depth = 7)
  Object bool3065 = alloc_Boolean(0);
// compiled identifier node returning bool3065 (depth = 7)
  gc_frame_newslot(bool3065);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call3063;
  params[2] = bool3064;
  params[3] = bool3065;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3066 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3061);
// compiled call node returning call3066 (depth = 6)
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3067 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe3068 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3069 = callmethodflags(*var_lastToken, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe3068);
// compiled member node returning call3069 (depth = 7)
  gc_frame_newslot(call3069);
// starting to compile identifier node (depth = 7)
  Object bool3070 = alloc_Boolean(1);
// compiled identifier node returning bool3070 (depth = 7)
  gc_frame_newslot(bool3070);
// starting to compile identifier node (depth = 7)
  Object bool3071 = alloc_Boolean(0);
// compiled identifier node returning bool3071 (depth = 7)
  gc_frame_newslot(bool3071);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call3069;
  params[1] = bool3070;
  params[2] = bool3071;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3072 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3067);
// compiled call node returning call3072 (depth = 6)
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3073 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3074 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3073);
// compiled call node returning call3074 (depth = 6)
    gc_frame_newslot(call3074);
    if3047 = call3074;
  } else {
  }
// compiled if node returning if3047 (depth = 5)
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3075 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3076 == NULL) {
    strlit3076 = alloc_String("a prefix operator must be followed by an expression.");
    gc_root(strlit3076);
  }
// compiled string node returning strlit3076 (depth = 6)
  gc_frame_newslot(strlit3076);
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3077 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3078 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3077);
// compiled member node returning call3078 (depth = 6)
  gc_frame_newslot(call3078);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3080 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3081 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3080);
// compiled member node returning call3081 (depth = 7)
  int op_slot_right_3079 = gc_frame_newslot(call3081);
// starting to compile member node (depth = 7)
  int callframe3083 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3084 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3083);
// compiled member node returning call3084 (depth = 7)
  int op_slot_left_3079 = gc_frame_newslot(call3084);
  params[0] = call3081;
  partcv[0] = 1;
  Object sum3085 = callmethod(call3084, "+(1)", 1, partcv, params);
// compiled op node returning sum3085 (depth = 6)
  gc_frame_newslot(sum3085);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3076;
  params[1] = call3078;
  params[2] = sum3085;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3086 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3075);
// compiled call node returning call3086 (depth = 5)
    gc_frame_newslot(call3086);
    if3014 = call3086;
  } else {
  }
// compiled if node returning if3014 (depth = 4)
    gc_frame_newslot(if3014);
    if2941 = if3014;
  }
// compiled if node returning if2941 (depth = 3)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3087 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3088 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3087);
// compiled call node returning call3088 (depth = 3)
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3089 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3090 = callmethodflags(module_parser, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3089);
// compiled call node returning call3090 (depth = 3)
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3091 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call3092 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe3091);
// compiled member node returning call3092 (depth = 4)
  *var_rcvr = call3092;
  if (call3092 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3093 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_rcvr (depth = 5)
  gc_frame_newslot(*var_rcvr);
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array3094 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 6)
  int callframe3095 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_op (depth = 8)
  int op_slot_right_3096 = gc_frame_newslot(*var_op);
// starting to compile string node (depth = 8)
  if (strlit3098 == NULL) {
    strlit3098 = alloc_String("prefix");
    gc_root(strlit3098);
  }
// compiled string node returning strlit3098 (depth = 8)
  int op_slot_left_3096 = gc_frame_newslot(strlit3098);
  params[0] = *var_op;
  partcv[0] = 1;
  Object opresult3099 = callmethod(strlit3098, "++(1)", 1, partcv, params);
// compiled op node returning opresult3099 (depth = 7)
  gc_frame_newslot(opresult3099);
// starting to compile array node (depth = 7)
  Object array3100 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3100 (depth = 7)
  gc_frame_newslot(array3100);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3101 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call3102 = callmethodflags(*var_ast, "requestPart", 1, partcv, params, 0);
  gc_frame_end(callframe3101);
// compiled member node returning call3102 (depth = 7)
  params[0] = opresult3099;
  params[1] = array3100;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3103 = callmethodflags(call3102, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3095);
// compiled call node returning call3103 (depth = 6)
  params[0] = call3103;
  partcv[0] = 1;
  callmethodflags(array3094, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3094 (depth = 5)
  gc_frame_newslot(array3094);
// call case 6: other requests
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3104 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call3105 = callmethodflags(*var_ast, "callNode", 1, partcv, params, 0);
  gc_frame_end(callframe3104);
// compiled member node returning call3105 (depth = 5)
  params[0] = *var_rcvr;
  params[1] = array3094;
  partcv[0] = 2;
  Object call3106 = callmethodflags(call3105, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3093);
// compiled call node returning call3106 (depth = 4)
  *var_call = call3106;
  if (call3106 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3107 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3108 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  gc_frame_newslot(*var_lastLine);
// starting to compile member node (depth = 5)
  int callframe3109 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call3110 = callmethodflags(*var_lastToken, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe3109);
// compiled member node returning call3110 (depth = 5)
  gc_frame_newslot(call3110);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  params[0] = *var_lastLine;
  params[1] = call3110;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3111 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3108);
// compiled call node returning call3111 (depth = 4)
  gc_frame_newslot(call3111);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  params[0] = call3111;
  partcv[0] = 1;
  Object call3112 = callmethodflags(*var_call, "end:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3107);
// compiled call node returning call3112 (depth = 3)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3113 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call3114 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3113);
// compiled call node returning call3114 (depth = 3)
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_minIndentLevel = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if2933 = done;
  } else {
  }
// compiled if node returning if2933 (depth = 2)
  gc_frame_end(frame);
  return if2933;
}
Object meth_parser_3128__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe3129 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3130 == NULL) {
    strlit3130 = alloc_String("identifier");
    gc_root(strlit3130);
  }
// compiled string node returning strlit3130 (depth = 6)
  gc_frame_newslot(strlit3130);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3130;
  partcv[0] = 1;
  Object call3131 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3129);
// compiled call node returning call3131 (depth = 5)
  gc_frame_end(frame);
  return call3131;
}
Object meth_parser_3139__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe3140 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3141 == NULL) {
    strlit3141 = alloc_String("dot");
    gc_root(strlit3141);
  }
// compiled string node returning strlit3141 (depth = 8)
  gc_frame_newslot(strlit3141);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit3141;
  partcv[0] = 1;
  Object call3142 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3140);
// compiled call node returning call3142 (depth = 7)
  gc_frame_end(frame);
  return call3142;
}
Object meth_parser_3145__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_memberIn = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "memberIn");
// definebindings:
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
  Object *var_memberName = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "memberName");
  Object *var_memberNd = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "memberNd");
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3146 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3147 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3146);
// compiled member node returning call3147 (depth = 7)
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3148 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call3149 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe3148);
// compiled member node returning call3149 (depth = 8)
  *var_memberIn = call3149;
  if (call3149 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3152 == NULL) {
    strlit3152 = alloc_String("identifier");
    gc_root(strlit3152);
  }
// compiled string node returning strlit3152 (depth = 9)
  int op_slot_right_3151 = gc_frame_newslot(strlit3152);
// starting to compile member node (depth = 9)
  int callframe3154 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3155 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3154);
// compiled member node returning call3155 (depth = 9)
  int op_slot_left_3151 = gc_frame_newslot(call3155);
  params[0] = strlit3152;
  partcv[0] = 1;
  Object opresult3156 = callmethod(call3155, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3156 (depth = 8)
  Object if3150 = done;
  if (istrue(opresult3156)) {
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array3157 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3157 (depth = 9)
  *var_suggestions = array3157;
  if (array3157 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3158 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3159 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3160 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3159);
// compiled member node returning call3160 (depth = 10)
  partcv[0] = 0;
  Object call3161 = callmethodflags(call3160, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3158);
// compiled member node returning call3161 (depth = 9)
  *var_suggestion = call3161;
  if (call3161 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3162 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3163 == NULL) {
    strlit3163 = alloc_String("""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit3163);
  }
// compiled string node returning strlit3163 (depth = 9)
  gc_frame_newslot(strlit3163);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3163;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3164 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3162);
// compiled call node returning call3164 (depth = 8)
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3165 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3166 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3165);
// compiled call node returning call3166 (depth = 8)
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3167 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3168 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3169 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3168);
// compiled member node returning call3169 (depth = 10)
  partcv[0] = 0;
  Object call3170 = callmethodflags(call3169, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3167);
// compiled member node returning call3170 (depth = 9)
  *var_suggestion = call3170;
  if (call3170 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3172 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3173 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3172);
// compiled call node returning call3173 (depth = 8)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3174 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3175 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3174);
// compiled call node returning call3175 (depth = 8)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3176 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3177 == NULL) {
    strlit3177 = alloc_String("a type name must follow the '.'.");
    gc_root(strlit3177);
  }
// compiled string node returning strlit3177 (depth = 9)
  gc_frame_newslot(strlit3177);
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe3178 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3179 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3178);
// compiled member node returning call3179 (depth = 9)
  gc_frame_newslot(call3179);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3181 = alloc_Float64(1);
// compiled num node returning num3181 (depth = 10)
  int op_slot_right_3180 = gc_frame_newslot(num3181);
// starting to compile member node (depth = 10)
  int callframe3183 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3184 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3183);
// compiled member node returning call3184 (depth = 10)
  int op_slot_left_3180 = gc_frame_newslot(call3184);
  params[0] = num3181;
  partcv[0] = 1;
  Object sum3185 = callmethod(call3184, "+(1)", 1, partcv, params);
// compiled op node returning sum3185 (depth = 9)
  gc_frame_newslot(sum3185);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit3177;
  params[1] = call3179;
  params[2] = sum3185;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3186 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3176);
// compiled call node returning call3186 (depth = 8)
    gc_frame_newslot(call3186);
    if3150 = call3186;
  } else {
  }
// compiled if node returning if3150 (depth = 7)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3187 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3188 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3187);
// compiled member node returning call3188 (depth = 7)
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3189 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call3190 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe3189);
// compiled member node returning call3190 (depth = 8)
  *var_memberName = call3190;
  if (call3190 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3191 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe3192 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_memberName (depth = 10)
  partcv[0] = 0;
  Object call3193 = callmethodflags(*var_memberName, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3192);
// compiled member node returning call3193 (depth = 9)
  gc_frame_newslot(call3193);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberIn (depth = 9)
  gc_frame_newslot(*var_memberIn);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3194 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call3195 = callmethodflags(*var_ast, "memberNode", 1, partcv, params, 0);
  gc_frame_end(callframe3194);
// compiled member node returning call3195 (depth = 9)
  params[0] = call3193;
  params[1] = *var_memberIn;
  partcv[0] = 2;
  Object call3196 = callmethodflags(call3195, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3191);
// compiled call node returning call3196 (depth = 8)
  *var_memberNd = call3196;
  if (call3196 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3197 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe3198 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberName (depth = 9)
  partcv[0] = 0;
  Object call3199 = callmethodflags(*var_memberName, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3198);
// compiled member node returning call3199 (depth = 8)
  gc_frame_newslot(call3199);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  params[0] = call3199;
  partcv[0] = 1;
  Object call3200 = callmethodflags(*var_memberNd, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3197);
// compiled call node returning call3200 (depth = 7)
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3201 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe3202 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberName (depth = 9)
  partcv[0] = 0;
  Object call3203 = callmethodflags(*var_memberName, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3202);
// compiled member node returning call3203 (depth = 8)
  gc_frame_newslot(call3203);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  params[0] = call3203;
  partcv[0] = 1;
  Object call3204 = callmethodflags(*var_memberNd, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3201);
// compiled call node returning call3204 (depth = 7)
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3205 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  gc_frame_newslot(*var_memberNd);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_memberNd;
  partcv[0] = 1;
  Object call3206 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3205);
// compiled call node returning call3206 (depth = 7)
  gc_frame_end(frame);
  return call3206;
}
Object meth_parser_3134__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_gens = getfromclosure(closure, 5);
  Object *var_startToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// definebindings:
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3135 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3136 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3135);
// compiled member node returning call3136 (depth = 5)
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3137 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3138 = alloc_Block(NULL, NULL, "parser", 1114);
  gc_frame_newslot(block3138);
// method "_apply"
  block_savedest(block3138);
  Object closure3139 = createclosure(1, "_apply");
  setclosureframe(closure3139, stackframe);
  addtoclosure(closure3139, selfslot);
  struct UserObject *uo3139 = (struct UserObject*)block3138;
  uo3139->data[0] = (Object)closure3139;
  Method *meth_meth_parser_3139__apply = addmethod2pos(block3138, "_apply", &meth_parser_3139__apply, 0);
  int argcv_meth_parser_3139__apply[] = {0};
  meth_meth_parser_3139__apply->type = alloc_MethodType(1, argcv_meth_parser_3139__apply);
  meth_meth_parser_3139__apply->definitionModule = modulename;
  meth_meth_parser_3139__apply->definitionLine = 183;
// compiled block node returning block3138 (depth = 6)
  gc_frame_newslot(block3138);
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block3144 = alloc_Block(NULL, NULL, "parser", 1114);
  gc_frame_newslot(block3144);
// method "_apply"
  block_savedest(block3144);
  Object closure3145 = createclosure(6, "_apply");
  setclosureframe(closure3145, stackframe);
  addtoclosure(closure3145, var_values);
  addtoclosure(closure3145, var_sym);
  addtoclosure(closure3145, var_errormessages);
  addtoclosure(closure3145, var_lastToken);
  addtoclosure(closure3145, var_ast);
  addtoclosure(closure3145, selfslot);
  struct UserObject *uo3145 = (struct UserObject*)block3144;
  uo3145->data[0] = (Object)closure3145;
  Method *meth_meth_parser_3145__apply = addmethod2pos(block3144, "_apply", &meth_parser_3145__apply, 0);
  int argcv_meth_parser_3145__apply[] = {0};
  meth_meth_parser_3145__apply->type = alloc_MethodType(1, argcv_meth_parser_3145__apply);
  meth_meth_parser_3145__apply->definitionModule = modulename;
  meth_meth_parser_3145__apply->definitionLine = 183;
// compiled block node returning block3144 (depth = 6)
  gc_frame_newslot(block3144);
// call case 5: prelude request
  params[0] = block3138;
  params[1] = block3144;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3208 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3137);
// compiled call node returning call3208 (depth = 5)
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3209 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3210 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3209);
// compiled member node returning call3210 (depth = 5)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3211 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3212 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call3213 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe3212);
// compiled member node returning call3213 (depth = 6)
  gc_frame_newslot(call3213);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_gens (depth = 6)
  params[0] = call3213;
  partcv[0] = 1;
  Object call3214 = callmethodflags(*var_gens, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3211);
// compiled call node returning call3214 (depth = 5)
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3216 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3217 == NULL) {
    strlit3217 = alloc_String("comma");
    gc_root(strlit3217);
  }
// compiled string node returning strlit3217 (depth = 7)
  gc_frame_newslot(strlit3217);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit3217;
  partcv[0] = 1;
  Object call3218 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3216);
// compiled call node returning call3218 (depth = 6)
  Object if3215 = done;
  if (istrue(call3218)) {
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3219 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3220 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3219);
// compiled member node returning call3220 (depth = 6)
    gc_frame_newslot(call3220);
    if3215 = call3220;
  } else {
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3223 == NULL) {
    strlit3223 = alloc_String("rgeneric");
    gc_root(strlit3223);
  }
// compiled string node returning strlit3223 (depth = 8)
  int op_slot_right_3222 = gc_frame_newslot(strlit3223);
// starting to compile member node (depth = 8)
  int callframe3225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3226 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3225);
// compiled member node returning call3226 (depth = 8)
  int op_slot_left_3222 = gc_frame_newslot(call3226);
  params[0] = strlit3223;
  partcv[0] = 1;
  Object opresult3227 = callmethod(call3226, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3227 (depth = 7)
  Object if3221 = done;
  if (istrue(opresult3227)) {
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3228 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3229 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3230 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3229);
// compiled member node returning call3230 (depth = 9)
  partcv[0] = 0;
  Object call3231 = callmethodflags(call3230, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3228);
// compiled member node returning call3231 (depth = 8)
  *var_suggestion = call3231;
  if (call3231 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3232 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3233 == NULL) {
    strlit3233 = alloc_String(">");
    gc_root(strlit3233);
  }
// compiled string node returning strlit3233 (depth = 8)
  gc_frame_newslot(strlit3233);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3233;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3234 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3232);
// compiled call node returning call3234 (depth = 7)
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3235 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3236 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3237 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3236);
// compiled member node returning call3237 (depth = 9)
  partcv[0] = 0;
  Object call3238 = callmethodflags(call3237, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3235);
// compiled member node returning call3238 (depth = 8)
  *var_suggestion2 = call3238;
  if (call3238 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3239 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3240 == NULL) {
    strlit3240 = alloc_String(" ");
    gc_root(strlit3240);
  }
// compiled string node returning strlit3240 (depth = 8)
  gc_frame_newslot(strlit3240);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startToken (depth = 8)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion2 (depth = 8)
  params[0] = strlit3240;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3241 = callmethodflags(*var_suggestion2, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3239);
// compiled call node returning call3241 (depth = 7)
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array3242 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array3242, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion2 (depth = 9)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array3242, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3242 (depth = 8)
  *var_suggestions = array3242;
  if (array3242 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3243 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3244 == NULL) {
    strlit3244 = alloc_String("a type containing a '""\xe2""""\x9f""""\xa6""' must end with a '""\xe2""""\x9f""""\xa7""'.");
    gc_root(strlit3244);
  }
// compiled string node returning strlit3244 (depth = 8)
  gc_frame_newslot(strlit3244);
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe3245 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3246 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3245);
// compiled member node returning call3246 (depth = 8)
  gc_frame_newslot(call3246);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3248 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3249 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3248);
// compiled member node returning call3249 (depth = 9)
  int op_slot_right_3247 = gc_frame_newslot(call3249);
// starting to compile member node (depth = 9)
  int callframe3251 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3252 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3251);
// compiled member node returning call3252 (depth = 9)
  int op_slot_left_3247 = gc_frame_newslot(call3252);
  params[0] = call3249;
  partcv[0] = 1;
  Object sum3253 = callmethod(call3252, "+(1)", 1, partcv, params);
// compiled op node returning sum3253 (depth = 8)
  gc_frame_newslot(sum3253);
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3244;
  params[1] = call3246;
  params[2] = sum3253;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3254 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3243);
// compiled call node returning call3254 (depth = 7)
    gc_frame_newslot(call3254);
    if3221 = call3254;
  } else {
  }
// compiled if node returning if3221 (depth = 6)
    gc_frame_newslot(if3221);
    if3215 = if3221;
  }
// compiled if node returning if3215 (depth = 5)
  gc_frame_end(frame);
  return if3215;
}
Object meth_parser_3116_generic(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "generic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
  Object *var_gens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "gens");
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
// definebindings:
// definebindings:
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3118 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3119 == NULL) {
    strlit3119 = alloc_String("lgeneric");
    gc_root(strlit3119);
  }
// compiled string node returning strlit3119 (depth = 4)
  gc_frame_newslot(strlit3119);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit3119;
  partcv[0] = 1;
  Object call3120 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3118);
// compiled call node returning call3120 (depth = 3)
  Object if3117 = done;
  if (istrue(call3120)) {
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3121 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call3122 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe3121);
// compiled member node returning call3122 (depth = 4)
  *var_id = call3122;
  if (call3122 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array3123 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3123 (depth = 4)
  *var_gens = array3123;
  if (array3123 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3124 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3125 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3124);
// compiled member node returning call3125 (depth = 3)
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3126 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3127 = alloc_Block(NULL, NULL, "parser", 1112);
  gc_frame_newslot(block3127);
// method "_apply"
  block_savedest(block3127);
  Object closure3128 = createclosure(1, "_apply");
  setclosureframe(closure3128, stackframe);
  addtoclosure(closure3128, selfslot);
  struct UserObject *uo3128 = (struct UserObject*)block3127;
  uo3128->data[0] = (Object)closure3128;
  Method *meth_meth_parser_3128__apply = addmethod2pos(block3127, "_apply", &meth_parser_3128__apply, 0);
  int argcv_meth_parser_3128__apply[] = {0};
  meth_meth_parser_3128__apply->type = alloc_MethodType(1, argcv_meth_parser_3128__apply);
  meth_meth_parser_3128__apply->definitionModule = modulename;
  meth_meth_parser_3128__apply->definitionLine = 183;
// compiled block node returning block3127 (depth = 4)
  gc_frame_newslot(block3127);
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block3133 = alloc_Block(NULL, NULL, "parser", 1112);
  gc_frame_newslot(block3133);
// method "_apply"
  block_savedest(block3133);
  Object closure3134 = createclosure(8, "_apply");
  setclosureframe(closure3134, stackframe);
  addtoclosure(closure3134, var_values);
  addtoclosure(closure3134, var_sym);
  addtoclosure(closure3134, var_errormessages);
  addtoclosure(closure3134, var_lastToken);
  addtoclosure(closure3134, var_ast);
  addtoclosure(closure3134, var_gens);
  addtoclosure(closure3134, var_startToken);
  addtoclosure(closure3134, selfslot);
  struct UserObject *uo3134 = (struct UserObject*)block3133;
  uo3134->data[0] = (Object)closure3134;
  Method *meth_meth_parser_3134__apply = addmethod2pos(block3133, "_apply", &meth_parser_3134__apply, 0);
  int argcv_meth_parser_3134__apply[] = {0};
  meth_meth_parser_3134__apply->type = alloc_MethodType(1, argcv_meth_parser_3134__apply);
  meth_meth_parser_3134__apply->definitionModule = modulename;
  meth_meth_parser_3134__apply->definitionLine = 183;
// compiled block node returning block3133 (depth = 4)
  gc_frame_newslot(block3133);
// call case 5: prelude request
  params[0] = block3127;
  params[1] = block3133;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3256 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3126);
// compiled call node returning call3256 (depth = 3)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3259 == NULL) {
    strlit3259 = alloc_String("rgeneric");
    gc_root(strlit3259);
  }
// compiled string node returning strlit3259 (depth = 5)
  int op_slot_right_3258 = gc_frame_newslot(strlit3259);
// starting to compile member node (depth = 5)
  int callframe3261 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3262 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3261);
// compiled member node returning call3262 (depth = 5)
  int op_slot_left_3258 = gc_frame_newslot(call3262);
  params[0] = strlit3259;
  partcv[0] = 1;
  Object opresult3263 = callmethod(call3262, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3263 (depth = 4)
  Object if3257 = done;
  if (istrue(opresult3263)) {
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3264 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3265 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call3266 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3265);
// compiled member node returning call3266 (depth = 6)
  partcv[0] = 0;
  Object call3267 = callmethodflags(call3266, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3264);
// compiled member node returning call3267 (depth = 5)
  *var_suggestion = call3267;
  if (call3267 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3268 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3269 == NULL) {
    strlit3269 = alloc_String(">");
    gc_root(strlit3269);
  }
// compiled string node returning strlit3269 (depth = 5)
  gc_frame_newslot(strlit3269);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3269;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3270 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3268);
// compiled call node returning call3270 (depth = 4)
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3271 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3272 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call3273 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3272);
// compiled member node returning call3273 (depth = 6)
  partcv[0] = 0;
  Object call3274 = callmethodflags(call3273, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3271);
// compiled member node returning call3274 (depth = 5)
  *var_suggestion2 = call3274;
  if (call3274 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3275 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3276 == NULL) {
    strlit3276 = alloc_String(" ");
    gc_root(strlit3276);
  }
// compiled string node returning strlit3276 (depth = 5)
  gc_frame_newslot(strlit3276);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = strlit3276;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3277 = callmethodflags(*var_suggestion2, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3275);
// compiled call node returning call3277 (depth = 4)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array3278 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array3278, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion2 (depth = 6)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array3278, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3278 (depth = 5)
  *var_suggestions = array3278;
  if (array3278 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3279 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3280 == NULL) {
    strlit3280 = alloc_String("a type containing a '""\xe2""""\x9f""""\xa6""' must end with a '""\xe2""""\x9f""""\xa7""'.");
    gc_root(strlit3280);
  }
// compiled string node returning strlit3280 (depth = 5)
  gc_frame_newslot(strlit3280);
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3281 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call3282 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3281);
// compiled member node returning call3282 (depth = 5)
  gc_frame_newslot(call3282);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3284 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3285 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3284);
// compiled member node returning call3285 (depth = 6)
  int op_slot_right_3283 = gc_frame_newslot(call3285);
// starting to compile member node (depth = 6)
  int callframe3287 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3288 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3287);
// compiled member node returning call3288 (depth = 6)
  int op_slot_left_3283 = gc_frame_newslot(call3288);
  params[0] = call3285;
  partcv[0] = 1;
  Object sum3289 = callmethod(call3288, "+(1)", 1, partcv, params);
// compiled op node returning sum3289 (depth = 5)
  gc_frame_newslot(sum3289);
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3280;
  params[1] = call3282;
  params[2] = sum3289;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3290 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3279);
// compiled call node returning call3290 (depth = 4)
    gc_frame_newslot(call3290);
    if3257 = call3290;
  } else {
  }
// compiled if node returning if3257 (depth = 3)
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3291 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3292 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3291);
// compiled member node returning call3292 (depth = 3)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3293 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3294 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_gens (depth = 5)
  gc_frame_newslot(*var_gens);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3295 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call3296 = callmethodflags(*var_ast, "genericNode", 1, partcv, params, 0);
  gc_frame_end(callframe3295);
// compiled member node returning call3296 (depth = 5)
  params[0] = *var_id;
  params[1] = *var_gens;
  partcv[0] = 2;
  Object call3297 = callmethodflags(call3296, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3294);
// compiled call node returning call3297 (depth = 4)
  gc_frame_newslot(call3297);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call3297;
  partcv[0] = 1;
  Object call3298 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3293);
// compiled call node returning call3298 (depth = 3)
    gc_frame_newslot(call3298);
    if3117 = call3298;
  } else {
  }
// compiled if node returning if3117 (depth = 2)
  gc_frame_end(frame);
  return if3117;
}
Object meth_parser_3304__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3306 == NULL) {
    strlit3306 = alloc_String("try");
    gc_root(strlit3306);
  }
// compiled string node returning strlit3306 (depth = 7)
  int op_slot_right_3305 = gc_frame_newslot(strlit3306);
// starting to compile member node (depth = 7)
  int callframe3308 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3309 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3308);
// compiled member node returning call3309 (depth = 7)
  int op_slot_left_3305 = gc_frame_newslot(call3309);
  params[0] = strlit3306;
  partcv[0] = 1;
  Object opresult3310 = callmethod(call3309, "==(1)", 1, partcv, params);
// compiled op node returning opresult3310 (depth = 6)
  gc_frame_end(frame);
  return opresult3310;
}
Object meth_parser_3339__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_tryTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3343 == NULL) {
    strlit3343 = alloc_String("catch");
    gc_root(strlit3343);
  }
// compiled string node returning strlit3343 (depth = 10)
  int op_slot_right_3342 = gc_frame_newslot(strlit3343);
// starting to compile member node (depth = 10)
  int callframe3345 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call3346 = callmethodflags(*var_t, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3345);
// compiled member node returning call3346 (depth = 10)
  int op_slot_left_3342 = gc_frame_newslot(call3346);
  params[0] = strlit3343;
  partcv[0] = 1;
  Object opresult3347 = callmethod(call3346, "==(1)", 1, partcv, params);
// compiled op node returning opresult3347 (depth = 9)
  int op_slot_right_3341 = gc_frame_newslot(opresult3347);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3350 == NULL) {
    strlit3350 = alloc_String("identifier");
    gc_root(strlit3350);
  }
// compiled string node returning strlit3350 (depth = 10)
  int op_slot_right_3349 = gc_frame_newslot(strlit3350);
// starting to compile member node (depth = 10)
  int callframe3352 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call3353 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3352);
// compiled member node returning call3353 (depth = 10)
  int op_slot_left_3349 = gc_frame_newslot(call3353);
  params[0] = strlit3350;
  partcv[0] = 1;
  Object opresult3354 = callmethod(call3353, "==(1)", 1, partcv, params);
// compiled op node returning opresult3354 (depth = 9)
  int op_slot_left_3341 = gc_frame_newslot(opresult3354);
  params[0] = opresult3347;
  partcv[0] = 1;
  Object opresult3355 = callmethod(opresult3354, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3355 (depth = 8)
  int op_slot_right_3340 = gc_frame_newslot(opresult3355);
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe3360 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tryTok (depth = 12)
  partcv[0] = 0;
  Object call3361 = callmethodflags(*var_tryTok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3360);
// compiled member node returning call3361 (depth = 11)
  int op_slot_right_3359 = gc_frame_newslot(call3361);
// starting to compile member node (depth = 11)
  int callframe3363 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3364 = callmethodflags(*var_t, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3363);
// compiled member node returning call3364 (depth = 11)
  int op_slot_left_3359 = gc_frame_newslot(call3364);
  params[0] = call3361;
  partcv[0] = 1;
  Object opresult3365 = callmethod(call3364, "==(1)", 1, partcv, params);
// compiled op node returning opresult3365 (depth = 10)
  int op_slot_right_3358 = gc_frame_newslot(opresult3365);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3368 == NULL) {
    strlit3368 = alloc_String("rparen");
    gc_root(strlit3368);
  }
// compiled string node returning strlit3368 (depth = 11)
  int op_slot_right_3367 = gc_frame_newslot(strlit3368);
// starting to compile member node (depth = 11)
  int callframe3370 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3371 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3370);
// compiled member node returning call3371 (depth = 11)
  int op_slot_left_3367 = gc_frame_newslot(call3371);
  params[0] = strlit3368;
  partcv[0] = 1;
  Object opresult3372 = callmethod(call3371, "==(1)", 1, partcv, params);
// compiled op node returning opresult3372 (depth = 10)
  int op_slot_left_3358 = gc_frame_newslot(opresult3372);
  params[0] = opresult3365;
  partcv[0] = 1;
  Object opresult3373 = callmethod(opresult3372, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3373 (depth = 9)
  int op_slot_right_3357 = gc_frame_newslot(opresult3373);
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3376 == NULL) {
    strlit3376 = alloc_String("rbrace");
    gc_root(strlit3376);
  }
// compiled string node returning strlit3376 (depth = 10)
  int op_slot_right_3375 = gc_frame_newslot(strlit3376);
// starting to compile member node (depth = 10)
  int callframe3378 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call3379 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3378);
// compiled member node returning call3379 (depth = 10)
  int op_slot_left_3375 = gc_frame_newslot(call3379);
  params[0] = strlit3376;
  partcv[0] = 1;
  Object opresult3380 = callmethod(call3379, "==(1)", 1, partcv, params);
// compiled op node returning opresult3380 (depth = 9)
  int op_slot_left_3357 = gc_frame_newslot(opresult3380);
  params[0] = opresult3373;
  partcv[0] = 1;
  Object opresult3381 = callmethod(opresult3380, "||(1)", 1, partcv, params);
// compiled op node returning opresult3381 (depth = 8)
  int op_slot_left_3340 = gc_frame_newslot(opresult3381);
  params[0] = opresult3355;
  partcv[0] = 1;
  Object opresult3382 = callmethod(opresult3381, "||(1)", 1, partcv, params);
// compiled op node returning opresult3382 (depth = 7)
  gc_frame_end(frame);
  return opresult3382;
}
Object meth_parser_3455__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe3456 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blocksOK (depth = 7)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3457 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3456);
// compiled call node returning call3457 (depth = 6)
  gc_frame_end(frame);
  return call3457;
}
Object meth_parser_3529__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3532 == NULL) {
    strlit3532 = alloc_String("catch");
    gc_root(strlit3532);
  }
// compiled string node returning strlit3532 (depth = 6)
  int op_slot_right_3531 = gc_frame_newslot(strlit3532);
// starting to compile member node (depth = 6)
  int callframe3534 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3535 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3534);
// compiled member node returning call3535 (depth = 6)
  int op_slot_left_3531 = gc_frame_newslot(call3535);
  params[0] = strlit3532;
  partcv[0] = 1;
  Object opresult3536 = callmethod(call3535, "==(1)", 1, partcv, params);
// compiled op node returning opresult3536 (depth = 5)
  int op_slot_right_3530 = gc_frame_newslot(opresult3536);
// starting to compile call node (depth = 5)
  int callframe3538 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3539 == NULL) {
    strlit3539 = alloc_String("identifier");
    gc_root(strlit3539);
  }
// compiled string node returning strlit3539 (depth = 6)
  gc_frame_newslot(strlit3539);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3539;
  partcv[0] = 1;
  Object call3540 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3538);
// compiled call node returning call3540 (depth = 5)
  int op_slot_left_3530 = gc_frame_newslot(call3540);
  params[0] = opresult3536;
  partcv[0] = 1;
  Object opresult3541 = callmethod(call3540, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3541 (depth = 4)
  gc_frame_end(frame);
  return opresult3541;
}
Object meth_parser_3562__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 9)
  int callframe3563 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3564 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3563);
// compiled call node returning call3564 (depth = 9)
  gc_frame_end(frame);
  return call3564;
}
Object meth_parser_3544__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3545 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3546 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3545);
// compiled member node returning call3546 (depth = 4)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3548 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3549 == NULL) {
    strlit3549 = alloc_String("lbrace");
    gc_root(strlit3549);
  }
// compiled string node returning strlit3549 (depth = 6)
  gc_frame_newslot(strlit3549);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3549;
  partcv[0] = 1;
  Object call3550 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3548);
// compiled call node returning call3550 (depth = 5)
  Object if3547 = done;
  if (istrue(call3550)) {
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3552 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3551);
// compiled member node returning call3552 (depth = 5)
    gc_frame_newslot(call3552);
    if3547 = call3552;
  } else {
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3554 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3555 == NULL) {
    strlit3555 = alloc_String("lparen");
    gc_root(strlit3555);
  }
// compiled string node returning strlit3555 (depth = 7)
  gc_frame_newslot(strlit3555);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit3555;
  partcv[0] = 1;
  Object call3556 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3554);
// compiled call node returning call3556 (depth = 6)
  Object if3553 = done;
  if (istrue(call3556)) {
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3557 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3558 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3557);
// compiled member node returning call3558 (depth = 6)
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3560 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3561 = alloc_Block(NULL, NULL, "parser", 1233);
  gc_frame_newslot(block3561);
// method "_apply"
  block_savedest(block3561);
  Object closure3562 = createclosure(2, "_apply");
  setclosureframe(closure3562, stackframe);
  addtoclosure(closure3562, var_blocksOK);
  addtoclosure(closure3562, selfslot);
  struct UserObject *uo3562 = (struct UserObject*)block3561;
  uo3562->data[0] = (Object)closure3562;
  Method *meth_meth_parser_3562__apply = addmethod2pos(block3561, "_apply", &meth_parser_3562__apply, 0);
  int argcv_meth_parser_3562__apply[] = {0};
  meth_meth_parser_3562__apply->type = alloc_MethodType(1, argcv_meth_parser_3562__apply);
  meth_meth_parser_3562__apply->definitionModule = modulename;
  meth_meth_parser_3562__apply->definitionLine = 183;
// compiled block node returning block3561 (depth = 8)
  gc_frame_newslot(block3561);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block3561;
  partcv[0] = 1;
  Object call3566 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3560);
// compiled call node returning call3566 (depth = 7)
  Object if3559 = done;
  if (istrue(call3566)) {
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3567 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3568 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3569 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3568);
// compiled member node returning call3569 (depth = 9)
  partcv[0] = 0;
  Object call3570 = callmethodflags(call3569, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3567);
// compiled member node returning call3570 (depth = 8)
  *var_suggestion = call3570;
  if (call3570 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3571 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array3572 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit3573 == NULL) {
    strlit3573 = alloc_String("rparen");
    gc_root(strlit3573);
  }
// compiled string node returning strlit3573 (depth = 10)
  params[0] = strlit3573;
  partcv[0] = 1;
  callmethodflags(array3572, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3572 (depth = 9)
  gc_frame_newslot(array3572);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = array3572;
  partcv[0] = 1;
  Object call3574 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3571);
// compiled call node returning call3574 (depth = 8)
  *var_nextTok = call3574;
  if (call3574 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3576 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3576 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3578 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3578 (depth = 8)
  Object if3575 = done;
  if (istrue(opresult3578)) {
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3579 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3580 == NULL) {
    strlit3580 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3580);
  }
// compiled string node returning strlit3580 (depth = 9)
  gc_frame_newslot(strlit3580);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3580;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3581 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3579);
// compiled call node returning call3581 (depth = 8)
    gc_frame_newslot(call3581);
    if3575 = call3581;
  } else {
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3582 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe3583 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call3584 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe3583);
// compiled member node returning call3584 (depth = 9)
  gc_frame_newslot(call3584);
// starting to compile identifier node (depth = 9)
  Object bool3585 = alloc_Boolean(1);
// compiled identifier node returning bool3585 (depth = 9)
  gc_frame_newslot(bool3585);
// starting to compile identifier node (depth = 9)
  Object bool3586 = alloc_Boolean(0);
// compiled identifier node returning bool3586 (depth = 9)
  gc_frame_newslot(bool3586);
// starting to compile string node (depth = 9)
  if (strlit3587 == NULL) {
    strlit3587 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3587);
  }
// compiled string node returning strlit3587 (depth = 9)
  gc_frame_newslot(strlit3587);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call3584;
  params[2] = bool3585;
  params[3] = bool3586;
  params[4] = strlit3587;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3588 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3582);
// compiled call node returning call3588 (depth = 8)
    gc_frame_newslot(call3588);
    if3575 = call3588;
  }
// compiled if node returning if3575 (depth = 7)
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3589 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3590 == NULL) {
    strlit3590 = alloc_String("a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3590);
  }
// compiled string node returning strlit3590 (depth = 8)
  gc_frame_newslot(strlit3590);
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe3591 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3592 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3591);
// compiled member node returning call3592 (depth = 8)
  gc_frame_newslot(call3592);
// starting to compile member node (depth = 8)
  int callframe3593 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3594 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3593);
// compiled member node returning call3594 (depth = 8)
  gc_frame_newslot(call3594);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3590;
  params[1] = call3592;
  params[2] = call3594;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3595 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3589);
// compiled call node returning call3595 (depth = 7)
    gc_frame_newslot(call3595);
    if3559 = call3595;
  } else {
  }
// compiled if node returning if3559 (depth = 6)
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3598 == NULL) {
    strlit3598 = alloc_String("rparen");
    gc_root(strlit3598);
  }
// compiled string node returning strlit3598 (depth = 8)
  int op_slot_right_3597 = gc_frame_newslot(strlit3598);
// starting to compile member node (depth = 8)
  int callframe3600 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3601 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3600);
// compiled member node returning call3601 (depth = 8)
  int op_slot_left_3597 = gc_frame_newslot(call3601);
  params[0] = strlit3598;
  partcv[0] = 1;
  Object opresult3602 = callmethod(call3601, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3602 (depth = 7)
  Object if3596 = done;
  if (istrue(opresult3602)) {
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3603 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3604 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3603);
// compiled member node returning call3604 (depth = 7)
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3605 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3606 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3607 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3606);
// compiled member node returning call3607 (depth = 9)
  partcv[0] = 0;
  Object call3608 = callmethodflags(call3607, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3605);
// compiled member node returning call3608 (depth = 8)
  *var_suggestion = call3608;
  if (call3608 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3609 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3610 == NULL) {
    strlit3610 = alloc_String(")");
    gc_root(strlit3610);
  }
// compiled string node returning strlit3610 (depth = 8)
  gc_frame_newslot(strlit3610);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3610;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3611 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3609);
// compiled call node returning call3611 (depth = 7)
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3612 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3613 == NULL) {
    strlit3613 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3613);
  }
// compiled string node returning strlit3613 (depth = 8)
  gc_frame_newslot(strlit3613);
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe3614 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3615 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3614);
// compiled member node returning call3615 (depth = 8)
  gc_frame_newslot(call3615);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3617 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3618 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3617);
// compiled member node returning call3618 (depth = 9)
  int op_slot_right_3616 = gc_frame_newslot(call3618);
// starting to compile member node (depth = 9)
  int callframe3620 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3621 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3620);
// compiled member node returning call3621 (depth = 9)
  int op_slot_left_3616 = gc_frame_newslot(call3621);
  params[0] = call3618;
  partcv[0] = 1;
  Object sum3622 = callmethod(call3621, "+(1)", 1, partcv, params);
// compiled op node returning sum3622 (depth = 8)
  gc_frame_newslot(sum3622);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3613;
  params[1] = call3615;
  params[2] = sum3622;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3623 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3612);
// compiled call node returning call3623 (depth = 7)
    gc_frame_newslot(call3623);
    if3596 = call3623;
  } else {
  }
// compiled if node returning if3596 (depth = 6)
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3624 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3625 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3624);
// compiled member node returning call3625 (depth = 6)
    gc_frame_newslot(call3625);
    if3553 = call3625;
  } else {
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array3626 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3626 (depth = 7)
  *var_suggestions = array3626;
  if (array3626 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3627 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3628 = callmethodflags(module_parser, "findNextTokenIndentedAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3627);
// compiled call node returning call3628 (depth = 7)
  *var_nextTok = call3628;
  if (call3628 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3629 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3630 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3631 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3630);
// compiled member node returning call3631 (depth = 8)
  partcv[0] = 0;
  Object call3632 = callmethodflags(call3631, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3629);
// compiled member node returning call3632 (depth = 7)
  *var_suggestion = call3632;
  if (call3632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_3634 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool3636 = alloc_Boolean(0);
// compiled identifier node returning bool3636 (depth = 8)
  int op_slot_left_3634 = gc_frame_newslot(bool3636);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3637 = callmethod(bool3636, "==(1)", 1, partcv, params);
// compiled op node returning opresult3637 (depth = 7)
  Object if3633 = done;
  if (istrue(opresult3637)) {
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3638 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3639 == NULL) {
    strlit3639 = alloc_String(" }");
    gc_root(strlit3639);
  }
// compiled string node returning strlit3639 (depth = 8)
  gc_frame_newslot(strlit3639);
// starting to compile member node (depth = 8)
  int callframe3640 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call3641 = callmethodflags(*var_tokens, "last", 1, partcv, params, 0);
  gc_frame_end(callframe3640);
// compiled member node returning call3641 (depth = 8)
  gc_frame_newslot(call3641);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3639;
  params[1] = call3641;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3642 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3638);
// compiled call node returning call3642 (depth = 7)
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3643 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3644 == NULL) {
    strlit3644 = alloc_String(" {");
    gc_root(strlit3644);
  }
// compiled string node returning strlit3644 (depth = 8)
  gc_frame_newslot(strlit3644);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3644;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3645 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3643);
// compiled call node returning call3645 (depth = 7)
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3646 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3647 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3646);
// compiled call node returning call3647 (depth = 7)
    gc_frame_newslot(call3647);
    if3633 = call3647;
  } else {
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3649 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3649 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3651 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3651 (depth = 8)
  Object if3648 = done;
  if (istrue(opresult3651)) {
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3652 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3653 == NULL) {
    strlit3653 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3653);
  }
// compiled string node returning strlit3653 (depth = 9)
  gc_frame_newslot(strlit3653);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3653;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3654 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3652);
// compiled call node returning call3654 (depth = 8)
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3655 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3656 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3655);
// compiled call node returning call3656 (depth = 8)
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3657 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3658 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3659 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3658);
// compiled member node returning call3659 (depth = 10)
  partcv[0] = 0;
  Object call3660 = callmethodflags(call3659, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3657);
// compiled member node returning call3660 (depth = 9)
  *var_suggestion = call3660;
  if (call3660 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3662 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3663 == NULL) {
    strlit3663 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit3663);
  }
// compiled string node returning strlit3663 (depth = 9)
  gc_frame_newslot(strlit3663);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3663;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3664 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3662);
// compiled call node returning call3664 (depth = 8)
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3665 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3666 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3665);
// compiled call node returning call3666 (depth = 8)
    gc_frame_newslot(call3666);
    if3648 = call3666;
  } else {
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3667 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3668 == NULL) {
    strlit3668 = alloc_String(" }");
    gc_root(strlit3668);
  }
// compiled string node returning strlit3668 (depth = 9)
  gc_frame_newslot(strlit3668);
// starting to compile member node (depth = 9)
  int callframe3669 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call3670 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe3669);
// compiled member node returning call3670 (depth = 9)
  gc_frame_newslot(call3670);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3668;
  params[1] = call3670;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3671 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3667);
// compiled call node returning call3671 (depth = 8)
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3672 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3673 == NULL) {
    strlit3673 = alloc_String(" {");
    gc_root(strlit3673);
  }
// compiled string node returning strlit3673 (depth = 9)
  gc_frame_newslot(strlit3673);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3673;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3674 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3672);
// compiled call node returning call3674 (depth = 8)
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3675 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3676 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3675);
// compiled call node returning call3676 (depth = 8)
    gc_frame_newslot(call3676);
    if3648 = call3676;
  }
// compiled if node returning if3648 (depth = 7)
    gc_frame_newslot(if3648);
    if3633 = if3648;
  }
// compiled if node returning if3633 (depth = 6)
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3677 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3679 == NULL) {
    strlit3679 = alloc_String("either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3679);
  }
// compiled string node returning strlit3679 (depth = 8)
  int op_slot_right_3678 = gc_frame_newslot(strlit3679);
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3681 == NULL) {
    strlit3681 = alloc_String("a 'try(_)catch(_)""\xe2""""\x80""""\xa6""' statement must have ");
    gc_root(strlit3681);
  }
// compiled string node returning strlit3681 (depth = 8)
  int op_slot_left_3678 = gc_frame_newslot(strlit3681);
  params[0] = strlit3679;
  partcv[0] = 1;
  Object opresult3682 = callmethod(strlit3681, "++(1)", 1, partcv, params);
// compiled op node returning opresult3682 (depth = 7)
  gc_frame_newslot(opresult3682);
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3683 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3684 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3683);
// compiled member node returning call3684 (depth = 7)
  gc_frame_newslot(call3684);
// starting to compile member node (depth = 7)
  int callframe3685 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3686 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3685);
// compiled member node returning call3686 (depth = 7)
  gc_frame_newslot(call3686);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult3682;
  params[1] = call3684;
  params[2] = call3686;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3687 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3677);
// compiled call node returning call3687 (depth = 6)
    gc_frame_newslot(call3687);
    if3553 = call3687;
  }
// compiled if node returning if3553 (depth = 5)
    gc_frame_newslot(if3553);
    if3547 = if3553;
  }
// compiled if node returning if3547 (depth = 4)
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3688 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3689 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call3690 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe3689);
// compiled member node returning call3690 (depth = 5)
  gc_frame_newslot(call3690);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call3690;
  partcv[0] = 1;
  Object call3691 = callmethodflags(*var_cases, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3688);
// compiled call node returning call3691 (depth = 4)
  gc_frame_end(frame);
  return call3691;
}
Object meth_parser_3765__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 8)
  int callframe3766 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3767 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3766);
// compiled call node returning call3767 (depth = 8)
  gc_frame_end(frame);
  return call3767;
}
Object meth_parser_3299_trycatch(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trycatch");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_tokens = getfromclosure(closure, 7);
  Object *var_util = getfromclosure(closure, 8);
  Object *var_ast = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_tryTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tryTok");
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3301 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block3303 = alloc_Block(NULL, NULL, "parser", 1167);
  gc_frame_newslot(block3303);
// method "_apply"
  block_savedest(block3303);
  Object closure3304 = createclosure(2, "_apply");
  setclosureframe(closure3304, stackframe);
  addtoclosure(closure3304, var_sym);
  addtoclosure(closure3304, selfslot);
  struct UserObject *uo3304 = (struct UserObject*)block3303;
  uo3304->data[0] = (Object)closure3304;
  Method *meth_meth_parser_3304__apply = addmethod2pos(block3303, "_apply", &meth_parser_3304__apply, 0);
  int argcv_meth_parser_3304__apply[] = {0};
  meth_meth_parser_3304__apply->type = alloc_MethodType(1, argcv_meth_parser_3304__apply);
  meth_meth_parser_3304__apply->definitionModule = modulename;
  meth_meth_parser_3304__apply->definitionLine = 183;
// compiled block node returning block3303 (depth = 5)
  int op_slot_right_3302 = gc_frame_newslot(block3303);
// starting to compile call node (depth = 5)
  int callframe3313 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3314 == NULL) {
    strlit3314 = alloc_String("identifier");
    gc_root(strlit3314);
  }
// compiled string node returning strlit3314 (depth = 6)
  gc_frame_newslot(strlit3314);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3314;
  partcv[0] = 1;
  Object call3315 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3313);
// compiled call node returning call3315 (depth = 5)
  int op_slot_left_3302 = gc_frame_newslot(call3315);
  params[0] = block3303;
  partcv[0] = 1;
  Object opresult3316 = callmethod(call3315, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3316 (depth = 4)
  partcv[0] = 0;
  Object call3317 = callmethodflags(opresult3316, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3301);
// compiled call node returning call3317 (depth = 3)
  Object if3300 = done;
  if (istrue(call3317)) {
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3300 = undefined;
  } else {
  }
// compiled if node returning if3300 (depth = 2)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_tryTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3318 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3319 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3318);
// compiled member node returning call3319 (depth = 2)
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3321 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3322 == NULL) {
    strlit3322 = alloc_String("lbrace");
    gc_root(strlit3322);
  }
// compiled string node returning strlit3322 (depth = 4)
  gc_frame_newslot(strlit3322);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit3322;
  partcv[0] = 1;
  Object call3323 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3321);
// compiled call node returning call3323 (depth = 3)
  Object if3320 = done;
  if (istrue(call3323)) {
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3325 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3324);
// compiled member node returning call3325 (depth = 3)
    gc_frame_newslot(call3325);
    if3320 = call3325;
  } else {
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3328 == NULL) {
    strlit3328 = alloc_String("lparen");
    gc_root(strlit3328);
  }
// compiled string node returning strlit3328 (depth = 5)
  int op_slot_right_3327 = gc_frame_newslot(strlit3328);
// starting to compile member node (depth = 5)
  int callframe3330 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3331 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3330);
// compiled member node returning call3331 (depth = 5)
  int op_slot_left_3327 = gc_frame_newslot(call3331);
  params[0] = strlit3328;
  partcv[0] = 1;
  Object opresult3332 = callmethod(call3331, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3332 (depth = 4)
  Object if3326 = done;
  if (istrue(opresult3332)) {
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3333 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3334 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call3335 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3334);
// compiled member node returning call3335 (depth = 6)
  partcv[0] = 0;
  Object call3336 = callmethodflags(call3335, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3333);
// compiled member node returning call3336 (depth = 5)
  *var_suggestion = call3336;
  if (call3336 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3337 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3338 = alloc_Block(NULL, NULL, "parser", 1179);
  gc_frame_newslot(block3338);
// method "_apply(_)"
  block_savedest(block3338);
  Object closure3339 = createclosure(2, "_apply(1)");
  setclosureframe(closure3339, stackframe);
  addtoclosure(closure3339, var_tryTok);
  addtoclosure(closure3339, selfslot);
  struct UserObject *uo3339 = (struct UserObject*)block3338;
  uo3339->data[0] = (Object)closure3339;
  Method *meth_meth_parser_3339__apply_40_1_41_ = addmethod2pos(block3338, "_apply(1)", &meth_parser_3339__apply_40_1_41_, 0);
  int argcv_meth_parser_3339__apply_40_1_41_[] = {1};
  meth_meth_parser_3339__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_3339__apply_40_1_41_);
  meth_meth_parser_3339__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_3339__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block3338 (depth = 6)
  gc_frame_newslot(block3338);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block3338;
  partcv[0] = 1;
  Object call3384 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3337);
// compiled call node returning call3384 (depth = 5)
  *var_nextTok = call3384;
  if (call3384 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_3386 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool3388 = alloc_Boolean(0);
// compiled identifier node returning bool3388 (depth = 6)
  int op_slot_left_3386 = gc_frame_newslot(bool3388);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3389 = callmethod(bool3388, "==(1)", 1, partcv, params);
// compiled op node returning opresult3389 (depth = 5)
  Object if3385 = done;
  if (istrue(opresult3389)) {
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3390 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3391 == NULL) {
    strlit3391 = alloc_String(" {}");
    gc_root(strlit3391);
  }
// compiled string node returning strlit3391 (depth = 6)
  gc_frame_newslot(strlit3391);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tryTok (depth = 6)
  gc_frame_newslot(*var_tryTok);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3391;
  params[1] = *var_tryTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3392 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3390);
// compiled call node returning call3392 (depth = 5)
    gc_frame_newslot(call3392);
    if3385 = call3392;
  } else {
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3395 == NULL) {
    strlit3395 = alloc_String("rbrace");
    gc_root(strlit3395);
  }
// compiled string node returning strlit3395 (depth = 7)
  int op_slot_right_3394 = gc_frame_newslot(strlit3395);
// starting to compile member node (depth = 7)
  int callframe3397 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call3398 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3397);
// compiled member node returning call3398 (depth = 7)
  int op_slot_left_3394 = gc_frame_newslot(call3398);
  params[0] = strlit3395;
  partcv[0] = 1;
  Object opresult3399 = callmethod(call3398, "==(1)", 1, partcv, params);
// compiled op node returning opresult3399 (depth = 6)
  Object if3393 = done;
  if (istrue(opresult3399)) {
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3400 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3401 == NULL) {
    strlit3401 = alloc_String(" {");
    gc_root(strlit3401);
  }
// compiled string node returning strlit3401 (depth = 7)
  gc_frame_newslot(strlit3401);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tryTok (depth = 7)
  gc_frame_newslot(*var_tryTok);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3401;
  params[1] = *var_tryTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3402 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3400);
// compiled call node returning call3402 (depth = 6)
    gc_frame_newslot(call3402);
    if3393 = call3402;
  } else {
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3405 == NULL) {
    strlit3405 = alloc_String("rparen");
    gc_root(strlit3405);
  }
// compiled string node returning strlit3405 (depth = 8)
  int op_slot_right_3404 = gc_frame_newslot(strlit3405);
// starting to compile member node (depth = 8)
  int callframe3407 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3408 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3407);
// compiled member node returning call3408 (depth = 8)
  int op_slot_left_3404 = gc_frame_newslot(call3408);
  params[0] = strlit3405;
  partcv[0] = 1;
  Object opresult3409 = callmethod(call3408, "==(1)", 1, partcv, params);
// compiled op node returning opresult3409 (depth = 7)
  Object if3403 = done;
  if (istrue(opresult3409)) {
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3411 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3411 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3413 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3413 (depth = 8)
  Object if3410 = done;
  if (istrue(opresult3413)) {
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3414 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3415 == NULL) {
    strlit3415 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3415);
  }
// compiled string node returning strlit3415 (depth = 9)
  gc_frame_newslot(strlit3415);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3416 = alloc_Boolean(1);
// compiled identifier node returning bool3416 (depth = 9)
  gc_frame_newslot(bool3416);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3415;
  params[1] = *var_lastToken;
  params[2] = bool3416;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3417 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3414);
// compiled call node returning call3417 (depth = 8)
    gc_frame_newslot(call3417);
    if3410 = call3417;
  } else {
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3418 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3419 == NULL) {
    strlit3419 = alloc_String("(");
    gc_root(strlit3419);
  }
// compiled string node returning strlit3419 (depth = 9)
  gc_frame_newslot(strlit3419);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3420 = alloc_Boolean(1);
// compiled identifier node returning bool3420 (depth = 9)
  gc_frame_newslot(bool3420);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3419;
  params[1] = *var_lastToken;
  params[2] = bool3420;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3421 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3418);
// compiled call node returning call3421 (depth = 8)
    gc_frame_newslot(call3421);
    if3410 = call3421;
  }
// compiled if node returning if3410 (depth = 7)
    gc_frame_newslot(if3410);
    if3403 = if3410;
  } else {
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3424 == NULL) {
    strlit3424 = alloc_String("identifier");
    gc_root(strlit3424);
  }
// compiled string node returning strlit3424 (depth = 9)
  int op_slot_right_3423 = gc_frame_newslot(strlit3424);
// starting to compile member node (depth = 9)
  int callframe3426 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call3427 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3426);
// compiled member node returning call3427 (depth = 9)
  int op_slot_left_3423 = gc_frame_newslot(call3427);
  params[0] = strlit3424;
  partcv[0] = 1;
  Object opresult3428 = callmethod(call3427, "==(1)", 1, partcv, params);
// compiled op node returning opresult3428 (depth = 8)
  Object if3422 = done;
  if (istrue(opresult3428)) {
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3429 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3430 == NULL) {
    strlit3430 = alloc_String(" {");
    gc_root(strlit3430);
  }
// compiled string node returning strlit3430 (depth = 9)
  gc_frame_newslot(strlit3430);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tryTok (depth = 9)
  gc_frame_newslot(*var_tryTok);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3430;
  params[1] = *var_tryTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3431 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3429);
// compiled call node returning call3431 (depth = 8)
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3432 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3433 == NULL) {
    strlit3433 = alloc_String("} ");
    gc_root(strlit3433);
  }
// compiled string node returning strlit3433 (depth = 9)
  gc_frame_newslot(strlit3433);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  gc_frame_newslot(*var_nextTok);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3433;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3434 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3432);
// compiled call node returning call3434 (depth = 8)
    gc_frame_newslot(call3434);
    if3422 = call3434;
  } else {
  }
// compiled if node returning if3422 (depth = 7)
    gc_frame_newslot(if3422);
    if3403 = if3422;
  }
// compiled if node returning if3403 (depth = 6)
    gc_frame_newslot(if3403);
    if3393 = if3403;
  }
// compiled if node returning if3393 (depth = 5)
    gc_frame_newslot(if3393);
    if3385 = if3393;
  }
// compiled if node returning if3385 (depth = 4)
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3435 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3437 == NULL) {
    strlit3437 = alloc_String("a block or an expression in parentheses after the 'try'.");
    gc_root(strlit3437);
  }
// compiled string node returning strlit3437 (depth = 6)
  int op_slot_right_3436 = gc_frame_newslot(strlit3437);
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3439 == NULL) {
    strlit3439 = alloc_String("a try(_)catch(_) statement must have ");
    gc_root(strlit3439);
  }
// compiled string node returning strlit3439 (depth = 6)
  int op_slot_left_3436 = gc_frame_newslot(strlit3439);
  params[0] = strlit3437;
  partcv[0] = 1;
  Object opresult3440 = callmethod(strlit3439, "++(1)", 1, partcv, params);
// compiled op node returning opresult3440 (depth = 5)
  gc_frame_newslot(opresult3440);
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3441 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tryTok (depth = 6)
  partcv[0] = 0;
  Object call3442 = callmethodflags(*var_tryTok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3441);
// compiled member node returning call3442 (depth = 5)
  gc_frame_newslot(call3442);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3444 = alloc_Float64(1);
// compiled num node returning num3444 (depth = 6)
  int op_slot_right_3443 = gc_frame_newslot(num3444);
// starting to compile member node (depth = 6)
  int callframe3446 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tryTok (depth = 7)
  partcv[0] = 0;
  Object call3447 = callmethodflags(*var_tryTok, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe3446);
// compiled member node returning call3447 (depth = 6)
  int op_slot_left_3443 = gc_frame_newslot(call3447);
  params[0] = num3444;
  partcv[0] = 1;
  Object sum3448 = callmethod(call3447, "+(1)", 1, partcv, params);
// compiled op node returning sum3448 (depth = 5)
  gc_frame_newslot(sum3448);
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult3440;
  params[1] = call3442;
  params[2] = sum3448;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3449 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3435);
// compiled call node returning call3449 (depth = 4)
    gc_frame_newslot(call3449);
    if3326 = call3449;
  } else {
  }
// compiled if node returning if3326 (depth = 3)
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3450 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3451 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3450);
// compiled member node returning call3451 (depth = 3)
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3453 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3454 = alloc_Block(NULL, NULL, "parser", 1202);
  gc_frame_newslot(block3454);
// method "_apply"
  block_savedest(block3454);
  Object closure3455 = createclosure(2, "_apply");
  setclosureframe(closure3455, stackframe);
  addtoclosure(closure3455, var_blocksOK);
  addtoclosure(closure3455, selfslot);
  struct UserObject *uo3455 = (struct UserObject*)block3454;
  uo3455->data[0] = (Object)closure3455;
  Method *meth_meth_parser_3455__apply = addmethod2pos(block3454, "_apply", &meth_parser_3455__apply, 0);
  int argcv_meth_parser_3455__apply[] = {0};
  meth_meth_parser_3455__apply->type = alloc_MethodType(1, argcv_meth_parser_3455__apply);
  meth_meth_parser_3455__apply->definitionModule = modulename;
  meth_meth_parser_3455__apply->definitionLine = 183;
// compiled block node returning block3454 (depth = 5)
  gc_frame_newslot(block3454);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block3454;
  partcv[0] = 1;
  Object call3459 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3453);
// compiled call node returning call3459 (depth = 4)
  Object if3452 = done;
  if (istrue(call3459)) {
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3460 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3461 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call3462 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3461);
// compiled member node returning call3462 (depth = 6)
  partcv[0] = 0;
  Object call3463 = callmethodflags(call3462, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3460);
// compiled member node returning call3463 (depth = 5)
  *var_suggestion = call3463;
  if (call3463 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3464 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array3465 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit3466 == NULL) {
    strlit3466 = alloc_String("rparen");
    gc_root(strlit3466);
  }
// compiled string node returning strlit3466 (depth = 7)
  params[0] = strlit3466;
  partcv[0] = 1;
  callmethodflags(array3465, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3465 (depth = 6)
  gc_frame_newslot(array3465);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = array3465;
  partcv[0] = 1;
  Object call3467 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3464);
// compiled call node returning call3467 (depth = 5)
  *var_nextTok = call3467;
  if (call3467 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_3469 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_3469 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3471 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3471 (depth = 5)
  Object if3468 = done;
  if (istrue(opresult3471)) {
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3472 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3473 == NULL) {
    strlit3473 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3473);
  }
// compiled string node returning strlit3473 (depth = 6)
  gc_frame_newslot(strlit3473);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3473;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3474 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3472);
// compiled call node returning call3474 (depth = 5)
    gc_frame_newslot(call3474);
    if3468 = call3474;
  } else {
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3475 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe3476 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call3477 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe3476);
// compiled member node returning call3477 (depth = 6)
  gc_frame_newslot(call3477);
// starting to compile identifier node (depth = 6)
  Object bool3478 = alloc_Boolean(1);
// compiled identifier node returning bool3478 (depth = 6)
  gc_frame_newslot(bool3478);
// starting to compile identifier node (depth = 6)
  Object bool3479 = alloc_Boolean(0);
// compiled identifier node returning bool3479 (depth = 6)
  gc_frame_newslot(bool3479);
// starting to compile string node (depth = 6)
  if (strlit3480 == NULL) {
    strlit3480 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3480);
  }
// compiled string node returning strlit3480 (depth = 6)
  gc_frame_newslot(strlit3480);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call3477;
  params[2] = bool3478;
  params[3] = bool3479;
  params[4] = strlit3480;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3481 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3475);
// compiled call node returning call3481 (depth = 5)
    gc_frame_newslot(call3481);
    if3468 = call3481;
  }
// compiled if node returning if3468 (depth = 4)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3482 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3484 == NULL) {
    strlit3484 = alloc_String("a block or an expression in parentheses after the 'try'.");
    gc_root(strlit3484);
  }
// compiled string node returning strlit3484 (depth = 6)
  int op_slot_right_3483 = gc_frame_newslot(strlit3484);
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3486 == NULL) {
    strlit3486 = alloc_String("a 'try(_)catch(_)""\xe2""""\x80""""\xa6""' statement must have ");
    gc_root(strlit3486);
  }
// compiled string node returning strlit3486 (depth = 6)
  int op_slot_left_3483 = gc_frame_newslot(strlit3486);
  params[0] = strlit3484;
  partcv[0] = 1;
  Object opresult3487 = callmethod(strlit3486, "++(1)", 1, partcv, params);
// compiled op node returning opresult3487 (depth = 5)
  gc_frame_newslot(opresult3487);
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3488 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3489 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3488);
// compiled member node returning call3489 (depth = 5)
  gc_frame_newslot(call3489);
// starting to compile member node (depth = 5)
  int callframe3490 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3491 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3490);
// compiled member node returning call3491 (depth = 5)
  gc_frame_newslot(call3491);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult3487;
  params[1] = call3489;
  params[2] = call3491;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3492 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3482);
// compiled call node returning call3492 (depth = 4)
    gc_frame_newslot(call3492);
    if3452 = call3492;
  } else {
  }
// compiled if node returning if3452 (depth = 3)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3495 == NULL) {
    strlit3495 = alloc_String("rparen");
    gc_root(strlit3495);
  }
// compiled string node returning strlit3495 (depth = 5)
  int op_slot_right_3494 = gc_frame_newslot(strlit3495);
// starting to compile member node (depth = 5)
  int callframe3497 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3498 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3497);
// compiled member node returning call3498 (depth = 5)
  int op_slot_left_3494 = gc_frame_newslot(call3498);
  params[0] = strlit3495;
  partcv[0] = 1;
  Object opresult3499 = callmethod(call3498, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3499 (depth = 4)
  Object if3493 = done;
  if (istrue(opresult3499)) {
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3501 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3500);
// compiled member node returning call3501 (depth = 4)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3502 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3503 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call3504 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3503);
// compiled member node returning call3504 (depth = 6)
  partcv[0] = 0;
  Object call3505 = callmethodflags(call3504, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3502);
// compiled member node returning call3505 (depth = 5)
  *var_suggestion = call3505;
  if (call3505 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3506 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3507 == NULL) {
    strlit3507 = alloc_String(")");
    gc_root(strlit3507);
  }
// compiled string node returning strlit3507 (depth = 5)
  gc_frame_newslot(strlit3507);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3507;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3508 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3506);
// compiled call node returning call3508 (depth = 4)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3509 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3510 == NULL) {
    strlit3510 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3510);
  }
// compiled string node returning strlit3510 (depth = 5)
  gc_frame_newslot(strlit3510);
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3511 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call3512 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3511);
// compiled member node returning call3512 (depth = 5)
  gc_frame_newslot(call3512);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3514 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3515 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3514);
// compiled member node returning call3515 (depth = 6)
  int op_slot_right_3513 = gc_frame_newslot(call3515);
// starting to compile member node (depth = 6)
  int callframe3517 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3518 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3517);
// compiled member node returning call3518 (depth = 6)
  int op_slot_left_3513 = gc_frame_newslot(call3518);
  params[0] = call3515;
  partcv[0] = 1;
  Object sum3519 = callmethod(call3518, "+(1)", 1, partcv, params);
// compiled op node returning sum3519 (depth = 5)
  gc_frame_newslot(sum3519);
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3510;
  params[1] = call3512;
  params[2] = sum3519;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3520 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3509);
// compiled call node returning call3520 (depth = 4)
    gc_frame_newslot(call3520);
    if3493 = call3520;
  } else {
  }
// compiled if node returning if3493 (depth = 3)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3521 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3522 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3521);
// compiled member node returning call3522 (depth = 3)
    gc_frame_newslot(call3522);
    if3320 = call3522;
  }
// compiled if node returning if3320 (depth = 2)
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3523 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  partcv[0] = 0;
  Object call3524 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe3523);
// compiled member node returning call3524 (depth = 3)
  *var_mainblock = call3524;
  if (call3524 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array3525 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3525 (depth = 3)
  *var_cases = array3525;
  if (array3525 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3526 = alloc_Boolean(0);
// compiled identifier node returning bool3526 (depth = 3)
  *var_finally = bool3526;
  if (bool3526 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3527 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3528 = alloc_Block(NULL, NULL, "parser", 1227);
  gc_frame_newslot(block3528);
// method "_apply"
  block_savedest(block3528);
  Object closure3529 = createclosure(2, "_apply");
  setclosureframe(closure3529, stackframe);
  addtoclosure(closure3529, var_sym);
  addtoclosure(closure3529, selfslot);
  struct UserObject *uo3529 = (struct UserObject*)block3528;
  uo3529->data[0] = (Object)closure3529;
  Method *meth_meth_parser_3529__apply = addmethod2pos(block3528, "_apply", &meth_parser_3529__apply, 0);
  int argcv_meth_parser_3529__apply[] = {0};
  meth_meth_parser_3529__apply->type = alloc_MethodType(1, argcv_meth_parser_3529__apply);
  meth_meth_parser_3529__apply->definitionModule = modulename;
  meth_meth_parser_3529__apply->definitionLine = 183;
// compiled block node returning block3528 (depth = 3)
  gc_frame_newslot(block3528);
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block3543 = alloc_Block(NULL, NULL, "parser", 1227);
  gc_frame_newslot(block3543);
// method "_apply"
  block_savedest(block3543);
  Object closure3544 = createclosure(8, "_apply");
  setclosureframe(closure3544, stackframe);
  addtoclosure(closure3544, var_blocksOK);
  addtoclosure(closure3544, var_errormessages);
  addtoclosure(closure3544, var_sym);
  addtoclosure(closure3544, var_lastToken);
  addtoclosure(closure3544, var_tokens);
  addtoclosure(closure3544, var_values);
  addtoclosure(closure3544, var_cases);
  addtoclosure(closure3544, selfslot);
  struct UserObject *uo3544 = (struct UserObject*)block3543;
  uo3544->data[0] = (Object)closure3544;
  Method *meth_meth_parser_3544__apply = addmethod2pos(block3543, "_apply", &meth_parser_3544__apply, 0);
  int argcv_meth_parser_3544__apply[] = {0};
  meth_meth_parser_3544__apply->type = alloc_MethodType(1, argcv_meth_parser_3544__apply);
  meth_meth_parser_3544__apply->definitionModule = modulename;
  meth_meth_parser_3544__apply->definitionLine = 183;
// compiled block node returning block3543 (depth = 3)
  gc_frame_newslot(block3543);
// call case 5: prelude request
  params[0] = block3528;
  params[1] = block3543;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3693 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3527);
// compiled call node returning call3693 (depth = 2)
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3697 == NULL) {
    strlit3697 = alloc_String("case");
    gc_root(strlit3697);
  }
// compiled string node returning strlit3697 (depth = 5)
  int op_slot_right_3696 = gc_frame_newslot(strlit3697);
// starting to compile member node (depth = 5)
  int callframe3699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3700 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3699);
// compiled member node returning call3700 (depth = 5)
  int op_slot_left_3696 = gc_frame_newslot(call3700);
  params[0] = strlit3697;
  partcv[0] = 1;
  Object opresult3701 = callmethod(call3700, "==(1)", 1, partcv, params);
// compiled op node returning opresult3701 (depth = 4)
  int op_slot_right_3695 = gc_frame_newslot(opresult3701);
// starting to compile call node (depth = 4)
  int callframe3703 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3704 == NULL) {
    strlit3704 = alloc_String("identifier");
    gc_root(strlit3704);
  }
// compiled string node returning strlit3704 (depth = 5)
  gc_frame_newslot(strlit3704);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tryTok (depth = 5)
  gc_frame_newslot(*var_tryTok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit3704;
  params[1] = *var_tryTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3705 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3703);
// compiled call node returning call3705 (depth = 4)
  int op_slot_left_3695 = gc_frame_newslot(call3705);
  params[0] = opresult3701;
  partcv[0] = 1;
  Object opresult3706 = callmethod(call3705, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3706 (depth = 3)
  Object if3694 = done;
  if (istrue(opresult3706)) {
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3707 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3708 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call3709 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3708);
// compiled member node returning call3709 (depth = 5)
  partcv[0] = 0;
  Object call3710 = callmethodflags(call3709, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3707);
// compiled member node returning call3710 (depth = 4)
  *var_suggestion = call3710;
  if (call3710 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3711 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 4)
  if (strlit3712 == NULL) {
    strlit3712 = alloc_String("catch");
    gc_root(strlit3712);
  }
// compiled string node returning strlit3712 (depth = 4)
  gc_frame_newslot(strlit3712);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = strlit3712;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3713 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3711);
// compiled call node returning call3713 (depth = 3)
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3714 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3716 == NULL) {
    strlit3716 = alloc_String("are no 'case' blocks.");
    gc_root(strlit3716);
  }
// compiled string node returning strlit3716 (depth = 5)
  int op_slot_right_3715 = gc_frame_newslot(strlit3716);
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3719 == NULL) {
    strlit3719 = alloc_String("'try', followed by zero or more 'catch' blocks; there ");
    gc_root(strlit3719);
  }
// compiled string node returning strlit3719 (depth = 6)
  int op_slot_right_3718 = gc_frame_newslot(strlit3719);
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3721 == NULL) {
    strlit3721 = alloc_String("a 'try(_)catch(_)""\xe2""""\x80""""\xa6""' statement starts with a ");
    gc_root(strlit3721);
  }
// compiled string node returning strlit3721 (depth = 6)
  int op_slot_left_3718 = gc_frame_newslot(strlit3721);
  params[0] = strlit3719;
  partcv[0] = 1;
  Object opresult3722 = callmethod(strlit3721, "++(1)", 1, partcv, params);
// compiled op node returning opresult3722 (depth = 5)
  int op_slot_left_3715 = gc_frame_newslot(opresult3722);
  params[0] = strlit3716;
  partcv[0] = 1;
  Object opresult3723 = callmethod(opresult3722, "++(1)", 1, partcv, params);
// compiled op node returning opresult3723 (depth = 4)
  gc_frame_newslot(opresult3723);
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3724 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call3725 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3724);
// compiled member node returning call3725 (depth = 4)
  gc_frame_newslot(call3725);
// starting to compile member node (depth = 4)
  int callframe3726 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call3727 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3726);
// compiled member node returning call3727 (depth = 4)
  gc_frame_newslot(call3727);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3729 = alloc_Float64(3);
// compiled num node returning num3729 (depth = 5)
  int op_slot_right_3728 = gc_frame_newslot(num3729);
// starting to compile member node (depth = 5)
  int callframe3731 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3732 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3731);
// compiled member node returning call3732 (depth = 5)
  int op_slot_left_3728 = gc_frame_newslot(call3732);
  params[0] = num3729;
  partcv[0] = 1;
  Object sum3733 = callmethod(call3732, "+(1)", 1, partcv, params);
// compiled op node returning sum3733 (depth = 4)
  gc_frame_newslot(sum3733);
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult3723;
  params[1] = call3725;
  params[2] = call3727;
  params[3] = sum3733;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3734 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3714);
// compiled call node returning call3734 (depth = 3)
    gc_frame_newslot(call3734);
    if3694 = call3734;
  } else {
  }
// compiled if node returning if3694 (depth = 2)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3738 == NULL) {
    strlit3738 = alloc_String("finally");
    gc_root(strlit3738);
  }
// compiled string node returning strlit3738 (depth = 5)
  int op_slot_right_3737 = gc_frame_newslot(strlit3738);
// starting to compile member node (depth = 5)
  int callframe3740 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3741 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3740);
// compiled member node returning call3741 (depth = 5)
  int op_slot_left_3737 = gc_frame_newslot(call3741);
  params[0] = strlit3738;
  partcv[0] = 1;
  Object opresult3742 = callmethod(call3741, "==(1)", 1, partcv, params);
// compiled op node returning opresult3742 (depth = 4)
  int op_slot_right_3736 = gc_frame_newslot(opresult3742);
// starting to compile call node (depth = 4)
  int callframe3744 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3745 == NULL) {
    strlit3745 = alloc_String("identifier");
    gc_root(strlit3745);
  }
// compiled string node returning strlit3745 (depth = 5)
  gc_frame_newslot(strlit3745);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit3745;
  partcv[0] = 1;
  Object call3746 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3744);
// compiled call node returning call3746 (depth = 4)
  int op_slot_left_3736 = gc_frame_newslot(call3746);
  params[0] = opresult3742;
  partcv[0] = 1;
  Object opresult3747 = callmethod(call3746, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3747 (depth = 3)
  Object if3735 = done;
  if (istrue(opresult3747)) {
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3748 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3749 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3748);
// compiled member node returning call3749 (depth = 3)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3751 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3752 == NULL) {
    strlit3752 = alloc_String("lbrace");
    gc_root(strlit3752);
  }
// compiled string node returning strlit3752 (depth = 5)
  gc_frame_newslot(strlit3752);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit3752;
  partcv[0] = 1;
  Object call3753 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3751);
// compiled call node returning call3753 (depth = 4)
  Object if3750 = done;
  if (istrue(call3753)) {
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3754 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3755 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3754);
// compiled member node returning call3755 (depth = 4)
    gc_frame_newslot(call3755);
    if3750 = call3755;
  } else {
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3757 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3758 == NULL) {
    strlit3758 = alloc_String("lparen");
    gc_root(strlit3758);
  }
// compiled string node returning strlit3758 (depth = 6)
  gc_frame_newslot(strlit3758);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3758;
  partcv[0] = 1;
  Object call3759 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3757);
// compiled call node returning call3759 (depth = 5)
  Object if3756 = done;
  if (istrue(call3759)) {
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3760 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3761 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3760);
// compiled member node returning call3761 (depth = 5)
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3763 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block3764 = alloc_Block(NULL, NULL, "parser", 1292);
  gc_frame_newslot(block3764);
// method "_apply"
  block_savedest(block3764);
  Object closure3765 = createclosure(2, "_apply");
  setclosureframe(closure3765, stackframe);
  addtoclosure(closure3765, var_blocksOK);
  addtoclosure(closure3765, selfslot);
  struct UserObject *uo3765 = (struct UserObject*)block3764;
  uo3765->data[0] = (Object)closure3765;
  Method *meth_meth_parser_3765__apply = addmethod2pos(block3764, "_apply", &meth_parser_3765__apply, 0);
  int argcv_meth_parser_3765__apply[] = {0};
  meth_meth_parser_3765__apply->type = alloc_MethodType(1, argcv_meth_parser_3765__apply);
  meth_meth_parser_3765__apply->definitionModule = modulename;
  meth_meth_parser_3765__apply->definitionLine = 183;
// compiled block node returning block3764 (depth = 7)
  gc_frame_newslot(block3764);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block3764;
  partcv[0] = 1;
  Object call3769 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3763);
// compiled call node returning call3769 (depth = 6)
  Object if3762 = done;
  if (istrue(call3769)) {
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3770 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3771 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3772 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3771);
// compiled member node returning call3772 (depth = 8)
  partcv[0] = 0;
  Object call3773 = callmethodflags(call3772, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3770);
// compiled member node returning call3773 (depth = 7)
  *var_suggestion = call3773;
  if (call3773 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3774 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array3775 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit3776 == NULL) {
    strlit3776 = alloc_String("rparen");
    gc_root(strlit3776);
  }
// compiled string node returning strlit3776 (depth = 9)
  params[0] = strlit3776;
  partcv[0] = 1;
  callmethodflags(array3775, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3775 (depth = 8)
  gc_frame_newslot(array3775);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = array3775;
  partcv[0] = 1;
  Object call3777 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3774);
// compiled call node returning call3777 (depth = 7)
  *var_nextTok = call3777;
  if (call3777 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3779 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3779 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3781 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3781 (depth = 7)
  Object if3778 = done;
  if (istrue(opresult3781)) {
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3782 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3783 == NULL) {
    strlit3783 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3783);
  }
// compiled string node returning strlit3783 (depth = 8)
  gc_frame_newslot(strlit3783);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3783;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3784 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3782);
// compiled call node returning call3784 (depth = 7)
    gc_frame_newslot(call3784);
    if3778 = call3784;
  } else {
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3785 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe3786 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3787 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe3786);
// compiled member node returning call3787 (depth = 8)
  gc_frame_newslot(call3787);
// starting to compile identifier node (depth = 8)
  Object bool3788 = alloc_Boolean(1);
// compiled identifier node returning bool3788 (depth = 8)
  gc_frame_newslot(bool3788);
// starting to compile identifier node (depth = 8)
  Object bool3789 = alloc_Boolean(0);
// compiled identifier node returning bool3789 (depth = 8)
  gc_frame_newslot(bool3789);
// starting to compile string node (depth = 8)
  if (strlit3790 == NULL) {
    strlit3790 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3790);
  }
// compiled string node returning strlit3790 (depth = 8)
  gc_frame_newslot(strlit3790);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call3787;
  params[2] = bool3788;
  params[3] = bool3789;
  params[4] = strlit3790;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3791 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3785);
// compiled call node returning call3791 (depth = 7)
    gc_frame_newslot(call3791);
    if3778 = call3791;
  }
// compiled if node returning if3778 (depth = 6)
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3792 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3794 == NULL) {
    strlit3794 = alloc_String("after the 'finally'.");
    gc_root(strlit3794);
  }
// compiled string node returning strlit3794 (depth = 8)
  int op_slot_right_3793 = gc_frame_newslot(strlit3794);
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit3797 == NULL) {
    strlit3797 = alloc_String("must have either a block, or an expression in parentheses, ");
    gc_root(strlit3797);
  }
// compiled string node returning strlit3797 (depth = 9)
  int op_slot_right_3796 = gc_frame_newslot(strlit3797);
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit3799 == NULL) {
    strlit3799 = alloc_String("a 'try(_)catch(_)""\xe2""""\x80""""\xa6""finally(_)' statement ");
    gc_root(strlit3799);
  }
// compiled string node returning strlit3799 (depth = 9)
  int op_slot_left_3796 = gc_frame_newslot(strlit3799);
  params[0] = strlit3797;
  partcv[0] = 1;
  Object opresult3800 = callmethod(strlit3799, "++(1)", 1, partcv, params);
// compiled op node returning opresult3800 (depth = 8)
  int op_slot_left_3793 = gc_frame_newslot(opresult3800);
  params[0] = strlit3794;
  partcv[0] = 1;
  Object opresult3801 = callmethod(opresult3800, "++(1)", 1, partcv, params);
// compiled op node returning opresult3801 (depth = 7)
  gc_frame_newslot(opresult3801);
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3802 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3803 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3802);
// compiled member node returning call3803 (depth = 7)
  gc_frame_newslot(call3803);
// starting to compile member node (depth = 7)
  int callframe3804 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3805 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3804);
// compiled member node returning call3805 (depth = 7)
  gc_frame_newslot(call3805);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult3801;
  params[1] = call3803;
  params[2] = call3805;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3806 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3792);
// compiled call node returning call3806 (depth = 6)
    gc_frame_newslot(call3806);
    if3762 = call3806;
  } else {
  }
// compiled if node returning if3762 (depth = 5)
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3809 == NULL) {
    strlit3809 = alloc_String("rparen");
    gc_root(strlit3809);
  }
// compiled string node returning strlit3809 (depth = 7)
  int op_slot_right_3808 = gc_frame_newslot(strlit3809);
// starting to compile member node (depth = 7)
  int callframe3811 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3812 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3811);
// compiled member node returning call3812 (depth = 7)
  int op_slot_left_3808 = gc_frame_newslot(call3812);
  params[0] = strlit3809;
  partcv[0] = 1;
  Object opresult3813 = callmethod(call3812, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3813 (depth = 6)
  Object if3807 = done;
  if (istrue(opresult3813)) {
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3814 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3815 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3814);
// compiled member node returning call3815 (depth = 6)
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3816 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3817 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3818 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3817);
// compiled member node returning call3818 (depth = 8)
  partcv[0] = 0;
  Object call3819 = callmethodflags(call3818, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3816);
// compiled member node returning call3819 (depth = 7)
  *var_suggestion = call3819;
  if (call3819 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3820 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3821 == NULL) {
    strlit3821 = alloc_String(")");
    gc_root(strlit3821);
  }
// compiled string node returning strlit3821 (depth = 7)
  gc_frame_newslot(strlit3821);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3821;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3822 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3820);
// compiled call node returning call3822 (depth = 6)
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3823 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3824 == NULL) {
    strlit3824 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3824);
  }
// compiled string node returning strlit3824 (depth = 7)
  gc_frame_newslot(strlit3824);
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3825 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3826 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3825);
// compiled member node returning call3826 (depth = 7)
  gc_frame_newslot(call3826);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3828 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3829 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe3828);
// compiled member node returning call3829 (depth = 8)
  int op_slot_right_3827 = gc_frame_newslot(call3829);
// starting to compile member node (depth = 8)
  int callframe3831 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3832 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3831);
// compiled member node returning call3832 (depth = 8)
  int op_slot_left_3827 = gc_frame_newslot(call3832);
  params[0] = call3829;
  partcv[0] = 1;
  Object sum3833 = callmethod(call3832, "+(1)", 1, partcv, params);
// compiled op node returning sum3833 (depth = 7)
  gc_frame_newslot(sum3833);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3824;
  params[1] = call3826;
  params[2] = sum3833;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3834 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3823);
// compiled call node returning call3834 (depth = 6)
    gc_frame_newslot(call3834);
    if3807 = call3834;
  } else {
  }
// compiled if node returning if3807 (depth = 5)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3835 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3836 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3835);
// compiled member node returning call3836 (depth = 5)
    gc_frame_newslot(call3836);
    if3756 = call3836;
  } else {
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array3837 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3837 (depth = 6)
  *var_suggestions = array3837;
  if (array3837 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3838 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3839 = callmethodflags(module_parser, "findNextTokenIndentedAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3838);
// compiled call node returning call3839 (depth = 6)
  *var_nextTok = call3839;
  if (call3839 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3840 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3841 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call3842 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3841);
// compiled member node returning call3842 (depth = 7)
  partcv[0] = 0;
  Object call3843 = callmethodflags(call3842, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3840);
// compiled member node returning call3843 (depth = 6)
  *var_suggestion = call3843;
  if (call3843 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_3845 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool3847 = alloc_Boolean(0);
// compiled identifier node returning bool3847 (depth = 7)
  int op_slot_left_3845 = gc_frame_newslot(bool3847);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3848 = callmethod(bool3847, "==(1)", 1, partcv, params);
// compiled op node returning opresult3848 (depth = 6)
  Object if3844 = done;
  if (istrue(opresult3848)) {
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3849 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3850 == NULL) {
    strlit3850 = alloc_String(" }");
    gc_root(strlit3850);
  }
// compiled string node returning strlit3850 (depth = 7)
  gc_frame_newslot(strlit3850);
// starting to compile member node (depth = 7)
  int callframe3851 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  partcv[0] = 0;
  Object call3852 = callmethodflags(*var_tokens, "first", 1, partcv, params, 0);
  gc_frame_end(callframe3851);
// compiled member node returning call3852 (depth = 7)
  gc_frame_newslot(call3852);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3850;
  params[1] = call3852;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3853 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3849);
// compiled call node returning call3853 (depth = 6)
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3854 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3855 == NULL) {
    strlit3855 = alloc_String(" {");
    gc_root(strlit3855);
  }
// compiled string node returning strlit3855 (depth = 7)
  gc_frame_newslot(strlit3855);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3855;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3856 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3854);
// compiled call node returning call3856 (depth = 6)
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3857 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3858 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3857);
// compiled call node returning call3858 (depth = 6)
    gc_frame_newslot(call3858);
    if3844 = call3858;
  } else {
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3860 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3860 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3862 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3862 (depth = 7)
  Object if3859 = done;
  if (istrue(opresult3862)) {
// Begin line 1322
  setline(1322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3863 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3864 == NULL) {
    strlit3864 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3864);
  }
// compiled string node returning strlit3864 (depth = 8)
  gc_frame_newslot(strlit3864);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3864;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3865 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3863);
// compiled call node returning call3865 (depth = 7)
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3866 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3867 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3866);
// compiled call node returning call3867 (depth = 7)
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3868 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3869 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3870 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3869);
// compiled member node returning call3870 (depth = 9)
  partcv[0] = 0;
  Object call3871 = callmethodflags(call3870, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3868);
// compiled member node returning call3871 (depth = 8)
  *var_suggestion = call3871;
  if (call3871 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3873 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3874 == NULL) {
    strlit3874 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit3874);
  }
// compiled string node returning strlit3874 (depth = 8)
  gc_frame_newslot(strlit3874);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3874;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3875 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3873);
// compiled call node returning call3875 (depth = 7)
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3876 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3877 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3876);
// compiled call node returning call3877 (depth = 7)
    gc_frame_newslot(call3877);
    if3859 = call3877;
  } else {
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3878 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3879 == NULL) {
    strlit3879 = alloc_String(" }");
    gc_root(strlit3879);
  }
// compiled string node returning strlit3879 (depth = 8)
  gc_frame_newslot(strlit3879);
// starting to compile member node (depth = 8)
  int callframe3880 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3881 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe3880);
// compiled member node returning call3881 (depth = 8)
  gc_frame_newslot(call3881);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3879;
  params[1] = call3881;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3882 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3878);
// compiled call node returning call3882 (depth = 7)
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3883 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3884 == NULL) {
    strlit3884 = alloc_String(" {");
    gc_root(strlit3884);
  }
// compiled string node returning strlit3884 (depth = 8)
  gc_frame_newslot(strlit3884);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3884;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3885 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3883);
// compiled call node returning call3885 (depth = 7)
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3886 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3887 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3886);
// compiled call node returning call3887 (depth = 7)
    gc_frame_newslot(call3887);
    if3859 = call3887;
  }
// compiled if node returning if3859 (depth = 6)
    gc_frame_newslot(if3859);
    if3844 = if3859;
  }
// compiled if node returning if3844 (depth = 5)
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3888 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3889 == NULL) {
    strlit3889 = alloc_String("a try(_)catch(_)""\xe2""""\x80""""\xa6""finally(_) statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit3889);
  }
// compiled string node returning strlit3889 (depth = 6)
  gc_frame_newslot(strlit3889);
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3890 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3891 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3890);
// compiled member node returning call3891 (depth = 6)
  gc_frame_newslot(call3891);
// starting to compile member node (depth = 6)
  int callframe3892 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3893 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3892);
// compiled member node returning call3893 (depth = 6)
  gc_frame_newslot(call3893);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3889;
  params[1] = call3891;
  params[2] = call3893;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3894 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3888);
// compiled call node returning call3894 (depth = 5)
    gc_frame_newslot(call3894);
    if3756 = call3894;
  }
// compiled if node returning if3756 (depth = 4)
    gc_frame_newslot(if3756);
    if3750 = if3756;
  }
// compiled if node returning if3750 (depth = 3)
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3895 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call3896 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe3895);
// compiled member node returning call3896 (depth = 4)
  *var_finally = call3896;
  if (call3896 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if3735 = done;
  } else {
  }
// compiled if node returning if3735 (depth = 2)
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3898 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe3899 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tryTok (depth = 4)
  partcv[0] = 0;
  Object call3900 = callmethodflags(*var_tryTok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3899);
// compiled member node returning call3900 (depth = 3)
  gc_frame_newslot(call3900);
// starting to compile member node (depth = 3)
  int callframe3901 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tryTok (depth = 4)
  partcv[0] = 0;
  Object call3902 = callmethodflags(*var_tryTok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe3901);
// compiled member node returning call3902 (depth = 3)
  gc_frame_newslot(call3902);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call3900;
  params[1] = call3902;
  partcv[0] = 2;
  Object call3903 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3898);
// compiled call node returning call3903 (depth = 2)
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3904 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe3905 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mainblock (depth = 4)
  gc_frame_newslot(*var_mainblock);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally (depth = 4)
  gc_frame_newslot(*var_finally);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3906 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call3907 = callmethodflags(*var_ast, "tryCatchNode", 1, partcv, params, 0);
  gc_frame_end(callframe3906);
// compiled member node returning call3907 (depth = 4)
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call3908 = callmethodflags(call3907, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe3905);
// compiled call node returning call3908 (depth = 3)
  gc_frame_newslot(call3908);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call3908;
  partcv[0] = 1;
  Object call3909 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3904);
// compiled call node returning call3909 (depth = 2)
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_3943__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_matchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3947 == NULL) {
    strlit3947 = alloc_String("case");
    gc_root(strlit3947);
  }
// compiled string node returning strlit3947 (depth = 9)
  int op_slot_right_3946 = gc_frame_newslot(strlit3947);
// starting to compile member node (depth = 9)
  int callframe3949 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call3950 = callmethodflags(*var_t, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3949);
// compiled member node returning call3950 (depth = 9)
  int op_slot_left_3946 = gc_frame_newslot(call3950);
  params[0] = strlit3947;
  partcv[0] = 1;
  Object opresult3951 = callmethod(call3950, "==(1)", 1, partcv, params);
// compiled op node returning opresult3951 (depth = 8)
  int op_slot_right_3945 = gc_frame_newslot(opresult3951);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3954 == NULL) {
    strlit3954 = alloc_String("identifier");
    gc_root(strlit3954);
  }
// compiled string node returning strlit3954 (depth = 9)
  int op_slot_right_3953 = gc_frame_newslot(strlit3954);
// starting to compile member node (depth = 9)
  int callframe3956 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call3957 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3956);
// compiled member node returning call3957 (depth = 9)
  int op_slot_left_3953 = gc_frame_newslot(call3957);
  params[0] = strlit3954;
  partcv[0] = 1;
  Object opresult3958 = callmethod(call3957, "==(1)", 1, partcv, params);
// compiled op node returning opresult3958 (depth = 8)
  int op_slot_left_3945 = gc_frame_newslot(opresult3958);
  params[0] = opresult3951;
  partcv[0] = 1;
  Object opresult3959 = callmethod(opresult3958, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3959 (depth = 7)
  int op_slot_right_3944 = gc_frame_newslot(opresult3959);
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3963 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_matchTok (depth = 10)
  partcv[0] = 0;
  Object call3964 = callmethodflags(*var_matchTok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3963);
// compiled member node returning call3964 (depth = 9)
  int op_slot_right_3962 = gc_frame_newslot(call3964);
// starting to compile member node (depth = 9)
  int callframe3966 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call3967 = callmethodflags(*var_t, "line", 1, partcv, params, 0);
  gc_frame_end(callframe3966);
// compiled member node returning call3967 (depth = 9)
  int op_slot_left_3962 = gc_frame_newslot(call3967);
  params[0] = call3964;
  partcv[0] = 1;
  Object opresult3968 = callmethod(call3967, "==(1)", 1, partcv, params);
// compiled op node returning opresult3968 (depth = 8)
  int op_slot_right_3961 = gc_frame_newslot(opresult3968);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3971 == NULL) {
    strlit3971 = alloc_String("rparen");
    gc_root(strlit3971);
  }
// compiled string node returning strlit3971 (depth = 9)
  int op_slot_right_3970 = gc_frame_newslot(strlit3971);
// starting to compile member node (depth = 9)
  int callframe3973 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call3974 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3973);
// compiled member node returning call3974 (depth = 9)
  int op_slot_left_3970 = gc_frame_newslot(call3974);
  params[0] = strlit3971;
  partcv[0] = 1;
  Object opresult3975 = callmethod(call3974, "==(1)", 1, partcv, params);
// compiled op node returning opresult3975 (depth = 8)
  int op_slot_left_3961 = gc_frame_newslot(opresult3975);
  params[0] = opresult3968;
  partcv[0] = 1;
  Object opresult3976 = callmethod(opresult3975, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3976 (depth = 7)
  int op_slot_left_3944 = gc_frame_newslot(opresult3976);
  params[0] = opresult3959;
  partcv[0] = 1;
  Object opresult3977 = callmethod(opresult3976, "||(1)", 1, partcv, params);
// compiled op node returning opresult3977 (depth = 6)
  gc_frame_end(frame);
  return opresult3977;
}
Object meth_parser_4038__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe4039 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4040 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4039);
// compiled call node returning call4040 (depth = 5)
  gc_frame_end(frame);
  return call4040;
}
Object meth_parser_4107__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4110 == NULL) {
    strlit4110 = alloc_String("case");
    gc_root(strlit4110);
  }
// compiled string node returning strlit4110 (depth = 6)
  int op_slot_right_4109 = gc_frame_newslot(strlit4110);
// starting to compile member node (depth = 6)
  int callframe4112 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4113 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4112);
// compiled member node returning call4113 (depth = 6)
  int op_slot_left_4109 = gc_frame_newslot(call4113);
  params[0] = strlit4110;
  partcv[0] = 1;
  Object opresult4114 = callmethod(call4113, "==(1)", 1, partcv, params);
// compiled op node returning opresult4114 (depth = 5)
  int op_slot_right_4108 = gc_frame_newslot(opresult4114);
// starting to compile call node (depth = 5)
  int callframe4116 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4117 == NULL) {
    strlit4117 = alloc_String("identifier");
    gc_root(strlit4117);
  }
// compiled string node returning strlit4117 (depth = 6)
  gc_frame_newslot(strlit4117);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit4117;
  partcv[0] = 1;
  Object call4118 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4116);
// compiled call node returning call4118 (depth = 5)
  int op_slot_left_4108 = gc_frame_newslot(call4118);
  params[0] = opresult4114;
  partcv[0] = 1;
  Object opresult4119 = callmethod(call4118, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4119 (depth = 4)
  gc_frame_end(frame);
  return opresult4119;
}
Object meth_parser_4140__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 9)
  int callframe4141 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4142 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4141);
// compiled call node returning call4142 (depth = 9)
  gc_frame_end(frame);
  return call4142;
}
Object meth_parser_4122__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4123 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4124 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4123);
// compiled member node returning call4124 (depth = 4)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4126 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4127 == NULL) {
    strlit4127 = alloc_String("lbrace");
    gc_root(strlit4127);
  }
// compiled string node returning strlit4127 (depth = 6)
  gc_frame_newslot(strlit4127);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit4127;
  partcv[0] = 1;
  Object call4128 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4126);
// compiled call node returning call4128 (depth = 5)
  Object if4125 = done;
  if (istrue(call4128)) {
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4129 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4130 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4129);
// compiled member node returning call4130 (depth = 5)
    gc_frame_newslot(call4130);
    if4125 = call4130;
  } else {
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4132 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4133 == NULL) {
    strlit4133 = alloc_String("lparen");
    gc_root(strlit4133);
  }
// compiled string node returning strlit4133 (depth = 7)
  gc_frame_newslot(strlit4133);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit4133;
  partcv[0] = 1;
  Object call4134 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4132);
// compiled call node returning call4134 (depth = 6)
  Object if4131 = done;
  if (istrue(call4134)) {
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4135 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4136 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4135);
// compiled member node returning call4136 (depth = 6)
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4138 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block4139 = alloc_Block(NULL, NULL, "parser", 1396);
  gc_frame_newslot(block4139);
// method "_apply"
  block_savedest(block4139);
  Object closure4140 = createclosure(2, "_apply");
  setclosureframe(closure4140, stackframe);
  addtoclosure(closure4140, var_blocksOK);
  addtoclosure(closure4140, selfslot);
  struct UserObject *uo4140 = (struct UserObject*)block4139;
  uo4140->data[0] = (Object)closure4140;
  Method *meth_meth_parser_4140__apply = addmethod2pos(block4139, "_apply", &meth_parser_4140__apply, 0);
  int argcv_meth_parser_4140__apply[] = {0};
  meth_meth_parser_4140__apply->type = alloc_MethodType(1, argcv_meth_parser_4140__apply);
  meth_meth_parser_4140__apply->definitionModule = modulename;
  meth_meth_parser_4140__apply->definitionLine = 183;
// compiled block node returning block4139 (depth = 8)
  gc_frame_newslot(block4139);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block4139;
  partcv[0] = 1;
  Object call4144 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4138);
// compiled call node returning call4144 (depth = 7)
  Object if4137 = done;
  if (istrue(call4144)) {
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4145 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4146 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call4147 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4146);
// compiled member node returning call4147 (depth = 9)
  partcv[0] = 0;
  Object call4148 = callmethodflags(call4147, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4145);
// compiled member node returning call4148 (depth = 8)
  *var_suggestion = call4148;
  if (call4148 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4149 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array4150 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit4151 == NULL) {
    strlit4151 = alloc_String("rparen");
    gc_root(strlit4151);
  }
// compiled string node returning strlit4151 (depth = 10)
  params[0] = strlit4151;
  partcv[0] = 1;
  callmethodflags(array4150, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4150 (depth = 9)
  gc_frame_newslot(array4150);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = array4150;
  partcv[0] = 1;
  Object call4152 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4149);
// compiled call node returning call4152 (depth = 8)
  *var_nextTok = call4152;
  if (call4152 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4154 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4154 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4156 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4156 (depth = 8)
  Object if4153 = done;
  if (istrue(opresult4156)) {
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4157 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4158 == NULL) {
    strlit4158 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4158);
  }
// compiled string node returning strlit4158 (depth = 9)
  gc_frame_newslot(strlit4158);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4158;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4159 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4157);
// compiled call node returning call4159 (depth = 8)
    gc_frame_newslot(call4159);
    if4153 = call4159;
  } else {
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4160 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe4161 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4162 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4161);
// compiled member node returning call4162 (depth = 9)
  gc_frame_newslot(call4162);
// starting to compile identifier node (depth = 9)
  Object bool4163 = alloc_Boolean(1);
// compiled identifier node returning bool4163 (depth = 9)
  gc_frame_newslot(bool4163);
// starting to compile identifier node (depth = 9)
  Object bool4164 = alloc_Boolean(0);
// compiled identifier node returning bool4164 (depth = 9)
  gc_frame_newslot(bool4164);
// starting to compile string node (depth = 9)
  if (strlit4165 == NULL) {
    strlit4165 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4165);
  }
// compiled string node returning strlit4165 (depth = 9)
  gc_frame_newslot(strlit4165);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call4162;
  params[2] = bool4163;
  params[3] = bool4164;
  params[4] = strlit4165;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4166 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4160);
// compiled call node returning call4166 (depth = 8)
    gc_frame_newslot(call4166);
    if4153 = call4166;
  }
// compiled if node returning if4153 (depth = 7)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4167 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4168 == NULL) {
    strlit4168 = alloc_String("a match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4168);
  }
// compiled string node returning strlit4168 (depth = 8)
  gc_frame_newslot(strlit4168);
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe4169 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4170 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4169);
// compiled member node returning call4170 (depth = 8)
  gc_frame_newslot(call4170);
// starting to compile member node (depth = 8)
  int callframe4171 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4172 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4171);
// compiled member node returning call4172 (depth = 8)
  gc_frame_newslot(call4172);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4168;
  params[1] = call4170;
  params[2] = call4172;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4173 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4167);
// compiled call node returning call4173 (depth = 7)
    gc_frame_newslot(call4173);
    if4137 = call4173;
  } else {
  }
// compiled if node returning if4137 (depth = 6)
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4176 == NULL) {
    strlit4176 = alloc_String("rparen");
    gc_root(strlit4176);
  }
// compiled string node returning strlit4176 (depth = 8)
  int op_slot_right_4175 = gc_frame_newslot(strlit4176);
// starting to compile member node (depth = 8)
  int callframe4178 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4179 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe4178);
// compiled member node returning call4179 (depth = 8)
  int op_slot_left_4175 = gc_frame_newslot(call4179);
  params[0] = strlit4176;
  partcv[0] = 1;
  Object opresult4180 = callmethod(call4179, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4180 (depth = 7)
  Object if4174 = done;
  if (istrue(opresult4180)) {
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4181 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4182 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4181);
// compiled member node returning call4182 (depth = 7)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4183 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4184 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call4185 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4184);
// compiled member node returning call4185 (depth = 9)
  partcv[0] = 0;
  Object call4186 = callmethodflags(call4185, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4183);
// compiled member node returning call4186 (depth = 8)
  *var_suggestion = call4186;
  if (call4186 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4187 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4188 == NULL) {
    strlit4188 = alloc_String(")");
    gc_root(strlit4188);
  }
// compiled string node returning strlit4188 (depth = 8)
  gc_frame_newslot(strlit4188);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4188;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4189 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4187);
// compiled call node returning call4189 (depth = 7)
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4190 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4191 == NULL) {
    strlit4191 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4191);
  }
// compiled string node returning strlit4191 (depth = 8)
  gc_frame_newslot(strlit4191);
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe4192 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4193 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4192);
// compiled member node returning call4193 (depth = 8)
  gc_frame_newslot(call4193);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4196 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4195);
// compiled member node returning call4196 (depth = 9)
  int op_slot_right_4194 = gc_frame_newslot(call4196);
// starting to compile member node (depth = 9)
  int callframe4198 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4199 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4198);
// compiled member node returning call4199 (depth = 9)
  int op_slot_left_4194 = gc_frame_newslot(call4199);
  params[0] = call4196;
  partcv[0] = 1;
  Object sum4200 = callmethod(call4199, "+(1)", 1, partcv, params);
// compiled op node returning sum4200 (depth = 8)
  gc_frame_newslot(sum4200);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4191;
  params[1] = call4193;
  params[2] = sum4200;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4201 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4190);
// compiled call node returning call4201 (depth = 7)
    gc_frame_newslot(call4201);
    if4174 = call4201;
  } else {
  }
// compiled if node returning if4174 (depth = 6)
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4202 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4203 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4202);
// compiled member node returning call4203 (depth = 6)
    gc_frame_newslot(call4203);
    if4131 = call4203;
  } else {
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array4204 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4204 (depth = 7)
  *var_suggestions = array4204;
  if (array4204 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4205 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4206 = callmethodflags(module_parser, "findNextTokenIndentedAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4205);
// compiled call node returning call4206 (depth = 7)
  *var_nextTok = call4206;
  if (call4206 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4207 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4208 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4209 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4208);
// compiled member node returning call4209 (depth = 8)
  partcv[0] = 0;
  Object call4210 = callmethodflags(call4209, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4207);
// compiled member node returning call4210 (depth = 7)
  *var_suggestion = call4210;
  if (call4210 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_4212 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool4214 = alloc_Boolean(0);
// compiled identifier node returning bool4214 (depth = 8)
  int op_slot_left_4212 = gc_frame_newslot(bool4214);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult4215 = callmethod(bool4214, "==(1)", 1, partcv, params);
// compiled op node returning opresult4215 (depth = 7)
  Object if4211 = done;
  if (istrue(opresult4215)) {
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4216 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4217 == NULL) {
    strlit4217 = alloc_String(" }");
    gc_root(strlit4217);
  }
// compiled string node returning strlit4217 (depth = 8)
  gc_frame_newslot(strlit4217);
// starting to compile member node (depth = 8)
  int callframe4218 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call4219 = callmethodflags(*var_tokens, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4218);
// compiled member node returning call4219 (depth = 8)
  gc_frame_newslot(call4219);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4217;
  params[1] = call4219;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4220 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4216);
// compiled call node returning call4220 (depth = 7)
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4221 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4222 == NULL) {
    strlit4222 = alloc_String(" {");
    gc_root(strlit4222);
  }
// compiled string node returning strlit4222 (depth = 8)
  gc_frame_newslot(strlit4222);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4222;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4223 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4221);
// compiled call node returning call4223 (depth = 7)
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4224 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4225 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4224);
// compiled call node returning call4225 (depth = 7)
    gc_frame_newslot(call4225);
    if4211 = call4225;
  } else {
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4227 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4227 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4229 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4229 (depth = 8)
  Object if4226 = done;
  if (istrue(opresult4229)) {
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4230 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4231 == NULL) {
    strlit4231 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4231);
  }
// compiled string node returning strlit4231 (depth = 9)
  gc_frame_newslot(strlit4231);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4231;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4232 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4230);
// compiled call node returning call4232 (depth = 8)
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4233 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4234 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4233);
// compiled call node returning call4234 (depth = 8)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4235 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe4236 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4237 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4236);
// compiled member node returning call4237 (depth = 10)
  partcv[0] = 0;
  Object call4238 = callmethodflags(call4237, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4235);
// compiled member node returning call4238 (depth = 9)
  *var_suggestion = call4238;
  if (call4238 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4240 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4241 == NULL) {
    strlit4241 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4241);
  }
// compiled string node returning strlit4241 (depth = 9)
  gc_frame_newslot(strlit4241);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4241;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4242 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4240);
// compiled call node returning call4242 (depth = 8)
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4243 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4244 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4243);
// compiled call node returning call4244 (depth = 8)
    gc_frame_newslot(call4244);
    if4226 = call4244;
  } else {
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4245 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4246 == NULL) {
    strlit4246 = alloc_String(" }");
    gc_root(strlit4246);
  }
// compiled string node returning strlit4246 (depth = 9)
  gc_frame_newslot(strlit4246);
// starting to compile member node (depth = 9)
  int callframe4247 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4248 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4247);
// compiled member node returning call4248 (depth = 9)
  gc_frame_newslot(call4248);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4246;
  params[1] = call4248;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4249 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4245);
// compiled call node returning call4249 (depth = 8)
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4250 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4251 == NULL) {
    strlit4251 = alloc_String(" {");
    gc_root(strlit4251);
  }
// compiled string node returning strlit4251 (depth = 9)
  gc_frame_newslot(strlit4251);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4251;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4252 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4250);
// compiled call node returning call4252 (depth = 8)
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4253 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4254 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4253);
// compiled call node returning call4254 (depth = 8)
    gc_frame_newslot(call4254);
    if4226 = call4254;
  }
// compiled if node returning if4226 (depth = 7)
    gc_frame_newslot(if4226);
    if4211 = if4226;
  }
// compiled if node returning if4211 (depth = 6)
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4255 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4256 == NULL) {
    strlit4256 = alloc_String("a match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4256);
  }
// compiled string node returning strlit4256 (depth = 7)
  gc_frame_newslot(strlit4256);
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4257 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4258 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4257);
// compiled member node returning call4258 (depth = 7)
  gc_frame_newslot(call4258);
// starting to compile member node (depth = 7)
  int callframe4259 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4260 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4259);
// compiled member node returning call4260 (depth = 7)
  gc_frame_newslot(call4260);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4256;
  params[1] = call4258;
  params[2] = call4260;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4261 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4255);
// compiled call node returning call4261 (depth = 6)
    gc_frame_newslot(call4261);
    if4131 = call4261;
  }
// compiled if node returning if4131 (depth = 5)
    gc_frame_newslot(if4131);
    if4125 = if4131;
  }
// compiled if node returning if4125 (depth = 4)
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4262 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4263 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4264 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe4263);
// compiled member node returning call4264 (depth = 5)
  gc_frame_newslot(call4264);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call4264;
  partcv[0] = 1;
  Object call4265 = callmethodflags(*var_cases, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4262);
// compiled call node returning call4265 (depth = 4)
  gc_frame_end(frame);
  return call4265;
}
Object meth_parser_3911_matchcase(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_matchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "matchTok");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_matchee = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "matchee");
// definebindings:
// definebindings:
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3913 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3916 == NULL) {
    strlit3916 = alloc_String("match");
    gc_root(strlit3916);
  }
// compiled string node returning strlit3916 (depth = 6)
  int op_slot_right_3915 = gc_frame_newslot(strlit3916);
// starting to compile member node (depth = 6)
  int callframe3918 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3919 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe3918);
// compiled member node returning call3919 (depth = 6)
  int op_slot_left_3915 = gc_frame_newslot(call3919);
  params[0] = strlit3916;
  partcv[0] = 1;
  Object opresult3920 = callmethod(call3919, "==(1)", 1, partcv, params);
// compiled op node returning opresult3920 (depth = 5)
  int op_slot_right_3914 = gc_frame_newslot(opresult3920);
// starting to compile call node (depth = 5)
  int callframe3922 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3923 == NULL) {
    strlit3923 = alloc_String("identifier");
    gc_root(strlit3923);
  }
// compiled string node returning strlit3923 (depth = 6)
  gc_frame_newslot(strlit3923);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit3923;
  partcv[0] = 1;
  Object call3924 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3922);
// compiled call node returning call3924 (depth = 5)
  int op_slot_left_3914 = gc_frame_newslot(call3924);
  params[0] = opresult3920;
  partcv[0] = 1;
  Object opresult3925 = callmethod(call3924, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3925 (depth = 4)
  partcv[0] = 0;
  Object call3926 = callmethodflags(opresult3925, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3913);
// compiled call node returning call3926 (depth = 3)
  Object if3912 = done;
  if (istrue(call3926)) {
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3927 = alloc_Float64(0);
// compiled num node returning num3927 (depth = 4)
  return num3927;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3912 = undefined;
  } else {
  }
// compiled if node returning if3912 (depth = 2)
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_matchTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3928 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3929 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3928);
// compiled member node returning call3929 (depth = 2)
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3932 == NULL) {
    strlit3932 = alloc_String("lparen");
    gc_root(strlit3932);
  }
// compiled string node returning strlit3932 (depth = 4)
  int op_slot_right_3931 = gc_frame_newslot(strlit3932);
// starting to compile member node (depth = 4)
  int callframe3934 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call3935 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3934);
// compiled member node returning call3935 (depth = 4)
  int op_slot_left_3931 = gc_frame_newslot(call3935);
  params[0] = strlit3932;
  partcv[0] = 1;
  Object opresult3936 = callmethod(call3935, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3936 (depth = 3)
  Object if3930 = done;
  if (istrue(opresult3936)) {
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3937 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3938 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call3939 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe3938);
// compiled member node returning call3939 (depth = 5)
  partcv[0] = 0;
  Object call3940 = callmethodflags(call3939, "new", 1, partcv, params, 0);
  gc_frame_end(callframe3937);
// compiled member node returning call3940 (depth = 4)
  *var_suggestion = call3940;
  if (call3940 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3941 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3942 = alloc_Block(NULL, NULL, "parser", 1351);
  gc_frame_newslot(block3942);
// method "_apply(_)"
  block_savedest(block3942);
  Object closure3943 = createclosure(2, "_apply(1)");
  setclosureframe(closure3943, stackframe);
  addtoclosure(closure3943, var_matchTok);
  addtoclosure(closure3943, selfslot);
  struct UserObject *uo3943 = (struct UserObject*)block3942;
  uo3943->data[0] = (Object)closure3943;
  Method *meth_meth_parser_3943__apply_40_1_41_ = addmethod2pos(block3942, "_apply(1)", &meth_parser_3943__apply_40_1_41_, 0);
  int argcv_meth_parser_3943__apply_40_1_41_[] = {1};
  meth_meth_parser_3943__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_3943__apply_40_1_41_);
  meth_meth_parser_3943__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_3943__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block3942 (depth = 5)
  gc_frame_newslot(block3942);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block3942;
  partcv[0] = 1;
  Object call3979 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3941);
// compiled call node returning call3979 (depth = 4)
  *var_nextTok = call3979;
  if (call3979 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_right_3981 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 5)
  Object bool3983 = alloc_Boolean(0);
// compiled identifier node returning bool3983 (depth = 5)
  int op_slot_left_3981 = gc_frame_newslot(bool3983);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3984 = callmethod(bool3983, "==(1)", 1, partcv, params);
// compiled op node returning opresult3984 (depth = 4)
  Object if3980 = done;
  if (istrue(opresult3984)) {
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3985 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3986 == NULL) {
    strlit3986 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3986);
  }
// compiled string node returning strlit3986 (depth = 5)
  gc_frame_newslot(strlit3986);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  gc_frame_newslot(*var_matchTok);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3986;
  params[1] = *var_matchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3987 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3985);
// compiled call node returning call3987 (depth = 4)
    gc_frame_newslot(call3987);
    if3980 = call3987;
  } else {
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3990 == NULL) {
    strlit3990 = alloc_String("rparen");
    gc_root(strlit3990);
  }
// compiled string node returning strlit3990 (depth = 6)
  int op_slot_right_3989 = gc_frame_newslot(strlit3990);
// starting to compile member node (depth = 6)
  int callframe3992 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call3993 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe3992);
// compiled member node returning call3993 (depth = 6)
  int op_slot_left_3989 = gc_frame_newslot(call3993);
  params[0] = strlit3990;
  partcv[0] = 1;
  Object opresult3994 = callmethod(call3993, "==(1)", 1, partcv, params);
// compiled op node returning opresult3994 (depth = 5)
  Object if3988 = done;
  if (istrue(opresult3994)) {
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3996 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3996 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3998 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3998 (depth = 6)
  Object if3995 = done;
  if (istrue(opresult3998)) {
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3999 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4000 == NULL) {
    strlit4000 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4000);
  }
// compiled string node returning strlit4000 (depth = 7)
  gc_frame_newslot(strlit4000);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4000;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4001 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3999);
// compiled call node returning call4001 (depth = 6)
    gc_frame_newslot(call4001);
    if3995 = call4001;
  } else {
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4002 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4003 == NULL) {
    strlit4003 = alloc_String("(");
    gc_root(strlit4003);
  }
// compiled string node returning strlit4003 (depth = 7)
  gc_frame_newslot(strlit4003);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4003;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4004 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4002);
// compiled call node returning call4004 (depth = 6)
    gc_frame_newslot(call4004);
    if3995 = call4004;
  }
// compiled if node returning if3995 (depth = 5)
    gc_frame_newslot(if3995);
    if3988 = if3995;
  } else {
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4007 == NULL) {
    strlit4007 = alloc_String("identifier");
    gc_root(strlit4007);
  }
// compiled string node returning strlit4007 (depth = 7)
  int op_slot_right_4006 = gc_frame_newslot(strlit4007);
// starting to compile member node (depth = 7)
  int callframe4009 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4010 = callmethodflags(*var_nextTok, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe4009);
// compiled member node returning call4010 (depth = 7)
  int op_slot_left_4006 = gc_frame_newslot(call4010);
  params[0] = strlit4007;
  partcv[0] = 1;
  Object opresult4011 = callmethod(call4010, "==(1)", 1, partcv, params);
// compiled op node returning opresult4011 (depth = 6)
  Object if4005 = done;
  if (istrue(opresult4011)) {
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4012 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4013 == NULL) {
    strlit4013 = alloc_String("(");
    gc_root(strlit4013);
  }
// compiled string node returning strlit4013 (depth = 7)
  gc_frame_newslot(strlit4013);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4013;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4014 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4012);
// compiled call node returning call4014 (depth = 6)
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4015 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4016 == NULL) {
    strlit4016 = alloc_String(")");
    gc_root(strlit4016);
  }
// compiled string node returning strlit4016 (depth = 7)
  gc_frame_newslot(strlit4016);
// starting to compile member node (depth = 7)
  int callframe4017 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4018 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4017);
// compiled member node returning call4018 (depth = 7)
  gc_frame_newslot(call4018);
// starting to compile identifier node (depth = 7)
  Object bool4019 = alloc_Boolean(1);
// compiled identifier node returning bool4019 (depth = 7)
  gc_frame_newslot(bool4019);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4016;
  params[1] = call4018;
  params[2] = bool4019;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4020 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4015);
// compiled call node returning call4020 (depth = 6)
    gc_frame_newslot(call4020);
    if4005 = call4020;
  } else {
  }
// compiled if node returning if4005 (depth = 5)
    gc_frame_newslot(if4005);
    if3988 = if4005;
  }
// compiled if node returning if3988 (depth = 4)
    gc_frame_newslot(if3988);
    if3980 = if3988;
  }
// compiled if node returning if3980 (depth = 3)
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4021 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4022 == NULL) {
    strlit4022 = alloc_String("a match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4022);
  }
// compiled string node returning strlit4022 (depth = 4)
  gc_frame_newslot(strlit4022);
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4023 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  partcv[0] = 0;
  Object call4024 = callmethodflags(*var_matchTok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4023);
// compiled member node returning call4024 (depth = 4)
  gc_frame_newslot(call4024);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4026 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchTok (depth = 6)
  partcv[0] = 0;
  Object call4027 = callmethodflags(*var_matchTok, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4026);
// compiled member node returning call4027 (depth = 5)
  int op_slot_right_4025 = gc_frame_newslot(call4027);
// starting to compile member node (depth = 5)
  int callframe4029 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchTok (depth = 6)
  partcv[0] = 0;
  Object call4030 = callmethodflags(*var_matchTok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4029);
// compiled member node returning call4030 (depth = 5)
  int op_slot_left_4025 = gc_frame_newslot(call4030);
  params[0] = call4027;
  partcv[0] = 1;
  Object sum4031 = callmethod(call4030, "+(1)", 1, partcv, params);
// compiled op node returning sum4031 (depth = 4)
  gc_frame_newslot(sum4031);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4022;
  params[1] = call4024;
  params[2] = sum4031;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4032 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4021);
// compiled call node returning call4032 (depth = 3)
    gc_frame_newslot(call4032);
    if3930 = call4032;
  } else {
  }
// compiled if node returning if3930 (depth = 2)
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4033 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4034 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4033);
// compiled member node returning call4034 (depth = 2)
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4036 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block4037 = alloc_Block(NULL, NULL, "parser", 1369);
  gc_frame_newslot(block4037);
// method "_apply"
  block_savedest(block4037);
  Object closure4038 = createclosure(2, "_apply");
  setclosureframe(closure4038, stackframe);
  addtoclosure(closure4038, var_blocksOK);
  addtoclosure(closure4038, selfslot);
  struct UserObject *uo4038 = (struct UserObject*)block4037;
  uo4038->data[0] = (Object)closure4038;
  Method *meth_meth_parser_4038__apply = addmethod2pos(block4037, "_apply", &meth_parser_4038__apply, 0);
  int argcv_meth_parser_4038__apply[] = {0};
  meth_meth_parser_4038__apply->type = alloc_MethodType(1, argcv_meth_parser_4038__apply);
  meth_meth_parser_4038__apply->definitionModule = modulename;
  meth_meth_parser_4038__apply->definitionLine = 183;
// compiled block node returning block4037 (depth = 4)
  gc_frame_newslot(block4037);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = block4037;
  partcv[0] = 1;
  Object call4042 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4036);
// compiled call node returning call4042 (depth = 3)
  Object if4035 = done;
  if (istrue(call4042)) {
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4043 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4044 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call4045 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4044);
// compiled member node returning call4045 (depth = 5)
  partcv[0] = 0;
  Object call4046 = callmethodflags(call4045, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4043);
// compiled member node returning call4046 (depth = 4)
  *var_suggestion = call4046;
  if (call4046 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4047 = gc_frame_new();
// starting to compile array node (depth = 5)
  Object array4048 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 6)
  if (strlit4049 == NULL) {
    strlit4049 = alloc_String("rparen");
    gc_root(strlit4049);
  }
// compiled string node returning strlit4049 (depth = 6)
  params[0] = strlit4049;
  partcv[0] = 1;
  callmethodflags(array4048, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4048 (depth = 5)
  gc_frame_newslot(array4048);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = array4048;
  partcv[0] = 1;
  Object call4050 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4047);
// compiled call node returning call4050 (depth = 4)
  *var_nextTok = call4050;
  if (call4050 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_4052 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_4052 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4054 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4054 (depth = 4)
  Object if4051 = done;
  if (istrue(opresult4054)) {
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4055 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4056 == NULL) {
    strlit4056 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4056);
  }
// compiled string node returning strlit4056 (depth = 5)
  gc_frame_newslot(strlit4056);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4056;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4057 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4055);
// compiled call node returning call4057 (depth = 4)
    gc_frame_newslot(call4057);
    if4051 = call4057;
  } else {
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4058 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
  int callframe4059 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  partcv[0] = 0;
  Object call4060 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4059);
// compiled member node returning call4060 (depth = 5)
  gc_frame_newslot(call4060);
// starting to compile identifier node (depth = 5)
  Object bool4061 = alloc_Boolean(1);
// compiled identifier node returning bool4061 (depth = 5)
  gc_frame_newslot(bool4061);
// starting to compile identifier node (depth = 5)
  Object bool4062 = alloc_Boolean(0);
// compiled identifier node returning bool4062 (depth = 5)
  gc_frame_newslot(bool4062);
// starting to compile string node (depth = 5)
  if (strlit4063 == NULL) {
    strlit4063 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4063);
  }
// compiled string node returning strlit4063 (depth = 5)
  gc_frame_newslot(strlit4063);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call4060;
  params[2] = bool4061;
  params[3] = bool4062;
  params[4] = strlit4063;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4064 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4058);
// compiled call node returning call4064 (depth = 4)
    gc_frame_newslot(call4064);
    if4051 = call4064;
  }
// compiled if node returning if4051 (depth = 3)
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4065 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4066 == NULL) {
    strlit4066 = alloc_String("a match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4066);
  }
// compiled string node returning strlit4066 (depth = 4)
  gc_frame_newslot(strlit4066);
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4067 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4068 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4067);
// compiled member node returning call4068 (depth = 4)
  gc_frame_newslot(call4068);
// starting to compile member node (depth = 4)
  int callframe4069 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4070 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4069);
// compiled member node returning call4070 (depth = 4)
  gc_frame_newslot(call4070);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4066;
  params[1] = call4068;
  params[2] = call4070;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4071 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4065);
// compiled call node returning call4071 (depth = 3)
    gc_frame_newslot(call4071);
    if4035 = call4071;
  } else {
  }
// compiled if node returning if4035 (depth = 2)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4072 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  partcv[0] = 0;
  Object call4073 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe4072);
// compiled member node returning call4073 (depth = 3)
  *var_matchee = call4073;
  if (call4073 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4076 == NULL) {
    strlit4076 = alloc_String("rparen");
    gc_root(strlit4076);
  }
// compiled string node returning strlit4076 (depth = 4)
  int op_slot_right_4075 = gc_frame_newslot(strlit4076);
// starting to compile member node (depth = 4)
  int callframe4078 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4079 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe4078);
// compiled member node returning call4079 (depth = 4)
  int op_slot_left_4075 = gc_frame_newslot(call4079);
  params[0] = strlit4076;
  partcv[0] = 1;
  Object opresult4080 = callmethod(call4079, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4080 (depth = 3)
  Object if4074 = done;
  if (istrue(opresult4080)) {
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4081 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4082 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4081);
// compiled member node returning call4082 (depth = 3)
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4083 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4084 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call4085 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4084);
// compiled member node returning call4085 (depth = 5)
  partcv[0] = 0;
  Object call4086 = callmethodflags(call4085, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4083);
// compiled member node returning call4086 (depth = 4)
  *var_suggestion = call4086;
  if (call4086 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4087 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4088 == NULL) {
    strlit4088 = alloc_String(")");
    gc_root(strlit4088);
  }
// compiled string node returning strlit4088 (depth = 4)
  gc_frame_newslot(strlit4088);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit4088;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4089 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4087);
// compiled call node returning call4089 (depth = 3)
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4090 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4091 == NULL) {
    strlit4091 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4091);
  }
// compiled string node returning strlit4091 (depth = 4)
  gc_frame_newslot(strlit4091);
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4092 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call4093 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4092);
// compiled member node returning call4093 (depth = 4)
  gc_frame_newslot(call4093);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4095 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call4096 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4095);
// compiled member node returning call4096 (depth = 5)
  int op_slot_right_4094 = gc_frame_newslot(call4096);
// starting to compile member node (depth = 5)
  int callframe4098 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call4099 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4098);
// compiled member node returning call4099 (depth = 5)
  int op_slot_left_4094 = gc_frame_newslot(call4099);
  params[0] = call4096;
  partcv[0] = 1;
  Object sum4100 = callmethod(call4099, "+(1)", 1, partcv, params);
// compiled op node returning sum4100 (depth = 4)
  gc_frame_newslot(sum4100);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4091;
  params[1] = call4093;
  params[2] = sum4100;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4101 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4090);
// compiled call node returning call4101 (depth = 3)
    gc_frame_newslot(call4101);
    if4074 = call4101;
  } else {
  }
// compiled if node returning if4074 (depth = 2)
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4102 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4103 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4102);
// compiled member node returning call4103 (depth = 2)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4104 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4104 (depth = 3)
  *var_cases = array4104;
  if (array4104 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4105 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4106 = alloc_Block(NULL, NULL, "parser", 1390);
  gc_frame_newslot(block4106);
// method "_apply"
  block_savedest(block4106);
  Object closure4107 = createclosure(2, "_apply");
  setclosureframe(closure4107, stackframe);
  addtoclosure(closure4107, var_sym);
  addtoclosure(closure4107, selfslot);
  struct UserObject *uo4107 = (struct UserObject*)block4106;
  uo4107->data[0] = (Object)closure4107;
  Method *meth_meth_parser_4107__apply = addmethod2pos(block4106, "_apply", &meth_parser_4107__apply, 0);
  int argcv_meth_parser_4107__apply[] = {0};
  meth_meth_parser_4107__apply->type = alloc_MethodType(1, argcv_meth_parser_4107__apply);
  meth_meth_parser_4107__apply->definitionModule = modulename;
  meth_meth_parser_4107__apply->definitionLine = 183;
// compiled block node returning block4106 (depth = 3)
  gc_frame_newslot(block4106);
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4121 = alloc_Block(NULL, NULL, "parser", 1390);
  gc_frame_newslot(block4121);
// method "_apply"
  block_savedest(block4121);
  Object closure4122 = createclosure(8, "_apply");
  setclosureframe(closure4122, stackframe);
  addtoclosure(closure4122, var_blocksOK);
  addtoclosure(closure4122, var_errormessages);
  addtoclosure(closure4122, var_sym);
  addtoclosure(closure4122, var_lastToken);
  addtoclosure(closure4122, var_tokens);
  addtoclosure(closure4122, var_values);
  addtoclosure(closure4122, var_cases);
  addtoclosure(closure4122, selfslot);
  struct UserObject *uo4122 = (struct UserObject*)block4121;
  uo4122->data[0] = (Object)closure4122;
  Method *meth_meth_parser_4122__apply = addmethod2pos(block4121, "_apply", &meth_parser_4122__apply, 0);
  int argcv_meth_parser_4122__apply[] = {0};
  meth_meth_parser_4122__apply->type = alloc_MethodType(1, argcv_meth_parser_4122__apply);
  meth_meth_parser_4122__apply->definitionModule = modulename;
  meth_meth_parser_4122__apply->definitionLine = 183;
// compiled block node returning block4121 (depth = 3)
  gc_frame_newslot(block4121);
// call case 5: prelude request
  params[0] = block4106;
  params[1] = block4121;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4267 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4105);
// compiled call node returning call4267 (depth = 2)
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4268 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe4269 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchTok (depth = 4)
  partcv[0] = 0;
  Object call4270 = callmethodflags(*var_matchTok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4269);
// compiled member node returning call4270 (depth = 3)
  gc_frame_newslot(call4270);
// starting to compile member node (depth = 3)
  int callframe4271 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchTok (depth = 4)
  partcv[0] = 0;
  Object call4272 = callmethodflags(*var_matchTok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4271);
// compiled member node returning call4272 (depth = 3)
  gc_frame_newslot(call4272);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4270;
  params[1] = call4272;
  partcv[0] = 2;
  Object call4273 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4268);
// compiled call node returning call4273 (depth = 2)
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4274 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4275 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee (depth = 4)
  gc_frame_newslot(*var_matchee);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4276 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call4277 = callmethodflags(*var_ast, "matchCaseNode", 1, partcv, params, 0);
  gc_frame_end(callframe4276);
// compiled member node returning call4277 (depth = 4)
  params[0] = *var_matchee;
  params[1] = *var_cases;
  partcv[0] = 2;
  Object call4278 = callmethodflags(call4277, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4275);
// compiled call node returning call4278 (depth = 3)
  gc_frame_newslot(call4278);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4278;
  partcv[0] = 1;
  Object call4279 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4274);
// compiled call node returning call4279 (depth = 2)
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_4281_term(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "term");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4282 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe4283 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call4284 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4283);
// compiled member node returning call4284 (depth = 3)
  gc_frame_newslot(call4284);
// starting to compile member node (depth = 3)
  int callframe4285 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call4286 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4285);
// compiled member node returning call4286 (depth = 3)
  gc_frame_newslot(call4286);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4284;
  params[1] = call4286;
  partcv[0] = 2;
  Object call4287 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4282);
// compiled call node returning call4287 (depth = 2)
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4289 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4290 == NULL) {
    strlit4290 = alloc_String("num");
    gc_root(strlit4290);
  }
// compiled string node returning strlit4290 (depth = 4)
  gc_frame_newslot(strlit4290);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4290;
  partcv[0] = 1;
  Object call4291 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4289);
// compiled call node returning call4291 (depth = 3)
  Object if4288 = done;
  if (istrue(call4291)) {
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4292 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4293 = callmethodflags(self, "pushnum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4292);
// compiled member node returning call4293 (depth = 3)
    gc_frame_newslot(call4293);
    if4288 = call4293;
  } else {
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4295 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4296 == NULL) {
    strlit4296 = alloc_String("string");
    gc_root(strlit4296);
  }
// compiled string node returning strlit4296 (depth = 5)
  gc_frame_newslot(strlit4296);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit4296;
  partcv[0] = 1;
  Object call4297 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4295);
// compiled call node returning call4297 (depth = 4)
  Object if4294 = done;
  if (istrue(call4297)) {
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4298 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4299 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4298);
// compiled member node returning call4299 (depth = 4)
    gc_frame_newslot(call4299);
    if4294 = call4299;
  } else {
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4303 == NULL) {
    strlit4303 = alloc_String("match");
    gc_root(strlit4303);
  }
// compiled string node returning strlit4303 (depth = 7)
  int op_slot_right_4302 = gc_frame_newslot(strlit4303);
// starting to compile member node (depth = 7)
  int callframe4305 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4306 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4305);
// compiled member node returning call4306 (depth = 7)
  int op_slot_left_4302 = gc_frame_newslot(call4306);
  params[0] = strlit4303;
  partcv[0] = 1;
  Object opresult4307 = callmethod(call4306, "==(1)", 1, partcv, params);
// compiled op node returning opresult4307 (depth = 6)
  int op_slot_right_4301 = gc_frame_newslot(opresult4307);
// starting to compile call node (depth = 6)
  int callframe4309 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4310 == NULL) {
    strlit4310 = alloc_String("identifier");
    gc_root(strlit4310);
  }
// compiled string node returning strlit4310 (depth = 7)
  gc_frame_newslot(strlit4310);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit4310;
  partcv[0] = 1;
  Object call4311 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4309);
// compiled call node returning call4311 (depth = 6)
  int op_slot_left_4301 = gc_frame_newslot(call4311);
  params[0] = opresult4307;
  partcv[0] = 1;
  Object opresult4312 = callmethod(call4311, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4312 (depth = 5)
  Object if4300 = done;
  if (istrue(opresult4312)) {
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4313 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4314 = callmethodflags(self, "matchcase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4313);
// compiled member node returning call4314 (depth = 5)
    gc_frame_newslot(call4314);
    if4300 = call4314;
  } else {
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4318 == NULL) {
    strlit4318 = alloc_String("try");
    gc_root(strlit4318);
  }
// compiled string node returning strlit4318 (depth = 8)
  int op_slot_right_4317 = gc_frame_newslot(strlit4318);
// starting to compile member node (depth = 8)
  int callframe4320 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4321 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4320);
// compiled member node returning call4321 (depth = 8)
  int op_slot_left_4317 = gc_frame_newslot(call4321);
  params[0] = strlit4318;
  partcv[0] = 1;
  Object opresult4322 = callmethod(call4321, "==(1)", 1, partcv, params);
// compiled op node returning opresult4322 (depth = 7)
  int op_slot_right_4316 = gc_frame_newslot(opresult4322);
// starting to compile call node (depth = 7)
  int callframe4324 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4325 == NULL) {
    strlit4325 = alloc_String("identifier");
    gc_root(strlit4325);
  }
// compiled string node returning strlit4325 (depth = 8)
  gc_frame_newslot(strlit4325);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit4325;
  partcv[0] = 1;
  Object call4326 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4324);
// compiled call node returning call4326 (depth = 7)
  int op_slot_left_4316 = gc_frame_newslot(call4326);
  params[0] = opresult4322;
  partcv[0] = 1;
  Object opresult4327 = callmethod(call4326, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4327 (depth = 6)
  Object if4315 = done;
  if (istrue(opresult4327)) {
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4328 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4329 = callmethodflags(self, "trycatch", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4328);
// compiled member node returning call4329 (depth = 6)
    gc_frame_newslot(call4329);
    if4315 = call4329;
  } else {
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4331 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4332 == NULL) {
    strlit4332 = alloc_String("identifier");
    gc_root(strlit4332);
  }
// compiled string node returning strlit4332 (depth = 8)
  gc_frame_newslot(strlit4332);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit4332;
  partcv[0] = 1;
  Object call4333 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4331);
// compiled call node returning call4333 (depth = 7)
  Object if4330 = done;
  if (istrue(call4333)) {
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4334 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4335 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4334);
// compiled member node returning call4335 (depth = 7)
    gc_frame_newslot(call4335);
    if4330 = call4335;
  } else {
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4337 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4338 == NULL) {
    strlit4338 = alloc_String("object");
    gc_root(strlit4338);
  }
// compiled string node returning strlit4338 (depth = 9)
  gc_frame_newslot(strlit4338);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = strlit4338;
  partcv[0] = 1;
  Object call4339 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4337);
// compiled call node returning call4339 (depth = 8)
  Object if4336 = done;
  if (istrue(call4339)) {
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe4340 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4341 = callmethodflags(self, "doobject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4340);
// compiled member node returning call4341 (depth = 8)
    gc_frame_newslot(call4341);
    if4336 = call4341;
  } else {
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe4343 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit4344 == NULL) {
    strlit4344 = alloc_String("type");
    gc_root(strlit4344);
  }
// compiled string node returning strlit4344 (depth = 10)
  gc_frame_newslot(strlit4344);
// starting to compile string node (depth = 10)
  if (strlit4345 == NULL) {
    strlit4345 = alloc_String("interface");
    gc_root(strlit4345);
  }
// compiled string node returning strlit4345 (depth = 10)
  gc_frame_newslot(strlit4345);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = strlit4344;
  params[1] = strlit4345;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4346 = callmethodflags(module_parser, "acceptKeyword(1)or(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4343);
// compiled call node returning call4346 (depth = 9)
  Object if4342 = done;
  if (istrue(call4346)) {
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe4347 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4348 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4347);
// compiled member node returning call4348 (depth = 9)
    gc_frame_newslot(call4348);
    if4342 = call4348;
  } else {
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe4350 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit4351 == NULL) {
    strlit4351 = alloc_String("lbrace");
    gc_root(strlit4351);
  }
// compiled string node returning strlit4351 (depth = 11)
  gc_frame_newslot(strlit4351);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning module_parser (depth = 11)
  params[0] = strlit4351;
  partcv[0] = 1;
  Object call4352 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4350);
// compiled call node returning call4352 (depth = 10)
  Object if4349 = done;
  if (istrue(call4352)) {
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe4353 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4354 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4353);
// compiled member node returning call4354 (depth = 10)
    gc_frame_newslot(call4354);
    if4349 = call4354;
  } else {
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe4356 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit4357 == NULL) {
    strlit4357 = alloc_String("lsquare");
    gc_root(strlit4357);
  }
// compiled string node returning strlit4357 (depth = 12)
  gc_frame_newslot(strlit4357);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning module_parser (depth = 12)
  params[0] = strlit4357;
  partcv[0] = 1;
  Object call4358 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4356);
// compiled call node returning call4358 (depth = 11)
  Object if4355 = done;
  if (istrue(call4358)) {
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
  int callframe4359 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4360 = callmethodflags(self, "doarray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4359);
// compiled member node returning call4360 (depth = 11)
    gc_frame_newslot(call4360);
    if4355 = call4360;
  } else {
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe4362 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit4363 == NULL) {
    strlit4363 = alloc_String("op");
    gc_root(strlit4363);
  }
// compiled string node returning strlit4363 (depth = 13)
  gc_frame_newslot(strlit4363);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning module_parser (depth = 13)
  params[0] = strlit4363;
  partcv[0] = 1;
  Object call4364 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4362);
// compiled call node returning call4364 (depth = 12)
  Object if4361 = done;
  if (istrue(call4364)) {
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
  int callframe4365 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4366 = callmethodflags(self, "prefixop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4365);
// compiled member node returning call4366 (depth = 12)
    gc_frame_newslot(call4366);
    if4361 = call4366;
  } else {
  }
// compiled if node returning if4361 (depth = 11)
    gc_frame_newslot(if4361);
    if4355 = if4361;
  }
// compiled if node returning if4355 (depth = 10)
    gc_frame_newslot(if4355);
    if4349 = if4355;
  }
// compiled if node returning if4349 (depth = 9)
    gc_frame_newslot(if4349);
    if4342 = if4349;
  }
// compiled if node returning if4342 (depth = 8)
    gc_frame_newslot(if4342);
    if4336 = if4342;
  }
// compiled if node returning if4336 (depth = 7)
    gc_frame_newslot(if4336);
    if4330 = if4336;
  }
// compiled if node returning if4330 (depth = 6)
    gc_frame_newslot(if4330);
    if4315 = if4330;
  }
// compiled if node returning if4315 (depth = 5)
    gc_frame_newslot(if4315);
    if4300 = if4315;
  }
// compiled if node returning if4300 (depth = 4)
    gc_frame_newslot(if4300);
    if4294 = if4300;
  }
// compiled if node returning if4294 (depth = 3)
    gc_frame_newslot(if4294);
    if4288 = if4294;
  }
// compiled if node returning if4288 (depth = 2)
  gc_frame_end(frame);
  return if4288;
}
Object meth_parser_4393__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_acceptBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe4394 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_acceptBlocks (depth = 8)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4395 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4394);
// compiled call node returning call4395 (depth = 7)
  gc_frame_end(frame);
  return call4395;
}
Object meth_parser_4367_expression_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expression(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expression(_)");
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expression(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part expression(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// definebindings:
  Object *var_tmpStatementToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tmpStatementToken");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4368 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  partcv[0] = 0;
  Object call4369 = callmethodflags(*var_values, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4368);
// compiled member node returning call4369 (depth = 3)
  *var_sz = call4369;
  if (call4369 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4370 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe4371 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call4372 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4371);
// compiled member node returning call4372 (depth = 3)
  gc_frame_newslot(call4372);
// starting to compile member node (depth = 3)
  int callframe4373 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call4374 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4373);
// compiled member node returning call4374 (depth = 3)
  gc_frame_newslot(call4374);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4372;
  params[1] = call4374;
  partcv[0] = 2;
  Object call4375 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4370);
// compiled call node returning call4375 (depth = 2)
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4377 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4378 == NULL) {
    strlit4378 = alloc_String("lparen");
    gc_root(strlit4378);
  }
// compiled string node returning strlit4378 (depth = 4)
  gc_frame_newslot(strlit4378);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4378;
  partcv[0] = 1;
  Object call4379 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4377);
// compiled call node returning call4379 (depth = 3)
  Object if4376 = done;
  if (istrue(call4379)) {
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_tmpStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4381 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4382 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4383 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4382);
// compiled member node returning call4383 (depth = 4)
  gc_frame_newslot(call4383);
// starting to compile member node (depth = 4)
  int callframe4384 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4385 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4384);
// compiled member node returning call4385 (depth = 4)
  gc_frame_newslot(call4385);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call4383;
  params[1] = call4385;
  partcv[0] = 2;
  Object call4386 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4381);
// compiled call node returning call4386 (depth = 3)
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4388 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4387);
// compiled member node returning call4388 (depth = 3)
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4390 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe4391 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4392 = alloc_Block(NULL, NULL, "parser", 1483);
  gc_frame_newslot(block4392);
// method "_apply"
  block_savedest(block4392);
  Object closure4393 = createclosure(2, "_apply");
  setclosureframe(closure4393, stackframe);
  addtoclosure(closure4393, var_acceptBlocks);
  addtoclosure(closure4393, selfslot);
  struct UserObject *uo4393 = (struct UserObject*)block4392;
  uo4393->data[0] = (Object)closure4393;
  Method *meth_meth_parser_4393__apply = addmethod2pos(block4392, "_apply", &meth_parser_4393__apply, 0);
  int argcv_meth_parser_4393__apply[] = {0};
  meth_meth_parser_4393__apply->type = alloc_MethodType(1, argcv_meth_parser_4393__apply);
  meth_meth_parser_4393__apply->definitionModule = modulename;
  meth_meth_parser_4393__apply->definitionLine = 183;
// compiled block node returning block4392 (depth = 6)
  gc_frame_newslot(block4392);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block4392;
  partcv[0] = 1;
  Object call4397 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4391);
// compiled call node returning call4397 (depth = 5)
  partcv[0] = 0;
  Object call4398 = callmethodflags(call4397, "not", 1, partcv, params, 0);
  gc_frame_end(callframe4390);
// compiled member node returning call4398 (depth = 4)
  Object if4389 = done;
  if (istrue(call4398)) {
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4399 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4400 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call4401 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4400);
// compiled member node returning call4401 (depth = 6)
  partcv[0] = 0;
  Object call4402 = callmethodflags(call4401, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4399);
// compiled member node returning call4402 (depth = 5)
  *var_suggestion = call4402;
  if (call4402 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4403 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array4404 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit4405 == NULL) {
    strlit4405 = alloc_String("rparen");
    gc_root(strlit4405);
  }
// compiled string node returning strlit4405 (depth = 7)
  params[0] = strlit4405;
  partcv[0] = 1;
  callmethodflags(array4404, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4404 (depth = 6)
  gc_frame_newslot(array4404);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = array4404;
  partcv[0] = 1;
  Object call4406 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4403);
// compiled call node returning call4406 (depth = 5)
  *var_nextTok = call4406;
  if (call4406 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_4408 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4408 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4410 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4410 (depth = 5)
  Object if4407 = done;
  if (istrue(opresult4410)) {
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4411 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4412 == NULL) {
    strlit4412 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4412);
  }
// compiled string node returning strlit4412 (depth = 6)
  gc_frame_newslot(strlit4412);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4412;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4413 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4411);
// compiled call node returning call4413 (depth = 5)
    gc_frame_newslot(call4413);
    if4407 = call4413;
  } else {
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4414 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe4415 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call4416 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4415);
// compiled member node returning call4416 (depth = 6)
  gc_frame_newslot(call4416);
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool4417 = alloc_Boolean(1);
// compiled identifier node returning bool4417 (depth = 6)
  gc_frame_newslot(bool4417);
// starting to compile identifier node (depth = 6)
  Object bool4418 = alloc_Boolean(0);
// compiled identifier node returning bool4418 (depth = 6)
  gc_frame_newslot(bool4418);
// starting to compile string node (depth = 6)
  if (strlit4419 == NULL) {
    strlit4419 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4419);
  }
// compiled string node returning strlit4419 (depth = 6)
  gc_frame_newslot(strlit4419);
// call case 6: other requests
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call4416;
  params[2] = bool4417;
  params[3] = bool4418;
  params[4] = strlit4419;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4420 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4414);
// compiled call node returning call4420 (depth = 5)
    gc_frame_newslot(call4420);
    if4407 = call4420;
  }
// compiled if node returning if4407 (depth = 4)
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4421 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4422 == NULL) {
    strlit4422 = alloc_String("parentheses must contain a valid expression.");
    gc_root(strlit4422);
  }
// compiled string node returning strlit4422 (depth = 5)
  gc_frame_newslot(strlit4422);
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4423 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4424 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4423);
// compiled member node returning call4424 (depth = 5)
  gc_frame_newslot(call4424);
// starting to compile member node (depth = 5)
  int callframe4425 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4426 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4425);
// compiled member node returning call4426 (depth = 5)
  gc_frame_newslot(call4426);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4422;
  params[1] = call4424;
  params[2] = call4426;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4427 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4421);
// compiled call node returning call4427 (depth = 4)
    gc_frame_newslot(call4427);
    if4389 = call4427;
  } else {
  }
// compiled if node returning if4389 (depth = 3)
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4430 == NULL) {
    strlit4430 = alloc_String("rparen");
    gc_root(strlit4430);
  }
// compiled string node returning strlit4430 (depth = 5)
  int op_slot_right_4429 = gc_frame_newslot(strlit4430);
// starting to compile member node (depth = 5)
  int callframe4432 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4433 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe4432);
// compiled member node returning call4433 (depth = 5)
  int op_slot_left_4429 = gc_frame_newslot(call4433);
  params[0] = strlit4430;
  partcv[0] = 1;
  Object opresult4434 = callmethod(call4433, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4434 (depth = 4)
  Object if4428 = done;
  if (istrue(opresult4434)) {
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4435 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4436 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4435);
// compiled member node returning call4436 (depth = 4)
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4437 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4438 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call4439 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4438);
// compiled member node returning call4439 (depth = 6)
  partcv[0] = 0;
  Object call4440 = callmethodflags(call4439, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4437);
// compiled member node returning call4440 (depth = 5)
  *var_suggestion = call4440;
  if (call4440 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4441 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4442 == NULL) {
    strlit4442 = alloc_String(")");
    gc_root(strlit4442);
  }
// compiled string node returning strlit4442 (depth = 5)
  gc_frame_newslot(strlit4442);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4442;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4443 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4441);
// compiled call node returning call4443 (depth = 4)
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4444 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4445 == NULL) {
    strlit4445 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4445);
  }
// compiled string node returning strlit4445 (depth = 5)
  gc_frame_newslot(strlit4445);
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4446 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call4447 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4446);
// compiled member node returning call4447 (depth = 5)
  gc_frame_newslot(call4447);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4449 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4450 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4449);
// compiled member node returning call4450 (depth = 6)
  int op_slot_right_4448 = gc_frame_newslot(call4450);
// starting to compile member node (depth = 6)
  int callframe4452 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4453 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4452);
// compiled member node returning call4453 (depth = 6)
  int op_slot_left_4448 = gc_frame_newslot(call4453);
  params[0] = call4450;
  partcv[0] = 1;
  Object sum4454 = callmethod(call4453, "+(1)", 1, partcv, params);
// compiled op node returning sum4454 (depth = 5)
  gc_frame_newslot(sum4454);
// Begin line 1501
  setline(1501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4445;
  params[1] = call4447;
  params[2] = sum4454;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4455 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4444);
// compiled call node returning call4455 (depth = 4)
    gc_frame_newslot(call4455);
    if4428 = call4455;
  } else {
  }
// compiled if node returning if4428 (depth = 3)
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tmpStatementToken (depth = 4)
  *var_statementToken = *var_tmpStatementToken;
  if (*var_tmpStatementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4457 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4458 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4457);
// compiled member node returning call4458 (depth = 3)
    gc_frame_newslot(call4458);
    if4376 = call4458;
  } else {
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4459 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4460 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4459);
// compiled member node returning call4460 (depth = 3)
    gc_frame_newslot(call4460);
    if4376 = call4460;
  }
// compiled if node returning if4376 (depth = 2)
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_4462 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
  int callframe4464 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call4465 = callmethodflags(*var_values, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4464);
// compiled member node returning call4465 (depth = 4)
  int op_slot_left_4462 = gc_frame_newslot(call4465);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult4466 = callmethod(call4465, ">(1)", 1, partcv, params);
// compiled op node returning opresult4466 (depth = 3)
  Object if4461 = done;
  if (istrue(opresult4466)) {
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4467 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4468 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4467);
// compiled call node returning call4468 (depth = 3)
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4469 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4470 = callmethodflags(module_parser, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4469);
// compiled call node returning call4470 (depth = 3)
// Begin line 1511
  setline(1511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4471 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4472 = callmethodflags(self, "valueexpressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4471);
// compiled member node returning call4472 (depth = 3)
    gc_frame_newslot(call4472);
    if4461 = call4472;
  } else {
  }
// compiled if node returning if4461 (depth = 2)
  gc_frame_end(frame);
  return if4461;
}
Object meth_parser_4473_oprec_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "oprec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method oprec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for oprec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part oprec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4476 == NULL) {
    strlit4476 = alloc_String("*");
    gc_root(strlit4476);
  }
// compiled string node returning strlit4476 (depth = 4)
  int op_slot_right_4475 = gc_frame_newslot(strlit4476);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  int op_slot_left_4475 = gc_frame_newslot(*var_o);
  params[0] = strlit4476;
  partcv[0] = 1;
  Object opresult4478 = callmethod(*var_o, "==(1)", 1, partcv, params);
// compiled op node returning opresult4478 (depth = 3)
  Object if4474 = done;
  if (istrue(opresult4478)) {
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4479 = alloc_Float64(10);
// compiled num node returning num4479 (depth = 4)
  return num4479;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4474 = undefined;
  } else {
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4482 == NULL) {
    strlit4482 = alloc_String("/");
    gc_root(strlit4482);
  }
// compiled string node returning strlit4482 (depth = 5)
  int op_slot_right_4481 = gc_frame_newslot(strlit4482);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  int op_slot_left_4481 = gc_frame_newslot(*var_o);
  params[0] = strlit4482;
  partcv[0] = 1;
  Object opresult4484 = callmethod(*var_o, "==(1)", 1, partcv, params);
// compiled op node returning opresult4484 (depth = 4)
  Object if4480 = done;
  if (istrue(opresult4484)) {
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4485 = alloc_Float64(10);
// compiled num node returning num4485 (depth = 5)
  return num4485;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4480 = undefined;
  } else {
  }
// compiled if node returning if4480 (depth = 3)
    gc_frame_newslot(if4480);
    if4474 = if4480;
  }
// compiled if node returning if4474 (depth = 2)
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4486 = alloc_Float64(5);
// compiled num node returning num4486 (depth = 3)
  return num4486;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_4487_toprec_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toprec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toprec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toprec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ops = &(stackframe->slots[0]);
  *var_ops = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toprec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "o");
// definebindings:
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4490 = alloc_Float64(0);
// compiled num node returning num4490 (depth = 4)
  int op_slot_right_4489 = gc_frame_newslot(num4490);
// starting to compile member node (depth = 4)
  int callframe4492 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  partcv[0] = 0;
  Object call4493 = callmethodflags(*var_ops, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4492);
// compiled member node returning call4493 (depth = 4)
  int op_slot_left_4489 = gc_frame_newslot(call4493);
  params[0] = num4490;
  partcv[0] = 1;
  Object opresult4494 = callmethod(call4493, ">(1)", 1, partcv, params);
// compiled op node returning opresult4494 (depth = 3)
  Object if4488 = done;
  if (istrue(opresult4494)) {
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4495 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  partcv[0] = 0;
  Object call4496 = callmethodflags(*var_ops, "last", 1, partcv, params, 0);
  gc_frame_end(callframe4495);
// compiled member node returning call4496 (depth = 4)
  *var_o = call4496;
  if (call4496 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4497 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4498 = callmethodflags(module_parser, "oprec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4497);
// compiled call node returning call4498 (depth = 4)
  return call4498;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4488 = undefined;
  } else {
  }
// compiled if node returning if4488 (depth = 2)
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4499 = alloc_Float64(0);
// compiled num node returning num4499 (depth = 2)
  gc_frame_end(frame);
  return num4499;
}
Object meth_parser_4508__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 5)
  int callframe4509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4510 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4509);
// compiled member node returning call4510 (depth = 5)
  gc_frame_end(frame);
  return call4510;
}
Object meth_parser_4500_typeexpressionrest(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4502 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4503 == NULL) {
    strlit4503 = alloc_String("op");
    gc_root(strlit4503);
  }
// compiled string node returning strlit4503 (depth = 4)
  gc_frame_newslot(strlit4503);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4503;
  partcv[0] = 1;
  Object call4504 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4502);
// compiled call node returning call4504 (depth = 3)
  Object if4501 = done;
  if (istrue(call4504)) {
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4505 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4506 == NULL) {
    strlit4506 = alloc_String("type expression");
    gc_root(strlit4506);
  }
// compiled string node returning strlit4506 (depth = 4)
  gc_frame_newslot(strlit4506);
// starting to compile block node (depth = 4)
  Object block4507 = alloc_Block(NULL, NULL, "parser", 1539);
  gc_frame_newslot(block4507);
// method "_apply"
  block_savedest(block4507);
  Object closure4508 = createclosure(1, "_apply");
  setclosureframe(closure4508, stackframe);
  addtoclosure(closure4508, selfslot);
  struct UserObject *uo4508 = (struct UserObject*)block4507;
  uo4508->data[0] = (Object)closure4508;
  Method *meth_meth_parser_4508__apply = addmethod2pos(block4507, "_apply", &meth_parser_4508__apply, 0);
  int argcv_meth_parser_4508__apply[] = {0};
  meth_meth_parser_4508__apply->type = alloc_MethodType(1, argcv_meth_parser_4508__apply);
  meth_meth_parser_4508__apply->definitionModule = modulename;
  meth_meth_parser_4508__apply->definitionLine = 183;
// compiled block node returning block4507 (depth = 4)
  gc_frame_newslot(block4507);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4506;
  params[1] = block4507;
  params[2] = *var_noBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4512 = callmethodflags(module_parser, "expressionrest(1)recursingWith(1)blocks(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4505);
// compiled call node returning call4512 (depth = 3)
    gc_frame_newslot(call4512);
    if4501 = call4512;
  } else {
  }
// compiled if node returning if4501 (depth = 2)
  gc_frame_end(frame);
  return if4501;
}
Object meth_parser_4521__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe4522 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4523 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4522);
// compiled call node returning call4523 (depth = 5)
  gc_frame_end(frame);
  return call4523;
}
Object meth_parser_4513_valueexpressionrest(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valueexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4515 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4516 == NULL) {
    strlit4516 = alloc_String("op");
    gc_root(strlit4516);
  }
// compiled string node returning strlit4516 (depth = 4)
  gc_frame_newslot(strlit4516);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4516;
  partcv[0] = 1;
  Object call4517 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4515);
// compiled call node returning call4517 (depth = 3)
  Object if4514 = done;
  if (istrue(call4517)) {
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4518 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4519 == NULL) {
    strlit4519 = alloc_String("expression");
    gc_root(strlit4519);
  }
// compiled string node returning strlit4519 (depth = 4)
  gc_frame_newslot(strlit4519);
// starting to compile block node (depth = 4)
  Object block4520 = alloc_Block(NULL, NULL, "parser", 1545);
  gc_frame_newslot(block4520);
// method "_apply"
  block_savedest(block4520);
  Object closure4521 = createclosure(2, "_apply");
  setclosureframe(closure4521, stackframe);
  addtoclosure(closure4521, var_blocksOK);
  addtoclosure(closure4521, selfslot);
  struct UserObject *uo4521 = (struct UserObject*)block4520;
  uo4521->data[0] = (Object)closure4521;
  Method *meth_meth_parser_4521__apply = addmethod2pos(block4520, "_apply", &meth_parser_4521__apply, 0);
  int argcv_meth_parser_4521__apply[] = {0};
  meth_meth_parser_4521__apply->type = alloc_MethodType(1, argcv_meth_parser_4521__apply);
  meth_meth_parser_4521__apply->definitionModule = modulename;
  meth_meth_parser_4521__apply->definitionLine = 183;
// compiled block node returning block4520 (depth = 4)
  gc_frame_newslot(block4520);
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit4519;
  params[1] = block4520;
  params[2] = *var_blocksOK;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4525 = callmethodflags(module_parser, "expressionrest(1)recursingWith(1)blocks(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4518);
// compiled call node returning call4525 (depth = 3)
    gc_frame_newslot(call4525);
    if4514 = call4525;
  } else {
  }
// compiled if node returning if4514 (depth = 2)
  gc_frame_end(frame);
  return if4514;
}
Object meth_parser_4541__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4543 == NULL) {
    strlit4543 = alloc_String("=");
    gc_root(strlit4543);
  }
// compiled string node returning strlit4543 (depth = 7)
  int op_slot_right_4542 = gc_frame_newslot(strlit4543);
// starting to compile member node (depth = 7)
  int callframe4545 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4546 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4545);
// compiled member node returning call4546 (depth = 7)
  int op_slot_left_4542 = gc_frame_newslot(call4546);
  params[0] = strlit4543;
  partcv[0] = 1;
  Object opresult4547 = callmethod(call4546, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4547 (depth = 6)
  gc_frame_end(frame);
  return opresult4547;
}
Object meth_parser_4538__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block4540 = alloc_Block(NULL, NULL, "parser", 1569);
  gc_frame_newslot(block4540);
// method "_apply"
  block_savedest(block4540);
  Object closure4541 = createclosure(2, "_apply");
  setclosureframe(closure4541, stackframe);
  addtoclosure(closure4541, var_sym);
  addtoclosure(closure4541, selfslot);
  struct UserObject *uo4541 = (struct UserObject*)block4540;
  uo4541->data[0] = (Object)closure4541;
  Method *meth_meth_parser_4541__apply = addmethod2pos(block4540, "_apply", &meth_parser_4541__apply, 0);
  int argcv_meth_parser_4541__apply[] = {0};
  meth_meth_parser_4541__apply->type = alloc_MethodType(1, argcv_meth_parser_4541__apply);
  meth_meth_parser_4541__apply->definitionModule = modulename;
  meth_meth_parser_4541__apply->definitionLine = 183;
// compiled block node returning block4540 (depth = 5)
  int op_slot_right_4539 = gc_frame_newslot(block4540);
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4550 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4551 == NULL) {
    strlit4551 = alloc_String("op");
    gc_root(strlit4551);
  }
// compiled string node returning strlit4551 (depth = 6)
  gc_frame_newslot(strlit4551);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit4551;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4552 = callmethodflags(module_parser, "accept(1)onLineOfLastOr(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4550);
// compiled call node returning call4552 (depth = 5)
  int op_slot_left_4539 = gc_frame_newslot(call4552);
  params[0] = block4540;
  partcv[0] = 1;
  Object opresult4553 = callmethod(call4552, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4553 (depth = 4)
  gc_frame_end(frame);
  return opresult4553;
}
Object meth_parser_4678__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_prec = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4681 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  gc_frame_newslot(*var_ops);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_ops;
  partcv[0] = 1;
  Object call4682 = callmethodflags(module_parser, "toprec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4681);
// compiled call node returning call4682 (depth = 8)
  int op_slot_right_4680 = gc_frame_newslot(call4682);
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_prec (depth = 8)
  int op_slot_left_4680 = gc_frame_newslot(*var_prec);
  params[0] = call4682;
  partcv[0] = 1;
  Object opresult4684 = callmethod(*var_prec, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4684 (depth = 7)
  int op_slot_right_4679 = gc_frame_newslot(opresult4684);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4687 = alloc_Float64(0);
// compiled num node returning num4687 (depth = 8)
  int op_slot_right_4686 = gc_frame_newslot(num4687);
// starting to compile member node (depth = 8)
  int callframe4689 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  partcv[0] = 0;
  Object call4690 = callmethodflags(*var_ops, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4689);
// compiled member node returning call4690 (depth = 8)
  int op_slot_left_4686 = gc_frame_newslot(call4690);
  params[0] = num4687;
  partcv[0] = 1;
  Object opresult4691 = callmethod(call4690, ">(1)", 1, partcv, params);
// compiled op node returning opresult4691 (depth = 7)
  int op_slot_left_4679 = gc_frame_newslot(opresult4691);
  params[0] = opresult4684;
  partcv[0] = 1;
  Object opresult4692 = callmethod(opresult4691, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4692 (depth = 6)
  gc_frame_end(frame);
  return opresult4692;
}
Object meth_parser_4695__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o2 = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4696 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ops (depth = 8)
  partcv[0] = 0;
  Object call4697 = callmethodflags(*var_ops, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe4696);
// compiled member node returning call4697 (depth = 7)
  *var_o2 = call4697;
  if (call4697 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_terms (depth = 8)
  partcv[0] = 0;
  Object call4700 = callmethodflags(*var_terms, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe4699);
// compiled member node returning call4700 (depth = 7)
  *var_tmp2 = call4700;
  if (call4700 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4702 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_terms (depth = 8)
  partcv[0] = 0;
  Object call4703 = callmethodflags(*var_terms, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe4702);
// compiled member node returning call4703 (depth = 7)
  *var_tmp = call4703;
  if (call4703 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4705 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4706 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  partcv[0] = 0;
  Object call4707 = callmethodflags(*var_tmp, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4706);
// compiled member node returning call4707 (depth = 7)
  gc_frame_newslot(call4707);
// starting to compile member node (depth = 7)
  int callframe4708 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  partcv[0] = 0;
  Object call4709 = callmethodflags(*var_tmp, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4708);
// compiled member node returning call4709 (depth = 7)
  gc_frame_newslot(call4709);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  params[0] = call4707;
  params[1] = call4709;
  partcv[0] = 2;
  Object call4710 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4705);
// compiled call node returning call4710 (depth = 6)
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4711 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o2 (depth = 8)
  gc_frame_newslot(*var_o2);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp2 (depth = 8)
  gc_frame_newslot(*var_tmp2);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4712 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call4713 = callmethodflags(*var_ast, "opNode", 1, partcv, params, 0);
  gc_frame_end(callframe4712);
// compiled member node returning call4713 (depth = 8)
  params[0] = *var_o2;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call4714 = callmethodflags(call4713, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe4711);
// compiled call node returning call4714 (depth = 7)
  *var_tmp = call4714;
  if (call4714 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4716 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call4717 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4716);
// compiled call node returning call4717 (depth = 6)
  gc_frame_end(frame);
  return call4717;
}
Object meth_parser_4893__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 8)
  int callframe4894 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4895 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4894);
// compiled member node returning call4895 (depth = 8)
  gc_frame_end(frame);
  return call4895;
}
Object meth_parser_4556__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_opcount = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_o = getfromclosure(closure, 2);
  Object *var_prec = getfromclosure(closure, 3);
  Object *var_allarith = getfromclosure(closure, 4);
  Object *var_opdtype = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_ops = getfromclosure(closure, 8);
  Object *var_o2 = getfromclosure(closure, 9);
  Object *var_terms = getfromclosure(closure, 10);
  Object *var_tmp2 = getfromclosure(closure, 11);
  Object *var_tmp = getfromclosure(closure, 12);
  Object *var_util = getfromclosure(closure, 13);
  Object *var_ast = getfromclosure(closure, 14);
  Object *var_recurse = getfromclosure(closure, 15);
  Object *var_name = getfromclosure(closure, 16);
  Object *var_statementToken = getfromclosure(closure, 17);
  Object *var_acceptBlocks = getfromclosure(closure, 18);
  Object *var_values = getfromclosure(closure, 19);
  Object self = *(getfromclosure(closure, 20));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
// definebindings:
// definebindings:
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4558 = alloc_Float64(1);
// compiled num node returning num4558 (depth = 6)
  int op_slot_right_4557 = gc_frame_newslot(num4558);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opcount (depth = 6)
  int op_slot_left_4557 = gc_frame_newslot(*var_opcount);
  params[0] = num4558;
  partcv[0] = 1;
  Object sum4560 = callmethod(*var_opcount, "+(1)", 1, partcv, params);
// compiled op node returning sum4560 (depth = 5)
  *var_opcount = sum4560;
  if (sum4560 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4562 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4563 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4562);
// compiled member node returning call4563 (depth = 5)
  *var_o = call4563;
  if (call4563 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4565 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4566 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4565);
// compiled member node returning call4566 (depth = 4)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4567 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4568 = callmethodflags(module_parser, "oprec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4567);
// compiled call node returning call4568 (depth = 5)
  *var_prec = call4568;
  if (call4568 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4573 == NULL) {
    strlit4573 = alloc_String("-");
    gc_root(strlit4573);
  }
// compiled string node returning strlit4573 (depth = 7)
  int op_slot_right_4572 = gc_frame_newslot(strlit4573);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  int op_slot_left_4572 = gc_frame_newslot(*var_o);
  params[0] = strlit4573;
  partcv[0] = 1;
  Object opresult4575 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4575 (depth = 6)
  int op_slot_right_4571 = gc_frame_newslot(opresult4575);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4579 == NULL) {
    strlit4579 = alloc_String("+");
    gc_root(strlit4579);
  }
// compiled string node returning strlit4579 (depth = 8)
  int op_slot_right_4578 = gc_frame_newslot(strlit4579);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_left_4578 = gc_frame_newslot(*var_o);
  params[0] = strlit4579;
  partcv[0] = 1;
  Object opresult4581 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4581 (depth = 7)
  int op_slot_right_4577 = gc_frame_newslot(opresult4581);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4585 == NULL) {
    strlit4585 = alloc_String("/");
    gc_root(strlit4585);
  }
// compiled string node returning strlit4585 (depth = 9)
  int op_slot_right_4584 = gc_frame_newslot(strlit4585);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_4584 = gc_frame_newslot(*var_o);
  params[0] = strlit4585;
  partcv[0] = 1;
  Object opresult4587 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4587 (depth = 8)
  int op_slot_right_4583 = gc_frame_newslot(opresult4587);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4590 == NULL) {
    strlit4590 = alloc_String("*");
    gc_root(strlit4590);
  }
// compiled string node returning strlit4590 (depth = 9)
  int op_slot_right_4589 = gc_frame_newslot(strlit4590);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_4589 = gc_frame_newslot(*var_o);
  params[0] = strlit4590;
  partcv[0] = 1;
  Object opresult4592 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4592 (depth = 8)
  int op_slot_left_4583 = gc_frame_newslot(opresult4592);
  params[0] = opresult4587;
  partcv[0] = 1;
  Object opresult4593 = callmethod(opresult4592, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4593 (depth = 7)
  int op_slot_left_4577 = gc_frame_newslot(opresult4593);
  params[0] = opresult4581;
  partcv[0] = 1;
  Object opresult4594 = callmethod(opresult4593, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4594 (depth = 6)
  int op_slot_left_4571 = gc_frame_newslot(opresult4594);
  params[0] = opresult4575;
  partcv[0] = 1;
  Object opresult4595 = callmethod(opresult4594, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4595 (depth = 5)
  Object if4570 = done;
  if (istrue(opresult4595)) {
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4596 = alloc_Boolean(0);
// compiled identifier node returning bool4596 (depth = 6)
  *var_allarith = bool4596;
  if (bool4596 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4570 = done;
  } else {
  }
// compiled if node returning if4570 (depth = 4)
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4600 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_allarith (depth = 7)
  partcv[0] = 0;
  Object call4601 = callmethodflags(*var_allarith, "not", 1, partcv, params, 0);
  gc_frame_end(callframe4600);
// compiled member node returning call4601 (depth = 6)
  int op_slot_right_4599 = gc_frame_newslot(call4601);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_right_4604 = gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_4604 = gc_frame_newslot(*var_opdtype);
  params[0] = *var_o;
  partcv[0] = 1;
  Object opresult4606 = callmethod(*var_opdtype, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4606 (depth = 7)
  int op_slot_right_4603 = gc_frame_newslot(opresult4606);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4609 == NULL) {
    strlit4609 = alloc_String("");
    gc_root(strlit4609);
  }
// compiled string node returning strlit4609 (depth = 8)
  int op_slot_right_4608 = gc_frame_newslot(strlit4609);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_4608 = gc_frame_newslot(*var_opdtype);
  params[0] = strlit4609;
  partcv[0] = 1;
  Object opresult4611 = callmethod(*var_opdtype, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4611 (depth = 7)
  int op_slot_left_4603 = gc_frame_newslot(opresult4611);
  params[0] = opresult4606;
  partcv[0] = 1;
  Object opresult4612 = callmethod(opresult4611, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4612 (depth = 6)
  int op_slot_left_4599 = gc_frame_newslot(opresult4612);
  params[0] = call4601;
  partcv[0] = 1;
  Object opresult4613 = callmethod(opresult4612, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4613 (depth = 5)
  Object if4598 = done;
  if (istrue(opresult4613)) {
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array4614 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4614 (depth = 6)
  *var_suggestions = array4614;
  if (array4614 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4615 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4616 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4617 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4616);
// compiled member node returning call4617 (depth = 7)
  partcv[0] = 0;
  Object call4618 = callmethodflags(call4617, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4615);
// compiled member node returning call4618 (depth = 6)
  *var_suggestion = call4618;
  if (call4618 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4619 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4620 == NULL) {
    strlit4620 = alloc_String(")");
    gc_root(strlit4620);
  }
// compiled string node returning strlit4620 (depth = 6)
  gc_frame_newslot(strlit4620);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4620;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4621 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4619);
// compiled call node returning call4621 (depth = 5)
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4622 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4623 == NULL) {
    strlit4623 = alloc_String("(");
    gc_root(strlit4623);
  }
// compiled string node returning strlit4623 (depth = 6)
  gc_frame_newslot(strlit4623);
// starting to compile member node (depth = 6)
  int callframe4624 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4625 = callmethodflags(*var_lastToken, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4624);
// compiled member node returning call4625 (depth = 6)
  gc_frame_newslot(call4625);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4623;
  params[1] = call4625;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4626 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4622);
// compiled call node returning call4626 (depth = 5)
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4627 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4628 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4627);
// compiled call node returning call4628 (depth = 5)
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4629 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4630 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4631 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4630);
// compiled member node returning call4631 (depth = 7)
  partcv[0] = 0;
  Object call4632 = callmethodflags(call4631, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4629);
// compiled member node returning call4632 (depth = 6)
  *var_suggestion = call4632;
  if (call4632 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4634 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4635 == NULL) {
    strlit4635 = alloc_String(")");
    gc_root(strlit4635);
  }
// compiled string node returning strlit4635 (depth = 6)
  gc_frame_newslot(strlit4635);
// starting to compile member node (depth = 6)
  int callframe4636 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4637 = callmethodflags(*var_lastToken, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4636);
// compiled member node returning call4637 (depth = 6)
  gc_frame_newslot(call4637);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4635;
  params[1] = call4637;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4638 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4634);
// compiled call node returning call4638 (depth = 5)
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4639 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4640 == NULL) {
    strlit4640 = alloc_String("(");
    gc_root(strlit4640);
  }
// compiled string node returning strlit4640 (depth = 6)
  gc_frame_newslot(strlit4640);
// starting to compile member node (depth = 6)
  int callframe4641 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4642 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4643 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4644 = callmethodflags(*var_lastToken, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4643);
// compiled member node returning call4644 (depth = 8)
  partcv[0] = 0;
  Object call4645 = callmethodflags(call4644, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4642);
// compiled member node returning call4645 (depth = 7)
  partcv[0] = 0;
  Object call4646 = callmethodflags(call4645, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4641);
// compiled member node returning call4646 (depth = 6)
  gc_frame_newslot(call4646);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4640;
  params[1] = call4646;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4647 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4639);
// compiled call node returning call4647 (depth = 5)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4648 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4649 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4648);
// compiled call node returning call4649 (depth = 5)
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4650 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4652 == NULL) {
    strlit4652 = alloc_String("and non-arithmetic operators requires parentheses.");
    gc_root(strlit4652);
  }
// compiled string node returning strlit4652 (depth = 7)
  int op_slot_right_4651 = gc_frame_newslot(strlit4652);
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4654 == NULL) {
    strlit4654 = alloc_String("an expression containing both arithmetic ");
    gc_root(strlit4654);
  }
// compiled string node returning strlit4654 (depth = 7)
  int op_slot_left_4651 = gc_frame_newslot(strlit4654);
  params[0] = strlit4652;
  partcv[0] = 1;
  Object opresult4655 = callmethod(strlit4654, "++(1)", 1, partcv, params);
// compiled op node returning opresult4655 (depth = 6)
  gc_frame_newslot(opresult4655);
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4656 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4657 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4658 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4659 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4660 = callmethodflags(*var_lastToken, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4659);
// compiled member node returning call4660 (depth = 9)
  partcv[0] = 0;
  Object call4661 = callmethodflags(call4660, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4658);
// compiled member node returning call4661 (depth = 8)
  partcv[0] = 0;
  Object call4662 = callmethodflags(call4661, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4657);
// compiled member node returning call4662 (depth = 7)
  partcv[0] = 0;
  Object call4663 = callmethodflags(call4662, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4656);
// compiled member node returning call4663 (depth = 6)
  gc_frame_newslot(call4663);
// starting to compile member node (depth = 6)
  int callframe4664 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4665 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4666 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4667 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4668 = callmethodflags(*var_lastToken, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4667);
// compiled member node returning call4668 (depth = 9)
  partcv[0] = 0;
  Object call4669 = callmethodflags(call4668, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4666);
// compiled member node returning call4669 (depth = 8)
  partcv[0] = 0;
  Object call4670 = callmethodflags(call4669, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4665);
// compiled member node returning call4670 (depth = 7)
  partcv[0] = 0;
  Object call4671 = callmethodflags(call4670, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4664);
// compiled member node returning call4671 (depth = 6)
  gc_frame_newslot(call4671);
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4672 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4673 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4672);
// compiled member node returning call4673 (depth = 6)
  gc_frame_newslot(call4673);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult4655;
  params[1] = call4663;
  params[2] = call4671;
  params[3] = call4673;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call4674 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4650);
// compiled call node returning call4674 (depth = 5)
    gc_frame_newslot(call4674);
    if4598 = call4674;
  } else {
  }
// compiled if node returning if4598 (depth = 4)
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  *var_opdtype = *var_o;
  if (*var_o == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4676 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4677 = alloc_Block(NULL, NULL, "parser", 1596);
  gc_frame_newslot(block4677);
// method "_apply"
  block_savedest(block4677);
  Object closure4678 = createclosure(3, "_apply");
  setclosureframe(closure4678, stackframe);
  addtoclosure(closure4678, var_ops);
  addtoclosure(closure4678, var_prec);
  addtoclosure(closure4678, selfslot);
  struct UserObject *uo4678 = (struct UserObject*)block4677;
  uo4678->data[0] = (Object)closure4678;
  Method *meth_meth_parser_4678__apply = addmethod2pos(block4677, "_apply", &meth_parser_4678__apply, 0);
  int argcv_meth_parser_4678__apply[] = {0};
  meth_meth_parser_4678__apply->type = alloc_MethodType(1, argcv_meth_parser_4678__apply);
  meth_meth_parser_4678__apply->definitionModule = modulename;
  meth_meth_parser_4678__apply->definitionLine = 183;
// compiled block node returning block4677 (depth = 5)
  gc_frame_newslot(block4677);
// starting to compile block node (depth = 5)
  Object block4694 = alloc_Block(NULL, NULL, "parser", 1596);
  gc_frame_newslot(block4694);
// method "_apply"
  block_savedest(block4694);
  Object closure4695 = createclosure(8, "_apply");
  setclosureframe(closure4695, stackframe);
  addtoclosure(closure4695, var_ops);
  addtoclosure(closure4695, var_o2);
  addtoclosure(closure4695, var_terms);
  addtoclosure(closure4695, var_tmp2);
  addtoclosure(closure4695, var_tmp);
  addtoclosure(closure4695, var_util);
  addtoclosure(closure4695, var_ast);
  addtoclosure(closure4695, selfslot);
  struct UserObject *uo4695 = (struct UserObject*)block4694;
  uo4695->data[0] = (Object)closure4695;
  Method *meth_meth_parser_4695__apply = addmethod2pos(block4694, "_apply", &meth_parser_4695__apply, 0);
  int argcv_meth_parser_4695__apply[] = {0};
  meth_meth_parser_4695__apply->type = alloc_MethodType(1, argcv_meth_parser_4695__apply);
  meth_meth_parser_4695__apply->definitionModule = modulename;
  meth_meth_parser_4695__apply->definitionLine = 183;
// compiled block node returning block4694 (depth = 5)
  gc_frame_newslot(block4694);
// call case 5: prelude request
  params[0] = block4677;
  params[1] = block4694;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4719 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4676);
// compiled call node returning call4719 (depth = 4)
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4720 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4721 = callmethodflags(*var_ops, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4720);
// compiled call node returning call4721 (depth = 4)
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4723 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4724 == NULL) {
    strlit4724 = alloc_String("lparen");
    gc_root(strlit4724);
  }
// compiled string node returning strlit4724 (depth = 6)
  gc_frame_newslot(strlit4724);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit4724;
  partcv[0] = 1;
  Object call4725 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4723);
// compiled call node returning call4725 (depth = 5)
  Object if4722 = done;
  if (istrue(call4725)) {
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4726 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4727 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4726);
// compiled member node returning call4727 (depth = 5)
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4729 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe4730 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_recurse (depth = 8)
  gc_frame_newslot(*var_recurse);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_recurse;
  partcv[0] = 1;
  Object call4731 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4730);
// compiled call node returning call4731 (depth = 7)
  partcv[0] = 0;
  Object call4732 = callmethodflags(call4731, "not", 1, partcv, params, 0);
  gc_frame_end(callframe4729);
// compiled member node returning call4732 (depth = 6)
  Object if4728 = done;
  if (istrue(call4732)) {
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4733 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4734 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4735 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4734);
// compiled member node returning call4735 (depth = 8)
  partcv[0] = 0;
  Object call4736 = callmethodflags(call4735, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4733);
// compiled member node returning call4736 (depth = 7)
  *var_suggestion = call4736;
  if (call4736 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4737 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array4738 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit4739 == NULL) {
    strlit4739 = alloc_String("rparen");
    gc_root(strlit4739);
  }
// compiled string node returning strlit4739 (depth = 9)
  params[0] = strlit4739;
  partcv[0] = 1;
  callmethodflags(array4738, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4738 (depth = 8)
  gc_frame_newslot(array4738);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = array4738;
  partcv[0] = 1;
  Object call4740 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4737);
// compiled call node returning call4740 (depth = 7)
  *var_nextTok = call4740;
  if (call4740 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4742 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4742 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4744 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4744 (depth = 7)
  Object if4741 = done;
  if (istrue(opresult4744)) {
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4745 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4747 == NULL) {
    strlit4747 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit4747);
  }
// compiled string node returning strlit4747 (depth = 9)
  int op_slot_right_4746 = gc_frame_newslot(strlit4747);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_4749 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit4751 == NULL) {
    strlit4751 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit4751);
  }
// compiled string node returning strlit4751 (depth = 10)
  int op_slot_left_4749 = gc_frame_newslot(strlit4751);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4752 = callmethod(strlit4751, "++(1)", 1, partcv, params);
// compiled op node returning opresult4752 (depth = 9)
  int op_slot_left_4746 = gc_frame_newslot(opresult4752);
  params[0] = strlit4747;
  partcv[0] = 1;
  Object opresult4753 = callmethod(opresult4752, "++(1)", 1, partcv, params);
// compiled op node returning opresult4753 (depth = 8)
  gc_frame_newslot(opresult4753);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult4753;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4754 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4745);
// compiled call node returning call4754 (depth = 7)
    gc_frame_newslot(call4754);
    if4741 = call4754;
  } else {
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4755 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe4756 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4757 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4756);
// compiled member node returning call4757 (depth = 8)
  gc_frame_newslot(call4757);
// starting to compile identifier node (depth = 8)
  Object bool4758 = alloc_Boolean(1);
// compiled identifier node returning bool4758 (depth = 8)
  gc_frame_newslot(bool4758);
// starting to compile identifier node (depth = 8)
  Object bool4759 = alloc_Boolean(0);
// compiled identifier node returning bool4759 (depth = 8)
  gc_frame_newslot(bool4759);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4761 == NULL) {
    strlit4761 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit4761);
  }
// compiled string node returning strlit4761 (depth = 9)
  int op_slot_right_4760 = gc_frame_newslot(strlit4761);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_4763 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit4765 == NULL) {
    strlit4765 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit4765);
  }
// compiled string node returning strlit4765 (depth = 10)
  int op_slot_left_4763 = gc_frame_newslot(strlit4765);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4766 = callmethod(strlit4765, "++(1)", 1, partcv, params);
// compiled op node returning opresult4766 (depth = 9)
  int op_slot_left_4760 = gc_frame_newslot(opresult4766);
  params[0] = strlit4761;
  partcv[0] = 1;
  Object opresult4767 = callmethod(opresult4766, "++(1)", 1, partcv, params);
// compiled op node returning opresult4767 (depth = 8)
  gc_frame_newslot(opresult4767);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call4757;
  params[2] = bool4758;
  params[3] = bool4759;
  params[4] = opresult4767;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4768 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4755);
// compiled call node returning call4768 (depth = 7)
    gc_frame_newslot(call4768);
    if4741 = call4768;
  }
// compiled if node returning if4741 (depth = 6)
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4769 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4771 == NULL) {
    strlit4771 = alloc_String(".");
    gc_root(strlit4771);
  }
// compiled string node returning strlit4771 (depth = 8)
  int op_slot_right_4770 = gc_frame_newslot(strlit4771);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_4773 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit4775 == NULL) {
    strlit4775 = alloc_String("parentheses must contain a valid ");
    gc_root(strlit4775);
  }
// compiled string node returning strlit4775 (depth = 9)
  int op_slot_left_4773 = gc_frame_newslot(strlit4775);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4776 = callmethod(strlit4775, "++(1)", 1, partcv, params);
// compiled op node returning opresult4776 (depth = 8)
  int op_slot_left_4770 = gc_frame_newslot(opresult4776);
  params[0] = strlit4771;
  partcv[0] = 1;
  Object opresult4777 = callmethod(opresult4776, "++(1)", 1, partcv, params);
// compiled op node returning opresult4777 (depth = 7)
  gc_frame_newslot(opresult4777);
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4778 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4779 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4778);
// compiled member node returning call4779 (depth = 7)
  gc_frame_newslot(call4779);
// starting to compile member node (depth = 7)
  int callframe4780 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4781 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4780);
// compiled member node returning call4781 (depth = 7)
  gc_frame_newslot(call4781);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult4777;
  params[1] = call4779;
  params[2] = call4781;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4782 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4769);
// compiled call node returning call4782 (depth = 6)
    gc_frame_newslot(call4782);
    if4728 = call4782;
  } else {
  }
// compiled if node returning if4728 (depth = 5)
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4785 == NULL) {
    strlit4785 = alloc_String("rparen");
    gc_root(strlit4785);
  }
// compiled string node returning strlit4785 (depth = 7)
  int op_slot_right_4784 = gc_frame_newslot(strlit4785);
// starting to compile member node (depth = 7)
  int callframe4787 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4788 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe4787);
// compiled member node returning call4788 (depth = 7)
  int op_slot_left_4784 = gc_frame_newslot(call4788);
  params[0] = strlit4785;
  partcv[0] = 1;
  Object opresult4789 = callmethod(call4788, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4789 (depth = 6)
  Object if4783 = done;
  if (istrue(opresult4789)) {
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4790 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4791 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4790);
// compiled member node returning call4791 (depth = 6)
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4792 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4793 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4794 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4793);
// compiled member node returning call4794 (depth = 8)
  partcv[0] = 0;
  Object call4795 = callmethodflags(call4794, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4792);
// compiled member node returning call4795 (depth = 7)
  *var_suggestion = call4795;
  if (call4795 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4796 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4797 == NULL) {
    strlit4797 = alloc_String(")");
    gc_root(strlit4797);
  }
// compiled string node returning strlit4797 (depth = 7)
  gc_frame_newslot(strlit4797);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4797;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4798 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4796);
// compiled call node returning call4798 (depth = 6)
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4799 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4800 == NULL) {
    strlit4800 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4800);
  }
// compiled string node returning strlit4800 (depth = 7)
  gc_frame_newslot(strlit4800);
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4801 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4802 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4801);
// compiled member node returning call4802 (depth = 7)
  gc_frame_newslot(call4802);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4804 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4805 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4804);
// compiled member node returning call4805 (depth = 8)
  int op_slot_right_4803 = gc_frame_newslot(call4805);
// starting to compile member node (depth = 8)
  int callframe4807 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4808 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4807);
// compiled member node returning call4808 (depth = 8)
  int op_slot_left_4803 = gc_frame_newslot(call4808);
  params[0] = call4805;
  partcv[0] = 1;
  Object sum4809 = callmethod(call4808, "+(1)", 1, partcv, params);
// compiled op node returning sum4809 (depth = 7)
  gc_frame_newslot(sum4809);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4800;
  params[1] = call4802;
  params[2] = sum4809;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4810 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4799);
// compiled call node returning call4810 (depth = 6)
    gc_frame_newslot(call4810);
    if4783 = call4810;
  } else {
  }
// compiled if node returning if4783 (depth = 5)
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4811 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4812 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4811);
// compiled member node returning call4812 (depth = 5)
    gc_frame_newslot(call4812);
    if4722 = call4812;
  } else {
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4814 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe4815 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_statementToken (depth = 8)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_statementToken;
  partcv[0] = 1;
  Object call4816 = callmethodflags(module_parser, "tokenOnLineOfLastOr(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4815);
// compiled call node returning call4816 (depth = 7)
  partcv[0] = 0;
  Object call4817 = callmethodflags(call4816, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4814);
// compiled call node returning call4817 (depth = 6)
  Object if4813 = done;
  if (istrue(call4817)) {
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array4818 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4818 (depth = 7)
  *var_suggestions = array4818;
  if (array4818 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4819 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4820 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4821 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4820);
// compiled member node returning call4821 (depth = 8)
  partcv[0] = 0;
  Object call4822 = callmethodflags(call4821, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4819);
// compiled member node returning call4822 (depth = 7)
  *var_suggestion = call4822;
  if (call4822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4823 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool4824 = alloc_Boolean(1);
// compiled identifier node returning bool4824 (depth = 7)
  gc_frame_newslot(bool4824);
// starting to compile identifier node (depth = 7)
  Object bool4825 = alloc_Boolean(0);
// compiled identifier node returning bool4825 (depth = 7)
  gc_frame_newslot(bool4825);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool4824;
  params[2] = bool4825;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4826 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4823);
// compiled call node returning call4826 (depth = 6)
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4827 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4828 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4827);
// compiled call node returning call4828 (depth = 6)
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4829 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4830 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4831 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4830);
// compiled member node returning call4831 (depth = 8)
  partcv[0] = 0;
  Object call4832 = callmethodflags(call4831, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4829);
// compiled member node returning call4832 (depth = 7)
  *var_suggestion = call4832;
  if (call4832 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4834 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4836 == NULL) {
    strlit4836 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit4836);
  }
// compiled string node returning strlit4836 (depth = 8)
  int op_slot_right_4835 = gc_frame_newslot(strlit4836);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_4838 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit4840 == NULL) {
    strlit4840 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit4840);
  }
// compiled string node returning strlit4840 (depth = 9)
  int op_slot_left_4838 = gc_frame_newslot(strlit4840);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4841 = callmethod(strlit4840, "++(1)", 1, partcv, params);
// compiled op node returning opresult4841 (depth = 8)
  int op_slot_left_4835 = gc_frame_newslot(opresult4841);
  params[0] = strlit4836;
  partcv[0] = 1;
  Object opresult4842 = callmethod(opresult4841, "++(1)", 1, partcv, params);
// compiled op node returning opresult4842 (depth = 7)
  gc_frame_newslot(opresult4842);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult4842;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4843 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4834);
// compiled call node returning call4843 (depth = 6)
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4844 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4845 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4844);
// compiled call node returning call4845 (depth = 6)
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4846 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4847 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4848 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4847);
// compiled member node returning call4848 (depth = 8)
  partcv[0] = 0;
  Object call4849 = callmethodflags(call4848, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4846);
// compiled member node returning call4849 (depth = 7)
  *var_suggestion = call4849;
  if (call4849 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4851 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4853 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe4854 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4855 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4854);
// compiled member node returning call4855 (depth = 9)
  gc_frame_newslot(call4855);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4856 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call4857 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe4856);
// compiled member node returning call4857 (depth = 9)
  params[0] = call4855;
  partcv[0] = 1;
  Object call4858 = callmethodflags(call4857, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4853);
// compiled call node returning call4858 (depth = 8)
  int op_slot_right_4852 = gc_frame_newslot(call4858);
// starting to compile string node (depth = 8)
  if (strlit4860 == NULL) {
    strlit4860 = alloc_String(" ");
    gc_root(strlit4860);
  }
// compiled string node returning strlit4860 (depth = 8)
  int op_slot_left_4852 = gc_frame_newslot(strlit4860);
  params[0] = call4858;
  partcv[0] = 1;
  Object opresult4861 = callmethod(strlit4860, "++(1)", 1, partcv, params);
// compiled op node returning opresult4861 (depth = 7)
  gc_frame_newslot(opresult4861);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult4861;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4862 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4851);
// compiled call node returning call4862 (depth = 6)
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4863 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4864 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4865 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4864);
// compiled member node returning call4865 (depth = 7)
  gc_frame_newslot(call4865);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call4865;
  partcv[0] = 1;
  Object call4866 = callmethodflags(*var_suggestion, "deleteLine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4863);
// compiled call node returning call4866 (depth = 6)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4867 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4868 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4867);
// compiled call node returning call4868 (depth = 6)
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4869 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4871 == NULL) {
    strlit4871 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit4871);
  }
// compiled string node returning strlit4871 (depth = 8)
  int op_slot_right_4870 = gc_frame_newslot(strlit4871);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4874 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4875 = callmethodflags(*var_lastToken, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4874);
// compiled member node returning call4875 (depth = 9)
  int op_slot_right_4873 = gc_frame_newslot(call4875);
// starting to compile string node (depth = 9)
  if (strlit4877 == NULL) {
    strlit4877 = alloc_String("a valid expression must follow '");
    gc_root(strlit4877);
  }
// compiled string node returning strlit4877 (depth = 9)
  int op_slot_left_4873 = gc_frame_newslot(strlit4877);
  params[0] = call4875;
  partcv[0] = 1;
  Object opresult4878 = callmethod(strlit4877, "++(1)", 1, partcv, params);
// compiled op node returning opresult4878 (depth = 8)
  int op_slot_left_4870 = gc_frame_newslot(opresult4878);
  params[0] = strlit4871;
  partcv[0] = 1;
  Object opresult4879 = callmethod(opresult4878, "++(1)", 1, partcv, params);
// compiled op node returning opresult4879 (depth = 7)
  gc_frame_newslot(opresult4879);
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4880 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4881 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4880);
// compiled member node returning call4881 (depth = 7)
  gc_frame_newslot(call4881);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4883 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4884 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4883);
// compiled member node returning call4884 (depth = 8)
  int op_slot_right_4882 = gc_frame_newslot(call4884);
// starting to compile member node (depth = 8)
  int callframe4886 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4887 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4886);
// compiled member node returning call4887 (depth = 8)
  int op_slot_left_4882 = gc_frame_newslot(call4887);
  params[0] = call4884;
  partcv[0] = 1;
  Object sum4888 = callmethod(call4887, "+(1)", 1, partcv, params);
// compiled op node returning sum4888 (depth = 7)
  gc_frame_newslot(sum4888);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult4879;
  params[1] = call4881;
  params[2] = sum4888;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4889 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4869);
// compiled call node returning call4889 (depth = 6)
    gc_frame_newslot(call4889);
    if4813 = call4889;
  } else {
  }
// compiled if node returning if4813 (depth = 5)
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4891 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4892 = alloc_Block(NULL, NULL, "parser", 1653);
  gc_frame_newslot(block4892);
// method "_apply"
  block_savedest(block4892);
  Object closure4893 = createclosure(1, "_apply");
  setclosureframe(closure4893, stackframe);
  addtoclosure(closure4893, selfslot);
  struct UserObject *uo4893 = (struct UserObject*)block4892;
  uo4893->data[0] = (Object)closure4893;
  Method *meth_meth_parser_4893__apply = addmethod2pos(block4892, "_apply", &meth_parser_4893__apply, 0);
  int argcv_meth_parser_4893__apply[] = {0};
  meth_meth_parser_4893__apply->type = alloc_MethodType(1, argcv_meth_parser_4893__apply);
  meth_meth_parser_4893__apply->definitionModule = modulename;
  meth_meth_parser_4893__apply->definitionLine = 183;
// compiled block node returning block4892 (depth = 7)
  gc_frame_newslot(block4892);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block4892;
  partcv[0] = 1;
  Object call4897 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4891);
// compiled call node returning call4897 (depth = 6)
  Object if4890 = done;
  if (istrue(call4897)) {
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array4898 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4898 (depth = 7)
  *var_suggestions = array4898;
  if (array4898 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4899 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4900 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4901 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4900);
// compiled member node returning call4901 (depth = 8)
  partcv[0] = 0;
  Object call4902 = callmethodflags(call4901, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4899);
// compiled member node returning call4902 (depth = 7)
  *var_suggestion = call4902;
  if (call4902 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4903 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array4904 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit4905 == NULL) {
    strlit4905 = alloc_String("comma");
    gc_root(strlit4905);
  }
// compiled string node returning strlit4905 (depth = 9)
  params[0] = strlit4905;
  partcv[0] = 1;
  callmethodflags(array4904, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit4906 == NULL) {
    strlit4906 = alloc_String("rparen");
    gc_root(strlit4906);
  }
// compiled string node returning strlit4906 (depth = 9)
  params[0] = strlit4906;
  partcv[0] = 1;
  callmethodflags(array4904, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit4907 == NULL) {
    strlit4907 = alloc_String("rsquare");
    gc_root(strlit4907);
  }
// compiled string node returning strlit4907 (depth = 9)
  params[0] = strlit4907;
  partcv[0] = 1;
  callmethodflags(array4904, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit4908 == NULL) {
    strlit4908 = alloc_String("rbrace");
    gc_root(strlit4908);
  }
// compiled string node returning strlit4908 (depth = 9)
  params[0] = strlit4908;
  partcv[0] = 1;
  callmethodflags(array4904, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4904 (depth = 8)
  gc_frame_newslot(array4904);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = array4904;
  partcv[0] = 1;
  Object call4909 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4903);
// compiled call node returning call4909 (depth = 7)
  *var_nextTok = call4909;
  if (call4909 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4911 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4911 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4913 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4913 (depth = 7)
  Object if4910 = done;
  if (istrue(opresult4913)) {
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4914 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4916 == NULL) {
    strlit4916 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit4916);
  }
// compiled string node returning strlit4916 (depth = 9)
  int op_slot_right_4915 = gc_frame_newslot(strlit4916);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_4918 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit4920 == NULL) {
    strlit4920 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit4920);
  }
// compiled string node returning strlit4920 (depth = 10)
  int op_slot_left_4918 = gc_frame_newslot(strlit4920);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4921 = callmethod(strlit4920, "++(1)", 1, partcv, params);
// compiled op node returning opresult4921 (depth = 9)
  int op_slot_left_4915 = gc_frame_newslot(opresult4921);
  params[0] = strlit4916;
  partcv[0] = 1;
  Object opresult4922 = callmethod(opresult4921, "++(1)", 1, partcv, params);
// compiled op node returning opresult4922 (depth = 8)
  gc_frame_newslot(opresult4922);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult4922;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4923 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4914);
// compiled call node returning call4923 (depth = 7)
    gc_frame_newslot(call4923);
    if4910 = call4923;
  } else {
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4924 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe4925 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4926 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4925);
// compiled member node returning call4926 (depth = 8)
  gc_frame_newslot(call4926);
// starting to compile identifier node (depth = 8)
  Object bool4927 = alloc_Boolean(1);
// compiled identifier node returning bool4927 (depth = 8)
  gc_frame_newslot(bool4927);
// starting to compile identifier node (depth = 8)
  Object bool4928 = alloc_Boolean(0);
// compiled identifier node returning bool4928 (depth = 8)
  gc_frame_newslot(bool4928);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4930 == NULL) {
    strlit4930 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit4930);
  }
// compiled string node returning strlit4930 (depth = 9)
  int op_slot_right_4929 = gc_frame_newslot(strlit4930);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_4932 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit4934 == NULL) {
    strlit4934 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit4934);
  }
// compiled string node returning strlit4934 (depth = 10)
  int op_slot_left_4932 = gc_frame_newslot(strlit4934);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4935 = callmethod(strlit4934, "++(1)", 1, partcv, params);
// compiled op node returning opresult4935 (depth = 9)
  int op_slot_left_4929 = gc_frame_newslot(opresult4935);
  params[0] = strlit4930;
  partcv[0] = 1;
  Object opresult4936 = callmethod(opresult4935, "++(1)", 1, partcv, params);
// compiled op node returning opresult4936 (depth = 8)
  gc_frame_newslot(opresult4936);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call4926;
  params[2] = bool4927;
  params[3] = bool4928;
  params[4] = opresult4936;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4937 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4924);
// compiled call node returning call4937 (depth = 7)
    gc_frame_newslot(call4937);
    if4910 = call4937;
  }
// compiled if node returning if4910 (depth = 6)
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4938 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4939 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4938);
// compiled call node returning call4939 (depth = 6)
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4940 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4941 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4942 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe4941);
// compiled member node returning call4942 (depth = 8)
  partcv[0] = 0;
  Object call4943 = callmethodflags(call4942, "new", 1, partcv, params, 0);
  gc_frame_end(callframe4940);
// compiled member node returning call4943 (depth = 7)
  *var_suggestion = call4943;
  if (call4943 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4945 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe4946 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4947 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe4946);
// compiled member node returning call4947 (depth = 7)
  gc_frame_newslot(call4947);
// starting to compile identifier node (depth = 7)
  Object bool4948 = alloc_Boolean(1);
// compiled identifier node returning bool4948 (depth = 7)
  gc_frame_newslot(bool4948);
// starting to compile identifier node (depth = 7)
  Object bool4949 = alloc_Boolean(0);
// compiled identifier node returning bool4949 (depth = 7)
  gc_frame_newslot(bool4949);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call4947;
  params[2] = bool4948;
  params[3] = bool4949;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4950 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4945);
// compiled call node returning call4950 (depth = 6)
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4951 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4952 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4951);
// compiled call node returning call4952 (depth = 6)
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4953 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4955 == NULL) {
    strlit4955 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit4955);
  }
// compiled string node returning strlit4955 (depth = 8)
  int op_slot_right_4954 = gc_frame_newslot(strlit4955);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4958 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4959 = callmethodflags(*var_lastToken, "value", 1, partcv, params, 0);
  gc_frame_end(callframe4958);
// compiled member node returning call4959 (depth = 9)
  int op_slot_right_4957 = gc_frame_newslot(call4959);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4962 == NULL) {
    strlit4962 = alloc_String(" must follow '");
    gc_root(strlit4962);
  }
// compiled string node returning strlit4962 (depth = 10)
  int op_slot_right_4961 = gc_frame_newslot(strlit4962);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_name (depth = 11)
  int op_slot_right_4964 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 11)
  if (strlit4966 == NULL) {
    strlit4966 = alloc_String("a valid ");
    gc_root(strlit4966);
  }
// compiled string node returning strlit4966 (depth = 11)
  int op_slot_left_4964 = gc_frame_newslot(strlit4966);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult4967 = callmethod(strlit4966, "++(1)", 1, partcv, params);
// compiled op node returning opresult4967 (depth = 10)
  int op_slot_left_4961 = gc_frame_newslot(opresult4967);
  params[0] = strlit4962;
  partcv[0] = 1;
  Object opresult4968 = callmethod(opresult4967, "++(1)", 1, partcv, params);
// compiled op node returning opresult4968 (depth = 9)
  int op_slot_left_4957 = gc_frame_newslot(opresult4968);
  params[0] = call4959;
  partcv[0] = 1;
  Object opresult4969 = callmethod(opresult4968, "++(1)", 1, partcv, params);
// compiled op node returning opresult4969 (depth = 8)
  int op_slot_left_4954 = gc_frame_newslot(opresult4969);
  params[0] = strlit4955;
  partcv[0] = 1;
  Object opresult4970 = callmethod(opresult4969, "++(1)", 1, partcv, params);
// compiled op node returning opresult4970 (depth = 7)
  gc_frame_newslot(opresult4970);
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4971 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4972 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe4971);
// compiled member node returning call4972 (depth = 7)
  gc_frame_newslot(call4972);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4974 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4975 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4974);
// compiled member node returning call4975 (depth = 8)
  int op_slot_right_4973 = gc_frame_newslot(call4975);
// starting to compile member node (depth = 8)
  int callframe4977 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4978 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe4977);
// compiled member node returning call4978 (depth = 8)
  int op_slot_left_4973 = gc_frame_newslot(call4978);
  params[0] = call4975;
  partcv[0] = 1;
  Object sum4979 = callmethod(call4978, "+(1)", 1, partcv, params);
// compiled op node returning sum4979 (depth = 7)
  gc_frame_newslot(sum4979);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult4970;
  params[1] = call4972;
  params[2] = sum4979;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4980 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4953);
// compiled call node returning call4980 (depth = 6)
    gc_frame_newslot(call4980);
    if4890 = call4980;
  } else {
  }
// compiled if node returning if4890 (depth = 5)
    gc_frame_newslot(if4890);
    if4722 = if4890;
  }
// compiled if node returning if4722 (depth = 4)
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4981 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4982 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4981);
// compiled call node returning call4982 (depth = 4)
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4983 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4984 = callmethodflags(module_parser, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4983);
// compiled call node returning call4984 (depth = 4)
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4985 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4986 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe4985);
// compiled member node returning call4986 (depth = 5)
  *var_tmp = call4986;
  if (call4986 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4988 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call4989 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4988);
// compiled call node returning call4989 (depth = 4)
  gc_frame_end(frame);
  return call4989;
}
Object meth_parser_4994__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4996 = alloc_Float64(0);
// compiled num node returning num4996 (depth = 5)
  int op_slot_right_4995 = gc_frame_newslot(num4996);
// starting to compile member node (depth = 5)
  int callframe4998 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  partcv[0] = 0;
  Object call4999 = callmethodflags(*var_ops, "size", 1, partcv, params, 0);
  gc_frame_end(callframe4998);
// compiled member node returning call4999 (depth = 5)
  int op_slot_left_4995 = gc_frame_newslot(call4999);
  params[0] = num4996;
  partcv[0] = 1;
  Object opresult5000 = callmethod(call4999, ">(1)", 1, partcv, params);
// compiled op node returning opresult5000 (depth = 4)
  gc_frame_end(frame);
  return opresult5000;
}
Object meth_parser_5003__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5004 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  partcv[0] = 0;
  Object call5005 = callmethodflags(*var_ops, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5004);
// compiled member node returning call5005 (depth = 5)
  *var_o = call5005;
  if (call5005 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5007 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_terms (depth = 6)
  partcv[0] = 0;
  Object call5008 = callmethodflags(*var_terms, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5007);
// compiled member node returning call5008 (depth = 5)
  *var_tmp2 = call5008;
  if (call5008 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5010 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_terms (depth = 6)
  partcv[0] = 0;
  Object call5011 = callmethodflags(*var_terms, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5010);
// compiled member node returning call5011 (depth = 5)
  *var_tmp = call5011;
  if (call5011 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5013 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5014 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  partcv[0] = 0;
  Object call5015 = callmethodflags(*var_tmp, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5014);
// compiled member node returning call5015 (depth = 5)
  gc_frame_newslot(call5015);
// starting to compile member node (depth = 5)
  int callframe5016 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  partcv[0] = 0;
  Object call5017 = callmethodflags(*var_tmp, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5016);
// compiled member node returning call5017 (depth = 5)
  gc_frame_newslot(call5017);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5015;
  params[1] = call5017;
  partcv[0] = 2;
  Object call5018 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5013);
// compiled call node returning call5018 (depth = 4)
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5019 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp2 (depth = 6)
  gc_frame_newslot(*var_tmp2);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5020 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5021 = callmethodflags(*var_ast, "opNode", 1, partcv, params, 0);
  gc_frame_end(callframe5020);
// compiled member node returning call5021 (depth = 6)
  params[0] = *var_o;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5022 = callmethodflags(call5021, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe5019);
// compiled call node returning call5022 (depth = 5)
  *var_tmp = call5022;
  if (call5022 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5024 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5025 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5024);
// compiled call node returning call5025 (depth = 4)
  gc_frame_end(frame);
  return call5025;
}
Object meth_parser_4526_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(15, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expressionrest(1)recursingWith(1)blocks(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest(_)recursingWith(_)blocks(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest(_)recursingWith(_)blocks(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest(_)recursingWith(_)blocks(_)");
  Object params[3];
  int partcv[2];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for expressionrest(_)recursingWith(_)blocks(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part expressionrest(_)");
  Object *var_recurse = &(stackframe->slots[1]);
  *var_recurse = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part recursingWith(_)");
  Object *var_acceptBlocks = &(stackframe->slots[2]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part blocks(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_startIndent = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "startIndent");
  Object *var_terms = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "terms");
  Object *var_ops = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ops");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_o2 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "o2");
  Object *var_tmp2 = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "tmp2");
  Object *var_tmp = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tmp");
  Object *var_prec = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "prec");
  Object *var_allarith = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "allarith");
  Object *var_opcount = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "opcount");
  Object *var_opdtype = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "opdtype");
// definebindings:
// definebindings:
// Begin line 1556
  setline(1556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_startIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4527 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4527 (depth = 3)
  *var_terms = array4527;
  if (array4527 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4528 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4528 (depth = 3)
  *var_ops = array4528;
  if (array4528 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_tmp2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4529 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  partcv[0] = 0;
  Object call4530 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe4529);
// compiled member node returning call4530 (depth = 3)
  *var_tmp = call4530;
  if (call4530 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4531 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_terms (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call4532 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4531);
// compiled call node returning call4532 (depth = 2)
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_prec = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4533 = alloc_Boolean(1);
// compiled identifier node returning bool4533 (depth = 3)
  *var_allarith = bool4533;
  if (bool4533 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4534 = alloc_Float64(0);
// compiled num node returning num4534 (depth = 3)
  *var_opcount = num4534;
  if (num4534 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4535 == NULL) {
    strlit4535 = alloc_String("");
    gc_root(strlit4535);
  }
// compiled string node returning strlit4535 (depth = 3)
  *var_opdtype = strlit4535;
  if (strlit4535 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4536 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4537 = alloc_Block(NULL, NULL, "parser", 1568);
  gc_frame_newslot(block4537);
// method "_apply"
  block_savedest(block4537);
  Object closure4538 = createclosure(3, "_apply");
  setclosureframe(closure4538, stackframe);
  addtoclosure(closure4538, var_sym);
  addtoclosure(closure4538, var_statementToken);
  addtoclosure(closure4538, selfslot);
  struct UserObject *uo4538 = (struct UserObject*)block4537;
  uo4538->data[0] = (Object)closure4538;
  Method *meth_meth_parser_4538__apply = addmethod2pos(block4537, "_apply", &meth_parser_4538__apply, 0);
  int argcv_meth_parser_4538__apply[] = {0};
  meth_meth_parser_4538__apply->type = alloc_MethodType(1, argcv_meth_parser_4538__apply);
  meth_meth_parser_4538__apply->definitionModule = modulename;
  meth_meth_parser_4538__apply->definitionLine = 183;
// compiled block node returning block4537 (depth = 3)
  gc_frame_newslot(block4537);
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4555 = alloc_Block(NULL, NULL, "parser", 1569);
  gc_frame_newslot(block4555);
// method "_apply"
  block_savedest(block4555);
  Object closure4556 = createclosure(21, "_apply");
  setclosureframe(closure4556, stackframe);
  addtoclosure(closure4556, var_opcount);
  addtoclosure(closure4556, var_sym);
  addtoclosure(closure4556, var_o);
  addtoclosure(closure4556, var_prec);
  addtoclosure(closure4556, var_allarith);
  addtoclosure(closure4556, var_opdtype);
  addtoclosure(closure4556, var_errormessages);
  addtoclosure(closure4556, var_lastToken);
  addtoclosure(closure4556, var_ops);
  addtoclosure(closure4556, var_o2);
  addtoclosure(closure4556, var_terms);
  addtoclosure(closure4556, var_tmp2);
  addtoclosure(closure4556, var_tmp);
  addtoclosure(closure4556, var_util);
  addtoclosure(closure4556, var_ast);
  addtoclosure(closure4556, var_recurse);
  addtoclosure(closure4556, var_name);
  addtoclosure(closure4556, var_statementToken);
  addtoclosure(closure4556, var_acceptBlocks);
  addtoclosure(closure4556, var_values);
  addtoclosure(closure4556, selfslot);
  struct UserObject *uo4556 = (struct UserObject*)block4555;
  uo4556->data[0] = (Object)closure4556;
  Method *meth_meth_parser_4556__apply = addmethod2pos(block4555, "_apply", &meth_parser_4556__apply, 0);
  int argcv_meth_parser_4556__apply[] = {0};
  meth_meth_parser_4556__apply->type = alloc_MethodType(1, argcv_meth_parser_4556__apply);
  meth_meth_parser_4556__apply->definitionModule = modulename;
  meth_meth_parser_4556__apply->definitionLine = 183;
// compiled block node returning block4555 (depth = 3)
  gc_frame_newslot(block4555);
// call case 5: prelude request
  params[0] = block4537;
  params[1] = block4555;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4991 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4536);
// compiled call node returning call4991 (depth = 2)
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4992 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4993 = alloc_Block(NULL, NULL, "parser", 1680);
  gc_frame_newslot(block4993);
// method "_apply"
  block_savedest(block4993);
  Object closure4994 = createclosure(2, "_apply");
  setclosureframe(closure4994, stackframe);
  addtoclosure(closure4994, var_ops);
  addtoclosure(closure4994, selfslot);
  struct UserObject *uo4994 = (struct UserObject*)block4993;
  uo4994->data[0] = (Object)closure4994;
  Method *meth_meth_parser_4994__apply = addmethod2pos(block4993, "_apply", &meth_parser_4994__apply, 0);
  int argcv_meth_parser_4994__apply[] = {0};
  meth_meth_parser_4994__apply->type = alloc_MethodType(1, argcv_meth_parser_4994__apply);
  meth_meth_parser_4994__apply->definitionModule = modulename;
  meth_meth_parser_4994__apply->definitionLine = 183;
// compiled block node returning block4993 (depth = 3)
  gc_frame_newslot(block4993);
// starting to compile block node (depth = 3)
  Object block5002 = alloc_Block(NULL, NULL, "parser", 1680);
  gc_frame_newslot(block5002);
// method "_apply"
  block_savedest(block5002);
  Object closure5003 = createclosure(8, "_apply");
  setclosureframe(closure5003, stackframe);
  addtoclosure(closure5003, var_ops);
  addtoclosure(closure5003, var_o);
  addtoclosure(closure5003, var_terms);
  addtoclosure(closure5003, var_tmp2);
  addtoclosure(closure5003, var_tmp);
  addtoclosure(closure5003, var_util);
  addtoclosure(closure5003, var_ast);
  addtoclosure(closure5003, selfslot);
  struct UserObject *uo5003 = (struct UserObject*)block5002;
  uo5003->data[0] = (Object)closure5003;
  Method *meth_meth_parser_5003__apply = addmethod2pos(block5002, "_apply", &meth_parser_5003__apply, 0);
  int argcv_meth_parser_5003__apply[] = {0};
  meth_meth_parser_5003__apply->type = alloc_MethodType(1, argcv_meth_parser_5003__apply);
  meth_meth_parser_5003__apply->definitionModule = modulename;
  meth_meth_parser_5003__apply->definitionLine = 183;
// compiled block node returning block5002 (depth = 3)
  gc_frame_newslot(block5002);
// call case 5: prelude request
  params[0] = block4993;
  params[1] = block5002;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5027 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4992);
// compiled call node returning call5027 (depth = 2)
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5028 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_terms (depth = 4)
  partcv[0] = 0;
  Object call5029 = callmethodflags(*var_terms, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5028);
// compiled member node returning call5029 (depth = 3)
  *var_tmp = call5029;
  if (call5029 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5031 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5032 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5031);
// compiled call node returning call5032 (depth = 2)
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5035 = alloc_Float64(0);
// compiled num node returning num5035 (depth = 4)
  int op_slot_right_5034 = gc_frame_newslot(num5035);
// starting to compile member node (depth = 4)
  int callframe5037 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  partcv[0] = 0;
  Object call5038 = callmethodflags(*var_terms, "size", 1, partcv, params, 0);
  gc_frame_end(callframe5037);
// compiled member node returning call5038 (depth = 4)
  int op_slot_left_5034 = gc_frame_newslot(call5038);
  params[0] = num5035;
  partcv[0] = 1;
  Object opresult5039 = callmethod(call5038, ">(1)", 1, partcv, params);
// compiled op node returning opresult5039 (depth = 3)
  Object if5033 = done;
  if (istrue(opresult5039)) {
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5040 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5041 == NULL) {
    strlit5041 = alloc_String("values left on term stack.");
    gc_root(strlit5041);
  }
// compiled string node returning strlit5041 (depth = 4)
  gc_frame_newslot(strlit5041);
// starting to compile member node (depth = 4)
  int callframe5042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5043 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5042);
// compiled member node returning call5043 (depth = 4)
  gc_frame_newslot(call5043);
// starting to compile member node (depth = 4)
  int callframe5044 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5045 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5044);
// compiled member node returning call5045 (depth = 4)
  gc_frame_newslot(call5045);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit5041;
  params[1] = call5043;
  params[2] = call5045;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call5046 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe5040);
// compiled call node returning call5046 (depth = 3)
    gc_frame_newslot(call5046);
    if5033 = call5046;
  } else {
  }
// compiled if node returning if5033 (depth = 2)
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startIndent (depth = 3)
  *var_minIndentLevel = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_5048_dotrest_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotrest(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method dotrest(_)");
  Object params[4];
  int partcv[3];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dotrest(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part dotrest(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_startIndent = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "startIndent");
  Object *var_lookuptarget = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lookuptarget");
// definebindings:
  Object *var_dro = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "dro");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
  Object *var_suggestion = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestion");
// definebindings:
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5050 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5051 == NULL) {
    strlit5051 = alloc_String("dot");
    gc_root(strlit5051);
  }
// compiled string node returning strlit5051 (depth = 4)
  gc_frame_newslot(strlit5051);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit5051;
  partcv[0] = 1;
  Object call5052 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5050);
// compiled call node returning call5052 (depth = 3)
  Object if5049 = done;
  if (istrue(call5052)) {
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_startIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5053 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5054 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5055 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5054);
// compiled member node returning call5055 (depth = 4)
  gc_frame_newslot(call5055);
// starting to compile member node (depth = 4)
  int callframe5056 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5057 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5056);
// compiled member node returning call5057 (depth = 4)
  gc_frame_newslot(call5057);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call5055;
  params[1] = call5057;
  partcv[0] = 2;
  Object call5058 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5053);
// compiled call node returning call5058 (depth = 3)
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5059 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5060 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5059);
// compiled member node returning call5060 (depth = 4)
  *var_lookuptarget = call5060;
  if (call5060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5061 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5062 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5061);
// compiled member node returning call5062 (depth = 3)
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5064 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5065 == NULL) {
    strlit5065 = alloc_String("identifier");
    gc_root(strlit5065);
  }
// compiled string node returning strlit5065 (depth = 5)
  gc_frame_newslot(strlit5065);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit5065;
  partcv[0] = 1;
  Object call5066 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5064);
// compiled call node returning call5066 (depth = 4)
  Object if5063 = done;
  if (istrue(call5066)) {
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5067 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5068 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5069 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5068);
// compiled member node returning call5069 (depth = 5)
  gc_frame_newslot(call5069);
// starting to compile member node (depth = 5)
  int callframe5070 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5071 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5070);
// compiled member node returning call5071 (depth = 5)
  gc_frame_newslot(call5071);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5069;
  params[1] = call5071;
  partcv[0] = 2;
  Object call5072 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5067);
// compiled call node returning call5072 (depth = 4)
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5073 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5074 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5075 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe5074);
// compiled member node returning call5075 (depth = 6)
  gc_frame_newslot(call5075);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lookuptarget (depth = 6)
  gc_frame_newslot(*var_lookuptarget);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5076 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5077 = callmethodflags(*var_ast, "memberNode", 1, partcv, params, 0);
  gc_frame_end(callframe5076);
// compiled member node returning call5077 (depth = 6)
  params[0] = call5075;
  params[1] = *var_lookuptarget;
  partcv[0] = 2;
  Object call5078 = callmethodflags(call5077, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5073);
// compiled call node returning call5078 (depth = 5)
  *var_dro = call5078;
  if (call5078 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5079 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dro (depth = 5)
  gc_frame_newslot(*var_dro);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_dro;
  partcv[0] = 1;
  Object call5080 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5079);
// compiled call node returning call5080 (depth = 4)
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5081 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5082 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5081);
// compiled member node returning call5082 (depth = 4)
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5084 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5085 == NULL) {
    strlit5085 = alloc_String("dot");
    gc_root(strlit5085);
  }
// compiled string node returning strlit5085 (depth = 6)
  gc_frame_newslot(strlit5085);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit5085;
  partcv[0] = 1;
  Object call5086 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5084);
// compiled call node returning call5086 (depth = 5)
  Object if5083 = done;
  if (istrue(call5086)) {
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5087 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5088 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5087);
// compiled call node returning call5088 (depth = 5)
    gc_frame_newslot(call5088);
    if5083 = call5088;
  } else {
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5090 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5091 == NULL) {
    strlit5091 = alloc_String("lgeneric");
    gc_root(strlit5091);
  }
// compiled string node returning strlit5091 (depth = 7)
  gc_frame_newslot(strlit5091);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit5091;
  partcv[0] = 1;
  Object call5092 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5090);
// compiled call node returning call5092 (depth = 6)
  Object if5089 = done;
  if (istrue(call5092)) {
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5093 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe5094 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5095 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5094);
// compiled member node returning call5095 (depth = 7)
  gc_frame_newslot(call5095);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_dro (depth = 7)
  params[0] = call5095;
  partcv[0] = 1;
  Object call5096 = callmethodflags(*var_dro, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5093);
// compiled call node returning call5096 (depth = 6)
    gc_frame_newslot(call5096);
    if5089 = call5096;
  } else {
  }
// compiled if node returning if5089 (depth = 5)
    gc_frame_newslot(if5089);
    if5083 = if5089;
  }
// compiled if node returning if5083 (depth = 4)
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5099 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5100 == NULL) {
    strlit5100 = alloc_String("lsquare");
    gc_root(strlit5100);
  }
// compiled string node returning strlit5100 (depth = 7)
  gc_frame_newslot(strlit5100);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit5100;
  partcv[0] = 1;
  Object call5101 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5099);
// compiled call node returning call5101 (depth = 6)
  int op_slot_right_5098 = gc_frame_newslot(call5101);
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5104 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5105 == NULL) {
    strlit5105 = alloc_String("string");
    gc_root(strlit5105);
  }
// compiled string node returning strlit5105 (depth = 8)
  gc_frame_newslot(strlit5105);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit5105;
  partcv[0] = 1;
  Object call5106 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5104);
// compiled call node returning call5106 (depth = 7)
  int op_slot_right_5103 = gc_frame_newslot(call5106);
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5109 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit5110 == NULL) {
    strlit5110 = alloc_String("num");
    gc_root(strlit5110);
  }
// compiled string node returning strlit5110 (depth = 9)
  gc_frame_newslot(strlit5110);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = strlit5110;
  partcv[0] = 1;
  Object call5111 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5109);
// compiled call node returning call5111 (depth = 8)
  int op_slot_right_5108 = gc_frame_newslot(call5111);
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5115 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit5116 == NULL) {
    strlit5116 = alloc_String("lbrace");
    gc_root(strlit5116);
  }
// compiled string node returning strlit5116 (depth = 11)
  gc_frame_newslot(strlit5116);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning module_parser (depth = 11)
  params[0] = strlit5116;
  partcv[0] = 1;
  Object call5117 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5115);
// compiled call node returning call5117 (depth = 10)
  int op_slot_right_5114 = gc_frame_newslot(call5117);
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_acceptBlocks (depth = 10)
  int op_slot_left_5114 = gc_frame_newslot(*var_acceptBlocks);
  params[0] = call5117;
  partcv[0] = 1;
  Object opresult5119 = callmethod(*var_acceptBlocks, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5119 (depth = 9)
  int op_slot_right_5113 = gc_frame_newslot(opresult5119);
// starting to compile call node (depth = 9)
  int callframe5121 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5122 == NULL) {
    strlit5122 = alloc_String("lparen");
    gc_root(strlit5122);
  }
// compiled string node returning strlit5122 (depth = 10)
  gc_frame_newslot(strlit5122);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = strlit5122;
  partcv[0] = 1;
  Object call5123 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5121);
// compiled call node returning call5123 (depth = 9)
  int op_slot_left_5113 = gc_frame_newslot(call5123);
  params[0] = opresult5119;
  partcv[0] = 1;
  Object opresult5124 = callmethod(call5123, "||(1)", 1, partcv, params);
// compiled op node returning opresult5124 (depth = 8)
  int op_slot_left_5108 = gc_frame_newslot(opresult5124);
  params[0] = call5111;
  partcv[0] = 1;
  Object opresult5125 = callmethod(opresult5124, "||(1)", 1, partcv, params);
// compiled op node returning opresult5125 (depth = 7)
  int op_slot_left_5103 = gc_frame_newslot(opresult5125);
  params[0] = call5106;
  partcv[0] = 1;
  Object opresult5126 = callmethod(opresult5125, "||(1)", 1, partcv, params);
// compiled op node returning opresult5126 (depth = 6)
  int op_slot_left_5098 = gc_frame_newslot(opresult5126);
  params[0] = call5101;
  partcv[0] = 1;
  Object opresult5127 = callmethod(opresult5126, "||(1)", 1, partcv, params);
// compiled op node returning opresult5127 (depth = 5)
  Object if5097 = done;
  if (istrue(opresult5127)) {
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5128 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5129 = callmethodflags(module_parser, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5128);
// compiled call node returning call5129 (depth = 5)
    gc_frame_newslot(call5129);
    if5097 = call5129;
  } else {
  }
// compiled if node returning if5097 (depth = 4)
    gc_frame_newslot(if5097);
    if5063 = if5097;
  } else {
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array5130 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5130 (depth = 5)
  *var_suggestions = array5130;
  if (array5130 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5131 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5132 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call5133 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5132);
// compiled member node returning call5133 (depth = 6)
  partcv[0] = 0;
  Object call5134 = callmethodflags(call5133, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5131);
// compiled member node returning call5134 (depth = 5)
  *var_suggestion = call5134;
  if (call5134 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5135 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call5136 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5135);
// compiled call node returning call5136 (depth = 4)
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5137 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5138 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5137);
// compiled call node returning call5138 (depth = 4)
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5139 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5140 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call5141 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5140);
// compiled member node returning call5141 (depth = 6)
  partcv[0] = 0;
  Object call5142 = callmethodflags(call5141, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5139);
// compiled member node returning call5142 (depth = 5)
  *var_suggestion = call5142;
  if (call5142 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5144 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5145 == NULL) {
    strlit5145 = alloc_String("""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit5145);
  }
// compiled string node returning strlit5145 (depth = 5)
  gc_frame_newslot(strlit5145);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5145;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5146 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5144);
// compiled call node returning call5146 (depth = 4)
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5147 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5148 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5147);
// compiled call node returning call5148 (depth = 4)
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5149 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5150 == NULL) {
    strlit5150 = alloc_String("a field or method name must follow a '.'.");
    gc_root(strlit5150);
  }
// compiled string node returning strlit5150 (depth = 5)
  gc_frame_newslot(strlit5150);
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5151 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5152 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5151);
// compiled member node returning call5152 (depth = 5)
  gc_frame_newslot(call5152);
// starting to compile member node (depth = 5)
  int callframe5153 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5154 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5153);
// compiled member node returning call5154 (depth = 5)
  gc_frame_newslot(call5154);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5150;
  params[1] = call5152;
  params[2] = call5154;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5155 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5149);
// compiled call node returning call5155 (depth = 4)
    gc_frame_newslot(call5155);
    if5063 = call5155;
  }
// compiled if node returning if5063 (depth = 3)
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_minIndentLevel = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5049 = done;
  } else {
  }
// compiled if node returning if5049 (depth = 2)
  gc_frame_end(frame);
  return if5049;
}
Object meth_parser_5238__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe5239 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5240 == NULL) {
    strlit5240 = alloc_String("identifier");
    gc_root(strlit5240);
  }
// compiled string node returning strlit5240 (depth = 6)
  gc_frame_newslot(strlit5240);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit5240;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5241 = callmethodflags(module_parser, "accept(1)onLineOfLastOr(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5239);
// compiled call node returning call5241 (depth = 5)
  gc_frame_end(frame);
  return call5241;
}
Object meth_parser_5244__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_meth = getfromclosure(closure, 2);
  Object *var_acceptBlocks = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_lnum = getfromclosure(closure, 6);
  Object *var_lpos = getfromclosure(closure, 7);
  Object *var_argumentParts = getfromclosure(closure, 8);
  Object self = *(getfromclosure(closure, 9));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_argList = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "argList");
  Object *var_namePart = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "namePart");
  Object *var_argsFound = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "argsFound");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_more = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "more");
  Object *var_reqStart = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "reqStart");
  Object *var_reqEnd = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "reqEnd");
  Object *var_reqRange = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "reqRange");
// definebindings:
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array5245 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5245 (depth = 6)
  *var_argList = array5245;
  if (array5245 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5246 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe5247 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe5248 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5249 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe5248);
// compiled member node returning call5249 (depth = 8)
  gc_frame_newslot(call5249);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_argList (depth = 8)
  gc_frame_newslot(*var_argList);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5250 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call5251 = callmethodflags(*var_ast, "requestPart", 1, partcv, params, 0);
  gc_frame_end(callframe5250);
// compiled member node returning call5251 (depth = 8)
  params[0] = call5249;
  params[1] = *var_argList;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5252 = callmethodflags(call5251, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5247);
// compiled call node returning call5252 (depth = 7)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call5253 = callmethodflags(call5252, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5246);
// compiled call node returning call5253 (depth = 6)
  *var_namePart = call5253;
  if (call5253 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5254 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5255 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5254);
// compiled member node returning call5255 (depth = 5)
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5256 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_namePart (depth = 7)
  gc_frame_newslot(*var_namePart);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_meth;
  params[1] = *var_namePart;
  params[2] = *var_acceptBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5257 = callmethodflags(module_parser, "parseArgumentsFor(1)into(1)acceptBlocks(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5256);
// compiled call node returning call5257 (depth = 6)
  *var_argsFound = call5257;
  if (call5257 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5259 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_argsFound (depth = 7)
  partcv[0] = 0;
  Object call5260 = callmethodflags(*var_argsFound, "not", 1, partcv, params, 0);
  gc_frame_end(callframe5259);
// compiled member node returning call5260 (depth = 6)
  Object if5258 = done;
  if (istrue(call5260)) {
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5261 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5262 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5263 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5262);
// compiled member node returning call5263 (depth = 8)
  partcv[0] = 0;
  Object call5264 = callmethodflags(call5263, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5261);
// compiled member node returning call5264 (depth = 7)
  *var_suggestion = call5264;
  if (call5264 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5265 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5266 == NULL) {
    strlit5266 = alloc_String("(""\xe2""""\x80""""\xb9""expression""\xe2""""\x80""""\xba"")");
    gc_root(strlit5266);
  }
// compiled string node returning strlit5266 (depth = 7)
  gc_frame_newslot(strlit5266);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit5266;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5267 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5265);
// compiled call node returning call5267 (depth = 6)
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5269 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5270 = callmethodflags(self, "indentHasIncreased", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5269);
// compiled member node returning call5270 (depth = 8)
  Object if5268 = done;
struct StackFrameObject *iftmpstackframe5268 = stackframe;
  if (istrue(call5270)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5268);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit5272 == NULL) {
    strlit5272 = alloc_String(" the previous line; is that what you intended?");
    gc_root(strlit5272);
  }
// compiled string node returning strlit5272 (depth = 9)
  int op_slot_right_5271 = gc_frame_newslot(strlit5272);
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit5274 == NULL) {
    strlit5274 = alloc_String("  The indentation tells me that this is a continuation of");
    gc_root(strlit5274);
  }
// compiled string node returning strlit5274 (depth = 9)
  int op_slot_left_5271 = gc_frame_newslot(strlit5274);
  params[0] = strlit5272;
  partcv[0] = 1;
  Object opresult5275 = callmethod(strlit5274, "++(1)", 1, partcv, params);
// compiled op node returning opresult5275 (depth = 8)
    gc_frame_newslot(opresult5275);
    if5268 = opresult5275;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5268);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit5276 == NULL) {
    strlit5276 = alloc_String("");
    gc_root(strlit5276);
  }
// compiled string node returning strlit5276 (depth = 8)
    gc_frame_newslot(strlit5276);
    if5268 = strlit5276;
  }
stackframe = iftmpstackframe5268;
// compiled if node returning if5268 (depth = 7)
  *var_more = if5268;
  if (if5268 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5277 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lnum (depth = 8)
  gc_frame_newslot(*var_lnum);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lpos (depth = 8)
  gc_frame_newslot(*var_lpos);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  params[0] = *var_lnum;
  params[1] = *var_lpos;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5278 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5277);
// compiled call node returning call5278 (depth = 7)
  *var_reqStart = call5278;
  if (call5278 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5279 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe5280 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5281 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5280);
// compiled member node returning call5281 (depth = 8)
  gc_frame_newslot(call5281);
// starting to compile member node (depth = 8)
  int callframe5282 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5283 = callmethodflags(*var_lastToken, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe5282);
// compiled member node returning call5283 (depth = 8)
  gc_frame_newslot(call5283);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  params[0] = call5281;
  params[1] = call5283;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5284 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5279);
// compiled call node returning call5284 (depth = 7)
  *var_reqEnd = call5284;
  if (call5284 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5285 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_reqStart (depth = 8)
  gc_frame_newslot(*var_reqStart);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_reqEnd (depth = 8)
  gc_frame_newslot(*var_reqEnd);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  params[0] = *var_reqStart;
  params[1] = *var_reqEnd;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5286 = callmethodflags(*var_ast, "start(1)end(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5285);
// compiled call node returning call5286 (depth = 7)
  *var_reqRange = call5286;
  if (call5286 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5287 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_more (depth = 8)
  int op_slot_right_5288 = gc_frame_newslot(*var_more);
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit5291 == NULL) {
    strlit5291 = alloc_String(" either parenthesized or self-delimiting.");
    gc_root(strlit5291);
  }
// compiled string node returning strlit5291 (depth = 9)
  int op_slot_right_5290 = gc_frame_newslot(strlit5291);
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit5293 == NULL) {
    strlit5293 = alloc_String("a multi-part method request must end with an argument list,");
    gc_root(strlit5293);
  }
// compiled string node returning strlit5293 (depth = 9)
  int op_slot_left_5290 = gc_frame_newslot(strlit5293);
  params[0] = strlit5291;
  partcv[0] = 1;
  Object opresult5294 = callmethod(strlit5293, "++(1)", 1, partcv, params);
// compiled op node returning opresult5294 (depth = 8)
  int op_slot_left_5288 = gc_frame_newslot(opresult5294);
  params[0] = *var_more;
  partcv[0] = 1;
  Object opresult5295 = callmethod(opresult5294, "++(1)", 1, partcv, params);
// compiled op node returning opresult5295 (depth = 7)
  gc_frame_newslot(opresult5295);
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_reqRange (depth = 7)
  gc_frame_newslot(*var_reqRange);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5295;
  params[1] = *var_reqRange;
  params[2] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5296 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(1)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5287);
// compiled call node returning call5296 (depth = 6)
    gc_frame_newslot(call5296);
    if5258 = call5296;
  } else {
  }
// compiled if node returning if5258 (depth = 5)
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5297 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_namePart (depth = 6)
  gc_frame_newslot(*var_namePart);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_argumentParts (depth = 6)
  params[0] = *var_namePart;
  partcv[0] = 1;
  Object call5298 = callmethodflags(*var_argumentParts, "addLast(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5297);
// compiled call node returning call5298 (depth = 5)
  gc_frame_end(frame);
  return call5298;
}
Object meth_parser_5157_callrest_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callrest(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method callrest(_)");
  Object params[3];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_statementToken = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastLine = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callrest(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part callrest(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_meth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "meth");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_lnum = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lnum");
  Object *var_lpos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "lpos");
  Object *var_methn = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "methn");
  Object *var_argumentParts = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "argumentParts");
  Object *var_part = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "part");
  Object *var_foundArgs = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "foundArgs");
  Object *var_tok = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "tok");
  Object *var_genericIdents = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "genericIdents");
  Object *var_g = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "g");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_realRcvr = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "realRcvr");
// definebindings:
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5160 = alloc_Float64(0);
// compiled num node returning num5160 (depth = 4)
  int op_slot_right_5159 = gc_frame_newslot(num5160);
// starting to compile member node (depth = 4)
  int callframe5162 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5163 = callmethodflags(*var_values, "size", 1, partcv, params, 0);
  gc_frame_end(callframe5162);
// compiled member node returning call5163 (depth = 4)
  int op_slot_left_5159 = gc_frame_newslot(call5163);
  params[0] = num5160;
  partcv[0] = 1;
  Object opresult5164 = callmethod(call5163, "==(1)", 1, partcv, params);
// compiled op node returning opresult5164 (depth = 3)
  Object if5158 = done;
  if (istrue(opresult5164)) {
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5158 = undefined;
  } else {
  }
// compiled if node returning if5158 (depth = 2)
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5165 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  partcv[0] = 0;
  Object call5166 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5165);
// compiled member node returning call5166 (depth = 3)
  *var_meth = call5166;
  if (call5166 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5169 == NULL) {
    strlit5169 = alloc_String("identifier");
    gc_root(strlit5169);
  }
// compiled string node returning strlit5169 (depth = 4)
  int op_slot_right_5168 = gc_frame_newslot(strlit5169);
// starting to compile member node (depth = 4)
  int callframe5171 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call5172 = callmethodflags(*var_meth, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5171);
// compiled member node returning call5172 (depth = 4)
  int op_slot_left_5168 = gc_frame_newslot(call5172);
  params[0] = strlit5169;
  partcv[0] = 1;
  Object opresult5173 = callmethod(call5172, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5173 (depth = 3)
  Object if5167 = done;
  if (istrue(opresult5173)) {
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5176 == NULL) {
    strlit5176 = alloc_String("member");
    gc_root(strlit5176);
  }
// compiled string node returning strlit5176 (depth = 5)
  int op_slot_right_5175 = gc_frame_newslot(strlit5176);
// starting to compile member node (depth = 5)
  int callframe5178 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call5179 = callmethodflags(*var_meth, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5178);
// compiled member node returning call5179 (depth = 5)
  int op_slot_left_5175 = gc_frame_newslot(call5179);
  params[0] = strlit5176;
  partcv[0] = 1;
  Object opresult5180 = callmethod(call5179, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5180 (depth = 4)
  Object if5174 = done;
  if (istrue(opresult5180)) {
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5181 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5182 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5181);
// compiled call node returning call5182 (depth = 4)
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5174 = undefined;
  } else {
  }
// compiled if node returning if5174 (depth = 3)
    gc_frame_newslot(if5174);
    if5167 = if5174;
  } else {
  }
// compiled if node returning if5167 (depth = 2)
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5183 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  partcv[0] = 0;
  Object call5184 = callmethodflags(*var_meth, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5183);
// compiled member node returning call5184 (depth = 3)
  *var_lnum = call5184;
  if (call5184 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5185 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  partcv[0] = 0;
  Object call5186 = callmethodflags(*var_meth, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5185);
// compiled member node returning call5186 (depth = 3)
  *var_lpos = call5186;
  if (call5186 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5187 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  partcv[0] = 0;
  Object call5188 = callmethodflags(*var_meth, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe5187);
// compiled member node returning call5188 (depth = 3)
  *var_methn = call5188;
  if (call5188 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5189 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5189 (depth = 3)
  *var_argumentParts = array5189;
  if (array5189 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5190 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe5191 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methn (depth = 5)
  gc_frame_newslot(*var_methn);
// starting to compile array node (depth = 5)
  Object array5192 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5192 (depth = 5)
  gc_frame_newslot(array5192);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5193 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call5194 = callmethodflags(*var_ast, "requestPart", 1, partcv, params, 0);
  gc_frame_end(callframe5193);
// compiled member node returning call5194 (depth = 5)
  params[0] = *var_methn;
  params[1] = array5192;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5195 = callmethodflags(call5194, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5191);
// compiled call node returning call5195 (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5196 = callmethodflags(call5195, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5190);
// compiled call node returning call5196 (depth = 3)
  *var_part = call5196;
  if (call5196 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5197 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_argumentParts (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5198 = callmethodflags(*var_argumentParts, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5197);
// compiled call node returning call5198 (depth = 2)
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5199 = alloc_Boolean(0);
// compiled identifier node returning bool5199 (depth = 3)
  *var_foundArgs = bool5199;
  if (bool5199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5200 = alloc_Boolean(0);
// compiled identifier node returning bool5200 (depth = 3)
  *var_genericIdents = bool5200;
  if (bool5200 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5201 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  partcv[0] = 0;
  Object call5202 = callmethodflags(*var_meth, "generics", 1, partcv, params, 0);
  gc_frame_end(callframe5201);
// compiled member node returning call5202 (depth = 3)
  *var_g = call5202;
  if (call5202 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_g (depth = 4)
  int op_slot_right_5204 = gc_frame_newslot(*var_g);
// starting to compile identifier node (depth = 4)
  Object bool5206 = alloc_Boolean(0);
// compiled identifier node returning bool5206 (depth = 4)
  int op_slot_left_5204 = gc_frame_newslot(bool5206);
  params[0] = *var_g;
  partcv[0] = 1;
  Object opresult5207 = callmethod(bool5206, "==(1)", 1, partcv, params);
// compiled op node returning opresult5207 (depth = 3)
  Object if5203 = done;
  if (istrue(opresult5207)) {
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5209 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5210 == NULL) {
    strlit5210 = alloc_String("lgeneric");
    gc_root(strlit5210);
  }
// compiled string node returning strlit5210 (depth = 5)
  gc_frame_newslot(strlit5210);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit5210;
  partcv[0] = 1;
  Object call5211 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5209);
// compiled call node returning call5211 (depth = 4)
  Object if5208 = done;
  if (istrue(call5211)) {
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5212 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5213 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5212);
// compiled member node returning call5213 (depth = 5)
  *var_genericIdents = call5213;
  if (call5213 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5208 = done;
  } else {
  }
// compiled if node returning if5208 (depth = 3)
    gc_frame_newslot(if5208);
    if5203 = if5208;
  } else {
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_g (depth = 4)
  *var_genericIdents = *var_g;
  if (*var_g == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5203 = done;
  }
// compiled if node returning if5203 (depth = 2)
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5216 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  gc_frame_newslot(*var_part);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_meth;
  params[1] = *var_part;
  params[2] = *var_acceptBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5217 = callmethodflags(module_parser, "parseArgumentsFor(1)into(1)acceptBlocks(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5216);
// compiled call node returning call5217 (depth = 3)
  *var_foundArgs = call5217;
  if (call5217 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_foundArgs (depth = 3)
  Object if5219 = done;
  if (istrue(*var_foundArgs)) {
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5221 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call5222 = callmethodflags(*var_meth, "isIdentifier", 1, partcv, params, 0);
  gc_frame_end(callframe5221);
// compiled member node returning call5222 (depth = 5)
  Object if5220 = done;
struct StackFrameObject *iftmpstackframe5220 = stackframe;
  if (istrue(call5222)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5220);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5223 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5224 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5225 = callmethodflags(*var_ast, "implicit", 1, partcv, params, 0);
  gc_frame_end(callframe5224);
// compiled member node returning call5225 (depth = 6)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5226 = callmethodflags(call5225, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5223);
// compiled call node returning call5226 (depth = 5)
    gc_frame_newslot(call5226);
    if5220 = call5226;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5220);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5227 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call5228 = callmethodflags(*var_meth, "receiver", 1, partcv, params, 0);
  gc_frame_end(callframe5227);
// compiled member node returning call5228 (depth = 5)
    gc_frame_newslot(call5228);
    if5220 = call5228;
  }
stackframe = iftmpstackframe5220;
// compiled if node returning if5220 (depth = 4)
  *var_realRcvr = if5220;
  if (if5220 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5229 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_realRcvr (depth = 5)
  gc_frame_newslot(*var_realRcvr);
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe5230 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_realRcvr (depth = 6)
  gc_frame_newslot(*var_realRcvr);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_argumentParts (depth = 6)
  gc_frame_newslot(*var_argumentParts);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5231 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5232 = callmethodflags(*var_ast, "callNode", 1, partcv, params, 0);
  gc_frame_end(callframe5231);
// compiled member node returning call5232 (depth = 6)
  params[0] = *var_realRcvr;
  params[1] = *var_argumentParts;
  partcv[0] = 2;
  Object call5233 = callmethodflags(call5232, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5230);
// compiled call node returning call5233 (depth = 5)
  params[0] = *var_realRcvr;
  partcv[0] = 1;
  Object call5234 = callmethodflags(call5233, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5229);
// compiled call node returning call5234 (depth = 4)
  *var_meth = call5234;
  if (call5234 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5236 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5237 = alloc_Block(NULL, NULL, "parser", 1790);
  gc_frame_newslot(block5237);
// method "_apply"
  block_savedest(block5237);
  Object closure5238 = createclosure(2, "_apply");
  setclosureframe(closure5238, stackframe);
  addtoclosure(closure5238, var_statementToken);
  addtoclosure(closure5238, selfslot);
  struct UserObject *uo5238 = (struct UserObject*)block5237;
  uo5238->data[0] = (Object)closure5238;
  Method *meth_meth_parser_5238__apply = addmethod2pos(block5237, "_apply", &meth_parser_5238__apply, 0);
  int argcv_meth_parser_5238__apply[] = {0};
  meth_meth_parser_5238__apply->type = alloc_MethodType(1, argcv_meth_parser_5238__apply);
  meth_meth_parser_5238__apply->definitionModule = modulename;
  meth_meth_parser_5238__apply->definitionLine = 183;
// compiled block node returning block5237 (depth = 4)
  gc_frame_newslot(block5237);
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5243 = alloc_Block(NULL, NULL, "parser", 1790);
  gc_frame_newslot(block5243);
// method "_apply"
  block_savedest(block5243);
  Object closure5244 = createclosure(10, "_apply");
  setclosureframe(closure5244, stackframe);
  addtoclosure(closure5244, var_sym);
  addtoclosure(closure5244, var_ast);
  addtoclosure(closure5244, var_meth);
  addtoclosure(closure5244, var_acceptBlocks);
  addtoclosure(closure5244, var_errormessages);
  addtoclosure(closure5244, var_lastToken);
  addtoclosure(closure5244, var_lnum);
  addtoclosure(closure5244, var_lpos);
  addtoclosure(closure5244, var_argumentParts);
  addtoclosure(closure5244, selfslot);
  struct UserObject *uo5244 = (struct UserObject*)block5243;
  uo5244->data[0] = (Object)closure5244;
  Method *meth_meth_parser_5244__apply = addmethod2pos(block5243, "_apply", &meth_parser_5244__apply, 0);
  int argcv_meth_parser_5244__apply[] = {0};
  meth_meth_parser_5244__apply->type = alloc_MethodType(1, argcv_meth_parser_5244__apply);
  meth_meth_parser_5244__apply->definitionModule = modulename;
  meth_meth_parser_5244__apply->definitionLine = 183;
// compiled block node returning block5243 (depth = 4)
  gc_frame_newslot(block5243);
// call case 5: prelude request
  params[0] = block5237;
  params[1] = block5243;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5300 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5236);
// compiled call node returning call5300 (depth = 3)
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5301 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5302 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  gc_frame_newslot(*var_lastLine);
// starting to compile member node (depth = 5)
  int callframe5303 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call5304 = callmethodflags(*var_lastToken, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe5303);
// compiled member node returning call5304 (depth = 5)
  gc_frame_newslot(call5304);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  params[0] = *var_lastLine;
  params[1] = call5304;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5305 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5302);
// compiled call node returning call5305 (depth = 4)
  gc_frame_newslot(call5305);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = call5305;
  partcv[0] = 1;
  Object call5306 = callmethodflags(*var_meth, "end:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5301);
// compiled call node returning call5306 (depth = 3)
    gc_frame_newslot(call5306);
    if5219 = call5306;
  } else {
  }
// compiled if node returning if5219 (depth = 2)
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5307 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genericIdents (depth = 3)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5308 = callmethodflags(*var_meth, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5307);
// compiled call node returning call5308 (depth = 2)
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5309 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5310 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5309);
// compiled call node returning call5310 (depth = 2)
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5311 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_acceptBlocks (depth = 3)
  gc_frame_newslot(*var_acceptBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_parser (depth = 3)
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5312 = callmethodflags(module_parser, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5311);
// compiled call node returning call5312 (depth = 2)
  gc_frame_end(frame);
  return call5312;
}
Object meth_parser_5325__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe5326 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5327 == NULL) {
    strlit5327 = alloc_String("lbrace");
    gc_root(strlit5327);
  }
// compiled string node returning strlit5327 (depth = 7)
  gc_frame_newslot(strlit5327);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_statementToken (depth = 7)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit5327;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5328 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5326);
// compiled call node returning call5328 (depth = 6)
  gc_frame_end(frame);
  return call5328;
}
Object meth_parser_5313_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseArgumentsFor(1)into(1)acceptBlocks(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseArgumentsFor(_)into(_)acceptBlocks(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseArgumentsFor(_)into(_)acceptBlocks(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseArgumentsFor(_)into(_)acceptBlocks(_)");
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for parseArgumentsFor(_)into(_)acceptBlocks(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_meth = &(stackframe->slots[0]);
  *var_meth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseArgumentsFor(_)");
  Object *var_part = &(stackframe->slots[1]);
  *var_part = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *var_acceptBlocks = &(stackframe->slots[2]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptBlocks(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_tok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "tok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5315 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5316 == NULL) {
    strlit5316 = alloc_String("lparen");
    gc_root(strlit5316);
  }
// compiled string node returning strlit5316 (depth = 4)
  gc_frame_newslot(strlit5316);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit5316;
  partcv[0] = 1;
  Object call5317 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5315);
// compiled call node returning call5317 (depth = 3)
  Object if5314 = done;
  if (istrue(call5317)) {
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5319 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  gc_frame_newslot(*var_part);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_part;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5320 = callmethodflags(module_parser, "parenthesizedArgs(1)startingWith(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5319);
// compiled call node returning call5320 (depth = 3)
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5321 = alloc_Boolean(1);
// compiled identifier node returning bool5321 (depth = 3)
    gc_frame_newslot(bool5321);
    if5314 = bool5321;
  } else {
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block5324 = alloc_Block(NULL, NULL, "parser", 1833);
  gc_frame_newslot(block5324);
// method "_apply"
  block_savedest(block5324);
  Object closure5325 = createclosure(2, "_apply");
  setclosureframe(closure5325, stackframe);
  addtoclosure(closure5325, var_statementToken);
  addtoclosure(closure5325, selfslot);
  struct UserObject *uo5325 = (struct UserObject*)block5324;
  uo5325->data[0] = (Object)closure5325;
  Method *meth_meth_parser_5325__apply = addmethod2pos(block5324, "_apply", &meth_parser_5325__apply, 0);
  int argcv_meth_parser_5325__apply[] = {0};
  meth_meth_parser_5325__apply->type = alloc_MethodType(1, argcv_meth_parser_5325__apply);
  meth_meth_parser_5325__apply->definitionModule = modulename;
  meth_meth_parser_5325__apply->definitionLine = 183;
// compiled block node returning block5324 (depth = 5)
  int op_slot_right_5323 = gc_frame_newslot(block5324);
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5331 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  partcv[0] = 0;
  Object call5332 = callmethodflags(*var_acceptBlocks, "not", 1, partcv, params, 0);
  gc_frame_end(callframe5331);
// compiled member node returning call5332 (depth = 5)
  int op_slot_left_5323 = gc_frame_newslot(call5332);
  params[0] = block5324;
  partcv[0] = 1;
  Object opresult5333 = callmethod(call5332, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5333 (depth = 4)
  Object if5322 = done;
  if (istrue(opresult5333)) {
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5334 = alloc_Boolean(0);
// compiled identifier node returning bool5334 (depth = 4)
    gc_frame_newslot(bool5334);
    if5322 = bool5334;
  } else {
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5336 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call5337 = callmethodflags(module_parser, "acceptArgumentOnLineOf(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5336);
// compiled call node returning call5337 (depth = 5)
  Object if5335 = done;
  if (istrue(call5337)) {
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5339 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5340 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5339);
// compiled member node returning call5340 (depth = 5)
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5341 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5342 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call5343 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5342);
// compiled member node returning call5343 (depth = 6)
  gc_frame_newslot(call5343);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5344 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call5345 = callmethodflags(*var_part, "args", 1, partcv, params, 0);
  gc_frame_end(callframe5344);
// compiled member node returning call5345 (depth = 6)
  params[0] = call5343;
  partcv[0] = 1;
  Object call5346 = callmethodflags(call5345, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5341);
// compiled call node returning call5346 (depth = 5)
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool5347 = alloc_Boolean(1);
// compiled identifier node returning bool5347 (depth = 5)
    gc_frame_newslot(bool5347);
    if5335 = bool5347;
  } else {
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool5348 = alloc_Boolean(0);
// compiled identifier node returning bool5348 (depth = 5)
    gc_frame_newslot(bool5348);
    if5335 = bool5348;
  }
// compiled if node returning if5335 (depth = 4)
    gc_frame_newslot(if5335);
    if5322 = if5335;
  }
// compiled if node returning if5322 (depth = 3)
    gc_frame_newslot(if5322);
    if5314 = if5322;
  }
// compiled if node returning if5314 (depth = 2)
  gc_frame_end(frame);
  return if5314;
}
Object meth_parser_5355__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe5356 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5357 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5356);
// compiled call node returning call5357 (depth = 5)
  gc_frame_end(frame);
  return call5357;
}
Object meth_parser_5362__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe5363 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5364 == NULL) {
    strlit5364 = alloc_String("comma");
    gc_root(strlit5364);
  }
// compiled string node returning strlit5364 (depth = 6)
  gc_frame_newslot(strlit5364);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit5364;
  partcv[0] = 1;
  Object call5365 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5363);
// compiled call node returning call5365 (depth = 5)
  gc_frame_end(frame);
  return call5365;
}
Object meth_parser_5380__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 8)
  int callframe5381 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5382 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5381);
// compiled call node returning call5382 (depth = 8)
  gc_frame_end(frame);
  return call5382;
}
Object meth_parser_5368__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5369 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5370 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call5371 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5370);
// compiled member node returning call5371 (depth = 6)
  gc_frame_newslot(call5371);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5372 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call5373 = callmethodflags(*var_part, "args", 1, partcv, params, 0);
  gc_frame_end(callframe5372);
// compiled member node returning call5373 (depth = 6)
  params[0] = call5371;
  partcv[0] = 1;
  Object call5374 = callmethodflags(call5373, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5369);
// compiled call node returning call5374 (depth = 5)
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5375 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5376 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5375);
// compiled member node returning call5376 (depth = 5)
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5378 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5379 = alloc_Block(NULL, NULL, "parser", 1851);
  gc_frame_newslot(block5379);
// method "_apply"
  block_savedest(block5379);
  Object closure5380 = createclosure(2, "_apply");
  setclosureframe(closure5380, stackframe);
  addtoclosure(closure5380, var_blocksOK);
  addtoclosure(closure5380, selfslot);
  struct UserObject *uo5380 = (struct UserObject*)block5379;
  uo5380->data[0] = (Object)closure5380;
  Method *meth_meth_parser_5380__apply = addmethod2pos(block5379, "_apply", &meth_parser_5380__apply, 0);
  int argcv_meth_parser_5380__apply[] = {0};
  meth_meth_parser_5380__apply->type = alloc_MethodType(1, argcv_meth_parser_5380__apply);
  meth_meth_parser_5380__apply->definitionModule = modulename;
  meth_meth_parser_5380__apply->definitionLine = 183;
// compiled block node returning block5379 (depth = 7)
  gc_frame_newslot(block5379);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block5379;
  partcv[0] = 1;
  Object call5384 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5378);
// compiled call node returning call5384 (depth = 6)
  Object if5377 = done;
  if (istrue(call5384)) {
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array5385 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5385 (depth = 7)
  *var_suggestions = array5385;
  if (array5385 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5386 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5387 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5388 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5387);
// compiled member node returning call5388 (depth = 8)
  partcv[0] = 0;
  Object call5389 = callmethodflags(call5388, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5386);
// compiled member node returning call5389 (depth = 7)
  *var_suggestion = call5389;
  if (call5389 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5390 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5391 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5392 == NULL) {
    strlit5392 = alloc_String("rparen");
    gc_root(strlit5392);
  }
// compiled string node returning strlit5392 (depth = 9)
  params[0] = strlit5392;
  partcv[0] = 1;
  callmethodflags(array5391, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5391 (depth = 8)
  gc_frame_newslot(array5391);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = array5391;
  partcv[0] = 1;
  Object call5393 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5390);
// compiled call node returning call5393 (depth = 7)
  *var_nextTok = call5393;
  if (call5393 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5395 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5395 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5397 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5397 (depth = 7)
  Object if5394 = done;
  if (istrue(opresult5397)) {
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5398 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5399 == NULL) {
    strlit5399 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5399);
  }
// compiled string node returning strlit5399 (depth = 8)
  gc_frame_newslot(strlit5399);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit5399;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5400 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5398);
// compiled call node returning call5400 (depth = 7)
    gc_frame_newslot(call5400);
    if5394 = call5400;
  } else {
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5401 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe5402 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call5403 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe5402);
// compiled member node returning call5403 (depth = 8)
  gc_frame_newslot(call5403);
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool5404 = alloc_Boolean(1);
// compiled identifier node returning bool5404 (depth = 8)
  gc_frame_newslot(bool5404);
// starting to compile identifier node (depth = 8)
  Object bool5405 = alloc_Boolean(0);
// compiled identifier node returning bool5405 (depth = 8)
  gc_frame_newslot(bool5405);
// starting to compile string node (depth = 8)
  if (strlit5406 == NULL) {
    strlit5406 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5406);
  }
// compiled string node returning strlit5406 (depth = 8)
  gc_frame_newslot(strlit5406);
// call case 6: other requests
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5403;
  params[2] = bool5404;
  params[3] = bool5405;
  params[4] = strlit5406;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5407 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5401);
// compiled call node returning call5407 (depth = 7)
    gc_frame_newslot(call5407);
    if5394 = call5407;
  }
// compiled if node returning if5394 (depth = 6)
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5408 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5409 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5408);
// compiled call node returning call5409 (depth = 6)
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5410 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5411 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5412 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5411);
// compiled member node returning call5412 (depth = 8)
  partcv[0] = 0;
  Object call5413 = callmethodflags(call5412, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5410);
// compiled member node returning call5413 (depth = 7)
  *var_suggestion = call5413;
  if (call5413 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5415 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe5416 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call5417 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe5416);
// compiled member node returning call5417 (depth = 7)
  gc_frame_newslot(call5417);
// starting to compile identifier node (depth = 7)
  Object bool5418 = alloc_Boolean(1);
// compiled identifier node returning bool5418 (depth = 7)
  gc_frame_newslot(bool5418);
// starting to compile identifier node (depth = 7)
  Object bool5419 = alloc_Boolean(0);
// compiled identifier node returning bool5419 (depth = 7)
  gc_frame_newslot(bool5419);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call5417;
  params[2] = bool5418;
  params[3] = bool5419;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5420 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5415);
// compiled call node returning call5420 (depth = 6)
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5421 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5422 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5421);
// compiled call node returning call5422 (depth = 6)
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5423 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5424 == NULL) {
    strlit5424 = alloc_String("an argument list must have an expression after a ','.");
    gc_root(strlit5424);
  }
// compiled string node returning strlit5424 (depth = 7)
  gc_frame_newslot(strlit5424);
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe5425 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call5426 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5425);
// compiled member node returning call5426 (depth = 7)
  gc_frame_newslot(call5426);
// starting to compile member node (depth = 7)
  int callframe5427 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call5428 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5427);
// compiled member node returning call5428 (depth = 7)
  gc_frame_newslot(call5428);
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit5424;
  params[1] = call5426;
  params[2] = call5428;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5429 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5423);
// compiled call node returning call5429 (depth = 6)
    gc_frame_newslot(call5429);
    if5377 = call5429;
  } else {
  }
// compiled if node returning if5377 (depth = 5)
  gc_frame_end(frame);
  return if5377;
}
Object meth_parser_5349_parenthesizedArgs_40_1_41_startingWith_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parenthesizedArgs(1)startingWith(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parenthesizedArgs(_)startingWith(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parenthesizedArgs(_)startingWith(_)");
  Object params[3];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for parenthesizedArgs(_)startingWith(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parenthesizedArgs(_)");
  Object *var_tok = &(stackframe->slots[1]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_rng = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "rng");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5350 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5351 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5350);
// compiled member node returning call5351 (depth = 2)
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5353 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5354 = alloc_Block(NULL, NULL, "parser", 1847);
  gc_frame_newslot(block5354);
// method "_apply"
  block_savedest(block5354);
  Object closure5355 = createclosure(2, "_apply");
  setclosureframe(closure5355, stackframe);
  addtoclosure(closure5355, var_blocksOK);
  addtoclosure(closure5355, selfslot);
  struct UserObject *uo5355 = (struct UserObject*)block5354;
  uo5355->data[0] = (Object)closure5355;
  Method *meth_meth_parser_5355__apply = addmethod2pos(block5354, "_apply", &meth_parser_5355__apply, 0);
  int argcv_meth_parser_5355__apply[] = {0};
  meth_meth_parser_5355__apply->type = alloc_MethodType(1, argcv_meth_parser_5355__apply);
  meth_meth_parser_5355__apply->definitionModule = modulename;
  meth_meth_parser_5355__apply->definitionLine = 183;
// compiled block node returning block5354 (depth = 4)
  gc_frame_newslot(block5354);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = block5354;
  partcv[0] = 1;
  Object call5359 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5353);
// compiled call node returning call5359 (depth = 3)
  Object if5352 = done;
  if (istrue(call5359)) {
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5360 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5361 = alloc_Block(NULL, NULL, "parser", 1848);
  gc_frame_newslot(block5361);
// method "_apply"
  block_savedest(block5361);
  Object closure5362 = createclosure(1, "_apply");
  setclosureframe(closure5362, stackframe);
  addtoclosure(closure5362, selfslot);
  struct UserObject *uo5362 = (struct UserObject*)block5361;
  uo5362->data[0] = (Object)closure5362;
  Method *meth_meth_parser_5362__apply = addmethod2pos(block5361, "_apply", &meth_parser_5362__apply, 0);
  int argcv_meth_parser_5362__apply[] = {0};
  meth_meth_parser_5362__apply->type = alloc_MethodType(1, argcv_meth_parser_5362__apply);
  meth_meth_parser_5362__apply->definitionModule = modulename;
  meth_meth_parser_5362__apply->definitionLine = 183;
// compiled block node returning block5361 (depth = 4)
  gc_frame_newslot(block5361);
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5367 = alloc_Block(NULL, NULL, "parser", 1848);
  gc_frame_newslot(block5367);
// method "_apply"
  block_savedest(block5367);
  Object closure5368 = createclosure(7, "_apply");
  setclosureframe(closure5368, stackframe);
  addtoclosure(closure5368, var_values);
  addtoclosure(closure5368, var_part);
  addtoclosure(closure5368, var_blocksOK);
  addtoclosure(closure5368, var_errormessages);
  addtoclosure(closure5368, var_sym);
  addtoclosure(closure5368, var_lastToken);
  addtoclosure(closure5368, selfslot);
  struct UserObject *uo5368 = (struct UserObject*)block5367;
  uo5368->data[0] = (Object)closure5368;
  Method *meth_meth_parser_5368__apply = addmethod2pos(block5367, "_apply", &meth_parser_5368__apply, 0);
  int argcv_meth_parser_5368__apply[] = {0};
  meth_meth_parser_5368__apply->type = alloc_MethodType(1, argcv_meth_parser_5368__apply);
  meth_meth_parser_5368__apply->definitionModule = modulename;
  meth_meth_parser_5368__apply->definitionLine = 183;
// compiled block node returning block5367 (depth = 4)
  gc_frame_newslot(block5367);
// call case 5: prelude request
  params[0] = block5361;
  params[1] = block5367;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5431 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5360);
// compiled call node returning call5431 (depth = 3)
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5432 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5433 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5434 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5433);
// compiled member node returning call5434 (depth = 4)
  gc_frame_newslot(call5434);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5435 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  partcv[0] = 0;
  Object call5436 = callmethodflags(*var_part, "args", 1, partcv, params, 0);
  gc_frame_end(callframe5435);
// compiled member node returning call5436 (depth = 4)
  params[0] = call5434;
  partcv[0] = 1;
  Object call5437 = callmethodflags(call5436, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5432);
// compiled call node returning call5437 (depth = 3)
    gc_frame_newslot(call5437);
    if5352 = call5437;
  } else {
  }
// compiled if node returning if5352 (depth = 2)
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5440 == NULL) {
    strlit5440 = alloc_String("rparen");
    gc_root(strlit5440);
  }
// compiled string node returning strlit5440 (depth = 4)
  int op_slot_right_5439 = gc_frame_newslot(strlit5440);
// starting to compile member node (depth = 4)
  int callframe5442 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5443 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5442);
// compiled member node returning call5443 (depth = 4)
  int op_slot_left_5439 = gc_frame_newslot(call5443);
  params[0] = strlit5440;
  partcv[0] = 1;
  Object opresult5444 = callmethod(call5443, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5444 (depth = 3)
  Object if5438 = done;
  if (istrue(opresult5444)) {
// Begin line 1873
  setline(1873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5445 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5446 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5445);
// compiled member node returning call5446 (depth = 3)
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5447 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5448 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call5449 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5448);
// compiled member node returning call5449 (depth = 5)
  partcv[0] = 0;
  Object call5450 = callmethodflags(call5449, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5447);
// compiled member node returning call5450 (depth = 4)
  *var_suggestion = call5450;
  if (call5450 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5451 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5452 == NULL) {
    strlit5452 = alloc_String(")");
    gc_root(strlit5452);
  }
// compiled string node returning strlit5452 (depth = 4)
  gc_frame_newslot(strlit5452);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit5452;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5453 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5451);
// compiled call node returning call5453 (depth = 3)
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5454 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5455 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5456 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  partcv[0] = 0;
  Object call5457 = callmethodflags(*var_tok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5456);
// compiled member node returning call5457 (depth = 6)
  gc_frame_newslot(call5457);
// starting to compile member node (depth = 6)
  int callframe5458 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  partcv[0] = 0;
  Object call5459 = callmethodflags(*var_tok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5458);
// compiled member node returning call5459 (depth = 6)
  gc_frame_newslot(call5459);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  params[0] = call5457;
  params[1] = call5459;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5460 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5455);
// compiled call node returning call5460 (depth = 5)
  gc_frame_newslot(call5460);
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5461 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5462 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call5463 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5462);
// compiled member node returning call5463 (depth = 6)
  gc_frame_newslot(call5463);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5465 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5466 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe5465);
// compiled member node returning call5466 (depth = 7)
  int op_slot_right_5464 = gc_frame_newslot(call5466);
// starting to compile member node (depth = 7)
  int callframe5468 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5469 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5468);
// compiled member node returning call5469 (depth = 7)
  int op_slot_left_5464 = gc_frame_newslot(call5469);
  params[0] = call5466;
  partcv[0] = 1;
  Object sum5470 = callmethod(call5469, "+(1)", 1, partcv, params);
// compiled op node returning sum5470 (depth = 6)
  gc_frame_newslot(sum5470);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  params[0] = call5463;
  params[1] = sum5470;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5471 = callmethodflags(*var_ast, "line(1)column(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5461);
// compiled call node returning call5471 (depth = 5)
  gc_frame_newslot(call5471);
// call case 6: other requests
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  params[0] = call5460;
  params[1] = call5471;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5472 = callmethodflags(*var_ast, "start(1)end(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5454);
// compiled call node returning call5472 (depth = 4)
  *var_rng = call5472;
  if (call5472 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1878
  setline(1878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5473 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5474 == NULL) {
    strlit5474 = alloc_String("an argument list beginning with a '(' must end with a ')'.");
    gc_root(strlit5474);
  }
// compiled string node returning strlit5474 (depth = 4)
  gc_frame_newslot(strlit5474);
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_rng (depth = 4)
  gc_frame_newslot(*var_rng);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1878
  setline(1878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit5474;
  params[1] = *var_rng;
  params[2] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5475 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(1)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5473);
// compiled call node returning call5475 (depth = 3)
    gc_frame_newslot(call5475);
    if5438 = call5475;
  } else {
  }
// compiled if node returning if5438 (depth = 2)
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5478 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  partcv[0] = 0;
  Object call5479 = callmethodflags(*var_part, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5478);
// compiled member node returning call5479 (depth = 4)
  int op_slot_right_5477 = gc_frame_newslot(call5479);
// starting to compile member node (depth = 4)
  int callframe5481 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5482 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5481);
// compiled member node returning call5482 (depth = 4)
  int op_slot_left_5477 = gc_frame_newslot(call5482);
  params[0] = call5479;
  partcv[0] = 1;
  Object opresult5483 = callmethod(call5482, "==(1)", 1, partcv, params);
// compiled op node returning opresult5483 (depth = 3)
  Object if5476 = done;
  if (istrue(opresult5483)) {
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5484 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5486 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  partcv[0] = 0;
  Object call5487 = callmethodflags(*var_part, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5486);
// compiled member node returning call5487 (depth = 5)
  int op_slot_right_5485 = gc_frame_newslot(call5487);
// starting to compile member node (depth = 5)
  int callframe5489 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5490 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5489);
// compiled member node returning call5490 (depth = 5)
  int op_slot_left_5485 = gc_frame_newslot(call5490);
  params[0] = call5487;
  partcv[0] = 1;
  Object diff5491 = callmethod(call5490, "-(1)", 1, partcv, params);
// compiled op node returning diff5491 (depth = 4)
  gc_frame_newslot(diff5491);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = diff5491;
  partcv[0] = 1;
  Object call5492 = callmethodflags(*var_part, "lineLength:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5484);
// compiled call node returning call5492 (depth = 3)
    gc_frame_newslot(call5492);
    if5476 = call5492;
  } else {
  }
// compiled if node returning if5476 (depth = 2)
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5493 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5494 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5493);
// compiled member node returning call5494 (depth = 2)
  gc_frame_end(frame);
  return call5494;
}
Object meth_parser_5511__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe5512 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5513 = callmethodflags(self, "typeArg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5512);
// compiled member node returning call5513 (depth = 6)
  gc_frame_end(frame);
  return call5513;
}
Object meth_parser_5508__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe5509 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5510 = alloc_Block(NULL, NULL, "parser", 1894);
  gc_frame_newslot(block5510);
// method "_apply"
  block_savedest(block5510);
  Object closure5511 = createclosure(1, "_apply");
  setclosureframe(closure5511, stackframe);
  addtoclosure(closure5511, selfslot);
  struct UserObject *uo5511 = (struct UserObject*)block5510;
  uo5511->data[0] = (Object)closure5511;
  Method *meth_meth_parser_5511__apply = addmethod2pos(block5510, "_apply", &meth_parser_5511__apply, 0);
  int argcv_meth_parser_5511__apply[] = {0};
  meth_meth_parser_5511__apply->type = alloc_MethodType(1, argcv_meth_parser_5511__apply);
  meth_meth_parser_5511__apply->definitionModule = modulename;
  meth_meth_parser_5511__apply->definitionLine = 183;
// compiled block node returning block5510 (depth = 5)
  gc_frame_newslot(block5510);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block5510;
  partcv[0] = 1;
  Object call5515 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5509);
// compiled call node returning call5515 (depth = 4)
  gc_frame_end(frame);
  return call5515;
}
Object meth_parser_5518__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_args = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5519 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5520 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5521 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5520);
// compiled member node returning call5521 (depth = 5)
  gc_frame_newslot(call5521);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_args (depth = 5)
  params[0] = call5521;
  partcv[0] = 1;
  Object call5522 = callmethodflags(*var_args, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5519);
// compiled call node returning call5522 (depth = 4)
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5525 == NULL) {
    strlit5525 = alloc_String("comma");
    gc_root(strlit5525);
  }
// compiled string node returning strlit5525 (depth = 6)
  int op_slot_right_5524 = gc_frame_newslot(strlit5525);
// starting to compile member node (depth = 6)
  int callframe5527 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5528 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5527);
// compiled member node returning call5528 (depth = 6)
  int op_slot_left_5524 = gc_frame_newslot(call5528);
  params[0] = strlit5525;
  partcv[0] = 1;
  Object opresult5529 = callmethod(call5528, "==(1)", 1, partcv, params);
// compiled op node returning opresult5529 (depth = 5)
  Object if5523 = done;
  if (istrue(opresult5529)) {
// starting to compile member node (depth = 5)
  int callframe5530 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5531 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5530);
// compiled member node returning call5531 (depth = 5)
    gc_frame_newslot(call5531);
    if5523 = call5531;
  } else {
  }
// compiled if node returning if5523 (depth = 4)
  gc_frame_end(frame);
  return if5523;
}
Object meth_parser_5495_typeArgs(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 54, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_args = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "args");
// definebindings:
// definebindings:
  Object *var_startToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "startToken");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
// definebindings:
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5496 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5496 (depth = 3)
  *var_args = array5496;
  if (array5496 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5499 == NULL) {
    strlit5499 = alloc_String("lgeneric");
    gc_root(strlit5499);
  }
// compiled string node returning strlit5499 (depth = 4)
  int op_slot_right_5498 = gc_frame_newslot(strlit5499);
// starting to compile member node (depth = 4)
  int callframe5501 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5502 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5501);
// compiled member node returning call5502 (depth = 4)
  int op_slot_left_5498 = gc_frame_newslot(call5502);
  params[0] = strlit5499;
  partcv[0] = 1;
  Object opresult5503 = callmethod(call5502, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5503 (depth = 3)
  Object if5497 = done;
  if (istrue(opresult5503)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_args (depth = 4)
  return *var_args;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5497 = undefined;
  } else {
  }
// compiled if node returning if5497 (depth = 2)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5504 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5505 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5504);
// compiled member node returning call5505 (depth = 2)
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5506 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5507 = alloc_Block(NULL, NULL, "parser", 1894);
  gc_frame_newslot(block5507);
// method "_apply"
  block_savedest(block5507);
  Object closure5508 = createclosure(1, "_apply");
  setclosureframe(closure5508, stackframe);
  addtoclosure(closure5508, selfslot);
  struct UserObject *uo5508 = (struct UserObject*)block5507;
  uo5508->data[0] = (Object)closure5508;
  Method *meth_meth_parser_5508__apply = addmethod2pos(block5507, "_apply", &meth_parser_5508__apply, 0);
  int argcv_meth_parser_5508__apply[] = {0};
  meth_meth_parser_5508__apply->type = alloc_MethodType(1, argcv_meth_parser_5508__apply);
  meth_meth_parser_5508__apply->definitionModule = modulename;
  meth_meth_parser_5508__apply->definitionLine = 183;
// compiled block node returning block5507 (depth = 3)
  gc_frame_newslot(block5507);
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5517 = alloc_Block(NULL, NULL, "parser", 1894);
  gc_frame_newslot(block5517);
// method "_apply"
  block_savedest(block5517);
  Object closure5518 = createclosure(4, "_apply");
  setclosureframe(closure5518, stackframe);
  addtoclosure(closure5518, var_values);
  addtoclosure(closure5518, var_args);
  addtoclosure(closure5518, var_sym);
  addtoclosure(closure5518, selfslot);
  struct UserObject *uo5518 = (struct UserObject*)block5517;
  uo5518->data[0] = (Object)closure5518;
  Method *meth_meth_parser_5518__apply = addmethod2pos(block5517, "_apply", &meth_parser_5518__apply, 0);
  int argcv_meth_parser_5518__apply[] = {0};
  meth_meth_parser_5518__apply->type = alloc_MethodType(1, argcv_meth_parser_5518__apply);
  meth_meth_parser_5518__apply->definitionModule = modulename;
  meth_meth_parser_5518__apply->definitionLine = 183;
// compiled block node returning block5517 (depth = 3)
  gc_frame_newslot(block5517);
// call case 5: prelude request
  params[0] = block5507;
  params[1] = block5517;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5533 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5506);
// compiled call node returning call5533 (depth = 2)
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5536 == NULL) {
    strlit5536 = alloc_String("rgeneric");
    gc_root(strlit5536);
  }
// compiled string node returning strlit5536 (depth = 4)
  int op_slot_right_5535 = gc_frame_newslot(strlit5536);
// starting to compile member node (depth = 4)
  int callframe5538 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5539 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5538);
// compiled member node returning call5539 (depth = 4)
  int op_slot_left_5535 = gc_frame_newslot(call5539);
  params[0] = strlit5536;
  partcv[0] = 1;
  Object opresult5540 = callmethod(call5539, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5540 (depth = 3)
  Object if5534 = done;
  if (istrue(opresult5540)) {
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5541 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5542 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call5543 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5542);
// compiled member node returning call5543 (depth = 5)
  partcv[0] = 0;
  Object call5544 = callmethodflags(call5543, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5541);
// compiled member node returning call5544 (depth = 4)
  *var_suggestion = call5544;
  if (call5544 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5545 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5546 == NULL) {
    strlit5546 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit5546);
  }
// compiled string node returning strlit5546 (depth = 4)
  gc_frame_newslot(strlit5546);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit5546;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5547 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5545);
// compiled call node returning call5547 (depth = 3)
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5548 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5549 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call5550 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5549);
// compiled member node returning call5550 (depth = 5)
  partcv[0] = 0;
  Object call5551 = callmethodflags(call5550, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5548);
// compiled member node returning call5551 (depth = 4)
  *var_suggestion2 = call5551;
  if (call5551 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5552 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5553 == NULL) {
    strlit5553 = alloc_String(" ");
    gc_root(strlit5553);
  }
// compiled string node returning strlit5553 (depth = 4)
  gc_frame_newslot(strlit5553);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startToken (depth = 4)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion2 (depth = 4)
  params[0] = strlit5553;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5554 = callmethodflags(*var_suggestion2, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5552);
// compiled call node returning call5554 (depth = 3)
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array5555 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array5555, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array5555, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5555 (depth = 4)
  *var_suggestions = array5555;
  if (array5555 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5556 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5557 == NULL) {
    strlit5557 = alloc_String("a method request containing a '""\xe2""""\x9f""""\xa6""' must have a matching '""\xe2""""\x9f""""\xa7""'. ");
    gc_root(strlit5557);
  }
// compiled string node returning strlit5557 (depth = 4)
  gc_frame_newslot(strlit5557);
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5558 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call5559 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5558);
// compiled member node returning call5559 (depth = 4)
  gc_frame_newslot(call5559);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5561 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call5562 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe5561);
// compiled member node returning call5562 (depth = 5)
  int op_slot_right_5560 = gc_frame_newslot(call5562);
// starting to compile member node (depth = 5)
  int callframe5564 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call5565 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5564);
// compiled member node returning call5565 (depth = 5)
  int op_slot_left_5560 = gc_frame_newslot(call5565);
  params[0] = call5562;
  partcv[0] = 1;
  Object sum5566 = callmethod(call5565, "+(1)", 1, partcv, params);
// compiled op node returning sum5566 (depth = 4)
  gc_frame_newslot(sum5566);
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit5557;
  params[1] = call5559;
  params[2] = sum5566;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5567 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5556);
// compiled call node returning call5567 (depth = 3)
    gc_frame_newslot(call5567);
    if5534 = call5567;
  } else {
  }
// compiled if node returning if5534 (depth = 2)
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5568 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5569 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5568);
// compiled member node returning call5569 (depth = 2)
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_args (depth = 3)
  return *var_args;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_5570_typeArg(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 55, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5572 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5573 == NULL) {
    strlit5573 = alloc_String("identifier");
    gc_root(strlit5573);
  }
// compiled string node returning strlit5573 (depth = 4)
  gc_frame_newslot(strlit5573);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit5573;
  partcv[0] = 1;
  Object call5574 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5572);
// compiled call node returning call5574 (depth = 3)
  Object if5571 = done;
  if (istrue(call5574)) {
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5575 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5576 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5575);
// compiled member node returning call5576 (depth = 3)
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5579 == NULL) {
    strlit5579 = alloc_String("lgeneric");
    gc_root(strlit5579);
  }
// compiled string node returning strlit5579 (depth = 5)
  int op_slot_right_5578 = gc_frame_newslot(strlit5579);
// starting to compile member node (depth = 5)
  int callframe5581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5582 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5581);
// compiled member node returning call5582 (depth = 5)
  int op_slot_left_5578 = gc_frame_newslot(call5582);
  params[0] = strlit5579;
  partcv[0] = 1;
  Object opresult5583 = callmethod(call5582, "==(1)", 1, partcv, params);
// compiled op node returning opresult5583 (depth = 4)
  Object if5577 = done;
  if (istrue(opresult5583)) {
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5584 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5585 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5586 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call5587 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5586);
// compiled member node returning call5587 (depth = 6)
  gc_frame_newslot(call5587);
// starting to compile member node (depth = 6)
  int callframe5588 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5589 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5588);
// compiled member node returning call5589 (depth = 6)
  gc_frame_newslot(call5589);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5590 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5591 = callmethodflags(*var_ast, "genericNode", 1, partcv, params, 0);
  gc_frame_end(callframe5590);
// compiled member node returning call5591 (depth = 6)
  params[0] = call5587;
  params[1] = call5589;
  partcv[0] = 2;
  Object call5592 = callmethodflags(call5591, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5585);
// compiled call node returning call5592 (depth = 5)
  gc_frame_newslot(call5592);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = call5592;
  partcv[0] = 1;
  Object call5593 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5584);
// compiled call node returning call5593 (depth = 4)
    gc_frame_newslot(call5593);
    if5577 = call5593;
  } else {
  }
// compiled if node returning if5577 (depth = 3)
    gc_frame_newslot(if5577);
    if5571 = if5577;
  } else {
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5594 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5595 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5594);
// compiled member node returning call5595 (depth = 3)
    gc_frame_newslot(call5595);
    if5571 = call5595;
  }
// compiled if node returning if5571 (depth = 2)
  gc_frame_end(frame);
  return if5571;
}
Object meth_parser_5603__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5606 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call5607 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5606);
// compiled member node returning call5607 (depth = 7)
  int op_slot_right_5605 = gc_frame_newslot(call5607);
// starting to compile member node (depth = 7)
  int callframe5609 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  partcv[0] = 0;
  Object call5610 = callmethodflags(*var_t, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5609);
// compiled member node returning call5610 (depth = 7)
  int op_slot_left_5605 = gc_frame_newslot(call5610);
  params[0] = call5607;
  partcv[0] = 1;
  Object opresult5611 = callmethod(call5610, "==(1)", 1, partcv, params);
// compiled op node returning opresult5611 (depth = 6)
  int op_slot_right_5604 = gc_frame_newslot(opresult5611);
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5615 == NULL) {
    strlit5615 = alloc_String("=");
    gc_root(strlit5615);
  }
// compiled string node returning strlit5615 (depth = 8)
  int op_slot_right_5614 = gc_frame_newslot(strlit5615);
// starting to compile member node (depth = 8)
  int callframe5617 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  partcv[0] = 0;
  Object call5618 = callmethodflags(*var_t, "value", 1, partcv, params, 0);
  gc_frame_end(callframe5617);
// compiled member node returning call5618 (depth = 8)
  int op_slot_left_5614 = gc_frame_newslot(call5618);
  params[0] = strlit5615;
  partcv[0] = 1;
  Object opresult5619 = callmethod(call5618, "==(1)", 1, partcv, params);
// compiled op node returning opresult5619 (depth = 7)
  int op_slot_right_5613 = gc_frame_newslot(opresult5619);
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5622 == NULL) {
    strlit5622 = alloc_String("op");
    gc_root(strlit5622);
  }
// compiled string node returning strlit5622 (depth = 8)
  int op_slot_right_5621 = gc_frame_newslot(strlit5622);
// starting to compile member node (depth = 8)
  int callframe5624 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  partcv[0] = 0;
  Object call5625 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5624);
// compiled member node returning call5625 (depth = 8)
  int op_slot_left_5621 = gc_frame_newslot(call5625);
  params[0] = strlit5622;
  partcv[0] = 1;
  Object opresult5626 = callmethod(call5625, "==(1)", 1, partcv, params);
// compiled op node returning opresult5626 (depth = 7)
  int op_slot_left_5613 = gc_frame_newslot(opresult5626);
  params[0] = opresult5619;
  partcv[0] = 1;
  Object opresult5627 = callmethod(opresult5626, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5627 (depth = 6)
  int op_slot_left_5604 = gc_frame_newslot(opresult5627);
  params[0] = opresult5611;
  partcv[0] = 1;
  Object opresult5628 = callmethod(opresult5627, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5628 (depth = 5)
  gc_frame_end(frame);
  return opresult5628;
}
Object meth_parser_5596_errorDefNoName(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 56, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "errorDefNoName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextToken");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5597 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5598 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call5599 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5598);
// compiled member node returning call5599 (depth = 4)
  partcv[0] = 0;
  Object call5600 = callmethodflags(call5599, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5597);
// compiled member node returning call5600 (depth = 3)
  *var_suggestion = call5600;
  if (call5600 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5601 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5602 = alloc_Block(NULL, NULL, "parser", 1929);
  gc_frame_newslot(block5602);
// method "_apply(_)"
  block_savedest(block5602);
  Object closure5603 = createclosure(2, "_apply(1)");
  setclosureframe(closure5603, stackframe);
  addtoclosure(closure5603, var_sym);
  addtoclosure(closure5603, selfslot);
  struct UserObject *uo5603 = (struct UserObject*)block5602;
  uo5603->data[0] = (Object)closure5603;
  Method *meth_meth_parser_5603__apply_40_1_41_ = addmethod2pos(block5602, "_apply(1)", &meth_parser_5603__apply_40_1_41_, 0);
  int argcv_meth_parser_5603__apply_40_1_41_[] = {1};
  meth_meth_parser_5603__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5603__apply_40_1_41_);
  meth_meth_parser_5603__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5603__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block5602 (depth = 4)
  gc_frame_newslot(block5602);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = block5602;
  partcv[0] = 1;
  Object call5630 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5601);
// compiled call node returning call5630 (depth = 3)
  *var_nextToken = call5630;
  if (call5630 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextToken (depth = 4)
  int op_slot_right_5632 = gc_frame_newslot(*var_nextToken);
// starting to compile identifier node (depth = 4)
  Object bool5634 = alloc_Boolean(0);
// compiled identifier node returning bool5634 (depth = 4)
  int op_slot_left_5632 = gc_frame_newslot(bool5634);
  params[0] = *var_nextToken;
  partcv[0] = 1;
  Object opresult5635 = callmethod(bool5634, "==(1)", 1, partcv, params);
// compiled op node returning opresult5635 (depth = 3)
  Object if5631 = done;
  if (istrue(opresult5635)) {
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5636 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5637 == NULL) {
    strlit5637 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb"" =");
    gc_root(strlit5637);
  }
// compiled string node returning strlit5637 (depth = 4)
  gc_frame_newslot(strlit5637);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit5637;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5638 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5636);
// compiled call node returning call5638 (depth = 3)
    gc_frame_newslot(call5638);
    if5631 = call5638;
  } else {
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_5640 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextToken (depth = 5)
  int op_slot_left_5640 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5642 = callmethod(*var_nextToken, "==(1)", 1, partcv, params);
// compiled op node returning opresult5642 (depth = 4)
  Object if5639 = done;
  if (istrue(opresult5642)) {
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5643 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5644 == NULL) {
    strlit5644 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit5644);
  }
// compiled string node returning strlit5644 (depth = 5)
  gc_frame_newslot(strlit5644);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5644;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5645 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5643);
// compiled call node returning call5645 (depth = 4)
    gc_frame_newslot(call5645);
    if5639 = call5645;
  } else {
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5646 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
  int callframe5647 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextToken (depth = 6)
  partcv[0] = 0;
  Object call5648 = callmethodflags(*var_nextToken, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe5647);
// compiled member node returning call5648 (depth = 5)
  gc_frame_newslot(call5648);
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool5649 = alloc_Boolean(0);
// compiled identifier node returning bool5649 (depth = 5)
  gc_frame_newslot(bool5649);
// starting to compile identifier node (depth = 5)
  Object bool5650 = alloc_Boolean(1);
// compiled identifier node returning bool5650 (depth = 5)
  gc_frame_newslot(bool5650);
// starting to compile string node (depth = 5)
  if (strlit5651 == NULL) {
    strlit5651 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit5651);
  }
// compiled string node returning strlit5651 (depth = 5)
  gc_frame_newslot(strlit5651);
// call case 6: other requests
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call5648;
  params[2] = bool5649;
  params[3] = bool5650;
  params[4] = strlit5651;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5652 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5646);
// compiled call node returning call5652 (depth = 4)
    gc_frame_newslot(call5652);
    if5639 = call5652;
  }
// compiled if node returning if5639 (depth = 3)
    gc_frame_newslot(if5639);
    if5631 = if5639;
  }
// compiled if node returning if5631 (depth = 2)
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5653 = gc_frame_new();
// starting to compile op node (depth = 3)
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5655 == NULL) {
    strlit5655 = alloc_String("and a value after the 'def'.");
    gc_root(strlit5655);
  }
// compiled string node returning strlit5655 (depth = 4)
  int op_slot_right_5654 = gc_frame_newslot(strlit5655);
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5657 == NULL) {
    strlit5657 = alloc_String("a definition must have a name, '=', ");
    gc_root(strlit5657);
  }
// compiled string node returning strlit5657 (depth = 4)
  int op_slot_left_5654 = gc_frame_newslot(strlit5657);
  params[0] = strlit5655;
  partcv[0] = 1;
  Object opresult5658 = callmethod(strlit5657, "++(1)", 1, partcv, params);
// compiled op node returning opresult5658 (depth = 3)
  gc_frame_newslot(opresult5658);
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5659 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call5660 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5659);
// compiled member node returning call5660 (depth = 3)
  gc_frame_newslot(call5660);
// starting to compile member node (depth = 3)
  int callframe5661 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call5662 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5661);
// compiled member node returning call5662 (depth = 3)
  gc_frame_newslot(call5662);
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = opresult5658;
  params[1] = call5660;
  params[2] = call5662;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5663 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5653);
// compiled call node returning call5663 (depth = 2)
  gc_frame_end(frame);
  return call5663;
}
Object meth_parser_5664_errorDefNoExpression(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 57, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "errorDefNoExpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
// definebindings:
// definebindings:
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5665 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5666 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call5667 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5666);
// compiled member node returning call5667 (depth = 4)
  partcv[0] = 0;
  Object call5668 = callmethodflags(call5667, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5665);
// compiled member node returning call5668 (depth = 3)
  *var_suggestion = call5668;
  if (call5668 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5669 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array5670 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5670 (depth = 4)
  gc_frame_newslot(array5670);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = array5670;
  partcv[0] = 1;
  Object call5671 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5669);
// compiled call node returning call5671 (depth = 3)
  *var_nextTok = call5671;
  if (call5671 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  int op_slot_right_5673 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nextTok (depth = 4)
  int op_slot_left_5673 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5675 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5675 (depth = 3)
  Object if5672 = done;
  if (istrue(opresult5675)) {
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5676 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5677 == NULL) {
    strlit5677 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5677);
  }
// compiled string node returning strlit5677 (depth = 4)
  gc_frame_newslot(strlit5677);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit5677;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5678 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5676);
// compiled call node returning call5678 (depth = 3)
    gc_frame_newslot(call5678);
    if5672 = call5678;
  } else {
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5679 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 4)
  int callframe5680 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  partcv[0] = 0;
  Object call5681 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe5680);
// compiled member node returning call5681 (depth = 4)
  gc_frame_newslot(call5681);
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5682 = alloc_Boolean(1);
// compiled identifier node returning bool5682 (depth = 4)
  gc_frame_newslot(bool5682);
// starting to compile identifier node (depth = 4)
  Object bool5683 = alloc_Boolean(0);
// compiled identifier node returning bool5683 (depth = 4)
  gc_frame_newslot(bool5683);
// starting to compile string node (depth = 4)
  if (strlit5684 == NULL) {
    strlit5684 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5684);
  }
// compiled string node returning strlit5684 (depth = 4)
  gc_frame_newslot(strlit5684);
// call case 6: other requests
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = call5681;
  params[2] = bool5682;
  params[3] = bool5683;
  params[4] = strlit5684;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5685 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5679);
// compiled call node returning call5685 (depth = 3)
    gc_frame_newslot(call5685);
    if5672 = call5685;
  }
// compiled if node returning if5672 (depth = 2)
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5686 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5687 == NULL) {
    strlit5687 = alloc_String("a definition must have a value after the '='.");
    gc_root(strlit5687);
  }
// compiled string node returning strlit5687 (depth = 3)
  gc_frame_newslot(strlit5687);
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5688 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  partcv[0] = 0;
  Object call5689 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5688);
// compiled member node returning call5689 (depth = 3)
  gc_frame_newslot(call5689);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5691 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call5692 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe5691);
// compiled member node returning call5692 (depth = 4)
  int op_slot_right_5690 = gc_frame_newslot(call5692);
// starting to compile member node (depth = 4)
  int callframe5694 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call5695 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5694);
// compiled member node returning call5695 (depth = 4)
  int op_slot_left_5690 = gc_frame_newslot(call5695);
  params[0] = call5692;
  partcv[0] = 1;
  Object sum5696 = callmethod(call5695, "+(1)", 1, partcv, params);
// compiled op node returning sum5696 (depth = 3)
  gc_frame_newslot(sum5696);
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = strlit5687;
  params[1] = call5689;
  params[2] = sum5696;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5697 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5686);
// compiled call node returning call5697 (depth = 2)
  gc_frame_end(frame);
  return call5697;
}
Object meth_parser_5698_errorDefUsesAssign_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 58, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "errorDefUsesAssign(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method errorDefUsesAssign(_)");
  Object params[5];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for errorDefUsesAssign(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_defTok = &(stackframe->slots[0]);
  *var_defTok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part errorDefUsesAssign(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5699 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5699 (depth = 3)
  *var_suggestions = array5699;
  if (array5699 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5700 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5701 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call5702 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5701);
// compiled member node returning call5702 (depth = 4)
  partcv[0] = 0;
  Object call5703 = callmethodflags(call5702, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5700);
// compiled member node returning call5703 (depth = 3)
  *var_suggestion = call5703;
  if (call5703 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5704 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 3)
  if (strlit5705 == NULL) {
    strlit5705 = alloc_String("=");
    gc_root(strlit5705);
  }
// compiled string node returning strlit5705 (depth = 3)
  gc_frame_newslot(strlit5705);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_sym;
  params[1] = strlit5705;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5706 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5704);
// compiled call node returning call5706 (depth = 2)
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5707 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5708 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5707);
// compiled call node returning call5708 (depth = 2)
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5709 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5710 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call5711 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5710);
// compiled member node returning call5711 (depth = 4)
  partcv[0] = 0;
  Object call5712 = callmethodflags(call5711, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5709);
// compiled member node returning call5712 (depth = 3)
  *var_suggestion = call5712;
  if (call5712 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5714 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defTok (depth = 3)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 3)
  if (strlit5715 == NULL) {
    strlit5715 = alloc_String("var");
    gc_root(strlit5715);
  }
// compiled string node returning strlit5715 (depth = 3)
  gc_frame_newslot(strlit5715);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_defTok;
  params[1] = strlit5715;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5716 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5714);
// compiled call node returning call5716 (depth = 2)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5717 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5718 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5717);
// compiled call node returning call5718 (depth = 2)
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5719 = gc_frame_new();
// starting to compile op node (depth = 3)
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5721 == NULL) {
    strlit5721 = alloc_String("A variable declaration uses 'var' and ':='.");
    gc_root(strlit5721);
  }
// compiled string node returning strlit5721 (depth = 4)
  int op_slot_right_5720 = gc_frame_newslot(strlit5721);
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5723 == NULL) {
    strlit5723 = alloc_String("a definition must use '=' instead of ':='. ");
    gc_root(strlit5723);
  }
// compiled string node returning strlit5723 (depth = 4)
  int op_slot_left_5720 = gc_frame_newslot(strlit5723);
  params[0] = strlit5721;
  partcv[0] = 1;
  Object opresult5724 = callmethod(strlit5723, "++(1)", 1, partcv, params);
// compiled op node returning opresult5724 (depth = 3)
  gc_frame_newslot(opresult5724);
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5725 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call5726 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5725);
// compiled member node returning call5726 (depth = 3)
  gc_frame_newslot(call5726);
// starting to compile member node (depth = 3)
  int callframe5727 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call5728 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5727);
// compiled member node returning call5728 (depth = 3)
  gc_frame_newslot(call5728);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5730 = alloc_Float64(1);
// compiled num node returning num5730 (depth = 4)
  int op_slot_right_5729 = gc_frame_newslot(num5730);
// starting to compile member node (depth = 4)
  int callframe5732 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5733 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5732);
// compiled member node returning call5733 (depth = 4)
  int op_slot_left_5729 = gc_frame_newslot(call5733);
  params[0] = num5730;
  partcv[0] = 1;
  Object sum5734 = callmethod(call5733, "+(1)", 1, partcv, params);
// compiled op node returning sum5734 (depth = 3)
  gc_frame_newslot(sum5734);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = opresult5724;
  params[1] = call5726;
  params[2] = call5728;
  params[3] = sum5734;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5735 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5719);
// compiled call node returning call5735 (depth = 2)
  gc_frame_end(frame);
  return call5735;
}
Object meth_parser_5736_errorDefMissingRhs_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 59, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "errorDefMissingRhs(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method errorDefMissingRhs(_)");
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for errorDefMissingRhs(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_defTok = &(stackframe->slots[0]);
  *var_defTok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part errorDefMissingRhs(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5737 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5737 (depth = 3)
  *var_suggestions = array5737;
  if (array5737 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5738 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5739 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call5740 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5739);
// compiled member node returning call5740 (depth = 4)
  partcv[0] = 0;
  Object call5741 = callmethodflags(call5740, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5738);
// compiled member node returning call5741 (depth = 3)
  *var_suggestion = call5741;
  if (call5741 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5742 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5743 == NULL) {
    strlit5743 = alloc_String(" = ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5743);
  }
// compiled string node returning strlit5743 (depth = 3)
  gc_frame_newslot(strlit5743);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = strlit5743;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5744 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5742);
// compiled call node returning call5744 (depth = 2)
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5745 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5746 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5745);
// compiled call node returning call5746 (depth = 2)
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5747 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5748 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  partcv[0] = 0;
  Object call5749 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5748);
// compiled member node returning call5749 (depth = 4)
  partcv[0] = 0;
  Object call5750 = callmethodflags(call5749, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5747);
// compiled member node returning call5750 (depth = 3)
  *var_suggestion = call5750;
  if (call5750 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5752 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defTok (depth = 3)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 3)
  if (strlit5753 == NULL) {
    strlit5753 = alloc_String("var");
    gc_root(strlit5753);
  }
// compiled string node returning strlit5753 (depth = 3)
  gc_frame_newslot(strlit5753);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  params[0] = *var_defTok;
  params[1] = strlit5753;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5754 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5752);
// compiled call node returning call5754 (depth = 2)
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5755 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5756 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5755);
// compiled call node returning call5756 (depth = 2)
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5757 = gc_frame_new();
// starting to compile op node (depth = 3)
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5759 == NULL) {
    strlit5759 = alloc_String("A variable declaration does not require a value but uses 'var', not 'def'.");
    gc_root(strlit5759);
  }
// compiled string node returning strlit5759 (depth = 4)
  int op_slot_right_5758 = gc_frame_newslot(strlit5759);
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5761 == NULL) {
    strlit5761 = alloc_String("a definition must have '=' and a value after the name. ");
    gc_root(strlit5761);
  }
// compiled string node returning strlit5761 (depth = 4)
  int op_slot_left_5758 = gc_frame_newslot(strlit5761);
  params[0] = strlit5759;
  partcv[0] = 1;
  Object opresult5762 = callmethod(strlit5761, "++(1)", 1, partcv, params);
// compiled op node returning opresult5762 (depth = 3)
  gc_frame_newslot(opresult5762);
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5763 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call5764 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5763);
// compiled member node returning call5764 (depth = 3)
  gc_frame_newslot(call5764);
// starting to compile member node (depth = 3)
  int callframe5765 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call5766 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5765);
// compiled member node returning call5766 (depth = 3)
  gc_frame_newslot(call5766);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errormessages (depth = 3)
  params[0] = opresult5762;
  params[1] = call5764;
  params[2] = call5766;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5767 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5757);
// compiled call node returning call5767 (depth = 2)
  gc_frame_end(frame);
  return call5767;
}
Object meth_parser_5818__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe5819 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5820 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5819);
// compiled call node returning call5820 (depth = 7)
  gc_frame_end(frame);
  return call5820;
}
Object meth_parser_5768_defdec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 60, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_startIndent = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startIndent");
  Object *var_line = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "line");
  Object *var_pos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "pos");
  Object *var_defTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "defTok");
// definebindings:
// definebindings:
  Object *var_val = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "val");
  Object *var_name = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "name");
  Object *var_dtype = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "dtype");
  Object *var_anns = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "anns");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "o");
// definebindings:
// definebindings:
// definebindings:
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5770 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5771 == NULL) {
    strlit5771 = alloc_String("def");
    gc_root(strlit5771);
  }
// compiled string node returning strlit5771 (depth = 4)
  gc_frame_newslot(strlit5771);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit5771;
  partcv[0] = 1;
  Object call5772 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5770);
// compiled call node returning call5772 (depth = 3)
  Object if5769 = done;
  if (istrue(call5772)) {
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_startIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5773 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5774 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5773);
// compiled member node returning call5774 (depth = 4)
  *var_line = call5774;
  if (call5774 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5775 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5776 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5775);
// compiled member node returning call5776 (depth = 4)
  *var_pos = call5776;
  if (call5776 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_defTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5777 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5778 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5777);
// compiled member node returning call5778 (depth = 3)
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5781 == NULL) {
    strlit5781 = alloc_String("identifier");
    gc_root(strlit5781);
  }
// compiled string node returning strlit5781 (depth = 5)
  int op_slot_right_5780 = gc_frame_newslot(strlit5781);
// starting to compile member node (depth = 5)
  int callframe5783 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5784 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5783);
// compiled member node returning call5784 (depth = 5)
  int op_slot_left_5780 = gc_frame_newslot(call5784);
  params[0] = strlit5781;
  partcv[0] = 1;
  Object opresult5785 = callmethod(call5784, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5785 (depth = 4)
  Object if5779 = done;
  if (istrue(opresult5785)) {
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5786 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5787 = callmethodflags(self, "errorDefNoName", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5786);
// compiled member node returning call5787 (depth = 4)
    gc_frame_newslot(call5787);
    if5779 = call5787;
  } else {
  }
// compiled if node returning if5779 (depth = 3)
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5788 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5789 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5788);
// compiled member node returning call5789 (depth = 3)
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5790 = alloc_Boolean(0);
// compiled identifier node returning bool5790 (depth = 4)
  *var_val = bool5790;
  if (bool5790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5791 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5792 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5791);
// compiled member node returning call5792 (depth = 4)
  *var_name = call5792;
  if (call5792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5793 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool5794 = alloc_Boolean(1);
// compiled identifier node returning bool5794 (depth = 4)
  gc_frame_newslot(bool5794);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool5794;
  partcv[0] = 1;
  Object call5795 = callmethodflags(*var_name, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5793);
// compiled call node returning call5795 (depth = 3)
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5796 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5797 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5796);
// compiled member node returning call5797 (depth = 4)
  *var_dtype = call5797;
  if (call5797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5798 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5799 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5798);
// compiled member node returning call5799 (depth = 4)
  *var_anns = call5799;
  if (call5799 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5803 == NULL) {
    strlit5803 = alloc_String("=");
    gc_root(strlit5803);
  }
// compiled string node returning strlit5803 (depth = 6)
  int op_slot_right_5802 = gc_frame_newslot(strlit5803);
// starting to compile member node (depth = 6)
  int callframe5805 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5806 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe5805);
// compiled member node returning call5806 (depth = 6)
  int op_slot_left_5802 = gc_frame_newslot(call5806);
  params[0] = strlit5803;
  partcv[0] = 1;
  Object opresult5807 = callmethod(call5806, "==(1)", 1, partcv, params);
// compiled op node returning opresult5807 (depth = 5)
  int op_slot_right_5801 = gc_frame_newslot(opresult5807);
// starting to compile call node (depth = 5)
  int callframe5809 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5810 == NULL) {
    strlit5810 = alloc_String("op");
    gc_root(strlit5810);
  }
// compiled string node returning strlit5810 (depth = 6)
  gc_frame_newslot(strlit5810);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit5810;
  partcv[0] = 1;
  Object call5811 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5809);
// compiled call node returning call5811 (depth = 5)
  int op_slot_left_5801 = gc_frame_newslot(call5811);
  params[0] = opresult5807;
  partcv[0] = 1;
  Object opresult5812 = callmethod(call5811, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5812 (depth = 4)
  Object if5800 = done;
  if (istrue(opresult5812)) {
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5813 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5814 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5813);
// compiled member node returning call5814 (depth = 4)
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5816 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block5817 = alloc_Block(NULL, NULL, "parser", 2004);
  gc_frame_newslot(block5817);
// method "_apply"
  block_savedest(block5817);
  Object closure5818 = createclosure(2, "_apply");
  setclosureframe(closure5818, stackframe);
  addtoclosure(closure5818, var_blocksOK);
  addtoclosure(closure5818, selfslot);
  struct UserObject *uo5818 = (struct UserObject*)block5817;
  uo5818->data[0] = (Object)closure5818;
  Method *meth_meth_parser_5818__apply = addmethod2pos(block5817, "_apply", &meth_parser_5818__apply, 0);
  int argcv_meth_parser_5818__apply[] = {0};
  meth_meth_parser_5818__apply->type = alloc_MethodType(1, argcv_meth_parser_5818__apply);
  meth_meth_parser_5818__apply->definitionModule = modulename;
  meth_meth_parser_5818__apply->definitionLine = 183;
// compiled block node returning block5817 (depth = 6)
  gc_frame_newslot(block5817);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block5817;
  partcv[0] = 1;
  Object call5822 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5816);
// compiled call node returning call5822 (depth = 5)
  Object if5815 = done;
  if (istrue(call5822)) {
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5823 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5824 = callmethodflags(self, "errorDefNoExpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5823);
// compiled member node returning call5824 (depth = 5)
    gc_frame_newslot(call5824);
    if5815 = call5824;
  } else {
  }
// compiled if node returning if5815 (depth = 4)
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5825 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5826 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5825);
// compiled member node returning call5826 (depth = 5)
  *var_val = call5826;
  if (call5826 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5800 = done;
  } else {
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5829 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5830 == NULL) {
    strlit5830 = alloc_String("bind");
    gc_root(strlit5830);
  }
// compiled string node returning strlit5830 (depth = 6)
  gc_frame_newslot(strlit5830);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit5830;
  partcv[0] = 1;
  Object call5831 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5829);
// compiled call node returning call5831 (depth = 5)
  Object if5828 = done;
  if (istrue(call5831)) {
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5832 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call5833 = callmethodflags(module_parser, "errorDefUsesAssign(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5832);
// compiled call node returning call5833 (depth = 5)
    gc_frame_newslot(call5833);
    if5828 = call5833;
  } else {
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5834 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call5835 = callmethodflags(module_parser, "errorDefMissingRhs(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5834);
// compiled call node returning call5835 (depth = 5)
    gc_frame_newslot(call5835);
    if5828 = call5835;
  }
// compiled if node returning if5828 (depth = 4)
    gc_frame_newslot(if5828);
    if5800 = if5828;
  }
// compiled if node returning if5800 (depth = 3)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5836 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5837 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defTok (depth = 5)
  partcv[0] = 0;
  Object call5838 = callmethodflags(*var_defTok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5837);
// compiled member node returning call5838 (depth = 4)
  gc_frame_newslot(call5838);
// starting to compile member node (depth = 4)
  int callframe5839 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defTok (depth = 5)
  partcv[0] = 0;
  Object call5840 = callmethodflags(*var_defTok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5839);
// compiled member node returning call5840 (depth = 4)
  gc_frame_newslot(call5840);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call5838;
  params[1] = call5840;
  partcv[0] = 2;
  Object call5841 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5836);
// compiled call node returning call5841 (depth = 3)
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5842 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5843 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call5844 = callmethodflags(*var_ast, "defDecNode", 1, partcv, params, 0);
  gc_frame_end(callframe5843);
// compiled member node returning call5844 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call5845 = callmethodflags(call5844, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe5842);
// compiled call node returning call5845 (depth = 4)
  *var_o = call5845;
  if (call5845 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_5847 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool5849 = alloc_Boolean(0);
// compiled identifier node returning bool5849 (depth = 5)
  int op_slot_left_5847 = gc_frame_newslot(bool5849);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult5850 = callmethod(bool5849, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5850 (depth = 4)
  Object if5846 = done;
  if (istrue(opresult5850)) {
// starting to compile call node (depth = 4)
  int callframe5851 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5852 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  partcv[0] = 0;
  Object call5853 = callmethodflags(*var_o, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe5852);
// compiled member node returning call5853 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call5854 = callmethodflags(call5853, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5851);
// compiled call node returning call5854 (depth = 4)
    gc_frame_newslot(call5854);
    if5846 = call5854;
  } else {
  }
// compiled if node returning if5846 (depth = 3)
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5855 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defTok (depth = 4)
  gc_frame_newslot(*var_defTok);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call5856 = callmethodflags(*var_o, "startToken:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5855);
// compiled call node returning call5856 (depth = 3)
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5857 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5858 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5857);
// compiled call node returning call5858 (depth = 3)
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5859 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5860 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5859);
// compiled member node returning call5860 (depth = 3)
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_minIndentLevel = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5769 = done;
  } else {
  }
// compiled if node returning if5769 (depth = 2)
  gc_frame_end(frame);
  return if5769;
}
Object meth_parser_5886__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe5889 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5890 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5889);
// compiled member node returning call5890 (depth = 9)
  int op_slot_right_5888 = gc_frame_newslot(call5890);
// starting to compile member node (depth = 9)
  int callframe5892 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call5893 = callmethodflags(*var_t, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5892);
// compiled member node returning call5893 (depth = 9)
  int op_slot_left_5888 = gc_frame_newslot(call5893);
  params[0] = call5890;
  partcv[0] = 1;
  Object opresult5894 = callmethod(call5893, "==(1)", 1, partcv, params);
// compiled op node returning opresult5894 (depth = 8)
  int op_slot_right_5887 = gc_frame_newslot(opresult5894);
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5897 == NULL) {
    strlit5897 = alloc_String("bind");
    gc_root(strlit5897);
  }
// compiled string node returning strlit5897 (depth = 9)
  int op_slot_right_5896 = gc_frame_newslot(strlit5897);
// starting to compile member node (depth = 9)
  int callframe5899 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call5900 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5899);
// compiled member node returning call5900 (depth = 9)
  int op_slot_left_5896 = gc_frame_newslot(call5900);
  params[0] = strlit5897;
  partcv[0] = 1;
  Object opresult5901 = callmethod(call5900, "==(1)", 1, partcv, params);
// compiled op node returning opresult5901 (depth = 8)
  int op_slot_left_5887 = gc_frame_newslot(opresult5901);
  params[0] = opresult5894;
  partcv[0] = 1;
  Object opresult5902 = callmethod(opresult5901, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5902 (depth = 7)
  gc_frame_end(frame);
  return opresult5902;
}
Object meth_parser_5908__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5909 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  int op_slot_left_5909 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5911 = callmethod(*var_nextToken, "==(1)", 1, partcv, params);
// compiled op node returning opresult5911 (depth = 7)
  gc_frame_end(frame);
  return opresult5911;
}
Object meth_parser_5957__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe5958 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5959 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5958);
// compiled call node returning call5959 (depth = 7)
  gc_frame_end(frame);
  return call5959;
}
Object meth_parser_5862_vardec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 61, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "vardec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_startIndent = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startIndent");
  Object *var_line = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "line");
  Object *var_pos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "pos");
  Object *var_varTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "varTok");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
  Object *var_nextToken = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextToken");
// definebindings:
// definebindings:
// definebindings:
  Object *var_val = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "val");
  Object *var_name = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "name");
  Object *var_dtype = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "dtype");
  Object *var_anns = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "anns");
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "suggestions");
  Object *var_nextTok = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "o");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5864 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5865 == NULL) {
    strlit5865 = alloc_String("var");
    gc_root(strlit5865);
  }
// compiled string node returning strlit5865 (depth = 4)
  gc_frame_newslot(strlit5865);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit5865;
  partcv[0] = 1;
  Object call5866 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5864);
// compiled call node returning call5866 (depth = 3)
  Object if5863 = done;
  if (istrue(call5866)) {
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_startIndent = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5867 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5868 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5867);
// compiled member node returning call5868 (depth = 4)
  *var_line = call5868;
  if (call5868 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5869 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5870 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5869);
// compiled member node returning call5870 (depth = 4)
  *var_pos = call5870;
  if (call5870 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_varTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5871 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5872 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5871);
// compiled member node returning call5872 (depth = 3)
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5875 == NULL) {
    strlit5875 = alloc_String("identifier");
    gc_root(strlit5875);
  }
// compiled string node returning strlit5875 (depth = 5)
  int op_slot_right_5874 = gc_frame_newslot(strlit5875);
// starting to compile member node (depth = 5)
  int callframe5877 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5878 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe5877);
// compiled member node returning call5878 (depth = 5)
  int op_slot_left_5874 = gc_frame_newslot(call5878);
  params[0] = strlit5875;
  partcv[0] = 1;
  Object opresult5879 = callmethod(call5878, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5879 (depth = 4)
  Object if5873 = done;
  if (istrue(opresult5879)) {
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5880 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5881 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call5882 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5881);
// compiled member node returning call5882 (depth = 6)
  partcv[0] = 0;
  Object call5883 = callmethodflags(call5882, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5880);
// compiled member node returning call5883 (depth = 5)
  *var_suggestion = call5883;
  if (call5883 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5884 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block5885 = alloc_Block(NULL, NULL, "parser", 2034);
  gc_frame_newslot(block5885);
// method "_apply(_)"
  block_savedest(block5885);
  Object closure5886 = createclosure(2, "_apply(1)");
  setclosureframe(closure5886, stackframe);
  addtoclosure(closure5886, var_sym);
  addtoclosure(closure5886, selfslot);
  struct UserObject *uo5886 = (struct UserObject*)block5885;
  uo5886->data[0] = (Object)closure5886;
  Method *meth_meth_parser_5886__apply_40_1_41_ = addmethod2pos(block5885, "_apply(1)", &meth_parser_5886__apply_40_1_41_, 0);
  int argcv_meth_parser_5886__apply_40_1_41_[] = {1};
  meth_meth_parser_5886__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5886__apply_40_1_41_);
  meth_meth_parser_5886__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5886__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block5885 (depth = 6)
  gc_frame_newslot(block5885);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block5885;
  partcv[0] = 1;
  Object call5904 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5884);
// compiled call node returning call5904 (depth = 5)
  *var_nextToken = call5904;
  if (call5904 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block5907 = alloc_Block(NULL, NULL, "parser", 2036);
  gc_frame_newslot(block5907);
// method "_apply"
  block_savedest(block5907);
  Object closure5908 = createclosure(3, "_apply");
  setclosureframe(closure5908, stackframe);
  addtoclosure(closure5908, var_sym);
  addtoclosure(closure5908, var_nextToken);
  addtoclosure(closure5908, selfslot);
  struct UserObject *uo5908 = (struct UserObject*)block5907;
  uo5908->data[0] = (Object)closure5908;
  Method *meth_meth_parser_5908__apply = addmethod2pos(block5907, "_apply", &meth_parser_5908__apply, 0);
  int argcv_meth_parser_5908__apply[] = {0};
  meth_meth_parser_5908__apply->type = alloc_MethodType(1, argcv_meth_parser_5908__apply);
  meth_meth_parser_5908__apply->definitionModule = modulename;
  meth_meth_parser_5908__apply->definitionLine = 183;
// compiled block node returning block5907 (depth = 6)
  int op_slot_right_5906 = gc_frame_newslot(block5907);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_right_5914 = gc_frame_newslot(*var_nextToken);
// starting to compile identifier node (depth = 7)
  Object bool5916 = alloc_Boolean(0);
// compiled identifier node returning bool5916 (depth = 7)
  int op_slot_left_5914 = gc_frame_newslot(bool5916);
  params[0] = *var_nextToken;
  partcv[0] = 1;
  Object opresult5917 = callmethod(bool5916, "==(1)", 1, partcv, params);
// compiled op node returning opresult5917 (depth = 6)
  int op_slot_left_5906 = gc_frame_newslot(opresult5917);
  params[0] = block5907;
  partcv[0] = 1;
  Object opresult5918 = callmethod(opresult5917, "||(1)", 1, partcv, params);
// compiled op node returning opresult5918 (depth = 5)
  Object if5905 = done;
  if (istrue(opresult5918)) {
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5919 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5920 == NULL) {
    strlit5920 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit5920);
  }
// compiled string node returning strlit5920 (depth = 6)
  gc_frame_newslot(strlit5920);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5920;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5921 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5919);
// compiled call node returning call5921 (depth = 5)
    gc_frame_newslot(call5921);
    if5905 = call5921;
  } else {
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5922 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe5923 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  partcv[0] = 0;
  Object call5924 = callmethodflags(*var_nextToken, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe5923);
// compiled member node returning call5924 (depth = 6)
  gc_frame_newslot(call5924);
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool5925 = alloc_Boolean(0);
// compiled identifier node returning bool5925 (depth = 6)
  gc_frame_newslot(bool5925);
// starting to compile identifier node (depth = 6)
  Object bool5926 = alloc_Boolean(1);
// compiled identifier node returning bool5926 (depth = 6)
  gc_frame_newslot(bool5926);
// starting to compile string node (depth = 6)
  if (strlit5927 == NULL) {
    strlit5927 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit5927);
  }
// compiled string node returning strlit5927 (depth = 6)
  gc_frame_newslot(strlit5927);
// call case 6: other requests
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call5924;
  params[2] = bool5925;
  params[3] = bool5926;
  params[4] = strlit5927;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5928 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5922);
// compiled call node returning call5928 (depth = 5)
    gc_frame_newslot(call5928);
    if5905 = call5928;
  }
// compiled if node returning if5905 (depth = 4)
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5929 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5930 == NULL) {
    strlit5930 = alloc_String("a variable declaration must have a name after the 'var'.");
    gc_root(strlit5930);
  }
// compiled string node returning strlit5930 (depth = 5)
  gc_frame_newslot(strlit5930);
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5931 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5932 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe5931);
// compiled member node returning call5932 (depth = 5)
  gc_frame_newslot(call5932);
// starting to compile member node (depth = 5)
  int callframe5933 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5934 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe5933);
// compiled member node returning call5934 (depth = 5)
  gc_frame_newslot(call5934);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5930;
  params[1] = call5932;
  params[2] = call5934;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5935 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5929);
// compiled call node returning call5935 (depth = 4)
    gc_frame_newslot(call5935);
    if5873 = call5935;
  } else {
  }
// compiled if node returning if5873 (depth = 3)
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5936 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5937 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5936);
// compiled member node returning call5937 (depth = 3)
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5938 = alloc_Boolean(0);
// compiled identifier node returning bool5938 (depth = 4)
  *var_val = bool5938;
  if (bool5938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5939 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5940 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe5939);
// compiled member node returning call5940 (depth = 4)
  *var_name = call5940;
  if (call5940 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5941 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool5942 = alloc_Boolean(1);
// compiled identifier node returning bool5942 (depth = 4)
  gc_frame_newslot(bool5942);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool5942;
  partcv[0] = 1;
  Object call5943 = callmethodflags(*var_name, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5941);
// compiled call node returning call5943 (depth = 3)
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5944 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5945 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5944);
// compiled member node returning call5945 (depth = 4)
  *var_dtype = call5945;
  if (call5945 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5946 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5947 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5946);
// compiled member node returning call5947 (depth = 4)
  *var_anns = call5947;
  if (call5947 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5949 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5950 == NULL) {
    strlit5950 = alloc_String("bind");
    gc_root(strlit5950);
  }
// compiled string node returning strlit5950 (depth = 5)
  gc_frame_newslot(strlit5950);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit5950;
  partcv[0] = 1;
  Object call5951 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5949);
// compiled call node returning call5951 (depth = 4)
  Object if5948 = done;
  if (istrue(call5951)) {
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5952 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5953 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5952);
// compiled member node returning call5953 (depth = 4)
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5955 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block5956 = alloc_Block(NULL, NULL, "parser", 2053);
  gc_frame_newslot(block5956);
// method "_apply"
  block_savedest(block5956);
  Object closure5957 = createclosure(2, "_apply");
  setclosureframe(closure5957, stackframe);
  addtoclosure(closure5957, var_blocksOK);
  addtoclosure(closure5957, selfslot);
  struct UserObject *uo5957 = (struct UserObject*)block5956;
  uo5957->data[0] = (Object)closure5957;
  Method *meth_meth_parser_5957__apply = addmethod2pos(block5956, "_apply", &meth_parser_5957__apply, 0);
  int argcv_meth_parser_5957__apply[] = {0};
  meth_meth_parser_5957__apply->type = alloc_MethodType(1, argcv_meth_parser_5957__apply);
  meth_meth_parser_5957__apply->definitionModule = modulename;
  meth_meth_parser_5957__apply->definitionLine = 183;
// compiled block node returning block5956 (depth = 6)
  gc_frame_newslot(block5956);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block5956;
  partcv[0] = 1;
  Object call5961 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5955);
// compiled call node returning call5961 (depth = 5)
  Object if5954 = done;
  if (istrue(call5961)) {
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array5962 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5962 (depth = 6)
  *var_suggestions = array5962;
  if (array5962 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5963 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5964 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call5965 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5964);
// compiled member node returning call5965 (depth = 7)
  partcv[0] = 0;
  Object call5966 = callmethodflags(call5965, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5963);
// compiled member node returning call5966 (depth = 6)
  *var_suggestion = call5966;
  if (call5966 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5967 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array5968 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5968 (depth = 7)
  gc_frame_newslot(array5968);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = array5968;
  partcv[0] = 1;
  Object call5969 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5967);
// compiled call node returning call5969 (depth = 6)
  *var_nextTok = call5969;
  if (call5969 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_5971 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_5971 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5973 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5973 (depth = 6)
  Object if5970 = done;
  if (istrue(opresult5973)) {
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5974 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5975 == NULL) {
    strlit5975 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5975);
  }
// compiled string node returning strlit5975 (depth = 7)
  gc_frame_newslot(strlit5975);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit5975;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5976 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5974);
// compiled call node returning call5976 (depth = 6)
    gc_frame_newslot(call5976);
    if5970 = call5976;
  } else {
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5977 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe5978 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call5979 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe5978);
// compiled member node returning call5979 (depth = 7)
  gc_frame_newslot(call5979);
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool5980 = alloc_Boolean(1);
// compiled identifier node returning bool5980 (depth = 7)
  gc_frame_newslot(bool5980);
// starting to compile identifier node (depth = 7)
  Object bool5981 = alloc_Boolean(0);
// compiled identifier node returning bool5981 (depth = 7)
  gc_frame_newslot(bool5981);
// starting to compile string node (depth = 7)
  if (strlit5982 == NULL) {
    strlit5982 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5982);
  }
// compiled string node returning strlit5982 (depth = 7)
  gc_frame_newslot(strlit5982);
// call case 6: other requests
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call5979;
  params[2] = bool5980;
  params[3] = bool5981;
  params[4] = strlit5982;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5983 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5977);
// compiled call node returning call5983 (depth = 6)
    gc_frame_newslot(call5983);
    if5970 = call5983;
  }
// compiled if node returning if5970 (depth = 5)
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5984 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5985 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5984);
// compiled call node returning call5985 (depth = 5)
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5986 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5987 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call5988 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe5987);
// compiled member node returning call5988 (depth = 7)
  partcv[0] = 0;
  Object call5989 = callmethodflags(call5988, "new", 1, partcv, params, 0);
  gc_frame_end(callframe5986);
// compiled member node returning call5989 (depth = 6)
  *var_suggestion = call5989;
  if (call5989 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5991 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
  int callframe5992 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call5993 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe5992);
// compiled member node returning call5993 (depth = 6)
  gc_frame_newslot(call5993);
// starting to compile identifier node (depth = 6)
  Object bool5994 = alloc_Boolean(1);
// compiled identifier node returning bool5994 (depth = 6)
  gc_frame_newslot(bool5994);
// starting to compile identifier node (depth = 6)
  Object bool5995 = alloc_Boolean(0);
// compiled identifier node returning bool5995 (depth = 6)
  gc_frame_newslot(bool5995);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call5993;
  params[2] = bool5994;
  params[3] = bool5995;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5996 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5991);
// compiled call node returning call5996 (depth = 5)
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5997 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5998 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5997);
// compiled call node returning call5998 (depth = 5)
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5999 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2068
  setline(2068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6001 == NULL) {
    strlit6001 = alloc_String("A variable without a value can be declared with 'var' followed only by the variable name.");
    gc_root(strlit6001);
  }
// compiled string node returning strlit6001 (depth = 7)
  int op_slot_right_6000 = gc_frame_newslot(strlit6001);
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6003 == NULL) {
    strlit6003 = alloc_String("a variable declaration must have a value after the ':='. ");
    gc_root(strlit6003);
  }
// compiled string node returning strlit6003 (depth = 7)
  int op_slot_left_6000 = gc_frame_newslot(strlit6003);
  params[0] = strlit6001;
  partcv[0] = 1;
  Object opresult6004 = callmethod(strlit6003, "++(1)", 1, partcv, params);
// compiled op node returning opresult6004 (depth = 6)
  gc_frame_newslot(opresult6004);
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6005 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6006 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6005);
// compiled member node returning call6006 (depth = 6)
  gc_frame_newslot(call6006);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6008 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call6009 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6008);
// compiled member node returning call6009 (depth = 7)
  int op_slot_right_6007 = gc_frame_newslot(call6009);
// starting to compile member node (depth = 7)
  int callframe6011 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call6012 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6011);
// compiled member node returning call6012 (depth = 7)
  int op_slot_left_6007 = gc_frame_newslot(call6012);
  params[0] = call6009;
  partcv[0] = 1;
  Object sum6013 = callmethod(call6012, "+(1)", 1, partcv, params);
// compiled op node returning sum6013 (depth = 6)
  gc_frame_newslot(sum6013);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult6004;
  params[1] = call6006;
  params[2] = sum6013;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6014 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5999);
// compiled call node returning call6014 (depth = 5)
    gc_frame_newslot(call6014);
    if5954 = call6014;
  } else {
  }
// compiled if node returning if5954 (depth = 4)
// Begin line 2071
  setline(2071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6015 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call6016 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe6015);
// compiled member node returning call6016 (depth = 5)
  *var_val = call6016;
  if (call6016 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5948 = done;
  } else {
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6021 == NULL) {
    strlit6021 = alloc_String("=");
    gc_root(strlit6021);
  }
// compiled string node returning strlit6021 (depth = 7)
  int op_slot_right_6020 = gc_frame_newslot(strlit6021);
// starting to compile member node (depth = 7)
  int callframe6023 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6024 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6023);
// compiled member node returning call6024 (depth = 7)
  int op_slot_left_6020 = gc_frame_newslot(call6024);
  params[0] = strlit6021;
  partcv[0] = 1;
  Object opresult6025 = callmethod(call6024, "==(1)", 1, partcv, params);
// compiled op node returning opresult6025 (depth = 6)
  int op_slot_right_6019 = gc_frame_newslot(opresult6025);
// starting to compile call node (depth = 6)
  int callframe6027 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6028 == NULL) {
    strlit6028 = alloc_String("op");
    gc_root(strlit6028);
  }
// compiled string node returning strlit6028 (depth = 7)
  gc_frame_newslot(strlit6028);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit6028;
  partcv[0] = 1;
  Object call6029 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6027);
// compiled call node returning call6029 (depth = 6)
  int op_slot_left_6019 = gc_frame_newslot(call6029);
  params[0] = opresult6025;
  partcv[0] = 1;
  Object opresult6030 = callmethod(call6029, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6030 (depth = 5)
  Object if6018 = done;
  if (istrue(opresult6030)) {
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array6031 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6031 (depth = 6)
  *var_suggestions = array6031;
  if (array6031 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6032 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6033 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6034 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6033);
// compiled member node returning call6034 (depth = 7)
  partcv[0] = 0;
  Object call6035 = callmethodflags(call6034, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6032);
// compiled member node returning call6035 (depth = 6)
  *var_suggestion = call6035;
  if (call6035 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6036 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit6037 == NULL) {
    strlit6037 = alloc_String(":=");
    gc_root(strlit6037);
  }
// compiled string node returning strlit6037 (depth = 6)
  gc_frame_newslot(strlit6037);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit6037;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6038 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6036);
// compiled call node returning call6038 (depth = 5)
// Begin line 2077
  setline(2077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6039 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6040 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6039);
// compiled call node returning call6040 (depth = 5)
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6041 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6043 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6042);
// compiled member node returning call6043 (depth = 7)
  partcv[0] = 0;
  Object call6044 = callmethodflags(call6043, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6041);
// compiled member node returning call6044 (depth = 6)
  *var_suggestion = call6044;
  if (call6044 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6046 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varTok (depth = 6)
  gc_frame_newslot(*var_varTok);
// starting to compile string node (depth = 6)
  if (strlit6047 == NULL) {
    strlit6047 = alloc_String("def");
    gc_root(strlit6047);
  }
// compiled string node returning strlit6047 (depth = 6)
  gc_frame_newslot(strlit6047);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_varTok;
  params[1] = strlit6047;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6048 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6046);
// compiled call node returning call6048 (depth = 5)
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6049 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6050 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6049);
// compiled call node returning call6050 (depth = 5)
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6051 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6052 == NULL) {
    strlit6052 = alloc_String("a variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.");
    gc_root(strlit6052);
  }
// compiled string node returning strlit6052 (depth = 6)
  gc_frame_newslot(strlit6052);
// Begin line 2082
  setline(2082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6053 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6054 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6053);
// compiled member node returning call6054 (depth = 6)
  gc_frame_newslot(call6054);
// starting to compile member node (depth = 6)
  int callframe6055 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6056 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6055);
// compiled member node returning call6056 (depth = 6)
  gc_frame_newslot(call6056);
// starting to compile member node (depth = 6)
  int callframe6057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6058 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6057);
// compiled member node returning call6058 (depth = 6)
  gc_frame_newslot(call6058);
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit6052;
  params[1] = call6054;
  params[2] = call6056;
  params[3] = call6058;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6059 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6051);
// compiled call node returning call6059 (depth = 5)
    gc_frame_newslot(call6059);
    if6018 = call6059;
  } else {
  }
// compiled if node returning if6018 (depth = 4)
    gc_frame_newslot(if6018);
    if5948 = if6018;
  }
// compiled if node returning if5948 (depth = 3)
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6060 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call6061 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6060);
// compiled call node returning call6061 (depth = 3)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6062 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6063 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call6064 = callmethodflags(*var_ast, "varDecNode", 1, partcv, params, 0);
  gc_frame_end(callframe6063);
// compiled member node returning call6064 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call6065 = callmethodflags(call6064, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe6062);
// compiled call node returning call6065 (depth = 4)
  *var_o = call6065;
  if (call6065 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_6067 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool6069 = alloc_Boolean(0);
// compiled identifier node returning bool6069 (depth = 5)
  int op_slot_left_6067 = gc_frame_newslot(bool6069);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult6070 = callmethod(bool6069, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6070 (depth = 4)
  Object if6066 = done;
  if (istrue(opresult6070)) {
// starting to compile call node (depth = 4)
  int callframe6071 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6072 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  partcv[0] = 0;
  Object call6073 = callmethodflags(*var_o, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe6072);
// compiled member node returning call6073 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call6074 = callmethodflags(call6073, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6071);
// compiled call node returning call6074 (depth = 4)
    gc_frame_newslot(call6074);
    if6066 = call6074;
  } else {
  }
// compiled if node returning if6066 (depth = 3)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6075 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call6076 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6075);
// compiled call node returning call6076 (depth = 3)
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6077 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6078 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6077);
// compiled member node returning call6078 (depth = 3)
// Begin line 2091
  setline(2091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_minIndentLevel = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5863 = done;
  } else {
  }
// compiled if node returning if5863 (depth = 2)
  gc_frame_end(frame);
  return if5863;
}
Object meth_parser_6091__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe6092 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blocksOK (depth = 7)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6093 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6092);
// compiled call node returning call6093 (depth = 6)
  gc_frame_end(frame);
  return call6093;
}
Object meth_parser_6098__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe6099 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6100 == NULL) {
    strlit6100 = alloc_String("comma");
    gc_root(strlit6100);
  }
// compiled string node returning strlit6100 (depth = 7)
  gc_frame_newslot(strlit6100);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit6100;
  partcv[0] = 1;
  Object call6101 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6099);
// compiled call node returning call6101 (depth = 6)
  gc_frame_end(frame);
  return call6101;
}
Object meth_parser_6115__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 9)
  int callframe6116 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning module_parser (depth = 10)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6117 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6116);
// compiled call node returning call6117 (depth = 9)
  gc_frame_end(frame);
  return call6117;
}
Object meth_parser_6104__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6105 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6106 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe6105);
// compiled member node returning call6106 (depth = 7)
  *var_tmp = call6106;
  if (call6106 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6108 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_params (depth = 7)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call6109 = callmethodflags(*var_params, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6108);
// compiled call node returning call6109 (depth = 6)
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6110 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6111 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6110);
// compiled member node returning call6111 (depth = 6)
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6113 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block6114 = alloc_Block(NULL, NULL, "parser", 2108);
  gc_frame_newslot(block6114);
// method "_apply"
  block_savedest(block6114);
  Object closure6115 = createclosure(2, "_apply");
  setclosureframe(closure6115, stackframe);
  addtoclosure(closure6115, var_blocksOK);
  addtoclosure(closure6115, selfslot);
  struct UserObject *uo6115 = (struct UserObject*)block6114;
  uo6115->data[0] = (Object)closure6115;
  Method *meth_meth_parser_6115__apply = addmethod2pos(block6114, "_apply", &meth_parser_6115__apply, 0);
  int argcv_meth_parser_6115__apply[] = {0};
  meth_meth_parser_6115__apply->type = alloc_MethodType(1, argcv_meth_parser_6115__apply);
  meth_meth_parser_6115__apply->definitionModule = modulename;
  meth_meth_parser_6115__apply->definitionLine = 183;
// compiled block node returning block6114 (depth = 8)
  gc_frame_newslot(block6114);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block6114;
  partcv[0] = 1;
  Object call6119 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6113);
// compiled call node returning call6119 (depth = 7)
  Object if6112 = done;
  if (istrue(call6119)) {
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array6120 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6120 (depth = 8)
  *var_suggestions = array6120;
  if (array6120 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6121 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe6122 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6123 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6122);
// compiled member node returning call6123 (depth = 9)
  partcv[0] = 0;
  Object call6124 = callmethodflags(call6123, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6121);
// compiled member node returning call6124 (depth = 8)
  *var_suggestion = call6124;
  if (call6124 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6125 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array6126 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit6127 == NULL) {
    strlit6127 = alloc_String("rsquare");
    gc_root(strlit6127);
  }
// compiled string node returning strlit6127 (depth = 10)
  params[0] = strlit6127;
  partcv[0] = 1;
  callmethodflags(array6126, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6126 (depth = 9)
  gc_frame_newslot(array6126);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = array6126;
  partcv[0] = 1;
  Object call6128 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6125);
// compiled call node returning call6128 (depth = 8)
  *var_nextTok = call6128;
  if (call6128 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_6130 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_6130 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6132 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult6132 (depth = 8)
  Object if6129 = done;
  if (istrue(opresult6132)) {
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6133 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6134 == NULL) {
    strlit6134 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6134);
  }
// compiled string node returning strlit6134 (depth = 9)
  gc_frame_newslot(strlit6134);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6134;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6135 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6133);
// compiled call node returning call6135 (depth = 8)
    gc_frame_newslot(call6135);
    if6129 = call6135;
  } else {
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6136 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe6137 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call6138 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe6137);
// compiled member node returning call6138 (depth = 9)
  gc_frame_newslot(call6138);
// starting to compile identifier node (depth = 9)
  Object bool6139 = alloc_Boolean(1);
// compiled identifier node returning bool6139 (depth = 9)
  gc_frame_newslot(bool6139);
// starting to compile identifier node (depth = 9)
  Object bool6140 = alloc_Boolean(0);
// compiled identifier node returning bool6140 (depth = 9)
  gc_frame_newslot(bool6140);
// starting to compile string node (depth = 9)
  if (strlit6141 == NULL) {
    strlit6141 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6141);
  }
// compiled string node returning strlit6141 (depth = 9)
  gc_frame_newslot(strlit6141);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6138;
  params[2] = bool6139;
  params[3] = bool6140;
  params[4] = strlit6141;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6142 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe6136);
// compiled call node returning call6142 (depth = 8)
    gc_frame_newslot(call6142);
    if6129 = call6142;
  }
// compiled if node returning if6129 (depth = 7)
// Begin line 2117
  setline(2117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6143 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6144 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6143);
// compiled call node returning call6144 (depth = 7)
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6145 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe6146 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6147 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6146);
// compiled member node returning call6147 (depth = 9)
  partcv[0] = 0;
  Object call6148 = callmethodflags(call6147, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6145);
// compiled member node returning call6148 (depth = 8)
  *var_suggestion = call6148;
  if (call6148 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6150 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
  int callframe6151 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call6152 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe6151);
// compiled member node returning call6152 (depth = 8)
  gc_frame_newslot(call6152);
// starting to compile identifier node (depth = 8)
  Object bool6153 = alloc_Boolean(1);
// compiled identifier node returning bool6153 (depth = 8)
  gc_frame_newslot(bool6153);
// starting to compile identifier node (depth = 8)
  Object bool6154 = alloc_Boolean(0);
// compiled identifier node returning bool6154 (depth = 8)
  gc_frame_newslot(bool6154);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call6152;
  params[2] = bool6153;
  params[3] = bool6154;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6155 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6150);
// compiled call node returning call6155 (depth = 7)
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6156 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6157 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6156);
// compiled call node returning call6157 (depth = 7)
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6158 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6159 == NULL) {
    strlit6159 = alloc_String("a collection must contain zero or more expressions separated by commas.");
    gc_root(strlit6159);
  }
// compiled string node returning strlit6159 (depth = 8)
  gc_frame_newslot(strlit6159);
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe6160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6161 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6160);
// compiled member node returning call6161 (depth = 8)
  gc_frame_newslot(call6161);
// starting to compile member node (depth = 8)
  int callframe6162 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6163 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6162);
// compiled member node returning call6163 (depth = 8)
  gc_frame_newslot(call6163);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6159;
  params[1] = call6161;
  params[2] = call6163;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6164 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6158);
// compiled call node returning call6164 (depth = 7)
    gc_frame_newslot(call6164);
    if6112 = call6164;
  } else {
  }
// compiled if node returning if6112 (depth = 6)
  gc_frame_end(frame);
  return if6112;
}
Object meth_parser_6080_doarray(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 62, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doarray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_lSq = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lSq");
  Object *var_tmp = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tmp");
  Object *var_params = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "params");
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// definebindings:
  Object *var_o = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "o");
// definebindings:
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6082 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6083 == NULL) {
    strlit6083 = alloc_String("lsquare");
    gc_root(strlit6083);
  }
// compiled string node returning strlit6083 (depth = 4)
  gc_frame_newslot(strlit6083);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit6083;
  partcv[0] = 1;
  Object call6084 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6082);
// compiled call node returning call6084 (depth = 3)
  Object if6081 = done;
  if (istrue(call6084)) {
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lSq = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6085 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6086 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6085);
// compiled member node returning call6086 (depth = 3)
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array6087 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6087 (depth = 4)
  *var_params = array6087;
  if (array6087 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2103
  setline(2103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6089 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6090 = alloc_Block(NULL, NULL, "parser", 2103);
  gc_frame_newslot(block6090);
// method "_apply"
  block_savedest(block6090);
  Object closure6091 = createclosure(2, "_apply");
  setclosureframe(closure6091, stackframe);
  addtoclosure(closure6091, var_blocksOK);
  addtoclosure(closure6091, selfslot);
  struct UserObject *uo6091 = (struct UserObject*)block6090;
  uo6091->data[0] = (Object)closure6091;
  Method *meth_meth_parser_6091__apply = addmethod2pos(block6090, "_apply", &meth_parser_6091__apply, 0);
  int argcv_meth_parser_6091__apply[] = {0};
  meth_meth_parser_6091__apply->type = alloc_MethodType(1, argcv_meth_parser_6091__apply);
  meth_meth_parser_6091__apply->definitionModule = modulename;
  meth_meth_parser_6091__apply->definitionLine = 183;
// compiled block node returning block6090 (depth = 5)
  gc_frame_newslot(block6090);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block6090;
  partcv[0] = 1;
  Object call6095 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6089);
// compiled call node returning call6095 (depth = 4)
  Object if6088 = done;
  if (istrue(call6095)) {
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6096 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6097 = alloc_Block(NULL, NULL, "parser", 2104);
  gc_frame_newslot(block6097);
// method "_apply"
  block_savedest(block6097);
  Object closure6098 = createclosure(1, "_apply");
  setclosureframe(closure6098, stackframe);
  addtoclosure(closure6098, selfslot);
  struct UserObject *uo6098 = (struct UserObject*)block6097;
  uo6098->data[0] = (Object)closure6098;
  Method *meth_meth_parser_6098__apply = addmethod2pos(block6097, "_apply", &meth_parser_6098__apply, 0);
  int argcv_meth_parser_6098__apply[] = {0};
  meth_meth_parser_6098__apply->type = alloc_MethodType(1, argcv_meth_parser_6098__apply);
  meth_meth_parser_6098__apply->definitionModule = modulename;
  meth_meth_parser_6098__apply->definitionLine = 183;
// compiled block node returning block6097 (depth = 5)
  gc_frame_newslot(block6097);
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block6103 = alloc_Block(NULL, NULL, "parser", 2104);
  gc_frame_newslot(block6103);
// method "_apply"
  block_savedest(block6103);
  Object closure6104 = createclosure(8, "_apply");
  setclosureframe(closure6104, stackframe);
  addtoclosure(closure6104, var_values);
  addtoclosure(closure6104, var_tmp);
  addtoclosure(closure6104, var_params);
  addtoclosure(closure6104, var_blocksOK);
  addtoclosure(closure6104, var_errormessages);
  addtoclosure(closure6104, var_sym);
  addtoclosure(closure6104, var_lastToken);
  addtoclosure(closure6104, selfslot);
  struct UserObject *uo6104 = (struct UserObject*)block6103;
  uo6104->data[0] = (Object)closure6104;
  Method *meth_meth_parser_6104__apply = addmethod2pos(block6103, "_apply", &meth_parser_6104__apply, 0);
  int argcv_meth_parser_6104__apply[] = {0};
  meth_meth_parser_6104__apply->type = alloc_MethodType(1, argcv_meth_parser_6104__apply);
  meth_meth_parser_6104__apply->definitionModule = modulename;
  meth_meth_parser_6104__apply->definitionLine = 183;
// compiled block node returning block6103 (depth = 5)
  gc_frame_newslot(block6103);
// call case 5: prelude request
  params[0] = block6097;
  params[1] = block6103;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6166 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6096);
// compiled call node returning call6166 (depth = 4)
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6167 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call6168 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe6167);
// compiled member node returning call6168 (depth = 5)
  *var_tmp = call6168;
  if (call6168 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2126
  setline(2126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6170 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call6171 = callmethodflags(*var_params, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6170);
// compiled call node returning call6171 (depth = 4)
    gc_frame_newslot(call6171);
    if6088 = call6171;
  } else {
  }
// compiled if node returning if6088 (depth = 3)
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6174 == NULL) {
    strlit6174 = alloc_String("rsquare");
    gc_root(strlit6174);
  }
// compiled string node returning strlit6174 (depth = 5)
  int op_slot_right_6173 = gc_frame_newslot(strlit6174);
// starting to compile member node (depth = 5)
  int callframe6176 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6177 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe6176);
// compiled member node returning call6177 (depth = 5)
  int op_slot_left_6173 = gc_frame_newslot(call6177);
  params[0] = strlit6174;
  partcv[0] = 1;
  Object opresult6178 = callmethod(call6177, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6178 (depth = 4)
  Object if6172 = done;
  if (istrue(opresult6178)) {
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6179 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6180 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call6181 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6180);
// compiled member node returning call6181 (depth = 6)
  partcv[0] = 0;
  Object call6182 = callmethodflags(call6181, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6179);
// compiled member node returning call6182 (depth = 5)
  *var_suggestion = call6182;
  if (call6182 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6183 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6184 == NULL) {
    strlit6184 = alloc_String("]");
    gc_root(strlit6184);
  }
// compiled string node returning strlit6184 (depth = 5)
  gc_frame_newslot(strlit6184);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit6184;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6185 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6183);
// compiled call node returning call6185 (depth = 4)
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6186 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6187 == NULL) {
    strlit6187 = alloc_String("a collection beginning with a '[' must end with a ']'.");
    gc_root(strlit6187);
  }
// compiled string node returning strlit6187 (depth = 5)
  gc_frame_newslot(strlit6187);
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6188 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6189 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6188);
// compiled member node returning call6189 (depth = 5)
  gc_frame_newslot(call6189);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6191 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6192 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6191);
// compiled member node returning call6192 (depth = 6)
  int op_slot_right_6190 = gc_frame_newslot(call6192);
// starting to compile member node (depth = 6)
  int callframe6194 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6195 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6194);
// compiled member node returning call6195 (depth = 6)
  int op_slot_left_6190 = gc_frame_newslot(call6195);
  params[0] = call6192;
  partcv[0] = 1;
  Object sum6196 = callmethod(call6195, "+(1)", 1, partcv, params);
// compiled op node returning sum6196 (depth = 5)
  gc_frame_newslot(sum6196);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit6187;
  params[1] = call6189;
  params[2] = sum6196;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6197 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6186);
// compiled call node returning call6197 (depth = 4)
    gc_frame_newslot(call6197);
    if6172 = call6197;
  } else {
  }
// compiled if node returning if6172 (depth = 3)
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6198 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lSq (depth = 5)
  gc_frame_newslot(*var_lSq);
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe6199 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_params (depth = 6)
  gc_frame_newslot(*var_params);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6200 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call6201 = callmethodflags(*var_ast, "arrayNode", 1, partcv, params, 0);
  gc_frame_end(callframe6200);
// compiled member node returning call6201 (depth = 6)
  params[0] = *var_params;
  partcv[0] = 1;
  Object call6202 = callmethodflags(call6201, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6199);
// compiled call node returning call6202 (depth = 5)
  params[0] = *var_lSq;
  partcv[0] = 1;
  Object call6203 = callmethodflags(call6202, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6198);
// compiled call node returning call6203 (depth = 4)
  *var_o = call6203;
  if (call6203 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6204 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call6205 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6204);
// compiled call node returning call6205 (depth = 3)
// Begin line 2136
  setline(2136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6206 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6207 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6206);
// compiled member node returning call6207 (depth = 3)
    gc_frame_newslot(call6207);
    if6081 = call6207;
  } else {
  }
// compiled if node returning if6081 (depth = 2)
  gc_frame_end(frame);
  return if6081;
}
Object meth_parser_6208_dodialect(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 63, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dodialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_moduleObject = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_errorPos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "errorPos");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_dn = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "dn");
// definebindings:
// definebindings:
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6210 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6211 == NULL) {
    strlit6211 = alloc_String("dialect");
    gc_root(strlit6211);
  }
// compiled string node returning strlit6211 (depth = 4)
  gc_frame_newslot(strlit6211);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit6211;
  partcv[0] = 1;
  Object call6212 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6210);
// compiled call node returning call6212 (depth = 3)
  Object if6209 = done;
  if (istrue(call6212)) {
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6213 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6214 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6213);
// compiled member node returning call6214 (depth = 3)
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6217 == NULL) {
    strlit6217 = alloc_String("string");
    gc_root(strlit6217);
  }
// compiled string node returning strlit6217 (depth = 5)
  int op_slot_right_6216 = gc_frame_newslot(strlit6217);
// starting to compile member node (depth = 5)
  int callframe6219 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6220 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe6219);
// compiled member node returning call6220 (depth = 5)
  int op_slot_left_6216 = gc_frame_newslot(call6220);
  params[0] = strlit6217;
  partcv[0] = 1;
  Object opresult6221 = callmethod(call6220, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6221 (depth = 4)
  Object if6215 = done;
  if (istrue(opresult6221)) {
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6222 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6223 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call6224 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6223);
// compiled member node returning call6224 (depth = 6)
  partcv[0] = 0;
  Object call6225 = callmethodflags(call6224, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6222);
// compiled member node returning call6225 (depth = 5)
  *var_suggestion = call6225;
  if (call6225 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6229 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call6230 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6229);
// compiled member node returning call6230 (depth = 7)
  int op_slot_right_6228 = gc_frame_newslot(call6230);
// starting to compile member node (depth = 7)
  int callframe6232 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6233 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6232);
// compiled member node returning call6233 (depth = 7)
  int op_slot_left_6228 = gc_frame_newslot(call6233);
  params[0] = call6230;
  partcv[0] = 1;
  Object opresult6234 = callmethod(call6233, "==(1)", 1, partcv, params);
// compiled op node returning opresult6234 (depth = 6)
  int op_slot_right_6227 = gc_frame_newslot(opresult6234);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6237 == NULL) {
    strlit6237 = alloc_String("identifier");
    gc_root(strlit6237);
  }
// compiled string node returning strlit6237 (depth = 7)
  int op_slot_right_6236 = gc_frame_newslot(strlit6237);
// starting to compile member node (depth = 7)
  int callframe6239 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6240 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe6239);
// compiled member node returning call6240 (depth = 7)
  int op_slot_left_6236 = gc_frame_newslot(call6240);
  params[0] = strlit6237;
  partcv[0] = 1;
  Object opresult6241 = callmethod(call6240, "==(1)", 1, partcv, params);
// compiled op node returning opresult6241 (depth = 6)
  int op_slot_left_6227 = gc_frame_newslot(opresult6241);
  params[0] = opresult6234;
  partcv[0] = 1;
  Object opresult6242 = callmethod(opresult6241, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6242 (depth = 5)
  Object if6226 = done;
  if (istrue(opresult6242)) {
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6243 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6245 == NULL) {
    strlit6245 = alloc_String("""\x22""");
    gc_root(strlit6245);
  }
// compiled string node returning strlit6245 (depth = 7)
  int op_slot_right_6244 = gc_frame_newslot(strlit6245);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6248 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6249 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6248);
// compiled member node returning call6249 (depth = 8)
  int op_slot_right_6247 = gc_frame_newslot(call6249);
// starting to compile string node (depth = 8)
  if (strlit6251 == NULL) {
    strlit6251 = alloc_String("""\x22""");
    gc_root(strlit6251);
  }
// compiled string node returning strlit6251 (depth = 8)
  int op_slot_left_6247 = gc_frame_newslot(strlit6251);
  params[0] = call6249;
  partcv[0] = 1;
  Object opresult6252 = callmethod(strlit6251, "++(1)", 1, partcv, params);
// compiled op node returning opresult6252 (depth = 7)
  int op_slot_left_6244 = gc_frame_newslot(opresult6252);
  params[0] = strlit6245;
  partcv[0] = 1;
  Object opresult6253 = callmethod(opresult6252, "++(1)", 1, partcv, params);
// compiled op node returning opresult6253 (depth = 6)
  gc_frame_newslot(opresult6253);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult6253;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6254 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6243);
// compiled call node returning call6254 (depth = 5)
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6255 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6256 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6255);
// compiled member node returning call6256 (depth = 6)
  *var_errorPos = call6256;
  if (call6256 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6226 = done;
  } else {
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6258 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6259 == NULL) {
    strlit6259 = alloc_String(" ""\x22""""\xc2""""\xab""dialect name""\xc2""""\xbb""""\x22""");
    gc_root(strlit6259);
  }
// compiled string node returning strlit6259 (depth = 6)
  gc_frame_newslot(strlit6259);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6259;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6260 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6258);
// compiled call node returning call6260 (depth = 5)
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6262 = alloc_Float64(1);
// compiled num node returning num6262 (depth = 7)
  int op_slot_right_6261 = gc_frame_newslot(num6262);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6265 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call6266 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6265);
// compiled member node returning call6266 (depth = 8)
  int op_slot_right_6264 = gc_frame_newslot(call6266);
// starting to compile member node (depth = 8)
  int callframe6268 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call6269 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6268);
// compiled member node returning call6269 (depth = 8)
  int op_slot_left_6264 = gc_frame_newslot(call6269);
  params[0] = call6266;
  partcv[0] = 1;
  Object sum6270 = callmethod(call6269, "+(1)", 1, partcv, params);
// compiled op node returning sum6270 (depth = 7)
  int op_slot_left_6261 = gc_frame_newslot(sum6270);
  params[0] = num6262;
  partcv[0] = 1;
  Object sum6271 = callmethod(sum6270, "+(1)", 1, partcv, params);
// compiled op node returning sum6271 (depth = 6)
  *var_errorPos = sum6271;
  if (sum6271 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6226 = done;
  }
// compiled if node returning if6226 (depth = 4)
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6273 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6275 == NULL) {
    strlit6275 = alloc_String("of the dialect in quotes after the word 'dialect'.");
    gc_root(strlit6275);
  }
// compiled string node returning strlit6275 (depth = 6)
  int op_slot_right_6274 = gc_frame_newslot(strlit6275);
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6277 == NULL) {
    strlit6277 = alloc_String("a dialect statement must have the name ");
    gc_root(strlit6277);
  }
// compiled string node returning strlit6277 (depth = 6)
  int op_slot_left_6274 = gc_frame_newslot(strlit6277);
  params[0] = strlit6275;
  partcv[0] = 1;
  Object opresult6278 = callmethod(strlit6277, "++(1)", 1, partcv, params);
// compiled op node returning opresult6278 (depth = 5)
  gc_frame_newslot(opresult6278);
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6279 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6280 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6279);
// compiled member node returning call6280 (depth = 5)
  gc_frame_newslot(call6280);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult6278;
  params[1] = call6280;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6281 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6273);
// compiled call node returning call6281 (depth = 4)
    gc_frame_newslot(call6281);
    if6215 = call6281;
  } else {
  }
// compiled if node returning if6215 (depth = 3)
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6283 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call6284 = callmethodflags(*var_values, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe6283);
// compiled member node returning call6284 (depth = 4)
  Object if6282 = done;
  if (istrue(call6284)) {
// Begin line 2160
  setline(2160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6285 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6286 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call6287 = callmethodflags(*var_ast, "dialectNode", 1, partcv, params, 0);
  gc_frame_end(callframe6286);
// compiled member node returning call6287 (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call6288 = callmethodflags(call6287, "fromToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6285);
// compiled call node returning call6288 (depth = 5)
  *var_dn = call6288;
  if (call6288 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6289 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6290 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6289);
// compiled member node returning call6290 (depth = 4)
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6291 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dn (depth = 5)
  gc_frame_newslot(*var_dn);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_moduleObject (depth = 5)
  params[0] = *var_dn;
  partcv[0] = 1;
  Object call6292 = callmethodflags(*var_moduleObject, "theDialect:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6291);
// compiled call node returning call6292 (depth = 4)
    gc_frame_newslot(call6292);
    if6282 = call6292;
  } else {
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6293 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6294 == NULL) {
    strlit6294 = alloc_String("a dialect statement must be at the start of the module.");
    gc_root(strlit6294);
  }
// compiled string node returning strlit6294 (depth = 5)
  gc_frame_newslot(strlit6294);
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6295 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6296 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6295);
// compiled member node returning call6296 (depth = 5)
  gc_frame_newslot(call6296);
// call case 6: other requests
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit6294;
  params[1] = call6296;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6297 = callmethodflags(*var_errormessages, "syntaxError(1)atLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6293);
// compiled call node returning call6297 (depth = 4)
    gc_frame_newslot(call6297);
    if6282 = call6297;
  }
// compiled if node returning if6282 (depth = 3)
    gc_frame_newslot(if6282);
    if6209 = if6282;
  } else {
  }
// compiled if node returning if6209 (depth = 2)
  gc_frame_end(frame);
  return if6209;
}
Object meth_parser_6329__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe6330 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_noBlocks (depth = 7)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call6331 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6330);
// compiled call node returning call6331 (depth = 6)
  gc_frame_end(frame);
  return call6331;
}
Object meth_parser_6438__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_inhNode = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 5)
  int callframe6439 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inhNode (depth = 6)
  gc_frame_newslot(*var_inhNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_inhNode;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6440 = callmethodflags(module_parser, "inheritModifier(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6439);
// compiled call node returning call6440 (depth = 5)
  gc_frame_end(frame);
  return call6440;
}
Object meth_parser_6443__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_parser_6298_inheritOrUse(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 64, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritOrUse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_noBlocks = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_values = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
// definebindings:
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// definebindings:
// definebindings:
  Object *var_msg = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "msg");
// definebindings:
// definebindings:
// definebindings:
  Object *var_inhNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "inhNode");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6300 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6301 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6302 == NULL) {
    strlit6302 = alloc_String("keyword");
    gc_root(strlit6302);
  }
// compiled string node returning strlit6302 (depth = 5)
  gc_frame_newslot(strlit6302);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit6302;
  partcv[0] = 1;
  Object call6303 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6301);
// compiled call node returning call6303 (depth = 4)
  partcv[0] = 0;
  Object call6304 = callmethodflags(call6303, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe6300);
// compiled call node returning call6304 (depth = 3)
  Object if6299 = done;
  if (istrue(call6304)) {
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6299 = undefined;
  } else {
  }
// compiled if node returning if6299 (depth = 2)
// Begin line 2174
  setline(2174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6308 == NULL) {
    strlit6308 = alloc_String("use");
    gc_root(strlit6308);
  }
// compiled string node returning strlit6308 (depth = 5)
  int op_slot_right_6307 = gc_frame_newslot(strlit6308);
// starting to compile member node (depth = 5)
  int callframe6310 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6311 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6310);
// compiled member node returning call6311 (depth = 5)
  int op_slot_left_6307 = gc_frame_newslot(call6311);
  params[0] = strlit6308;
  partcv[0] = 1;
  Object opresult6312 = callmethod(call6311, "==(1)", 1, partcv, params);
// compiled op node returning opresult6312 (depth = 4)
  int op_slot_right_6306 = gc_frame_newslot(opresult6312);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6315 == NULL) {
    strlit6315 = alloc_String("inherit");
    gc_root(strlit6315);
  }
// compiled string node returning strlit6315 (depth = 5)
  int op_slot_right_6314 = gc_frame_newslot(strlit6315);
// starting to compile member node (depth = 5)
  int callframe6317 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6318 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6317);
// compiled member node returning call6318 (depth = 5)
  int op_slot_left_6314 = gc_frame_newslot(call6318);
  params[0] = strlit6315;
  partcv[0] = 1;
  Object opresult6319 = callmethod(call6318, "==(1)", 1, partcv, params);
// compiled op node returning opresult6319 (depth = 4)
  int op_slot_left_6306 = gc_frame_newslot(opresult6319);
  params[0] = opresult6312;
  partcv[0] = 1;
  Object opresult6320 = callmethod(opresult6319, "||(1)", 1, partcv, params);
// compiled op node returning opresult6320 (depth = 3)
  Object if6305 = done;
  if (istrue(opresult6320)) {
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6322 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6323 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6322);
// compiled member node returning call6323 (depth = 3)
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6325 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6324);
// compiled member node returning call6325 (depth = 3)
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6327 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6328 = alloc_Block(NULL, NULL, "parser", 2179);
  gc_frame_newslot(block6328);
// method "_apply"
  block_savedest(block6328);
  Object closure6329 = createclosure(2, "_apply");
  setclosureframe(closure6329, stackframe);
  addtoclosure(closure6329, var_noBlocks);
  addtoclosure(closure6329, selfslot);
  struct UserObject *uo6329 = (struct UserObject*)block6328;
  uo6329->data[0] = (Object)closure6329;
  Method *meth_meth_parser_6329__apply = addmethod2pos(block6328, "_apply", &meth_parser_6329__apply, 0);
  int argcv_meth_parser_6329__apply[] = {0};
  meth_meth_parser_6329__apply->type = alloc_MethodType(1, argcv_meth_parser_6329__apply);
  meth_meth_parser_6329__apply->definitionModule = modulename;
  meth_meth_parser_6329__apply->definitionLine = 183;
// compiled block node returning block6328 (depth = 5)
  gc_frame_newslot(block6328);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block6328;
  partcv[0] = 1;
  Object call6333 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6327);
// compiled call node returning call6333 (depth = 4)
  Object if6326 = done;
  if (istrue(call6333)) {
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array6334 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6334 (depth = 5)
  *var_suggestions = array6334;
  if (array6334 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6335 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6336 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call6337 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6336);
// compiled member node returning call6337 (depth = 6)
  partcv[0] = 0;
  Object call6338 = callmethodflags(call6337, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6335);
// compiled member node returning call6338 (depth = 5)
  *var_suggestion = call6338;
  if (call6338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6339 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array6340 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit6341 == NULL) {
    strlit6341 = alloc_String("rsquare");
    gc_root(strlit6341);
  }
// compiled string node returning strlit6341 (depth = 7)
  params[0] = strlit6341;
  partcv[0] = 1;
  callmethodflags(array6340, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6340 (depth = 6)
  gc_frame_newslot(array6340);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = array6340;
  partcv[0] = 1;
  Object call6342 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6339);
// compiled call node returning call6342 (depth = 5)
  *var_nextTok = call6342;
  if (call6342 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_6344 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_6344 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6346 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult6346 (depth = 5)
  Object if6343 = done;
  if (istrue(opresult6346)) {
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6347 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6348 == NULL) {
    strlit6348 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit6348);
  }
// compiled string node returning strlit6348 (depth = 6)
  gc_frame_newslot(strlit6348);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6348;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6349 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6347);
// compiled call node returning call6349 (depth = 5)
    gc_frame_newslot(call6349);
    if6343 = call6349;
  } else {
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6350 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe6351 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call6352 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe6351);
// compiled member node returning call6352 (depth = 6)
  gc_frame_newslot(call6352);
// starting to compile identifier node (depth = 6)
  Object bool6353 = alloc_Boolean(1);
// compiled identifier node returning bool6353 (depth = 6)
  gc_frame_newslot(bool6353);
// starting to compile identifier node (depth = 6)
  Object bool6354 = alloc_Boolean(0);
// compiled identifier node returning bool6354 (depth = 6)
  gc_frame_newslot(bool6354);
// starting to compile string node (depth = 6)
  if (strlit6355 == NULL) {
    strlit6355 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit6355);
  }
// compiled string node returning strlit6355 (depth = 6)
  gc_frame_newslot(strlit6355);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call6352;
  params[2] = bool6353;
  params[3] = bool6354;
  params[4] = strlit6355;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6356 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe6350);
// compiled call node returning call6356 (depth = 5)
    gc_frame_newslot(call6356);
    if6343 = call6356;
  }
// compiled if node returning if6343 (depth = 4)
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6357 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6358 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6357);
// compiled call node returning call6358 (depth = 4)
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6359 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6360 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call6361 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6360);
// compiled member node returning call6361 (depth = 6)
  partcv[0] = 0;
  Object call6362 = callmethodflags(call6361, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6359);
// compiled member node returning call6362 (depth = 5)
  *var_suggestion = call6362;
  if (call6362 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6364 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 5)
  int callframe6365 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  partcv[0] = 0;
  Object call6366 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe6365);
// compiled member node returning call6366 (depth = 5)
  gc_frame_newslot(call6366);
// starting to compile identifier node (depth = 5)
  Object bool6367 = alloc_Boolean(1);
// compiled identifier node returning bool6367 (depth = 5)
  gc_frame_newslot(bool6367);
// starting to compile identifier node (depth = 5)
  Object bool6368 = alloc_Boolean(0);
// compiled identifier node returning bool6368 (depth = 5)
  gc_frame_newslot(bool6368);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = call6366;
  params[2] = bool6367;
  params[3] = bool6368;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6369 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6364);
// compiled call node returning call6369 (depth = 4)
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6370 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6371 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6370);
// compiled call node returning call6371 (depth = 4)
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6373 == NULL) {
    strlit6373 = alloc_String(" keyword must be followed by an expression that creates ");
    gc_root(strlit6373);
  }
// compiled string node returning strlit6373 (depth = 6)
  int op_slot_right_6372 = gc_frame_newslot(strlit6373);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6376 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  partcv[0] = 0;
  Object call6377 = callmethodflags(*var_btok, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6376);
// compiled member node returning call6377 (depth = 7)
  int op_slot_right_6375 = gc_frame_newslot(call6377);
// starting to compile string node (depth = 7)
  if (strlit6379 == NULL) {
    strlit6379 = alloc_String("The ");
    gc_root(strlit6379);
  }
// compiled string node returning strlit6379 (depth = 7)
  int op_slot_left_6375 = gc_frame_newslot(strlit6379);
  params[0] = call6377;
  partcv[0] = 1;
  Object opresult6380 = callmethod(strlit6379, "++(1)", 1, partcv, params);
// compiled op node returning opresult6380 (depth = 6)
  int op_slot_left_6372 = gc_frame_newslot(opresult6380);
  params[0] = strlit6373;
  partcv[0] = 1;
  Object opresult6381 = callmethod(opresult6380, "++(1)", 1, partcv, params);
// compiled op node returning opresult6381 (depth = 5)
  *var_msg = opresult6381;
  if (opresult6381 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6384 == NULL) {
    strlit6384 = alloc_String("use");
    gc_root(strlit6384);
  }
// compiled string node returning strlit6384 (depth = 6)
  int op_slot_right_6383 = gc_frame_newslot(strlit6384);
// starting to compile member node (depth = 6)
  int callframe6386 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call6387 = callmethodflags(*var_btok, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6386);
// compiled member node returning call6387 (depth = 6)
  int op_slot_left_6383 = gc_frame_newslot(call6387);
  params[0] = strlit6384;
  partcv[0] = 1;
  Object opresult6388 = callmethod(call6387, "==(1)", 1, partcv, params);
// compiled op node returning opresult6388 (depth = 5)
  Object if6382 = done;
  if (istrue(opresult6388)) {
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6390 == NULL) {
    strlit6390 = alloc_String("the trait being used.");
    gc_root(strlit6390);
  }
// compiled string node returning strlit6390 (depth = 7)
  int op_slot_right_6389 = gc_frame_newslot(strlit6390);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  int op_slot_left_6389 = gc_frame_newslot(*var_msg);
  params[0] = strlit6390;
  partcv[0] = 1;
  Object opresult6392 = callmethod(*var_msg, "++(1)", 1, partcv, params);
// compiled op node returning opresult6392 (depth = 6)
  *var_msg = opresult6392;
  if (opresult6392 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6382 = done;
  } else {
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6395 == NULL) {
    strlit6395 = alloc_String("the object being inherited.");
    gc_root(strlit6395);
  }
// compiled string node returning strlit6395 (depth = 7)
  int op_slot_right_6394 = gc_frame_newslot(strlit6395);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  int op_slot_left_6394 = gc_frame_newslot(*var_msg);
  params[0] = strlit6395;
  partcv[0] = 1;
  Object opresult6397 = callmethod(*var_msg, "++(1)", 1, partcv, params);
// compiled op node returning opresult6397 (depth = 6)
  *var_msg = opresult6397;
  if (opresult6397 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6382 = done;
  }
// compiled if node returning if6382 (depth = 4)
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6399 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_msg (depth = 5)
  gc_frame_newslot(*var_msg);
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6400 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6401 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6400);
// compiled member node returning call6401 (depth = 5)
  gc_frame_newslot(call6401);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num6403 = alloc_Float64(1);
// compiled num node returning num6403 (depth = 6)
  int op_slot_right_6402 = gc_frame_newslot(num6403);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6406 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call6407 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6406);
// compiled member node returning call6407 (depth = 7)
  int op_slot_right_6405 = gc_frame_newslot(call6407);
// starting to compile member node (depth = 7)
  int callframe6409 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call6410 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6409);
// compiled member node returning call6410 (depth = 7)
  int op_slot_left_6405 = gc_frame_newslot(call6410);
  params[0] = call6407;
  partcv[0] = 1;
  Object sum6411 = callmethod(call6410, "+(1)", 1, partcv, params);
// compiled op node returning sum6411 (depth = 6)
  int op_slot_left_6402 = gc_frame_newslot(sum6411);
  params[0] = num6403;
  partcv[0] = 1;
  Object sum6412 = callmethod(sum6411, "+(1)", 1, partcv, params);
// compiled op node returning sum6412 (depth = 5)
  gc_frame_newslot(sum6412);
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = *var_msg;
  params[1] = call6401;
  params[2] = sum6412;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6413 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6399);
// compiled call node returning call6413 (depth = 4)
    gc_frame_newslot(call6413);
    if6326 = call6413;
  } else {
  }
// compiled if node returning if6326 (depth = 3)
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6414 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6415 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call6416 = callmethodflags(*var_btok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6415);
// compiled member node returning call6416 (depth = 4)
  gc_frame_newslot(call6416);
// starting to compile member node (depth = 4)
  int callframe6417 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call6418 = callmethodflags(*var_btok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6417);
// compiled member node returning call6418 (depth = 4)
  gc_frame_newslot(call6418);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call6416;
  params[1] = call6418;
  partcv[0] = 2;
  Object call6419 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6414);
// compiled call node returning call6419 (depth = 3)
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6420 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6421 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call6422 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe6421);
// compiled member node returning call6422 (depth = 5)
  gc_frame_newslot(call6422);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6423 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call6424 = callmethodflags(*var_ast, "inheritNode", 1, partcv, params, 0);
  gc_frame_end(callframe6423);
// compiled member node returning call6424 (depth = 5)
  params[0] = call6422;
  partcv[0] = 1;
  Object call6425 = callmethodflags(call6424, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6420);
// compiled call node returning call6425 (depth = 4)
  *var_inhNode = call6425;
  if (call6425 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6428 == NULL) {
    strlit6428 = alloc_String("use");
    gc_root(strlit6428);
  }
// compiled string node returning strlit6428 (depth = 5)
  int op_slot_right_6427 = gc_frame_newslot(strlit6428);
// starting to compile member node (depth = 5)
  int callframe6430 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call6431 = callmethodflags(*var_btok, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6430);
// compiled member node returning call6431 (depth = 5)
  int op_slot_left_6427 = gc_frame_newslot(call6431);
  params[0] = strlit6428;
  partcv[0] = 1;
  Object opresult6432 = callmethod(call6431, "==(1)", 1, partcv, params);
// compiled op node returning opresult6432 (depth = 4)
  Object if6426 = done;
  if (istrue(opresult6432)) {
// Begin line 2205
  setline(2205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6433 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool6434 = alloc_Boolean(1);
// compiled identifier node returning bool6434 (depth = 5)
  gc_frame_newslot(bool6434);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inhNode (depth = 5)
  params[0] = bool6434;
  partcv[0] = 1;
  Object call6435 = callmethodflags(*var_inhNode, "isUse:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6433);
// compiled call node returning call6435 (depth = 4)
    gc_frame_newslot(call6435);
    if6426 = call6435;
  } else {
  }
// compiled if node returning if6426 (depth = 3)
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6436 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6437 = alloc_Block(NULL, NULL, "parser", 2207);
  gc_frame_newslot(block6437);
// method "_apply"
  block_savedest(block6437);
  Object closure6438 = createclosure(3, "_apply");
  setclosureframe(closure6438, stackframe);
  addtoclosure(closure6438, var_inhNode);
  addtoclosure(closure6438, var_btok);
  addtoclosure(closure6438, selfslot);
  struct UserObject *uo6438 = (struct UserObject*)block6437;
  uo6438->data[0] = (Object)closure6438;
  Method *meth_meth_parser_6438__apply = addmethod2pos(block6437, "_apply", &meth_parser_6438__apply, 0);
  int argcv_meth_parser_6438__apply[] = {0};
  meth_meth_parser_6438__apply->type = alloc_MethodType(1, argcv_meth_parser_6438__apply);
  meth_meth_parser_6438__apply->definitionModule = modulename;
  meth_meth_parser_6438__apply->definitionLine = 183;
// compiled block node returning block6437 (depth = 4)
  gc_frame_newslot(block6437);
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6442 = alloc_Block(NULL, NULL, "parser", 2207);
  gc_frame_newslot(block6442);
// method "_apply"
  block_savedest(block6442);
  Object closure6443 = createclosure(1, "_apply");
  setclosureframe(closure6443, stackframe);
  addtoclosure(closure6443, selfslot);
  struct UserObject *uo6443 = (struct UserObject*)block6442;
  uo6443->data[0] = (Object)closure6443;
  Method *meth_meth_parser_6443__apply = addmethod2pos(block6442, "_apply", &meth_parser_6443__apply, 0);
  int argcv_meth_parser_6443__apply[] = {0};
  meth_meth_parser_6443__apply->type = alloc_MethodType(1, argcv_meth_parser_6443__apply);
  meth_meth_parser_6443__apply->definitionModule = modulename;
  meth_meth_parser_6443__apply->definitionLine = 183;
// compiled block node returning block6442 (depth = 4)
  gc_frame_newslot(block6442);
// call case 5: prelude request
  params[0] = block6437;
  params[1] = block6442;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6445 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6436);
// compiled call node returning call6445 (depth = 3)
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6446 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inhNode (depth = 4)
  gc_frame_newslot(*var_inhNode);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_inhNode;
  partcv[0] = 1;
  Object call6447 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6446);
// compiled call node returning call6447 (depth = 3)
    gc_frame_newslot(call6447);
    if6305 = call6447;
  } else {
  }
// compiled if node returning if6305 (depth = 2)
  gc_frame_end(frame);
  return if6305;
}
Object meth_parser_6448_inheritModifier_40_1_41_onLineOf_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 65, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritModifier(1)onLineOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inheritModifier(_)onLineOf(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inheritModifier(_)onLineOf(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for inheritModifier(_)onLineOf(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part inheritModifier(_)");
  Object *var_startToken = &(stackframe->slots[1]);
  *var_startToken = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLineOf(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6450 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6451 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6452 == NULL) {
    strlit6452 = alloc_String("keyword");
    gc_root(strlit6452);
  }
// compiled string node returning strlit6452 (depth = 5)
  gc_frame_newslot(strlit6452);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit6452;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6453 = callmethodflags(module_parser, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6451);
// compiled call node returning call6453 (depth = 4)
  partcv[0] = 0;
  Object call6454 = callmethodflags(call6453, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe6450);
// compiled call node returning call6454 (depth = 3)
  Object if6449 = done;
  if (istrue(call6454)) {
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool6455 = alloc_Boolean(0);
// compiled identifier node returning bool6455 (depth = 4)
  return bool6455;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6449 = undefined;
  } else {
  }
// compiled if node returning if6449 (depth = 2)
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6458 == NULL) {
    strlit6458 = alloc_String("alias");
    gc_root(strlit6458);
  }
// compiled string node returning strlit6458 (depth = 4)
  int op_slot_right_6457 = gc_frame_newslot(strlit6458);
// starting to compile member node (depth = 4)
  int callframe6460 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call6461 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6460);
// compiled member node returning call6461 (depth = 4)
  int op_slot_left_6457 = gc_frame_newslot(call6461);
  params[0] = strlit6458;
  partcv[0] = 1;
  Object opresult6462 = callmethod(call6461, "==(1)", 1, partcv, params);
// compiled op node returning opresult6462 (depth = 3)
  Object if6456 = done;
  if (istrue(opresult6462)) {
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6463 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  gc_frame_newslot(*var_node);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = *var_node;
  partcv[0] = 1;
  Object call6464 = callmethodflags(module_parser, "parseAlias(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6463);
// compiled call node returning call6464 (depth = 3)
    gc_frame_newslot(call6464);
    if6456 = call6464;
  } else {
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6467 == NULL) {
    strlit6467 = alloc_String("exclude");
    gc_root(strlit6467);
  }
// compiled string node returning strlit6467 (depth = 5)
  int op_slot_right_6466 = gc_frame_newslot(strlit6467);
// starting to compile member node (depth = 5)
  int callframe6469 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6470 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6469);
// compiled member node returning call6470 (depth = 5)
  int op_slot_left_6466 = gc_frame_newslot(call6470);
  params[0] = strlit6467;
  partcv[0] = 1;
  Object opresult6471 = callmethod(call6470, "==(1)", 1, partcv, params);
// compiled op node returning opresult6471 (depth = 4)
  Object if6465 = done;
  if (istrue(opresult6471)) {
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6472 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  gc_frame_newslot(*var_node);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_node;
  partcv[0] = 1;
  Object call6473 = callmethodflags(module_parser, "parseExclude(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6472);
// compiled call node returning call6473 (depth = 4)
    gc_frame_newslot(call6473);
    if6465 = call6473;
  } else {
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6474 = alloc_Boolean(0);
// compiled identifier node returning bool6474 (depth = 4)
    gc_frame_newslot(bool6474);
    if6465 = bool6474;
  }
// compiled if node returning if6465 (depth = 3)
    gc_frame_newslot(if6465);
    if6456 = if6465;
  }
// compiled if node returning if6456 (depth = 2)
  gc_frame_end(frame);
  return if6456;
}
Object meth_parser_6475_parseAlias_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 66, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseAlias(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseAlias(_)");
  Object params[4];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parseAlias(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseAlias(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_newMeth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newMeth");
// definebindings:
  Object *var_oldMeth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldMeth");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2227
  setline(2227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6476 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6477 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6476);
// compiled member node returning call6477 (depth = 2)
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6478 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6479 = alloc_Boolean(1);
// compiled identifier node returning bool6479 (depth = 4)
  gc_frame_newslot(bool6479);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = bool6479;
  partcv[0] = 1;
  Object call6480 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6478);
// compiled call node returning call6480 (depth = 3)
  *var_newMeth = call6480;
  if (call6480 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6484 == NULL) {
    strlit6484 = alloc_String("=");
    gc_root(strlit6484);
  }
// compiled string node returning strlit6484 (depth = 5)
  int op_slot_right_6483 = gc_frame_newslot(strlit6484);
// starting to compile member node (depth = 5)
  int callframe6486 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6487 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6486);
// compiled member node returning call6487 (depth = 5)
  int op_slot_left_6483 = gc_frame_newslot(call6487);
  params[0] = strlit6484;
  partcv[0] = 1;
  Object opresult6488 = callmethod(call6487, "==(1)", 1, partcv, params);
// compiled op node returning opresult6488 (depth = 4)
  int op_slot_right_6482 = gc_frame_newslot(opresult6488);
// starting to compile call node (depth = 4)
  int callframe6490 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6491 == NULL) {
    strlit6491 = alloc_String("op");
    gc_root(strlit6491);
  }
// compiled string node returning strlit6491 (depth = 5)
  gc_frame_newslot(strlit6491);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit6491;
  partcv[0] = 1;
  Object call6492 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6490);
// compiled call node returning call6492 (depth = 4)
  int op_slot_left_6482 = gc_frame_newslot(call6492);
  params[0] = opresult6488;
  partcv[0] = 1;
  Object opresult6493 = callmethod(call6492, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6493 (depth = 3)
  Object if6481 = done;
  if (istrue(opresult6493)) {
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6494 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6495 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6494);
// compiled member node returning call6495 (depth = 3)
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6496 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe6497 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool6498 = alloc_Boolean(1);
// compiled identifier node returning bool6498 (depth = 6)
  gc_frame_newslot(bool6498);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = bool6498;
  partcv[0] = 1;
  Object call6499 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6497);
// compiled call node returning call6499 (depth = 5)
  partcv[0] = 0;
  Object call6500 = callmethodflags(call6499, "appliedOccurence", 1, partcv, params, 0);
  gc_frame_end(callframe6496);
// compiled member node returning call6500 (depth = 4)
  *var_oldMeth = call6500;
  if (call6500 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6503 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldMeth (depth = 6)
  partcv[0] = 0;
  Object call6504 = callmethodflags(*var_oldMeth, "numParams", 1, partcv, params, 0);
  gc_frame_end(callframe6503);
// compiled member node returning call6504 (depth = 5)
  int op_slot_right_6502 = gc_frame_newslot(call6504);
// starting to compile member node (depth = 5)
  int callframe6506 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newMeth (depth = 6)
  partcv[0] = 0;
  Object call6507 = callmethodflags(*var_newMeth, "numParams", 1, partcv, params, 0);
  gc_frame_end(callframe6506);
// compiled member node returning call6507 (depth = 5)
  int op_slot_left_6502 = gc_frame_newslot(call6507);
  params[0] = call6504;
  partcv[0] = 1;
  Object opresult6508 = callmethod(call6507, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6508 (depth = 4)
  Object if6501 = done;
  if (istrue(opresult6508)) {
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6509 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6510 == NULL) {
    strlit6510 = alloc_String("a method and its alias must have the same number of parameters");
    gc_root(strlit6510);
  }
// compiled string node returning strlit6510 (depth = 5)
  gc_frame_newslot(strlit6510);
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6511 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newMeth (depth = 6)
  partcv[0] = 0;
  Object call6512 = callmethodflags(*var_newMeth, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6511);
// compiled member node returning call6512 (depth = 5)
  gc_frame_newslot(call6512);
// starting to compile member node (depth = 5)
  int callframe6513 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newMeth (depth = 6)
  partcv[0] = 0;
  Object call6514 = callmethodflags(*var_newMeth, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6513);
// compiled member node returning call6514 (depth = 5)
  gc_frame_newslot(call6514);
// starting to compile member node (depth = 5)
  int callframe6515 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldMeth (depth = 6)
  partcv[0] = 0;
  Object call6516 = callmethodflags(*var_oldMeth, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe6515);
// compiled member node returning call6516 (depth = 5)
  gc_frame_newslot(call6516);
// call case 6: other requests
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit6510;
  params[1] = call6512;
  params[2] = call6514;
  params[3] = call6516;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call6517 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe6509);
// compiled call node returning call6517 (depth = 4)
    gc_frame_newslot(call6517);
    if6501 = call6517;
  } else {
  }
// compiled if node returning if6501 (depth = 3)
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6518 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6519 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newMeth (depth = 5)
  partcv[0] = 0;
  Object call6520 = callmethodflags(*var_newMeth, "asIdentifier", 1, partcv, params, 0);
  gc_frame_end(callframe6519);
// compiled member node returning call6520 (depth = 4)
  gc_frame_newslot(call6520);
// starting to compile member node (depth = 4)
  int callframe6521 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldMeth (depth = 5)
  partcv[0] = 0;
  Object call6522 = callmethodflags(*var_oldMeth, "asIdentifier", 1, partcv, params, 0);
  gc_frame_end(callframe6521);
// compiled member node returning call6522 (depth = 4)
  gc_frame_newslot(call6522);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  params[0] = call6520;
  params[1] = call6522;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6523 = callmethodflags(*var_node, "addAlias(1)for(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6518);
// compiled call node returning call6523 (depth = 3)
    gc_frame_newslot(call6523);
    if6481 = call6523;
  } else {
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6524 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6526 == NULL) {
    strlit6526 = alloc_String("'""\xe2""""\x80""""\xb9""newMethodName""\xe2""""\x80""""\xba"" = ""\xe2""""\x80""""\xb9""oldMethodName""\xe2""""\x80""""\xba""'");
    gc_root(strlit6526);
  }
// compiled string node returning strlit6526 (depth = 5)
  int op_slot_right_6525 = gc_frame_newslot(strlit6526);
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6528 == NULL) {
    strlit6528 = alloc_String("an alias modifier must take the form ");
    gc_root(strlit6528);
  }
// compiled string node returning strlit6528 (depth = 5)
  int op_slot_left_6525 = gc_frame_newslot(strlit6528);
  params[0] = strlit6526;
  partcv[0] = 1;
  Object opresult6529 = callmethod(strlit6528, "++(1)", 1, partcv, params);
// compiled op node returning opresult6529 (depth = 4)
  gc_frame_newslot(opresult6529);
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6530 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call6531 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6530);
// compiled member node returning call6531 (depth = 4)
  gc_frame_newslot(call6531);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6533 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6534 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6533);
// compiled member node returning call6534 (depth = 5)
  int op_slot_right_6532 = gc_frame_newslot(call6534);
// starting to compile member node (depth = 5)
  int callframe6536 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6537 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6536);
// compiled member node returning call6537 (depth = 5)
  int op_slot_left_6532 = gc_frame_newslot(call6537);
  params[0] = call6534;
  partcv[0] = 1;
  Object sum6538 = callmethod(call6537, "+(1)", 1, partcv, params);
// compiled op node returning sum6538 (depth = 4)
  gc_frame_newslot(sum6538);
// call case 6: other requests
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult6529;
  params[1] = call6531;
  params[2] = sum6538;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call6539 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe6524);
// compiled call node returning call6539 (depth = 3)
    gc_frame_newslot(call6539);
    if6481 = call6539;
  }
// compiled if node returning if6481 (depth = 2)
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6540 = alloc_Boolean(1);
// compiled identifier node returning bool6540 (depth = 3)
  return bool6540;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_6541_parseExclude_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parseExclude(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseExclude(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parseExclude(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseExclude(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_excludedMeth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "excludedMeth");
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6542 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6543 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6542);
// compiled member node returning call6543 (depth = 2)
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe6544 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6545 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool6546 = alloc_Boolean(1);
// compiled identifier node returning bool6546 (depth = 5)
  gc_frame_newslot(bool6546);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = bool6546;
  partcv[0] = 1;
  Object call6547 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6545);
// compiled call node returning call6547 (depth = 4)
  partcv[0] = 0;
  Object call6548 = callmethodflags(call6547, "appliedOccurence", 1, partcv, params, 0);
  gc_frame_end(callframe6544);
// compiled member node returning call6548 (depth = 3)
  *var_excludedMeth = call6548;
  if (call6548 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6549 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe6550 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_excludedMeth (depth = 4)
  partcv[0] = 0;
  Object call6551 = callmethodflags(*var_excludedMeth, "asIdentifier", 1, partcv, params, 0);
  gc_frame_end(callframe6550);
// compiled member node returning call6551 (depth = 3)
  gc_frame_newslot(call6551);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = call6551;
  partcv[0] = 1;
  Object call6552 = callmethodflags(*var_node, "addExclusion(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6549);
// compiled call node returning call6552 (depth = 2)
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6553 = alloc_Boolean(1);
// compiled identifier node returning bool6553 (depth = 3)
  return bool6553;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_6554_doobject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 68, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doobject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6556 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6557 == NULL) {
    strlit6557 = alloc_String("object");
    gc_root(strlit6557);
  }
// compiled string node returning strlit6557 (depth = 4)
  gc_frame_newslot(strlit6557);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit6557;
  partcv[0] = 1;
  Object call6558 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6556);
// compiled call node returning call6558 (depth = 3)
  Object if6555 = done;
  if (istrue(call6558)) {
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6559 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6560 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6559);
// compiled member node returning call6560 (depth = 3)
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6561 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6562 == NULL) {
    strlit6562 = alloc_String("an object constructor");
    gc_root(strlit6562);
  }
// compiled string node returning strlit6562 (depth = 4)
  gc_frame_newslot(strlit6562);
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 4)
  if (strlit6563 == NULL) {
    strlit6563 = alloc_String("'object'");
    gc_root(strlit6563);
  }
// compiled string node returning strlit6563 (depth = 4)
  gc_frame_newslot(strlit6563);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit6562;
  params[1] = *var_lastToken;
  params[2] = strlit6563;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6564 = callmethodflags(module_parser, "parseObjectConstructorBody(1)startingWith(1)after(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6561);
// compiled call node returning call6564 (depth = 3)
    gc_frame_newslot(call6564);
    if6555 = call6564;
  } else {
  }
// compiled if node returning if6555 (depth = 2)
  gc_frame_end(frame);
  return if6555;
}
Object meth_parser_6581__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6583 == NULL) {
    strlit6583 = alloc_String("rbrace");
    gc_root(strlit6583);
  }
// compiled string node returning strlit6583 (depth = 7)
  int op_slot_right_6582 = gc_frame_newslot(strlit6583);
// starting to compile member node (depth = 7)
  int callframe6585 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  partcv[0] = 0;
  Object call6586 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe6585);
// compiled member node returning call6586 (depth = 7)
  int op_slot_left_6582 = gc_frame_newslot(call6586);
  params[0] = strlit6583;
  partcv[0] = 1;
  Object opresult6587 = callmethod(call6586, "==(1)", 1, partcv, params);
// compiled op node returning opresult6587 (depth = 6)
  gc_frame_end(frame);
  return opresult6587;
}
Object meth_parser_6661__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6663 == NULL) {
    strlit6663 = alloc_String("eof");
    gc_root(strlit6663);
  }
// compiled string node returning strlit6663 (depth = 7)
  int op_slot_right_6662 = gc_frame_newslot(strlit6663);
// starting to compile member node (depth = 7)
  int callframe6665 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6666 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe6665);
// compiled member node returning call6666 (depth = 7)
  int op_slot_left_6662 = gc_frame_newslot(call6666);
  params[0] = strlit6663;
  partcv[0] = 1;
  Object opresult6667 = callmethod(call6666, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6667 (depth = 6)
  gc_frame_end(frame);
  return opresult6667;
}
Object meth_parser_6658__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block6660 = alloc_Block(NULL, NULL, "parser", 2292);
  gc_frame_newslot(block6660);
// method "_apply"
  block_savedest(block6660);
  Object closure6661 = createclosure(2, "_apply");
  setclosureframe(closure6661, stackframe);
  addtoclosure(closure6661, var_sym);
  addtoclosure(closure6661, selfslot);
  struct UserObject *uo6661 = (struct UserObject*)block6660;
  uo6661->data[0] = (Object)closure6661;
  Method *meth_meth_parser_6661__apply = addmethod2pos(block6660, "_apply", &meth_parser_6661__apply, 0);
  int argcv_meth_parser_6661__apply[] = {0};
  meth_meth_parser_6661__apply->type = alloc_MethodType(1, argcv_meth_parser_6661__apply);
  meth_meth_parser_6661__apply->definitionModule = modulename;
  meth_meth_parser_6661__apply->definitionLine = 183;
// compiled block node returning block6660 (depth = 5)
  int op_slot_right_6659 = gc_frame_newslot(block6660);
// starting to compile member node (depth = 5)
  int callframe6670 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe6671 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6672 == NULL) {
    strlit6672 = alloc_String("rbrace");
    gc_root(strlit6672);
  }
// compiled string node returning strlit6672 (depth = 7)
  gc_frame_newslot(strlit6672);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit6672;
  partcv[0] = 1;
  Object call6673 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6671);
// compiled call node returning call6673 (depth = 6)
  partcv[0] = 0;
  Object call6674 = callmethodflags(call6673, "not", 1, partcv, params, 0);
  gc_frame_end(callframe6670);
// compiled member node returning call6674 (depth = 5)
  int op_slot_left_6659 = gc_frame_newslot(call6674);
  params[0] = block6660;
  partcv[0] = 1;
  Object opresult6675 = callmethod(call6674, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6675 (depth = 4)
  gc_frame_end(frame);
  return opresult6675;
}
Object meth_parser_6684__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 7)
  int callframe6685 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6686 = callmethodflags(self, "inheritOrUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6685);
// compiled member node returning call6686 (depth = 7)
  gc_frame_end(frame);
  return call6686;
}
Object meth_parser_6764__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 8)
  int callframe6765 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6766 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6765);
// compiled member node returning call6766 (depth = 8)
  gc_frame_end(frame);
  return call6766;
}
Object meth_parser_6774__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 9)
  int callframe6775 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6776 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6775);
// compiled member node returning call6776 (depth = 9)
  gc_frame_end(frame);
  return call6776;
}
Object meth_parser_6678__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_inPreamble = getfromclosure(closure, 1);
  Object *var_usedTraits = getfromclosure(closure, 2);
  Object *var_superObject = getfromclosure(closure, 3);
  Object *var_constructName = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_sym = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_parentNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "parentNode");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6679 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6680 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6679);
// compiled member node returning call6680 (depth = 4)
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6682 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6683 = alloc_Block(NULL, NULL, "parser", 2294);
  gc_frame_newslot(block6683);
// method "_apply"
  block_savedest(block6683);
  Object closure6684 = createclosure(1, "_apply");
  setclosureframe(closure6684, stackframe);
  addtoclosure(closure6684, selfslot);
  struct UserObject *uo6684 = (struct UserObject*)block6683;
  uo6684->data[0] = (Object)closure6684;
  Method *meth_meth_parser_6684__apply = addmethod2pos(block6683, "_apply", &meth_parser_6684__apply, 0);
  int argcv_meth_parser_6684__apply[] = {0};
  meth_meth_parser_6684__apply->type = alloc_MethodType(1, argcv_meth_parser_6684__apply);
  meth_meth_parser_6684__apply->definitionModule = modulename;
  meth_meth_parser_6684__apply->definitionLine = 183;
// compiled block node returning block6683 (depth = 6)
  gc_frame_newslot(block6683);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block6683;
  partcv[0] = 1;
  Object call6688 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6682);
// compiled call node returning call6688 (depth = 5)
  Object if6681 = done;
  if (istrue(call6688)) {
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6689 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6690 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe6689);
// compiled member node returning call6690 (depth = 6)
  *var_parentNode = call6690;
  if (call6690 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inPreamble (depth = 6)
  Object if6691 = done;
  if (istrue(*var_inPreamble)) {
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6693 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  partcv[0] = 0;
  Object call6694 = callmethodflags(*var_parentNode, "isUse", 1, partcv, params, 0);
  gc_frame_end(callframe6693);
// compiled member node returning call6694 (depth = 7)
  Object if6692 = done;
  if (istrue(call6694)) {
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6695 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  gc_frame_newslot(*var_parentNode);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_usedTraits (depth = 8)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call6696 = callmethodflags(*var_usedTraits, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6695);
// compiled call node returning call6696 (depth = 7)
    gc_frame_newslot(call6696);
    if6692 = call6696;
  } else {
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe6698 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_usedTraits (depth = 9)
  partcv[0] = 0;
  Object call6699 = callmethodflags(*var_usedTraits, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe6698);
// compiled member node returning call6699 (depth = 8)
  Object if6697 = done;
  if (istrue(call6699)) {
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  *var_superObject = *var_parentNode;
  if (*var_parentNode == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if6697 = done;
  } else {
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6701 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit6704 == NULL) {
    strlit6704 = alloc_String("");
    gc_root(strlit6704);
  }
// compiled string node returning strlit6704 (depth = 11)
  int op_slot_right_6703 = gc_frame_newslot(strlit6704);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_constructName (depth = 12)
  int op_slot_right_6706 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 12)
  if (strlit6708 == NULL) {
    strlit6708 = alloc_String("before 'use' in ");
    gc_root(strlit6708);
  }
// compiled string node returning strlit6708 (depth = 12)
  int op_slot_left_6706 = gc_frame_newslot(strlit6708);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult6709 = callmethod(strlit6708, "++(1)", 1, partcv, params);
// compiled op node returning opresult6709 (depth = 11)
  int op_slot_left_6703 = gc_frame_newslot(opresult6709);
  params[0] = strlit6704;
  partcv[0] = 1;
  Object opresult6710 = callmethod(opresult6709, "++(1)", 1, partcv, params);
// compiled op node returning opresult6710 (depth = 10)
  int op_slot_right_6702 = gc_frame_newslot(opresult6710);
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit6712 == NULL) {
    strlit6712 = alloc_String("'inherit' must come ");
    gc_root(strlit6712);
  }
// compiled string node returning strlit6712 (depth = 10)
  int op_slot_left_6702 = gc_frame_newslot(strlit6712);
  params[0] = opresult6710;
  partcv[0] = 1;
  Object opresult6713 = callmethod(strlit6712, "++(1)", 1, partcv, params);
// compiled op node returning opresult6713 (depth = 9)
  gc_frame_newslot(opresult6713);
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe6714 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  partcv[0] = 0;
  Object call6715 = callmethodflags(*var_parentNode, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6714);
// compiled member node returning call6715 (depth = 9)
  gc_frame_newslot(call6715);
// starting to compile member node (depth = 9)
  int callframe6716 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  partcv[0] = 0;
  Object call6717 = callmethodflags(*var_parentNode, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6716);
// compiled member node returning call6717 (depth = 9)
  gc_frame_newslot(call6717);
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6719 = alloc_Float64(7);
// compiled num node returning num6719 (depth = 10)
  int op_slot_right_6718 = gc_frame_newslot(num6719);
// starting to compile member node (depth = 10)
  int callframe6721 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  partcv[0] = 0;
  Object call6722 = callmethodflags(*var_parentNode, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6721);
// compiled member node returning call6722 (depth = 10)
  int op_slot_left_6718 = gc_frame_newslot(call6722);
  params[0] = num6719;
  partcv[0] = 1;
  Object sum6723 = callmethod(call6722, "+(1)", 1, partcv, params);
// compiled op node returning sum6723 (depth = 9)
  gc_frame_newslot(sum6723);
// call case 6: other requests
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult6713;
  params[1] = call6715;
  params[2] = call6717;
  params[3] = sum6723;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call6724 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe6701);
// compiled call node returning call6724 (depth = 8)
    gc_frame_newslot(call6724);
    if6697 = call6724;
  }
// compiled if node returning if6697 (depth = 7)
    gc_frame_newslot(if6697);
    if6692 = if6697;
  }
// compiled if node returning if6692 (depth = 6)
    gc_frame_newslot(if6692);
    if6691 = if6692;
  } else {
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6725 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6728 == NULL) {
    strlit6728 = alloc_String("");
    gc_root(strlit6728);
  }
// compiled string node returning strlit6728 (depth = 9)
  int op_slot_right_6727 = gc_frame_newslot(strlit6728);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_constructName (depth = 10)
  int op_slot_right_6730 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 10)
  if (strlit6732 == NULL) {
    strlit6732 = alloc_String("come at the start of ");
    gc_root(strlit6732);
  }
// compiled string node returning strlit6732 (depth = 10)
  int op_slot_left_6730 = gc_frame_newslot(strlit6732);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult6733 = callmethod(strlit6732, "++(1)", 1, partcv, params);
// compiled op node returning opresult6733 (depth = 9)
  int op_slot_left_6727 = gc_frame_newslot(opresult6733);
  params[0] = strlit6728;
  partcv[0] = 1;
  Object opresult6734 = callmethod(opresult6733, "++(1)", 1, partcv, params);
// compiled op node returning opresult6734 (depth = 8)
  int op_slot_right_6726 = gc_frame_newslot(opresult6734);
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6737 == NULL) {
    strlit6737 = alloc_String("' must ");
    gc_root(strlit6737);
  }
// compiled string node returning strlit6737 (depth = 9)
  int op_slot_right_6736 = gc_frame_newslot(strlit6737);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe6740 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  partcv[0] = 0;
  Object call6741 = callmethodflags(*var_parentNode, "statementName", 1, partcv, params, 0);
  gc_frame_end(callframe6740);
// compiled member node returning call6741 (depth = 10)
  int op_slot_right_6739 = gc_frame_newslot(call6741);
// starting to compile string node (depth = 10)
  if (strlit6743 == NULL) {
    strlit6743 = alloc_String("'");
    gc_root(strlit6743);
  }
// compiled string node returning strlit6743 (depth = 10)
  int op_slot_left_6739 = gc_frame_newslot(strlit6743);
  params[0] = call6741;
  partcv[0] = 1;
  Object opresult6744 = callmethod(strlit6743, "++(1)", 1, partcv, params);
// compiled op node returning opresult6744 (depth = 9)
  int op_slot_left_6736 = gc_frame_newslot(opresult6744);
  params[0] = strlit6737;
  partcv[0] = 1;
  Object opresult6745 = callmethod(opresult6744, "++(1)", 1, partcv, params);
// compiled op node returning opresult6745 (depth = 8)
  int op_slot_left_6726 = gc_frame_newslot(opresult6745);
  params[0] = opresult6734;
  partcv[0] = 1;
  Object opresult6746 = callmethod(opresult6745, "++(1)", 1, partcv, params);
// compiled op node returning opresult6746 (depth = 7)
  gc_frame_newslot(opresult6746);
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe6747 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  partcv[0] = 0;
  Object call6748 = callmethodflags(*var_parentNode, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6747);
// compiled member node returning call6748 (depth = 7)
  gc_frame_newslot(call6748);
// starting to compile member node (depth = 7)
  int callframe6749 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  partcv[0] = 0;
  Object call6750 = callmethodflags(*var_parentNode, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6749);
// compiled member node returning call6750 (depth = 7)
  gc_frame_newslot(call6750);
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6752 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe6753 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  partcv[0] = 0;
  Object call6754 = callmethodflags(*var_parentNode, "statementName", 1, partcv, params, 0);
  gc_frame_end(callframe6753);
// compiled member node returning call6754 (depth = 9)
  partcv[0] = 0;
  Object call6755 = callmethodflags(call6754, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6752);
// compiled member node returning call6755 (depth = 8)
  int op_slot_right_6751 = gc_frame_newslot(call6755);
// starting to compile member node (depth = 8)
  int callframe6757 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call6758 = callmethodflags(*var_parentNode, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6757);
// compiled member node returning call6758 (depth = 8)
  int op_slot_left_6751 = gc_frame_newslot(call6758);
  params[0] = call6755;
  partcv[0] = 1;
  Object sum6759 = callmethod(call6758, "+(1)", 1, partcv, params);
// compiled op node returning sum6759 (depth = 7)
  gc_frame_newslot(sum6759);
// call case 6: other requests
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult6746;
  params[1] = call6748;
  params[2] = call6750;
  params[3] = sum6759;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call6760 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe6725);
// compiled call node returning call6760 (depth = 6)
    gc_frame_newslot(call6760);
    if6691 = call6760;
  }
// compiled if node returning if6691 (depth = 5)
    gc_frame_newslot(if6691);
    if6681 = if6691;
  } else {
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6762 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block6763 = alloc_Block(NULL, NULL, "parser", 2313);
  gc_frame_newslot(block6763);
// method "_apply"
  block_savedest(block6763);
  Object closure6764 = createclosure(1, "_apply");
  setclosureframe(closure6764, stackframe);
  addtoclosure(closure6764, selfslot);
  struct UserObject *uo6764 = (struct UserObject*)block6763;
  uo6764->data[0] = (Object)closure6764;
  Method *meth_meth_parser_6764__apply = addmethod2pos(block6763, "_apply", &meth_parser_6764__apply, 0);
  int argcv_meth_parser_6764__apply[] = {0};
  meth_meth_parser_6764__apply->type = alloc_MethodType(1, argcv_meth_parser_6764__apply);
  meth_meth_parser_6764__apply->definitionModule = modulename;
  meth_meth_parser_6764__apply->definitionLine = 183;
// compiled block node returning block6763 (depth = 7)
  gc_frame_newslot(block6763);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block6763;
  partcv[0] = 1;
  Object call6768 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6762);
// compiled call node returning call6768 (depth = 6)
  Object if6761 = done;
  if (istrue(call6768)) {
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool6769 = alloc_Boolean(0);
// compiled identifier node returning bool6769 (depth = 7)
  *var_inPreamble = bool6769;
  if (bool6769 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6761 = done;
  } else {
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6772 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block6773 = alloc_Block(NULL, NULL, "parser", 2315);
  gc_frame_newslot(block6773);
// method "_apply"
  block_savedest(block6773);
  Object closure6774 = createclosure(1, "_apply");
  setclosureframe(closure6774, stackframe);
  addtoclosure(closure6774, selfslot);
  struct UserObject *uo6774 = (struct UserObject*)block6773;
  uo6774->data[0] = (Object)closure6774;
  Method *meth_meth_parser_6774__apply = addmethod2pos(block6773, "_apply", &meth_parser_6774__apply, 0);
  int argcv_meth_parser_6774__apply[] = {0};
  meth_meth_parser_6774__apply->type = alloc_MethodType(1, argcv_meth_parser_6774__apply);
  meth_meth_parser_6774__apply->definitionModule = modulename;
  meth_meth_parser_6774__apply->definitionLine = 183;
// compiled block node returning block6773 (depth = 8)
  gc_frame_newslot(block6773);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = block6773;
  partcv[0] = 1;
  Object call6778 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6772);
// compiled call node returning call6778 (depth = 7)
  Object if6771 = done;
  if (istrue(call6778)) {
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool6779 = alloc_Boolean(0);
// compiled identifier node returning bool6779 (depth = 8)
  *var_inPreamble = bool6779;
  if (bool6779 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if6771 = done;
  } else {
// Begin line 2318
  setline(2318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6781 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6784 == NULL) {
    strlit6784 = alloc_String("");
    gc_root(strlit6784);
  }
// compiled string node returning strlit6784 (depth = 10)
  int op_slot_right_6783 = gc_frame_newslot(strlit6784);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_constructName (depth = 11)
  int op_slot_right_6786 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 11)
  if (strlit6788 == NULL) {
    strlit6788 = alloc_String("of of ");
    gc_root(strlit6788);
  }
// compiled string node returning strlit6788 (depth = 11)
  int op_slot_left_6786 = gc_frame_newslot(strlit6788);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult6789 = callmethod(strlit6788, "++(1)", 1, partcv, params);
// compiled op node returning opresult6789 (depth = 10)
  int op_slot_left_6783 = gc_frame_newslot(opresult6789);
  params[0] = strlit6784;
  partcv[0] = 1;
  Object opresult6790 = callmethod(opresult6789, "++(1)", 1, partcv, params);
// compiled op node returning opresult6790 (depth = 9)
  int op_slot_right_6782 = gc_frame_newslot(opresult6790);
// Begin line 2318
  setline(2318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6793 == NULL) {
    strlit6793 = alloc_String("' in body ");
    gc_root(strlit6793);
  }
// compiled string node returning strlit6793 (depth = 10)
  int op_slot_right_6792 = gc_frame_newslot(strlit6793);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe6796 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6797 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6796);
// compiled member node returning call6797 (depth = 11)
  int op_slot_right_6795 = gc_frame_newslot(call6797);
// starting to compile string node (depth = 11)
  if (strlit6799 == NULL) {
    strlit6799 = alloc_String("unexpected symbol '");
    gc_root(strlit6799);
  }
// compiled string node returning strlit6799 (depth = 11)
  int op_slot_left_6795 = gc_frame_newslot(strlit6799);
  params[0] = call6797;
  partcv[0] = 1;
  Object opresult6800 = callmethod(strlit6799, "++(1)", 1, partcv, params);
// compiled op node returning opresult6800 (depth = 10)
  int op_slot_left_6792 = gc_frame_newslot(opresult6800);
  params[0] = strlit6793;
  partcv[0] = 1;
  Object opresult6801 = callmethod(opresult6800, "++(1)", 1, partcv, params);
// compiled op node returning opresult6801 (depth = 9)
  int op_slot_left_6782 = gc_frame_newslot(opresult6801);
  params[0] = opresult6790;
  partcv[0] = 1;
  Object opresult6802 = callmethod(opresult6801, "++(1)", 1, partcv, params);
// compiled op node returning opresult6802 (depth = 8)
  gc_frame_newslot(opresult6802);
// Begin line 2320
  setline(2320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe6803 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6804 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6803);
// compiled member node returning call6804 (depth = 8)
  gc_frame_newslot(call6804);
// starting to compile member node (depth = 8)
  int callframe6805 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6806 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6805);
// compiled member node returning call6806 (depth = 8)
  gc_frame_newslot(call6806);
// starting to compile member node (depth = 8)
  int callframe6807 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6808 = callmethodflags(*var_sym, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe6807);
// compiled member node returning call6808 (depth = 8)
  gc_frame_newslot(call6808);
// call case 6: other requests
// Begin line 2318
  setline(2318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult6802;
  params[1] = call6804;
  params[2] = call6806;
  params[3] = call6808;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call6809 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe6781);
// compiled call node returning call6809 (depth = 7)
    gc_frame_newslot(call6809);
    if6771 = call6809;
  }
// compiled if node returning if6771 (depth = 6)
    gc_frame_newslot(if6771);
    if6761 = if6771;
  }
// compiled if node returning if6761 (depth = 5)
    gc_frame_newslot(if6761);
    if6681 = if6761;
  }
// compiled if node returning if6681 (depth = 4)
  gc_frame_end(frame);
  return if6681;
}
Object meth_parser_6565_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 69, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseObjectConstructorBody(1)startingWith(1)after(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody(_)startingWith(_)after(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody(_)startingWith(_)after(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody(_)startingWith(_)after(_)");
  Object params[4];
  int partcv[3];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_statementToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for parseObjectConstructorBody(_)startingWith(_)after(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_constructName = &(stackframe->slots[0]);
  *var_constructName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseObjectConstructorBody(_)");
  Object *var_btok = &(stackframe->slots[1]);
  *var_btok = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *var_prev = &(stackframe->slots[2]);
  *var_prev = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part after(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_localMinIndentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "localMinIndentLevel");
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestion");
  Object *var_nextTok = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_originalValues = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "originalValues");
  Object *var_superObject = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "superObject");
  Object *var_usedTraits = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "usedTraits");
  Object *var_inPreamble = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "inPreamble");
  Object *var_body = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "body");
  Object *var_objNode = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "objNode");
// definebindings:
// definebindings:
// Begin line 2267
  setline(2267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe6566 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6567 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6566);
// compiled member node returning call6567 (depth = 3)
  *var_anns = call6567;
  if (call6567 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6570 == NULL) {
    strlit6570 = alloc_String("lbrace");
    gc_root(strlit6570);
  }
// compiled string node returning strlit6570 (depth = 4)
  int op_slot_right_6569 = gc_frame_newslot(strlit6570);
// starting to compile member node (depth = 4)
  int callframe6572 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call6573 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe6572);
// compiled member node returning call6573 (depth = 4)
  int op_slot_left_6569 = gc_frame_newslot(call6573);
  params[0] = strlit6570;
  partcv[0] = 1;
  Object opresult6574 = callmethod(call6573, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6574 (depth = 3)
  Object if6568 = done;
  if (istrue(opresult6574)) {
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6575 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6576 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call6577 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6576);
// compiled member node returning call6577 (depth = 5)
  partcv[0] = 0;
  Object call6578 = callmethodflags(call6577, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6575);
// compiled member node returning call6578 (depth = 4)
  *var_suggestion = call6578;
  if (call6578 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6579 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6580 = alloc_Block(NULL, NULL, "parser", 2271);
  gc_frame_newslot(block6580);
// method "_apply(_)"
  block_savedest(block6580);
  Object closure6581 = createclosure(1, "_apply(1)");
  setclosureframe(closure6581, stackframe);
  addtoclosure(closure6581, selfslot);
  struct UserObject *uo6581 = (struct UserObject*)block6580;
  uo6581->data[0] = (Object)closure6581;
  Method *meth_meth_parser_6581__apply_40_1_41_ = addmethod2pos(block6580, "_apply(1)", &meth_parser_6581__apply_40_1_41_, 0);
  int argcv_meth_parser_6581__apply_40_1_41_[] = {1};
  meth_meth_parser_6581__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_6581__apply_40_1_41_);
  meth_meth_parser_6581__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_6581__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block6580 (depth = 5)
  gc_frame_newslot(block6580);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block6580;
  partcv[0] = 1;
  Object call6589 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6579);
// compiled call node returning call6589 (depth = 4)
  *var_nextTok = call6589;
  if (call6589 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_right_6591 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 5)
  Object bool6593 = alloc_Boolean(0);
// compiled identifier node returning bool6593 (depth = 5)
  int op_slot_left_6591 = gc_frame_newslot(bool6593);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult6594 = callmethod(bool6593, "==(1)", 1, partcv, params);
// compiled op node returning opresult6594 (depth = 4)
  Object if6590 = done;
  if (istrue(opresult6594)) {
// Begin line 2273
  setline(2273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6595 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6596 == NULL) {
    strlit6596 = alloc_String(" {}");
    gc_root(strlit6596);
  }
// compiled string node returning strlit6596 (depth = 5)
  gc_frame_newslot(strlit6596);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit6596;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6597 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6595);
// compiled call node returning call6597 (depth = 4)
    gc_frame_newslot(call6597);
    if6590 = call6597;
  } else {
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6598 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6599 == NULL) {
    strlit6599 = alloc_String(" {");
    gc_root(strlit6599);
  }
// compiled string node returning strlit6599 (depth = 5)
  gc_frame_newslot(strlit6599);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit6599;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6600 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6598);
// compiled call node returning call6600 (depth = 4)
    gc_frame_newslot(call6600);
    if6590 = call6600;
  }
// compiled if node returning if6590 (depth = 3)
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6601 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6603 == NULL) {
    strlit6603 = alloc_String(".");
    gc_root(strlit6603);
  }
// compiled string node returning strlit6603 (depth = 5)
  int op_slot_right_6602 = gc_frame_newslot(strlit6603);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_prev (depth = 6)
  int op_slot_right_6605 = gc_frame_newslot(*var_prev);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6608 == NULL) {
    strlit6608 = alloc_String(" must have a '{' after the ");
    gc_root(strlit6608);
  }
// compiled string node returning strlit6608 (depth = 7)
  int op_slot_right_6607 = gc_frame_newslot(strlit6608);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_constructName (depth = 8)
  int op_slot_right_6610 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 8)
  if (strlit6612 == NULL) {
    strlit6612 = alloc_String("");
    gc_root(strlit6612);
  }
// compiled string node returning strlit6612 (depth = 8)
  int op_slot_left_6610 = gc_frame_newslot(strlit6612);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult6613 = callmethod(strlit6612, "++(1)", 1, partcv, params);
// compiled op node returning opresult6613 (depth = 7)
  int op_slot_left_6607 = gc_frame_newslot(opresult6613);
  params[0] = strlit6608;
  partcv[0] = 1;
  Object opresult6614 = callmethod(opresult6613, "++(1)", 1, partcv, params);
// compiled op node returning opresult6614 (depth = 6)
  int op_slot_left_6605 = gc_frame_newslot(opresult6614);
  params[0] = *var_prev;
  partcv[0] = 1;
  Object opresult6615 = callmethod(opresult6614, "++(1)", 1, partcv, params);
// compiled op node returning opresult6615 (depth = 5)
  int op_slot_left_6602 = gc_frame_newslot(opresult6615);
  params[0] = strlit6603;
  partcv[0] = 1;
  Object opresult6616 = callmethod(opresult6615, "++(1)", 1, partcv, params);
// compiled op node returning opresult6616 (depth = 4)
  gc_frame_newslot(opresult6616);
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6617 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call6618 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6617);
// compiled member node returning call6618 (depth = 4)
  gc_frame_newslot(call6618);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6620 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6621 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6620);
// compiled member node returning call6621 (depth = 5)
  int op_slot_right_6619 = gc_frame_newslot(call6621);
// starting to compile member node (depth = 5)
  int callframe6623 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6624 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6623);
// compiled member node returning call6624 (depth = 5)
  int op_slot_left_6619 = gc_frame_newslot(call6624);
  params[0] = call6621;
  partcv[0] = 1;
  Object sum6625 = callmethod(call6624, "+(1)", 1, partcv, params);
// compiled op node returning sum6625 (depth = 4)
  gc_frame_newslot(sum6625);
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult6616;
  params[1] = call6618;
  params[2] = sum6625;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6626 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6601);
// compiled call node returning call6626 (depth = 3)
    gc_frame_newslot(call6626);
    if6568 = call6626;
  } else {
  }
// compiled if node returning if6568 (depth = 2)
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6627 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6628 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6627);
// compiled member node returning call6628 (depth = 2)
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6631 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementToken (depth = 5)
  partcv[0] = 0;
  Object call6632 = callmethodflags(*var_statementToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6631);
// compiled member node returning call6632 (depth = 4)
  int op_slot_right_6630 = gc_frame_newslot(call6632);
// starting to compile member node (depth = 4)
  int callframe6634 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call6635 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6634);
// compiled member node returning call6635 (depth = 4)
  int op_slot_left_6630 = gc_frame_newslot(call6635);
  params[0] = call6632;
  partcv[0] = 1;
  Object opresult6636 = callmethod(call6635, "==(1)", 1, partcv, params);
// compiled op node returning opresult6636 (depth = 3)
  Object if6629 = done;
  if (istrue(opresult6636)) {
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6638 = alloc_Float64(2);
// compiled num node returning num6638 (depth = 5)
  int op_slot_right_6637 = gc_frame_newslot(num6638);
// starting to compile member node (depth = 5)
  int callframe6640 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6641 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6640);
// compiled member node returning call6641 (depth = 5)
  int op_slot_left_6637 = gc_frame_newslot(call6641);
  params[0] = num6638;
  partcv[0] = 1;
  Object diff6642 = callmethod(call6641, "-(1)", 1, partcv, params);
// compiled op node returning diff6642 (depth = 4)
  *var_minIndentLevel = diff6642;
  if (diff6642 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if6629 = done;
  } else {
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6645 = alloc_Float64(2);
// compiled num node returning num6645 (depth = 5)
  int op_slot_right_6644 = gc_frame_newslot(num6645);
// starting to compile member node (depth = 5)
  int callframe6647 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  partcv[0] = 0;
  Object call6648 = callmethodflags(*var_statementToken, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe6647);
// compiled member node returning call6648 (depth = 5)
  int op_slot_left_6644 = gc_frame_newslot(call6648);
  params[0] = num6645;
  partcv[0] = 1;
  Object sum6649 = callmethod(call6648, "+(1)", 1, partcv, params);
// compiled op node returning sum6649 (depth = 4)
  *var_minIndentLevel = sum6649;
  if (sum6649 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if6629 = done;
  }
// compiled if node returning if6629 (depth = 2)
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  *var_originalValues = *var_values;
  if (*var_values == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile array node (depth = 3)
  Object array6651 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6651 (depth = 3)
  *var_values = array6651;
  if (array6651 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6653 = alloc_Boolean(0);
// compiled identifier node returning bool6653 (depth = 3)
  *var_superObject = bool6653;
  if (bool6653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2290
  setline(2290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array6654 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6654 (depth = 3)
  *var_usedTraits = array6654;
  if (array6654 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6655 = alloc_Boolean(1);
// compiled identifier node returning bool6655 (depth = 3)
  *var_inPreamble = bool6655;
  if (bool6655 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2292
  setline(2292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6656 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6657 = alloc_Block(NULL, NULL, "parser", 2292);
  gc_frame_newslot(block6657);
// method "_apply"
  block_savedest(block6657);
  Object closure6658 = createclosure(2, "_apply");
  setclosureframe(closure6658, stackframe);
  addtoclosure(closure6658, var_sym);
  addtoclosure(closure6658, selfslot);
  struct UserObject *uo6658 = (struct UserObject*)block6657;
  uo6658->data[0] = (Object)closure6658;
  Method *meth_meth_parser_6658__apply = addmethod2pos(block6657, "_apply", &meth_parser_6658__apply, 0);
  int argcv_meth_parser_6658__apply[] = {0};
  meth_meth_parser_6658__apply->type = alloc_MethodType(1, argcv_meth_parser_6658__apply);
  meth_meth_parser_6658__apply->definitionModule = modulename;
  meth_meth_parser_6658__apply->definitionLine = 183;
// compiled block node returning block6657 (depth = 3)
  gc_frame_newslot(block6657);
// Begin line 2292
  setline(2292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block6677 = alloc_Block(NULL, NULL, "parser", 2292);
  gc_frame_newslot(block6677);
// method "_apply"
  block_savedest(block6677);
  Object closure6678 = createclosure(8, "_apply");
  setclosureframe(closure6678, stackframe);
  addtoclosure(closure6678, var_values);
  addtoclosure(closure6678, var_inPreamble);
  addtoclosure(closure6678, var_usedTraits);
  addtoclosure(closure6678, var_superObject);
  addtoclosure(closure6678, var_constructName);
  addtoclosure(closure6678, var_errormessages);
  addtoclosure(closure6678, var_sym);
  addtoclosure(closure6678, selfslot);
  struct UserObject *uo6678 = (struct UserObject*)block6677;
  uo6678->data[0] = (Object)closure6678;
  Method *meth_meth_parser_6678__apply = addmethod2pos(block6677, "_apply", &meth_parser_6678__apply, 0);
  int argcv_meth_parser_6678__apply[] = {0};
  meth_meth_parser_6678__apply->type = alloc_MethodType(1, argcv_meth_parser_6678__apply);
  meth_meth_parser_6678__apply->definitionModule = modulename;
  meth_meth_parser_6678__apply->definitionLine = 183;
// compiled block node returning block6677 (depth = 3)
  gc_frame_newslot(block6677);
// call case 5: prelude request
  params[0] = block6657;
  params[1] = block6677;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6811 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6656);
// compiled call node returning call6811 (depth = 2)
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  *var_body = *var_values;
  if (*var_values == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2324
  setline(2324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_originalValues (depth = 3)
  *var_values = *var_originalValues;
  if (*var_originalValues == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6813 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6814 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6813);
// compiled member node returning call6814 (depth = 2)
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6815 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6816 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_superObject (depth = 5)
  gc_frame_newslot(*var_superObject);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6817 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call6818 = callmethodflags(*var_ast, "objectNode", 1, partcv, params, 0);
  gc_frame_end(callframe6817);
// compiled member node returning call6818 (depth = 5)
  params[0] = *var_body;
  params[1] = *var_superObject;
  partcv[0] = 2;
  Object call6819 = callmethodflags(call6818, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6816);
// compiled call node returning call6819 (depth = 4)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call6820 = callmethodflags(call6819, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6815);
// compiled call node returning call6820 (depth = 3)
  *var_objNode = call6820;
  if (call6820 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_anns (depth = 4)
  int op_slot_right_6822 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 4)
  Object bool6824 = alloc_Boolean(0);
// compiled identifier node returning bool6824 (depth = 4)
  int op_slot_left_6822 = gc_frame_newslot(bool6824);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult6825 = callmethod(bool6824, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6825 (depth = 3)
  Object if6821 = done;
  if (istrue(opresult6825)) {
// starting to compile call node (depth = 3)
  int callframe6826 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_anns (depth = 4)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6827 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  partcv[0] = 0;
  Object call6828 = callmethodflags(*var_objNode, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe6827);
// compiled member node returning call6828 (depth = 4)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call6829 = callmethodflags(call6828, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6826);
// compiled call node returning call6829 (depth = 3)
    gc_frame_newslot(call6829);
    if6821 = call6829;
  } else {
  }
// compiled if node returning if6821 (depth = 2)
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6830 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_usedTraits (depth = 3)
  gc_frame_newslot(*var_usedTraits);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  params[0] = *var_usedTraits;
  partcv[0] = 1;
  Object call6831 = callmethodflags(*var_objNode, "usedTraits:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6830);
// compiled call node returning call6831 (depth = 2)
// Begin line 2329
  setline(2329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6832 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  gc_frame_newslot(*var_objNode);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_objNode;
  partcv[0] = 1;
  Object call6833 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6832);
// compiled call node returning call6833 (depth = 2)
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localMinIndentLevel (depth = 3)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_6835_doclass(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 70, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doclass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_meth = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "meth");
  Object *var_objNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "objNode");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6836 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6837 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6836);
// compiled member node returning call6837 (depth = 2)
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6840 == NULL) {
    strlit6840 = alloc_String("identifier");
    gc_root(strlit6840);
  }
// compiled string node returning strlit6840 (depth = 4)
  int op_slot_right_6839 = gc_frame_newslot(strlit6840);
// starting to compile member node (depth = 4)
  int callframe6842 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call6843 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe6842);
// compiled member node returning call6843 (depth = 4)
  int op_slot_left_6839 = gc_frame_newslot(call6843);
  params[0] = strlit6840;
  partcv[0] = 1;
  Object opresult6844 = callmethod(call6843, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6844 (depth = 3)
  Object if6838 = done;
  if (istrue(opresult6844)) {
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array6845 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6845 (depth = 4)
  *var_suggestions = array6845;
  if (array6845 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6848 == NULL) {
    strlit6848 = alloc_String("lbrace");
    gc_root(strlit6848);
  }
// compiled string node returning strlit6848 (depth = 5)
  int op_slot_right_6847 = gc_frame_newslot(strlit6848);
// starting to compile member node (depth = 5)
  int callframe6850 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6851 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe6850);
// compiled member node returning call6851 (depth = 5)
  int op_slot_left_6847 = gc_frame_newslot(call6851);
  params[0] = strlit6848;
  partcv[0] = 1;
  Object opresult6852 = callmethod(call6851, "==(1)", 1, partcv, params);
// compiled op node returning opresult6852 (depth = 4)
  Object if6846 = done;
  if (istrue(opresult6852)) {
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6853 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6854 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call6855 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6854);
// compiled member node returning call6855 (depth = 6)
  partcv[0] = 0;
  Object call6856 = callmethodflags(call6855, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6853);
// compiled member node returning call6856 (depth = 5)
  *var_suggestion = call6856;
  if (call6856 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6857 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6858 == NULL) {
    strlit6858 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new");
    gc_root(strlit6858);
  }
// compiled string node returning strlit6858 (depth = 5)
  gc_frame_newslot(strlit6858);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit6858;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6859 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6857);
// compiled call node returning call6859 (depth = 4)
// Begin line 2377
  setline(2377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6860 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6861 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6860);
// compiled call node returning call6861 (depth = 4)
// Begin line 2378
  setline(2378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6862 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6863 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call6864 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6863);
// compiled member node returning call6864 (depth = 6)
  partcv[0] = 0;
  Object call6865 = callmethodflags(call6864, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6862);
// compiled member node returning call6865 (depth = 5)
  *var_suggestion = call6865;
  if (call6865 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6867 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 5)
  if (strlit6868 == NULL) {
    strlit6868 = alloc_String("object");
    gc_root(strlit6868);
  }
// compiled string node returning strlit6868 (depth = 5)
  gc_frame_newslot(strlit6868);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = strlit6868;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6869 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6867);
// compiled call node returning call6869 (depth = 4)
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6870 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6871 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6870);
// compiled call node returning call6871 (depth = 4)
    gc_frame_newslot(call6871);
    if6846 = call6871;
  } else {
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6872 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6873 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call6874 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe6873);
// compiled member node returning call6874 (depth = 6)
  partcv[0] = 0;
  Object call6875 = callmethodflags(call6874, "new", 1, partcv, params, 0);
  gc_frame_end(callframe6872);
// compiled member node returning call6875 (depth = 5)
  *var_suggestion = call6875;
  if (call6875 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6876 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6877 == NULL) {
    strlit6877 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new {}");
    gc_root(strlit6877);
  }
// compiled string node returning strlit6877 (depth = 5)
  gc_frame_newslot(strlit6877);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit6877;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6878 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6876);
// compiled call node returning call6878 (depth = 4)
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6879 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6880 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6879);
// compiled call node returning call6880 (depth = 4)
    gc_frame_newslot(call6880);
    if6846 = call6880;
  }
// compiled if node returning if6846 (depth = 3)
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6881 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6882 == NULL) {
    strlit6882 = alloc_String("a class must have a name after the keyword 'class'.");
    gc_root(strlit6882);
  }
// compiled string node returning strlit6882 (depth = 4)
  gc_frame_newslot(strlit6882);
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6883 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call6884 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6883);
// compiled member node returning call6884 (depth = 4)
  gc_frame_newslot(call6884);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6886 = alloc_Float64(1);
// compiled num node returning num6886 (depth = 5)
  int op_slot_right_6885 = gc_frame_newslot(num6886);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6889 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6890 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe6889);
// compiled member node returning call6890 (depth = 6)
  int op_slot_right_6888 = gc_frame_newslot(call6890);
// starting to compile member node (depth = 6)
  int callframe6892 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6893 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6892);
// compiled member node returning call6893 (depth = 6)
  int op_slot_left_6888 = gc_frame_newslot(call6893);
  params[0] = call6890;
  partcv[0] = 1;
  Object sum6894 = callmethod(call6893, "+(1)", 1, partcv, params);
// compiled op node returning sum6894 (depth = 5)
  int op_slot_left_6885 = gc_frame_newslot(sum6894);
  params[0] = num6886;
  partcv[0] = 1;
  Object sum6895 = callmethod(sum6894, "+(1)", 1, partcv, params);
// compiled op node returning sum6895 (depth = 4)
  gc_frame_newslot(sum6895);
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit6882;
  params[1] = call6884;
  params[2] = sum6895;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6896 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6881);
// compiled call node returning call6896 (depth = 3)
    gc_frame_newslot(call6896);
    if6838 = call6896;
  } else {
  }
// compiled if node returning if6838 (depth = 2)
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6899 == NULL) {
    strlit6899 = alloc_String("dot");
    gc_root(strlit6899);
  }
// compiled string node returning strlit6899 (depth = 4)
  int op_slot_right_6898 = gc_frame_newslot(strlit6899);
// starting to compile member node (depth = 4)
  int callframe6901 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6902 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call6903 = callmethodflags(*var_tokens, "first", 1, partcv, params, 0);
  gc_frame_end(callframe6902);
// compiled member node returning call6903 (depth = 5)
  partcv[0] = 0;
  Object call6904 = callmethodflags(call6903, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe6901);
// compiled member node returning call6904 (depth = 4)
  int op_slot_left_6898 = gc_frame_newslot(call6904);
  params[0] = strlit6899;
  partcv[0] = 1;
  Object opresult6905 = callmethod(call6904, "==(1)", 1, partcv, params);
// compiled op node returning opresult6905 (depth = 3)
  Object if6897 = done;
  if (istrue(opresult6905)) {
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6906 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6908 == NULL) {
    strlit6908 = alloc_String("Consider using a class, or a class inside an object constructor.");
    gc_root(strlit6908);
  }
// compiled string node returning strlit6908 (depth = 5)
  int op_slot_right_6907 = gc_frame_newslot(strlit6908);
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6910 == NULL) {
    strlit6910 = alloc_String("dotted classes are no longer supported. ");
    gc_root(strlit6910);
  }
// compiled string node returning strlit6910 (depth = 5)
  int op_slot_left_6907 = gc_frame_newslot(strlit6910);
  params[0] = strlit6908;
  partcv[0] = 1;
  Object opresult6911 = callmethod(strlit6910, "++(1)", 1, partcv, params);
// compiled op node returning opresult6911 (depth = 4)
  gc_frame_newslot(opresult6911);
// Begin line 2393
  setline(2393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6912 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6913 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call6914 = callmethodflags(*var_tokens, "first", 1, partcv, params, 0);
  gc_frame_end(callframe6913);
// compiled member node returning call6914 (depth = 5)
  partcv[0] = 0;
  Object call6915 = callmethodflags(call6914, "line", 1, partcv, params, 0);
  gc_frame_end(callframe6912);
// compiled member node returning call6915 (depth = 4)
  gc_frame_newslot(call6915);
// starting to compile member node (depth = 4)
  int callframe6916 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6917 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call6918 = callmethodflags(*var_tokens, "first", 1, partcv, params, 0);
  gc_frame_end(callframe6917);
// compiled member node returning call6918 (depth = 5)
  partcv[0] = 0;
  Object call6919 = callmethodflags(call6918, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe6916);
// compiled member node returning call6919 (depth = 4)
  gc_frame_newslot(call6919);
// call case 6: other requests
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult6911;
  params[1] = call6915;
  params[2] = call6919;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call6920 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe6906);
// compiled call node returning call6920 (depth = 3)
    gc_frame_newslot(call6920);
    if6897 = call6920;
  } else {
  }
// compiled if node returning if6897 (depth = 2)
// Begin line 2395
  setline(2395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6921 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6922 = alloc_Boolean(0);
// compiled identifier node returning bool6922 (depth = 4)
  gc_frame_newslot(bool6922);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = bool6922;
  partcv[0] = 1;
  Object call6923 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6921);
// compiled call node returning call6923 (depth = 3)
  *var_meth = call6923;
  if (call6923 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6924 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_btok (depth = 3)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call6925 = callmethodflags(*var_meth, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6924);
// compiled call node returning call6925 (depth = 2)
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6926 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit6927 == NULL) {
    strlit6927 = alloc_String("a class");
    gc_root(strlit6927);
  }
// compiled string node returning strlit6927 (depth = 3)
  gc_frame_newslot(strlit6927);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_btok (depth = 3)
  gc_frame_newslot(*var_btok);
// starting to compile string node (depth = 3)
  if (strlit6928 == NULL) {
    strlit6928 = alloc_String("method header");
    gc_root(strlit6928);
  }
// compiled string node returning strlit6928 (depth = 3)
  gc_frame_newslot(strlit6928);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning module_parser (depth = 3)
  params[0] = strlit6927;
  params[1] = *var_btok;
  params[2] = strlit6928;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6929 = callmethodflags(module_parser, "parseObjectConstructorBody(1)startingWith(1)after(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6926);
// compiled call node returning call6929 (depth = 2)
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe6930 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  partcv[0] = 0;
  Object call6931 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe6930);
// compiled member node returning call6931 (depth = 3)
  *var_objNode = call6931;
  if (call6931 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2399
  setline(2399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6932 = gc_frame_new();
// starting to compile array node (depth = 3)
  Object array6933 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = *var_objNode;
  partcv[0] = 1;
  callmethodflags(array6933, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6933 (depth = 3)
  gc_frame_newslot(array6933);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = array6933;
  partcv[0] = 1;
  Object call6934 = callmethodflags(*var_meth, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6932);
// compiled call node returning call6934 (depth = 2)
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6935 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool6936 = alloc_Boolean(1);
// compiled identifier node returning bool6936 (depth = 3)
  gc_frame_newslot(bool6936);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = bool6936;
  partcv[0] = 1;
  Object call6937 = callmethodflags(*var_meth, "usesClassSyntax:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6935);
// compiled call node returning call6937 (depth = 2)
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6938 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe6939 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  partcv[0] = 0;
  Object call6940 = callmethodflags(*var_objNode, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe6939);
// compiled member node returning call6940 (depth = 3)
  gc_frame_newslot(call6940);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe6941 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  partcv[0] = 0;
  Object call6942 = callmethodflags(*var_meth, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe6941);
// compiled member node returning call6942 (depth = 3)
  params[0] = call6940;
  partcv[0] = 1;
  Object call6943 = callmethodflags(call6942, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6938);
// compiled call node returning call6943 (depth = 2)
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6944 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe6945 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  partcv[0] = 0;
  Object call6946 = callmethodflags(*var_meth, "canonicalName", 1, partcv, params, 0);
  gc_frame_end(callframe6945);
// compiled member node returning call6946 (depth = 3)
  gc_frame_newslot(call6946);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  params[0] = call6946;
  partcv[0] = 1;
  Object call6947 = callmethodflags(*var_objNode, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6944);
// compiled call node returning call6947 (depth = 2)
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6950 == NULL) {
    strlit6950 = alloc_String("class");
    gc_root(strlit6950);
  }
// compiled string node returning strlit6950 (depth = 4)
  int op_slot_right_6949 = gc_frame_newslot(strlit6950);
// starting to compile member node (depth = 4)
  int callframe6952 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call6953 = callmethodflags(*var_btok, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6952);
// compiled member node returning call6953 (depth = 4)
  int op_slot_left_6949 = gc_frame_newslot(call6953);
  params[0] = strlit6950;
  partcv[0] = 1;
  Object opresult6954 = callmethod(call6953, "==(1)", 1, partcv, params);
// compiled op node returning opresult6954 (depth = 3)
  Object if6948 = done;
  if (istrue(opresult6954)) {
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6955 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6956 = alloc_Boolean(1);
// compiled identifier node returning bool6956 (depth = 4)
  gc_frame_newslot(bool6956);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = bool6956;
  partcv[0] = 1;
  Object call6957 = callmethodflags(*var_objNode, "inClass:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6955);
// compiled call node returning call6957 (depth = 3)
    gc_frame_newslot(call6957);
    if6948 = call6957;
  } else {
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6960 == NULL) {
    strlit6960 = alloc_String("trait");
    gc_root(strlit6960);
  }
// compiled string node returning strlit6960 (depth = 5)
  int op_slot_right_6959 = gc_frame_newslot(strlit6960);
// starting to compile member node (depth = 5)
  int callframe6962 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call6963 = callmethodflags(*var_btok, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6962);
// compiled member node returning call6963 (depth = 5)
  int op_slot_left_6959 = gc_frame_newslot(call6963);
  params[0] = strlit6960;
  partcv[0] = 1;
  Object opresult6964 = callmethod(call6963, "==(1)", 1, partcv, params);
// compiled op node returning opresult6964 (depth = 4)
  Object if6958 = done;
  if (istrue(opresult6964)) {
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6965 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool6966 = alloc_Boolean(1);
// compiled identifier node returning bool6966 (depth = 5)
  gc_frame_newslot(bool6966);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  params[0] = bool6966;
  partcv[0] = 1;
  Object call6967 = callmethodflags(*var_objNode, "inTrait:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6965);
// compiled call node returning call6967 (depth = 4)
    gc_frame_newslot(call6967);
    if6958 = call6967;
  } else {
  }
// compiled if node returning if6958 (depth = 3)
    gc_frame_newslot(if6958);
    if6948 = if6958;
  }
// compiled if node returning if6948 (depth = 2)
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6968 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6969 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6968);
// compiled call node returning call6969 (depth = 2)
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6970 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6971 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6970);
// compiled member node returning call6971 (depth = 2)
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localMinIndentLevel (depth = 3)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_6977__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6979 == NULL) {
    strlit6979 = alloc_String("method");
    gc_root(strlit6979);
  }
// compiled string node returning strlit6979 (depth = 6)
  int op_slot_right_6978 = gc_frame_newslot(strlit6979);
// starting to compile member node (depth = 6)
  int callframe6981 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6982 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  partcv[0] = 0;
  Object call6983 = callmethodflags(*var_tokens, "first", 1, partcv, params, 0);
  gc_frame_end(callframe6982);
// compiled member node returning call6983 (depth = 7)
  partcv[0] = 0;
  Object call6984 = callmethodflags(call6983, "value", 1, partcv, params, 0);
  gc_frame_end(callframe6981);
// compiled member node returning call6984 (depth = 6)
  int op_slot_left_6978 = gc_frame_newslot(call6984);
  params[0] = strlit6979;
  partcv[0] = 1;
  Object opresult6985 = callmethod(call6984, "==(1)", 1, partcv, params);
// compiled op node returning opresult6985 (depth = 5)
  gc_frame_end(frame);
  return opresult6985;
}
Object meth_parser_6990__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6992 == NULL) {
    strlit6992 = alloc_String("keyword");
    gc_root(strlit6992);
  }
// compiled string node returning strlit6992 (depth = 7)
  int op_slot_right_6991 = gc_frame_newslot(strlit6992);
// starting to compile member node (depth = 7)
  int callframe6994 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6995 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call6996 = callmethodflags(*var_tokens, "first", 1, partcv, params, 0);
  gc_frame_end(callframe6995);
// compiled member node returning call6996 (depth = 8)
  partcv[0] = 0;
  Object call6997 = callmethodflags(call6996, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe6994);
// compiled member node returning call6997 (depth = 7)
  int op_slot_left_6991 = gc_frame_newslot(call6997);
  params[0] = strlit6992;
  partcv[0] = 1;
  Object opresult6998 = callmethod(call6997, "==(1)", 1, partcv, params);
// compiled op node returning opresult6998 (depth = 6)
  gc_frame_end(frame);
  return opresult6998;
}
Object meth_parser_6973_dofactoryMethod(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 71, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dofactoryMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[2];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
// definebindings:
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6976 = alloc_Block(NULL, NULL, "parser", 2419);
  gc_frame_newslot(block6976);
// method "_apply"
  block_savedest(block6976);
  Object closure6977 = createclosure(2, "_apply");
  setclosureframe(closure6977, stackframe);
  addtoclosure(closure6977, var_tokens);
  addtoclosure(closure6977, selfslot);
  struct UserObject *uo6977 = (struct UserObject*)block6976;
  uo6977->data[0] = (Object)closure6977;
  Method *meth_meth_parser_6977__apply = addmethod2pos(block6976, "_apply", &meth_parser_6977__apply, 0);
  int argcv_meth_parser_6977__apply[] = {0};
  meth_meth_parser_6977__apply->type = alloc_MethodType(1, argcv_meth_parser_6977__apply);
  meth_meth_parser_6977__apply->definitionModule = modulename;
  meth_meth_parser_6977__apply->definitionLine = 183;
// compiled block node returning block6976 (depth = 4)
  int op_slot_right_6975 = gc_frame_newslot(block6976);
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block6989 = alloc_Block(NULL, NULL, "parser", 2418);
  gc_frame_newslot(block6989);
// method "_apply"
  block_savedest(block6989);
  Object closure6990 = createclosure(2, "_apply");
  setclosureframe(closure6990, stackframe);
  addtoclosure(closure6990, var_tokens);
  addtoclosure(closure6990, selfslot);
  struct UserObject *uo6990 = (struct UserObject*)block6989;
  uo6990->data[0] = (Object)closure6990;
  Method *meth_meth_parser_6990__apply = addmethod2pos(block6989, "_apply", &meth_parser_6990__apply, 0);
  int argcv_meth_parser_6990__apply[] = {0};
  meth_meth_parser_6990__apply->type = alloc_MethodType(1, argcv_meth_parser_6990__apply);
  meth_meth_parser_6990__apply->definitionModule = modulename;
  meth_meth_parser_6990__apply->definitionLine = 183;
// compiled block node returning block6989 (depth = 5)
  int op_slot_right_6988 = gc_frame_newslot(block6989);
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7001 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7002 == NULL) {
    strlit7002 = alloc_String("factory");
    gc_root(strlit7002);
  }
// compiled string node returning strlit7002 (depth = 6)
  gc_frame_newslot(strlit7002);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit7002;
  partcv[0] = 1;
  Object call7003 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7001);
// compiled call node returning call7003 (depth = 5)
  int op_slot_left_6988 = gc_frame_newslot(call7003);
  params[0] = block6989;
  partcv[0] = 1;
  Object opresult7004 = callmethod(call7003, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7004 (depth = 4)
  int op_slot_left_6975 = gc_frame_newslot(opresult7004);
  params[0] = block6976;
  partcv[0] = 1;
  Object opresult7005 = callmethod(opresult7004, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7005 (depth = 3)
  Object if6974 = done;
  if (istrue(opresult7005)) {
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7006 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7007 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7006);
// compiled member node returning call7007 (depth = 3)
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7008 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2424
  setline(2424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7010 == NULL) {
    strlit7010 = alloc_String("no longer supported. Use 'class' instead.");
    gc_root(strlit7010);
  }
// compiled string node returning strlit7010 (depth = 5)
  int op_slot_right_7009 = gc_frame_newslot(strlit7010);
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7012 == NULL) {
    strlit7012 = alloc_String("the keyword combination 'factory method' is ");
    gc_root(strlit7012);
  }
// compiled string node returning strlit7012 (depth = 5)
  int op_slot_left_7009 = gc_frame_newslot(strlit7012);
  params[0] = strlit7010;
  partcv[0] = 1;
  Object opresult7013 = callmethod(strlit7012, "++(1)", 1, partcv, params);
// compiled op node returning opresult7013 (depth = 4)
  gc_frame_newslot(opresult7013);
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7014 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call7015 = callmethodflags(*var_btok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7014);
// compiled member node returning call7015 (depth = 4)
  gc_frame_newslot(call7015);
// starting to compile member node (depth = 4)
  int callframe7016 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call7017 = callmethodflags(*var_btok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7016);
// compiled member node returning call7017 (depth = 4)
  gc_frame_newslot(call7017);
// starting to compile member node (depth = 4)
  int callframe7018 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call7019 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7018);
// compiled member node returning call7019 (depth = 4)
  gc_frame_newslot(call7019);
// starting to compile member node (depth = 4)
  int callframe7020 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call7021 = callmethodflags(*var_sym, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe7020);
// compiled member node returning call7021 (depth = 4)
  gc_frame_newslot(call7021);
// call case 6: other requests
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult7013;
  params[1] = call7015;
  params[2] = call7017;
  params[3] = call7019;
  params[4] = call7021;
  partcv[0] = 1;
  partcv[1] = 4;
  Object call7022 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(4)", 2, partcv, params, 0);
  gc_frame_end(callframe7008);
// compiled call node returning call7022 (depth = 3)
    gc_frame_newslot(call7022);
    if6974 = call7022;
  } else {
  }
// compiled if node returning if6974 (depth = 2)
  gc_frame_end(frame);
  return if6974;
}
Object meth_parser_7076__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 8)
  int callframe7077 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7078 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7077);
// compiled member node returning call7078 (depth = 8)
  gc_frame_end(frame);
  return call7078;
}
Object meth_parser_7073__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe7074 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block7075 = alloc_Block(NULL, NULL, "parser", 2452);
  gc_frame_newslot(block7075);
// method "_apply"
  block_savedest(block7075);
  Object closure7076 = createclosure(1, "_apply");
  setclosureframe(closure7076, stackframe);
  addtoclosure(closure7076, selfslot);
  struct UserObject *uo7076 = (struct UserObject*)block7075;
  uo7076->data[0] = (Object)closure7076;
  Method *meth_meth_parser_7076__apply = addmethod2pos(block7075, "_apply", &meth_parser_7076__apply, 0);
  int argcv_meth_parser_7076__apply[] = {0};
  meth_meth_parser_7076__apply->type = alloc_MethodType(1, argcv_meth_parser_7076__apply);
  meth_meth_parser_7076__apply->definitionModule = modulename;
  meth_meth_parser_7076__apply->definitionLine = 183;
// compiled block node returning block7075 (depth = 7)
  gc_frame_newslot(block7075);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block7075;
  partcv[0] = 1;
  Object call7080 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7074);
// compiled call node returning call7080 (depth = 6)
  gc_frame_end(frame);
  return call7080;
}
Object meth_parser_7083__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  gc_frame_end(frame);
  return done;
}
Object meth_parser_7023_methoddec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 72, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methoddec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_minIndentLevel = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_methNode = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "methNode");
  Object *var_localMin = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "localMin");
  Object *var_anns = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "anns");
  Object *var_originalValues = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "originalValues");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "closingBrace");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7025 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7026 == NULL) {
    strlit7026 = alloc_String("method");
    gc_root(strlit7026);
  }
// compiled string node returning strlit7026 (depth = 4)
  gc_frame_newslot(strlit7026);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7026;
  partcv[0] = 1;
  Object call7027 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7025);
// compiled call node returning call7027 (depth = 3)
  Object if7024 = done;
  if (istrue(call7027)) {
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7028 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7029 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7028);
// compiled member node returning call7029 (depth = 3)
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7031 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7032 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7031);
// compiled member node returning call7032 (depth = 3)
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7033 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe7034 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool7035 = alloc_Boolean(0);
// compiled identifier node returning bool7035 (depth = 6)
  gc_frame_newslot(bool7035);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = bool7035;
  partcv[0] = 1;
  Object call7036 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7034);
// compiled call node returning call7036 (depth = 5)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call7037 = callmethodflags(call7036, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7033);
// compiled call node returning call7037 (depth = 4)
  *var_methNode = call7037;
  if (call7037 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_localMin = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7038 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7039 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7038);
// compiled member node returning call7039 (depth = 4)
  *var_anns = call7039;
  if (call7039 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2440
  setline(2440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  *var_originalValues = *var_values;
  if (*var_values == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2441
  setline(2441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7040 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7040 (depth = 4)
  *var_values = array7040;
  if (array7040 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7043 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7044 == NULL) {
    strlit7044 = alloc_String("lbrace");
    gc_root(strlit7044);
  }
// compiled string node returning strlit7044 (depth = 5)
  gc_frame_newslot(strlit7044);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit7044;
  partcv[0] = 1;
  Object call7045 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7043);
// compiled call node returning call7045 (depth = 4)
  Object if7042 = done;
  if (istrue(call7045)) {
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7046 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7047 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7046);
// compiled member node returning call7047 (depth = 4)
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minIndentLevel (depth = 5)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7051 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call7052 = callmethodflags(*var_btok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7051);
// compiled member node returning call7052 (depth = 6)
  int op_slot_right_7050 = gc_frame_newslot(call7052);
// starting to compile member node (depth = 6)
  int callframe7054 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7055 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7054);
// compiled member node returning call7055 (depth = 6)
  int op_slot_left_7050 = gc_frame_newslot(call7055);
  params[0] = call7052;
  partcv[0] = 1;
  Object opresult7056 = callmethod(call7055, "==(1)", 1, partcv, params);
// compiled op node returning opresult7056 (depth = 5)
  Object if7049 = done;
  if (istrue(opresult7056)) {
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7058 = alloc_Float64(1);
// compiled num node returning num7058 (depth = 7)
  int op_slot_right_7057 = gc_frame_newslot(num7058);
// starting to compile member node (depth = 7)
  int callframe7060 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7061 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7060);
// compiled member node returning call7061 (depth = 7)
  int op_slot_left_7057 = gc_frame_newslot(call7061);
  params[0] = num7058;
  partcv[0] = 1;
  Object diff7062 = callmethod(call7061, "-(1)", 1, partcv, params);
// compiled op node returning diff7062 (depth = 6)
  *var_minIndentLevel = diff7062;
  if (diff7062 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7049 = done;
  } else {
// Begin line 2450
  setline(2450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7065 = alloc_Float64(2);
// compiled num node returning num7065 (depth = 7)
  int op_slot_right_7064 = gc_frame_newslot(num7065);
// starting to compile member node (depth = 7)
  int callframe7067 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  partcv[0] = 0;
  Object call7068 = callmethodflags(*var_btok, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe7067);
// compiled member node returning call7068 (depth = 7)
  int op_slot_left_7064 = gc_frame_newslot(call7068);
  params[0] = num7065;
  partcv[0] = 1;
  Object sum7069 = callmethod(call7068, "+(1)", 1, partcv, params);
// compiled op node returning sum7069 (depth = 6)
  *var_minIndentLevel = sum7069;
  if (sum7069 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7049 = done;
  }
// compiled if node returning if7049 (depth = 4)
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7071 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7072 = alloc_Block(NULL, NULL, "parser", 2452);
  gc_frame_newslot(block7072);
// method "_apply"
  block_savedest(block7072);
  Object closure7073 = createclosure(1, "_apply");
  setclosureframe(closure7073, stackframe);
  addtoclosure(closure7073, selfslot);
  struct UserObject *uo7073 = (struct UserObject*)block7072;
  uo7073->data[0] = (Object)closure7073;
  Method *meth_meth_parser_7073__apply = addmethod2pos(block7072, "_apply", &meth_parser_7073__apply, 0);
  int argcv_meth_parser_7073__apply[] = {0};
  meth_meth_parser_7073__apply->type = alloc_MethodType(1, argcv_meth_parser_7073__apply);
  meth_meth_parser_7073__apply->definitionModule = modulename;
  meth_meth_parser_7073__apply->definitionLine = 183;
// compiled block node returning block7072 (depth = 5)
  gc_frame_newslot(block7072);
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block7082 = alloc_Block(NULL, NULL, "parser", 2452);
  gc_frame_newslot(block7082);
// method "_apply"
  block_savedest(block7082);
  Object closure7083 = createclosure(1, "_apply");
  setclosureframe(closure7083, stackframe);
  addtoclosure(closure7083, selfslot);
  struct UserObject *uo7083 = (struct UserObject*)block7082;
  uo7083->data[0] = (Object)closure7083;
  Method *meth_meth_parser_7083__apply = addmethod2pos(block7082, "_apply", &meth_parser_7083__apply, 0);
  int argcv_meth_parser_7083__apply[] = {0};
  meth_meth_parser_7083__apply->type = alloc_MethodType(1, argcv_meth_parser_7083__apply);
  meth_meth_parser_7083__apply->definitionModule = modulename;
  meth_meth_parser_7083__apply->definitionLine = 183;
// compiled block node returning block7082 (depth = 5)
  gc_frame_newslot(block7082);
// call case 5: prelude request
  params[0] = block7072;
  params[1] = block7082;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7085 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7071);
// compiled call node returning call7085 (depth = 4)
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7088 == NULL) {
    strlit7088 = alloc_String("rbrace");
    gc_root(strlit7088);
  }
// compiled string node returning strlit7088 (depth = 6)
  int op_slot_right_7087 = gc_frame_newslot(strlit7088);
// starting to compile member node (depth = 6)
  int callframe7090 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7091 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7090);
// compiled member node returning call7091 (depth = 6)
  int op_slot_left_7087 = gc_frame_newslot(call7091);
  params[0] = strlit7088;
  partcv[0] = 1;
  Object opresult7092 = callmethod(call7091, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7092 (depth = 5)
  Object if7086 = done;
  if (istrue(opresult7092)) {
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7093 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7094 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call7095 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7094);
// compiled member node returning call7095 (depth = 7)
  partcv[0] = 0;
  Object call7096 = callmethodflags(call7095, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7093);
// compiled member node returning call7096 (depth = 6)
  *var_suggestion = call7096;
  if (call7096 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7097 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool7098 = alloc_Boolean(0);
// compiled identifier node returning bool7098 (depth = 7)
  gc_frame_newslot(bool7098);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_btok;
  params[1] = bool7098;
  partcv[0] = 2;
  Object call7099 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7097);
// compiled call node returning call7099 (depth = 6)
  *var_closingBrace = call7099;
  if (call7099 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7101 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7102 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  partcv[0] = 0;
  Object call7103 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe7102);
// compiled member node returning call7103 (depth = 7)
  partcv[0] = 0;
  Object call7104 = callmethodflags(call7103, "not", 1, partcv, params, 0);
  gc_frame_end(callframe7101);
// compiled member node returning call7104 (depth = 6)
  Object if7100 = done;
  if (istrue(call7104)) {
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7107 == NULL) {
    strlit7107 = alloc_String("eof");
    gc_root(strlit7107);
  }
// compiled string node returning strlit7107 (depth = 8)
  int op_slot_right_7106 = gc_frame_newslot(strlit7107);
// starting to compile member node (depth = 8)
  int callframe7109 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7110 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7109);
// compiled member node returning call7110 (depth = 8)
  int op_slot_left_7106 = gc_frame_newslot(call7110);
  params[0] = strlit7107;
  partcv[0] = 1;
  Object opresult7111 = callmethod(call7110, "==(1)", 1, partcv, params);
// compiled op node returning opresult7111 (depth = 7)
  Object if7105 = done;
  if (istrue(opresult7111)) {
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7112 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit7114 == NULL) {
    strlit7114 = alloc_String("a method declaration.");
    gc_root(strlit7114);
  }
// compiled string node returning strlit7114 (depth = 9)
  int op_slot_right_7113 = gc_frame_newslot(strlit7114);
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit7117 == NULL) {
    strlit7117 = alloc_String("found while searching for the '}' to close ");
    gc_root(strlit7117);
  }
// compiled string node returning strlit7117 (depth = 10)
  int op_slot_right_7116 = gc_frame_newslot(strlit7117);
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit7119 == NULL) {
    strlit7119 = alloc_String("end of program ");
    gc_root(strlit7119);
  }
// compiled string node returning strlit7119 (depth = 10)
  int op_slot_left_7116 = gc_frame_newslot(strlit7119);
  params[0] = strlit7117;
  partcv[0] = 1;
  Object opresult7120 = callmethod(strlit7119, "++(1)", 1, partcv, params);
// compiled op node returning opresult7120 (depth = 9)
  int op_slot_left_7113 = gc_frame_newslot(opresult7120);
  params[0] = strlit7114;
  partcv[0] = 1;
  Object opresult7121 = callmethod(opresult7120, "++(1)", 1, partcv, params);
// compiled op node returning opresult7121 (depth = 8)
  gc_frame_newslot(opresult7121);
// Begin line 2463
  setline(2463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe7122 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7123 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7122);
// compiled member node returning call7123 (depth = 8)
  gc_frame_newslot(call7123);
// starting to compile member node (depth = 8)
  int callframe7124 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7125 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7124);
// compiled member node returning call7125 (depth = 8)
  gc_frame_newslot(call7125);
// call case 6: other requests
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult7121;
  params[1] = call7123;
  params[2] = call7125;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call7126 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe7112);
// compiled call node returning call7126 (depth = 7)
    gc_frame_newslot(call7126);
    if7105 = call7126;
  } else {
  }
// compiled if node returning if7105 (depth = 6)
// Begin line 2465
  setline(2465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_7128 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe7130 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call7131 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe7130);
// compiled member node returning call7131 (depth = 8)
  int op_slot_left_7128 = gc_frame_newslot(call7131);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7132 = callmethod(call7131, "==(1)", 1, partcv, params);
// compiled op node returning opresult7132 (depth = 7)
  Object if7127 = done;
  if (istrue(opresult7132)) {
// Begin line 2466
  setline(2466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7133 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7134 == NULL) {
    strlit7134 = alloc_String("}");
    gc_root(strlit7134);
  }
// compiled string node returning strlit7134 (depth = 8)
  gc_frame_newslot(strlit7134);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit7134;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7135 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7133);
// compiled call node returning call7135 (depth = 7)
    gc_frame_newslot(call7135);
    if7127 = call7135;
  } else {
// Begin line 2468
  setline(2468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7136 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7138 = alloc_Float64(0.1);
// compiled num node returning num7138 (depth = 9)
  int op_slot_right_7137 = gc_frame_newslot(num7138);
// starting to compile member node (depth = 9)
  int callframe7140 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe7141 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call7142 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe7141);
// compiled member node returning call7142 (depth = 10)
  partcv[0] = 0;
  Object call7143 = callmethodflags(call7142, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7140);
// compiled member node returning call7143 (depth = 9)
  int op_slot_left_7137 = gc_frame_newslot(call7143);
  params[0] = num7138;
  partcv[0] = 1;
  Object sum7144 = callmethod(call7143, "+(1)", 1, partcv, params);
// compiled op node returning sum7144 (depth = 8)
  gc_frame_newslot(sum7144);
// starting to compile string node (depth = 8)
  if (strlit7145 == NULL) {
    strlit7145 = alloc_String("}");
    gc_root(strlit7145);
  }
// compiled string node returning strlit7145 (depth = 8)
  gc_frame_newslot(strlit7145);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum7144;
  params[1] = strlit7145;
  partcv[0] = 2;
  Object call7146 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7136);
// compiled call node returning call7146 (depth = 7)
    gc_frame_newslot(call7146);
    if7127 = call7146;
  }
// compiled if node returning if7127 (depth = 6)
    gc_frame_newslot(if7127);
    if7100 = if7127;
  } else {
  }
// compiled if node returning if7100 (depth = 5)
// Begin line 2471
  setline(2471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7147 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call7148 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7147);
// compiled call node returning call7148 (depth = 5)
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7149 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7150 == NULL) {
    strlit7150 = alloc_String("a method must end with a '}'.");
    gc_root(strlit7150);
  }
// compiled string node returning strlit7150 (depth = 6)
  gc_frame_newslot(strlit7150);
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7151 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7152 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7151);
// compiled member node returning call7152 (depth = 6)
  gc_frame_newslot(call7152);
// starting to compile member node (depth = 6)
  int callframe7153 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7154 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7153);
// compiled member node returning call7154 (depth = 6)
  gc_frame_newslot(call7154);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7150;
  params[1] = call7152;
  params[2] = call7154;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7155 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7149);
// compiled call node returning call7155 (depth = 5)
    gc_frame_newslot(call7155);
    if7086 = call7155;
  } else {
  }
// compiled if node returning if7086 (depth = 4)
// Begin line 2475
  setline(2475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7156 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7157 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7156);
// compiled member node returning call7157 (depth = 4)
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_localMin (depth = 5)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7042 = done;
  } else {
// Begin line 2478
  setline(2478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7159 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call7161 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7160);
// compiled member node returning call7161 (depth = 6)
  partcv[0] = 0;
  Object call7162 = callmethodflags(call7161, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7159);
// compiled member node returning call7162 (depth = 5)
  *var_suggestion = call7162;
  if (call7162 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7163 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 6)
  Object bool7164 = alloc_Boolean(1);
// compiled identifier node returning bool7164 (depth = 6)
  gc_frame_newslot(bool7164);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = *var_btok;
  params[1] = bool7164;
  partcv[0] = 2;
  Object call7165 = callmethodflags(module_parser, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7163);
// compiled call node returning call7165 (depth = 5)
  *var_closingBrace = call7165;
  if (call7165 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7167 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7168 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_closingBrace (depth = 7)
  partcv[0] = 0;
  Object call7169 = callmethodflags(*var_closingBrace, "found", 1, partcv, params, 0);
  gc_frame_end(callframe7168);
// compiled member node returning call7169 (depth = 6)
  partcv[0] = 0;
  Object call7170 = callmethodflags(call7169, "not", 1, partcv, params, 0);
  gc_frame_end(callframe7167);
// compiled member node returning call7170 (depth = 5)
  Object if7166 = done;
  if (istrue(call7170)) {
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  int op_slot_right_7172 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe7174 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  partcv[0] = 0;
  Object call7175 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe7174);
// compiled member node returning call7175 (depth = 7)
  int op_slot_left_7172 = gc_frame_newslot(call7175);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult7176 = callmethod(call7175, "==(1)", 1, partcv, params);
// compiled op node returning opresult7176 (depth = 6)
  Object if7171 = done;
  if (istrue(opresult7176)) {
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7177 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7178 == NULL) {
    strlit7178 = alloc_String(" {}");
    gc_root(strlit7178);
  }
// compiled string node returning strlit7178 (depth = 7)
  gc_frame_newslot(strlit7178);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool7179 = alloc_Boolean(1);
// compiled identifier node returning bool7179 (depth = 7)
  gc_frame_newslot(bool7179);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7178;
  params[1] = *var_lastToken;
  params[2] = bool7179;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7180 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7177);
// compiled call node returning call7180 (depth = 6)
    gc_frame_newslot(call7180);
    if7171 = call7180;
  } else {
// Begin line 2484
  setline(2484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7181 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7183 = alloc_Float64(0.1);
// compiled num node returning num7183 (depth = 8)
  int op_slot_right_7182 = gc_frame_newslot(num7183);
// starting to compile member node (depth = 8)
  int callframe7185 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe7186 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call7187 = callmethodflags(*var_closingBrace, "tok", 1, partcv, params, 0);
  gc_frame_end(callframe7186);
// compiled member node returning call7187 (depth = 9)
  partcv[0] = 0;
  Object call7188 = callmethodflags(call7187, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7185);
// compiled member node returning call7188 (depth = 8)
  int op_slot_left_7182 = gc_frame_newslot(call7188);
  params[0] = num7183;
  partcv[0] = 1;
  Object sum7189 = callmethod(call7188, "+(1)", 1, partcv, params);
// compiled op node returning sum7189 (depth = 7)
  gc_frame_newslot(sum7189);
// starting to compile string node (depth = 7)
  if (strlit7190 == NULL) {
    strlit7190 = alloc_String("}");
    gc_root(strlit7190);
  }
// compiled string node returning strlit7190 (depth = 7)
  gc_frame_newslot(strlit7190);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = sum7189;
  params[1] = strlit7190;
  partcv[0] = 2;
  Object call7191 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7181);
// compiled call node returning call7191 (depth = 6)
// Begin line 2485
  setline(2485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7192 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7193 == NULL) {
    strlit7193 = alloc_String(" {");
    gc_root(strlit7193);
  }
// compiled string node returning strlit7193 (depth = 7)
  gc_frame_newslot(strlit7193);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool7194 = alloc_Boolean(1);
// compiled identifier node returning bool7194 (depth = 7)
  gc_frame_newslot(bool7194);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7193;
  params[1] = *var_lastToken;
  params[2] = bool7194;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7195 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7192);
// compiled call node returning call7195 (depth = 6)
    gc_frame_newslot(call7195);
    if7171 = call7195;
  }
// compiled if node returning if7171 (depth = 5)
    gc_frame_newslot(if7171);
    if7166 = if7171;
  } else {
// Begin line 2488
  setline(2488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7196 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7197 == NULL) {
    strlit7197 = alloc_String(" {");
    gc_root(strlit7197);
  }
// compiled string node returning strlit7197 (depth = 6)
  gc_frame_newslot(strlit7197);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
  Object bool7198 = alloc_Boolean(1);
// compiled identifier node returning bool7198 (depth = 6)
  gc_frame_newslot(bool7198);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7197;
  params[1] = *var_lastToken;
  params[2] = bool7198;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7199 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7196);
// compiled call node returning call7199 (depth = 5)
    gc_frame_newslot(call7199);
    if7166 = call7199;
  }
// compiled if node returning if7166 (depth = 4)
// Begin line 2490
  setline(2490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7200 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7201 == NULL) {
    strlit7201 = alloc_String("a method must have a '{' after the name.");
    gc_root(strlit7201);
  }
// compiled string node returning strlit7201 (depth = 5)
  gc_frame_newslot(strlit7201);
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7202 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7203 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7202);
// compiled member node returning call7203 (depth = 5)
  gc_frame_newslot(call7203);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7205 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7206 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe7205);
// compiled member node returning call7206 (depth = 6)
  int op_slot_right_7204 = gc_frame_newslot(call7206);
// starting to compile member node (depth = 6)
  int callframe7208 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7209 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7208);
// compiled member node returning call7209 (depth = 6)
  int op_slot_left_7204 = gc_frame_newslot(call7209);
  params[0] = call7206;
  partcv[0] = 1;
  Object sum7210 = callmethod(call7209, "+(1)", 1, partcv, params);
// compiled op node returning sum7210 (depth = 5)
  gc_frame_newslot(sum7210);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2490
  setline(2490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7201;
  params[1] = call7203;
  params[2] = sum7210;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7211 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7200);
// compiled call node returning call7211 (depth = 4)
    gc_frame_newslot(call7211);
    if7042 = call7211;
  }
// compiled if node returning if7042 (depth = 3)
// Begin line 2493
  setline(2493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7212 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  gc_frame_newslot(*var_values);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  params[0] = *var_values;
  partcv[0] = 1;
  Object call7213 = callmethodflags(*var_methNode, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7212);
// compiled call node returning call7213 (depth = 3)
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_originalValues (depth = 4)
  *var_values = *var_originalValues;
  if (*var_originalValues == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2495
  setline(2495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7215 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7216 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call7217 = callmethodflags(*var_btok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7216);
// compiled member node returning call7217 (depth = 4)
  gc_frame_newslot(call7217);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call7217;
  partcv[0] = 1;
  Object call7218 = callmethodflags(*var_util, "setline(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7215);
// compiled call node returning call7218 (depth = 3)
// Begin line 2496
  setline(2496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_7220 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool7222 = alloc_Boolean(0);
// compiled identifier node returning bool7222 (depth = 5)
  int op_slot_left_7220 = gc_frame_newslot(bool7222);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult7223 = callmethod(bool7222, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7223 (depth = 4)
  Object if7219 = done;
  if (istrue(opresult7223)) {
// starting to compile call node (depth = 4)
  int callframe7224 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methNode (depth = 6)
  partcv[0] = 0;
  Object call7226 = callmethodflags(*var_methNode, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe7225);
// compiled member node returning call7226 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7227 = callmethodflags(call7226, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7224);
// compiled call node returning call7227 (depth = 4)
    gc_frame_newslot(call7227);
    if7219 = call7227;
  } else {
  }
// compiled if node returning if7219 (depth = 3)
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7228 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  gc_frame_newslot(*var_methNode);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_methNode;
  partcv[0] = 1;
  Object call7229 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7228);
// compiled call node returning call7229 (depth = 3)
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7230 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7231 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7230);
// compiled member node returning call7231 (depth = 3)
    gc_frame_newslot(call7231);
    if7024 = call7231;
  } else {
  }
// compiled if node returning if7024 (depth = 2)
  gc_frame_end(frame);
  return if7024;
}
Object meth_parser_7237__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sameline = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7239 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7240 == NULL) {
    strlit7240 = alloc_String("identifier");
    gc_root(strlit7240);
  }
// compiled string node returning strlit7240 (depth = 6)
  gc_frame_newslot(strlit7240);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit7240;
  partcv[0] = 1;
  Object call7241 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7239);
// compiled call node returning call7241 (depth = 5)
  int op_slot_right_7238 = gc_frame_newslot(call7241);
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7244 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7245 == NULL) {
    strlit7245 = alloc_String("identifier");
    gc_root(strlit7245);
  }
// compiled string node returning strlit7245 (depth = 7)
  gc_frame_newslot(strlit7245);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7245;
  partcv[0] = 1;
  Object call7246 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7244);
// compiled call node returning call7246 (depth = 6)
  int op_slot_right_7243 = gc_frame_newslot(call7246);
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7248 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call7249 = callmethodflags(*var_sameline, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe7248);
// compiled call node returning call7249 (depth = 6)
  int op_slot_left_7243 = gc_frame_newslot(call7249);
  params[0] = call7246;
  partcv[0] = 1;
  Object opresult7250 = callmethod(call7249, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7250 (depth = 5)
  int op_slot_left_7238 = gc_frame_newslot(opresult7250);
  params[0] = call7241;
  partcv[0] = 1;
  Object opresult7251 = callmethod(opresult7250, "||(1)", 1, partcv, params);
// compiled op node returning opresult7251 (depth = 4)
  gc_frame_end(frame);
  return opresult7251;
}
Object meth_parser_7294__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 6)
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7298 == NULL) {
    strlit7298 = alloc_String("*");
    gc_root(strlit7298);
  }
// compiled string node returning strlit7298 (depth = 9)
  int op_slot_right_7297 = gc_frame_newslot(strlit7298);
// starting to compile member node (depth = 9)
  int callframe7300 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7301 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe7300);
// compiled member node returning call7301 (depth = 9)
  int op_slot_left_7297 = gc_frame_newslot(call7301);
  params[0] = strlit7298;
  partcv[0] = 1;
  Object opresult7302 = callmethod(call7301, "==(1)", 1, partcv, params);
// compiled op node returning opresult7302 (depth = 8)
  int op_slot_right_7296 = gc_frame_newslot(opresult7302);
// starting to compile call node (depth = 8)
  int callframe7304 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7305 == NULL) {
    strlit7305 = alloc_String("op");
    gc_root(strlit7305);
  }
// compiled string node returning strlit7305 (depth = 9)
  gc_frame_newslot(strlit7305);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = strlit7305;
  partcv[0] = 1;
  Object call7306 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7304);
// compiled call node returning call7306 (depth = 8)
  int op_slot_left_7296 = gc_frame_newslot(call7306);
  params[0] = opresult7302;
  partcv[0] = 1;
  Object opresult7307 = callmethod(call7306, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7307 (depth = 7)
  int op_slot_right_7295 = gc_frame_newslot(opresult7307);
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7309 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7310 == NULL) {
    strlit7310 = alloc_String("identifier");
    gc_root(strlit7310);
  }
// compiled string node returning strlit7310 (depth = 8)
  gc_frame_newslot(strlit7310);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit7310;
  partcv[0] = 1;
  Object call7311 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7309);
// compiled call node returning call7311 (depth = 7)
  int op_slot_left_7295 = gc_frame_newslot(call7311);
  params[0] = opresult7307;
  partcv[0] = 1;
  Object opresult7312 = callmethod(call7311, "||(1)", 1, partcv, params);
// compiled op node returning opresult7312 (depth = 6)
  gc_frame_end(frame);
  return opresult7312;
}
Object meth_parser_7315__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_part = getfromclosure(closure, 4);
  Object *var_comma = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_nxt = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "nxt");
// definebindings:
// definebindings:
// Begin line 2525
  setline(2525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7317 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7318 == NULL) {
    strlit7318 = alloc_String("op");
    gc_root(strlit7318);
  }
// compiled string node returning strlit7318 (depth = 8)
  gc_frame_newslot(strlit7318);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit7318;
  partcv[0] = 1;
  Object call7319 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7317);
// compiled call node returning call7319 (depth = 7)
  Object if7316 = done;
  if (istrue(call7319)) {
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe7320 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7321 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7320);
// compiled member node returning call7321 (depth = 7)
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7322 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7324 == NULL) {
    strlit7324 = alloc_String(" an Iterable.");
    gc_root(strlit7324);
  }
// compiled string node returning strlit7324 (depth = 9)
  int op_slot_right_7323 = gc_frame_newslot(strlit7324);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe7327 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7328 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe7327);
// compiled member node returning call7328 (depth = 10)
  int op_slot_right_7326 = gc_frame_newslot(call7328);
// starting to compile string node (depth = 10)
  if (strlit7330 == NULL) {
    strlit7330 = alloc_String("variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making ");
    gc_root(strlit7330);
  }
// compiled string node returning strlit7330 (depth = 10)
  int op_slot_left_7326 = gc_frame_newslot(strlit7330);
  params[0] = call7328;
  partcv[0] = 1;
  Object opresult7331 = callmethod(strlit7330, "++(1)", 1, partcv, params);
// compiled op node returning opresult7331 (depth = 9)
  int op_slot_left_7323 = gc_frame_newslot(opresult7331);
  params[0] = strlit7324;
  partcv[0] = 1;
  Object opresult7332 = callmethod(opresult7331, "++(1)", 1, partcv, params);
// compiled op node returning opresult7332 (depth = 8)
  gc_frame_newslot(opresult7332);
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe7333 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7334 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7333);
// compiled member node returning call7334 (depth = 8)
  gc_frame_newslot(call7334);
// starting to compile member node (depth = 8)
  int callframe7335 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7336 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7335);
// compiled member node returning call7336 (depth = 8)
  gc_frame_newslot(call7336);
// call case 6: other requests
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult7332;
  params[1] = call7334;
  params[2] = call7336;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call7337 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe7322);
// compiled call node returning call7337 (depth = 7)
    gc_frame_newslot(call7337);
    if7316 = call7337;
  } else {
  }
// compiled if node returning if7316 (depth = 6)
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7338 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7339 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7338);
// compiled member node returning call7339 (depth = 6)
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7340 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call7341 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe7340);
// compiled member node returning call7341 (depth = 7)
  *var_nxt = call7341;
  if (call7341 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7342 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool7343 = alloc_Boolean(1);
// compiled identifier node returning bool7343 (depth = 7)
  gc_frame_newslot(bool7343);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  params[0] = bool7343;
  partcv[0] = 1;
  Object call7344 = callmethodflags(*var_nxt, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7342);
// compiled call node returning call7344 (depth = 6)
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7345 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe7346 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7347 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7346);
// compiled member node returning call7347 (depth = 7)
  gc_frame_newslot(call7347);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  params[0] = call7347;
  partcv[0] = 1;
  Object call7348 = callmethodflags(*var_nxt, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7345);
// compiled call node returning call7348 (depth = 6)
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7349 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  gc_frame_newslot(*var_nxt);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7350 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call7351 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe7350);
// compiled member node returning call7351 (depth = 7)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call7352 = callmethodflags(call7351, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7349);
// compiled call node returning call7352 (depth = 6)
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7354 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7355 == NULL) {
    strlit7355 = alloc_String("comma");
    gc_root(strlit7355);
  }
// compiled string node returning strlit7355 (depth = 8)
  gc_frame_newslot(strlit7355);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit7355;
  partcv[0] = 1;
  Object call7356 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7354);
// compiled call node returning call7356 (depth = 7)
  Object if7353 = done;
  if (istrue(call7356)) {
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe7358 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7359 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7358);
// compiled member node returning call7359 (depth = 7)
    gc_frame_newslot(call7359);
    if7353 = call7359;
  } else {
  }
// compiled if node returning if7353 (depth = 6)
  gc_frame_end(frame);
  return if7353;
}
Object meth_parser_7254__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_signature = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_part = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "part");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
  Object *var_comma = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "comma");
// definebindings:
// definebindings:
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7255 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7256 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7255);
// compiled member node returning call7256 (depth = 4)
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7257 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe7258 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7259 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call7260 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe7259);
// compiled member node returning call7260 (depth = 7)
  partcv[0] = 0;
  Object call7261 = callmethodflags(call7260, "nameString", 1, partcv, params, 0);
  gc_frame_end(callframe7258);
// compiled member node returning call7261 (depth = 6)
  gc_frame_newslot(call7261);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7262 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7263 = callmethodflags(*var_ast, "signaturePart", 1, partcv, params, 0);
  gc_frame_end(callframe7262);
// compiled member node returning call7263 (depth = 6)
  params[0] = call7261;
  partcv[0] = 1;
  Object call7264 = callmethodflags(call7263, "partName(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7257);
// compiled call node returning call7264 (depth = 5)
  *var_part = call7264;
  if (call7264 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7266 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe7267 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7268 == NULL) {
    strlit7268 = alloc_String("lparen");
    gc_root(strlit7268);
  }
// compiled string node returning strlit7268 (depth = 7)
  gc_frame_newslot(strlit7268);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7268;
  partcv[0] = 1;
  Object call7269 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7267);
// compiled call node returning call7269 (depth = 6)
  partcv[0] = 0;
  Object call7270 = callmethodflags(call7269, "not", 1, partcv, params, 0);
  gc_frame_end(callframe7266);
// compiled member node returning call7270 (depth = 5)
  Object if7265 = done;
  if (istrue(call7270)) {
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7271 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7272 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call7273 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7272);
// compiled member node returning call7273 (depth = 7)
  partcv[0] = 0;
  Object call7274 = callmethodflags(call7273, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7271);
// compiled member node returning call7274 (depth = 6)
  *var_suggestion = call7274;
  if (call7274 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2516
  setline(2516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7275 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7276 == NULL) {
    strlit7276 = alloc_String("()");
    gc_root(strlit7276);
  }
// compiled string node returning strlit7276 (depth = 6)
  gc_frame_newslot(strlit7276);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7276;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7277 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7275);
// compiled call node returning call7277 (depth = 5)
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7278 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7280 == NULL) {
    strlit7280 = alloc_String("parameter lists must have parentheses around each parameter list.");
    gc_root(strlit7280);
  }
// compiled string node returning strlit7280 (depth = 7)
  int op_slot_right_7279 = gc_frame_newslot(strlit7280);
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7282 == NULL) {
    strlit7282 = alloc_String("the declaration of a method with multiple ");
    gc_root(strlit7282);
  }
// compiled string node returning strlit7282 (depth = 7)
  int op_slot_left_7279 = gc_frame_newslot(strlit7282);
  params[0] = strlit7280;
  partcv[0] = 1;
  Object opresult7283 = callmethod(strlit7282, "++(1)", 1, partcv, params);
// compiled op node returning opresult7283 (depth = 6)
  gc_frame_newslot(opresult7283);
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7284 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7285 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7284);
// compiled member node returning call7285 (depth = 6)
  gc_frame_newslot(call7285);
// starting to compile member node (depth = 6)
  int callframe7286 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7287 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7286);
// compiled member node returning call7287 (depth = 6)
  gc_frame_newslot(call7287);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult7283;
  params[1] = call7285;
  params[2] = call7287;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7288 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7278);
// compiled call node returning call7288 (depth = 5)
    gc_frame_newslot(call7288);
    if7265 = call7288;
  } else {
  }
// compiled if node returning if7265 (depth = 4)
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7289 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7290 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7289);
// compiled member node returning call7290 (depth = 4)
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7291 = alloc_Boolean(0);
// compiled identifier node returning bool7291 (depth = 5)
  *var_comma = bool7291;
  if (bool7291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7292 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7293 = alloc_Block(NULL, NULL, "parser", 2523);
  gc_frame_newslot(block7293);
// method "_apply"
  block_savedest(block7293);
  Object closure7294 = createclosure(2, "_apply");
  setclosureframe(closure7294, stackframe);
  addtoclosure(closure7294, var_sym);
  addtoclosure(closure7294, selfslot);
  struct UserObject *uo7294 = (struct UserObject*)block7293;
  uo7294->data[0] = (Object)closure7294;
  Method *meth_meth_parser_7294__apply = addmethod2pos(block7293, "_apply", &meth_parser_7294__apply, 0);
  int argcv_meth_parser_7294__apply[] = {0};
  meth_meth_parser_7294__apply->type = alloc_MethodType(1, argcv_meth_parser_7294__apply);
  meth_meth_parser_7294__apply->definitionModule = modulename;
  meth_meth_parser_7294__apply->definitionLine = 183;
// compiled block node returning block7293 (depth = 5)
  gc_frame_newslot(block7293);
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block7314 = alloc_Block(NULL, NULL, "parser", 2524);
  gc_frame_newslot(block7314);
// method "_apply"
  block_savedest(block7314);
  Object closure7315 = createclosure(7, "_apply");
  setclosureframe(closure7315, stackframe);
  addtoclosure(closure7315, var_sym);
  addtoclosure(closure7315, var_lastToken);
  addtoclosure(closure7315, var_errormessages);
  addtoclosure(closure7315, var_values);
  addtoclosure(closure7315, var_part);
  addtoclosure(closure7315, var_comma);
  addtoclosure(closure7315, selfslot);
  struct UserObject *uo7315 = (struct UserObject*)block7314;
  uo7315->data[0] = (Object)closure7315;
  Method *meth_meth_parser_7315__apply = addmethod2pos(block7314, "_apply", &meth_parser_7315__apply, 0);
  int argcv_meth_parser_7315__apply[] = {0};
  meth_meth_parser_7315__apply->type = alloc_MethodType(1, argcv_meth_parser_7315__apply);
  meth_meth_parser_7315__apply->definitionModule = modulename;
  meth_meth_parser_7315__apply->definitionLine = 183;
// compiled block node returning block7314 (depth = 5)
  gc_frame_newslot(block7314);
// call case 5: prelude request
  params[0] = block7293;
  params[1] = block7314;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7361 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7292);
// compiled call node returning call7361 (depth = 4)
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7364 == NULL) {
    strlit7364 = alloc_String("rparen");
    gc_root(strlit7364);
  }
// compiled string node returning strlit7364 (depth = 6)
  int op_slot_right_7363 = gc_frame_newslot(strlit7364);
// starting to compile member node (depth = 6)
  int callframe7366 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7367 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7366);
// compiled member node returning call7367 (depth = 6)
  int op_slot_left_7363 = gc_frame_newslot(call7367);
  params[0] = strlit7364;
  partcv[0] = 1;
  Object opresult7368 = callmethod(call7367, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7368 (depth = 5)
  Object if7362 = done;
  if (istrue(opresult7368)) {
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7369 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7370 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call7371 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7370);
// compiled member node returning call7371 (depth = 7)
  partcv[0] = 0;
  Object call7372 = callmethodflags(call7371, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7369);
// compiled member node returning call7372 (depth = 6)
  *var_suggestion = call7372;
  if (call7372 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7373 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7374 == NULL) {
    strlit7374 = alloc_String(")");
    gc_root(strlit7374);
  }
// compiled string node returning strlit7374 (depth = 6)
  gc_frame_newslot(strlit7374);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7374;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7375 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7373);
// compiled call node returning call7375 (depth = 5)
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7376 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7377 == NULL) {
    strlit7377 = alloc_String("a part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit7377);
  }
// compiled string node returning strlit7377 (depth = 6)
  gc_frame_newslot(strlit7377);
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7378 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7379 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7378);
// compiled member node returning call7379 (depth = 6)
  gc_frame_newslot(call7379);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7381 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7382 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe7381);
// compiled member node returning call7382 (depth = 7)
  int op_slot_right_7380 = gc_frame_newslot(call7382);
// starting to compile member node (depth = 7)
  int callframe7384 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7385 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7384);
// compiled member node returning call7385 (depth = 7)
  int op_slot_left_7380 = gc_frame_newslot(call7385);
  params[0] = call7382;
  partcv[0] = 1;
  Object sum7386 = callmethod(call7385, "+(1)", 1, partcv, params);
// compiled op node returning sum7386 (depth = 6)
  gc_frame_newslot(sum7386);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7377;
  params[1] = call7379;
  params[2] = sum7386;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7387 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7376);
// compiled call node returning call7387 (depth = 5)
    gc_frame_newslot(call7387);
    if7362 = call7387;
  } else {
  }
// compiled if node returning if7362 (depth = 4)
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7388 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7389 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7388);
// compiled member node returning call7389 (depth = 4)
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7390 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call7391 = callmethodflags(*var_signature, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7390);
// compiled call node returning call7391 (depth = 4)
  gc_frame_end(frame);
  return call7391;
}
Object meth_parser_7232_methodDecRest_40_2_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 73, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodDecRest(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method methodDecRest(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodDecRest(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tm = &(stackframe->slots[0]);
  *var_tm = args[curarg];
  curarg++;
  Object *var_sameline = &(stackframe->slots[1]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part methodDecRest(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_signature = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "signature");
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe7233 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tm (depth = 4)
  partcv[0] = 0;
  Object call7234 = callmethodflags(*var_tm, "signature", 1, partcv, params, 0);
  gc_frame_end(callframe7233);
// compiled member node returning call7234 (depth = 3)
  *var_signature = call7234;
  if (call7234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7235 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block7236 = alloc_Block(NULL, NULL, "parser", 2511);
  gc_frame_newslot(block7236);
// method "_apply"
  block_savedest(block7236);
  Object closure7237 = createclosure(2, "_apply");
  setclosureframe(closure7237, stackframe);
  addtoclosure(closure7237, var_sameline);
  addtoclosure(closure7237, selfslot);
  struct UserObject *uo7237 = (struct UserObject*)block7236;
  uo7237->data[0] = (Object)closure7237;
  Method *meth_meth_parser_7237__apply = addmethod2pos(block7236, "_apply", &meth_parser_7237__apply, 0);
  int argcv_meth_parser_7237__apply[] = {0};
  meth_meth_parser_7237__apply->type = alloc_MethodType(1, argcv_meth_parser_7237__apply);
  meth_meth_parser_7237__apply->definitionModule = modulename;
  meth_meth_parser_7237__apply->definitionLine = 183;
// compiled block node returning block7236 (depth = 3)
  gc_frame_newslot(block7236);
// starting to compile block node (depth = 3)
  Object block7253 = alloc_Block(NULL, NULL, "parser", 2511);
  gc_frame_newslot(block7253);
// method "_apply"
  block_savedest(block7253);
  Object closure7254 = createclosure(7, "_apply");
  setclosureframe(closure7254, stackframe);
  addtoclosure(closure7254, var_values);
  addtoclosure(closure7254, var_ast);
  addtoclosure(closure7254, var_errormessages);
  addtoclosure(closure7254, var_lastToken);
  addtoclosure(closure7254, var_sym);
  addtoclosure(closure7254, var_signature);
  addtoclosure(closure7254, selfslot);
  struct UserObject *uo7254 = (struct UserObject*)block7253;
  uo7254->data[0] = (Object)closure7254;
  Method *meth_meth_parser_7254__apply = addmethod2pos(block7253, "_apply", &meth_parser_7254__apply, 0);
  int argcv_meth_parser_7254__apply[] = {0};
  meth_meth_parser_7254__apply->type = alloc_MethodType(1, argcv_meth_parser_7254__apply);
  meth_meth_parser_7254__apply->definitionModule = modulename;
  meth_meth_parser_7254__apply->definitionLine = 183;
// compiled block node returning block7253 (depth = 3)
  gc_frame_newslot(block7253);
// call case 5: prelude request
  params[0] = block7236;
  params[1] = block7253;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7393 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7235);
// compiled call node returning call7393 (depth = 2)
  gc_frame_end(frame);
  return call7393;
}
Object meth_parser_7404__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe7405 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7406 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7405);
// compiled member node returning call7406 (depth = 6)
  gc_frame_end(frame);
  return call7406;
}
Object meth_parser_7394_optionalTypeAnnotation(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 74, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "optionalTypeAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7396 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7397 == NULL) {
    strlit7397 = alloc_String("colon");
    gc_root(strlit7397);
  }
// compiled string node returning strlit7397 (depth = 4)
  gc_frame_newslot(strlit7397);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7397;
  partcv[0] = 1;
  Object call7398 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7396);
// compiled call node returning call7398 (depth = 3)
  Object if7395 = done;
  if (istrue(call7398)) {
// Begin line 2555
  setline(2555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7399 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7400 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7399);
// compiled member node returning call7400 (depth = 3)
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7402 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7403 = alloc_Block(NULL, NULL, "parser", 2556);
  gc_frame_newslot(block7403);
// method "_apply"
  block_savedest(block7403);
  Object closure7404 = createclosure(1, "_apply");
  setclosureframe(closure7404, stackframe);
  addtoclosure(closure7404, selfslot);
  struct UserObject *uo7404 = (struct UserObject*)block7403;
  uo7404->data[0] = (Object)closure7404;
  Method *meth_meth_parser_7404__apply = addmethod2pos(block7403, "_apply", &meth_parser_7404__apply, 0);
  int argcv_meth_parser_7404__apply[] = {0};
  meth_meth_parser_7404__apply->type = alloc_MethodType(1, argcv_meth_parser_7404__apply);
  meth_meth_parser_7404__apply->definitionModule = modulename;
  meth_meth_parser_7404__apply->definitionLine = 183;
// compiled block node returning block7403 (depth = 5)
  gc_frame_newslot(block7403);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block7403;
  partcv[0] = 1;
  Object call7408 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7402);
// compiled call node returning call7408 (depth = 4)
  Object if7401 = done;
  if (istrue(call7408)) {
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7409 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call7410 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe7409);
// compiled member node returning call7410 (depth = 4)
    gc_frame_newslot(call7410);
    if7401 = call7410;
  } else {
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7412 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7411);
// compiled member node returning call7412 (depth = 4)
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array7413 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7413 (depth = 5)
  *var_suggestions = array7413;
  if (array7413 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7414 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7415 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call7416 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7415);
// compiled member node returning call7416 (depth = 6)
  partcv[0] = 0;
  Object call7417 = callmethodflags(call7416, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7414);
// compiled member node returning call7417 (depth = 5)
  *var_suggestion = call7417;
  if (call7417 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2562
  setline(2562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7418 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7419 == NULL) {
    strlit7419 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit7419);
  }
// compiled string node returning strlit7419 (depth = 5)
  gc_frame_newslot(strlit7419);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7419;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7420 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7418);
// compiled call node returning call7420 (depth = 4)
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7421 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7422 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7421);
// compiled call node returning call7422 (depth = 4)
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7423 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7424 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call7425 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7424);
// compiled member node returning call7425 (depth = 6)
  partcv[0] = 0;
  Object call7426 = callmethodflags(call7425, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7423);
// compiled member node returning call7426 (depth = 5)
  *var_suggestion = call7426;
  if (call7426 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2565
  setline(2565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7428 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 5)
  Object bool7429 = alloc_Boolean(1);
// compiled identifier node returning bool7429 (depth = 5)
  gc_frame_newslot(bool7429);
// starting to compile identifier node (depth = 5)
  Object bool7430 = alloc_Boolean(0);
// compiled identifier node returning bool7430 (depth = 5)
  gc_frame_newslot(bool7430);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = bool7429;
  params[2] = bool7430;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7431 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7428);
// compiled call node returning call7431 (depth = 4)
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7432 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7433 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7432);
// compiled call node returning call7433 (depth = 4)
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7434 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7435 == NULL) {
    strlit7435 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit7435);
  }
// compiled string node returning strlit7435 (depth = 5)
  gc_frame_newslot(strlit7435);
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7436 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7437 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7436);
// compiled member node returning call7437 (depth = 5)
  gc_frame_newslot(call7437);
// starting to compile member node (depth = 5)
  int callframe7438 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7439 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7438);
// compiled member node returning call7439 (depth = 5)
  gc_frame_newslot(call7439);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7435;
  params[1] = call7437;
  params[2] = call7439;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7440 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7434);
// compiled call node returning call7440 (depth = 4)
    gc_frame_newslot(call7440);
    if7401 = call7440;
  }
// compiled if node returning if7401 (depth = 3)
    gc_frame_newslot(if7401);
    if7395 = if7401;
  } else {
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7441 = alloc_Boolean(0);
// compiled identifier node returning bool7441 (depth = 3)
    gc_frame_newslot(bool7441);
    if7395 = bool7441;
  }
// compiled if node returning if7395 (depth = 2)
  gc_frame_end(frame);
  return if7395;
}
Object meth_parser_7509__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7511 == NULL) {
    strlit7511 = alloc_String("rsquare");
    gc_root(strlit7511);
  }
// compiled string node returning strlit7511 (depth = 6)
  int op_slot_right_7510 = gc_frame_newslot(strlit7511);
// starting to compile member node (depth = 6)
  int callframe7513 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7514 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7513);
// compiled member node returning call7514 (depth = 6)
  int op_slot_left_7510 = gc_frame_newslot(call7514);
  params[0] = strlit7511;
  partcv[0] = 1;
  Object opresult7515 = callmethod(call7514, "==(1)", 1, partcv, params);
// compiled op node returning opresult7515 (depth = 5)
  gc_frame_end(frame);
  return opresult7515;
}
Object meth_parser_7589__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 5)
// Begin line 2606
  setline(2606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7593 == NULL) {
    strlit7593 = alloc_String("*");
    gc_root(strlit7593);
  }
// compiled string node returning strlit7593 (depth = 8)
  int op_slot_right_7592 = gc_frame_newslot(strlit7593);
// starting to compile member node (depth = 8)
  int callframe7595 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7596 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe7595);
// compiled member node returning call7596 (depth = 8)
  int op_slot_left_7592 = gc_frame_newslot(call7596);
  params[0] = strlit7593;
  partcv[0] = 1;
  Object opresult7597 = callmethod(call7596, "==(1)", 1, partcv, params);
// compiled op node returning opresult7597 (depth = 7)
  int op_slot_right_7591 = gc_frame_newslot(opresult7597);
// starting to compile call node (depth = 7)
  int callframe7599 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7600 == NULL) {
    strlit7600 = alloc_String("op");
    gc_root(strlit7600);
  }
// compiled string node returning strlit7600 (depth = 8)
  gc_frame_newslot(strlit7600);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit7600;
  partcv[0] = 1;
  Object call7601 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7599);
// compiled call node returning call7601 (depth = 7)
  int op_slot_left_7591 = gc_frame_newslot(call7601);
  params[0] = opresult7597;
  partcv[0] = 1;
  Object opresult7602 = callmethod(call7601, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7602 (depth = 6)
  int op_slot_right_7590 = gc_frame_newslot(opresult7602);
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7604 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7605 == NULL) {
    strlit7605 = alloc_String("identifier");
    gc_root(strlit7605);
  }
// compiled string node returning strlit7605 (depth = 7)
  gc_frame_newslot(strlit7605);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7605;
  partcv[0] = 1;
  Object call7606 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7604);
// compiled call node returning call7606 (depth = 6)
  int op_slot_left_7590 = gc_frame_newslot(call7606);
  params[0] = opresult7602;
  partcv[0] = 1;
  Object opresult7607 = callmethod(call7606, "||(1)", 1, partcv, params);
// compiled op node returning opresult7607 (depth = 5)
  gc_frame_end(frame);
  return opresult7607;
}
Object meth_parser_7610__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_id = getfromclosure(closure, 4);
  Object *var_part = getfromclosure(closure, 5);
  Object *var_comma = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// definebindings:
// definebindings:
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7612 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7613 == NULL) {
    strlit7613 = alloc_String("op");
    gc_root(strlit7613);
  }
// compiled string node returning strlit7613 (depth = 7)
  gc_frame_newslot(strlit7613);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7613;
  partcv[0] = 1;
  Object call7614 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7612);
// compiled call node returning call7614 (depth = 6)
  Object if7611 = done;
  if (istrue(call7614)) {
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7615 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7616 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7615);
// compiled member node returning call7616 (depth = 6)
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7617 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7619 == NULL) {
    strlit7619 = alloc_String(" an Iterable.");
    gc_root(strlit7619);
  }
// compiled string node returning strlit7619 (depth = 8)
  int op_slot_right_7618 = gc_frame_newslot(strlit7619);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7622 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7623 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe7622);
// compiled member node returning call7623 (depth = 9)
  int op_slot_right_7621 = gc_frame_newslot(call7623);
// starting to compile string node (depth = 9)
  if (strlit7625 == NULL) {
    strlit7625 = alloc_String("variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making ");
    gc_root(strlit7625);
  }
// compiled string node returning strlit7625 (depth = 9)
  int op_slot_left_7621 = gc_frame_newslot(strlit7625);
  params[0] = call7623;
  partcv[0] = 1;
  Object opresult7626 = callmethod(strlit7625, "++(1)", 1, partcv, params);
// compiled op node returning opresult7626 (depth = 8)
  int op_slot_left_7618 = gc_frame_newslot(opresult7626);
  params[0] = strlit7619;
  partcv[0] = 1;
  Object opresult7627 = callmethod(opresult7626, "++(1)", 1, partcv, params);
// compiled op node returning opresult7627 (depth = 7)
  gc_frame_newslot(opresult7627);
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe7628 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7629 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7628);
// compiled member node returning call7629 (depth = 7)
  gc_frame_newslot(call7629);
// starting to compile member node (depth = 7)
  int callframe7630 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7631 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7630);
// compiled member node returning call7631 (depth = 7)
  gc_frame_newslot(call7631);
// call case 6: other requests
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult7627;
  params[1] = call7629;
  params[2] = call7631;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call7632 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe7617);
// compiled call node returning call7632 (depth = 6)
    gc_frame_newslot(call7632);
    if7611 = call7632;
  } else {
  }
// compiled if node returning if7611 (depth = 5)
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7633 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7634 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7633);
// compiled member node returning call7634 (depth = 5)
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7635 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7636 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe7635);
// compiled member node returning call7636 (depth = 6)
  *var_id = call7636;
  if (call7636 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7638 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool7639 = alloc_Boolean(1);
// compiled identifier node returning bool7639 (depth = 6)
  gc_frame_newslot(bool7639);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = bool7639;
  partcv[0] = 1;
  Object call7640 = callmethodflags(*var_id, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7638);
// compiled call node returning call7640 (depth = 5)
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7641 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe7642 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7643 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7642);
// compiled member node returning call7643 (depth = 6)
  gc_frame_newslot(call7643);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = call7643;
  partcv[0] = 1;
  Object call7644 = callmethodflags(*var_id, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7641);
// compiled call node returning call7644 (depth = 5)
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7645 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  gc_frame_newslot(*var_id);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7646 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call7647 = callmethodflags(*var_part, "params", 1, partcv, params, 0);
  gc_frame_end(callframe7646);
// compiled member node returning call7647 (depth = 6)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call7648 = callmethodflags(call7647, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7645);
// compiled call node returning call7648 (depth = 5)
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7650 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7651 == NULL) {
    strlit7651 = alloc_String("comma");
    gc_root(strlit7651);
  }
// compiled string node returning strlit7651 (depth = 7)
  gc_frame_newslot(strlit7651);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7651;
  partcv[0] = 1;
  Object call7652 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7650);
// compiled call node returning call7652 (depth = 6)
  Object if7649 = done;
  if (istrue(call7652)) {
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe7654 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7655 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7654);
// compiled member node returning call7655 (depth = 6)
    gc_frame_newslot(call7655);
    if7649 = call7655;
  } else {
// Begin line 2630
  setline(2630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7658 == NULL) {
    strlit7658 = alloc_String("rparen");
    gc_root(strlit7658);
  }
// compiled string node returning strlit7658 (depth = 8)
  int op_slot_right_7657 = gc_frame_newslot(strlit7658);
// starting to compile member node (depth = 8)
  int callframe7660 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7661 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7660);
// compiled member node returning call7661 (depth = 8)
  int op_slot_left_7657 = gc_frame_newslot(call7661);
  params[0] = strlit7658;
  partcv[0] = 1;
  Object opresult7662 = callmethod(call7661, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7662 (depth = 7)
  Object if7656 = done;
  if (istrue(opresult7662)) {
// Begin line 2623
  setline(2623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7665 == NULL) {
    strlit7665 = alloc_String("rparen");
    gc_root(strlit7665);
  }
// compiled string node returning strlit7665 (depth = 9)
  int op_slot_right_7664 = gc_frame_newslot(strlit7665);
// starting to compile member node (depth = 9)
  int callframe7667 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7668 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7667);
// compiled member node returning call7668 (depth = 9)
  int op_slot_left_7664 = gc_frame_newslot(call7668);
  params[0] = strlit7665;
  partcv[0] = 1;
  Object opresult7669 = callmethod(call7668, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7669 (depth = 8)
  Object if7663 = done;
  if (istrue(opresult7669)) {
// Begin line 2624
  setline(2624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7670 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe7671 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call7672 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7671);
// compiled member node returning call7672 (depth = 10)
  partcv[0] = 0;
  Object call7673 = callmethodflags(call7672, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7670);
// compiled member node returning call7673 (depth = 9)
  *var_suggestion = call7673;
  if (call7673 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2625
  setline(2625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7674 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7675 == NULL) {
    strlit7675 = alloc_String(")");
    gc_root(strlit7675);
  }
// compiled string node returning strlit7675 (depth = 9)
  gc_frame_newslot(strlit7675);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit7675;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7676 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7674);
// compiled call node returning call7676 (depth = 8)
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7677 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7678 == NULL) {
    strlit7678 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit7678);
  }
// compiled string node returning strlit7678 (depth = 9)
  gc_frame_newslot(strlit7678);
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe7679 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7680 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7679);
// compiled member node returning call7680 (depth = 9)
  gc_frame_newslot(call7680);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe7682 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call7683 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe7682);
// compiled member node returning call7683 (depth = 10)
  int op_slot_right_7681 = gc_frame_newslot(call7683);
// starting to compile member node (depth = 10)
  int callframe7685 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call7686 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7685);
// compiled member node returning call7686 (depth = 10)
  int op_slot_left_7681 = gc_frame_newslot(call7686);
  params[0] = call7683;
  partcv[0] = 1;
  Object sum7687 = callmethod(call7686, "+(1)", 1, partcv, params);
// compiled op node returning sum7687 (depth = 9)
  gc_frame_newslot(sum7687);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit7678;
  params[1] = call7680;
  params[2] = sum7687;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7688 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7677);
// compiled call node returning call7688 (depth = 8)
    gc_frame_newslot(call7688);
    if7663 = call7688;
  } else {
  }
// compiled if node returning if7663 (depth = 7)
    gc_frame_newslot(if7663);
    if7656 = if7663;
  } else {
  }
// compiled if node returning if7656 (depth = 6)
    gc_frame_newslot(if7656);
    if7649 = if7656;
  }
// compiled if node returning if7649 (depth = 5)
  gc_frame_end(frame);
  return if7649;
}
Object meth_parser_7704__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7707 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7708 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7707);
// compiled member node returning call7708 (depth = 9)
  int op_slot_right_7706 = gc_frame_newslot(call7708);
// starting to compile member node (depth = 9)
  int callframe7710 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call7711 = callmethodflags(*var_t, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7710);
// compiled member node returning call7711 (depth = 9)
  int op_slot_left_7706 = gc_frame_newslot(call7711);
  params[0] = call7708;
  partcv[0] = 1;
  Object opresult7712 = callmethod(call7711, "==(1)", 1, partcv, params);
// compiled op node returning opresult7712 (depth = 8)
  int op_slot_right_7705 = gc_frame_newslot(opresult7712);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7715 == NULL) {
    strlit7715 = alloc_String("rparen");
    gc_root(strlit7715);
  }
// compiled string node returning strlit7715 (depth = 9)
  int op_slot_right_7714 = gc_frame_newslot(strlit7715);
// starting to compile member node (depth = 9)
  int callframe7717 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call7718 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7717);
// compiled member node returning call7718 (depth = 9)
  int op_slot_left_7714 = gc_frame_newslot(call7718);
  params[0] = strlit7715;
  partcv[0] = 1;
  Object opresult7719 = callmethod(call7718, "==(1)", 1, partcv, params);
// compiled op node returning opresult7719 (depth = 8)
  int op_slot_left_7705 = gc_frame_newslot(opresult7719);
  params[0] = opresult7712;
  partcv[0] = 1;
  Object opresult7720 = callmethod(opresult7719, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7720 (depth = 7)
  gc_frame_end(frame);
  return opresult7720;
}
Object meth_parser_7787__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe7788 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7789 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7788);
// compiled member node returning call7789 (depth = 6)
  gc_frame_end(frame);
  return call7789;
}
Object meth_parser_7442_methodsignature_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 75, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsignature(_)");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsignature(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part methodsignature(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
  Object *var_part = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "part");
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_lparen = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "lparen");
  Object *var_id = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "id");
  Object *var_comma = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "comma");
// definebindings:
  Object *var_rparen = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "rparen");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7446 == NULL) {
    strlit7446 = alloc_String("lsquare");
    gc_root(strlit7446);
  }
// compiled string node returning strlit7446 (depth = 5)
  int op_slot_right_7445 = gc_frame_newslot(strlit7446);
// starting to compile member node (depth = 5)
  int callframe7448 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7449 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7448);
// compiled member node returning call7449 (depth = 5)
  int op_slot_left_7445 = gc_frame_newslot(call7449);
  params[0] = strlit7446;
  partcv[0] = 1;
  Object opresult7450 = callmethod(call7449, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7450 (depth = 4)
  int op_slot_right_7444 = gc_frame_newslot(opresult7450);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7454 == NULL) {
    strlit7454 = alloc_String("op");
    gc_root(strlit7454);
  }
// compiled string node returning strlit7454 (depth = 6)
  int op_slot_right_7453 = gc_frame_newslot(strlit7454);
// starting to compile member node (depth = 6)
  int callframe7456 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7457 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7456);
// compiled member node returning call7457 (depth = 6)
  int op_slot_left_7453 = gc_frame_newslot(call7457);
  params[0] = strlit7454;
  partcv[0] = 1;
  Object opresult7458 = callmethod(call7457, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7458 (depth = 5)
  int op_slot_right_7452 = gc_frame_newslot(opresult7458);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7461 == NULL) {
    strlit7461 = alloc_String("identifier");
    gc_root(strlit7461);
  }
// compiled string node returning strlit7461 (depth = 6)
  int op_slot_right_7460 = gc_frame_newslot(strlit7461);
// starting to compile member node (depth = 6)
  int callframe7463 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7464 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7463);
// compiled member node returning call7464 (depth = 6)
  int op_slot_left_7460 = gc_frame_newslot(call7464);
  params[0] = strlit7461;
  partcv[0] = 1;
  Object opresult7465 = callmethod(call7464, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7465 (depth = 5)
  int op_slot_left_7452 = gc_frame_newslot(opresult7465);
  params[0] = opresult7458;
  partcv[0] = 1;
  Object opresult7466 = callmethod(opresult7465, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7466 (depth = 4)
  int op_slot_left_7444 = gc_frame_newslot(opresult7466);
  params[0] = opresult7450;
  partcv[0] = 1;
  Object opresult7467 = callmethod(opresult7466, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7467 (depth = 3)
  Object if7443 = done;
  if (istrue(opresult7467)) {
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7468 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7469 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call7470 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7469);
// compiled member node returning call7470 (depth = 5)
  partcv[0] = 0;
  Object call7471 = callmethodflags(call7470, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7468);
// compiled member node returning call7471 (depth = 4)
  *var_suggestion = call7471;
  if (call7471 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7472 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7473 == NULL) {
    strlit7473 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit7473);
  }
// compiled string node returning strlit7473 (depth = 4)
  gc_frame_newslot(strlit7473);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit7473;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7474 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7472);
// compiled call node returning call7474 (depth = 3)
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7475 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7476 == NULL) {
    strlit7476 = alloc_String("a method name must start with an identifier, or be an operator.");
    gc_root(strlit7476);
  }
// compiled string node returning strlit7476 (depth = 4)
  gc_frame_newslot(strlit7476);
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7477 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call7478 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7477);
// compiled member node returning call7478 (depth = 4)
  gc_frame_newslot(call7478);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7480 = alloc_Float64(1);
// compiled num node returning num7480 (depth = 5)
  int op_slot_right_7479 = gc_frame_newslot(num7480);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7483 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7484 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe7483);
// compiled member node returning call7484 (depth = 6)
  int op_slot_right_7482 = gc_frame_newslot(call7484);
// starting to compile member node (depth = 6)
  int callframe7486 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7487 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7486);
// compiled member node returning call7487 (depth = 6)
  int op_slot_left_7482 = gc_frame_newslot(call7487);
  params[0] = call7484;
  partcv[0] = 1;
  Object sum7488 = callmethod(call7487, "+(1)", 1, partcv, params);
// compiled op node returning sum7488 (depth = 5)
  int op_slot_left_7479 = gc_frame_newslot(sum7488);
  params[0] = num7480;
  partcv[0] = 1;
  Object sum7489 = callmethod(sum7488, "+(1)", 1, partcv, params);
// compiled op node returning sum7489 (depth = 4)
  gc_frame_newslot(sum7489);
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit7476;
  params[1] = call7478;
  params[2] = sum7489;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7490 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7475);
// compiled call node returning call7490 (depth = 3)
    gc_frame_newslot(call7490);
    if7443 = call7490;
  } else {
  }
// compiled if node returning if7443 (depth = 2)
// Begin line 2584
  setline(2584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7491 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7492 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  partcv[0] = 0;
  Object call7493 = callmethodflags(*var_startToken, "value", 1, partcv, params, 0);
  gc_frame_end(callframe7492);
// compiled member node returning call7493 (depth = 4)
  gc_frame_newslot(call7493);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7494 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call7495 = callmethodflags(*var_ast, "signaturePart", 1, partcv, params, 0);
  gc_frame_end(callframe7494);
// compiled member node returning call7495 (depth = 4)
  params[0] = call7493;
  partcv[0] = 1;
  Object call7496 = callmethodflags(call7495, "partName(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7491);
// compiled call node returning call7496 (depth = 3)
  *var_part = call7496;
  if (call7496 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7497 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7498 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7497);
// compiled member node returning call7498 (depth = 2)
// Begin line 2587
  setline(2587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7499 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array7500 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  callmethodflags(array7500, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7500 (depth = 4)
  gc_frame_newslot(array7500);
// starting to compile array node (depth = 4)
  Object array7501 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7501 (depth = 4)
  gc_frame_newslot(array7501);
// starting to compile identifier node (depth = 4)
  Object bool7502 = alloc_Boolean(0);
// compiled identifier node returning bool7502 (depth = 4)
  gc_frame_newslot(bool7502);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7503 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call7504 = callmethodflags(*var_ast, "methodNode", 1, partcv, params, 0);
  gc_frame_end(callframe7503);
// compiled member node returning call7504 (depth = 4)
  params[0] = array7500;
  params[1] = array7501;
  params[2] = bool7502;
  partcv[0] = 3;
  Object call7505 = callmethodflags(call7504, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe7499);
// compiled call node returning call7505 (depth = 3)
  *var_result = call7505;
  if (call7505 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block7508 = alloc_Block(NULL, NULL, "parser", 2588);
  gc_frame_newslot(block7508);
// method "_apply"
  block_savedest(block7508);
  Object closure7509 = createclosure(2, "_apply");
  setclosureframe(closure7509, stackframe);
  addtoclosure(closure7509, var_sym);
  addtoclosure(closure7509, selfslot);
  struct UserObject *uo7509 = (struct UserObject*)block7508;
  uo7509->data[0] = (Object)closure7509;
  Method *meth_meth_parser_7509__apply = addmethod2pos(block7508, "_apply", &meth_parser_7509__apply, 0);
  int argcv_meth_parser_7509__apply[] = {0};
  meth_meth_parser_7509__apply->type = alloc_MethodType(1, argcv_meth_parser_7509__apply);
  meth_meth_parser_7509__apply->definitionModule = modulename;
  meth_meth_parser_7509__apply->definitionLine = 183;
// compiled block node returning block7508 (depth = 4)
  int op_slot_right_7507 = gc_frame_newslot(block7508);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7519 == NULL) {
    strlit7519 = alloc_String("[");
    gc_root(strlit7519);
  }
// compiled string node returning strlit7519 (depth = 5)
  int op_slot_right_7518 = gc_frame_newslot(strlit7519);
// starting to compile member node (depth = 5)
  int callframe7521 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startToken (depth = 6)
  partcv[0] = 0;
  Object call7522 = callmethodflags(*var_startToken, "value", 1, partcv, params, 0);
  gc_frame_end(callframe7521);
// compiled member node returning call7522 (depth = 5)
  int op_slot_left_7518 = gc_frame_newslot(call7522);
  params[0] = strlit7519;
  partcv[0] = 1;
  Object opresult7523 = callmethod(call7522, "==(1)", 1, partcv, params);
// compiled op node returning opresult7523 (depth = 4)
  int op_slot_left_7507 = gc_frame_newslot(opresult7523);
  params[0] = block7508;
  partcv[0] = 1;
  Object opresult7524 = callmethod(opresult7523, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7524 (depth = 3)
  Object if7506 = done;
  if (istrue(opresult7524)) {
// Begin line 2589
  setline(2589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7525 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7526 == NULL) {
    strlit7526 = alloc_String("methods named '[]' and '[]:=' are no longer part of Grace.");
    gc_root(strlit7526);
  }
// compiled string node returning strlit7526 (depth = 4)
  gc_frame_newslot(strlit7526);
// Begin line 2590
  setline(2590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7527 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call7528 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7527);
// compiled member node returning call7528 (depth = 4)
  gc_frame_newslot(call7528);
// starting to compile member node (depth = 4)
  int callframe7529 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call7530 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7529);
// compiled member node returning call7530 (depth = 4)
  gc_frame_newslot(call7530);
// starting to compile member node (depth = 4)
  int callframe7531 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call7532 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7531);
// compiled member node returning call7532 (depth = 4)
  gc_frame_newslot(call7532);
// call case 6: other requests
// Begin line 2589
  setline(2589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit7526;
  params[1] = call7528;
  params[2] = call7530;
  params[3] = call7532;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7533 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe7525);
// compiled call node returning call7533 (depth = 3)
    gc_frame_newslot(call7533);
    if7506 = call7533;
  } else {
  }
// compiled if node returning if7506 (depth = 2)
// Begin line 2592
  setline(2592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7535 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7536 == NULL) {
    strlit7536 = alloc_String("lgeneric");
    gc_root(strlit7536);
  }
// compiled string node returning strlit7536 (depth = 4)
  gc_frame_newslot(strlit7536);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7536;
  partcv[0] = 1;
  Object call7537 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7535);
// compiled call node returning call7537 (depth = 3)
  Object if7534 = done;
  if (istrue(call7537)) {
// Begin line 2592
  setline(2592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7538 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7539 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7540 = callmethodflags(self, "typeparameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7539);
// compiled member node returning call7540 (depth = 4)
  gc_frame_newslot(call7540);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = call7540;
  partcv[0] = 1;
  Object call7541 = callmethodflags(*var_result, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7538);
// compiled call node returning call7541 (depth = 3)
    gc_frame_newslot(call7541);
    if7534 = call7541;
  } else {
  }
// compiled if node returning if7534 (depth = 2)
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7543 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7544 == NULL) {
    strlit7544 = alloc_String("bind");
    gc_root(strlit7544);
  }
// compiled string node returning strlit7544 (depth = 4)
  gc_frame_newslot(strlit7544);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7544;
  partcv[0] = 1;
  Object call7545 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7543);
// compiled call node returning call7545 (depth = 3)
  Object if7542 = done;
  if (istrue(call7545)) {
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7546 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7548 == NULL) {
    strlit7548 = alloc_String(":=");
    gc_root(strlit7548);
  }
// compiled string node returning strlit7548 (depth = 5)
  int op_slot_right_7547 = gc_frame_newslot(strlit7548);
// starting to compile member node (depth = 5)
  int callframe7550 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  partcv[0] = 0;
  Object call7551 = callmethodflags(*var_part, "name", 1, partcv, params, 0);
  gc_frame_end(callframe7550);
// compiled member node returning call7551 (depth = 5)
  int op_slot_left_7547 = gc_frame_newslot(call7551);
  params[0] = strlit7548;
  partcv[0] = 1;
  Object opresult7552 = callmethod(call7551, "++(1)", 1, partcv, params);
// compiled op node returning opresult7552 (depth = 4)
  gc_frame_newslot(opresult7552);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = opresult7552;
  partcv[0] = 1;
  Object call7553 = callmethodflags(*var_part, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7546);
// compiled call node returning call7553 (depth = 3)
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7554 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7555 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7554);
// compiled member node returning call7555 (depth = 3)
    gc_frame_newslot(call7555);
    if7542 = call7555;
  } else {
// Begin line 2600
  setline(2600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7559 == NULL) {
    strlit7559 = alloc_String("prefix");
    gc_root(strlit7559);
  }
// compiled string node returning strlit7559 (depth = 6)
  int op_slot_right_7558 = gc_frame_newslot(strlit7559);
// starting to compile member node (depth = 6)
  int callframe7561 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startToken (depth = 7)
  partcv[0] = 0;
  Object call7562 = callmethodflags(*var_startToken, "value", 1, partcv, params, 0);
  gc_frame_end(callframe7561);
// compiled member node returning call7562 (depth = 6)
  int op_slot_left_7558 = gc_frame_newslot(call7562);
  params[0] = strlit7559;
  partcv[0] = 1;
  Object opresult7563 = callmethod(call7562, "==(1)", 1, partcv, params);
// compiled op node returning opresult7563 (depth = 5)
  int op_slot_right_7557 = gc_frame_newslot(opresult7563);
// starting to compile call node (depth = 5)
  int callframe7565 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7566 == NULL) {
    strlit7566 = alloc_String("op");
    gc_root(strlit7566);
  }
// compiled string node returning strlit7566 (depth = 6)
  gc_frame_newslot(strlit7566);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit7566;
  partcv[0] = 1;
  Object call7567 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7565);
// compiled call node returning call7567 (depth = 5)
  int op_slot_left_7557 = gc_frame_newslot(call7567);
  params[0] = opresult7563;
  partcv[0] = 1;
  Object opresult7568 = callmethod(call7567, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7568 (depth = 4)
  Object if7556 = done;
  if (istrue(opresult7568)) {
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7569 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7571 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7572 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe7571);
// compiled member node returning call7572 (depth = 6)
  int op_slot_right_7570 = gc_frame_newslot(call7572);
// starting to compile member node (depth = 6)
  int callframe7574 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call7575 = callmethodflags(*var_part, "name", 1, partcv, params, 0);
  gc_frame_end(callframe7574);
// compiled member node returning call7575 (depth = 6)
  int op_slot_left_7570 = gc_frame_newslot(call7575);
  params[0] = call7572;
  partcv[0] = 1;
  Object opresult7576 = callmethod(call7575, "++(1)", 1, partcv, params);
// compiled op node returning opresult7576 (depth = 5)
  gc_frame_newslot(opresult7576);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = opresult7576;
  partcv[0] = 1;
  Object call7577 = callmethodflags(*var_part, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7569);
// compiled call node returning call7577 (depth = 4)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7578 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7579 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7578);
// compiled member node returning call7579 (depth = 4)
    gc_frame_newslot(call7579);
    if7556 = call7579;
  } else {
  }
// compiled if node returning if7556 (depth = 3)
    gc_frame_newslot(if7556);
    if7542 = if7556;
  }
// compiled if node returning if7542 (depth = 2)
// Begin line 2600
  setline(2600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7581 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7582 == NULL) {
    strlit7582 = alloc_String("lparen");
    gc_root(strlit7582);
  }
// compiled string node returning strlit7582 (depth = 4)
  gc_frame_newslot(strlit7582);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7582;
  partcv[0] = 1;
  Object call7583 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7581);
// compiled call node returning call7583 (depth = 3)
  Object if7580 = done;
  if (istrue(call7583)) {
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7584 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7585 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7584);
// compiled member node returning call7585 (depth = 3)
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_id = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2604
  setline(2604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool7586 = alloc_Boolean(0);
// compiled identifier node returning bool7586 (depth = 4)
  *var_comma = bool7586;
  if (bool7586 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7587 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7588 = alloc_Block(NULL, NULL, "parser", 2605);
  gc_frame_newslot(block7588);
// method "_apply"
  block_savedest(block7588);
  Object closure7589 = createclosure(2, "_apply");
  setclosureframe(closure7589, stackframe);
  addtoclosure(closure7589, var_sym);
  addtoclosure(closure7589, selfslot);
  struct UserObject *uo7589 = (struct UserObject*)block7588;
  uo7589->data[0] = (Object)closure7589;
  Method *meth_meth_parser_7589__apply = addmethod2pos(block7588, "_apply", &meth_parser_7589__apply, 0);
  int argcv_meth_parser_7589__apply[] = {0};
  meth_meth_parser_7589__apply->type = alloc_MethodType(1, argcv_meth_parser_7589__apply);
  meth_meth_parser_7589__apply->definitionModule = modulename;
  meth_meth_parser_7589__apply->definitionLine = 183;
// compiled block node returning block7588 (depth = 4)
  gc_frame_newslot(block7588);
// Begin line 2606
  setline(2606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block7609 = alloc_Block(NULL, NULL, "parser", 2606);
  gc_frame_newslot(block7609);
// method "_apply"
  block_savedest(block7609);
  Object closure7610 = createclosure(8, "_apply");
  setclosureframe(closure7610, stackframe);
  addtoclosure(closure7610, var_sym);
  addtoclosure(closure7610, var_lastToken);
  addtoclosure(closure7610, var_errormessages);
  addtoclosure(closure7610, var_values);
  addtoclosure(closure7610, var_id);
  addtoclosure(closure7610, var_part);
  addtoclosure(closure7610, var_comma);
  addtoclosure(closure7610, selfslot);
  struct UserObject *uo7610 = (struct UserObject*)block7609;
  uo7610->data[0] = (Object)closure7610;
  Method *meth_meth_parser_7610__apply = addmethod2pos(block7609, "_apply", &meth_parser_7610__apply, 0);
  int argcv_meth_parser_7610__apply[] = {0};
  meth_meth_parser_7610__apply->type = alloc_MethodType(1, argcv_meth_parser_7610__apply);
  meth_meth_parser_7610__apply->definitionModule = modulename;
  meth_meth_parser_7610__apply->definitionLine = 183;
// compiled block node returning block7609 (depth = 4)
  gc_frame_newslot(block7609);
// call case 5: prelude request
  params[0] = block7588;
  params[1] = block7609;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7690 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7587);
// compiled call node returning call7690 (depth = 3)
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7693 == NULL) {
    strlit7693 = alloc_String("rparen");
    gc_root(strlit7693);
  }
// compiled string node returning strlit7693 (depth = 5)
  int op_slot_right_7692 = gc_frame_newslot(strlit7693);
// starting to compile member node (depth = 5)
  int callframe7695 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7696 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7695);
// compiled member node returning call7696 (depth = 5)
  int op_slot_left_7692 = gc_frame_newslot(call7696);
  params[0] = strlit7693;
  partcv[0] = 1;
  Object opresult7697 = callmethod(call7696, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7697 (depth = 4)
  Object if7691 = done;
  if (istrue(opresult7697)) {
// Begin line 2632
  setline(2632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7698 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call7700 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7699);
// compiled member node returning call7700 (depth = 6)
  partcv[0] = 0;
  Object call7701 = callmethodflags(call7700, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7698);
// compiled member node returning call7701 (depth = 5)
  *var_suggestion = call7701;
  if (call7701 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7702 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7703 = alloc_Block(NULL, NULL, "parser", 2633);
  gc_frame_newslot(block7703);
// method "_apply(_)"
  block_savedest(block7703);
  Object closure7704 = createclosure(2, "_apply(1)");
  setclosureframe(closure7704, stackframe);
  addtoclosure(closure7704, var_lastToken);
  addtoclosure(closure7704, selfslot);
  struct UserObject *uo7704 = (struct UserObject*)block7703;
  uo7704->data[0] = (Object)closure7704;
  Method *meth_meth_parser_7704__apply_40_1_41_ = addmethod2pos(block7703, "_apply(1)", &meth_parser_7704__apply_40_1_41_, 0);
  int argcv_meth_parser_7704__apply_40_1_41_[] = {1};
  meth_meth_parser_7704__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_7704__apply_40_1_41_);
  meth_meth_parser_7704__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_7704__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block7703 (depth = 6)
  gc_frame_newslot(block7703);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block7703;
  partcv[0] = 1;
  Object call7722 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7702);
// compiled call node returning call7722 (depth = 5)
  *var_rparen = call7722;
  if (call7722 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2634
  setline(2634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rparen (depth = 6)
  int op_slot_right_7724 = gc_frame_newslot(*var_rparen);
// starting to compile identifier node (depth = 6)
  Object bool7726 = alloc_Boolean(0);
// compiled identifier node returning bool7726 (depth = 6)
  int op_slot_left_7724 = gc_frame_newslot(bool7726);
  params[0] = *var_rparen;
  partcv[0] = 1;
  Object opresult7727 = callmethod(bool7726, "==(1)", 1, partcv, params);
// compiled op node returning opresult7727 (depth = 5)
  Object if7723 = done;
  if (istrue(opresult7727)) {
// Begin line 2635
  setline(2635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7728 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit7729 == NULL) {
    strlit7729 = alloc_String(")");
    gc_root(strlit7729);
  }
// compiled string node returning strlit7729 (depth = 6)
  gc_frame_newslot(strlit7729);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit7729;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7730 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7728);
// compiled call node returning call7730 (depth = 5)
    gc_frame_newslot(call7730);
    if7723 = call7730;
  } else {
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7731 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call7732 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7731);
// compiled call node returning call7732 (depth = 5)
    gc_frame_newslot(call7732);
    if7723 = call7732;
  }
// compiled if node returning if7723 (depth = 4)
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7733 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7734 == NULL) {
    strlit7734 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit7734);
  }
// compiled string node returning strlit7734 (depth = 5)
  gc_frame_newslot(strlit7734);
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7735 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7736 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7735);
// compiled member node returning call7736 (depth = 5)
  gc_frame_newslot(call7736);
// starting to compile member node (depth = 5)
  int callframe7737 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7738 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7737);
// compiled member node returning call7738 (depth = 5)
  gc_frame_newslot(call7738);
// starting to compile member node (depth = 5)
  int callframe7739 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7740 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7739);
// compiled member node returning call7740 (depth = 5)
  gc_frame_newslot(call7740);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7734;
  params[1] = call7736;
  params[2] = call7738;
  params[3] = call7740;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7741 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7733);
// compiled call node returning call7741 (depth = 4)
    gc_frame_newslot(call7741);
    if7691 = call7741;
  } else {
  }
// compiled if node returning if7691 (depth = 3)
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7744 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  partcv[0] = 0;
  Object call7745 = callmethodflags(*var_part, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7744);
// compiled member node returning call7745 (depth = 5)
  int op_slot_right_7743 = gc_frame_newslot(call7745);
// starting to compile member node (depth = 5)
  int callframe7747 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7748 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7747);
// compiled member node returning call7748 (depth = 5)
  int op_slot_left_7743 = gc_frame_newslot(call7748);
  params[0] = call7745;
  partcv[0] = 1;
  Object opresult7749 = callmethod(call7748, "==(1)", 1, partcv, params);
// compiled op node returning opresult7749 (depth = 4)
  Object if7742 = done;
  if (istrue(opresult7749)) {
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7750 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7752 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call7753 = callmethodflags(*var_part, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7752);
// compiled member node returning call7753 (depth = 6)
  int op_slot_right_7751 = gc_frame_newslot(call7753);
// starting to compile member node (depth = 6)
  int callframe7755 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7756 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7755);
// compiled member node returning call7756 (depth = 6)
  int op_slot_left_7751 = gc_frame_newslot(call7756);
  params[0] = call7753;
  partcv[0] = 1;
  Object diff7757 = callmethod(call7756, "-(1)", 1, partcv, params);
// compiled op node returning diff7757 (depth = 5)
  gc_frame_newslot(diff7757);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = diff7757;
  partcv[0] = 1;
  Object call7758 = callmethodflags(*var_part, "lineLength:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7750);
// compiled call node returning call7758 (depth = 4)
    gc_frame_newslot(call7758);
    if7742 = call7758;
  } else {
  }
// compiled if node returning if7742 (depth = 3)
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7759 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7760 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7759);
// compiled member node returning call7760 (depth = 3)
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7763 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7764 == NULL) {
    strlit7764 = alloc_String("identifier");
    gc_root(strlit7764);
  }
// compiled string node returning strlit7764 (depth = 6)
  gc_frame_newslot(strlit7764);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit7764;
  partcv[0] = 1;
  Object call7765 = callmethodflags(module_parser, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7763);
// compiled call node returning call7765 (depth = 5)
  int op_slot_right_7762 = gc_frame_newslot(call7765);
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7768 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7769 == NULL) {
    strlit7769 = alloc_String("identifier");
    gc_root(strlit7769);
  }
// compiled string node returning strlit7769 (depth = 7)
  gc_frame_newslot(strlit7769);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit7769;
  partcv[0] = 1;
  Object call7770 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7768);
// compiled call node returning call7770 (depth = 6)
  int op_slot_right_7767 = gc_frame_newslot(call7770);
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7772 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call7773 = callmethodflags(*var_sameline, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe7772);
// compiled call node returning call7773 (depth = 6)
  int op_slot_left_7767 = gc_frame_newslot(call7773);
  params[0] = call7770;
  partcv[0] = 1;
  Object opresult7774 = callmethod(call7773, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7774 (depth = 5)
  int op_slot_left_7762 = gc_frame_newslot(opresult7774);
  params[0] = call7765;
  partcv[0] = 1;
  Object opresult7775 = callmethod(opresult7774, "||(1)", 1, partcv, params);
// compiled op node returning opresult7775 (depth = 4)
  Object if7761 = done;
  if (istrue(opresult7775)) {
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7776 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  gc_frame_newslot(*var_result);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sameline (depth = 5)
  gc_frame_newslot(*var_sameline);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_result;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call7777 = callmethodflags(module_parser, "methodDecRest(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7776);
// compiled call node returning call7777 (depth = 4)
    gc_frame_newslot(call7777);
    if7761 = call7777;
  } else {
  }
// compiled if node returning if7761 (depth = 3)
    gc_frame_newslot(if7761);
    if7580 = if7761;
  } else {
  }
// compiled if node returning if7580 (depth = 2)
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7779 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7780 == NULL) {
    strlit7780 = alloc_String("arrow");
    gc_root(strlit7780);
  }
// compiled string node returning strlit7780 (depth = 4)
  gc_frame_newslot(strlit7780);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7780;
  partcv[0] = 1;
  Object call7781 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7779);
// compiled call node returning call7781 (depth = 3)
  Object if7778 = done;
  if (istrue(call7781)) {
// Begin line 2655
  setline(2655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7782 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7783 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7782);
// compiled member node returning call7783 (depth = 3)
// Begin line 2656
  setline(2656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7785 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7786 = alloc_Block(NULL, NULL, "parser", 2656);
  gc_frame_newslot(block7786);
// method "_apply"
  block_savedest(block7786);
  Object closure7787 = createclosure(1, "_apply");
  setclosureframe(closure7787, stackframe);
  addtoclosure(closure7787, selfslot);
  struct UserObject *uo7787 = (struct UserObject*)block7786;
  uo7787->data[0] = (Object)closure7787;
  Method *meth_meth_parser_7787__apply = addmethod2pos(block7786, "_apply", &meth_parser_7787__apply, 0);
  int argcv_meth_parser_7787__apply[] = {0};
  meth_meth_parser_7787__apply->type = alloc_MethodType(1, argcv_meth_parser_7787__apply);
  meth_meth_parser_7787__apply->definitionModule = modulename;
  meth_meth_parser_7787__apply->definitionLine = 183;
// compiled block node returning block7786 (depth = 5)
  gc_frame_newslot(block7786);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block7786;
  partcv[0] = 1;
  Object call7791 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7785);
// compiled call node returning call7791 (depth = 4)
  Object if7784 = done;
  if (istrue(call7791)) {
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7792 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 2658
  setline(2658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7794 == NULL) {
    strlit7794 = alloc_String("type. If you don't want to state the return type, omit the arrow.");
    gc_root(strlit7794);
  }
// compiled string node returning strlit7794 (depth = 6)
  int op_slot_right_7793 = gc_frame_newslot(strlit7794);
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7796 == NULL) {
    strlit7796 = alloc_String("after an arrow, write the method's return ");
    gc_root(strlit7796);
  }
// compiled string node returning strlit7796 (depth = 6)
  int op_slot_left_7793 = gc_frame_newslot(strlit7796);
  params[0] = strlit7794;
  partcv[0] = 1;
  Object opresult7797 = callmethod(strlit7796, "++(1)", 1, partcv, params);
// compiled op node returning opresult7797 (depth = 5)
  gc_frame_newslot(opresult7797);
// Begin line 2659
  setline(2659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7798 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7799 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7798);
// compiled member node returning call7799 (depth = 5)
  gc_frame_newslot(call7799);
// starting to compile member node (depth = 5)
  int callframe7800 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7801 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7800);
// compiled member node returning call7801 (depth = 5)
  gc_frame_newslot(call7801);
// starting to compile member node (depth = 5)
  int callframe7802 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7803 = callmethodflags(*var_sym, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe7802);
// compiled member node returning call7803 (depth = 5)
  gc_frame_newslot(call7803);
// call case 6: other requests
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult7797;
  params[1] = call7799;
  params[2] = call7801;
  params[3] = call7803;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7804 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe7792);
// compiled call node returning call7804 (depth = 4)
    gc_frame_newslot(call7804);
    if7784 = call7804;
  } else {
  }
// compiled if node returning if7784 (depth = 3)
// Begin line 2661
  setline(2661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7805 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7806 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call7807 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe7806);
// compiled member node returning call7807 (depth = 4)
  gc_frame_newslot(call7807);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = call7807;
  partcv[0] = 1;
  Object call7808 = callmethodflags(*var_result, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7805);
// compiled call node returning call7808 (depth = 3)
    gc_frame_newslot(call7808);
    if7778 = call7808;
  } else {
  }
// compiled if node returning if7778 (depth = 2)
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_7815__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe7816 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7817 == NULL) {
    strlit7817 = alloc_String("identifier");
    gc_root(strlit7817);
  }
// compiled string node returning strlit7817 (depth = 5)
  gc_frame_newslot(strlit7817);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit7817;
  partcv[0] = 1;
  Object call7818 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7816);
// compiled call node returning call7818 (depth = 4)
  gc_frame_end(frame);
  return call7818;
}
Object meth_parser_7821__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_typeIds = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
// definebindings:
// definebindings:
// Begin line 2671
  setline(2671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7822 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7823 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7822);
// compiled member node returning call7823 (depth = 4)
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7824 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call7825 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe7824);
// compiled member node returning call7825 (depth = 5)
  *var_id = call7825;
  if (call7825 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2673
  setline(2673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7826 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7827 = alloc_Boolean(1);
// compiled identifier node returning bool7827 (depth = 5)
  gc_frame_newslot(bool7827);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  params[0] = bool7827;
  partcv[0] = 1;
  Object call7828 = callmethodflags(*var_id, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7826);
// compiled call node returning call7828 (depth = 4)
// Begin line 2674
  setline(2674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7829 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeIds (depth = 5)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call7830 = callmethodflags(*var_typeIds, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7829);
// compiled call node returning call7830 (depth = 4)
// Begin line 2675
  setline(2675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7832 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7833 == NULL) {
    strlit7833 = alloc_String("comma");
    gc_root(strlit7833);
  }
// compiled string node returning strlit7833 (depth = 6)
  gc_frame_newslot(strlit7833);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit7833;
  partcv[0] = 1;
  Object call7834 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7832);
// compiled call node returning call7834 (depth = 5)
  Object if7831 = done;
  if (istrue(call7834)) {
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7835 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7836 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7835);
// compiled member node returning call7836 (depth = 5)
    gc_frame_newslot(call7836);
    if7831 = call7836;
  } else {
  }
// compiled if node returning if7831 (depth = 4)
  gc_frame_end(frame);
  return if7831;
}
Object meth_parser_7841__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 4)
  int callframe7842 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7843 = alloc_Boolean(1);
// compiled identifier node returning bool7843 (depth = 5)
  gc_frame_newslot(bool7843);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  params[0] = bool7843;
  partcv[0] = 1;
  Object call7844 = callmethodflags(*var_each, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7842);
// compiled call node returning call7844 (depth = 4)
  gc_frame_end(frame);
  return call7844;
}
Object meth_parser_7809_typeparameters(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 76, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeparameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_openBracket = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "openBracket");
  Object *var_typeIds = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "typeIds");
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// definebindings:
// Begin line 2667
  setline(2667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_openBracket = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7810 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7811 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7810);
// compiled member node returning call7811 (depth = 2)
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array7812 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7812 (depth = 3)
  *var_typeIds = array7812;
  if (array7812 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7813 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block7814 = alloc_Block(NULL, NULL, "parser", 2670);
  gc_frame_newslot(block7814);
// method "_apply"
  block_savedest(block7814);
  Object closure7815 = createclosure(1, "_apply");
  setclosureframe(closure7815, stackframe);
  addtoclosure(closure7815, selfslot);
  struct UserObject *uo7815 = (struct UserObject*)block7814;
  uo7815->data[0] = (Object)closure7815;
  Method *meth_meth_parser_7815__apply = addmethod2pos(block7814, "_apply", &meth_parser_7815__apply, 0);
  int argcv_meth_parser_7815__apply[] = {0};
  meth_meth_parser_7815__apply->type = alloc_MethodType(1, argcv_meth_parser_7815__apply);
  meth_meth_parser_7815__apply->definitionModule = modulename;
  meth_meth_parser_7815__apply->definitionLine = 183;
// compiled block node returning block7814 (depth = 3)
  gc_frame_newslot(block7814);
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block7820 = alloc_Block(NULL, NULL, "parser", 2670);
  gc_frame_newslot(block7820);
// method "_apply"
  block_savedest(block7820);
  Object closure7821 = createclosure(3, "_apply");
  setclosureframe(closure7821, stackframe);
  addtoclosure(closure7821, var_values);
  addtoclosure(closure7821, var_typeIds);
  addtoclosure(closure7821, selfslot);
  struct UserObject *uo7821 = (struct UserObject*)block7820;
  uo7821->data[0] = (Object)closure7821;
  Method *meth_meth_parser_7821__apply = addmethod2pos(block7820, "_apply", &meth_parser_7821__apply, 0);
  int argcv_meth_parser_7821__apply[] = {0};
  meth_meth_parser_7821__apply->type = alloc_MethodType(1, argcv_meth_parser_7821__apply);
  meth_meth_parser_7821__apply->definitionModule = modulename;
  meth_meth_parser_7821__apply->definitionLine = 183;
// compiled block node returning block7820 (depth = 3)
  gc_frame_newslot(block7820);
// call case 5: prelude request
  params[0] = block7814;
  params[1] = block7820;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7838 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7813);
// compiled call node returning call7838 (depth = 2)
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7839 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block7840 = alloc_Block(NULL, NULL, "parser", 2679);
  gc_frame_newslot(block7840);
// method "_apply(_)"
  block_savedest(block7840);
  Object closure7841 = createclosure(1, "_apply(1)");
  setclosureframe(closure7841, stackframe);
  addtoclosure(closure7841, selfslot);
  struct UserObject *uo7841 = (struct UserObject*)block7840;
  uo7841->data[0] = (Object)closure7841;
  Method *meth_meth_parser_7841__apply_40_1_41_ = addmethod2pos(block7840, "_apply(1)", &meth_parser_7841__apply_40_1_41_, 0);
  int argcv_meth_parser_7841__apply_40_1_41_[] = {1};
  meth_meth_parser_7841__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_7841__apply_40_1_41_);
  meth_meth_parser_7841__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_7841__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block7840 (depth = 3)
  gc_frame_newslot(block7840);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeIds (depth = 3)
  params[0] = block7840;
  partcv[0] = 1;
  Object call7846 = callmethodflags(*var_typeIds, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7839);
// compiled call node returning call7846 (depth = 2)
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7847 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_openBracket (depth = 4)
  gc_frame_newslot(*var_openBracket);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7848 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeIds (depth = 5)
  gc_frame_newslot(*var_typeIds);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7849 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call7850 = callmethodflags(*var_ast, "typeParametersNode", 1, partcv, params, 0);
  gc_frame_end(callframe7849);
// compiled member node returning call7850 (depth = 5)
  params[0] = *var_typeIds;
  partcv[0] = 1;
  Object call7851 = callmethodflags(call7850, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7848);
// compiled call node returning call7851 (depth = 4)
  params[0] = *var_openBracket;
  partcv[0] = 1;
  Object call7852 = callmethodflags(call7851, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7847);
// compiled call node returning call7852 (depth = 3)
  *var_result = call7852;
  if (call7852 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2681
  setline(2681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7855 == NULL) {
    strlit7855 = alloc_String("rgeneric");
    gc_root(strlit7855);
  }
// compiled string node returning strlit7855 (depth = 4)
  int op_slot_right_7854 = gc_frame_newslot(strlit7855);
// starting to compile member node (depth = 4)
  int callframe7857 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call7858 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7857);
// compiled member node returning call7858 (depth = 4)
  int op_slot_left_7854 = gc_frame_newslot(call7858);
  params[0] = strlit7855;
  partcv[0] = 1;
  Object opresult7859 = callmethod(call7858, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7859 (depth = 3)
  Object if7853 = done;
  if (istrue(opresult7859)) {
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7860 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7861 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call7862 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7861);
// compiled member node returning call7862 (depth = 5)
  partcv[0] = 0;
  Object call7863 = callmethodflags(call7862, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7860);
// compiled member node returning call7863 (depth = 4)
  *var_suggestion = call7863;
  if (call7863 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7864 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7865 == NULL) {
    strlit7865 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit7865);
  }
// compiled string node returning strlit7865 (depth = 4)
  gc_frame_newslot(strlit7865);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit7865;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7866 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7864);
// compiled call node returning call7866 (depth = 3)
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7867 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7868 == NULL) {
    strlit7868 = alloc_String("a list of type parameters starting with '""\xe2""""\x9f""""\xa6""' must end with '""\xe2""""\x9f""""\xa7""'.");
    gc_root(strlit7868);
  }
// compiled string node returning strlit7868 (depth = 4)
  gc_frame_newslot(strlit7868);
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7869 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call7870 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7869);
// compiled member node returning call7870 (depth = 4)
  gc_frame_newslot(call7870);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7872 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7873 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe7872);
// compiled member node returning call7873 (depth = 5)
  int op_slot_right_7871 = gc_frame_newslot(call7873);
// starting to compile member node (depth = 5)
  int callframe7875 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7876 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7875);
// compiled member node returning call7876 (depth = 5)
  int op_slot_left_7871 = gc_frame_newslot(call7876);
  params[0] = call7873;
  partcv[0] = 1;
  Object sum7877 = callmethod(call7876, "+(1)", 1, partcv, params);
// compiled op node returning sum7877 (depth = 4)
  gc_frame_newslot(sum7877);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit7868;
  params[1] = call7870;
  params[2] = sum7877;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7878 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7867);
// compiled call node returning call7878 (depth = 3)
    gc_frame_newslot(call7878);
    if7853 = call7878;
  } else {
  }
// compiled if node returning if7853 (depth = 2)
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7879 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7880 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7879);
// compiled member node returning call7880 (depth = 2)
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_7881_doimport(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 77, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doimport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_importSym = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "importSym");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_errorPos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "errorPos");
// definebindings:
// definebindings:
// definebindings:
  Object *var_p = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "p");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_name = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "name");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_anns = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "anns");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7883 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7884 == NULL) {
    strlit7884 = alloc_String("import");
    gc_root(strlit7884);
  }
// compiled string node returning strlit7884 (depth = 4)
  gc_frame_newslot(strlit7884);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit7884;
  partcv[0] = 1;
  Object call7885 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7883);
// compiled call node returning call7885 (depth = 3)
  Object if7882 = done;
  if (istrue(call7885)) {
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_importSym = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7886 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7887 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7886);
// compiled member node returning call7887 (depth = 3)
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7890 == NULL) {
    strlit7890 = alloc_String("string");
    gc_root(strlit7890);
  }
// compiled string node returning strlit7890 (depth = 5)
  int op_slot_right_7889 = gc_frame_newslot(strlit7890);
// starting to compile member node (depth = 5)
  int callframe7892 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7893 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7892);
// compiled member node returning call7893 (depth = 5)
  int op_slot_left_7889 = gc_frame_newslot(call7893);
  params[0] = strlit7890;
  partcv[0] = 1;
  Object opresult7894 = callmethod(call7893, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7894 (depth = 4)
  Object if7888 = done;
  if (istrue(opresult7894)) {
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7895 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7896 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call7897 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7896);
// compiled member node returning call7897 (depth = 6)
  partcv[0] = 0;
  Object call7898 = callmethodflags(call7897, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7895);
// compiled member node returning call7898 (depth = 5)
  *var_suggestion = call7898;
  if (call7898 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7902 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7903 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7902);
// compiled member node returning call7903 (depth = 7)
  int op_slot_right_7901 = gc_frame_newslot(call7903);
// starting to compile member node (depth = 7)
  int callframe7905 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7906 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7905);
// compiled member node returning call7906 (depth = 7)
  int op_slot_left_7901 = gc_frame_newslot(call7906);
  params[0] = call7903;
  partcv[0] = 1;
  Object opresult7907 = callmethod(call7906, "==(1)", 1, partcv, params);
// compiled op node returning opresult7907 (depth = 6)
  int op_slot_right_7900 = gc_frame_newslot(opresult7907);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7910 == NULL) {
    strlit7910 = alloc_String("identifier");
    gc_root(strlit7910);
  }
// compiled string node returning strlit7910 (depth = 7)
  int op_slot_right_7909 = gc_frame_newslot(strlit7910);
// starting to compile member node (depth = 7)
  int callframe7912 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7913 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7912);
// compiled member node returning call7913 (depth = 7)
  int op_slot_left_7909 = gc_frame_newslot(call7913);
  params[0] = strlit7910;
  partcv[0] = 1;
  Object opresult7914 = callmethod(call7913, "==(1)", 1, partcv, params);
// compiled op node returning opresult7914 (depth = 6)
  int op_slot_left_7900 = gc_frame_newslot(opresult7914);
  params[0] = opresult7907;
  partcv[0] = 1;
  Object opresult7915 = callmethod(opresult7914, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7915 (depth = 5)
  Object if7899 = done;
  if (istrue(opresult7915)) {
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7916 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7918 == NULL) {
    strlit7918 = alloc_String("""\x22""");
    gc_root(strlit7918);
  }
// compiled string node returning strlit7918 (depth = 7)
  int op_slot_right_7917 = gc_frame_newslot(strlit7918);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe7921 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7922 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe7921);
// compiled member node returning call7922 (depth = 8)
  int op_slot_right_7920 = gc_frame_newslot(call7922);
// starting to compile string node (depth = 8)
  if (strlit7924 == NULL) {
    strlit7924 = alloc_String("""\x22""");
    gc_root(strlit7924);
  }
// compiled string node returning strlit7924 (depth = 8)
  int op_slot_left_7920 = gc_frame_newslot(strlit7924);
  params[0] = call7922;
  partcv[0] = 1;
  Object opresult7925 = callmethod(strlit7924, "++(1)", 1, partcv, params);
// compiled op node returning opresult7925 (depth = 7)
  int op_slot_left_7917 = gc_frame_newslot(opresult7925);
  params[0] = strlit7918;
  partcv[0] = 1;
  Object opresult7926 = callmethod(opresult7925, "++(1)", 1, partcv, params);
// compiled op node returning opresult7926 (depth = 6)
  gc_frame_newslot(opresult7926);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult7926;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7927 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7916);
// compiled call node returning call7927 (depth = 5)
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7928 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7929 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7928);
// compiled member node returning call7929 (depth = 6)
  *var_errorPos = call7929;
  if (call7929 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7899 = done;
  } else {
// Begin line 2704
  setline(2704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7931 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7932 == NULL) {
    strlit7932 = alloc_String(" ""\x22""""\xc2""""\xab""module name""\xc2""""\xbb""""\x22""");
    gc_root(strlit7932);
  }
// compiled string node returning strlit7932 (depth = 6)
  gc_frame_newslot(strlit7932);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7932;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7933 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7931);
// compiled call node returning call7933 (depth = 5)
// Begin line 2705
  setline(2705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7935 = alloc_Float64(1);
// compiled num node returning num7935 (depth = 7)
  int op_slot_right_7934 = gc_frame_newslot(num7935);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe7938 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7939 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe7938);
// compiled member node returning call7939 (depth = 8)
  int op_slot_right_7937 = gc_frame_newslot(call7939);
// starting to compile member node (depth = 8)
  int callframe7941 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7942 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe7941);
// compiled member node returning call7942 (depth = 8)
  int op_slot_left_7937 = gc_frame_newslot(call7942);
  params[0] = call7939;
  partcv[0] = 1;
  Object sum7943 = callmethod(call7942, "+(1)", 1, partcv, params);
// compiled op node returning sum7943 (depth = 7)
  int op_slot_left_7934 = gc_frame_newslot(sum7943);
  params[0] = num7935;
  partcv[0] = 1;
  Object sum7944 = callmethod(sum7943, "+(1)", 1, partcv, params);
// compiled op node returning sum7944 (depth = 6)
  *var_errorPos = sum7944;
  if (sum7944 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7899 = done;
  }
// compiled if node returning if7899 (depth = 4)
// Begin line 2707
  setline(2707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7946 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7947 == NULL) {
    strlit7947 = alloc_String("an import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.");
    gc_root(strlit7947);
  }
// compiled string node returning strlit7947 (depth = 5)
  gc_frame_newslot(strlit7947);
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7948 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7949 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7948);
// compiled member node returning call7949 (depth = 5)
  gc_frame_newslot(call7949);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2707
  setline(2707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7947;
  params[1] = call7949;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7950 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7946);
// compiled call node returning call7950 (depth = 4)
    gc_frame_newslot(call7950);
    if7888 = call7950;
  } else {
  }
// compiled if node returning if7888 (depth = 3)
// Begin line 2710
  setline(2710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7951 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7952 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7951);
// compiled member node returning call7952 (depth = 3)
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7953 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call7954 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe7953);
// compiled member node returning call7954 (depth = 4)
  *var_p = call7954;
  if (call7954 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7958 == NULL) {
    strlit7958 = alloc_String("as");
    gc_root(strlit7958);
  }
// compiled string node returning strlit7958 (depth = 6)
  int op_slot_right_7957 = gc_frame_newslot(strlit7958);
// starting to compile member node (depth = 6)
  int callframe7960 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7961 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe7960);
// compiled member node returning call7961 (depth = 6)
  int op_slot_left_7957 = gc_frame_newslot(call7961);
  params[0] = strlit7958;
  partcv[0] = 1;
  Object opresult7962 = callmethod(call7961, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7962 (depth = 5)
  int op_slot_right_7956 = gc_frame_newslot(opresult7962);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7965 == NULL) {
    strlit7965 = alloc_String("identifier");
    gc_root(strlit7965);
  }
// compiled string node returning strlit7965 (depth = 6)
  int op_slot_right_7964 = gc_frame_newslot(strlit7965);
// starting to compile member node (depth = 6)
  int callframe7967 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7968 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7967);
// compiled member node returning call7968 (depth = 6)
  int op_slot_left_7964 = gc_frame_newslot(call7968);
  params[0] = strlit7965;
  partcv[0] = 1;
  Object opresult7969 = callmethod(call7968, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7969 (depth = 5)
  int op_slot_left_7956 = gc_frame_newslot(opresult7969);
  params[0] = opresult7962;
  partcv[0] = 1;
  Object opresult7970 = callmethod(opresult7969, "||(1)", 1, partcv, params);
// compiled op node returning opresult7970 (depth = 4)
  Object if7955 = done;
  if (istrue(opresult7970)) {
// Begin line 2713
  setline(2713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7971 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7972 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call7973 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe7972);
// compiled member node returning call7973 (depth = 6)
  partcv[0] = 0;
  Object call7974 = callmethodflags(call7973, "new", 1, partcv, params, 0);
  gc_frame_end(callframe7971);
// compiled member node returning call7974 (depth = 5)
  *var_suggestion = call7974;
  if (call7974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2714
  setline(2714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7978 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7979 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7978);
// compiled member node returning call7979 (depth = 7)
  int op_slot_right_7977 = gc_frame_newslot(call7979);
// starting to compile member node (depth = 7)
  int callframe7981 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7982 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe7981);
// compiled member node returning call7982 (depth = 7)
  int op_slot_left_7977 = gc_frame_newslot(call7982);
  params[0] = call7979;
  partcv[0] = 1;
  Object opresult7983 = callmethod(call7982, "==(1)", 1, partcv, params);
// compiled op node returning opresult7983 (depth = 6)
  int op_slot_right_7976 = gc_frame_newslot(opresult7983);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7986 == NULL) {
    strlit7986 = alloc_String("identifier");
    gc_root(strlit7986);
  }
// compiled string node returning strlit7986 (depth = 7)
  int op_slot_right_7985 = gc_frame_newslot(strlit7986);
// starting to compile member node (depth = 7)
  int callframe7988 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7989 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe7988);
// compiled member node returning call7989 (depth = 7)
  int op_slot_left_7985 = gc_frame_newslot(call7989);
  params[0] = strlit7986;
  partcv[0] = 1;
  Object opresult7990 = callmethod(call7989, "==(1)", 1, partcv, params);
// compiled op node returning opresult7990 (depth = 6)
  int op_slot_left_7976 = gc_frame_newslot(opresult7990);
  params[0] = opresult7983;
  partcv[0] = 1;
  Object opresult7991 = callmethod(opresult7990, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7991 (depth = 5)
  Object if7975 = done;
  if (istrue(opresult7991)) {
// Begin line 2715
  setline(2715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7992 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7993 == NULL) {
    strlit7993 = alloc_String(" as");
    gc_root(strlit7993);
  }
// compiled string node returning strlit7993 (depth = 6)
  gc_frame_newslot(strlit7993);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7993;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7994 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7992);
// compiled call node returning call7994 (depth = 5)
    gc_frame_newslot(call7994);
    if7975 = call7994;
  } else {
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7995 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7997 == NULL) {
    strlit7997 = alloc_String("");
    gc_root(strlit7997);
  }
// compiled string node returning strlit7997 (depth = 7)
  int op_slot_right_7996 = gc_frame_newslot(strlit7997);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe8000 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  partcv[0] = 0;
  Object call8001 = callmethodflags(*var_p, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8000);
// compiled member node returning call8001 (depth = 8)
  int op_slot_right_7999 = gc_frame_newslot(call8001);
// starting to compile string node (depth = 8)
  if (strlit8003 == NULL) {
    strlit8003 = alloc_String(" as ");
    gc_root(strlit8003);
  }
// compiled string node returning strlit8003 (depth = 8)
  int op_slot_left_7999 = gc_frame_newslot(strlit8003);
  params[0] = call8001;
  partcv[0] = 1;
  Object opresult8004 = callmethod(strlit8003, "++(1)", 1, partcv, params);
// compiled op node returning opresult8004 (depth = 7)
  int op_slot_left_7996 = gc_frame_newslot(opresult8004);
  params[0] = strlit7997;
  partcv[0] = 1;
  Object opresult8005 = callmethod(opresult8004, "++(1)", 1, partcv, params);
// compiled op node returning opresult8005 (depth = 6)
  gc_frame_newslot(opresult8005);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult8005;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8006 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7995);
// compiled call node returning call8006 (depth = 5)
    gc_frame_newslot(call8006);
    if7975 = call8006;
  }
// compiled if node returning if7975 (depth = 4)
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8007 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8008 == NULL) {
    strlit8008 = alloc_String("an import statement must have 'as', and an identifier after the name of the module in quotes.");
    gc_root(strlit8008);
  }
// compiled string node returning strlit8008 (depth = 5)
  gc_frame_newslot(strlit8008);
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8009 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8010 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8009);
// compiled member node returning call8010 (depth = 5)
  gc_frame_newslot(call8010);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8012 = alloc_Float64(1);
// compiled num node returning num8012 (depth = 6)
  int op_slot_right_8011 = gc_frame_newslot(num8012);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8015 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8016 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe8015);
// compiled member node returning call8016 (depth = 7)
  int op_slot_right_8014 = gc_frame_newslot(call8016);
// starting to compile member node (depth = 7)
  int callframe8018 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8019 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8018);
// compiled member node returning call8019 (depth = 7)
  int op_slot_left_8014 = gc_frame_newslot(call8019);
  params[0] = call8016;
  partcv[0] = 1;
  Object sum8020 = callmethod(call8019, "+(1)", 1, partcv, params);
// compiled op node returning sum8020 (depth = 6)
  int op_slot_left_8011 = gc_frame_newslot(sum8020);
  params[0] = num8012;
  partcv[0] = 1;
  Object sum8021 = callmethod(sum8020, "+(1)", 1, partcv, params);
// compiled op node returning sum8021 (depth = 5)
  gc_frame_newslot(sum8021);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8008;
  params[1] = call8010;
  params[2] = sum8021;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8022 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8007);
// compiled call node returning call8022 (depth = 4)
    gc_frame_newslot(call8022);
    if7955 = call8022;
  } else {
  }
// compiled if node returning if7955 (depth = 3)
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8023 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8024 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8023);
// compiled member node returning call8024 (depth = 3)
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8027 == NULL) {
    strlit8027 = alloc_String("identifier");
    gc_root(strlit8027);
  }
// compiled string node returning strlit8027 (depth = 5)
  int op_slot_right_8026 = gc_frame_newslot(strlit8027);
// starting to compile member node (depth = 5)
  int callframe8029 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8030 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8029);
// compiled member node returning call8030 (depth = 5)
  int op_slot_left_8026 = gc_frame_newslot(call8030);
  params[0] = strlit8027;
  partcv[0] = 1;
  Object opresult8031 = callmethod(call8030, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8031 (depth = 4)
  Object if8025 = done;
  if (istrue(opresult8031)) {
// Begin line 2724
  setline(2724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8032 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8033 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call8034 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe8033);
// compiled member node returning call8034 (depth = 6)
  partcv[0] = 0;
  Object call8035 = callmethodflags(call8034, "new", 1, partcv, params, 0);
  gc_frame_end(callframe8032);
// compiled member node returning call8035 (depth = 5)
  *var_suggestion = call8035;
  if (call8035 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8039 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8040 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8039);
// compiled member node returning call8040 (depth = 7)
  int op_slot_right_8038 = gc_frame_newslot(call8040);
// starting to compile member node (depth = 7)
  int callframe8042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8043 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8042);
// compiled member node returning call8043 (depth = 7)
  int op_slot_left_8038 = gc_frame_newslot(call8043);
  params[0] = call8040;
  partcv[0] = 1;
  Object opresult8044 = callmethod(call8043, "==(1)", 1, partcv, params);
// compiled op node returning opresult8044 (depth = 6)
  int op_slot_right_8037 = gc_frame_newslot(opresult8044);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8047 == NULL) {
    strlit8047 = alloc_String("string");
    gc_root(strlit8047);
  }
// compiled string node returning strlit8047 (depth = 7)
  int op_slot_right_8046 = gc_frame_newslot(strlit8047);
// starting to compile member node (depth = 7)
  int callframe8049 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8050 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8049);
// compiled member node returning call8050 (depth = 7)
  int op_slot_left_8046 = gc_frame_newslot(call8050);
  params[0] = strlit8047;
  partcv[0] = 1;
  Object opresult8051 = callmethod(call8050, "==(1)", 1, partcv, params);
// compiled op node returning opresult8051 (depth = 6)
  int op_slot_left_8037 = gc_frame_newslot(opresult8051);
  params[0] = opresult8044;
  partcv[0] = 1;
  Object opresult8052 = callmethod(opresult8051, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8052 (depth = 5)
  Object if8036 = done;
  if (istrue(opresult8052)) {
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8053 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8055 == NULL) {
    strlit8055 = alloc_String("");
    gc_root(strlit8055);
  }
// compiled string node returning strlit8055 (depth = 7)
  int op_slot_right_8054 = gc_frame_newslot(strlit8055);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe8058 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8059 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8058);
// compiled member node returning call8059 (depth = 8)
  int op_slot_right_8057 = gc_frame_newslot(call8059);
// starting to compile string node (depth = 8)
  if (strlit8061 == NULL) {
    strlit8061 = alloc_String("");
    gc_root(strlit8061);
  }
// compiled string node returning strlit8061 (depth = 8)
  int op_slot_left_8057 = gc_frame_newslot(strlit8061);
  params[0] = call8059;
  partcv[0] = 1;
  Object opresult8062 = callmethod(strlit8061, "++(1)", 1, partcv, params);
// compiled op node returning opresult8062 (depth = 7)
  int op_slot_left_8054 = gc_frame_newslot(opresult8062);
  params[0] = strlit8055;
  partcv[0] = 1;
  Object opresult8063 = callmethod(opresult8062, "++(1)", 1, partcv, params);
// compiled op node returning opresult8063 (depth = 6)
  gc_frame_newslot(opresult8063);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult8063;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8064 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8053);
// compiled call node returning call8064 (depth = 5)
// Begin line 2728
  setline(2728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8065 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8066 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8065);
// compiled member node returning call8066 (depth = 6)
  *var_errorPos = call8066;
  if (call8066 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8036 = done;
  } else {
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8068 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8070 == NULL) {
    strlit8070 = alloc_String("");
    gc_root(strlit8070);
  }
// compiled string node returning strlit8070 (depth = 7)
  int op_slot_right_8069 = gc_frame_newslot(strlit8070);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe8073 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  partcv[0] = 0;
  Object call8074 = callmethodflags(*var_p, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8073);
// compiled member node returning call8074 (depth = 8)
  int op_slot_right_8072 = gc_frame_newslot(call8074);
// starting to compile string node (depth = 8)
  if (strlit8076 == NULL) {
    strlit8076 = alloc_String(" ");
    gc_root(strlit8076);
  }
// compiled string node returning strlit8076 (depth = 8)
  int op_slot_left_8072 = gc_frame_newslot(strlit8076);
  params[0] = call8074;
  partcv[0] = 1;
  Object opresult8077 = callmethod(strlit8076, "++(1)", 1, partcv, params);
// compiled op node returning opresult8077 (depth = 7)
  int op_slot_left_8069 = gc_frame_newslot(opresult8077);
  params[0] = strlit8070;
  partcv[0] = 1;
  Object opresult8078 = callmethod(opresult8077, "++(1)", 1, partcv, params);
// compiled op node returning opresult8078 (depth = 6)
  gc_frame_newslot(opresult8078);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult8078;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8079 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8068);
// compiled call node returning call8079 (depth = 5)
// Begin line 2731
  setline(2731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8081 = alloc_Float64(1);
// compiled num node returning num8081 (depth = 7)
  int op_slot_right_8080 = gc_frame_newslot(num8081);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe8084 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8085 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe8084);
// compiled member node returning call8085 (depth = 8)
  int op_slot_right_8083 = gc_frame_newslot(call8085);
// starting to compile member node (depth = 8)
  int callframe8087 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8088 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8087);
// compiled member node returning call8088 (depth = 8)
  int op_slot_left_8083 = gc_frame_newslot(call8088);
  params[0] = call8085;
  partcv[0] = 1;
  Object sum8089 = callmethod(call8088, "+(1)", 1, partcv, params);
// compiled op node returning sum8089 (depth = 7)
  int op_slot_left_8080 = gc_frame_newslot(sum8089);
  params[0] = num8081;
  partcv[0] = 1;
  Object sum8090 = callmethod(sum8089, "+(1)", 1, partcv, params);
// compiled op node returning sum8090 (depth = 6)
  *var_errorPos = sum8090;
  if (sum8090 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8036 = done;
  }
// compiled if node returning if8036 (depth = 4)
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8092 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8093 == NULL) {
    strlit8093 = alloc_String("an import statement must have an identifier after 'as'.");
    gc_root(strlit8093);
  }
// compiled string node returning strlit8093 (depth = 5)
  gc_frame_newslot(strlit8093);
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8094 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8095 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8094);
// compiled member node returning call8095 (depth = 5)
  gc_frame_newslot(call8095);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8093;
  params[1] = call8095;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8096 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8092);
// compiled call node returning call8096 (depth = 4)
    gc_frame_newslot(call8096);
    if8025 = call8096;
  } else {
  }
// compiled if node returning if8025 (depth = 3)
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8097 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8098 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8097);
// compiled member node returning call8098 (depth = 3)
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8099 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call8100 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe8099);
// compiled member node returning call8100 (depth = 4)
  *var_name = call8100;
  if (call8100 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8101 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8102 = alloc_Boolean(1);
// compiled identifier node returning bool8102 (depth = 4)
  gc_frame_newslot(bool8102);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool8102;
  partcv[0] = 1;
  Object call8103 = callmethodflags(*var_name, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8101);
// compiled call node returning call8103 (depth = 3)
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8104 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8105 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8104);
// compiled member node returning call8105 (depth = 4)
  *var_dtype = call8105;
  if (call8105 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8106 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_importSym (depth = 5)
  gc_frame_newslot(*var_importSym);
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe8107 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe8108 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call8109 = callmethodflags(*var_p, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8108);
// compiled member node returning call8109 (depth = 6)
  gc_frame_newslot(call8109);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_name (depth = 6)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dtype (depth = 6)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8110 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8111 = callmethodflags(*var_ast, "importNode", 1, partcv, params, 0);
  gc_frame_end(callframe8110);
// compiled member node returning call8111 (depth = 6)
  params[0] = call8109;
  params[1] = *var_name;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call8112 = callmethodflags(call8111, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe8107);
// compiled call node returning call8112 (depth = 5)
  params[0] = *var_importSym;
  partcv[0] = 1;
  Object call8113 = callmethodflags(call8112, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8106);
// compiled call node returning call8113 (depth = 4)
  *var_o = call8113;
  if (call8113 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8114 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8115 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8114);
// compiled member node returning call8115 (depth = 4)
  *var_anns = call8115;
  if (call8115 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2742
  setline(2742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_8117 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool8119 = alloc_Boolean(0);
// compiled identifier node returning bool8119 (depth = 5)
  int op_slot_left_8117 = gc_frame_newslot(bool8119);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8120 = callmethod(bool8119, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8120 (depth = 4)
  Object if8116 = done;
  if (istrue(opresult8120)) {
// starting to compile call node (depth = 4)
  int callframe8121 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8122 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  partcv[0] = 0;
  Object call8123 = callmethodflags(*var_o, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe8122);
// compiled member node returning call8123 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8124 = callmethodflags(call8123, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8121);
// compiled call node returning call8124 (depth = 4)
    gc_frame_newslot(call8124);
    if8116 = call8124;
  } else {
  }
// compiled if node returning if8116 (depth = 3)
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8125 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8126 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8125);
// compiled call node returning call8126 (depth = 3)
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8127 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8128 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8127);
// compiled member node returning call8128 (depth = 3)
    gc_frame_newslot(call8128);
    if7882 = call8128;
  } else {
  }
// compiled if node returning if7882 (depth = 2)
  gc_frame_end(frame);
  return if7882;
}
Object meth_parser_8139__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 6)
  int callframe8140 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe8141 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8142 == NULL) {
    strlit8142 = alloc_String("rbrace");
    gc_root(strlit8142);
  }
// compiled string node returning strlit8142 (depth = 8)
  gc_frame_newslot(strlit8142);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = strlit8142;
  partcv[0] = 1;
  Object call8143 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8141);
// compiled call node returning call8143 (depth = 7)
  partcv[0] = 0;
  Object call8144 = callmethodflags(call8143, "not", 1, partcv, params, 0);
  gc_frame_end(callframe8140);
// compiled member node returning call8144 (depth = 6)
  gc_frame_end(frame);
  return call8144;
}
Object meth_parser_8153__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 7)
  int callframe8154 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning module_parser (depth = 8)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call8155 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8154);
// compiled call node returning call8155 (depth = 7)
  gc_frame_end(frame);
  return call8155;
}
Object meth_parser_8129_doreturn(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 78, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doreturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_retTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "retTok");
  Object *var_retval = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "retval");
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// definebindings:
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8131 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8132 == NULL) {
    strlit8132 = alloc_String("return");
    gc_root(strlit8132);
  }
// compiled string node returning strlit8132 (depth = 4)
  gc_frame_newslot(strlit8132);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8132;
  partcv[0] = 1;
  Object call8133 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8131);
// compiled call node returning call8133 (depth = 3)
  Object if8130 = done;
  if (istrue(call8133)) {
// Begin line 2751
  setline(2751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_retTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8134 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8135 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8134);
// compiled member node returning call8135 (depth = 3)
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_retval = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8138 = alloc_Block(NULL, NULL, "parser", 2754);
  gc_frame_newslot(block8138);
// method "_apply"
  block_savedest(block8138);
  Object closure8139 = createclosure(1, "_apply");
  setclosureframe(closure8139, stackframe);
  addtoclosure(closure8139, selfslot);
  struct UserObject *uo8139 = (struct UserObject*)block8138;
  uo8139->data[0] = (Object)closure8139;
  Method *meth_meth_parser_8139__apply = addmethod2pos(block8138, "_apply", &meth_parser_8139__apply, 0);
  int argcv_meth_parser_8139__apply[] = {0};
  meth_meth_parser_8139__apply->type = alloc_MethodType(1, argcv_meth_parser_8139__apply);
  meth_meth_parser_8139__apply->definitionModule = modulename;
  meth_meth_parser_8139__apply->definitionLine = 183;
// compiled block node returning block8138 (depth = 5)
  int op_slot_right_8137 = gc_frame_newslot(block8138);
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8147 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8148 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8147);
// compiled member node returning call8148 (depth = 5)
  int op_slot_left_8137 = gc_frame_newslot(call8148);
  params[0] = block8138;
  partcv[0] = 1;
  Object opresult8149 = callmethod(call8148, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8149 (depth = 4)
  Object if8136 = done;
  if (istrue(opresult8149)) {
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8151 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8152 = alloc_Block(NULL, NULL, "parser", 2755);
  gc_frame_newslot(block8152);
// method "_apply"
  block_savedest(block8152);
  Object closure8153 = createclosure(2, "_apply");
  setclosureframe(closure8153, stackframe);
  addtoclosure(closure8153, var_blocksOK);
  addtoclosure(closure8153, selfslot);
  struct UserObject *uo8153 = (struct UserObject*)block8152;
  uo8153->data[0] = (Object)closure8153;
  Method *meth_meth_parser_8153__apply = addmethod2pos(block8152, "_apply", &meth_parser_8153__apply, 0);
  int argcv_meth_parser_8153__apply[] = {0};
  meth_meth_parser_8153__apply->type = alloc_MethodType(1, argcv_meth_parser_8153__apply);
  meth_meth_parser_8153__apply->definitionModule = modulename;
  meth_meth_parser_8153__apply->definitionLine = 183;
// compiled block node returning block8152 (depth = 6)
  gc_frame_newslot(block8152);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block8152;
  partcv[0] = 1;
  Object call8157 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8151);
// compiled call node returning call8157 (depth = 5)
  Object if8150 = done;
  if (istrue(call8157)) {
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array8158 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8158 (depth = 6)
  *var_suggestions = array8158;
  if (array8158 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8159 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call8161 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe8160);
// compiled member node returning call8161 (depth = 7)
  partcv[0] = 0;
  Object call8162 = callmethodflags(call8161, "new", 1, partcv, params, 0);
  gc_frame_end(callframe8159);
// compiled member node returning call8162 (depth = 6)
  *var_suggestion = call8162;
  if (call8162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8163 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array8164 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit8165 == NULL) {
    strlit8165 = alloc_String("rbrace");
    gc_root(strlit8165);
  }
// compiled string node returning strlit8165 (depth = 8)
  params[0] = strlit8165;
  partcv[0] = 1;
  callmethodflags(array8164, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array8164 (depth = 7)
  gc_frame_newslot(array8164);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = array8164;
  partcv[0] = 1;
  Object call8166 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8163);
// compiled call node returning call8166 (depth = 6)
  *var_nextTok = call8166;
  if (call8166 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_8168 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_8168 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8170 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult8170 (depth = 6)
  Object if8167 = done;
  if (istrue(opresult8170)) {
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8171 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8172 == NULL) {
    strlit8172 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit8172);
  }
// compiled string node returning strlit8172 (depth = 7)
  gc_frame_newslot(strlit8172);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit8172;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8173 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8171);
// compiled call node returning call8173 (depth = 6)
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8174 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8175 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8174);
// compiled call node returning call8175 (depth = 6)
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8176 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8177 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8178 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe8177);
// compiled member node returning call8178 (depth = 8)
  partcv[0] = 0;
  Object call8179 = callmethodflags(call8178, "new", 1, partcv, params, 0);
  gc_frame_end(callframe8176);
// compiled member node returning call8179 (depth = 7)
  *var_suggestion = call8179;
  if (call8179 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8181 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool8182 = alloc_Boolean(1);
// compiled identifier node returning bool8182 (depth = 7)
  gc_frame_newslot(bool8182);
// starting to compile identifier node (depth = 7)
  Object bool8183 = alloc_Boolean(0);
// compiled identifier node returning bool8183 (depth = 7)
  gc_frame_newslot(bool8183);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool8182;
  params[2] = bool8183;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8184 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8181);
// compiled call node returning call8184 (depth = 6)
    gc_frame_newslot(call8184);
    if8167 = call8184;
  } else {
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8185 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe8186 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call8187 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe8186);
// compiled member node returning call8187 (depth = 7)
  gc_frame_newslot(call8187);
// starting to compile identifier node (depth = 7)
  Object bool8188 = alloc_Boolean(1);
// compiled identifier node returning bool8188 (depth = 7)
  gc_frame_newslot(bool8188);
// starting to compile identifier node (depth = 7)
  Object bool8189 = alloc_Boolean(0);
// compiled identifier node returning bool8189 (depth = 7)
  gc_frame_newslot(bool8189);
// starting to compile string node (depth = 7)
  if (strlit8190 == NULL) {
    strlit8190 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit8190);
  }
// compiled string node returning strlit8190 (depth = 7)
  gc_frame_newslot(strlit8190);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call8187;
  params[2] = bool8188;
  params[3] = bool8189;
  params[4] = strlit8190;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call8191 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe8185);
// compiled call node returning call8191 (depth = 6)
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8192 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8193 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8192);
// compiled call node returning call8193 (depth = 6)
// Begin line 2767
  setline(2767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8194 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8196 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe8195);
// compiled member node returning call8196 (depth = 8)
  partcv[0] = 0;
  Object call8197 = callmethodflags(call8196, "new", 1, partcv, params, 0);
  gc_frame_end(callframe8194);
// compiled member node returning call8197 (depth = 7)
  *var_suggestion = call8197;
  if (call8197 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8199 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe8200 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call8201 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe8200);
// compiled member node returning call8201 (depth = 7)
  gc_frame_newslot(call8201);
// starting to compile identifier node (depth = 7)
  Object bool8202 = alloc_Boolean(1);
// compiled identifier node returning bool8202 (depth = 7)
  gc_frame_newslot(bool8202);
// starting to compile identifier node (depth = 7)
  Object bool8203 = alloc_Boolean(0);
// compiled identifier node returning bool8203 (depth = 7)
  gc_frame_newslot(bool8203);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call8201;
  params[2] = bool8202;
  params[3] = bool8203;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8204 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8199);
// compiled call node returning call8204 (depth = 6)
    gc_frame_newslot(call8204);
    if8167 = call8204;
  }
// compiled if node returning if8167 (depth = 5)
// Begin line 2770
  setline(2770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8205 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8206 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8205);
// compiled call node returning call8206 (depth = 5)
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8207 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2772
  setline(2772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8209 == NULL) {
    strlit8209 = alloc_String("an expression or a newline after the word 'return'.");
    gc_root(strlit8209);
  }
// compiled string node returning strlit8209 (depth = 7)
  int op_slot_right_8208 = gc_frame_newslot(strlit8209);
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8211 == NULL) {
    strlit8211 = alloc_String("a return statement must have ");
    gc_root(strlit8211);
  }
// compiled string node returning strlit8211 (depth = 7)
  int op_slot_left_8208 = gc_frame_newslot(strlit8211);
  params[0] = strlit8209;
  partcv[0] = 1;
  Object opresult8212 = callmethod(strlit8211, "++(1)", 1, partcv, params);
// compiled op node returning opresult8212 (depth = 6)
  gc_frame_newslot(opresult8212);
// Begin line 2773
  setline(2773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8213 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8214 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8213);
// compiled member node returning call8214 (depth = 6)
  gc_frame_newslot(call8214);
// starting to compile member node (depth = 6)
  int callframe8215 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8216 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8215);
// compiled member node returning call8216 (depth = 6)
  gc_frame_newslot(call8216);
// starting to compile member node (depth = 6)
  int callframe8217 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8218 = callmethodflags(*var_sym, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe8217);
// compiled member node returning call8218 (depth = 6)
  gc_frame_newslot(call8218);
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult8212;
  params[1] = call8214;
  params[2] = call8216;
  params[3] = call8218;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call8219 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8207);
// compiled call node returning call8219 (depth = 5)
    gc_frame_newslot(call8219);
    if8150 = call8219;
  } else {
  }
// compiled if node returning if8150 (depth = 4)
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8220 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8221 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe8220);
// compiled member node returning call8221 (depth = 5)
  *var_retval = call8221;
  if (call8221 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8136 = done;
  } else {
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8223 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe8224 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8225 = callmethodflags(*var_ast, "noPosition", 1, partcv, params, 0);
  gc_frame_end(callframe8224);
// compiled member node returning call8225 (depth = 6)
  gc_frame_newslot(call8225);
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe8226 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8227 == NULL) {
    strlit8227 = alloc_String("done");
    gc_root(strlit8227);
  }
// compiled string node returning strlit8227 (depth = 7)
  gc_frame_newslot(strlit8227);
// starting to compile identifier node (depth = 7)
  Object bool8228 = alloc_Boolean(0);
// compiled identifier node returning bool8228 (depth = 7)
  gc_frame_newslot(bool8228);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8229 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call8230 = callmethodflags(*var_ast, "identifierNode", 1, partcv, params, 0);
  gc_frame_end(callframe8229);
// compiled member node returning call8230 (depth = 7)
  params[0] = strlit8227;
  params[1] = bool8228;
  partcv[0] = 2;
  Object call8231 = callmethodflags(call8230, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8226);
// compiled call node returning call8231 (depth = 6)
  params[0] = call8225;
  partcv[0] = 1;
  Object call8232 = callmethodflags(call8231, "setStart(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8223);
// compiled call node returning call8232 (depth = 5)
  *var_retval = call8232;
  if (call8232 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2779
  setline(2779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8234 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8235 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8236 = callmethodflags(*var_ast, "noPosition", 1, partcv, params, 0);
  gc_frame_end(callframe8235);
// compiled member node returning call8236 (depth = 5)
  gc_frame_newslot(call8236);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retval (depth = 5)
  params[0] = call8236;
  partcv[0] = 1;
  Object call8237 = callmethodflags(*var_retval, "end:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8234);
// compiled call node returning call8237 (depth = 4)
    gc_frame_newslot(call8237);
    if8136 = call8237;
  }
// compiled if node returning if8136 (depth = 3)
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8238 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8239 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retTok (depth = 5)
  partcv[0] = 0;
  Object call8240 = callmethodflags(*var_retTok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8239);
// compiled member node returning call8240 (depth = 4)
  gc_frame_newslot(call8240);
// starting to compile member node (depth = 4)
  int callframe8241 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retTok (depth = 5)
  partcv[0] = 0;
  Object call8242 = callmethodflags(*var_retTok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8241);
// compiled member node returning call8242 (depth = 4)
  gc_frame_newslot(call8242);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8240;
  params[1] = call8242;
  partcv[0] = 2;
  Object call8243 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8238);
// compiled call node returning call8243 (depth = 3)
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8244 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retval (depth = 5)
  gc_frame_newslot(*var_retval);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8245 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8246 = callmethodflags(*var_ast, "returnNode", 1, partcv, params, 0);
  gc_frame_end(callframe8245);
// compiled member node returning call8246 (depth = 5)
  params[0] = *var_retval;
  partcv[0] = 1;
  Object call8247 = callmethodflags(call8246, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8244);
// compiled call node returning call8247 (depth = 4)
  *var_o = call8247;
  if (call8247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8248 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8249 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8248);
// compiled call node returning call8249 (depth = 3)
    gc_frame_newslot(call8249);
    if8130 = call8249;
  } else {
  }
// compiled if node returning if8130 (depth = 2)
  gc_frame_end(frame);
  return if8130;
}
Object meth_parser_8250_domethodtype(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 79, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "domethodtype");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_methodTypeTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "methodTypeTok");
  Object *var_methNode = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "methNode");
  Object *var_dtype = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "dtype");
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
  Object *var_newLine = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "newLine");
// definebindings:
// definebindings:
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_methodTypeTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8251 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8252 = alloc_Boolean(1);
// compiled identifier node returning bool8252 (depth = 4)
  gc_frame_newslot(bool8252);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = bool8252;
  partcv[0] = 1;
  Object call8253 = callmethodflags(module_parser, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8251);
// compiled call node returning call8253 (depth = 3)
  *var_methNode = call8253;
  if (call8253 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe8254 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  partcv[0] = 0;
  Object call8255 = callmethodflags(*var_methNode, "dtype", 1, partcv, params, 0);
  gc_frame_end(callframe8254);
// compiled member node returning call8255 (depth = 3)
  *var_dtype = call8255;
  if (call8255 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8258 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methNode (depth = 5)
  partcv[0] = 0;
  Object call8259 = callmethodflags(*var_methNode, "dtype", 1, partcv, params, 0);
  gc_frame_end(callframe8258);
// compiled member node returning call8259 (depth = 4)
  int op_slot_right_8257 = gc_frame_newslot(call8259);
// starting to compile identifier node (depth = 4)
  Object bool8261 = alloc_Boolean(0);
// compiled identifier node returning bool8261 (depth = 4)
  int op_slot_left_8257 = gc_frame_newslot(bool8261);
  params[0] = call8259;
  partcv[0] = 1;
  Object opresult8262 = callmethod(bool8261, "==(1)", 1, partcv, params);
// compiled op node returning opresult8262 (depth = 3)
  Object if8256 = done;
  if (istrue(opresult8262)) {
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8263 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8264 == NULL) {
    strlit8264 = alloc_String("Done");
    gc_root(strlit8264);
  }
// compiled string node returning strlit8264 (depth = 5)
  gc_frame_newslot(strlit8264);
// starting to compile identifier node (depth = 5)
  Object bool8265 = alloc_Boolean(0);
// compiled identifier node returning bool8265 (depth = 5)
  gc_frame_newslot(bool8265);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8266 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8267 = callmethodflags(*var_ast, "identifierNode", 1, partcv, params, 0);
  gc_frame_end(callframe8266);
// compiled member node returning call8267 (depth = 5)
  params[0] = strlit8264;
  params[1] = bool8265;
  partcv[0] = 2;
  Object call8268 = callmethodflags(call8267, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8263);
// compiled call node returning call8268 (depth = 4)
  *var_dtype = call8268;
  if (call8268 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8256 = done;
  } else {
  }
// compiled if node returning if8256 (depth = 2)
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8270 = gc_frame_new();
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methodTypeTok (depth = 4)
  gc_frame_newslot(*var_methodTypeTok);
// call case 6: other requests
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8271 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8272 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methNode (depth = 6)
  partcv[0] = 0;
  Object call8273 = callmethodflags(*var_methNode, "signature", 1, partcv, params, 0);
  gc_frame_end(callframe8272);
// compiled member node returning call8273 (depth = 5)
  gc_frame_newslot(call8273);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8274 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8275 = callmethodflags(*var_ast, "methodTypeNode", 1, partcv, params, 0);
  gc_frame_end(callframe8274);
// compiled member node returning call8275 (depth = 5)
  params[0] = call8273;
  params[1] = *var_dtype;
  partcv[0] = 2;
  Object call8276 = callmethodflags(call8275, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8271);
// compiled call node returning call8276 (depth = 4)
  params[0] = *var_methodTypeTok;
  partcv[0] = 1;
  Object call8277 = callmethodflags(call8276, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8270);
// compiled call node returning call8277 (depth = 3)
  *var_o = call8277;
  if (call8277 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8278 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe8279 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  partcv[0] = 0;
  Object call8280 = callmethodflags(*var_methNode, "typeParams", 1, partcv, params, 0);
  gc_frame_end(callframe8279);
// compiled member node returning call8280 (depth = 3)
  gc_frame_newslot(call8280);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  params[0] = call8280;
  partcv[0] = 1;
  Object call8281 = callmethodflags(*var_o, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8278);
// compiled call node returning call8281 (depth = 2)
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8282 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8283 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8282);
// compiled call node returning call8283 (depth = 2)
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8284 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8285 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8284);
// compiled member node returning call8285 (depth = 2)
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8287 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8288 == NULL) {
    strlit8288 = alloc_String("semicolon");
    gc_root(strlit8288);
  }
// compiled string node returning strlit8288 (depth = 4)
  gc_frame_newslot(strlit8288);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8288;
  partcv[0] = 1;
  Object call8289 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8287);
// compiled call node returning call8289 (depth = 3)
  Object if8286 = done;
  if (istrue(call8289)) {
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8290 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8291 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8290);
// compiled member node returning call8291 (depth = 3)
    gc_frame_newslot(call8291);
    if8286 = call8291;
  } else {
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8293 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe8294 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8295 == NULL) {
    strlit8295 = alloc_String("rbrace");
    gc_root(strlit8295);
  }
// compiled string node returning strlit8295 (depth = 6)
  gc_frame_newslot(strlit8295);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit8295;
  partcv[0] = 1;
  Object call8296 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8294);
// compiled call node returning call8296 (depth = 5)
  partcv[0] = 0;
  Object call8297 = callmethodflags(call8296, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe8293);
// compiled call node returning call8297 (depth = 4)
  Object if8292 = done;
  if (istrue(call8297)) {
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8300 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8301 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8300);
// compiled member node returning call8301 (depth = 6)
  int op_slot_right_8299 = gc_frame_newslot(call8301);
// starting to compile member node (depth = 6)
  int callframe8303 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8304 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8303);
// compiled member node returning call8304 (depth = 6)
  int op_slot_left_8299 = gc_frame_newslot(call8304);
  params[0] = call8301;
  partcv[0] = 1;
  Object opresult8305 = callmethod(call8304, "==(1)", 1, partcv, params);
// compiled op node returning opresult8305 (depth = 5)
  Object if8298 = done;
  if (istrue(opresult8305)) {
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8306 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8307 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call8308 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe8307);
// compiled member node returning call8308 (depth = 7)
  partcv[0] = 0;
  Object call8309 = callmethodflags(call8308, "new", 1, partcv, params, 0);
  gc_frame_end(callframe8306);
// compiled member node returning call8309 (depth = 6)
  *var_suggestion = call8309;
  if (call8309 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8311 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8312 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8311);
// compiled member node returning call8312 (depth = 7)
  int op_slot_right_8310 = gc_frame_newslot(call8312);
// starting to compile call node (depth = 7)
  int callframe8314 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num8315 = alloc_Float64(1);
// compiled num node returning num8315 (depth = 8)
  gc_frame_newslot(num8315);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8317 = alloc_Float64(1);
// compiled num node returning num8317 (depth = 9)
  int op_slot_right_8316 = gc_frame_newslot(num8317);
// starting to compile member node (depth = 9)
  int callframe8319 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call8320 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8319);
// compiled member node returning call8320 (depth = 9)
  int op_slot_left_8316 = gc_frame_newslot(call8320);
  params[0] = num8317;
  partcv[0] = 1;
  Object diff8321 = callmethod(call8320, "-(1)", 1, partcv, params);
// compiled op node returning diff8321 (depth = 8)
  gc_frame_newslot(diff8321);
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe8322 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe8323 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8324 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8323);
// compiled member node returning call8324 (depth = 9)
  gc_frame_newslot(call8324);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe8325 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call8326 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe8325);
// compiled member node returning call8326 (depth = 9)
  params[0] = call8324;
  partcv[0] = 1;
  Object call8327 = callmethodflags(call8326, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8322);
// compiled call node returning call8327 (depth = 8)
  params[0] = num8315;
  params[1] = diff8321;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8328 = callmethodflags(call8327, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8314);
// compiled call node returning call8328 (depth = 7)
  int op_slot_left_8310 = gc_frame_newslot(call8328);
  params[0] = call8312;
  partcv[0] = 1;
  Object opresult8329 = callmethod(call8328, "++(1)", 1, partcv, params);
// compiled op node returning opresult8329 (depth = 6)
  *var_newLine = opresult8329;
  if (opresult8329 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2807
  setline(2807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8330 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8332 = alloc_Float64(0.1);
// compiled num node returning num8332 (depth = 7)
  int op_slot_right_8331 = gc_frame_newslot(num8332);
// starting to compile member node (depth = 7)
  int callframe8334 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8335 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8334);
// compiled member node returning call8335 (depth = 7)
  int op_slot_left_8331 = gc_frame_newslot(call8335);
  params[0] = num8332;
  partcv[0] = 1;
  Object sum8336 = callmethod(call8335, "+(1)", 1, partcv, params);
// compiled op node returning sum8336 (depth = 6)
  gc_frame_newslot(sum8336);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum8336;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call8337 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8330);
// compiled call node returning call8337 (depth = 5)
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8338 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool8339 = alloc_Boolean(1);
// compiled identifier node returning bool8339 (depth = 6)
  gc_frame_newslot(bool8339);
// starting to compile identifier node (depth = 6)
  Object bool8340 = alloc_Boolean(1);
// compiled identifier node returning bool8340 (depth = 6)
  gc_frame_newslot(bool8340);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool8339;
  params[2] = bool8340;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8341 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8338);
// compiled call node returning call8341 (depth = 5)
// Begin line 2809
  setline(2809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8342 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8343 == NULL) {
    strlit8343 = alloc_String("methods in a type literal must be on separate lines, or separated by semicolons.");
    gc_root(strlit8343);
  }
// compiled string node returning strlit8343 (depth = 6)
  gc_frame_newslot(strlit8343);
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8344 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8345 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8344);
// compiled member node returning call8345 (depth = 6)
  gc_frame_newslot(call8345);
// starting to compile member node (depth = 6)
  int callframe8346 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8347 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8346);
// compiled member node returning call8347 (depth = 6)
  gc_frame_newslot(call8347);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2809
  setline(2809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit8343;
  params[1] = call8345;
  params[2] = call8347;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8348 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8342);
// compiled call node returning call8348 (depth = 5)
    gc_frame_newslot(call8348);
    if8298 = call8348;
  } else {
  }
// compiled if node returning if8298 (depth = 4)
    gc_frame_newslot(if8298);
    if8292 = if8298;
  } else {
  }
// compiled if node returning if8292 (depth = 3)
    gc_frame_newslot(if8292);
    if8286 = if8292;
  }
// compiled if node returning if8286 (depth = 2)
  gc_frame_end(frame);
  return if8286;
}
Object meth_parser_8401__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 5)
  int callframe8402 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe8403 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8404 == NULL) {
    strlit8404 = alloc_String("rbrace");
    gc_root(strlit8404);
  }
// compiled string node returning strlit8404 (depth = 7)
  gc_frame_newslot(strlit8404);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit8404;
  partcv[0] = 1;
  Object call8405 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8403);
// compiled call node returning call8405 (depth = 6)
  partcv[0] = 0;
  Object call8406 = callmethodflags(call8405, "not", 1, partcv, params, 0);
  gc_frame_end(callframe8402);
// compiled member node returning call8406 (depth = 5)
  gc_frame_end(frame);
  return call8406;
}
Object meth_parser_8409__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_types = getfromclosure(closure, 1);
  Object *var_meths = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 2837
  setline(2837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8411 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8412 == NULL) {
    strlit8412 = alloc_String("type");
    gc_root(strlit8412);
  }
// compiled string node returning strlit8412 (depth = 7)
  gc_frame_newslot(strlit8412);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit8412;
  partcv[0] = 1;
  Object call8413 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8411);
// compiled call node returning call8413 (depth = 6)
  Object if8410 = done;
  if (istrue(call8413)) {
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8414 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8415 = callmethodflags(self, "typedec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8414);
// compiled member node returning call8415 (depth = 6)
// Begin line 2839
  setline(2839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8416 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe8417 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call8418 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe8417);
// compiled member node returning call8418 (depth = 7)
  gc_frame_newslot(call8418);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_types (depth = 7)
  params[0] = call8418;
  partcv[0] = 1;
  Object call8419 = callmethodflags(*var_types, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8416);
// compiled call node returning call8419 (depth = 6)
    gc_frame_newslot(call8419);
    if8410 = call8419;
  } else {
// Begin line 2841
  setline(2841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8420 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8421 = callmethodflags(self, "domethodtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8420);
// compiled member node returning call8421 (depth = 6)
// Begin line 2842
  setline(2842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8422 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe8423 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call8424 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe8423);
// compiled member node returning call8424 (depth = 7)
  gc_frame_newslot(call8424);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meths (depth = 7)
  params[0] = call8424;
  partcv[0] = 1;
  Object call8425 = callmethodflags(*var_meths, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8422);
// compiled call node returning call8425 (depth = 6)
    gc_frame_newslot(call8425);
    if8410 = call8425;
  }
// compiled if node returning if8410 (depth = 5)
  gc_frame_end(frame);
  return if8410;
}
Object meth_parser_8349_dotypeLiteral(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 80, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_typeLiteralTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "typeLiteralTok");
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
// definebindings:
// definebindings:
  Object *var_meths = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meths");
  Object *var_types = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "types");
  Object *var_mc = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mc");
  Object *var_t = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "t");
// definebindings:
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_typeLiteralTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8351 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8352 == NULL) {
    strlit8352 = alloc_String("type");
    gc_root(strlit8352);
  }
// compiled string node returning strlit8352 (depth = 4)
  gc_frame_newslot(strlit8352);
// starting to compile string node (depth = 4)
  if (strlit8353 == NULL) {
    strlit8353 = alloc_String("interface");
    gc_root(strlit8353);
  }
// compiled string node returning strlit8353 (depth = 4)
  gc_frame_newslot(strlit8353);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8352;
  params[1] = strlit8353;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8354 = callmethodflags(module_parser, "acceptKeyword(1)or(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8351);
// compiled call node returning call8354 (depth = 3)
  Object if8350 = done;
  if (istrue(call8354)) {
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8355 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8356 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8355);
// compiled member node returning call8356 (depth = 3)
// Begin line 2822
  setline(2822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8358 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe8359 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8360 == NULL) {
    strlit8360 = alloc_String("lbrace");
    gc_root(strlit8360);
  }
// compiled string node returning strlit8360 (depth = 6)
  gc_frame_newslot(strlit8360);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = strlit8360;
  partcv[0] = 1;
  Object call8361 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8359);
// compiled call node returning call8361 (depth = 5)
  partcv[0] = 0;
  Object call8362 = callmethodflags(call8361, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe8358);
// compiled call node returning call8362 (depth = 4)
  Object if8357 = done;
  if (istrue(call8362)) {
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8363 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8364 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call8365 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe8364);
// compiled member node returning call8365 (depth = 6)
  partcv[0] = 0;
  Object call8366 = callmethodflags(call8365, "new", 1, partcv, params, 0);
  gc_frame_end(callframe8363);
// compiled member node returning call8366 (depth = 5)
  *var_suggestion = call8366;
  if (call8366 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2824
  setline(2824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8367 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 5)
  if (strlit8368 == NULL) {
    strlit8368 = alloc_String("{");
    gc_root(strlit8368);
  }
// compiled string node returning strlit8368 (depth = 5)
  gc_frame_newslot(strlit8368);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = strlit8368;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8369 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8367);
// compiled call node returning call8369 (depth = 4)
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8370 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8372 == NULL) {
    strlit8372 = alloc_String(" literals must open with a brace.");
    gc_root(strlit8372);
  }
// compiled string node returning strlit8372 (depth = 6)
  int op_slot_right_8371 = gc_frame_newslot(strlit8372);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8375 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_typeLiteralTok (depth = 8)
  partcv[0] = 0;
  Object call8376 = callmethodflags(*var_typeLiteralTok, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8375);
// compiled member node returning call8376 (depth = 7)
  int op_slot_right_8374 = gc_frame_newslot(call8376);
// starting to compile string node (depth = 7)
  if (strlit8378 == NULL) {
    strlit8378 = alloc_String("");
    gc_root(strlit8378);
  }
// compiled string node returning strlit8378 (depth = 7)
  int op_slot_left_8374 = gc_frame_newslot(strlit8378);
  params[0] = call8376;
  partcv[0] = 1;
  Object opresult8379 = callmethod(strlit8378, "++(1)", 1, partcv, params);
// compiled op node returning opresult8379 (depth = 6)
  int op_slot_left_8371 = gc_frame_newslot(opresult8379);
  params[0] = strlit8372;
  partcv[0] = 1;
  Object opresult8380 = callmethod(opresult8379, "++(1)", 1, partcv, params);
// compiled op node returning opresult8380 (depth = 5)
  gc_frame_newslot(opresult8380);
// Begin line 2826
  setline(2826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8381 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8382 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8381);
// compiled member node returning call8382 (depth = 5)
  gc_frame_newslot(call8382);
// starting to compile member node (depth = 5)
  int callframe8383 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8384 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8383);
// compiled member node returning call8384 (depth = 5)
  gc_frame_newslot(call8384);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult8380;
  params[1] = call8382;
  params[2] = call8384;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8385 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8370);
// compiled call node returning call8385 (depth = 4)
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8357 = undefined;
  } else {
  }
// compiled if node returning if8357 (depth = 3)
    gc_frame_newslot(if8357);
    if8350 = if8357;
  } else {
  }
// compiled if node returning if8350 (depth = 2)
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8387 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8388 == NULL) {
    strlit8388 = alloc_String("lbrace");
    gc_root(strlit8388);
  }
// compiled string node returning strlit8388 (depth = 4)
  gc_frame_newslot(strlit8388);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8388;
  partcv[0] = 1;
  Object call8389 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8387);
// compiled call node returning call8389 (depth = 3)
  Object if8386 = done;
  if (istrue(call8389)) {
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8390 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8390 (depth = 4)
  *var_meths = array8390;
  if (array8390 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8391 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8391 (depth = 4)
  *var_types = array8391;
  if (array8391 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_auto_count (depth = 4)
  *var_mc = *var_auto_count;
  if (*var_auto_count == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8393 = alloc_Float64(1);
// compiled num node returning num8393 (depth = 5)
  int op_slot_right_8392 = gc_frame_newslot(num8393);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_8392 = gc_frame_newslot(*var_auto_count);
  params[0] = num8393;
  partcv[0] = 1;
  Object sum8395 = callmethod(*var_auto_count, "+(1)", 1, partcv, params);
// compiled op node returning sum8395 (depth = 4)
  *var_auto_count = sum8395;
  if (sum8395 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8397 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8398 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8397);
// compiled member node returning call8398 (depth = 3)
// Begin line 2836
  setline(2836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8399 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8400 = alloc_Block(NULL, NULL, "parser", 2836);
  gc_frame_newslot(block8400);
// method "_apply"
  block_savedest(block8400);
  Object closure8401 = createclosure(1, "_apply");
  setclosureframe(closure8401, stackframe);
  addtoclosure(closure8401, selfslot);
  struct UserObject *uo8401 = (struct UserObject*)block8400;
  uo8401->data[0] = (Object)closure8401;
  Method *meth_meth_parser_8401__apply = addmethod2pos(block8400, "_apply", &meth_parser_8401__apply, 0);
  int argcv_meth_parser_8401__apply[] = {0};
  meth_meth_parser_8401__apply->type = alloc_MethodType(1, argcv_meth_parser_8401__apply);
  meth_meth_parser_8401__apply->definitionModule = modulename;
  meth_meth_parser_8401__apply->definitionLine = 183;
// compiled block node returning block8400 (depth = 4)
  gc_frame_newslot(block8400);
// Begin line 2836
  setline(2836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block8408 = alloc_Block(NULL, NULL, "parser", 2836);
  gc_frame_newslot(block8408);
// method "_apply"
  block_savedest(block8408);
  Object closure8409 = createclosure(4, "_apply");
  setclosureframe(closure8409, stackframe);
  addtoclosure(closure8409, var_values);
  addtoclosure(closure8409, var_types);
  addtoclosure(closure8409, var_meths);
  addtoclosure(closure8409, selfslot);
  struct UserObject *uo8409 = (struct UserObject*)block8408;
  uo8409->data[0] = (Object)closure8409;
  Method *meth_meth_parser_8409__apply = addmethod2pos(block8408, "_apply", &meth_parser_8409__apply, 0);
  int argcv_meth_parser_8409__apply[] = {0};
  meth_meth_parser_8409__apply->type = alloc_MethodType(1, argcv_meth_parser_8409__apply);
  meth_meth_parser_8409__apply->definitionModule = modulename;
  meth_meth_parser_8409__apply->definitionLine = 183;
// compiled block node returning block8408 (depth = 4)
  gc_frame_newslot(block8408);
// call case 5: prelude request
  params[0] = block8400;
  params[1] = block8408;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8427 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8399);
// compiled call node returning call8427 (depth = 3)
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8428 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8429 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8428);
// compiled member node returning call8429 (depth = 3)
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8430 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8431 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralTok (depth = 5)
  partcv[0] = 0;
  Object call8432 = callmethodflags(*var_typeLiteralTok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8431);
// compiled member node returning call8432 (depth = 4)
  gc_frame_newslot(call8432);
// starting to compile member node (depth = 4)
  int callframe8433 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralTok (depth = 5)
  partcv[0] = 0;
  Object call8434 = callmethodflags(*var_typeLiteralTok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8433);
// compiled member node returning call8434 (depth = 4)
  gc_frame_newslot(call8434);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8432;
  params[1] = call8434;
  partcv[0] = 2;
  Object call8435 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8430);
// compiled call node returning call8435 (depth = 3)
// Begin line 2847
  setline(2847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8436 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meths (depth = 5)
  gc_frame_newslot(*var_meths);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_types (depth = 5)
  gc_frame_newslot(*var_types);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8437 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8438 = callmethodflags(*var_ast, "typeLiteralNode", 1, partcv, params, 0);
  gc_frame_end(callframe8437);
// compiled member node returning call8438 (depth = 5)
  params[0] = *var_meths;
  params[1] = *var_types;
  partcv[0] = 2;
  Object call8439 = callmethodflags(call8438, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8436);
// compiled call node returning call8439 (depth = 4)
  *var_t = call8439;
  if (call8439 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8440 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call8441 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8440);
// compiled call node returning call8441 (depth = 3)
    gc_frame_newslot(call8441);
    if8386 = call8441;
  } else {
  }
// compiled if node returning if8386 (depth = 2)
  gc_frame_end(frame);
  return if8386;
}
Object meth_parser_8531__apply_40_1_41_(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8534 == NULL) {
    strlit8534 = alloc_String("keyword");
    gc_root(strlit8534);
  }
// compiled string node returning strlit8534 (depth = 9)
  int op_slot_right_8533 = gc_frame_newslot(strlit8534);
// starting to compile member node (depth = 9)
  int callframe8536 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call8537 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8536);
// compiled member node returning call8537 (depth = 9)
  int op_slot_left_8533 = gc_frame_newslot(call8537);
  params[0] = strlit8534;
  partcv[0] = 1;
  Object opresult8538 = callmethod(call8537, "==(1)", 1, partcv, params);
// compiled op node returning opresult8538 (depth = 8)
  int op_slot_right_8532 = gc_frame_newslot(opresult8538);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8541 == NULL) {
    strlit8541 = alloc_String("lbrace");
    gc_root(strlit8541);
  }
// compiled string node returning strlit8541 (depth = 9)
  int op_slot_right_8540 = gc_frame_newslot(strlit8541);
// starting to compile member node (depth = 9)
  int callframe8543 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call8544 = callmethodflags(*var_t, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8543);
// compiled member node returning call8544 (depth = 9)
  int op_slot_left_8540 = gc_frame_newslot(call8544);
  params[0] = strlit8541;
  partcv[0] = 1;
  Object opresult8545 = callmethod(call8544, "==(1)", 1, partcv, params);
// compiled op node returning opresult8545 (depth = 8)
  int op_slot_left_8532 = gc_frame_newslot(opresult8545);
  params[0] = opresult8538;
  partcv[0] = 1;
  Object opresult8546 = callmethod(opresult8545, "||(1)", 1, partcv, params);
// compiled op node returning opresult8546 (depth = 7)
  gc_frame_end(frame);
  return opresult8546;
}
Object meth_parser_8552__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextTok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_8553 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_8553 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8555 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult8555 (depth = 7)
  gc_frame_end(frame);
  return opresult8555;
}
Object meth_parser_8442_typedec(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 81, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typedec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_noBlocks = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
// definebindings:
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// definebindings:
  Object *var_nt = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nt");
// definebindings:
// definebindings:
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
// definebindings:
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8444 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8445 == NULL) {
    strlit8445 = alloc_String("type");
    gc_root(strlit8445);
  }
// compiled string node returning strlit8445 (depth = 4)
  gc_frame_newslot(strlit8445);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8445;
  partcv[0] = 1;
  Object call8446 = callmethodflags(module_parser, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8444);
// compiled call node returning call8446 (depth = 3)
  Object if8443 = done;
  if (istrue(call8446)) {
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8447 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call8448 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8447);
// compiled member node returning call8448 (depth = 4)
  *var_line = call8448;
  if (call8448 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8449 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call8450 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8449);
// compiled member node returning call8450 (depth = 4)
  *var_pos = call8450;
  if (call8450 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8451 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8452 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8451);
// compiled member node returning call8452 (depth = 3)
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8455 == NULL) {
    strlit8455 = alloc_String("identifier");
    gc_root(strlit8455);
  }
// compiled string node returning strlit8455 (depth = 5)
  int op_slot_right_8454 = gc_frame_newslot(strlit8455);
// starting to compile member node (depth = 5)
  int callframe8457 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8458 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8457);
// compiled member node returning call8458 (depth = 5)
  int op_slot_left_8454 = gc_frame_newslot(call8458);
  params[0] = strlit8455;
  partcv[0] = 1;
  Object opresult8459 = callmethod(call8458, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8459 (depth = 4)
  Object if8453 = done;
  if (istrue(opresult8459)) {
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8460 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8461 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call8462 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe8461);
// compiled member node returning call8462 (depth = 6)
  partcv[0] = 0;
  Object call8463 = callmethodflags(call8462, "new", 1, partcv, params, 0);
  gc_frame_end(callframe8460);
// compiled member node returning call8463 (depth = 5)
  *var_suggestion = call8463;
  if (call8463 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8464 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8465 == NULL) {
    strlit8465 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit8465);
  }
// compiled string node returning strlit8465 (depth = 5)
  gc_frame_newslot(strlit8465);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8465;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8466 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8464);
// compiled call node returning call8466 (depth = 4)
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8467 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8468 == NULL) {
    strlit8468 = alloc_String("a type declaration must have a name after the 'type'.");
    gc_root(strlit8468);
  }
// compiled string node returning strlit8468 (depth = 5)
  gc_frame_newslot(strlit8468);
// Begin line 2862
  setline(2862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8469 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8470 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8469);
// compiled member node returning call8470 (depth = 5)
  gc_frame_newslot(call8470);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8472 = alloc_Float64(1);
// compiled num node returning num8472 (depth = 6)
  int op_slot_right_8471 = gc_frame_newslot(num8472);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8475 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8476 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe8475);
// compiled member node returning call8476 (depth = 7)
  int op_slot_right_8474 = gc_frame_newslot(call8476);
// starting to compile member node (depth = 7)
  int callframe8478 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8479 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8478);
// compiled member node returning call8479 (depth = 7)
  int op_slot_left_8474 = gc_frame_newslot(call8479);
  params[0] = call8476;
  partcv[0] = 1;
  Object sum8480 = callmethod(call8479, "+(1)", 1, partcv, params);
// compiled op node returning sum8480 (depth = 6)
  int op_slot_left_8471 = gc_frame_newslot(sum8480);
  params[0] = num8472;
  partcv[0] = 1;
  Object sum8481 = callmethod(sum8480, "+(1)", 1, partcv, params);
// compiled op node returning sum8481 (depth = 5)
  gc_frame_newslot(sum8481);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8468;
  params[1] = call8470;
  params[2] = sum8481;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8482 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8467);
// compiled call node returning call8482 (depth = 4)
    gc_frame_newslot(call8482);
    if8453 = call8482;
  } else {
  }
// compiled if node returning if8453 (depth = 3)
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8483 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8484 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8483);
// compiled member node returning call8484 (depth = 3)
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8485 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call8486 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8485);
// compiled call node returning call8486 (depth = 3)
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8487 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8488 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8489 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe8488);
// compiled member node returning call8489 (depth = 5)
  gc_frame_newslot(call8489);
// starting to compile identifier node (depth = 5)
  Object bool8490 = alloc_Boolean(0);
// compiled identifier node returning bool8490 (depth = 5)
  gc_frame_newslot(bool8490);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8491 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8492 = callmethodflags(*var_ast, "typeDecNode", 1, partcv, params, 0);
  gc_frame_end(callframe8491);
// compiled member node returning call8492 (depth = 5)
  params[0] = call8489;
  params[1] = bool8490;
  partcv[0] = 2;
  Object call8493 = callmethodflags(call8492, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8487);
// compiled call node returning call8493 (depth = 4)
  *var_nt = call8493;
  if (call8493 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8495 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8496 == NULL) {
    strlit8496 = alloc_String("lgeneric");
    gc_root(strlit8496);
  }
// compiled string node returning strlit8496 (depth = 5)
  gc_frame_newslot(strlit8496);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit8496;
  partcv[0] = 1;
  Object call8497 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8495);
// compiled call node returning call8497 (depth = 4)
  Object if8494 = done;
  if (istrue(call8497)) {
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8498 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8499 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8500 = callmethodflags(self, "typeparameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8499);
// compiled member node returning call8500 (depth = 5)
  gc_frame_newslot(call8500);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  params[0] = call8500;
  partcv[0] = 1;
  Object call8501 = callmethodflags(*var_nt, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8498);
// compiled call node returning call8501 (depth = 4)
    gc_frame_newslot(call8501);
    if8494 = call8501;
  } else {
  }
// compiled if node returning if8494 (depth = 3)
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8502 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8503 = alloc_Boolean(1);
// compiled identifier node returning bool8503 (depth = 4)
  gc_frame_newslot(bool8503);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8504 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  partcv[0] = 0;
  Object call8505 = callmethodflags(*var_nt, "name", 1, partcv, params, 0);
  gc_frame_end(callframe8504);
// compiled member node returning call8505 (depth = 4)
  params[0] = bool8503;
  partcv[0] = 1;
  Object call8506 = callmethodflags(call8505, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8502);
// compiled call node returning call8506 (depth = 3)
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8507 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8508 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8507);
// compiled member node returning call8508 (depth = 4)
  *var_anns = call8508;
  if (call8508 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8512 == NULL) {
    strlit8512 = alloc_String("=");
    gc_root(strlit8512);
  }
// compiled string node returning strlit8512 (depth = 6)
  int op_slot_right_8511 = gc_frame_newslot(strlit8512);
// starting to compile member node (depth = 6)
  int callframe8514 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8515 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8514);
// compiled member node returning call8515 (depth = 6)
  int op_slot_left_8511 = gc_frame_newslot(call8515);
  params[0] = strlit8512;
  partcv[0] = 1;
  Object opresult8516 = callmethod(call8515, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8516 (depth = 5)
  int op_slot_right_8510 = gc_frame_newslot(opresult8516);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8519 == NULL) {
    strlit8519 = alloc_String("op");
    gc_root(strlit8519);
  }
// compiled string node returning strlit8519 (depth = 6)
  int op_slot_right_8518 = gc_frame_newslot(strlit8519);
// starting to compile member node (depth = 6)
  int callframe8521 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8522 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8521);
// compiled member node returning call8522 (depth = 6)
  int op_slot_left_8518 = gc_frame_newslot(call8522);
  params[0] = strlit8519;
  partcv[0] = 1;
  Object opresult8523 = callmethod(call8522, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8523 (depth = 5)
  int op_slot_left_8510 = gc_frame_newslot(opresult8523);
  params[0] = opresult8516;
  partcv[0] = 1;
  Object opresult8524 = callmethod(opresult8523, "||(1)", 1, partcv, params);
// compiled op node returning opresult8524 (depth = 4)
  Object if8509 = done;
  if (istrue(opresult8524)) {
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8525 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8526 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call8527 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe8526);
// compiled member node returning call8527 (depth = 6)
  partcv[0] = 0;
  Object call8528 = callmethodflags(call8527, "new", 1, partcv, params, 0);
  gc_frame_end(callframe8525);
// compiled member node returning call8528 (depth = 5)
  *var_suggestion = call8528;
  if (call8528 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8529 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8530 = alloc_Block(NULL, NULL, "parser", 2872);
  gc_frame_newslot(block8530);
// method "_apply(_)"
  block_savedest(block8530);
  Object closure8531 = createclosure(1, "_apply(1)");
  setclosureframe(closure8531, stackframe);
  addtoclosure(closure8531, selfslot);
  struct UserObject *uo8531 = (struct UserObject*)block8530;
  uo8531->data[0] = (Object)closure8531;
  Method *meth_meth_parser_8531__apply_40_1_41_ = addmethod2pos(block8530, "_apply(1)", &meth_parser_8531__apply_40_1_41_, 0);
  int argcv_meth_parser_8531__apply_40_1_41_[] = {1};
  meth_meth_parser_8531__apply_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_8531__apply_40_1_41_);
  meth_meth_parser_8531__apply_40_1_41_->definitionModule = modulename;
  meth_meth_parser_8531__apply_40_1_41_->definitionLine = 183;
// compiled block node returning block8530 (depth = 6)
  gc_frame_newslot(block8530);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block8530;
  partcv[0] = 1;
  Object call8548 = callmethodflags(module_parser, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8529);
// compiled call node returning call8548 (depth = 5)
  *var_nextTok = call8548;
  if (call8548 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block8551 = alloc_Block(NULL, NULL, "parser", 2875);
  gc_frame_newslot(block8551);
// method "_apply"
  block_savedest(block8551);
  Object closure8552 = createclosure(3, "_apply");
  setclosureframe(closure8552, stackframe);
  addtoclosure(closure8552, var_sym);
  addtoclosure(closure8552, var_nextTok);
  addtoclosure(closure8552, selfslot);
  struct UserObject *uo8552 = (struct UserObject*)block8551;
  uo8552->data[0] = (Object)closure8552;
  Method *meth_meth_parser_8552__apply = addmethod2pos(block8551, "_apply", &meth_parser_8552__apply, 0);
  int argcv_meth_parser_8552__apply[] = {0};
  meth_meth_parser_8552__apply->type = alloc_MethodType(1, argcv_meth_parser_8552__apply);
  meth_meth_parser_8552__apply->definitionModule = modulename;
  meth_meth_parser_8552__apply->definitionLine = 183;
// compiled block node returning block8551 (depth = 6)
  int op_slot_right_8550 = gc_frame_newslot(block8551);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_8558 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool8560 = alloc_Boolean(0);
// compiled identifier node returning bool8560 (depth = 7)
  int op_slot_left_8558 = gc_frame_newslot(bool8560);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult8561 = callmethod(bool8560, "==(1)", 1, partcv, params);
// compiled op node returning opresult8561 (depth = 6)
  int op_slot_left_8550 = gc_frame_newslot(opresult8561);
  params[0] = block8551;
  partcv[0] = 1;
  Object opresult8562 = callmethod(opresult8561, "||(1)", 1, partcv, params);
// compiled op node returning opresult8562 (depth = 5)
  Object if8549 = done;
  if (istrue(opresult8562)) {
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8563 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8564 == NULL) {
    strlit8564 = alloc_String(" =");
    gc_root(strlit8564);
  }
// compiled string node returning strlit8564 (depth = 6)
  gc_frame_newslot(strlit8564);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8564;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8565 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8563);
// compiled call node returning call8565 (depth = 5)
    gc_frame_newslot(call8565);
    if8549 = call8565;
  } else {
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8566 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe8567 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call8568 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe8567);
// compiled member node returning call8568 (depth = 6)
  gc_frame_newslot(call8568);
// starting to compile string node (depth = 6)
  if (strlit8569 == NULL) {
    strlit8569 = alloc_String("=");
    gc_root(strlit8569);
  }
// compiled string node returning strlit8569 (depth = 6)
  gc_frame_newslot(strlit8569);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call8568;
  params[2] = strlit8569;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8570 = callmethodflags(*var_suggestion, "replaceTokenRange(2)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8566);
// compiled call node returning call8570 (depth = 5)
    gc_frame_newslot(call8570);
    if8549 = call8570;
  }
// compiled if node returning if8549 (depth = 4)
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8571 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8572 == NULL) {
    strlit8572 = alloc_String("a type declaration must have an '=' after the type name.");
    gc_root(strlit8572);
  }
// compiled string node returning strlit8572 (depth = 5)
  gc_frame_newslot(strlit8572);
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8573 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8574 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8573);
// compiled member node returning call8574 (depth = 5)
  gc_frame_newslot(call8574);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8576 = alloc_Float64(1);
// compiled num node returning num8576 (depth = 6)
  int op_slot_right_8575 = gc_frame_newslot(num8576);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8579 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8580 = callmethodflags(*var_lastToken, "size", 1, partcv, params, 0);
  gc_frame_end(callframe8579);
// compiled member node returning call8580 (depth = 7)
  int op_slot_right_8578 = gc_frame_newslot(call8580);
// starting to compile member node (depth = 7)
  int callframe8582 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8583 = callmethodflags(*var_lastToken, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8582);
// compiled member node returning call8583 (depth = 7)
  int op_slot_left_8578 = gc_frame_newslot(call8583);
  params[0] = call8580;
  partcv[0] = 1;
  Object sum8584 = callmethod(call8583, "+(1)", 1, partcv, params);
// compiled op node returning sum8584 (depth = 6)
  int op_slot_left_8575 = gc_frame_newslot(sum8584);
  params[0] = num8576;
  partcv[0] = 1;
  Object sum8585 = callmethod(sum8584, "+(1)", 1, partcv, params);
// compiled op node returning sum8585 (depth = 5)
  gc_frame_newslot(sum8585);
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8572;
  params[1] = call8574;
  params[2] = sum8585;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8586 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8571);
// compiled call node returning call8586 (depth = 4)
    gc_frame_newslot(call8586);
    if8509 = call8586;
  } else {
  }
// compiled if node returning if8509 (depth = 3)
// Begin line 2884
  setline(2884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8587 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8588 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8587);
// compiled member node returning call8588 (depth = 3)
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8590 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8591 == NULL) {
    strlit8591 = alloc_String("lbrace");
    gc_root(strlit8591);
  }
// compiled string node returning strlit8591 (depth = 5)
  gc_frame_newslot(strlit8591);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit8591;
  partcv[0] = 1;
  Object call8592 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8590);
// compiled call node returning call8592 (depth = 4)
  Object if8589 = done;
  if (istrue(call8592)) {
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8593 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8594 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8593);
// compiled member node returning call8594 (depth = 4)
    gc_frame_newslot(call8594);
    if8589 = call8594;
  } else {
// Begin line 2889
  setline(2889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8595 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noBlocks (depth = 5)
  gc_frame_newslot(*var_noBlocks);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call8596 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8595);
// compiled call node returning call8596 (depth = 4)
    gc_frame_newslot(call8596);
    if8589 = call8596;
  }
// compiled if node returning if8589 (depth = 3)
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8597 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8598 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call8599 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe8598);
// compiled member node returning call8599 (depth = 4)
  gc_frame_newslot(call8599);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  params[0] = call8599;
  partcv[0] = 1;
  Object call8600 = callmethodflags(*var_nt, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8597);
// compiled call node returning call8600 (depth = 3)
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_8602 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool8604 = alloc_Boolean(0);
// compiled identifier node returning bool8604 (depth = 5)
  int op_slot_left_8602 = gc_frame_newslot(bool8604);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8605 = callmethod(bool8604, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8605 (depth = 4)
  Object if8601 = done;
  if (istrue(opresult8605)) {
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8606 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8607 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nt (depth = 6)
  partcv[0] = 0;
  Object call8608 = callmethodflags(*var_nt, "annotations", 1, partcv, params, 0);
  gc_frame_end(callframe8607);
// compiled member node returning call8608 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8609 = callmethodflags(call8608, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8606);
// compiled call node returning call8609 (depth = 4)
    gc_frame_newslot(call8609);
    if8601 = call8609;
  } else {
  }
// compiled if node returning if8601 (depth = 3)
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8610 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  gc_frame_newslot(*var_nt);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_nt;
  partcv[0] = 1;
  Object call8611 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8610);
// compiled call node returning call8611 (depth = 3)
// Begin line 2896
  setline(2896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8612 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8613 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8612);
// compiled member node returning call8613 (depth = 3)
    gc_frame_newslot(call8613);
    if8443 = call8613;
  } else {
  }
// compiled if node returning if8443 (depth = 2)
  gc_frame_end(frame);
  return if8443;
}
Object meth_parser_8705__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_8707 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 12)
  int callframe8709 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call8710 = callmethodflags(*var_tok, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe8709);
// compiled member node returning call8710 (depth = 12)
  int op_slot_left_8707 = gc_frame_newslot(call8710);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult8711 = callmethod(call8710, "≥(1)", 1, partcv, params);
// compiled op node returning opresult8711 (depth = 11)
  int op_slot_right_8706 = gc_frame_newslot(opresult8711);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num8715 = alloc_Float64(1);
// compiled num node returning num8715 (depth = 13)
  int op_slot_right_8714 = gc_frame_newslot(num8715);
// starting to compile member node (depth = 13)
  int callframe8717 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  partcv[0] = 0;
  Object call8718 = callmethodflags(*var_tok, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe8717);
// compiled member node returning call8718 (depth = 13)
  int op_slot_left_8714 = gc_frame_newslot(call8718);
  params[0] = num8715;
  partcv[0] = 1;
  Object sum8719 = callmethod(call8718, "+(1)", 1, partcv, params);
// compiled op node returning sum8719 (depth = 12)
  int op_slot_right_8713 = gc_frame_newslot(sum8719);
// starting to compile member node (depth = 12)
  int callframe8721 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call8722 = callmethodflags(*var_tok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8721);
// compiled member node returning call8722 (depth = 12)
  int op_slot_left_8713 = gc_frame_newslot(call8722);
  params[0] = sum8719;
  partcv[0] = 1;
  Object opresult8723 = callmethod(call8722, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8723 (depth = 11)
  int op_slot_left_8706 = gc_frame_newslot(opresult8723);
  params[0] = opresult8711;
  partcv[0] = 1;
  Object opresult8724 = callmethod(opresult8723, "||(1)", 1, partcv, params);
// compiled op node returning opresult8724 (depth = 10)
  gc_frame_end(frame);
  return opresult8724;
}
Object meth_parser_8727__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe8728 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  partcv[0] = 0;
  Object call8729 = callmethodflags(*var_tok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe8728);
// compiled member node returning call8729 (depth = 11)
  *var_tok = call8729;
  if (call8729 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_8614_checkIndent(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 82, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_correctIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "correctIndent");
  Object *var_tok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "tok");
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  Object if8615 = done;
  if (istrue(*var_indentFreePass)) {
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool8616 = alloc_Boolean(0);
// compiled identifier node returning bool8616 (depth = 4)
  *var_indentFreePass = bool8616;
  if (bool8616 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8615 = done;
  } else {
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8620 == NULL) {
    strlit8620 = alloc_String("semicolon");
    gc_root(strlit8620);
  }
// compiled string node returning strlit8620 (depth = 5)
  int op_slot_right_8619 = gc_frame_newslot(strlit8620);
// starting to compile member node (depth = 5)
  int callframe8622 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8623 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8622);
// compiled member node returning call8623 (depth = 5)
  int op_slot_left_8619 = gc_frame_newslot(call8623);
  params[0] = strlit8620;
  partcv[0] = 1;
  Object opresult8624 = callmethod(call8623, "==(1)", 1, partcv, params);
// compiled op node returning opresult8624 (depth = 4)
  Object if8618 = done;
  if (istrue(opresult8624)) {
    gc_frame_newslot(done);
    if8618 = done;
  } else {
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 2906
  setline(2906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8628 == NULL) {
    strlit8628 = alloc_String("rsquare");
    gc_root(strlit8628);
  }
// compiled string node returning strlit8628 (depth = 7)
  int op_slot_right_8627 = gc_frame_newslot(strlit8628);
// starting to compile member node (depth = 7)
  int callframe8630 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8631 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8630);
// compiled member node returning call8631 (depth = 7)
  int op_slot_left_8627 = gc_frame_newslot(call8631);
  params[0] = strlit8628;
  partcv[0] = 1;
  Object opresult8632 = callmethod(call8631, "==(1)", 1, partcv, params);
// compiled op node returning opresult8632 (depth = 6)
  int op_slot_right_8626 = gc_frame_newslot(opresult8632);
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8636 == NULL) {
    strlit8636 = alloc_String("rparen");
    gc_root(strlit8636);
  }
// compiled string node returning strlit8636 (depth = 8)
  int op_slot_right_8635 = gc_frame_newslot(strlit8636);
// starting to compile member node (depth = 8)
  int callframe8638 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8639 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8638);
// compiled member node returning call8639 (depth = 8)
  int op_slot_left_8635 = gc_frame_newslot(call8639);
  params[0] = strlit8636;
  partcv[0] = 1;
  Object opresult8640 = callmethod(call8639, "==(1)", 1, partcv, params);
// compiled op node returning opresult8640 (depth = 7)
  int op_slot_right_8634 = gc_frame_newslot(opresult8640);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8643 == NULL) {
    strlit8643 = alloc_String("rbrace");
    gc_root(strlit8643);
  }
// compiled string node returning strlit8643 (depth = 8)
  int op_slot_right_8642 = gc_frame_newslot(strlit8643);
// starting to compile member node (depth = 8)
  int callframe8645 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8646 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8645);
// compiled member node returning call8646 (depth = 8)
  int op_slot_left_8642 = gc_frame_newslot(call8646);
  params[0] = strlit8643;
  partcv[0] = 1;
  Object opresult8647 = callmethod(call8646, "==(1)", 1, partcv, params);
// compiled op node returning opresult8647 (depth = 7)
  int op_slot_left_8634 = gc_frame_newslot(opresult8647);
  params[0] = opresult8640;
  partcv[0] = 1;
  Object opresult8648 = callmethod(opresult8647, "||(1)", 1, partcv, params);
// compiled op node returning opresult8648 (depth = 6)
  int op_slot_left_8626 = gc_frame_newslot(opresult8648);
  params[0] = opresult8632;
  partcv[0] = 1;
  Object opresult8649 = callmethod(opresult8648, "||(1)", 1, partcv, params);
// compiled op node returning opresult8649 (depth = 5)
  Object if8625 = done;
  if (istrue(opresult8649)) {
    gc_frame_newslot(done);
    if8625 = done;
  } else {
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8652 == NULL) {
    strlit8652 = alloc_String("eof");
    gc_root(strlit8652);
  }
// compiled string node returning strlit8652 (depth = 7)
  int op_slot_right_8651 = gc_frame_newslot(strlit8652);
// starting to compile member node (depth = 7)
  int callframe8654 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8655 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8654);
// compiled member node returning call8655 (depth = 7)
  int op_slot_left_8651 = gc_frame_newslot(call8655);
  params[0] = strlit8652;
  partcv[0] = 1;
  Object opresult8656 = callmethod(call8655, "==(1)", 1, partcv, params);
// compiled op node returning opresult8656 (depth = 6)
  Object if8650 = done;
  if (istrue(opresult8656)) {
    gc_frame_newslot(done);
    if8650 = done;
  } else {
// Begin line 2929
  setline(2929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minIndentLevel (depth = 8)
  int op_slot_right_8658 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 8)
  int callframe8660 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8661 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe8660);
// compiled member node returning call8661 (depth = 8)
  int op_slot_left_8658 = gc_frame_newslot(call8661);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult8662 = callmethod(call8661, "<(1)", 1, partcv, params);
// compiled op node returning opresult8662 (depth = 7)
  Object if8657 = done;
  if (istrue(opresult8662)) {
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_8664 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num8667 = alloc_Float64(1);
// compiled num node returning num8667 (depth = 10)
  int op_slot_right_8666 = gc_frame_newslot(num8667);
// starting to compile member node (depth = 10)
  int callframe8669 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call8670 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8669);
// compiled member node returning call8670 (depth = 10)
  int op_slot_left_8666 = gc_frame_newslot(call8670);
  params[0] = num8667;
  partcv[0] = 1;
  Object diff8671 = callmethod(call8670, "-(1)", 1, partcv, params);
// compiled op node returning diff8671 (depth = 9)
  int op_slot_left_8664 = gc_frame_newslot(diff8671);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult8672 = callmethod(diff8671, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8672 (depth = 8)
  Object if8663 = done;
  if (istrue(opresult8672)) {
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array8673 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8673 (depth = 9)
  *var_suggestions = array8673;
  if (array8673 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2912
  setline(2912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8674 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe8675 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call8676 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe8675);
// compiled member node returning call8676 (depth = 10)
  partcv[0] = 0;
  Object call8677 = callmethodflags(call8676, "new", 1, partcv, params, 0);
  gc_frame_end(callframe8674);
// compiled member node returning call8677 (depth = 9)
  *var_suggestion = call8677;
  if (call8677 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2913
  setline(2913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num8681 = alloc_Float64(1);
// compiled num node returning num8681 (depth = 12)
  int op_slot_right_8680 = gc_frame_newslot(num8681);
// starting to compile member node (depth = 12)
  int callframe8683 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call8684 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8683);
// compiled member node returning call8684 (depth = 12)
  int op_slot_left_8680 = gc_frame_newslot(call8684);
  params[0] = num8681;
  partcv[0] = 1;
  Object diff8685 = callmethod(call8684, "-(1)", 1, partcv, params);
// compiled op node returning diff8685 (depth = 11)
  int op_slot_right_8679 = gc_frame_newslot(diff8685);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_minIndentLevel (depth = 11)
  int op_slot_left_8679 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = diff8685;
  partcv[0] = 1;
  Object diff8687 = callmethod(*var_minIndentLevel, "-(1)", 1, partcv, params);
// compiled op node returning diff8687 (depth = 10)
  int op_slot_right_8678 = gc_frame_newslot(diff8687);
// starting to compile string node (depth = 10)
  if (strlit8689 == NULL) {
    strlit8689 = alloc_String(" ");
    gc_root(strlit8689);
  }
// compiled string node returning strlit8689 (depth = 10)
  int op_slot_left_8678 = gc_frame_newslot(strlit8689);
  params[0] = diff8687;
  partcv[0] = 1;
  Object prod8690 = callmethod(strlit8689, "*(1)", 1, partcv, params);
// compiled op node returning prod8690 (depth = 9)
  *var_correctIndent = prod8690;
  if (prod8690 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8691 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_correctIndent (depth = 9)
  gc_frame_newslot(*var_correctIndent);
// starting to compile num node (depth = 9)
  Object num8692 = alloc_Float64(1);
// compiled num node returning num8692 (depth = 9)
  gc_frame_newslot(num8692);
// starting to compile member node (depth = 9)
  int callframe8693 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8694 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8693);
// compiled member node returning call8694 (depth = 9)
  gc_frame_newslot(call8694);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_correctIndent;
  params[1] = num8692;
  params[2] = call8694;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8695 = callmethodflags(*var_suggestion, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8691);
// compiled call node returning call8695 (depth = 8)
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8696 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8697 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8696);
// compiled call node returning call8697 (depth = 8)
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8698 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe8699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call8700 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe8699);
// compiled member node returning call8700 (depth = 10)
  partcv[0] = 0;
  Object call8701 = callmethodflags(call8700, "new", 1, partcv, params, 0);
  gc_frame_end(callframe8698);
// compiled member node returning call8701 (depth = 9)
  *var_suggestion = call8701;
  if (call8701 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8703 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block8704 = alloc_Block(NULL, NULL, "parser", 2919);
  gc_frame_newslot(block8704);
// method "_apply"
  block_savedest(block8704);
  Object closure8705 = createclosure(3, "_apply");
  setclosureframe(closure8705, stackframe);
  addtoclosure(closure8705, var_minIndentLevel);
  addtoclosure(closure8705, var_tok);
  addtoclosure(closure8705, selfslot);
  struct UserObject *uo8705 = (struct UserObject*)block8704;
  uo8705->data[0] = (Object)closure8705;
  Method *meth_meth_parser_8705__apply = addmethod2pos(block8704, "_apply", &meth_parser_8705__apply, 0);
  int argcv_meth_parser_8705__apply[] = {0};
  meth_meth_parser_8705__apply->type = alloc_MethodType(1, argcv_meth_parser_8705__apply);
  meth_meth_parser_8705__apply->definitionModule = modulename;
  meth_meth_parser_8705__apply->definitionLine = 183;
// compiled block node returning block8704 (depth = 9)
  gc_frame_newslot(block8704);
// starting to compile block node (depth = 9)
  Object block8726 = alloc_Block(NULL, NULL, "parser", 2919);
  gc_frame_newslot(block8726);
// method "_apply"
  block_savedest(block8726);
  Object closure8727 = createclosure(2, "_apply");
  setclosureframe(closure8727, stackframe);
  addtoclosure(closure8727, var_tok);
  addtoclosure(closure8727, selfslot);
  struct UserObject *uo8727 = (struct UserObject*)block8726;
  uo8727->data[0] = (Object)closure8727;
  Method *meth_meth_parser_8727__apply = addmethod2pos(block8726, "_apply", &meth_parser_8727__apply, 0);
  int argcv_meth_parser_8727__apply[] = {0};
  meth_meth_parser_8727__apply->type = alloc_MethodType(1, argcv_meth_parser_8727__apply);
  meth_meth_parser_8727__apply->definitionModule = modulename;
  meth_meth_parser_8727__apply->definitionLine = 183;
// compiled block node returning block8726 (depth = 9)
  gc_frame_newslot(block8726);
// call case 5: prelude request
  params[0] = block8704;
  params[1] = block8726;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8732 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8703);
// compiled call node returning call8732 (depth = 8)
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8734 == NULL) {
    strlit8734 = alloc_String("}");
    gc_root(strlit8734);
  }
// compiled string node returning strlit8734 (depth = 10)
  int op_slot_right_8733 = gc_frame_newslot(strlit8734);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe8737 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  partcv[0] = 0;
  Object call8738 = callmethodflags(*var_tok, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe8737);
// compiled member node returning call8738 (depth = 11)
  int op_slot_right_8736 = gc_frame_newslot(call8738);
// starting to compile string node (depth = 11)
  if (strlit8740 == NULL) {
    strlit8740 = alloc_String(" ");
    gc_root(strlit8740);
  }
// compiled string node returning strlit8740 (depth = 11)
  int op_slot_left_8736 = gc_frame_newslot(strlit8740);
  params[0] = call8738;
  partcv[0] = 1;
  Object prod8741 = callmethod(strlit8740, "*(1)", 1, partcv, params);
// compiled op node returning prod8741 (depth = 10)
  int op_slot_left_8733 = gc_frame_newslot(prod8741);
  params[0] = strlit8734;
  partcv[0] = 1;
  Object opresult8742 = callmethod(prod8741, "++(1)", 1, partcv, params);
// compiled op node returning opresult8742 (depth = 9)
  *var_line = opresult8742;
  if (opresult8742 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8743 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num8745 = alloc_Float64(0.9);
// compiled num node returning num8745 (depth = 10)
  int op_slot_right_8744 = gc_frame_newslot(num8745);
// starting to compile member node (depth = 10)
  int callframe8747 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call8748 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8747);
// compiled member node returning call8748 (depth = 10)
  int op_slot_left_8744 = gc_frame_newslot(call8748);
  params[0] = num8745;
  partcv[0] = 1;
  Object diff8749 = callmethod(call8748, "-(1)", 1, partcv, params);
// compiled op node returning diff8749 (depth = 9)
  gc_frame_newslot(diff8749);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = diff8749;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call8750 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8743);
// compiled call node returning call8750 (depth = 8)
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8751 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8752 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8751);
// compiled call node returning call8752 (depth = 8)
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8753 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 2926
  setline(2926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8756 == NULL) {
    strlit8756 = alloc_String(". This is often caused by a missing '}'.");
    gc_root(strlit8756);
  }
// compiled string node returning strlit8756 (depth = 11)
  int op_slot_right_8755 = gc_frame_newslot(strlit8756);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_8758 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile string node (depth = 12)
  if (strlit8760 == NULL) {
    strlit8760 = alloc_String("at least ");
    gc_root(strlit8760);
  }
// compiled string node returning strlit8760 (depth = 12)
  int op_slot_left_8758 = gc_frame_newslot(strlit8760);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult8761 = callmethod(strlit8760, "++(1)", 1, partcv, params);
// compiled op node returning opresult8761 (depth = 11)
  int op_slot_left_8755 = gc_frame_newslot(opresult8761);
  params[0] = strlit8756;
  partcv[0] = 1;
  Object opresult8762 = callmethod(opresult8761, "++(1)", 1, partcv, params);
// compiled op node returning opresult8762 (depth = 10)
  int op_slot_right_8754 = gc_frame_newslot(opresult8762);
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit8764 == NULL) {
    strlit8764 = alloc_String("the indentation for this line must be ");
    gc_root(strlit8764);
  }
// compiled string node returning strlit8764 (depth = 10)
  int op_slot_left_8754 = gc_frame_newslot(strlit8764);
  params[0] = opresult8762;
  partcv[0] = 1;
  Object opresult8765 = callmethod(strlit8764, "++(1)", 1, partcv, params);
// compiled op node returning opresult8765 (depth = 9)
  gc_frame_newslot(opresult8765);
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe8766 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8767 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8766);
// compiled member node returning call8767 (depth = 9)
  gc_frame_newslot(call8767);
// starting to compile member node (depth = 9)
  int callframe8768 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8769 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8768);
// compiled member node returning call8769 (depth = 9)
  gc_frame_newslot(call8769);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult8765;
  params[1] = call8767;
  params[2] = call8769;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8770 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8753);
// compiled call node returning call8770 (depth = 8)
    gc_frame_newslot(call8770);
    if8663 = call8770;
  } else {
  }
// compiled if node returning if8663 (depth = 7)
    gc_frame_newslot(if8663);
    if8657 = if8663;
  } else {
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2929
  setline(2929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_8772 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 9)
  int callframe8774 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8775 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe8774);
// compiled member node returning call8775 (depth = 9)
  int op_slot_left_8772 = gc_frame_newslot(call8775);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult8776 = callmethod(call8775, ">(1)", 1, partcv, params);
// compiled op node returning opresult8776 (depth = 8)
  Object if8771 = done;
  if (istrue(opresult8776)) {
// Begin line 2932
  setline(2932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8777 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8778 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe8777);
// compiled member node returning call8778 (depth = 9)
  *var_minIndentLevel = call8778;
  if (call8778 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if8771 = done;
  } else {
  }
// compiled if node returning if8771 (depth = 7)
    gc_frame_newslot(if8771);
    if8657 = if8771;
  }
// compiled if node returning if8657 (depth = 6)
    gc_frame_newslot(if8657);
    if8650 = if8657;
  }
// compiled if node returning if8650 (depth = 5)
    gc_frame_newslot(if8650);
    if8625 = if8650;
  }
// compiled if node returning if8625 (depth = 4)
    gc_frame_newslot(if8625);
    if8618 = if8625;
  }
// compiled if node returning if8618 (depth = 3)
    gc_frame_newslot(if8618);
    if8615 = if8618;
  }
// compiled if node returning if8615 (depth = 2)
  gc_frame_end(frame);
  return if8615;
}
Object meth_parser_8879__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 6)
  int callframe8880 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blocksOK (depth = 7)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call8881 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8880);
// compiled call node returning call8881 (depth = 6)
  gc_frame_end(frame);
  return call8881;
}
Object meth_parser_8947__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile call node (depth = 8)
  int callframe8948 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning module_parser (depth = 9)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call8949 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8948);
// compiled call node returning call8949 (depth = 8)
  gc_frame_end(frame);
  return call8949;
}
Object meth_parser_8780_statement(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 83, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object *var_indentFreePass = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_dest = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "dest");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_oldLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "oldLine");
// definebindings:
// definebindings:
// definebindings:
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe8781 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call8782 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe8781);
// compiled member node returning call8782 (depth = 3)
  *var_statementIndent = call8782;
  if (call8782 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2946
  setline(2946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8785 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8786 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8785);
// compiled member node returning call8786 (depth = 2)
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8787 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8788 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8787);
// compiled member node returning call8788 (depth = 2)
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8790 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8791 == NULL) {
    strlit8791 = alloc_String("keyword");
    gc_root(strlit8791);
  }
// compiled string node returning strlit8791 (depth = 4)
  gc_frame_newslot(strlit8791);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8791;
  partcv[0] = 1;
  Object call8792 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8790);
// compiled call node returning call8792 (depth = 3)
  Object if8789 = done;
  if (istrue(call8792)) {
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8795 == NULL) {
    strlit8795 = alloc_String("var");
    gc_root(strlit8795);
  }
// compiled string node returning strlit8795 (depth = 5)
  int op_slot_right_8794 = gc_frame_newslot(strlit8795);
// starting to compile member node (depth = 5)
  int callframe8797 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8798 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8797);
// compiled member node returning call8798 (depth = 5)
  int op_slot_left_8794 = gc_frame_newslot(call8798);
  params[0] = strlit8795;
  partcv[0] = 1;
  Object opresult8799 = callmethod(call8798, "==(1)", 1, partcv, params);
// compiled op node returning opresult8799 (depth = 4)
  Object if8793 = done;
  if (istrue(opresult8799)) {
// Begin line 2950
  setline(2950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8800 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8801 = callmethodflags(self, "vardec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8800);
// compiled member node returning call8801 (depth = 4)
    gc_frame_newslot(call8801);
    if8793 = call8801;
  } else {
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8804 == NULL) {
    strlit8804 = alloc_String("def");
    gc_root(strlit8804);
  }
// compiled string node returning strlit8804 (depth = 6)
  int op_slot_right_8803 = gc_frame_newslot(strlit8804);
// starting to compile member node (depth = 6)
  int callframe8806 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8807 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8806);
// compiled member node returning call8807 (depth = 6)
  int op_slot_left_8803 = gc_frame_newslot(call8807);
  params[0] = strlit8804;
  partcv[0] = 1;
  Object opresult8808 = callmethod(call8807, "==(1)", 1, partcv, params);
// compiled op node returning opresult8808 (depth = 5)
  Object if8802 = done;
  if (istrue(opresult8808)) {
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8809 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8810 = callmethodflags(self, "defdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8809);
// compiled member node returning call8810 (depth = 5)
    gc_frame_newslot(call8810);
    if8802 = call8810;
  } else {
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8813 == NULL) {
    strlit8813 = alloc_String("import");
    gc_root(strlit8813);
  }
// compiled string node returning strlit8813 (depth = 7)
  int op_slot_right_8812 = gc_frame_newslot(strlit8813);
// starting to compile member node (depth = 7)
  int callframe8815 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8816 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8815);
// compiled member node returning call8816 (depth = 7)
  int op_slot_left_8812 = gc_frame_newslot(call8816);
  params[0] = strlit8813;
  partcv[0] = 1;
  Object opresult8817 = callmethod(call8816, "==(1)", 1, partcv, params);
// compiled op node returning opresult8817 (depth = 6)
  Object if8811 = done;
  if (istrue(opresult8817)) {
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8818 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8819 = callmethodflags(self, "doimport", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8818);
// compiled member node returning call8819 (depth = 6)
    gc_frame_newslot(call8819);
    if8811 = call8819;
  } else {
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8822 == NULL) {
    strlit8822 = alloc_String("dialect");
    gc_root(strlit8822);
  }
// compiled string node returning strlit8822 (depth = 8)
  int op_slot_right_8821 = gc_frame_newslot(strlit8822);
// starting to compile member node (depth = 8)
  int callframe8824 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8825 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8824);
// compiled member node returning call8825 (depth = 8)
  int op_slot_left_8821 = gc_frame_newslot(call8825);
  params[0] = strlit8822;
  partcv[0] = 1;
  Object opresult8826 = callmethod(call8825, "==(1)", 1, partcv, params);
// compiled op node returning opresult8826 (depth = 7)
  Object if8820 = done;
  if (istrue(opresult8826)) {
// Begin line 2956
  setline(2956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe8827 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8828 = callmethodflags(self, "dodialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8827);
// compiled member node returning call8828 (depth = 7)
    gc_frame_newslot(call8828);
    if8820 = call8828;
  } else {
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8831 == NULL) {
    strlit8831 = alloc_String("type");
    gc_root(strlit8831);
  }
// compiled string node returning strlit8831 (depth = 9)
  int op_slot_right_8830 = gc_frame_newslot(strlit8831);
// starting to compile member node (depth = 9)
  int callframe8833 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8834 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8833);
// compiled member node returning call8834 (depth = 9)
  int op_slot_left_8830 = gc_frame_newslot(call8834);
  params[0] = strlit8831;
  partcv[0] = 1;
  Object opresult8835 = callmethod(call8834, "==(1)", 1, partcv, params);
// compiled op node returning opresult8835 (depth = 8)
  Object if8829 = done;
  if (istrue(opresult8835)) {
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe8836 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8837 = callmethodflags(self, "typedec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8836);
// compiled member node returning call8837 (depth = 8)
    gc_frame_newslot(call8837);
    if8829 = call8837;
  } else {
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8840 == NULL) {
    strlit8840 = alloc_String("class");
    gc_root(strlit8840);
  }
// compiled string node returning strlit8840 (depth = 10)
  int op_slot_right_8839 = gc_frame_newslot(strlit8840);
// starting to compile member node (depth = 10)
  int callframe8842 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call8843 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8842);
// compiled member node returning call8843 (depth = 10)
  int op_slot_left_8839 = gc_frame_newslot(call8843);
  params[0] = strlit8840;
  partcv[0] = 1;
  Object opresult8844 = callmethod(call8843, "==(1)", 1, partcv, params);
// compiled op node returning opresult8844 (depth = 9)
  Object if8838 = done;
  if (istrue(opresult8844)) {
// Begin line 2960
  setline(2960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe8845 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8846 = callmethodflags(self, "doclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8845);
// compiled member node returning call8846 (depth = 9)
    gc_frame_newslot(call8846);
    if8838 = call8846;
  } else {
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8849 == NULL) {
    strlit8849 = alloc_String("trait");
    gc_root(strlit8849);
  }
// compiled string node returning strlit8849 (depth = 11)
  int op_slot_right_8848 = gc_frame_newslot(strlit8849);
// starting to compile member node (depth = 11)
  int callframe8851 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call8852 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8851);
// compiled member node returning call8852 (depth = 11)
  int op_slot_left_8848 = gc_frame_newslot(call8852);
  params[0] = strlit8849;
  partcv[0] = 1;
  Object opresult8853 = callmethod(call8852, "==(1)", 1, partcv, params);
// compiled op node returning opresult8853 (depth = 10)
  Object if8847 = done;
  if (istrue(opresult8853)) {
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe8854 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8855 = callmethodflags(self, "doclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8854);
// compiled member node returning call8855 (depth = 10)
    gc_frame_newslot(call8855);
    if8847 = call8855;
  } else {
// Begin line 2965
  setline(2965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit8858 == NULL) {
    strlit8858 = alloc_String("factory");
    gc_root(strlit8858);
  }
// compiled string node returning strlit8858 (depth = 12)
  int op_slot_right_8857 = gc_frame_newslot(strlit8858);
// starting to compile member node (depth = 12)
  int callframe8860 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call8861 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8860);
// compiled member node returning call8861 (depth = 12)
  int op_slot_left_8857 = gc_frame_newslot(call8861);
  params[0] = strlit8858;
  partcv[0] = 1;
  Object opresult8862 = callmethod(call8861, "==(1)", 1, partcv, params);
// compiled op node returning opresult8862 (depth = 11)
  Object if8856 = done;
  if (istrue(opresult8862)) {
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
  int callframe8863 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8864 = callmethodflags(self, "dofactoryMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8863);
// compiled member node returning call8864 (depth = 11)
    gc_frame_newslot(call8864);
    if8856 = call8864;
  } else {
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 2965
  setline(2965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit8867 == NULL) {
    strlit8867 = alloc_String("return");
    gc_root(strlit8867);
  }
// compiled string node returning strlit8867 (depth = 13)
  int op_slot_right_8866 = gc_frame_newslot(strlit8867);
// starting to compile member node (depth = 13)
  int callframe8869 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call8870 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe8869);
// compiled member node returning call8870 (depth = 13)
  int op_slot_left_8866 = gc_frame_newslot(call8870);
  params[0] = strlit8867;
  partcv[0] = 1;
  Object opresult8871 = callmethod(call8870, "==(1)", 1, partcv, params);
// compiled op node returning opresult8871 (depth = 12)
  Object if8865 = done;
  if (istrue(opresult8871)) {
// Begin line 2966
  setline(2966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
  int callframe8872 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8873 = callmethodflags(self, "doreturn", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8872);
// compiled member node returning call8873 (depth = 12)
    gc_frame_newslot(call8873);
    if8865 = call8873;
  } else {
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe8874 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning module_parser (depth = 13)
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call8875 = callmethodflags(module_parser, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8874);
// compiled call node returning call8875 (depth = 12)
    gc_frame_newslot(call8875);
    if8865 = call8875;
  }
// compiled if node returning if8865 (depth = 11)
    gc_frame_newslot(if8865);
    if8856 = if8865;
  }
// compiled if node returning if8856 (depth = 10)
    gc_frame_newslot(if8856);
    if8847 = if8856;
  }
// compiled if node returning if8847 (depth = 9)
    gc_frame_newslot(if8847);
    if8838 = if8847;
  }
// compiled if node returning if8838 (depth = 8)
    gc_frame_newslot(if8838);
    if8829 = if8838;
  }
// compiled if node returning if8829 (depth = 7)
    gc_frame_newslot(if8829);
    if8820 = if8829;
  }
// compiled if node returning if8820 (depth = 6)
    gc_frame_newslot(if8820);
    if8811 = if8820;
  }
// compiled if node returning if8811 (depth = 5)
    gc_frame_newslot(if8811);
    if8802 = if8811;
  }
// compiled if node returning if8802 (depth = 4)
    gc_frame_newslot(if8802);
    if8793 = if8802;
  }
// compiled if node returning if8793 (depth = 3)
    gc_frame_newslot(if8793);
    if8789 = if8793;
  } else {
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8877 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8878 = alloc_Block(NULL, NULL, "parser", 2971);
  gc_frame_newslot(block8878);
// method "_apply"
  block_savedest(block8878);
  Object closure8879 = createclosure(2, "_apply");
  setclosureframe(closure8879, stackframe);
  addtoclosure(closure8879, var_blocksOK);
  addtoclosure(closure8879, selfslot);
  struct UserObject *uo8879 = (struct UserObject*)block8878;
  uo8879->data[0] = (Object)closure8879;
  Method *meth_meth_parser_8879__apply = addmethod2pos(block8878, "_apply", &meth_parser_8879__apply, 0);
  int argcv_meth_parser_8879__apply[] = {0};
  meth_meth_parser_8879__apply->type = alloc_MethodType(1, argcv_meth_parser_8879__apply);
  meth_meth_parser_8879__apply->definitionModule = modulename;
  meth_meth_parser_8879__apply->definitionLine = 183;
// compiled block node returning block8878 (depth = 5)
  gc_frame_newslot(block8878);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = block8878;
  partcv[0] = 1;
  Object call8883 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8877);
// compiled call node returning call8883 (depth = 4)
  Object if8876 = done;
  if (istrue(call8883)) {
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8886 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8887 == NULL) {
    strlit8887 = alloc_String("bind");
    gc_root(strlit8887);
  }
// compiled string node returning strlit8887 (depth = 7)
  gc_frame_newslot(strlit8887);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = strlit8887;
  partcv[0] = 1;
  Object call8888 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8886);
// compiled call node returning call8888 (depth = 6)
  int op_slot_right_8885 = gc_frame_newslot(call8888);
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8892 == NULL) {
    strlit8892 = alloc_String("member");
    gc_root(strlit8892);
  }
// compiled string node returning strlit8892 (depth = 8)
  int op_slot_right_8891 = gc_frame_newslot(strlit8892);
// starting to compile member node (depth = 8)
  int callframe8894 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe8895 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8896 = callmethodflags(*var_values, "last", 1, partcv, params, 0);
  gc_frame_end(callframe8895);
// compiled member node returning call8896 (depth = 9)
  partcv[0] = 0;
  Object call8897 = callmethodflags(call8896, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8894);
// compiled member node returning call8897 (depth = 8)
  int op_slot_left_8891 = gc_frame_newslot(call8897);
  params[0] = strlit8892;
  partcv[0] = 1;
  Object opresult8898 = callmethod(call8897, "==(1)", 1, partcv, params);
// compiled op node returning opresult8898 (depth = 7)
  int op_slot_right_8890 = gc_frame_newslot(opresult8898);
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8901 == NULL) {
    strlit8901 = alloc_String("identifier");
    gc_root(strlit8901);
  }
// compiled string node returning strlit8901 (depth = 8)
  int op_slot_right_8900 = gc_frame_newslot(strlit8901);
// starting to compile member node (depth = 8)
  int callframe8903 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe8904 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8905 = callmethodflags(*var_values, "last", 1, partcv, params, 0);
  gc_frame_end(callframe8904);
// compiled member node returning call8905 (depth = 9)
  partcv[0] = 0;
  Object call8906 = callmethodflags(call8905, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8903);
// compiled member node returning call8906 (depth = 8)
  int op_slot_left_8900 = gc_frame_newslot(call8906);
  params[0] = strlit8901;
  partcv[0] = 1;
  Object opresult8907 = callmethod(call8906, "==(1)", 1, partcv, params);
// compiled op node returning opresult8907 (depth = 7)
  int op_slot_left_8890 = gc_frame_newslot(opresult8907);
  params[0] = opresult8898;
  partcv[0] = 1;
  Object opresult8908 = callmethod(opresult8907, "||(1)", 1, partcv, params);
// compiled op node returning opresult8908 (depth = 6)
  int op_slot_left_8885 = gc_frame_newslot(opresult8908);
  params[0] = call8888;
  partcv[0] = 1;
  Object opresult8909 = callmethod(opresult8908, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8909 (depth = 5)
  Object if8884 = done;
  if (istrue(opresult8909)) {
// Begin line 2975
  setline(2975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8910 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call8911 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe8910);
// compiled member node returning call8911 (depth = 6)
  *var_dest = call8911;
  if (call8911 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8914 == NULL) {
    strlit8914 = alloc_String("lbrace");
    gc_root(strlit8914);
  }
// compiled string node returning strlit8914 (depth = 7)
  int op_slot_right_8913 = gc_frame_newslot(strlit8914);
// starting to compile member node (depth = 7)
  int callframe8916 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_dest (depth = 8)
  partcv[0] = 0;
  Object call8917 = callmethodflags(*var_dest, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe8916);
// compiled member node returning call8917 (depth = 7)
  int op_slot_left_8913 = gc_frame_newslot(call8917);
  params[0] = strlit8914;
  partcv[0] = 1;
  Object opresult8918 = callmethod(call8917, "==(1)", 1, partcv, params);
// compiled op node returning opresult8918 (depth = 6)
  Object if8912 = done;
  if (istrue(opresult8918)) {
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8920 == NULL) {
    strlit8920 = alloc_String("");
    gc_root(strlit8920);
  }
// compiled string node returning strlit8920 (depth = 8)
  int op_slot_right_8919 = gc_frame_newslot(strlit8920);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8923 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8924 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8923);
// compiled member node returning call8924 (depth = 9)
  int op_slot_right_8922 = gc_frame_newslot(call8924);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8927 == NULL) {
    strlit8927 = alloc_String(", sym.line = ");
    gc_root(strlit8927);
  }
// compiled string node returning strlit8927 (depth = 10)
  int op_slot_right_8926 = gc_frame_newslot(strlit8927);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_8929 = gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 11)
  if (strlit8931 == NULL) {
    strlit8931 = alloc_String("sym = ");
    gc_root(strlit8931);
  }
// compiled string node returning strlit8931 (depth = 11)
  int op_slot_left_8929 = gc_frame_newslot(strlit8931);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8932 = callmethod(strlit8931, "++(1)", 1, partcv, params);
// compiled op node returning opresult8932 (depth = 10)
  int op_slot_left_8926 = gc_frame_newslot(opresult8932);
  params[0] = strlit8927;
  partcv[0] = 1;
  Object opresult8933 = callmethod(opresult8932, "++(1)", 1, partcv, params);
// compiled op node returning opresult8933 (depth = 9)
  int op_slot_left_8922 = gc_frame_newslot(opresult8933);
  params[0] = call8924;
  partcv[0] = 1;
  Object opresult8934 = callmethod(opresult8933, "++(1)", 1, partcv, params);
// compiled op node returning opresult8934 (depth = 8)
  int op_slot_left_8919 = gc_frame_newslot(opresult8934);
  params[0] = strlit8920;
  partcv[0] = 1;
  Object opresult8935 = callmethod(opresult8934, "++(1)", 1, partcv, params);
// compiled op node returning opresult8935 (depth = 7)
  params[0] = opresult8935;
  Object call8936 = gracelib_print(NULL, 1,  params);
// compiled call node returning call8936 (depth = 6)
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8937 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8938 == NULL) {
    strlit8938 = alloc_String("popped lbrace token while parsing statement");
    gc_root(strlit8938);
  }
// compiled string node returning strlit8938 (depth = 7)
  gc_frame_newslot(strlit8938);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8939 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8940 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8939);
// compiled member node returning call8940 (depth = 7)
  params[0] = strlit8938;
  partcv[0] = 1;
  Object call8941 = callmethodflags(call8940, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8937);
// compiled call node returning call8941 (depth = 6)
    gc_frame_newslot(call8941);
    if8912 = call8941;
  } else {
  }
// compiled if node returning if8912 (depth = 5)
// Begin line 2980
  setline(2980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8942 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8943 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8942);
// compiled member node returning call8943 (depth = 5)
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8945 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block8946 = alloc_Block(NULL, NULL, "parser", 2981);
  gc_frame_newslot(block8946);
// method "_apply"
  block_savedest(block8946);
  Object closure8947 = createclosure(2, "_apply");
  setclosureframe(closure8947, stackframe);
  addtoclosure(closure8947, var_blocksOK);
  addtoclosure(closure8947, selfslot);
  struct UserObject *uo8947 = (struct UserObject*)block8946;
  uo8947->data[0] = (Object)closure8947;
  Method *meth_meth_parser_8947__apply = addmethod2pos(block8946, "_apply", &meth_parser_8947__apply, 0);
  int argcv_meth_parser_8947__apply[] = {0};
  meth_meth_parser_8947__apply->type = alloc_MethodType(1, argcv_meth_parser_8947__apply);
  meth_meth_parser_8947__apply->definitionModule = modulename;
  meth_meth_parser_8947__apply->definitionLine = 183;
// compiled block node returning block8946 (depth = 7)
  gc_frame_newslot(block8946);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning module_parser (depth = 7)
  params[0] = block8946;
  partcv[0] = 1;
  Object call8951 = callmethodflags(module_parser, "didNotConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8945);
// compiled call node returning call8951 (depth = 6)
  Object if8944 = done;
  if (istrue(call8951)) {
// Begin line 2982
  setline(2982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8952 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8953 = callmethodflags(self, "reportBadRhs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8952);
// compiled member node returning call8953 (depth = 6)
    gc_frame_newslot(call8953);
    if8944 = call8953;
  } else {
  }
// compiled if node returning if8944 (depth = 5)
// Begin line 2984
  setline(2984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8954 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call8955 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe8954);
// compiled member node returning call8955 (depth = 6)
  *var_val = call8955;
  if (call8955 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2985
  setline(2985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8956 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe8957 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call8958 = callmethodflags(*var_btok, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8957);
// compiled member node returning call8958 (depth = 6)
  gc_frame_newslot(call8958);
// starting to compile member node (depth = 6)
  int callframe8959 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call8960 = callmethodflags(*var_btok, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe8959);
// compiled member node returning call8960 (depth = 6)
  gc_frame_newslot(call8960);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  params[0] = call8958;
  params[1] = call8960;
  partcv[0] = 2;
  Object call8961 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8956);
// compiled call node returning call8961 (depth = 5)
// Begin line 2986
  setline(2986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8962 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_dest (depth = 7)
  gc_frame_newslot(*var_dest);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_val (depth = 7)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8963 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call8964 = callmethodflags(*var_ast, "bindNode", 1, partcv, params, 0);
  gc_frame_end(callframe8963);
// compiled member node returning call8964 (depth = 7)
  params[0] = *var_dest;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call8965 = callmethodflags(call8964, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8962);
// compiled call node returning call8965 (depth = 6)
  *var_o = call8965;
  if (call8965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2987
  setline(2987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8966 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8967 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8966);
// compiled call node returning call8967 (depth = 5)
    gc_frame_newslot(call8967);
    if8884 = call8967;
  } else {
  }
// compiled if node returning if8884 (depth = 4)
    gc_frame_newslot(if8884);
    if8876 = if8884;
  } else {
  }
// compiled if node returning if8876 (depth = 3)
    gc_frame_newslot(if8876);
    if8789 = if8876;
  }
// compiled if node returning if8789 (depth = 2)
// Begin line 2991
  setline(2991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8968 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8969 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8968);
// compiled member node returning call8969 (depth = 2)
// Begin line 2992
  setline(2992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8971 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8972 == NULL) {
    strlit8972 = alloc_String("eof");
    gc_root(strlit8972);
  }
// compiled string node returning strlit8972 (depth = 4)
  gc_frame_newslot(strlit8972);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8972;
  partcv[0] = 1;
  Object call8973 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8971);
// compiled call node returning call8973 (depth = 3)
  Object if8970 = done;
  if (istrue(call8973)) {
// Begin line 2993
  setline(2993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool8974 = alloc_Boolean(1);
// compiled identifier node returning bool8974 (depth = 4)
  return bool8974;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if8970 = undefined;
  } else {
  }
// compiled if node returning if8970 (depth = 2)
// Begin line 2995
  setline(2995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8976 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8977 == NULL) {
    strlit8977 = alloc_String("semicolon");
    gc_root(strlit8977);
  }
// compiled string node returning strlit8977 (depth = 4)
  gc_frame_newslot(strlit8977);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning module_parser (depth = 4)
  params[0] = strlit8977;
  partcv[0] = 1;
  Object call8978 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8976);
// compiled call node returning call8978 (depth = 3)
  Object if8975 = done;
  if (istrue(call8978)) {
// Begin line 2996
  setline(2996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8979 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call8980 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8979);
// compiled member node returning call8980 (depth = 4)
  *var_oldLine = call8980;
  if (call8980 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2997
  setline(2997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8981 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8982 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8981);
// compiled member node returning call8982 (depth = 3)
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldLine (depth = 5)
  int op_slot_right_8984 = gc_frame_newslot(*var_oldLine);
// starting to compile member node (depth = 5)
  int callframe8986 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8987 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe8986);
// compiled member node returning call8987 (depth = 5)
  int op_slot_left_8984 = gc_frame_newslot(call8987);
  params[0] = *var_oldLine;
  partcv[0] = 1;
  Object opresult8988 = callmethod(call8987, "==(1)", 1, partcv, params);
// compiled op node returning opresult8988 (depth = 4)
  Object if8983 = done;
  if (istrue(opresult8988)) {
// Begin line 2999
  setline(2999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8989 = alloc_Boolean(1);
// compiled identifier node returning bool8989 (depth = 5)
  *var_indentFreePass = bool8989;
  if (bool8989 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8983 = done;
  } else {
  }
// compiled if node returning if8983 (depth = 3)
    gc_frame_newslot(if8983);
    if8975 = if8983;
  } else {
// Begin line 3002
  setline(3002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8991 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8992 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8991);
// compiled member node returning call8992 (depth = 3)
    gc_frame_newslot(call8992);
    if8975 = call8992;
  }
// compiled if node returning if8975 (depth = 2)
  gc_frame_end(frame);
  return if8975;
}
Object meth_parser_9051__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_previousCommentToken = getfromclosure(closure, 1);
  Object *var_tokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  *var_previousCommentToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9053 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call9054 = callmethodflags(*var_tokens, "poll", 1, partcv, params, 0);
  gc_frame_end(callframe9053);
// compiled member node returning call9054 (depth = 5)
  *var_sym = call9054;
  if (call9054 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3024
  setline(3024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9056 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9057 == NULL) {
    strlit9057 = alloc_String("comment");
    gc_root(strlit9057);
  }
// compiled string node returning strlit9057 (depth = 5)
  gc_frame_newslot(strlit9057);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit9057;
  partcv[0] = 1;
  Object call9058 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9056);
// compiled call node returning call9058 (depth = 4)
  gc_frame_end(frame);
  return call9058;
}
Object meth_parser_9061__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_o = getfromclosure(closure, 3);
  Object *var_comments = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 3026
  setline(3026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9062 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9063 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9064 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9063);
// compiled member node returning call9064 (depth = 5)
  gc_frame_newslot(call9064);
// starting to compile member node (depth = 5)
  int callframe9065 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9066 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9065);
// compiled member node returning call9066 (depth = 5)
  gc_frame_newslot(call9066);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call9064;
  params[1] = call9066;
  partcv[0] = 2;
  Object call9067 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9062);
// compiled call node returning call9067 (depth = 4)
// Begin line 3027
  setline(3027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9068 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe9069 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9070 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9069);
// compiled member node returning call9070 (depth = 6)
  gc_frame_newslot(call9070);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9071 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call9072 = callmethodflags(*var_ast, "commentNode", 1, partcv, params, 0);
  gc_frame_end(callframe9071);
// compiled member node returning call9072 (depth = 6)
  params[0] = call9070;
  partcv[0] = 1;
  Object call9073 = callmethodflags(call9072, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9068);
// compiled call node returning call9073 (depth = 5)
  *var_o = call9073;
  if (call9073 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3028
  setline(3028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9078 = alloc_Float64(1);
// compiled num node returning num9078 (depth = 7)
  int op_slot_right_9077 = gc_frame_newslot(num9078);
// starting to compile member node (depth = 7)
  int callframe9080 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9081 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9080);
// compiled member node returning call9081 (depth = 7)
  int op_slot_left_9077 = gc_frame_newslot(call9081);
  params[0] = num9078;
  partcv[0] = 1;
  Object diff9082 = callmethod(call9081, "-(1)", 1, partcv, params);
// compiled op node returning diff9082 (depth = 6)
  int op_slot_right_9076 = gc_frame_newslot(diff9082);
// starting to compile member node (depth = 6)
  int callframe9084 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9085 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  partcv[0] = 0;
  Object call9086 = callmethodflags(*var_comments, "last", 1, partcv, params, 0);
  gc_frame_end(callframe9085);
// compiled member node returning call9086 (depth = 7)
  partcv[0] = 0;
  Object call9087 = callmethodflags(call9086, "endLine", 1, partcv, params, 0);
  gc_frame_end(callframe9084);
// compiled member node returning call9087 (depth = 6)
  int op_slot_left_9076 = gc_frame_newslot(call9087);
  params[0] = diff9082;
  partcv[0] = 1;
  Object opresult9088 = callmethod(call9087, "==(1)", 1, partcv, params);
// compiled op node returning opresult9088 (depth = 5)
  Object if9075 = done;
  if (istrue(opresult9088)) {
// Begin line 3029
  setline(3029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9089 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9090 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_comments (depth = 7)
  partcv[0] = 0;
  Object call9091 = callmethodflags(*var_comments, "last", 1, partcv, params, 0);
  gc_frame_end(callframe9090);
// compiled member node returning call9091 (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9092 = callmethodflags(call9091, "extendCommentUsing(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9089);
// compiled call node returning call9092 (depth = 5)
    gc_frame_newslot(call9092);
    if9075 = call9092;
  } else {
// Begin line 3031
  setline(3031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9093 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9094 = callmethodflags(*var_comments, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9093);
// compiled call node returning call9094 (depth = 5)
// Begin line 3032
  setline(3032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9098 = alloc_Float64(1);
// compiled num node returning num9098 (depth = 8)
  int op_slot_right_9097 = gc_frame_newslot(num9098);
// starting to compile member node (depth = 8)
  int callframe9100 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9101 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9100);
// compiled member node returning call9101 (depth = 8)
  int op_slot_left_9097 = gc_frame_newslot(call9101);
  params[0] = num9098;
  partcv[0] = 1;
  Object diff9102 = callmethod(call9101, "-(1)", 1, partcv, params);
// compiled op node returning diff9102 (depth = 7)
  int op_slot_right_9096 = gc_frame_newslot(diff9102);
// starting to compile member node (depth = 7)
  int callframe9104 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9105 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9104);
// compiled member node returning call9105 (depth = 7)
  int op_slot_left_9096 = gc_frame_newslot(call9105);
  params[0] = diff9102;
  partcv[0] = 1;
  Object opresult9106 = callmethod(call9105, "<(1)", 1, partcv, params);
// compiled op node returning opresult9106 (depth = 6)
  Object if9095 = done;
  if (istrue(opresult9106)) {
// Begin line 3033
  setline(3033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9107 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool9108 = alloc_Boolean(1);
// compiled identifier node returning bool9108 (depth = 7)
  gc_frame_newslot(bool9108);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  params[0] = bool9108;
  partcv[0] = 1;
  Object call9109 = callmethodflags(*var_o, "isPreceededByBlankLine:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9107);
// compiled call node returning call9109 (depth = 6)
    gc_frame_newslot(call9109);
    if9095 = call9109;
  } else {
  }
// compiled if node returning if9095 (depth = 5)
    gc_frame_newslot(if9095);
    if9075 = if9095;
  }
// compiled if node returning if9075 (depth = 4)
  gc_frame_end(frame);
  return if9075;
}
Object meth_parser_8993_pushComments(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 84, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_comments = getfromclosure(closure, 5);
  Object *var_previousCommentToken = getfromclosure(closure, 6);
  Object *var_tokens = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8995 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8996 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8997 == NULL) {
    strlit8997 = alloc_String("comment");
    gc_root(strlit8997);
  }
// compiled string node returning strlit8997 (depth = 5)
  gc_frame_newslot(strlit8997);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning module_parser (depth = 5)
  params[0] = strlit8997;
  partcv[0] = 1;
  Object call8998 = callmethodflags(module_parser, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8996);
// compiled call node returning call8998 (depth = 4)
  partcv[0] = 0;
  Object call8999 = callmethodflags(call8998, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe8995);
// compiled call node returning call8999 (depth = 3)
  Object if8994 = done;
  if (istrue(call8999)) {
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if8994 = undefined;
  } else {
  }
// compiled if node returning if8994 (depth = 2)
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9000 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe9001 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call9002 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9001);
// compiled member node returning call9002 (depth = 3)
  gc_frame_newslot(call9002);
// starting to compile member node (depth = 3)
  int callframe9003 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  partcv[0] = 0;
  Object call9004 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9003);
// compiled member node returning call9004 (depth = 3)
  gc_frame_newslot(call9004);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call9002;
  params[1] = call9004;
  partcv[0] = 2;
  Object call9005 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9000);
// compiled call node returning call9005 (depth = 2)
// Begin line 3014
  setline(3014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9006 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9007 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9008 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9007);
// compiled member node returning call9008 (depth = 4)
  gc_frame_newslot(call9008);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9009 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call9010 = callmethodflags(*var_ast, "commentNode", 1, partcv, params, 0);
  gc_frame_end(callframe9009);
// compiled member node returning call9010 (depth = 4)
  params[0] = call9008;
  partcv[0] = 1;
  Object call9011 = callmethodflags(call9010, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9006);
// compiled call node returning call9011 (depth = 3)
  *var_o = call9011;
  if (call9011 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9015 == NULL) {
    strlit9015 = alloc_String("comment");
    gc_root(strlit9015);
  }
// compiled string node returning strlit9015 (depth = 5)
  int op_slot_right_9014 = gc_frame_newslot(strlit9015);
// starting to compile member node (depth = 5)
  int callframe9017 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call9018 = callmethodflags(*var_lastToken, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe9017);
// compiled member node returning call9018 (depth = 5)
  int op_slot_left_9014 = gc_frame_newslot(call9018);
  params[0] = strlit9015;
  partcv[0] = 1;
  Object opresult9019 = callmethod(call9018, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9019 (depth = 4)
  int op_slot_right_9013 = gc_frame_newslot(opresult9019);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9022 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9023 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9022);
// compiled member node returning call9023 (depth = 5)
  int op_slot_right_9021 = gc_frame_newslot(call9023);
// starting to compile member node (depth = 5)
  int callframe9025 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call9026 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9025);
// compiled member node returning call9026 (depth = 5)
  int op_slot_left_9021 = gc_frame_newslot(call9026);
  params[0] = call9023;
  partcv[0] = 1;
  Object opresult9027 = callmethod(call9026, "==(1)", 1, partcv, params);
// compiled op node returning opresult9027 (depth = 4)
  int op_slot_left_9013 = gc_frame_newslot(opresult9027);
  params[0] = opresult9019;
  partcv[0] = 1;
  Object opresult9028 = callmethod(opresult9027, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9028 (depth = 3)
  Object if9012 = done;
  if (istrue(opresult9028)) {
// Begin line 3016
  setline(3016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9029 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool9030 = alloc_Boolean(1);
// compiled identifier node returning bool9030 (depth = 4)
  gc_frame_newslot(bool9030);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = bool9030;
  partcv[0] = 1;
  Object call9031 = callmethodflags(*var_o, "isPartialLine:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9029);
// compiled call node returning call9031 (depth = 3)
    gc_frame_newslot(call9031);
    if9012 = call9031;
  } else {
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9035 = alloc_Float64(1);
// compiled num node returning num9035 (depth = 6)
  int op_slot_right_9034 = gc_frame_newslot(num9035);
// starting to compile member node (depth = 6)
  int callframe9037 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9038 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9037);
// compiled member node returning call9038 (depth = 6)
  int op_slot_left_9034 = gc_frame_newslot(call9038);
  params[0] = num9035;
  partcv[0] = 1;
  Object diff9039 = callmethod(call9038, "-(1)", 1, partcv, params);
// compiled op node returning diff9039 (depth = 5)
  int op_slot_right_9033 = gc_frame_newslot(diff9039);
// starting to compile member node (depth = 5)
  int callframe9041 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call9042 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9041);
// compiled member node returning call9042 (depth = 5)
  int op_slot_left_9033 = gc_frame_newslot(call9042);
  params[0] = diff9039;
  partcv[0] = 1;
  Object opresult9043 = callmethod(call9042, "<(1)", 1, partcv, params);
// compiled op node returning opresult9043 (depth = 4)
  Object if9032 = done;
  if (istrue(opresult9043)) {
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9044 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool9045 = alloc_Boolean(1);
// compiled identifier node returning bool9045 (depth = 5)
  gc_frame_newslot(bool9045);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = bool9045;
  partcv[0] = 1;
  Object call9046 = callmethodflags(*var_o, "isPreceededByBlankLine:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9044);
// compiled call node returning call9046 (depth = 4)
    gc_frame_newslot(call9046);
    if9032 = call9046;
  } else {
  }
// compiled if node returning if9032 (depth = 3)
    gc_frame_newslot(if9032);
    if9012 = if9032;
  }
// compiled if node returning if9012 (depth = 2)
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9047 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9048 = callmethodflags(*var_comments, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9047);
// compiled call node returning call9048 (depth = 2)
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9049 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9050 = alloc_Block(NULL, NULL, "parser", 3021);
  gc_frame_newslot(block9050);
// method "_apply"
  block_savedest(block9050);
  Object closure9051 = createclosure(4, "_apply");
  setclosureframe(closure9051, stackframe);
  addtoclosure(closure9051, var_sym);
  addtoclosure(closure9051, var_previousCommentToken);
  addtoclosure(closure9051, var_tokens);
  addtoclosure(closure9051, selfslot);
  struct UserObject *uo9051 = (struct UserObject*)block9050;
  uo9051->data[0] = (Object)closure9051;
  Method *meth_meth_parser_9051__apply = addmethod2pos(block9050, "_apply", &meth_parser_9051__apply, 0);
  int argcv_meth_parser_9051__apply[] = {0};
  meth_meth_parser_9051__apply->type = alloc_MethodType(1, argcv_meth_parser_9051__apply);
  meth_meth_parser_9051__apply->definitionModule = modulename;
  meth_meth_parser_9051__apply->definitionLine = 183;
// compiled block node returning block9050 (depth = 3)
  gc_frame_newslot(block9050);
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block9060 = alloc_Block(NULL, NULL, "parser", 3025);
  gc_frame_newslot(block9060);
// method "_apply"
  block_savedest(block9060);
  Object closure9061 = createclosure(7, "_apply");
  setclosureframe(closure9061, stackframe);
  addtoclosure(closure9061, var_sym);
  addtoclosure(closure9061, var_util);
  addtoclosure(closure9061, var_ast);
  addtoclosure(closure9061, var_o);
  addtoclosure(closure9061, var_comments);
  addtoclosure(closure9061, var_lastToken);
  addtoclosure(closure9061, selfslot);
  struct UserObject *uo9061 = (struct UserObject*)block9060;
  uo9061->data[0] = (Object)closure9061;
  Method *meth_meth_parser_9061__apply = addmethod2pos(block9060, "_apply", &meth_parser_9061__apply, 0);
  int argcv_meth_parser_9061__apply[] = {0};
  meth_meth_parser_9061__apply->type = alloc_MethodType(1, argcv_meth_parser_9061__apply);
  meth_meth_parser_9061__apply->definitionModule = modulename;
  meth_meth_parser_9061__apply->definitionLine = 183;
// compiled block node returning block9060 (depth = 3)
  gc_frame_newslot(block9060);
// call case 5: prelude request
  params[0] = block9050;
  params[1] = block9060;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9111 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9049);
// compiled call node returning call9111 (depth = 2)
  gc_frame_end(frame);
  return call9111;
}
Object meth_parser_9137__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9139 = alloc_Float64(0);
// compiled num node returning num9139 (depth = 5)
  int op_slot_right_9138 = gc_frame_newslot(num9139);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_9138 = gc_frame_newslot(*var_ix);
  params[0] = num9139;
  partcv[0] = 1;
  Object opresult9141 = callmethod(*var_ix, ">(1)", 1, partcv, params);
// compiled op node returning opresult9141 (depth = 4)
  gc_frame_end(frame);
  return opresult9141;
}
Object meth_parser_9144__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_comments = getfromclosure(closure, 1);
  Object *var_oLine = getfromclosure(closure, 2);
  Object *var_postComments = getfromclosure(closure, 3);
  Object *var_preComments = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_each = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "each");
  Object *var_isPostComment = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isPostComment");
  Object *var_isPreComment = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isPreComment");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// Begin line 3062
  setline(3062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9145 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call9146 = callmethodflags(*var_comments, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9145);
// compiled call node returning call9146 (depth = 5)
  *var_each = call9146;
  if (call9146 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3063
  setline(3063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9150 = alloc_Float64(1);
// compiled num node returning num9150 (depth = 8)
  int op_slot_right_9149 = gc_frame_newslot(num9150);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_9149 = gc_frame_newslot(*var_oLine);
  params[0] = num9150;
  partcv[0] = 1;
  Object sum9152 = callmethod(*var_oLine, "+(1)", 1, partcv, params);
// compiled op node returning sum9152 (depth = 7)
  int op_slot_right_9148 = gc_frame_newslot(sum9152);
// starting to compile member node (depth = 7)
  int callframe9154 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  partcv[0] = 0;
  Object call9155 = callmethodflags(*var_each, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9154);
// compiled member node returning call9155 (depth = 7)
  int op_slot_left_9148 = gc_frame_newslot(call9155);
  params[0] = sum9152;
  partcv[0] = 1;
  Object opresult9156 = callmethod(call9155, "==(1)", 1, partcv, params);
// compiled op node returning opresult9156 (depth = 6)
  int op_slot_right_9147 = gc_frame_newslot(opresult9156);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oLine (depth = 7)
  int op_slot_right_9158 = gc_frame_newslot(*var_oLine);
// starting to compile member node (depth = 7)
  int callframe9160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  partcv[0] = 0;
  Object call9161 = callmethodflags(*var_each, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9160);
// compiled member node returning call9161 (depth = 7)
  int op_slot_left_9158 = gc_frame_newslot(call9161);
  params[0] = *var_oLine;
  partcv[0] = 1;
  Object opresult9162 = callmethod(call9161, "==(1)", 1, partcv, params);
// compiled op node returning opresult9162 (depth = 6)
  int op_slot_left_9147 = gc_frame_newslot(opresult9162);
  params[0] = opresult9156;
  partcv[0] = 1;
  Object opresult9163 = callmethod(opresult9162, "||(1)", 1, partcv, params);
// compiled op node returning opresult9163 (depth = 5)
  *var_isPostComment = opresult9163;
  if (opresult9163 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3064
  setline(3064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9167 = alloc_Float64(1);
// compiled num node returning num9167 (depth = 8)
  int op_slot_right_9166 = gc_frame_newslot(num9167);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_9166 = gc_frame_newslot(*var_oLine);
  params[0] = num9167;
  partcv[0] = 1;
  Object diff9169 = callmethod(*var_oLine, "-(1)", 1, partcv, params);
// compiled op node returning diff9169 (depth = 7)
  int op_slot_right_9165 = gc_frame_newslot(diff9169);
// starting to compile member node (depth = 7)
  int callframe9171 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  partcv[0] = 0;
  Object call9172 = callmethodflags(*var_each, "endLine", 1, partcv, params, 0);
  gc_frame_end(callframe9171);
// compiled member node returning call9172 (depth = 7)
  int op_slot_left_9165 = gc_frame_newslot(call9172);
  params[0] = diff9169;
  partcv[0] = 1;
  Object opresult9173 = callmethod(call9172, "==(1)", 1, partcv, params);
// compiled op node returning opresult9173 (depth = 6)
  int op_slot_right_9164 = gc_frame_newslot(opresult9173);
// starting to compile member node (depth = 6)
  int callframe9175 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  partcv[0] = 0;
  Object call9176 = callmethodflags(*var_each, "isPreceededByBlankLine", 1, partcv, params, 0);
  gc_frame_end(callframe9175);
// compiled member node returning call9176 (depth = 6)
  int op_slot_left_9164 = gc_frame_newslot(call9176);
  params[0] = opresult9173;
  partcv[0] = 1;
  Object opresult9177 = callmethod(call9176, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9177 (depth = 5)
  *var_isPreComment = opresult9177;
  if (opresult9177 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3065
  setline(3065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isPostComment (depth = 5)
  Object if9178 = done;
  if (istrue(*var_isPostComment)) {
// Begin line 3066
  setline(3066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9179 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe9180 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_comments (depth = 7)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call9181 = callmethodflags(*var_comments, "removeAt(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9180);
// compiled call node returning call9181 (depth = 6)
  gc_frame_newslot(call9181);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_postComments (depth = 6)
  params[0] = call9181;
  partcv[0] = 1;
  Object call9182 = callmethodflags(*var_postComments, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9179);
// compiled call node returning call9182 (depth = 5)
    gc_frame_newslot(call9182);
    if9178 = call9182;
  } else {
// Begin line 3069
  setline(3069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3067
  setline(3067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isPreComment (depth = 6)
  Object if9183 = done;
  if (istrue(*var_isPreComment)) {
// Begin line 3068
  setline(3068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9184 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe9185 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call9186 = callmethodflags(*var_comments, "removeAt(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9185);
// compiled call node returning call9186 (depth = 7)
  gc_frame_newslot(call9186);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_preComments (depth = 7)
  params[0] = call9186;
  partcv[0] = 1;
  Object call9187 = callmethodflags(*var_preComments, "addFirst(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9184);
// compiled call node returning call9187 (depth = 6)
    gc_frame_newslot(call9187);
    if9183 = call9187;
  } else {
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3069
  setline(3069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9191 = alloc_Float64(1);
// compiled num node returning num9191 (depth = 9)
  int op_slot_right_9190 = gc_frame_newslot(num9191);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_oLine (depth = 9)
  int op_slot_left_9190 = gc_frame_newslot(*var_oLine);
  params[0] = num9191;
  partcv[0] = 1;
  Object diff9193 = callmethod(*var_oLine, "-(1)", 1, partcv, params);
// compiled op node returning diff9193 (depth = 8)
  int op_slot_right_9189 = gc_frame_newslot(diff9193);
// starting to compile member node (depth = 8)
  int callframe9195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call9196 = callmethodflags(*var_each, "endLine", 1, partcv, params, 0);
  gc_frame_end(callframe9195);
// compiled member node returning call9196 (depth = 8)
  int op_slot_left_9189 = gc_frame_newslot(call9196);
  params[0] = diff9193;
  partcv[0] = 1;
  Object opresult9197 = callmethod(call9196, "<(1)", 1, partcv, params);
// compiled op node returning opresult9197 (depth = 7)
  Object if9188 = done;
  if (istrue(opresult9197)) {
// Begin line 3070
  setline(3070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9198 = alloc_Float64(0);
// compiled num node returning num9198 (depth = 8)
  *var_ix = num9198;
  if (num9198 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if9188 = done;
  } else {
  }
// compiled if node returning if9188 (depth = 6)
    gc_frame_newslot(if9188);
    if9183 = if9188;
  }
// compiled if node returning if9183 (depth = 5)
    gc_frame_newslot(if9183);
    if9178 = if9183;
  }
// compiled if node returning if9178 (depth = 4)
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9201 = alloc_Float64(1);
// compiled num node returning num9201 (depth = 6)
  int op_slot_right_9200 = gc_frame_newslot(num9201);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_9200 = gc_frame_newslot(*var_ix);
  params[0] = num9201;
  partcv[0] = 1;
  Object diff9203 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff9203 (depth = 5)
  *var_ix = diff9203;
  if (diff9203 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9112_reconcileComments(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 85, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reconcileComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_comments = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
  Object *var_node = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "node");
// definebindings:
// definebindings:
  Object *var_oLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oLine");
  Object *var_preComments = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "preComments");
  Object *var_postComments = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "postComments");
  Object *var_ix = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ix");
  Object *var_postSz = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "postSz");
  Object *var_preSz = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "preSz");
// definebindings:
// definebindings:
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe9113 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9114 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9113);
// compiled member node returning call9114 (depth = 2)
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9116 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call9117 = callmethodflags(*var_values, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe9116);
// compiled member node returning call9117 (depth = 4)
  Object if9115 = done;
struct StackFrameObject *iftmpstackframe9115 = stackframe;
  if (istrue(call9117)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9115);
gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 3047
  setline(3047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_moduleObject (depth = 4)
    gc_frame_newslot(*var_moduleObject);
    if9115 = *var_moduleObject;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9115);
  gc_frame_newslot((Object)stackframe);
// definebindings:
// Begin line 3049
  setline(3049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9118 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call9119 = callmethodflags(*var_values, "last", 1, partcv, params, 0);
  gc_frame_end(callframe9118);
// compiled member node returning call9119 (depth = 4)
    gc_frame_newslot(call9119);
    if9115 = call9119;
  }
stackframe = iftmpstackframe9115;
// compiled if node returning if9115 (depth = 3)
  *var_node = if9115;
  if (if9115 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3051
  setline(3051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9122 == NULL) {
    strlit9122 = alloc_String("lbrace");
    gc_root(strlit9122);
  }
// compiled string node returning strlit9122 (depth = 4)
  int op_slot_right_9121 = gc_frame_newslot(strlit9122);
// starting to compile member node (depth = 4)
  int callframe9124 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call9125 = callmethodflags(*var_node, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe9124);
// compiled member node returning call9125 (depth = 4)
  int op_slot_left_9121 = gc_frame_newslot(call9125);
  params[0] = strlit9122;
  partcv[0] = 1;
  Object opresult9126 = callmethod(call9125, "==(1)", 1, partcv, params);
// compiled op node returning opresult9126 (depth = 3)
  Object if9120 = done;
  if (istrue(opresult9126)) {
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if9120 = undefined;
  } else {
  }
// compiled if node returning if9120 (depth = 2)
// Begin line 3056
  setline(3056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9127 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  partcv[0] = 0;
  Object call9128 = callmethodflags(*var_node, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9127);
// compiled member node returning call9128 (depth = 3)
  *var_oLine = call9128;
  if (call9128 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3057
  setline(3057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9129 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9130 = callmethodflags(prelude, "emptyList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9129);
// compiled member node returning call9130 (depth = 3)
  *var_preComments = call9130;
  if (call9130 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3058
  setline(3058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9131 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9132 = callmethodflags(prelude, "emptyList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9131);
// compiled member node returning call9132 (depth = 3)
  *var_postComments = call9132;
  if (call9132 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3060
  setline(3060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9133 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_comments (depth = 4)
  partcv[0] = 0;
  Object call9134 = callmethodflags(*var_comments, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9133);
// compiled member node returning call9134 (depth = 3)
  *var_ix = call9134;
  if (call9134 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3061
  setline(3061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9135 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9136 = alloc_Block(NULL, NULL, "parser", 3061);
  gc_frame_newslot(block9136);
// method "_apply"
  block_savedest(block9136);
  Object closure9137 = createclosure(2, "_apply");
  setclosureframe(closure9137, stackframe);
  addtoclosure(closure9137, var_ix);
  addtoclosure(closure9137, selfslot);
  struct UserObject *uo9137 = (struct UserObject*)block9136;
  uo9137->data[0] = (Object)closure9137;
  Method *meth_meth_parser_9137__apply = addmethod2pos(block9136, "_apply", &meth_parser_9137__apply, 0);
  int argcv_meth_parser_9137__apply[] = {0};
  meth_meth_parser_9137__apply->type = alloc_MethodType(1, argcv_meth_parser_9137__apply);
  meth_meth_parser_9137__apply->definitionModule = modulename;
  meth_meth_parser_9137__apply->definitionLine = 183;
// compiled block node returning block9136 (depth = 3)
  gc_frame_newslot(block9136);
// starting to compile block node (depth = 3)
  Object block9143 = alloc_Block(NULL, NULL, "parser", 3061);
  gc_frame_newslot(block9143);
// method "_apply"
  block_savedest(block9143);
  Object closure9144 = createclosure(6, "_apply");
  setclosureframe(closure9144, stackframe);
  addtoclosure(closure9144, var_ix);
  addtoclosure(closure9144, var_comments);
  addtoclosure(closure9144, var_oLine);
  addtoclosure(closure9144, var_postComments);
  addtoclosure(closure9144, var_preComments);
  addtoclosure(closure9144, selfslot);
  struct UserObject *uo9144 = (struct UserObject*)block9143;
  uo9144->data[0] = (Object)closure9144;
  Method *meth_meth_parser_9144__apply = addmethod2pos(block9143, "_apply", &meth_parser_9144__apply, 0);
  int argcv_meth_parser_9144__apply[] = {0};
  meth_meth_parser_9144__apply->type = alloc_MethodType(1, argcv_meth_parser_9144__apply);
  meth_meth_parser_9144__apply->definitionModule = modulename;
  meth_meth_parser_9144__apply->definitionLine = 183;
// compiled block node returning block9143 (depth = 3)
  gc_frame_newslot(block9143);
// call case 5: prelude request
  params[0] = block9136;
  params[1] = block9143;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9206 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9135);
// compiled call node returning call9206 (depth = 2)
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9207 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_postComments (depth = 4)
  partcv[0] = 0;
  Object call9208 = callmethodflags(*var_postComments, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9207);
// compiled member node returning call9208 (depth = 3)
  *var_postSz = call9208;
  if (call9208 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3076
  setline(3076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9209 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_preComments (depth = 4)
  partcv[0] = 0;
  Object call9210 = callmethodflags(*var_preComments, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9209);
// compiled member node returning call9210 (depth = 3)
  *var_preSz = call9210;
  if (call9210 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3078
  setline(3078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9214 = alloc_Float64(1);
// compiled num node returning num9214 (depth = 5)
  int op_slot_right_9213 = gc_frame_newslot(num9214);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preSz (depth = 5)
  int op_slot_left_9213 = gc_frame_newslot(*var_preSz);
  params[0] = num9214;
  partcv[0] = 1;
  Object opresult9216 = callmethod(*var_preSz, ">(1)", 1, partcv, params);
// compiled op node returning opresult9216 (depth = 4)
  int op_slot_right_9212 = gc_frame_newslot(opresult9216);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9219 = alloc_Float64(1);
// compiled num node returning num9219 (depth = 5)
  int op_slot_right_9218 = gc_frame_newslot(num9219);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_postSz (depth = 5)
  int op_slot_left_9218 = gc_frame_newslot(*var_postSz);
  params[0] = num9219;
  partcv[0] = 1;
  Object opresult9221 = callmethod(*var_postSz, ">(1)", 1, partcv, params);
// compiled op node returning opresult9221 (depth = 4)
  int op_slot_left_9212 = gc_frame_newslot(opresult9221);
  params[0] = opresult9216;
  partcv[0] = 1;
  Object opresult9222 = callmethod(opresult9221, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9222 (depth = 3)
  Object if9211 = done;
  if (istrue(opresult9222)) {
// Begin line 3079
  setline(3079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9223 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9225 == NULL) {
    strlit9225 = alloc_String("""\x0a""");
    gc_root(strlit9225);
  }
// compiled string node returning strlit9225 (depth = 5)
  int op_slot_right_9224 = gc_frame_newslot(strlit9225);
// starting to compile member node (depth = 5)
  int callframe9227 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9228 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_preComments (depth = 7)
  partcv[0] = 0;
  Object call9229 = callmethodflags(*var_preComments, "last", 1, partcv, params, 0);
  gc_frame_end(callframe9228);
// compiled member node returning call9229 (depth = 6)
  partcv[0] = 0;
  Object call9230 = callmethodflags(call9229, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9227);
// compiled member node returning call9230 (depth = 5)
  int op_slot_left_9224 = gc_frame_newslot(call9230);
  params[0] = strlit9225;
  partcv[0] = 1;
  Object opresult9231 = callmethod(call9230, "++(1)", 1, partcv, params);
// compiled op node returning opresult9231 (depth = 4)
  gc_frame_newslot(opresult9231);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9232 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preComments (depth = 5)
  partcv[0] = 0;
  Object call9233 = callmethodflags(*var_preComments, "last", 1, partcv, params, 0);
  gc_frame_end(callframe9232);
// compiled member node returning call9233 (depth = 4)
  params[0] = opresult9231;
  partcv[0] = 1;
  Object call9234 = callmethodflags(call9233, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9223);
// compiled call node returning call9234 (depth = 3)
    gc_frame_newslot(call9234);
    if9211 = call9234;
  } else {
  }
// compiled if node returning if9211 (depth = 2)
// Begin line 3081
  setline(3081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9235 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_preComments (depth = 3)
  gc_frame_newslot(*var_preComments);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_preComments;
  partcv[0] = 1;
  Object call9236 = callmethodflags(*var_node, "addComments(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9235);
// compiled call node returning call9236 (depth = 2)
// Begin line 3082
  setline(3082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9237 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_postComments (depth = 3)
  gc_frame_newslot(*var_postComments);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_postComments;
  partcv[0] = 1;
  Object call9238 = callmethodflags(*var_node, "addComments(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9237);
// compiled call node returning call9238 (depth = 2)
  gc_frame_end(frame);
  return call9238;
}
Object meth_parser_9239_checkBadOperators(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 86, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadOperators");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// definebindings:
// Begin line 3086
  setline(3086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9242 == NULL) {
    strlit9242 = alloc_String("=");
    gc_root(strlit9242);
  }
// compiled string node returning strlit9242 (depth = 4)
  int op_slot_right_9241 = gc_frame_newslot(strlit9242);
// starting to compile member node (depth = 4)
  int callframe9244 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9245 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9244);
// compiled member node returning call9245 (depth = 4)
  int op_slot_left_9241 = gc_frame_newslot(call9245);
  params[0] = strlit9242;
  partcv[0] = 1;
  Object opresult9246 = callmethod(call9245, "==(1)", 1, partcv, params);
// compiled op node returning opresult9246 (depth = 3)
  Object if9240 = done;
  if (istrue(opresult9246)) {
// Begin line 3087
  setline(3087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9247 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9248 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call9249 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9248);
// compiled member node returning call9249 (depth = 5)
  partcv[0] = 0;
  Object call9250 = callmethodflags(call9249, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9247);
// compiled member node returning call9250 (depth = 4)
  *var_sugg = call9250;
  if (call9250 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3088
  setline(3088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9251 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9252 == NULL) {
    strlit9252 = alloc_String("=");
    gc_root(strlit9252);
  }
// compiled string node returning strlit9252 (depth = 4)
  gc_frame_newslot(strlit9252);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit9252;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9253 = callmethodflags(*var_sugg, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9251);
// compiled call node returning call9253 (depth = 3)
// Begin line 3089
  setline(3089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9254 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9255 == NULL) {
    strlit9255 = alloc_String("use '==' to test equality, not '='.");
    gc_root(strlit9255);
  }
// compiled string node returning strlit9255 (depth = 4)
  gc_frame_newslot(strlit9255);
// Begin line 3090
  setline(3090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9256 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9257 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9256);
// compiled member node returning call9257 (depth = 4)
  gc_frame_newslot(call9257);
// starting to compile member node (depth = 4)
  int callframe9258 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9259 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9258);
// compiled member node returning call9259 (depth = 4)
  gc_frame_newslot(call9259);
// starting to compile member node (depth = 4)
  int callframe9260 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9261 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9260);
// compiled member node returning call9261 (depth = 4)
  gc_frame_newslot(call9261);
// Begin line 3091
  setline(3091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3089
  setline(3089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit9255;
  params[1] = call9257;
  params[2] = call9259;
  params[3] = call9261;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9262 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9254);
// compiled call node returning call9262 (depth = 3)
    gc_frame_newslot(call9262);
    if9240 = call9262;
  } else {
  }
// compiled if node returning if9240 (depth = 2)
  gc_frame_end(frame);
  return if9240;
}
Object meth_parser_9263_checkBadTypeLiteral(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 87, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// definebindings:
// Begin line 3096
  setline(3096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9266 == NULL) {
    strlit9266 = alloc_String("lbrace");
    gc_root(strlit9266);
  }
// compiled string node returning strlit9266 (depth = 4)
  int op_slot_right_9265 = gc_frame_newslot(strlit9266);
// starting to compile member node (depth = 4)
  int callframe9268 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9269 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe9268);
// compiled member node returning call9269 (depth = 4)
  int op_slot_left_9265 = gc_frame_newslot(call9269);
  params[0] = strlit9266;
  partcv[0] = 1;
  Object opresult9270 = callmethod(call9269, "==(1)", 1, partcv, params);
// compiled op node returning opresult9270 (depth = 3)
  Object if9264 = done;
  if (istrue(opresult9270)) {
// Begin line 3097
  setline(3097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9271 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9272 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call9273 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9272);
// compiled member node returning call9273 (depth = 5)
  partcv[0] = 0;
  Object call9274 = callmethodflags(call9273, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9271);
// compiled member node returning call9274 (depth = 4)
  *var_sugg = call9274;
  if (call9274 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3098
  setline(3098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9275 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9276 == NULL) {
    strlit9276 = alloc_String("type ");
    gc_root(strlit9276);
  }
// compiled string node returning strlit9276 (depth = 4)
  gc_frame_newslot(strlit9276);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit9276;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9277 = callmethodflags(*var_sugg, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9275);
// compiled call node returning call9277 (depth = 3)
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9278 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9279 == NULL) {
    strlit9279 = alloc_String("type literals must start with the keyword 'type'.");
    gc_root(strlit9279);
  }
// compiled string node returning strlit9279 (depth = 4)
  gc_frame_newslot(strlit9279);
// Begin line 3100
  setline(3100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9280 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9281 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9280);
// compiled member node returning call9281 (depth = 4)
  gc_frame_newslot(call9281);
// starting to compile member node (depth = 4)
  int callframe9282 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9283 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9282);
// compiled member node returning call9283 (depth = 4)
  gc_frame_newslot(call9283);
// starting to compile member node (depth = 4)
  int callframe9284 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9285 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9284);
// compiled member node returning call9285 (depth = 4)
  gc_frame_newslot(call9285);
// Begin line 3101
  setline(3101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit9279;
  params[1] = call9281;
  params[2] = call9283;
  params[3] = call9285;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9286 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9278);
// compiled call node returning call9286 (depth = 3)
    gc_frame_newslot(call9286);
    if9264 = call9286;
  } else {
  }
// compiled if node returning if9264 (depth = 2)
  gc_frame_end(frame);
  return if9264;
}
Object meth_parser_9364__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9366 == NULL) {
    strlit9366 = alloc_String("identifier");
    gc_root(strlit9366);
  }
// compiled string node returning strlit9366 (depth = 8)
  int op_slot_right_9365 = gc_frame_newslot(strlit9366);
// starting to compile member node (depth = 8)
  int callframe9368 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9369 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe9368);
// compiled member node returning call9369 (depth = 8)
  int op_slot_left_9365 = gc_frame_newslot(call9369);
  params[0] = strlit9366;
  partcv[0] = 1;
  Object opresult9370 = callmethod(call9369, "==(1)", 1, partcv, params);
// compiled op node returning opresult9370 (depth = 7)
  gc_frame_end(frame);
  return opresult9370;
}
Object meth_parser_9378__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9380 == NULL) {
    strlit9380 = alloc_String("member");
    gc_root(strlit9380);
  }
// compiled string node returning strlit9380 (depth = 11)
  int op_slot_right_9379 = gc_frame_newslot(strlit9380);
// starting to compile member node (depth = 11)
  int callframe9382 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe9383 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_values (depth = 13)
  partcv[0] = 0;
  Object call9384 = callmethodflags(*var_values, "last", 1, partcv, params, 0);
  gc_frame_end(callframe9383);
// compiled member node returning call9384 (depth = 12)
  partcv[0] = 0;
  Object call9385 = callmethodflags(call9384, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe9382);
// compiled member node returning call9385 (depth = 11)
  int op_slot_left_9379 = gc_frame_newslot(call9385);
  params[0] = strlit9380;
  partcv[0] = 1;
  Object opresult9386 = callmethod(call9385, "==(1)", 1, partcv, params);
// compiled op node returning opresult9386 (depth = 10)
  gc_frame_end(frame);
  return opresult9386;
}
Object meth_parser_9375__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block9377 = alloc_Block(NULL, NULL, "parser", 3123);
  gc_frame_newslot(block9377);
// method "_apply"
  block_savedest(block9377);
  Object closure9378 = createclosure(2, "_apply");
  setclosureframe(closure9378, stackframe);
  addtoclosure(closure9378, var_values);
  addtoclosure(closure9378, selfslot);
  struct UserObject *uo9378 = (struct UserObject*)block9377;
  uo9378->data[0] = (Object)closure9378;
  Method *meth_meth_parser_9378__apply = addmethod2pos(block9377, "_apply", &meth_parser_9378__apply, 0);
  int argcv_meth_parser_9378__apply[] = {0};
  meth_meth_parser_9378__apply->type = alloc_MethodType(1, argcv_meth_parser_9378__apply);
  meth_meth_parser_9378__apply->definitionModule = modulename;
  meth_meth_parser_9378__apply->definitionLine = 183;
// compiled block node returning block9377 (depth = 9)
  int op_slot_right_9376 = gc_frame_newslot(block9377);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9390 == NULL) {
    strlit9390 = alloc_String("identifier");
    gc_root(strlit9390);
  }
// compiled string node returning strlit9390 (depth = 10)
  int op_slot_right_9389 = gc_frame_newslot(strlit9390);
// starting to compile member node (depth = 10)
  int callframe9392 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe9393 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_values (depth = 12)
  partcv[0] = 0;
  Object call9394 = callmethodflags(*var_values, "last", 1, partcv, params, 0);
  gc_frame_end(callframe9393);
// compiled member node returning call9394 (depth = 11)
  partcv[0] = 0;
  Object call9395 = callmethodflags(call9394, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe9392);
// compiled member node returning call9395 (depth = 10)
  int op_slot_left_9389 = gc_frame_newslot(call9395);
  params[0] = strlit9390;
  partcv[0] = 1;
  Object opresult9396 = callmethod(call9395, "==(1)", 1, partcv, params);
// compiled op node returning opresult9396 (depth = 9)
  int op_slot_left_9376 = gc_frame_newslot(opresult9396);
  params[0] = block9377;
  partcv[0] = 1;
  Object opresult9397 = callmethod(opresult9396, "||(1)", 1, partcv, params);
// compiled op node returning opresult9397 (depth = 8)
  gc_frame_end(frame);
  return opresult9397;
}
Object meth_parser_9287_checkUnexpectedTokenAfterStatement(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 88, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkUnexpectedTokenAfterStatement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_sugg2 = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sugg2");
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// definebindings:
// definebindings:
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
// definebindings:
  Object *var_newLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "newLine");
// definebindings:
// definebindings:
// definebindings:
// Begin line 3106
  setline(3106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9290 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  partcv[0] = 0;
  Object call9291 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9290);
// compiled member node returning call9291 (depth = 4)
  int op_slot_right_9289 = gc_frame_newslot(call9291);
// starting to compile member node (depth = 4)
  int callframe9293 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9294 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9293);
// compiled member node returning call9294 (depth = 4)
  int op_slot_left_9289 = gc_frame_newslot(call9294);
  params[0] = call9291;
  partcv[0] = 1;
  Object opresult9295 = callmethod(call9294, "==(1)", 1, partcv, params);
// compiled op node returning opresult9295 (depth = 3)
  Object if9288 = done;
  if (istrue(opresult9295)) {
// Begin line 3107
  setline(3107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 3108
  setline(3108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9299 == NULL) {
    strlit9299 = alloc_String("identifier");
    gc_root(strlit9299);
  }
// compiled string node returning strlit9299 (depth = 6)
  int op_slot_right_9298 = gc_frame_newslot(strlit9299);
// starting to compile member node (depth = 6)
  int callframe9301 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9302 = callmethodflags(*var_lastToken, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe9301);
// compiled member node returning call9302 (depth = 6)
  int op_slot_left_9298 = gc_frame_newslot(call9302);
  params[0] = strlit9299;
  partcv[0] = 1;
  Object opresult9303 = callmethod(call9302, "==(1)", 1, partcv, params);
// compiled op node returning opresult9303 (depth = 5)
  int op_slot_right_9297 = gc_frame_newslot(opresult9303);
// Begin line 3107
  setline(3107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9307 == NULL) {
    strlit9307 = alloc_String("=");
    gc_root(strlit9307);
  }
// compiled string node returning strlit9307 (depth = 7)
  int op_slot_right_9306 = gc_frame_newslot(strlit9307);
// starting to compile member node (depth = 7)
  int callframe9309 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9310 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9309);
// compiled member node returning call9310 (depth = 7)
  int op_slot_left_9306 = gc_frame_newslot(call9310);
  params[0] = strlit9307;
  partcv[0] = 1;
  Object opresult9311 = callmethod(call9310, "==(1)", 1, partcv, params);
// compiled op node returning opresult9311 (depth = 6)
  int op_slot_right_9305 = gc_frame_newslot(opresult9311);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9314 == NULL) {
    strlit9314 = alloc_String("op");
    gc_root(strlit9314);
  }
// compiled string node returning strlit9314 (depth = 7)
  int op_slot_right_9313 = gc_frame_newslot(strlit9314);
// starting to compile member node (depth = 7)
  int callframe9316 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9317 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe9316);
// compiled member node returning call9317 (depth = 7)
  int op_slot_left_9313 = gc_frame_newslot(call9317);
  params[0] = strlit9314;
  partcv[0] = 1;
  Object opresult9318 = callmethod(call9317, "==(1)", 1, partcv, params);
// compiled op node returning opresult9318 (depth = 6)
  int op_slot_left_9305 = gc_frame_newslot(opresult9318);
  params[0] = opresult9311;
  partcv[0] = 1;
  Object opresult9319 = callmethod(opresult9318, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9319 (depth = 5)
  int op_slot_left_9297 = gc_frame_newslot(opresult9319);
  params[0] = opresult9303;
  partcv[0] = 1;
  Object opresult9320 = callmethod(opresult9319, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9320 (depth = 4)
  Object if9296 = done;
  if (istrue(opresult9320)) {
// Begin line 3109
  setline(3109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9321 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9322 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call9323 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9322);
// compiled member node returning call9323 (depth = 6)
  partcv[0] = 0;
  Object call9324 = callmethodflags(call9323, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9321);
// compiled member node returning call9324 (depth = 5)
  *var_sugg = call9324;
  if (call9324 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3110
  setline(3110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array9325 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9325 (depth = 5)
  *var_suggestions = array9325;
  if (array9325 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3111
  setline(3111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9326 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool9327 = alloc_Boolean(0);
// compiled identifier node returning bool9327 (depth = 5)
  gc_frame_newslot(bool9327);
// starting to compile identifier node (depth = 5)
  Object bool9328 = alloc_Boolean(0);
// compiled identifier node returning bool9328 (depth = 5)
  gc_frame_newslot(bool9328);
// starting to compile string node (depth = 5)
  if (strlit9329 == NULL) {
    strlit9329 = alloc_String(":=");
    gc_root(strlit9329);
  }
// compiled string node returning strlit9329 (depth = 5)
  gc_frame_newslot(strlit9329);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = *var_sym;
  params[1] = bool9327;
  params[2] = bool9328;
  params[3] = strlit9329;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9330 = callmethodflags(*var_sugg, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9326);
// compiled call node returning call9330 (depth = 4)
// Begin line 3112
  setline(3112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9331 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg;
  partcv[0] = 1;
  Object call9332 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9331);
// compiled call node returning call9332 (depth = 4)
// Begin line 3113
  setline(3113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9333 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9334 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  partcv[0] = 0;
  Object call9335 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9334);
// compiled member node returning call9335 (depth = 6)
  partcv[0] = 0;
  Object call9336 = callmethodflags(call9335, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9333);
// compiled member node returning call9336 (depth = 5)
  *var_sugg2 = call9336;
  if (call9336 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3114
  setline(3114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9337 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool9338 = alloc_Boolean(0);
// compiled identifier node returning bool9338 (depth = 5)
  gc_frame_newslot(bool9338);
// starting to compile identifier node (depth = 5)
  Object bool9339 = alloc_Boolean(0);
// compiled identifier node returning bool9339 (depth = 5)
  gc_frame_newslot(bool9339);
// starting to compile string node (depth = 5)
  if (strlit9340 == NULL) {
    strlit9340 = alloc_String("==");
    gc_root(strlit9340);
  }
// compiled string node returning strlit9340 (depth = 5)
  gc_frame_newslot(strlit9340);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  params[0] = *var_sym;
  params[1] = bool9338;
  params[2] = bool9339;
  params[3] = strlit9340;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9341 = callmethodflags(*var_sugg2, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9337);
// compiled call node returning call9341 (depth = 4)
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9342 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  gc_frame_newslot(*var_sugg2);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg2;
  partcv[0] = 1;
  Object call9343 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9342);
// compiled call node returning call9343 (depth = 4)
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9344 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9345 == NULL) {
    strlit9345 = alloc_String("assignment uses ':=', not '='.");
    gc_root(strlit9345);
  }
// compiled string node returning strlit9345 (depth = 5)
  gc_frame_newslot(strlit9345);
// Begin line 3117
  setline(3117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9346 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9347 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9346);
// compiled member node returning call9347 (depth = 5)
  gc_frame_newslot(call9347);
// starting to compile member node (depth = 5)
  int callframe9348 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9349 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9348);
// compiled member node returning call9349 (depth = 5)
  gc_frame_newslot(call9349);
// starting to compile member node (depth = 5)
  int callframe9350 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9351 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9350);
// compiled member node returning call9351 (depth = 5)
  gc_frame_newslot(call9351);
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9345;
  params[1] = call9347;
  params[2] = call9349;
  params[3] = call9351;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9352 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9344);
// compiled call node returning call9352 (depth = 4)
    gc_frame_newslot(call9352);
    if9296 = call9352;
  } else {
  }
// compiled if node returning if9296 (depth = 3)
// Begin line 3120
  setline(3120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9355 == NULL) {
    strlit9355 = alloc_String("rbrace");
    gc_root(strlit9355);
  }
// compiled string node returning strlit9355 (depth = 5)
  int op_slot_right_9354 = gc_frame_newslot(strlit9355);
// starting to compile member node (depth = 5)
  int callframe9357 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9358 = callmethodflags(*var_sym, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe9357);
// compiled member node returning call9358 (depth = 5)
  int op_slot_left_9354 = gc_frame_newslot(call9358);
  params[0] = strlit9355;
  partcv[0] = 1;
  Object opresult9359 = callmethod(call9358, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9359 (depth = 4)
  Object if9353 = done;
  if (istrue(opresult9359)) {
// Begin line 3121
  setline(3121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array9360 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9360 (depth = 5)
  *var_suggestions = array9360;
  if (array9360 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3122
  setline(3122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3123
  setline(3123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block9363 = alloc_Block(NULL, NULL, "parser", 3123);
  gc_frame_newslot(block9363);
// method "_apply"
  block_savedest(block9363);
  Object closure9364 = createclosure(2, "_apply");
  setclosureframe(closure9364, stackframe);
  addtoclosure(closure9364, var_sym);
  addtoclosure(closure9364, selfslot);
  struct UserObject *uo9364 = (struct UserObject*)block9363;
  uo9364->data[0] = (Object)closure9364;
  Method *meth_meth_parser_9364__apply = addmethod2pos(block9363, "_apply", &meth_parser_9364__apply, 0);
  int argcv_meth_parser_9364__apply[] = {0};
  meth_meth_parser_9364__apply->type = alloc_MethodType(1, argcv_meth_parser_9364__apply);
  meth_meth_parser_9364__apply->definitionModule = modulename;
  meth_meth_parser_9364__apply->definitionLine = 183;
// compiled block node returning block9363 (depth = 6)
  int op_slot_right_9362 = gc_frame_newslot(block9363);
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block9374 = alloc_Block(NULL, NULL, "parser", 3123);
  gc_frame_newslot(block9374);
// method "_apply"
  block_savedest(block9374);
  Object closure9375 = createclosure(2, "_apply");
  setclosureframe(closure9375, stackframe);
  addtoclosure(closure9375, var_values);
  addtoclosure(closure9375, selfslot);
  struct UserObject *uo9375 = (struct UserObject*)block9374;
  uo9375->data[0] = (Object)closure9375;
  Method *meth_meth_parser_9375__apply = addmethod2pos(block9374, "_apply", &meth_parser_9375__apply, 0);
  int argcv_meth_parser_9375__apply[] = {0};
  meth_meth_parser_9375__apply->type = alloc_MethodType(1, argcv_meth_parser_9375__apply);
  meth_meth_parser_9375__apply->definitionModule = modulename;
  meth_meth_parser_9375__apply->definitionLine = 183;
// compiled block node returning block9374 (depth = 7)
  int op_slot_right_9373 = gc_frame_newslot(block9374);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9401 = alloc_Float64(0);
// compiled num node returning num9401 (depth = 8)
  int op_slot_right_9400 = gc_frame_newslot(num9401);
// starting to compile member node (depth = 8)
  int callframe9403 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call9404 = callmethodflags(*var_values, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9403);
// compiled member node returning call9404 (depth = 8)
  int op_slot_left_9400 = gc_frame_newslot(call9404);
  params[0] = num9401;
  partcv[0] = 1;
  Object opresult9405 = callmethod(call9404, ">(1)", 1, partcv, params);
// compiled op node returning opresult9405 (depth = 7)
  int op_slot_left_9373 = gc_frame_newslot(opresult9405);
  params[0] = block9374;
  partcv[0] = 1;
  Object opresult9406 = callmethod(opresult9405, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9406 (depth = 6)
  int op_slot_left_9362 = gc_frame_newslot(opresult9406);
  params[0] = block9363;
  partcv[0] = 1;
  Object opresult9407 = callmethod(opresult9406, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9407 (depth = 5)
  Object if9361 = done;
  if (istrue(opresult9407)) {
// Begin line 3124
  setline(3124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9408 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9409 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call9410 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9409);
// compiled member node returning call9410 (depth = 7)
  partcv[0] = 0;
  Object call9411 = callmethodflags(call9410, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9408);
// compiled member node returning call9411 (depth = 6)
  *var_suggestion = call9411;
  if (call9411 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 3125
  setline(3125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9413 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool9414 = alloc_Boolean(1);
// compiled identifier node returning bool9414 (depth = 6)
  gc_frame_newslot(bool9414);
// starting to compile identifier node (depth = 6)
  Object bool9415 = alloc_Boolean(0);
// compiled identifier node returning bool9415 (depth = 6)
  gc_frame_newslot(bool9415);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9417 == NULL) {
    strlit9417 = alloc_String(")");
    gc_root(strlit9417);
  }
// compiled string node returning strlit9417 (depth = 7)
  int op_slot_right_9416 = gc_frame_newslot(strlit9417);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9420 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9421 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9420);
// compiled member node returning call9421 (depth = 8)
  int op_slot_right_9419 = gc_frame_newslot(call9421);
// starting to compile string node (depth = 8)
  if (strlit9423 == NULL) {
    strlit9423 = alloc_String("(");
    gc_root(strlit9423);
  }
// compiled string node returning strlit9423 (depth = 8)
  int op_slot_left_9419 = gc_frame_newslot(strlit9423);
  params[0] = call9421;
  partcv[0] = 1;
  Object opresult9424 = callmethod(strlit9423, "++(1)", 1, partcv, params);
// compiled op node returning opresult9424 (depth = 7)
  int op_slot_left_9416 = gc_frame_newslot(opresult9424);
  params[0] = strlit9417;
  partcv[0] = 1;
  Object opresult9425 = callmethod(opresult9424, "++(1)", 1, partcv, params);
// compiled op node returning opresult9425 (depth = 6)
  gc_frame_newslot(opresult9425);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool9414;
  params[2] = bool9415;
  params[3] = opresult9425;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9426 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9413);
// compiled call node returning call9426 (depth = 5)
// Begin line 3126
  setline(3126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9427 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9428 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9427);
// compiled call node returning call9428 (depth = 5)
// Begin line 3127
  setline(3127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9431 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9432 = callmethodflags(*var_sym, "next", 1, partcv, params, 0);
  gc_frame_end(callframe9431);
// compiled member node returning call9432 (depth = 7)
  int op_slot_right_9430 = gc_frame_newslot(call9432);
// starting to compile identifier node (depth = 7)
  Object bool9434 = alloc_Boolean(0);
// compiled identifier node returning bool9434 (depth = 7)
  int op_slot_left_9430 = gc_frame_newslot(bool9434);
  params[0] = call9432;
  partcv[0] = 1;
  Object opresult9435 = callmethod(bool9434, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9435 (depth = 6)
  Object if9429 = done;
  if (istrue(opresult9435)) {
// Begin line 3128
  setline(3128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9436 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9437 = callmethodflags(*var_sym, "next", 1, partcv, params, 0);
  gc_frame_end(callframe9436);
// compiled member node returning call9437 (depth = 7)
  *var_n = call9437;
  if (call9437 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 3129
  setline(3129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9440 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9441 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9440);
// compiled member node returning call9441 (depth = 8)
  int op_slot_right_9439 = gc_frame_newslot(call9441);
// starting to compile member node (depth = 8)
  int callframe9443 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call9444 = callmethodflags(*var_n, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9443);
// compiled member node returning call9444 (depth = 8)
  int op_slot_left_9439 = gc_frame_newslot(call9444);
  params[0] = call9441;
  partcv[0] = 1;
  Object opresult9445 = callmethod(call9444, "==(1)", 1, partcv, params);
// compiled op node returning opresult9445 (depth = 7)
  Object if9438 = done;
  if (istrue(opresult9445)) {
// Begin line 3130
  setline(3130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9446 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe9447 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9448 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9447);
// compiled member node returning call9448 (depth = 9)
  partcv[0] = 0;
  Object call9449 = callmethodflags(call9448, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9446);
// compiled member node returning call9449 (depth = 8)
  *var_suggestion = call9449;
  if (call9449 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 3131
  setline(3131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9451 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool9452 = alloc_Boolean(1);
// compiled identifier node returning bool9452 (depth = 8)
  gc_frame_newslot(bool9452);
// starting to compile identifier node (depth = 8)
  Object bool9453 = alloc_Boolean(0);
// compiled identifier node returning bool9453 (depth = 8)
  gc_frame_newslot(bool9453);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9455 == NULL) {
    strlit9455 = alloc_String("");
    gc_root(strlit9455);
  }
// compiled string node returning strlit9455 (depth = 9)
  int op_slot_right_9454 = gc_frame_newslot(strlit9455);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe9458 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9459 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9458);
// compiled member node returning call9459 (depth = 10)
  int op_slot_right_9457 = gc_frame_newslot(call9459);
// starting to compile string node (depth = 10)
  if (strlit9461 == NULL) {
    strlit9461 = alloc_String("(");
    gc_root(strlit9461);
  }
// compiled string node returning strlit9461 (depth = 10)
  int op_slot_left_9457 = gc_frame_newslot(strlit9461);
  params[0] = call9459;
  partcv[0] = 1;
  Object opresult9462 = callmethod(strlit9461, "++(1)", 1, partcv, params);
// compiled op node returning opresult9462 (depth = 9)
  int op_slot_left_9454 = gc_frame_newslot(opresult9462);
  params[0] = strlit9455;
  partcv[0] = 1;
  Object opresult9463 = callmethod(opresult9462, "++(1)", 1, partcv, params);
// compiled op node returning opresult9463 (depth = 8)
  gc_frame_newslot(opresult9463);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool9452;
  params[2] = bool9453;
  params[3] = opresult9463;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9464 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9451);
// compiled call node returning call9464 (depth = 7)
// Begin line 3132
  setline(3132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9465 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9466 == NULL) {
    strlit9466 = alloc_String(")");
    gc_root(strlit9466);
  }
// compiled string node returning strlit9466 (depth = 8)
  gc_frame_newslot(strlit9466);
// starting to compile member node (depth = 8)
  int callframe9467 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9468 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9467);
// compiled member node returning call9468 (depth = 8)
  gc_frame_newslot(call9468);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit9466;
  params[1] = call9468;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9469 = callmethodflags(*var_suggestion, "append(1)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9465);
// compiled call node returning call9469 (depth = 7)
// Begin line 3133
  setline(3133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9470 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9471 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9470);
// compiled call node returning call9471 (depth = 7)
    gc_frame_newslot(call9471);
    if9438 = call9471;
  } else {
  }
// compiled if node returning if9438 (depth = 6)
    gc_frame_newslot(if9438);
    if9429 = if9438;
  } else {
  }
// compiled if node returning if9429 (depth = 5)
// Begin line 3136
  setline(3136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9474 == NULL) {
    strlit9474 = alloc_String("identifier");
    gc_root(strlit9474);
  }
// compiled string node returning strlit9474 (depth = 7)
  int op_slot_right_9473 = gc_frame_newslot(strlit9474);
// starting to compile member node (depth = 7)
  int callframe9476 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9477 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call9478 = callmethodflags(*var_values, "last", 1, partcv, params, 0);
  gc_frame_end(callframe9477);
// compiled member node returning call9478 (depth = 8)
  partcv[0] = 0;
  Object call9479 = callmethodflags(call9478, "kind", 1, partcv, params, 0);
  gc_frame_end(callframe9476);
// compiled member node returning call9479 (depth = 7)
  int op_slot_left_9473 = gc_frame_newslot(call9479);
  params[0] = strlit9474;
  partcv[0] = 1;
  Object opresult9480 = callmethod(call9479, "==(1)", 1, partcv, params);
// compiled op node returning opresult9480 (depth = 6)
  Object if9472 = done;
  if (istrue(opresult9480)) {
// Begin line 3137
  setline(3137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9481 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9482 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9483 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9482);
// compiled member node returning call9483 (depth = 8)
  partcv[0] = 0;
  Object call9484 = callmethodflags(call9483, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9481);
// compiled member node returning call9484 (depth = 7)
  *var_suggestion = call9484;
  if (call9484 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 3138
  setline(3138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9486 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool9487 = alloc_Boolean(0);
// compiled identifier node returning bool9487 (depth = 7)
  gc_frame_newslot(bool9487);
// starting to compile identifier node (depth = 7)
  Object bool9488 = alloc_Boolean(0);
// compiled identifier node returning bool9488 (depth = 7)
  gc_frame_newslot(bool9488);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9490 == NULL) {
    strlit9490 = alloc_String("""\x22""");
    gc_root(strlit9490);
  }
// compiled string node returning strlit9490 (depth = 8)
  int op_slot_right_9489 = gc_frame_newslot(strlit9490);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe9493 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9494 = callmethodflags(*var_sym, "value", 1, partcv, params, 0);
  gc_frame_end(callframe9493);
// compiled member node returning call9494 (depth = 9)
  int op_slot_right_9492 = gc_frame_newslot(call9494);
// starting to compile string node (depth = 9)
  if (strlit9496 == NULL) {
    strlit9496 = alloc_String("""\x22""");
    gc_root(strlit9496);
  }
// compiled string node returning strlit9496 (depth = 9)
  int op_slot_left_9492 = gc_frame_newslot(strlit9496);
  params[0] = call9494;
  partcv[0] = 1;
  Object opresult9497 = callmethod(strlit9496, "++(1)", 1, partcv, params);
// compiled op node returning opresult9497 (depth = 8)
  int op_slot_left_9489 = gc_frame_newslot(opresult9497);
  params[0] = strlit9490;
  partcv[0] = 1;
  Object opresult9498 = callmethod(opresult9497, "++(1)", 1, partcv, params);
// compiled op node returning opresult9498 (depth = 7)
  gc_frame_newslot(opresult9498);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool9487;
  params[2] = bool9488;
  params[3] = opresult9498;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9499 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9486);
// compiled call node returning call9499 (depth = 6)
// Begin line 3139
  setline(3139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9500 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9501 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9500);
// compiled call node returning call9501 (depth = 6)
    gc_frame_newslot(call9501);
    if9472 = call9501;
  } else {
  }
// compiled if node returning if9472 (depth = 5)
    gc_frame_newslot(if9472);
    if9361 = if9472;
  } else {
  }
// compiled if node returning if9361 (depth = 4)
// Begin line 3142
  setline(3142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9502 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array9503 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit9504 == NULL) {
    strlit9504 = alloc_String("rbrace");
    gc_root(strlit9504);
  }
// compiled string node returning strlit9504 (depth = 7)
  params[0] = strlit9504;
  partcv[0] = 1;
  callmethodflags(array9503, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array9503 (depth = 6)
  gc_frame_newslot(array9503);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = array9503;
  partcv[0] = 1;
  Object call9505 = callmethodflags(module_parser, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9502);
// compiled call node returning call9505 (depth = 5)
  *var_nextTok = call9505;
  if (call9505 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3143
  setline(3143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_9507 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_9507 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult9509 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult9509 (depth = 5)
  Object if9506 = done;
  if (istrue(opresult9509)) {
// Begin line 3144
  setline(3144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9510 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9511 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call9512 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9511);
// compiled member node returning call9512 (depth = 7)
  partcv[0] = 0;
  Object call9513 = callmethodflags(call9512, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9510);
// compiled member node returning call9513 (depth = 6)
  *var_suggestion = call9513;
  if (call9513 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 3145
  setline(3145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9515 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe9516 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9517 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9516);
// compiled member node returning call9517 (depth = 6)
  gc_frame_newslot(call9517);
// starting to compile call node (depth = 6)
  int callframe9518 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num9519 = alloc_Float64(1);
// compiled num node returning num9519 (depth = 7)
  gc_frame_newslot(num9519);
// starting to compile member node (depth = 7)
  int callframe9520 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9521 = callmethodflags(*var_lastToken, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe9520);
// compiled member node returning call9521 (depth = 7)
  gc_frame_newslot(call9521);
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe9522 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe9523 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9524 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9523);
// compiled member node returning call9524 (depth = 8)
  gc_frame_newslot(call9524);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9525 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  partcv[0] = 0;
  Object call9526 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe9525);
// compiled member node returning call9526 (depth = 8)
  params[0] = call9524;
  partcv[0] = 1;
  Object call9527 = callmethodflags(call9526, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9522);
// compiled call node returning call9527 (depth = 7)
  params[0] = num9519;
  params[1] = call9521;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9528 = callmethodflags(call9527, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9518);
// compiled call node returning call9528 (depth = 6)
  gc_frame_newslot(call9528);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = call9517;
  params[1] = call9528;
  partcv[0] = 2;
  Object call9529 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9515);
// compiled call node returning call9529 (depth = 5)
// Begin line 3146
  setline(3146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9530 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe9531 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9532 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9531);
// compiled member node returning call9532 (depth = 7)
  gc_frame_newslot(call9532);
// starting to compile member node (depth = 7)
  int callframe9533 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe9534 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe9535 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9536 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9535);
// compiled member node returning call9536 (depth = 9)
  gc_frame_newslot(call9536);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe9537 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call9538 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe9537);
// compiled member node returning call9538 (depth = 9)
  params[0] = call9536;
  partcv[0] = 1;
  Object call9539 = callmethodflags(call9538, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9534);
// compiled call node returning call9539 (depth = 8)
  partcv[0] = 0;
  Object call9540 = callmethodflags(call9539, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9533);
// compiled member node returning call9540 (depth = 7)
  gc_frame_newslot(call9540);
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe9541 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe9542 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9543 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9542);
// compiled member node returning call9543 (depth = 8)
  gc_frame_newslot(call9543);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9544 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  partcv[0] = 0;
  Object call9545 = callmethodflags(*var_util, "lines", 1, partcv, params, 0);
  gc_frame_end(callframe9544);
// compiled member node returning call9545 (depth = 8)
  params[0] = call9543;
  partcv[0] = 1;
  Object call9546 = callmethodflags(call9545, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9541);
// compiled call node returning call9546 (depth = 7)
  params[0] = call9532;
  params[1] = call9540;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9547 = callmethodflags(call9546, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9530);
// compiled call node returning call9547 (depth = 6)
  *var_newLine = call9547;
  if (call9547 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9548 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9550 = alloc_Float64(0.1);
// compiled num node returning num9550 (depth = 7)
  int op_slot_right_9549 = gc_frame_newslot(num9550);
// starting to compile member node (depth = 7)
  int callframe9552 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9553 = callmethodflags(*var_lastToken, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9552);
// compiled member node returning call9553 (depth = 7)
  int op_slot_left_9549 = gc_frame_newslot(call9553);
  params[0] = num9550;
  partcv[0] = 1;
  Object sum9554 = callmethod(call9553, "+(1)", 1, partcv, params);
// compiled op node returning sum9554 (depth = 6)
  gc_frame_newslot(sum9554);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum9554;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call9555 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9548);
// compiled call node returning call9555 (depth = 5)
// Begin line 3148
  setline(3148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9556 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9557 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9556);
// compiled call node returning call9557 (depth = 5)
    gc_frame_newslot(call9557);
    if9506 = call9557;
  } else {
// Begin line 3150
  setline(3150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9558 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9559 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call9560 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9559);
// compiled member node returning call9560 (depth = 7)
  partcv[0] = 0;
  Object call9561 = callmethodflags(call9560, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9558);
// compiled member node returning call9561 (depth = 6)
  *var_suggestion = call9561;
  if (call9561 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 3151
  setline(3151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9563 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe9564 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call9565 = callmethodflags(*var_nextTok, "prev", 1, partcv, params, 0);
  gc_frame_end(callframe9564);
// compiled member node returning call9565 (depth = 6)
  gc_frame_newslot(call9565);
// starting to compile identifier node (depth = 6)
  Object bool9566 = alloc_Boolean(1);
// compiled identifier node returning bool9566 (depth = 6)
  gc_frame_newslot(bool9566);
// starting to compile identifier node (depth = 6)
  Object bool9567 = alloc_Boolean(0);
// compiled identifier node returning bool9567 (depth = 6)
  gc_frame_newslot(bool9567);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call9565;
  params[2] = bool9566;
  params[3] = bool9567;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9568 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9563);
// compiled call node returning call9568 (depth = 5)
// Begin line 3152
  setline(3152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9569 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9570 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9569);
// compiled call node returning call9570 (depth = 5)
    gc_frame_newslot(call9570);
    if9506 = call9570;
  }
// compiled if node returning if9506 (depth = 4)
// Begin line 3154
  setline(3154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9571 = gc_frame_new();
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 3157
  setline(3157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit9573 == NULL) {
    strlit9573 = alloc_String("or by omitting a part of a method name.");
    gc_root(strlit9573);
  }
// compiled string node returning strlit9573 (depth = 6)
  int op_slot_right_9572 = gc_frame_newslot(strlit9573);
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 3156
  setline(3156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit9576 == NULL) {
    strlit9576 = alloc_String("This error is often caused by unbalanced parentheses, ");
    gc_root(strlit9576);
  }
// compiled string node returning strlit9576 (depth = 7)
  int op_slot_right_9575 = gc_frame_newslot(strlit9576);
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit9578 == NULL) {
    strlit9578 = alloc_String("multiple statements must be separated by a newline or a semicolon. ");
    gc_root(strlit9578);
  }
// compiled string node returning strlit9578 (depth = 7)
  int op_slot_left_9575 = gc_frame_newslot(strlit9578);
  params[0] = strlit9576;
  partcv[0] = 1;
  Object opresult9579 = callmethod(strlit9578, "++(1)", 1, partcv, params);
// compiled op node returning opresult9579 (depth = 6)
  int op_slot_left_9572 = gc_frame_newslot(opresult9579);
  params[0] = strlit9573;
  partcv[0] = 1;
  Object opresult9580 = callmethod(opresult9579, "++(1)", 1, partcv, params);
// compiled op node returning opresult9580 (depth = 5)
  gc_frame_newslot(opresult9580);
// Begin line 3158
  setline(3158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9582 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9581);
// compiled member node returning call9582 (depth = 5)
  gc_frame_newslot(call9582);
// starting to compile member node (depth = 5)
  int callframe9583 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9584 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9583);
// compiled member node returning call9584 (depth = 5)
  gc_frame_newslot(call9584);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 3154
  setline(3154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult9580;
  params[1] = call9582;
  params[2] = call9584;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9585 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9571);
// compiled call node returning call9585 (depth = 4)
    gc_frame_newslot(call9585);
    if9353 = call9585;
  } else {
  }
// compiled if node returning if9353 (depth = 3)
    gc_frame_newslot(if9353);
    if9288 = if9353;
  } else {
  }
// compiled if node returning if9288 (depth = 2)
  gc_frame_end(frame);
  return if9288;
}
Object meth_parser_9637__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9639 = alloc_Float64(0);
// compiled num node returning num9639 (depth = 5)
  int op_slot_right_9638 = gc_frame_newslot(num9639);
// starting to compile member node (depth = 5)
  int callframe9641 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call9642 = callmethodflags(*var_tokens, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9641);
// compiled member node returning call9642 (depth = 5)
  int op_slot_left_9638 = gc_frame_newslot(call9642);
  params[0] = num9639;
  partcv[0] = 1;
  Object opresult9643 = callmethod(call9642, ">(1)", 1, partcv, params);
// compiled op node returning opresult9643 (depth = 4)
  gc_frame_end(frame);
  return opresult9643;
}
Object meth_parser_9656__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile member node (depth = 7)
  int callframe9657 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9658 = callmethodflags(self, "inheritOrUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9657);
// compiled member node returning call9658 (depth = 7)
  gc_frame_end(frame);
  return call9658;
}
Object meth_parser_9646__apply(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_oldlength = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
  Object *var_parentNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "parentNode");
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// definebindings:
// Begin line 3186
  setline(3186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9647 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9648 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9647);
// compiled member node returning call9648 (depth = 4)
// Begin line 3187
  setline(3187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9649 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9650 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9649);
// compiled member node returning call9650 (depth = 4)
// Begin line 3188
  setline(3188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9651 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9652 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9651);
// compiled member node returning call9652 (depth = 4)
// Begin line 3189
  setline(3189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9654 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9655 = alloc_Block(NULL, NULL, "parser", 3189);
  gc_frame_newslot(block9655);
// method "_apply"
  block_savedest(block9655);
  Object closure9656 = createclosure(1, "_apply");
  setclosureframe(closure9656, stackframe);
  addtoclosure(closure9656, selfslot);
  struct UserObject *uo9656 = (struct UserObject*)block9655;
  uo9656->data[0] = (Object)closure9656;
  Method *meth_meth_parser_9656__apply = addmethod2pos(block9655, "_apply", &meth_parser_9656__apply, 0);
  int argcv_meth_parser_9656__apply[] = {0};
  meth_meth_parser_9656__apply->type = alloc_MethodType(1, argcv_meth_parser_9656__apply);
  meth_meth_parser_9656__apply->definitionModule = modulename;
  meth_meth_parser_9656__apply->definitionLine = 183;
// compiled block node returning block9655 (depth = 6)
  gc_frame_newslot(block9655);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning module_parser (depth = 6)
  params[0] = block9655;
  partcv[0] = 1;
  Object call9660 = callmethodflags(module_parser, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9654);
// compiled call node returning call9660 (depth = 5)
  Object if9653 = done;
  if (istrue(call9660)) {
// Begin line 3190
  setline(3190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9661 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call9662 = callmethodflags(*var_values, "pop", 1, partcv, params, 0);
  gc_frame_end(callframe9661);
// compiled member node returning call9662 (depth = 6)
  *var_parentNode = call9662;
  if (call9662 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 3191
  setline(3191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9664 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_parentNode (depth = 7)
  partcv[0] = 0;
  Object call9665 = callmethodflags(*var_parentNode, "isUse", 1, partcv, params, 0);
  gc_frame_end(callframe9664);
// compiled member node returning call9665 (depth = 6)
  Object if9663 = done;
  if (istrue(call9665)) {
// Begin line 3192
  setline(3192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9666 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_parentNode (depth = 7)
  gc_frame_newslot(*var_parentNode);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9667 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_moduleObject (depth = 8)
  partcv[0] = 0;
  Object call9668 = callmethodflags(*var_moduleObject, "usedTraits", 1, partcv, params, 0);
  gc_frame_end(callframe9667);
// compiled member node returning call9668 (depth = 7)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call9669 = callmethodflags(call9668, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9666);
// compiled call node returning call9669 (depth = 6)
    gc_frame_newslot(call9669);
    if9663 = call9669;
  } else {
// Begin line 3195
  setline(3195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3193
  setline(3193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe9671 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9672 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_moduleObject (depth = 9)
  partcv[0] = 0;
  Object call9673 = callmethodflags(*var_moduleObject, "usedTraits", 1, partcv, params, 0);
  gc_frame_end(callframe9672);
// compiled member node returning call9673 (depth = 8)
  partcv[0] = 0;
  Object call9674 = callmethodflags(call9673, "isEmpty", 1, partcv, params, 0);
  gc_frame_end(callframe9671);
// compiled member node returning call9674 (depth = 7)
  Object if9670 = done;
  if (istrue(call9674)) {
// Begin line 3194
  setline(3194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9675 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  gc_frame_newslot(*var_parentNode);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_moduleObject (depth = 8)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call9676 = callmethodflags(*var_moduleObject, "superclass:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9675);
// compiled call node returning call9676 (depth = 7)
    gc_frame_newslot(call9676);
    if9670 = call9676;
  } else {
// Begin line 3196
  setline(3196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9677 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 3197
  setline(3197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit9679 == NULL) {
    strlit9679 = alloc_String("before 'use' in a module.");
    gc_root(strlit9679);
  }
// compiled string node returning strlit9679 (depth = 9)
  int op_slot_right_9678 = gc_frame_newslot(strlit9679);
// Begin line 3196
  setline(3196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit9681 == NULL) {
    strlit9681 = alloc_String("'inherit' must come ");
    gc_root(strlit9681);
  }
// compiled string node returning strlit9681 (depth = 9)
  int op_slot_left_9678 = gc_frame_newslot(strlit9681);
  params[0] = strlit9679;
  partcv[0] = 1;
  Object opresult9682 = callmethod(strlit9681, "++(1)", 1, partcv, params);
// compiled op node returning opresult9682 (depth = 8)
  gc_frame_newslot(opresult9682);
// Begin line 3198
  setline(3198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe9683 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call9684 = callmethodflags(*var_parentNode, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9683);
// compiled member node returning call9684 (depth = 8)
  gc_frame_newslot(call9684);
// starting to compile member node (depth = 8)
  int callframe9685 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call9686 = callmethodflags(*var_parentNode, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9685);
// compiled member node returning call9686 (depth = 8)
  gc_frame_newslot(call9686);
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9688 = alloc_Float64(6);
// compiled num node returning num9688 (depth = 9)
  int op_slot_right_9687 = gc_frame_newslot(num9688);
// starting to compile member node (depth = 9)
  int callframe9690 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  partcv[0] = 0;
  Object call9691 = callmethodflags(*var_parentNode, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9690);
// compiled member node returning call9691 (depth = 9)
  int op_slot_left_9687 = gc_frame_newslot(call9691);
  params[0] = num9688;
  partcv[0] = 1;
  Object sum9692 = callmethod(call9691, "+(1)", 1, partcv, params);
// compiled op node returning sum9692 (depth = 8)
  gc_frame_newslot(sum9692);
// call case 6: other requests
// Begin line 3196
  setline(3196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult9682;
  params[1] = call9684;
  params[2] = call9686;
  params[3] = sum9692;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call9693 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe9677);
// compiled call node returning call9693 (depth = 7)
    gc_frame_newslot(call9693);
    if9670 = call9693;
  }
// compiled if node returning if9670 (depth = 6)
    gc_frame_newslot(if9670);
    if9663 = if9670;
  }
// compiled if node returning if9663 (depth = 5)
    gc_frame_newslot(if9663);
    if9653 = if9663;
  } else {
  }
// compiled if node returning if9653 (depth = 4)
// Begin line 3202
  setline(3202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9694 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9695 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9694);
// compiled member node returning call9695 (depth = 4)
// Begin line 3203
  setline(3203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9696 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9697 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9696);
// compiled member node returning call9697 (depth = 4)
// Begin line 3204
  setline(3204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldlength (depth = 6)
  int op_slot_right_9699 = gc_frame_newslot(*var_oldlength);
// starting to compile member node (depth = 6)
  int callframe9701 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call9702 = callmethodflags(*var_tokens, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9701);
// compiled member node returning call9702 (depth = 6)
  int op_slot_left_9699 = gc_frame_newslot(call9702);
  params[0] = *var_oldlength;
  partcv[0] = 1;
  Object opresult9703 = callmethod(call9702, "==(1)", 1, partcv, params);
// compiled op node returning opresult9703 (depth = 5)
  Object if9698 = done;
  if (istrue(opresult9703)) {
// Begin line 3205
  setline(3205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9704 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9705 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call9706 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9705);
// compiled member node returning call9706 (depth = 7)
  partcv[0] = 0;
  Object call9707 = callmethodflags(call9706, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9704);
// compiled member node returning call9707 (depth = 6)
  *var_suggestion = call9707;
  if (call9707 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 3206
  setline(3206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9708 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call9709 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9708);
// compiled call node returning call9709 (depth = 5)
// Begin line 3207
  setline(3207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9710 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit9712 == NULL) {
    strlit9712 = alloc_String("caused by an extra '}', ')', or ']'.");
    gc_root(strlit9712);
  }
// compiled string node returning strlit9712 (depth = 7)
  int op_slot_right_9711 = gc_frame_newslot(strlit9712);
// Begin line 3207
  setline(3207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit9714 == NULL) {
    strlit9714 = alloc_String("invalid statement. This is often ");
    gc_root(strlit9714);
  }
// compiled string node returning strlit9714 (depth = 7)
  int op_slot_left_9711 = gc_frame_newslot(strlit9714);
  params[0] = strlit9712;
  partcv[0] = 1;
  Object opresult9715 = callmethod(strlit9714, "++(1)", 1, partcv, params);
// compiled op node returning opresult9715 (depth = 6)
  gc_frame_newslot(opresult9715);
// Begin line 3209
  setline(3209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe9716 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9717 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9716);
// compiled member node returning call9717 (depth = 6)
  gc_frame_newslot(call9717);
// starting to compile member node (depth = 6)
  int callframe9718 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9719 = callmethodflags(*var_sym, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9718);
// compiled member node returning call9719 (depth = 6)
  gc_frame_newslot(call9719);
// starting to compile member node (depth = 6)
  int callframe9720 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9721 = callmethodflags(*var_sym, "endPos", 1, partcv, params, 0);
  gc_frame_end(callframe9720);
// compiled member node returning call9721 (depth = 6)
  gc_frame_newslot(call9721);
// Begin line 3210
  setline(3210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 3207
  setline(3207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult9715;
  params[1] = call9717;
  params[2] = call9719;
  params[3] = call9721;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9722 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9710);
// compiled call node returning call9722 (depth = 5)
    gc_frame_newslot(call9722);
    if9698 = call9722;
  } else {
  }
// compiled if node returning if9698 (depth = 4)
// Begin line 3212
  setline(3212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9723 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call9724 = callmethodflags(*var_tokens, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9723);
// compiled member node returning call9724 (depth = 5)
  *var_oldlength = call9724;
  if (call9724 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9586_parse_40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 89, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parse(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parse(_)");
  Object params[5];
  int partcv[3];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_moduleObject = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parse(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_toks = &(stackframe->slots[0]);
  *var_toks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parse(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// definebindings:
  Object *var_sugg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sugg");
// definebindings:
  Object *var_oldlength = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldlength");
// Begin line 3168
  setline(3168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9587 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit9588 == NULL) {
    strlit9588 = alloc_String("parsing.");
    gc_root(strlit9588);
  }
// compiled string node returning strlit9588 (depth = 3)
  gc_frame_newslot(strlit9588);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit9588;
  partcv[0] = 1;
  Object call9589 = callmethodflags(*var_util, "log_verbose(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9587);
// compiled call node returning call9589 (depth = 2)
// Begin line 3169
  setline(3169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9590 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  gc_frame_newslot(*var_values);
// starting to compile member node (depth = 4)
  int callframe9591 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call9592 = callmethodflags(*var_util, "modname", 1, partcv, params, 0);
  gc_frame_end(callframe9591);
// compiled member node returning call9592 (depth = 4)
  gc_frame_newslot(call9592);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9593 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call9594 = callmethodflags(*var_ast, "moduleNode", 1, partcv, params, 0);
  gc_frame_end(callframe9593);
// compiled member node returning call9594 (depth = 4)
  params[0] = *var_values;
  params[1] = call9592;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9595 = callmethodflags(call9594, "body(1)named(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9590);
// compiled call node returning call9595 (depth = 3)
  *var_moduleObject = call9595;
  if (call9595 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 3171
  setline(3171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num9599 = alloc_Float64(0);
// compiled num node returning num9599 (depth = 4)
  int op_slot_right_9598 = gc_frame_newslot(num9599);
// starting to compile member node (depth = 4)
  int callframe9601 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_toks (depth = 5)
  partcv[0] = 0;
  Object call9602 = callmethodflags(*var_toks, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9601);
// compiled member node returning call9602 (depth = 4)
  int op_slot_left_9598 = gc_frame_newslot(call9602);
  params[0] = num9599;
  partcv[0] = 1;
  Object opresult9603 = callmethod(call9602, "==(1)", 1, partcv, params);
// compiled op node returning opresult9603 (depth = 3)
  Object if9597 = done;
  if (istrue(opresult9603)) {
// Begin line 3172
  setline(3172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_moduleObject (depth = 4)
  return *var_moduleObject;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if9597 = undefined;
  } else {
  }
// compiled if node returning if9597 (depth = 2)
// Begin line 3174
  setline(3174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_toks (depth = 3)
  *var_tokens = *var_toks;
  if (*var_toks == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 3175
  setline(3175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe9605 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9606 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9605);
// compiled member node returning call9606 (depth = 2)
// Begin line 3177
  setline(3177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num9609 = alloc_Float64(0);
// compiled num node returning num9609 (depth = 4)
  int op_slot_right_9608 = gc_frame_newslot(num9609);
// starting to compile member node (depth = 4)
  int callframe9611 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9612 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe9611);
// compiled member node returning call9612 (depth = 4)
  int op_slot_left_9608 = gc_frame_newslot(call9612);
  params[0] = num9609;
  partcv[0] = 1;
  Object opresult9613 = callmethod(call9612, ">(1)", 1, partcv, params);
// compiled op node returning opresult9613 (depth = 3)
  Object if9607 = done;
  if (istrue(opresult9613)) {
// Begin line 3178
  setline(3178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9614 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9615 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  partcv[0] = 0;
  Object call9616 = callmethodflags(*var_errormessages, "suggestion", 1, partcv, params, 0);
  gc_frame_end(callframe9615);
// compiled member node returning call9616 (depth = 5)
  partcv[0] = 0;
  Object call9617 = callmethodflags(call9616, "new", 1, partcv, params, 0);
  gc_frame_end(callframe9614);
// compiled member node returning call9617 (depth = 4)
  *var_sugg = call9617;
  if (call9617 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3179
  setline(3179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9618 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num9619 = alloc_Float64(1);
// compiled num node returning num9619 (depth = 4)
  gc_frame_newslot(num9619);
// starting to compile member node (depth = 4)
  int callframe9620 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9621 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe9620);
// compiled member node returning call9621 (depth = 4)
  gc_frame_newslot(call9621);
// starting to compile member node (depth = 4)
  int callframe9622 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9623 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9622);
// compiled member node returning call9623 (depth = 4)
  gc_frame_newslot(call9623);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = num9619;
  params[1] = call9621;
  params[2] = call9623;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9624 = callmethodflags(*var_sugg, "deleteRange(2)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9618);
// compiled call node returning call9624 (depth = 3)
// Begin line 3180
  setline(3180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9625 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9626 == NULL) {
    strlit9626 = alloc_String("the first line must not be indented.");
    gc_root(strlit9626);
  }
// compiled string node returning strlit9626 (depth = 4)
  gc_frame_newslot(strlit9626);
// Begin line 3181
  setline(3181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9627 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9628 = callmethodflags(*var_sym, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9627);
// compiled member node returning call9628 (depth = 4)
  gc_frame_newslot(call9628);
// starting to compile num node (depth = 4)
  Object num9629 = alloc_Float64(1);
// compiled num node returning num9629 (depth = 4)
  gc_frame_newslot(num9629);
// starting to compile member node (depth = 4)
  int callframe9630 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call9631 = callmethodflags(*var_sym, "indent", 1, partcv, params, 0);
  gc_frame_end(callframe9630);
// compiled member node returning call9631 (depth = 4)
  gc_frame_newslot(call9631);
// Begin line 3182
  setline(3182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3180
  setline(3180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit9626;
  params[1] = call9628;
  params[2] = num9629;
  params[3] = call9631;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9632 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9625);
// compiled call node returning call9632 (depth = 3)
    gc_frame_newslot(call9632);
    if9607 = call9632;
  } else {
  }
// compiled if node returning if9607 (depth = 2)
// Begin line 3184
  setline(3184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9633 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  partcv[0] = 0;
  Object call9634 = callmethodflags(*var_tokens, "size", 1, partcv, params, 0);
  gc_frame_end(callframe9633);
// compiled member node returning call9634 (depth = 3)
  *var_oldlength = call9634;
  if (call9634 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3185
  setline(3185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9635 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9636 = alloc_Block(NULL, NULL, "parser", 3185);
  gc_frame_newslot(block9636);
// method "_apply"
  block_savedest(block9636);
  Object closure9637 = createclosure(2, "_apply");
  setclosureframe(closure9637, stackframe);
  addtoclosure(closure9637, var_tokens);
  addtoclosure(closure9637, selfslot);
  struct UserObject *uo9637 = (struct UserObject*)block9636;
  uo9637->data[0] = (Object)closure9637;
  Method *meth_meth_parser_9637__apply = addmethod2pos(block9636, "_apply", &meth_parser_9637__apply, 0);
  int argcv_meth_parser_9637__apply[] = {0};
  meth_meth_parser_9637__apply->type = alloc_MethodType(1, argcv_meth_parser_9637__apply);
  meth_meth_parser_9637__apply->definitionModule = modulename;
  meth_meth_parser_9637__apply->definitionLine = 183;
// compiled block node returning block9636 (depth = 3)
  gc_frame_newslot(block9636);
// starting to compile block node (depth = 3)
  Object block9645 = alloc_Block(NULL, NULL, "parser", 3185);
  gc_frame_newslot(block9645);
// method "_apply"
  block_savedest(block9645);
  Object closure9646 = createclosure(7, "_apply");
  setclosureframe(closure9646, stackframe);
  addtoclosure(closure9646, var_values);
  addtoclosure(closure9646, var_moduleObject);
  addtoclosure(closure9646, var_errormessages);
  addtoclosure(closure9646, var_oldlength);
  addtoclosure(closure9646, var_tokens);
  addtoclosure(closure9646, var_sym);
  addtoclosure(closure9646, selfslot);
  struct UserObject *uo9646 = (struct UserObject*)block9645;
  uo9646->data[0] = (Object)closure9646;
  Method *meth_meth_parser_9646__apply = addmethod2pos(block9645, "_apply", &meth_parser_9646__apply, 0);
  int argcv_meth_parser_9646__apply[] = {0};
  meth_meth_parser_9646__apply->type = alloc_MethodType(1, argcv_meth_parser_9646__apply);
  meth_meth_parser_9646__apply->definitionModule = modulename;
  meth_meth_parser_9646__apply->definitionLine = 183;
// compiled block node returning block9645 (depth = 3)
  gc_frame_newslot(block9645);
// call case 5: prelude request
  params[0] = block9636;
  params[1] = block9645;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9727 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9635);
// compiled call node returning call9727 (depth = 2)
// Begin line 3214
  setline(3214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe9728 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9729 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9728);
// compiled member node returning call9729 (depth = 2)
// Begin line 3215
  setline(3215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe9730 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9731 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9730);
// compiled member node returning call9731 (depth = 2)
// Begin line 3216
  setline(3216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleObject (depth = 3)
  return *var_moduleObject;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_9733_lastLine(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 90, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastLine (depth = 3)
  gc_frame_end(frame);
  return *var_lastLine;
}
Object meth_parser_9734_lastLine_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 91, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastLine:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastLine:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lastLine:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastLine = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9737_lastIndent(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 92, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastIndent (depth = 3)
  gc_frame_end(frame);
  return *var_lastIndent;
}
Object meth_parser_9738_lastIndent_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 93, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastIndent:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastIndent:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lastIndent:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9741_indentFreePass(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 94, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  gc_frame_end(frame);
  return *var_indentFreePass;
}
Object meth_parser_9742_indentFreePass_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 95, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indentFreePass:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indentFreePass:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part indentFreePass:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_indentFreePass = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9745_minIndentLevel(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 96, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  gc_frame_end(frame);
  return *var_minIndentLevel;
}
Object meth_parser_9746_minIndentLevel_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 97, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method minIndentLevel:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for minIndentLevel:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part minIndentLevel:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_minIndentLevel = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9749_statementIndent(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 98, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementIndent (depth = 3)
  gc_frame_end(frame);
  return *var_statementIndent;
}
Object meth_parser_9750_statementIndent_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 99, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method statementIndent:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementIndent:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part statementIndent:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9753_tokens(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 100, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_parser_9754_tokens_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 101, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method tokens:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokens:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part tokens:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_tokens = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9756_moduleObject(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 102, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleObject (depth = 3)
  gc_frame_end(frame);
  return *var_moduleObject;
}
Object meth_parser_9757_moduleObject_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 103, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleObject:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method moduleObject:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_moduleObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleObject:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part moduleObject:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_moduleObject = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9761_comments(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 104, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  gc_frame_end(frame);
  return *var_comments;
}
Object meth_parser_9762_comments_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 105, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method comments:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comments:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part comments:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comments = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9765_auto_count(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 106, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_auto_count (depth = 3)
  gc_frame_end(frame);
  return *var_auto_count;
}
Object meth_parser_9766_auto_count_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 107, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method auto_count:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for auto_count:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part auto_count:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_auto_count = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9769_noBlocks(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 108, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noBlocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noBlocks (depth = 3)
  gc_frame_end(frame);
  return *var_noBlocks;
}
Object meth_parser_9771_blocksOK(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 109, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blocksOK");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blocksOK (depth = 3)
  gc_frame_end(frame);
  return *var_blocksOK;
}
Object meth_parser_9773_values(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 110, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_9774_values_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 111, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method values:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part values:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_values = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9784__61__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// definebindings:
// definebindings:
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9787 = alloc_Boolean(0);
// compiled identifier node returning bool9787 (depth = 5)
  int op_slot_right_9786 = gc_frame_newslot(bool9787);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  int op_slot_left_9786 = gc_frame_newslot(*var_other);
  params[0] = bool9787;
  partcv[0] = 1;
  Object opresult9789 = callmethod(*var_other, "==(1)", 1, partcv, params);
// compiled op node returning opresult9789 (depth = 4)
  Object if9785 = done;
  if (istrue(opresult9789)) {
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9790 = alloc_Boolean(0);
// compiled identifier node returning bool9790 (depth = 4)
    gc_frame_newslot(bool9790);
    if9785 = bool9790;
  } else {
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9793 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9794 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9793);
// compiled member node returning call9794 (depth = 6)
  int op_slot_right_9792 = gc_frame_newslot(call9794);
// starting to compile member node (depth = 6)
  int callframe9796 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call9797 = callmethodflags(*var_other, "linePos", 1, partcv, params, 0);
  gc_frame_end(callframe9796);
// compiled member node returning call9797 (depth = 6)
  int op_slot_left_9792 = gc_frame_newslot(call9797);
  params[0] = call9794;
  partcv[0] = 1;
  Object opresult9798 = callmethod(call9797, "==(1)", 1, partcv, params);
// compiled op node returning opresult9798 (depth = 5)
  int op_slot_right_9791 = gc_frame_newslot(opresult9798);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9801 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9802 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9801);
// compiled member node returning call9802 (depth = 6)
  int op_slot_right_9800 = gc_frame_newslot(call9802);
// starting to compile member node (depth = 6)
  int callframe9804 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call9805 = callmethodflags(*var_other, "line", 1, partcv, params, 0);
  gc_frame_end(callframe9804);
// compiled member node returning call9805 (depth = 6)
  int op_slot_left_9800 = gc_frame_newslot(call9805);
  params[0] = call9802;
  partcv[0] = 1;
  Object opresult9806 = callmethod(call9805, "==(1)", 1, partcv, params);
// compiled op node returning opresult9806 (depth = 5)
  int op_slot_left_9791 = gc_frame_newslot(opresult9806);
  params[0] = opresult9798;
  partcv[0] = 1;
  Object opresult9807 = callmethod(opresult9806, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9807 (depth = 4)
    gc_frame_newslot(opresult9807);
    if9785 = opresult9807;
  }
// compiled if node returning if9785 (depth = 3)
  gc_frame_end(frame);
  return if9785;
}
Object meth_parser_9814_sym(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 112, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  gc_frame_end(frame);
  return *var_sym;
}
Object meth_parser_9815_sym_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 113, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sym:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sym:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sym:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_sym = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9817_lastToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 114, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_end(frame);
  return *var_lastToken;
}
Object meth_parser_9818_lastToken_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 115, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastToken:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastToken:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lastToken:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9820_previousCommentToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 116, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_previousCommentToken (depth = 3)
  gc_frame_end(frame);
  return *var_previousCommentToken;
}
Object meth_parser_9821_previousCommentToken_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 117, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method previousCommentToken:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for previousCommentToken:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part previousCommentToken:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_previousCommentToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9823_statementToken(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 118, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementToken (depth = 3)
  gc_frame_end(frame);
  return *var_statementToken;
}
Object meth_parser_9824_statementToken_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 119, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method statementToken:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementToken:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part statementToken:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_9827_comment(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 120, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comment (depth = 3)
  gc_frame_end(frame);
  return *var_comment;
}
Object meth_parser_9828_comment_58__61__40_1_41_(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 121, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method comment:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comment:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part comment:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// definebindings:
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comment = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object module_parser_init() {
  if (module_parser) return module_parser;
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(127, 127);
  module_parser = self;
  self->class->definitionModule = "parser";
  gc_root(self);
  prelude = module_standardGrace_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule("parser");
  setsource(originalSourceLines);
  setclassname(self, "Module<parser>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(127, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[1];
// definebindings:
  Object *var_io = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "io");
  Object *var_ast = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ast");
  Object *var_util = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "util");
  Object *var_errormessages = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "errormessages");
  Object *var_lastLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "lastLine");
  Object *var_lastIndent = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "lastIndent");
  Object *var_indentFreePass = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "indentFreePass");
  Object *var_minIndentLevel = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "minIndentLevel");
  Object *var_statementIndent = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "statementIndent");
  Object *var_tokens = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tokens");
  Object *var_moduleObject = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "moduleObject");
  Object *var_comments = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "comments");
  Object *var_auto_count = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "auto_count");
  Object *var_noBlocks = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "noBlocks");
  Object *var_blocksOK = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "blocksOK");
  Object *var_values = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "values");
  Object *var_sym = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "sym");
  Object *var_lastToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "lastToken");
  Object *var_previousCommentToken = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "previousCommentToken");
  Object *var_statementToken = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "statementToken");
  Object *var_comment = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "comment");
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "next"
  block_savedest(self);
  Object closure1 = createclosure(7, "next");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_tokens);
  addtoclosure(closure1, var_sym);
  addtoclosure(closure1, var_lastToken);
  addtoclosure(closure1, var_lastLine);
  addtoclosure(closure1, var_lastIndent);
  addtoclosure(closure1, var_util);
  addtoclosure(closure1, var_errormessages);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_parser_1_next = addmethod2pos(self, "next", &meth_parser_1_next, 1);
  int argcv_meth_parser_1_next[] = {0};
  meth_meth_parser_1_next->type = alloc_MethodType(1, argcv_meth_parser_1_next);
  meth_meth_parser_1_next->definitionModule = modulename;
  meth_meth_parser_1_next->definitionLine = 70;
// compiled method node returning  (depth = 1)
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "indentHasIncreased"
  block_savedest(self);
  Object closure38 = createclosure(3, "indentHasIncreased");
  setclosureframe(closure38, stackframe);
  addtoclosure(closure38, var_lastIndent);
  addtoclosure(closure38, var_sym);
  addtoclosure(closure38, var_lastLine);
  struct UserObject *uo38 = (struct UserObject*)self;
  uo38->data[2] = (Object)closure38;
  Method *meth_meth_parser_38_indentHasIncreased = addmethod2pos(self, "indentHasIncreased", &meth_parser_38_indentHasIncreased, 2);
  int argcv_meth_parser_38_indentHasIncreased[] = {0};
  meth_meth_parser_38_indentHasIncreased->type = alloc_MethodType(1, argcv_meth_parser_38_indentHasIncreased);
  meth_meth_parser_38_indentHasIncreased->definitionModule = modulename;
  meth_meth_parser_38_indentHasIncreased->definitionLine = 88;
// compiled method node returning  (depth = 1)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "saveParsePosition"
  block_savedest(self);
  Object closure84 = createclosure(2, "saveParsePosition");
  setclosureframe(closure84, stackframe);
  addtoclosure(closure84, var_tokens);
  addtoclosure(closure84, var_values);
  struct UserObject *uo84 = (struct UserObject*)self;
  uo84->data[3] = (Object)closure84;
  Method *meth_meth_parser_84_saveParsePosition = addmethod2pos(self, "saveParsePosition", &meth_parser_84_saveParsePosition, 3);
  int argcv_meth_parser_84_saveParsePosition[] = {0};
  meth_meth_parser_84_saveParsePosition->type = alloc_MethodType(1, argcv_meth_parser_84_saveParsePosition);
  meth_meth_parser_84_saveParsePosition->definitionModule = modulename;
  meth_meth_parser_84_saveParsePosition->definitionLine = 102;
// compiled method node returning  (depth = 1)
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "restoreParsePosition(_)"
  block_savedest(self);
  Object closure90 = createclosure(4, "restoreParsePosition(1)");
  setclosureframe(closure90, stackframe);
  addtoclosure(closure90, var_tokens);
  addtoclosure(closure90, var_sym);
  addtoclosure(closure90, var_lastToken);
  addtoclosure(closure90, var_values);
  struct UserObject *uo90 = (struct UserObject*)self;
  uo90->data[4] = (Object)closure90;
  Method *meth_meth_parser_90_restoreParsePosition_40_1_41_ = addmethod2pos(self, "restoreParsePosition(1)", &meth_parser_90_restoreParsePosition_40_1_41_, 4);
  int argcv_meth_parser_90_restoreParsePosition_40_1_41_[] = {1};
  meth_meth_parser_90_restoreParsePosition_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_90_restoreParsePosition_40_1_41_);
  meth_meth_parser_90_restoreParsePosition_40_1_41_->definitionModule = modulename;
  meth_meth_parser_90_restoreParsePosition_40_1_41_->definitionLine = 107;
// compiled method node returning  (depth = 1)
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextToken(_)"
  block_savedest(self);
  Object closure131 = createclosure(2, "findNextToken(1)");
  setclosureframe(closure131, stackframe);
  addtoclosure(closure131, var_sym);
  addtoclosure(closure131, var_lastToken);
  struct UserObject *uo131 = (struct UserObject*)self;
  uo131->data[5] = (Object)closure131;
  Method *meth_meth_parser_131_findNextToken_40_1_41_ = addmethod2pos(self, "findNextToken(1)", &meth_parser_131_findNextToken_40_1_41_, 5);
  int argcv_meth_parser_131_findNextToken_40_1_41_[] = {1};
  meth_meth_parser_131_findNextToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_131_findNextToken_40_1_41_);
  meth_meth_parser_131_findNextToken_40_1_41_->definitionModule = modulename;
  meth_meth_parser_131_findNextToken_40_1_41_->definitionLine = 118;
// compiled method node returning  (depth = 1)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextTokenIndentedAt(_)"
  block_savedest(self);
  Object closure178 = createclosure(1, "findNextTokenIndentedAt(1)");
  setclosureframe(closure178, stackframe);
  addtoclosure(closure178, var_sym);
  struct UserObject *uo178 = (struct UserObject*)self;
  uo178->data[6] = (Object)closure178;
  Method *meth_meth_parser_178_findNextTokenIndentedAt_40_1_41_ = addmethod2pos(self, "findNextTokenIndentedAt(1)", &meth_parser_178_findNextTokenIndentedAt_40_1_41_, 6);
  int argcv_meth_parser_178_findNextTokenIndentedAt_40_1_41_[] = {1};
  meth_meth_parser_178_findNextTokenIndentedAt_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_178_findNextTokenIndentedAt_40_1_41_);
  meth_meth_parser_178_findNextTokenIndentedAt_40_1_41_->definitionModule = modulename;
  meth_meth_parser_178_findNextTokenIndentedAt_40_1_41_->definitionLine = 136;
// compiled method node returning  (depth = 1)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextValidToken(_)"
  block_savedest(self);
  Object closure260 = createclosure(1, "findNextValidToken(1)");
  setclosureframe(closure260, stackframe);
  addtoclosure(closure260, var_sym);
  struct UserObject *uo260 = (struct UserObject*)self;
  uo260->data[7] = (Object)closure260;
  Method *meth_meth_parser_260_findNextValidToken_40_1_41_ = addmethod2pos(self, "findNextValidToken(1)", &meth_parser_260_findNextValidToken_40_1_41_, 7);
  int argcv_meth_parser_260_findNextValidToken_40_1_41_[] = {1};
  meth_meth_parser_260_findNextValidToken_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_260_findNextValidToken_40_1_41_);
  meth_meth_parser_260_findNextValidToken_40_1_41_->definitionModule = modulename;
  meth_meth_parser_260_findNextValidToken_40_1_41_->definitionLine = 151;
// compiled method node returning  (depth = 1)
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findClosingBrace(_,_)"
  block_savedest(self);
  Object closure301 = createclosure(1, "findClosingBrace(2)");
  setclosureframe(closure301, stackframe);
  addtoclosure(closure301, var_sym);
  struct UserObject *uo301 = (struct UserObject*)self;
  uo301->data[8] = (Object)closure301;
  Method *meth_meth_parser_301_findClosingBrace_40_2_41_ = addmethod2pos(self, "findClosingBrace(2)", &meth_parser_301_findClosingBrace_40_2_41_, 8);
  int argcv_meth_parser_301_findClosingBrace_40_2_41_[] = {2};
  meth_meth_parser_301_findClosingBrace_40_2_41_->type = alloc_MethodType(1, argcv_meth_parser_301_findClosingBrace_40_2_41_);
  meth_meth_parser_301_findClosingBrace_40_2_41_->definitionModule = modulename;
  meth_meth_parser_301_findClosingBrace_40_2_41_->definitionLine = 171;
// compiled method node returning  (depth = 1)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept(_)"
  block_savedest(self);
  Object closure453 = createclosure(1, "accept(1)");
  setclosureframe(closure453, stackframe);
  addtoclosure(closure453, var_sym);
  struct UserObject *uo453 = (struct UserObject*)self;
  uo453->data[9] = (Object)closure453;
  Method *meth_meth_parser_453_accept_40_1_41_ = addmethod2pos(self, "accept(1)", &meth_parser_453_accept_40_1_41_, 9);
  int argcv_meth_parser_453_accept_40_1_41_[] = {1};
  meth_meth_parser_453_accept_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_453_accept_40_1_41_);
  meth_meth_parser_453_accept_40_1_41_->definitionModule = modulename;
  meth_meth_parser_453_accept_40_1_41_->definitionLine = 218;
// compiled method node returning  (depth = 1)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptKeyword(_)"
  block_savedest(self);
  Object closure459 = createclosure(1, "acceptKeyword(1)");
  setclosureframe(closure459, stackframe);
  addtoclosure(closure459, var_sym);
  struct UserObject *uo459 = (struct UserObject*)self;
  uo459->data[10] = (Object)closure459;
  Method *meth_meth_parser_459_acceptKeyword_40_1_41_ = addmethod2pos(self, "acceptKeyword(1)", &meth_parser_459_acceptKeyword_40_1_41_, 10);
  int argcv_meth_parser_459_acceptKeyword_40_1_41_[] = {1};
  meth_meth_parser_459_acceptKeyword_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_459_acceptKeyword_40_1_41_);
  meth_meth_parser_459_acceptKeyword_40_1_41_->definitionModule = modulename;
  meth_meth_parser_459_acceptKeyword_40_1_41_->definitionLine = 224;
// compiled method node returning  (depth = 1)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptKeyword(_)or(_)"
  block_savedest(self);
  Object closure473 = createclosure(1, "acceptKeyword(1)or(1)");
  setclosureframe(closure473, stackframe);
  addtoclosure(closure473, var_sym);
  struct UserObject *uo473 = (struct UserObject*)self;
  uo473->data[11] = (Object)closure473;
  Method *meth_meth_parser_473_acceptKeyword_40_1_41_or_40_1_41_ = addmethod2pos(self, "acceptKeyword(1)or(1)", &meth_parser_473_acceptKeyword_40_1_41_or_40_1_41_, 11);
  int argcv_meth_parser_473_acceptKeyword_40_1_41_or_40_1_41_[] = {1, 1};
  meth_meth_parser_473_acceptKeyword_40_1_41_or_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_473_acceptKeyword_40_1_41_or_40_1_41_);
  meth_meth_parser_473_acceptKeyword_40_1_41_or_40_1_41_->definitionModule = modulename;
  meth_meth_parser_473_acceptKeyword_40_1_41_or_40_1_41_->definitionLine = 229;
// compiled method node returning  (depth = 1)
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptSameLine(_)"
  block_savedest(self);
  Object closure494 = createclosure(3, "acceptSameLine(1)");
  setclosureframe(closure494, stackframe);
  addtoclosure(closure494, var_lastIndent);
  addtoclosure(closure494, var_sym);
  addtoclosure(closure494, var_lastLine);
  struct UserObject *uo494 = (struct UserObject*)self;
  uo494->data[12] = (Object)closure494;
  Method *meth_meth_parser_494_acceptSameLine_40_1_41_ = addmethod2pos(self, "acceptSameLine(1)", &meth_parser_494_acceptSameLine_40_1_41_, 12);
  int argcv_meth_parser_494_acceptSameLine_40_1_41_[] = {1};
  meth_meth_parser_494_acceptSameLine_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_494_acceptSameLine_40_1_41_);
  meth_meth_parser_494_acceptSameLine_40_1_41_->definitionModule = modulename;
  meth_meth_parser_494_acceptSameLine_40_1_41_->definitionLine = 235;
// compiled method node returning  (depth = 1)
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptWithoutSpaces(_)"
  block_savedest(self);
  Object closure516 = createclosure(3, "acceptWithoutSpaces(1)");
  setclosureframe(closure516, stackframe);
  addtoclosure(closure516, var_lastToken);
  addtoclosure(closure516, var_sym);
  addtoclosure(closure516, var_lastLine);
  struct UserObject *uo516 = (struct UserObject*)self;
  uo516->data[13] = (Object)closure516;
  Method *meth_meth_parser_516_acceptWithoutSpaces_40_1_41_ = addmethod2pos(self, "acceptWithoutSpaces(1)", &meth_parser_516_acceptWithoutSpaces_40_1_41_, 13);
  int argcv_meth_parser_516_acceptWithoutSpaces_40_1_41_[] = {1};
  meth_meth_parser_516_acceptWithoutSpaces_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_516_acceptWithoutSpaces_40_1_41_);
  meth_meth_parser_516_acceptWithoutSpaces_40_1_41_->definitionModule = modulename;
  meth_meth_parser_516_acceptWithoutSpaces_40_1_41_->definitionLine = 243;
// compiled method node returning  (depth = 1)
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept(_)onLineOf(_)"
  block_savedest(self);
  Object closure545 = createclosure(1, "accept(1)onLineOf(1)");
  setclosureframe(closure545, stackframe);
  addtoclosure(closure545, var_sym);
  struct UserObject *uo545 = (struct UserObject*)self;
  uo545->data[14] = (Object)closure545;
  Method *meth_meth_parser_545_accept_40_1_41_onLineOf_40_1_41_ = addmethod2pos(self, "accept(1)onLineOf(1)", &meth_parser_545_accept_40_1_41_onLineOf_40_1_41_, 14);
  int argcv_meth_parser_545_accept_40_1_41_onLineOf_40_1_41_[] = {1, 1};
  meth_meth_parser_545_accept_40_1_41_onLineOf_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_545_accept_40_1_41_onLineOf_40_1_41_);
  meth_meth_parser_545_accept_40_1_41_onLineOf_40_1_41_->definitionModule = modulename;
  meth_meth_parser_545_accept_40_1_41_onLineOf_40_1_41_->definitionLine = 250;
// compiled method node returning  (depth = 1)
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept(_)onLineOfLastOr(_)"
  block_savedest(self);
  Object closure571 = createclosure(3, "accept(1)onLineOfLastOr(1)");
  setclosureframe(closure571, stackframe);
  addtoclosure(closure571, var_sym);
  addtoclosure(closure571, var_lastLine);
  addtoclosure(closure571, var_lastIndent);
  struct UserObject *uo571 = (struct UserObject*)self;
  uo571->data[15] = (Object)closure571;
  Method *meth_meth_parser_571_accept_40_1_41_onLineOfLastOr_40_1_41_ = addmethod2pos(self, "accept(1)onLineOfLastOr(1)", &meth_parser_571_accept_40_1_41_onLineOfLastOr_40_1_41_, 15);
  int argcv_meth_parser_571_accept_40_1_41_onLineOfLastOr_40_1_41_[] = {1, 1};
  meth_meth_parser_571_accept_40_1_41_onLineOfLastOr_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_571_accept_40_1_41_onLineOfLastOr_40_1_41_);
  meth_meth_parser_571_accept_40_1_41_onLineOfLastOr_40_1_41_->definitionModule = modulename;
  meth_meth_parser_571_accept_40_1_41_onLineOfLastOr_40_1_41_->definitionLine = 257;
// compiled method node returning  (depth = 1)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptArgumentOnLineOf(_)"
  block_savedest(self);
  Object closure612 = createclosure(1, "acceptArgumentOnLineOf(1)");
  setclosureframe(closure612, stackframe);
  addtoclosure(closure612, var_sym);
  struct UserObject *uo612 = (struct UserObject*)self;
  uo612->data[16] = (Object)closure612;
  Method *meth_meth_parser_612_acceptArgumentOnLineOf_40_1_41_ = addmethod2pos(self, "acceptArgumentOnLineOf(1)", &meth_parser_612_acceptArgumentOnLineOf_40_1_41_, 16);
  int argcv_meth_parser_612_acceptArgumentOnLineOf_40_1_41_[] = {1};
  meth_meth_parser_612_acceptArgumentOnLineOf_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_612_acceptArgumentOnLineOf_40_1_41_);
  meth_meth_parser_612_acceptArgumentOnLineOf_40_1_41_->definitionModule = modulename;
  meth_meth_parser_612_acceptArgumentOnLineOf_40_1_41_->definitionLine = 267;
// compiled method node returning  (depth = 1)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "tokenOnSameLine"
  block_savedest(self);
  Object closure653 = createclosure(3, "tokenOnSameLine");
  setclosureframe(closure653, stackframe);
  addtoclosure(closure653, var_lastIndent);
  addtoclosure(closure653, var_sym);
  addtoclosure(closure653, var_lastLine);
  struct UserObject *uo653 = (struct UserObject*)self;
  uo653->data[17] = (Object)closure653;
  Method *meth_meth_parser_653_tokenOnSameLine = addmethod2pos(self, "tokenOnSameLine", &meth_parser_653_tokenOnSameLine, 17);
  int argcv_meth_parser_653_tokenOnSameLine[] = {0};
  meth_meth_parser_653_tokenOnSameLine->type = alloc_MethodType(1, argcv_meth_parser_653_tokenOnSameLine);
  meth_meth_parser_653_tokenOnSameLine->definitionModule = modulename;
  meth_meth_parser_653_tokenOnSameLine->definitionLine = 278;
// compiled method node returning  (depth = 1)
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "tokenOnLineOfLastOr(_)"
  block_savedest(self);
  Object closure667 = createclosure(3, "tokenOnLineOfLastOr(1)");
  setclosureframe(closure667, stackframe);
  addtoclosure(closure667, var_sym);
  addtoclosure(closure667, var_lastLine);
  addtoclosure(closure667, var_lastIndent);
  struct UserObject *uo667 = (struct UserObject*)self;
  uo667->data[18] = (Object)closure667;
  Method *meth_meth_parser_667_tokenOnLineOfLastOr_40_1_41_ = addmethod2pos(self, "tokenOnLineOfLastOr(1)", &meth_parser_667_tokenOnLineOfLastOr_40_1_41_, 18);
  int argcv_meth_parser_667_tokenOnLineOfLastOr_40_1_41_[] = {1};
  meth_meth_parser_667_tokenOnLineOfLastOr_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_667_tokenOnLineOfLastOr_40_1_41_);
  meth_meth_parser_667_tokenOnLineOfLastOr_40_1_41_->definitionModule = modulename;
  meth_meth_parser_667_tokenOnLineOfLastOr_40_1_41_->definitionLine = 282;
// compiled method node returning  (depth = 1)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "didConsume(_)"
  block_savedest(self);
  Object closure701 = createclosure(1, "didConsume(1)");
  setclosureframe(closure701, stackframe);
  addtoclosure(closure701, var_tokens);
  struct UserObject *uo701 = (struct UserObject*)self;
  uo701->data[19] = (Object)closure701;
  Method *meth_meth_parser_701_didConsume_40_1_41_ = addmethod2pos(self, "didConsume(1)", &meth_parser_701_didConsume_40_1_41_, 19);
  int argcv_meth_parser_701_didConsume_40_1_41_[] = {1};
  meth_meth_parser_701_didConsume_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_701_didConsume_40_1_41_);
  meth_meth_parser_701_didConsume_40_1_41_->definitionModule = modulename;
  meth_meth_parser_701_didConsume_40_1_41_->definitionLine = 291;
// compiled method node returning  (depth = 1)
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "didNotConsume(_)"
  block_savedest(self);
  Object closure711 = createclosure(1, "didNotConsume(1)");
  setclosureframe(closure711, stackframe);
  addtoclosure(closure711, var_tokens);
  struct UserObject *uo711 = (struct UserObject*)self;
  uo711->data[20] = (Object)closure711;
  Method *meth_meth_parser_711_didNotConsume_40_1_41_ = addmethod2pos(self, "didNotConsume(1)", &meth_parser_711_didNotConsume_40_1_41_, 20);
  int argcv_meth_parser_711_didNotConsume_40_1_41_[] = {1};
  meth_meth_parser_711_didNotConsume_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_711_didNotConsume_40_1_41_);
  meth_meth_parser_711_didNotConsume_40_1_41_->definitionModule = modulename;
  meth_meth_parser_711_didNotConsume_40_1_41_->definitionLine = 297;
// compiled method node returning  (depth = 1)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushnum"
  block_savedest(self);
  Object closure721 = createclosure(3, "pushnum");
  setclosureframe(closure721, stackframe);
  addtoclosure(closure721, var_sym);
  addtoclosure(closure721, var_ast);
  addtoclosure(closure721, var_values);
  struct UserObject *uo721 = (struct UserObject*)self;
  uo721->data[21] = (Object)closure721;
  Method *meth_meth_parser_721_pushnum = addmethod2pos(self, "pushnum", &meth_parser_721_pushnum, 21);
  int argcv_meth_parser_721_pushnum[] = {0};
  meth_meth_parser_721_pushnum->type = alloc_MethodType(1, argcv_meth_parser_721_pushnum);
  meth_meth_parser_721_pushnum->definitionModule = modulename;
  meth_meth_parser_721_pushnum->definitionLine = 303;
// compiled method node returning  (depth = 1)
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushstring"
  block_savedest(self);
  Object closure732 = createclosure(3, "pushstring");
  setclosureframe(closure732, stackframe);
  addtoclosure(closure732, var_sym);
  addtoclosure(closure732, var_ast);
  addtoclosure(closure732, var_values);
  struct UserObject *uo732 = (struct UserObject*)self;
  uo732->data[22] = (Object)closure732;
  Method *meth_meth_parser_732_pushstring = addmethod2pos(self, "pushstring", &meth_parser_732_pushstring, 22);
  int argcv_meth_parser_732_pushstring[] = {0};
  meth_meth_parser_732_pushstring->type = alloc_MethodType(1, argcv_meth_parser_732_pushstring);
  meth_meth_parser_732_pushstring->definitionModule = modulename;
  meth_meth_parser_732_pushstring->definitionLine = 310;
// compiled method node returning  (depth = 1)
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushidentifier"
  block_savedest(self);
  Object closure751 = createclosure(4, "pushidentifier");
  setclosureframe(closure751, stackframe);
  addtoclosure(closure751, var_sym);
  addtoclosure(closure751, var_util);
  addtoclosure(closure751, var_ast);
  addtoclosure(closure751, var_values);
  struct UserObject *uo751 = (struct UserObject*)self;
  uo751->data[23] = (Object)closure751;
  Method *meth_meth_parser_751_pushidentifier = addmethod2pos(self, "pushidentifier", &meth_parser_751_pushidentifier, 23);
  int argcv_meth_parser_751_pushidentifier[] = {0};
  meth_meth_parser_751_pushidentifier->type = alloc_MethodType(1, argcv_meth_parser_751_pushidentifier);
  meth_meth_parser_751_pushidentifier->definitionModule = modulename;
  meth_meth_parser_751_pushidentifier->definitionLine = 320;
// compiled method node returning  (depth = 1)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkAnnotation(_)"
  block_savedest(self);
  Object closure781 = createclosure(2, "checkAnnotation(1)");
  setclosureframe(closure781, stackframe);
  addtoclosure(closure781, var_sym);
  addtoclosure(closure781, var_errormessages);
  struct UserObject *uo781 = (struct UserObject*)self;
  uo781->data[24] = (Object)closure781;
  Method *meth_meth_parser_781_checkAnnotation_40_1_41_ = addmethod2pos(self, "checkAnnotation(1)", &meth_parser_781_checkAnnotation_40_1_41_, 24);
  int argcv_meth_parser_781_checkAnnotation_40_1_41_[] = {1};
  meth_meth_parser_781_checkAnnotation_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_781_checkAnnotation_40_1_41_);
  meth_meth_parser_781_checkAnnotation_40_1_41_->definitionModule = modulename;
  meth_meth_parser_781_checkAnnotation_40_1_41_->definitionLine = 331;
// compiled method node returning  (depth = 1)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doannotation"
  block_savedest(self);
  Object closure860 = createclosure(2, "doannotation");
  setclosureframe(closure860, stackframe);
  addtoclosure(closure860, var_noBlocks);
  addtoclosure(closure860, var_values);
  struct UserObject *uo860 = (struct UserObject*)self;
  uo860->data[25] = (Object)closure860;
  Method *meth_meth_parser_860_doannotation = addmethod2pos(self, "doannotation", &meth_parser_860_doannotation, 25);
  int argcv_meth_parser_860_doannotation[] = {0};
  meth_meth_parser_860_doannotation->type = alloc_MethodType(1, argcv_meth_parser_860_doannotation);
  meth_meth_parser_860_doannotation->definitionModule = modulename;
  meth_meth_parser_860_doannotation->definitionLine = 350;
// compiled method node returning  (depth = 1)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "errorMissingAnnotation"
  block_savedest(self);
  Object closure916 = createclosure(3, "errorMissingAnnotation");
  setclosureframe(closure916, stackframe);
  addtoclosure(closure916, var_errormessages);
  addtoclosure(closure916, var_sym);
  addtoclosure(closure916, var_lastToken);
  struct UserObject *uo916 = (struct UserObject*)self;
  uo916->data[26] = (Object)closure916;
  Method *meth_meth_parser_916_errorMissingAnnotation = addmethod2pos(self, "errorMissingAnnotation", &meth_parser_916_errorMissingAnnotation, 26);
  int argcv_meth_parser_916_errorMissingAnnotation[] = {0};
  meth_meth_parser_916_errorMissingAnnotation->type = alloc_MethodType(1, argcv_meth_parser_916_errorMissingAnnotation);
  meth_meth_parser_916_errorMissingAnnotation->definitionModule = modulename;
  meth_meth_parser_916_errorMissingAnnotation->definitionLine = 370;
// compiled method node returning  (depth = 1)
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotypeterm"
  block_savedest(self);
  Object closure964 = createclosure(1, "dotypeterm");
  setclosureframe(closure964, stackframe);
  addtoclosure(closure964, var_noBlocks);
  struct UserObject *uo964 = (struct UserObject*)self;
  uo964->data[27] = (Object)closure964;
  Method *meth_meth_parser_964_dotypeterm = addmethod2pos(self, "dotypeterm", &meth_parser_964_dotypeterm, 27);
  int argcv_meth_parser_964_dotypeterm[] = {0};
  meth_meth_parser_964_dotypeterm->type = alloc_MethodType(1, argcv_meth_parser_964_dotypeterm);
  meth_meth_parser_964_dotypeterm->definitionModule = modulename;
  meth_meth_parser_964_dotypeterm->definitionLine = 388;
// compiled method node returning  (depth = 1)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeexpression"
  block_savedest(self);
  Object closure982 = createclosure(6, "typeexpression");
  setclosureframe(closure982, stackframe);
  addtoclosure(closure982, var_values);
  addtoclosure(closure982, var_statementToken);
  addtoclosure(closure982, var_sym);
  addtoclosure(closure982, var_errormessages);
  addtoclosure(closure982, var_lastToken);
  addtoclosure(closure982, var_noBlocks);
  struct UserObject *uo982 = (struct UserObject*)self;
  uo982->data[28] = (Object)closure982;
  Method *meth_meth_parser_982_typeexpression = addmethod2pos(self, "typeexpression", &meth_parser_982_typeexpression, 28);
  int argcv_meth_parser_982_typeexpression[] = {0};
  meth_meth_parser_982_typeexpression->type = alloc_MethodType(1, argcv_meth_parser_982_typeexpression);
  meth_meth_parser_982_typeexpression->definitionModule = modulename;
  meth_meth_parser_982_typeexpression->definitionLine = 400;
// compiled method node returning  (depth = 1)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "newIf(_,_,_)"
  block_savedest(self);
  Object closure1069 = createclosure(1, "newIf(3)");
  setclosureframe(closure1069, stackframe);
  addtoclosure(closure1069, var_ast);
  struct UserObject *uo1069 = (struct UserObject*)self;
  uo1069->data[29] = (Object)closure1069;
  Method *meth_meth_parser_1069_newIf_40_3_41_ = addmethod2pos(self, "newIf(3)", &meth_parser_1069_newIf_40_3_41_, 29);
  int argcv_meth_parser_1069_newIf_40_3_41_[] = {3};
  meth_meth_parser_1069_newIf_40_3_41_->type = alloc_MethodType(1, argcv_meth_parser_1069_newIf_40_3_41_);
  meth_meth_parser_1069_newIf_40_3_41_->definitionModule = modulename;
  meth_meth_parser_1069_newIf_40_3_41_->definitionLine = 439;
// compiled method node returning  (depth = 1)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reportSyntaxError(_)before(_)"
  block_savedest(self);
  Object closure1086 = createclosure(3, "reportSyntaxError(1)before(1)");
  setclosureframe(closure1086, stackframe);
  addtoclosure(closure1086, var_errormessages);
  addtoclosure(closure1086, var_sym);
  addtoclosure(closure1086, var_lastToken);
  struct UserObject *uo1086 = (struct UserObject*)self;
  uo1086->data[30] = (Object)closure1086;
  Method *meth_meth_parser_1086_reportSyntaxError_40_1_41_before_40_1_41_ = addmethod2pos(self, "reportSyntaxError(1)before(1)", &meth_parser_1086_reportSyntaxError_40_1_41_before_40_1_41_, 30);
  int argcv_meth_parser_1086_reportSyntaxError_40_1_41_before_40_1_41_[] = {1, 1};
  meth_meth_parser_1086_reportSyntaxError_40_1_41_before_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_1086_reportSyntaxError_40_1_41_before_40_1_41_);
  meth_meth_parser_1086_reportSyntaxError_40_1_41_before_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1086_reportSyntaxError_40_1_41_before_40_1_41_->definitionLine = 445;
// compiled method node returning  (depth = 1)
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reportMissingArrow"
  block_savedest(self);
  Object closure1129 = createclosure(3, "reportMissingArrow");
  setclosureframe(closure1129, stackframe);
  addtoclosure(closure1129, var_errormessages);
  addtoclosure(closure1129, var_sym);
  addtoclosure(closure1129, var_lastToken);
  struct UserObject *uo1129 = (struct UserObject*)self;
  uo1129->data[31] = (Object)closure1129;
  Method *meth_meth_parser_1129_reportMissingArrow = addmethod2pos(self, "reportMissingArrow", &meth_parser_1129_reportMissingArrow, 31);
  int argcv_meth_parser_1129_reportMissingArrow[] = {0};
  meth_meth_parser_1129_reportMissingArrow->type = alloc_MethodType(1, argcv_meth_parser_1129_reportMissingArrow);
  meth_meth_parser_1129_reportMissingArrow->definitionModule = modulename;
  meth_meth_parser_1129_reportMissingArrow->definitionLine = 463;
// compiled method node returning  (depth = 1)
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reportBadRhs"
  block_savedest(self);
  Object closure1163 = createclosure(3, "reportBadRhs");
  setclosureframe(closure1163, stackframe);
  addtoclosure(closure1163, var_errormessages);
  addtoclosure(closure1163, var_sym);
  addtoclosure(closure1163, var_lastToken);
  struct UserObject *uo1163 = (struct UserObject*)self;
  uo1163->data[32] = (Object)closure1163;
  Method *meth_meth_parser_1163_reportBadRhs = addmethod2pos(self, "reportBadRhs", &meth_parser_1163_reportBadRhs, 32);
  int argcv_meth_parser_1163_reportBadRhs[] = {0};
  meth_meth_parser_1163_reportBadRhs->type = alloc_MethodType(1, argcv_meth_parser_1163_reportBadRhs);
  meth_meth_parser_1163_reportBadRhs->definitionModule = modulename;
  meth_meth_parser_1163_reportBadRhs->definitionLine = 474;
// compiled method node returning  (depth = 1)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "block"
  block_savedest(self);
  Object closure1209 = createclosure(5, "block");
  setclosureframe(closure1209, stackframe);
  addtoclosure(closure1209, var_sym);
  addtoclosure(closure1209, var_minIndentLevel);
  addtoclosure(closure1209, var_statementIndent);
  addtoclosure(closure1209, var_statementToken);
  addtoclosure(closure1209, var_values);
  struct UserObject *uo1209 = (struct UserObject*)self;
  uo1209->data[33] = (Object)closure1209;
  Method *meth_meth_parser_1209_block = addmethod2pos(self, "block", &meth_parser_1209_block, 33);
  int argcv_meth_parser_1209_block[] = {0};
  meth_meth_parser_1209_block->type = alloc_MethodType(1, argcv_meth_parser_1209_block);
  meth_meth_parser_1209_block->definitionModule = modulename;
  meth_meth_parser_1209_block->definitionLine = 493;
// compiled method node returning  (depth = 1)
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "blockParameters"
  struct UserObject *uo1238 = (struct UserObject*)self;
  uo1238->data[34] = emptyclosure;
  Method *meth_meth_parser_1238_blockParameters = addmethod2pos(self, "blockParameters", &meth_parser_1238_blockParameters, 34);
  int argcv_meth_parser_1238_blockParameters[] = {0};
  meth_meth_parser_1238_blockParameters->type = alloc_MethodType(1, argcv_meth_parser_1238_blockParameters);
  meth_meth_parser_1238_blockParameters->definitionModule = modulename;
  meth_meth_parser_1238_blockParameters->definitionLine = 525;
// compiled method node returning  (depth = 1)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "blockParameter(_)"
  block_savedest(self);
  Object closure1264 = createclosure(4, "blockParameter(1)");
  setclosureframe(closure1264, stackframe);
  addtoclosure(closure1264, var_sym);
  addtoclosure(closure1264, var_blocksOK);
  addtoclosure(closure1264, var_values);
  addtoclosure(closure1264, var_ast);
  struct UserObject *uo1264 = (struct UserObject*)self;
  uo1264->data[35] = (Object)closure1264;
  Method *meth_meth_parser_1264_blockParameter_40_1_41_ = addmethod2pos(self, "blockParameter(1)", &meth_parser_1264_blockParameter_40_1_41_, 35);
  int argcv_meth_parser_1264_blockParameter_40_1_41_[] = {1};
  meth_meth_parser_1264_blockParameter_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_1264_blockParameter_40_1_41_);
  meth_meth_parser_1264_blockParameter_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1264_blockParameter_40_1_41_->definitionLine = 543;
// compiled method node returning  (depth = 1)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "blockBody(_)beginningWith(_)"
  block_savedest(self);
  Object closure1363 = createclosure(6, "blockBody(1)beginningWith(1)");
  setclosureframe(closure1363, stackframe);
  addtoclosure(closure1363, var_values);
  addtoclosure(closure1363, var_lastToken);
  addtoclosure(closure1363, var_sym);
  addtoclosure(closure1363, var_indentFreePass);
  addtoclosure(closure1363, var_errormessages);
  addtoclosure(closure1363, var_ast);
  struct UserObject *uo1363 = (struct UserObject*)self;
  uo1363->data[36] = (Object)closure1363;
  Method *meth_meth_parser_1363_blockBody_40_1_41_beginningWith_40_1_41_ = addmethod2pos(self, "blockBody(1)beginningWith(1)", &meth_parser_1363_blockBody_40_1_41_beginningWith_40_1_41_, 36);
  int argcv_meth_parser_1363_blockBody_40_1_41_beginningWith_40_1_41_[] = {1, 1};
  meth_meth_parser_1363_blockBody_40_1_41_beginningWith_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_1363_blockBody_40_1_41_beginningWith_40_1_41_);
  meth_meth_parser_1363_blockBody_40_1_41_beginningWith_40_1_41_->definitionModule = modulename;
  meth_meth_parser_1363_blockBody_40_1_41_beginningWith_40_1_41_->definitionLine = 584;
// compiled method node returning  (depth = 1)
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doif"
  block_savedest(self);
  Object closure1420 = createclosure(9, "doif");
  setclosureframe(closure1420, stackframe);
  addtoclosure(closure1420, var_sym);
  addtoclosure(closure1420, var_errormessages);
  addtoclosure(closure1420, var_blocksOK);
  addtoclosure(closure1420, var_lastToken);
  addtoclosure(closure1420, var_values);
  addtoclosure(closure1420, var_minIndentLevel);
  addtoclosure(closure1420, var_statementIndent);
  addtoclosure(closure1420, var_statementToken);
  addtoclosure(closure1420, var_util);
  struct UserObject *uo1420 = (struct UserObject*)self;
  uo1420->data[37] = (Object)closure1420;
  Method *meth_meth_parser_1420_doif = addmethod2pos(self, "doif", &meth_parser_1420_doif, 37);
  int argcv_meth_parser_1420_doif[] = {0};
  meth_meth_parser_1420_doif->type = alloc_MethodType(1, argcv_meth_parser_1420_doif);
  meth_meth_parser_1420_doif->definitionModule = modulename;
  meth_meth_parser_1420_doif->definitionLine = 611;
// compiled method node returning  (depth = 1)
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "identifier"
  block_savedest(self);
  Object closure2916 = createclosure(1, "identifier");
  setclosureframe(closure2916, stackframe);
  addtoclosure(closure2916, var_sym);
  struct UserObject *uo2916 = (struct UserObject*)self;
  uo2916->data[38] = (Object)closure2916;
  Method *meth_meth_parser_2916_identifier = addmethod2pos(self, "identifier", &meth_parser_2916_identifier, 38);
  int argcv_meth_parser_2916_identifier[] = {0};
  meth_meth_parser_2916_identifier->type = alloc_MethodType(1, argcv_meth_parser_2916_identifier);
  meth_meth_parser_2916_identifier->definitionModule = modulename;
  meth_meth_parser_2916_identifier->definitionLine = 1038;
// compiled method node returning  (depth = 1)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "prefixop"
  block_savedest(self);
  Object closure2932 = createclosure(8, "prefixop");
  setclosureframe(closure2932, stackframe);
  addtoclosure(closure2932, var_minIndentLevel);
  addtoclosure(closure2932, var_sym);
  addtoclosure(closure2932, var_blocksOK);
  addtoclosure(closure2932, var_errormessages);
  addtoclosure(closure2932, var_lastToken);
  addtoclosure(closure2932, var_values);
  addtoclosure(closure2932, var_ast);
  addtoclosure(closure2932, var_lastLine);
  struct UserObject *uo2932 = (struct UserObject*)self;
  uo2932->data[39] = (Object)closure2932;
  Method *meth_meth_parser_2932_prefixop = addmethod2pos(self, "prefixop", &meth_parser_2932_prefixop, 39);
  int argcv_meth_parser_2932_prefixop[] = {0};
  meth_meth_parser_2932_prefixop->type = alloc_MethodType(1, argcv_meth_parser_2932_prefixop);
  meth_meth_parser_2932_prefixop->definitionModule = modulename;
  meth_meth_parser_2932_prefixop->definitionLine = 1048;
// compiled method node returning  (depth = 1)
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "generic"
  block_savedest(self);
  Object closure3116 = createclosure(5, "generic");
  setclosureframe(closure3116, stackframe);
  addtoclosure(closure3116, var_values);
  addtoclosure(closure3116, var_sym);
  addtoclosure(closure3116, var_errormessages);
  addtoclosure(closure3116, var_lastToken);
  addtoclosure(closure3116, var_ast);
  struct UserObject *uo3116 = (struct UserObject*)self;
  uo3116->data[40] = (Object)closure3116;
  Method *meth_meth_parser_3116_generic = addmethod2pos(self, "generic", &meth_parser_3116_generic, 40);
  int argcv_meth_parser_3116_generic[] = {0};
  meth_meth_parser_3116_generic->type = alloc_MethodType(1, argcv_meth_parser_3116_generic);
  meth_meth_parser_3116_generic->definitionModule = modulename;
  meth_meth_parser_3116_generic->definitionLine = 1106;
// compiled method node returning  (depth = 1)
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "trycatch"
  block_savedest(self);
  Object closure3299 = createclosure(10, "trycatch");
  setclosureframe(closure3299, stackframe);
  addtoclosure(closure3299, var_sym);
  addtoclosure(closure3299, var_done);
  addtoclosure(closure3299, var_minIndentLevel);
  addtoclosure(closure3299, var_errormessages);
  addtoclosure(closure3299, var_lastToken);
  addtoclosure(closure3299, var_blocksOK);
  addtoclosure(closure3299, var_values);
  addtoclosure(closure3299, var_tokens);
  addtoclosure(closure3299, var_util);
  addtoclosure(closure3299, var_ast);
  struct UserObject *uo3299 = (struct UserObject*)self;
  uo3299->data[41] = (Object)closure3299;
  Method *meth_meth_parser_3299_trycatch = addmethod2pos(self, "trycatch", &meth_parser_3299_trycatch, 41);
  int argcv_meth_parser_3299_trycatch[] = {0};
  meth_meth_parser_3299_trycatch->type = alloc_MethodType(1, argcv_meth_parser_3299_trycatch);
  meth_meth_parser_3299_trycatch->definitionModule = modulename;
  meth_meth_parser_3299_trycatch->definitionLine = 1166;
// compiled method node returning  (depth = 1)
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "matchcase"
  block_savedest(self);
  Object closure3911 = createclosure(9, "matchcase");
  setclosureframe(closure3911, stackframe);
  addtoclosure(closure3911, var_sym);
  addtoclosure(closure3911, var_minIndentLevel);
  addtoclosure(closure3911, var_errormessages);
  addtoclosure(closure3911, var_blocksOK);
  addtoclosure(closure3911, var_lastToken);
  addtoclosure(closure3911, var_values);
  addtoclosure(closure3911, var_tokens);
  addtoclosure(closure3911, var_util);
  addtoclosure(closure3911, var_ast);
  struct UserObject *uo3911 = (struct UserObject*)self;
  uo3911->data[42] = (Object)closure3911;
  Method *meth_meth_parser_3911_matchcase = addmethod2pos(self, "matchcase", &meth_parser_3911_matchcase, 42);
  int argcv_meth_parser_3911_matchcase[] = {0};
  meth_meth_parser_3911_matchcase->type = alloc_MethodType(1, argcv_meth_parser_3911_matchcase);
  meth_meth_parser_3911_matchcase->definitionModule = modulename;
  meth_meth_parser_3911_matchcase->definitionLine = 1341;
// compiled method node returning  (depth = 1)
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "term"
  block_savedest(self);
  Object closure4281 = createclosure(2, "term");
  setclosureframe(closure4281, stackframe);
  addtoclosure(closure4281, var_sym);
  addtoclosure(closure4281, var_util);
  struct UserObject *uo4281 = (struct UserObject*)self;
  uo4281->data[43] = (Object)closure4281;
  Method *meth_meth_parser_4281_term = addmethod2pos(self, "term", &meth_parser_4281_term, 43);
  int argcv_meth_parser_4281_term[] = {0};
  meth_meth_parser_4281_term->type = alloc_MethodType(1, argcv_meth_parser_4281_term);
  meth_meth_parser_4281_term->definitionModule = modulename;
  meth_meth_parser_4281_term->definitionLine = 1445;
// compiled method node returning  (depth = 1)
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "expression(_)"
  block_savedest(self);
  Object closure4367 = createclosure(6, "expression(1)");
  setclosureframe(closure4367, stackframe);
  addtoclosure(closure4367, var_values);
  addtoclosure(closure4367, var_sym);
  addtoclosure(closure4367, var_util);
  addtoclosure(closure4367, var_statementToken);
  addtoclosure(closure4367, var_errormessages);
  addtoclosure(closure4367, var_lastToken);
  struct UserObject *uo4367 = (struct UserObject*)self;
  uo4367->data[44] = (Object)closure4367;
  Method *meth_meth_parser_4367_expression_40_1_41_ = addmethod2pos(self, "expression(1)", &meth_parser_4367_expression_40_1_41_, 44);
  int argcv_meth_parser_4367_expression_40_1_41_[] = {1};
  meth_meth_parser_4367_expression_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_4367_expression_40_1_41_);
  meth_meth_parser_4367_expression_40_1_41_->definitionModule = modulename;
  meth_meth_parser_4367_expression_40_1_41_->definitionLine = 1475;
// compiled method node returning  (depth = 1)
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "oprec(_)"
  struct UserObject *uo4473 = (struct UserObject*)self;
  uo4473->data[45] = emptyclosure;
  Method *meth_meth_parser_4473_oprec_40_1_41_ = addmethod2pos(self, "oprec(1)", &meth_parser_4473_oprec_40_1_41_, 45);
  int argcv_meth_parser_4473_oprec_40_1_41_[] = {1};
  meth_meth_parser_4473_oprec_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_4473_oprec_40_1_41_);
  meth_meth_parser_4473_oprec_40_1_41_->definitionModule = modulename;
  meth_meth_parser_4473_oprec_40_1_41_->definitionLine = 1518;
// compiled method node returning  (depth = 1)
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "toprec(_)"
  struct UserObject *uo4487 = (struct UserObject*)self;
  uo4487->data[46] = emptyclosure;
  Method *meth_meth_parser_4487_toprec_40_1_41_ = addmethod2pos(self, "toprec(1)", &meth_parser_4487_toprec_40_1_41_, 46);
  int argcv_meth_parser_4487_toprec_40_1_41_[] = {1};
  meth_meth_parser_4487_toprec_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_4487_toprec_40_1_41_);
  meth_meth_parser_4487_toprec_40_1_41_->definitionModule = modulename;
  meth_meth_parser_4487_toprec_40_1_41_->definitionLine = 1528;
// compiled method node returning  (depth = 1)
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeexpressionrest"
  block_savedest(self);
  Object closure4500 = createclosure(1, "typeexpressionrest");
  setclosureframe(closure4500, stackframe);
  addtoclosure(closure4500, var_noBlocks);
  struct UserObject *uo4500 = (struct UserObject*)self;
  uo4500->data[47] = (Object)closure4500;
  Method *meth_meth_parser_4500_typeexpressionrest = addmethod2pos(self, "typeexpressionrest", &meth_parser_4500_typeexpressionrest, 47);
  int argcv_meth_parser_4500_typeexpressionrest[] = {0};
  meth_meth_parser_4500_typeexpressionrest->type = alloc_MethodType(1, argcv_meth_parser_4500_typeexpressionrest);
  meth_meth_parser_4500_typeexpressionrest->definitionModule = modulename;
  meth_meth_parser_4500_typeexpressionrest->definitionLine = 1537;
// compiled method node returning  (depth = 1)
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "valueexpressionrest"
  block_savedest(self);
  Object closure4513 = createclosure(1, "valueexpressionrest");
  setclosureframe(closure4513, stackframe);
  addtoclosure(closure4513, var_blocksOK);
  struct UserObject *uo4513 = (struct UserObject*)self;
  uo4513->data[48] = (Object)closure4513;
  Method *meth_meth_parser_4513_valueexpressionrest = addmethod2pos(self, "valueexpressionrest", &meth_parser_4513_valueexpressionrest, 48);
  int argcv_meth_parser_4513_valueexpressionrest[] = {0};
  meth_meth_parser_4513_valueexpressionrest->type = alloc_MethodType(1, argcv_meth_parser_4513_valueexpressionrest);
  meth_meth_parser_4513_valueexpressionrest->definitionModule = modulename;
  meth_meth_parser_4513_valueexpressionrest->definitionLine = 1543;
// compiled method node returning  (depth = 1)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "expressionrest(_)recursingWith(_)blocks(_)"
  block_savedest(self);
  Object closure4526 = createclosure(8, "expressionrest(1)recursingWith(1)blocks(1)");
  setclosureframe(closure4526, stackframe);
  addtoclosure(closure4526, var_minIndentLevel);
  addtoclosure(closure4526, var_values);
  addtoclosure(closure4526, var_sym);
  addtoclosure(closure4526, var_statementToken);
  addtoclosure(closure4526, var_errormessages);
  addtoclosure(closure4526, var_lastToken);
  addtoclosure(closure4526, var_util);
  addtoclosure(closure4526, var_ast);
  struct UserObject *uo4526 = (struct UserObject*)self;
  uo4526->data[49] = (Object)closure4526;
  Method *meth_meth_parser_4526_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_ = addmethod2pos(self, "expressionrest(1)recursingWith(1)blocks(1)", &meth_parser_4526_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_, 49);
  int argcv_meth_parser_4526_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_[] = {1, 1, 1};
  meth_meth_parser_4526_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_->type = alloc_MethodType(3, argcv_meth_parser_4526_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_);
  meth_meth_parser_4526_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_->definitionModule = modulename;
  meth_meth_parser_4526_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_->definitionLine = 1549;
// compiled method node returning  (depth = 1)
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotrest(_)"
  block_savedest(self);
  Object closure5048 = createclosure(7, "dotrest(1)");
  setclosureframe(closure5048, stackframe);
  addtoclosure(closure5048, var_minIndentLevel);
  addtoclosure(closure5048, var_sym);
  addtoclosure(closure5048, var_util);
  addtoclosure(closure5048, var_values);
  addtoclosure(closure5048, var_ast);
  addtoclosure(closure5048, var_errormessages);
  addtoclosure(closure5048, var_lastToken);
  struct UserObject *uo5048 = (struct UserObject*)self;
  uo5048->data[50] = (Object)closure5048;
  Method *meth_meth_parser_5048_dotrest_40_1_41_ = addmethod2pos(self, "dotrest(1)", &meth_parser_5048_dotrest_40_1_41_, 50);
  int argcv_meth_parser_5048_dotrest_40_1_41_[] = {1};
  meth_meth_parser_5048_dotrest_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5048_dotrest_40_1_41_);
  meth_meth_parser_5048_dotrest_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5048_dotrest_40_1_41_->definitionLine = 1697;
// compiled method node returning  (depth = 1)
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "callrest(_)"
  block_savedest(self);
  Object closure5157 = createclosure(8, "callrest(1)");
  setclosureframe(closure5157, stackframe);
  addtoclosure(closure5157, var_values);
  addtoclosure(closure5157, var_done);
  addtoclosure(closure5157, var_ast);
  addtoclosure(closure5157, var_lastToken);
  addtoclosure(closure5157, var_statementToken);
  addtoclosure(closure5157, var_sym);
  addtoclosure(closure5157, var_errormessages);
  addtoclosure(closure5157, var_lastLine);
  struct UserObject *uo5157 = (struct UserObject*)self;
  uo5157->data[51] = (Object)closure5157;
  Method *meth_meth_parser_5157_callrest_40_1_41_ = addmethod2pos(self, "callrest(1)", &meth_parser_5157_callrest_40_1_41_, 51);
  int argcv_meth_parser_5157_callrest_40_1_41_[] = {1};
  meth_meth_parser_5157_callrest_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5157_callrest_40_1_41_);
  meth_meth_parser_5157_callrest_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5157_callrest_40_1_41_->definitionLine = 1738;
// compiled method node returning  (depth = 1)
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseArgumentsFor(_)into(_)acceptBlocks(_)"
  block_savedest(self);
  Object closure5313 = createclosure(4, "parseArgumentsFor(1)into(1)acceptBlocks(1)");
  setclosureframe(closure5313, stackframe);
  addtoclosure(closure5313, var_lastToken);
  addtoclosure(closure5313, var_sym);
  addtoclosure(closure5313, var_statementToken);
  addtoclosure(closure5313, var_values);
  struct UserObject *uo5313 = (struct UserObject*)self;
  uo5313->data[52] = (Object)closure5313;
  Method *meth_meth_parser_5313_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_ = addmethod2pos(self, "parseArgumentsFor(1)into(1)acceptBlocks(1)", &meth_parser_5313_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_, 52);
  int argcv_meth_parser_5313_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_[] = {1, 1, 1};
  meth_meth_parser_5313_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_->type = alloc_MethodType(3, argcv_meth_parser_5313_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_);
  meth_meth_parser_5313_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5313_parseArgumentsFor_40_1_41_into_40_1_41_acceptBlocks_40_1_41_->definitionLine = 1821;
// compiled method node returning  (depth = 1)
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parenthesizedArgs(_)startingWith(_)"
  block_savedest(self);
  Object closure5349 = createclosure(6, "parenthesizedArgs(1)startingWith(1)");
  setclosureframe(closure5349, stackframe);
  addtoclosure(closure5349, var_blocksOK);
  addtoclosure(closure5349, var_values);
  addtoclosure(closure5349, var_errormessages);
  addtoclosure(closure5349, var_sym);
  addtoclosure(closure5349, var_lastToken);
  addtoclosure(closure5349, var_ast);
  struct UserObject *uo5349 = (struct UserObject*)self;
  uo5349->data[53] = (Object)closure5349;
  Method *meth_meth_parser_5349_parenthesizedArgs_40_1_41_startingWith_40_1_41_ = addmethod2pos(self, "parenthesizedArgs(1)startingWith(1)", &meth_parser_5349_parenthesizedArgs_40_1_41_startingWith_40_1_41_, 53);
  int argcv_meth_parser_5349_parenthesizedArgs_40_1_41_startingWith_40_1_41_[] = {1, 1};
  meth_meth_parser_5349_parenthesizedArgs_40_1_41_startingWith_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_5349_parenthesizedArgs_40_1_41_startingWith_40_1_41_);
  meth_meth_parser_5349_parenthesizedArgs_40_1_41_startingWith_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5349_parenthesizedArgs_40_1_41_startingWith_40_1_41_->definitionLine = 1845;
// compiled method node returning  (depth = 1)
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeArgs"
  block_savedest(self);
  Object closure5495 = createclosure(4, "typeArgs");
  setclosureframe(closure5495, stackframe);
  addtoclosure(closure5495, var_sym);
  addtoclosure(closure5495, var_values);
  addtoclosure(closure5495, var_errormessages);
  addtoclosure(closure5495, var_lastToken);
  struct UserObject *uo5495 = (struct UserObject*)self;
  uo5495->data[54] = (Object)closure5495;
  Method *meth_meth_parser_5495_typeArgs = addmethod2pos(self, "typeArgs", &meth_parser_5495_typeArgs, 54);
  int argcv_meth_parser_5495_typeArgs[] = {0};
  meth_meth_parser_5495_typeArgs->type = alloc_MethodType(1, argcv_meth_parser_5495_typeArgs);
  meth_meth_parser_5495_typeArgs->definitionModule = modulename;
  meth_meth_parser_5495_typeArgs->definitionLine = 1887;
// compiled method node returning  (depth = 1)
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeArg"
  block_savedest(self);
  Object closure5570 = createclosure(3, "typeArg");
  setclosureframe(closure5570, stackframe);
  addtoclosure(closure5570, var_sym);
  addtoclosure(closure5570, var_values);
  addtoclosure(closure5570, var_ast);
  struct UserObject *uo5570 = (struct UserObject*)self;
  uo5570->data[55] = (Object)closure5570;
  Method *meth_meth_parser_5570_typeArg = addmethod2pos(self, "typeArg", &meth_parser_5570_typeArg, 55);
  int argcv_meth_parser_5570_typeArg[] = {0};
  meth_meth_parser_5570_typeArg->type = alloc_MethodType(1, argcv_meth_parser_5570_typeArg);
  meth_meth_parser_5570_typeArg->definitionModule = modulename;
  meth_meth_parser_5570_typeArg->definitionLine = 1912;
// compiled method node returning  (depth = 1)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "errorDefNoName"
  block_savedest(self);
  Object closure5596 = createclosure(3, "errorDefNoName");
  setclosureframe(closure5596, stackframe);
  addtoclosure(closure5596, var_errormessages);
  addtoclosure(closure5596, var_sym);
  addtoclosure(closure5596, var_lastToken);
  struct UserObject *uo5596 = (struct UserObject*)self;
  uo5596->data[56] = (Object)closure5596;
  Method *meth_meth_parser_5596_errorDefNoName = addmethod2pos(self, "errorDefNoName", &meth_parser_5596_errorDefNoName, 56);
  int argcv_meth_parser_5596_errorDefNoName[] = {0};
  meth_meth_parser_5596_errorDefNoName->type = alloc_MethodType(1, argcv_meth_parser_5596_errorDefNoName);
  meth_meth_parser_5596_errorDefNoName->definitionModule = modulename;
  meth_meth_parser_5596_errorDefNoName->definitionLine = 1927;
// compiled method node returning  (depth = 1)
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "errorDefNoExpression"
  block_savedest(self);
  Object closure5664 = createclosure(3, "errorDefNoExpression");
  setclosureframe(closure5664, stackframe);
  addtoclosure(closure5664, var_errormessages);
  addtoclosure(closure5664, var_sym);
  addtoclosure(closure5664, var_lastToken);
  struct UserObject *uo5664 = (struct UserObject*)self;
  uo5664->data[57] = (Object)closure5664;
  Method *meth_meth_parser_5664_errorDefNoExpression = addmethod2pos(self, "errorDefNoExpression", &meth_parser_5664_errorDefNoExpression, 57);
  int argcv_meth_parser_5664_errorDefNoExpression[] = {0};
  meth_meth_parser_5664_errorDefNoExpression->type = alloc_MethodType(1, argcv_meth_parser_5664_errorDefNoExpression);
  meth_meth_parser_5664_errorDefNoExpression->definitionModule = modulename;
  meth_meth_parser_5664_errorDefNoExpression->definitionLine = 1944;
// compiled method node returning  (depth = 1)
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "errorDefUsesAssign(_)"
  block_savedest(self);
  Object closure5698 = createclosure(2, "errorDefUsesAssign(1)");
  setclosureframe(closure5698, stackframe);
  addtoclosure(closure5698, var_errormessages);
  addtoclosure(closure5698, var_sym);
  struct UserObject *uo5698 = (struct UserObject*)self;
  uo5698->data[58] = (Object)closure5698;
  Method *meth_meth_parser_5698_errorDefUsesAssign_40_1_41_ = addmethod2pos(self, "errorDefUsesAssign(1)", &meth_parser_5698_errorDefUsesAssign_40_1_41_, 58);
  int argcv_meth_parser_5698_errorDefUsesAssign_40_1_41_[] = {1};
  meth_meth_parser_5698_errorDefUsesAssign_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5698_errorDefUsesAssign_40_1_41_);
  meth_meth_parser_5698_errorDefUsesAssign_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5698_errorDefUsesAssign_40_1_41_->definitionLine = 1958;
// compiled method node returning  (depth = 1)
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "errorDefMissingRhs(_)"
  block_savedest(self);
  Object closure5736 = createclosure(3, "errorDefMissingRhs(1)");
  setclosureframe(closure5736, stackframe);
  addtoclosure(closure5736, var_errormessages);
  addtoclosure(closure5736, var_lastToken);
  addtoclosure(closure5736, var_sym);
  struct UserObject *uo5736 = (struct UserObject*)self;
  uo5736->data[59] = (Object)closure5736;
  Method *meth_meth_parser_5736_errorDefMissingRhs_40_1_41_ = addmethod2pos(self, "errorDefMissingRhs(1)", &meth_parser_5736_errorDefMissingRhs_40_1_41_, 59);
  int argcv_meth_parser_5736_errorDefMissingRhs_40_1_41_[] = {1};
  meth_meth_parser_5736_errorDefMissingRhs_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_5736_errorDefMissingRhs_40_1_41_);
  meth_meth_parser_5736_errorDefMissingRhs_40_1_41_->definitionModule = modulename;
  meth_meth_parser_5736_errorDefMissingRhs_40_1_41_->definitionLine = 1971;
// compiled method node returning  (depth = 1)
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "defdec"
  block_savedest(self);
  Object closure5768 = createclosure(6, "defdec");
  setclosureframe(closure5768, stackframe);
  addtoclosure(closure5768, var_minIndentLevel);
  addtoclosure(closure5768, var_sym);
  addtoclosure(closure5768, var_values);
  addtoclosure(closure5768, var_blocksOK);
  addtoclosure(closure5768, var_util);
  addtoclosure(closure5768, var_ast);
  struct UserObject *uo5768 = (struct UserObject*)self;
  uo5768->data[60] = (Object)closure5768;
  Method *meth_meth_parser_5768_defdec = addmethod2pos(self, "defdec", &meth_parser_5768_defdec, 60);
  int argcv_meth_parser_5768_defdec[] = {0};
  meth_meth_parser_5768_defdec->type = alloc_MethodType(1, argcv_meth_parser_5768_defdec);
  meth_meth_parser_5768_defdec->definitionModule = modulename;
  meth_meth_parser_5768_defdec->definitionLine = 1984;
// compiled method node returning  (depth = 1)
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "vardec"
  block_savedest(self);
  Object closure5862 = createclosure(8, "vardec");
  setclosureframe(closure5862, stackframe);
  addtoclosure(closure5862, var_minIndentLevel);
  addtoclosure(closure5862, var_sym);
  addtoclosure(closure5862, var_errormessages);
  addtoclosure(closure5862, var_lastToken);
  addtoclosure(closure5862, var_values);
  addtoclosure(closure5862, var_blocksOK);
  addtoclosure(closure5862, var_util);
  addtoclosure(closure5862, var_ast);
  struct UserObject *uo5862 = (struct UserObject*)self;
  uo5862->data[61] = (Object)closure5862;
  Method *meth_meth_parser_5862_vardec = addmethod2pos(self, "vardec", &meth_parser_5862_vardec, 61);
  int argcv_meth_parser_5862_vardec[] = {0};
  meth_meth_parser_5862_vardec->type = alloc_MethodType(1, argcv_meth_parser_5862_vardec);
  meth_meth_parser_5862_vardec->definitionModule = modulename;
  meth_meth_parser_5862_vardec->definitionLine = 2023;
// compiled method node returning  (depth = 1)
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doarray"
  block_savedest(self);
  Object closure6080 = createclosure(6, "doarray");
  setclosureframe(closure6080, stackframe);
  addtoclosure(closure6080, var_sym);
  addtoclosure(closure6080, var_blocksOK);
  addtoclosure(closure6080, var_values);
  addtoclosure(closure6080, var_errormessages);
  addtoclosure(closure6080, var_lastToken);
  addtoclosure(closure6080, var_ast);
  struct UserObject *uo6080 = (struct UserObject*)self;
  uo6080->data[62] = (Object)closure6080;
  Method *meth_meth_parser_6080_doarray = addmethod2pos(self, "doarray", &meth_parser_6080_doarray, 62);
  int argcv_meth_parser_6080_doarray[] = {0};
  meth_meth_parser_6080_doarray->type = alloc_MethodType(1, argcv_meth_parser_6080_doarray);
  meth_meth_parser_6080_doarray->definitionModule = modulename;
  meth_meth_parser_6080_doarray->definitionLine = 2095;
// compiled method node returning  (depth = 1)
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dodialect"
  block_savedest(self);
  Object closure6208 = createclosure(6, "dodialect");
  setclosureframe(closure6208, stackframe);
  addtoclosure(closure6208, var_sym);
  addtoclosure(closure6208, var_errormessages);
  addtoclosure(closure6208, var_lastToken);
  addtoclosure(closure6208, var_values);
  addtoclosure(closure6208, var_ast);
  addtoclosure(closure6208, var_moduleObject);
  struct UserObject *uo6208 = (struct UserObject*)self;
  uo6208->data[63] = (Object)closure6208;
  Method *meth_meth_parser_6208_dodialect = addmethod2pos(self, "dodialect", &meth_parser_6208_dodialect, 63);
  int argcv_meth_parser_6208_dodialect[] = {0};
  meth_meth_parser_6208_dodialect->type = alloc_MethodType(1, argcv_meth_parser_6208_dodialect);
  meth_meth_parser_6208_dodialect->definitionModule = modulename;
  meth_meth_parser_6208_dodialect->definitionLine = 2140;
// compiled method node returning  (depth = 1)
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "inheritOrUse"
  block_savedest(self);
  Object closure6298 = createclosure(9, "inheritOrUse");
  setclosureframe(closure6298, stackframe);
  addtoclosure(closure6298, var_done);
  addtoclosure(closure6298, var_sym);
  addtoclosure(closure6298, var_statementToken);
  addtoclosure(closure6298, var_noBlocks);
  addtoclosure(closure6298, var_errormessages);
  addtoclosure(closure6298, var_lastToken);
  addtoclosure(closure6298, var_util);
  addtoclosure(closure6298, var_values);
  addtoclosure(closure6298, var_ast);
  struct UserObject *uo6298 = (struct UserObject*)self;
  uo6298->data[64] = (Object)closure6298;
  Method *meth_meth_parser_6298_inheritOrUse = addmethod2pos(self, "inheritOrUse", &meth_parser_6298_inheritOrUse, 64);
  int argcv_meth_parser_6298_inheritOrUse[] = {0};
  meth_meth_parser_6298_inheritOrUse->type = alloc_MethodType(1, argcv_meth_parser_6298_inheritOrUse);
  meth_meth_parser_6298_inheritOrUse->definitionModule = modulename;
  meth_meth_parser_6298_inheritOrUse->definitionLine = 2170;
// compiled method node returning  (depth = 1)
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "inheritModifier(_)onLineOf(_)"
  block_savedest(self);
  Object closure6448 = createclosure(1, "inheritModifier(1)onLineOf(1)");
  setclosureframe(closure6448, stackframe);
  addtoclosure(closure6448, var_sym);
  struct UserObject *uo6448 = (struct UserObject*)self;
  uo6448->data[65] = (Object)closure6448;
  Method *meth_meth_parser_6448_inheritModifier_40_1_41_onLineOf_40_1_41_ = addmethod2pos(self, "inheritModifier(1)onLineOf(1)", &meth_parser_6448_inheritModifier_40_1_41_onLineOf_40_1_41_, 65);
  int argcv_meth_parser_6448_inheritModifier_40_1_41_onLineOf_40_1_41_[] = {1, 1};
  meth_meth_parser_6448_inheritModifier_40_1_41_onLineOf_40_1_41_->type = alloc_MethodType(2, argcv_meth_parser_6448_inheritModifier_40_1_41_onLineOf_40_1_41_);
  meth_meth_parser_6448_inheritModifier_40_1_41_onLineOf_40_1_41_->definitionModule = modulename;
  meth_meth_parser_6448_inheritModifier_40_1_41_onLineOf_40_1_41_->definitionLine = 2212;
// compiled method node returning  (depth = 1)
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseAlias(_)"
  block_savedest(self);
  Object closure6475 = createclosure(3, "parseAlias(1)");
  setclosureframe(closure6475, stackframe);
  addtoclosure(closure6475, var_sym);
  addtoclosure(closure6475, var_errormessages);
  addtoclosure(closure6475, var_lastToken);
  struct UserObject *uo6475 = (struct UserObject*)self;
  uo6475->data[66] = (Object)closure6475;
  Method *meth_meth_parser_6475_parseAlias_40_1_41_ = addmethod2pos(self, "parseAlias(1)", &meth_parser_6475_parseAlias_40_1_41_, 66);
  int argcv_meth_parser_6475_parseAlias_40_1_41_[] = {1};
  meth_meth_parser_6475_parseAlias_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_6475_parseAlias_40_1_41_);
  meth_meth_parser_6475_parseAlias_40_1_41_->definitionModule = modulename;
  meth_meth_parser_6475_parseAlias_40_1_41_->definitionLine = 2226;
// compiled method node returning  (depth = 1)
// Begin line 2244
  setline(2244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseExclude(_)"
  struct UserObject *uo6541 = (struct UserObject*)self;
  uo6541->data[67] = emptyclosure;
  Method *meth_meth_parser_6541_parseExclude_40_1_41_ = addmethod2pos(self, "parseExclude(1)", &meth_parser_6541_parseExclude_40_1_41_, 67);
  int argcv_meth_parser_6541_parseExclude_40_1_41_[] = {1};
  meth_meth_parser_6541_parseExclude_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_6541_parseExclude_40_1_41_);
  meth_meth_parser_6541_parseExclude_40_1_41_->definitionModule = modulename;
  meth_meth_parser_6541_parseExclude_40_1_41_->definitionLine = 2244;
// compiled method node returning  (depth = 1)
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doobject"
  block_savedest(self);
  Object closure6554 = createclosure(1, "doobject");
  setclosureframe(closure6554, stackframe);
  addtoclosure(closure6554, var_lastToken);
  struct UserObject *uo6554 = (struct UserObject*)self;
  uo6554->data[68] = (Object)closure6554;
  Method *meth_meth_parser_6554_doobject = addmethod2pos(self, "doobject", &meth_parser_6554_doobject, 68);
  int argcv_meth_parser_6554_doobject[] = {0};
  meth_meth_parser_6554_doobject->type = alloc_MethodType(1, argcv_meth_parser_6554_doobject);
  meth_meth_parser_6554_doobject->definitionModule = modulename;
  meth_meth_parser_6554_doobject->definitionLine = 2251;
// compiled method node returning  (depth = 1)
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseObjectConstructorBody(_)startingWith(_)after(_)"
  block_savedest(self);
  Object closure6565 = createclosure(7, "parseObjectConstructorBody(1)startingWith(1)after(1)");
  setclosureframe(closure6565, stackframe);
  addtoclosure(closure6565, var_minIndentLevel);
  addtoclosure(closure6565, var_sym);
  addtoclosure(closure6565, var_errormessages);
  addtoclosure(closure6565, var_lastToken);
  addtoclosure(closure6565, var_statementToken);
  addtoclosure(closure6565, var_values);
  addtoclosure(closure6565, var_ast);
  struct UserObject *uo6565 = (struct UserObject*)self;
  uo6565->data[69] = (Object)closure6565;
  Method *meth_meth_parser_6565_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_ = addmethod2pos(self, "parseObjectConstructorBody(1)startingWith(1)after(1)", &meth_parser_6565_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_, 69);
  int argcv_meth_parser_6565_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_[] = {1, 1, 1};
  meth_meth_parser_6565_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_->type = alloc_MethodType(3, argcv_meth_parser_6565_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_);
  meth_meth_parser_6565_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_->definitionModule = modulename;
  meth_meth_parser_6565_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_->definitionLine = 2262;
// compiled method node returning  (depth = 1)
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doclass"
  block_savedest(self);
  Object closure6835 = createclosure(6, "doclass");
  setclosureframe(closure6835, stackframe);
  addtoclosure(closure6835, var_sym);
  addtoclosure(closure6835, var_minIndentLevel);
  addtoclosure(closure6835, var_errormessages);
  addtoclosure(closure6835, var_lastToken);
  addtoclosure(closure6835, var_tokens);
  addtoclosure(closure6835, var_values);
  struct UserObject *uo6835 = (struct UserObject*)self;
  uo6835->data[70] = (Object)closure6835;
  Method *meth_meth_parser_6835_doclass = addmethod2pos(self, "doclass", &meth_parser_6835_doclass, 70);
  int argcv_meth_parser_6835_doclass[] = {0};
  meth_meth_parser_6835_doclass->type = alloc_MethodType(1, argcv_meth_parser_6835_doclass);
  meth_meth_parser_6835_doclass->definitionModule = modulename;
  meth_meth_parser_6835_doclass->definitionLine = 2333;
// compiled method node returning  (depth = 1)
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dofactoryMethod"
  block_savedest(self);
  Object closure6973 = createclosure(3, "dofactoryMethod");
  setclosureframe(closure6973, stackframe);
  addtoclosure(closure6973, var_tokens);
  addtoclosure(closure6973, var_sym);
  addtoclosure(closure6973, var_errormessages);
  struct UserObject *uo6973 = (struct UserObject*)self;
  uo6973->data[71] = (Object)closure6973;
  Method *meth_meth_parser_6973_dofactoryMethod = addmethod2pos(self, "dofactoryMethod", &meth_parser_6973_dofactoryMethod, 71);
  int argcv_meth_parser_6973_dofactoryMethod[] = {0};
  meth_meth_parser_6973_dofactoryMethod->type = alloc_MethodType(1, argcv_meth_parser_6973_dofactoryMethod);
  meth_meth_parser_6973_dofactoryMethod->definitionModule = modulename;
  meth_meth_parser_6973_dofactoryMethod->definitionLine = 2416;
// compiled method node returning  (depth = 1)
// Begin line 2429
  setline(2429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methoddec"
  block_savedest(self);
  Object closure7023 = createclosure(7, "methoddec");
  setclosureframe(closure7023, stackframe);
  addtoclosure(closure7023, var_sym);
  addtoclosure(closure7023, var_statementToken);
  addtoclosure(closure7023, var_values);
  addtoclosure(closure7023, var_minIndentLevel);
  addtoclosure(closure7023, var_errormessages);
  addtoclosure(closure7023, var_lastToken);
  addtoclosure(closure7023, var_util);
  struct UserObject *uo7023 = (struct UserObject*)self;
  uo7023->data[72] = (Object)closure7023;
  Method *meth_meth_parser_7023_methoddec = addmethod2pos(self, "methoddec", &meth_parser_7023_methoddec, 72);
  int argcv_meth_parser_7023_methoddec[] = {0};
  meth_meth_parser_7023_methoddec->type = alloc_MethodType(1, argcv_meth_parser_7023_methoddec);
  meth_meth_parser_7023_methoddec->definitionModule = modulename;
  meth_meth_parser_7023_methoddec->definitionLine = 2429;
// compiled method node returning  (depth = 1)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methodDecRest(_,_)"
  block_savedest(self);
  Object closure7232 = createclosure(5, "methodDecRest(2)");
  setclosureframe(closure7232, stackframe);
  addtoclosure(closure7232, var_values);
  addtoclosure(closure7232, var_ast);
  addtoclosure(closure7232, var_errormessages);
  addtoclosure(closure7232, var_lastToken);
  addtoclosure(closure7232, var_sym);
  struct UserObject *uo7232 = (struct UserObject*)self;
  uo7232->data[73] = (Object)closure7232;
  Method *meth_meth_parser_7232_methodDecRest_40_2_41_ = addmethod2pos(self, "methodDecRest(2)", &meth_parser_7232_methodDecRest_40_2_41_, 73);
  int argcv_meth_parser_7232_methodDecRest_40_2_41_[] = {2};
  meth_meth_parser_7232_methodDecRest_40_2_41_->type = alloc_MethodType(1, argcv_meth_parser_7232_methodDecRest_40_2_41_);
  meth_meth_parser_7232_methodDecRest_40_2_41_->definitionModule = modulename;
  meth_meth_parser_7232_methodDecRest_40_2_41_->definitionLine = 2503;
// compiled method node returning  (depth = 1)
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "optionalTypeAnnotation"
  block_savedest(self);
  Object closure7394 = createclosure(4, "optionalTypeAnnotation");
  setclosureframe(closure7394, stackframe);
  addtoclosure(closure7394, var_values);
  addtoclosure(closure7394, var_errormessages);
  addtoclosure(closure7394, var_lastToken);
  addtoclosure(closure7394, var_sym);
  struct UserObject *uo7394 = (struct UserObject*)self;
  uo7394->data[74] = (Object)closure7394;
  Method *meth_meth_parser_7394_optionalTypeAnnotation = addmethod2pos(self, "optionalTypeAnnotation", &meth_parser_7394_optionalTypeAnnotation, 74);
  int argcv_meth_parser_7394_optionalTypeAnnotation[] = {0};
  meth_meth_parser_7394_optionalTypeAnnotation->type = alloc_MethodType(1, argcv_meth_parser_7394_optionalTypeAnnotation);
  meth_meth_parser_7394_optionalTypeAnnotation->definitionModule = modulename;
  meth_meth_parser_7394_optionalTypeAnnotation->definitionLine = 2551;
// compiled method node returning  (depth = 1)
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methodsignature(_)"
  block_savedest(self);
  Object closure7442 = createclosure(5, "methodsignature(1)");
  setclosureframe(closure7442, stackframe);
  addtoclosure(closure7442, var_sym);
  addtoclosure(closure7442, var_errormessages);
  addtoclosure(closure7442, var_lastToken);
  addtoclosure(closure7442, var_ast);
  addtoclosure(closure7442, var_values);
  struct UserObject *uo7442 = (struct UserObject*)self;
  uo7442->data[75] = (Object)closure7442;
  Method *meth_meth_parser_7442_methodsignature_40_1_41_ = addmethod2pos(self, "methodsignature(1)", &meth_parser_7442_methodsignature_40_1_41_, 75);
  int argcv_meth_parser_7442_methodsignature_40_1_41_[] = {1};
  meth_meth_parser_7442_methodsignature_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_7442_methodsignature_40_1_41_);
  meth_meth_parser_7442_methodsignature_40_1_41_->definitionModule = modulename;
  meth_meth_parser_7442_methodsignature_40_1_41_->definitionLine = 2575;
// compiled method node returning  (depth = 1)
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeparameters"
  block_savedest(self);
  Object closure7809 = createclosure(5, "typeparameters");
  setclosureframe(closure7809, stackframe);
  addtoclosure(closure7809, var_sym);
  addtoclosure(closure7809, var_values);
  addtoclosure(closure7809, var_ast);
  addtoclosure(closure7809, var_errormessages);
  addtoclosure(closure7809, var_lastToken);
  struct UserObject *uo7809 = (struct UserObject*)self;
  uo7809->data[76] = (Object)closure7809;
  Method *meth_meth_parser_7809_typeparameters = addmethod2pos(self, "typeparameters", &meth_parser_7809_typeparameters, 76);
  int argcv_meth_parser_7809_typeparameters[] = {0};
  meth_meth_parser_7809_typeparameters->type = alloc_MethodType(1, argcv_meth_parser_7809_typeparameters);
  meth_meth_parser_7809_typeparameters->definitionModule = modulename;
  meth_meth_parser_7809_typeparameters->definitionLine = 2666;
// compiled method node returning  (depth = 1)
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doimport"
  block_savedest(self);
  Object closure7881 = createclosure(5, "doimport");
  setclosureframe(closure7881, stackframe);
  addtoclosure(closure7881, var_sym);
  addtoclosure(closure7881, var_errormessages);
  addtoclosure(closure7881, var_lastToken);
  addtoclosure(closure7881, var_values);
  addtoclosure(closure7881, var_ast);
  struct UserObject *uo7881 = (struct UserObject*)self;
  uo7881->data[77] = (Object)closure7881;
  Method *meth_meth_parser_7881_doimport = addmethod2pos(self, "doimport", &meth_parser_7881_doimport, 77);
  int argcv_meth_parser_7881_doimport[] = {0};
  meth_meth_parser_7881_doimport->type = alloc_MethodType(1, argcv_meth_parser_7881_doimport);
  meth_meth_parser_7881_doimport->definitionModule = modulename;
  meth_meth_parser_7881_doimport->definitionLine = 2691;
// compiled method node returning  (depth = 1)
// Begin line 2748
  setline(2748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doreturn"
  block_savedest(self);
  Object closure8129 = createclosure(7, "doreturn");
  setclosureframe(closure8129, stackframe);
  addtoclosure(closure8129, var_sym);
  addtoclosure(closure8129, var_blocksOK);
  addtoclosure(closure8129, var_errormessages);
  addtoclosure(closure8129, var_lastToken);
  addtoclosure(closure8129, var_values);
  addtoclosure(closure8129, var_ast);
  addtoclosure(closure8129, var_util);
  struct UserObject *uo8129 = (struct UserObject*)self;
  uo8129->data[78] = (Object)closure8129;
  Method *meth_meth_parser_8129_doreturn = addmethod2pos(self, "doreturn", &meth_parser_8129_doreturn, 78);
  int argcv_meth_parser_8129_doreturn[] = {0};
  meth_meth_parser_8129_doreturn->type = alloc_MethodType(1, argcv_meth_parser_8129_doreturn);
  meth_meth_parser_8129_doreturn->definitionModule = modulename;
  meth_meth_parser_8129_doreturn->definitionLine = 2748;
// compiled method node returning  (depth = 1)
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "domethodtype"
  block_savedest(self);
  Object closure8250 = createclosure(6, "domethodtype");
  setclosureframe(closure8250, stackframe);
  addtoclosure(closure8250, var_sym);
  addtoclosure(closure8250, var_ast);
  addtoclosure(closure8250, var_values);
  addtoclosure(closure8250, var_lastToken);
  addtoclosure(closure8250, var_errormessages);
  addtoclosure(closure8250, var_util);
  struct UserObject *uo8250 = (struct UserObject*)self;
  uo8250->data[79] = (Object)closure8250;
  Method *meth_meth_parser_8250_domethodtype = addmethod2pos(self, "domethodtype", &meth_parser_8250_domethodtype, 79);
  int argcv_meth_parser_8250_domethodtype[] = {0};
  meth_meth_parser_8250_domethodtype->type = alloc_MethodType(1, argcv_meth_parser_8250_domethodtype);
  meth_meth_parser_8250_domethodtype->definitionModule = modulename;
  meth_meth_parser_8250_domethodtype->definitionLine = 2787;
// compiled method node returning  (depth = 1)
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotypeLiteral"
  block_savedest(self);
  Object closure8349 = createclosure(7, "dotypeLiteral");
  setclosureframe(closure8349, stackframe);
  addtoclosure(closure8349, var_sym);
  addtoclosure(closure8349, var_errormessages);
  addtoclosure(closure8349, var_done);
  addtoclosure(closure8349, var_auto_count);
  addtoclosure(closure8349, var_values);
  addtoclosure(closure8349, var_util);
  addtoclosure(closure8349, var_ast);
  struct UserObject *uo8349 = (struct UserObject*)self;
  uo8349->data[80] = (Object)closure8349;
  Method *meth_meth_parser_8349_dotypeLiteral = addmethod2pos(self, "dotypeLiteral", &meth_parser_8349_dotypeLiteral, 80);
  int argcv_meth_parser_8349_dotypeLiteral[] = {0};
  meth_meth_parser_8349_dotypeLiteral->type = alloc_MethodType(1, argcv_meth_parser_8349_dotypeLiteral);
  meth_meth_parser_8349_dotypeLiteral->definitionModule = modulename;
  meth_meth_parser_8349_dotypeLiteral->definitionLine = 2816;
// compiled method node returning  (depth = 1)
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typedec"
  block_savedest(self);
  Object closure8442 = createclosure(7, "typedec");
  setclosureframe(closure8442, stackframe);
  addtoclosure(closure8442, var_sym);
  addtoclosure(closure8442, var_errormessages);
  addtoclosure(closure8442, var_lastToken);
  addtoclosure(closure8442, var_util);
  addtoclosure(closure8442, var_values);
  addtoclosure(closure8442, var_ast);
  addtoclosure(closure8442, var_noBlocks);
  struct UserObject *uo8442 = (struct UserObject*)self;
  uo8442->data[81] = (Object)closure8442;
  Method *meth_meth_parser_8442_typedec = addmethod2pos(self, "typedec", &meth_parser_8442_typedec, 81);
  int argcv_meth_parser_8442_typedec[] = {0};
  meth_meth_parser_8442_typedec->type = alloc_MethodType(1, argcv_meth_parser_8442_typedec);
  meth_meth_parser_8442_typedec->definitionModule = modulename;
  meth_meth_parser_8442_typedec->definitionLine = 2852;
// compiled method node returning  (depth = 1)
// Begin line 2900
  setline(2900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkIndent"
  block_savedest(self);
  Object closure8614 = createclosure(5, "checkIndent");
  setclosureframe(closure8614, stackframe);
  addtoclosure(closure8614, var_indentFreePass);
  addtoclosure(closure8614, var_sym);
  addtoclosure(closure8614, var_minIndentLevel);
  addtoclosure(closure8614, var_errormessages);
  addtoclosure(closure8614, var_lastToken);
  struct UserObject *uo8614 = (struct UserObject*)self;
  uo8614->data[82] = (Object)closure8614;
  Method *meth_meth_parser_8614_checkIndent = addmethod2pos(self, "checkIndent", &meth_parser_8614_checkIndent, 82);
  int argcv_meth_parser_8614_checkIndent[] = {0};
  meth_meth_parser_8614_checkIndent->type = alloc_MethodType(1, argcv_meth_parser_8614_checkIndent);
  meth_meth_parser_8614_checkIndent->definitionModule = modulename;
  meth_meth_parser_8614_checkIndent->definitionLine = 2900;
// compiled method node returning  (depth = 1)
// Begin line 2936
  setline(2936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "statement"
  block_savedest(self);
  Object closure8780 = createclosure(8, "statement");
  setclosureframe(closure8780, stackframe);
  addtoclosure(closure8780, var_sym);
  addtoclosure(closure8780, var_statementIndent);
  addtoclosure(closure8780, var_statementToken);
  addtoclosure(closure8780, var_blocksOK);
  addtoclosure(closure8780, var_values);
  addtoclosure(closure8780, var_util);
  addtoclosure(closure8780, var_ast);
  addtoclosure(closure8780, var_indentFreePass);
  struct UserObject *uo8780 = (struct UserObject*)self;
  uo8780->data[83] = (Object)closure8780;
  Method *meth_meth_parser_8780_statement = addmethod2pos(self, "statement", &meth_parser_8780_statement, 83);
  int argcv_meth_parser_8780_statement[] = {0};
  meth_meth_parser_8780_statement->type = alloc_MethodType(1, argcv_meth_parser_8780_statement);
  meth_meth_parser_8780_statement->definitionModule = modulename;
  meth_meth_parser_8780_statement->definitionLine = 2936;
// compiled method node returning  (depth = 1)
// Begin line 3006
  setline(3006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushComments"
  block_savedest(self);
  Object closure8993 = createclosure(8, "pushComments");
  setclosureframe(closure8993, stackframe);
  addtoclosure(closure8993, var_done);
  addtoclosure(closure8993, var_sym);
  addtoclosure(closure8993, var_util);
  addtoclosure(closure8993, var_ast);
  addtoclosure(closure8993, var_lastToken);
  addtoclosure(closure8993, var_comments);
  addtoclosure(closure8993, var_previousCommentToken);
  addtoclosure(closure8993, var_tokens);
  struct UserObject *uo8993 = (struct UserObject*)self;
  uo8993->data[84] = (Object)closure8993;
  Method *meth_meth_parser_8993_pushComments = addmethod2pos(self, "pushComments", &meth_parser_8993_pushComments, 84);
  int argcv_meth_parser_8993_pushComments[] = {0};
  meth_meth_parser_8993_pushComments->type = alloc_MethodType(1, argcv_meth_parser_8993_pushComments);
  meth_meth_parser_8993_pushComments->definitionModule = modulename;
  meth_meth_parser_8993_pushComments->definitionLine = 3006;
// compiled method node returning  (depth = 1)
// Begin line 3039
  setline(3039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reconcileComments"
  block_savedest(self);
  Object closure9112 = createclosure(4, "reconcileComments");
  setclosureframe(closure9112, stackframe);
  addtoclosure(closure9112, var_values);
  addtoclosure(closure9112, var_moduleObject);
  addtoclosure(closure9112, var_done);
  addtoclosure(closure9112, var_comments);
  struct UserObject *uo9112 = (struct UserObject*)self;
  uo9112->data[85] = (Object)closure9112;
  Method *meth_meth_parser_9112_reconcileComments = addmethod2pos(self, "reconcileComments", &meth_parser_9112_reconcileComments, 85);
  int argcv_meth_parser_9112_reconcileComments[] = {0};
  meth_meth_parser_9112_reconcileComments->type = alloc_MethodType(1, argcv_meth_parser_9112_reconcileComments);
  meth_meth_parser_9112_reconcileComments->definitionModule = modulename;
  meth_meth_parser_9112_reconcileComments->definitionLine = 3039;
// compiled method node returning  (depth = 1)
// Begin line 3085
  setline(3085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkBadOperators"
  block_savedest(self);
  Object closure9239 = createclosure(2, "checkBadOperators");
  setclosureframe(closure9239, stackframe);
  addtoclosure(closure9239, var_sym);
  addtoclosure(closure9239, var_errormessages);
  struct UserObject *uo9239 = (struct UserObject*)self;
  uo9239->data[86] = (Object)closure9239;
  Method *meth_meth_parser_9239_checkBadOperators = addmethod2pos(self, "checkBadOperators", &meth_parser_9239_checkBadOperators, 86);
  int argcv_meth_parser_9239_checkBadOperators[] = {0};
  meth_meth_parser_9239_checkBadOperators->type = alloc_MethodType(1, argcv_meth_parser_9239_checkBadOperators);
  meth_meth_parser_9239_checkBadOperators->definitionModule = modulename;
  meth_meth_parser_9239_checkBadOperators->definitionLine = 3085;
// compiled method node returning  (depth = 1)
// Begin line 3095
  setline(3095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkBadTypeLiteral"
  block_savedest(self);
  Object closure9263 = createclosure(2, "checkBadTypeLiteral");
  setclosureframe(closure9263, stackframe);
  addtoclosure(closure9263, var_sym);
  addtoclosure(closure9263, var_errormessages);
  struct UserObject *uo9263 = (struct UserObject*)self;
  uo9263->data[87] = (Object)closure9263;
  Method *meth_meth_parser_9263_checkBadTypeLiteral = addmethod2pos(self, "checkBadTypeLiteral", &meth_parser_9263_checkBadTypeLiteral, 87);
  int argcv_meth_parser_9263_checkBadTypeLiteral[] = {0};
  meth_meth_parser_9263_checkBadTypeLiteral->type = alloc_MethodType(1, argcv_meth_parser_9263_checkBadTypeLiteral);
  meth_meth_parser_9263_checkBadTypeLiteral->definitionModule = modulename;
  meth_meth_parser_9263_checkBadTypeLiteral->definitionLine = 3095;
// compiled method node returning  (depth = 1)
// Begin line 3105
  setline(3105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkUnexpectedTokenAfterStatement"
  block_savedest(self);
  Object closure9287 = createclosure(5, "checkUnexpectedTokenAfterStatement");
  setclosureframe(closure9287, stackframe);
  addtoclosure(closure9287, var_lastToken);
  addtoclosure(closure9287, var_sym);
  addtoclosure(closure9287, var_errormessages);
  addtoclosure(closure9287, var_values);
  addtoclosure(closure9287, var_util);
  struct UserObject *uo9287 = (struct UserObject*)self;
  uo9287->data[88] = (Object)closure9287;
  Method *meth_meth_parser_9287_checkUnexpectedTokenAfterStatement = addmethod2pos(self, "checkUnexpectedTokenAfterStatement", &meth_parser_9287_checkUnexpectedTokenAfterStatement, 88);
  int argcv_meth_parser_9287_checkUnexpectedTokenAfterStatement[] = {0};
  meth_meth_parser_9287_checkUnexpectedTokenAfterStatement->type = alloc_MethodType(1, argcv_meth_parser_9287_checkUnexpectedTokenAfterStatement);
  meth_meth_parser_9287_checkUnexpectedTokenAfterStatement->definitionModule = modulename;
  meth_meth_parser_9287_checkUnexpectedTokenAfterStatement->definitionLine = 3105;
// compiled method node returning  (depth = 1)
// Begin line 3164
  setline(3164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parse(_)"
  block_savedest(self);
  Object closure9586 = createclosure(7, "parse(1)");
  setclosureframe(closure9586, stackframe);
  addtoclosure(closure9586, var_util);
  addtoclosure(closure9586, var_values);
  addtoclosure(closure9586, var_ast);
  addtoclosure(closure9586, var_moduleObject);
  addtoclosure(closure9586, var_tokens);
  addtoclosure(closure9586, var_sym);
  addtoclosure(closure9586, var_errormessages);
  struct UserObject *uo9586 = (struct UserObject*)self;
  uo9586->data[89] = (Object)closure9586;
  Method *meth_meth_parser_9586_parse_40_1_41_ = addmethod2pos(self, "parse(1)", &meth_parser_9586_parse_40_1_41_, 89);
  int argcv_meth_parser_9586_parse_40_1_41_[] = {1};
  meth_meth_parser_9586_parse_40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9586_parse_40_1_41_);
  meth_meth_parser_9586_parse_40_1_41_->definitionModule = modulename;
  meth_meth_parser_9586_parse_40_1_41_->definitionLine = 3164;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of ast as ast
  if (module_ast == NULL)
    module_ast = LOAD_MODULE(ast);
  *var_ast = module_ast;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = LOAD_MODULE(errormessages);
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num9732 = alloc_Float64(0);
// compiled num node returning num9732 (depth = 2)
  *var_lastLine = num9732;
  if (num9732 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastLine"
  block_savedest(self);
  Object closure9733 = createclosure(1, "lastLine");
  setclosureframe(closure9733, stackframe);
  addtoclosure(closure9733, var_lastLine);
  struct UserObject *uo9733 = (struct UserObject*)self;
  uo9733->data[90] = (Object)closure9733;
  Method *meth_meth_parser_9733_lastLine = addmethod2pos(self, "lastLine", &meth_parser_9733_lastLine, 90);
  int argcv_meth_parser_9733_lastLine[] = {0};
  meth_meth_parser_9733_lastLine->type = alloc_MethodType(1, argcv_meth_parser_9733_lastLine);
  meth_meth_parser_9733_lastLine->definitionModule = modulename;
  meth_meth_parser_9733_lastLine->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastLine:=(_)"
  block_savedest(self);
  Object closure9734 = createclosure(1, "lastLine:=(1)");
  setclosureframe(closure9734, stackframe);
  addtoclosure(closure9734, var_lastLine);
  struct UserObject *uo9734 = (struct UserObject*)self;
  uo9734->data[91] = (Object)closure9734;
  Method *meth_meth_parser_9734_lastLine_58__61__40_1_41_ = addmethod2pos(self, "lastLine:=(1)", &meth_parser_9734_lastLine_58__61__40_1_41_, 91);
  int argcv_meth_parser_9734_lastLine_58__61__40_1_41_[] = {1};
  meth_meth_parser_9734_lastLine_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9734_lastLine_58__61__40_1_41_);
  meth_meth_parser_9734_lastLine_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9734_lastLine_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num9736 = alloc_Float64(0);
// compiled num node returning num9736 (depth = 2)
  *var_lastIndent = num9736;
  if (num9736 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastIndent"
  block_savedest(self);
  Object closure9737 = createclosure(1, "lastIndent");
  setclosureframe(closure9737, stackframe);
  addtoclosure(closure9737, var_lastIndent);
  struct UserObject *uo9737 = (struct UserObject*)self;
  uo9737->data[92] = (Object)closure9737;
  Method *meth_meth_parser_9737_lastIndent = addmethod2pos(self, "lastIndent", &meth_parser_9737_lastIndent, 92);
  int argcv_meth_parser_9737_lastIndent[] = {0};
  meth_meth_parser_9737_lastIndent->type = alloc_MethodType(1, argcv_meth_parser_9737_lastIndent);
  meth_meth_parser_9737_lastIndent->definitionModule = modulename;
  meth_meth_parser_9737_lastIndent->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastIndent:=(_)"
  block_savedest(self);
  Object closure9738 = createclosure(1, "lastIndent:=(1)");
  setclosureframe(closure9738, stackframe);
  addtoclosure(closure9738, var_lastIndent);
  struct UserObject *uo9738 = (struct UserObject*)self;
  uo9738->data[93] = (Object)closure9738;
  Method *meth_meth_parser_9738_lastIndent_58__61__40_1_41_ = addmethod2pos(self, "lastIndent:=(1)", &meth_parser_9738_lastIndent_58__61__40_1_41_, 93);
  int argcv_meth_parser_9738_lastIndent_58__61__40_1_41_[] = {1};
  meth_meth_parser_9738_lastIndent_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9738_lastIndent_58__61__40_1_41_);
  meth_meth_parser_9738_lastIndent_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9738_lastIndent_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool9740 = alloc_Boolean(0);
// compiled identifier node returning bool9740 (depth = 2)
  *var_indentFreePass = bool9740;
  if (bool9740 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indentFreePass"
  block_savedest(self);
  Object closure9741 = createclosure(1, "indentFreePass");
  setclosureframe(closure9741, stackframe);
  addtoclosure(closure9741, var_indentFreePass);
  struct UserObject *uo9741 = (struct UserObject*)self;
  uo9741->data[94] = (Object)closure9741;
  Method *meth_meth_parser_9741_indentFreePass = addmethod2pos(self, "indentFreePass", &meth_parser_9741_indentFreePass, 94);
  int argcv_meth_parser_9741_indentFreePass[] = {0};
  meth_meth_parser_9741_indentFreePass->type = alloc_MethodType(1, argcv_meth_parser_9741_indentFreePass);
  meth_meth_parser_9741_indentFreePass->definitionModule = modulename;
  meth_meth_parser_9741_indentFreePass->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indentFreePass:=(_)"
  block_savedest(self);
  Object closure9742 = createclosure(1, "indentFreePass:=(1)");
  setclosureframe(closure9742, stackframe);
  addtoclosure(closure9742, var_indentFreePass);
  struct UserObject *uo9742 = (struct UserObject*)self;
  uo9742->data[95] = (Object)closure9742;
  Method *meth_meth_parser_9742_indentFreePass_58__61__40_1_41_ = addmethod2pos(self, "indentFreePass:=(1)", &meth_parser_9742_indentFreePass_58__61__40_1_41_, 95);
  int argcv_meth_parser_9742_indentFreePass_58__61__40_1_41_[] = {1};
  meth_meth_parser_9742_indentFreePass_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9742_indentFreePass_58__61__40_1_41_);
  meth_meth_parser_9742_indentFreePass_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9742_indentFreePass_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num9744 = alloc_Float64(0);
// compiled num node returning num9744 (depth = 2)
  *var_minIndentLevel = num9744;
  if (num9744 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "minIndentLevel"
  block_savedest(self);
  Object closure9745 = createclosure(1, "minIndentLevel");
  setclosureframe(closure9745, stackframe);
  addtoclosure(closure9745, var_minIndentLevel);
  struct UserObject *uo9745 = (struct UserObject*)self;
  uo9745->data[96] = (Object)closure9745;
  Method *meth_meth_parser_9745_minIndentLevel = addmethod2pos(self, "minIndentLevel", &meth_parser_9745_minIndentLevel, 96);
  int argcv_meth_parser_9745_minIndentLevel[] = {0};
  meth_meth_parser_9745_minIndentLevel->type = alloc_MethodType(1, argcv_meth_parser_9745_minIndentLevel);
  meth_meth_parser_9745_minIndentLevel->definitionModule = modulename;
  meth_meth_parser_9745_minIndentLevel->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "minIndentLevel:=(_)"
  block_savedest(self);
  Object closure9746 = createclosure(1, "minIndentLevel:=(1)");
  setclosureframe(closure9746, stackframe);
  addtoclosure(closure9746, var_minIndentLevel);
  struct UserObject *uo9746 = (struct UserObject*)self;
  uo9746->data[97] = (Object)closure9746;
  Method *meth_meth_parser_9746_minIndentLevel_58__61__40_1_41_ = addmethod2pos(self, "minIndentLevel:=(1)", &meth_parser_9746_minIndentLevel_58__61__40_1_41_, 97);
  int argcv_meth_parser_9746_minIndentLevel_58__61__40_1_41_[] = {1};
  meth_meth_parser_9746_minIndentLevel_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9746_minIndentLevel_58__61__40_1_41_);
  meth_meth_parser_9746_minIndentLevel_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9746_minIndentLevel_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num9748 = alloc_Float64(0);
// compiled num node returning num9748 (depth = 2)
  *var_statementIndent = num9748;
  if (num9748 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementIndent"
  block_savedest(self);
  Object closure9749 = createclosure(1, "statementIndent");
  setclosureframe(closure9749, stackframe);
  addtoclosure(closure9749, var_statementIndent);
  struct UserObject *uo9749 = (struct UserObject*)self;
  uo9749->data[98] = (Object)closure9749;
  Method *meth_meth_parser_9749_statementIndent = addmethod2pos(self, "statementIndent", &meth_parser_9749_statementIndent, 98);
  int argcv_meth_parser_9749_statementIndent[] = {0};
  meth_meth_parser_9749_statementIndent->type = alloc_MethodType(1, argcv_meth_parser_9749_statementIndent);
  meth_meth_parser_9749_statementIndent->definitionModule = modulename;
  meth_meth_parser_9749_statementIndent->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementIndent:=(_)"
  block_savedest(self);
  Object closure9750 = createclosure(1, "statementIndent:=(1)");
  setclosureframe(closure9750, stackframe);
  addtoclosure(closure9750, var_statementIndent);
  struct UserObject *uo9750 = (struct UserObject*)self;
  uo9750->data[99] = (Object)closure9750;
  Method *meth_meth_parser_9750_statementIndent_58__61__40_1_41_ = addmethod2pos(self, "statementIndent:=(1)", &meth_parser_9750_statementIndent_58__61__40_1_41_, 99);
  int argcv_meth_parser_9750_statementIndent_58__61__40_1_41_[] = {1};
  meth_meth_parser_9750_statementIndent_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9750_statementIndent_58__61__40_1_41_);
  meth_meth_parser_9750_statementIndent_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9750_statementIndent_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool9752 = alloc_Boolean(0);
// compiled identifier node returning bool9752 (depth = 2)
  *var_tokens = bool9752;
  if (bool9752 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tokens"
  block_savedest(self);
  Object closure9753 = createclosure(1, "tokens");
  setclosureframe(closure9753, stackframe);
  addtoclosure(closure9753, var_tokens);
  struct UserObject *uo9753 = (struct UserObject*)self;
  uo9753->data[100] = (Object)closure9753;
  Method *meth_meth_parser_9753_tokens = addmethod2pos(self, "tokens", &meth_parser_9753_tokens, 100);
  int argcv_meth_parser_9753_tokens[] = {0};
  meth_meth_parser_9753_tokens->type = alloc_MethodType(1, argcv_meth_parser_9753_tokens);
  meth_meth_parser_9753_tokens->definitionModule = modulename;
  meth_meth_parser_9753_tokens->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tokens:=(_)"
  block_savedest(self);
  Object closure9754 = createclosure(1, "tokens:=(1)");
  setclosureframe(closure9754, stackframe);
  addtoclosure(closure9754, var_tokens);
  struct UserObject *uo9754 = (struct UserObject*)self;
  uo9754->data[101] = (Object)closure9754;
  Method *meth_meth_parser_9754_tokens_58__61__40_1_41_ = addmethod2pos(self, "tokens:=(1)", &meth_parser_9754_tokens_58__61__40_1_41_, 101);
  int argcv_meth_parser_9754_tokens_58__61__40_1_41_[] = {1};
  meth_meth_parser_9754_tokens_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9754_tokens_58__61__40_1_41_);
  meth_meth_parser_9754_tokens_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9754_tokens_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
  *var_moduleObject = undefined;
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleObject"
  block_savedest(self);
  Object closure9756 = createclosure(1, "moduleObject");
  setclosureframe(closure9756, stackframe);
  addtoclosure(closure9756, var_moduleObject);
  struct UserObject *uo9756 = (struct UserObject*)self;
  uo9756->data[102] = (Object)closure9756;
  Method *meth_meth_parser_9756_moduleObject = addmethod2pos(self, "moduleObject", &meth_parser_9756_moduleObject, 102);
  int argcv_meth_parser_9756_moduleObject[] = {0};
  meth_meth_parser_9756_moduleObject->type = alloc_MethodType(1, argcv_meth_parser_9756_moduleObject);
  meth_meth_parser_9756_moduleObject->definitionModule = modulename;
  meth_meth_parser_9756_moduleObject->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleObject:=(_)"
  block_savedest(self);
  Object closure9757 = createclosure(1, "moduleObject:=(1)");
  setclosureframe(closure9757, stackframe);
  addtoclosure(closure9757, var_moduleObject);
  struct UserObject *uo9757 = (struct UserObject*)self;
  uo9757->data[103] = (Object)closure9757;
  Method *meth_meth_parser_9757_moduleObject_58__61__40_1_41_ = addmethod2pos(self, "moduleObject:=(1)", &meth_parser_9757_moduleObject_58__61__40_1_41_, 103);
  int argcv_meth_parser_9757_moduleObject_58__61__40_1_41_[] = {1};
  meth_meth_parser_9757_moduleObject_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9757_moduleObject_58__61__40_1_41_);
  meth_meth_parser_9757_moduleObject_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9757_moduleObject_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile member node (depth = 2)
  int callframe9759 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9760 = callmethodflags(prelude, "emptyList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9759);
// compiled member node returning call9760 (depth = 2)
  *var_comments = call9760;
  if (call9760 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comments"
  block_savedest(self);
  Object closure9761 = createclosure(1, "comments");
  setclosureframe(closure9761, stackframe);
  addtoclosure(closure9761, var_comments);
  struct UserObject *uo9761 = (struct UserObject*)self;
  uo9761->data[104] = (Object)closure9761;
  Method *meth_meth_parser_9761_comments = addmethod2pos(self, "comments", &meth_parser_9761_comments, 104);
  int argcv_meth_parser_9761_comments[] = {0};
  meth_meth_parser_9761_comments->type = alloc_MethodType(1, argcv_meth_parser_9761_comments);
  meth_meth_parser_9761_comments->definitionModule = modulename;
  meth_meth_parser_9761_comments->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comments:=(_)"
  block_savedest(self);
  Object closure9762 = createclosure(1, "comments:=(1)");
  setclosureframe(closure9762, stackframe);
  addtoclosure(closure9762, var_comments);
  struct UserObject *uo9762 = (struct UserObject*)self;
  uo9762->data[105] = (Object)closure9762;
  Method *meth_meth_parser_9762_comments_58__61__40_1_41_ = addmethod2pos(self, "comments:=(1)", &meth_parser_9762_comments_58__61__40_1_41_, 105);
  int argcv_meth_parser_9762_comments_58__61__40_1_41_[] = {1};
  meth_meth_parser_9762_comments_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9762_comments_58__61__40_1_41_);
  meth_meth_parser_9762_comments_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9762_comments_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num9764 = alloc_Float64(0);
// compiled num node returning num9764 (depth = 2)
  *var_auto_count = num9764;
  if (num9764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "auto_count"
  block_savedest(self);
  Object closure9765 = createclosure(1, "auto_count");
  setclosureframe(closure9765, stackframe);
  addtoclosure(closure9765, var_auto_count);
  struct UserObject *uo9765 = (struct UserObject*)self;
  uo9765->data[106] = (Object)closure9765;
  Method *meth_meth_parser_9765_auto_count = addmethod2pos(self, "auto_count", &meth_parser_9765_auto_count, 106);
  int argcv_meth_parser_9765_auto_count[] = {0};
  meth_meth_parser_9765_auto_count->type = alloc_MethodType(1, argcv_meth_parser_9765_auto_count);
  meth_meth_parser_9765_auto_count->definitionModule = modulename;
  meth_meth_parser_9765_auto_count->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "auto_count:=(_)"
  block_savedest(self);
  Object closure9766 = createclosure(1, "auto_count:=(1)");
  setclosureframe(closure9766, stackframe);
  addtoclosure(closure9766, var_auto_count);
  struct UserObject *uo9766 = (struct UserObject*)self;
  uo9766->data[107] = (Object)closure9766;
  Method *meth_meth_parser_9766_auto_count_58__61__40_1_41_ = addmethod2pos(self, "auto_count:=(1)", &meth_parser_9766_auto_count_58__61__40_1_41_, 107);
  int argcv_meth_parser_9766_auto_count_58__61__40_1_41_[] = {1};
  meth_meth_parser_9766_auto_count_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9766_auto_count_58__61__40_1_41_);
  meth_meth_parser_9766_auto_count_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9766_auto_count_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool9768 = alloc_Boolean(0);
// compiled identifier node returning bool9768 (depth = 2)
  *var_noBlocks = bool9768;
  if (bool9768 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "noBlocks"
  block_savedest(self);
  Object closure9769 = createclosure(1, "noBlocks");
  setclosureframe(closure9769, stackframe);
  addtoclosure(closure9769, var_noBlocks);
  struct UserObject *uo9769 = (struct UserObject*)self;
  uo9769->data[108] = (Object)closure9769;
  Method *meth_meth_parser_9769_noBlocks = addmethod2pos(self, "noBlocks", &meth_parser_9769_noBlocks, 108);
  int argcv_meth_parser_9769_noBlocks[] = {0};
  meth_meth_parser_9769_noBlocks->type = alloc_MethodType(1, argcv_meth_parser_9769_noBlocks);
  meth_meth_parser_9769_noBlocks->definitionModule = modulename;
  meth_meth_parser_9769_noBlocks->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool9770 = alloc_Boolean(1);
// compiled identifier node returning bool9770 (depth = 2)
  *var_blocksOK = bool9770;
  if (bool9770 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an uninitilized variable");
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blocksOK"
  block_savedest(self);
  Object closure9771 = createclosure(1, "blocksOK");
  setclosureframe(closure9771, stackframe);
  addtoclosure(closure9771, var_blocksOK);
  struct UserObject *uo9771 = (struct UserObject*)self;
  uo9771->data[109] = (Object)closure9771;
  Method *meth_meth_parser_9771_blocksOK = addmethod2pos(self, "blocksOK", &meth_parser_9771_blocksOK, 109);
  int argcv_meth_parser_9771_blocksOK[] = {0};
  meth_meth_parser_9771_blocksOK->type = alloc_MethodType(1, argcv_meth_parser_9771_blocksOK);
  meth_meth_parser_9771_blocksOK->definitionModule = modulename;
  meth_meth_parser_9771_blocksOK->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile array node (depth = 2)
  Object array9772 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9772 (depth = 2)
  *var_values = array9772;
  if (array9772 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "values"
  block_savedest(self);
  Object closure9773 = createclosure(1, "values");
  setclosureframe(closure9773, stackframe);
  addtoclosure(closure9773, var_values);
  struct UserObject *uo9773 = (struct UserObject*)self;
  uo9773->data[110] = (Object)closure9773;
  Method *meth_meth_parser_9773_values = addmethod2pos(self, "values", &meth_parser_9773_values, 110);
  int argcv_meth_parser_9773_values[] = {0};
  meth_meth_parser_9773_values->type = alloc_MethodType(1, argcv_meth_parser_9773_values);
  meth_meth_parser_9773_values->definitionModule = modulename;
  meth_meth_parser_9773_values->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "values:=(_)"
  block_savedest(self);
  Object closure9774 = createclosure(1, "values:=(1)");
  setclosureframe(closure9774, stackframe);
  addtoclosure(closure9774, var_values);
  struct UserObject *uo9774 = (struct UserObject*)self;
  uo9774->data[111] = (Object)closure9774;
  Method *meth_meth_parser_9774_values_58__61__40_1_41_ = addmethod2pos(self, "values:=(1)", &meth_parser_9774_values_58__61__40_1_41_, 111);
  int argcv_meth_parser_9774_values_58__61__40_1_41_[] = {1};
  meth_meth_parser_9774_values_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9774_values_58__61__40_1_41_);
  meth_meth_parser_9774_values_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9774_values_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9776 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9776 = alloc_userobj2(7,8, objclass9776);
  gc_frame_newslot(obj9776);
// OBJECT OUTER DEC outer
  adddatum2(obj9776, self, 0);
  addmethodreal(obj9776,"outer", &reader_parser_outer_9777);
  Object oldself9776 = self;
  struct StackFrameObject *oldstackframe9776 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9776);
  gc_frame_newslot((Object)stackframe);
  self = obj9776;
  Object *oldselfslot9776 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9776 = (*(struct UserObject *)self).data[0], lowerouter9776 = thisouter9776;
  if (inheritingObject9776) {
    struct UserObject *inho9776 = (struct UserObject *)inheritingObject9776;
    while (inho9776->super != GraceDefaultObject) inho9776 = (struct UserObject *)inho9776->super;
    inho9776->super = obj9776;
    self = inheritingObject9776;
    *selfslot = self;
    lowerouter9776 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9776;
  }
  if (objclass9776 == NULL) {
  Method *reader9778 = addmethodrealflags(obj9776, "kind",&reader_parser_kind_9778, MFLAG_DEF);
  reader9778->definitionModule = modulename;
  reader9778->definitionLine = 50;
  }
  adddatum2(obj9776, alloc_Undefined(), 1);
  if (objclass9776 == NULL) {
  Method *reader9779 = addmethodrealflags(obj9776, "line",&reader_parser_line_9779, MFLAG_DEF);
  reader9779->definitionModule = modulename;
  reader9779->definitionLine = 51;
  }
  adddatum2(obj9776, alloc_Undefined(), 2);
  if (objclass9776 == NULL) {
  Method *reader9780 = addmethodrealflags(obj9776, "linePos",&reader_parser_linePos_9780, MFLAG_DEF);
  reader9780->definitionModule = modulename;
  reader9780->definitionLine = 52;
  }
  adddatum2(obj9776, alloc_Undefined(), 3);
  if (objclass9776 == NULL) {
  Method *reader9781 = addmethodrealflags(obj9776, "indent",&reader_parser_indent_9781, MFLAG_DEF);
  reader9781->definitionModule = modulename;
  reader9781->definitionLine = 53;
  }
  adddatum2(obj9776, alloc_Undefined(), 4);
  if (objclass9776 == NULL) {
  Method *reader9782 = addmethodrealflags(obj9776, "value",&reader_parser_value_9782, MFLAG_DEF);
  reader9782->definitionModule = modulename;
  reader9782->definitionLine = 54;
  }
  adddatum2(obj9776, alloc_Undefined(), 5);
  if (objclass9776 == NULL) {
  Method *reader9783 = addmethodrealflags(obj9776, "size",&reader_parser_size_9783, MFLAG_DEF);
  reader9783->definitionModule = modulename;
  reader9783->definitionLine = 55;
  }
  adddatum2(obj9776, alloc_Undefined(), 6);
// method "==(_)"
  struct UserObject *uo9784 = (struct UserObject*)obj9776;
  uo9784->data[7] = emptyclosure;
  Method *meth_meth_parser_9784__61__61__40_1_41_ = addmethod2pos(obj9776, "==(1)", &meth_parser_9784__61__61__40_1_41_, 7);
  int argcv_meth_parser_9784__61__61__40_1_41_[] = {1};
  meth_meth_parser_9784__61__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9784__61__61__40_1_41_);
  meth_meth_parser_9784__61__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9784__61__61__40_1_41_->definitionLine = 56;
  sourceObject = obj9776;
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9808 == NULL) {
    strlit9808 = alloc_String("start");
    gc_root(strlit9808);
  }
// compiled string node returning strlit9808 (depth = 3)
  adddatum2(obj9776, strlit9808, 1);
  sourceObject = obj9776;
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9809 = alloc_Float64(0);
// compiled num node returning num9809 (depth = 3)
  adddatum2(obj9776, num9809, 2);
  sourceObject = obj9776;
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9810 = alloc_Float64(0);
// compiled num node returning num9810 (depth = 3)
  adddatum2(obj9776, num9810, 3);
  sourceObject = obj9776;
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9811 = alloc_Float64(0);
// compiled num node returning num9811 (depth = 3)
  adddatum2(obj9776, num9811, 4);
  sourceObject = obj9776;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9812 == NULL) {
    strlit9812 = alloc_String("");
    gc_root(strlit9812);
  }
// compiled string node returning strlit9812 (depth = 3)
  adddatum2(obj9776, strlit9812, 5);
  sourceObject = obj9776;
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9813 = alloc_Float64(0);
// compiled num node returning num9813 (depth = 3)
  adddatum2(obj9776, num9813, 6);
  sourceObject = obj9776;
  objclass9776 = obj9776->class;
  objclass9776->definitionModule = modulename;
  objclass9776->definitionLine = 49;
  (*(struct UserObject *)self).data[0] = lowerouter9776;
  self = oldself9776;
  selfslot = oldselfslot9776;
  stackframe = oldstackframe9776;
// compiled object node returning obj9776 (depth = 2)
  *var_sym = obj9776;
  if (obj9776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "sym"
  block_savedest(self);
  Object closure9814 = createclosure(1, "sym");
  setclosureframe(closure9814, stackframe);
  addtoclosure(closure9814, var_sym);
  struct UserObject *uo9814 = (struct UserObject*)self;
  uo9814->data[112] = (Object)closure9814;
  Method *meth_meth_parser_9814_sym = addmethod2pos(self, "sym", &meth_parser_9814_sym, 112);
  int argcv_meth_parser_9814_sym[] = {0};
  meth_meth_parser_9814_sym->type = alloc_MethodType(1, argcv_meth_parser_9814_sym);
  meth_meth_parser_9814_sym->definitionModule = modulename;
  meth_meth_parser_9814_sym->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "sym:=(_)"
  block_savedest(self);
  Object closure9815 = createclosure(1, "sym:=(1)");
  setclosureframe(closure9815, stackframe);
  addtoclosure(closure9815, var_sym);
  struct UserObject *uo9815 = (struct UserObject*)self;
  uo9815->data[113] = (Object)closure9815;
  Method *meth_meth_parser_9815_sym_58__61__40_1_41_ = addmethod2pos(self, "sym:=(1)", &meth_parser_9815_sym_58__61__40_1_41_, 113);
  int argcv_meth_parser_9815_sym_58__61__40_1_41_[] = {1};
  meth_meth_parser_9815_sym_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9815_sym_58__61__40_1_41_);
  meth_meth_parser_9815_sym_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9815_sym_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sym (depth = 2)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastToken"
  block_savedest(self);
  Object closure9817 = createclosure(1, "lastToken");
  setclosureframe(closure9817, stackframe);
  addtoclosure(closure9817, var_lastToken);
  struct UserObject *uo9817 = (struct UserObject*)self;
  uo9817->data[114] = (Object)closure9817;
  Method *meth_meth_parser_9817_lastToken = addmethod2pos(self, "lastToken", &meth_parser_9817_lastToken, 114);
  int argcv_meth_parser_9817_lastToken[] = {0};
  meth_meth_parser_9817_lastToken->type = alloc_MethodType(1, argcv_meth_parser_9817_lastToken);
  meth_meth_parser_9817_lastToken->definitionModule = modulename;
  meth_meth_parser_9817_lastToken->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastToken:=(_)"
  block_savedest(self);
  Object closure9818 = createclosure(1, "lastToken:=(1)");
  setclosureframe(closure9818, stackframe);
  addtoclosure(closure9818, var_lastToken);
  struct UserObject *uo9818 = (struct UserObject*)self;
  uo9818->data[115] = (Object)closure9818;
  Method *meth_meth_parser_9818_lastToken_58__61__40_1_41_ = addmethod2pos(self, "lastToken:=(1)", &meth_parser_9818_lastToken_58__61__40_1_41_, 115);
  int argcv_meth_parser_9818_lastToken_58__61__40_1_41_[] = {1};
  meth_meth_parser_9818_lastToken_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9818_lastToken_58__61__40_1_41_);
  meth_meth_parser_9818_lastToken_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9818_lastToken_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_previousCommentToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "previousCommentToken"
  block_savedest(self);
  Object closure9820 = createclosure(1, "previousCommentToken");
  setclosureframe(closure9820, stackframe);
  addtoclosure(closure9820, var_previousCommentToken);
  struct UserObject *uo9820 = (struct UserObject*)self;
  uo9820->data[116] = (Object)closure9820;
  Method *meth_meth_parser_9820_previousCommentToken = addmethod2pos(self, "previousCommentToken", &meth_parser_9820_previousCommentToken, 116);
  int argcv_meth_parser_9820_previousCommentToken[] = {0};
  meth_meth_parser_9820_previousCommentToken->type = alloc_MethodType(1, argcv_meth_parser_9820_previousCommentToken);
  meth_meth_parser_9820_previousCommentToken->definitionModule = modulename;
  meth_meth_parser_9820_previousCommentToken->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "previousCommentToken:=(_)"
  block_savedest(self);
  Object closure9821 = createclosure(1, "previousCommentToken:=(1)");
  setclosureframe(closure9821, stackframe);
  addtoclosure(closure9821, var_previousCommentToken);
  struct UserObject *uo9821 = (struct UserObject*)self;
  uo9821->data[117] = (Object)closure9821;
  Method *meth_meth_parser_9821_previousCommentToken_58__61__40_1_41_ = addmethod2pos(self, "previousCommentToken:=(1)", &meth_parser_9821_previousCommentToken_58__61__40_1_41_, 117);
  int argcv_meth_parser_9821_previousCommentToken_58__61__40_1_41_[] = {1};
  meth_meth_parser_9821_previousCommentToken_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9821_previousCommentToken_58__61__40_1_41_);
  meth_meth_parser_9821_previousCommentToken_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9821_previousCommentToken_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_statementToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementToken"
  block_savedest(self);
  Object closure9823 = createclosure(1, "statementToken");
  setclosureframe(closure9823, stackframe);
  addtoclosure(closure9823, var_statementToken);
  struct UserObject *uo9823 = (struct UserObject*)self;
  uo9823->data[118] = (Object)closure9823;
  Method *meth_meth_parser_9823_statementToken = addmethod2pos(self, "statementToken", &meth_parser_9823_statementToken, 118);
  int argcv_meth_parser_9823_statementToken[] = {0};
  meth_meth_parser_9823_statementToken->type = alloc_MethodType(1, argcv_meth_parser_9823_statementToken);
  meth_meth_parser_9823_statementToken->definitionModule = modulename;
  meth_meth_parser_9823_statementToken->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementToken:=(_)"
  block_savedest(self);
  Object closure9824 = createclosure(1, "statementToken:=(1)");
  setclosureframe(closure9824, stackframe);
  addtoclosure(closure9824, var_statementToken);
  struct UserObject *uo9824 = (struct UserObject*)self;
  uo9824->data[119] = (Object)closure9824;
  Method *meth_meth_parser_9824_statementToken_58__61__40_1_41_ = addmethod2pos(self, "statementToken:=(1)", &meth_parser_9824_statementToken_58__61__40_1_41_, 119);
  int argcv_meth_parser_9824_statementToken_58__61__40_1_41_[] = {1};
  meth_meth_parser_9824_statementToken_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9824_statementToken_58__61__40_1_41_);
  meth_meth_parser_9824_statementToken_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9824_statementToken_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool9826 = alloc_Boolean(0);
// compiled identifier node returning bool9826 (depth = 2)
  *var_comment = bool9826;
  if (bool9826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comment"
  block_savedest(self);
  Object closure9827 = createclosure(1, "comment");
  setclosureframe(closure9827, stackframe);
  addtoclosure(closure9827, var_comment);
  struct UserObject *uo9827 = (struct UserObject*)self;
  uo9827->data[120] = (Object)closure9827;
  Method *meth_meth_parser_9827_comment = addmethod2pos(self, "comment", &meth_parser_9827_comment, 120);
  int argcv_meth_parser_9827_comment[] = {0};
  meth_meth_parser_9827_comment->type = alloc_MethodType(1, argcv_meth_parser_9827_comment);
  meth_meth_parser_9827_comment->definitionModule = modulename;
  meth_meth_parser_9827_comment->definitionLine = 183;
// compiled method node returning  (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comment:=(_)"
  block_savedest(self);
  Object closure9828 = createclosure(1, "comment:=(1)");
  setclosureframe(closure9828, stackframe);
  addtoclosure(closure9828, var_comment);
  struct UserObject *uo9828 = (struct UserObject*)self;
  uo9828->data[121] = (Object)closure9828;
  Method *meth_meth_parser_9828_comment_58__61__40_1_41_ = addmethod2pos(self, "comment:=(1)", &meth_parser_9828_comment_58__61__40_1_41_, 121);
  int argcv_meth_parser_9828_comment_58__61__40_1_41_[] = {1};
  meth_meth_parser_9828_comment_58__61__40_1_41_->type = alloc_MethodType(1, argcv_meth_parser_9828_comment_58__61__40_1_41_);
  meth_meth_parser_9828_comment_58__61__40_1_41_->definitionModule = modulename;
  meth_meth_parser_9828_comment_58__61__40_1_41_->definitionLine = 183;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
  gc_frame_end(frame);
  return self;
}
